local m_curIdPlayer = nil;
local m_mark = nil;
local ARENASCRITP_BEGIN_FIGHT					= 15	--/*发起挑战*/

local function sendBeginFight(id)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then
        dataStream:writeShort(ARENASCRITP_BEGIN_FIGHT);
        dataStream:writeInt(id);
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function onBtnArenaType(tag)
    if nil == m_curIdPlayer then
        return;
    end
    SCActivityIndicator:getSingleton():show();
    if 1 == tag then
        luaLookPlayerInfo(m_curIdPlayer, "");
    else
        sendBeginFight(m_curIdPlayer);
        local navige = getCurentSceneNavigationController();
        if navige then
            navige:removeWindowControllerByTag(7009);
        end
    end
end

local function ArenaSelectedWndClose()
    m_curIdPlayer = nil
end

local function createWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7009));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile56.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(ArenaSelectedWndClose);
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeRound)
        dragNode:setFrameVisibled(false)
    end
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if pBtn then
       pBtn:luaSetSelectorOnClicked(onBtnArenaType);
    end

    pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
    if pBtn then
       pBtn:luaSetSelectorOnClicked(onBtnArenaType);
    end
    return wndCtrl;
end

local function setArenaSelectedData(dt)
    local pNode = SCFunction:getUiNodeByIdlist("7009-3");
    if nil == pNode then
        return;
    end
    local pNameLab = SCTypeCast:castNodeToLabel(pNode:getChildByTag(5));
    local pLevelLab = SCTypeCast:castNodeToLabel(pNode:getChildByTag(6));
    local pImgBtn = SCTypeCast:castNodeToImage(pNode:getChildByTag(4));
    if nil == pNameLab or nil == pLevelLab or nil == pImgBtn then
        return;
    end
    pNameLab:setText(dt.szName);
    
    local szLev = _LTParser("str0013");
    szLev = szLev .. dt.usLevel;
    szLev = szLev .. " ";
    szLev = szLev .. dt.nRank;
    szLev = szLev .. _LTParser("str5034");
    pLevelLab:setText(szLev);

    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/" .. dt.nPhoto .. ".png")
    end
    if imgPath then
        pImgBtn:setImage(imgPath:getData());
    end
    m_curIdPlayer = dt.idPlayer;
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        getCurentSceneWindow(tag):setAutoCloseOnTouchSpace(true);
        local data = getArenaPlayer(m_mark);
        if data then
            setArenaSelectedData(data);
        end
    end
end

function showArenaSelectedWnd(mark)
    local wndCtrl = createWnd();
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        m_mark = mark;
    end
end