local ACT_AUTO_EXERCISE = 12                  --// 自动练功
local ACT_AUTO_EXERCISE_GETEXP = 13                  --// 自动练功
local ACT_AUTO_EXERCISE_FLAG = 14                  --// 是否满标记
local m_timeID = nil;
local m_time = nil;
local m_curTime = nil;
local m_mark = nil;
local AutomaticGrindingInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ulData = dt:readInt();			--//时间或者数据
        tmp.dwAddExp = dt:readInt();		--//增加经验
        return tmp
    end
}

function closeOnlineLevWnd()
    local pFrameWindow = nil;
    local scene = getRunningScene();
    if scene~= nil and scene:getUINode() then
        scene:getUINode():removeChildByTag(70001, true);
    end
    if m_timeID then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
        m_timeID = nil
    end
    m_time = nil;
    m_curTime = nil;
end

local function onClickextract(tag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRAINING)
	if dataStream then
        dataStream:writeShort(ACT_AUTO_EXERCISE_GETEXP)
        SCDataTransThread:getSingleton():transData(dataStream)
	    closeOnlineLevWnd()
	    m_mark = nil;
	    AutomaticGrinding_Mark();
	end
end

local function onAutomaticGrindingCloss()
    if m_timeID then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
        m_timeID = nil
    end
end

function AutomaticGrinding_sendAutomaticGrindingInfo()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRAINING)
	if dataStream then
        dataStream:writeShort(ACT_AUTO_EXERCISE)
        SCDataTransThread:getSingleton():transData(dataStream)
	end
end

local function showTime()
    local pFrameWindow = nil;
    local scene = getRunningScene();
    if scene~= nil and scene:getUINode() then
        pFrameWindow = scene:getUINode():getChildByTag(70001);
        if pFrameWindow == nil then
            return;
        end
    end
    local h = m_time / 3600;
    local m = (m_time % 3600) / 60;
    local s = ((m_time % 3600) % 60);
    local hstr = nil;
    local mstr = nil;
    local sstr = nil;
    if h < 10 then
        hstr = "0" .. getIntPart(h);
    else
        hstr = "" .. getIntPart(h);
    end
    if m < 10 then
        mstr = "0" .. getIntPart(m);
    else
        mstr = "" .. getIntPart(m);
    end
    if s < 10 then
        sstr = "0" .. getIntPart(s);
    else
        sstr = "" .. getIntPart(s);
    end
    local pLabel = tolua.cast(pFrameWindow:getChildByTag(5), "SCLabel");
    if pLabel == nil then
        pLabel = SCLabel:labelWithStringFont(hstr .. ":" .. mstr .. ":" .. sstr, DEFAULT_FONT_NAME, F(12));
        pLabel:setPosition(AUTO_POS(67, 10));
        pLabel:setTag(5);
        pFrameWindow:addChild(pLabel);
    end
    if pLabel then
        if pLabel then
            pLabel:setText(hstr .. ":" .. mstr .. ":" .. sstr);
        end
    end
end

local function updateTime()
    AutomaticGrinding_sendAutomaticGrindingInfo();
    --[[if m_curTime == nil then
        m_curTime = 1;
    elseif m_curTime == 30 then
        m_curTime = 0;
        AutomaticGrinding_sendAutomaticGrindingInfo();
    else
        m_curTime = m_curTime + 1;
    end
    if m_time == nil then
        m_time = 1;
    else
        m_time = m_time + 1;
    end
    showTime]]
end

function showAutomaticGrindingWnd(tmp)
    local pFrameWindow = nil;
    local scene = getRunningScene();
    if scene~= nil and scene:getUINode() then
        pFrameWindow = scene:getUINode():getChildByTag(70001);
        if pFrameWindow == nil then
            pFrameWindow = FrameWindow:frameWnd();
            pFrameWindow:setTag(70001);
            pFrameWindow:luaSetReturnSelector(onAutomaticGrindingCloss);
            scene:getUINode():addChild(pFrameWindow);
            pFrameWindow:setCloseBtnVisible(false);
            m_timeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updateTime, 10, false)
        end
    end
    if pFrameWindow then
        pFrameWindow:setContentSize(AUTO_SIZE(190, 70));
        pFrameWindow:setPosition(AUTO_POS(350, 90));
        local pLabel = tolua.cast(pFrameWindow:getChildByTag(1), "SCLabel");
        if pLabel == nil then
            pLabel = SCLabel:labelWithStringFont("", DEFAULT_FONT_NAME, F(12));
            pLabel:setPosition(AUTO_POS(13, 26));
            pLabel:setTag(1);
            pFrameWindow:addChild(pLabel);
        end
        if pLabel then
            pLabel:setText(L("str6128") .. " " .. tmp.dwAddExp);
        end
        pLabel = SCTypeCast:castNodeToLabel(pFrameWindow:getChildByTag(2));
        if pLabel == nil then
            pLabel = SCLabel:labelWithStringFont(L("str6125"), DEFAULT_FONT_NAME, F(12));
            pLabel:setPosition(AUTO_POS(13, 42));
            pLabel:setTag(2);
            pFrameWindow:addChild(pLabel);
        end
        pLabel = SCTypeCast:castNodeToLabel(pFrameWindow:getChildByTag(3));
        if pLabel == nil then
            pLabel = SCLabel:labelWithStringFont(L("str6126"), DEFAULT_FONT_NAME, F(12));
            pLabel:setPosition(AUTO_POS(13, 10));
            pLabel:setTag(3);
            pFrameWindow:addChild(pLabel);
        end
        local pBtn = SCTypeCast:castNodeToButton(pFrameWindow:getChildByTag(4));
        if pBtn == nil then
            pBtn = SCButton:button(EnumBtnType9Atlas);
		    pBtn:setTitle(L("str6127"), DEFAULT_FONT_NAME, F(12))
            pBtn:setPosition(AUTO_POS(128, 10));
            pBtn:setContentSize(AUTO_SIZE(50, 26));
            pBtn:luaSetSelectorOnClicked(onClickextract);
            pBtn:setTag(4);
            pFrameWindow:addChild(pBtn);
        end
        m_time = tmp.ulData;
        showTime();
        --[[local pTime = tolua.cast(pFrameWindow:getChildByTag(5), "CountDownNode");
        if pTime == nil then
            pTime = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second);
            pTime:setTag(222);
            pTime:setPosition(AUTO_POS(67, 10));
            --pTime:luasetSelectorOnClose(onTimeOut)
            pTime:setTag(5);
            pFrameWindow:addChild(pTime);
        end
        if pTime then 
            pTime:setTime(tmp.ulData);
        end]]
    end
end

function AutomaticGrinding_Mark(node)
    local pNode = SCFunction:getUiNodeByIdlist("5918-5933-2-23");
    if node then
        pNode = node;
    end
    if pNode then
        pNode:removeAllChildrenWithCleanup(true);
        if 1 == m_mark  then
            local pAni = SCLookfaceParser:getSingleton():getAnimationByIndex(1044, 1044);
            if pAni then
	            local pAnimation =  SCAnimationNode:nodeWithAnimation(pAni);
	            if pAnimation then
                    pAnimation:setAnchorPoint(CCPointMake(0.5, 0.5));
                    local size = pNode:getContentSize();
                    pAnimation:setPosition(CCPointMake(size.width / 2, size.height / 2));
                    pNode:addChild(pAnimation);
	            end
            end
        end
    end
end

local function recAutomaticInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readShort();
    if action == ACT_AUTO_EXERCISE then
        showAutomaticGrindingWnd(AutomaticGrindingInfo.initWithStream(dt));
    elseif ACT_AUTO_EXERCISE_FLAG == action then
        m_mark = dt:readByte();
        AutomaticGrinding_Mark();
    end
end

SCMessageCenter:getSingleton():luaRegistCommand(recAutomaticInfo, _MSG_TRAINING, 0, nil);