--定义一个与文件名相同的table
BattleRewards = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------

local stScoreBonus = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		
		local tmp = {
            __mode = "kv",
        }
		
		tmp.BonusExp = dt:readInt()
		tmp.BonusMoney = dt:readInt()
        --[[if CLIENT_VERSION > 328 then 
            local cutWillInfo = ItemProcessor:getSingleton():getCutWillInfo();
            if cutWillInfo ~= nil then
                if cutWillInfo.nTimes > 0 then
                    tmp.BonusExp = tmp.BonusExp * (1 + cutWillInfo.nAddExp/1000)
                    tmp.BonusMoney = tmp.BonusMoney * (1 + cutWillInfo.nAddMoney/1000)
                end
            end
        end]]
		tmp.BonusEmoney = dt:readInt()
		tmp.BonusGodExp = dt:readInt()
		tmp.BonusProffer = dt:readInt()
		tmp.nBonusReputation = dt:readInt()
		tmp.nBonusSynMoney = dt:readInt()
		tmp.nBonusSynContribute = dt:readInt()
		tmp.nBonusBattleHonor = dt:readInt()
		
		return tmp
	end
}

----------------变量定义区----------------
local m_wnd = nil;
local m_timeID = nil;
local m_posX = nil;
local m_posY = nil;
local m_pos = nil;
local m_struScore = {__mode = "kv"};
local m_showId = nil;

local MAPTYPE_COPYMAP  = 2097152			--// 副本地图
local MAPTYPE_BOSS_MAP = 131072				--// BOSS战地图

--变量的定义
----------------UI控制器区----------------
function BattleRewards.initControl()
	local pWindow7025 = SCWindow:window()
	if pWindow7025 then
		pWindow7025:setTag(7025)
		pWindow7025:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow7025:setPosition(AUTO_POS(0.00, 0.00))
        pWindow7025:setContentSize(AUTO_SIZE(480, 320))
		pWindow7025:luaSetSelectorOnClose(BattleRewards.releaseControl)
	end

	local imgPath = getRealUIResourcePath("img/img7092.png")
	local pImage1 = nil
	if imgPath then
		pImage1 = SCImage:imageWithFile(imgPath:getData())
		if pImage1 then
			pImage1:setTag(1)
			pImage1:setAnchorPoint(ANCHOR_CENTER)
			pImage1:setPosition(AUTO_POS(240.00, 160.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/img7093.png")
	local pImage2 = nil
	if imgPath then
		pImage2 = SCImage:imageWithFile(imgPath:getData())
		if pImage2 then
			pImage2:setTag(2)
			pImage2:setAnchorPoint(CCPointMake(0.5, 1))
			pImage2:setPosition(AUTO_POS(240.00, 320.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/img7094.png")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage3:setPosition(AUTO_POS(272.00, 0.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/img7033.png")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage4:setPosition(AUTO_POS(0.00, 0.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/img7095.png")
	local pImage5 = nil
	if imgPath then
		pImage5 = SCImage:imageWithFile(imgPath:getData())
		if pImage5 then
			pImage5:setTag(5)
			pImage5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage5:setPosition(AUTO_POS(0.00, 50.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/img7096.png")
	local pImage6 = nil
	if imgPath then
		pImage6 = SCImage:imageWithFile(imgPath:getData())
		if pImage6 then
			pImage6:setTag(6)
			pImage6:setAnchorPoint(ANCHOR_CENTER)
			pImage6:setPosition(AUTO_POS(369.00, 215.00))
		end
	end

	local pLable7 = SCLabel:labelWithStringFont(L("0"), DEFAULT_FONT_NAME, F(12))
	if pLable7 then
		pLable7:setTag(7)
		pLable7:setAnchorPoint(CCPointMake(0, 0.5))
		pLable7:setPosition(AUTO_POS(212.00, 112.00))
		pLable7:setColor(ccc4(255,255,255,255))
	end

	local pLable8 = SCLabel:labelWithStringFont(L("0"), DEFAULT_FONT_NAME, F(12))
	if pLable8 then
		pLable8:setTag(8)
		pLable8:setAnchorPoint(CCPointMake(0, 0.5))
		pLable8:setPosition(AUTO_POS(203.00, 96.00))
		pLable8:setColor(ccc4(255,255,255,255))
	end

	local pLable9 = SCLabel:labelWithStringFont(L("0"), DEFAULT_FONT_NAME, F(12))
	if pLable9 then
		pLable9:setTag(9)
		pLable9:setAnchorPoint(CCPointMake(0, 0.5))
		pLable9:setPosition(AUTO_POS(195.00, 79.00))
		pLable9:setColor(ccc4(255,255,255,255))
	end

	local pLable10 = SCLabel:labelWithStringFont(L("0"), DEFAULT_FONT_NAME, F(12))
	if pLable10 then
		pLable10:setTag(10)
		pLable10:setAnchorPoint(CCPointMake(0, 0.5))
		pLable10:setPosition(AUTO_POS(185.00, 64.00))
		pLable10:setColor(ccc4(255,255,255,255))
	end

	BattleRewards.m_numNode = SCDragNode:node()
	if BattleRewards.m_numNode then
		BattleRewards.m_numNode:setTag(11)
		BattleRewards.m_numNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BattleRewards.m_numNode:setPosition(AUTO_POS(346.00, 81.00))
		BattleRewards.m_numNode:setContentSize(AUTO_SIZE(20, 20))
		BattleRewards.m_numNode:setFrameVisibled(false)
		BattleRewards.m_numNode:setDragEnabled(false)
		BattleRewards.m_numNode:setFrameType(EnumFrameTypeRound)
	end

	local pLable12 = SCLabel:labelWithStringFont(L("str0192"), DEFAULT_FONT_NAME, F(15))
	if pLable12 then
		pLable12:setTag(12)
		pLable12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable12:setPosition(AUTO_POS(236.00, 129.00))
		pLable12:setColor(ccc4(255,255,255,255))
	end

	local pButton13 = SCButton:button()
	if pButton13 then
		pButton13:setTag(13)
		pButton13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton13:setPosition(AUTO_POS(273.00, 3.00))
		pButton13:setContentSize(AUTO_SIZE(244, 26))
		pButton13:setTitle(L(""), DEFAULT_FONT_NAME, F(20))
		local pBackimg = getRealUIResourcePath("img/img7100.png")
		if pBackimg then
			pButton13:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/img7100.png")
		if pBackimg then
			pButton13:setSelectedImage(pPressimg:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/img7101.png")
	local pImage14 = nil
	if imgPath then
		pImage14 = SCImage:imageWithFile(imgPath:getData())
		if pImage14 then
			pImage14:setTag(14)
			pImage14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage14:setPosition(AUTO_POS(45.00, 286.00))
		end
	end

	if pImage1 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pImage1, "SCNode"))
	end
	if pImage2 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pImage2, "SCNode"))
	end
	if pImage3 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if pImage4 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pImage4, "SCNode"))
	end
	if pImage5 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pImage5, "SCNode"))
	end
	if pImage6 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pImage6, "SCNode"))
	end
	if pLable7 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pLable7, "SCNode"))
	end
	if pLable8 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pLable8, "SCNode"))
	end
	if pLable9 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pLable9, "SCNode"))
	end
	if pLable10 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pLable10, "SCNode"))
	end
	if BattleRewards.m_numNode and pWindow7025 then
		pWindow7025:addChild(tolua.cast(BattleRewards.m_numNode, "SCNode"))
	end
	if pLable12 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pLable12, "SCNode"))
	end
	if pButton13 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pButton13, "SCNode"))
	end
	if pImage14 and pWindow7025 then
		pWindow7025:addChild(tolua.cast(pImage14, "SCNode"))
	end
	return pWindow7025
end
function BattleRewards.releaseControl()
	BattleRewards.m_numNode = nil
	if BattleRewards.wndCloss then
		BattleRewards.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------

local function setImaNum(num)
    if m_wnd == nil then
        return
    end
    local m_numNode = SCTypeCast:castNodeToDragNode(m_wnd:getChildByTag(11));
    if m_numNode then
        m_numNode:setVisible(false);
        m_numNode:removeAllChildrenWithCleanup(true);
        local file = getRealUIResourcePath("img/img7099.png")
        if file then
            local cont = 0
            while getIntPart(num/10)~=0 or num%10~=0 do
                local sumImg = SCImage:imageWithFile(file:getData(), CCRectMake((num%10)*SX(15.9), 0, SX(15.9), SY(20)))
                sumImg:setAnchorPoint(CCPointMake(1, 0))
                sumImg:setPosition(CCPointMake(m_numNode:getContentSize().width-cont*SX(15), 0))
                m_numNode:addChild(sumImg)
                num = getIntPart(num/10)
                cont = cont + 1
            end
        end
    end
    
end

local function onClickBox(tag)
    if m_wnd == nil then
        return
    end
    local pNode = m_wnd:getChildByTag(1000);
    if pNode then
        local ActNode = pNode:getChildByTag(1000)
        if ActNode then
            pNode:removeChildByTag(1000,true)
        end
    end
    local wnd = BattleRewards1.showBattleRewardsWnd();
    if m_wnd and wnd then
        m_wnd:addChild(wnd, 100);
    end
end

local function moveEnd() 
    if m_wnd == nil then
        return
    end
    
    local pNode = m_wnd:getChildByTag(1000);--SCFunction:getUiNodeByIdlist("7025-1000");
    if pNode then
        pNode:setVisible(true);
        local ActNode = pNode:getChildByTag(1000)
        if not ActNode then
            local imgPath = getRealUIResourcePath("img/new00447.png")
            if imgPath == nil then
                return;
            end
            local pImage = SCImage:imageWithFile(imgPath:getData())
            if pImage == nil then
                return;
            end
            local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
            if pLabel then
                --pImage:setFlipX(true)
                pImage:setTag(1001)
                pImage:setScale(0.9)
                pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage:setPosition(AUTO_POS(0.00, 0.00))
                pLabel:setAnchorPoint(ANCHOR_CENTER)
                pLabel:setPosition(CCPointMake(SX(44), pImage:getContentSize().height/2))
                pLabel:setColor(ccc4(255, 0, 0, 255))
                pImage:addChild(tolua.cast(pLabel, "SCNode"))
            end
            
            ActNode = ActionNode:newActionNode();
            if ActNode then
                ActNode:setTag(1000)
                ActNode:setContentSize(pImage:getContentSize());
                ActNode:setAnchorPoint(ANCHOR_CENTER);
                ActNode:setPosition(CCPointMake(0 - pImage:getContentSize().width/2 +SX(15), pNode:getContentSize().height/2));
                ActNode:moveToRetuen(CCPointMake(0 - pImage:getContentSize().width/2 +SX(15), pNode:getContentSize().height/2), CCPointMake(0 - pImage:getContentSize().width/2 +SX(11), pNode:getContentSize().height/2), 0.2);
                ActNode:addChild(tolua.cast(pImage, "SCNode"))
                pNode:addChild(tolua.cast(ActNode, "SCNode"))
            end
        end
    end
end

local function updateTime()
    local pNode = m_wnd:getChildByTag(1001);
    m_posY = m_posY - SY(10);
    if m_posY <= m_pos then
        if m_timeID then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID);
            m_timeID = nil;
        end
        m_posX = nil;
        m_posY = nil;
        m_pos = nil;
        m_wnd:removeChildByTag(1001, true);
        moveEnd();
        return;
    end
    if pNode then
        pNode:setPosition(CCPointMake(m_posX, m_posY));
    end
end

local function onClickBattleRewards(tag)
    if m_wnd == nil then
        return
    end
    
    local pNode = m_wnd:getChildByTag(1000);--SCFunction:getUiNodeByIdlist("7025-1000");
    if pNode then
        return;
    end
    local imgFile = getRealUIResourcePath("img/img7102.png");
    if imgFile == nil then
        return;
    end
    local pImage = SCImage:imageWithFile(imgFile:getData());
    if pImage == nil  then  
        return;
    end
    local wnd = m_wnd;
    if wnd == nil then
        return;
    end
    
    local pNode = SCNode:node()
    if pNode then
        pNode:setTag(2000)
        pNode:setAnchorPoint(ANCHOR_CENTER)
        pNode:setContentSize(CCSizeMake(CCDirector:sharedDirector():getWinSize().width, CCDirector:sharedDirector():getWinSize().height))
        pNode:setPosition(CCPointMake(wnd:getContentSize().width/2 , wnd:getContentSize().height/2));
        pNode:setBackgroundColor(ccc4(0,0,0,210));
        wnd:addChild(pNode);
    end
    
    local pBtn = SCButton:button();
    local imgFile = getRealUIResourcePath("img/img7102.png");
    if pBtn and imgFile then
        pBtn:setTitle(imgFile:getData());
        pBtn:luaSetSelectorOnClicked(onClickBox);
        pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
        pBtn:setPosition(CCPointMake(m_wnd:getContentSize().width / 2, m_wnd:getContentSize().height / 2));
        pBtn:setTag(1000);
        pBtn:setVisible(false);
        wnd:addChild(pBtn);
    end
    
    m_timeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updateTime, 0.001, false);
    pImage:setAnchorPoint(CCPointMake(0.5, 0));
    m_posX = m_wnd:getContentSize().width / 2;
    m_posY = getScreenHeight();
    m_pos = getScreenHeight() / 2 - pImage:getContentSize().height / 2;
    pImage:setPosition(CCPointMake(m_posX, m_posY));
    pImage:setTag(1001);
    wnd:addChild(pImage);
    --[[local pNode =  ActionNode:newActionNode(); 
    if pNode then
        pNode:setContentSize(pImage:getContentSize());
		pNode:setAutoRemove(true);
        pNode:setAnchorPoint(CCPointMake(0.5, 0));
        pNode:setPosition(CCPointMake(getScreenWidth() / 2, getScreenHeight()));
        pNode:addChild(pImage);
        pNode:moveTo(CCPoint(getScreenWidth() / 2, getScreenHeight() / 2 - pNode:getContentSize().height / 2), 1);
        pNode:luaSetSelectorOnMoveEnd(moveEnd);
        --wnd:addChild(pNode, 1000)  
        local scene = getRunningScene();
        if scene~= nil then
            scene:getUINode():addChild(pNode, 1000);
        end
    end]]
end

local function updateShow(float)
    if m_wnd == nil then
        return;
    end
    local pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(6))
    if pImg == nil then
        return;
    end
    local scale = pImg:getScale();
    scale = scale - 0.1;
    pImg:setScale(scale);
    if scale <= 1 and m_showId then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_showId);
        m_showId = nil;
    end
end

local function actionEnd()
    if m_wnd == nil then
        return;
    end
    m_wnd:removeChildByTag(70251, true);
    local pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(7));--SCFunction:getUiNodeByIdlist("7025-7"));
    if pLabel:isVisible() == false then
        pLabel:setVisible(true);      
        local pAniNode = BattleRewards.getAnimation()
        if pAniNode then
            pAniNode:setPosition(CCPointMake(SX(219), SY(95)));
            m_wnd:addChild(pAniNode);
        end
        return;
    end
    pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(8));--SCFunction:getUiNodeByIdlist("7025-8"));
    if pLabel:isVisible() == false then
        pLabel:setVisible(true);   
        local pAniNode = BattleRewards.getAnimation()
        if pAniNode then
            pAniNode:setPosition(CCPointMake(SX(207), SY(79)));
            m_wnd:addChild(pAniNode);
        end
        return;
    end
    pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(9));--SCFunction:getUiNodeByIdlist("7025-9"));
    if pLabel:isVisible() == false then
        pLabel:setVisible(true);   
        local pAniNode = BattleRewards.getAnimation()
        if pAniNode then
            pAniNode:setPosition(CCPointMake(SX(194), SY(64)));
            m_wnd:addChild(pAniNode);
        end
        return;
    end
    pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(10));--SCFunction:getUiNodeByIdlist("7025-10"));
    if pLabel:isVisible() == false then
        pLabel:setVisible(true);
        local pAniNode = BattleRewards.getAnimation()
        if pAniNode then
            pAniNode:setPosition(CCPointMake(SX(332), SY(88)));
            m_wnd:addChild(pAniNode);
        end
        return;
    end
   
    local m_numNode = SCTypeCast:castNodeToDragNode(m_wnd:getChildByTag(11));
    
    if m_numNode and m_numNode:isVisible() == false then
        m_numNode:setVisible(true);   
        playEffectMusic("win_rate.mp3");  
        m_showId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updateShow, 0.01, false);        
        local pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(6))
        if pImg then
            pImg:setVisible(true);
        end
    end
end

function BattleRewards.getAnimation()
	playEffectMusic("win_score.mp3");  
	local pAi = SCLookfaceParser:getSingleton():getAnimationByIndex(1035, 1035);
	if pAi then
	    pAi:setFPS(38);
        pAi:setAutoremoveOnComplete(true);
        pAi:luaSetSelectorOnComplete(actionEnd);
        local pNode =  SCAnimationNode:nodeWithAnimation(pAi);
        if pNode then
            --local size = m_wnd:getContentSize();
            pNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            --pNode:setPosition(CCPointMake(size.width / 2, size.height / 2 - SY(80)));
            pNode:setTag(70251);
            return pNode;
        end
	end
end

local function getHeroPhoto()
    local profession = Hero:getSingleton():getProfessionID();
    if 1 == profession then
        return 7033;
    elseif 4 == profession then
        return 7034;
    elseif 3 == profession then
        return 7035;
    elseif 2 == profession then
        return 7036;
    end
end

local function actionMoveEnd()
    local pAniNode = BattleRewards.getAnimation()
    if pAniNode then
        pAniNode:setPosition(CCPointMake(SX(228), SY(111)));
        m_wnd:addChild(pAniNode);
    end
    
    local pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(4));
    if pImg then
        pImg:setVisible(true);
    end
end

local function ControlOperating()
    if m_wnd == nil then
        return;
    end
	
	local tmp = {};
	tmp.nScoreOper = NewBattleMessage:getSingleton():getScoreOper();
	tmp.nScoreTime = NewBattleMessage:getSingleton():getScoreTime(); 
	tmp.nScoreCombo = NewBattleMessage:getSingleton():getScoreCombo();
	tmp.nScoreKill = NewBattleMessage:getSingleton():getScoreKill(); 
	tmp.BonusExp = 0;
	tmp.nBonusBattleHonor = 0;
	
	if CLIENT_VERSION == 326 and Hero:getSingleton():isATeamMember() and not Hero:getSingleton():iSATeamLeader() then
        tmp.nScoreTime = 3000
    end
	
	local allPoint = 0
    if tmp.nScoreOper and tmp.nScoreTime and tmp.nScoreCombo and tmp.nScoreKill then
        allPoint = tmp.nScoreOper + tmp.nScoreTime + tmp.nScoreCombo + tmp.nScoreKill
    end
	
	if allPoint >= 32000 then
		if #m_struScore > 0 then
			tmp.BonusExp = m_struScore[1].BonusExp;
			tmp.nBonusBattleHonor = m_struScore[1].nBonusBattleHonor;
		end
	elseif allPoint >= 25000 then
		if #m_struScore > 1 then
			tmp.BonusExp = m_struScore[2].BonusExp;
			tmp.nBonusBattleHonor = m_struScore[2].nBonusBattleHonor;
		end
	else
		if #m_struScore > 2 then
			tmp.BonusExp = m_struScore[3].BonusExp;
			tmp.nBonusBattleHonor = m_struScore[3].nBonusBattleHonor;
		end
	end
    
    local size = SCREEN_SIZE;
    local wndSize = m_wnd:getContentSize();
    
    local pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(4));
    local pFile = getRealUIResourcePath("img/img" .. getHeroPhoto() .. ".png");
    if pImg and pFile then
        pImg:setVisible(false);
        pImg:setPosition(CCPointMake(SX(-300) - (size.width - wndSize.width) / 2,  -(size.height - wndSize.height) / 2));
        pImg:setImage(pFile:getData());
        pImg = SCImage:imageWithFile(pFile:getData());
        local pActionNode = ActionNode:newActionNode();
        if pImg and pActionNode then
            pActionNode:addChild(pImg);
            pActionNode:setPosition(CCPointMake(wndSize.width + (size.width - wndSize.width) / 2, 0));
            pActionNode:moveTo(CCPointMake(SX(-300) - (size.width - wndSize.width) / 2, -(size.height - wndSize.height) / 2), 0.6);
            pActionNode:setAutoRemove(true);
            pActionNode:luaSetSelectorOnMoveEnd(actionMoveEnd);
            m_wnd:addChild(pActionNode);
        end
    end
	local battleCopyType = GameCopyController_getBattleCopyType()
	if (battleCopyType==2 or battleCopyType==3) and ActivityAll_isUnlock(S_WONDERFULEVENT_TYPE_COPYDOUBLEEXP) then
		local pFile = getRealUIResourcePath("img/new00815.png");
		if pFile then
			local pImg = SCImage:imageWithFile(pFile:getData())
			if pImg then
				pImg:setPosition(CCPointMake(SX(60),  SY(125)));
				m_wnd:addChild(pImg)	
			end
		end
	end
	
    local pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(7));--SCFunction:getUiNodeByIdlist("7025-7"));
    if pLabel then
        pLabel:setText(tmp.nScoreOper);
        pLabel:setVisible(false);
    end
    pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(8));--SCFunction:getUiNodeByIdlist("7025-8"));
    if pLabel then
        pLabel:setText(tmp.nScoreTime);
        pLabel:setVisible(false);
    end
    pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(9));--SCFunction:getUiNodeByIdlist("7025-9"));
    if pLabel then
        pLabel:setText(tmp.nScoreCombo);
        pLabel:setVisible(false);
    end
    pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(10));--SCFunction:getUiNodeByIdlist("7025-10"));
    if pLabel then
        pLabel:setText(tmp.nScoreKill);
        pLabel:setVisible(false);
    end
    pLabel = SCTypeCast:castNodeToLabel(m_wnd:getChildByTag(12));--SCFunction:getUiNodeByIdlist("7025-12"));
    if pLabel then
        local str = nil 
        if tmp.BonusExp and tmp.nBonusBattleHonor and tmp.nBonusBattleHonor > 0 then
            str = L("str0192") .. "+" .. tmp.BonusExp .. "  " .. L("str6156") .. "+" .. tmp.nBonusBattleHonor;
        elseif tmp.BonusExp then
            str = L("str0192") .. "+" .. tmp.BonusExp
        end
        
        
        pLabel:setText(str);
    end
    local pImgFile = nil
    if allPoint < 25000 then
        BattleRewards1.setCurCopyTreasure(3);
        pImgFile = getRealUIResourcePath("img/img7096.png");
    elseif allPoint >= 32000 then
        BattleRewards1.setCurCopyTreasure(1);
        pImgFile = getRealUIResourcePath("img/img7098.png");
    else
        BattleRewards1.setCurCopyTreasure(2);
        pImgFile = getRealUIResourcePath("img/img7097.png");
    end
    local pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(6))
    if pImg and pImgFile then
        pImg:setImage(pImgFile:getData());
        pImg:setScale(2);
        pImg:setVisible(false);
    end
    
    setImaNum(allPoint);
    
    local pBtn = SCTypeCast:castNodeToButton(m_wnd:getChildByTag(13));--SCFunction:getUiNodeByIdlist("7025-13"));
    local imgFile = getRealUIResourcePath("img/img7100.png");
    if pBtn and imgFile then
        pBtn:setTitle(imgFile:getData());
        pBtn:luaSetSelectorOnClicked(onClickBattleRewards);
        pBtn:setAnchorPoint(CCPointMake(1, 0));
        pBtn:setPosition(CCPointMake(wndSize.width + (size.width - wndSize.width) / 2 + SX(36), SY(4) - (size.height - wndSize.height) / 2));
    end
    
    local pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(3));
    if pImg then
        pImg:setAnchorPoint(CCPointMake(1, 0));
        pImg:setPosition(CCPointMake(wndSize.width + (size.width - wndSize.width) / 2, 0 - (size.height - wndSize.height) / 2));
    end
    
    pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(1));
    if pImg then
        local pSize = pImg:getContentSize();
        pImg:setScaleX(size.width / pSize.width);
        pImg:setScaleY(size.height / pSize.height);
    end
    
    pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(2));
    if pImg then
        local pSize = pImg:getContentSize();
        pImg:setPosition(CCPointMake(wndSize.width / 2, wndSize.height + (size.height - wndSize.height) / 2));
        pImg:setScaleX(size.width / pSize.width);
    end
    
    pImg = SCTypeCast:castNodeToImage(m_wnd:getChildByTag(14));
    if pImg then
        pImg:setPosition(CCPointMake(SX(45) - (size.width - wndSize.width) / 2, SY(286) + (size.height - wndSize.height) / 2));
    end
end

function BattleRewards.showBattleRewardsWnd()
    local wnd = BattleRewards.initControl();
    if wnd == nil then
        return;
    end
    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
    if mapLay then
        local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
        if pBattleNode then
            m_wnd = wnd;
            ControlOperating();
            local size = pBattleNode:getContentSize();
            wnd:setAnchorPoint(CCPointMake(0.5, 0.5));
            wnd:setPosition(CCPointMake(size.width / 2, size.height / 2));
            pBattleNode:addChild(wnd);
		    wnd:setCloseButtonVisibled(false);
		    wnd:setAutoCloseOnTouchSpace(false);
            --wnd:setFrameVisibled(false);
        end
        return;
    end
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            ControlOperating();
		    wnd:setCloseButtonVisibled(false);
            return
        end
    end
end

function BattleRewards_showBattleRewardsWnd()
    if GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_COPYMAP) and GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_BOSS_MAP) then
        return 1
    end
    BattleRewards.showBattleRewardsWnd()
	return 1
end

function BattleRewards_FinishAllScore(dt)
	local ucAmount = dt:readByte();
	m_struScore = {__mode = "kv"};
	for i=1, ucAmount do
		table.insert(m_struScore, stScoreBonus.initWithStream(dt))
	end
end

function BattleRewards.wndCloss()
    m_wnd = nil;
    m_timeID = nil;
    m_posX = nil;
    m_posY = nil;
    m_pos = nil;
    m_struScore = {__mode = "kv"};
    BattleRewards1.wndCloss();
end

function BattleRewards.setCopyTreasure(tmp)
    --m_struScore = tmp;
end
----------------消息处理区----------------

----------------消息注册区----------------

----------------全局函数区----------------

--函数调用