--定义一个与文件名相同的table
BattleTeam = {}
------------------消息--------------------
local MSG_TEAM_INST_TEAMS					= 68;	--//多人副本组队列表
local MSG_TEAM_INST_TEAMS_END				= 69;	--//多人副本组队列表end
local MSG_TEAM_CREATE                       = 0;    --创建队伍
local MSG_TEAM_CLOSE_COPY_TEAM			    = 101;	--//关闭副本主界面
local MSG_TEAM_JOIN_TEAM					= 76;	--//加入队伍
local MSG_TEAM_INST_TEAM_ADD				= 71;	--//多人副本组队添加
local MSG_TEAM_INST_TEAM_UPDATE			    = 72;	--//多人副本组队更新
local MSG_TEAM_INST_TEAM_DEL				= 73;	--//多人副本组队删除
local MSG_TEAM_MEMBER_ADDMEMBER			    = 102;	--//将新加入的队员的信息告诉队伍中的现有成员
local MSG_TEAM_LEAVE						= 1;	--// 成员离队(包括队长)
local MSG_TEAM_QUIT						    = 11;	--// 解散队伍
local MSG_TEAM_PROMOTELEADER_TO_CLIENT	    = 35;	--//TC	//提升队长	队长改变的时候发送给客户端
local MSG_TEAM_INVITE						= 2;	--// 邀请加入队伍
local MSG_TEAM_ACCEPT_INVITE				= 3;	--// 接受邀请加入队伍
local MSG_TEAM_REFUSE_INVITE				= 4;	--// 拒绝邀请加入队伍
local MSG_TEAM_CHANGE_INST_ID				= 103;	--//更换关卡
local MSG_TEAM_WITH_FRIEND				= 106;	--//直接邀请好友组队
----------------结构定义区----------------
local m_teamId = nil;
local m_curInstanceType = nil;
local m_tmpInstanceType = nil;
local m_curCopyName = nil
local m_curCopyId = nil
		
local stInstTeam = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
		tmp.idTeam = dt:readInt();--//队伍ID
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szLeaderName = ""
        else
            tmp.szLeaderName = scStr:getData()   --//队长名字
        end
		tmp.ucNum = dt:readByte();	--// 人数 
		tmp.ucMaxNum = dt:readByte();	--//最大人数
		tmp.idInst = dt:readInt();--//多人副本ID
		scStr = dt:readString()
        if scStr == nil then
            tmp.szInstName = ""
        else
            tmp.szInstName = scStr:getData()   --//多人副本名字
        end
        scStr = dt:readString()
        if scStr == nil then
            tmp.szMemberInfo = ""
        else
		    tmp.szMemberInfo = scStr:getData(); --//队员情况(职业)
		end
		tmp.usLevel = dt:readShort(); --//队长等级
		if m_teamId == tmp.idTeam then
		    BattleTeam3.m_gameCopyIndex = GameCopyController_getGameNameIndex(tmp.idInst);
		    m_curCopyName = tmp.szInstName
		    m_curCopyId = tmp.idInst
		    if Hero:getSingleton():isATeamMember() == true then
		        local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
		        if pMultiPage1 then
                    pMultiPage1:selectPageWithIndex(1);
                end
            end
		end
        return tmp
    end
}

local MSG_Info4 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
		tmp.ucAmount = dt:readByte();
		tmp.stInstTeam = {__mode = "kv"};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stInstTeam, stInstTeam.initWithStream(dt));
        end
        return tmp
    end
}

local stCopyMemberInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.id = dt:readInt();
        local str = dt:readString();
        if str then
            tmp.szName = str:getData();
        else
            tmp.szName = "";
        end
		tmp.nFacePhoto = dt:readInt();
		tmp.usLevel = dt:readShort();
		tmp.nLookface = dt:readInt();
		tmp.ucMemberType = dt:readByte();		--//1: 队员  2:队长
		tmp.szTribeName = "";
		local szTribeName = dt:readString();
		if szTribeName then
		    tmp.szTribeName = szTribeName:getData();
		end
		
		tmp.dwStrength = dt:readInt();
		
        return tmp
    end
}

local tMsg_Info1 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        m_teamId = dt:readInt(); --队伍id
        tmp.ucAmount = dt:readByte();
        tmp.stfill = {__mode = "kv"};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stCopyMemberInfo.initWithStream(dt));
        end
        return tmp
    end
}
----------------常量定义区----------------

----------------变量定义区----------------
local teamInfo = {__mode = "kv"};
local m_curGameCopyID = nil;
local m_inviteId = nil;
--变量的定义
----------------UI控制器区----------------
function BattleTeam.initControl()
	local pWindow7023 = SCWindow:window()
	if pWindow7023 then
		pWindow7023:setTag(7023)
		pWindow7023:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow7023:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("img/new00152.png")
		if pImgPath then
			pWindow7023:setTitleWithImage(pImgPath:getData())
		end
		pWindow7023:setContentSize(AUTO_SIZE(480, 320))
		pWindow7023:luaSetSelectorOnClose(BattleTeam.releaseControl)
	end

	BattleTeam.m_multipage = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	if BattleTeam.m_multipage then
		BattleTeam.m_multipage:setTag(1)
		BattleTeam.m_multipage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BattleTeam.m_multipage:setPosition(AUTO_POS(0.00, 0.00))
		BattleTeam.m_multipage:setContentSize(AUTO_SIZE(480, 320))
		local pageImg = {"new00153.png", "new00149.png"}
		for i = 1, 2 do
			local pNode = SCNode:node()
			if pNode then
				pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)				   
				pNode:setPosition(ANCHOR_LEFT_BOTTOM)
				BattleTeam.m_multipage:addPage(pNode)
				local imgPath = getRealUIResourcePath("img/" .. pageImg[i])				   
				if imgPath then
					BattleTeam.m_multipage:setTitleAtPage(imgPath:getData(), i - 1)
				end
			end
		end
	end

	if BattleTeam.m_multipage and pWindow7023 then
		pWindow7023:addChild(tolua.cast(BattleTeam.m_multipage, "SCNode"))
	end
	return pWindow7023
end
function BattleTeam.releaseControl()
	BattleTeam.m_multipage = nil
	if BattleTeam.wndCloss then
		BattleTeam.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------

function BattleTeam.wndCloss()
    BattleTeam1.releaseControl()
    BattleTeam2.releaseControl()
    BattleTeam3.releaseControl()
    BattleTeam4.releaseControl()
    BattleTeam5.releaseControl()
    BattleTeam6.releaseControl()
    teamInfo = {__mode = "kv"};    
    BattleTeam3.m_gameCopyIndex = nil;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
    dataStream:writeShort(MSG_TEAM_CLOSE_COPY_TEAM);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
    end
    m_inviteId = nil;
    m_curGameCopyID = nil;
    m_tmpInstanceType = nil;
end

local function onMultipageSel(tag, pageIndex)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
    if not pMultiPage1 then return end 
    
    local pNode = pMultiPage1:getPageWithIndex(pageIndex);
    if nil == pNode then
        return;
    end
    if 0 == pageIndex then
    elseif 1 == pageIndex then
        if Hero:getSingleton():isATeamMember() == false then
            pMultiPage1:selectPageWithIndex(0);
            showMessage(L("str6161"));
            return;
        end
        local pDragNode = pNode:getChildByTag(3);
        if pDragNode == nil then
            BattleTeam3.initTeam();
        end
    end
end

local function onClickedSelect(tag)
    if 2 == tag then
        showGameCopyWnd(1, 0);
        m_tmpInstanceType = 1;
    elseif 3 == tag then
        showGameCopyWnd(2, 0);
        m_tmpInstanceType = 2;
    elseif 4 == tag then
        showGameCopyWnd(3, 0);
        m_tmpInstanceType = 3;
    end
    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7023-70231-1"));
    if pListBox then
        if 5 == tag then
            local pt = pListBox:getOffset();
            if pt then
                pListBox:setOffset(CCPointMake(pt.x, pt.y + pListBox:getContentSize().height));
            end
        else
            GameCopyController_selectList(pListBox);
        end
    end
end

function BattleTeam.onClickedType(tag)
    if 6 == tag then
        local wnd = SCFunction:getUiNodeByIdlist("7023");
        if wnd then
            local pframeWnd = FrameWindow:frameWnd();
            if pframeWnd then
                pframeWnd:setTag(70231);
                pframeWnd:setContentSize(CCSizeMake(AUTO_W(270), AUTO_H(250)));
                local pLabel = SCLabel:labelWithStringFont(L("str6231"), DEFAULT_FONT_NAME, F(12));
                if pLabel then
                    pLabel:setPosition(CCPointMake(SX(22), SY(220)));
                    pframeWnd:addChild(pLabel);
                end
                pLabel = SCLabel:labelWithStringFont(L("str6235"), DEFAULT_FONT_NAME, F(12));
                if pLabel then  
                    pLabel:setAnchorPoint(CCPointMake(0.5, 0));
                    pLabel:setColor(color_green);
                    pLabel:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, SY(196)));
                    pframeWnd:addChild(pLabel);
                end
                for i = 1, 3 do
                    local pBtn = SCButton:button(EnumBtnType9Atlas)
                    if pBtn then
                        pBtn:setTag(i + 1);
                        pBtn:setPosition(CCPointMake(SX(75) + SX(60) * (i - 1), SY(213)));
                        pBtn:setContentSize(CCSizeMake(SX(60), SY(24)));
                        pBtn:setTitle(L("str623" .. i + 1), DEFAULT_FONT_NAME, F(12));
                        pBtn:luaSetSelectorOnClicked(onClickedSelect);
                        pframeWnd:addChild(pBtn);
                    end
                end
                local pListBox = SCListBox:boxWithWidthHeight(AUTO_W(250), AUTO_H(150));
                if pListBox then
                    onClickedSelect(2);
                    pListBox:setAnchorPoint(CCPointMake(0.5, 0));
                    pListBox:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, SY(35)));
                    GameCopyController_selectList(pListBox);
                    pListBox:setTag(1);
                    pframeWnd:addChild(pListBox)
                end
                local pBtn = SCButton:button();
                local pImgPath = getRealUIResourcePath("img/new00092.png");
                if pBtn then
                    pBtn:setTag(5);
                    pBtn:setTitle(pImgPath:getData());
                    pBtn:luaSetSelectorOnClicked(onClickedSelect);
                    pBtn:setAnchorPoint(CCPointMake(0.5, 0));
                    pBtn:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, SY(12)));
                    pframeWnd:addChild(pBtn);
                end
                pframeWnd:setCloseBtnVisible(false);
                local size = wnd:getContentSize();
                pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
                pframeWnd:setPosition(CCPointMake(size.width / 2, size.height / 2));
                wnd:addChild(pframeWnd);
            end
        end
    elseif 7 == tag then
        --[[     
        if BattleTeam3.m_gameCopyIndex == nil or BattleTeam3.m_gameCopyIndex == "" then 
            BattleTeam.onClickedType(6);
        else
            GameCopyController_onClickInGameCopy(BattleTeam3.m_gameCopyIndex);
        end
        --]]
        if nil == m_curCopyId or 0 == m_curCopyId then
            BattleTeam.onClickedType(6)
        else
            GameCopyController_InGameCopyWithInstanceId(m_curCopyId)
        end
    elseif 8 == tag then
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
        if nil == dataStream then
            return;
        end
        dataStream:writeShort(MSG_TEAM_CREATE);
        dataStream:writeInt(Hero:getSingleton():getID());
        if m_curGameCopyID == nil then
            dataStream:writeInt(0);
        else
            dataStream:writeInt(m_curGameCopyID);
        end
        if SCDataTransThread:getSingleton() then
            SCDataTransThread:getSingleton():transData(dataStream);
            SCActivityIndicator:getSingleton():show();
        end
        BattleTeam3.m_gameCopyIndex = GameCopyController_getGameNameIndex(m_curGameCopyID)
    end
end

local function onListBoxClicked(tag, itemTag, itemIndex)
    if Hero:getSingleton():isATeamMember() == false then
        BattleTeam3.clearTeam();
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
        if nil == dataStream then
            return;
        end
        dataStream:writeShort(MSG_TEAM_JOIN_TEAM);
        dataStream:writeInt(itemTag);
        if SCDataTransThread:getSingleton() then
            SCDataTransThread:getSingleton():transData(dataStream);
            SCActivityIndicator:getSingleton():show();
        end
    elseif m_teamId ~= itemTag then
        showMessage(L("str6236"));
    else
        local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
        if pMultiPage1 then
            pMultiPage1:selectPageWithIndex(1);   
        end
    end
end

local function onClickDown(tag)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
    if not pMultiPage1 then return end 

    local pNode = pMultiPage1:getPageWithIndex(0);
    if pNode == nil then
        return;
    end

    local pListBox3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-2-3"), pNode), "SCListBox")
    if pListBox3 then
        local pt = pListBox3:getOffset();
        if pt then
            pListBox3:setOffset(CCPointMake(pt.x, pt.y + pListBox3:getContentSize().height));
        end
    end
end

local function getBattleTeamInfoNode()
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
    if not pMultiPage1 then return end 

    pMultiPage1:luaSetSelectorOnPageSelected(onMultipageSel);
    local pNode = pMultiPage1:getPageWithIndex(0);
    if pNode == nil then
        return;
    end
    local pChildNode = nil;
    local pListBox3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-2-3"), pNode), "SCListBox")
    if pListBox3 == nil then
        pChildNode = BattleTeam1.initControl();
        if pChildNode then
            pNode:addChild(pChildNode);
            local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-10", pChildNode));
            if pBtn then
                pBtn:luaSetSelectorOnClicked(onClickDown);
            end
        end
    end
    return pNode:getChildByTag(1);
end

function BattleTeam.setTeamInfo()
    local pChildNode = getBattleTeamInfoNode();
    
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
    if not pMultiPage1 then return end 

    local pNode = pMultiPage1:getPageWithIndex(0);
    if pNode == nil then
        return;
    end

    local pListBox3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-2-3"), pNode), "SCListBox")
    if pChildNode == nil or pListBox3 == nil then
        return;
    end
    pListBox3:luaSetSelectorOnItemSelected(onListBoxClicked);
    pListBox3:removeAllItems()
    for i = 1, #teamInfo do
        for j = 1, teamInfo[i].ucAmount do
            --if m_curGameCopyID == nil or m_curGameCopyID == teamInfo[i].stInstTeam[j].idInst then
                local pDragNode = BattleTeam2.initControl();
                if pDragNode then
                    local pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(3));
                    if pLabel then
                        pLabel:setText(teamInfo[i].stInstTeam[j].szLeaderName);
                    end
                    pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(4));
                    if pLabel then
                        pLabel:setText(teamInfo[i].stInstTeam[j].szInstName);
                    end
                    pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(5));
                    if pLabel then
                        pLabel:setText(teamInfo[i].stInstTeam[j].szMemberInfo);
                    end
                    pListBox3:addItem(pDragNode);
                    pDragNode:setTag(teamInfo[i].stInstTeam[j].idTeam);
                    local pImg = SCTypeCast:castNodeToImage(pDragNode:getChildByTag(6));
                    if pImg then
                        if m_teamId == teamInfo[i].stInstTeam[j].idTeam then    
                            m_curGameCopyID = teamInfo[i].stInstTeam[j].idInst;
                            pImg:setVisible(true);
                            BattleTeam3.init();
                            BattleTeam.setGameCopyName();
                        else
                            pImg:setVisible(false);
                        end
                    end
                end
           --end
        end
    end
end

local function ControlOperating()
    BattleTeam.setTeamInfo();
    local pChildNode = getBattleTeamInfoNode();
    if pChildNode == nil then
        return;
    end
    local pNode = pChildNode:getChildByTag(2);
    if pNode then
        local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(2));
        if pDragNode == nil then
            pDragNode = SCTypeCast:castNodeToDragNode(BattleTeam2.initControl());
            if pDragNode then
                pDragNode:setFrameVisibled(false);
                --pDragNode:setFrameType(EnumFrameTypeLine);
                pNode:addChild(pDragNode);
                for i = 1, 3 do
                    local pLabel = SCTypeCast:castNodeToLabel(pDragNode:getChildByTag(i + 2));
                    if pLabel then
                        pLabel:setText(L("str615" .. i - 1));
                        pLabel:setColor(color_orange);
                    end
                end
                local pImg = SCTypeCast:castNodeToImage(pDragNode:getChildByTag(1));
                if pImg then
                    pImg:setVisible(false);
                end
                pImg = SCTypeCast:castNodeToImage(pDragNode:getChildByTag(6));
                if pImg then
                    pImg:setVisible(false);
                end
                pDragNode:setPosition(CCPointMake(SX(3), SY(223)));
            end
        end
    end    
    for i = 1, 3 do
        local pBtn = SCTypeCast:castNodeToButton(pChildNode:getChildByTag(5 + i));
        if pBtn then
            pBtn:luaSetSelectorOnClicked(BattleTeam.onClickedType);
        end
    end
    BattleTeam.setGameCopyName();
end

local function setBattleTeamWndInfo(tmp)
    for i = 1, #teamInfo do
        for j = 1, teamInfo[i].ucAmount do
            for k = 1, tmp.ucAmount do
                if teamInfo[i].stInstTeam[j].idTeam == tmp.stInstTeam[k].idTeam then
                    teamInfo[i].stInstTeam[j] = tmp.stInstTeam[k];
                    return;
                end
            end
        end
    end
    table.insert(teamInfo, tmp);
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        ControlOperating();
    end
end

local function showBattleTeamWnd()
    local wndCtrl = getCurentSceneWindowController(7023) 
    if wndCtrl then
        return;
    end

    local wnd = BattleTeam.initControl();
    if wnd == nil then
        return;
    end
    if wnd then
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        end
    end
    BattleTeam3.initTeam();
    if (Hero:getSingleton():iSATeamLeader()) or (Hero:getSingleton():isATeamMember()) then
        local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
        if pMultiPage1 then
           pMultiPage1:selectPageWithIndex(1);
        end
    end
end

local function updataTeamInfo(tmp)
    for i = 1, tmp.ucAmount do
        BattleTeam3.insertPlay(tmp.stfill[i].dwStrength, tmp.stfill[i].szTribeName, tmp.stfill[i].szName, tmp.stfill[i].usLevel, tmp.stfill[i].nLookface, tmp.stfill[i].id, tmp.stfill[i].ucMemberType);
    end
end

local function updataBattleTeamWndInfo(tmp)
    for i = 1, #teamInfo do
        for j = 1, teamInfo[i].ucAmount do
            for k = 1, tmp.ucAmount do
                if teamInfo[i].stInstTeam[j].idTeam == tmp.stInstTeam[k].idTeam then
                    teamInfo[i].stInstTeam[j] = tmp.stInstTeam[k];
                    return;
                end
            end
        end
    end
end

local function deleteBattleTeamWndInfo(idTeam)    
    for i = 1, #teamInfo do
        for j = 1, teamInfo[i].ucAmount do
            if teamInfo[i].stInstTeam[j].idTeam == idTeam then
                --teamInfo[i].stInstTeam[j] = nil;
                table.remove(teamInfo[i].stInstTeam, i);
                teamInfo[i].ucAmount = teamInfo[i].ucAmount - 1;
                return;
            end
        end
    end
end

local function onClickedDelete(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
    if 0 == tag then
        dataStream:writeShort(MSG_TEAM_REFUSE_INVITE);
    elseif 1 == tag then
        dataStream:writeShort(MSG_TEAM_ACCEPT_INVITE);
    end
    dataStream:writeInt(m_inviteId);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
    end
end

----------------消息处理区----------------
local function recGameCopyTeamInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end    
    local action = dt:readShort();
    if MSG_TEAM_INST_TEAMS == action then   
        setBattleTeamWndInfo(MSG_Info4.initWithStream(dt));
    elseif MSG_TEAM_INST_TEAMS_END == action then        
        setBattleTeamWndInfo(MSG_Info4.initWithStream(dt));
        showBattleTeamWnd();
    elseif MSG_TEAM_CREATE == action then
        BattleTeam3.clearTeam();
        local id = dt:readInt();--队长ID
        local idInstID = dt:readInt();--副本ID
        
        local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
        if pMultiPage1 then
            pMultiPage1:selectPageWithIndex(1);   
        end
        local roleLevel = Hero:getSingleton():getLeval()  
        --BattleTeam3.insertPlay(nil, nil, Hero:getSingleton():getName():getData(), roleLevel, Hero:getSingleton():getLookFace(), Hero:getSingleton():getID(), 2);
    elseif MSG_TEAM_MEMBER_ADDMEMBER == action then
        BattleTeam.setInstanceType()
        updataTeamInfo(tMsg_Info1.initWithStream(dt))
    elseif MSG_TEAM_INST_TEAM_UPDATE == action then
        updataBattleTeamWndInfo(MSG_Info4.initWithStream(dt));
        BattleTeam.setTeamInfo();
    elseif MSG_TEAM_LEAVE == action then
        local playID = dt:readInt();
        BattleTeam3.leavePlay(playID);
    elseif MSG_TEAM_INST_TEAM_ADD == action then
        setBattleTeamWndInfo(MSG_Info4.initWithStream(dt));
        BattleTeam.setTeamInfo();
    elseif MSG_TEAM_INST_TEAM_DEL == action then
        local idTeam = dt:readInt();
        local wndCtrl = getCurentSceneWindowController(7023) 
        if not wndCtrl then
            return
        end
        deleteBattleTeamWndInfo(idTeam);
        BattleTeam.setTeamInfo();
    elseif MSG_TEAM_QUIT == action then
        BattleTeam3.clearTeam();  
        
        local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
        if pMultiPage1 then
            pMultiPage1:selectPageWithIndex(0);   
        end
        m_curGameCopyID = nil;
        BattleTeam3.m_gameCopyIndex = nil;
        BattleTeam.setTempInstanceType(nil)
        BattleTeam.setInstanceType()
        m_curCopyId = nil
        m_curCopyName = nil
        BattleTeam.setGameCopyName();
    elseif MSG_TEAM_PROMOTELEADER_TO_CLIENT == action then
        local playID = dt:readInt();   
        BattleTeam3.improveCaptain(playID);
    elseif MSG_TEAM_INVITE == action then
        m_inviteId = dt:readInt();
        local str = dt:readString();
        local playName = nil;
        if str then
            playName = str:getData();
        else
            playName = "";
        end
        luashowConfirmationWindow(playName .. _LTParser("str6163"), WIN_YES_NO, onClickedDelete);
    end
end

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recGameCopyTeamInfo, _MSG_TEAM, 0, nil);
----------------全局函数区----------------
function BattleTeam.setcurGameCopyID(id)
    m_curGameCopyID = id;
end

function BattleTeam.getGameName()
    return GameCopyController_getGameName(m_curGameCopyID);
end

--副本名字
function BattleTeam.setGameCopyName()
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7023-1"), "SCMultiPage")
    if not pMultiPage1 then return end 

    pMultiPage1:luaSetSelectorOnPageSelected(onMultipageSel);
    local pNode = pMultiPage1:getPageWithIndex(0);
    if pNode == nil then
        return;
    end
    local pChildNode = nil;
    local pListBox3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-2-3"), pNode), "SCListBox")
    if pListBox3 == nil then
        pChildNode = BattleTeam1.initControl();
        pNode:addChild(pChildNode);
    end
    pChildNode = pNode:getChildByTag(1);
    if nil == pChildNode or pListBox3 == nil then
        return;
    end
    local pImage = SCTypeCast:castNodeToImage(pChildNode:getChildByTag(5));
    local nImg, nBossImg = GameCopyController_getGameImgId(m_curGameCopyID);
    local imgFile = getRealUIResourcePath("instance/" .. nImg .. ".png");
    if pImage then
        if not imgFile then
            local path = RES("instance/20101.pn")
            if path then
                pImage:setImage(path)
            end
        else
            pImage:setImage(imgFile:getData());
        end
        pImage:removeChildByTag(99, true);
        local imgFile
        if nBossImg then
            imgFile = getRealUIResourcePath("PlotPhoto/" .. nBossImg .. ".png");
        end
        if imgFile then
            local pImg = SCImage:imageWithFile(imgFile:getData());
            if pImg then
                local size = pImage:getContentSize();
                pImg:setAnchorPoint(CCPointMake(0.5, 1));
                pImg:setPosition(CCPointMake(size.width / 2, size.height));
                pImg:setScale(0.7);
                pImg:setTag(99);
                local imgSize = pImg:getContentSize();
                pImg:setImage(imgFile:getData(), CCRectMake(0, 0, imgSize.width, imgSize.height * 0.55));
                pImage:addChild(pImg);
            end
        end
    end
    local pLabel = SCTypeCast:castNodeToLabel(pChildNode:getChildByTag(9));
    if pLabel then
        pLabel:setText(BattleTeam.getGameName());
    end
end

--打开组队
function BattleTeam_openBattleTeamWnd()
    BattleTeam.openBattleTeamWnd()
end
function BattleTeam.openBattleTeamWnd()
    --showBattleTeamWnd();        
    local MAP_CHEAT_PROSON	= 1080400--,			// 外挂监狱
    if MAP_CHEAT_PROSON == math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100 then
        showMessage(L("str20047"))
        return
    end
    
    if m_curInstanceType == nil then
	    showGameCopyWnd(1, 0);
    else
	    showGameCopyWnd(m_curInstanceType, 0);
	end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
    local MSG_TEAM_OPEN_COPY_TEAM = 99;	--//打开副本主界面
    dataStream:writeShort(MSG_TEAM_OPEN_COPY_TEAM);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

--更换关卡
function BattleTeam.ReplacementLevel()
    if Hero:getSingleton():iSATeamLeader() == false then
        return;
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
    dataStream:writeShort(MSG_TEAM_CHANGE_INST_ID);
    dataStream:writeInt(m_curGameCopyID);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
    end
end

function BattleTeam.setTeamId()
    m_teamId = nil;
end

function BattleTeam.setTempInstanceType(tmpType)
    m_tmpInstanceType = tmpType;
end

function BattleTeam.setInstanceType()
    m_curInstanceType = m_tmpInstanceType;
end

function BattleTeam.getCurTeamCopyName()
    return m_curCopyName
end

function BattleTeam.setCurTeamCopyName(name)
    m_curCopyName = name
end

function BattleTeam.getCurTeamCopyId()
    return m_curCopyId
end

function BattleTeam.setCurTeamCopyId(id)
    m_curCopyId = id
end

--邀请好友
function BattleTeam_inviteFriendToTeam(heroId,iduser)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
    if nil == dataStream then
        return;
    end
    dataStream:writeShort(MSG_TEAM_WITH_FRIEND);
    dataStream:writeInt(heroId);
    dataStream:writeInt(0);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
    dataStream:writeShort(MSG_TEAM_INVITE);
    dataStream:writeInt(iduser);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
    end
end
--函数调用