--定义一个与文件名相同的table
BlowRecruit = {}
------------------消息--------------------
local EUDEMONSHOW_RECRUIT_PARTNER_LIST	= 47;			--//招募伙伴列表
local EUDEMONSHOW_TRAIN_VIEW = 43 --//查看伙伴详情
----------------结构定义区----------------
local stPartnerInfo = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		
		local tmp = {
            __mode = "kv",
        }
		
		tmp.idPartnerType = dt:readInt();
		local tmpStr = dt:readString();
		if tmpStr == nil then
			tmp.szName = "";
		else	
			tmp.szName = tmpStr:getData();
		end
		
		tmpStr = dt:readString();
		if tmpStr == nil then
			tmp.szClanName = "";
		else	
			tmp.szClanName = tmpStr:getData();
		end		
		
		
		tmp.ucLevel = dt:readByte();
		tmp.ucStatusType = dt:readByte();
		
		tmpStr = dt:readString();
		if tmpStr == nil then
			tmp.szTip = "";
		else	
			tmp.szTip = tmpStr:getData();
		end	
		
		tmpStr = dt:readString();
		if tmpStr == nil then
			tmp.szTip2 = "";
		else	
			tmp.szTip2 = tmpStr:getData();
		end	
		
		tmp.nFacePhoto = dt:readInt();
		tmp.ucRecommend = dt:readByte();
		tmp.ucClan = dt:readByte();
				
		tmp.nAtk = dt:readInt()
		--tmp.nDef = 0--dt:readInt()
		tmp.nSkillAtk = dt:readInt()
		--tmp.nSkillDef = 0--dt:readInt()
		tmp.dwHpGrowUp = dt:readInt()
		tmp.nHp = dt:readInt()
		tmp.szSkillName = dt:readString()
		if tmp.szSkillName then
		    tmp.szSkillName = tmp.szSkillName:getData()
		else
		    tmp.szSkillName = ""
		end
		return tmp
	end
}

----------------常量定义区----------------
local EUDEMONSHOW_RECRUIT_PARTNER_LIST	= 47;			--//招募伙伴列表
local EUDEMONSHOW_RECRUIT_PARTNER_LIST_END = 48;
local EUDEMONSHOW_RECRUIT_PARTNER = 49;
local EUDEMONSHOW_TRAIN_INFO = 66;          --//培养信息
local EUDEMONSHOW_TRAIN_EUDEMONTYPE = 67;          --//点击培养 
----------------变量定义区----------------
local m_stHotelPartnerList = {}
local m_stEudemonTrainInfo = {}
local m_typeTrain = nil;
local m_curPartnerIndex = nil;
local m_isFirst = nil
--变量的定义
----------------UI控制器区----------------
function BlowRecruit.initControl()
	local pWindow7020 = SCWindow:window()
	if pWindow7020 then
		pWindow7020:setTag(7020)
		pWindow7020:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow7020:setPosition(AUTO_POS(0.00, 0.00))
		pWindow7020:setContentSize(AUTO_SIZE(480, 320))
		pWindow7020:luaSetSelectorOnClose(BlowRecruit.releaseControl)
	end

	BlowRecruit.m_pMultipage = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	if BlowRecruit.m_pMultipage then
		BlowRecruit.m_pMultipage:setTag(1)
		BlowRecruit.m_pMultipage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BlowRecruit.m_pMultipage:setPosition(AUTO_POS(0.00, 0.00))
		BlowRecruit.m_pMultipage:setContentSize(AUTO_SIZE(480, 320))
		local pageImg = {"new00089.png", "new00136.png"}
		for i = 1, 2 do
			local pNode = SCNode:node()
			if pNode then
			    pNode:setTag(i)
				pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)				   
				pNode:setPosition(ANCHOR_LEFT_BOTTOM)
				BlowRecruit.m_pMultipage:addPage(pNode)
				local imgPath = getRealUIResourcePath("img/" .. pageImg[i])				   
				if imgPath then
					BlowRecruit.m_pMultipage:setTitleAtPage(imgPath:getData(), i - 1)
				end
			end
		end
	end

	if BlowRecruit.m_pMultipage and pWindow7020 then
		pWindow7020:addChild(tolua.cast(BlowRecruit.m_pMultipage, "SCNode"))
	end
	return pWindow7020
end
function BlowRecruit.releaseControl()
	BlowRecruit.m_pMultipage = nil
	if BlowRecruit.wndCloss then
		BlowRecruit.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------
--发送请求伙伴列表
local function sendHotePartnerList()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
	if dataStream then
		dataStream:writeShort(EUDEMONSHOW_RECRUIT_PARTNER_LIST);
		dataStream:writeShort(255);
        dataStream:writeByte(255);
        dataStream:writeByte(0);
		dataStream:writeByte(0);
		SCDataTransThread:getSingleton():transData(dataStream);
		SCActivityIndicator:getSingleton():show();
	end
end
--发送招募伙伴信息
local function sendRecruitPartner(idPartnerType)
    GuidePoint_LuaAddCount(14, 4)  --增加招募武将引导计数
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
	if dataStream then
		dataStream:writeShort(EUDEMONSHOW_RECRUIT_PARTNER);
		dataStream:writeInt(idPartnerType);
		SCDataTransThread:getSingleton():transData(dataStream);
		SCActivityIndicator:getSingleton():show();
	end	
end
--发送请求培养信息
local function sendRequestTrainInfo(idPartnerType)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
	if dataStream then
		dataStream:writeShort(EUDEMONSHOW_TRAIN_INFO);
		dataStream:writeInt(idPartnerType);
		SCDataTransThread:getSingleton():transData(dataStream);
		SCActivityIndicator:getSingleton():show();
	end		
end
--发送培养
local function sendSureTrain(ucType, idPartnerType)
    if ucType == 1 then
        local money = Hero:getSingleton():getMoney();
        if money < 100000 then
            GuidePoint_shopBuyTip()
            return;
        end
    end
	GuidePoint_LuaAddCount(14, 3)
	if ucType == 1 or ucType == 2 or ucType == 3 or ucType == 4 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
		if dataStream then
			dataStream:writeShort(EUDEMONSHOW_TRAIN_EUDEMONTYPE);
			dataStream:writeByte(ucType-1);
			dataStream:writeInt(idPartnerType);
			SCDataTransThread:getSingleton():transData(dataStream);
			SCActivityIndicator:getSingleton():show();
		end	
	end		
end
--发送出战信息
local function sendFightInfo(idRole, pos)
    if pos == 1 then
        GuidePoint_LuaAddCount(14, 6)
    end
	if idRole and pos then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
		if dataStream then
			dataStream:writeShort(USERINFO_FORMATION);
			dataStream:writeInt(idRole);
			dataStream:writeByte(pos);
			SCDataTransThread:getSingleton():transData(dataStream);
			SCActivityIndicator:getSingleton():show();
		end	
	end
end

-----------------------------------伙伴布阵界面------------------------------------
local function onClickedPrison(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
    if dataStream then
        dataStream:writeShort(EUDEMONSHOW_RECRUIT_PARTNER_LIST);
        dataStream:writeShort(0);
        dataStream:writeByte(0);
        dataStream:writeByte(0);
        if SCDataTransThread:getSingleton() then
            SCDataTransThread:getSingleton():transData(dataStream);
            SCActivityIndicator:getSingleton():show();
        end
    end
end

local function onClickedMultipage(tag, pageIndex)
	local index1 = 1;
	local index2 = 0;
	if pageIndex == 1 then
		index1 = 0;
		index2 = 1;
	end
	
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
	if not pMultiPage then return end 
	
	local pNode = pMultiPage:getPageWithIndex(index1);
	if pNode then
		local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
		if pDragNode then
			pDragNode:setVisible(false);
		end
	end
	
	pNode = pMultiPage:getPageWithIndex(index2);
	if pNode then
		local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
		if pDragNode then
			pDragNode:setVisible(true);
		end
	end
	
    if 0 == pageIndex then
        GuidePoint_LuaAddCount(14, 5)  --武将招募增加引导计数
		local bFirst= pMultiPage:isPageFirstTimeSelected(0);
		if bFirst then
			BlowRecruit_refreshPartnerInfo();
		end
    elseif 1 == pageIndex then
		if not m_isFirst then
			sendHotePartnerList();
		end
		m_isFirst = true
    end
end

--流放
local function onBanishBtnClick(tag)
end

--关闭玩家属性界面
local function onClosePartnerInfoBtnClick(tag)
	local wndCtrl =  getCurentSceneWindowController(6002);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end	
end

--显示伙伴信息窗口
local function showPartnerInfoWnd(tag)
	local pRunningScene = getRunningScene()
    if not pRunningScene then return end
    
	if pRunningScene:getUINode():getChildByTag(6002) then return end
	
    local wnd = BlowRecruit6.initControl();
    if wnd == nil then
		return
    end
    
	pRunningScene:getUINode():addChild(wnd)
	
	local role = Hero:getSingleton();
    if nil == role then
        return;
    end
	local parterData = role:getPartnerWithPos(tag); 
	if parterData == nil then
		return;
	end
	
	wnd:setBackButtonVisibled(false);
    wnd:setCloseButtonVisibled(false);
    wnd:setFrameVisibled(false);
    wnd:setAutoCloseOnTouchSpace(true)
	
	local pButton2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("6002-1-2"))
	if pButton2 then
		pButton2:luaSetSelectorOnClicked(onBanishBtnClick);
		pButton2:setVisible(false);
	end
	
	if BlowRecruit6.m_pButton6 then--不存在的变量
		BlowRecruit6.m_pButton6:luaSetSelectorOnClicked(onClosePartnerInfoBtnClick);
	end
	
	local pTextBox3 = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlist("6002-1-3"))
	if parterData and pTextBox3 then
		local strInfo = "*6"..parterData.strName:getData();
		strInfo = strInfo.."_"..L("str5056").." "..parterData.strClanName:getData();
		strInfo = strInfo.."_"..L("str0013").." "..parterData.usLevel;
		strInfo = strInfo.."_"..L("str5069").." "..parterData.nHp;
		strInfo = strInfo.."_"..L("str9147").." "..parterData.dwHpGrowUp;
		strInfo = strInfo.."_"..L("str9143").." "..parterData.nAtk;
		strInfo = strInfo.."_"..L("str9144").." "..parterData.nDef;
		strInfo = strInfo.."_"..L("str9145").." "..parterData.nSkillAtk;
		strInfo = strInfo.."_"..L("str9146").." "..parterData.nSkillDef;
		strInfo = strInfo.."_".."*3"..L("str0295").." "..parterData.strSkillTypeName:getData();
		pTextBox3:setParserDelegate(TextParser:getSingleton());
		pTextBox3:setText(strInfo); 
	end
end

local function onListSelect(tag, itemTag, itemIndex)    
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
    if not pMultiPage then return end 
    
    local pNode = pMultiPage:getPageWithIndex(0);
    if not pNode then return end 
    
    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("1-2-7", pNode))
    if not pListBox then return end 
    
    local node = SCTypeCast:castNodeToDragNode(pListBox:getChildByTag(itemTag))
    if node then
        node:setFrameType(EnumFrameTypeListSelect)
        node:setFrameVisibled(true)
    end
	
	if itemTag >= 0 then
		showPartnerInfoWnd(itemTag)
	end
end

local function onListUnSelect(tag, itemTag, itemIndex)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
    if not pMultiPage then return end 
    
    local pNode = pMultiPage:getPageWithIndex(0);
    if not pNode then return end 
    
    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("1-2-7", pNode))
    if not pListBox then return end 
    
    local node = SCTypeCast:castNodeToDragNode(pListBox:getChildByTag(itemTag))
    if node then
        node:setFrameType(EnumFrameTypeListNormal)
        node:setFrameVisibled(true)
    end
end

--玩家信息查看
local function onPartnerInfoBtnClick(tag)
	local wndCtrl = getCurentSceneWindowController(6002);
	if wndCtrl then
		return;
	end
	
    local index = tag - 4000;
    if index >= 0 then
	    showPartnerInfoWnd(index);
	end
end

--点击待命按钮
local function onRestBtnClick(tag)
    local role = Hero:getSingleton();
    if nil == role then
        return;
    end
	
    local index = tag - 3000;
    if index < 0 then
        return 
    end
    
	local parterData = role:getPartnerWithPos(index);
	if parterData then
		sendFightInfo(parterData.nID, 0);
	end	
end

--获取布阵数据
local function getFormationInfo()
    local mapLayer = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer")
    if mapLayer then
        return mapLayer:getFormationInfo()
    end
    return nil
end

--点击出战
local function onFightBtnClick(tag)
	local formationInfo = getFormationInfo();
    local role = Hero:getSingleton();
    if nil == role then
        return;
    end
    
	local index = tag - 5000;
	if index < 0 then
	    return
	end
	
	local parterData = role:getPartnerWithPos(index);
	if parterData then
		for j=1, 3 do
		    if formationInfo then
                if formationInfo.posInfo[j-1].idRole == 1 then
                    sendFightInfo(parterData.nID, j);
                    break;
                end	
                if j == 3 then
                    showMessage(_LTParser("str3043"))
                end
            end			
		end	
	end
end
--点击伙伴详情查看
local function onClickLookMate(tag)
    
    local pMainInterface = getMainInterface()
    if pMainInterface ~= nil then
        pMainInterface:onClickHero(tag)
    end
    
    --[[
    local dt = SCDataTransStream:streamWithCommand(_MSG_EUDEMONINFO);
    dt:writeShort(EUDEMONSHOW_TRAIN_VIEW)--查看
    dt:writeInt(tag)--// 伙伴ID
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
    ]]
end

--刷新已招募伙伴信息
function BlowRecruit_refreshPartnerInfo()
    local role = Hero:getSingleton();
    if nil == role then
        return;
    end
	
	local formationInfo = getFormationInfo();	
	
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
    if not pMultiPage then return end 
    
    local pNode = pMultiPage:getPageWithIndex(0);
    if not pNode then return end 
    
    local pImage8 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent(("1-8"), pNode))
    local pImage9 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent(("1-9"), pNode))
    local pImage10 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent(("1-10"), pNode))
	if pImage9 and pImage10 and pImage8 then
	    local lev = Hero:getSingleton():getLeval();
	    if lev >= 100 then
            pImage9:removeAllChildrenWithCleanup(true);
            pImage10:removeAllChildrenWithCleanup(true);
            pImage8:removeAllChildrenWithCleanup(true);
        elseif lev >= 70 then
            pImage10:removeAllChildrenWithCleanup(true);
            pImage8:removeAllChildrenWithCleanup(true);
        elseif lev >= 14 then
            pImage8:removeAllChildrenWithCleanup(true);
        end
	end
	
    local amount = role:partnerSize();
	local inCount = 0;
	local mateItem = 2;
    
    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent(("1-2-7"), pNode))
    if pListBox then		
		pListBox:removeAllItems();
        for i=0, amount-1 do
			local parterData = role:getPartnerWithPos(i);
			if parterData then
				local pos = 0;
				for j=1, 3 do
				    if formationInfo then
                        if formationInfo.posInfo[j-1].idRole == parterData.nID then
                            pos = j;
                            break;
                        end		
                    end			
				end
				
				if pos == 0 then
					local pChildNode = BlowRecruit2.initControl();
					if pChildNode then
					    local pImage2 = SCTypeCast:castNodeToImage(pChildNode:getChildByTag(2))
						if pImage2 then
							local imgPath = getRealUIResourcePath("faceicon/"..parterData.nFacePhoto..".jp");
							if imgPath then			
								pImage2:setImage(imgPath:getData());
								pImage2:setScale(0.6)
							end
						end
						
						local pLabel3 = SCTypeCast:castNodeToLabel(pChildNode:getChildByTag(3))
						if pLabel3 then
							pLabel3:setText(parterData.strName:getData());
						end
						
						local pLabel4 = SCTypeCast:castNodeToLabel(pChildNode:getChildByTag(4))
						if pLabel4 then
							pLabel4:setText("LV."..parterData.usLevel);
						end
						
						local pButton5 = SCTypeCast:castNodeToButton(pChildNode:getChildByTag(5))
						if pButton5 then
							pButton5:setTag(5000 + i);
							pButton5:luaSetSelectorOnClicked(onFightBtnClick);
						end
						
						pListBox:addItem(pChildNode);
						pChildNode:setTag(i);
					end
					
					inCount = inCount + 1;
				else
					local node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent(("1-8"), pNode))
					if pos == 2 then
						node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent(("1-10"), pNode))
					elseif pos == 3 then
						node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent(("1-9"), pNode))
					end
					
					if node then
						local partnerRole = MapObject:newMapObject(parterData.dwLookFace);
						if partnerRole then
						   --[[local ani = partnerRole:getAnimation();
						    if ani then
						        ani:setScale(CCPointMake(1.0, 1.0));
						    end]]
							local roleNode = SCRoleNode:nodeWithRole(partnerRole);
							if roleNode then
								roleNode:setAnchorPoint(CCPointMake(0.5, 0));
								roleNode:setPosition(CCPointMake(node:getContentSize().width/2, SY(20)));
								node:addChild(roleNode);
								
								local button = SCButton:button();
								if button then
									button:setTag(4000 + i);
									button:setContentSize(roleNode:getContentSize());
									button:luaSetSelectorOnClicked(onPartnerInfoBtnClick);
									roleNode:addChild(button);
								end
								
								local buttonRest = SCButton:button();
								if buttonRest then
									buttonRest:setTag(3000 + i);
									buttonRest:setAnchorPoint(CCPointMake(0.5, 0))
									--buttonRest:setPosition(CCPointMake(roleNode:getContentSize().width/2 - SX(25), roleNode:getContentSize().height + SY(5)));
									buttonRest:setPosition(CCPointMake(roleNode:getContentSize().width/2 - SX(25), SY(140)));
									buttonRest:setContentSize(AUTO_SIZE(36, 36))
									buttonRest:luaSetSelectorOnClicked(onRestBtnClick);
									local imgPath1 = getRealUIResourcePath("img/new00187.png")
									local imgPath2 = getRealUIResourcePath("img/new00188.png")
									if imgPath1 and imgPath2 then
										buttonRest:setBackgroundImage(imgPath1:getData());
										buttonRest:setSelectedImage(imgPath2:getData());
									end
									
									roleNode:addChild(buttonRest);
								end
								--//查看按钮
								local buttonRest = SCButton:button();
								if buttonRest then
								    mateItem = mateItem + 1
									buttonRest:setTag(mateItem);
									buttonRest:setAnchorPoint(CCPointMake(0.5, 0))
									--buttonRest:setPosition(CCPointMake(roleNode:getContentSize().width/2 + SX(25), roleNode:getContentSize().height + SY(5)));
									buttonRest:setPosition(CCPointMake(roleNode:getContentSize().width/2 + SX(25), SY(140)));
									buttonRest:setContentSize(AUTO_SIZE(36, 36))
									buttonRest:luaSetSelectorOnClicked(onClickLookMate);
									local imgPath1 = getRealUIResourcePath("img/new00657.png")
									local imgPath2 = getRealUIResourcePath("img/new00658.png")
									if imgPath1 and imgPath2 then
										buttonRest:setBackgroundImage(imgPath1:getData());
										buttonRest:setSelectedImage(imgPath2:getData());
									end
									
									roleNode:addChild(buttonRest);
								end
							end
						end					
					end			
				end
			end
        end
		
		for i = inCount+1, 4 do
            local pChildNode = BlowRecruit2.initControl();
            if pChildNode then
                pChildNode:removeAllChildrenWithCleanup(true);
                local pImgPath = getRealUIResourcePath("img/new00087.png");           
                if pImgPath then
                    local pImg = SCImage:imageWithFile(pImgPath:getData());
                    if pImg then
                        pImg:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pImg:setPosition(CCPointMake(pChildNode:getContentSize().width / 2, pChildNode:getContentSize().height / 2));
                        pChildNode:addChild(pImg);
                    end
                end
                pListBox:addItem(pChildNode);
                pChildNode:setTag(10000 + i);
            end
        end
    end
    ----
    
    
end

-------------上下键翻页
local function onClickUpPage(tag)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
    if not pMultiPage then return end 
    
    local pNode = pMultiPage:getPageWithIndex(0);
    if not pNode then return end 
    
    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("1-2-7", pNode))
    if not pListBox then
        return
    end
    --[[
    local index = pListBox:getPageIndex();
    if index < 1 then
        return;
    end
    pListBox:setOffset(CCPointMake((index - 1) * pListBox:getWidth(), 0));
    ]]
    local pt = pListBox:getOffset();
    pListBox:setOffset(CCPointMake(pt.x, pt.y + pListBox:getContentSize().height));

end

local function onClickDownPage(tag)
   local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
    if not pMultiPage then return end 
    
    local pNode = pMultiPage:getPageWithIndex(0);
    if not pNode then return end 
    
    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("1-2-7", pNode))
    if not pListBox then
        return
    end
    --[[
    local index = pListBox:getPageIndex();
    local count = pListBox:getPageCount();
    if index > count - 2 then
        return;
    end
    pListBox:setOffset(CCPointMake((index + 1) * pListBox:getWidth(), 0));
    ]]
    local pt = pListBox:getOffset();
    pListBox:setOffset(CCPointMake(pt.x, pt.y - pListBox:getContentSize().height));
end

--------------



local function ControlOperating()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
    if not pMultiPage then return end 
    
    pMultiPage:luaSetSelectorOnPageSelected(onClickedMultipage);    
    local pNode = pMultiPage:getPageWithIndex(0);
    if pNode then
        local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
        if nil == pDragNode then
            pDragNode = BlowRecruit1.initControl();
            if pDragNode then
                pNode:addChild(pDragNode);
            end
        end
        local blackNode = pDragNode:getChildByTag(2)
        if blackNode then
            local btn = SCTypeCast:castNodeToButton(blackNode:getChildByTag(10011))
            if  btn  then
                btn:luaSetSelectorOnClicked(onClickUpPage);
            end 
            local btn = SCTypeCast:castNodeToButton(blackNode:getChildByTag(10012))
            if  btn  then
                btn:luaSetSelectorOnClicked(onClickDownPage);
            end 
        end
    end
    
    
	local lev = Hero:getSingleton():getLeval();
	local imgPath = getRealUIResourcePath("img/new00081.png");
	    
    local pImage8 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-8", pNode))
    local pImage9 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-9", pNode))
    local pImage10 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-10", pNode))
	if imgPath and pImage8 and pImage9 and pImage10 then
		if lev >= 100 then
			pImage8:setImage(imgPath:getData());
			pImage9:setImage(imgPath:getData());
			pImage10:setImage(imgPath:getData());
		elseif lev >= 70 then
			pImage8:setImage(imgPath:getData());
			pImage10:setImage(imgPath:getData());
			--[[
			local pDragNode = SCNode:node()            --半透明标志
                if pDragNode then
                    pDragNode:setTag(1010)
                    pDragNode:setAnchorPoint(ANCHOR_CENTER)
                    pDragNode:setPosition(AUTO_POS(pImage9:getContentSize().width / 2 +SX(2),pImage9:getContentSize().height +SY(5)))
                    pDragNode:setContentSize(CCSizeMake(pImage9:getContentSize().width-SX(20),pImage9:getContentSize().height-SY(15)))
                    pDragNode:setBackgroundColor(ccc4(0,0,0,0))
                    
                    --pDragNode:setDragEnabled(false)
                    pImage9:addChild(tolua.cast(pDragNode, "SCNode"))
                    ]]
                    local label = SCLabel:labelWithStringFont(L("str3042"), DEFAULT_FONT_NAME, F(15))
                    if label then
                        label:setAnchorPoint(CCPointMake(0.5, 0))
                        label:setPosition(CCPointMake(pImage9:getContentSize().width / 2 , pImage9:getContentSize().height ))
                        label:setColor(getColorRed())
                        pImage9:addChild(label)
                    end
                
		elseif lev >= 14 then
			pImage8:setImage(imgPath:getData());
			    --[[
                local pDragNode = SCNode:node()            --半透明标志
                if pDragNode then
                    pDragNode:setTag(1010)
                    pDragNode:setAnchorPoint(ANCHOR_CENTER)
                    pDragNode:setPosition(AUTO_POS(pImage9:getContentSize().width / 2 + SX(2),pImage9:getContentSize().height +SY(5)))
                    pDragNode:setContentSize(CCSizeMake(pImage9:getContentSize().width-SX(20),pImage9:getContentSize().height-SY(15)))
                    pDragNode:setBackgroundColor(ccc4(0,0,0,0))
                    --pDragNode:setDragEnabled(false)
                    pImage9:addChild(tolua.cast(pDragNode, "SCNode"))
                    ]]
                    local label = SCLabel:labelWithStringFont(L("str3042"), DEFAULT_FONT_NAME, F(15))
                    if label then
                        label:setAnchorPoint(CCPointMake(0.5, 0))
                        label:setPosition(CCPointMake(pImage9:getContentSize().width / 2 , pImage9:getContentSize().height ))
                        label:setColor(getColorRed())
                        pImage9:addChild(label)
                    end
                
                --[[
                local pDragNode = SCNode:node()            --半透明标志
                if pDragNode then
                    pDragNode:setTag(1010)
                    pDragNode:setAnchorPoint(ANCHOR_CENTER)
                    pDragNode:setPosition(AUTO_POS(pImage10:getContentSize().width / 2 + SX(2),pImage10:getContentSize().height +SY(5)))
                    pDragNode:setContentSize(CCSizeMake(pImage10:getContentSize().width-SX(20),pImage10:getContentSize().height-SY(15)))
                    pDragNode:setBackgroundColor(ccc4(0,0,0,0))
                    --pDragNode:setDragEnabled(false)
                    pImage10:addChild(tolua.cast(pDragNode, "SCNode"))
                    ]]
                    local label = SCLabel:labelWithStringFont(L("str3041"), DEFAULT_FONT_NAME, F(15))
                    if label then
                        label:setAnchorPoint(CCPointMake(0.5, 0))
                        label:setPosition(CCPointMake(pImage10:getContentSize().width / 2 , pImage10:getContentSize().height ))
                        label:setColor(getColorRed())
                        pImage10:addChild(label)
                    end
                
		end
	end
	
	
	if pNode then 
	    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("1-2-7", pNode))
	    if pListBox then
            pListBox:luaSetSelectorOnItemSelected(onListSelect);
            pListBox:luaSetSelectorOnItemUnSelected(onListUnSelect);
        end
	end
	
	BlowRecruit_refreshPartnerInfo();
end

-----------------------------------伙伴招募界面------------------------------------
--列表招募按钮
local function onRecruitBtnClick(tag)
    if not tag then return end 
    tag = tag - 2000;
	if tag > #m_stHotelPartnerList or tag < 1 then
		return
	end
	
	if m_stHotelPartnerList[tag].ucStatusType == 0 then
	    luashowConfirmationWindowPoint(L("str0464"), L("str0465"), nil, WIN_AUTO_CLOSE, nil, nil, nil);
	    --showMessage(L("str0455"))
		return;
	end

	local wndCtrl = getCurentSceneWindowController(6001);
	if wndCtrl then
		return;
	end
	m_curPartnerIndex = tag;
	sendRequestTrainInfo(m_stHotelPartnerList[tag].idPartnerType);
end

--刷新单个伙伴属性信息
local function refreshRecruitInfo(tmp)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
	if not pMultiPage then return end	
	
	local pNode = pMultiPage:getPageWithIndex(1);
	if not pNode then return end
	
	local pPageBox1 = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-1", pNode))
	if m_curPartnerIndex == nil or pPageBox1 == nil then
		return;
	end
	
	if m_curPartnerIndex > #m_stHotelPartnerList or m_curPartnerIndex < 0 then
		return;
	end
	
	local pageIndex = pPageBox1:getPageIndex();
	local childNode = pPageBox1:getChildByTag(pageIndex);
	if childNode == nil then
		return
	end
	
	local pDragNode = SCTypeCast:castNodeToDragNode(childNode:getChildByTag(m_curPartnerIndex));
	if pDragNode then
		local pTextBox6 = SCTypeCast:castNodeToTextBox(pDragNode:getChildByTag(6));
		if pTextBox6 then
			local tip = tmp.szTip;
			tip = tip..tmp.szTip2;
			TextParser:getSingleton():setText(pTextBox6, tip);
		end
	end	
end

--
local function onPhotoClick(tag)
    if not tag then return end 
    tag = tag - 1100;
    if tag < 0 or tag > #m_stHotelPartnerList then return end 
    
    local pRunningScene = getRunningScene()
    if not pRunningScene then return end
    
	if pRunningScene:getUINode():getChildByTag(6002) then return end
	
    BlowRecruit6.nExtraHeight = SY(20)
    local wnd = BlowRecruit6.initControl();
    if wnd == nil then
        BlowRecruit6.nExtraHeight = SY(0)
		return
    end    
    
	pRunningScene:getUINode():addChild(wnd)
	
	wnd:setBackButtonVisibled(false);
    wnd:setCloseButtonVisibled(false);
    wnd:setFrameVisibled(false);
    wnd:setAutoCloseOnTouchSpace(true)	
	
	local pButton2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("6002-1-2"))
	if pButton2 then
		pButton2:luaSetSelectorOnClicked(onBanishBtnClick);
		pButton2:setVisible(false);
	end
	
	if BlowRecruit6.m_pButton6 then--不存在的变量
		BlowRecruit6.m_pButton6:luaSetSelectorOnClicked(onClosePartnerInfoBtnClick);
	end
	
	local parterData = m_stHotelPartnerList[tag]
	local pTextBox3 = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlist("6002-1-3"))
	if parterData and pTextBox3 then
		local strInfo = "*6"..parterData.szName
		strInfo = strInfo.."_"..L("str5056").." "..parterData.szClanName
		strInfo = strInfo.."_"..L("str0013").." "..parterData.ucLevel;
		
		strInfo = strInfo.."_"..L("str8127").." "..parterData.nAtk;
		--strInfo = strInfo.."_"..L("str9145").." "..parterData.nDef;
		strInfo = strInfo.."_"..L("str8128").." "..parterData.nSkillAtk;
		--strInfo = strInfo.."_"..L("str9146").." "..parterData.nSkillDef;
		strInfo = strInfo.."_"..L("str9147").." "..parterData.dwHpGrowUp;
		strInfo = strInfo.."_"..L("str5069").." "..parterData.nHp;
		strInfo = strInfo.."_".."*3"..L("str0295").." "..parterData.szSkillName;
		
		TextParser:getSingleton():setText(pTextBox3, strInfo); 
	end
end
--刷新招募列表
local function refreshHotePartnerList()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
	if not pMultiPage then return end	
	
	local pNode = pMultiPage:getPageWithIndex(1);
	if not pNode then return end
	
	local pPageBox1 = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-1", pNode))
    if pPageBox1 == nil then
        return;
    end
	
	local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return
    end
	
	local dwGodExp = heroInfo.nReputation;
	local pImage3 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("2-3", pNode))
	if pImage3 then
		pImage3:removeAllChildrenWithCleanup(true);
		local numNode = getImageNumber(dwGodExp, "img/new00085.png", SX(11.8), SY(14))
		if numNode then
			numNode:setAnchorPoint(CCPointMake(0, 0.5));
			numNode:setPosition(CCPointMake(pImage3:getContentSize().width +SX(2) , pImage3:getContentSize().height/2));
			pImage3:addChild(numNode);
		end
	end
	
	if BlowRecruit3.m_pImage5 and BlowRecruit3.m_pImage6 then--不存在的2个变量
		if #m_stHotelPartnerList > 3 then
			BlowRecruit3.m_pImage5:setVisible(true);
			BlowRecruit3.m_pImage6:setVisible(true);
		else
			BlowRecruit3.m_pImage5:setVisible(false);
			BlowRecruit3.m_pImage6:setVisible(false);
		end
	end
	
    pPageBox1:setScrollVertical(false);
	pPageBox1:removeAllChildrenWithCleanup(true);
    local width = pPageBox1:getContentSize().width;
    local height = pPageBox1:getContentSize().height;
	local pNode = nil;
	local pageCount = 0;
	local childIndex = 0;
	for i=1, #m_stHotelPartnerList do
		childIndex = math.mod(i, 3);
	    if childIndex == 1 then
			pNode = SCNode:node();
			pNode:setPosition(CCPointMake(width * pageCount, 0));
			pPageBox1:addChild(pNode);
			pNode:setTag(pageCount);
			pPageBox1:setContentSize(CCSizeMake(width * pPageBox1:getPageCount(), height));
			pageCount = pageCount + 1;
		end
		
		if pNode then
			local pDragNode = BlowRecruit4.initControl();
			if pDragNode then
				if childIndex == 0 then
					childIndex = 3;
				end
                local pLabel4 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-4", pDragNode))
				if pLabel4 then
					pLabel4:setText(m_stHotelPartnerList[i].szName);
				end
				local pButton3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-3", pDragNode))
				if pButton3 then
				    local num = m_stHotelPartnerList[i].nFacePhoto;   --配置头像地方
					local imgPath = getRealUIResourcePath("faceicon/"..m_stHotelPartnerList[i].nFacePhoto..".jp")
					if imgPath then
						pButton3:setTitle(imgPath:getData());
						pButton3:luaSetSelectorOnClicked(onPhotoClick)
						pButton3:setTag(i+1100)
					end
				end
				local pTextBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("6", pDragNode))
				if pTextBox then
				    pTextBox:setTouchEnabled(false);
					pTextBox:setScrollVertical(false);
					pTextBox:setScrollHorizontal(false);
					local tip = m_stHotelPartnerList[i].szTip;
					tip = tip..m_stHotelPartnerList[i].szTip2;
					TextParser:getSingleton():setText(pTextBox, tip);
				end 
				local pButton5 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5", pDragNode))
				if pButton5 then
					pButton5:setTag(i+2000);
					pButton5:luaSetSelectorOnClicked(onRecruitBtnClick);
					if m_stHotelPartnerList[i].ucStatusType == 0 then
					    pButton5:setButtonType(EnumBtnTypeAsh)
					end
				end
				
				pDragNode:setBackgroundColor(ccc4(53, 48, 44, 255));
				pDragNode:setPosition(CCPointMake((childIndex - 1) * SX(147), SY(0)));
				pNode:addChild(pDragNode);				
				pDragNode:setTag(i);
			end
		end
    end
end


--左右键翻页
local function onClickLeftPage(tag)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
	if not pMultiPage then return end	
	
	local pNode = pMultiPage:getPageWithIndex(1);
	if not pNode then return end
	
	local pPageBox1 = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-1", pNode))
    if not pPageBox1 then
        return
    end
    local index = pPageBox1:getPageIndex();
    if index < 1 then
        return;
    end
    pPageBox1:setOffset(CCPointMake((index - 1) * pPageBox1:getWidth(), 0));
end

local function onClickRightPage(tag)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
	if not pMultiPage then return end	
	
	local pNode = pMultiPage:getPageWithIndex(1);
	if not pNode then return end
	
	local pPageBox1 = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-1", pNode))
    if not pPageBox1 then
        return
    end
    local index = pPageBox1:getPageIndex();
    local count = pPageBox1:getPageCount();
    if index > count - 2 then
        return;
    end
    pPageBox1:setOffset(CCPointMake((index + 1) * pPageBox1:getWidth(), 0));
end

--添加招募列表
local function ControlOperating2()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
	if pMultiPage == nil then
		return;
	end	
	
	local pNode = pMultiPage:getPageWithIndex(1);
	if pNode == nil then
		return;
	end
	
	local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
	if nil == pDragNode then
		pDragNode = BlowRecruit3.initControl();
		if pDragNode then
			pNode:addChild(pDragNode);
			
			
                local btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(10006));
                if  btn  then
                    btn:luaSetSelectorOnClicked(onClickLeftPage);
                end 
                local btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(10007));
                if  btn  then
                    btn:luaSetSelectorOnClicked(onClickRightPage);
                end 
            
		end
	end
		
	refreshHotePartnerList();
end

--显示已添加伙伴
function BlowRecruit_showBlowRecruitWnd()
	local wndCtrl = getCurentSceneWindowController(7020);
	if wndCtrl then
		return;
	end
	
    local wnd = BlowRecruit.initControl();
    if wnd then
        local imgPath = getRealUIResourcePath("img/titile31.png")
        local pImage = SCImage:imageWithFile(imgPath:getData())
        if pImage and imgPath then
            pImage:setTag(10003)
            pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage:setPosition(AUTO_POS(33.50, 283.50))
            --pImage:setContentSize(AUTO_SIZE(70, 20))
            wnd:addChild(pImage);
        end
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)            
            ControlOperating();
        end
    end
    SCActivityIndicator:getSingleton():close();
end

function BlowRecruit_showBlowRecruitWnd1()
    BlowRecruit_showBlowRecruitWnd();
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
    if pMultiPage then
        pMultiPage:selectPageWithIndex(1);
    end
end

-----------------------------------伙伴培养------------------------------------
--返回按钮
local function onReturnBtnClick(tag)
	local wndCtrl =  getCurentSceneWindowController(6001);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end
end
--培养按钮
local function onRecruitAndTrainBtnChild(tag)
    if tag == 11 then
        m_typeTrain = 2
    elseif tag == 13 then
        m_typeTrain = 1
    elseif tag == 12 then
        m_typeTrain = 4
    elseif tag == 16 then
        m_typeTrain = 3
    else
        return;
    end

	if m_curPartnerIndex then
		sendSureTrain(m_typeTrain, m_stHotelPartnerList[m_curPartnerIndex].idPartnerType);
	end
end
--招募按钮
local function onRecruitBtnClick2(tag)
	if m_curPartnerIndex then
		sendRecruitPartner(m_stHotelPartnerList[m_curPartnerIndex].idPartnerType);
	end
	
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
	if pMultiPage then
		pMultiPage:canclePageSelectedFlag(0);
	end
	onReturnBtnClick(NULL);
end

local function onChooseBtnClick(tag)
	--[[if BlowRecruit5.m_pImage7 and BlowRecruit5.m_pImage9 then
		local imgPath1 = getRealUIResourcePath("img/new00049.png");
		local imgPath2 = getRealUIResourcePath("img/new00050.png");
		if imgPath1 and imgPath2 then
			if tag == 1 then
				BlowRecruit5.m_pImage9:setImage(imgPath2:getData());
				BlowRecruit5.m_pImage7:setImage(imgPath1:getData());
				m_typeTrain = 1;
			else
				BlowRecruit5.m_pImage9:setImage(imgPath1:getData());
				BlowRecruit5.m_pImage7:setImage(imgPath2:getData());
				m_typeTrain = 2;
			end
		end
	end--]]
end
-------------经验满的提示-------------
local  function show_no()
	showMessage(_LTParser("str21062"))
end 
--刷新培养经验条
local function refreshTrainEXP()
    local wndCtrl = getCurentSceneWindowController(6001);
	if wndCtrl == nil then
		return;
	end
	
	local wnd = wndCtrl:getWindow();
	if wnd == nil then
	    return
	end

    
    
    local pImage4 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-4", wnd));
    if pImage4 == nil then
        return
    end

    local pLabel6 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-5-6", wnd));
    if pLabel6 == nil then
        return
    end
    if m_stEudemonTrainInfo.nFrinedly and m_stEudemonTrainInfo.nMaxFrinedly and m_stEudemonTrainInfo.nFrinedly < m_stEudemonTrainInfo.nMaxFrinedly then
		local pButton11 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-7-11", wnd));
		if pButton11 then
			pButton11:luaSetSelectorOnClicked(onRecruitAndTrainBtnChild);
		end
		local pButton12 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-7-12", wnd));
		if pButton12 then
			pButton12:luaSetSelectorOnClicked(onRecruitAndTrainBtnChild);
		end
		local pButton13 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-8-13", wnd));
		if pButton13 then
			pButton13:luaSetSelectorOnClicked(onRecruitAndTrainBtnChild);
		end
		local pButton16 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-8-16", wnd));
		if pButton16 then
			pButton16:luaSetSelectorOnClicked(onRecruitAndTrainBtnChild);
		end
    else
		local pButton11 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-7-11", wnd));
		if pButton11 then
			pButton11:luaSetSelectorOnClicked(show_no);
		end
		local pButton12 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-7-12", wnd));
		if pButton12 then
			pButton12:luaSetSelectorOnClicked(show_no);
		end
		local pButton13 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-8-13", wnd));
		if pButton13 then
			pButton13:luaSetSelectorOnClicked(show_no);
		end
		local pButton16 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-8-16", wnd));
		if pButton16 then
			pButton16:luaSetSelectorOnClicked(show_no);
		end
    end 
	local pButton14 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-14", wnd));
	if pButton14 == nil then
		return
	end
    
    if m_stEudemonTrainInfo.nFrinedly and m_stEudemonTrainInfo.nMaxFrinedly then
        if m_stEudemonTrainInfo.nFrinedly >= 0 and m_stEudemonTrainInfo.nMaxFrinedly >= 0 then
            if m_stEudemonTrainInfo.nFrinedly >= m_stEudemonTrainInfo.nMaxFrinedly then
                local imgPath = getRealUIResourcePath("img/new00509.png");
                if imgPath then
                    pButton14:setTitle(imgPath:getData());
                end
                pButton14:luaSetSelectorOnClicked(onRecruitBtnClick2);
                pButton14:setButtonType(EnumBtnType9Atlas)
                m_stEudemonTrainInfo.nFrinedly = m_stEudemonTrainInfo.nMaxFrinedly;
            else
                pButton14:setButtonType(EnumBtnTypeAsh)
            end
            
            local strData = m_stEudemonTrainInfo.nFrinedly;
            strData = strData.."/"..m_stEudemonTrainInfo.nMaxFrinedly;
            if strData then
                pLabel6:setText(strData);
            end
            local pImage5 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-5", wnd))
            local imgPath = getRealUIResourcePath("img/new00036.png");
            if imgPath and pImage5 then
                if m_stEudemonTrainInfo.nMaxFrinedly > 0 and m_stEudemonTrainInfo.nFrinedly then
                    local num = pImage4:getContentSize().width * (m_stEudemonTrainInfo.nFrinedly/m_stEudemonTrainInfo.nMaxFrinedly)
                    pImage5:setImage(imgPath:getData(), CCRectMake(0, 0, num, pImage4:getContentSize().height));
                else
					local num = pImage4:getContentSize().width
                    pImage5:setImage(imgPath:getData(), CCRectMake(0, 0, num, pImage4:getContentSize().height));
                end
            end
        end
    end
end

--刷新伙伴培养界面
local function refreshTrainWnd()
	local wndCtrl = getCurentSceneWindowController(6001);
	if wndCtrl == nil then
		return;
	end
	
	local wnd = wndCtrl:getWindow();
	if wnd == nil then
	    return
	end

    local pTextBox3 = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("1-2-3", wnd));
	if pTextBox3 then
		if m_stEudemonTrainInfo.szDescribe then
			pTextBox3:setScrollVertical(false);
			TextParser:getSingleton():setText(pTextBox3, m_stEudemonTrainInfo.szDescribe);
		end
	end
	
--[[	if BlowRecruit5.m_pTextBox10 then
		if m_stEudemonTrainInfo.szDescribe1 then
			BlowRecruit5.m_pTextBox10:setScrollVertical(false);
			TextParser:getSingleton():setText(BlowRecruit5.m_pTextBox10, m_stEudemonTrainInfo.szDescribe1);
		end
		
		if BlowRecruit5.m_pImage9 then
            local child = BlowRecruit5.m_pImage9:getChildByTag(1);
            if child == nil then
                child = SCButton:button();
                if child and BlowRecruit5.m_pImage9 then
                    child:setTag(1);
                    child:setContentSize(CCSizeMake(BlowRecruit5.m_pTextBox10:getContentSize().width + BlowRecruit5.m_pImage7:getContentSize().width, BlowRecruit5.m_pTextBox10:getContentSize().height));
                    child:setPosition(CCPointMake(0, BlowRecruit5.m_pImage9:getContentSize().height - child:getContentSize().height));
                    child:luaSetSelectorOnClicked(onChooseBtnClick);
                    BlowRecruit5.m_pImage9:addChild(child);
                end
            end
        end
		m_typeTrain = 1;
	end
	
	if BlowRecruit5.m_pTextBox11 then
		if m_stEudemonTrainInfo.szDescribe2 then
			BlowRecruit5.m_pTextBox11:setScrollVertical(false);
			TextParser:getSingleton():setText(BlowRecruit5.m_pTextBox11, m_stEudemonTrainInfo.szDescribe2);
		end
		
		if BlowRecruit5.m_pImage7 then
            local child = BlowRecruit5.m_pImage7:getChildByTag(2);
            if child == nil then
                child = SCButton:button();
                if child then
                    child:setTag(2);
                    child:setContentSize(CCSizeMake(BlowRecruit5.m_pTextBox10:getContentSize().width + BlowRecruit5.m_pImage7:getContentSize().width, BlowRecruit5.m_pTextBox10:getContentSize().height));
                    child:setPosition(CCPointMake(0, BlowRecruit5.m_pImage7:getContentSize().height - child:getContentSize().height));
                    child:setContentSize(BlowRecruit5.m_pTextBox11:getContentSize());
                    child:luaSetSelectorOnClicked(onChooseBtnClick);
                    BlowRecruit5.m_pImage7:addChild(child);
                end
            end
        end
	end]]
	
	local pButton15 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-15", wnd));
	if pButton15  then
		pButton15 :luaSetSelectorOnClicked(onReturnBtnClick);
	end
	
	refreshTrainEXP();
end

--显示伙伴培养界面
local function showEudTrainWnd()
	local wndCtrl = getCurentSceneWindowController(6001);
	if wndCtrl then
		return;
	end
	
    local wnd = BlowRecruit5.initControl();
    if wnd then
        local pDragNode1 = wnd:getChildByTag(1);
		if pDragNode1 then
			pDragNode1:setBackgroundColor(ccc4(53, 48, 44, 255));
		end
		
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl);
        end
        wnd:setBackButtonVisibled(false);
		wnd:setCloseButtonVisibled(false);
		wnd:setFrameVisibled(false);
    end
    
    local pLabel9 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("6001-1-7-9"))
    if pLabel9 then
        pLabel9:setText(L("str0508"));
        pLabel9:setColor(color_orange);
    end
    
    local pLabel10 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("6001-1-8-10"))
    if pLabel10 then
        pLabel10:setText(L("str0509"));
        pLabel10:setColor(color_orange);
    end
	
	refreshTrainWnd();
end

----------------消息处理区----------------
local function reveRecruitListData(dt)
	if dt == nil then
	    return;
	end
	
	local usPage = dt:readShort();
	if usPage == 1000 then				--1000，寻宝界面的武将信息专用, 转到寻宝界面处理
		TreasureHunt.recvRoleInfo(dt)
		return
	end
	
	local ucAmountPerPage = dt:readByte();
	local ucType = dt:readByte();
	local ucClan = dt:readByte();
	local usAllPage = dt:readShort();
	local ucAmount = dt:readByte();
	for i=1, ucAmount do
		table.insert(m_stHotelPartnerList, stPartnerInfo.initWithStream(dt));
	end
end

local function recvRecruitListBegin()
	local dt = LuaData:getSingleton():getDataTransStream();
	if dt == nil then
	    return;
	end
	
	reveRecruitListData(dt)
end

local function recvRecruitListEnd()
	SCActivityIndicator:getSingleton():close();
	local dt = LuaData:getSingleton():getDataTransStream();
	if dt == nil then
	    return;
	end
	
	reveRecruitListData(dt);
	BlowRecruit_showBlowRecruitWnd();
	ControlOperating2();
	m_isFirst = true
end

local function recvTrainInfo()
	SCActivityIndicator:getSingleton():close();
	local dt = LuaData:getSingleton():getDataTransStream();
	if dt == nil then
	    return;
	end
	
	m_stEudemonTrainInfo.nFrinedly = dt:readInt();
	m_stEudemonTrainInfo.nMaxFrinedly = dt:readInt();
	local tmpStr = dt:readString();
	if tmpStr == nil then
		m_stEudemonTrainInfo.szDescribe = "";
	else	
		m_stEudemonTrainInfo.szDescribe = tmpStr:getData();
	end
	
	tmpStr = dt:readString();
	if tmpStr == nil then
		m_stEudemonTrainInfo.szDescribe1 = "";
	else	
		m_stEudemonTrainInfo.szDescribe1 = tmpStr:getData();
	end
	
	tmpStr = dt:readString();
	if tmpStr == nil then
		m_stEudemonTrainInfo.szDescribe2 = "";
	else	
		m_stEudemonTrainInfo.szDescribe2 = tmpStr:getData();
	end
	
	showEudTrainWnd();
end

local function recvTrainEudEmontype()
	SCActivityIndicator:getSingleton():close();
	local dt = LuaData:getSingleton():getDataTransStream();
	if dt == nil then
	    return;
	end
	
    m_stEudemonTrainInfo.nFrinedly = dt:readInt();
	m_stEudemonTrainInfo.nMaxFrinedly = dt:readInt();
	refreshTrainEXP();
end

local function recvRefreshRecruitList()
	SCActivityIndicator:getSingleton():close();
	local dt = LuaData:getSingleton():getDataTransStream();
	if dt == nil then
	    return;
	end
	
	local idPartnerType = dt:readInt();
	for i=1, #m_stHotelPartnerList do
		if idPartnerType == m_stHotelPartnerList[i].idPartnerType then
			table.remove(m_stHotelPartnerList, i);
			break;
		end
	end
	
	refreshHotePartnerList();
end

local function recvRefreshRecruitInfo()
	SCActivityIndicator:getSingleton():close();
	local dt = LuaData:getSingleton():getDataTransStream();
	if dt == nil then
	    return;
	end
	
	local tmp = stPartnerInfo.initWithStream(dt);
	for i=1, #m_stHotelPartnerList do
		if tmp.idPartnerType == m_stHotelPartnerList[i].idPartnerType then
			table.remove(m_stHotelPartnerList, i);
			table.insert(m_stHotelPartnerList, i, tmp);
			break;
		end
	end
	
	refreshRecruitInfo(tmp);
end

----------------消息注册区----------------
LuaData:getSingleton():luaSetSelectorOnRecvData(recvRecruitListBegin, LuaData_EUDEMONSHOW_RECRUIT_PARTNER_LIST);
LuaData:getSingleton():luaSetSelectorOnRecvData(recvRecruitListEnd, LuaData_EUDEMONSHOW_RECRUIT_PARTNER_LIST_END);
LuaData:getSingleton():luaSetSelectorOnRecvData(recvTrainInfo, LuaData_EUDEMONSHOW_TRAIN_INFO);
LuaData:getSingleton():luaSetSelectorOnRecvData(recvTrainEudEmontype, LuaData_EUDEMONSHOW_TRAIN_EUDEMONTYPE);
LuaData:getSingleton():luaSetSelectorOnRecvData(recvRefreshRecruitList, LuaData_EUDEMONSHOW_RECRUIT_PARTNER);
LuaData:getSingleton():luaSetSelectorOnRecvData(recvRefreshRecruitInfo, LuaData_EUDEMONSHOW_SHOW_EUDEMONTYPE);
----------------全局函数区----------------
function BlowRecruit_refresh()
	BlowRecruit_refreshPartnerInfo();
end

function BlowRecruit.wndCloss()
    GuidePoint_EndGuide(14) --释放武将招募数据
    BlowRecruit1.releaseControl();
    BlowRecruit2.releaseControl();
    BlowRecruit3.releaseControl();
    BlowRecruit4.releaseControl();

    m_stHotelPartnerList = {}
    m_stEudemonTrainInfo = {}
    m_typeTrain = nil;
    m_curPartnerIndex = nil;
    m_isFirst = nil
end

--函数调用