--神兵重铸界面8001界面

ChangeEquiptProfession = {};

local m_equiptList = nil--可重铸的装备列表

local m_equiptTemplateList = nil--重铸装备模板

local m_currentSelectEquipt = nil

local m_currentSelectTemplateEquipt = nil

local m_changeId = nil--要重铸的装备id
	
local m_changeSelectId= nil--重铸后的装备id
	
local m_idCost= nil--重铸符id

local m_leftContent_startX = nil
local m_leftContent_startY = nil
local m_leftContent_width  = nil
local m_leftContent_height = nil

local m_rightContent_startX = nil
local m_rightContent_startY = nil
local m_rightContent_width  = nil
local m_rightContent_height = nil

local m_roleList = nil
local m_currentRoleId = nil

local m_wnd = nil

local m_currentSelectIndex = nil --当前显示所属索引


--控件封装
local function createMenuItem(icon,name,levelStr,tag,nameColor,levelColor,professionStr)
    
	local menuItem = SCButton:button()
	menuItem:setContentSize(CCSizeMake(66*gUIScale().x,82*gUIScale().y))
	menuItem:setTag(tag)
    
    
	local imgFile = getRealUIResourcePath(Button_ImagePath);
	local backItem = nil
	if imgFile then
	    backItem = SCImage:imageWithFile(imgFile:getData())
	    backItem:setTag(1)
	    backItem:setVisible(false)
        menuItem:addChild(backItem)
	end
	
    
    local itemBtn = SCButton:button()
    itemBtn:setTag(tag)
    if icon~=0 then
        local itemFile,rect = getItemImageByIcon(icon)
        if itemFile then
             itemBtn:setTitle(itemFile:getData(),rect)
        end
    end
    itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Normal_ImagePath):getData())
    itemBtn:setAnchorPoint(CCPointMake(0,0));
    itemBtn:setPosition(CCPointMake((menuItem:getContentSize().width-itemBtn:getContentSize().width)/2,menuItem:getContentSize().height-itemBtn:getContentSize().height-5));
    menuItem:addChild(itemBtn)
	
	if name~= nil and name ~= "" then--字符串已经带颜色了
	    local nameLabel = ParsedNode:getParsedNode(name,0)
        nameLabel:setAnchorPoint(CCPointMake(0,0));
        nameLabel:setPosition(CCPointMake((menuItem:getContentSize().width-nameLabel:getContentSize().width)/2,nameLabel:getContentSize().height+5*gUIScale().y));
        menuItem:addChild(nameLabel)
	end
	
	if levelStr~=nil and levelStr~="" then
	    local levelLabel = SCLabel:labelWithStringFont(levelStr,getDefaultFontName(), getFontSize(12))
	    if levelColor then
	        levelLabel:setColor(levelColor)
	    end
        levelLabel:setAnchorPoint(CCPointMake(0,0));
        levelLabel:setPosition(CCPointMake((menuItem:getContentSize().width-levelLabel:getContentSize().width)/2,5*gUIScale().y));
        menuItem:addChild(levelLabel)
	end
	
	if professionStr~=nil and professionStr~="" then
	    local professionLabel = SCLabel:labelWithStringFont(professionStr,getDefaultFontName(), getFontSize(12))
        professionLabel:setColor(getColorOrange())
        professionLabel:setAnchorPoint(CCPointMake(0,0));
        professionLabel:setPosition(CCPointMake((menuItem:getContentSize().width-professionLabel:getContentSize().width)/2,-professionLabel:getContentSize().height));
        menuItem:addChild(professionLabel)
	end
	
	return menuItem,itemBtn,backItem
end

--点击装备模板列表响应
function templateEquiptButtonAction(tag)
    local back     = m_wnd:getChildByTag(800101);--大背景层
    for i=1,4 do
        local ctrlId = 8001400+i
        local btn      = SCTypeCast:castNodeToButton(back:getChildByTag(ctrlId))
        if btn then
            local childBtn =  SCTypeCast:castNodeToImage(btn:getChildByTag(1));
            if childBtn then
                if tag == ctrlId then
                    childBtn :setVisible(true)
                else
                    childBtn :setVisible(false)
                end
            end
        end
    end
    
    local maxAmount = #m_equiptTemplateList
    local index    = tag - 8001400
    if index <=maxAmount then
        m_currentSelectTemplateEquipt = m_equiptTemplateList[index]
    end
    showSelectTemplateEquiptDetail()
end



local function confirmChangeEquipt()--点击确认转换响应
    if m_currentSelectEquipt == nil then
        local tmpMessage = _LTParser("str8010")
        showMessage(tmpMessage,1)
        return
    end
    
    if m_currentSelectTemplateEquipt == nil then
        local tmpMessage = _LTParser("str8011")
        showMessage(tmpMessage,1)
        return
    end
    
    sendChangeEquptMsg(m_currentSelectEquipt.idItemType,m_currentSelectTemplateEquipt.idItemType,m_idCost)
end

local function showRoleList()

    local backDragNodeLayer = m_wnd:getChildByTag(800101);
    backDragNodeLayer = SCTypeCast:castNodeToDragNode(backDragNodeLayer)
    for i=1,3 do
        ctrlId = 8001100+i
        backDragNodeLayer:removeChildByTag(ctrlId,true)
    end
    
    --向左按钮
    local leftButton = SCButton:button()
    leftButton:setTag(8001101)
	local imgNormlFile = getRealUIResourcePath(TurnLeft_Normal_ImagePath);
	if imgNormlFile then
	    leftButton:setBackgroundImage(imgNormlFile:getData())
	end
	local imgClickFile = getRealUIResourcePath(TurnLeft_Click_ImagePath);
	if imgClickFile then
	    leftButton:setSelectedImage(imgClickFile:getData())
	end
    leftButton:setAnchorPoint(CCPointMake(0,0));
    leftButton:setPosition(CCPointMake(40*gUIScale().x,m_leftContent_height-leftButton:getContentSize().height-5*gUIScale().y));
    leftButton:luaSetSelectorOnClicked(turnLeftRoleSelect)--设置回调
	backDragNodeLayer:addChild(leftButton)
	
	local tmpRole = getRoleById(m_currentRoleId)
	if tmpRole then
	    local nameLabel = SCLabel:labelWithStringFont(tmpRole.name,getDefaultFontName(), getFontSize(12))
	    nameLabel:setTag(8001102)
        nameLabel:setAnchorPoint(CCPointMake(0,0));
        local px = (m_leftContent_width-nameLabel:getContentSize().width)/2
        local py = leftButton:getPosition().y+(leftButton:getContentSize().height-nameLabel:getContentSize().height)/2
        nameLabel:setPosition(CCPointMake(px,py));
        backDragNodeLayer:addChild(nameLabel)
	end
	
    
	--向右按钮
	local rightButton = SCButton:button()
    rightButton:setTag(8001103)
	local imgNormlFile = getRealUIResourcePath(TurnRight_Normal_ImagePath);
	if imgNormlFile then
	    rightButton:setBackgroundImage(imgNormlFile:getData())
	end
	local imgClickFile = getRealUIResourcePath(TurnRIght_Click_ImagePath);
	if imgClickFile then
	    rightButton:setSelectedImage(imgClickFile:getData())
	end
	rightButton:luaSetSelectorOnClicked(turnRightRoleSelect)--设置回调
    rightButton:setAnchorPoint(CCPointMake(0,0));
    rightButton:setPosition(CCPointMake(m_leftContent_width-rightButton:getContentSize().width-40*gUIScale().x,leftButton:getPosition().y));
	backDragNodeLayer:addChild(rightButton)
end

--可重铸装备列表
local function showRefreshEquiptList()
    local backDragNodeLayer = m_wnd:getChildByTag(800101);
    backDragNodeLayer = SCTypeCast:castNodeToDragNode(backDragNodeLayer)
    if backDragNodeLayer == nil then
        return
    end
    for i=1,4 do
        ctrlId = 8001200+i
        backDragNodeLayer:removeChildByTag(ctrlId,true)
    end
    
    if m_equiptList == nil then
        return
    end 
    local tmpEquiptList = getEquiptListByRoleId(m_currentRoleId)
    local amount = #tmpEquiptList
    if amount > 4 then
        amount = 4
    end
    for i=1,amount do
	    local icon = 0
	    local name = nil
	    local levelStr = nil
	    local ctrlId = 8001200+i
	    if tmpEquiptList[i] then
	        icon     = tmpEquiptList[i].nPhoto
	        name     = tmpEquiptList[i].name
            levelStr = tmpEquiptList[i].szStrengthLevel
        end
        local menuItem,itemBtn = createMenuItem(icon,name,levelStr,ctrlId)
        local tmpX = menuItem:getContentSize().width*(i-1)+5*gUIScale().x
        local tmpY = m_leftContent_height-menuItem:getContentSize().height-40*gUIScale().y
        menuItem:setAnchorPoint(CCPointMake(0,0));
        menuItem:setPosition(CCPointMake(tmpX,tmpY));
        menuItem:luaSetSelectorOnClicked(equiptButtonAction)--设置回调
        itemBtn:luaSetSelectorOnClicked(equiptButtonAction)--设置回调
	    backDragNodeLayer:addChild(menuItem) 
    end
end

--重铸装备模板列表
local function refreshEquiptTemplateList()
    local backDragNodeLayer = m_wnd:getChildByTag(800101);
    backDragNodeLayer = SCTypeCast:castNodeToDragNode(backDragNodeLayer)
    if backDragNodeLayer == nil then
        return
    end
    for i=1,4 do
        ctrlId = 8001400+i
        backDragNodeLayer:removeChildByTag(ctrlId,true)
    end
    
    if m_equiptTemplateList == nil then
        return
    end
    local amount = #m_equiptTemplateList
    if amount > 4 then
        amount = 4
    end
    local row = 1
    local col = 1
    for i=1,4 do
	    local icon = 0
	    local name = nil
	    local levelStr = nil
	    local ctrlId = 8001400+i
	    local professionStr = nil
        if m_equiptTemplateList[i] then
	        icon          = m_equiptTemplateList[i].nPhoto
	        name          = m_equiptTemplateList[i].name--名称
            levelStr      = m_equiptTemplateList[i].szStrengthLevel--强化等级
            professionStr = m_equiptTemplateList[i].professionalName--职业
        end
        
        local menuItem,itemBtn = createMenuItem(icon,name,levelStr,ctrlId,nil,nil,professionStr)
        local tmpX = (menuItem:getContentSize().width)*(col-1)+SX(2)
        --local tmpY = m_rightContent_height-(menuItem:getContentSize().height)*row-30*(row-1)-10
        local tmpY = 20*gUIScale().y
        menuItem:setAnchorPoint(CCPointMake(0,0));
        menuItem:setPosition(CCPointMake(tmpX,tmpY));
        menuItem:luaSetSelectorOnClicked(templateEquiptButtonAction)--设置回调
        itemBtn:luaSetSelectorOnClicked(templateEquiptButtonAction)--设置回调
	    backDragNodeLayer:addChild(menuItem) 
	    --if math.mod(i,4) == 0 then
        --    row = row + 1
        --    col = 1
        --else
            col = col + 1
        --end
    end
end

local function showSelectEquiptDetail()
    local backDragNodeLayer = m_wnd:getChildByTag(800102);
    backDragNodeLayer = SCTypeCast:castNodeToDragNode(backDragNodeLayer)
    if backDragNodeLayer == nil then
        return
    end
    for i=1,4 do
        ctrlId = 8001300+i
        backDragNodeLayer:removeChildByTag(ctrlId,true)
    end

    --当前装备
    local professionLabel = SCLabel:labelWithStringFont(_LTParser("str8007"),getDefaultFontName(), getFontSize(14))
    professionLabel:setTag(8001301)
    professionLabel:setColor(getColorYellow())
    professionLabel:setAnchorPoint(CCPointMake(0,0));
    local px = 10*gUIScale().x
    local py = m_rightContent_height-professionLabel:getContentSize().height-10*gUIScale().y
    professionLabel:setPosition(CCPointMake(px,py));
    backDragNodeLayer:addChild(professionLabel)

    local icon = 0
    local name = nil
    local levelStr = nil
    local ctrlId = 8001302
    local professionStr = nil
    local attrDetail = nil
    if m_currentSelectEquipt then
        icon          = m_currentSelectEquipt.nPhoto
        name          = m_currentSelectEquipt.name
        levelStr      = m_currentSelectEquipt.szStrengthLevel
        professionStr = m_currentSelectEquipt.professionalName
        attrDetail    = m_currentSelectEquipt.attrDetail
    end

    local menuItem,itemBtn,backItem = createMenuItem(icon,name,levelStr,ctrlId,nil,nil,professionStr)
    menuItem:setAnchorPoint(CCPointMake(0,0));
    local tmpX = SX(5)
    local tmpY = m_leftContent_height-menuItem:getContentSize().height-30*gUIScale().y
    menuItem:setPosition(CCPointMake(tmpX,tmpY));
    backItem:setVisible(true)
    backDragNodeLayer:addChild(menuItem)
     
    --当前属性
    backDragNodeLayer:removeChildByTag(8001303, true)
    local text = "*6".._LTParser("str8002")
    if attrDetail then
		text = text.."_"..attrDetail
    end
    local parNode =  ParsedNode:getParsedNode(text, 0, 10)
    parNode:setTag(8001303)
    parNode:setAnchorPoint(CCPointMake(0, 1))
    parNode:setPosition(CCPointMake(tmpX-SX(5), m_leftContent_height*0.5))
    backDragNodeLayer:addChild(parNode)
--[[
    local nameLabel = SCLabel:labelWithStringFont(_LTParser("str8002"),getDefaultFontName(), getFontSize(12))
	nameLabel:setTag(8001303)
	nameLabel:setColor(getColorYellow())
    nameLabel:setAnchorPoint(CCPointMake(0,0));
    local px = 10*gUIScale().x
    local py = m_leftContent_height*0.42
    nameLabel:setPosition(CCPointMake(px,py));
    backDragNodeLayer:addChild(nameLabel)
    --属性值
    if attrDetail then
        local valueTextLabel = ParsedNode:getParsedNode(attrDetail,0);
        valueTextLabel:setTag(8001304)
        valueTextLabel:setAnchorPoint(CCPointMake(0,0));
        valueTextLabel:setPosition(CCPointMake(nameLabel:getPosition().x,nameLabel:getPosition().y-valueTextLabel:getContentSize().height-3));
        backDragNodeLayer:addChild(valueTextLabel)
    end
]]
end

function showSelectTemplateEquiptDetail()
    local backDragNodeLayer = m_wnd:getChildByTag(800102);
    backDragNodeLayer = SCTypeCast:castNodeToDragNode(backDragNodeLayer)
    if backDragNodeLayer == nil then
        return
    end
    for i=1,4 do
        ctrlId = 8001320+i
        backDragNodeLayer:removeChildByTag(ctrlId,true)
    end
    
    --铸成装备
    local professionLabel = SCLabel:labelWithStringFont(_LTParser("str8008"),getDefaultFontName(), getFontSize(14))
    professionLabel:setTag(8001321)
    professionLabel:setColor(getColorYellow())
    professionLabel:setAnchorPoint(CCPointMake(0,0));
    local px = m_rightContent_width/2+25*gUIScale().x
    local py = m_rightContent_height-professionLabel:getContentSize().height-10*gUIScale().y
    professionLabel:setPosition(CCPointMake(px,py));
    backDragNodeLayer:addChild(professionLabel)
    
    local icon = 0
    local name = nil
    local levelStr = nil
    local ctrlId = 8001322
    local professionStr = nil
    local attrDetail = nil
    if m_currentSelectTemplateEquipt then
        icon          = m_currentSelectTemplateEquipt.nPhoto
        name          = m_currentSelectTemplateEquipt.name
        levelStr      = m_currentSelectTemplateEquipt.szStrengthLevel
        professionStr = m_currentSelectTemplateEquipt.professionalName
        attrDetail    = m_currentSelectTemplateEquipt.attrDetail
    end
    
    local menuItem,itemBtn,backItem = createMenuItem(icon,name,levelStr,ctrlId,nil,nil,professionStr)
    menuItem:setAnchorPoint(CCPointMake(0,0));
    local tmpX = m_rightContent_width/2+20*gUIScale().x
    local tmpY = m_leftContent_height-menuItem:getContentSize().height-30*gUIScale().y
    menuItem:setPosition(CCPointMake(tmpX,tmpY));
    backItem:setVisible(true)
    backDragNodeLayer:addChild(menuItem)
    
    --local afterPx = m_rightContent_width/2+30*gUIScale().x
    --local afterPy = m_rightContent_height*0.42
    --重铸属性
    backDragNodeLayer:removeChildByTag(8001323, true)
    local text = "*6".._LTParser("str8003")
    if attrDetail then
		text = text.."_"..attrDetail
    end
    local parNode =  ParsedNode:getParsedNode(text, 0, 10)
    parNode:setTag(8001323)
    parNode:setAnchorPoint(CCPointMake(0, 1))
    parNode:setPosition(CCPointMake(tmpX-SX(5), m_rightContent_height*0.5))
    backDragNodeLayer:addChild(parNode)
--[[
    local afterNameLabel = SCLabel:labelWithStringFont(_LTParser("str8003"),getDefaultFontName(), getFontSize(12))
	afterNameLabel:setTag(8001323)
	afterNameLabel:setColor(getColorYellow())
    afterNameLabel:setAnchorPoint(CCPointMake(0,0));
    afterNameLabel:setPosition(CCPointMake(afterPx,afterPy));
    backDragNodeLayer:addChild(afterNameLabel)
    --属性值
    if attrDetail then
        local afterValueLabel = ParsedNode:getParsedNode(attrDetail,0);
        afterValueLabel:setTag(8001324)
        afterValueLabel:setAnchorPoint(CCPointMake(0,0));
        afterValueLabel:setPosition(CCPointMake(afterNameLabel:getPosition().x,afterNameLabel:getPosition().y-afterValueLabel:getContentSize().height-3));
        backDragNodeLayer:addChild(afterValueLabel)
    end
]]
end



function getRoleById(roleId)
    local role = nil
    local amount = #m_roleList
    for i=1,amount do
        if m_roleList[i].id == roleId then
            role = m_roleList[i]
            break
        end
    end
    return role
end

function getEquiptListByRoleId(roleId)
    local equiptList = {}
    local index  = 1
    local amount = #m_equiptList
    for i=1,amount do
        if m_equiptList[i].roleId == roleId then
            equiptList[index] = m_equiptList[i]
            index = index + 1
        end
    end
    return equiptList
end

--获取当前背包装备个数
function getCurrentOnBagAmount()

    local total  = 0
    local amount = #m_equiptList
    for i=1,amount do
        if m_equiptList[i].roleId < 100 then
            total = total + 1
        end
    end
    return total
end

--向左选择 上一页
function turnLeftRoleSelect(tag)
    if (m_currentSelectIndex -1) > 0 then
        m_currentSelectIndex = m_currentSelectIndex - 1
    end
    local maxAmount = #m_roleList
    if m_currentSelectIndex <= maxAmount then
        m_currentRoleId = m_roleList[m_currentSelectIndex].id
    end
    
    showRoleList()
    showRefreshEquiptList()
    m_equiptTemplateList = nil
    refreshEquiptTemplateList()
end

--向右选择 下一页
function turnRightRoleSelect(tag)
    local maxAmount = #m_roleList
    if (m_currentSelectIndex + 1) <= maxAmount then
        m_currentSelectIndex = m_currentSelectIndex + 1
    end
    if m_currentSelectIndex <= maxAmount then
        m_currentRoleId = m_roleList[m_currentSelectIndex].id
    end
    showRoleList()
    showRefreshEquiptList()
    m_equiptTemplateList = nil
    refreshEquiptTemplateList()
end


--点击可重铸装备列表响应
function equiptButtonAction(tag)
    local back     = m_wnd:getChildByTag(800101);--大背景层
    for i=1,4 do
        local ctrlId = 8001200+i
        local btn      = SCTypeCast:castNodeToButton(back:getChildByTag(ctrlId));
        if btn then
            local childBtn =  SCTypeCast:castNodeToImage(btn:getChildByTag(1));
            if childBtn then
                if tag == ctrlId then
                    childBtn :setVisible(true)
                else
                    childBtn :setVisible(false)
                end
            end
        end
    end
    local tmpEquipList = getEquiptListByRoleId(m_currentRoleId)
    if tmpEquipList then
        local maxAmount = #tmpEquipList
        local index    = tag - 8001200
        if index <=maxAmount then
            m_currentSelectEquipt = tmpEquipList[index]
        end
        
        if m_currentSelectEquipt then
            sendQueryTemplateEquipList(m_currentSelectEquipt.idItemType)
        end
        
        showSelectEquiptDetail()
        
        m_equiptTemplateList = nil
        refreshEquiptTemplateList()
        m_currentSelectTemplateEquipt = nil
        showSelectTemplateEquiptDetail()
        
    end
end

local function getRoleName(roleId)
    local role = Hero:getSingleton()  
    if roleId==role:getID() then
        return role:getName():getData()
    end
    local amount = role:partnerSize()
    for i=1,amount do
        local partner = role:getPartnerWithPos(i-1)
        if partner then
            if  roleId == partner.nID then
                return partner.strName:getData()
            end
        end
    end
    return ""
end



local function open_changeEquiptProfession()

    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setContentSize(CCSizeMake(SX(480), SY(320)))
    wnd:setTag(8001);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
	local imgFile = getRealUIResourcePath("img/titile59.png");
	if imgFile then
	   wnd:setTitleWithImage(imgFile:getData())
	end
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	naviCtrl:pushWindowController(wndCtrl)
	
	m_wnd =  getCurentSceneWindowController(8001):getWindow();
	
	
	m_leftContent_startX = 10*gUIScale().x
	m_leftContent_startY = 10*gUIScale().y
	m_leftContent_width  = wnd:getContentSize().width*0.56
	m_leftContent_height = wnd:getContentSize().height*0.8
	
	
    m_rightContent_startY = 10*gUIScale().y
    m_rightContent_width  = wnd:getContentSize().width*0.39
    m_rightContent_startX = wnd:getContentSize().width - m_rightContent_width-10*gUIScale().x
    m_rightContent_height = wnd:getContentSize().height*0.8
	
	local leftBackLayer = SCDragNode:node()
	leftBackLayer:setTag(800101)--左半边大背景层
	leftBackLayer:setFrameType(EnumFrameTypeRound)
	leftBackLayer:setFrameVisibled(true)
	leftBackLayer:setAnchorPoint(CCPointMake(0,0));
	leftBackLayer:setPosition(CCPointMake(m_leftContent_startX,m_leftContent_startY));
	leftBackLayer:setContentSize(CCSizeMake(m_leftContent_width,m_leftContent_height))
	wnd:addChild(leftBackLayer)
    
    --选择要铸成的装备
    local tmpStr = _LTParser("str8006")
    local detailLabel = SCLabel:labelWithStringFont(tmpStr,getDefaultFontName(), getFontSize(12))
	detailLabel:setTag(8001001)
	detailLabel:setColor(getColorYellow())
    detailLabel:setAnchorPoint(CCPointMake(0,0));
    local py = m_rightContent_height*0.42
    detailLabel:setPosition(CCPointMake(10*gUIScale().x,py));
    leftBackLayer:addChild(detailLabel)
    
    
    ----右半边
    local rightBackLayer = SCDragNode:node()
	rightBackLayer:setTag(800102)--左半边大背景层
	rightBackLayer:setFrameType(EnumFrameTypeRound)
	rightBackLayer:setFrameVisibled(true)
	rightBackLayer:setAnchorPoint(CCPointMake(0,0));
	rightBackLayer:setPosition(CCPointMake(m_rightContent_startX,m_rightContent_startY));
	rightBackLayer:setContentSize(CCSizeMake(m_rightContent_width,m_rightContent_height))
	wnd:addChild(rightBackLayer)
    
    --箭头
    local imgFile = getRealUIResourcePath(Img5058_ImagePath);
	local imageLabel = nil
	if imgFile then
	    imageLabel = SCImage:imageWithFile(imgFile:getData())
	    imageLabel:setTag(8001002)
	    imageLabel:setVisible(true)
        imageLabel:setAnchorPoint(CCPointMake(0.5,0));
	    local px = m_rightContent_width*0.48
        local py = m_rightContent_height*0.6
        imageLabel:setPosition(CCPointMake(px,py));
        rightBackLayer:addChild(imageLabel)
	end
	
     --确认转换按钮
    local changeButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(changeButton, SmallButton_Size)
	changeButton:setTag(8001003)
	local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	changeButton:setTitle(_LTParser("str8005"),getDefaultFontName(), getFontSize(12),getColorYellow())
    changeButton:setAnchorPoint(CCPointMake(0,0));
    changeButton:setPosition(CCPointMake((m_rightContent_width-changeButton:getContentSize().width)/2,10*gUIScale().y));
    changeButton:luaSetSelectorOnClicked(confirmChangeEquipt)--设置回调
    rightBackLayer:addChild(changeButton)
    
    --[[
    m_roleList = {}
    local role = Hero:getSingleton()  
    m_roleList[1] = {}
    m_roleList[1].id   = role:getID()
    m_roleList[1].name = ""..role:getName():getData();
    local amount = role:partnerSize()
    for i=1,amount do
        local partner = role:getPartnerWithPos(i-1)
        if partner then
            m_roleList[i+1] = {}
            m_roleList[i+1].id   = partner.nID
            m_roleList[i+1].name = ""..partner.strName:getData();
        end
    end
    --背包
    m_roleList[amount+2] = {}
    m_roleList[amount+2].id   = 1
    m_roleList[amount+2].name = _LTParser("str8009")--背包
    ]]
    
    --m_currentRoleId = role:getID()
    m_currentSelectIndex = 1
    
    showRoleList()
    showRefreshEquiptList();
    refreshEquiptTemplateList()
    showSelectEquiptDetail()
    showSelectTemplateEquiptDetail()
end

function closeWnd_ChangeEquiptWnd()
    local ctrl = getCurentSceneNavigationController()
    ctrl:removeWindowControllerByTag(8001)
end

function onClickClose()
    m_equiptList = nil--可重铸的装备列表

    m_equiptTemplateList = nil--重铸装备模板

    m_currentSelectEquipt = nil

    m_currentSelectTemplateEquipt = nil

    m_changeId = nil--要重铸的装备id
	
    m_changeSelectId= nil--重铸后的装备id
	
    m_idCost= nil--重铸符id

    m_leftContent_startX = nil
    m_leftContent_startY = nil
    m_leftContent_width  = nil
    m_leftContent_height = nil

    m_rightContent_startX = nil
    m_rightContent_startY = nil
    m_rightContent_width  = nil
    m_rightContent_height = nil

    m_roleList = nil;
    m_currentRoleId = nil

    m_wnd = nil

    m_currentSelectIndex = nil;--当前显示所属索引
   
end

--获取装备重铸模板
function sendQueryTemplateEquipList(equiptId)
    local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE);
    --EQUIPMADE_EQUIPMENTRECASTING_ITEMS=92--//装备重铸选择
    dt:writeShort(92);
    dt:writeInt(equiptId);
    SCDataTransThread:getSingleton():transData(dt);
end

--发送确认转换消息
function sendChangeEquptMsg(idItem,idEquipType,idCostItem)
    local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE);
    --EQUIPMADE_EQUIPMENTRECASTING_OK	= 93,		//确定重铸装备
    dt:writeShort(93);
    dt:writeInt(idItem);
    dt:writeInt(idEquipType);
    dt:writeInt(idCostItem);
    SCDataTransThread:getSingleton():transData(dt);
end

--
function processCanChangeEquiptListData(dt)
    if dt== nil then
        return
    end
    if m_equiptList == nil then
        m_equiptList = {}
    end
    if m_roleList == nil then
        m_roleList = {}
    end
    
    m_idCost       = dt:readInt()--//重铸符id
    local roleId   = dt:readInt()--//所属角色id，0为背包
    local bagEquiptAmount = 0
    
    local ucAmount = dt:readByte()
    local bagTag = 1
    if roleId == 0 then--背包
        bagEquiptAmount = getCurrentOnBagAmount()
        bagTag = math.modf(bagEquiptAmount/4)
        if bagTag < 1 then
            bagTag = 1
        end
        if getRoleById(roleId) == nil then
            local tmp = {}
            tmp.id   = bagTag
            tmp.name = _LTParser("str8009")..bagTag--背包
            table.insert(m_roleList,tmp);
        end
    else
        if ucAmount>0 and getRoleById(roleId) == nil then
            local tmp = {}
            tmp.id   = roleId
            tmp.name = getRoleName(roleId)
            table.insert(m_roleList,tmp);
        end
    end
    
    for i=1,ucAmount do
        local equipt = {}
        if roleId == 0 then
            equipt.roleId    = bagTag
            bagEquiptAmount = bagEquiptAmount+1
            local vaule = math.mod(bagEquiptAmount,4)
            if vaule ==0 and bagEquiptAmount > 0 then
                bagTag = bagTag + 1
                local tmp = {}
                tmp.id   = bagTag
                tmp.name = _LTParser("str8009")..bagTag--背包
                table.insert(m_roleList,tmp);
            end
        else
            equipt.roleId    = roleId
        end
        
        equipt.idItemType       = dt:readInt()--//id
        equipt.nPhoto           = dt:readInt()--//图标
        local tmpName           = dt:readString()--//名字
        local tmpProfession     =  dt:readString()--//职业	
        local tmpAttr           = dt:readString()--//当前属性
        local tmpStrength       = dt:readString()--//强化等级
        if tmpName then--//名字
            equipt.name  = tmpName:getData()
        else
           equipt.name   = ""
        end
        if tmpProfession then--//职业	
            equipt.professionalName = tmpProfession:getData()
        else
            equipt.professionalName = ""
        end
        if tmpAttr then--//当前属性
            equipt.attrDetail = tmpAttr:getData()
        else
            equipt.attrDetail = ""
        end
        if tmpStrength then--//强化等级
            equipt.szStrengthLevel = tmpStrength:getData()
        else
            equipt.szStrengthLevel = ""
        end
        table.insert(m_equiptList,equipt);
    end
    if m_wnd == nil then
        open_changeEquiptProfession()
    end
    showRefreshEquiptList()
    if m_currentSelectIndex == nil then
        m_currentSelectIndex = 1
    end
    if m_roleList[m_currentSelectIndex] then
        m_currentRoleId = m_roleList[m_currentSelectIndex].id
    end
    showRoleList()
end

--
function processChangeEquiptSelectListData(dt)
    if dt == nil then
        return
    end
    m_equiptTemplateList = {}
    local idEquipt   = dt:readInt()--//要重铸装备id
    local ucAmount   = dt:readByte()
    for i=1,ucAmount do
        local equipt = {}
        equipt.idItemType       = dt:readInt()--//id
        equipt.nPhoto           = dt:readInt()--//图标
        local tmpName           = dt:readString()--//名字
        local tmpProfession     =  dt:readString()--//职业	
        local tmpAttr           = dt:readString()--//当前属性
        local tmpStrength       = dt:readString()--//强化等级
        if tmpName then--//名字
            equipt.name  = tmpName:getData()
        else
           equipt.name   = ""
        end
        if tmpProfession then--//职业	
            equipt.professionalName = tmpProfession:getData()
        else
            equipt.professionalName = ""
        end
        if tmpAttr then--//当前属性
            equipt.attrDetail = tmpAttr:getData()
        else
            equipt.attrDetail = ""
        end
        if tmpStrength then--//强化等级
            equipt.szStrengthLevel = tmpStrength:getData()
        else
            equipt.szStrengthLevel = ""
        end
        table.insert(m_equiptTemplateList,equipt);
    end
    refreshEquiptTemplateList()
end


--LuaData:getSingleton():luaSetSelectorOnRecvData(processCanChangeEquiptListData, LuaData_EQUIPMADE_EQUIPMENTRECASTING_OPEN);
--LuaData:getSingleton():luaSetSelectorOnRecvData(processChangeEquiptSelectListData,LuaData_EQUIPMADE_EQUIPMENTRECASTING_ITEMS);