--定义一个与文件名相同的table
CopymapSweep = {}
------------------消息--------------------
local ACTION_COPY_MONSTOR_NAME = 17
local ACTION_COPYWIPE_MONSTOR_AWARD = 18
local ACTION_COPY_WIPE_END=22; --//停止扫荡
local ACTION_COPY_WIPE_CLOSE_WINDOW = 40; --//关闭窗口
local m_bSweeping = false;
local m_stInstance = nil;
local m_stOutInfo = {}

----------------结构定义区----------------
local stCopyItemInfo = {
    initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local tmpEx1 = {};
		tmpEx1.nId = dt:readInt();
		tmpEx1.usAmount = dt:readShort();
		return tmpEx1;
	end
};

local stCurrAward = {
    initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local tmpEx = {};
		tmpEx.ucType = dt:readByte();
		tmpEx.dwAwardValue = dt:readInt();
		return tmpEx;
	end
};

local stCopyOutInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		local tmp = {};
		tmp.ucItemAmount = dt:readByte();
		tmp.ItemInfo = {};
		for i=1,tmp.ucItemAmount do
		    table.insert(tmp.ItemInfo, stCopyItemInfo.initWithStream(dt));
		end
		
		tmp.BonusExp = dt:readInt();
		tmp.BonusMoney = dt:readInt();
		tmp.BonusEmoney = dt:readInt();
		tmp.BonusGodExp = dt:readInt();
		tmp.BonusProffer = dt:readInt();
		tmp.nBonusReputation = dt:readInt();
		tmp.nBonusSynMoney = dt:readInt();
		tmp.nBonusSynContribute = dt:readInt();
		tmp.nBonusTired = dt:readInt();
		tmp.ucOtherAmount = dt:readByte();
		tmp.CurrInfo = {};
		for i=1,tmp.ucOtherAmount do
		    table.insert(tmp.CurrInfo, stCurrAward.initWithStream(dt));
		end
		return tmp
	end
}

----------------常量定义区----------------

----------------变量定义区----------------
--变量的定义
local m_turns = nil;
local m_idTemplate = nil;
local m_strAward = nil;
local m_Type = nil;
local m_bStart = nil;
local m_textStr = "";
local m_CutWillTable = {}
local onClickStart = nil
----------------UI控制器区----------------
function CopymapSweep.initControl()
	local pWindow8001 = SCWindow:window()
	if pWindow8001 then
		pWindow8001:setTag(8001)
		pWindow8001:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow8001:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("img/new00233.png")
		if pImgPath then
			pWindow8001:setTitleWithImage(pImgPath:getData())
		end
		pWindow8001:setContentSize(AUTO_SIZE(480, 320))
		pWindow8001:luaSetSelectorOnClose(CopymapSweep.releaseControl)
	end

	CopymapSweep.m_DragNode1 = SCDragNode:node()
	if CopymapSweep.m_DragNode1 then
		CopymapSweep.m_DragNode1:setTag(1)
		CopymapSweep.m_DragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		CopymapSweep.m_DragNode1:setPosition(AUTO_POS(15.00, 182.00))
		CopymapSweep.m_DragNode1:setContentSize(AUTO_SIZE(222, 81))
		CopymapSweep.m_DragNode1:setFrameVisibled(true)
		CopymapSweep.m_DragNode1:setDragEnabled(false)
		CopymapSweep.m_DragNode1:setFrameType(EnumFrameTypeRound)
	end

	CopymapSweep.m_DragNode2 = SCDragNode:node()
	if CopymapSweep.m_DragNode2 then
		CopymapSweep.m_DragNode2:setTag(2)
		CopymapSweep.m_DragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		CopymapSweep.m_DragNode2:setPosition(AUTO_POS(15.00, 15.00))
		CopymapSweep.m_DragNode2:setContentSize(AUTO_SIZE(222, 166))
		CopymapSweep.m_DragNode2:setFrameVisibled(true)
		CopymapSweep.m_DragNode2:setDragEnabled(false)
		CopymapSweep.m_DragNode2:setFrameType(EnumFrameTypeRound)
	end

	CopymapSweep.m_DragNode3 = SCDragNode:node()
	if CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:setTag(3)
		CopymapSweep.m_DragNode3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		CopymapSweep.m_DragNode3:setPosition(AUTO_POS(243.00, 15.00))
		CopymapSweep.m_DragNode3:setContentSize(AUTO_SIZE(222, 248))
		CopymapSweep.m_DragNode3:setFrameVisibled(true)
		CopymapSweep.m_DragNode3:setDragEnabled(false)
		CopymapSweep.m_DragNode3:setFrameType(EnumFrameTypeRound)
	end

	local pLable4 = SCLabel:labelWithStringFont(L("str8149"), DEFAULT_FONT_NAME, F(12))
	if pLable4 then
		pLable4:setTag(4)
		pLable4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable4:setPosition(AUTO_POS(8.00, 59.00))
		pLable4:setColor(ccc4(255,255,255,255))
	end

	local pLable7 = SCLabel:labelWithStringFont(L("str8157"), DEFAULT_FONT_NAME, F(12))
	if pLable7 then
		pLable7:setTag(7)
		pLable7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable7:setPosition(AUTO_POS(86.00, 225.00))
		pLable7:setColor(ccc4(255,255,255,255))
	end

	local pTextBox5 = SCTextBox:boxWithWidthHeightFont(AUTO_W(206), AUTO_H(48), DEFAULT_FONT_NAME, F(10))
	if pTextBox5 then
		tolua.cast(pTextBox5, "SCNode"):setTag(5)
		tolua.cast(pTextBox5, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pTextBox5, "SCNode"):setPosition(AUTO_POS(8.00, 9.00))
		pTextBox5:setText(L(""))
	end

	local pLable8 = SCLabel:labelWithStringFont(L("str8150"), DEFAULT_FONT_NAME, F(12))
	if pLable8 then
		pLable8:setTag(8)
		pLable8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable8:setPosition(AUTO_POS(14.00, 207.00))
		pLable8:setColor(ccc4(255,255,255,255))
	end

	local imgPath = getRealUIResourcePath("img/new00235.png")
	local pImage10 = nil
	if imgPath then
		pImage10 = SCImage:imageWithFile(imgPath:getData())
		if pImage10 then
			pImage10:setTag(10)
			pImage10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10:setPosition(AUTO_POS(40.00, 206.00))
		end
	end

	local pEdit9 = SCEdit:editWithFont(L(""), F(15))
	if pEdit9 then
		pEdit9:setTag(9)
		pEdit9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pEdit9:setPosition(AUTO_POS(41.00, 208.00))
		pEdit9:setContentSize(AUTO_SIZE(27, 13))
		pEdit9:setPlaceHolder(L(""))
		pEdit9:setIsPasswordText(false)
		pEdit9:setMaxCharCount(3)
		pEdit9:setMinCharCount(0)
	end

	local pLable11 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable11 then
		pLable11:setTag(11)
		pLable11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable11:setPosition(AUTO_POS(70.00, 207.00))
		pLable11:setColor(ccc4(255,255,255,255))
	end

	local pButton12 = SCButton:button(EnumBtnType9Atlas)
	if pButton12 then
		pButton12:setTag(12)
		pButton12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton12:setPosition(AUTO_POS(18.00, 168.00))
		pButton12:setContentSize(AUTO_SIZE(85, 30))
		pButton12:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton13 = SCButton:button(EnumBtnType9Atlas)
	if pButton13 then
		pButton13:setTag(13)
		pButton13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton13:setPosition(AUTO_POS(112.00, 168.00))
		pButton13:setContentSize(AUTO_SIZE(85, 30))
		pButton13:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton14 = SCButton:button(EnumBtnType9Atlas)
	if pButton14 then
		pButton14:setTag(14)
		pButton14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton14:setPosition(AUTO_POS(18.00, 128.00))
		pButton14:setContentSize(AUTO_SIZE(85, 30))
		pButton14:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton15 = SCButton:button(EnumBtnType9Atlas)
	if pButton15 then
		pButton15:setTag(15)
		pButton15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton15:setPosition(AUTO_POS(112.00, 128.00))
		pButton15:setContentSize(AUTO_SIZE(85, 30))
		pButton15:setTitle(L("str8154"), DEFAULT_FONT_NAME, F(15))
	end

	local pLable16 = SCLabel:labelWithStringFont(L("str8155"), DEFAULT_FONT_NAME, F(12))
	if pLable16 then
		pLable16:setTag(16)
		pLable16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable16:setPosition(AUTO_POS(25.00, 105.00))
		pLable16:setColor(ccc4(255,255,255,255))
	end

	local pLable17 = SCLabel:labelWithStringFont(L("str8156"), DEFAULT_FONT_NAME, F(12))
	if pLable17 then
		pLable17:setTag(17)
		pLable17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable17:setPosition(AUTO_POS(10.00, 81.00))
		pLable17:setColor(ccc4(255,255,255,255))
	end

	local imgPath = getRealUIResourcePath("img/new00001.png")
	local pImage18 = nil
	if imgPath then
		pImage18 = SCImage:imageWithFile(imgPath:getData())
		if pImage18 then
			pImage18:setTag(18)
			pImage18:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage18:setPosition(AUTO_POS(85.00, 78.00))
		end
	end

	local pButton19 = SCButton:button(EnumBtnType9Atlas)
	if pButton19 then
		pButton19:setTag(19)
		pButton19:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton19:setPosition(AUTO_POS(60.00, 25.00))
		pButton19:setContentSize(AUTO_SIZE(100, 30))
		local imgPath = getRealUIResourcePath("img/new00234.png")
		if imgPath then
			pButton19:setTitle(imgPath:getData())
		end
	end

	local pLable20 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable20 then
		pLable20:setTag(20)
		pLable20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable20:setPosition(AUTO_POS(90.00, 81.00))
		pLable20:setColor(ccc4(255,255,255,255))
	end

	local pListBox6 = SCListBox:boxWithWidthHeight(AUTO_W(205), AUTO_H(146))
	if pListBox6 then
		tolua.cast(pListBox6, "SCNode"):setTag(6)
		tolua.cast(pListBox6, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pListBox6, "SCNode"):setPosition(AUTO_POS(8.00, 9.00))
	end

	if CopymapSweep.m_DragNode1 and pWindow8001 then
		pWindow8001:addChild(tolua.cast(CopymapSweep.m_DragNode1, "SCNode"))
	end
	if CopymapSweep.m_DragNode2 and pWindow8001 then
		pWindow8001:addChild(tolua.cast(CopymapSweep.m_DragNode2, "SCNode"))
	end
	if CopymapSweep.m_DragNode3 and pWindow8001 then
		pWindow8001:addChild(tolua.cast(CopymapSweep.m_DragNode3, "SCNode"))
	end
	if pLable4 and CopymapSweep.m_DragNode1 then
		CopymapSweep.m_DragNode1:addChild(tolua.cast(pLable4, "SCNode"))
	end
	if pLable7 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pLable7, "SCNode"))
	end
	if pTextBox5 and CopymapSweep.m_DragNode1 then
		CopymapSweep.m_DragNode1:addChild(tolua.cast(pTextBox5, "SCNode"))
	end
	if pLable8 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pLable8, "SCNode"))
	end
	if pImage10 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pImage10, "SCNode"))
	end
	if pEdit9 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pEdit9, "SCNode"))
	end
	if pLable11 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pLable11, "SCNode"))
	end
	if pButton12 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pButton12, "SCNode"))
	end
	if pButton13 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pButton13, "SCNode"))
	end
	if pButton14 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pButton14, "SCNode"))
	end
	if pButton15 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pButton15, "SCNode"))
	end
	if pLable16 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pLable16, "SCNode"))
	end
	if pLable17 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pLable17, "SCNode"))
	end
	if pImage18 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pImage18, "SCNode"))
	end
	if pButton19 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pButton19, "SCNode"))
	end
	if pLable20 and CopymapSweep.m_DragNode3 then
		CopymapSweep.m_DragNode3:addChild(tolua.cast(pLable20, "SCNode"))
	end
	if pListBox6 and CopymapSweep.m_DragNode2 then
		CopymapSweep.m_DragNode2:addChild(tolua.cast(pListBox6, "SCNode"))
	end
	
	return pWindow8001
end
function CopymapSweep.releaseControl()
	CopymapSweep.m_DragNode1 = nil
	CopymapSweep.m_DragNode2 = nil
	CopymapSweep.m_DragNode3 = nil
	if CopymapSweep.wndClose then
		CopymapSweep.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function CloseWnd()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
	dataStream:writeShort(ACTION_COPY_WIPE_CLOSE_WINDOW);
	SCDataTransThread:getSingleton():transData(dataStream)
end

function CopymapSweep.wndClose()
    CloseWnd();
    
    m_turns = nil;
    m_idTemplate = nil;
    m_strAward = nil;
    m_Type = nil;
    m_bStart = nil;
    m_textStr = "";
    m_stOutInfo = {};
end

local function GetSweepWaitTime()
    local nAddWaitTime = 0;
    local nVipLev = Hero:getSingleton():getVipLevel();
    local nLev = Hero:getSingleton():getLeval();
    nAddWaitTime = Hero:getSingleton():getSweepLeaveTime();
    if nAddWaitTime>0 then
        return nAddWaitTime;
    end
    
    if m_Type==1 then
        if nLev>=80 or nVipLev>=1 then
            nAddWaitTime = 0;
        else
            nAddWaitTime = 180*m_turns;
        end
    else
        if nVipLev>=4 then
            nAddWaitTime = 0;
        else
            nAddWaitTime = 900*m_turns;
        end
    end
    return nAddWaitTime;
end

local function showTip(tag)
    showMessage(L("str0515"));
end

local function onSureBuyTired(tag)
	if 1 == tag then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    	dataStream:writeShort(43);
		dataStream:writeByte(0)
	    SCDataTransThread:getSingleton():transData(dataStream);
	end
end

local function EditValueShowLabel(turns,bSys)
    if m_bStart==true and bSys==nil then
        return;
    end

    if turns==nil then
        return;
    end
    
    local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-3"), "SCDragNode")
    if not pDragNode3 then return end
        
    local pEdit = SCTypeCast:castNodeToEdit(pDragNode3:getChildByTag(9))
	if not pEdit then
		return;
	end
	local nInstanceType = GameCopyController_getInstanceType()
	local nCostTired = 5
	local nTmpNum = nil
	if m_idTemplate~=nil then
	    local stInstance = TableParser:getSingleton():getInstanceTemplate(m_idTemplate);
	    if stInstance.type==2 then
	        nCostTired = 10
	        if not m_bSweeping then
	            nTmpNum = GameCopyController_getFrequencyNum()
	        end
	    elseif stInstance.type==3 then
	        nCostTired = 15
	    end
	    nInstanceType = stInstance.type
	end
	
	local bEnough = true
	m_turns = turns;
    local tiredness = Hero:getSingleton():getTiredness() + Hero:getSingleton():getTirednessAdd()
    if 999999999 == m_turns then
		m_turns = math.floor(tiredness/nCostTired)
    end
	if m_turns > math.floor(tiredness/nCostTired) then
		m_turns = math.floor(tiredness/nCostTired)
		bEnough = false
	end
	if nTmpNum then
	    if nTmpNum < m_turns then
	        m_turns = nTmpNum 
	        if nTmpNum > math.floor(tiredness/nCostTired) then
	            bEnough = false
	        end
	    end
    end 
	local times = nil
	if nInstanceType == 2 then
        if GameCopyController_getLeaveUseTimes() > m_turns then
            times = m_turns
        else
            times = GameCopyController_getLeaveUseTimes()
        end
        pEdit:setContentText(getIntPart(times).."") 
    else
        pEdit:setContentText(getIntPart(m_turns).."")
    end
	
	local pLable = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(11));
	if pLable then
	    if nInstanceType == 2 then
            if GameCopyController_getLeaveUseTimes() >= m_turns then
                times = m_turns
            else
                times = GameCopyController_getLeaveUseTimes()
            end
            pLable:setText(L("str8151")..(getIntPart(times)*nCostTired)..L("str8152")); 
        else
            pLable:setText(L("str8151")..(getIntPart(m_turns)*nCostTired)..L("str8152")); 
        end
    end
    
    if turns==0 then
        local pCountDownImg = SCTypeCast:castNodeToImage(pDragNode3:getChildByTag(18));
        if pCountDownImg then
            pCountDownImg:removeChildByTag(999,true);
        end
        
        if bSys~=nil then
            local pCountDownLabel = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(20));
            if pCountDownLabel then
                pCountDownLabel:setVisible(true);
                pCountDownLabel:setText("00:00:00");
            end
        end
    end
    
    if bSys==nil then
        local nAddWaitTime = GetSweepWaitTime();
        local pCountDownLabel = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(20));
        if pCountDownLabel then
        
            pCountDownLabel:setVisible(true);
            
            local strTxt = "";
            local nHou = math.floor(nAddWaitTime/3600);
            if nHou<10 then
                strTxt = strTxt.."0"..nHou
            else
                strTxt = strTxt..nHou
            end
            
            strTxt = strTxt..":"
            local nMin = math.floor((math.mod(nAddWaitTime,3600))/60);
            if nMin<10 then
                strTxt = strTxt.."0"..nMin
            else
                strTxt = strTxt..nMin
            end
            
            strTxt = strTxt..":"
            local nSec = math.mod(nAddWaitTime,60);
            if nSec<10 then
                strTxt = strTxt.."0"..nSec
            else
                strTxt = strTxt..nSec
            end
            
            pCountDownLabel:setText(strTxt);
        end
    end
    if false == bEnough then
		--if not getCurentSceneWindow(788889) then 
			luashowConfirmationWindow(L("str6309"), WIN_YES_NO, onSureBuyTired)
		--end
    end
    local pStartBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(19))
	if pStartBtn then
	    if m_turns>0 then
	        pStartBtn:luaSetSelectorOnClicked(onClickStart);
	    else
	        pStartBtn:luaSetSelectorOnClicked(showTip);
	    end
	end
end

local function onClickTurnsCheck(tag)
    local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-3"), "SCDragNode")
    if not pDragNode3 then return end
    
    local pEdit = SCTypeCast:castNodeToEdit(pDragNode3:getChildByTag(9))
	if not pEdit then
		return;
	end
	
	local turns = 0;
	if tag==12 then
	    turns = 5;
	elseif tag==13 then
	    turns = 10;
	elseif tag==14 then
	    turns = 20;
	elseif tag==15 then
	    turns = 999999999;
	else
	    return;
	end
	
	EditValueShowLabel(turns);
end

function onClickStart(tag)
    local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-3"), "SCDragNode")
    if not pDragNode3 then return end
    
    local pStartBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(19));
    if pStartBtn==nil then
        return;
    end
    
    if m_bStart==true then
        m_bStart = false;
        m_bSweeping = false;
        
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
    	dataStream:writeShort(ACTION_COPY_WIPE_END);
	    SCDataTransThread:getSingleton():transData(dataStream);
	    
	    local pImgPath = getRealUIResourcePath("img/new00234.png")
	    if pImgPath then
            pStartBtn:setTitle(pImgPath:getData()); 
	    end
        
        local pCountDownImg = SCTypeCast:castNodeToImage(pDragNode3:getChildByTag(18));
        if pCountDownImg then
            pCountDownImg:removeChildByTag(999,true);
        end
	    Hero:getSingleton():setSweepLeaveTime(0)
	    EditValueShowLabel(1);
	    
	    MainInterface_endCopySweep();
    else	
        if m_bSweeping == true then
            return
        end
		
		if m_turns<=0 or (GameCopyController_getInstanceType() == 2 and GameCopyController_getLeaveUseTimes()<= 0) then
            showMessage(L("str8173"));
            return;
        end
    
        local times = nil;
        if GameCopyController_getInstanceType() == 2 then
            if GameCopyController_getLeaveUseTimes() >= getIntPart(m_turns) then
                times = getIntPart(m_turns)
            else
                times = GameCopyController_getLeaveUseTimes()
            end
        else
            times = getIntPart(m_turns)
        end
        
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
        dataStream:writeShort(ACTION_COPYWIPE_MONSTOR_AWARD);
        dataStream:writeByte(0);
        dataStream:writeInt(m_idTemplate)
        dataStream:writeInt(times)
        dataStream:writeInt(0)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show();
    end
end

local function onEditEndInput(tag)
    local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-3"), "SCDragNode")
    if not pDragNode3 then return end

	local pEdit = SCTypeCast:castNodeToEdit(pDragNode3:getChildByTag(9))
	if not pEdit then
		return
	end
	
	local text = pEdit:getContentText()
	local turns = tonumber(text)
	if turns==nil then
		pEdit:setContentText("");
		return;
	end
	
    EditValueShowLabel(turns)

	if pEdit:getIsInputing() then
		pEdit:detachWithIME()
	end
end

--打开扫荡窗口
function CopymapSweep.OpenCopymaoSweep(idTemplate,nTimes,nType,bQuery,isStart)
    local wndCtrl = getCurentSceneWindowController(8001);
    if wndCtrl then
        return;
    end
    
    local wnd = CopymapSweep.initControl();
    if wnd==nil then
        return;
    end
    
    wndCtrl = SCWindowController:controllerWithWindow(wnd)
    getCurentSceneNavigationController():pushWindowController(wndCtrl);
    
    m_idTemplate = idTemplate;
    m_Type = nType;
    m_bStart = false;
    EditValueShowLabel(nTimes);
    
    local pDragNode1 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-1"), "SCDragNode")
    if not pDragNode1 then return end
    
    local pLabel1 = SCTypeCast:castNodeToLabel(pDragNode1:getChildByTag(4))
	if pLabel1 then
	    pLabel1:setColor(getColorOrange());
	end
	
	local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-3"), "SCDragNode")
    if not pDragNode3 then return end
    
	local pLabe12 = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(16))
	if pLabe12 then
        local nVipLev = Hero:getSingleton():getVipLevel();
        local nLev = Hero:getSingleton():getLeval();
	    if m_Type==1 then
	        if nLev>=80 or nVipLev>=1 then
	            pLabe12:setVisible(false);
	        else
	            pLabe12:setVisible(true);
	            pLabe12:setText(L("str8155"));
	            pLabe12:setColor(getColorOrange());
	        end
	    else
	        if nVipLev>=4 then
	            pLabe12:setVisible(false);
	        else
	            pLabe12:setVisible(true);
	            pLabe12:setText(L("str8168"));
	            pLabe12:setColor(getColorOrange());
	        end
	    end
	end
    
    local pBtn1 = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(12))
	if pBtn1 then
	    pBtn1:setTitle("5"..L("str8153"), DEFAULT_FONT_NAME, F(15), getColorWhite());
	    pBtn1:luaSetSelectorOnClicked(onClickTurnsCheck);
	end
	
	local pBtn2 = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(13))
	if pBtn2 then
	    pBtn2:setTitle("10"..L("str8153"), DEFAULT_FONT_NAME, F(15), getColorWhite());
	    pBtn2:luaSetSelectorOnClicked(onClickTurnsCheck);
	end
    
    local pBtn3 = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(14))
	if pBtn3 then
	    pBtn3:setTitle("20"..L("str8153"), DEFAULT_FONT_NAME, F(15), getColorWhite());
	    pBtn3:luaSetSelectorOnClicked(onClickTurnsCheck);
	end
	
	local pBtn4 = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(15))
	if pBtn4 then
	    pBtn4:luaSetSelectorOnClicked(onClickTurnsCheck);
	end
	
	local pEdit = SCTypeCast:castNodeToEdit(pDragNode3:getChildByTag(9))
	if pEdit then
	    pEdit:luaSetSelectorOnEndInput(onEditEndInput);
	end
	
	local pStartBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(19))
	if pStartBtn then
	    if m_turns>0 then
	        pStartBtn:luaSetSelectorOnClicked(onClickStart);
	    else
	        pStartBtn:luaSetSelectorOnClicked(showTip);
	    end
	end
	if isStart == false then
	    return;
	end
	if bQuery==true then
        --扫荡收益请求
        --请求下发副本收益数据
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE)
        dataStream:writeShort(ACTION_COPY_MONSTOR_NAME)
        dataStream:writeInt(m_idTemplate)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    else
        m_bStart = true;
        
        local pImgPath = getRealUIResourcePath("img/new00479.png")
        if pImgPath then
            pStartBtn:setTitle(pImgPath:getData());
        end
        
        local pCountDownLabel = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(20));
        if pCountDownLabel then
            pCountDownLabel:setVisible(false);
        end
        
        local nAddWaitTime = GetSweepWaitTime();
        local pCountDownImg = SCTypeCast:castNodeToImage(pDragNode3:getChildByTag(18));
        if pCountDownImg then
            pCountDownImg:removeChildByTag(999,true);
            local pCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second,12)
            if pCountDownNode then
                pCountDownNode:setTime(nAddWaitTime);
                pCountDownNode:setTag(999);
                --pCountDownNode:setColor(getColorRed());
                pCountDownNode:setPosition(SX(5),SY(3));
                pCountDownImg:addChild(pCountDownNode);
                --pCountDownNode:luasetSelectorOnClose(CloseWnd);
            end
        end
        
        local pDragNode2 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-2"), "SCDragNode")
        if not pDragNode2 then return end
    
        local plistBox = SCTypeCast:castNodeToListBox(pDragNode2:getChildByTag(6));
        if plistBox then
            plistBox:removeAllItems();
        end
	end
end


----------------消息处理区----------------
function CopymapSweep.recCopyPutout(dt)
    if m_stInstance then
        CopymapSweep.OpenCopymaoSweep(m_stInstance.id,1,m_stInstance.type,true, false);
        m_stInstance = nil;
    end
    local idTemplate = dt:readInt();
	local nType = dt:readByte();
	local nTimes = dt:readInt();
	local nLeaveTimes = dt:readInt();
	--读取数据
    local stOutInfo = stCopyOutInfo.initWithStream(dt);
    m_stOutInfo = stOutInfo;
    
	Hero:getSingleton():setSweepLeaveTime(nLeaveTimes);
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("8001"));
    if wnd==nil then
        CopymapSweep.OpenCopymaoSweep(idTemplate,nTimes,nType,false)
    end
    
    SCActivityIndicator:getSingleton():close()
    
    local nMarkValue = 0;
    local idMatrialType,nMatrialNum = EquipMake_getNeedMaterialInfo();
    if idMatrialType~=nil and nMatrialNum>0 then
        for i=1,stOutInfo.ucItemAmount do
            local nId = stOutInfo.ItemInfo[i].nId
            local usAmount = stOutInfo.ItemInfo[i].usAmount;
            if string.format("%u", idMatrialType)==string.format("%u", nId) and usAmount>0 then
                nTimes = math.floor(nMatrialNum+usAmount-1/usAmount);
                EditValueShowLabel(nTimes);
                nMarkValue = 1;
                break;
            end
        end
    end
    
    if nMarkValue==0 then
        local nCopyQuestTimes = CopyQuest_getNeedCopySweepInfo();
        if nCopyQuestTimes~=nil and nCopyQuestTimes>0 then
            EditValueShowLabel(nCopyQuestTimes);
        end
    end
    
    local pDragNode1 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-1"), "SCDragNode")
    if not pDragNode1 then return end
    
    local pTxtBox = SCTypeCast:castNodeToTextBox(pDragNode1:getChildByTag(5));
    if pTxtBox then
        local strAward = "";
        local additionExp = 1;
        local additionMoney = 1;
        if CLIENT_VERSION > 328 then 
			local cutWillInfo = ItemProcessor:getSingleton():getCutWillInfo();
			if cutWillInfo ~= nil then
				if cutWillInfo.nTimes > 0 then
					additionExp = additionExp + m_CutWillTable.nAddExp/1000
					additionMoney = additionMoney + m_CutWillTable.nAddMoney/1000
				end
            end
        end
        if stOutInfo then
			m_strAward = "";
            local iCount = 0;
            if stOutInfo.BonusExp>0 then
                strAward = strAward..L("str0192").."+"..stOutInfo.BonusExp.."  ";
				m_strAward = m_strAward..L("str0192").."+"..(stOutInfo.BonusExp * additionExp).."  ";
				iCount = iCount+1;
            end
            if stOutInfo.BonusMoney>0 then
                strAward = strAward..L("str6157").."+"..stOutInfo.BonusMoney.."  ";
				m_strAward = m_strAward..L("str6157").."+"..(stOutInfo.BonusMoney * additionMoney).."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            if stOutInfo.BonusEmoney>0 then
                strAward = strAward..L("str0183").."+"..stOutInfo.BonusEmoney.."  ";
				m_strAward = m_strAward..L("str0183").."+"..stOutInfo.BonusEmoney.."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            if stOutInfo.BonusProffer>0 then
                strAward = strAward..L("str6011").."+"..stOutInfo.BonusProffer.."  ";
                m_strAward = m_strAward..L("str6011").."+"..stOutInfo.BonusProffer.."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            if stOutInfo.nBonusReputation>0 then
                strAward = strAward..L("str6010").."+"..stOutInfo.nBonusReputation.."  ";
				m_strAward = m_strAward..L("str6010").."+"..stOutInfo.nBonusReputation.."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            if stOutInfo.nBonusTired>0 then
                strAward = strAward..L("str8158").."+"..stOutInfo.nBonusTired.."  ";
				m_strAward = m_strAward..L("str8158").."+"..stOutInfo.nBonusTired.."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            
            for i=1,stOutInfo.ucOtherAmount do
                local ucCurrType = stOutInfo.CurrInfo[i].ucType;
                local nVaule = stOutInfo.CurrInfo[i].dwAwardValue;
                if ucCurrType==1 then
                    strAward = strAward..L("str6156").."+"..nVaule.."  "; --"str6156"  = "战功"
					m_strAward = m_strAward..L("str6156").."+"..nVaule.."  "; --"str6156"  = "战功"
                elseif ucCurrType==2 then
                    strAward = strAward..L("str8159").."+"..nVaule.."  "; --"str8159"  = "通宝"
					m_strAward = m_strAward..L("str8159").."+"..nVaule.."  "; --"str8159"  = "通宝"
                elseif ucCurrType==3 then
                    strAward = strAward..L("str8160").."+"..nVaule.."  "; --"str8160"  = "符石"
					m_strAward = m_strAward..L("str8160").."+"..nVaule.."  "; --"str8160"  = "符石"
                elseif ucCurrType==4 then
                    strAward = strAward..L("str8161").."+"..nVaule.."  "; --"str8161" = "武魂碎片"
					m_strAward = m_strAward..L("str8161").."+"..nVaule.."  "; --"str8161" = "武魂碎片"
                elseif ucCurrType==5 then
                    strAward = strAward..L("str8162").."+"..nVaule.."  "; --"str8161" = "活跃币"
					m_strAward = m_strAward..L("str8162").."+"..nVaule.."  "; --"str8161" = "活跃币"
                else
					return;
				end
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            
            for i=1,stOutInfo.ucItemAmount do
                local nId = stOutInfo.ItemInfo[i].nId;
                local usAmount = stOutInfo.ItemInfo[i].usAmount;
                if nId~=0 and usAmount>0 then
                    local stTypeInfo = TableParser:getSingleton():getItemInfoByKey(nId);
                    if stTypeInfo then
                        strAward = strAward..stTypeInfo.name:getData().."+"..usAmount.."  ";
                        m_strAward = m_strAward..stTypeInfo.name:getData().."+"..usAmount.."  ";
                        iCount = iCount+1;
		                if math.mod(iCount,2)==0 and iCount>0 then
		                    m_strAward = m_strAward.."_";
		                end
                    end
                end
            end
            if ActivityAll_isUnlock(S_WONDERFULEVENT_TYPE_COPYDOUBLEEXP) and (m_Type == 2 or m_Type == 3) then
				strAward = strAward.."*3("..L("str6302")..")"
				pTxtBox:setParserDelegate(TextParser:getSingleton())
			end
			
			if CLIENT_VERSION > 328 then 
				local cutWillInfo = ItemProcessor:getSingleton():getCutWillInfo();
				if cutWillInfo ~= nil then
					if cutWillInfo.nTimes > 0 then
						local tipStr = "*3"..m_CutWillTable.strName.."*0"..L("str8117").."*3"..cutWillInfo.nTimes;
						tipStr = tipStr.."_"..L("str9248").."*3"..math.floor(cutWillInfo.nAddExp/10).."%*0,";
						tipStr = tipStr..L("str9249").."*3"..math.floor(cutWillInfo.nAddMoney/10).."%";
						strAward = strAward.."_"..tipStr;
						pTxtBox:setParserDelegate(TextParser:getSingleton())
						
						if cutWillInfo.nTimes == 1 then
							m_CutWillTable.nTimes = 1
						end
					end
				end
			end
            pTxtBox:setText(strAward);
        end
    end
end

local function getAwardString()
    local stOutInfo = m_stOutInfo;
    local pDragNode1 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-1"), "SCDragNode")
    if not pDragNode1 then return end
    local pTxtBox = SCTypeCast:castNodeToTextBox(pDragNode1:getChildByTag(5));
    if pTxtBox then
        local strAward = "";
        local additionExp = 1;
        local additionMoney = 1;
        if CLIENT_VERSION > 328 then 
            if m_CutWillTable.nTimes > 0 then
				additionExp = additionExp + m_CutWillTable.nAddExp/1000
				additionMoney = additionMoney + m_CutWillTable.nAddMoney/1000
            end
        end
        if stOutInfo then
			m_strAward = "";
            local iCount = 0;
            if stOutInfo.BonusExp>0 then
                strAward = strAward..L("str0192").."+"..stOutInfo.BonusExp.."  ";
				m_strAward = m_strAward..L("str0192").."+"..(stOutInfo.BonusExp * additionExp).."  ";
				iCount = iCount+1;
            end
            if stOutInfo.BonusMoney>0 then
                strAward = strAward..L("str6157").."+"..stOutInfo.BonusMoney.."  ";
				m_strAward = m_strAward..L("str6157").."+"..(stOutInfo.BonusMoney * additionMoney).."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            if stOutInfo.BonusEmoney>0 then
                strAward = strAward..L("str0183").."+"..stOutInfo.BonusEmoney.."  ";
				m_strAward = m_strAward..L("str0183").."+"..stOutInfo.BonusEmoney.."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            if stOutInfo.BonusProffer>0 then
                strAward = strAward..L("str6011").."+"..stOutInfo.BonusProffer.."  ";
                m_strAward = m_strAward..L("str6011").."+"..stOutInfo.BonusProffer.."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            if stOutInfo.nBonusReputation>0 then
                strAward = strAward..L("str6010").."+"..stOutInfo.nBonusReputation.."  ";
				m_strAward = m_strAward..L("str6010").."+"..stOutInfo.nBonusReputation.."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            if stOutInfo.nBonusTired>0 then
                strAward = strAward..L("str8158").."+"..stOutInfo.nBonusTired.."  ";
				m_strAward = m_strAward..L("str8158").."+"..stOutInfo.nBonusTired.."  ";
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            
            for i=1,stOutInfo.ucOtherAmount do
                local ucCurrType = stOutInfo.CurrInfo[i].ucType;
                local nVaule = stOutInfo.CurrInfo[i].dwAwardValue;
                if ucCurrType==1 then
                    strAward = strAward..L("str6156").."+"..nVaule.."  "; --"str6156"  = "战功"
					m_strAward = m_strAward..L("str6156").."+"..nVaule.."  "; --"str6156"  = "战功"
                elseif ucCurrType==2 then
                    strAward = strAward..L("str8159").."+"..nVaule.."  "; --"str8159"  = "通宝"
					m_strAward = m_strAward..L("str8159").."+"..nVaule.."  "; --"str8159"  = "通宝"
                elseif ucCurrType==3 then
                    strAward = strAward..L("str8160").."+"..nVaule.."  "; --"str8160"  = "符石"
					m_strAward = m_strAward..L("str8160").."+"..nVaule.."  "; --"str8160"  = "符石"
                elseif ucCurrType==4 then
                    strAward = strAward..L("str8161").."+"..nVaule.."  "; --"str8161" = "武魂碎片"
					m_strAward = m_strAward..L("str8161").."+"..nVaule.."  "; --"str8161" = "武魂碎片"
                elseif ucCurrType==5 then
                    strAward = strAward..L("str8162").."+"..nVaule.."  "; --"str8161" = "活跃币"
					m_strAward = m_strAward..L("str8162").."+"..nVaule.."  "; --"str8161" = "活跃币"
                else
					return;
				end
                iCount = iCount+1;
                if math.mod(iCount,2)==0 and iCount>0 then
                    m_strAward = m_strAward.."_";
                end
            end
            
            for i=1,stOutInfo.ucItemAmount do
                local nId = stOutInfo.ItemInfo[i].nId;
                local usAmount = stOutInfo.ItemInfo[i].usAmount;
                if nId~=0 and usAmount>0 then
                    local stTypeInfo = TableParser:getSingleton():getItemInfoByKey(nId);
                    if stTypeInfo then
                        strAward = strAward..stTypeInfo.name:getData().."+"..usAmount.."  ";
                        m_strAward = m_strAward..stTypeInfo.name:getData().."+"..usAmount.."  ";
                        iCount = iCount+1;
		                if math.mod(iCount,2)==0 and iCount>0 then
		                    m_strAward = m_strAward.."_";
		                end
                    end
                end
            end
            if ActivityAll_isUnlock(S_WONDERFULEVENT_TYPE_COPYDOUBLEEXP) and (m_Type == 2 or m_Type == 3) then
				strAward = strAward.."*3("..L("str6302")..")"
			end
			
			if CLIENT_VERSION > 328 and m_CutWillTable.nTimes > 0 then 
				if m_CutWillTable.nTimes > 1 then
					local tipStr = "*3"..m_CutWillTable.strName.."*0"..L("str8117").."*3"..(m_CutWillTable.nTimes-1);
					tipStr = tipStr.."_"..L("str9248").."*3"..math.floor(m_CutWillTable.nAddExp/10).."%*0,";
					tipStr = tipStr..L("str9249").."*3"..math.floor(m_CutWillTable.nAddMoney/10).."%";
					strAward = strAward.."_"..tipStr;
				end
				
				if m_CutWillTable.nTimes == 2 then
					m_CutWillTable.nTimes = 1
				elseif m_CutWillTable.nTimes == 1 then
					m_CutWillTable.nTimes = 0
				end
			end
            pTxtBox:setText(strAward);
        end
    end
end

function CopymapSweep.recCopyTimsShow(dt)
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("8001"));
    if wnd==nil then
        return;
    end
    
    if m_strAward==nil then
        return;
    end
    local nTurn = dt:readShort();
    
    local pDragNode2 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-2"), "SCDragNode")
    if not pDragNode2 then return end
        
    local plistBox = SCTypeCast:castNodeToListBox(pDragNode2:getChildByTag(6));
    if plistBox then
		local cutWillInfo = ItemProcessor:getSingleton():getCutWillInfo();
		if cutWillInfo ~= nil then
			if cutWillInfo.nTimes > 0 then
				getAwardString();
			end
		end
        m_textStr = L("str8162")..nTurn..L("str8163")..m_strAward;--getNewLinStr(L("str8162")..nTurn..L("str8163")..m_strAward, 20);
        local pNode = getItemTextNode(m_textStr);
        if pNode then
            plistBox:addItem(pNode);
        end
		plistBox:setOffset(CCPointMake(0, plistBox:getContentSize().height));
    end
    
    local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-3"), "SCDragNode")
    if not pDragNode3 then return end
    
    if getIntPart(m_turns)>0 then
        EditValueShowLabel(m_turns-1,true);
        
        if GameCopyController_getInstanceType() == 2 then
            if GameCopyController_getLeaveUseTimes() == 0 then
                m_bStart = false;
                local pStartBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(19));
                local pImgPath = getRealUIResourcePath("img/new00234.png")
                if pStartBtn and pImgPath then
                    pStartBtn:setTitle(pImgPath:getData()); 
                end
            end
        end
        if getIntPart(m_turns)==0 then
            m_bStart = false;
            local pStartBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(19));
            local pImgPath = getRealUIResourcePath("img/new00234.png")
            if pStartBtn and pImgPath then
                pStartBtn:setTitle(pImgPath:getData()); 
            end
        end
    end
end

----------------消息注册区----------------

----------------全局函数区----------------

function CopymapSweep_beginSweep()
    if m_turns == nil then
        return
   end
   
   local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-3"), "SCDragNode")
    if not pDragNode3 then return end
    
    local pStartBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(19));
    if pStartBtn==nil then
        return;
    end
   
    if getIntPart(m_turns)<=0 or (GameCopyController_getLeaveUseTimes()<= 0 and GameCopyController_getInstanceType() == 2) then
        if GameCopyController_getInstanceType() == 2 then
            showMessage(L("str8173"));
        else
            showMessage(L("str0515"));
        end
        return;
    end
    
    local times = nil;
    if GameCopyController_getInstanceType() == 2 then
        if GameCopyController_getLeaveUseTimes() >= getIntPart(m_turns) then
            times = getIntPart(m_turns)
        else
            times = GameCopyController_getLeaveUseTimes()
        end
    else
        times = getIntPart(m_turns)
    end

    m_bStart = true;
    
    local pImgPath = getRealUIResourcePath("img/new00479.png")
    if pImgPath then
        pStartBtn:setTitle(pImgPath:getData());
    end
    
    local pCountDownLabel = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(20));
    if pCountDownLabel then
        pCountDownLabel:setVisible(false);
    end
    
    local nAddWaitTime = GetSweepWaitTime();
    local pCountDownImg = SCTypeCast:castNodeToImage(pDragNode3:getChildByTag(18));
    if pCountDownImg then
        pCountDownImg:removeChildByTag(999,true);
        local pCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second,12)
        if pCountDownNode then
            pCountDownNode:setTime(nAddWaitTime);
            pCountDownNode:setTag(999);
            --pCountDownNode:setColor(getColorRed());
            pCountDownNode:setPosition(SX(5),SY(3));
            pCountDownImg:addChild(pCountDownNode);
            --pCountDownNode:luasetSelectorOnClose(CloseWnd);
        end
    end
    
    local pDragNode2 = tolua.cast(SCFunction:getUiNodeByIdlist("8001-2"), "SCDragNode")
    if not pDragNode2 then return end
    
    local plistBox = SCTypeCast:castNodeToListBox(pDragNode2:getChildByTag(6));
    if plistBox then
        plistBox:removeAllItems();
    end
    
    Hero:getSingleton():setSweepTeamplateID(m_idTemplate);
    Hero:getSingleton():setSweepLeaveTime(nAddWaitTime);
    MainInterface_AddCopySweepTime();
    
    if nAddWaitTime > 0 then
        m_bSweeping = true;
    end
end

function CopymapSweep_setIsSweeping(bSweeping)
    if m_bSweeping ~= nil then
        m_bSweeping = bSweeping;
    end
end

function CopymapSweep_getIsSweeping()
    return m_bSweeping;
end

function CopymapSweep_saveCutWillTable()
	if CLIENT_VERSION > 328 then 
		local cutWillInfo = ItemProcessor:getSingleton():getCutWillInfo();
		if cutWillInfo ~= nil then
			if cutWillInfo.nTimes > 0 then
				m_CutWillTable.nAddExp = cutWillInfo.nAddExp;
				m_CutWillTable.nAddMoney = cutWillInfo.nAddMoney;
				m_CutWillTable.nTimes = cutWillInfo.nTimes + 1;
				m_CutWillTable.strName = cutWillInfo:getName();
			end
		end
	end
end

function CopymapSweep_initCutWillTable()
	m_CutWillTable.nAddExp = 0;
	m_CutWillTable.nAddMoney = 0;
	m_CutWillTable.nTimes = 0;
	m_CutWillTable.strName = "";
end
CopymapSweep_initCutWillTable();

function CopymapSweep.sendOpenWnd(stInstance) 
    m_stInstance = stInstance;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE)
    dataStream:writeShort(ACTION_COPY_MONSTOR_NAME)
    dataStream:writeInt(stInstance.id)
    SCDataTransThread:getSingleton():transData(dataStream)
    SCActivityIndicator:getSingleton():show()
end

--函数调用