local USERINFO_SHOW_INFO        = 86 --//点击展示
local OTHERPLAYDATA_UPDATA_EUD  = 15 --//跟新列表信息

local DisplayMsg = {
    __mode = "kv",
    title = {},
    partner = {},
    achievement = {},
}
local nowID = nil
local nowMark = nil

local InfoShow = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idActor = dt:readInt();
        tmp.id = dt:readInt();
        tmp.idPhoto = dt:readInt();
        local scStr = dt:readString()
            if scStr == nil then
                tmp.szName = ""
            else
                tmp.szName = scStr:getData()
        end
        scStr = dt:readString()
            if scStr == nil then
                tmp.nLV = ""
            else
                tmp.nLV = scStr:getData()
        end
        return tmp;
    end
}

local Msg_tInfo18 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucType = dt:readByte();
        tmp.ucNumber = dt:readByte();
        tmp.stInfoShow = {};
        for i = 1, tmp.ucNumber do
            table.insert(tmp.stInfoShow, InfoShow.initWithStream(dt));
        end
        return tmp
    end
}

local function DisplayInterfaceWndClose()
end

local function creatWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7007));
    if wnd == nil then
        return nil 
    end
    wnd:luaSetSelectorOnClose(DisplayInterfaceWndClose);
    wnd:setFrameVisibled(false);
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeLine)
        dragNode:setFrameVisibled(true)
    end
    dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("4-1", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeListNormal)
        dragNode:setFrameVisibled(true)
    end
    return wndCtrl;
end

local function insertDisplay(tmp)    
    local edit = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("9000-21-7"));
    if edit then
        tmp = edit:getContentText() .. tmp;
        edit:setContentText(tmp);
    end
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        getCurentSceneWindow(tag):setAutoCloseOnTouchSpace(true);
        getCurentSceneWindow(tag):setCloseButtonVisibled(false);
    end
end

local function joinInTeam(tag, itemTag, itemIndex)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7007-4-1-3-"..itemTag), "SCDragNode");
    if node then
        node:setFrameType(EnumFrameTypeListSelect)
        node:setFrameVisibled(true)
        if nowMark == 2 then
            insertDisplay("k" .. itemTag);
        elseif nowMark == 3 then
            --insertDisplay("g" .. itemTag);
            local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
            dataStream:writeShort(USERINFO_SHOW_INFO);
            dataStream:writeByte(4);
            dataStream:writeInt(itemTag);
            if SCDataTransThread:getSingleton() then
                SCDataTransThread:getSingleton():transData(dataStream);
                SCActivityIndicator:getSingleton():show();
            end
            return;
        elseif nowMark == 1 then
            insertDisplay("m" .. itemTag);
        else
            insertDisplay("l" .. itemTag);
        end
        nowID = itemTag;
    end
    getCurentSceneNavigationController():removeWindowControllerByTag(7007);
end

function titleAnalytic()
    local luarecall = LuaReCall:getSingleton();
    if nil == luarecall then
        return;
    end 
    nowID = luarecall:getszText() + 0;     
    for i = 1, #DisplayMsg.title do
        for j = 1, #DisplayMsg.title[i].stInfoShow do
            if DisplayMsg.title[i].stInfoShow[j].id == nowID then
                local luarecall = LuaReCall:getSingleton();
                if luarecall then          
                    local str = nil;
                    local icon = 3;
                    str = "#(";
                    str = str .. icon    
                    str = str .. ",";
                    str = str .. 1032 * 1000 + 4;
                    str = str .. ",";
                    --str = str .. DisplayMsg.title[i].stInfoShow[j].idActor;
                    str = str .. ",";
                    str = str .. DisplayMsg.title[i].stInfoShow[j].id;
                    str = str .. ")";
                    str = str .. "*4";
                    str = str .. DisplayMsg.title[i].stInfoShow[j].szName;
                    luarecall:setText(str);
                end
                break;
            end
        end
    end
end

function achievementAnalytic()
    local luarecall = LuaReCall:getSingleton();
    if nil == luarecall then
        return;
    end 
    nowID = luarecall:getszText() + 0;     
    for i = 1, #DisplayMsg.achievement do
        for j = 1, #DisplayMsg.achievement[i].stInfoShow do
            if DisplayMsg.achievement[i].stInfoShow[j].id == nowID then
                local luarecall = LuaReCall:getSingleton();
                if luarecall then            
                    local str = nil;
                    local icon = 2;
                    str = "#(";
                    str = str .. icon    
                    str = str .. ",";
                    str = str .. 1032 * 1000 + 3;
                    str = str .. ",";
                    --str = str .. DisplayMsg.achievement[i].stInfoShow[j].idActor;
                    str = str .. ",";
                    str = str .. DisplayMsg.achievement[i].stInfoShow[j].id;
                    str = str .. ")";
                    str = str .. "*4";
                    str = str .. DisplayMsg.achievement[i].stInfoShow[j].szName;
                    luarecall:setText(str);
                end
                break;
            end
        end
    end
end

function partnerAnalytic()
    local luarecall = LuaReCall:getSingleton();
    if nil == luarecall then
        return;
    end 
    nowID = luarecall:getszText() + 0;    
    for i = 1, #DisplayMsg.partner do
        for j = 1, #DisplayMsg.partner[i].stInfoShow do
            if DisplayMsg.partner[i].stInfoShow[j].id == nowID then
                local luarecall = LuaReCall:getSingleton();
                if luarecall then            
                    local str = nil;
                    local icon = 1;
                    str = "#(";
                    str = str .. icon    
                    str = str .. ",";
                    str = str .. 1032 * 1000 + 2;
                    str = str .. ",";
                    str = str .. DisplayMsg.partner[i].stInfoShow[j].idActor;
                    str = str .. ",";
                    str = str .. DisplayMsg.partner[i].stInfoShow[j].id;
                    str = str .. ")";
                    str = str .. "*4";
                    str = str .. DisplayMsg.partner[i].stInfoShow[j].szName;
                    luarecall:setText(str);
                end
                break;
            end
        end
    end
end

local function unSelset(tag, itemTag, itemIndex)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7007-4-1-3-"..itemTag), "SCDragNode");   
    if node then
        node:setFrameType(EnumFrameTypeListNormal)
        node:setFrameVisibled(true)
    end
end

local function setDisplayData(tmp)
    local listbox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7007-4-1-3"));
    if listbox then     
        listbox:removeAllItems(); 
        listbox:luaSetSelectorOnItemSelected(joinInTeam)
        listbox:luaSetSelectorOnItemUnSelected(unSelset)
        for i = 1, #tmp do
            for j = 1, #tmp[i].stInfoShow do
                local dragnode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7007, 101));
                if dragnode then
                    dragnode:setFrameType(EnumFrameTypeListNormal);
                    dragnode:setFrameVisibled(true);
                    local img = SCTypeCast:castNodeToImage(dragnode:getChildByTag(1));
                    if 1 == nowMark then
                        local imgFace = getFaceImg(tmp[i].stInfoShow[j].idPhoto);
                        if img and imgFace then                        
                            imgFace:setAnchorPoint(CCPointMake(0.5, 0.5));
                            imgFace:setPosition(CCPointMake(img:getContentSize().width / 2, img:getContentSize().height / 2));
                            local size = img:getContentSize();
                            local faceSize = imgFace:getContentSize();
                            imgFace:setScaleX((size.width - SX(4)) / faceSize.width);
                            imgFace:setScaleY((size.height - SY(4)) / faceSize.height);
                            img:addChild(imgFace);
                        end
                    elseif 3 == nowMark or 4 == nowMark then
                        local imgPath = getRealUIResourcePath("img/" .. tmp[i].stInfoShow[j].idPhoto .. ".png");
                        if img and imgPath then
                            img:setImage(imgPath:getData());
                        end
                    elseif 2 == nowMark then
                        local imgPath = getRealUIResourcePath("Skill/" .. tmp[i].stInfoShow[j].idPhoto .. ".png");
                        if img and imgPath then
                            img:setImage(imgPath:getData());
                        end
                    end
                    local label = SCTypeCast:castNodeToLabel(dragnode:getChildByTag(2));
                    if label then
                        label:setText(tmp[i].stInfoShow[j].szName);
                    end
                    if tmp[1].ucType == 1 then
                        label = SCLabel:labelWithStringFont(tmp[i].stInfoShow[j].szName, DEFAULT_FONT_NAME, 15);
                    end
                    listbox:addItem(dragnode);
                    dragnode:setTag(tmp[i].stInfoShow[j].id);
                end
            end
        end   
    end
end

local function AcceptDisplayMsg(tmp)
    if tmp.ucType == 1 then
        table.insert(DisplayMsg.partner, tmp);
        nowMark = 1;
    elseif tmp.ucType == 2 then
        table.insert(DisplayMsg.title, tmp);
        nowMark = 2;
    elseif tmp.ucType == 3 then
        table.insert(DisplayMsg.achievement, tmp);
        nowMark = 3;
    else
        DisplayMsg.achievement = {};
        table.insert(DisplayMsg.achievement, tmp);
        nowMark = 4;
    end
end

function showDisplayWnd(tmp)
    AcceptDisplayMsg(tmp);
    local wndCtrl = creatWnd();    
    local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and wndCtrl then
            naviCtrl:pushWindowController(wndCtrl);
            wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);   
    
            local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7007-4-2"));
            if label then
                if tmp.ucType == 1 then
                    label:setText(_LTParser("str5096"));
                    setDisplayData(DisplayMsg.partner);
                elseif tmp.ucType == 2 then
                    label:setText(_LTParser("str0087"));
                    setDisplayData(DisplayMsg.title);
                else
                    label:setText(_LTParser("str0083"));
                    setDisplayData(DisplayMsg.achievement);
                end
            end
        end   
    return 
end

local function OpenDisplay(mark)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_SHOW_INFO);
    dataStream:writeByte(mark);
    dataStream:writeInt(0);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

function showDisplayPartnerWnd()    
    DisplayMsg.partner = {};
    OpenDisplay(1);
end

function showDisplayTitleWnd()      
    DisplayMsg.title = {};
    OpenDisplay(2);
end

function showDisplayAchievementWnd()   
    DisplayMsg.achievement = {};
    OpenDisplay(3);
end

local function recvShowBegin()
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        AcceptDisplayMsg(Msg_tInfo18.initWithStrea6m(dt));
    end
end

local function recvShowEnd()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        showDisplayWnd(Msg_tInfo18.initWithStream(dt));
    end
end

if LuaData:getSingleton() then
    LuaData:getSingleton():luaSetSelectorOnRecvData(recvShowBegin, LuaData_USERINFO_SHOW_INFO)
    LuaData:getSingleton():luaSetSelectorOnRecvData(recvShowEnd, LuaData_USERINFO_SHOW_END)
end