--定义一个与文件名相同的table
GuideTip = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------

----------------变量定义区----------------
local m_timeID = nil;
local m_Value = nil;
local m_Flag = nil;
--变量的定义
local function setBackColor()
    m_Value = m_Value - 10;
    if m_Value < 0 then
        m_Value = 0;
    end
    local pNode = SCFunction:getUiNodeByIdlist("4430-2")
    if pNode then
        pNode:setBackgroundColor(ccc4(0,0,0,m_Value));
    end
    if m_Value == 0 then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
        POP_TOP_CTRL()
    end
end

local function OnCheckBtn(tag)
    if tag == 6 then
        local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4430-2-3-6"))
        local verbatimNode = tolua.cast(SCFunction:getUiNodeByIdlist("4430-2-3-5-5000"), "VerbatimDisplay")
        if button and verbatimNode then
            button:setTag(16)
            verbatimNode:stopVerbatim()
        end
    elseif tag == 16 then
        m_timeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(setBackColor, 0.05, false)--8秒后自动关闭
        local pNode = SCFunction:getUiNodeByIdlist("4430-2")
        if pNode then
            pNode:removeAllChildrenWithCleanup(true);
        end
    end 
end

local function setBtnTag()
    local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4430-2-3-6"))
    if button then
        button:setTag(16)
    end
end
----------------UI控制器区----------------
function GuideTip.initControl()
	local pWindow1 = SCWindow:window()
	if pWindow1 then
		pWindow1:setTag(4430)
		pWindow1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow1:setPosition(AUTO_POS(0.00, 0.00))
        pWindow1:setContentSize(AUTO_SIZE(480, 320))
		pWindow1:luaSetSelectorOnClose(GuideTip.releaseControl)
	end

	local pDragNode2 = SCNode:node();
    if pDragNode2 then
        pDragNode2:setTag(2)
        pDragNode2:setBackgroundColor(ccc4(0,0,0,m_Value));
        pDragNode2:setAnchorPoint(ANCHOR_CENTER)
        pDragNode2:setPosition(CCPointMake(pWindow1:getContentSize().width/2, pWindow1:getContentSize().height/2))
		pDragNode2:setContentSize(SCREEN_SIZE)
    end

	local pDragNode3 = SCDragNode:node()
	if pDragNode3 then
		pDragNode3:setTag(3)
		pDragNode3:setAnchorPoint(CCPointMake(0.5, 0))
		pDragNode3:setPosition(CCPointMake(pDragNode2:getContentSize().width/2, SY(72)))
		pDragNode3:setContentSize(AUTO_SIZE(420, 132))
		pDragNode3:setFrameVisibled(true)
		pDragNode3:setDragEnabled(false)
		pDragNode3:setFrameType(EnumFrameTypeRound)
	end

	local imgPath = getRealUIResourcePath("img/new00587.png")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage4:setPosition(AUTO_POS(9.50, 9.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00696.png")
	local pImage5 = nil
	if imgPath then
		pImage5 = SCImage:imageWithFile(imgPath:getData())
		if pImage5 then
			pImage5:setTag(5)
			pImage5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage5:setPosition(AUTO_POS(175.00, 74.00))
		end
	end
	
	local str = nil;     --说明
	local str1 = nil;    --说明内容
	if m_Flag == 1 then         --强化
	    str = L("str0488");
        str1 = L("str0489");
	elseif m_Flag == 2 then     --镶嵌
	    str = L("str0490");
        str1 = L("str0491");
	elseif m_Flag == 3 then     --技能
        str = L("str0492");
        str1 = L("str0493");
    elseif m_Flag == 4 then     --武将
        str = L("str0494");
        str1 = L("str0495");
    else
        str = "";
        str1 = "";
    end 
	
	local pLabel = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(15))
    if pLabel then
        pLabel:setColor(color_orange);
        pLabel:setTag(10038)
        pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pLabel:setPosition(AUTO_POS(30.00, 73.00))
        pImage5:addChild(tolua.cast(pLabel, "SCNode"))
    end
	
	local verbatimNode = nil
	if pImage5 then
		verbatimNode = VerbatimDisplay:newVerbatimDisplay(AUTO_W(200), AUTO_H(60), getDefaultFontName(), getFontSize(10))
		tolua.cast(verbatimNode, "SCNode"):setTag(5000);
		verbatimNode:setVerbatimText(str1, true, 0.1)
		tolua.cast(verbatimNode, "SCNode"):setAnchorPoint(CCPointMake(0.5, 0));
		tolua.cast(verbatimNode, "SCNode"):setPosition(CCPointMake(pImage5:getContentSize().width / 2 + SX(13), SY(7)));
		verbatimNode:luaDialogueEnd(setBtnTag)
		pImage5:addChild(tolua.cast(verbatimNode, "SCNode"))
	end

	local pButton6 = SCButton:button(EnumBtnType9Atlas)
	if pButton6 then
		pButton6:setTag(6)
		pButton6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton6:setPosition(AUTO_POS(252.00, 24.50))
		pButton6:setContentSize(AUTO_SIZE(90, 30))
		local imgPath = getRealUIResourcePath("img/new00637.pn")
		if imgPath then
			pButton6:setTitle(imgPath:getData())
		end
		pButton6:luaSetSelectorOnClicked(OnCheckBtn)
		GuidePoint_createRightGuideNode(pButton6)
	end

	if pDragNode2 and pWindow1 then
		pWindow1:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pDragNode3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode3, "SCNode"))
	end
	if pImage4 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pImage4, "SCNode"))
	end
	if pImage5 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pImage5, "SCNode"))
	end
	if pButton6 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pButton6, "SCNode"))
	end
	return pWindow1
end
function GuideTip.releaseControl()
	if GuideTip.wndClose then
		GuideTip.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------

----------------消息处理区----------------

----------------消息注册区----------------

----------------全局函数区----------------
function GuideTip.Window(id)
	local wnd = nil;
	m_Value = 230;
	m_Flag = id;
	local wndCtrl = getCurentSceneWindowController(4430);
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
	else
		wnd = GuideTip.initControl()
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd)
			local naviCtrl = getCurentSceneNavigationController()
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl)
				wnd:setCloseButtonVisibled(false)
				wnd:setFrameVisibled(false);
			end
		 end
	end
end

function GuideTip.wndCloss()
    m_timeID = nil;
    m_Value = nil;
    m_Flag = nil;
end



--函数调用