--定义一个与文件名相同的table
Hunter1 = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------
local GOD_HUNTER_BEGIN = 1811010000
local GOD_HUNTER_END = 1861010010
local GOD_HUNTER_DRAGON = 1811010010 --青龙魂
local GOD_HUNTER_TIGER = 1812010010  --白虎魂
local GOD_HUNTER_BRID = 1813010010   --朱雀魂
local GOD_HUNTER_TURTLE = 1814010010 --玄武魂
----------------变量定义区----------------
--变量的定义
local m_tmpHunterId = nil
----------------UI控制器区----------------
function Hunter1.initControl()
	local pWindow6005 = SCWindow:window()
	if pWindow6005 then
		pWindow6005:setTag(6005)
		pWindow6005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow6005:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("img/new00481.png")
		if pImgPath then
			pWindow6005:setTitleWithImage(pImgPath:getData())
		end
		pWindow6005:setContentSize(AUTO_SIZE(480, 320))
		pWindow6005:luaSetSelectorOnClose(Hunter1.releaseControl)
	end

	Hunter1.m_pMultipage1 = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	if Hunter1.m_pMultipage1 then
		Hunter1.m_pMultipage1:setTag(1)
		Hunter1.m_pMultipage1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Hunter1.m_pMultipage1:setPosition(AUTO_POS(0.00, 0.00))
		Hunter1.m_pMultipage1:setContentSize(AUTO_SIZE(480, 320))
		local pageImg = {"new00238.png", "new00242.png"}
		for i = 1, 2 do
			local pNode = SCNode:node()
			if pNode then
				pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pNode:setContentSize(Hunter1.m_pMultipage1:getContentSize())			   
				pNode:setPosition(ANCHOR_LEFT_BOTTOM)
				Hunter1.m_pMultipage1:addPage(pNode)
				local imgPath = getRealUIResourcePath("img/" .. pageImg[i])				   
				if imgPath then
					Hunter1.m_pMultipage1:setTitleAtPage(imgPath:getData(), i - 1)
				end
			end
		end
	end

	Hunter1.pLabel2 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(12))
	if Hunter1.pLabel2 then
		Hunter1.pLabel2:setTag(2)
		Hunter1.pLabel2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Hunter1.pLabel2:setPosition(AUTO_POS(372.72, 264.89))
		Hunter1.pLabel2:setColor(ccc4(255,255,255,255))
	end

	local imgPath = getRealUIResourcePath("img/2001004.png")
	Hunter1.m_pImgIcon = nil
	if imgPath then
		Hunter1.m_pImgIcon = SCImage:imageWithFile(imgPath:getData())
		if Hunter1.m_pImgIcon then
			Hunter1.m_pImgIcon:setTag(3)
			Hunter1.m_pImgIcon:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			Hunter1.m_pImgIcon:setPosition(AUTO_POS(340.50, 261.00))
			Hunter1.m_pImgIcon:setScale(0.5);
		end
	end

	if Hunter1.m_pMultipage1 and pWindow6005 then
		pWindow6005:addChild(Hunter1.m_pMultipage1)
	end
	if Hunter1.pLabel2 and pWindow6005 then
		pWindow6005:addChild(Hunter1.pLabel2)
	end
	if Hunter1.m_pImgIcon and pWindow6005 then
		pWindow6005:addChild(Hunter1.m_pImgIcon)
	end
	return pWindow6005
end
function Hunter1.releaseControl()
	Hunter1.m_pMultipage1 = nil
	Hunter1.pLabel2 = nil
	Hunter1.m_pImgIcon = nil
	if Hunter1.wndCloss then
		Hunter1.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------
--点击查看物品
local function luaShowHunterTip()
	
end
local function sendGodHunterMsg()
	
end
local function onImageBtnClick(tag)
	if GOD_HUNTER_BEGIN < tag and GOD_HUNTER_END > tag then
		 local item = ItemProcessor:getSingleton():getItemByTypeID(tag);
		if item then
			local strTip = nil
			if GOD_HUNTER_DRAGON == tag then
				strTip = "_*5"..L("str3306").."_*5"..L("str3307")
			elseif GOD_HUNTER_TIGER == tag then
				strTip = "_*5"..L("str3308").."_*5"..L("str3309")
			elseif GOD_HUNTER_BRID == tag then
				strTip = "_*5"..L("str3310").."_*5"..L("str3311")
			elseif GOD_HUNTER_TURTLE == tag then
				strTip = "_*5"..L("str3312").."_*5"..L("str3313")
			end
			local strTitle = "*5"..item:getName()
			local file = getRealUIResourcePath("item/"..item:getIconID()..".jpg")
			luaShowTipHaveIcon(strTip,strTitle,file,nil,nil,nil,0.7)
		end
	else
		showTip(tag);
	end
end

local function onImageBtnClickBagItem(tag)
    local item = ItemProcessor:getSingleton():getItem(tag);
    if item:getIdType() > GOD_HUNTER_BEGIN and item:getIdType() < GOD_HUNTER_END then
		Hunter_sendGodHuntMsg(tag,0)
		return
    end
    if item then
        showTipExe(item,"",0);
    end
end

--上一页
local function onScrollToPreviousPage(tag)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    if pMultiPage1 == nil then
        return;
    end
    
    local pageIndex = pMultiPage1:selectedPageIndex();
    local nodePage = pMultiPage1:getPageWithIndex(pageIndex)
    if not nodePage then return end 
    
    local pLabel25 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-23-25"), nodePage), "SCLabel")
	if pLabel25 then
		pLabel25:setText("1/2");
	end	
end

--下一页
local function onScrollToNextPage(tag)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    if pMultiPage1 == nil then
        return;
    end
    
    local pageIndex = pMultiPage1:selectedPageIndex();
    local nodePage = pMultiPage1:getPageWithIndex(pageIndex)
    if not nodePage then return end 
    local pDragNode = SCTypeCast:castNodeToDragNode(nodePage:getChildByTag(1));
    if pDragNode == nil then
        return
    end
    
    local pDragNode20 = nil
    if 1==pageIndex then
        pDragNode20 = pDragNode:getChildByTag(10020)
    else
        pDragNode20 = pDragNode:getChildByTag(20)
    end
    if pDragNode20 == nil then
        return
    end
    
    local tableBox = SCTypeCast:castNodeToTableBox(pDragNode20:getChildByTag(1))
    if tableBox == nil then
        return
    end
    
    local index = tableBox:getPageIndex();
    local count = tableBox:getPageCount();
    local pLabel25 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-23-25"), nodePage), "SCLabel")
	if pLabel25 then
		pLabel25:setText((index+1).."/"..count);
	end
end

--点击兑换
local function onBuyBtnClick(tag)
	local dataStream = SCDataTransStream:streamWithCommand(1601);
	if dataStream then
		dataStream:writeShort(3)
		dataStream:writeByte(0)
		dataStream:writeInt(405)
		dataStream:writeInt(tag)
		dataStream:writeInt(1)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end
end

--点击分解
local function onTwoClickDropBtn(tag)
    if 0 == tag then
        return
    end 
    if m_tmpHunterId then
        Hunter_sendHuntSplit(m_tmpHunterId)
    end
end
local function onDropBtnClick(tag)	
    m_tmpHunterId = tag
    local item = ItemProcessor:getSingleton():getItem(tag);
    if item then
        local info = item:getData();
        local str = item:getName().._LTParser("str3247")..info.dwData2
	    luashowConfirmationWindow(string.format(_LTParser("str3246"),str), WIN_YES_NO, onTwoClickDropBtn)
	end
end

--创建单页数
local function creatTabel(tabelBox, type)
	local tabel = SCTable:table();
	if tabel == nil then
		return;
	end
	
	tabel:setNumberOfRows(2);
	tabel:setNumberOfColumns(6);
	tabelBox:addTable(tabel);
	
	for i=0, 6 do
		tabel:setWidthForColumn(AUTO_W(70), i);
	end
	
	for i=0, 2 do
		tabel:setHeightForRow(AUTO_W(100), i);
	end
	
	tabel:reflashData();
	
	for i=0, 2 do
		for j=0, 6 do
			local tableCell = tabel:cellForRowAndColumn(i, j);
			if tableCell then
				local dragNode = Hunter4.initControl();
				if dragNode then
					dragNode:setTag(1);
					dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
					dragNode:setPosition(CCPointMake(tableCell:getContentSize().width/2, tableCell:getContentSize().height/2));
					tableCell:addChild(dragNode);
					
					local button = SCTypeCast:castNodeToButton(dragNode:getChildByTag(3));
					if button then
						button:luaSetSelectorOnClicked(onBuyBtnClick);
						button:setTouchEnabled(false);
						
						if type == 1 then
						    local imagePath = getRealUIResourcePath("img/new00240.png");
							if imagePath then
								button:setTitle(imagePath:getData());
							end
						end
					end
				end
			end
		end
	end
end

--//左右按钮切换
function onClickUpPage(tag)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    local pNode = pMultiPage1:getPageWithIndex(1);
    if pNode == nil then
        return
    end
    
    local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
    if pDragNode == nil then
        return
    end
    
    local pDragNode20 = pDragNode:getChildByTag(10020)
    if pDragNode20 == nil then
        return
    end
    
    local tableBox = SCTypeCast:castNodeToTableBox(pDragNode20:getChildByTag(1))
    if tableBox == nil then
        return
    end
    
    local index = tableBox:getPageIndex();
    if index < 1 then
        return;
    end
    
    tableBox:setOffset(CCPointMake((index - 1) * tableBox:getWidth(), 0));
    local label25 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("23-25", pDragNode));
    if label25 then
        label25:setText((index+1).."/"..tableBox:getPageCount());
    end
end

function onClickDownPage(tag)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    local pNode = pMultiPage1:getPageWithIndex(1);
    if pNode == nil then
        return
    end
    
    local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
    if pDragNode == nil then
        return
    end
        
    local pDragNode20 = pDragNode:getChildByTag(10020)
    if pDragNode20 == nil then
        return
    end
    
    local tableBox = SCTypeCast:castNodeToTableBox(pDragNode20:getChildByTag(1))
    if tableBox == nil then
        return
    end
    
    local index = tableBox:getPageIndex();
    local count = tableBox:getPageCount();
    if index > count - 2 then
        return;
    end
    tableBox:setOffset(CCPointMake((index + 1) * tableBox:getWidth(), 0));
    local label25 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("23-25", pDragNode));
    if label25 then
        label25:setText((index+1).."/"..count);
    end
end


--添加可分解命格
function Hunter1_refreshCanResolveHunterToShop()
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    if pMultiPage1 == nil then
        return
    end
    
    local pNode = pMultiPage1:getPageWithIndex(1);
    if pNode == nil then
        return
    end
    
    local tableNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
    if tableNode == nil then
        return
    end
	
	local pDragNode20 = tableNode:getChildByTag(10020)
	if pDragNode20 == nil then
	    return
	end
	
	--Hunter1_refreshMoney();
	
	pDragNode20:removeAllChildrenWithCleanup(true);
	local width = AUTO_W(420);
	local height = AUTO_H(200);
	local tableBox = SCTypeCast:castNodeToTableBox(pDragNode20:getChildByTag(1))
	if tableBox == nil then
        tableBox = SCTableBox:boxWithWidthHeight(width, height);
        if tableBox == nil then
            return;
        end
        
        tableBox:setAnchorPoint(CCPointMake(0.5, 0.5));
        tableBox:setPosition(CCPointMake(width/2 + SX(15), height/2 + SY(10)));
        tableBox:luaSetSelectorOnScrollToPrevious(onScrollToPreviousPage);
        tableBox:luaSetSelectorOnScrollToNext(onScrollToNextPage);
        tableBox:setTag(1);
        pDragNode20:addChild(tableBox);
    end
    tableBox:removeChildByTag(1988, true);
    tableBox:removeAllTables();
	
	local btn10007 = SCTypeCast:castNodeToButton(tableNode:getChildByTag(10007));
	if btn10007 then
	    btn10007:luaSetSelectorOnClicked(onClickUpPage);
	end
	
    local btn10008 = SCTypeCast:castNodeToButton(tableNode:getChildByTag(10008));
    if btn10008 then
        btn10008:luaSetSelectorOnClicked(onClickDownPage);
    end
	
	local tmpIndex = 0;
	local pTable = nil;
    local itemSize = ItemProcessor:getSingleton():ItemSize()
	for i=1, itemSize do
		local item = ItemProcessor:getSingleton():getItemInfo(i-1)
		if item then
		    local idItem = item:getID()
		    local idType = item:getIdType();
		    local postiton = item:getPostion();
		    local tmp = math.mod(idType, 10);
            if (1800000000<=idType and idType<=1899999999) and (tmp == 8 or tmp == 9 or tmp == 0) and postiton == 0 then
                if tmpIndex == 0 then
                    pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
                    if pTable == nil then
                        pTable = SCTable:table();
                        if pTable == nil then
                            return;
                        end
                        
                        pTable:setNumberOfRows(2);
                        pTable:setNumberOfColumns(6);
                        tableBox:addTable(pTable);
                        
                        for i=0, 6 do
                            pTable:setWidthForColumn(AUTO_W(70), i);
                        end
                        
                        for i=0, 2 do
                            pTable:setHeightForRow(AUTO_W(100), i);
                        end
                        
                        pTable:reflashData();
                        local label25 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("23-25", tableNode));
                        if label25 then
                            label25:setText("1/1");
                        end   
                    end
                elseif tmpIndex == 12 then
                    tmpIndex = 0;
                    pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("1", tableBox));
                    if pTable == nil then
                        pTable = SCTable:table();
                        if pTable == nil then
                            return;
                        end
                        
                        pTable:setNumberOfRows(2);
                        pTable:setNumberOfColumns(6);
                        tableBox:addTable(pTable);
                        
                        for i=0, 6 do
                            pTable:setWidthForColumn(AUTO_W(70), i);
                        end
                        
                        for i=0, 2 do
                            pTable:setHeightForRow(AUTO_W(100), i);
                        end
                        
                        pTable:reflashData();
                        local label25 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("23-25", tableNode));
                        if label25 then
                            label25:setText("1/2");
                        end               
                    end
                end
                
                local tableCell = pTable:cellForRowAndColumn(math.modf(tmpIndex/6), tmpIndex%6)
                if tableCell then
                    local itemInfo = TableParser:getSingleton():getItemInfoByKey(idType);
                    if itemInfo.id ~= 0 and item:getPostion() == 0 then
                        local childNode = tableCell:getChildByTag(1);
                        if childNode == nil then
                            childNode = Hunter4.initControl();
                            if childNode then
                                childNode:setTag(1);
                                childNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                childNode:setPosition(CCPointMake(tableCell:getContentSize().width/2, tableCell:getContentSize().height/2));
                                tableCell:addChild(childNode);
                                
                                local button = SCTypeCast:castNodeToButton(childNode:getChildByTag(3));
                                if button then
                                    button:luaSetSelectorOnClicked(onBuyBtnClick);
                                    button:setTouchEnabled(false);
                                    
                                    local imagePath = getRealUIResourcePath("img/new00240.png");
                                    if imagePath then
                                        button:setTitle(imagePath:getData());
                                    end
                                end
                            end  
                        end
                        
                        if childNode then
                            local costLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-5", childNode));
                            if costLabel then
                                if tmp == 9 then
                                    costLabel:setText("8");
								elseif 0 == tmp then
									costLabel:setText("16");
                                else
                                    costLabel:setText(""..(tmp-7));
                                end
                            end
                            
                            local imgPath = getRealUIResourcePath("img/new00244.png");
                            local button = SCTypeCast:castNodeToButton(childNode:getChildByTag(3));
                            if button and imgPath then
                                button:setTag(idItem);
                                button:luaSetSelectorOnClicked(onDropBtnClick);
                                button:setBackgroundImage(imgPath:getData());
                                button:setTouchEnabled(true);
                            end					
                            local itemName = item:getName()
                            local pLabel6  = SCTypeCast:castNodeToLabel(childNode:getChildByTag(6));
                            if pLabel6 and itemName then
                                pLabel6:setText(itemName)
                                local idType = item:getIdType()
                                if 4 == idType%10 then
                                    
                                elseif 5 == idType%10 then
                                    pLabel6:setColor(color_green)
                                elseif 6 == idType%10 then
                                    pLabel6:setColor(color_skyBlue)
                                elseif 7 == idType%10 then
                                    pLabel6:setColor(color_purple)
                                elseif 8 == idType%10 then
                                    pLabel6:setColor(color_yellow)
                                elseif 9 == idType%10 then
                                    pLabel6:setColor(color_orange)
								elseif 0 == idType%10 then
                                    pLabel6:setColor(color_orange)
                                end
                            end
                            local imgPath = getRealUIResourcePath("item/"..itemInfo.icon..".jpg");
                            if imgPath == nil then
                                imgPath = getRealUIResourcePath("img/ItemTemp.png");
                            end
                            local bgImage = SCTypeCast:castNodeToImage(childNode:getChildByTag(1));
                            if imgPath and bgImage then
                                local img = SCImage:imageWithFile(imgPath:getData());
                                if img then
                                    img:setAnchorPoint(ANCHOR_CENTER)
                                    img:setPosition(CCPointMake(bgImage:getContentSize().width/2, bgImage:getContentSize().height/2));
                                    bgImage:addChild(img);
                                    
                                    local eventBtn = SCButton:button();
                                    if eventBtn then
                                        eventBtn:setContentSize(img:getContentSize());
                                        eventBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        eventBtn:setPosition(CCPointMake(img:getContentSize().width/2, img:getContentSize().height/2));
                                        eventBtn:setTag(idItem);
                                        eventBtn:luaSetSelectorOnClicked(onImageBtnClickBagItem);
                                        img:addChild(eventBtn);
                                    end
                                end
                            end
                        end
                    end					
                end
                
                tmpIndex = tmpIndex + 1;
            end
        end
	end
	
	if tmpIndex == 0 then
	    local label = SCLabel:labelWithStringFont(L("str9223"), getDefaultFontName(), getFontSize(16));
	    if label then
	        label:setTag(1988);
	        label:setAnchorPoint(CCPointMake(0.5, 0.5));
	        label:setPosition(CCPointMake(tableBox:getContentSize().width/2, tableBox:getContentSize().height/2));
	        tableBox:addChild(label);
	    end
	end
end

--//左右按钮切换
function onClickUpPageOne(tag)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    if not pMultiPage1 then return end 
    
    local pNode = pMultiPage1:getPageWithIndex(0);
    if pNode == nil then
        return
    end
    
    local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
    if pDragNode == nil then
        return
    end
        
    local pDragNode20 = pDragNode:getChildByTag(20)
    if pDragNode20 == nil then
        return
    end
    
    local tableBox = SCTypeCast:castNodeToTableBox(pDragNode20:getChildByTag(1))
    if tableBox == nil then
        return
    end
    
    local index = tableBox:getPageIndex();
    if index < 1 then
        return;
    end
    tableBox:setOffset(CCPointMake((index - 1) * tableBox:getWidth(), 0));
    local label25 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("23-25", pDragNode));
    if label25 then
        label25:setText("1/2");
    end
end

local addPageItemToShop
function onClickDownPageTwo(tag)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    if not pMultiPage1 then return end 
    
    local pNode = pMultiPage1:getPageWithIndex(0);
    if pNode == nil then
        return
    end
    
    local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
    if pDragNode == nil then
        return
    end
        
    local pDragNode20 = pDragNode:getChildByTag(20)
    if pDragNode20 == nil then
        return
    end
    
    local tableBox = SCTypeCast:castNodeToTableBox(pDragNode20:getChildByTag(1))
    if tableBox == nil then
        return
    end
    
    local tabel = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("1", tableBox));
    if tabel == nil then
        addPageItemToShop(pDragNode, tableBox, 1);
    end
    
    local index = tableBox:getPageIndex();
    local count = tableBox:getPageCount();
    if index > count - 2 then
        return;
    end
    tableBox:setOffset(CCPointMake((index + 1) * tableBox:getWidth(), 0));
    local label25 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("23-25", pDragNode));
    if label25 then
        label25:setText("2/2");
    end
end

--添加可分解武魂
local function addCanResolveHunter()
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    if not pMultiPage1 then return end
    
    local pNode = pMultiPage1:getPageWithIndex(1);
    if pNode then
        local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
        if nil == pDragNode then
            pDragNode = Hunter5.initControl();
            if pDragNode then
                pDragNode:setTag(1);
                pNode:addChild(pDragNode);
                local label25 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("23-25", pDragNode));
                if label25 then
                    label25:setText("1/1");
                end
               
                local testBox22 = SCTypeCast:castNodeToTextBox(pDragNode:getChildByTag(10022));
                if testBox22 then
                    TextParser:getSingleton():setText(testBox22, L("str9152"));
                end
                Hunter1_refreshCanResolveHunterToShop()
            end
        end
    end
end

function addPageItemToShop(tableNode, tableBox, pageIndex)
    local pTable = nil
    local beginIndex = pageIndex * 12 + 1;
    local tmpIndex = beginIndex - 1;
	for i=beginIndex, beginIndex + 42 do
	    --if i > 20 then
	        --return
	    --end
		local goodsInfo = TableParser:getSingleton():getSpecialGoods(i);
		if goodsInfo.type == 405 then
            if tmpIndex == 0 then
                pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
                if pTable == nil then
                    pTable = SCTable:table();
                    if pTable == nil then
                        return;
                    end
                    
                    pTable:setNumberOfRows(2);
                    pTable:setNumberOfColumns(6);
                    tableBox:addTable(pTable);
                    
                    for i=0, 6 do
                        pTable:setWidthForColumn(AUTO_W(70), i);
                    end
                    
                    for i=0, 2 do
                        pTable:setHeightForRow(AUTO_W(100), i);
                    end
                    
                    pTable:reflashData();
                end
            elseif tmpIndex == 12 then
                tmpIndex = 0;
                pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("1", tableBox));
                if pTable == nil then
                    pTable = SCTable:table();
                    if pTable == nil then
                        return;
                    end
                    
                    pTable:setNumberOfRows(2);
                    pTable:setNumberOfColumns(6);
                    tableBox:addTable(pTable);
                    
                    for i=0, 6 do
                        pTable:setWidthForColumn(AUTO_W(70), i);
                    end
                    
                    for i=0, 2 do
                        pTable:setHeightForRow(AUTO_W(100), i);
                    end
                    
                    pTable:reflashData();              
                end
            end            
			
			local tableCell = pTable:cellForRowAndColumn(math.modf(tmpIndex/6), tmpIndex%6); 
			if tableCell then
				local childNode =  tableCell:getChildByTag(1);
				if childNode == nil then
                    childNode = Hunter4.initControl();
                    if childNode then
                        childNode:setTag(1);
                        childNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        childNode:setPosition(CCPointMake(tableCell:getContentSize().width/2, tableCell:getContentSize().height/2));
                        tableCell:addChild(childNode);
                        
                        local button = SCTypeCast:castNodeToButton(childNode:getChildByTag(3));
                        if button then
                            button:luaSetSelectorOnClicked(onBuyBtnClick);
                            button:setTouchEnabled(false);
                        end
                    end  
                end
                
				if childNode then
					local costLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-5", childNode));
					if costLabel then
						costLabel:setText(goodsInfo.cost);
					end
					
					local imgPath = getRealUIResourcePath("img/new00244.png");
					local button = SCTypeCast:castNodeToButton(childNode:getChildByTag(3));
					if button and imgPath then
					    button:setTag(goodsInfo.itemtype_id);
						button:setBackgroundImage(imgPath:getData());
						button:setTouchEnabled(true);
					end
					
					local itemInfo = TableParser:getSingleton():getItemInfoByKey(goodsInfo.itemtype_id);
					if itemInfo.id ~= 0 then
					    local itemName = itemInfo.name
                        local pLabel6  = SCTypeCast:castNodeToLabel(childNode:getChildByTag(6));
                        if pLabel6 and itemName then
                            pLabel6:setText(itemName:getData())
                            local idType = itemInfo.id
                            if 4 == idType%10 then
                                
                            elseif 5 == idType%10 then
                                pLabel6:setColor(color_green)
                            elseif 6 == idType%10 then
                                pLabel6:setColor(color_skyBlue)
                            elseif 7 == idType%10 then
                                pLabel6:setColor(color_purple)
                            elseif 8 == idType%10 then
                                pLabel6:setColor(color_yellow)
                            elseif 9 == idType%10 then
                                pLabel6:setColor(color_orange)
							elseif 0 == idType%10 then
                                pLabel6:setColor(color_orange)
                            end
                        end
						local bgImage = SCTypeCast:castNodeToImage(childNode:getChildByTag(1));
						if bgImage then
							local imgPath = getRealUIResourcePath("item/"..itemInfo.icon..".jpg");
							if imgPath == nil then
                                imgPath = getRealUIResourcePath("img/ItemTemp.png");
                            end
							if imgPath then
								local img = SCImage:imageWithFile(imgPath:getData());
								if img then
									img:setAnchorPoint(ANCHOR_CENTER)
									img:setPosition(CCPointMake(bgImage:getContentSize().width/2, bgImage:getContentSize().height/2));
									bgImage:addChild(img);
									
                                    local eventBtn = SCButton:button();
                                    if eventBtn then
                                        eventBtn:setContentSize(img:getContentSize());
                                        eventBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        eventBtn:setPosition(CCPointMake(img:getContentSize().width/2, img:getContentSize().height/2));
                                        eventBtn:setTag(itemInfo.id);
                                        eventBtn:luaSetSelectorOnClicked(onImageBtnClick);
                                        img:addChild(eventBtn);
                                    end
								end
							end
						end
					end
				end
			end
			
			tmpIndex = tmpIndex + 1;
		end
	end
end

--添加出售物品
local function addSellItemToShop(tableNode)
	if tableNode == nil then
	    return
	end
	
	local pDragNode20 = tableNode:getChildByTag(20)
	if pDragNode20 == nil then
	    return
	end
	
	pDragNode20:removeAllChildrenWithCleanup(true);
	local width = AUTO_W(420);
	local height = AUTO_H(200);
	local tableBox = SCTypeCast:castNodeToTableBox(pDragNode20:getChildByTag(1))
	if tableBox == nil then
        tableBox = SCTableBox:boxWithWidthHeight(width, height);
        if tableBox == nil then
            return;
        end
        
        tableBox:setAnchorPoint(CCPointMake(0.5, 0.5));
        tableBox:setPosition(CCPointMake(width/2 + SX(15), height/2 + SY(10)));
        tableBox:luaSetSelectorOnScrollToPrevious(onScrollToPreviousPage);
        tableBox:luaSetSelectorOnScrollToNext(onScrollToNextPage);
        tableBox:setTag(1);
        pDragNode20:addChild(tableBox);
    end
    tableBox:removeChildByTag(1988, true);
    tableBox:removeAllTables();
	
	local btn10007 = SCTypeCast:castNodeToButton(tableNode:getChildByTag(10007));
	if btn10007 then
	    btn10007:luaSetSelectorOnClicked(onClickUpPageOne);
	end
	
    local btn10008 = SCTypeCast:castNodeToButton(tableNode:getChildByTag(10008));
    if btn10008 then
        btn10008:luaSetSelectorOnClicked(onClickDownPageTwo);
    end
    
    local label25 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("23-25", tableNode));
    if label25 then
        label25:setText("1/2");
    end   
	
    addPageItemToShop(tableNode, tableBox, 0);
end

--添加可销售武魂
local function addShopHunter()
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    if not pMultiPage1 then return end 
    
    local pNode = pMultiPage1:getPageWithIndex(0);
    if pNode then
        local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
        if nil == pDragNode then
            pDragNode = Hunter3.initControl();
            if pDragNode then
                pDragNode:setTag(1);
                pNode:addChild(pDragNode);
                
                local testBox22 = SCTypeCast:castNodeToTextBox(pDragNode:getChildByTag(10022));
                if testBox22 then
                    TextParser:getSingleton():setText(testBox22, L("str9152"));
                end
                addSellItemToShop(pDragNode)
            end
        end
    end
end

local function onClickedMultipage(tag, pageIndex)
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
    if pMultiPage1 == nil then
        return;
    end

    if 0 == pageIndex then
        local pNode = pMultiPage1:getPageWithIndex(0);
        if pNode then
            local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
            if pDragNode == nil then
                addShopHunter();
            end
        end
    elseif 1 == pageIndex then
        local pNode = pMultiPage1:getPageWithIndex(1);
        if pNode then
            local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
            if pDragNode == nil then
                addCanResolveHunter();
            end
        end
    end
end

local function HunterShopWndEvent(tag, event)
	if tag ~= 6005 then
		return
	end
	if event == LuaControllerEventPushEnded then
        local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
        if pMultiPage1 then
            pMultiPage1:luaSetSelectorOnPageSelected(onClickedMultipage);
            if m_bCanResolve == true then
                pMultiPage1:selectPageWithIndex(1);
            else
                pMultiPage1:selectPageWithIndex(0);
            end
        end
        Hunter1_refreshMoney();
    end
	m_bCanResolve = nil
end
----------------消息处理区----------------

----------------消息注册区----------------

----------------全局函数区----------------
function Hunter1_showHunterShopWnd(isCanResolve)
	local wndCtrl = getCurentSceneWindowController(6005);
	if wndCtrl then
		return;
	end
	
	local wnd = Hunter1.initControl();
	if wnd then
		wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl);
            
            local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-1"), "SCMultiPage")
            local pImage3 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-3"), "SCImage")
            if pMultiPage1 and pImage3 then
                pImage3:setScale(0.5);
                pMultiPage1:luaSetSelectorOnPageSelected(onClickedMultipage);
            end
            if isCanResolve == true then
                addCanResolveHunter();
            else
                addShopHunter();
            end
			Hunter1_refreshMoney();
			if pMultiPage1 and isCanResolve == true then
			    pMultiPage1:selectPageWithIndex(1)
			end
        end
	end	
end

function Hunter1_refreshMoney()
    local pLabel2 = tolua.cast(SCFunction:getUiNodeByIdlist("6005-2"), "SCLabel")
    if pLabel2 == nil then
        return
    end
    
    local heroInfo = Hero:getSingleton():getHeroInfo();
    if heroInfo then
        pLabel2:setText(heroInfo.dwCurrency6);
    end
end

function Hunter1.wndCloss()
    m_tmpHunterId = nil
    Hunter_refreshHunterWnd()
end
--函数调用