--定义一个与文件名相同的table
Hunter = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------
local ACTION_HUNT_SHOW 		= 0 -- //猎魂师头像刷新 stoc 
local ACTION_HUNT_NORMAL	= 1	-- //猎魂 
local ACTION_HUNT_FAST		= 2 -- //一键猎魂 
local ACTION_HUNT_EATFAST	= 3 -- //一键合成 
local ACTION_HUNT_GETFAST	= 4	-- //一键提取 
local ACTION_HUNT_GETSHOW	= 5	-- //提取表现 stoc 
local ACTION_HUNT_SPLIT		= 6	-- //武魂分解 

local ITEMACT_EQUIP			= 5 --通知装备物品(带上装备)
local ITEMACT_UNEQUIP		= 6 --position(卸载下装备)
local ACTION_HUNT_ISFIRST   = 8   --第一次觉醒标记
local ITEMACT_MOVE			= 28 --// c/s, 移动物品的位置
local ACTION_HUNT_LIMIT_FAST = 9	--极速猎命
local ACTION_HUNT_BATCH_SWALLOW = 10	--批量吞噬
local ACTION_HUNT_GOD_HUNT_ACTIVE = 11  --查看神武魂

local GOD_HUNTER_DRAGON = 1811010010 --青龙魂
local GOD_HUNTER_TIGER = 1812010010  --白虎魂
local GOD_HUNTER_BRID = 1813010010   --朱雀魂
local GOD_HUNTER_TURTLE = 1814010010 --玄武魂
local GOD_HUNTER_BEGIN = 1811010000
local GOD_HUNTER_END = 1861010010
----------------变量定义区----------------
local m_dwEffect = nil; --按位表示显示的猎魂师头像
local m_curIdItem = nil;
local m_curPlayIndex = nil;
local m_hunterflag = 0;
local m_godHunterTipOpenType = nil
local m_godHunterId = nil
--变量的定义
----------------UI控制器区----------------
function Hunter.initControl()
	local pWindow6004 = SCWindow:window()
	if pWindow6004 then
		pWindow6004:setTag(6004)
		pWindow6004:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow6004:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("img/new00481.png")
		if pImgPath then
			pWindow6004:setTitleWithImage(pImgPath:getData())
		end
		pWindow6004:setContentSize(AUTO_SIZE(484, 324))
		pWindow6004:luaSetSelectorOnClose(Hunter.releaseControl)
	end

	local imgPath = getRealUIResourcePath("img/new00246.jpg")
	Hunter.m_pImage6 = nil
	if imgPath then
		Hunter.m_pImage6 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage6 then
		    Hunter.m_pImage6:setScaleX(SY(480) / Hunter.m_pImage6:getContentSize().width)
			Hunter.m_pImage6:setTag(6)
			Hunter.m_pImage6:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage6:setPosition(AUTO_POS(242.00, 162.00))
		end
	end

	Hunter.m_pDragNode1 = SCDragNode:node()
	if Hunter.m_pDragNode1 then
		Hunter.m_pDragNode1:setTag(1)
		Hunter.m_pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Hunter.m_pDragNode1:setPosition(AUTO_POS(249.00, 40.00))
		Hunter.m_pDragNode1:setContentSize(AUTO_SIZE(220, 255))
		Hunter.m_pDragNode1:setFrameVisibled(true)
		Hunter.m_pDragNode1:setDragEnabled(false)
		Hunter.m_pDragNode1:setFrameType(EnumFrameTypeLine)
	end

	Hunter.m_pButton3 = SCButton:button(EnumBtnType9Atlas)
	if Hunter.m_pButton3 then
		Hunter.m_pButton3:setTag(3)
		Hunter.m_pButton3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Hunter.m_pButton3:setPosition(AUTO_POS(40.00, 10.00))
		Hunter.m_pButton3:setContentSize(AUTO_SIZE(100, 30))
		local imgPath = getRealUIResourcePath("img/new00256.png")
		if imgPath then
			Hunter.m_pButton3:setTitle(imgPath:getData())
		end
	end

	Hunter.m_pButton4 = SCButton:button(EnumBtnType9Atlas)
	if Hunter.m_pButton4 then
		Hunter.m_pButton4:setTag(4)
		Hunter.m_pButton4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Hunter.m_pButton4:setPosition(AUTO_POS(195.00, 10.00))
		Hunter.m_pButton4:setContentSize(AUTO_SIZE(100, 30))
		local imgPath = getRealUIResourcePath("img/new00250.png")
		if imgPath then
			Hunter.m_pButton4:setTitle(imgPath:getData())
		end
	end

	Hunter.m_pButton5 = SCButton:button(EnumBtnType9Atlas)
	if Hunter.m_pButton5 then
		Hunter.m_pButton5:setTag(5)
		Hunter.m_pButton5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Hunter.m_pButton5:setPosition(AUTO_POS(340.00, 10.00))
		Hunter.m_pButton5:setContentSize(AUTO_SIZE(100, 30))
		local imgPath = getRealUIResourcePath("img/new00241.png")
		if imgPath then
			Hunter.m_pButton5:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10007 = nil
	if imgPath then
		pImage10007 = SCImage:imageWithFile(imgPath:getData())
		if pImage10007 then
			pImage10007:setTag(10007)
			pImage10007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10007:setPosition(AUTO_POS(85.00, 230.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10008 = nil
	if imgPath then
		pImage10008 = SCImage:imageWithFile(imgPath:getData())
		if pImage10008 then
			pImage10008:setTag(10008)
			pImage10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10008:setPosition(AUTO_POS(135.00, 230.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10009 = nil
	if imgPath then
		pImage10009 = SCImage:imageWithFile(imgPath:getData())
		if pImage10009 then
			pImage10009:setTag(10009)
			pImage10009:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10009:setPosition(AUTO_POS(35.00, 146.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10010 = nil
	if imgPath then
		pImage10010 = SCImage:imageWithFile(imgPath:getData())
		if pImage10010 then
			pImage10010:setTag(10010)
			pImage10010:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10010:setPosition(AUTO_POS(35.00, 86.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10011 = nil
	if imgPath then
		pImage10011 = SCImage:imageWithFile(imgPath:getData())
		if pImage10011 then
			pImage10011:setTag(10011)
			pImage10011:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10011:setPosition(AUTO_POS(85.00, 62.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10012 = nil
	if imgPath then
		pImage10012 = SCImage:imageWithFile(imgPath:getData())
		if pImage10012 then
			pImage10012:setTag(10012)
			pImage10012:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10012:setPosition(AUTO_POS(135.00, 62.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10013 = nil
	if imgPath then
		pImage10013 = SCImage:imageWithFile(imgPath:getData())
		if pImage10013 then
			pImage10013:setTag(10013)
			pImage10013:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10013:setPosition(AUTO_POS(185.00, 146.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10014 = nil
	if imgPath then
		pImage10014 = SCImage:imageWithFile(imgPath:getData())
		if pImage10014 then
			pImage10014:setTag(10014)
			pImage10014:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10014:setPosition(AUTO_POS(185.00, 86.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10015 = nil
	if imgPath then
		pImage10015 = SCImage:imageWithFile(imgPath:getData())
		if pImage10015 then
			pImage10015:setTag(10015)
			pImage10015:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10015:setPosition(AUTO_POS(35.00, 206.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	local pImage10016 = nil
	if imgPath then
		pImage10016 = SCImage:imageWithFile(imgPath:getData())
		if pImage10016 then
			pImage10016:setTag(10016)
			pImage10016:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10016:setPosition(AUTO_POS(185.00, 206.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage30 = nil
	if imgPath then
		Hunter.m_pImage30 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage30 then
			Hunter.m_pImage30:setTag(10017)
			Hunter.m_pImage30:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage30:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage31 = nil
	if imgPath then
		Hunter.m_pImage31 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage31 then
			Hunter.m_pImage31:setTag(10018)
			Hunter.m_pImage31:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage31:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage32 = nil
	if imgPath then
		Hunter.m_pImage32 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage32 then
			Hunter.m_pImage32:setTag(10019)
			Hunter.m_pImage32:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage32:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage29 = nil
	if imgPath then
		Hunter.m_pImage29 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage29 then
			Hunter.m_pImage29:setTag(10021)
			Hunter.m_pImage29:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage29:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage28 = nil
	if imgPath then
		Hunter.m_pImage28 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage28 then
			Hunter.m_pImage28:setTag(10022)
			Hunter.m_pImage28:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage28:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage37 = nil
	if imgPath then
		Hunter.m_pImage37 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage37 then
			Hunter.m_pImage37:setTag(10023)
			Hunter.m_pImage37:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage37:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage36 = nil
	if imgPath then
		Hunter.m_pImage36 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage36 then
			Hunter.m_pImage36:setTag(10024)
			Hunter.m_pImage36:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage36:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage35 = nil
	if imgPath then
		Hunter.m_pImage35 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage35 then
			Hunter.m_pImage35:setTag(10025)
			Hunter.m_pImage35:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage35:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage33 = nil
	if imgPath then
		Hunter.m_pImage33 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage33 then
			Hunter.m_pImage33:setTag(10026)
			Hunter.m_pImage33:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage33:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	Hunter.m_pImage34 = nil
	if imgPath then
		Hunter.m_pImage34 = SCImage:imageWithFile(imgPath:getData())
		if Hunter.m_pImage34 then
			Hunter.m_pImage34:setTag(10027)
			Hunter.m_pImage34:setAnchorPoint(ANCHOR_CENTER)
			Hunter.m_pImage34:setPosition(AUTO_POS(24.00, 24.00))
		end
	end

	local pButton28 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton28 then
		pButton28:setTag(28)
		pButton28:setAnchorPoint(ANCHOR_CENTER)
		pButton28:setPosition(AUTO_POS(23.00, 23.00))
		pButton28:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton28:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton29 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton29 then
		pButton29:setTag(29)
		pButton29:setAnchorPoint(ANCHOR_CENTER)
		pButton29:setPosition(AUTO_POS(24.00, 24.00))
		pButton29:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton29:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton30 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton30 then
		pButton30:setTag(30)
		pButton30:setAnchorPoint(ANCHOR_CENTER)
		pButton30:setPosition(AUTO_POS(23.00, 23.00))
		pButton30:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton30:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton31 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton31 then
		pButton31:setTag(31)
		pButton31:setAnchorPoint(ANCHOR_CENTER)
		pButton31:setPosition(AUTO_POS(23.00, 23.00))
		pButton31:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton31:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton32 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton32 then
		pButton32:setTag(32)
		pButton32:setAnchorPoint(ANCHOR_CENTER)
		pButton32:setPosition(AUTO_POS(23.00, 23.00))
		pButton32:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton32:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton33 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton33 then
		pButton33:setTag(33)
		pButton33:setAnchorPoint(ANCHOR_CENTER)
		pButton33:setPosition(AUTO_POS(23.00, 23.00))
		pButton33:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton33:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton34 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton34 then
		pButton34:setTag(34)
		pButton34:setAnchorPoint(ANCHOR_CENTER)
		pButton34:setPosition(AUTO_POS(23.00, 23.00))
		pButton34:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton34:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton35 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton35 then
		pButton35:setTag(35)
		pButton35:setAnchorPoint(ANCHOR_CENTER)
		pButton35:setPosition(AUTO_POS(23.00, 23.00))
		pButton35:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton35:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton36 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton36 then
		pButton36:setTag(36)
		pButton36:setAnchorPoint(ANCHOR_CENTER)
		pButton36:setPosition(AUTO_POS(23.00, 23.00))
		pButton36:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton36:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton37 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton37 then
		pButton37:setTag(37)
		pButton37:setAnchorPoint(ANCHOR_CENTER)
		pButton37:setPosition(AUTO_POS(23.00, 23.00))
		pButton37:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton37:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton200 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton200 then
		pButton200:setTag(200)
		pButton200:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton200:setPosition(AUTO_POS(56.00, 280.00))
		pButton200:setContentSize(AUTO_SIZE(22, 30))
		
		local pBackimg = getRealUIResourcePath("img/new00048.png")
		if pBackimg then
			pButton200:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton201 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton201 then
		pButton201:setTag(201)
		pButton201:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton201:setPosition(AUTO_POS(189.00, 280.00))
		pButton201:setContentSize(AUTO_SIZE(22, 30))
		
		local pBackimg = getRealUIResourcePath("img/new00047.png")
		if pBackimg then
			pButton201:setBackgroundImage(pBackimg:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00001.png")
	local pImage202 = nil
	if imgPath then
		pImage202 = SCImage:imageWithFile(imgPath:getData())
		if pImage202 then
			pImage202:setTag(202)
			pImage202:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage202:setPosition(AUTO_POS(83.00, 285.00))
		end
	end

	Hunter.m_pLabelName = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if Hunter.m_pLabelName then
		Hunter.m_pLabelName:setTag(204)
		Hunter.m_pLabelName:setAnchorPoint(ANCHOR_CENTER)
		Hunter.m_pLabelName:setPosition(AUTO_POS(49.50, 8.50))
		Hunter.m_pLabelName:setColor(ccc4(255,255,255,255))
	end

	if Hunter.m_pImage6 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(Hunter.m_pImage6, "SCNode"))
	end
	if Hunter.m_pDragNode1 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(Hunter.m_pDragNode1, "SCNode"))
	end
	if Hunter.m_pButton3 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(Hunter.m_pButton3, "SCNode"))
	end
	if Hunter.m_pButton4 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(Hunter.m_pButton4, "SCNode"))
	end
	if Hunter.m_pButton5 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(Hunter.m_pButton5, "SCNode"))
	end
	if pImage10007 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10007, "SCNode"))
	end
	if pImage10008 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10008, "SCNode"))
	end
	if pImage10009 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10009, "SCNode"))
	end
	if pImage10010 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10010, "SCNode"))
	end
	if pImage10011 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10011, "SCNode"))
	end
	if pImage10012 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10012, "SCNode"))
	end
	if pImage10013 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10013, "SCNode"))
	end
	if pImage10014 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10014, "SCNode"))
	end
	if pImage10015 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10015, "SCNode"))
	end
	if pImage10016 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage10016, "SCNode"))
	end
	if Hunter.m_pImage30 and pImage10015 then
		pImage10015:addChild(tolua.cast(Hunter.m_pImage30, "SCNode"))
	end
	if Hunter.m_pImage31 and pImage10009 then
		pImage10009:addChild(tolua.cast(Hunter.m_pImage31, "SCNode"))
	end
	if Hunter.m_pImage32 and pImage10010 then
		pImage10010:addChild(tolua.cast(Hunter.m_pImage32, "SCNode"))
	end
	if Hunter.m_pImage29 and pImage10007 then
		pImage10007:addChild(tolua.cast(Hunter.m_pImage29, "SCNode"))
	end
	if Hunter.m_pImage28 and pImage10008 then
		pImage10008:addChild(tolua.cast(Hunter.m_pImage28, "SCNode"))
	end
	if Hunter.m_pImage37 and pImage10016 then
		pImage10016:addChild(tolua.cast(Hunter.m_pImage37, "SCNode"))
	end
	if Hunter.m_pImage36 and pImage10013 then
		pImage10013:addChild(tolua.cast(Hunter.m_pImage36, "SCNode"))
	end
	if Hunter.m_pImage35 and pImage10014 then
		pImage10014:addChild(tolua.cast(Hunter.m_pImage35, "SCNode"))
	end
	if Hunter.m_pImage33 and pImage10011 then
		pImage10011:addChild(tolua.cast(Hunter.m_pImage33, "SCNode"))
	end
	if Hunter.m_pImage34 and pImage10012 then
		pImage10012:addChild(tolua.cast(Hunter.m_pImage34, "SCNode"))
	end
	if pButton28 and Hunter.m_pImage28 then
		Hunter.m_pImage28:addChild(tolua.cast(pButton28, "SCNode"))
	end
	if pButton29 and Hunter.m_pImage29 then
		Hunter.m_pImage29:addChild(tolua.cast(pButton29, "SCNode"))
	end
	if pButton30 and Hunter.m_pImage30 then
		Hunter.m_pImage30:addChild(tolua.cast(pButton30, "SCNode"))
	end
	if pButton31 and Hunter.m_pImage31 then
		Hunter.m_pImage31:addChild(tolua.cast(pButton31, "SCNode"))
	end
	if pButton32 and Hunter.m_pImage32 then
		Hunter.m_pImage32:addChild(tolua.cast(pButton32, "SCNode"))
	end
	if pButton33 and Hunter.m_pImage33 then
		Hunter.m_pImage33:addChild(tolua.cast(pButton33, "SCNode"))
	end
	if pButton34 and Hunter.m_pImage34 then
		Hunter.m_pImage34:addChild(tolua.cast(pButton34, "SCNode"))
	end
	if pButton35 and Hunter.m_pImage35 then
		Hunter.m_pImage35:addChild(tolua.cast(pButton35, "SCNode"))
	end
	if pButton36 and Hunter.m_pImage36 then
		Hunter.m_pImage36:addChild(tolua.cast(pButton36, "SCNode"))
	end
	if pButton37 and Hunter.m_pImage37 then
		Hunter.m_pImage37:addChild(tolua.cast(pButton37, "SCNode"))
	end
	if pButton200 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pButton200, "SCNode"))
	end
	if pButton201 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pButton201, "SCNode"))
	end
	if pImage202 and pWindow6004 then
		pWindow6004:addChild(tolua.cast(pImage202, "SCNode"))
	end
	if Hunter.m_pLabelName and pImage202 then
		pImage202:addChild(tolua.cast(Hunter.m_pLabelName, "SCNode"))
	end
	return pWindow6004
end
function Hunter.releaseControl()
	Hunter.m_pImage6 = nil
	Hunter.m_pDragNode1 = nil
	Hunter.m_pButton3 = nil
	Hunter.m_pButton4 = nil
	Hunter.m_pButton5 = nil
	Hunter.m_pImage30 = nil
	Hunter.m_pImage31 = nil
	Hunter.m_pImage32 = nil
	Hunter.m_pImage29 = nil
	Hunter.m_pImage28 = nil
	Hunter.m_pImage37 = nil
	Hunter.m_pImage36 = nil
	Hunter.m_pImage35 = nil
	Hunter.m_pImage33 = nil
	Hunter.m_pImage34 = nil
	Hunter.m_pLabelName = nil
	if Hunter.wndClose then
		Hunter.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
--一键猎命
function Hunter_sendHuntFast()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_HUNTER);
	if dataStream then
		dataStream:writeShort(ACTION_HUNT_FAST)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 	
end

--查看神武魂
function Hunter_sendGodHuntMsg(id,openType)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_HUNTER);
	if dataStream then
		dataStream:writeShort(ACTION_HUNT_GOD_HUNT_ACTIVE)
		dataStream:writeInt(id)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
		m_godHunterTipOpenType = openType
		m_godHunterId = id
	end 	
end

--一键合成
function Hunter_sendHuntEatFast(ucFlag, ucPosition)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_HUNTER);
	if dataStream then
		dataStream:writeShort(ACTION_HUNT_EATFAST)
		dataStream:writeByte(ucFlag)
		dataStream:writeInt(ucPosition)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end

--一键提取
function Hunter_sendHuntGetFast()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_HUNTER);
	if dataStream then
		dataStream:writeShort(ACTION_HUNT_GETFAST)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end

--武魂分解
function Hunter_sendHuntSplit(idItem)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_HUNTER);
	if dataStream then
		dataStream:writeShort(ACTION_HUNT_SPLIT)
		dataStream:writeInt(idItem)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 	
end

--常规猎命
function Hunter_sendHuntNormal(ucFlag, ucPosition)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_HUNTER);
	if dataStream then
		dataStream:writeShort(ACTION_HUNT_NORMAL)
		dataStream:writeByte(ucFlag)
		dataStream:writeByte(ucPosition)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 	
end

--极速猎命
function Hunter_sendfastHuntMsg()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_HUNTER);
	if dataStream then
		dataStream:writeShort(ACTION_HUNT_LIMIT_FAST)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end

--发送传装备
local function sendWearHunter(item, ucPosition)
	if item == nil or ucPosition == nil then
		return;
	end
	
    local heroInfo = Hero:getSingleton():getHeroInfo();
    if heroInfo == nil then
        return;
    end
    
    local id = Hero:getSingleton():getID();
    local level = 0;
    if m_curPlayIndex == 0 then
        level = Hero:getSingleton():getLeval();
    else
    	local amount = Hero:getSingleton():partnerSize();
	    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
	        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
	        if partner then
	            id = partner.nID;
	            level = partner.usLevel;
	        end
	    end
    end
    
    if level < 21 then
        return;
    end

	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM);
	if dataStream then
		dataStream:writeShort(ITEMACT_EQUIP)
		dataStream:writeInt(item:getID())
		dataStream:writeByte(51)
		dataStream:writeShort(0)
		dataStream:writeInt(id);
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 	
end

--发送脱装备
local function sendTakeOffHunter(item, usPlace)
	if item == nil or usPlace == nil then
		return;
	end
	
	local id = Hero:getSingleton():getID();
    if m_curPlayIndex == 0 then
    else
    	local amount = Hero:getSingleton():partnerSize();
	    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
	        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
	        if partner then
	            id = partner.nID;
	        end
	    end
    end

	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM);
	if dataStream then
		dataStream:writeShort(ITEMACT_UNEQUIP)
		dataStream:writeInt(item:getID())
		dataStream:writeByte(item:getPostion())
		dataStream:writeShort(400)
		dataStream:writeInt(id);
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end

--发送吞噬单个物品
local function sendEatHunter(itemFrom, itemTo)
	if itemFrom == nil or itemTo == nil then
		return;
	end

	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM);
	if dataStream then
		dataStream:writeShort(ITEMACT_MOVE)
		dataStream:writeInt(itemFrom:getID())
		dataStream:writeInt(0)
		dataStream:writeByte(0)
		dataStream:writeShort(itemFrom:getPlace())
		dataStream:writeShort(itemTo:getPlace())
		dataStream:writeInt(Hero:getSingleton():getID());
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end     
end

--点击封印按钮
local function onLockBtnClick(tag)
	local level = 21;
	
	if tag == 28 then
		level = 21;
	elseif tag == 29 then
		level = 31;
	elseif tag == 30 then
		level = 41;
	elseif tag == 31 then
		level = 51;
	elseif tag == 32 then
		level = 61;
	elseif tag == 33 then
		level = 71;
	elseif tag == 34 then
		level = 81;
	elseif tag == 35 then
		level = 91;
	elseif tag == 36 then
		level = 101;
	elseif tag == 37 then
		level = 111;
	end
	if 100 < level and CLIENT_VERSION < 328 then
	    showMessage(L("str9150"))
	    return
	end
	showMessage(L("str9150")..level..L("str9151"));
end

--获取节点
local function getHunterImageNode(index)
	local node = nil;
	if index == 28 then
		local pImage28 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10008-10022"));
	    if pImage28 then
		    node = pImage28;
		end
	elseif index == 29 then
		local pImage29 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10007-10021"));
	    if pImage29 then
		    node = pImage29;
		end
	elseif index == 30 then
	    local pImage30 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10015-10017"));
	    if pImage30 then
		    node = pImage30;
		end
	elseif index == 31 then
		local pImage31 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10009-10018"));
	    if pImage31 then
		    node = pImage31;
		end
	elseif index == 32 then
		local pImage32 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10010-10019"));
	    if pImage32 then
		    node = pImage32;
		end
	elseif index == 33 then
		local pImage33 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10011-10026"));
	    if pImage33 then
		    node = pImage33;
		end
	elseif index == 34 then
		local pImage34 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10012-10027"));
	    if pImage34 then
		    node = pImage34;
		end
	elseif index == 35 then
		local pImage35 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10014-10025"));
	    if pImage35 then
		    node = pImage35;
		end
	elseif index == 36 then
		local pImage36 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10013-10024"));
	    if pImage36 then
		    node = pImage36;
		end
	elseif index == 37 then
		local pImage37 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-10016-10023"));
	    if pImage37 then
		    node = pImage37;
		end
	end
	
	return node;
end

--点击装备
local function onWearBtnClick(tag)
	if tag == 0	then					--装备武魂
		if m_curIdItem then
			local item = ItemProcessor:getSingleton():getItem(m_curIdItem);
			if item then
				sendWearHunter(item, 0)
			end
		end
	elseif tag == 1	then				--吞噬武魂
		if m_curIdItem then
			Hunter6.initControl()
			Hunter6.refreshWnd(m_curIdItem)
		end
	end
end

--点击查看物品  装备
local function onImageBtnClick(tag)
    local item = ItemProcessor:getSingleton():getItem(tag);
    if item:getIdType() >= GOD_HUNTER_BEGIN and item:getIdType() <= GOD_HUNTER_END then
		Hunter_sendGodHuntMsg(tag,2)
		return
    end
    if item then
        if item:getIdType() >= ITEMID_HUNT_EXP_BEGIN and item:getIdType() <= ITEMID_HUNT_EXP_END then
			local itemInfo = item:getData()
			if itemInfo then
				local iconPath = getRealUIResourcePath("item/"..item:getIconID()..".jpg")
				luaShowTipHaveIcon(string.format(L("str6303"), itemInfo.dwData1), item:getName(), iconPath, nil, nil, nil, 1)
			end
		else
			local tabelStr = L("str0118").."_"..L("str30161");
			m_curIdItem = tag;
			local tip = showTipExe(item, tabelStr);
			if tip then
				tip:luaSetReturnSelector(onWearBtnClick);
			end
        end
    end
end

--点击脱下
local function onDropBtnClick(tag)
    if m_curIdItem then
        local item = ItemProcessor:getSingleton():getItem(m_curIdItem);
        if item then
            sendTakeOffHunter(item, 0);
        end
    end
end
local function showHunterEquitTip(item)
	if CLIENT_VERSION >= 331 then
		local tabelStr = L("str9165");
		local tip = showTipExe(item, tabelStr);
		if tip then
			tip:luaSetReturnSelector(onDropBtnClick);
			return
		end
	end
	
    local itemTypeInfo = TableParser:getSingleton():getItemInfoByKey(item:getIdType())
    local itemInfo = item:getData()
    if nil == itemTypeInfo or nil == itemInfo then
        return
    end
    local tmpIndex = 900;
    if item:getIdType()%10 == 4 then
        tmpIndex = 900
    elseif item:getIdType()%10 == 5 then
        tmpIndex = 1000
    elseif item:getIdType()%10 == 6 then
        tmpIndex = 2000
    elseif item:getIdType()%10 == 7 then
        tmpIndex = 3000
    elseif item:getIdType()%10 == 8 then
        tmpIndex = 4000
    elseif item:getIdType()%10 == 9 then
        tmpIndex = 5000
    end

    local strTip = ""
    if itemTypeInfo.need_level > 0 then
        strTip = strTip..L("str8120")
        strTip = strTip..itemTypeInfo.need_level
        strTip = strTip..L("str2042")
    end
    if itemTypeInfo.effect_type_1 ~= 0 then
        strTip = strTip.."_*5"..item:getEffectNameByPos(0):getData().." +"..(itemInfo.dwData2*item:getParamByPos(0))
        if 4971 == itemTypeInfo.effect_type_1 then
			strTip = strTip.."%";
		end
    end
	if itemTypeInfo.description ~= L("str5001") then
		strTip = strTip.."_";
		strTip = strTip..itemTypeInfo.description:getData();
	end

	if itemTypeInfo.price > 0 then
		local price = strTip.price * 0.25
		strTip = strTip.."__"
		strTip = strTip..L("str8121")
		strTip = strTip..price
		strTip = strTip.."_"
	end
	
	tmpIndex = tmpIndex + itemInfo.dwData2
	local eudExp = 120*math.pow(2, math.modf(tmpIndex/1000))*math.pow(2, (tmpIndex%10))
	strTip = strTip.."_";
	strTip = strTip..L("str9173");
	strTip = strTip..itemInfo.dwData1;
	strTip = strTip.."/";
	strTip = strTip..eudExp;
	
	local file = getRealUIResourcePath("item/"..item:getIconID()..".jpg")
	luaShowTipHaveIcon(strTip, getColorString(item:getIdType())..item:getName().."Lv"..itemInfo.dwData2, file, L("str9165"), 1, onDropBtnClick, 0.7)
end
--点击查看物品  脱下
local function onImageBtnClick2(tag)
    local item = ItemProcessor:getSingleton():getItem(tag);
    if item:getIdType() >= GOD_HUNTER_BEGIN and item:getIdType() <= GOD_HUNTER_END then
		Hunter_sendGodHuntMsg(tag,1)
		return
    end
    if item then
        m_curIdItem = tag;
        showHunterEquitTip(item);
    end
end

--获取解封个数
local function getUnlockCount()
	local tmpUnlockCount = 27;
    local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return tmpUnlockCount;
    end

	local level = heroInfo.ucLevel;
	if m_curPlayIndex == 0 then
    else
    	local amount = Hero:getSingleton():partnerSize();
	    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
	        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
	        if partner then
	            level = partner.usLevel;
	        end
	    end
    end
	if level >= 111 then
		tmpUnlockCount = tmpUnlockCount + 8;
	elseif level >= 101 then
		tmpUnlockCount = tmpUnlockCount + 8;
	elseif level >= 91 then
		tmpUnlockCount = tmpUnlockCount + 8;
	elseif level >= 81 then
		tmpUnlockCount = tmpUnlockCount + 7;
	elseif level >= 71 then
		tmpUnlockCount = tmpUnlockCount + 6;
	elseif level >= 61 then
		tmpUnlockCount = tmpUnlockCount + 5;
	elseif level >= 51 then
		tmpUnlockCount = tmpUnlockCount + 4;
	elseif level >= 41 then
		tmpUnlockCount = tmpUnlockCount + 3;
	elseif level >= 31 then
		tmpUnlockCount = tmpUnlockCount + 2;
	elseif level >= 21 then
		tmpUnlockCount = tmpUnlockCount + 1;
	end
	if CLIENT_VERSION > 327 then
	    if level >= 111 then
		    tmpUnlockCount = tmpUnlockCount + 2;
	    elseif level >= 101 then
		    tmpUnlockCount = tmpUnlockCount + 1;
        end
	end
	return tmpUnlockCount;
end

--填充所有按钮数据
local function addHunterEquipLock()
    for i=28, 37 do
		unlockNode = getHunterImageNode(i);
		if unlockNode then
			local node = unlockNode:getChildByTag(i);
			if node == nil then
                local pButton28 = SCButton:button(EnumBtnTypeNormalImg)
                if pButton28 then
                    pButton28:setTag(i)
                    pButton28:setAnchorPoint(ANCHOR_CENTER)
                    pButton28:setPosition(AUTO_POS(23.00, 23.00))
                    pButton28:setContentSize(AUTO_SIZE(28, 28))
                    pButton28:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
                    local pBackimg = getRealUIResourcePath("img/new00259.png")
                    if pBackimg then
                        pButton28:setBackgroundImage(pBackimg:getData())
                    end
                    unlockNode:addChild(pButton28);
                end
			end
		end
	end
end

--清空身上武魂装备
local function clearHunterEquip()
	local tmpUnlockCount = getUnlockCount();

	--处理解封
	local unlockNode = nil;
	for i=28, tmpUnlockCount do
		unlockNode = getHunterImageNode(i);
		if unlockNode then
			unlockNode:removeAllChildrenWithCleanup(true);
		end
	end
end

--清空身上所有武魂装备
local function clearAllHunterEquip()
	for i=28, 37 do
		unlockNode = getHunterImageNode(i);
		if unlockNode then
			unlockNode:removeAllChildrenWithCleanup(true);
		end
	end
end

--根据等级解封
local function unlockHunterByLevel()
	clearHunterEquip();
	
	--处理封印
	local tmpUnlockCount = getUnlockCount();
	local lockNode = nil;
	for i=tmpUnlockCount+1, 37 do
		lockNode = getHunterImageNode(i);
		if lockNode then
			local childNode = lockNode:getChildByTag(i);
			if childNode then
				SCTypeCast:castNodeToButton(childNode):luaSetSelectorOnClicked(onLockBtnClick);
			end
		end
	end
end

--穿装备
local function wearHunter(item, x, y)
	local tmpUnlockCount = getUnlockCount();
	local unlockNode = nil;
	local isInWear = false;
	for i=28, tmpUnlockCount do
		unlockNode = getHunterImageNode(i);
		if unlockNode then
			local size = unlockNode:getContentSize();
			local Pos = unlockNode:convertToNodeSpace(CCPointMake(x, y));
			isInWear = CCRectMake(0, 0, size.width, size.height):containsPoint(Pos);
			if isInWear then
                if item:getIdType() >= 1899000001 and item:getIdType() <= 1899000009 then
                    showMessage(L("str6308"))
                else
                   sendWearHunter(item, ITEMPOS_HUNT_BEGIN+i-28); 
                end
				break;
			end
		end
	end
end

--获取没放物品的位置
local function getPositionForNUll()
    local pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("6004-1"));
    if pDragNode1 == nil then
        return
    end

	local tableBox = SCTypeCast:castNodeToTableBox(pDragNode1:getChildByTag(1));
	if tableBox == nil then
		return 0;
	end
	
	local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
	if pTable == nil then
		return 0;
	end
	
	for i=0, 15 do
		local tableCell = pTable:getChildByTag(i);
		if tableCell then
			local dragButton = SCTypeCast:castNodeToButton(tableCell:getChildByTag(1));
			if dragButton then
				local dragNode = dragButton:getChildByTag(1);
				if dragNode then
					local child = dragNode:getChildren();
					if child == nil then
						return i;
					end
				end
			end
		end
	end
end

--拖拽吞噬背包中的武魂
local function onDragToEatHunter(pos, item)
    local pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("6004-1"));
    if pDragNode1 == nil then
        return
    end
    
	local tableBox = SCTypeCast:castNodeToTableBox(pDragNode1:getChildByTag(1));
	if tableBox == nil then
		return
	end
	
	local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
	if pTable == nil then
		return;
	end
	
	local row = math.floor(pos.y/SY(55));
	if row <= 0 then
	    row = 3;
	elseif row == 1 then
	    row = 2;
	elseif row == 2 then
	    row = 1;
	elseif row >= 3 and row <= 4 then
	    row = 0;
	end
	
	local column = math.floor(pos.x/SX(55));
	if column <= 0 then
	    column = 0;
	elseif column >= 3 and column <= 4 then
	    column = 3;
	end
	
	local tag = row * 4 + column + HUNT_GRID_BEGINPLACE;
    local itemTarget = ItemProcessor:getSingleton():getItemByPlace(tag);
    if itemTarget then
        if item:getID() ~= itemTarget:getID() then
            sendEatHunter(item, itemTarget);
        end
    end
end

--拖拽回调
local function setSelectorOnDragEnd(tag, x, y)
	local item = ItemProcessor:getSingleton():getItem(tag)
	if item == nil then
		return;
	end
	local itemPos = item:getPostion();
	local pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("6004-1"));
	local pImage6 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("6004-6"));
	if pImage6 and pDragNode1 then
		local size = pImage6:getContentSize();
		local Pos = pDragNode1:convertToNodeSpace(CCPointMake(x, y));
		local isInBag = CCRectMake(0, 0, size.width, size.height):containsPoint(Pos);
		if isInBag then
		    if itemPos == 0 then
		        onDragToEatHunter(Pos, item);
		        return;
		    end
			sendTakeOffHunter(item, 0);
		else
		    if itemPos ~= 0 then
		        return;
		    end
			wearHunter(item, x, y);
		end
	end
end

--填充猎命窗口数据
local function refreshHunterWnd()
    local pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("6004-1"));
	if pDragNode1 == nil then
		return;
	end	
	
	local tableBox = SCTypeCast:castNodeToTableBox(pDragNode1:getChildByTag(1));
	if tableBox == nil then
		return;
	end
	
	local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
	if pTable == nil then
		return;
	end
	
	local position = 0;
	local place = 0;
	local amount = Hero:getSingleton():partnerSize();
	local itemSize = ItemProcessor:getSingleton():getAllHunterItemSize();
	for i=1, itemSize do
		local idItem = ItemProcessor:getSingleton():getAllHunterItemByPos(i-1);
		if idItem ~= 0 then
		    local item = ItemProcessor:getSingleton():getItem(idItem);
            if item then
                position = item:getPostion();
                place = item:getPlace();
                if position == 0 then
                    if place >= HUNT_GRID_BEGINPLACE and place <= HUNT_GRID_ENDPLACE then
                        local tableCell = pTable:getChildByTag(place - HUNT_GRID_BEGINPLACE);
                        if tableCell then
                            local dragButton = SCTypeCast:castNodeToButton(tableCell:getChildByTag(1));
                            if dragButton then
                                local dragNode = SCTypeCast:castNodeToDragNode(dragButton:getChildByTag(1));
                                if dragNode then
                                    local imgPath = getRealUIResourcePath("item/"..item:getIconID()..".jpg");
                                    if imgPath == nil then
                                        imgPath = getRealUIResourcePath("img/ItemTemp.png");
                                    end
                                    if imgPath then
                                        local image = SCImage:imageWithFile(imgPath:getData());
                                        if image then
                                            image:setAnchorPoint(CCPointMake(0.5, 0.5));
                                            image:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height/2));
                                            dragNode:setTag(item:getID());
                                            dragNode:addChild(image);
                                            --武魂等级
                                            local itemInfo = item:getData()
                                            local pLv = "lv."..itemInfo.dwData2
                                            local label = SCLabel:labelWithStringFont(pLv, DEFAULT_FONT_NAME, F(9))
                                            if label then
                                                label:setAnchorPoint(ANCHOR_CENTER)
                                                label:setPosition(image:getContentSize().width - SX(10), SY(5))
                                                --label:setColor(getColorGray())
                                                image:addChild(label)
                                            end
                                            local itemName = item:getName()
                                           
                                            local labelName = SCLabel:labelWithStringFont(itemName, DEFAULT_FONT_NAME, F(10))
                                            if labelName then
                                                labelName:setAnchorPoint(ANCHOR_CENTER)
                                                labelName:setPosition(image:getContentSize().width /2, -SY(10))
                                                local idType = item:getIdType()
                                                if 4 == idType%10 then
                                                    
                                                elseif 5 == idType%10 then
                                                    labelName:setColor(color_green)
                                                elseif 6 == idType%10 then
                                                    labelName:setColor(color_skyBlue)
                                                elseif 7 == idType%10 then
                                                    labelName:setColor(color_purple)
                                                elseif 8 == idType%10 then
                                                    labelName:setColor(color_yellow)
                                                elseif 9 == idType%10 then
                                                    labelName:setColor(color_orange)
												elseif 0 == idType%10 then
                                                    labelName:setColor(color_orange)
                                                end
                                                --label:setColor(getColorGray())
                                                image:addChild(labelName)
                                            end
                                            --只处理点击事件
                                            local eventBtn = SCButton:button();
                                            if eventBtn then
                                                eventBtn:setContentSize(image:getContentSize());
                                                eventBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                                                eventBtn:setPosition(CCPointMake(image:getContentSize().width/2, image:getContentSize().height/2));
                                                eventBtn:setTag(item:getID());
                                                eventBtn:luaSetSelectorOnClicked(onImageBtnClick);
                                                image:addChild(eventBtn);
                                            end
                                        end
                                    end
                                end
                            end
                        end
                    end
			    elseif position >= ITEMPOS_HUNT_BEGIN and position <= ITEMPOS_HUNT_END then
			        if m_curPlayIndex == 0 and item:getOwnerID() == Hero:getSingleton():getID() then
                        local BgNode = getHunterImageNode(position - ITEMPOS_HUNT_BEGIN + 28);
                        if BgNode then
                            local imgPath = getRealUIResourcePath("item/"..item:getIconID()..".jpg");
                            if imgPath == nil then
                                imgPath = getRealUIResourcePath("img/ItemTemp.png");
                            end
                            if imgPath then
                                local dragNode = SCDragNode:node();
                                if dragNode then
                                    local bgButton = SCButton:button();
                                    if bgButton then
                                        bgButton:setBackgroundImage(imgPath:getData());	
                                        dragNode:setContentSize(bgButton:getContentSize());
                                        bgButton:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        bgButton:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height/2));
                                        bgButton:setTag(item:getID());  
                                        bgButton:luaSetSelectorOnClicked(onImageBtnClick2);
                                        dragNode:addChild(bgButton);
                                        dragNode:setDragEnabled(true);
                                        dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        dragNode:setPosition(CCPointMake(BgNode:getContentSize().width/2, BgNode:getContentSize().height/2));
                                        dragNode:setTag(item:getID());  
                                        dragNode:luaSetSelectorOnDragEnd(setSelectorOnDragEnd);
                                        BgNode:addChild(dragNode); 
                                            --武魂等级
                                            local itemInfo = item:getData()
                                            local pLv = "lv."..itemInfo.dwData2
                                            local label = SCLabel:labelWithStringFont(pLv, DEFAULT_FONT_NAME, F(9))
                                            if label then
                                                label:setAnchorPoint(ANCHOR_CENTER)
                                                label:setPosition(bgButton:getContentSize().width - SX(10), SY(5))
                                                --label:setColor(getColorGray())
                                                bgButton:addChild(label)
                                            end
                                            local itemName = item:getName()
                                           
                                            local labelName = SCLabel:labelWithStringFont(itemName, DEFAULT_FONT_NAME, F(10))
                                            if labelName then
                                                labelName:setAnchorPoint(ANCHOR_CENTER)
                                                labelName:setPosition(bgButton:getContentSize().width /2, -SY(10))
                                                local idType = item:getIdType()
                                                if 4 == idType%10 then
                                                    
                                                elseif 5 == idType%10 then
                                                    labelName:setColor(color_green)
                                                elseif 6 == idType%10 then
                                                    labelName:setColor(color_skyBlue)
                                                elseif 7 == idType%10 then
                                                    labelName:setColor(color_purple)
                                                elseif 8 == idType%10 then
                                                    labelName:setColor(color_yellow)
                                                elseif 9 == idType%10 then
                                                    labelName:setColor(color_orange)
												elseif 0 == idType%10 then
                                                    labelName:setColor(color_orange)
                                                end
                                                --label:setColor(getColorGray())
                                                bgButton:addChild(labelName)
                                            end           
                                    end
                                end
                            end
                        end
			        else
                        if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
                            local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
                            if partner then
                                if partner.nID == item:getOwnerID() then
                                    local BgNode = getHunterImageNode(position - ITEMPOS_HUNT_BEGIN + 28);
                                    if BgNode then
                                        local imgPath = getRealUIResourcePath("item/"..item:getIconID()..".jpg");
                                        if imgPath == nil then
                                            imgPath = getRealUIResourcePath("img/ItemTemp.png");
                                        end
                                        if imgPath then
                                            local dragNode = SCDragNode:node();
                                            if dragNode then
                                                local bgButton = SCButton:button();
                                                if bgButton then
                                                    bgButton:setBackgroundImage(imgPath:getData());	
                                                    dragNode:setContentSize(bgButton:getContentSize());
                                                    bgButton:setAnchorPoint(CCPointMake(0.5, 0.5));
                                                    bgButton:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height/2));
                                                    bgButton:setTag(item:getID());  
                                                    bgButton:luaSetSelectorOnClicked(onImageBtnClick2);
                                                    dragNode:addChild(bgButton);
                                                    dragNode:setDragEnabled(true);
                                                    dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                                    dragNode:setPosition(CCPointMake(BgNode:getContentSize().width/2, BgNode:getContentSize().height/2));
                                                    dragNode:setTag(item:getID());  
                                                    dragNode:luaSetSelectorOnDragEnd(setSelectorOnDragEnd);
                                                    BgNode:addChild(dragNode); 
                                                    --武魂等级
                                                    local itemInfo = item:getData()
                                                    local pLv = "lv."..itemInfo.dwData2
                                                    local label = SCLabel:labelWithStringFont(pLv, DEFAULT_FONT_NAME, F(9))
                                                    if label then
                                                        label:setAnchorPoint(ANCHOR_CENTER)
                                                        label:setPosition(bgButton:getContentSize().width - SX(10), SY(5))
                                                        --label:setColor(getColorGray())
                                                        bgButton:addChild(label)
                                                    end
                                                    local itemName = item:getName()
                                                    local labelName = SCLabel:labelWithStringFont(itemName, DEFAULT_FONT_NAME, F(10))
                                                    if labelName then
                                                        labelName:setAnchorPoint(ANCHOR_CENTER)
                                                        labelName:setPosition(bgButton:getContentSize().width /2, -SY(10))
                                                        local idType = item:getIdType()
                                                        if 4 == idType%10 then
                                                            
                                                        elseif 5 == idType%10 then
                                                            labelName:setColor(color_green)
                                                        elseif 6 == idType%10 then
                                                            labelName:setColor(color_skyBlue)
                                                        elseif 7 == idType%10 then
                                                            labelName:setColor(color_purple)
                                                        elseif 8 == idType%10 then
                                                            labelName:setColor(color_yellow)
                                                        elseif 9 == idType%10 then
                                                            labelName:setColor(color_orange)
														elseif 0 == idType%10 then
															labelName:setColor(color_orange)
                                                        end
                                                        --label:setColor(getColorGray())
                                                        bgButton:addChild(labelName)
                                                    end                
                                                end
                                            end
                                        end
                                    end
                                end
                            end
                        end
			        end
			    end
			end
		end
	end
end

--清空武魂背包
local function clearHunterBag()
    local pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("6004-1"));
    if pDragNode1 == nil then
        return;
    end
    
	local tableBox = SCTypeCast:castNodeToTableBox(pDragNode1:getChildByTag(1));
	if tableBox == nil then
		return;
	end
	
	local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
	if pTable == nil then
		return;
	end
	
	for i=0, 15 do
		local tableCell = pTable:getChildByTag(i);
		if tableCell then
			local dragButton = SCTypeCast:castNodeToButton(tableCell:getChildByTag(1));
			if dragButton then
			    dragButton:removeAllChildrenWithCleanup(true);
		        local dragNode = SCDragNode:node();
		        if dragNode then
			        dragNode:setTag(1);
			        dragNode:setContentSize(dragButton:getContentSize());
			        dragNode:setDragEnabled(true);
			        dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
			        dragNode:setPosition(CCPointMake(dragButton:getContentSize().width/2, dragButton:getContentSize().height/2));
			        dragNode:luaSetSelectorOnDragEnd(setSelectorOnDragEnd);
			        dragButton:addChild(dragNode); 
                end                  
			end
		end
	end
end

--创建拖拽控件
local function newDragNode()
	local imgPath1 = getRealUIResourcePath("img/new00002.png");
	local imgPath2 = getRealUIResourcePath("img/new00003.png");
	if imgPath1 and imgPath2 then
		local bgButton = SCButton:button();
		if bgButton == nil then
			return nil;
		end
		
		bgButton:setBackgroundImage(imgPath1:getData());
		bgButton:setSelectedImage(imgPath2:getData());
	
		local dragNode = SCDragNode:node();
		if dragNode then
			bgButton:setBackgroundImage(imgPath1:getData());
			bgButton:setSelectedImage(imgPath2:getData());
			dragNode:setTag(1);
			dragNode:setContentSize(bgButton:getContentSize());
			dragNode:setDragEnabled(true);
			dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
			dragNode:setPosition(CCPointMake(bgButton:getContentSize().width/2, bgButton:getContentSize().height/2));
			dragNode:luaSetSelectorOnDragEnd(setSelectorOnDragEnd);
			bgButton:addChild(dragNode);
			
			return bgButton;
		end
	end
	
	return nil;
end

function onHuntEatFastBtnOk(tag)
    if tag==1 then
        Hero:getSingleton():setFirstHuntEatfastFlag(false);
        Hunter_sendHuntEatFast(0, 0);
    end
end


--一键吞噬
local function onHuntEatFastBtnClick(tag)
    if Hero:getSingleton():getFirstHuntEatfastFlag()==true then
        luashowConfirmationWindow(_LTParser("str8188"), WIN_YES_NO, onHuntEatFastBtnOk)
    else
	    Hunter_sendHuntEatFast(0, 0);
	end
end

--进入猎命界面
local function onHuntGetBtnClick(tag)
	Hunter2_showHunterGetWnd(m_dwEffect);
	
--	local wndCtrl = getCurentSceneWindowController(6004);
--	if wndCtrl then
--		removeWindowCtrl(wndCtrl);
--	end
end

--武魂分解事件
local function onHuntSplitBtnClick(tag)
	Hunter1_showHunterShopWnd(true);
end

--处理功能按钮事件 
local function eventForButton()
    local wndCtrl = getCurentSceneWindowController(6004)
    if not wndCtrl then
        return
    end
    local wnd = wndCtrl:getWindow()
    if not wnd then
        return
    end
    local pBtn3 = SCTypeCast:castNodeToButton(wnd:getChildByTag(3));
	if pBtn3 then
		pBtn3:luaSetSelectorOnClicked(onHuntEatFastBtnClick);
	end
	local pBtn4 = SCTypeCast:castNodeToButton(wnd:getChildByTag(4));
	if pBtn4 then
		pBtn4:luaSetSelectorOnClicked(onHuntGetBtnClick);
	end
	local pBtn5 = SCTypeCast:castNodeToButton(wnd:getChildByTag(5));
	if pBtn5 then
		pBtn5:luaSetSelectorOnClicked(onHuntSplitBtnClick);
	end
end

--刷新名字
local function refreshName()
    local pLabelName = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("6004-202-204"));
    if pLabelName == nil then
        return;
    end
    
    local heroInfo = Hero:getSingleton():getHeroInfo();
    if heroInfo == nil then
        return;
    end
    
    if m_curPlayIndex == 0 then
        pLabelName:setText(heroInfo.strName:getData());
    else
    	local amount = Hero:getSingleton():partnerSize();
	    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
	        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
	        if partner then
	            pLabelName:setText(partner.strName:getData());
	        end
	    end
    end
end

--切换上一个人物
local function onUpPlayerBtnClick(tag)
    if m_curPlayIndex <= 0 then
        return;
    end
    
    m_curPlayIndex = m_curPlayIndex - 1;
    clearAllHunterEquip();
    addHunterEquipLock();
    unlockHunterByLevel();
    refreshHunterWnd();
    refreshName();
end

--切换下一个人物
local function onDownPlayerBtnClick(tag)
    local amount = Hero:getSingleton():partnerSize();
    if m_curPlayIndex + 1 > amount then
        return;
    end
    
    m_curPlayIndex = m_curPlayIndex + 1;
    clearAllHunterEquip();
    addHunterEquipLock();
    unlockHunterByLevel();
    refreshHunterWnd();
    refreshName();
end

--初始化按钮响应事件
local function initBtnEvent()
    local wndCtrl = getCurentSceneWindowController(6004);
	if wndCtrl == nil then
		return;
	end
	
	local win = wndCtrl:getWindow();
	if win then
	    local btnUp = SCTypeCast:castNodeToButton(win:getChildByTag(200));
	    local btnDown = SCTypeCast:castNodeToButton(win:getChildByTag(201));
	    if btnUp and btnDown then
	        btnUp:luaSetSelectorOnClicked(onUpPlayerBtnClick);
	        btnDown:luaSetSelectorOnClicked(onDownPlayerBtnClick);
	    end
	end
end

--创建猎命背包
local function creatHunterBag()
    local pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("6004-1"));
	if pDragNode1 == nil then
		return;
	end	
	pDragNode1:removeAllChildrenWithCleanup(true);
	
	local width = pDragNode1:getContentSize().width;
	local height = pDragNode1:getContentSize().height;
	local tabelBox = SCTableBox:boxWithWidthHeight(AUTO_W(200), AUTO_H(240));
	if tabelBox == nil then
        return;
	end
	
    tabelBox:setAnchorPoint(CCPointMake(0.5, 0.5));
    tabelBox:setPosition(CCPointMake(width/2, height/2+SY(5)));
	tabelBox:setScrollHorizontal(false);
	tabelBox:setTag(1);
    pDragNode1:addChild(tabelBox);
	
	local tabel = SCTable:table();
	if tabel == nil then
		return;
	end
	
	tabel:setNumberOfRows(4);
	tabel:setNumberOfColumns(4);
	tabelBox:addTable(tabel);
	
	for i=0, 3 do
		tabel:setWidthForColumn(AUTO_W(50), i);
		tabel:setHeightForRow(AUTO_H(57), i);
	end
	
	tabel:reflashData();
	
	for i=0, 3 do
		for j=0, 3 do
			local tableCell = tabel:cellForRowAndColumn(i, j);
			if tableCell then
				local dragNode = newDragNode();
				if dragNode then
					dragNode:setTag(1);
					dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
					dragNode:setPosition(CCPointMake(tableCell:getContentSize().width/2, tableCell:getContentSize().height/2+SY(5)));
					tableCell:addChild(dragNode);
				end
			end
		end
	end
end

local function showGodHunterTip(itemId,flg,type)
	if CLIENT_VERSION < 335 then
		showMessage(_LTParser("str3314"))
		return
	end
	local item = ItemProcessor:getSingleton():getItem(itemId);
	if item then
		local itemTypeInfo = TableParser:getSingleton():getItemInfoByKey(item:getIdType())
		local itemInfo = item:getData()
		if nil == itemTypeInfo or nil == itemInfo then
			return
		end
		local strTip = ""
		if itemTypeInfo.need_level > 0 then
			strTip = strTip..L("str8120")
			strTip = strTip..itemTypeInfo.need_level
			strTip = strTip..L("str2042")
		end
		if itemTypeInfo.effect_type_1 ~= 0 then
			if flg == 0 or flg == 2 then
				local strNum = item:getParamByPos(0)+(itemInfo.dwData2-1)*item:getParamByPos(0)/2
				if GOD_HUNTER_DRAGON == item:getIdType() then
					strTip = strTip.."_*a"..L("str3306")..strNum
				elseif GOD_HUNTER_TIGER == item:getIdType() then
					strTip = strTip.."_*a"..L("str3308")..strNum
				elseif GOD_HUNTER_BRID == item:getIdType() then
					strTip = strTip.."_*a"..L("str3310")..strNum
				elseif GOD_HUNTER_TURTLE == item:getIdType() then
					strTip = strTip.."_*a"..L("str3312")..strNum
				end
				if 4971 == itemTypeInfo.effect_type_1 then
					strTip = strTip.."%";
				end
			else
				strTip = strTip.."_*5"..item:getEffectNameByPos(0):getData().." +"..(item:getParamByPos(0)+(itemInfo.dwData2-1)*item:getParamByPos(0)/2)
				if 4971 == itemTypeInfo.effect_type_1 then
					strTip = strTip.."%";
				end
			end
		end
		if itemTypeInfo.effect_type_2 ~= 0 then
			if flg == 0 or flg == 1 then
				local strNum = item:getParamByPos(1)+(itemInfo.dwData2-1)*item:getParamByPos(1)/2
				if GOD_HUNTER_DRAGON == item:getIdType() then
					strTip = strTip.."_*a"..L("str3307")..strNum
				elseif GOD_HUNTER_TIGER == item:getIdType() then
					strTip = strTip.."_*a"..L("str3309")..strNum
				elseif GOD_HUNTER_BRID == item:getIdType() then
					strTip = strTip.."_*a"..L("str3311")..strNum
				elseif GOD_HUNTER_TURTLE == item:getIdType() then
					strTip = strTip.."_*a"..L("str3313")..strNum
				end
				if 4971 == itemTypeInfo.effect_type_1 then
					strTip = strTip.."%";
				end
			else
				strTip = strTip.."_*5"..item:getEffectNameByPos(1):getData().." +"..(item:getParamByPos(1)+(itemInfo.dwData2-1)*item:getParamByPos(1)/2)
				if 4971 == itemTypeInfo.effect_type_2 then
					strTip = strTip.."%";
				end
			end
		end
		if itemTypeInfo.description ~= L("str5001") then
			strTip = strTip.."__";
			strTip = strTip..itemTypeInfo.description:getData();
		end

		if itemTypeInfo.price > 0 then
			local price = strTip.price * 0.25
			strTip = strTip.."__"
			strTip = strTip..L("str8121")
			strTip = strTip..price
			strTip = strTip.."_"
		end
		local key = 6000 + itemInfo.dwData2
		local eudExp = TableParser:getSingleton():getEudLevExp(key)
		strTip = strTip.."_";
		strTip = strTip..L("str9173");
		strTip = strTip..itemInfo.dwData1;
		strTip = strTip.."/";
		strTip = strTip..eudExp.exp;
		
		local file = getRealUIResourcePath("item/"..item:getIconID()..".jpg")
		if 0 == type then
			luaShowTipHaveIcon(strTip, "*5"..item:getName().."Lv"..itemInfo.dwData2, file, nil, nil, nil, 0.7)
		elseif 1 == type then
			luaShowTipHaveIcon(strTip, "*5"..item:getName().."Lv"..itemInfo.dwData2, file, L("str9165"), 1,onDropBtnClick, 0.7)
			m_curIdItem = itemId;
		elseif 2 == type then
			local tabelStr = L("str0118").."_"..L("str30161");
			luaShowTipHaveIcon(strTip, "*5"..item:getName().."Lv"..itemInfo.dwData2, file, tabelStr, 2,onWearBtnClick, 0.7)
			m_curIdItem = itemId;
		end
		
	end
end

----------------消息处理区----------------
local function recvHunterInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
	
    local action = dt:readShort()	
	if action == ACTION_HUNT_SHOW then
		m_dwEffect = dt:readInt();
		local wndCtrl = getCurentSceneWindowController(6006);
		if wndCtrl then
			Hunter2_sendEffectAll(m_dwEffect);
		end
	elseif action == ACTION_HUNT_GETSHOW then
	elseif action == ACTION_HUNT_EATFAST then
		local idItem = dt:readInt();
		Hunter2_refreshHunterTmpBag();
	elseif action == ACTION_HUNT_ISFIRST then
        m_hunterflag = dt:readInt()
	elseif action == ACTION_HUNT_BATCH_SWALLOW then
		local id = dt:readInt()
		Hunter6.refreshWnd()
	elseif action == ACTION_HUNT_GOD_HUNT_ACTIVE then
		local godHunterFlg = dt:readInt()
		showGodHunterTip(m_godHunterId,godHunterFlg,m_godHunterTipOpenType)
	end
end
--传是否第一次标记
function send_hunterflag()
    return m_hunterflag;
end 
----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recvHunterInfo, _MSG_HUNTER, 0, nil)
----------------全局函数区----------------
function Hunter_showHunterWnd()
	local wndCtrl = getCurentSceneWindowController(6004);
	if wndCtrl then
		return;
	end
	
	local wnd = Hunter.initControl();
	if wnd then
		wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            m_curPlayIndex = 0;
            naviCtrl:pushWindowController(wndCtrl);
            wnd:setFrameVisibled(false)
			creatHunterBag();
			eventForButton();
			unlockHunterByLevel();
			refreshHunterWnd();
			refreshName();
			initBtnEvent();
			
        end
	end
    SCActivityIndicator:getSingleton():close();
end

function Hunter_showHunterWnd1()
    Hunter_showHunterWnd();
    onHuntGetBtnClick();
end

function Hunter_refreshHunterWnd()
	clearHunterBag();
	clearHunterEquip();
	refreshHunterWnd();
end

function Hunter.wndCloss()
    --m_dwEffect = nil;
    m_curIdItem = nil;
end


--函数调用