--定义一个与文件名相同的table
IntegralReward = {}
------------------消息--------------------

----------------结构定义区----------------
local tMsg_Info11 = {
    initWithStream = function(dt)
        local tmp = {}
		if not dt then
			return tmp
		end
		tmp.uEventStartTime = dt:readInt() 
		tmp.uEventFinishTime = dt:readInt()
		tmp.nIntegral = dt:readInt()
		tmp.pEventName = dt:readString()
        if tmp.pEventName then
			tmp.pEventName = tmp.pEventName:getData()
		else
			tmp.pEventName = " "
		end
		tmp.szDescribe = dt:readString()
        if tmp.szDescribe then
			tmp.szDescribe = tmp.szDescribe:getData()
		else
			tmp.szDescribe = " "
		end
		return tmp
	end 
}

local LimitGiftInfo = {
    initWithStream = function(dt)
        local tmp = {}
		if not dt then
			return tmp
		end
		tmp.idItemType = dt:readInt()
		tmp.nCost = dt:readInt()
		tmp.ByFlag = dt:readByte()
		return tmp
    end 
}

local Msg_tInfo25 = {
    initWithStream = function(dt)
        local tmp = {}
		if not dt then
			return tmp
		end
		tmp.nData = dt:readInt()
		tmp.ucAmount = dt:readByte()
		tmp.LimitGiftInfo = {}
        if tmp.ucAmount < 1 then
            tmp.ucAmount = 1
        end

        for i = 1,tmp.ucAmount do
            table.insert(tmp.LimitGiftInfo, LimitGiftInfo.initWithStream(dt))
        end

        return tmp
    end 
}

----------------常量定义区----------------
local MSG_TOP_UP_INTEGRAL         = 44 --//积分奖励 

----------------变量定义区----------------
local m_nowUnlockType = nil   --//当前类型
local m_limitGiftInfo = {}
--变量的定义
----------------UI控制器区----------------
function IntegralReward.initControl()
	local pWindow4100 = SCWindow:window()
	if pWindow4100 then
		pWindow4100:setTag(4100)
		pWindow4100:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4100:setPosition(AUTO_POS(0.00, 0.00))pWindow4100:setContentSize(AUTO_SIZE(480, 320))
		pWindow4100:luaSetSelectorOnClose(IntegralReward.releaseControl)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(4.00, 20.00))
		pDragNode2:setContentSize(AUTO_SIZE(472, 280))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTyperedwindowstip)
	end

	local imgPath = getRealUIResourcePath("kernal/redtop.png")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage3:setPosition(AUTO_POS(131.00, 261.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00703.png")
	IntegralReward.m_image = nil
	if imgPath then
		IntegralReward.m_image = SCImage:imageWithFile(imgPath:getData())
		if IntegralReward.m_image then
			IntegralReward.m_image:setTag(4)
			IntegralReward.m_image:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			IntegralReward.m_image:setPosition(AUTO_POS(205.00, 260.00))
		end
	end

	local pLable5 = SCLabel:labelWithStringFont(L("str3048"), DEFAULT_FONT_NAME, F(12))
	if pLable5 then
		pLable5:setTag(5)
		pLable5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable5:setPosition(AUTO_POS(40.00, 240.00))
		pLable5:setColor(ccc4(255,252,0,255))
	end

	IntegralReward.m_nameLabel = SCLabel:labelWithStringFont(L("   "), DEFAULT_FONT_NAME, F(12))
	if IntegralReward.m_nameLabel then
		IntegralReward.m_nameLabel:setTag(6)
		IntegralReward.m_nameLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		IntegralReward.m_nameLabel:setPosition(AUTO_POS(120.00, 240.00))
		IntegralReward.m_nameLabel:setColor(ccc4(255,132,0,123))
	end

	local pLable7 = SCLabel:labelWithStringFont(L("str3049"), DEFAULT_FONT_NAME, F(12))
	if pLable7 then
		pLable7:setTag(7)
		pLable7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable7:setPosition(AUTO_POS(40.00, 218.00))
		pLable7:setColor(ccc4(255,252,0,255))
	end

	IntegralReward.m_timeLabel = SCLabel:labelWithStringFont(L("   "), DEFAULT_FONT_NAME, F(12))
	if IntegralReward.m_timeLabel then
		IntegralReward.m_timeLabel:setTag(8)
		IntegralReward.m_timeLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		IntegralReward.m_timeLabel:setPosition(AUTO_POS(120.00, 218.00))
		IntegralReward.m_timeLabel:setColor(ccc4(255,255,255,255))
	end

	local pLable9 = SCLabel:labelWithStringFont(L("str3050"), DEFAULT_FONT_NAME, F(12))
	if pLable9 then
		pLable9:setTag(9)
		pLable9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable9:setPosition(AUTO_POS(40.00, 196.00))
		pLable9:setColor(ccc4(255,252,0,255))
	end

	local pLable11 = SCLabel:labelWithStringFont(L("str3051"), DEFAULT_FONT_NAME, F(12))
	if pLable11 then
		pLable11:setTag(11)
		pLable11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable11:setPosition(AUTO_POS(210.00, 126.00))
		pLable11:setColor(ccc4(255,252,0,255))
	end

	IntegralReward.m_droNode = SCDragNode:node()
	if IntegralReward.m_droNode then
		IntegralReward.m_droNode:setTag(12)
		IntegralReward.m_droNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		IntegralReward.m_droNode:setPosition(AUTO_POS(36.00, 15.00))
		IntegralReward.m_droNode:setContentSize(AUTO_SIZE(400, 110))
		IntegralReward.m_droNode:setFrameVisibled(true)
		IntegralReward.m_droNode:setDragEnabled(false)
		IntegralReward.m_droNode:setFrameType(EnumFrameTypeRound)
	end

	IntegralReward.m_numLabel = SCLabel:labelWithStringFont(L("str3052"), DEFAULT_FONT_NAME, F(12))
	if IntegralReward.m_numLabel then
		IntegralReward.m_numLabel:setTag(13)
		IntegralReward.m_numLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		IntegralReward.m_numLabel:setPosition(AUTO_POS(320.00, 3.00))
		IntegralReward.m_numLabel:setColor(ccc4(60,255,0,255))
	end

	IntegralReward.m_closeBtn = SCButton:button(EnumBtnTypeNormalImg)
	if IntegralReward.m_closeBtn then
		IntegralReward.m_closeBtn:setTag(1)
		IntegralReward.m_closeBtn:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		IntegralReward.m_closeBtn:setPosition(AUTO_POS(449.00, 259.00))
		IntegralReward.m_closeBtn:setContentSize(AUTO_SIZE(20, 20))
		local imgPath = getRealUIResourcePath("img/new00123.png")
		if imgPath then
			IntegralReward.m_closeBtn:setTitle(imgPath:getData())
		end
	end

	IntegralReward.m_textbox = SCTextBox:boxWithWidthHeightFont(AUTO_W(310), AUTO_H(64), DEFAULT_FONT_NAME, F(12))
	if IntegralReward.m_textbox then
		tolua.cast(IntegralReward.m_textbox, "SCNode"):setTag(10)
		tolua.cast(IntegralReward.m_textbox, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(IntegralReward.m_textbox, "SCNode"):setPosition(AUTO_POS(120.00, 144.00))
		IntegralReward.m_textbox:setText(L(""))
	end

	if pDragNode2 and pWindow4100 then
		pWindow4100:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pImage3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if IntegralReward.m_image and pDragNode2 then
		pDragNode2:addChild(tolua.cast(IntegralReward.m_image, "SCNode"))
	end
	if pLable5 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable5, "SCNode"))
	end
	if IntegralReward.m_nameLabel and pDragNode2 then
		pDragNode2:addChild(tolua.cast(IntegralReward.m_nameLabel, "SCNode"))
	end
	if pLable7 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable7, "SCNode"))
	end
	if IntegralReward.m_timeLabel and pDragNode2 then
		pDragNode2:addChild(tolua.cast(IntegralReward.m_timeLabel, "SCNode"))
	end
	if pLable9 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable9, "SCNode"))
	end
	if pLable11 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable11, "SCNode"))
	end
	if IntegralReward.m_droNode and pDragNode2 then
		pDragNode2:addChild(tolua.cast(IntegralReward.m_droNode, "SCNode"))
	end
	if IntegralReward.m_numLabel and pDragNode2 then
		pDragNode2:addChild(tolua.cast(IntegralReward.m_numLabel, "SCNode"))
	end
	if IntegralReward.m_closeBtn and pDragNode2 then
		pDragNode2:addChild(tolua.cast(IntegralReward.m_closeBtn, "SCNode"))
	end
	if IntegralReward.m_textbox and pDragNode2 then
		pDragNode2:addChild(tolua.cast(IntegralReward.m_textbox, "SCNode"))
	end
	return pWindow4100
end
function IntegralReward.releaseControl()
	IntegralReward.m_image = nil
	IntegralReward.m_nameLabel = nil
	IntegralReward.m_timeLabel = nil
	IntegralReward.m_droNode = nil
	IntegralReward.m_numLabel = nil
	IntegralReward.m_closeBtn = nil
	IntegralReward.m_textbox = nil
	if IntegralReward.wndClose then
		IntegralReward.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
--点击关闭
local function onCloseBtnClick(tag)
	local wndCtrl = getCurentSceneWindowController(4100);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end	
end
--点击兑换
local function convertBtnClick(tag)
    local tmpTag = getIntPart(tag/10)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    if dataStream then
        dataStream:writeShort(USERINFO_LIMIT_ACTIVE_GIFT)
        dataStream:writeByte(tmpTag)
        dataStream:writeInt(m_nowUnlockType)
        SCDataTransThread:getSingleton():transData(dataStream)
    end
end
--//显示物品TIP
local function checkGoods(tag)
    local idType =  m_limitGiftInfo[tag].idItemType
    showTip(idType)
end

local function notConvert(tag)
    showMessage(_LTParser("str3060"))
end
local function numToTime(num)
    local tmp = getIntPart(num/100000000)
    local time = "20"..tmp..L("str3055")
    tmp = getIntPart(num % 100000000 / 1000000)
    time = time..tmp..L("str3056")
    tmp = getIntPart(num % 1000000 / 10000)
    time = time..tmp..L("str3057")
    tmp = getIntPart(num % 10000 / 100)
    time = time..tmp..L("str3058")
    tmp = getIntPart(num % 100)
    if tmp > 0 then
        time = time..tmp..L("str3059")
    end
    return time
end
local function ShowWndMsgInfo(tmp)
    local wndCtrl = getCurentSceneWindowController(4100)
    if wndCtrl then
       local pLabel6 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-6"), "SCLabel")
       if pLabel6 then
            pLabel6:setText(tmp.pEventName)
       end
       local pLabel8 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-8"), "SCLabel")
       if pLabel8 then
            local startTime = numToTime(tmp.uEventStartTime)
            local finishTime = numToTime(tmp.uEventFinishTime)
            pLabel8:setText(startTime.."-"..finishTime)
       end
       local pTextBox10 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-10"), "SCTextBox")
       if pTextBox10 then
            pTextBox10:setText(tmp.szDescribe)
       end
    end
end
local function ShowRewardMsgInfo(tmp)
    local wndCtrl = getCurentSceneWindowController(4100)
    if wndCtrl then
        local pLabel13 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-13"), "SCLabel")
        if pLabel13 then
            if UNLOCK_TYPE_TYPE58 == m_nowUnlockType then --充值积分兑换
                pLabel13:setText(L("str3053")..tmp.nData)
            elseif UNLOCK_TYPE_TYPE60 == m_nowUnlockType then --消费积分兑换
                pLabel13:setText(L("str3052")..tmp.nData)
            end
        end
        local pDragNode12 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-12"), "SCDragNode")
        if pDragNode12 then
            local goodsNode = pDragNode12:getChildByTag(99)
            if goodsNode then
                for i = 1, #tmp.LimitGiftInfo do
                    local tTag = i*10 + 1
                    local tDroNode = SCTypeCast:castNodeToDragNode(goodsNode:getChildByTag(tTag))
                    if tDroNode then
                        local filebg = getRealUIResourcePath("img/new00002.png")
                        local filesl = getRealUIResourcePath("img/new00003.png")
                        local infoItem = TableParser:getSingleton():getItemInfoByKey(tmp.LimitGiftInfo[i].idItemType)
                        local fileTitle = nil
                        if infoItem then
                            local idIcon = infoItem.icon
                            fileTitle = getRealUIResourcePath("item/" .. idIcon .. ".jpg")
                        end
                        
                        if filebg and filesl then
                            local goodsBtn = SCButton:button()
                            if goodsBtn then
                                m_limitGiftInfo[i] = {}
                                m_limitGiftInfo[i].idItemType = tmp.LimitGiftInfo[i].idItemType
                                goodsBtn:setTag(i)
                                goodsBtn:setAnchorPoint(CCPointMake(0.5, 0.5))
                                goodsBtn:setPosition(CCPointMake(tDroNode:getContentSize().width / 2, tDroNode:getContentSize().height / 2))
                                if fileTitle then
                                    goodsBtn:setTitle(fileTitle:getData())
                                end
                                goodsBtn:setBackgroundImage(filebg:getData())
                                goodsBtn:setSelectedImage(filesl:getData())
                                goodsBtn:luaSetSelectorOnClicked(checkGoods)
                                tDroNode:addChild(goodsBtn)
                            end
                        end
                    end
                    tTag = tTag + 1
                    local tLabel = SCTypeCast:castNodeToLabel(goodsNode:getChildByTag(tTag))
                    if tLabel then
                        tLabel:setText(L("str3054")..tmp.LimitGiftInfo[i].nCost)
                        if tmp.nData < tmp.LimitGiftInfo[i].nCost then
                            tLabel:setColor(getColorRed())
                        else
                            tLabel:setColor(getColorOrange())
                        end
                    end 
                    tTag = tTag + 1
                    local tBtn = SCTypeCast:castNodeToButton(goodsNode:getChildByTag(tTag))
                    if tBtn then
                        if tmp.nData < tmp.LimitGiftInfo[i].nCost then
                            tBtn:luaSetSelectorOnClicked(notConvert)
                        else
                            tBtn:luaSetSelectorOnClicked(convertBtnClick)
                        end
                    end
                end
            end
        end
    end
end

----------------消息处理区----------------

local function recvShowRewardMsgInfo(tmp)
    local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
	    return
	end
	ShowRewardMsgInfo(Msg_tInfo25.initWithStream(dt))
end
local function recvShowWndMsgInfo(tmp)
    local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
	    return
	end
	ShowWndMsgInfo(tMsg_Info11.initWithStream(dt))
end
function IntegralReward_SendMsg(UnlockType)
    if luaIsUnlock(UnlockType) then
        IntegralReward_WndCreate(UnlockType)
        local unInfo = luaGetUnlockInfoWithType(UnlockType)
        if unInfo.usData then
            local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION)
            if dataStream then
                dataStream:writeShort(MSG_TOP_UP_INTEGRAL)
                dataStream:writeInt(unInfo.usData)
                SCDataTransThread:getSingleton():transData(dataStream)
            end
        end
    end
end
----------------消息注册区----------------
LuaData:getSingleton():luaSetSelectorOnRecvData(recvShowRewardMsgInfo, LuaData_USERINFO_LIMIT_ACTIVE_GIFT)
LuaData:getSingleton():luaSetSelectorOnRecvData(recvShowWndMsgInfo, LuaData_MSG_TOP_UP_INTEGRAL)
----------------全局函数区----------------
function IntegralReward_WndCreate(UnlockType)
    local wndCtrl = getCurentSceneWindowController(4100)
    if wndCtrl then
        return
    end
    m_nowUnlockType = UnlockType
    local wnd = IntegralReward.initControl()
    if wnd then
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()        
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
        end
        wnd:setBackButtonVisibled(false);
		wnd:setCloseButtonVisibled(false);
		wnd:setFrameVisibled(false)
		
		local pButton1 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-1"), "SCButton")
        if pButton1 then
            pButton1:setMusicPath("closeWindow.mp3");
			pButton1:luaSetSelectorOnClicked(onCloseBtnClick);
			pButton1:setTouchRectScale(4.0,4.0)
		end
		local pImage4 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-4"), "SCImage")
		if pImage4 then
		    local imgPath = nil
		    if UNLOCK_TYPE_TYPE58 == UnlockType then  --充值积分兑换
		        --imgPath = getRealUIResourcePath("event/new00689.pn")
		    elseif UNLOCK_TYPE_TYPE60 == UnlockType then   --消费积分兑换
		        --imgPath = getRealUIResourcePath("event/new00695.pn")
		    end
		    if imgPath then
		        --pImage4:setImage(imgPath:getData())
		    end
		end
		local pDragNode12 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-12"), "SCDragNode")
		if pDragNode12 then
            local goodsNode = IntegralReward1.initControl()
            if goodsNode then
                goodsNode:setTag(99)
                goodsNode:setPosition(CCPointMake(SX(0), SY(0)))
                pDragNode12:addChild(goodsNode)
            end
        end
        local pTextBox10 = tolua.cast(SCFunction:getUiNodeByIdlist("4100-2-10"), "SCTextBox")
        if pTextBox10 then
            pTextBox10:setParserDelegate(TextParser:getSingleton());
        end
    end
end

function IntegralReward_WndMsg(dt)
    createWndMsgInfo(tMsg_Info11.initWithStream(dt))
end
function IntegralReward.wndClose()
    m_nowUnlockType = nil   --//当前类型
    m_limitGiftInfo = {}
end
--函数调用