--过场切屏等待动画 8005界面

local m_updateEntryId = nil--定时器id
local m_isMapLoadOk = nil--地图加载完成
local m_currentTime = nil
local m_helpDetailStr = nil
local m_percentValue = nil
local m_percentMaxValue = 264
local m_Photoid = nil
local m_Name = nil
local MAPTYPE_REHEARSE_MAP = 32768
local MAPTYPE_ARENA = 33554432
local MAPTYPE_SYN_CAMPAIGN_WAR = 67108864
local MAPTYPE_YANWUFIELD_MAP = 1073741824
local YMTJ_PVP = 14

--移除窗口
local function remove_LoadingScreen()
    m_percentValue = nil
    m_currentTime = nil
    m_helpDetailStr = nil
    m_Photoid = nil
    m_Name = nil
    m_isMapLoadOk = nil--地图加载完?
    
    if m_updateEntryId then--关闭定时器
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_updateEntryId)
        m_updateEntryId = nil
    end
    
    local scene = SCBaseScene:getRunningScene()
    if scene then
        scene:getUINode():removeChildByTag(8005, true)--窗口移除
        local child = scene:getUINode():getChildByTag(Hero:getSingleton():getID());
        if child then
            child:setVisible(true);
        end
    end
    if Hero:getSingleton():getBatter() == false then
        showPlayerLevelUpAnimation()
    end
    BattleFailure();
	if GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_REHEARSE_MAP) then
		SCPay:getSingleton():statisticalInterface(YMTJ_PVP, "MAPTYPE_REHEARSE_MAP");
	elseif GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_ARENA) then
		SCPay:getSingleton():statisticalInterface(YMTJ_PVP, "MAPTYPE_ARENA");
	elseif GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_SYN_CAMPAIGN_WAR) then
		SCPay:getSingleton():statisticalInterface(YMTJ_PVP, "MAPTYPE_SYN_CAMPAIGN_WAR");
	elseif GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_YANWUFIELD_MAP) then 
		SCPay:getSingleton():statisticalInterface(YMTJ_PVP, "MAPTYPE_YANWUFIELD_MAP");
	end
end

local function refreshHelpInfoDetail(textPosx, textPosy)
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    
    local frameWndNode = scene:getUINode():getChildByTag(8005)
    if frameWndNode == nil then
        return
    end
    
    local showTextLabel = frameWndNode:getChildByTag(800501)
    if showTextLabel then
        return
    end
    
    local pDragNode = frameWndNode:getChildByTag(1);
    if pDragNode == nil then
        return;
    end
    
    if m_Photoid>=1000000 and m_Photoid<=9999999 then
        local pNode1 = SCFunction:getUiNodeByIdlistAndParent("10047", pDragNode)
        if pNode1 then
            local pNode2 = SCFunction:getUiNodeByIdlistAndParent("10049", pNode1)
            if m_helpDetailStr and pNode2 then
                showTextLabel = SCTextBox:boxWithWidthHeight(AUTO_W(170), AUTO_H(105));
                if showTextLabel then
                    showTextLabel:setTag(800501)
                    showTextLabel:setAnchorPoint(CCPointMake(0,1))
                    showTextLabel:setPosition(AUTO_POS(13, 115))
                    showTextLabel:setText(L(m_helpDetailStr))
                    pNode2:addChild(showTextLabel)
                end
            end
        end
    else
        local window_Width  = frameWndNode:getContentSize().width
        local window_Height = frameWndNode:getContentSize().height
        if m_helpDetailStr then
            showTextLabel = SCTextBox:boxWithWidthHeight(AUTO_W(200), AUTO_H(100));
            if showTextLabel then
                showTextLabel:setTag(800501)
                showTextLabel:setAnchorPoint(CCPointMake(0,1))
                showTextLabel:setPosition(CCPointMake(textPosx,textPosy+20))
                showTextLabel:setText(L(m_helpDetailStr))
                pDragNode:addChild(showTextLabel)
            end
        end
    end
end

local function refreshProgress()
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    
    local frameWndNode = scene:getUINode():getChildByTag(8005)
    if frameWndNode == nil then
        return
    end 
    
    local pNode = frameWndNode:getChildByTag(1);
    if pNode then
        local sBarImage = SCTypeCast:castNodeToImage(pNode:getChildByTag(800502));
        if sBarImage then
            if m_percentValue > m_percentMaxValue then
                m_percentValue = m_percentMaxValue
            end
            local imgPath = getRealUIResourcePath("img/new00423.png")
            if imgPath then
                sBarImage:setImage(imgPath:getData(), CCRectMake(0, 0, SX(m_percentValue), SY(18)));
            end
        end
    end
end

--倒计时时间到
local function updateTime()
    if m_currentTime == nil then
        return
    end
    m_currentTime = m_currentTime + 0.5
    if m_isMapLoadOk == true then--地图加载完成
        if m_currentTime >= 5 then--大于3秒关闭
            remove_LoadingScreen()
            return
        end
    else
        m_percentValue = m_percentValue + 30
    end
    refreshProgress()
end

local function onLoadingScreenClose(tag)
	ChatProcessor:getSingleton():starShowMessage()
end

--打开界面，外部调用
function open_LoadingScreen()
    if m_Photoid == nil then
        return;
    end
    
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    
    local uiNode = scene:getUINode();
    if uiNode == nil then
        return
    end
    
    local frameWndNode = uiNode:getChildByTag(8005)
    if frameWndNode then
        return
    end 
    
    m_percentValue = 60
    local window_Width  = SCREEN_SIZE.width;
    local window_Height = SCREEN_SIZE.height;
    frameWndNode = FrameWindow:frameWnd()
    if frameWndNode == nil then
        return;
    end
    
    frameWndNode:setTag(8005)
    frameWndNode:setOutSpaceClickClose(false)--设置点击空白不响应
    frameWndNode:setContentSize(CCSizeMake(window_Width, window_Height))
    frameWndNode:setFrameVisibled(false)--去除边框
    frameWndNode:setCloseBtnVisible(false)--去除按钮
	frameWndNode:luaSetReturnSelector(onLoadingScreenClose)
	frameWndNode:removeAllChildrenWithCleanup(true);
    uiNode:addChild(frameWndNode, Max_Int)
   
    --背景图片
    local imgFile = getRealUIResourcePath("img/new00424.pn");
    if imgFile then
        local bgImage = SCImage:imageWithFile(imgFile:getData()) 
        if bgImage then
            bgImage:setVisible(true)
            bgImage:setAnchorPoint(CCPointMake(0.5,0.5));
            local x = window_Width / bgImage:getContentSize().width;
            local y = window_Height / bgImage:getContentSize().height;
            bgImage:setScaleX(x)
            bgImage:setScaleY(y)
            bgImage:setPosition(CCPointMake(window_Width/2, window_Height/2));
            frameWndNode:addChild(bgImage)   
        end
    end
    
    local pDragNode = SCDragNode:node();
    if pDragNode == nil then
        return
    end
    
    pDragNode:setTag(1);
    pDragNode:setAnchorPoint(ANCHOR_CENTER)
    pDragNode:setContentSize(AUTO_SIZE(360, 240))
    pDragNode:setPosition(CCPointMake(window_Width/2, window_Height/2));
    frameWndNode:addChild(pDragNode)  

    local nPosx = 0;
    local nPosy = 0;
    local perImage = nil;
	if m_Photoid>=1000000 and m_Photoid<=9999999 then
        local imgPath = getRealUIResourcePath("PlotPhoto/"..m_Photoid..".pn")
        if imgPath then
            perImage = SCImage:imageWithFile(imgPath:getData())
        end
        nPosx = 9;
        nPosy = 106;
	    
	    local pImageFile = getRealUIResourcePath("kernal/Tip.png");
        local pTxtFile = getRealUIResourcePath("kernal/Tip.ini");
        local pDragNode10047 = SCDragNode:node()
        if pDragNode10047 then
            pDragNode10047:setTag(10047)
            pDragNode10047:setAnchorPoint(ANCHOR_CENTER)
            pDragNode10047:setPosition(CCPointMake(pDragNode:getContentSize().width/2, pDragNode:getContentSize().height/2 + SY(37)))
            pDragNode10047:setContentSize(AUTO_SIZE(345, 170))
            if pTxtFile and pImageFile then
                pDragNode10047:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
            end
            pDragNode10047:setFrameVisibled(true);
            pDragNode10047:setDragEnabled(false)
            pDragNode:addChild(pDragNode10047)  
        end
        
        local pImageFile = getRealUIResourcePath("kernal/Tip3.png");
        local pTxtFile = getRealUIResourcePath("kernal/Tip3.ini");
        local pDragNode10048 = SCDragNode:node()
        if pDragNode10048 then
            pDragNode10048:setTag(10048)
            pDragNode10048:setAnchorPoint(ANCHOR_CENTER)
            pDragNode10048:setPosition(CCPointMake(pDragNode10047:getContentSize().width/2 - SX(97), pDragNode10047:getContentSize().height/2))
            pDragNode10048:setContentSize(AUTO_SIZE(130, 150))
            if pTxtFile and pImageFile then
                pDragNode10048:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
            end
            pDragNode10048:setFrameVisibled(true);
            pDragNode10048:setDragEnabled(false)
            pDragNode10047:addChild(pDragNode10048)  
        end
        
        local pDragNode10049 = SCDragNode:node()
        if pDragNode10049 then
            pDragNode10049:setTag(10049)
            pDragNode10049:setAnchorPoint(ANCHOR_CENTER)
            pDragNode10049:setPosition(CCPointMake(pDragNode10047:getContentSize().width/2 + SX(63), pDragNode10047:getContentSize().height/2))
            pDragNode10049:setContentSize(AUTO_SIZE(200, 150))
            if pTxtFile and pImageFile then
                pDragNode10049:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
            end
            pDragNode10049:setFrameVisibled(true);
            pDragNode10049:setDragEnabled(false)
            pDragNode10047:addChild(pDragNode10049)  
        end
        
        if m_Name then
            local Label = SCLabel:labelWithStringFont(m_Name, DEFAULT_FONT_NAME, F(15));
            if Label then
                Label:setColor(color_orange)
                Label:setAnchorPoint(CCPointMake(0, 0.5))
                Label:setPosition(AUTO_POS(13, 130))
                pDragNode10049:addChild(Label)
            end
        end
	else
	    local imgPath = getRealUIResourcePath("MainInterfaceImg/"..m_Photoid..".pn")
	    if imgPath then
	        perImage = SCImage:imageWithFile(imgPath:getData())
	    end
	    if m_Photoid == 5002 or m_Photoid == 5003 or m_Photoid == 5005 or m_Photoid == 5007 or m_Photoid == 5008 or m_Photoid == 5009 or m_Photoid == 5011 or m_Photoid == 5012 or m_Photoid == 5014 or m_Photoid == 5016 or m_Photoid == 5018 or m_Photoid == 5019 or m_Photoid == 5020 or m_Photoid == 5021 or m_Photoid == 5033 or m_Photoid == 5034 then
            nPosx = 47;
            nPosy = 23;
        elseif m_Photoid == 5000 then
            nPosx = 64;
            nPosy = 36;
        else
            nPosx = 64;
            nPosy = 30;
        end
	    
	    local appName = getAppName():getData();
	    local imgPath1 = nil;
	    if string.match(appName, "IOS") then
	        imgPath1 = getRealUIResourcePath("common/../img2073.pn")
	        if not imgPath1 then
          	 imgPath1 = getRealUIResourcePath("img/img2073.pn")
          end
	    else
	        if CLIENT_VERSION >328 then
               		imgPath1 = getRealUIResourcePath("imgBK/img2073.pn")
          	else
          	        imgPath1 = getRealUIResourcePath("imgBK/img2073.pn")
          	        if not imgPath1 then
          	           imgPath1 = getRealUIResourcePath("img/img2073.pn")
          	        end
               		
         	 end
	    end
	    
	    if imgPath1 then
            local pLogImg = SCImage:imageWithFile(imgPath1:getData());
            if pLogImg then
                pLogImg:setAnchorPoint(CCPointMake(0.5,0.5));
                pLogImg:setPosition(CCPointMake(pDragNode:getContentSize().width/2, SY(170)));
                pDragNode:addChild(pLogImg) 
            end
        end
	end
	
	local textPosx = 0;
    local textPosy = 0;
	if perImage then
	    if m_Photoid>=1000000 and m_Photoid<=9999999 then
	        local pNode1 = SCFunction:getUiNodeByIdlistAndParent("10047", pDragNode)
	        if pNode1 then
	            local pNode2 = SCFunction:getUiNodeByIdlistAndParent("10048", pNode1)
	            if pNode2 then
	                pNode2:addChild(perImage);
	                perImage:setAnchorPoint(CCPointMake(0.5, 0));
	                perImage:setPosition(CCPointMake(pNode2:getContentSize().width/2, SY(8)))
	            end
	        end
	    else
	        perImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
	        perImage:setPosition(AUTO_POS(nPosx, nPosy));
	        pDragNode:addChild(perImage)
	    end 
		
		textPosx = SX(nPosx) + perImage:getContentSize().width+SX(5);
		textPosy = SY(nPosy) + perImage:getContentSize().height*3/4;
	end
    
    ----进度条
    local imgPath = getRealUIResourcePath("img/new00422.png")
    if imgPath then
        local sFraImage = SCImage:imageWithFile(imgPath:getData())
        if sFraImage then
            sFraImage:setAnchorPoint(ANCHOR_CENTER)
            sFraImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2, SY(11)))
            sFraImage:setContentSize(AUTO_SIZE(264, 18))
            pDragNode:addChild(sFraImage) 
        end
    end
	
	local imgPath1 = getRealUIResourcePath("img/new00423.png")
	if imgPath1 then
        local sBarImage = SCImage:imageWithFile(imgPath1:getData(), CCRectMake(0, 0, SX(m_percentValue), SY(18)));
        if sBarImage then
            sBarImage:setTag(800502)
            sBarImage:setAnchorPoint(CCPointMake(0, 0.5))
            sBarImage:setPosition(CCPointMake(SX(48), SY(11)))
            sBarImage:setContentSize(AUTO_SIZE(264, 18))
            pDragNode:addChild(sBarImage)
        end
    end
    
    m_isMapLoadOk = false
    m_currentTime = 0
    
    if m_updateEntryId == nil then
        m_updateEntryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updateTime, 0.5, false) --启动定时器，0.5秒刷一次 
    end
    
    refreshHelpInfoDetail(textPosx, textPosy);
end


--关闭界面,外部调用
function coloseWnd_LoadingScreen()
    m_isMapLoadOk = true
    m_percentValue = m_percentMaxValue
end


local function recStageHelpMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end

	local action = dt:readByte();
	local idHelp = dt:readInt();
	local stHelp = TableParser:getSingleton():getHelp(idHelp);
	m_Photoid = stHelp.photoid;
	m_Name = stHelp.name:getData()
	m_helpDetailStr = stHelp.text:getData()
    --[[local action = dt:readByte();
    if action == 3 then--切屏提示内容
        m_helpDetailStr = nil
        local detail = dt:readString()
        if detail then
            m_helpDetailStr = detail:getData();
        end
    end
    
    m_Name = nil
    m_Photoid = dt:readInt();
    local detail = dt:readString()
    if detail then
        m_Name = detail:getData();
    end]]
end

SCMessageCenter:getSingleton():luaRegistCommand(recStageHelpMsg, _MSG_STAGEHELP, 0, nil);