--8006邮件窗口
MailScreen = {}
local m_wnd = nil

local m_mailListcurrentPage = nil--当前页
local m_mailListMaxPage = nil--最大页数
local m_mailPageAmount = nil--每页个数

local m_mailList = nil--邮件列表数据
local m_totalAmount = nil--邮件总个数

local m_mailDetail = nil--当前选择邮件详情

local m_initPoint = nil--窗口初始坐标
local m_moveUpHeight = nil--点击输入框上移高度

local m_openType = nil--m_openType=5公会邮件

local m_currentTabIndex = nil

local MAILACTION_ACCEPT_ALL	= 7	--//接收全部邮件
local m_isReply = nil

--界面关闭
local function coloseWnd_MailScreen()
    m_wnd = nil

    m_mailListcurrentPage = nil--当前页
    m_mailListMaxPage = nil--最大页数
    m_mailPageAmount = nil--每页个数

    m_mailList = nil--邮件列表数据
    m_totalAmount = nil--邮件总个数

    m_mailDetail = nil--当前选择邮件详情
    
    m_initPoint = nil
    m_moveUpHeight = nil
    m_openType = nil
    
    m_currentTabIndex = nil
    m_isReply = nil
end

local function createListMenuItem(showWidth,showHeight,mailId,type,sendName,title,timeStr,idObj)
    local contentLayer = SCButton:button(EnumBtnTypeNormalImg)
	contentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
    local clickBtn = SCButton:button(EnumBtnTypeNormalImg)
	clickBtn:setContentSize(CCSizeMake(showWidth*1,showHeight))
	clickBtn:setAnchorPoint(CCPointMake(0,0));
    clickBtn:setPosition(CCPointMake(0,0));
	contentLayer:addChild(clickBtn)
	
	local clickBtn2 = SCButton:button(EnumBtnTypeNormalImg)
	clickBtn2:setContentSize(CCSizeMake(showWidth*0.9,showHeight))
	clickBtn2:setAnchorPoint(CCPointMake(0,0));
    clickBtn2:setPosition(CCPointMake(showWidth*0.1,0));
	contentLayer:addChild(clickBtn2)
	
	local bgLayer = SCDragNode:node()
	bgLayer:setFrameVisibled(true)
	bgLayer:setFrameType(EnumFrameTypeListNormal)
	bgLayer:setContentSize(CCSizeMake(SX(427),SY(42)))
	contentLayer:addChild(bgLayer)
	
    local startX = SX(5)
    local startY = SY(10)
    
    --保存id
    local idLabel = SCLabel:labelWithStringFont(""..mailId,getDefaultFontName(), getFontSize(13))
    idLabel:setTag(100)
    idLabel:setVisible(false)
    contentLayer:addChild(idLabel)
    
    --全选框
    local checkLabel = SCCheckBox:box();
    checkLabel:setTag(200)
    checkLabel:setAnchorPoint(CCPointMake(0,0));
    checkLabel:setPosition(CCPointMake(startX,startY));
    contentLayer:addChild(checkLabel)
    
    startX = startX + checkLabel:getContentSize().width+SX(5)
    local imgFile = getRealUIResourcePath("img/new00426.png");
    if type == 1 then--已查看过
        imgFile = getRealUIResourcePath("img/new00427.png");
    end
    
    if imgFile then
        local imageLabel = SCImage:imageWithFile(imgFile:getData()) 
        imageLabel:setAnchorPoint(CCPointMake(0,0));
        imageLabel:setPosition(CCPointMake(startX,startY));
        contentLayer:addChild(imageLabel)
        startX = startX + imageLabel:getContentSize().width
    end
    
    if sendName == nil then
        sendName = ""
    end
     --发件人
    local titleLabel = SCLabel:labelWithStringFont(sendName,getDefaultFontName(), getFontSize(13))
    titleLabel:setAnchorPoint(CCPointMake(0,0));
    titleLabel:setPosition(CCPointMake(startX+SX(20),startY+SY(5)));
    contentLayer:addChild(titleLabel)

    if title == nil then
        title = ""
    end
    --主题
    
    titleLabel = SCLabel:labelWithStringFont(title,getDefaultFontName(), getFontSize(13))
    titleLabel:setAnchorPoint(CCPointMake(0.5,0));
    titleLabel:setPosition(CCPointMake(showWidth/2+SX(15),startY + SY(5)));
    contentLayer:addChild(titleLabel)
    
    local pTitle = ""
    local pColour = nil
    if type == 1 then--已查看过
		pTitle = L("str3321")
		pColour = getColorGreen()
	else
		pTitle = L("str3322")
		pColour = getColorRed()
    end
    local plabel = SCLabel:labelWithStringFont(pTitle,getDefaultFontName(), getFontSize(13))
    plabel:setAnchorPoint(CCPointMake(1,0));
    plabel:setPosition(CCPointMake(SX(0),SY(0)));
    plabel:setColor(pColour);
    titleLabel:addChild(plabel)
    
    if timeStr == nil then
        timeStr =""
    end
    --剩余时间
    titleLabel = SCLabel:labelWithStringFont(timeStr,getDefaultFontName(), getFontSize(13))
    titleLabel:setAnchorPoint(CCPointMake(0.5,0));
    titleLabel:setPosition(CCPointMake(showWidth*0.85,startY + SY(5)));
    contentLayer:addChild(titleLabel)
    
    if idObj > 0 then 
       --附件标记
        imgFile = getRealUIResourcePath("img/new00175.png"); 
        if imgFile then
            local imageLabel = SCImage:imageWithFile(imgFile:getData()) 
            imageLabel:setAnchorPoint(CCPointMake(0.5,0));
            imageLabel:setPosition(CCPointMake(showWidth*0.95,startY- SY(5)));
            contentLayer:addChild(imageLabel)
        end
    end
    
    return contentLayer,clickBtn,clickBtn2
end

local function cretateMenuItem(icon,usNum)    
	local menuItem = SCButton:button()
	menuItem:setContentSize(CCSizeMake(50,50))
	if tag then
	    menuItem:setTag(tag)
    end
	local imgFile = getRealUIResourcePath(Button_ImagePath);
	local backItem = nil
	if imgFile then
	    backItem = SCImage:imageWithFile(imgFile:getData())
	    backItem:setTag(1)
	    backItem:setVisible(false)
        menuItem:addChild(backItem)
	end
    local itemBtn = SCButton:button()
    if tag then
        itemBtn:setTag(tag)
    end
    if icon~=0 then
        local itemFile,rect = getItemImageByIcon(icon)
        if itemFile then
             itemBtn:setTitle(itemFile:getData(),rect)
        end
    end
    itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Normal_ImagePath):getData())
    itemBtn:setAnchorPoint(CCPointMake(0,0));
    itemBtn:setPosition(CCPointMake((menuItem:getContentSize().width-itemBtn:getContentSize().width)/2,menuItem:getContentSize().height-itemBtn:getContentSize().height-SY(5)));
    menuItem:addChild(itemBtn)
    if 0 < usNum then
        local pLabel = SCLabel:labelWithStringFont(usNum, getDefaultFontName(), F(12))
        if pLabel then
            pLabel:setAnchorPoint(CCPointMake(1,0));
            pLabel:setPosition(CCPointMake(itemBtn:getContentSize().width-SX(8),SY(5)))
            itemBtn:addChild(pLabel)
        end
    end
	return menuItem,itemBtn,backItem
end

--附件物品点击响应
local function itemButtonOtherAction()
    luaShowTipCpp(7,m_mailDetail.idObj)
end
local function itemButtonAction()
    if m_wnd == nil then
        return
    end
    
    ItemProcessor:getSingleton():sendLookOtherItem(m_mailDetail.idObj)
    if 1 == 1 then
        return;
    end

    if m_mailDetail == nil or m_mailDetail.szObjDescrib == nil then
        return
    end
    local showWidth  = SX(200)
    local showHeight = SY(160)
    local tmpX  = getScreenWidth()/2--当前屏幕宽
    local tmpY = getScreenHeight()/2--当前屏幕高
    

    local frameWndNode = FrameWindow:frameWnd()
    frameWndNode:setContentSize(CCSizeMake(showWidth, showHeight))
    frameWndNode:setOutSpaceClickClose(true)
    frameWndNode:setCloseBtnVisible(true)--是否显示关闭按钮
    frameWndNode:setAnchorPoint(CCPointMake(0.5, 0.5))
    frameWndNode:setPosition(CCPointMake(tmpX,tmpY))
	
	local detailLabel = SCTextBox:boxWithWidthHeightFont(showWidth*0.85,showHeight*0.9,getDefaultFontName(), getFontSize(14));
    detailLabel:setParserDelegate(TextParser:getSingleton())
    detailLabel:setAnchorPoint(CCPointMake(0,0));
    detailLabel:setPosition(CCPointMake(SX(10),showHeight-detailLabel:getContentSize().height-SY(15)));
    detailLabel:setText(m_mailDetail.szObjDescrib)
    detailLabel:setScrollHorizontal(false)
    detailLabel:setScrollVertical(false)
    frameWndNode:addChild(detailLabel)   
    
    m_wnd :addChild(frameWndNode)
end

--点击选择勾选所有邮件响应
local function checkDeleteAllAction(tag)
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = m_wnd:getChildByTag(800601);
    local isSelectAll = false
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(0)
        if contentLayer then
            local checkBox = contentLayer:getChildByTag(1)
            if checkBox then
                checkBox = SCTypeCast:castNodeToCheckBox(checkBox)
                isSelectAll = checkBox:isSelect()
                if tag == 9000 then
                    if isSelectAll == true then
                       checkBox:setSelect(false)
                       isSelectAll=false;
                    else
                       checkBox:setSelect(true)
                       isSelectAll=true;
                    end
                end
            end
            
            if isSelectAll ~= nil then
                for i=1,m_mailPageAmount do
                    local itemCheckBox = SCFunction:getUiNodeByIdlistAndParent("2-"..i.."-200",contentLayer)
                    if itemCheckBox then
                        itemCheckBox = SCTypeCast:castNodeToCheckBox(itemCheckBox)
                        itemCheckBox:setSelect(isSelectAll)
                    end
                end
            end
        end
    end
end


--点击复选框区域
local function mailListSelectAction(tag)
    if m_wnd ==nil then
        return;
    end
    local index = tag
    if index == nil then
        return
    end
    local multiTabLayer = m_wnd:getChildByTag(800601);
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(0)
        if contentLayer then
            local itemCheckBox = SCFunction:getUiNodeByIdlistAndParent("2-"..index.."-200",contentLayer)
            if itemCheckBox then
                itemCheckBox = SCTypeCast:castNodeToCheckBox(itemCheckBox)
                if itemCheckBox:isSelect() == true then
                    itemCheckBox:setSelect(false)
                else
                    itemCheckBox:setSelect(true)
                end
            end
        end
    end
end

--点击邮件列表
local function mailListClickAction(tag)
    if m_wnd ==nil then
        return;
    end
    local index = tag
    if m_mailList and index and m_mailList[index] then
        sendQuerMailDetailMsg(m_mailList[index].idMail);
    end
end

--刷新页码
local function refreshMailListPage()
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = m_wnd:getChildByTag(800601);
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(0)
        local pageLabel = contentLayer:getChildByTag(3)--邮件列表层
        if pageLabel then
            pageLabel = SCTypeCast:castNodeToLabel(pageLabel)
            if m_mailListcurrentPage == nil or m_mailListcurrentPage < 1 then
                m_mailListcurrentPage = 1
            end
            if m_mailListMaxPage == nil or m_mailListMaxPage < 1 then
                m_mailListMaxPage = 1
            end
            
            if m_mailListcurrentPage > m_mailListMaxPage then
                m_mailListcurrentPage = m_mailListMaxPage
            end
            pageLabel:setText(m_mailListcurrentPage.."/"..m_mailListMaxPage)
        end
    end
end

--上一页按钮响应
local function upPageButtonAction()
   
    if m_mailListcurrentPage then
        if (m_mailListcurrentPage-1)>0 then
            m_mailListcurrentPage = m_mailListcurrentPage-1
            sendQueryMailListMsg(m_mailListcurrentPage,m_mailPageAmount)
        else
            showMessage(_LTParser("str3064"))
        end
    end
end

--下一页按钮响应
local function nextPageButtonAction()
    if m_wnd ==nil then
        return;
    end
    if m_mailListMaxPage and m_mailListcurrentPage then
        if (m_mailListcurrentPage+1) <= m_mailListMaxPage then
            m_mailListcurrentPage = m_mailListcurrentPage + 1
            sendQueryMailListMsg(m_mailListcurrentPage,m_mailPageAmount)
        else
            showMessage(_LTParser("str3065"))
        end
    end
end

--点击好友按钮响应
local function friendButtonAction()
    NewFriends_MailOpenNewFriendsWnd()
end

--回复按钮点击响应
local function replyButtonAction()
    if m_mailDetail and m_mailDetail.szSender then
       m_isReply = true
       openSendMailWnd(m_mailDetail.szSender)
    end
end

--返回按钮点击响应
local function returnButtonAction()
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = m_wnd:getChildByTag(800601);
    if multiTabLayer then
        multiTabLayer:selectPageWithIndex(0)
    end
end

--点击获取附件响应
local function getItemButtonAction(tag)
    if m_mailDetail and m_mailDetail.idMail then
        sendGetMailItemMsg(m_mailDetail.idMail)
    end
end


--点击删除已选按钮响应
local function deleteSelectButtonAction(tag)
    if tag == 0 then
       return;
    end
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = m_wnd:getChildByTag(800601);
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(0)
        local idList = {}
        for i=1,m_mailPageAmount do
            local itemCheckBox = SCFunction:getUiNodeByIdlistAndParent("2-"..i.."-200",contentLayer)
            if itemCheckBox then
                itemCheckBox = SCTypeCast:castNodeToCheckBox(itemCheckBox)
                if itemCheckBox:isSelect() then
                    local idLabel = SCFunction:getUiNodeByIdlistAndParent("2-"..i.."-100",contentLayer)
                    if idLabel then
                        idLabel = SCTypeCast:castNodeToLabel(idLabel)
                        local tmpStr = idLabel:getText()
                        table.insert(idList,math.floor(tmpStr));
                    end
                end
            end
        end
        sendDeleteMailByIdMsg(idList)
    end
end

local function deleteAllMailShowConfirmationWindow()  --上次已选邮件 二次确认
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = m_wnd:getChildByTag(800601);
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(0)
        local idList = {}
        for i=1,m_mailPageAmount do
            local itemCheckBox = SCFunction:getUiNodeByIdlistAndParent("2-"..i.."-200",contentLayer)
            if itemCheckBox then
                itemCheckBox = SCTypeCast:castNodeToCheckBox(itemCheckBox)
                if itemCheckBox:isSelect() then
                    luashowConfirmationWindow(L("strcf022"), WIN_YES_NO, deleteSelectButtonAction);
                    return;
                end
            end
        end
    end
     showMessage(L("strcf023"));
     return;
end
--------------一键收取回调----------
local function getAllMail()
    local dt = SCDataTransStream:streamWithCommand(_MSG_MAILBOX);
    dt:writeShort(MAILACTION_ACCEPT_ALL);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end 
--点击发送邮件按钮响应
local function sendMailButtonAction()
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = m_wnd:getChildByTag(800601);
    
    local sendNameStr = ""--发送者名称
    local titleStr = ""--主题
    local contentStr = ""--内容
   
    if multiTabLayer then
        local mailInfo = {}
        local contentLayer = multiTabLayer:getPageWithTag(1)
        local sendNameEdit = contentLayer:getChildByTag(1)
        if sendNameEdit then--发送者名称
            sendNameEdit = SCTypeCast:castNodeToEdit(sendNameEdit)
            sendNameStr = sendNameEdit:getContentText()
            if sendNameStr and sendNameStr~= "" and DelS(sendNameStr)~= "" then
                mailInfo.szReceiver = sendNameStr
            else
                showMessage(_LTParser("str8026"),3)
                return
            end
        end
        
        local titleEdit = contentLayer:getChildByTag(2)
        if titleEdit then--主题
            titleEdit = SCTypeCast:castNodeToEdit(titleEdit)
            titleStr = titleEdit:getContentText()
            if titleStr and titleStr~= "" and DelS(titleStr)~= "" then
                mailInfo.szTitle = titleStr
            else
                showMessage(_LTParser("str8027"),3)
                return
            end
        end
        
        local contentEdit = contentLayer:getChildByTag(3)
        if contentEdit then--内容
            contentEdit = SCTypeCast:castNodeToTextBox(contentEdit)
            contentStr = contentEdit:getText()
            if contentStr and contentStr~="" and DelS(contentStr)~= "" then
                mailInfo.szContent = contentStr
            else
                showMessage(_LTParser("str8028"),3)
                return
            end
        end
        mailInfo.idReceiver = 0
        if m_openType == 5 then--公会邮件
            mailInfo.nType = 5
        else
            mailInfo.nType = 0
        end
        
        sendMailMsg(mailInfo)
    end
end

--显示邮件详细
local function showMailDetailContent(fatherLayer,mailDetail)
     if fatherLayer == nil then
        return;
    end
    fatherLayer:removeAllChildrenWithCleanup(true)
   
 
    local showWidth = fatherLayer:getContentSize().width
    local showHeight = fatherLayer:getContentSize().height
    
    local startX = SX(10)
    if CLIENT_TYPE == 2 then
		startX = SX(-5)
    end
    local startY = showHeight*0.92
    
    local editWidth = showWidth*0.63
    local editHeight = SY(25)
    local editStartX = SX(65)
    --左边发件人标题
    local titleLabel = SCLabel:labelWithStringFont(_LTParser("str8018"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0.5));
    titleLabel:setPosition(CCPointMake(startX,startY));
    fatherLayer:addChild(titleLabel)
    
    --发件人名称背景框
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
    editBgLayer:setAnchorPoint(CCPointMake(0,0.5));
    editBgLayer:setPosition(CCPointMake(editStartX,startY));
	editBgLayer:setContentSize(CCSizeMake(SX(294),editHeight + SY(8)))
	fatherLayer:addChild(editBgLayer)
	
     --发件人名称
	local sendName = mailDetail.szSender
    if sendName == nil then
        sendName = ""
    end
    local titleLabel = SCLabel:labelWithStringFont(sendName,getDefaultFontName(), getFontSize(15))
    titleLabel:setContentSize(CCSizeMake(editWidth*0.95,SY(20)))
	titleLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    titleLabel:setPosition(CCPointMake(editStartX+editWidth/2 + SX(2),startY + SY(3)));
    fatherLayer:addChild(titleLabel)
	
	if mailDetail.idSender and mailDetail.idSender ~= 0 then--不是系统邮件
	    --回复按钮
	    local replyButton = SCButton:button(EnumBtnType9Atlas)
        setNodeContentSize(replyButton, BigButton_Size)
	    local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	    
	    local file = getRealUIResourcePath("img/new00413.png")
        local fileP = getRealUIResourcePath("img/new00410.png")
	    local titlefile = getRealUIResourcePath("img/new00412.png")
	    if  titlefile then
	        --replyButton:setBackgroundImage(file:getData())
            --replyButton:setSelectedImage(fileP:getData())
	        replyButton:setTitle(titlefile:getData())
	    end
	    --replyButton:setTitle(_LTParser("str8029"),getDefaultFontName(), getFontSize(15),getColorYellow())
        replyButton:setAnchorPoint(CCPointMake(0,0.5));
        replyButton:setContentSize(AUTO_SIZE(70, 30))
        replyButton:setButtonType(EnumBtnType9Atlas)
        --replyButton:setPosition(CCPointMake(editStartX+editWidth+SX(5),startY));
        replyButton:setPosition(CCPointMake(SX(200),SY(20)))
        replyButton:luaSetSelectorOnClicked(replyButtonAction)--设置回调
        fatherLayer:addChild(replyButton)
        
        
     end   
        local returnBtn = SCButton:button(EnumBtnType9Atlas)
        setNodeContentSize(returnBtn, BigButton_Size)
        local imgFile = getRealUIResourcePath(Img0008_ImagePath);
            
        local file = getRealUIResourcePath("img/new00413.png")
        local fileP = getRealUIResourcePath("img/new00410.png")
        local titlefile = getRealUIResourcePath("img/new00080.png")
        if titlefile then
            --returnBtn:setBackgroundImage(file:getData())
            --returnBtn:setSelectedImage(fileP:getData())
            returnBtn:setTitle(titlefile:getData())
        end
        returnBtn:setAnchorPoint(CCPointMake(0,0.5));
        returnBtn:setContentSize(AUTO_SIZE(70, 30))
        --replyButton:setTitle(_LTParser("str8029"),getDefaultFontName(), getFontSize(15),getColorYellow())
        returnBtn:setAnchorPoint(CCPointMake(0,0.5));
        --replyButton:setPosition(CCPointMake(editStartX+editWidth+SX(5),startY));
        returnBtn:setPosition(CCPointMake(SX(280),SY(20)))
        --returnBtn:setScale()
        returnBtn:luaSetSelectorOnClicked(returnButtonAction)--设置回调
        fatherLayer:addChild(returnBtn)
    
	
        
    
    startY = showHeight*0.8
    --左边主题标题
    titleLabel = SCLabel:labelWithStringFont(_LTParser("str8019"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0.5));
    titleLabel:setPosition(CCPointMake(startX,startY));
    fatherLayer:addChild(titleLabel)
    
    
    --主题背景框
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
    editBgLayer:setAnchorPoint(CCPointMake(0,0.5));
    editBgLayer:setPosition(CCPointMake(editStartX,startY));
	editBgLayer:setContentSize(CCSizeMake(SX(294),editHeight+SY(8)))
	fatherLayer:addChild(editBgLayer)
    --主题
    local title = mailDetail.szTitle--邮件主题
    if title == nil then
        title = ""
    end
    titleLabel = SCLabel:labelWithStringFont(title,getDefaultFontName(), getFontSize(15))
    titleLabel:setContentSize(CCSizeMake(editWidth*0.95,SY(20)))
	titleLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    titleLabel:setPosition(CCPointMake(editStartX+editWidth/2 + SX(2),startY + SY(3)));
    fatherLayer:addChild(titleLabel)
    
    startY = showHeight*0.72
    --左边内容标题
    titleLabel = SCLabel:labelWithStringFont(_LTParser("str8022"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,1));
    titleLabel:setPosition(CCPointMake(startX,startY));
    fatherLayer:addChild(titleLabel)
    
    local editBoxHeight = showHeight*0.55
    if mailDetail.ucType == 1 or 3 == mailDetail.ucType then--有附件
        editBoxHeight = showHeight*0.3
    end
    local bHaveObj = true
	if mailDetail.ucType ~= 1 and 3 ~= mailDetail.ucType then--没有附件
	    if mailDetail.szObjName == nil then
	        bHaveObj = false
        end
    end
    --输入框
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
    editBgLayer:setAnchorPoint(CCPointMake(0,0));
	if false == bHaveObj then
		editBgLayer:setContentSize(CCSizeMake(SX(294),SY(150)))
		editBgLayer:setPosition(CCPointMake(editStartX,startY-editBoxHeight));
	else
		editBgLayer:setContentSize(CCSizeMake(SX(294),SY(85)))
		editBgLayer:setPosition(CCPointMake(editStartX,startY-editBoxHeight));
	end
	fatherLayer:addChild(editBgLayer)
	--邮件内容
	local contentStr = mailDetail.szContent--邮件内容
	if contentStr == nil then
	    contentStr = ""
    end
	local contentEditLabel = SCTextBox:boxWithWidthHeight(editWidth*0.95,editBgLayer:getContentSize().height-SY(20))
    contentEditLabel:setInputEnabled(false)
	contentEditLabel:setParserDelegate(TextParser:getSingleton())
	contentEditLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    contentEditLabel:setPosition(CCPointMake(editStartX+editWidth/2,startY-editBoxHeight+editBoxHeight/2+SY(3)));
    contentEditLabel:setText(contentStr)
   
    fatherLayer:addChild(contentEditLabel)
	
	if false == bHaveObj then
		return
	end
	
    ----------------以下显示附件-------
	startY = showHeight*0.34
    --左边附件标题
    titleLabel = SCLabel:labelWithStringFont(_LTParser("str8031"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0.5));
    titleLabel:setPosition(CCPointMake(startX,startY));
    fatherLayer:addChild(titleLabel)
    local bgLayer = SCDragNode:node()
	bgLayer:setFrameVisibled(true)
	bgLayer:setFrameType(EnumFrameTypeRound)
    bgLayer:setAnchorPoint(CCPointMake(0,0.5));
    bgLayer:setPosition(CCPointMake(editStartX,startY));
	bgLayer:setContentSize(CCSizeMake(editWidth + SX(5),editHeight + SY(8)))
	fatherLayer:addChild(bgLayer)
	
     --发件人名称
	local itemName = mailDetail.szObjName
    if itemName == nil then
        itemName = ""
    end
    if mailDetail.ucType == 3 then
        itemName = mailDetail.idObj.._LTParser("str0138")
    end
    local titleLabel = SCLabel:labelWithStringFont(itemName,getDefaultFontName(), getFontSize(15))
    titleLabel:setContentSize(CCSizeMake(editWidth*0.95,SY(20)))
	titleLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    titleLabel:setPosition(CCPointMake(editStartX+editWidth/2 + SX(5),startY + SY(3)));
    fatherLayer:addChild(titleLabel)
    --提取附件
	local getItemButton = SCButton:button(EnumBtnType9Atlas)
	getItemButton:setTag(2)
    setNodeContentSize(getItemButton, BigButton_Size)
	local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	
	
	--local file = getRealUIResourcePath("img/new00413.png")
    --local fileP = getRealUIResourcePath("img/new00410.png")
	local titlefile = getRealUIResourcePath("img/new00418.png")
	if  titlefile then
	    --getItemButton:setBackgroundImage(file:getData())
        --getItemButton:setSelectedImage(fileP:getData())
	    getItemButton:setTitle(titlefile:getData())
	end
	getItemButton:setContentSize(AUTO_SIZE(70, 30))
	getItemButton:setButtonType(EnumBtnType9Atlas)
	--getItemButton:setTitle(_LTParser("str8030"),getDefaultFontName(), getFontSize(15),getColorYellow())
    getItemButton:setAnchorPoint(CCPointMake(0,0.5));
    getItemButton:setPosition(CCPointMake(editStartX+editWidth+SX(5),startY));
    getItemButton:luaSetSelectorOnClicked(getItemButtonAction)--设置回调
    fatherLayer:addChild(getItemButton)
    
    
    --附件图标
    local iconId = nil
    if mailDetail.ucType == 3 then
        iconId = 3
    else
        iconId = mailDetail.dwIcon
    end
    local usNum = mailDetail.usNum
    startY = showHeight*0.2
    local iconItem,itemBtn = cretateMenuItem(iconId,usNum)
    iconItem:setTag(3)
    iconItem:setAnchorPoint(CCPointMake(0,0.5));
    iconItem:setPosition(CCPointMake(editStartX,startY));
    if mailDetail.ucType == 3 then
        itemBtn:luaSetSelectorOnClicked(itemButtonOtherAction)--设置回调
    else
        itemBtn:luaSetSelectorOnClicked(itemButtonAction)--设置回调
    end
    fatherLayer:addChild(iconItem)
    
end

--显示邮件列表
local function refreshMailListContent(fatherLayer)
    if fatherLayer == nil then
        return;
    end
    fatherLayer:removeAllChildrenWithCleanup(true)
     
    local showWidth = fatherLayer:getContentSize().width
    local showHeight = fatherLayer:getContentSize().height
    
    local startX = SX(30)
    local startY = showHeight*0.88
    
    --全选框
    local checkAllLabel = SCCheckBox:box();
    if checkAllLabel then
        checkAllLabel:setTag(1)
        checkAllLabel:setAnchorPoint(CCPointMake(0,0));
        checkAllLabel:setPosition(CCPointMake(startX-SX(9),startY));
        checkAllLabel:luaSetSelectorOnButtonClicked(checkDeleteAllAction)
        fatherLayer:addChild(checkAllLabel)
    end
    startX = startX + checkAllLabel:getContentSize().width+SX(5)
    local checkAllBtn = SCButton:button();
    if checkAllBtn then
        checkAllBtn:setTag(9000);
        checkAllBtn:setAnchorPoint(CCPointMake(0.5,0.5));
        checkAllBtn:setPosition(CCPointMake(startX-SX(20),startY+SY(10)));
        checkAllBtn:setContentSize(CCSizeMake(SX(50), SY(25)));
        checkAllBtn:luaSetSelectorOnClicked(checkDeleteAllAction)
        fatherLayer:addChild(checkAllBtn);
    end
    
    --邮件图标
    local imgFile = getRealUIResourcePath("img/new00426.png");
    if imgFile then
        local imageLabel = SCImage:imageWithFile(imgFile:getData()) 
        imageLabel:setAnchorPoint(CCPointMake(0,0));
        imageLabel:setPosition(CCPointMake(startX-SX(9),startY));
        fatherLayer:addChild(imageLabel)
        startX = startX + imageLabel:getContentSize().width
    end
    
    --发件人
    local titleLabel = SCLabel:labelWithStringFont(_LTParser("str8018"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0));
    titleLabel:setPosition(CCPointMake(startX+SX(15),startY));
    fatherLayer:addChild(titleLabel)
    
    --主题
    titleLabel = SCLabel:labelWithStringFont(_LTParser("str8019"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0.5,0));
    titleLabel:setPosition(CCPointMake(showWidth/2,startY));
    fatherLayer:addChild(titleLabel)
    
    --剩余时间
    titleLabel = SCLabel:labelWithStringFont(_LTParser("str8020"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0.5,0));
    titleLabel:setPosition(CCPointMake(showWidth*0.82,startY));
    fatherLayer:addChild(titleLabel)
    
    
    --邮件列表框------------------
    local mailListWidth = showWidth*0.95
    local mailListHeight = showHeight*0.72
    local mailListLayer = SCDragNode:node()
    mailListLayer:setTag(2)
	mailListLayer:setFrameVisibled(true)
	mailListLayer:setFrameType(EnumFrameTypeRound)
	mailListLayer:setAnchorPoint(CCPointMake(0.5,0));
	mailListLayer:setPosition(CCPointMake(showWidth/2,startY-mailListHeight-SY(5)));
	mailListLayer:setContentSize(CCSizeMake(SX(444),SY(188)))

    if m_mailList then
        local amount = #m_mailList
        if amount > 4 then
            amount = 4
        end
        local menuItemWidth  = mailListWidth*0.98
	    local menuItemHeight = mailListHeight*0.23
	    local tmpX = (mailListWidth-menuItemWidth)/2
	    
	    for i=1,amount do
	        local mailId   =  m_mailList[i].idMail
	        local type     =  m_mailList[i].ucQuery
	        local sendName =  m_mailList[i].szSender
	        local titleStr =  m_mailList[i].szTitle
	        local timeStr  =  m_mailList[i].szTime
	        local idObj  =  m_mailList[i].idObj
	        local itemLayer,clickBtn,clickBtn2 = createListMenuItem(menuItemWidth,menuItemHeight,mailId,type,sendName,titleStr,timeStr,idObj)
	        itemLayer:setTag(i)
	        itemLayer:setAnchorPoint(CCPointMake(0,0));
            itemLayer:setPosition(CCPointMake(tmpX + SX(4),mailListHeight-menuItemHeight*i-SY(6)));
            clickBtn:setTag(i)
            clickBtn:luaSetSelectorOnClicked(mailListSelectAction)
            clickBtn2:setTag(i)
            clickBtn2:luaSetSelectorOnClicked(mailListClickAction)
            mailListLayer:addChild(itemLayer)
        end
    end
    
    fatherLayer:addChild(mailListLayer)
    ----------------------------------
    
    local bottomStartY = SY(20)
    --上一页按钮
    local upPageButton = SCButton:button(EnumBtnTypeNormalImg);
    upPageButton:setAnchorPoint(CCPointMake(0.5,0.5));
    upPageButton:setPosition(CCPointMake(showWidth*0.35+22,bottomStartY));
    local imgFile = getRealUIResourcePath("img/new00048.png");
    if imgFile then
        upPageButton:setBackgroundImage(imgFile:getData())
    end
    local imgFile = getRealUIResourcePath("img/new00048.png");
    if imgFile then
        --upPageButton:setSelectedImage(imgFile:getData())
    end
    upPageButton:luaSetSelectorOnClicked(upPageButtonAction)--设置回调
    
    fatherLayer:addChild(upPageButton)
    
    --下一页按钮
    local nextPageButton = SCButton:button(EnumBtnTypeNormalImg);
    nextPageButton:setAnchorPoint(CCPointMake(0.5,0.5));
    nextPageButton:setPosition(CCPointMake(showWidth*0.55+22,bottomStartY));
    local imgFile = getRealUIResourcePath("img/new00047.png");
    if imgFile then
        nextPageButton:setBackgroundImage(imgFile:getData())
    end
    local imgFile = getRealUIResourcePath("img/new00047.png");
    if imgFile then
        --nextPageButton:setSelectedImage(imgFile:getData())
    end
    nextPageButton:luaSetSelectorOnClicked(nextPageButtonAction)--设置回调
    fatherLayer:addChild(nextPageButton)
    
     
    --当前页数
    local pageLabel = SCLabel:labelWithStringFont("",getDefaultFontName(), getFontSize(14))
    pageLabel:setTag(3)
    pageLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    pageLabel:setPosition(CCPointMake(showWidth*0.45+22,bottomStartY));
    fatherLayer:addChild(pageLabel)
    
    --删除已选按钮
    local deleteSelectButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(deleteSelectButton, BigButton_Size)
	deleteSelectButton:setTag(8001003)
	local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	
	local titlefile = getRealUIResourcePath("img/new00414.png")
	if titlefile then
	    deleteSelectButton:setTitle(titlefile:getData())
	end
	--deleteSelectButton:setTitle(_LTParser("str8023"),getDefaultFontName(), getFontSize(15),getColorYellow())
    deleteSelectButton:setAnchorPoint(CCPointMake(0.5,0.5));
    deleteSelectButton:setPosition(CCPointMake(showWidth*0.2,bottomStartY));
    deleteSelectButton:luaSetSelectorOnClicked(deleteAllMailShowConfirmationWindow)--设置回调
    fatherLayer:addChild(deleteSelectButton)
    
	-------一键收取按钮---------
    local getSelectButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(getSelectButton, BigButton_Size)
	getSelectButton:setTag(8001003)
	local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	local pimage = RES("img/new00283.png")
	local titlefile = getRealUIResourcePath("img/new00414.png")
	if titlefile then
	    getSelectButton:setTitle(pimage)
	end
	--getSelectButton:setTitle(_LTParser("str8023"),getDefaultFontName(), getFontSize(15),getColorYellow())
    getSelectButton:setAnchorPoint(CCPointMake(0.5,0.5));
    getSelectButton:setPosition(CCPointMake(showWidth*0.8,bottomStartY));
    getSelectButton:luaSetSelectorOnClicked(getAllMail)--设置回调
    fatherLayer:addChild(getSelectButton)
end

--窗口复原位置
local function resetWindowPosition()
    if m_wnd == nil then
        return
    end
    if m_initPoint and m_moveUpHeight then
        m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPoint.x, m_initPoint.y)));
        m_moveUpHeight = nil
    end

end

--点击主题输入框响应
local function titleEditAction()
    if m_wnd == nil then
        return
    end

    m_moveUpHeight = SY(50)
    if m_initPoint then
        m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPoint.x, m_initPoint.y + m_moveUpHeight)));
    end
end

local function titleInsertAction(tag, tlen, text)
	if m_wnd == nil then
        return
    end

   local multiTabLayer = m_wnd:getChildByTag(800601);
    if not multiTabLayer then
       return;
    end
    local contentLayer = multiTabLayer:getPageWithTag(1)
    if not contentLayer then
        return;
    end
    
    local contentEdit = SCTypeCast:castNodeToEdit(contentLayer:getChildByTag(tag));
    if not contentEdit then
        return;
    end
	local strInsertText = text
	if strInsertText == "\n" or not luaCheckCharIsLegitimacy(strInsertText) then
	    --contentEdit:luaSetSelectorOnInsertChar(false);
		return true;
	end
	return false
    --contentEdit:luaSetSelectorOnInsertChar(true);
end

--主题输入结束回调
local function titleEditTouchEndAction()
    resetWindowPosition()
end

--内容输入框点击
local function contentEditTouchAction()
    if m_wnd == nil then
        return
    end

    m_moveUpHeight = SY(110)
    if m_initPoint then
        m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPoint.x, m_initPoint.y + m_moveUpHeight)));
    end    
end

--内容输入框点击
local function contentEditInsertAction(tag, tlen, text)
    if m_wnd == nil then
        return
    end

    m_moveUpHeight = SY(110)
    if m_initPoint then
        m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPoint.x, m_initPoint.y + m_moveUpHeight)));
    end  
    
   local multiTabLayer = m_wnd:getChildByTag(800601);
    if not multiTabLayer then
       return;
    end
    local contentLayer = multiTabLayer:getPageWithTag(1)
    if not contentLayer then
        return;
    end
    
    local contentEdit = SCTypeCast:castNodeToTextBox(contentLayer:getChildByTag(3));
    if not contentEdit then
        return;
    end
	local strInsertText = text
	if strInsertText == "\n" or not luaCheckCharIsLegitimacy(strInsertText) then
	    contentEdit:luaSetSelectorOnInsertChar(false);
		return;
	end
    contentEdit:luaSetSelectorOnInsertChar(true);
end

--内容输入框点击
local function contentEditTouchEndAction()
    resetWindowPosition()
end

--窗口点击
local function onWindowTouched()
    local multiTabLayer = m_wnd:getChildByTag(800601);
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(1)
        local nameEdit    = contentLayer:getChildByTag(1)
        if nameEdit then
            nameEdit = SCTypeCast:castNodeToEdit(nameEdit)
            nameEdit:detachWithIME()
        end
        
        local titleEdit    = contentLayer:getChildByTag(2)
        if titleEdit then
            titleEdit = SCTypeCast:castNodeToEdit(titleEdit)
            titleEdit:detachWithIME()
        end
        local contentEdit = contentLayer:getChildByTag(3)
        if contentEdit then
            contentEdit = SCTypeCast:castNodeToTextBox(contentEdit)
            contentEdit:getTextControl():detachWithIME()
        end
    end
   
end
--显示发送邮件
local function showSendMailContent(fatherLayer)
    if fatherLayer == nil then
        return;
    end
    fatherLayer:removeAllChildrenWithCleanup(true)
     
    local showWidth = fatherLayer:getContentSize().width
    local showHeight = fatherLayer:getContentSize().height
    
    local startX = SX(10)
    if CLIENT_TYPE == 2 then
		startX = SX(-5)
    end
    local startY = showHeight*0.92
    
    local editWidth = showWidth*0.63
    local editHeight = SY(25)
    local editStartX = SX(65)
    --收件人标题
    local titleLabel = SCLabel:labelWithStringFont(_LTParser("str8021"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0.5));
    titleLabel:setPosition(CCPointMake(startX,startY));
    fatherLayer:addChild(titleLabel)
    
    --输入框
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
    editBgLayer:setAnchorPoint(CCPointMake(0,0.5));
    editBgLayer:setPosition(CCPointMake(editStartX,startY));
	editBgLayer:setContentSize(CCSizeMake(SX(290),editHeight * 1.4))
	fatherLayer:addChild(editBgLayer)
	local sendNameEditLabel = SCEdit:edit()
	sendNameEditLabel:setTag(1)
	sendNameEditLabel:setContentSize(CCSizeMake(editWidth*0.98,editHeight*0.95))
	sendNameEditLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    sendNameEditLabel:setPosition(CCPointMake(editStartX+editWidth/2 + SX(4),startY));
    sendNameEditLabel:setBottomColor(color_transparent)
    sendNameEditLabel:setFontColor(color_white)
    sendNameEditLabel:setMaxCharCount(12)
    if m_openType == 5 then--公会邮件
        sendNameEditLabel:setContentText(_LTParser("str8039"))
        sendNameEditLabel:setTouchEnabled(false)--不能点击
        --m_openType = 0
    end
    fatherLayer:addChild(sendNameEditLabel)
    
	if m_openType ~= 5 and not m_isReply then
	    --好友按钮
	    local friendButton = SCButton:button(EnumBtnType9Atlas)
        setNodeContentSize(friendButton, BigButton_Size)
	    local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	    
	    --local file = getRealUIResourcePath("kernal/multi-page-large-other.png")
        --local fileP = getRealUIResourcePath("kernal/multi-page-large-current.png")
        local titlefile = getRealUIResourcePath("img/new00416.png")
        if titlefile then
            --btn:setBackgroundImage(file:getData())
            --btn:setSelectedImage(fileP:getData())
            friendButton:setTitle(titlefile:getData())
        end
	    
	    --friendButton:setTitle(_LTParser("str8025"),getDefaultFontName(), getFontSize(15),getColorYellow())
        friendButton:setAnchorPoint(CCPointMake(0,0.5));
        friendButton:setPosition(CCPointMake(editStartX+editWidth+SX(5),startY));
        friendButton:luaSetSelectorOnClicked(friendButtonAction)--设置回调
        fatherLayer:addChild(friendButton)
    end
	
    
    startY = showHeight*0.8
    --主题
    titleLabel = SCLabel:labelWithStringFont(_LTParser("str8019"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0.5));
    titleLabel:setPosition(CCPointMake(startX,startY));
    fatherLayer:addChild(titleLabel)
    --输入框
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
    editBgLayer:setAnchorPoint(CCPointMake(0,0.5));
    editBgLayer:setPosition(CCPointMake(editStartX ,startY ));
	editBgLayer:setContentSize(CCSizeMake(SX(290) ,editHeight * 1.4))
	fatherLayer:addChild(editBgLayer)
	local titleEditLabel = SCEdit:edit()
	titleEditLabel:setTag(2)
	titleEditLabel:setContentSize(CCSizeMake(editWidth*0.98,editHeight*0.95))
	titleEditLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    titleEditLabel:setPosition(CCPointMake(editStartX+editWidth/2 + SX(4),startY));
    titleEditLabel:setBottomColor(color_transparent)
    titleEditLabel:setFontColor(color_white)
    titleEditLabel:luaSetSelectorOnBeginInput(titleEditAction)
	titleEditLabel:luaSetSelectorOnInsertText(titleInsertAction)
    titleEditLabel:luaSetSelectorOnEndInput(titleEditTouchEndAction)
    local str = L("str3275")
    titleEditLabel:setContentText(str)
    titleEditLabel:setTouchEnabled(false)
    titleEditLabel:setMaxCharCount(20)
    fatherLayer:addChild(titleEditLabel)
    
    startY = showHeight*0.72
    --内容
    titleLabel = SCLabel:labelWithStringFont(_LTParser("str8022"),getDefaultFontName(), getFontSize(15))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,1));
    titleLabel:setPosition(CCPointMake(startX,startY));
    fatherLayer:addChild(titleLabel)
    
    local pLabel = SCLabel:labelWithStringFont(_LTParser("str3323"),getDefaultFontName(), getFontSize(11))
    if pLabel then
		pLabel:setColor(getColorGreen())
		pLabel:setAnchorPoint(CCPointMake(0,1));
		pLabel:setPosition(CCPointMake(SX(355),startY));
		fatherLayer:addChild(pLabel)
	end
    
    local editBoxHeight = showHeight*0.5
    --输入框
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
    editBgLayer:setAnchorPoint(CCPointMake(0,0));
    editBgLayer:setPosition(CCPointMake(editStartX,startY-editBoxHeight));
	editBgLayer:setContentSize(CCSizeMake(SX(290),editBoxHeight+SY(5)))
	fatherLayer:addChild(editBgLayer)
	local contentEditLabel = SCTextBox:boxWithWidthHeight(editWidth*0.95,editBoxHeight*0.95)
	contentEditLabel:setTag(3)
	contentEditLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    contentEditLabel:setPosition(CCPointMake(editStartX+editWidth/2,startY-editBoxHeight+editBoxHeight/2));
    contentEditLabel:setInputEnabled(true)--设置成可输入
    contentEditLabel:luaSetSelectorOnBeginInput(contentEditTouchAction)
    contentEditLabel:luaSetSelectorOnInsertText(contentEditInsertAction)
    contentEditLabel:luaSetSelectorOnEndInput(contentEditTouchEndAction)
    contentEditLabel:setMaxCharCount(80)
    fatherLayer:addChild(contentEditLabel)
	
	--发送邮件按钮
	local sendMailButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(sendMailButton, BigButton_Size)
	local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	
    --local file = getRealUIResourcePath("img/new00413.png")
    --local fileP = getRealUIResourcePath("img/new00410.png")
    local titlefile = getRealUIResourcePath("img/new00411.png")
    if titlefile then
        --sendMailButton:setBackgroundImage(file:getData())
        --sendMailButton:setSelectedImage(fileP:getData())
        sendMailButton:setTitle(titlefile:getData())
    end
    sendMailButton:setContentSize(AUTO_SIZE(70, 30))
    sendMailButton:setButtonType(EnumBtnType9Atlas)    
	--sendMailButton:setTitle(_LTParser("str8024"),getDefaultFontName(), getFontSize(15),getColorYellow())
    sendMailButton:setAnchorPoint(CCPointMake(0,0.5));
    sendMailButton:setPosition(CCPointMake(200,SY(25)));
    sendMailButton:luaSetSelectorOnClicked(sendMailButtonAction)--设置回调
    fatherLayer:addChild(sendMailButton)
    
    -------------------------------------------------------------------------------------
    --返回邮件按钮
        local returnBtn = SCButton:button(EnumBtnType9Atlas)
        setNodeContentSize(returnBtn, BigButton_Size)
        local imgFile = getRealUIResourcePath(Img0008_ImagePath);
            
        --local file = getRealUIResourcePath("img/new00413.png")
        --local fileP = getRealUIResourcePath("img/new00410.png")
        local titlefile = getRealUIResourcePath("img/new00080.png")
        if  titlefile then
            --returnBtn:setBackgroundImage(file:getData())
            --returnBtn:setSelectedImage(fileP:getData())
            returnBtn:setTitle(titlefile:getData())
        end
        returnBtn:setContentSize(AUTO_SIZE(70, 30))
        returnBtn:setButtonType(EnumBtnType9Atlas)
        --replyButton:setTitle(_LTParser("str8029"),getDefaultFontName(), getFontSize(15),getColorYellow())
        returnBtn:setAnchorPoint(CCPointMake(0,0.5));
        --replyButton:setPosition(CCPointMake(editStartX+editWidth+SX(5),startY));
        returnBtn:setPosition(CCPointMake(SX(280),SY(25)))
        --returnBtn:setScale()
        returnBtn:luaSetSelectorOnClicked(returnButtonAction)--设置回调
        fatherLayer:addChild(returnBtn)
end

local function multiTabAction()
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = SCTypeCast:castNodeToMultiPage(m_wnd:getChildByTag(800601));
    if multiTabLayer then
        local index = multiTabLayer:selectedPageIndex()
        if m_currentTabIndex == index then
            return
        end
        m_currentTabIndex = index
        if index == 0 then
            local contentLayer = multiTabLayer:getPageWithTag(0)
            refreshMailListContent(contentLayer)
            refreshMailListPage()
        elseif index == 1 then
            local contentLayer = multiTabLayer:getPageWithTag(1)
            showSendMailContent(contentLayer)
        end
    end
end

--处理邮件列表数据
local function processMailListMsg(dt)
    if dt == nil then
        return;
    end

    m_mailList = {}
    
    local nTotalPage = dt:readInt()
     
    local amount      = dt:readByte()
    for i=1,amount do
        local idMail    = dt:readInt()--邮件id
        local szSender  = dt:readString()--发件人名称
        local szTitle   = dt:readString()--主题
        local ucType    = dt:readByte()--邮件类型
        local idObj     = dt:readInt()--附件id
        local usNum     = dt:readShort()--附件个数
        local szTime    = dt:readString()--剩余时间
        local ucQuery   = dt:readByte()--是否查看过
        local tmpDetail = {}
        tmpDetail.idMail = idMail
        if szSender then
            tmpDetail.szSender = szSender:getData()
        end
        if szTitle then
            tmpDetail.szTitle = szTitle:getData()
        end
        tmpDetail.ucType = ucType
        tmpDetail.idObj  = idObj
        tmpDetail.usNum  = usNum
        if szTime then
            tmpDetail.szTime = szTime:getData()
        end
        tmpDetail.ucQuery  = ucQuery
        
        table.insert(m_mailList,tmpDetail);
    end
    if m_wnd == nil then
        return
    end
    local multiTabLayer = SCTypeCast:castNodeToMultiPage(m_wnd:getChildByTag(800601));
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(0)
        refreshMailListContent(contentLayer)
    end
    m_totalAmount = nTotalPage
    if m_mailPageAmount and m_mailPageAmount >0 then
        m_mailListMaxPage = math.ceil(nTotalPage/m_mailPageAmount)--向上取整
    end
    refreshMailListPage()
end

--邮件详细
local function processMailDetail(dt)
     if m_wnd ==nil or dt == nil then
        return;
    end
    local idMail       = dt:readInt()--邮件id
    local idSender     = dt:readInt()--发件者id
    local szSender     = dt:readString()--发件人名称
    local szTitle      = dt:readString()--主题
    local szContent    = dt:readString()--内容
    local ucType       = dt:readByte()--邮件类型
    local idObj        = dt:readInt()--附件id
    local dwIcon       = dt:readInt()
    local usNum        = dt:readShort()--附件个数
    local dwMoney      = dt:readInt()
    local szObjName    = dt:readString()
    local szObjDescrib = dt:readString()
 
    local mailDetail = {}
    mailDetail.idMail   = idMail
    mailDetail.idSender = idSender
    if szSender then
        mailDetail.szSender = szSender:getData()
    end
    if szTitle then
        mailDetail.szTitle = szTitle:getData()
    end
    
    if szContent then
        mailDetail.szContent = szContent:getData()
    end 
    mailDetail.ucType  = ucType
    mailDetail.idObj   = idObj
    mailDetail.dwIcon  = dwIcon
    mailDetail.usNum   = usNum
    mailDetail.dwMoney = dwMoney
    if szObjName then
        mailDetail.szObjName = szObjName:getData()
    end
    if szObjDescrib then
        mailDetail.szObjDescrib = szObjDescrib:getData()
    end
    
    local multiTabLayer = m_wnd:getChildByTag(800601);
    if multiTabLayer then
        multiTabLayer = SCTypeCast:castNodeToMultiPage(multiTabLayer)
        multiTabLayer:selectPageWithIndex(0)
        local contentLayer = multiTabLayer:getPageWithTag(0)
        showMailDetailContent(contentLayer,mailDetail)
        m_currentTabIndex = 10--与列表区分开
    end
    m_mailDetail  = mailDetail
    if m_mailList then
        local amount = #m_mailList
        for i=1,amount do
            if m_mailList[i] and m_mailList[i].idMail == idMail then--设置为已读
                m_mailList[i].ucQuery = 1
                break
            end
        end
    end
end

--处理邮件附件提取成功
local function processGetItemSuccess(dt)
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = SCTypeCast:castNodeToMultiPage(m_wnd:getChildByTag(800601));
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(0)
        if contentLayer == nil then
            return
        end
        --contentLayer:removeChildByTag(2,true)
        contentLayer:removeChildByTag(3,true)
    end
	sendQueryMailListMsg(m_mailListcurrentPage,m_mailPageAmount)
end

--处理发送邮件成功
local function processSendSuccess(dt)
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = SCTypeCast:castNodeToMultiPage(m_wnd:getChildByTag(800601));
    if multiTabLayer then
        local contentLayer = multiTabLayer:getPageWithTag(1)
        if m_openType ~= 5 then
            local nameEdit = contentLayer:getChildByTag(1)
            if nameEdit then--发送者名称
                nameEdit = SCTypeCast:castNodeToEdit(nameEdit)
                nameEdit:setContentText("")
            end
        end
        
        local titleEdit = contentLayer:getChildByTag(2)
        if titleEdit then--主题
            titleEdit = SCTypeCast:castNodeToEdit(titleEdit)
            local str = L("str3275")
            titleEdit:setContentText(str)
            titleEdit:setTouchEnabled(false)
        end
        local contentEdit = contentLayer:getChildByTag(3)
        if contentEdit then--内容
            contentEdit = SCTypeCast:castNodeToTextBox(contentEdit)
            contentEdit:setText("")
        end
        if false == m_isReply then
            multiTabLayer:selectPageWithIndex(0)
            m_isReply = nil
        end
    end
end

--处理删除邮件成功消息
local function processDeleteMailSuccess(dt)
    if dt then
        local ucAmount = dt:readByte()--删除个数
        
        if m_totalAmount then
            m_totalAmount = m_totalAmount-ucAmount
        end
        m_mailListMaxPage = math.ceil(m_totalAmount/m_mailPageAmount)--向上取整
        if m_mailListMaxPage and m_mailListMaxPage>1 then
            if m_mailListcurrentPage> m_mailListMaxPage then
                m_mailListcurrentPage = m_mailListMaxPage
            end
        else
            m_mailListcurrentPage = 1
        end
        sendQueryMailListMsg(m_mailListcurrentPage,m_mailPageAmount)
    end
end

--获取邮件列表
function sendQueryMailListMsg(page,amount)
    if page and amount then
        local dt = SCDataTransStream:streamWithCommand(_MSG_MAILBOX);
        dt:writeShort(MAILACTION_QUERY_LIST);
        dt:writeInt(page);
        dt:writeInt(amount);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--获取邮件详情
function sendQuerMailDetailMsg(mailId)
    if mailId then
        local dt = SCDataTransStream:streamWithCommand(_MSG_MAILBOX);
        dt:writeShort(MAILACTION_QUERY_INFO);
        dt:writeInt(mailId);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--提取邮件附件
function sendGetMailItemMsg(mailId)
    if mailId then
        local dt = SCDataTransStream:streamWithCommand(_MSG_MAILBOX);
        dt:writeShort(MAILACTION_ACCEPT);
        dt:writeInt(mailId);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--发送邮件
function sendMailMsg(mailInfo)
    if mailInfo then
        local dt = SCDataTransStream:streamWithCommand(_MSG_MAILBOX);
        dt:writeShort(MAILACTION_SEND);
        dt:writeInt(0)--发送者id 
        dt:writeString(SCString:stringWithString(""))--发送者名称
        dt:writeInt(mailInfo.idReceiver)--//接受方id 0或玩家id
        dt:writeString(SCString:stringWithString(mailInfo.szReceiver))--//接受方名字
        dt:writeInt(0)--附件物品id
        dt:writeByte(0)--附件个数
        dt:writeInt(0)--银两
        dt:writeString(SCString:stringWithString(mailInfo.szTitle))--主题
        dt:writeString(SCString:stringWithString(mailInfo.szContent))--内容
        dt:writeInt(mailInfo.nType)--默认0,公会邮件type=5
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
    
end

--删除邮件
function sendDeleteMailByIdMsg(mailIdList)
    if mailIdList and #mailIdList >0 then
        local dt = SCDataTransStream:streamWithCommand(_MSG_MAILBOX);
        dt:writeShort(MAILACTION_DEL_MANY);
        local amount = #mailIdList
        dt:writeByte(amount);
        for i=1,amount do
            dt:writeInt(mailIdList[i]);
        end
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--接收邮件消息
function receiveMailBoxMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readShort();
    if action == MAILACTION_QUERY_LIST then----//邮箱列表
        processMailListMsg(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MAILACTION_QUERY_INFO then--邮件详情
        processMailDetail(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MAILACTION_ACCEPT_SUCCESS then--附件提取成功
        processGetItemSuccess(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MAILACTION_SEND_SUCCESS  then--邮件发送成功
        processSendSuccess(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MAILACTION_DEL_MANY then--邮件删除
        processDeleteMailSuccess(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MAILACTION_UPDATE_PHOTO then
        local type = dt:readInt()
        NewFriend_setMailScreenNum(type)
        if type > 0 then--有新邮件
            setNewFunctionType(UNLOCK_TYPE_FRIEND,true)--邮件
        else
            setNewFunctionType(UNLOCK_TYPE_FRIEND,false)
        end
    end
end



--普通打开邮件界面
function open_MailScreen()
    if not luaIsUnlock(UNLOCK_TYPE_MAIL) then
		showMessage(L("str6291"))
		return
	end
    if getCurentSceneWindowController(8006) then
        return;
    end
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setContentSize(CCSizeMake(SX(480), SY(320)))
    wnd:setTag(8006);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(coloseWnd_MailScreen);
    wnd:luaSetSelectorOnTouched(onWindowTouched)
    local imgFile = getRealUIResourcePath("img/new00421.png");
	if imgFile then
	   wnd:setTitleWithImage(imgFile:getData())
	end
	
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	naviCtrl:pushWindowController(wndCtrl)
	
	
    m_wnd =  getCurentSceneWindowController(8006):getWindow();
	
	local showWidth  = wnd:getContentSize().width*0.96
	local showHeight = wnd:getContentSize().height*0.8
	local startX = (wnd:getContentSize().width-showWidth)/2
	local startY = SY(10)
	
	--收件列表层
	local mailListLayer = SCDragNode:node()
	mailListLayer:setTag(0)
	mailListLayer:setFrameVisibled(true)
	mailListLayer:setAnchorPoint(CCPointMake(0,0));
	mailListLayer:setPosition(CCPointMake(startX,startY));
	mailListLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
	--发信列表层
	local sendMailLayer = SCDragNode:node()
	sendMailLayer:setTag(1)
	--sendMailLayer:setFrameType(EnumFrameTypeRound)
	sendMailLayer:setFrameVisibled(true)
	sendMailLayer:setAnchorPoint(CCPointMake(0,0));
	sendMailLayer:setPosition(CCPointMake(startX,startY));
	sendMailLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
	local multiTabLayer = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	multiTabLayer:setTag(800601)
	multiTabLayer:addPage(mailListLayer)
	multiTabLayer:addPage(sendMailLayer)
	local imgFile = getRealUIResourcePath("img/new00417.png")
	local imgFile1 = getRealUIResourcePath("img/new00419.png")
	if imgFile and imgFile1 then
	    multiTabLayer:setTitleAtPage( imgFile:getData(),0); 
	    multiTabLayer:setTitleAtPage( imgFile1:getData(),1);
	end
	
	
    multiTabLayer:luaSetSelectorOnPageSelected(multiTabAction)
    multiTabLayer:setContentSize(CCSizeMake(SX(480), SY(320)))
	m_wnd:addChild(multiTabLayer)
	
    m_mailListcurrentPage =1
    m_mailListMaxPage = 1
    m_mailPageAmount = 4
    m_currentTabIndex = 0
    
    sendQueryMailListMsg(m_mailListcurrentPage,m_mailPageAmount)
	local contentLayer = multiTabLayer:getPageWithTag(0)
    refreshMailListContent(contentLayer)
    
    refreshMailListPage()
    
    
    m_initPoint = CCPoint(getScreenWidth()/2,m_wnd:getPosition().y)
    

end


--给玩家发邮件打开调用
function openSendMailWnd(receiveName)
	if not luaIsUnlock(UNLOCK_TYPE_MAIL) then
		showMessage(L("str6291"))
		return
	end
    if m_wnd == nil then
        open_MailScreen()
    end
    m_openType = 0
    local multiTabLayer = SCTypeCast:castNodeToMultiPage(m_wnd:getChildByTag(800601));
    if multiTabLayer then
        multiTabLayer:selectPageWithIndex(1)
        local contentLayer = multiTabLayer:getPageWithTag(1)
        local sendNameEdit = contentLayer:getChildByTag(1)
        if sendNameEdit then--发送者名称
            sendNameEdit = SCTypeCast:castNodeToEdit(sendNameEdit)
            if receiveName then
                sendNameEdit:setContentText(receiveName)
            end
        end
        local sendTitleEdit = contentLayer:getChildByTag(2)
        if sendTitleEdit and m_isReply then
            sendTitleEdit = SCTypeCast:castNodeToEdit(sendTitleEdit)
           
            local str = L("str3274")
            sendTitleEdit:setContentText(str)
            sendTitleEdit:setTouchEnabled(false)
            m_isReply = false
        end
    end
end


--发送公会邮件打开
function openSendFamilyMailWnd()
    m_openType = 5
    open_MailScreen()
    
    local multiTabLayer = SCTypeCast:castNodeToMultiPage(m_wnd:getChildByTag(800601));
    if multiTabLayer then
        multiTabLayer:selectPageWithIndex(1)
        local contentLayer = multiTabLayer:getPageWithTag(0)
        showSendMailContent(contentLayer)
    end
end

SCMessageCenter:getSingleton():luaRegistCommand(receiveMailBoxMsg, _MSG_MAILBOX, 0, nil);