--定义一个与文件名相同的table
MoneyTree = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------
local MSG_SG_ACTION_MONEYTREEINFO = 21
local MSG_SG_ACTION_BEATMONEYTREE = 22
local MSG_SG_ACTION_ENTERMONEYTREE = 23
----------------变量定义区----------------
local m_moneyTree = {}
--变量的定义
----------------UI控制器区----------------
function MoneyTree.initControl()
	local pDragNode6003 = SCDragNode:node()
	if pDragNode6003 then
		pDragNode6003:setTag(6003)
		pDragNode6003:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode6003:setPosition(AUTO_POS(168.00, 57.00))
		pDragNode6003:setContentSize(AUTO_SIZE(154, 215))
		pDragNode6003:setFrameVisibled(true)
		pDragNode6003:setDragEnabled(false)
		pDragNode6003:setFrameType(EnumFrameTypeLine)
	end

	local imgPath = getRealUIResourcePath("img/new00162.png")
	local pImage1 = SCImage:imageWithFile(imgPath:getData())
	if pImage1 and imgPath then
		pImage1:setTag(1)
		pImage1:setAnchorPoint(ANCHOR_CENTER)
		pImage1:setPosition(AUTO_POS(77.00, 125.00))
	end

	local imgPath = getRealUIResourcePath("img/new00161.png")
	local pImage10002 = SCImage:imageWithFile(imgPath:getData())
	if pImage10002 and imgPath then
		pImage10002:setTag(10002)
		pImage10002:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10002:setPosition(AUTO_POS(40.00, 183.00))
	end

	MoneyTree.m_pButton3 = SCButton:button(EnumBtnTypeNormalImg)
	if MoneyTree.m_pButton3 then
		MoneyTree.m_pButton3:setTag(3)
		MoneyTree.m_pButton3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		MoneyTree.m_pButton3:setPosition(AUTO_POS(35.00, 9.00))
		MoneyTree.m_pButton3:setContentSize(AUTO_SIZE(82, 30))
		local imgPath = getRealUIResourcePath("img/new00193.png")
		if imgPath then
			MoneyTree.m_pButton3:setTitle(imgPath:getData())
		end
		local pBackimg = getRealUIResourcePath("img/new00154.png")
		if pBackimg then
			MoneyTree.m_pButton3:setBackgroundImage(pBackimg:getData())
		end
	end

	MoneyTree.m_pLabel4 = SCLabel:labelWithStringFont(L("str9148"), DEFAULT_FONT_NAME, F(9))
	if MoneyTree.m_pLabel4 then
		MoneyTree.m_pLabel4:setTag(4)
		MoneyTree.m_pLabel4:setAnchorPoint(ANCHOR_CENTER)
		MoneyTree.m_pLabel4:setPosition(AUTO_POS(76.50, 60.00))
	end

	MoneyTree.m_pLabel5 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(10))
	if MoneyTree.m_pLabel5 then
		MoneyTree.m_pLabel5:setTag(5)
		MoneyTree.m_pLabel5:setAnchorPoint(ANCHOR_CENTER)
		MoneyTree.m_pLabel5:setPosition(AUTO_POS(77.00, 47.00))
	end

	if pImage1 and pDragNode6003 then
		pDragNode6003:addChild(tolua.cast(pImage1, "SCNode"))
	end
	if pImage10002 and pDragNode6003 then
		pDragNode6003:addChild(tolua.cast(pImage10002, "SCNode"))
	end
	if MoneyTree.m_pButton3 and pDragNode6003 then
		pDragNode6003:addChild(tolua.cast(MoneyTree.m_pButton3, "SCNode"))
	end
	if MoneyTree.m_pLabel4 and pDragNode6003 then
		pDragNode6003:addChild(tolua.cast(MoneyTree.m_pLabel4, "SCNode"))
	end
	if MoneyTree.m_pLabel5 and pDragNode6003 then
		pDragNode6003:addChild(tolua.cast(MoneyTree.m_pLabel5, "SCNode"))
	end
	return pDragNode6003
end
function MoneyTree.releaseControl()
	MoneyTree.m_pButton3 = nil
	MoneyTree.m_pLabel4 = nil
	MoneyTree.m_pLabel5 = nil
	if MoneyTree.wndCloss then
		MoneyTree.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------
local function onEnterBtnClick(tag)
    local MAP_CHEAT_PROSON	= 1080400--,			// 外挂监狱
    if MAP_CHEAT_PROSON == math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100 then
        showMessage(L("str20047"))
        return
    end
    
	local wndCtrl = getCurentSceneWindowController(9002);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end
	
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_MONEYTREE);
	if dataStream then
		dataStream:writeShort(MSG_SG_ACTION_ENTERMONEYTREE)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
	--MoneyTree_sendBeatMoneyTree(1);
end

local function onTimerOut(tag)
    local pButton3 = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022-6003-3"), "SCButton")
    if pButton3 then
        local imgPath1 = getRealUIResourcePath("img/new00154.png");
        local imgPath2 = getRealUIResourcePath("img/new00193.png");
        if imgPath1 and imgPath2 then
            pButton3:setBackgroundImage(imgPath1:getData());
            pButton3:setTitle(imgPath2:getData());
            pButton3:removeAllChildrenWithCleanup(true);
        end
    end
end

local function refreshMoneyTreeNode()
	local pDragNode = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022-6003"), "SCDragNode")
	if pDragNode then
		if not pDragNode:getChildByTag(12000) then
			local label = SCLabel:labelWithStringFont(L("str5158"), DEFAULT_FONT_NAME, F(15))
			if label then
				label:setTag(12000)
				label:setAnchorPoint(ANCHOR_CENTER)
				label:setPosition(pDragNode:getContentSize().width / 2 , SY(95))
				label:setColor(color_red)
				pDragNode:addChild(label)
			end
		end
		if not pDragNode:getChildByTag(12001) then
			local label = SCLabel:labelWithStringFont(L("str3286"), DEFAULT_FONT_NAME, F(11))
			if label then
				label:setTag(12001)
				label:setAnchorPoint(ANCHOR_CENTER)
				label:setPosition(pDragNode:getContentSize().width / 2 , SY(80))
				label:setColor(color_red)
				pDragNode:addChild(label)
			end
		end
	end
	if ActivityAll_isUnlock(S_WONDERFULEVENT_TYPE_MONEY_TREE) then
		local pDragNode = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022-6003"), "SCDragNode")
		if pDragNode then
			if not pDragNode:getChildByTag(12000) then
				local label = SCLabel:labelWithStringFont(L("str5158"), DEFAULT_FONT_NAME, F(13))
				if label then
					label:setTag(12000)
					label:setAnchorPoint(ANCHOR_CENTER)
					label:setPosition(pDragNode:getContentSize().width / 2 , SY(85))
					label:setColor(color_green)
					pDragNode:addChild(label)
				end
			end
		end
	end
    local pLabel5 = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022-6003-5"), "SCLabel")
	if pLabel5 then
		local str = L("str9149")..m_moneyTree.ntime;
		pLabel5:setText(str);
	end
	local pLabel4 = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022-6003-4"), "SCLabel")
	if pLabel4 then
	    pLabel4:setVisible(true)
	    local money = 0
	    local str = nil
	    money = m_moneyTree.getMoney 
	    if 1 == m_moneyTree.ucFlag then
			str = L("str3288")..money
	    else
			str = L("str3289")..money
	    end
	    pLabel4:setText(str)
	end
	local pButton3 = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022-6003-3"), "SCButton")
	if pButton3 then
		if m_moneyTree.cooltime > 0 then
			pButton3:setTitle("", getDefaultFontName(), getFontSize(12));
			local child = pButton3:getChildByTag(1);
			if child == nil then
				child = CountDownNode:newCountDownNode();
				if child then
				    child:setTag(1)
					child:setTime(m_moneyTree.cooltime);
					child:setAnchorPoint(CCPointMake(0.5, 0.5));
					child:setPosition(pButton3:getContentSize().width/2, pButton3:getContentSize().height/2);
					child:luasetSelectorOnClose(onTimerOut);
					pButton3:addChild(child);
				end
			end
		elseif m_moneyTree.cooltime == 0 and m_moneyTree.ntime == 0 then
			local imgPath = getRealUIResourcePath("img/new00155.png");
			if imgPath then
				pButton3:setTouchEnabled(false);
			end
		end
	end
end
----------------消息处理区----------------
local function recvMoneyTreeInfo()
	SCActivityIndicator:getSingleton():close();
	local dt = LuaData:getSingleton():getDataTransStream();
	if dt == nil then
	    return;
	end
	
	m_moneyTree.ntime = dt:readInt();
	m_moneyTree.cooltime = dt:readInt();
	m_moneyTree.getMoney = dt:readInt()
	m_moneyTree.ucFlag = dt:readByte()
	--showMoneyTreeNode();
	refreshMoneyTreeNode()
end

----------------消息注册区----------------
LuaData:getSingleton():luaSetSelectorOnRecvData(recvMoneyTreeInfo, LuaData_MSG_SG_ACTION_MONEYTREEINFO);
----------------全局函数区----------------
function MoneyTree_sendRequestMoneyTreeInfo()
    if luaIsUnlock(UNLOCK_TYPE_TYPE7) then
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_MONEYTREE);
        if dataStream then
            dataStream:writeShort(MSG_SG_ACTION_MONEYTREEINFO)
            SCDataTransThread:getSingleton():transData(dataStream)
            SCActivityIndicator:getSingleton():show();
        end 
    end
end

function MoneyTree_sendBeatMoneyTree(flag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_MONEYTREE);
	if dataStream then
		dataStream:writeShort(MSG_SG_ACTION_BEATMONEYTREE)
		dataStream:writeByte(flag);
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 	
end

function MoneyTree_setEnterBtnClick()
    local pButton3 = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022-6003-3"), "SCButton")
    if pButton3 then
        pButton3:luaSetSelectorOnClicked(onEnterBtnClick);
    end
end

function showMoneyTreeNode()
	local wndCtrl = getCurentSceneWindowController(9002);
	if wndCtrl == nil then
		return;
	end
	
	local pDragNode20 = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022"), "SCDragNode")
	if pDragNode20 and pDragNode20:getChildByTag(6003) == nil then
		local node = MoneyTree.initControl();
		if node then
			node:setAnchorPoint(CCPointMake(0, 0));
			node:setPosition(CCPointMake(0, 0));
			node:setTag(6003);
			pDragNode20:addChild(node);
			local pLabel4 = tolua.cast(SCFunction:getUiNodeByIdlist("9002-10022-6003-4"), "SCLabel")
			if pLabel4 then
				pLabel4:setColor(color_lightgreen);
				pLabel4:setVisible(false)
			end
			
			--refreshMoneyTreeNode();
		end
	end
end

function MoneyTree.wndCloss()
	m_moneyTree = {}
end

--函数调用