--定义一个与文件名相同的table
NewDailyAttend = {}
------------------消息--------------------

----------------结构定义区----------------
local stRechargeItem = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		--local self = {
        --    __mode = "kv",
        --}
		local self = {}			
		self.usAwardType = dt:readShort();    --物品类型
	    self.idItemType = dt:readInt();       --物品id
	    self.nNum = dt:readInt();             --物品个数
		return self
	end
}

local stGiftInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		--local self = {
        --    __mode = "kv",
        --}
	    local self = {}	
		self.ucFlag = dt:readByte();        --领取标记 0 未达到 1 达到条件 2 已领取
	    self.nCondition = dt:readInt();     --条件  各个礼包天数
	    self.idGiftType = dt:readInt();     --礼包模版id
	    self.ucAmount = dt:readByte();		--奖励个数
	    self.stfill = {}
	    for i = 1, self.ucAmount do
            table.insert(self.stfill, stRechargeItem.initWithStream(dt))
        end
		return self
	end
}
----------------常量定义区----------------
local GIFTINFO_SEND_GIFT_INFO_BEGIN = 11  --礼包信息下发开始 
local GIFTINFO_SEND_GIFT_INFO_END   = 12  --礼包信息下发解锁 
local GIFTINFO_GET_GIFT_AWARD       = 13  --获取礼包
local GIFTINFO_CHECK_GIFT_INFO = 28   	  --查看每日签到礼包
----------------变量定义区----------------
--变量的定义
local m_Day = 0;       --签到天数
local m_Flag = nil;    --领取标记 用来刷新界面
local m_isLogin = nil; --今天是否签到
local m_stInfo = {};
----------------UI控制器区----------------
function NewDailyAttend.initControl()
	local pWindow4440 = SCWindow:window()
	if pWindow4440 then
		pWindow4440:setTag(4440)
		pWindow4440:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4440:setPosition(AUTO_POS(0.00, 0.00))pWindow4440:setContentSize(AUTO_SIZE(480, 320))
		pWindow4440:luaSetSelectorOnClose(NewDailyAttend.releaseControl)
	end

	local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_CENTER)
		pDragNode1:setPosition(AUTO_POS(240.00, 160.00))
		pDragNode1:setContentSize(AUTO_SIZE(480, 320))
		pDragNode1:setFrameVisibled(true)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTyperedwindowstip)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(5.00, 1.00))
		pDragNode2:setContentSize(AUTO_SIZE(470, 298))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTypeRound)
	end

	local imgPath = getRealUIResourcePath("qiandao/new00785.jpg")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage3:setPosition(AUTO_POS(10.00, 8.00))
		end
	end

	NewDailyAttend.m_signInBtn = SCButton:button(EnumBtnTypeNormalImg)
	if NewDailyAttend.m_signInBtn then
		NewDailyAttend.m_signInBtn:setTag(4)
		NewDailyAttend.m_signInBtn:setAnchorPoint(CCPointMake(0.5, 0))
		NewDailyAttend.m_signInBtn:setPosition(AUTO_POS(225.00, 27.00))
		NewDailyAttend.m_signInBtn:setContentSize(AUTO_SIZE(94, 96))
		local imgPath = getRealUIResourcePath("qiandao/new00750.png")
		if imgPath then
			NewDailyAttend.m_signInBtn:setTitle(imgPath:getData())
		end
	end

	local pLable5 = SCLabel:labelWithStringFont(L("str3138"), DEFAULT_FONT_NAME, F(12))
	if pLable5 then
		pLable5:setTag(5)
		pLable5:setAnchorPoint(CCPointMake(0.5, 0))
		pLable5:setPosition(AUTO_POS(218.50, 0.00))
		pLable5:setColor(ccc4(60,255,0,255))
	end

	NewDailyAttend.m_labelDay = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(15))
	if NewDailyAttend.m_labelDay then
		NewDailyAttend.m_labelDay:setTag(6)
		NewDailyAttend.m_labelDay:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		NewDailyAttend.m_labelDay:setPosition(AUTO_POS(325.00, 260.00))
		NewDailyAttend.m_labelDay:setColor(ccc4(60,255,0,255))
	end

	local imgPath = getRealUIResourcePath("qiandao/new00749.png")
	local pImage8 = nil
	if imgPath then
		pImage8 = SCImage:imageWithFile(imgPath:getData())
		if pImage8 then
			pImage8:setTag(8)
			pImage8:setAnchorPoint(ANCHOR_CENTER)
			pImage8:setPosition(AUTO_POS(105.00, 11.00))
		end
	end

	local pButton101 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton101 then
		pButton101:setTag(101)
		pButton101:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton101:setPosition(AUTO_POS(55.00, 72.00))
		pButton101:setContentSize(AUTO_SIZE(48, 44))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton101:setTitle(imgPath:getData())
		end
	end

	local pButton102 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton102 then
		pButton102:setTag(102)
		pButton102:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton102:setPosition(AUTO_POS(80.00, 145.00))
		pButton102:setContentSize(AUTO_SIZE(48, 44))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton102:setTitle(imgPath:getData())
		end
	end

	local pButton104 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton104 then
		pButton104:setTag(104)
		pButton104:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton104:setPosition(AUTO_POS(206.00, 225.00))
		pButton104:setContentSize(AUTO_SIZE(48, 44))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton104:setTitle(imgPath:getData())
		end
	end

	local pButton105 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton105 then
		pButton105:setTag(105)
		pButton105:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton105:setPosition(AUTO_POS(285.00, 205.00))
		pButton105:setContentSize(AUTO_SIZE(48, 44))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton105:setTitle(imgPath:getData())
		end
	end

	local pButton106 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton106 then
		pButton106:setTag(106)
		pButton106:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton106:setPosition(AUTO_POS(345.00, 147.00))
		pButton106:setContentSize(AUTO_SIZE(48, 44))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton106:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("kernal/redtop.png")
	local pImage7 = nil
	if imgPath then
		pImage7 = SCImage:imageWithFile(imgPath:getData())
		if pImage7 then
			pImage7:setTag(7)
			pImage7:setAnchorPoint(CCPointMake(0.5, 0))
			pImage7:setPosition(AUTO_POS(240.00, 298.00))
		end
	end

	local imgPath = getRealUIResourcePath("app/new00678.pn")
	NewDailyAttend.m_Img7 = nil
	if imgPath then
		NewDailyAttend.m_Img7 = SCImage:imageWithFile(imgPath:getData())
		if NewDailyAttend.m_Img7 then
			NewDailyAttend.m_Img7:setTag(60)
			NewDailyAttend.m_Img7:setAnchorPoint(ANCHOR_CENTER)
			NewDailyAttend.m_Img7:setPosition(AUTO_POS(24.00, 22.00))
		end
	end

	local imgPath = getRealUIResourcePath("app/new00678.pn")
	NewDailyAttend.m_Img15 = nil
	if imgPath then
		NewDailyAttend.m_Img15 = SCImage:imageWithFile(imgPath:getData())
		if NewDailyAttend.m_Img15 then
			NewDailyAttend.m_Img15:setTag(70)
			NewDailyAttend.m_Img15:setAnchorPoint(ANCHOR_CENTER)
			NewDailyAttend.m_Img15:setPosition(AUTO_POS(24.00, 22.00))
		end
	end

	NewDailyAttend.m_CloseBtn = SCButton:button(EnumBtnTypeNormalImg)
	if NewDailyAttend.m_CloseBtn then
		NewDailyAttend.m_CloseBtn:setTag(16)
		NewDailyAttend.m_CloseBtn:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		NewDailyAttend.m_CloseBtn:setPosition(AUTO_POS(456.00, 298.00))
		NewDailyAttend.m_CloseBtn:setContentSize(AUTO_SIZE(20, 20))
		local imgPath = getRealUIResourcePath("img/new00123.pn")
		if imgPath then
			NewDailyAttend.m_CloseBtn:setTitle(imgPath:getData())
		end
	end

	local pButton103 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton103 then
		pButton103:setTag(103)
		pButton103:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton103:setPosition(AUTO_POS(141.00, 202.00))
		pButton103:setContentSize(AUTO_SIZE(48, 44))
		
	end

	local pButton107 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton107 then
		pButton107:setTag(107)
		pButton107:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton107:setPosition(AUTO_POS(369.00, 70.00))
		pButton107:setContentSize(AUTO_SIZE(48, 44))
		
	end

	if pDragNode1 and pWindow4440 then
		pWindow4440:addChild(tolua.cast(pDragNode1, "SCNode"))
	end
	if pDragNode2 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pImage3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if NewDailyAttend.m_signInBtn and pImage3 then
		pImage3:addChild(tolua.cast(NewDailyAttend.m_signInBtn, "SCNode"))
	end
	if pLable5 and pImage3 then
		pImage3:addChild(tolua.cast(pLable5, "SCNode"))
	end
	if NewDailyAttend.m_labelDay and pImage3 then
		pImage3:addChild(tolua.cast(NewDailyAttend.m_labelDay, "SCNode"))
	end
	if pImage8 and pImage7 then
		pImage7:addChild(tolua.cast(pImage8, "SCNode"))
	end
	if pButton101 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton101, "SCNode"))
	end
	if pButton102 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton102, "SCNode"))
	end
	if pButton104 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton104, "SCNode"))
	end
	if pButton105 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton105, "SCNode"))
	end
	if pButton106 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton106, "SCNode"))
	end
	if pImage7 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pImage7, "SCNode"))
	end
	if NewDailyAttend.m_Img7 and pButton103 then
		pButton103:addChild(tolua.cast(NewDailyAttend.m_Img7, "SCNode"))
	end
	if NewDailyAttend.m_Img15 and pButton107 then
		pButton107:addChild(tolua.cast(NewDailyAttend.m_Img15, "SCNode"))
	end
	if NewDailyAttend.m_CloseBtn and pDragNode1 then
		pDragNode1:addChild(tolua.cast(NewDailyAttend.m_CloseBtn, "SCNode"))
	end
	if pButton103 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton103, "SCNode"))
	end
	if pButton107 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton107, "SCNode"))
	end
	return pWindow4440
end
function NewDailyAttend.releaseControl()
	NewDailyAttend.m_signInBtn = nil
	NewDailyAttend.m_labelDay = nil
	NewDailyAttend.m_Img7 = nil
	NewDailyAttend.m_Img15 = nil
	NewDailyAttend.m_CloseBtn = nil
	if NewDailyAttend.wndClose then
		NewDailyAttend.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function onCloseNewDailyAttendBtnClick(tag)
    local wndCtrl = getCurentSceneWindowController(4440);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end
end

local function setDays(num, pNode, x)
    local imgPath = getRealUIResourcePath("qiandao/new00751.png")
	local pImage = nil
	if imgPath then
		pImage = SCImage:imageWithFile(imgPath:getData())
		if pImage then
			pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage:setPosition(AUTO_POS(x, -15.00))
			pNode:addChild(pImage)
		end
	end
	local pBattleNumber = getImageNumber(num, "img/new00530.png", SX(12.2), SY(18), SX(8));
    if pBattleNumber then
        pBattleNumber:setAnchorPoint(CCPointMake(1, 0))
        if num < 10 then
            pBattleNumber:setPosition(CCPointMake(SX(8), 0));
        else
            pBattleNumber:setPosition(CCPointMake(SX(20), 0));
        end
        pImage:addChild(pBattleNumber);
    end
end

local function setDaysImgToNode()
    for i = 1 , 7 do
        local pNode = nil
        pNode = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-10"..i), "SCButton");
        if pNode and m_stInfo[i] then
            setDays(m_stInfo[i].nCondition, pNode, 8);
        end
    end
end

local function showArwad(tag)
    local num = tag - 100;
    local text = L("str0544");
    for i = 1, m_stInfo[num].ucAmount do    
        if m_stInfo[num].stfill[i].usAwardType == 1 then
            text = text..L("*6")..L("str6157")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 4 then
            text = text..L("*6")..L("str5172")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 5 then
            text = text..L("*6")..L("str0193")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 7 then
            text = text..L("*6")..L("str0138")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 9 then
            text = text..L("*6")..L("str8158")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 101 then
            text = text..L("*6")..L("str6156")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        else
            local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_stInfo[num].stfill[i].idItemType);
            if itemInfo then
                text = text..L("*6")..itemInfo.name:getData().."X1"..L("*0").." ";
            end
        end
    end
    showMessage(text)
end


local function clickSignin()
	TurnTable_sendData() 
end
local function clickNotSignin()
    showMessage(_LTParser("str3139"))
end
local function clickNotGetAward()
    showMessage(_LTParser("str3140"))
end
local function setLight(pBtn)
    if pBtn then
        pBtn:removeChildByTag(999,true);
        local pAni = SCLookfaceParser:getSingleton():getAnimationByIndex(1018, 1018);
        if pAni then
	        local pAnimation =  SCAnimationNode:nodeWithAnimation(pAni);
	        if pAnimation then
                pAnimation:setAnchorPoint(CCPointMake(0.5, 0.5));
                pAnimation:setTag(999);
                local size = pBtn:getContentSize();
                pAnimation:setPosition(CCPointMake(size.width / 2, size.height / 2));
                pBtn:addChild(pAnimation);
	        end
        end
    end
end
local function setLock(pBtn)
    if pBtn then
        pBtn:removeChildByTag(998,true);
        local imgFile = getRealUIResourcePath("img/new00444.png");
        if imgFile then
            local pImg =  SCImage:imageWithFile(imgFile:getData())
            if pImg then
                pImg:setAnchorPoint(CCPointMake(0.5, 0.5));
                pImg:setTag(998);
                local size = pBtn:getContentSize();
                pImg:setPosition(CCPointMake(size.width / 2, size.height / 2));
                pBtn:addChild(pImg);
            end
        end
    end
end
local function NewDailyAttend_refresh()
    local pButton4 = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-3-4"), "SCButton")
    if m_isLogin and pButton4 then
        if m_isLogin == 1 then
            pButton4:luaSetSelectorOnClicked(clickSignin);
        elseif 0 == m_isLogin then
            pButton4:luaSetSelectorOnClicked(clickNotSignin);
        end
    end
    local pLabel6 = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-3-6"), "SCLabel")
    if pLabel6 then
	    pLabel6:setText(string.format(L("str0539"), m_Day));
	    pLabel6:setPosition(CCPointMake(SX(295), pLabel6:getPosition().y))
    end
    for i = 1 , 7 do
        local pButton = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-10"..i), "SCButton");
        if pButton then
			if m_stInfo[i] then
                 pButton:removeChildByTag(999,true);
                if m_stInfo[i].ucFlag == 0 then
                    pButton:luaSetSelectorOnClicked(NewDailyAttend_onClickArwad)
                elseif m_stInfo[i].ucFlag == 1 then
                    pButton:removeChildByTag(998,true);
                    pButton:luaSetSelectorOnClicked(NewDailyAttend_sendGetAward)
                    setLight(pButton)
                elseif m_stInfo[i].ucFlag == 2 then
                    setLock(pButton);
                    pButton:luaSetSelectorOnClicked(clickNotGetAward)
                end
            end
        end
    end
end

---点击签到礼包---
function NewDailyAttend_onClickArwad(tag)
	if m_stInfo[tag - 100] and m_stInfo[tag - 100].nCondition then
		NewDailyAttend_sendAward(m_stInfo[tag - 100].nCondition)
	end
end

----------------消息处理区----------------
function NewDailyAttend_RecvDataBegin(dt)    --分包开始接收
    m_isLogin = dt:readByte();         --0不可点击 1可点击
    m_Day = dt:readInt();              --签到天数 
	local ucAmount = dt:readByte();
	for i = 1, ucAmount do
	    table.insert(m_stInfo, stGiftInfo.initWithStream(dt));
	end
end
function NewDailyAttend_RecvDataStop(dt)    --分包结束接收
    m_isLogin = dt:readByte();         --0不可点击 1可点击
    m_Day = dt:readInt();              --签到天数 
	local ucAmount = dt:readByte();
	for i = 1, ucAmount do
	    table.insert(m_stInfo, stGiftInfo.initWithStream(dt));
	end
	ShowWndNewDailyAttend();
	NewDailyAttend_refresh()
end

function NewDailyAttend_sendGetAward(tag)    --获取礼包信息
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);
    if dataStream then                   ----消息发送提示
		dataStream:writeShort(GIFTINFO_GET_GIFT_AWARD)
		m_Flag = tag - 100
		dataStream:writeInt(m_stInfo[m_Flag].idGiftType);
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show()
    end
end

---签到礼包领取、查看---
function NewDailyAttend_sendAward(index)  
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO)
    if dataStream then               
		dataStream:writeShort(GIFTINFO_CHECK_GIFT_INFO)
		dataStream:writeInt(index)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show()
    end
end

function NewDailyAttend_RecvAward(dt)
    local usAwardType = dt:readByte();
	local idItemType = dt:readInt();
	local nNum = dt:readInt();
	
	local str = ""
	
	if usAwardType == 1 then
		str = L("str0540")..L("*6")..L("str6157")..":"..L("*4")..nNum
	elseif usAwardType == 4 then
		str = L("str0540")..L("*6")..L("str5172")..":"..L("*4")..nNum
	elseif usAwardType == 5 then
		str = L("str0540")..L("*6")..L("str0193")..":"..L("*4")..nNum
	elseif usAwardType == 7 then
		str = L("str0540")..L("*6")..L("str0138")..":"..L("*4")..nNum
	elseif usAwardType == 9 then
		str = L("str0540")..L("*6")..L("str8158")..":"..L("*4")..nNum
	elseif usAwardType == 101 then
		str = L("str0540")..L("*6")..L("str6156")..":"..L("*4")..nNum
	else
		local itemInfo = TableParser:getSingleton():getItemInfoByKey(idItemType);
		if itemInfo then
			str = L("str0540")..L("*6")..itemInfo.name:getData().."X1"
		end
	end
	
	m_Day = m_Day + 1
	
	--更新签到天数
	local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4440-1-2-3-6"))
	if pLabel then
		pLabel:setText(string.format(L("str0539"), m_Day))
	    pLabel:setPosition(CCPointMake(pLabel:getPosition().x, pLabel:getPosition().y))
	end

	--签到按钮回调修改
	local pButton4 = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-3-4"), "SCButton")
    if pButton4 then
		pButton4:luaSetSelectorOnClicked(clickNotSignin);
	end
	
	--判断礼包是否可领,并修改回调
	for i = 1, #m_stInfo do
		if not m_stInfo[i] then break end
		if m_Day == m_stInfo[i].nCondition then
			local pButton = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-10"..i), "SCButton")
			pButton:removeChildByTag(998,true);
			pButton:luaSetSelectorOnClicked(NewDailyAttend_sendGetAward)
			setLight(pButton)
			break
		end
	end
	
	for i = 1, #m_stInfo do
		if not m_stInfo[i] then break end
		if m_Day < m_stInfo[i].nCondition then
			local strDayInfo = string.format(L("str30133"), m_stInfo[i].nCondition - m_Day, m_stInfo[i].nCondition)
			showMessage(str.."_*2"..strDayInfo)
			break
		end
	end
end
----------------消息注册区----------------

----------------全局函数区----------------
function ShowWndNewDailyAttend()
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4440);
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
		if m_labelDay then
		    m_labelDay:setText(string.format(L("str0539"), m_Day));
			m_labelDay:setPosition(CCPointMake(m_labelDay:getPosition().x, m_labelDay:getPosition().y))
		end
	else
		wnd = NewDailyAttend.initControl();
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd);
			local naviCtrl = getCurentSceneNavigationController();
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl);
				--wndCtrl:luaSetSelectorOnEvent(showWin);
				wnd:setBackButtonVisibled(false);
                wnd:setCloseButtonVisibled(false);
                wnd:setFrameVisibled(false);
			end
			local pButton16 = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-16"), "SCButton")
			if pButton16 then
                pButton16:setMusicPath("closeWindow.mp3");
			    pButton16:luaSetSelectorOnClicked(onCloseNewDailyAttendBtnClick);
			    pButton16:setTouchRectScale(4.0,4.0)
		    end
		    local pImage60 = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-103-60"), "SCImage")
		    local pImage70 = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-107-70"), "SCImage")
		    if pImage70 and pImage60 then
		        pImage70:setScale(0.7)
		        pImage60:setScale(0.7)
		    end
		    setDaysImgToNode()
		 end
    end
end

function NewDailyAttend_RecvGetAward()    --领取礼包后刷新界面
    local pButton = tolua.cast(SCFunction:getUiNodeByIdlist("4440-1-2-10"..m_Flag), "SCButton");
    if pButton then
        pButton:removeChildByTag(999,true);
        pButton:luaSetSelectorOnClicked(clickNotGetAward)
        setLock(pButton)
    end
end

function NewDailyAttend.setM_stInfoNull()
    m_stInfo = {};
end

function NewDailyAttend.wndClose()
    m_Day = 0;      --签到天数
    m_Flag = nil;   --领取标记 用来刷新界面
    m_isLogin = nil;
    m_stInfo = {};
end

--函数调用