--定义一个与文件名相同的table
OnTheWine = {}
------------------消息--------------------
local MSG_DRINK_SENDWINE = 8
local MSG_DRINK_GETREWARD = 9		--//领取对酒奖励
local MSG_DRINK_SENDWINEINFO_BEGIN = 10   --,//对酒信息开始 
local MSG_DRINK_SENDWINEINFO_END   = 11   --,//对酒信息结束

local m_stDrinkState = {__mode = "kv"}
local Friend_ListBox
local m_nFriendShow = nil
----------------结构定义区----------------
local strContentInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        local strBuf = dt:readString(); --//对酒信息
        if strBuf then
            tmp.content = strBuf:getData();
        else
            tmp.content = "";
        end
        return tmp
    end
}
local OpenDrinkingInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.sendrewardflag = dt:readByte(); --// 是否已经拿过奖励 友好度奖励
        tmp.recrewardflag = dt:readByte();	--//人气度奖励	
        tmp.sendtimes = dt:readInt();		--//友好值
        tmp.receivetimes = dt:readInt();	--//人气值
        tmp.contentnum = dt:readInt();		--//对酒信息数	
        tmp.contentInfo = {__mode = "kv"};
        for i = 1, tmp.contentnum do   
            table.insert(tmp.contentInfo, strContentInfo.initWithStream(dt));
        end
        return tmp
    end
}

--对酒
local stDringInfo = {
    initStream = function (dt)
        local tmp = {}
        if not dt then return tmp end 
        
        tmp.id = dt:readInt()
        tmp.state = dt:readByte()
        --[[
        tmp.lev = dt:readInt()
        tmp.power = dt:readInt()
        tmp.szName = dt:readString()
        if tmp.szName then
            tmp.szName = tmp.szName:getData()
        else
            tmp.szName = ""
        end
        tmp.ucOnlineFlag = dt:readByte()
        --]]
        return tmp
    end 
}

local stRecvDrinkState = {
    initStream = function (dt)
        if m_readEnd then
            m_stDrinkState = {}
            m_readEnd = nil
        end
        
        if not dt then return end 
        
        local ucAmount = dt:readInt()
        for i = 1, ucAmount do
            local tmp = stDringInfo.initStream(dt)
            if tmp.state == 1 then
                table.insert(m_stDrinkState, 1, tmp)
            else
                table.insert(m_stDrinkState, tmp)
            end
        end
    end
}
----------------常量定义区----------------

----------------变量定义区----------------
local m_onTheWineData = {__mode = "kv"};
local m_readEnd
--变量的定义
----------------UI控制器区----------------
function OnTheWine.initControl()
	local pWindow7029 = SCWindow:window()
	if pWindow7029 then
		pWindow7029:setTag(7029)
		pWindow7029:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow7029:setPosition(AUTO_POS(0.00, 0.00))pWindow7029:setContentSize(AUTO_SIZE(480, 320))
		pWindow7029:luaSetSelectorOnClose(OnTheWine.releaseControl)
	end

	local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(220.00, 286.00))
		pDragNode1:setContentSize(AUTO_SIZE(105, 25))
		pDragNode1:setFrameVisibled(true)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTypeListNormal)
	end

	local pLable2 = SCLabel:labelWithStringFont(L("label"), DEFAULT_FONT_NAME, F(15))
	if pLable2 then
		pLable2:setTag(2)
		pLable2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable2:setPosition(AUTO_POS(4.00, 5.00))
		pLable2:setColor(ccc4(255,128,64,255))
	end

	local pLable3 = SCLabel:labelWithStringFont(L("label"), DEFAULT_FONT_NAME, F(15))
	if pLable3 then
		pLable3:setTag(3)
		pLable3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable3:setPosition(AUTO_POS(105.00, 5.00))
		pLable3:setColor(ccc4(255,128,64,255))
	end

	OnTheWine.m_list = SCListBox:boxWithWidthHeight(AUTO_W(467), AUTO_H(129))
	if OnTheWine.m_list then
		tolua.cast(OnTheWine.m_list, "SCNode"):setTag(4)
		tolua.cast(OnTheWine.m_list, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(OnTheWine.m_list, "SCNode"):setPosition(AUTO_POS(6.00, 116.00))
		OnTheWine.m_list:luaSetSelectorOnScrollToEnd(OnTheWine.listScrollEnd)
	end

	local pDragNode5 = SCDragNode:node()
	if pDragNode5 then
		pDragNode5:setTag(5)
		pDragNode5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode5:setPosition(AUTO_POS(8.00, 4.00))
		pDragNode5:setContentSize(AUTO_SIZE(465, 89))
		pDragNode5:setFrameVisibled(true)
		pDragNode5:setDragEnabled(false)
		pDragNode5:setFrameType(EnumFrameTypeRound)
	end

	local imgPath = getRealUIResourcePath("img/new00092.png")
	local pImage10008 = nil
	if imgPath then
		pImage10008 = SCImage:imageWithFile(imgPath:getData())
		if pImage10008 then
			pImage10008:setTag(10008)
			pImage10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10008:setPosition(AUTO_POS(217.00, 93.00))
		end
	end

	OnTheWine.m_listbox = SCListBox:boxWithWidthHeight(AUTO_W(445), AUTO_H(69))
	if OnTheWine.m_listbox then
		tolua.cast(OnTheWine.m_listbox, "SCNode"):setTag(6)
		tolua.cast(OnTheWine.m_listbox, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(OnTheWine.m_listbox, "SCNode"):setPosition(AUTO_POS(10.00, 10.00))
	end

	if pDragNode1 and pWindow7029 then
		pWindow7029:addChild(tolua.cast(pDragNode1, "SCNode"))
	end
	if pLable2 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable2, "SCNode"))
	end
	if pLable3 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable3, "SCNode"))
	end
	if OnTheWine.m_list and pWindow7029 then
		pWindow7029:addChild(tolua.cast(OnTheWine.m_list, "SCNode"))
	end
	if pDragNode5 and pWindow7029 then
		pWindow7029:addChild(tolua.cast(pDragNode5, "SCNode"))
	end
	if pImage10008 and pWindow7029 then
		pWindow7029:addChild(tolua.cast(pImage10008, "SCNode"))
	end
	if OnTheWine.m_listbox and pDragNode5 then
		pDragNode5:addChild(tolua.cast(OnTheWine.m_listbox, "SCNode"))
	end
	return pWindow7029
end
function OnTheWine.releaseControl()
	OnTheWine.m_list = nil
	OnTheWine.m_listbox = nil
	if OnTheWine.wndClose then
		OnTheWine.wndClose()
	end
	
	m_stDrinkState = {}
	m_nFriendShow = nil
end
--函数定义
----------------逻辑功能区----------------
local function SortComp(a, b)
    if not a or not b then return end 
    
    if a.lev >= b.lev then
        return false
    end
    return true
end

local function CopyFriend(friend)
    if not friend then return {} end 
    
    local tmp = {}
    tmp.id = friend.id
    tmp.state = friend.state
    tmp.lev = friend.lev
    tmp.power = friend.power
    tmp.szName = friend.szName    
    tmp.ucOnlineFlag = friend.ucOnlineFlag
    
    return tmp
end

local function SortFriend()
    local friendData = NewFriend_getFriendData()
    local tmp = {}
    local insertIndex = 1
    if not friendData then
        return
    end
    for i=1, #friendData do
        local findFlag = false
        for j=1, #m_stDrinkState do
            if m_stDrinkState[j].id == friendData[i].idUser then
                local data = {}
                data.id = m_stDrinkState[j].id
                data.state = m_stDrinkState[j].state
                data.lev = friendData[i].dwData1
                data.power = friendData[i].dwData2
                data.szName = friendData[i].szName
                data.ucOnlineFlag = friendData[i].ucOnlineFlag
                if data.state == 1 then
                    table.insert(tmp, insertIndex, data)
                    insertIndex = insertIndex + 1
                else
                    table.insert(tmp, data)
                end
                findFlag = true
                break
            end
        end
        if false == findFlag then
            local data = {}
            data.id = friendData[i].idUser
            data.state = 0
            data.lev = friendData[i].dwData1
            data.power = friendData[i].dwData2
            data.szName = friendData[i].szName
            data.ucOnlineFlag = friendData[i].ucOnlineFlag
            table.insert(tmp, data)
        end
    end
    m_stDrinkState = tmp
    --[[
    local tmp1 = {}--1 0
    local tmp2 = {}--1 1
    local tmp3 = {}--0 0
    local tmp4 = {}--0 1
    table.sort(tmp, SortComp)
    for i = 1, #m_stDrinkState do
        local tmp = CopyFriend(m_stDrinkState[i])
        if tmp.state == 1 then
            if tmp.ucOnlineFlag == 0 then
                table.insert(tmp1, tmp)
            else
                table.insert(tmp2, tmp)
            end
        else
            if tmp.ucOnlineFlag == 0 then
                table.insert(tmp3, tmp)
            else
                table.insert(tmp4, tmp)
            end
        end
    end
    
    m_stDrinkState = {}
    for i = 1, #tmp2 do
        table.insert(m_stDrinkState, tmp2[i])
    end    
    for i = 1, #tmp1 do
        table.insert(m_stDrinkState, tmp1[i])
    end    
    for i = 1, #tmp4 do
        table.insert(m_stDrinkState, tmp4[i])
    end    
    for i = 1, #tmp3 do
        table.insert(m_stDrinkState, tmp3[i])
    end
    
    tmp1 = nil--0 0
    tmp2 = nil--0 1
    tmp3 = nil--1 0
    tmp4 = nil--1 1
    --]]
end

function OnTheWine.onSendWine(tag)
    OnTheWine.sendWine(tag)
    
    for i = 1, #m_stDrinkState do
        if m_stDrinkState[i].id == tag then
            m_stDrinkState[i].state = 0
            OnTheWine.UpdateItem(m_stDrinkState[i].id)
            break
        end
    end
    
    --Friend_ListBox(OnTheWine.m_list)
end

function OnTheWine.UpdateItem(id)
    if not id then return end 
    
    local pListBox4 = tolua.cast(SCFunction:getUiNodeByIdlist("7029-4"), "SCListBox")
    if not pListBox4 then return end
    
    local from
    local to
    local item
    for i = 1, #m_stDrinkState do
        if id == m_stDrinkState[i].id then
            from = i            
            break;            
        end
    end
    SortFriend()
    for i = 1, #m_stDrinkState do
        if id == m_stDrinkState[i].id then
            to = i
            break;            
        end
    end
    
    if not from or not to then return end
    
    pListBox4:removeItemAtIndex(from - 1)
    local pNode = OnTheWine1.initControl();
    if pNode then
        local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
        if pLabel then
            pLabel:setText(m_stDrinkState[to]["szName"]);
            if m_stDrinkState[to]["ucOnlineFlag"] == 0 then
                pLabel:setColor(color_gray)
            end
        end
        pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
        if pLabel then
            pLabel:setText(m_stDrinkState[to]["lev"] .. _LTParser("str0266"));
            if m_stDrinkState[to]["ucOnlineFlag"] == 0 then
                pLabel:setColor(color_gray)
            end
        end
        pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(4));
        if pLabel then
            pLabel:setText(m_stDrinkState[to]["power"]);
            if m_stDrinkState[to]["ucOnlineFlag"] == 0 then
                pLabel:setColor(color_gray)
            end
        end
        local pBtn = SCTypeCast:castNodeToButton(pNode:getChildByTag(5));
        if pBtn then
            pBtn:luaSetSelectorOnClicked(OnTheWine.onSendWine);
            pBtn:setTag(m_stDrinkState[to]["id"]);
            if m_stDrinkState[to]["state"] == 0 then
                pBtn:setTouchEnabled(false)
                pBtn:setButtonType(3)
                pBtn:setTitle(L("str20102"), getDefaultFontName(), F(15))
            end
        end                
        if pListBox4:itemCount() > to - 1 then
			pListBox4:insertItemAtIndex(pNode, to - 1);
		end
    end
    Friend_ListBox(pListBox4, true, 1)
end

function Friend_ListBox(pListBox, isScollEnd, increadNum)
   if not isScollEnd and m_nFriendShow then
        return
   end
   if nil == m_nFriendShow then
      m_nFriendShow = true
      SortFriend()
   end
   if not increadNum then
	  increadNum = 7
   end
   --Friend_SetFriendOnlineState(m_stDrinkState)
   if pListBox and #m_stDrinkState > 0 then
        local oldCount = pListBox:itemCount()
        local nowCount = oldCount+increadNum
        if nowCount > #m_stDrinkState then
            nowCount = #m_stDrinkState
        end
        for i = oldCount+1, nowCount do--#m_stDrinkState do
            local pNode = OnTheWine1.initControl();
            if pNode then
                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                if pLabel then
                    pLabel:setText(m_stDrinkState[i]["szName"]);
                    if m_stDrinkState[i]["ucOnlineFlag"] == 0 then
                        pLabel:setColor(color_gray)
                    end
                end
                pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
                if pLabel then
                    pLabel:setText(m_stDrinkState[i]["lev"] .. _LTParser("str0266"));
                    if m_stDrinkState[i]["ucOnlineFlag"] == 0 then
                        pLabel:setColor(color_gray)
                    end
                end
                pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(4));
                if pLabel then
                    pLabel:setText(m_stDrinkState[i]["power"]);
                    if m_stDrinkState[i]["ucOnlineFlag"] == 0 then
                        pLabel:setColor(color_gray)
                    end
                end
                local pBtn = SCTypeCast:castNodeToButton(pNode:getChildByTag(5));
                if pBtn then
                    pBtn:luaSetSelectorOnClicked(OnTheWine.onSendWine);
                    pBtn:setTag(m_stDrinkState[i]["id"]);
                    if m_stDrinkState[i]["state"] == 0 then
                        pBtn:setTouchEnabled(false)
                        pBtn:setButtonType(3)
                        pBtn:setTitle(L("str20102"), getDefaultFontName(), F(15))
                    end
                end                
                
                pListBox:addItem(pNode);
            end
        end
   end 
end

function OnTheWine.listScrollEnd(tag)
    local pListBox4 = tolua.cast(SCFunction:getUiNodeByIdlist("7029-4"), "SCListBox")
    if not pListBox4 then return end 
    Friend_ListBox(pListBox4, true)
end

local function sendOpenMsg()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_FLOWER);
    if dataStream then
        dataStream:writeShort(MSG_DRINK_OPEN_INFO);
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function setRewardState(sendrewardflag, recrewardflag)
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7029-1-2"));
    if pLabel then
        if sendrewardflag == 0 then
            if m_onTheWineData.receivetimes >= 30 then
                pLabel:setText("");
                local pBtn = SCButton:button();
                if pBtn then
		            pBtn:setTitle(L("str6193"), DEFAULT_FONT_NAME, F(15));
		            pLabel:addChild(pBtn);
		            pBtn:setTag(1);
                    pBtn:luaSetSelectorOnClicked(OnTheWine.onClickReward);
                end
            else
                pLabel:setText(L("str6167") .. m_onTheWineData.receivetimes .. "/30");
            end
        else
            pLabel:removeAllChildrenWithCleanup(true);
            pLabel:setText(L("str6169"));
        end
    end
    pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7029-1-3"));
    if pLabel then
        if recrewardflag == 0 then
            if m_onTheWineData.sendtimes >= 30 then
                pLabel:setText("");
                local pBtn = SCButton:button();
                if pBtn then
		            pBtn:setTitle(L("str6193"), DEFAULT_FONT_NAME, F(15));
		            pLabel:addChild(pBtn);
		            pBtn:setTag(2);
                    pBtn:luaSetSelectorOnClicked(OnTheWine.onClickReward);
                end
            else
                pLabel:setText(L("str6168") .. m_onTheWineData.sendtimes .. "/30");
            end
        else
            pLabel:removeAllChildrenWithCleanup(true);
            pLabel:setText(L("str6169"));
        end
    end
end

function OnTheWine.onClickReward(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_FLOWER);
    if dataStream then
        dataStream:writeShort(MSG_DRINK_GETREWARD);
        dataStream:writeByte(2 - tag);
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
    --[[if 1 == tag then
        setRewardState(1, m_onTheWineData.sendrewardflag);
    elseif 2 == tag then
        setRewardState(m_onTheWineData.recrewardflag, 1);
    end]]
end

function OnTheWine.onListNext()
    local pListBox4 = tolua.cast(SCFunction:getUiNodeByIdlist("7029-4"), "SCListBox")
    if not pListBox4 then return end 
    
    local szCell = AUTO_SIZE(350, 29)
    local height = tolua.cast(pListBox4, "SCScrollBox"):getOffset()
    if height then        
        height = height.y
        height = math.floor((height + szCell.height / 2) / szCell.height) * szCell.height
        pListBox4:setOffset(CCPointMake(0, height + szCell.height * 4))
    end    
end
local function setOnTheWineData(tmp)
    if tmp then
        m_onTheWineData = tmp;
    end
    setRewardState(m_onTheWineData.recrewardflag, m_onTheWineData.sendrewardflag);
    local pNode = SCDragNode:node()
    local pWnd = SCFunction:getUiNodeByIdlist("7029");
    if pNode and pWnd then
		pNode:setFrameVisibled(false);
		pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pNode:setPosition(AUTO_POS(6.00, 241.00))
		pNode:setContentSize(AUTO_SIZE(350, 29))
		pNode:setFrameVisibled(true)
		pNode:setDragEnabled(false)
		
		local pathNormal = RES("kernal/multi-page-large-other.pn")
        local pathSelect = RES("kernal/multi-page-large-current.pn")
        local szBtn = AUTO_SIZE(60, 30)
        local pt = {AUTO_POS(59.00, 14.50), AUTO_POS(170.00, 14.50), AUTO_POS(288.00, 14.50), AUTO_POS(410, 13.50)}
        local title = {L("str6170"), L("str6171"), L("str6172"), L("str6173")}
		for i = 2, 5 do		    
            if pathNormal and pathSelect then
                for i = 1, 4 do
                    local btn = SCButton:button()
                    if btn then
                        btn:setBackgroundImage(pathNormal)
                        btn:setSelectedImage(pathSelect)
                        btn:setAnchorPoint(ANCHOR_CENTER)
                        btn:setTitle(title[i], getDefaultFontName(), F(15), colorWhite())
                        btn:setPosition(pt[i])
                        btn:setTouchEnabled(false)                        
                        pNode:addChild(btn)
                    end
                end
            end
		end
        pWnd:addChild(pNode);
    end
    local pListBox6 = tolua.cast(SCFunction:getUiNodeByIdlist("7029-5-6"), "SCListBox")
    if pListBox6 and m_onTheWineData.contentnum then
        for i = 1, m_onTheWineData.contentnum do
            local pLabel = SCLabel:labelWithStringFont(m_onTheWineData.contentInfo[i].content, DEFAULT_FONT_NAME, F(12));
            if pLabel then
                pListBox6:addItem(pLabel);
            end
        end
        pListBox6:setOffset(CCPointMake(0, pListBox6:getContentSize().height));        
    end
end

local function ControlOperating()
    setOnTheWineData();
    --Friend_ListBox(OnTheWine.m_list);
end

----------------消息处理区----------------
local function recvOnTheWineData()    
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
    local action = dt:readShort();
    if MSG_DRINK_OPEN_INFO == action then
        setOnTheWineData(OpenDrinkingInfo.initWithStream(dt));
    elseif action == MSG_DRINK_SENDWINEINFO_BEGIN or action == MSG_DRINK_SENDWINEINFO_END then        
        stRecvDrinkState.initStream(dt)
        if action == MSG_DRINK_SENDWINEINFO_END then
            local pListBox4 = tolua.cast(SCFunction:getUiNodeByIdlist("7029-4"), "SCListBox")
            if pListBox4 then
                Friend_ListBox(pListBox4);     
            end
            m_readEnd = true
        end
    end
end

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recvOnTheWineData, _MSG_FLOWER, 0, nil);
----------------全局函数区----------------
function OnTheWine.wndCloss()
    OnTheWine1.releaseControl();
    m_onTheWineData = {__mode = "kv"};
end

function OnTheWine.showWnd()    
    sendOpenMsg();
    local wnd = OnTheWine.initControl();
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then            
            m_onTheWineData = {__mode = "kv"};
            naviCtrl:pushWindowController(wndCtrl)
            ControlOperating();
        end
    end
end

function OnTheWine.sendWine(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_FLOWER);
    if dataStream then
        dataStream:writeShort(MSG_DRINK_SENDWINE);
        dataStream:writeInt(tag);
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

function OntheWind_FriendOnlineNotify(friendData)
    local pWnd = SCFunction:getUiNodeByIdlist("7029");
    if not pWnd then return end 
    
    for i = 1, #m_stDrinkState do
        for j = 1, #friendData do
            if friendData[j].id == stFriendList[i].id then
                stFriendList[i].ucOnlineFlag = friendData[j].ucOnlineFlag
                break
            end
        end
    end    
    
    local pListBox4 = tolua.cast(SCFunction:getUiNodeByIdlist("7029-4"), "SCListBox")
    if pListBox4 then
        Friend_ListBox(pListBox4)
    end
end
--函数调用