--****************************************************** 充值界面
local moneyTypeName=nil;  --类型
local moneyUnit=nil;      --单元
local moneyAmount=nil;    --金额个数
local moneyTag=0;
local pRadioGroup=nil;    --单选框
local pfRechargeBtn=nil;  --平台充值
local AlipayBtn=nil;      --确认充值
local appName =nil;
--****************************************************** 点击充值
local function onClickPlatformAlipay(tag)
	SCPay:getSingleton():DoPlatformPay(moneyTag);
end
--****************************************************** 点击注意事项 或是 平台充值
local function OnClickCarkRechargeable(tag)

  if SCPay:getSingleton():BePlatformRecharge() then
       SCPay:getSingleton():DoPlatformRecharge();
  else
        local framWnd = FrameWindow:frameWnd();
        local wnd = SCFunction:getUiNodeByIdlist("7033");
        if framWnd and wnd then
            local pNode = getItemTextNode(L("str6229"));
            if pNode then
                local size = pNode:getContentSize();
                framWnd:addChild(pNode);
                pNode:setAnchorPoint(CCPointMake(0, 0.5));
                pNode:setPosition(CCPointMake(SX(10), size.height / 2 + SY(25)));
                framWnd:setContentSize(CCSizeMake(size.width + SX(20), size.height + SY(50)));
            end
            wnd:addChild(framWnd);
            framWnd:setCloseBtnVisible(false);
            local size = wnd:getContentSize();
            framWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
            framWnd:setPosition(CCPointMake(size.width / 2, size.height / 2));
        end
   end     
end
--****************************************************** 点击单选框
local function OnClickBtnMoney(tag)
       moneyTag=tag-10;
       if pRadioGroup then
        pRadioGroup:setSelectIndex(moneyTag);
       end
end

local function OnClickMoney(tag, radioIndex)
      moneyTag= radioIndex;
end

--****************************************************** 初始化界面
--兑换货币说明   325版本之前
local function getExchangeMoneyMSG()
 local msg ="";
 if string.match(appName, "_91") or string.match(appName, "_XIAOMI") then
    msg="1"..moneyTypeName.."=";
 elseif string.match(appName, "_NEARME") then
     msg="100"..moneyTypeName.."=";
 end
 return msg.._LTParser("strcf006");
end

--兑换货币说明  325版本之后
local function getExchangeMoneyMSG_NEW()
 local msg =SCPay:getSingleton():getUserCenterMenuMSG(100);
 if msg==nil or msg == "" then
   msg=_LTParser("strcf006");
 end
 return msg;
end
--初始化充值平台游戏币按键  325版本之前
local function initPlatformMoneyBtn()
  if pfRechargeBtn and SCPay:getSingleton():BePlatformRecharge()then
       if string.match(appName, "_91") then
          pfRechargeBtn:setTitle(_LTParser("strcf011"), getDefaultFontName(), getFontSize(12));
       end
  end
end

--初始化充值平台游戏币按键  325版本之后
local function initPlatformMoneyBtn_NEW(pNode)
  if pNode and pfRechargeBtn and SCPay:getSingleton():BePlatformRecharge() then
      local msg =SCPay:getSingleton():getUserCenterMenuMSG(101);
      if msg==nil or msg == "" then
          return;
      end
      pfRechargeBtn:setTitle(msg, getDefaultFontName(), getFontSize(12));
  else
      pfRechargeBtn:setVisible(false);
      AlipayBtn:setPosition(pNode:getContentSize().width/2-AlipayBtn:getContentSize().width/2 , AlipayBtn:getPosition().y);
  end
end
--初始化界面
local function initPlatformPrepaid()
 local pDragNode = SCFunction:getUiNodeByIdlist("7033-1")
    if pDragNode then
        pDragNode:removeAllChildrenWithCleanup(true);        
        local pNode = SCFunction:getUiByZipAndId(7033, 100);
            if pNode then
			
			    local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));  --角色名
                if pLabel then  
                    pLabel:setText(Hero:getSingleton():getName():getData());
                    pLabel:setColor(color_green);
					pLabel:setPosition(CCPointMake(pLabel:getPosition().x + SX(15), pLabel:getPosition().y))
                end
				
				pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(4));  --充值的类型
                if pLabel then  
                    pLabel:setText(moneyTypeName);
                end
				
				pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(5));  --请选择您需要充值的**数量
                if pLabel then  
                    pLabel:setText(_LTParser("strcf004")..moneyTypeName.._LTParser("strcf005"));
                end
				
				pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(19));  --1元人民币=10元宝
                if pLabel then
                    if CLIENT_VERSION<326 then  
                        pLabel:setText(getExchangeMoneyMSG());
                    else
                        pLabel:setText(getExchangeMoneyMSG_NEW());
                    end
                end
				
				local pTextbox = SCTypeCast:castNodeToTextBox(pNode:getChildByTag(7)); --说明
				if pTextbox then
				   pTextbox:setText("*2".._LTParser("strcf007")..moneyTypeName.._LTParser("strcf008")..moneyTypeName.._LTParser("strcf009"));
				end 
				
                pRadioGroup = SCTypeCast:castNodeToRadioGroup(pNode:getChildByTag(6));  --单选框
                if pRadioGroup and moneyAmount<10 and moneyAmount>=0 then
                    pRadioGroup:luaSetSelectorOnItemSelected(OnClickMoney);
                    for i = 0, 8 do
						if i>=moneyAmount then
							pRadioGroup:setItemVisible(i,false);
						else
							pRadioGroup:setDescribe(i, SCPay:getSingleton():getMoneyByIndex(i)..moneyUnit, getDefaultFontName(), getFontSize(12), color_skyBlue);
						end
                    end
                end
				local count = 10+moneyAmount;
                for i = 10, 18 do
                    local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
                    if Btn then
					    if i<count then
                          Btn:luaSetSelectorOnClicked(OnClickBtnMoney);
						else
						  Btn:setVisible(false);
						end  
                    end
                end
				
                AlipayBtn = SCTypeCast:castNodeToButton(pNode:getChildByTag(9));  --确认充值
                if AlipayBtn then
                    AlipayBtn:luaSetSelectorOnClicked(onClickPlatformAlipay);
                end
                pfRechargeBtn = SCTypeCast:castNodeToButton(pNode:getChildByTag(8));   --注意事项
                if pfRechargeBtn then
                    if CLIENT_VERSION <326 then   --版本判断
                      initPlatformMoneyBtn();
                    else
                      initPlatformMoneyBtn_NEW(pNode);
                    end
                      pfRechargeBtn:luaSetSelectorOnClicked(OnClickCarkRechargeable);
                end

                pDragNode:addChild(pNode);
            end  
	 end	
end

local function platformPrepaidWindowOnEvent(tag,type)
	if type == LuaControllerEventPushEnded then
	      initPlatformPrepaid();
	end
end

--****************************************************** 关闭界面调用
local function PlatformPrepaidWndClose()
    moneyTypeName=nil;  --类型
    moneyUnit=nil;      --单元
    moneyAmount=nil;    --金额个数
    moneyTag=0;
    pRadioGroup=nil;
    appName=nil;
    pfRechargeBtn=nil;
end

--****************************************************** 创建界面
local function createPlatformRechargeableWnd()   
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7033));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("app/new00672.png")  --充值
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(PlatformPrepaidWndClose);  
    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", wnd));
    if pDragNode then
        pDragNode:setFrameVisibled(true);
        pDragNode:setFrameType(EnumFrameTypeRound);
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    return wndCtrl;
end

----------------------------------------------------------------------------------------------------------------全局入口 函数
function OpenPlatformPrepaidWindow()  --打开平台充值界面
    appName = getAppName():getData();
    if string.find(appName, "APPSTORE") or string.find(appName, "_KAKAO") or string.find(appName, "_TSTORE") or string.find(appName, "_TG") then
        itunesPayWindow.showItunesWindow();
		return;
    else
        moneyTypeName=SCPay:getSingleton():getMoneyTypeName();  --类型
        moneyUnit=SCPay:getSingleton():getMoneyUnitName();      --单元
        moneyAmount=SCPay:getSingleton():getMoneyAmount();      --金额个数
        moneyTag=0;
        
        
        local wndCtrl = createPlatformRechargeableWnd();    
        local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and wndCtrl then
            wndCtrl:luaSetSelectorOnEvent(platformPrepaidWindowOnEvent);
            naviCtrl:pushWindowController(wndCtrl);
        end
    end  
end