local MSG_MAGICS_QUERY_TITLE        = 44    --打开称号界面
local MSG_MAGICS_SAVE_TITLE         = 45    --保存称号
local NAMEACT_USER_DESIGNATION      = 28    --人物当前称号更新
local MSG_MAGICS_LOGIN_TITLE        = 46    --登入时发送当前人物称号的状态
local MSG_MAGICS_SHOW_TITLE         = 47    --改变人物称号的显示状态

local btnIsVisible = nil;
local mark = nil;

local titlemsg = {
    __mode = "kv",
}

local stTieleInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idTitle = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTitleName = ""
        else
            tmp.szTitleName = scStr:getData()
        end
        scStr = dt:readString()
        if scStr == nil then
            tmp.szDesignation = ""
        else
            tmp.szDesignation = scStr:getData()
        end
        tmp.idPhoto = dt:readInt();
        return tmp
    end
}
local stTiele = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.usAmount = dt:readShort();
        tmp.Title = {};
        for i = 1, tmp.usAmount do
            table.insert(tmp.Title, stTieleInfo.initWithStream(dt));
        end
        tmp.ucType = dt:readByte();
        return tmp
    end
}

local stLoginTiele = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTitleName = ""
        else
            tmp.szTitleName = scStr:getData()
        end
        tmp.ucType = dt:readByte();
        tmp.idPhoto = dt:readInt();
        return tmp;
     end
}

local function PlayerTitleWndClose()
    btnIsVisible = nil;
    mark = nil;
    titlemsg = {__mode = "kv",}
end

local function onBtnClick(tag)
    if tag == 1 then
        if nil == mark then
            return;
        end
        if titlemsg[mark].idTitle == 0 then
            return;
        end
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_MAGICINFO);
        dataStream:writeShort(MSG_MAGICS_SAVE_TITLE);
        dataStream:writeInt(titlemsg[mark].idTitle);
        if SCDataTransThread:getSingleton() then
            SCDataTransThread:getSingleton():transData(dataStream);
            SCActivityIndicator:getSingleton():show();
        end
        return;
    end
    if tag == 2 then
        local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7003-1"));
        local pDragNode = nil;
        if pMultiPage then
            pDragNode = SCTypeCast:castNodeToDragNode(pMultiPage:getCurrentPage());
            if nil == pDragNode then    
                return;
            end
        end
        local btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(2));
        if btn == nil then
            return;
        end
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_MAGICINFO);
        dataStream:writeShort(MSG_MAGICS_SHOW_TITLE);
        if btnIsVisible == 0 then
            btn:setTitle(_LTParser("str6028"), getDefaultFontName(), getFontSize(15), Button_Normal_Color);
            dataStream:writeByte(1);
            btnIsVisible = 1;
        elseif btnIsVisible == 1 then
            local heroMapObject = tolua.cast(Hero:getSingleton(), "MapObject");
            local titlename = Hero:getSingleton():getTitle():getData();
            if titlename == "" then
                return;
            end
            btn:setTitle(_LTParser("str6029"), getDefaultFontName(), getFontSize(15), Button_Normal_Color);
            dataStream:writeByte(0);
            btnIsVisible = 0;
        end
        SCDataTransThread:getSingleton():transData(dataStream);
        return;
    end
end

local function OnPageSelected(tag, pageIndex)  
    mark = nil;      
    titlemsg = {__mode = "kv",}
    if SCActivityIndicator:getSingleton() then
        SCActivityIndicator:getSingleton():show();
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_MAGICINFO);
    dataStream:writeShort(MSG_MAGICS_QUERY_TITLE);
    if pageIndex == 0 then
        dataStream:writeByte(1);
    end
    if pageIndex == 1 then
        dataStream:writeByte(2);
    end
    if pageIndex == 2 then
        dataStream:writeByte(3);
    end
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function creatWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7003));
    if wnd == nil then
        return nil 
    end
    --wnd:setFrameVisibled(false);
    if SCPath:getSingleton() then
        local imgPath = getRealUIResourcePath("img/titile61.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
    end
    wnd:luaSetSelectorOnClose(PlayerTitleWndClose);
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if pMultiPage then
        pMultiPage:luaSetSelectorOnPageSelected(OnPageSelected);
    end
    for i = 1, 3 do        
        local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-10" .. (i - 1), tolua.cast(wnd, "SCNode")));
        if pDragNode then
            pDragNode:setFrameType(EnumFrameTypeRound);
            pDragNode:setFrameVisibled(true);
        end
        local pButton = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-10" .. (i - 1) .. "-1", tolua.cast(wnd, "SCNode")));
        if pButton then
            pButton:luaSetSelectorOnClicked(onBtnClick);
        end
        pButton = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-10" .. (i - 1) .. "-2", tolua.cast(wnd, "SCNode")));
        if pButton then
            pButton:luaSetSelectorOnClicked(onBtnClick);
        end
    end
    --[[local pPageNode = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("1-100-3", tolua.cast(wnd, "SCNode")));
    if pPageNode then
        local pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7003, 104));
        if pNode then
            pNode:setFrameType(EnumFrameTypeRound);
            pNode:setFrameVisibled(true);
            pNode:setPosition(CCPointMake(0, 0));
        end
        pPageNode:addChild(pNode);
    end]]
    return wndCtrl;
end

local function onTitleId(tag)
    if mark == tag then 
        return;
    end
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7003-1"));
    if pMultiPage then
        local pDragNode = SCTypeCast:castNodeToDragNode(pMultiPage:getCurrentPage());
        if pDragNode then
            local pPageScrollBox = SCTypeCast:castNodeToPageScrollBox(pDragNode:getChildByTag(3));
            if pPageScrollBox then
                if nil ~= mark then
                    local index = getIntPart(mark / 3) + 1;
                    if mark % 3 == 0 then
                        index = index - 1;
                    end
                    local pNode = pPageScrollBox:getChildByTag(index);
                    if pNode then
                        local dragnode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(mark));
                        if dragnode then
                            dragnode:setFrameType(EnumFrameTypeListNormal);
                        end
                    end
                end
                local index = getIntPart(tag / 3) + 1;
                if tag % 3 == 0 then
                    index = index - 1;
                end
                local pNode = pPageScrollBox:getChildByTag(index);
                if pNode then
                    local dragnode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(tag));
                    if dragnode then
                        dragnode:setFrameType(EnumFrameTypeListSelect);
                    end
                    mark = tag;
                end
            end
        end
    end
end

local function creatPlayerTitle(tmp)
    if SCActivityIndicator:getSingleton() then
        SCActivityIndicator:getSingleton():close();
    end    
    if tmp.usAmount == 0 then
        local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7003-1"));
        if pMultiPage then
            local pDragNode = SCTypeCast:castNodeToDragNode(pMultiPage:getCurrentPage());
            if pDragNode then
                local label = SCLabel:labelWithStringFont(_LTParser("str6070"), getDefaultFontName(), getFontSize(15));
                if label then
                    label:setAnchorPoint(CCPointMake(0.5, 0.5));
                    label:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, pDragNode:getContentSize().height / 2 + 30 * gUIScale().y));
                    pDragNode:addChild(label);
                end
            end
        end
        return;
    end
    for i = 1, tmp.usAmount do
        table.insert(titlemsg, tmp.Title[i]);
    end
    if 0 == tmp.ucType then
        return;
    end
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7003-1"));
    if pMultiPage then
        local pDragNode = SCTypeCast:castNodeToDragNode(pMultiPage:getCurrentPage());
        if pDragNode then
            local pPageScrollBox = SCTypeCast:castNodeToPageScrollBox(pDragNode:getChildByTag(3));
            if pPageScrollBox then
                pPageScrollBox:removeAllChildrenWithCleanup(true);
                pPageScrollBox:setPageSize(CCSizeMake(290 * gUIScale().x, 115 * gUIScale().y));
                --[[tmp.usAmount = 5;
                tmp1 = {};
                tmp1.idTitle = 1;
                tmp1.szTitleName = "asdf"
                tmp1.szDesignation = "fdsf"
                tmp1.idPhoto = 2100007;
                table.insert(tmp.Title, tmp1);
                table.insert(tmp.Title, tmp1);
                table.insert(tmp.Title, tmp1);
                table.insert(tmp.Title, tmp1);
                table.insert(tmp.Title, tmp1);]]
                local count = getIntPart(#titlemsg / 3) + 1;
                local remainder = #titlemsg % 3;
                if remainder == 0 then
                    count = count - 1;
                end
                for i = 1, count do
                    local pDrag = SCDragNode:node();
                    if pDrag then
                        pDrag:setTag(i);
                        local pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7003, 104));
                        if pNode then
                            pNode:setFrameType(EnumFrameTypeListNormal);
                            pNode:setFrameVisibled(true);
                            pNode:setPosition(CCPointMake(3, 0));
                            local pImg = SCTypeCast:castNodeToImage(pNode:getChildByTag(1));
                            if pImg then
                                local imgPath = getRealUIResourcePath("Skill/" .. titlemsg[(i - 1) * 3 + 1].idPhoto .. ".png");
                                if imgPath then
                                    local imgNode = SCImage:imageWithFile(imgPath:getData());
                                    if imgNode then
                                        imgNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        imgNode:setPosition(CCPointMake(pImg:getContentSize().width / 2, pImg:getContentSize().height / 2));
                                        pImg:addChild(imgNode);
                                    end
                                end
                            end
                            local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                            if pLabel then
                                pLabel:setText("- " .. titlemsg[(i - 1) * 3 + 1].szTitleName .. " -");           
                                pLabel:setColor(colorYellow());
                            end
                            local btn = SCButton:button();
                            if btn then
                                btn:setTag((i - 1) * 3 + 1);
                                btn:luaSetSelectorOnClicked(onTitleId);
                                btn:setContentSize(pNode:getContentSize());
                                pNode:addChild(btn);
                            end
                            local strbuf = getNewLinStr(titlemsg[(i - 1) * 3 + 1].szDesignation, 8);
                            --local strbuf = getNewLinStr("几点睡飞机色粉发的93发生的地方3反倒是的33我");
                            local pParsedNode = ParsedNode:getParsedNode(strbuf, 0, 11);
                            if pParsedNode then
                                pParsedNode:setAnchorPoint(CCPointMake(0.5, 1));
                                pParsedNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, 45 * gUIScale().y));
                                pNode:addChild(pParsedNode);
                            end
                            pNode:setTag((i - 1) * 3 + 1);
                            pDrag:addChild(pNode);
                        end
                        if remainder > 1 or count ~= i or remainder == 0 then
                            pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7003, 104));
                            if pNode then
                                pNode:setFrameType(EnumFrameTypeListNormal);
                                pNode:setFrameVisibled(true);
                                pNode:setPosition(CCPointMake(100 * gUIScale().x, 0));
                                local pImg = SCTypeCast:castNodeToImage(pNode:getChildByTag(1));
                                if pImg then
                                    local imgPath = getRealUIResourcePath("Skill/" .. titlemsg[(i - 1) * 3 + 2].idPhoto .. ".png");
                                    if imgPath then
                                        local imgNode = SCImage:imageWithFile(imgPath:getData());
                                        if imgNode then
                                            imgNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                            imgNode:setPosition(CCPointMake(pImg:getContentSize().width / 2, pImg:getContentSize().height / 2));
                                            pImg:addChild(imgNode);
                                        end
                                    end
                                end
                                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                                if pLabel then
                                    pLabel:setText("- " .. titlemsg[(i - 1) * 3 + 2].szTitleName .. " -");              
                                    pLabel:setColor(colorYellow());
                                end
                                local btn = SCButton:button();
                                if btn then
                                    btn:setTag((i - 1) * 3 + 2);
                                    btn:luaSetSelectorOnClicked(onTitleId);
                                    btn:setContentSize(pNode:getContentSize());
                                    pNode:addChild(btn);
                                end
                                local strbuf = getNewLinStr(titlemsg[(i - 1) * 3 + 1].szDesignation, 8);
                                local pParsedNode = ParsedNode:getParsedNode(strbuf, 0, 11);
                                if pParsedNode then
                                    pParsedNode:setAnchorPoint(CCPointMake(0.5, 1));
                                    pParsedNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, 45 * gUIScale().y));
                                    pNode:addChild(pParsedNode);
                                end
                                pNode:setTag((i - 1) * 3 + 2);
                                pDrag:addChild(pNode);
                            end
                        end
                        
                        if remainder > 2 or count ~= i or remainder == 0 then
                            pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(7003, 104));
                            if pNode then
                                pNode:setFrameType(EnumFrameTypeListNormal);
                                pNode:setFrameVisibled(true);
                                pNode:setPosition(CCPointMake(197 * gUIScale().x, 0));
                                local pImg = SCTypeCast:castNodeToImage(pNode:getChildByTag(1));
                                if pImg then
                                    local imgPath = getRealUIResourcePath("Skill/" .. titlemsg[(i - 1) * 3 + 3].idPhoto .. ".png");
                                    if imgPath then
                                        local imgNode = SCImage:imageWithFile(imgPath:getData());
                                        if imgNode then
                                            imgNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                            imgNode:setPosition(CCPointMake(pImg:getContentSize().width / 2, pImg:getContentSize().height / 2));
                                            pImg:addChild(imgNode);
                                        end
                                    end
                                end
                                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                                if pLabel then
                                    pLabel:setText("- " .. titlemsg[(i - 1) * 3 + 3].szTitleName .. " -");           
                                    pLabel:setColor(colorYellow());
                                end
                                local btn = SCButton:button();
                                if btn then
                                    btn:setTag((i - 1) * 3 + 3);
                                    btn:luaSetSelectorOnClicked(onTitleId);
                                    btn:setContentSize(pNode:getContentSize());
                                    pNode:addChild(btn);
                                end
                                local strbuf = getNewLinStr(titlemsg[(i - 1) * 3 + 1].szDesignation, 8);
                                local pParsedNode = ParsedNode:getParsedNode(strbuf, 0, 11);
                                if pParsedNode then
                                    pParsedNode:setAnchorPoint(CCPointMake(0.5, 1));
                                    pParsedNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, 45 * gUIScale().y));
                                    pNode:addChild(pParsedNode);
                                end
                                pNode:setTag((i - 1) * 3 + 3);
                                pDrag:addChild(pNode);
                            end
                        end
                        pDrag:setPosition(CCPointMake(290 * (i - 1) * gUIScale().x, 0));
                        pPageScrollBox:addChild(pDrag);
                    end
                end
                pPageScrollBox:setContentSize(CCSizeMake(290 * count * gUIScale().x, 115 * gUIScale().y));
            end
        end
    end
end

local function creatPlayerTitleWnd()
    local wndCtrl = creatWnd();
    
    local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and wndCtrl then
            naviCtrl:pushWindowController(wndCtrl);
            local dataStream = SCDataTransStream:streamWithCommand(_MSG_MAGICINFO);
            dataStream:writeShort(MSG_MAGICS_QUERY_TITLE);
            dataStream:writeByte(1);
            if SCDataTransThread:getSingleton() then
                SCDataTransThread:getSingleton():transData(dataStream);
                SCActivityIndicator:getSingleton():show();
            end
        end
    return 
end

local function setPlayerTitle(tmp)
    if tmp.ucType == 0 then
        local heroMapObject = tolua.cast(Hero:getSingleton(), "MapObject");
        if heroMapObject then
            if SCPath:getSingleton() then
                local imgPath = getRealUIResourcePath("Skill/" .. tmp.idPhoto .. ".png")
                if imgPath then
                    local pImg = SCImage:imageWithFile(imgPath:getData());
                    if pImg then
                        local pLabel = SCLabel:labelWithStringFont(tmp.szTitleName, getDefaultFontName(), getFontSize(12));
                        if pLabel then
                            pLabel:setAnchorPoint(CCPointMake(0.5, 0));
                            pLabel:setPosition(CCPointMake(pImg:getContentSize().width / 2, 6 * gUIScale().y));
                            pImg:addChild(pLabel);
                            heroMapObject:setTitle(pImg, 3);
                        end
                    end
                end
            end
        end
    end
end

function showPlayerTitleWnd()
    creatPlayerTitleWnd();
end

local function recvLoginPlayerTitle()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();  
    if dt == nil then
        return;
    end  
    setPlayerTitle(stLoginTiele.initWithStream(dt));
end

local function recvQueryPlayerTitle()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        creatPlayerTitle(stTiele.initWithStream(dt));
    end
end

local function recvPlayerTitleName()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
    local action = dt:readByte()
    if action == NAMEACT_USER_DESIGNATION then
        btnIsVisible = 1;
        onBtnClick(2);
        local scStr = dt:readString();
        local titlename = nil;
        if scStr == nil then
            titlename = ""
        else
            titlename = scStr:getData()
        end
        local idPhoto = dt:readInt();
        local heroMapObject = tolua.cast(Hero:getSingleton(), "MapObject");
        if heroMapObject then
            if SCPath:getSingleton() then
                local imgPath = getRealUIResourcePath("Skill/" .. idPhoto .. ".png")
                if imgPath then
                    local pImg = SCImage:imageWithFile(imgPath:getData());
                    if pImg then
                        local pLabel = SCLabel:labelWithStringFont(titlename, getDefaultFontName(), getFontSize(12));
                        if pLabel then
                            pLabel:setAnchorPoint(CCPointMake(0.5, 0));
                            pLabel:setPosition(CCPointMake(pImg:getContentSize().width / 2, 6 * gUIScale().y));
                            pImg:addChild(pLabel);
                            heroMapObject:setTitle(pImg, 3);
                        end
                    end
                end
            end
        end
    end
end

local function recvPlayerTitleInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();  
    if dt == nil then
        return;
    end
    local CuridTitle = dt:readInt();
    btnIsVisible = dt:readByte();
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7003-1"));
    local pDragNode = nil;
    if pMultiPage then
        pDragNode = SCTypeCast:castNodeToDragNode(pMultiPage:getCurrentPage());
        if nil == pDragNode then    
            return;
        end
    end
    local btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(2));
    if btn == nil then
        return;
    end
    if btnIsVisible == 1 then
        btn:setTitle(_LTParser("str6028"), getDefaultFontName(), getFontSize(15), Button_Normal_Color);
        local heroMapObject = tolua.cast(Hero:getSingleton(), "MapObject");
        heroMapObject:removeTitle(3);
    elseif btnIsVisible == 0 then
        local heroMapObject = tolua.cast(Hero:getSingleton(), "MapObject");
        local titlename = Hero:getSingleton():getTitle():getData();
        if titlename == "" then
           return;
        end
        btn:setTitle(_LTParser("str6029"), getDefaultFontName(), getFontSize(15), Button_Normal_Color);
    end
end

local function recvPlayerTitleShow()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();  
    if dt == nil then
        return;
    end
    local idPhoto = dt:readInt();
    local heroMapObject = tolua.cast(Hero:getSingleton(), "MapObject");
    if nil == heroMapObject then
        return;
    end
    if btnIsVisible == 1 then
        heroMapObject:removeTitle(3);
    elseif btnIsVisible == 0 then
            local titlename = Hero:getSingleton():getTitle():getData();
            if titlename == "" then
                return;
            end
            if SCPath:getSingleton() then
                local imgPath = getRealUIResourcePath("Skill/" .. idPhoto .. ".png")
                if imgPath then
                    local pImg = SCImage:imageWithFile(imgPath:getData());
                    if pImg then
                        local pLabel = SCLabel:labelWithStringFont(titlename, getDefaultFontName(), getFontSize(12));
                        if pLabel then
                            pLabel:setAnchorPoint(CCPointMake(0.5, 0));
                            pLabel:setPosition(CCPointMake(pImg:getContentSize().width / 2, 6 * gUIScale().y));
                            pImg:addChild(pLabel);
                            heroMapObject:setTitle(pImg, 3);
                        end
                    end
                end
            end
        end
end

if LuaData:getSingleton() and SCMessageCenter:getSingleton() then
    LuaData:getSingleton():luaSetSelectorOnRecvData(recvPlayerTitleInfo, LuaData_MSG_MAGICS_CURRENT_TITLE)
    LuaData:getSingleton():luaSetSelectorOnRecvData(recvQueryPlayerTitle, LuaData_MSG_MAGICS_QUERY_TITLE)
    LuaData:getSingleton():luaSetSelectorOnRecvData(recvLoginPlayerTitle, LuaData_MSG_MAGICS_LOGIN_TITLE)
    LuaData:getSingleton():luaSetSelectorOnRecvData(recvPlayerTitleShow, LuaData_MSG_MAGICS_SHOW_TITLE)
    SCMessageCenter:getSingleton():luaRegistCommand(recvPlayerTitleName, _MSG_NAME, 0, nil)
end