local m_editCarkID = nil;
local m_editCarkPwd = nil;
local m_initPointX = nil;
local m_initPointY = nil;
local m_carkMark = nil;

local function getRealMoneyByIndex(index)
	if index == 0 then
		return 10
	end
	if index == 1 then
		return 20
	end
	if index == 2 then
		return 30
	end
	if index == 3 then
		return 50
	end
	if index == 4 then
		return 100
	end
	if index == 5 then
		return 500
	end
	return 10
end

local function OnClickPhone(tag)
	local moneyType = 0;
	local pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-102-18"));
	if pRadioGroup then
		moneyType = pRadioGroup:getSelectIndex();
	end
	if SCPay:getSingleton():isMobile()==1 then
		SCPay:getSingleton():ScMobilePay(moneyType);
	elseif SCPay:getSingleton():isMobile()==2 then
		SCPay:getSingleton():ScMMBilingDoPay(moneyType);
	end
end

local function onClickAlipay(tag)
	local moneyType = 0;
	local pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-103-18"));
	if pRadioGroup then
		moneyType = pRadioGroup:getSelectIndex();
	end
	SCPay:getSingleton():ScMobilePay(getRealMoneyByIndex(moneyType));
end

local function OnClickCarkRechargeable(tag)   --点击充值
    if 6 == tag then
        local framWnd = FrameWindow:frameWnd();
        local wnd = SCFunction:getUiNodeByIdlist("7017");
        if framWnd and wnd then
            local pNode = getItemTextNode(L("str6229"));
            if pNode then
                local size = pNode:getContentSize();
                framWnd:addChild(pNode);
                pNode:setAnchorPoint(CCPointMake(0, 0.5));
                pNode:setPosition(CCPointMake(SX(10), size.height / 2 + SY(25)));
                framWnd:setContentSize(CCSizeMake(size.width + SX(20), size.height + SY(50)));
            end
            wnd:addChild(framWnd);
            framWnd:setCloseBtnVisible(false);
            local size = wnd:getContentSize();
            framWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
            framWnd:setPosition(CCPointMake(size.width / 2, size.height / 2));
        end
        return;
    end
    local carkType = nil;    
    local moneyType = nil; 
    local pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-1"));
    if pRadioGroup then
        carkType = pRadioGroup:getSelectIndex();
    end
    pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-100-18"));
    if pRadioGroup then
        moneyType = pRadioGroup:getSelectIndex();
    end
    if #m_editCarkID:getContentText() == 0 then
        showMessage(_LTParser("str6115"));
        return;
    end
    if #m_editCarkPwd:getContentText() == 0 then
        showMessage(_LTParser("str6116"));
        return;
    end
    local account = SCString:stringWithString(m_editCarkID:getContentText());
    local password = SCString:stringWithString(m_editCarkPwd:getContentText());
    local datastream = SCDataTransStream:streamWithCommand(_MSG_REMITRMB);
    datastream:writeByte(carkType + 1);  --移动1 联通2 电信3
    datastream:writeInt(getRealMoneyByIndex(moneyType));
    datastream:writeString(account);
    datastream:writeString(password);    
    SCDataTransThread:getSingleton():transData(datastream);
    --showMessage("卡" .. carkType .. " 钱" .. moneyType .. " " .. str1:getData() .. " " .. str2:getData());
end

local function OnClickBankRechargeable(tag)
	local moneyType = 0;
	local pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-104-18"));
	if pRadioGroup then
		moneyType = pRadioGroup:getSelectIndex();
	end
	SCPay:getSingleton():BankCharge(getRealMoneyByIndex(moneyType));
	--[[
    local moneyType = nil; 
    local carkType = nil;    
    local pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-101-18"));
    if pRadioGroup then
        moneyType = pRadioGroup:getSelectIndex();
    end
    pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-101-23"));
    if pRadioGroup then
        carkType = pRadioGroup:getSelectIndex();
    end
    showMessage("钱" .. moneyType .. " 卡" .. carkType);
    ]]
end

local function VIPrechargeableWndClose()
    m_editCarkID = nil;
    m_editCarkPwd = nil;
    m_initPointX = nil;
    m_initPointY = nil;
    m_carkMark = nil;
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then   
        local m_wnd = getCurentSceneWindow(7017);
        if m_wnd then
            m_initPointX = m_wnd:getPosition().x;
            m_initPointY = m_wnd:getPosition().y;
        else
            m_initPointX = 0;
            m_initPointY = 0;
        end
    end
end

local showCarkType

local function OnClickCard(tag, radioIndex)
    if m_carkMark == radioIndex or (nil == m_carkMark and  0 == radioIndex) then
        return;
    end
    m_carkMark = radioIndex;
    showCarkType(radioIndex)
end

local function OnClickBtnCard(tag)
    local pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-1"));
    if pRadioGroup then
        pRadioGroup:setSelectIndex(tag - 3);
    end
end

local function OnClickMoney(tag, radioIndex)
    if 0 == radioIndex then
    elseif 1 == radioIndex then
    elseif 2 == radioIndex then
    elseif 3 == radioIndex then
    elseif 4 == radioIndex then
    elseif 5 == radioIndex then
    end
end

local function OnClickBtnMoney(tag)
    local pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-100-18"));
    if pRadioGroup then
        pRadioGroup:setSelectIndex(tag - 12);
    end
    pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-101-18"));
    if pRadioGroup then
        pRadioGroup:setSelectIndex(tag - 12);
    end
end

local function OnClickBank(tag, radioIndex)
    if 0 == radioIndex then
    elseif 1 == radioIndex then
    elseif 2 == radioIndex then
    elseif 3 == radioIndex then
    end
end

local function onWindowTouched(tag)
    if m_editCarkID ~= nil and m_editCarkID:getIsInputing() then
        m_editCarkID:detachWithIME();
    end
    if m_editCarkPwd ~= nil and m_editCarkPwd:getIsInputing() then
        m_editCarkPwd:detachWithIME();
    end
end

local function onEditBeginInput(tag)
    local m_wnd = getCurentSceneWindow(7017);
    if nil == m_wnd then
        return;
    end
    local moveSize = 0;
    local pNode = SCFunction:getUiNodeByIdlist("7017-2")
    if pNode then
        moveSize = moveSize + pNode:getPosition().y - pNode:getAnchorPoint().y * pNode:getContentSize().height;
    end
    pNode = pNode:getChildByTag(100);
    if nil == pNode then
        return;
    end
    if 10 == tag then
        pNode = pNode:getChildByTag(8);
        if pNode then
            moveSize = moveSize + pNode:getPosition().y - pNode:getAnchorPoint().y * pNode:getContentSize().height;
        end
        moveSize = moveSize + m_editCarkID:getPosition().y - m_editCarkID:getAnchorPoint().y * m_editCarkID:getContentSize().height;
    elseif 11 == tag then
        pNode = pNode:getChildByTag(9);
        if pNode then
            moveSize = moveSize + pNode:getPosition().y - pNode:getAnchorPoint().y * pNode:getContentSize().height;
        end
        moveSize = moveSize + m_editCarkPwd:getPosition().y - m_editCarkPwd:getAnchorPoint().y * m_editCarkPwd:getContentSize().height;
    end
    m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPointX, m_initPointY + 200 * gUIScale().y - moveSize)));
end

local function onEditEndInput(tag)
    local m_wnd = getCurentSceneWindow(7017);
    if nil == m_wnd then
        return;
    end
    m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPointX, m_initPointY)));
end

local function OnClickBtnBank(tag)  
    pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlist("7017-2-101-23"));
    if pRadioGroup then
        pRadioGroup:setSelectIndex(tag - 19);
    end
end

local function OnClickWebsite(tag)
    LoginLogic:getSingleton():showAccountManagement(0);
end

function showCarkType(mark)
    local pDragNode = SCFunction:getUiNodeByIdlist("7017-2")
    if pDragNode then
        pDragNode:removeAllChildrenWithCleanup(true);        
        m_editCarkID = nil;
        m_editCarkPwd = nil;
        if mark == 5 then
			local pNode = SCFunction:getUiByZipAndId(7017, 102);
            if pNode then
				pNode:setTag(103)
                local pRadioGroup = SCTypeCast:castNodeToRadioGroup(pNode:getChildByTag(18));
                if pRadioGroup then
                    pRadioGroup:luaSetSelectorOnItemSelected(OnClickMoney);
                    for i = 0, 6 do
                        pRadioGroup:setDescribe(i, _LTParser("str" .. (i + 6105)), getDefaultFontName(), getFontSize(12), color_skyBlue);
                    end
                end
                for i = 12, 17 do
                    local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
                    if Btn then
                        Btn:luaSetSelectorOnClicked(OnClickBtnMoney);
                    end
                end
                local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(7));
                if Btn then
                    Btn:luaSetSelectorOnClicked(onClickAlipay);
                end
                Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(6));
                if Btn then
                    Btn:luaSetSelectorOnClicked(OnClickCarkRechargeable);
                end
                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
                if pLabel then  
                    pLabel:setColor(color_skyBlue);
                end
                pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                if pLabel then  
                    pLabel:setText(Hero:getSingleton():getName():getData());
                    pLabel:setColor(color_green);
                end
                pDragNode:addChild(pNode);
            end
            return;
        end
        if mark == 6 then
            local pNode = SCFunction:getUiByZipAndId(7017, 102);
            if pNode then
                local pRadioGroup = SCTypeCast:castNodeToRadioGroup(pNode:getChildByTag(18));
                if pRadioGroup then
                    pRadioGroup:luaSetSelectorOnItemSelected(OnClickMoney);
                    for i = 0, 6 do
                        pRadioGroup:setDescribe(i, _LTParser("str" .. (i + 6105)), getDefaultFontName(), getFontSize(12), color_skyBlue);
                    end
                end
                for i = 12, 17 do
                    local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
                    if Btn then
                        Btn:luaSetSelectorOnClicked(OnClickBtnMoney);
                    end
                end
                local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(7));
                if Btn then
                    Btn:luaSetSelectorOnClicked(OnClickPhone);
                end
                Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(6));
                if Btn then
                    Btn:luaSetSelectorOnClicked(OnClickCarkRechargeable);
                end
                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
                if pLabel then  
                    pLabel:setColor(color_skyBlue);
                end
                pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                if pLabel then  
                    pLabel:setText(Hero:getSingleton():getName():getData());
                    pLabel:setColor(color_green);
                end
                pDragNode:addChild(pNode);
            end
            return;
        end
        if mark == 3 then       
            local pBtn = SCButton:button();    
            if pBtn then
                pBtn:setContentSize(CCSizeMake(SX(90), SY(20)));
                pBtn:setPosition(CCPointMake(SX(42), SY(165)));
                pBtn:luaSetSelectorOnClicked(OnClickWebsite);
                pDragNode:addChild(pBtn);
            end 
            local pParsedNode = getItemTextNode(_LTParser("str6111"));
            if pParsedNode then
                pParsedNode:setAnchorPoint(CCPointMake(0, 1));
                setNodePostion(pParsedNode, CCPointMake(5, getNodeContentSize(pDragNode).height));
                pDragNode:addChild(pParsedNode);
            end
            return;
        end
        if mark == 4 then
			local pNode = SCFunction:getUiByZipAndId(7017, 102);
            if pNode then
				pNode:setTag(104)
                local pRadioGroup = SCTypeCast:castNodeToRadioGroup(pNode:getChildByTag(18));
                if pRadioGroup then
                    pRadioGroup:luaSetSelectorOnItemSelected(OnClickMoney);
                    for i = 0, 6 do
                        pRadioGroup:setDescribe(i, _LTParser("str" .. (i + 6105)), getDefaultFontName(), getFontSize(12), color_skyBlue);
                    end
                end
                for i = 12, 17 do
                    local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
                    if Btn then
                        Btn:luaSetSelectorOnClicked(OnClickBtnMoney);
                    end
                end
                local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(7));
                if Btn then
                    Btn:luaSetSelectorOnClicked(OnClickBankRechargeable);
                end
                Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(6));
                if Btn then
                    Btn:luaSetSelectorOnClicked(OnClickCarkRechargeable);
                end
                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
                if pLabel then  
                    pLabel:setColor(color_skyBlue);
                end
                pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                if pLabel then  
                    pLabel:setText(Hero:getSingleton():getName():getData());
                    pLabel:setColor(color_green);
                end
                pDragNode:addChild(pNode);
            end
            return;
			--[[
            local pNode = SCFunction:getUiByZipAndId(7017, 101);
            if pNode then
                local pImage = SCTypeCast:castNodeToImage(pNode:getChildByTag(4));
                if pImage then
                    pImage:setScaleX(4);
                end
                local pRadioGroup = SCTypeCast:castNodeToRadioGroup(pNode:getChildByTag(18));
                if pRadioGroup then
                    pRadioGroup:luaSetSelectorOnItemSelected(OnClickMoney);
                    for i = 0, 6 do
                        pRadioGroup:setDescribe(i, _LTParser("str" .. (i + 6105)), getDefaultFontName(), getFontSize(12), color_skyBlue);
                    end
                end
                for i = 12, 17 do
                    local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
                    if Btn then
                        Btn:luaSetSelectorOnClicked(OnClickBtnMoney);
                    end
                end
                pRadioGroup = SCTypeCast:castNodeToRadioGroup(pNode:getChildByTag(23));
                if pRadioGroup then
                    pRadioGroup:luaSetSelectorOnItemSelected(OnClickBank);
                end
                for i = 19, 22 do
                    local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
                    if Btn then
                        Btn:luaSetSelectorOnClicked(OnClickBtnBank);
                    end
                end
                local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
                if pLabel then  
                    pLabel:setColor(color_skyBlue);
                end
                pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
                if pLabel then  
                    pLabel:setText(Hero:getSingleton():getName():getData());
                    pLabel:setColor(color_green);
                end
                local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(7));
                if Btn then
                    Btn:luaSetSelectorOnClicked(OnClickBankRechargeable);
                end
                pDragNode:addChild(pNode);
            end
            return;
            --]]
        end
        local pNode = SCFunction:getUiByZipAndId(7017, 100);
        if pNode then
            local dragNode1 = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(8));
            local dragNode2 = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(9));
            if dragNode1 and dragNode2 then
                dragNode1:setFrameVisibled(true);
                dragNode1:setFrameType(EnumFrameTypeListInput);
                dragNode2:setFrameVisibled(true);
                dragNode2:setFrameType(EnumFrameTypeListInput);
                m_editCarkID = SCTypeCast:castNodeToEdit(dragNode1:getChildByTag(10));
                m_editCarkPwd = SCTypeCast:castNodeToEdit(dragNode2:getChildByTag(11));
                if m_editCarkID and m_editCarkPwd then
                     m_editCarkID:setMaxCharCount(100);
                     m_editCarkID:setBottomColor(color_transparent);
                     m_editCarkID:setFontColor(color_white);
                     m_editCarkID:setReturnKeyType(SCReturnKeySend);
                     m_editCarkID:luaSetSelectorOnBeginInput(onEditBeginInput);
                     m_editCarkID:luaSetSelectorOnEndInput(onEditEndInput);
                     m_editCarkPwd:setMaxCharCount(100);
                     m_editCarkPwd:setBottomColor(color_transparent);
                     m_editCarkPwd:setFontColor(color_white);
                     m_editCarkPwd:setReturnKeyType(SCReturnKeySend);
                     m_editCarkPwd:luaSetSelectorOnBeginInput(onEditBeginInput);
                     m_editCarkPwd:luaSetSelectorOnEndInput(onEditEndInput);
                end
            end
            local pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
            if pLabel then  
                pLabel:setColor(color_skyBlue);
            end
            pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
            if pLabel then  
                pLabel:setText(Hero:getSingleton():getName():getData());
                pLabel:setColor(color_green);
            end
            pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(4));
            if pLabel then
                pLabel:removeAllChildrenWithCleanup(true);
                local pParsedNode = getItemTextNode(_LTParser("str6097") .. "*6" .. _LTParser("str" .. (mark + 6100)) .. "*0" .. _LTParser("str6098"));
                if pParsedNode then
                    pParsedNode:setAnchorPoint(CCPointMake(1, 0));
                    pLabel:addChild(pParsedNode);
                end
            end
            pLabel = SCTypeCast:castNodeToLabel(pNode:getChildByTag(5));
            if pLabel then
                pLabel:removeAllChildrenWithCleanup(true);
                local pParsedNode = getItemTextNode(_LTParser("str6097") .. "*6" .. _LTParser("str" .. (mark + 6100)) .. "*0" .. _LTParser("str6099"));
                if pParsedNode then
                    pParsedNode:setAnchorPoint(CCPointMake(1, 0));
                    pLabel:addChild(pParsedNode);
                end
            end            
            local pRadioGroup = SCTypeCast:castNodeToRadioGroup(pNode:getChildByTag(18));
            if pRadioGroup then
                pRadioGroup:luaSetSelectorOnItemSelected(OnClickMoney);
                for i = 0, 6 do
                    pRadioGroup:setDescribe(i, _LTParser("str" .. (i + 6105)), getDefaultFontName(), getFontSize(12), color_skyBlue);
                end
            end
            for i = 12, 17 do
                local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
                if Btn then
                    Btn:luaSetSelectorOnClicked(OnClickBtnMoney);
                end
            end
            local Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(7));
            if Btn then
                Btn:luaSetSelectorOnClicked(OnClickCarkRechargeable);
            end
            Btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(6));
            if Btn then
                Btn:luaSetSelectorOnClicked(OnClickCarkRechargeable);
            end
            pDragNode:addChild(pNode);
        end
    end
end

local function createVIPrechargeableWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7017));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("app/new00672.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(VIPrechargeableWndClose);  
    wnd:luaSetSelectorOnTouched(onWindowTouched);
    -- create a test window controller
    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("2", wnd));
    if pDragNode then
        pDragNode:setFrameVisibled(true);
        pDragNode:setFrameType(EnumFrameTypeRound);
    end
    local pRadioGroup = SCTypeCast:castNodeToRadioGroup(SCFunction:getUiNodeByIdlistAndParent("1", wnd));
    if pRadioGroup then
        pRadioGroup:setItemVisible(7, false);
        pRadioGroup:setItemVisible(6, false);
        pRadioGroup:luaSetSelectorOnItemSelected(OnClickCard);
        for i = 0, 5 do
            if i > 4 then 
                pRadioGroup:setDescribe(i, _LTParser("str622" .. i + 2), getDefaultFontName(), getFontSize(12), color_orange);
            else
                pRadioGroup:setDescribe(i, _LTParser("str610" .. i), getDefaultFontName(), getFontSize(12), color_orange);
            end
        end
        if SCPay:getSingleton():isMobile() ~=0 then
			pRadioGroup:setItemVisible(6, true);
			pRadioGroup:setDescribe(6, _LTParser("str6228"), getDefaultFontName(), getFontSize(12), color_orange);
        end
    end
    for i = 3, 9 do
        local Btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(i, wnd));
        if Btn then
            if 9 == i then
                Btn:setVisible(false);
            else
                Btn:luaSetSelectorOnClicked(OnClickBtnCard);
            end
        end
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    return wndCtrl;
end

function OpenOfficialRechargeWnd()  --打开官方充值界面
    local wndCtrl = createVIPrechargeableWnd();    
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        naviCtrl:pushWindowController(wndCtrl);
        showCarkType(0);
    end
end

function showVIPrechargeableWnd() --充值入口函数
   -- showMessage(L("str6192"));
     SCPay:getSingleton():ShowPlatformPayWnd();
end