--排行榜
--排行分类
local PLAYER_COMBATFORCES_RANK = 1 --//战力总排行榜
local PLAYER_ARENA_RANK  = 2 --//竞技场总排行榜；
local PLAYER_FLOWER_RANK = 3 --//鲜花周排行榜；
local PLAYER_REPUTATION_RANK = 4 --//声望周排行榜；
local PLAYER_GODEXP_RANK = 5 --//阅历周排行榜
local PLAYER_MONEY_RANK = 6 --//财富周排行榜；

--action
local ACT_QUERY_RANK = 1 --//查询排行榜
local ACT_OPEN_RANK = 4 --//打开排行榜入口

local revRankData = {
    __mode = "kv",
}
local nPage = 0;
local stRankData = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucIndex = dt:readByte();
        tmp.idUser = dt:readInt();
        tmp.dwData = dt:readInt();
        tmp.ucLevel = dt:readShort();
        local scStr = dt:readString()
            if scStr == nil then
                tmp.szUserName = ""
            else
                tmp.szUserName = scStr:getData()
        end
        tmp.idPhoto = dt:readInt();
        tmp.ucType = dt:readByte();
        return tmp
    end
}

local RankData = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nRankType = dt:readByte()
        local scStr = dt:readString()
            if scStr == nil then
                tmp.szRankName = ""
            else
                tmp.szRankName = scStr:getData()
        end
        scStr = dt:readString()
            if scStr == nil then
                tmp.szRankInfo = ""
            else
                tmp.szRankInfo = scStr:getData()
        end
        return tmp
    end
}

local MSG_Info4 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nRankType = dt:readByte();
        tmp.ucRank = dt:readShort();
        tmp.ucAccount = dt:readByte();
        tmp.stRankInfo = {};
        for i = 1, tmp.ucAccount do
          table.insert(tmp.stRankInfo, stRankData.initWithStream(dt));
        end
        tmp.AwardType = dt:readShort();
        tmp.nType = dt:readByte();
            
        return tmp
    end
}

local MSG_Info5 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAccount = dt:readByte()
        tmp.stRankInfo = {};
        for i = 1, tmp.ucAccount do
          table.insert(tmp.stRankInfo, RankData.initWithStream(dt));
        end
            
        return tmp
    end
}

local function rankingListWndClose()
    revRankData = {__mode = "kv"};
    nPage = 0;
end

local function createWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7000));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile35.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(rankingListWndClose);
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("101", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeRound)
        dragNode:setFrameVisibled(true)
    end
    return wndCtrl;
end

local function creatRankingListWnd()
    local wndCtrl = createWnd();
    
    local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and wndCtrl then
            naviCtrl:pushWindowController(wndCtrl);
            
            local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
            dataStream:writeByte(ACT_OPEN_RANK);
            if SCDataTransThread:getSingleton() then
                SCDataTransThread:getSingleton():transData(dataStream);
                SCActivityIndicator:getSingleton():show();
            end
        end 
   
    return 
end

local function onBtnRankType(itemTag)
    if SCActivityIndicator:getSingleton() then        
        SCActivityIndicator:getSingleton():show();
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    dataStream:writeByte(ACT_QUERY_RANK);
    if itemTag == 0 then
    dataStream:writeByte(PLAYER_COMBATFORCES_RANK);
    end
    if itemTag == 1 then
    dataStream:writeByte(PLAYER_ARENA_RANK);
    end
    if itemTag == 2 then
    dataStream:writeByte(PLAYER_FLOWER_RANK);
    end
    if itemTag == 3 then
    dataStream:writeByte(PLAYER_REPUTATION_RANK);
    end
    if itemTag == 4 then
    dataStream:writeByte(PLAYER_GODEXP_RANK);
    end
    if itemTag == 5 then
    dataStream:writeByte(PLAYER_MONEY_RANK);
    end
    dataStream:writeByte(0);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

--查看鲜花排行版
function SeeflowerRanking()
    onBtnRankType(2);
end

local function creatRankingList(tmp)
    local listBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7000-101-1"));
    if listBox == nil then
        return
    end
    for i = 1, tmp.ucAccount do
        local node = SCFunction:getUiByZipAndId(7000, 102);
        if node ~= nil  then
            local img = SCTypeCast:castNodeToImage(node:getChildByTag(6));
            if img then 
               img:setScaleX(5);
            end
            img = SCTypeCast:castNodeToImage(node:getChildByTag(2));
            if img then
                local strPath = "img/img700";
                strPath = strPath .. i;
                strPath = strPath .. ".png";
                local imgPath = nil;
                if SCPath:getSingleton() then
                    imgPath = getRealUIResourcePath(strPath)    
                end            
                if imgPath then
                    img:setImage(imgPath:getData());
                end
            end
            local btn = SCTypeCast:castNodeToButton(node:getChildByTag(5));
            if btn then
            btn:luaSetSelectorOnClicked(onBtnRankType);
            btn:setTag(listBox:itemCount());
            end
            local text = getItemTextNode(tmp.stRankInfo[i].szRankName);
            text:setPosition(CCPointMake(60 * gUIScale().x, 36 * gUIScale().y));
            node:addChild(text);
            text = getItemTextNode(tmp.stRankInfo[i].szRankInfo);
            text:setPosition(CCPointMake(60 * gUIScale().x, 19 * gUIScale().y));
            node:addChild(text);
            listBox:addItem(node);
        end       
    end
end

local function joinInTeam(tag, itemTag, itemIndex)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7001-101-1-"..itemTag), "SCDragNode");
    if node then
        node:setFrameType(EnumFrameTypeListSelect)
        node:setFrameVisibled(true)
        luaLookPlayerInfo(itemTag, "");
    end
end

local function unSelset(tag, itemTag, itemIndex)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7001-101-1-"..itemTag), "SCDragNode");
   
    if node then
        node:setFrameType(EnumFrameTypeListNormal)
        node:setFrameVisibled(true)
    end
end

local function updata(tag)
    if revRankData[1].nType == 1 then
        return;
    end
    SCActivityIndicator:getSingleton():show();
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    dataStream:writeByte(ACT_QUERY_RANK);
    dataStream:writeByte(revRankData[1].nRankType);
    nPage = nPage + 1;
    dataStream:writeByte(nPage);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function searchRankingList()
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7001-101-2"));
    local label1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7001-101-8"));
    for j = 1, #revRankData do
        if label then
            if revRankData[j].nRankType == PLAYER_COMBATFORCES_RANK then
                label:setText(_LTParser("str6001"));
                label1:setText(_LTParser("str6007"));
            end
            if revRankData[j].nRankType == PLAYER_ARENA_RANK then
                label:setText(_LTParser("str6002"));
                label1:setText(_LTParser("str6008"));
            end
            if revRankData[j].nRankType == PLAYER_FLOWER_RANK then
                label:setText(_LTParser("str6003"));
                label1:setText(_LTParser("str6009"));
            end
            if revRankData[j].nRankType == PLAYER_REPUTATION_RANK then
                label:setText(_LTParser("str6004"));
                label1:setText(_LTParser("str6010"));
            end
            if revRankData[j].nRankType == PLAYER_GODEXP_RANK then
                label:setText(_LTParser("str6005"));
                label1:setText(_LTParser("str6011"));
            end
            if revRankData[j].nRankType == PLAYER_MONEY_RANK then
                label:setText(_LTParser("str6006"));
                label1:setText(_LTParser("str6012"));
            end
        end
        local listBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("7001-101-1"));
        if listBox == nil then
            return
        end
        listBox:luaSetSelectorOnItemSelected(joinInTeam)
        listBox:luaSetSelectorOnItemUnSelected(unSelset)   
        listBox:luaSetSelectorOnScrollToEnd(updata); 
        for i = 1, revRankData[j].ucAccount do        
            local node = SCFunction:getUiByZipAndId(7001, 102);
            if node ~= nil  then
                local dragNode = SCTypeCast:castNodeToDragNode(node);
                if dragNode then
                    dragNode:setFrameType(EnumFrameTypeLine)
                    dragNode:setFrameVisibled(true)
                    dragNode:setTag(i + 1);
                end
                node:setFrameType(EnumFrameTypeListNormal);
                node:setFrameVisibled(true);
                label = SCTypeCast:castNodeToLabel(node:getChildByTag(3));
                if label then
                    label:setText(revRankData[j].stRankInfo[i].ucIndex);
                end
                label = SCTypeCast:castNodeToLabel(node:getChildByTag(4));
                if label then
                    label:setText(revRankData[j].stRankInfo[i].szUserName);
                end
                label = SCTypeCast:castNodeToLabel(node:getChildByTag(5));
                if label then
                    label:setText(revRankData[j].stRankInfo[i].ucLevel);
                end
                label = SCTypeCast:castNodeToLabel(node:getChildByTag(6));
                if label then
                    if revRankData[j].nRankType ==PLAYER_ARENA_RANK then
                        if revRankData[j].stRankInfo[i].dwData == 1 then
                            label:setText(_LTParser("str6041"));
                        elseif revRankData[j].stRankInfo[i].dwData == 2 then
                            label:setText(_LTParser("str6042"));
                        elseif revRankData[j].stRankInfo[i].dwData == 3 then
                            label:setText(_LTParser("str6043"));
                        elseif revRankData[j].stRankInfo[i].dwData == 4 then
                            label:setText(_LTParser("str6044"));
                        else
                            label:setText(_LTParser("str6045"));
                        end
                    else
                        local data = revRankData[j].stRankInfo[i].dwData;
                        if revRankData[j].stRankInfo[i].dwData > 9999 then
                            data = getIntPart(revRankData[j].stRankInfo[i].dwData / 10000) .. _LTParser("str0285");
                        end
                        label:setText(data);
                    end
                end
                local img = SCTypeCast:castNodeToImage(node:getChildByTag(2));
                if img then
                    local imgPath = nil;                
                    if revRankData[j].stRankInfo[i].ucType == 1 then
                        imgPath = getRealUIResourcePath("img/top-up.png")
                    end
                    if revRankData[j].stRankInfo[i].ucType == 2 then
                        imgPath = getRealUIResourcePath("img/top-down.png")
                    end
                    if imgPath then
                        img:setImage(imgPath:getData());
                    end
                end
                listBox:addItem(node);
                node:setTag(revRankData[j].stRankInfo[i].idUser)
            end
        end
        label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("7001-101-11"));
        if label then
            str = "str601";
            if revRankData[j].AwardType > 5 or revRankData[j].AwardType < 1 then
                revRankData[j].AwardType = 0;
            end
            str = str .. (revRankData[j].AwardType + 3);
            label:setText(_LTParser(str));
            local pNode = SCFunction:getUiNodeByIdlist("7001-101");
            if pNode then
                label:setAnchorPoint(CCPointMake(0.5, 0));
                setNodePostion(label, CCPointMake(getNodeContentSize(pNode).width / 2, 30));
            end
        end
    end
end

local function creatsearchWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(7001));
    if wnd == nil then
        return nil 
    end
    
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(rankingListWndClose);
    wnd:setFrameVisibled(false);
    
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("101", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeLine)
        dragNode:setFrameVisibled(true)
    end
    local image = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("101-3", tolua.cast(wnd, "SCNode")));
    if image then
        image:setScaleX(2.0);
    end
    image = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("101-9", tolua.cast(wnd, "SCNode")));
    if image then
        image:setScaleX(2.1);
    end
    image = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("101-10", tolua.cast(wnd, "SCNode")));
    if image then
        image:setScaleX(2.1);
    end
    label = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("101-3", tolua.cast(wnd, "SCNode")));
    return wndCtrl;
end


local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        --getCurentSceneWindow(tag):setAutoCloseOnTouchSpace(true);
    end
end

local function creatsearchRankingList()
    local wndCtrl = creatsearchWnd();
    
    local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and wndCtrl then
            naviCtrl:pushWindowController(wndCtrl, NavigateStyleBottomToTop);
            wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        end
    searchRankingList();
    return 
end

local function setrevRankData(tmp)
    --[[table.insert(revRankData, tmp);
    if tmp.nType == 0 then
        SCActivityIndicator:getSingleton():close();
        creatsearchRankingList();
    end]]
    revRankData = {};
    table.insert(revRankData, tmp);
    SCActivityIndicator:getSingleton():close();
    creatsearchRankingList();
end

function showRankingListWnd() 
    creatRankingListWnd();
end

local function recvRankInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
    local action = dt:readByte()
    if action == ACT_OPEN_RANK then
        creatRankingList(MSG_Info5.initWithStream(dt))
    elseif action == ACT_QUERY_RANK then
        setrevRankData(MSG_Info4.initWithStream(dt))
    end
end

if SCMessageCenter:getSingleton() then
    SCMessageCenter:getSingleton():luaRegistCommand(recvRankInfo, _MSG_RANK, 0, nil)
end