--add by lbj
--2012.9.26
--------------------------送花结构开始--------------------------------------
stFlowerSum = {
	initWithStream = function (dt)
		if dt == nil then
			return {};
		end
		local tmp = {
			idPlayer,			--人物id
			szName,				--人物名字
			nFacePhoto,			--人物图标
			nFlowerPhoto,		--鲜花图标
			nFlowerSum,			--鲜花总数
			idPlayerSendMax,	--赠送最多
			szPlayerSendMax,	--赠送最多名字
			nSendMaxNum,		--赠送最多花数
			idPlayerGetMax,		--收到最多
			szPlayerGetMax,		--收到最多名字
			nGetMaxNum,			--收到最多花数
		}
		tmp.idPlayer = dt:readInt();			--人物id
		local scStr = dt:readString();
		if scStr == nil then
			tmp.szName = ""				--人物名字
		else
			tmp.szName = scStr:getData();
		end
		tmp.nFacePhoto = dt:readInt();			--人物图标
		tmp.nFlowerPhoto = dt:readInt();		--鲜花图标
		tmp.nFlowerSum = dt:readInt()			--鲜花总数
		tmp.idPlayerSendMax = dt:readInt()		--赠送最多
		scStr = dt:readString();
		if scStr == nil then
			tmp.szPlayerSendMax = ""	--赠送最多名字
		else
			tmp.szPlayerSendMax = scStr:getData();
		end		
		tmp.nSendMaxNum = dt:readInt();		--赠送最多花数
		tmp.idPlayerGetMax = dt:readInt();	--收到最多
		scStr = dt:readString();
		if scStr == nil then
			tmp.szPlayerGetMax = "";		--收到最多名字
		else
			tmp.szPlayerGetMax = scStr:getData();
		end
		tmp.nGetMaxNum = dt:readInt();			--收到最多花数
		return tmp;
	end
}

stSendFlower = {
	initWithStream = function (dt)
		if dt == nil then
			return {};
		end
		local tmp = {
			idPlayer;		--赠送人
			nFacePhoto;
			szName;			--名字
			szWords;		--赠送文字
			szTime;			--时间
		}
		tmp.idPlayer = dt:readInt();
		tmp.nFacePhpto = dt:readInt();
		local scStr = dt:readString();
		if scStr == nil then
			tmp.szName = "";
		else
			tmp.szName= scStr:getData();
		end
		scStr = dt:readString();
		if scStr == nil then
			tmp.szWords = "";
		else
			tmp.szWords= scStr:getData();
		end
		scStr = dt:readString();
		if scStr == nil then
			tmp.szTime = "";
		else
			tmp.szTime= scStr:getData();
		end
		return tmp;
	end
}

stSendFlowerList = {
	initWithStream = function (dt)
		if dt == nil then
			return {};
		end
		local tmp = {
			ucAmount;				--数量
			stSendFlowers = {};		--具体数据
		}
		tmp.ucAmount = dt:readByte();
		for i=1, tmp.ucAmount do
			tmp.stSendFlowers[i] = stSendFlower.initWithStream(dt);
		end
		return tmp;
	end
}

stFlowerType = {
	initWithStream = function (dt)
		if dt == nil then
			return {};
		end
		local tmp = {
			usFlowerNum;		--鲜花个数
			nFlowerPhoto;
			szFlower;			--鲜花名字(N朵鲜花)
			szAward;			--奖励
			szCondition;		--消耗
			ucOpenType;		--开启标记
		}
		tmp.usFlowerNum = dt:readShort();
		tmp.nFlowerPhoto = dt:readInt();
		local scStr = dt:readString();
		if scStr == nil then
			tmp.szFlower = "";
		else
			tmp.szFlower= scStr:getData();
		end
		scStr = dt:readString();
		if scStr == nil then
			tmp.szAward = "";
		else
			tmp.szAward= scStr:getData();
		end
		scStr = dt:readString();
		if scStr == nil then
			tmp.szCondition = "";
		else
			tmp.szCondition= scStr:getData();
		end
		tmp.ucOpenType = dt:readByte();
		return tmp;
	end
}

stFlowerCondition = {
	initWithStream = function (dt)
		if dt == nil then
			return {};
		end
		local tmp = {
			ucAmount;				--数量
			stFlowerTypes = {};		--具体数据
		}
		tmp.ucAmount = dt:readByte();
		for i=1, tmp.ucAmount do
			tmp.stFlowerTypes[i] = stFlowerType.initWithStream(dt);
		end
		return tmp;
	end
}
--------------------------送花结构结束--------------------------------------