--8012公会控制界面
	MSG_TRIBE_LEAVE						= 1--// 离开家族(不包括族长)
	MSG_TRIBE_DISMISS					= 3--// 解散家族
	MSG_TRIBE_KICKOUT					= 4--// 驱逐成员
	MSG_TRIBE_SUCCESSION				= 5--// 族长继位

	MSG_SOCIATY_LIST					= 6--//公会列表
	MSG_CREATE_SOCIATY_INFO				= 7--//"创建公会"
	MSG_CREATE_SOCIATY_OK				= 8--//确定创建公会
	MSG_REQUEST_SOCIATY					= 9--//申请公会
	MSG_CLEAR_REQUEST_SOCIATY			= 10--//撤消申请公会
	MSG_VIEW_SOCIATY_INFO				= 11--//查看公会
	MSG_SOCIATY_MEMBER_LIST				= 12--//公会成员列表
	MSG_SOCIATY_MEMBER_UPDATE			= 13--//公会成员列表成员信息更新
	MSG_SOCIATY_PROPOSER_LIST			= 14--//公会申请人列表
	MSG_SOCIATY_PROPOSER_ADMIT			= 15--//接收申请人 c->s
	MSG_SOCIATY_PROPOSER_REFUSE			= 16--//拒收申请人 c->s
	MSG_SOCIATY_PROPOSER_DEL			= 17--//公会申请人更新删除 s->c(接收或拒收后)
    MSG_SOCIATY_SET_TENET				= 18--//帮派信息设置(公告与介绍)	
	MSG_SOCIATY_SET_RANK				= 19--//公会任命
	MSG_FAST_REQUEST_SOCIATY			= 20--//快速申请公会
	
	MSG_SOCIATY_UPDATE_LIST				= 28--//用于公会申请后更新(与6公会列表消息结构一样)
	MSG_SOCIATY_EXP_SEND_LIST			= 29--公会成员日志(公会经验贡献)
	MSG_SOCIATY_CAMPAIGNS				= 30--//公会活动
	
	--/**六芒封魔*/
	MSG_SOCIATY_SAINT_CALLED_OUT		= 31--	/*召唤散仙*/
	MSG_GOLDTOUCH_JOIN			        = 32--	/*六芒封魔*/
	MSG_GOLDTOUCH_MEMBER_CALLED			= 33--	/*召集成员*/
	MSG_GOLDTOUCH_OPEN			        = 34--	/*查看封魔信息*/
	MSG_SOCIATY_RAPPELZ_SUCCEED			= 38--	/*封魔成功*/
	MSG_GOLDTOUCH_SUCCESS			    = 39--	/*客户端关窗口*/
	
    MSG_SOCIATY_TAKE_PART_CAMPAIGN		= 35--//参与活动
    MSG_SOCIATY_GOTO_MAP	            = 40--进入集会所
    MSG_SOCIATY_BOSS_TIME_LIST			= 41--//每周BOSS时间列表
	MSG_SOCIATY_CHICK_FEAST             = 49 --公会宴会
    
	MSG_SOCIATY_SIGN_GAME_INFO			= 55	--报名界面信息
	MSG_SOCIATY_SIGN_GAME_LIST			= 56	--已报名参加公会战的公会列表
    MSG_VIEW_SOCIATY_INFO2				= 57 --//查看公会(其他公会)
	MSG_SOCIATY_MEMBER_LIST2			= 58 --//公会成员列表(其他公会)
	
	MSG_SOCIATY_ACCUSE_LEADER			= 59--//弹劾会长

    MSG_SOCIATY_ACCUSE_STATUS			= 60--//支持或反对
    MSG_SOCIATY_CAMPAIGNS_SIGNPICS		= 61--//小助手公会活动
	MSG_SOCIATY_MORALE_TRAIN            = 71--//士气训练次数
	MSG_SOCIATY_MORALE_TRAIN_OK         = 72--//士气训练
    MSG_SOCIATY_RAPPELZ_JION            = 77--//桃园结义
    MSG_SOCIATY_RAPPELZ_OPEN            = 78--//桃园结义信息 
    MSG_INVITE_SOCIATY_MEMBER_LIST		= 80--//邀请公会成员列表
	MSG_INVITE_SOCIATY_MEMBER_LIST_END  = 86--//邀请公会成员列表下发结束
	MSG_INVITE_UPDATE_TRIBEINFO         = 81--//公会信息刷新
	MSG_SOCIATY_ACTIVIES_BEGIN          = 84--//军团活动开启
    MSG_SOCIATY_ACTIVIES_END            = 85--//军团活动结束 
	
	
	local MSG_CLOSEGOLDTOUCH_WND 		= 75
	
	
local stInviteMember = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
	    tmp.idMember = dt:readInt();
	    local str = dt:readString();
	    if str then
	        tmp.szName = str:getData();
	    else
	        tmp.szName = "";
	    end
        tmp.usLevel = dt:readShort();
        tmp.ucOnline = dt:readByte();	--//1在线
        tmp.nReputation = dt:readInt();
        return tmp
    end
}

local tMsg_Info25 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
		tmp.ucAmount = dt:readByte();
		tmp.stfill = {};
		for i = 1, tmp.ucAmount do
		    table.insert(tmp.stfill, stInviteMember.initWithStream(dt));
		end
        return tmp
    end
}

local stJoininfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.byType = dt:readByte();
        tmp.nFacePhoto = dt:readInt();
        local scStr = dt:readString()
            if scStr == nil then
                tmp.szName = ""
            else
                tmp.szName = scStr:getData()
        end
        return tmp
    end
}

local stRapplezinfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.usNum = dt:readShort()
        tmp.byIsIn = dt:readByte() -- //1为在队伍中，0为不在
        tmp.stJoin = {__mode = "kv"};
        for i = 1, tmp.usNum do
            table.insert(tmp.stJoin, stJoininfo.initWithStream(dt));
        end
        return tmp
    end
}
    
local  m_wnd = nil
    
local m_currentTabIndex = nil
local m_rankType = nil
local pIndex = nil
local m_isBright = false

local function removeAllData()
    removeAllData_SocietyMainLayer()
    removeAllData_otherSocietyListLayer()
    removeAllData_SocietyCreateLayer()
    m_wnd = nil
    m_currentTabIndex = nil
    m_rankType = nil
	pIndex = nil
end
local function multiTabAction(tag, pageIndex)
    if m_wnd ==nil then
        return;
    end
    
    local multiTabLayer = m_wnd:getChildByTag(801201);
    if multiTabLayer then
        multiTabLayer = SCTypeCast:castNodeToMultiPage(multiTabLayer)
        local index = multiTabLayer:selectedPageIndex()
        if m_rankType == 0 then
            if index == 1 then--公会创建
                local contentLayer = multiTabLayer:getPageWithTag(1)
                open_SocietyCreateScreen(contentLayer)
            end
        else    
            if index == 0 then--显示自己公会
                local otherSocietyLayer = multiTabLayer:getPageWithTag(1)
                if otherSocietyLayer then--其他公会
                    otherSocietyLayer:removeAllChildrenWithCleanup(true)
                    removeAllData_otherSocietyListLayer()
                end 
                pIndex = 0;
                
            elseif index == 1 then--显示其他公会
                if pIndex == nil then
                    pIndex = 0;
                end
                --multiTabLayer:selectPageWithIndex(pIndex)
                SocietyMainLayer_activityButtonAction()
                
               
            elseif index == 2 then
				if pIndex ~= 2 then
					local contentLayer = multiTabLayer:getPageWithTag(2)
					open_otherSocietyListWnd(contentLayer)
					pIndex = 2;
				end
            end
        end
    end
end


local function receiveTribeMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readShort();
    if action == MSG_VIEW_SOCIATY_INFO then--公会信息
        processSocietyInfo_societyMain(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_MEMBER_LIST then--公会成员
        processSocietyMemberList_societyMain(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action ==MSG_SOCIATY_EXP_SEND_LIST then --公会日志
        processJournal_societyMain(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_VIEW_SOCIATY_INFO2 then--其他公会信息
        processsSocietyInfo_societyOtherInfoScreen(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_MEMBER_LIST2 then--查看其他公会成员
        processSocietyMemberList_societyOtherInfoScreen(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_MEMBER_UPDATE then--公会成员更新
        processSocietyMemberUpdate_societyMain(dt)
    elseif action == MSG_SOCIATY_CAMPAIGNS then--公会活动
        processsActivityList_societyMain(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_CAMPAIGNS_SIGNPICS then--小助手公会活动界面
         showPartActivityInfo(dt);-----小助手打开公会活动
         SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_PROPOSER_LIST then--公会申请人列表
        processApplyList_societyMain(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_PROPOSER_DEL then--//公会申请人更新删除 s->c(接收或拒收后)
        processDeleteApplyList_societyMain(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_LIST then--其他公会列表
        processOtherList_SocietyCreateScreen(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_UPDATE_LIST then--//用于公会申请后更新(与6公会列表消息结构一样)
        processUpdate_SocietyCreateScreen(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_OPEN_LOTTERY then--//打开公宫殿牌占卜界面
        open_societyLotteryScreen()
        processSocietyLotteryMsg_societyLotteryScreen(dt)
    elseif action == MSG_SOCIATY_CHICK_LOTTERY then--公宫殿牌占卜点击抽奖
        processSocietyCardList_societyLotteryScreen(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_RANK_LOTTERY then--公会宫殿牌积分排名
        processSocietyRankList_societyLotteryScreen(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_OPEN_LOTTERY1 then--打开全服宫殿牌
        open_lotteryScreen()
        processLotteryMsg_lotteryScreen(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_CHICK_LOTTERY1 then--宫殿牌抽奖结果
        processCardList_lotteryScreen(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_CHICK_RUFFLE  then--洗牌换牌
        processChanageAward_lotteryScreen(dt)
         SCActivityIndicator:getSingleton():close()
    elseif action == MSG_TRIBE_DISMISS or action ==MSG_TRIBE_LEAVE then--离开或公会解散
        closeWindowById(8012)--公会主界面
        closeWindowById(8014)--公会介绍
    elseif action == MSG_TRIBE_KICKOUT then--踢出公会
        local idTarget = dt:readInt()
        local hero = Hero:getSingleton()
        if hero:getID() == idTarget then
            closeWindowById(8012)--公会主界面
            closeWindowById(8014)--公会介绍
        else
            processDeleteMember_societyMain(idTarget)
        end
    elseif action == MSG_CREATE_SOCIATY_INFO  then--//创建公会条件
        processCreateSocietyInfo_societyCreate(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_CREATE_SOCIATY_OK then--创建公会成功
        closeWindowById(8012)
        open_SocietyScreen()
    elseif action == MSG_SOCIATY_ACCUSE_STATUS then--弹劾
        processAccuse_societyMain(dt)
    elseif action == MSG_SOCIATY_SIGN_GAME_INFO then        
	    LuaData:getSingleton():setDataTransStream(LuaData_MSG_SOCIATY_SIGN_GAME_INFO,dt);
    elseif action == MSG_SOCIATY_SIGN_GAME_LIST then
	    LuaData:getSingleton():setDataTransStream(LuaData_MSG_SOCIATY_SIGN_GAME_LIST,dt);
	elseif action == MSG_SOCIATY_BOSS_TIME_LIST then
		LuaData:getSingleton():setDataTransStream(LuaData_SOCIATY_BOSS_TIME_LIST,dt);
	--elseif action == MSG_SOCIATY_RAPPELZ_OPEN then
		--Rappalz_processRappelzOpen(dt)
		--SCActivityIndicator:getSingleton():close()
	elseif action == MSG_SOCIATY_RAPPELZ_SUCCEED then
		Rappalz_processRappelzSuceed(dt)
		SCActivityIndicator:getSingleton():close()
	elseif action == MSG_SOCIATY_CHICK_FEAST then
		setFeatCountDown(dt:readInt())
		SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_RAPPELZ_JION then
        TaoyuanSworn.setTaoyuanSwornData(stRapplezinfo.initWithStream(dt));
    elseif action == MSG_SOCIATY_RAPPELZ_OPEN then
        TaoyuanSworn.setTaoyuanSwornData(stRapplezinfo.initWithStream(dt));
    elseif action == MSG_SOCIATY_MORALE_TRAIN then  --士气训练次数
        ArmyTraining.Window(dt);
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_INVITE_SOCIATY_MEMBER_LIST then
        BattleTeam5.prossInviteSociatyMember(tMsg_Info25.initWithStream(dt))
	elseif MSG_INVITE_SOCIATY_MEMBER_LIST_END then
		BattleTeam5.prossInviteSociatyMember(tMsg_Info25.initWithStream(dt), true)
    elseif action == MSG_INVITE_UPDATE_TRIBEINFO then
        processSocietyInfo_societyMain(dt)
        SCActivityIndicator:getSingleton():close()
    elseif action == MSG_SOCIATY_ACTIVIES_BEGIN then    --军团活动开启
        setLightEfficiency(UNLOCK_TYPE_TRIBE, true)
        m_isBright = true
    elseif action == MSG_SOCIATY_ACTIVIES_END then      --军团活动结束
        setLightEfficiency(UNLOCK_TYPE_TRIBE, false)
        m_isBright = false
    end
end

function getBrightFlagForTribe()
    return m_isBright
end

local function ctrlEvent8012(tag, eventType)
	if eventType == LuaControllerEventPushEnded then
		showGuideStep(GUIDE_TYPE_GUILD, -1)
	end
end

function open_SocietyScreen()
    if getCurentSceneWindowController(8012) then
        return;
    end
    local width = SX(480)
	local height = SY(320)
	
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setTag(8012);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(removeAllData);
    wnd:setContentSize(CCSizeMake(width,height))
    local imgFile = getRealUIResourcePath("img/new00428.png");
	if imgFile then
	   wnd:setTitleWithImage(imgFile:getData())
	end
	
    local scene = SCBaseScene:getRunningScene()
	local naviCtrl = scene:getNavigationController()
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	if wndCtrl == nil or naviCtrl == nil or scene == nil then
        return;
    end
	wndCtrl:luaSetSelectorOnEvent(ctrlEvent8012)
	naviCtrl:pushWindowController(wndCtrl)
	m_wnd = wnd;

	local hero = Hero:getSingleton()
	if hero == nil then
	    return;
	end
    m_rankType = hero:getRank()

	local showWidth  = width*0.96
	local showHeight = height*0.82
	local startX = (width-showWidth)/2
	local startY = SY(5)
	
	--tab1
	local pageContentLayer = SCDragNode:node()
	pageContentLayer:setTag(0)
	pageContentLayer:setFrameVisibled(true)
	pageContentLayer:setAnchorPoint(CCPointMake(0,0));
	pageContentLayer:setPosition(CCPointMake(startX,startY));
	pageContentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
	--tab2
	local pageContentLayer2 = SCDragNode:node()
	pageContentLayer2:setTag(1)
	pageContentLayer2:setFrameVisibled(true)
	pageContentLayer2:setAnchorPoint(CCPointMake(0,0));
	pageContentLayer2:setPosition(CCPointMake(startX,startY));
	pageContentLayer2:setContentSize(CCSizeMake(showWidth,showHeight))
	
	--tab3
	local pageContentLayer3 = SCDragNode:node()
	pageContentLayer3:setTag(2)
	pageContentLayer3:setFrameVisibled(true)
	pageContentLayer3:setAnchorPoint(CCPointMake(0,0));
	pageContentLayer3:setPosition(CCPointMake(startX,startY));
	pageContentLayer3:setContentSize(CCSizeMake(showWidth,showHeight))
	
	local multiTabLayer = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	multiTabLayer:setTag(801201)
	multiTabLayer:addPage(pageContentLayer)
	multiTabLayer:addPage(pageContentLayer2)
	
    multiTabLayer:luaSetSelectorOnPageSelected(multiTabAction)
    multiTabLayer:setContentSize(CCSizeMake(SX(480), SY(320)))
	m_wnd:addChild(multiTabLayer)
	
    if m_rankType == 0 then
        local imgPath1 = getRealUIResourcePath("img/new00379.png");
        local imgPath2 = getRealUIResourcePath("img/new00369.png");
        if imgPath1 and imgPath2 then
            multiTabLayer:setTitleAtPage(imgPath1:getData(), 0);
            multiTabLayer:setTitleAtPage(imgPath2:getData(), 1);
        else
            multiTabLayer:setTitleAtPage( _LTParser("str8061"), getDefaultFontName(),getFontSize(14), 0); --其他公会
	        multiTabLayer:setTitleAtPage( _LTParser("str8043"), getDefaultFontName(),getFontSize(14), 1);--创建公会
	    end
	    open_otherSocietyListWnd(pageContentLayer)
    else
        multiTabLayer:addPage(pageContentLayer3)
        local imgPath1 = getRealUIResourcePath("img/new00435.png");
        local imgPath2 = getRealUIResourcePath("img/new00548.png");
        local imgPath3 = getRealUIResourcePath("img/new00379.png");
        if imgPath1 and imgPath2 then
            multiTabLayer:setTitleAtPage(imgPath1:getData(), 0);
            multiTabLayer:setTitleAtPage(imgPath2:getData(), 1);
            multiTabLayer:setTitleAtPage(imgPath3:getData(), 2);
        else
            multiTabLayer:setTitleAtPage( _LTParser("str8060"), getDefaultFontName(),getFontSize(14), 0); --我的公会
	        multiTabLayer:setTitleAtPage( _LTParser("str8061"), getDefaultFontName(),getFontSize(14), 1);--其他公会
	        multiTabLayer:setTitleAtPage( _LTParser("str8061"), getDefaultFontName(),getFontSize(14), 2);--其他公会
        end
        open_SocietyMainScreen(pageContentLayer)
    end
    
    m_currentTabIndex = 1
end

function SocietyControllScreen_Open()
    open_SocietyScreen()
    if Hero:getSingleton():getIdTribe() ~= 0 then
        SocietyMainLayer_logButtonAction(4);
    end
end

SCMessageCenter:getSingleton():luaRegistCommand(receiveTribeMsg, _MSG_TRIBE, 0, nil);