--其他军团信息 8013界面

local m_wnd = nil
local m_societyMemberList = nil
local m_societyInfo = nil
local Value = nil

local function removeAllData()
    m_wnd = nil
    m_societyMemberList = nil
    m_societyInfo = nil
    Value = nil
end

local function createListMenuItem(showWidth,showHeight,name,level,rankName,rank,profer,szLoginTime)	
	local contentLayer = SCDragNode:node()
	contentLayer:setFrameVisibled(false)
	contentLayer:setFrameType(EnumFrameTypeListNormal)
	contentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
	--上分割线
	local imgPath = getRealUIResourcePath("img/new00346.png")
	if imgPath then
	    local cuttingLine = SCImage:imageWithFile(imgPath:getData());
	    if cuttingLine then
	        local size = contentLayer:getContentSize();
            cuttingLine:setAnchorPoint(CCPointMake(0.5,0.5));
            cuttingLine:setPosition(CCPointMake(size.width/2 ,size.height - 2 * cuttingLine:getContentSize().height));
            contentLayer:addChild(cuttingLine);
	    end
	end
	
	local flg = nil
	if string.match(szLoginTime,L("str3285")) then
	    flg = true
	end
	
    --成员名称
    if name == nil then
        name =""
    end
    local memberNameLabel = SCLabel:labelWithStringFont(""..name,getDefaultFontName(), getFontSize(10))
    if memberNameLabel then
		memberNameLabel:setColor(getColorYellow())
		if not flg then
            memberNameLabel:setColor(getColorGray())
        end
		memberNameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
		memberNameLabel:setPosition(CCPointMake(showWidth*0.13,showHeight/2));
		contentLayer:addChild(memberNameLabel)
	end
    
    --等级
    if level == nil then
        level = ""
    end
    local levelLabel = SCLabel:labelWithStringFont(""..level,getDefaultFontName(), getFontSize(10))
    if levelLabel then
		levelLabel:setColor(getColorYellow())
		if not flg then
            levelLabel:setColor(getColorGray())
        end
		levelLabel:setAnchorPoint(CCPointMake(0.5,0.5));
		levelLabel:setPosition(CCPointMake(showWidth*0.29,showHeight/2));
		contentLayer:addChild(levelLabel)
	end
    
    --职务
    if rankName == nil then
        rankName = ""
    end
    local memberNameLabel = SCLabel:labelWithStringFont(""..rankName,getDefaultFontName(), getFontSize(10))
	if memberNameLabel then
		memberNameLabel:setColor(getColorYellow())
		if not flg then
            memberNameLabel:setColor(getColorGray())
        end
		memberNameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
		memberNameLabel:setPosition(CCPointMake(showWidth*0.42,showHeight/2));
		contentLayer:addChild(memberNameLabel)
	end
    
    --竞技排名
    if rank==nil then
        rank = ""
    end
    local rankLabel = SCLabel:labelWithStringFont(""..rank,getDefaultFontName(), getFontSize(10))
    if rankLabel then
		rankLabel:setColor(getColorYellow())
		if not flg then
            rankLabel:setColor(getColorGray())
        end
		rankLabel:setAnchorPoint(CCPointMake(0.5,0.5));
		rankLabel:setPosition(CCPointMake(showWidth*0.58,showHeight/2));
		contentLayer:addChild(rankLabel)
	end
    
    --贡献
    if profer == nil then
        profer =""
    end
    local contributionLabel = SCLabel:labelWithStringFont(""..profer,getDefaultFontName(), getFontSize(10))
    if contributionLabel then
		contributionLabel:setColor(getColorYellow())
		if not flg then
            contributionLabel:setColor(getColorGray())
        end
		contributionLabel:setAnchorPoint(CCPointMake(0.5,0.5));
		contributionLabel:setPosition(CCPointMake(showWidth*0.76,showHeight/2));
		contentLayer:addChild(contributionLabel)
	end
    
    --登陆
    if szLoginTime == nil then
        szLoginTime = ""
    end
    local timeLabel = SCLabel:labelWithStringFont(""..szLoginTime,getDefaultFontName(), getFontSize(10))
    if timeLabel then
		timeLabel:setColor(getColorYellow())
		if not flg then
            timeLabel:setColor(getColorGray())
        end
		timeLabel:setAnchorPoint(CCPointMake(0.5,0.5));
		timeLabel:setPosition(CCPointMake(showWidth*0.91,showHeight/2));
		contentLayer:addChild(timeLabel)
	end
    
    return contentLayer
end

local function onClickMenuList(index)
    if index == 0 then--查看信息
        ViewPlayInfo_sendData(m_societyMemberList[Value].idMember, 0, "")
    elseif index == 1 then--添加好友
        gAddFriend(m_societyMemberList[Value].idMember,"")
    elseif index == 2 then--发送私聊
        gTalkTo(m_societyMemberList[Value].szName);
    elseif index == 3 then  --挑战
        send_Dekaron(m_societyMemberList[Value].idMember)
    end
end

--列表点击
local function listBoxItemSelected(tag,itemTag,itemIndex)

    if m_wnd == nil then
        return
    end
    local listBox = SCFunction:getUiNodeByIdlistAndParent("801302-"..tag,m_wnd)
    if listBox == nil then
        return
    end
    listBox = SCTypeCast:castNodeToListBox(listBox)
    local menuItem = listBox:getChildByTag(itemTag)
    if menuItem == nil then
        return
    end
    menuItem = SCTypeCast:castNodeToDragNode(menuItem)
    menuItem:setFrameType(EnumFrameTypeListSelect)
    
    Value = itemIndex + 1;
    
    local menuListStr = _LTParser("str8090").."_".._LTParser("str8091").."_".._LTParser("str8092").."_".._LTParser("str8093") 
    
    local pmenuList = menuList:newStringList()
    if pmenuList then
        pmenuList:createMenu(m_societyMemberList[itemIndex+1].szName, 2, menuListStr);
        pmenuList:luasetSelector(onClickMenuList);
    end
    
end

--成员列表取消
local function listBoxUnItemSelected(tag,itemTag,itemIndex)
     if m_wnd == nil then
        return
    end
    local listBox = SCFunction:getUiNodeByIdlistAndParent("801302-"..tag,m_wnd)
    if listBox == nil then
        return
    end
    listBox = SCTypeCast:castNodeToListBox(listBox)
    local menuItem = listBox:getChildByTag(itemTag)
    if menuItem == nil then
        return
    end
    menuItem = SCTypeCast:castNodeToDragNode(menuItem)
    menuItem:setFrameType(EnumFrameTypeListNormal)
end


--显示公会成员列表
local function showOtherSocietyMemberList()
    if m_wnd == nil then
        return
    end
    local contentLayer = m_wnd:getChildByTag(801302);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local showWidth  = contentLayer:getContentSize().width
    local showHeight = contentLayer:getContentSize().height
    local titleStartY = showHeight*0.9
    --成员名称
    local memberNameLabel = SCLabel:labelWithStringFont(_LTParser("str8066"),getDefaultFontName(), getFontSize(12))
	memberNameLabel:setColor(getColorYellow())
    memberNameLabel:setAnchorPoint(CCPointMake(0.5,0));
    memberNameLabel:setPosition(CCPointMake(showWidth*0.13,titleStartY));
    contentLayer:addChild(memberNameLabel)
    
    --等级
    local levelLabel = SCLabel:labelWithStringFont(_LTParser("str8047"),getDefaultFontName(), getFontSize(12))
	levelLabel:setColor(getColorYellow())
    levelLabel:setAnchorPoint(CCPointMake(0.5,0));
    levelLabel:setPosition(CCPointMake(showWidth*0.3,titleStartY));
    contentLayer:addChild(levelLabel)
    
    --职务
    local rankNameLabel = SCLabel:labelWithStringFont(_LTParser("str8067"),getDefaultFontName(), getFontSize(12))
	rankNameLabel:setColor(getColorYellow())
    rankNameLabel:setAnchorPoint(CCPointMake(0.5,0));
    rankNameLabel:setPosition(CCPointMake(showWidth*0.42,titleStartY));
    contentLayer:addChild(rankNameLabel)
    
    --竞技排名
    local rankLabel = SCLabel:labelWithStringFont(_LTParser("str8068"),getDefaultFontName(), getFontSize(12))
	rankLabel:setColor(getColorYellow())
    rankLabel:setAnchorPoint(CCPointMake(0.5,0));
    rankLabel:setPosition(CCPointMake(showWidth*0.58,titleStartY));
    contentLayer:addChild(rankLabel)
    
    --贡献
    local contributionLabel = SCLabel:labelWithStringFont(_LTParser("str8069"),getDefaultFontName(), getFontSize(12))
	contributionLabel:setColor(getColorYellow())
    contributionLabel:setAnchorPoint(CCPointMake(0.5,0));
    contributionLabel:setPosition(CCPointMake(showWidth*0.75,titleStartY));
    contentLayer:addChild(contributionLabel)
    
    --登陆
    local timeLabel = SCLabel:labelWithStringFont(_LTParser("str8070"),getDefaultFontName(), getFontSize(12))
	timeLabel:setColor(getColorYellow())
    timeLabel:setAnchorPoint(CCPointMake(0.5,0));
    timeLabel:setPosition(CCPointMake(showWidth*0.9,titleStartY));
    contentLayer:addChild(timeLabel)
    
    if m_societyMemberList == nil then
        return
    end
    local listBoxWidth  = showWidth*0.98
    local listBoxHeight = showHeight*0.85
    local listBox = SCListBox:boxWithWidthHeight(listBoxWidth,listBoxHeight)
    listBox:setTag(1001)
    listBox:setAnchorPoint(CCPointMake(0.5,0));
    listBox:setPosition(CCPointMake(showWidth/2,SY(5)));
    listBox:luaSetSelectorOnItemSelected(listBoxItemSelected)
    listBox:luaSetSelectorOnItemUnSelected(listBoxUnItemSelected)
    
    local menuWidth  = listBoxWidth
    local menuHeight = SY(40)
    local amount = #m_societyMemberList
    for i=1,amount do
        --idMember
        local name = m_societyMemberList[i].szName
        local level = m_societyMemberList[i].usLevel
        local rankName = _LTParser("str8080")
        if m_societyMemberList[i].ucRank==1 then--会长
            rankName = _LTParser("str8081")
        elseif m_societyMemberList[i].ucRank==2 then--会长夫人
            rankName = _LTParser("str8082")
        elseif m_societyMemberList[i].ucRank==3 then--副会长
            rankName = _LTParser("str8083")
        end
        local rank = m_societyMemberList[i].nArenaRank
        local profer = m_societyMemberList[i].dwSumProfer
        local szLoginTime = m_societyMemberList[i].szLoginTime
        local menuItem = createListMenuItem(menuWidth,menuHeight,name,level,rankName,rank,profer,szLoginTime)
        menuItem:setTag(i)
        menuItem:setAnchorPoint(CCPointMake(0.5,0));
        menuItem:setPosition(CCPointMake(showWidth/2,0));
        listBox:addItem(menuItem)
    end
    contentLayer:addChild(listBox)
end

--左边公会信息
local function showLeftSocietyInfoContent()
    if m_wnd == nil then
        return
    end
    local contentLayer = m_wnd:getChildByTag(801301);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local width = contentLayer:getContentSize().width
    local height = contentLayer:getContentSize().height
    
    if m_societyInfo == nil then
        return
    end
    
    
    --公会信息
    local tmpStr = "*5".._LTParser("str8085").." *0"..m_societyInfo.szTribeName--公会名称
    tmpStr = tmpStr.."_*5".._LTParser("str8086").." *0"..m_societyInfo.szLeaderName--会长名称
    tmpStr = tmpStr.."_*5".._LTParser("str8051").." *0"..m_societyInfo.usLevel--公会等级
    tmpStr = tmpStr.."_*5".._LTParser("str8052").." *0"..m_societyInfo.nRank--公会排名
    tmpStr = tmpStr.."_*5".._LTParser("str8053").." *0"..m_societyInfo.nCurrMemberCount.."/"..m_societyInfo.nMaxMemberCount--公会人数
    --tmpStr = tmpStr.."_*5".._LTParser("str8055").." *0"..m_societyInfo.nConTime--本周贡献
    local detailLabel = ParsedNode:getParsedNode(tmpStr,0,12)
    detailLabel:setPerWidthAndHeight(12,18)
    detailLabel:setAnchorPoint(CCPointMake(0,0));
    detailLabel:setPosition(CCPointMake(SX(3),height*0.95-detailLabel:getContentSize().height));
    contentLayer:addChild(detailLabel)
    
    --公会介绍标题
	--[[
	local imgPath = getRealUIResourcePath("img/new00376.png")
	if imgPath then
		local titleImage = SCImage:imageWithFile(imgPath:getData());
		if titleImage then
			titleImage:setAnchorPoint(CCPointMake(0,0));
			titleImage:setPosition(CCPointMake(SX(7),height*0.42));
			contentLayer:addChild(titleImage)
		end
    else
        local titleLabel = ParsedNode:getParsedNode("*6".._LTParser("str8088"),0,14)
        titleLabel:setPerWidthAndHeight(12,18)
        titleLabel:setAnchorPoint(CCPointMake(0,0));
        titleLabel:setPosition(CCPointMake(SX(3),height*0.4));
        contentLayer:addChild(titleLabel)
    end
	--]]
	local titleLabel = ParsedNode:getParsedNode("*6".._LTParser("str8088"),0,18)
		if titleLabel then
		titleLabel:setAnchorPoint(CCPointMake(0,0));
		titleLabel:setPosition(CCPointMake(SX(7),height*0.42));
		contentLayer:addChild(titleLabel)
	end
    
    --公会介绍
    local detailStr = m_societyInfo.szMsg1
    if detailStr == nil then
        detailStr = ""
    end
    local showTextLabel = SCTextBox:boxWithWidthHeight(width*0.9,height*0.37);
    showTextLabel:setParserDelegate(TextParser:getSingleton())
    showTextLabel:setAnchorPoint(CCPointMake(0.5,0));
    showTextLabel:setPosition(CCPointMake(width/2,height*0.4-showTextLabel:getContentSize().height));
    showTextLabel:setText(detailStr)
    contentLayer:addChild(showTextLabel)
end

function open_SocietyOtherInfoScreen()
    if getCurentSceneWindowController(8013) then
        return;
    end
    local width = SX(480)
	local height = SY(320)
	
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setTag(8013);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(removeAllData);
    wnd:setContentSize(CCSizeMake(width,height))
    local imgFile = getRealUIResourcePath("img/new00379.png");
	if imgFile then
	   wnd:setTitleWithImage(imgFile:getData())
	end
	
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	naviCtrl:pushWindowController(wndCtrl)
	
	m_wnd =  getCurentSceneWindowController(8013):getWindow();

    
    local showLeftWidth  = width*0.32
	local showLeftHeight = height*0.8
	
	local leftStartX = SX(12)
	local leftStartY = SY(12)
	
	local leftContentLayer = SCDragNode:node()
	leftContentLayer:setTag(801301)
	leftContentLayer:setFrameType(EnumFrameTypeRound)
	leftContentLayer:setFrameVisibled(true)
	leftContentLayer:setAnchorPoint(CCPointMake(0,0));
	leftContentLayer:setPosition(CCPointMake(leftStartX,leftStartY));
	leftContentLayer:setContentSize(CCSizeMake(showLeftWidth,showLeftHeight))
    m_wnd:addChild(leftContentLayer)
	  
	local showRightWidth  = width*0.61
	local showRightHeight = height*0.8
	
	local rightStartX = leftStartX+showLeftWidth+SX(6)
	local rightStartY = SY(12)
	
	local rightContentLayer = SCDragNode:node()
	rightContentLayer:setTag(801302)
	rightContentLayer:setFrameType(EnumFrameTypeRound)
	rightContentLayer:setFrameVisibled(true)
	rightContentLayer:setAnchorPoint(CCPointMake(0,0));
	rightContentLayer:setPosition(CCPointMake(rightStartX,rightStartY));
	rightContentLayer:setContentSize(CCSizeMake(showRightWidth,showRightHeight))
    m_wnd:addChild(rightContentLayer)

end

--获取公会信息
function processsSocietyInfo_societyOtherInfoScreen(dt)
    if dt == nil then
        return
    end
    if m_wnd == nil then
        open_SocietyOtherInfoScreen()
    end
    
                  
    

    local idTribe          = dt:readInt()--//公会ID
    local usLevel          = dt:readShort()--//等级
    local szTribeName      = dt:readString()--//名称
    local szLeaderName     = dt:readString()--//会长
    local nCurrMemberCount = dt:readShort()--//当前公会人数
    local nMaxMemberCount  = dt:readShort()--//最大公会人数
    local nRank            = dt:readInt()--//公会排名
    local dwExp            = dt:readInt()--//公会当前经验
    local dwMaxExp         = dt:readInt()--//公会升级经验
    local szMsg            = dt:readString()--公告
    local szMsg1           = dt:readString()--公会介绍
    local nConTime         = dt:readInt()--  /** 贡献*/

    local societyInfo = {}
    societyInfo.idTribe = idTribe
    societyInfo.usLevel = usLevel
    if szTribeName then
        societyInfo.szTribeName = szTribeName:getData()
	else
		societyInfo.szTribeName = " "
    end
    if szLeaderName then
        societyInfo.szLeaderName = szLeaderName:getData()
	else
		societyInfo.szLeaderName = " "
    end
    
    societyInfo.nCurrMemberCount = nCurrMemberCount
    societyInfo.nMaxMemberCount = nMaxMemberCount
    societyInfo.nRank = nRank
    societyInfo.dwExp = dwExp
    societyInfo.dwMaxExp = dwMaxExp
    if szMsg then
        societyInfo.szMsg = szMsg:getData()
	else
		societyInfo.szMsg = " "
    end
    if szMsg1 then
        societyInfo.szMsg1 = szMsg1:getData()
	else
		societyInfo.szMsg1 = " "
    end
    societyInfo.nConTime = nConTime
    
    
    m_societyInfo = societyInfo
     
    showLeftSocietyInfoContent()
end

function processSocietyMemberList_societyOtherInfoScreen(dt)
    if dt == nil then
        return
    end
    if m_societyMemberList == nil then
        m_societyMemberList = {}
    end
    
    local idTribe  = dt:readInt()--入口已经读过
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local idMember      = dt:readInt()
        local szName        = dt:readString()
        local usLevel       = dt:readShort()
        local ucRank        = dt:readByte()--//职务
        local nArenaRank    = dt:readInt()--//竞技排名
        local ucSex         = dt:readByte()--//性别
        local dwTodayProfer = dt:readInt()--//今日贡献
        local dwSumProfer   = dt:readInt()--//总贡献
        local szLoginTime   = dt:readString()--//登录时间
        
        local tmpDetail = {}
        tmpDetail.idMember = idMember
        if szName then
            tmpDetail.szName = szName:getData()
        end
        
        tmpDetail.usLevel       = usLevel
        tmpDetail.ucRank        = ucRank
        tmpDetail.nArenaRank    = nArenaRank
        tmpDetail.ucSex         = ucSex
        tmpDetail.dwTodayProfer = dwTodayProfer
        tmpDetail.dwSumProfer   = dwSumProfer
        if szLoginTime then
            tmpDetail.szLoginTime = szLoginTime:getData()
        end
        
        table.insert(m_societyMemberList,tmpDetail);
    end
    showOtherSocietyMemberList()
end