--8014公会设置界面

local m_wnd = nil

local m_initPoint = nil

local function removeAllData()
    m_wnd  = nil
end


--窗口复原位置
local function resetWindowPosition()
    if m_wnd == nil then
        return
    end
    if m_initPoint then
        m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPoint.x, m_initPoint.y)));
        m_moveUpHeight = nil
    end

end

--点击主题输入框响应
local function contentEditTouchAction2()
    if m_wnd == nil then
        return
    end
    local moveUpHeight = SY(120)
    if m_initPoint then
        m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPoint.x, m_initPoint.y + moveUpHeight)));
    end
end

local function contentEditTouchEndAction2()
    resetWindowPosition()
end

local function okButtonAction()
    local msg  = nil
    local msg2 = nil
    local msgEdit    = m_wnd:getChildByTag(801401);
    if msgEdit then
        msgEdit = SCTypeCast:castNodeToTextBox(msgEdit)
        msg     = msgEdit:getText()
    end
    
    local msgEdit2    =  m_wnd:getChildByTag(801402);
    if msgEdit2 then
        msgEdit2 = SCTypeCast:castNodeToTextBox(msgEdit2)
        msg2     = msgEdit2:getText()
    end
    if msg == nil then
        msg = ""
    end
    if msg2 == nil then
        msg2 = ""
    end
    if msg ~="" or msg2 ~= "" then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_SET_TENET)--//帮派信息设置(公告与介绍)
        local hero = Hero:getSingleton()
        dt:writeInt(hero:getIdTribe())-- //公会ID
        dt:writeString(SCString:stringWithString(msg))--//公告
        dt:writeString(SCString:stringWithString(msg2))--//介绍
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
    closeWindowById(8014)--关闭界面
end

local function onWindowTouched()
    if m_wnd == nil then
        return
    end
    local msgEdit    = m_wnd:getChildByTag(801401);
    if msgEdit then
        msgEdit = SCTypeCast:castNodeToTextBox(msgEdit)
        msgEdit:getTextControl():detachWithIME()
    end
        
    local msgEdit2    =  m_wnd:getChildByTag(801402);
    if msgEdit2 then
        msgEdit2 = SCTypeCast:castNodeToTextBox(msgEdit2)
        msgEdit2:getTextControl():detachWithIME()
    end
    
end

local function insertTitleText(tag, tlen, text)
    if m_wnd == nil then
        return
    end
    local moveUpHeight = SY(120)
    if m_initPoint then
        m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPoint.x, m_initPoint.y + moveUpHeight)));
    end
    
    if not m_wnd then
       return;
    end
    if tag~=801401 and tag ~=801402 then
        return
    end
    local editBox =m_wnd:getChildByTag(tag)
    if not editBox then
        return
    end
	local strInsertText = text
	if strInsertText == "\n" or not luaCheckCharIsLegitimacy(strInsertText) then
	    editBox:luaSetSelectorOnInsertChar(false);
		return;
	end
    editBox:luaSetSelectorOnInsertChar(true);
end

function open_SocietySetScreen(detailMsg,detailMsg2)
    if getCurentSceneWindowController(8014) then
        return;
    end
    local width = SX(340)
	local height = SY(320)
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setTag(8014);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(removeAllData);
    wnd:setContentSize(CCSizeMake(width,height))
    wnd:luaSetSelectorOnTouched(onWindowTouched)
    local imgFile = getRealUIResourcePath("img/new00449.png");
	if imgFile then
	   wnd:setTitleWithImage(imgFile:getData())
	end
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	naviCtrl:pushWindowController(wndCtrl)
	
	m_wnd =  getCurentSceneWindowController(8014):getWindow();
	
	local editBoxWidth  = width*0.8
	local editBoxHeight = height*0.27
	
	--公告标题
	local titleLabel = SCLabel:labelWithStringFont(_LTParser("str8087"),getDefaultFontName(), getFontSize(14))
    titleLabel:setAnchorPoint(CCPointMake(0,0));
    titleLabel:setPosition(CCPointMake(SX(35),height*0.79));
    m_wnd:addChild(titleLabel)
    
    --公会公告输入框
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
	--[[local imageFile = getRealUIResourcePath("kernal/Tip3.pn")
	local configFile = getRealUIResourcePath("kernal/Tip3.ini")
	if imageFile and configFile then
		editBgLayer:setFrameWithFile(imageFile:getData(), configFile:getData());
	end--]]
	
    editBgLayer:setAnchorPoint(CCPointMake(0.5,0.5));
    editBgLayer:setPosition(CCPointMake(width/2,height*0.65));
	editBgLayer:setContentSize(CCSizeMake(editBoxWidth,editBoxHeight))
	m_wnd:addChild(editBgLayer)
	local contentEditLabel = SCTextBox:boxWithWidthHeightFont(editBoxWidth*0.95,editBoxHeight*0.75,getDefaultFontName(), getFontSize(12))
	contentEditLabel:setTag(801401)
	contentEditLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    contentEditLabel:setPosition(CCPointMake(width/2,height*0.65));
    contentEditLabel:setInputEnabled(true)--设置成可输入
    contentEditLabel:setMaxCharCount(100)
    contentEditLabel:luaSetSelectorOnBeginInput(contentEditTouchAction2)
    contentEditLabel:luaSetSelectorOnEndInput(contentEditTouchEndAction2)
    contentEditLabel:luaSetSelectorOnInsertText(insertTitleText);
    if detailMsg then
        contentEditLabel:setText(detailMsg)
    end
    m_wnd:addChild(contentEditLabel)
    
    
    --介绍标题
	local titleLabel = SCLabel:labelWithStringFont(_LTParser("str8088"),getDefaultFontName(), getFontSize(14))
    titleLabel:setAnchorPoint(CCPointMake(0,0));
    titleLabel:setPosition(CCPointMake(SX(35),height*0.44));
    m_wnd:addChild(titleLabel)
    --公会介绍输入框
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
	--[[imageFile = getRealUIResourcePath("kernal/Tip2.pn")
	configFile = getRealUIResourcePath("kernal/Tip2.ini")
	if imageFile and configFile then
		editBgLayer:setFrameWithFile(imageFile:getData(), configFile:getData());
	end--]]
    editBgLayer:setAnchorPoint(CCPointMake(0.5,0.5));
    editBgLayer:setPosition(CCPointMake(width/2,height*0.3));
	editBgLayer:setContentSize(CCSizeMake(editBoxWidth,editBoxHeight))
	m_wnd:addChild(editBgLayer)
	local contentEditLabel = SCTextBox:boxWithWidthHeightFont(editBoxWidth*0.95,editBoxHeight*0.75,getDefaultFontName(), getFontSize(12))
	contentEditLabel:setTag(801402)
	contentEditLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    contentEditLabel:setPosition(CCPointMake(width/2,height*0.3));
    contentEditLabel:setInputEnabled(true)--设置成可输入
    contentEditLabel:setMaxCharCount(100)
    contentEditLabel:luaSetSelectorOnBeginInput(contentEditTouchAction2)
    contentEditLabel:luaSetSelectorOnEndInput(contentEditTouchEndAction2)
    contentEditLabel:luaSetSelectorOnInsertText(insertTitleText);
    if detailMsg2 then
        contentEditLabel:setText(detailMsg2)
    end
    m_wnd:addChild(contentEditLabel)
    
    --确定
    local okButton = SCButton:button()
    local imageFile1 = getRealUIResourcePath("kernal/multi-page-large-other.png")
    local imageFile2 = getRealUIResourcePath("kernal/multi-page-large-current.png")
    local imageFile3 = getRealUIResourcePath("img/new00381.png")
    if imageFile1 and imageFile2 and imageFile3 then
        okButton:setBackgroundImage(imageFile1:getData());
        okButton:setSelectedImage(imageFile2:getData());
        okButton:setTitle(imageFile3:getData());
    end
    okButton:setAnchorPoint(CCPointMake(0.5,0.5));
    okButton:setPosition(CCPointMake(width/2,SY(30)));
    okButton:luaSetSelectorOnClicked(okButtonAction)
    m_wnd:addChild(okButton)
    
    m_initPoint = CCPoint(getScreenWidth()/2,m_wnd:getPosition().y)
end