--定义一个与文件名相同的table
SoulJade6 = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------
local ENUE_ITEM_SOUL_ATTR_INFO = 1         --//魂玉属性 打开洗炼界面和刷新 
local ENUE_ITEM_SOUL_ACTIVATE_ATTR = 2     --//激活魂玉属性 
local ENUE_ITEM_SOUL_CHANGE_ATTR = 3       --//魂玉洗练 
local ENUE_ITEM_SOUL_DECOMPOSE = 4         --//魂玉分解 
local ENUE_ITEM_SOUL_DECOMPOSE_INFO=5      --//神玉数量
local ENUE_ITEM_SOUL_SAVE_ATTR = 6   --------保存属性
local ENUE_ITEM_SOUL_CANCEL = 7   --------取消属性
local ENUE_ITEM_SOUL_MORE_CHANGE_ATTR = 8   --------批量洗练
local m_send_idItem = 0       ---物品ID

local PRIMARY_SOULJADE = 1901000000
local INTERMEDIATE_SOULJADE = 1902000000
local ADVANCED_SOULJADE = 1903000000
local UPPER_SOULJADE = 1904000000
----------------变量定义区----------------
local m_nIndex1 = 1   -----------是否锁定标志
local m_nIndex2 = 1
local m_nIndex3 = 1
local m_nIndex4 = 1
local m_dranode_f = nil 
local m_lock_num = 0  ---------锁定条数
local m_flage_wash = 0  -------洗练方式
local m_read_mark = 0  ---------读取锁定标志
--变量的定义
----------------UI控制器区----------------
function SoulJade6.initControl()
	local pWindow4203 = SCWindow:window()
	if pWindow4203 then
		pWindow4203:setTag(12001)
		pWindow4203:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4203:setPosition(AUTO_POS(0.00, 0.00))pWindow4203:setContentSize(AUTO_SIZE(480, 320))
		pWindow4203:luaSetSelectorOnClose(SoulJade6.releaseControl)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(164.00, 173.00))
		pDragNode2:setContentSize(AUTO_SIZE(80, 80))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTypeLine)
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	SoulJade6.m_backImg = nil
	if imgPath then
		SoulJade6.m_backImg = SCImage:imageWithFile(imgPath:getData())
		if SoulJade6.m_backImg then
			SoulJade6.m_backImg:setTag(3)
			SoulJade6.m_backImg:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade6.m_backImg:setPosition(AUTO_POS(181.00, 193.00))
		end
	end

	SoulJade6.m_backNode = SCDragNode:node()
	if SoulJade6.m_backNode then
		SoulJade6.m_backNode:setTag(18)
		SoulJade6.m_backNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade6.m_backNode:setPosition(AUTO_POS(0.00, 0.00))
		SoulJade6.m_backNode:setContentSize(AUTO_SIZE(480, 320))
		SoulJade6.m_backNode:setFrameVisibled(true)
		SoulJade6.m_backNode:setDragEnabled(false)
		SoulJade6.m_backNode:setFrameType(EnumFrameTypeListNormal)
	end

	local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(30.00, 20.00))
		pDragNode1:setContentSize(AUTO_SIZE(420, 271))
		pDragNode1:setFrameVisibled(true)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTyperedwindowstip)
	end

	local imgPath = getRealUIResourcePath("kernal/redtop.png")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(ANCHOR_CENTER)
			pImage4:setPosition(AUTO_POS(202.00, 261.00))
		end
	end

	local pLable5 = SCLabel:labelWithStringFont(L("str3102"), DEFAULT_FONT_NAME, F(15))
	if pLable5 then
		pLable5:setTag(5)
		pLable5:setAnchorPoint(ANCHOR_CENTER)
		pLable5:setPosition(AUTO_POS(201.00, 260.50))
		pLable5:setColor(ccc4(255,128,0,255))
	end

	SoulJade6.m_closeBtn = SCButton:button(EnumBtnTypeNormalImg)
	if SoulJade6.m_closeBtn then
		SoulJade6.m_closeBtn:setTag(6)
		SoulJade6.m_closeBtn:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade6.m_closeBtn:setPosition(AUTO_POS(400.00, 251.00))
		SoulJade6.m_closeBtn:setContentSize(AUTO_SIZE(20, 20))
		local imgPath = getRealUIResourcePath("img/new00123.png")
		if imgPath then
			SoulJade6.m_closeBtn:setTitle(imgPath:getData())
		end
	end

	local pDragNode7 = SCDragNode:node()
	if pDragNode7 then
		pDragNode7:setTag(7)
		pDragNode7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode7:setPosition(AUTO_POS(45.00, 141.00))
		pDragNode7:setContentSize(AUTO_SIZE(179, 34))
		pDragNode7:setFrameVisibled(true)
		pDragNode7:setDragEnabled(false)
		pDragNode7:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode8 = SCDragNode:node()
	if pDragNode8 then
		pDragNode8:setTag(8)
		pDragNode8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode8:setPosition(AUTO_POS(45.00, 109.00))
		pDragNode8:setContentSize(AUTO_SIZE(179, 34))
		pDragNode8:setFrameVisibled(true)
		pDragNode8:setDragEnabled(false)
		pDragNode8:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode9 = SCDragNode:node()
	if pDragNode9 then
		pDragNode9:setTag(9)
		pDragNode9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode9:setPosition(AUTO_POS(45.00, 77.00))
		pDragNode9:setContentSize(AUTO_SIZE(179, 34))
		pDragNode9:setFrameVisibled(true)
		pDragNode9:setDragEnabled(false)
		pDragNode9:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode10 = SCDragNode:node()
	if pDragNode10 then
		pDragNode10:setTag(10)
		pDragNode10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10:setPosition(AUTO_POS(45.00, 45.00))
		pDragNode10:setContentSize(AUTO_SIZE(179, 34))
		pDragNode10:setFrameVisibled(true)
		pDragNode10:setDragEnabled(false)
		pDragNode10:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode11 = SCDragNode:node()
	if pDragNode11 then
		pDragNode11:setTag(11)
		pDragNode11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode11:setPosition(AUTO_POS(225.00, 141.00))
		pDragNode11:setContentSize(AUTO_SIZE(179, 34))
		pDragNode11:setFrameVisibled(true)
		pDragNode11:setDragEnabled(false)
		pDragNode11:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode12 = SCDragNode:node()
	if pDragNode12 then
		pDragNode12:setTag(12)
		pDragNode12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode12:setPosition(AUTO_POS(225.00, 109.00))
		pDragNode12:setContentSize(AUTO_SIZE(179, 34))
		pDragNode12:setFrameVisibled(true)
		pDragNode12:setDragEnabled(false)
		pDragNode12:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode13 = SCDragNode:node()
	if pDragNode13 then
		pDragNode13:setTag(13)
		pDragNode13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode13:setPosition(AUTO_POS(225.00, 77.00))
		pDragNode13:setContentSize(AUTO_SIZE(179, 34))
		pDragNode13:setFrameVisibled(true)
		pDragNode13:setDragEnabled(false)
		pDragNode13:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode14 = SCDragNode:node()
	if pDragNode14 then
		pDragNode14:setTag(14)
		pDragNode14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode14:setPosition(AUTO_POS(225.00, 45.00))
		pDragNode14:setContentSize(AUTO_SIZE(179, 34))
		pDragNode14:setFrameVisibled(true)
		pDragNode14:setDragEnabled(false)
		pDragNode14:setFrameType(EnumFrameTypeRound)
	end

	local pLable15 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable15 then
		pLable15:setTag(15)
		pLable15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable15:setPosition(AUTO_POS(30.23, 32))
		pLable15:setColor(ccc4(255,255,255,255))
	end

	local pButton16 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton16 then
		pButton16:setTag(16)
		pButton16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton16:setPosition(AUTO_POS(37.00, 5.00))
		pButton16:setContentSize(AUTO_SIZE(60, 26))
		pButton16:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton17 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton17 then
		pButton17:setTag(17)
		pButton17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton17:setPosition(AUTO_POS(137.00, 5.00))
		pButton17:setContentSize(AUTO_SIZE(60, 26))
		pButton17:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton19 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton19 then
		pButton19:setTag(19)
		pButton19:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton19:setPosition(AUTO_POS(316.00, 6.00))
		pButton19:setContentSize(AUTO_SIZE(70, 26))
		pButton19:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
	end

	local pLable20 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable20 then
		pLable20:setTag(20)
		pLable20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable20:setPosition(AUTO_POS(70.00, 11.00))
		pLable20:setColor(ccc4(255,255,255,255))
	end

	local pLable21 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable21 then
		pLable21:setTag(21)
		pLable21:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable21:setPosition(AUTO_POS(70.00, 11.00))
		pLable21:setColor(ccc4(255,255,255,255))
	end

	local pLable22 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable22 then
		pLable22:setTag(22)
		pLable22:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable22:setPosition(AUTO_POS(70.00, 10.13))
		pLable22:setColor(ccc4(255,255,255,255))
	end

	local pLable23 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable23 then
		pLable23:setTag(23)
		pLable23:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable23:setPosition(AUTO_POS(70.00, 11.19))
		pLable23:setColor(ccc4(255,255,255,255))
	end

	local pLable24 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable24 then
		pLable24:setTag(24)
		pLable24:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable24:setPosition(AUTO_POS(70.21, 11.22))
		pLable24:setColor(ccc4(255,255,255,255))
	end

	local pLable25 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable25 then
		pLable25:setTag(25)
		pLable25:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable25:setPosition(AUTO_POS(70.00, 11.00))
		pLable25:setColor(ccc4(255,255,255,255))
	end

	local pLable26 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable26 then
		pLable26:setTag(26)
		pLable26:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable26:setPosition(AUTO_POS(70.00, 11.26))
		pLable26:setColor(ccc4(255,255,255,255))
	end

	local pLable27 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable27 then
		pLable27:setTag(27)
		pLable27:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable27:setPosition(AUTO_POS(70.00, 11.19))
		pLable27:setColor(ccc4(255,255,255,255))
	end

	local pLable28 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable28 then
		pLable28:setTag(28)
		pLable28:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable28:setPosition(AUTO_POS(178.00, 178.00))
		pLable28:setColor(ccc4(255,255,255,255))
	end

	local pLable29 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable29 then
		pLable29:setTag(29)
		pLable29:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable29:setPosition(AUTO_POS(80.00, 178.00))
		pLable29:setColor(ccc4(255,255,255,255))
	end

	local pLable30 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable30 then
		pLable30:setTag(30)
		pLable30:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable30:setPosition(AUTO_POS(290.00, 177.00))
		pLable30:setColor(ccc4(255,255,255,255))
	end

	if pDragNode2 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if SoulJade6.m_backImg and pDragNode1 then
		pDragNode1:addChild(tolua.cast(SoulJade6.m_backImg, "SCNode"))
	end
	if SoulJade6.m_backNode and pWindow4203 then
		pWindow4203:addChild(tolua.cast(SoulJade6.m_backNode, "SCNode"))
	end
	if pDragNode1 and SoulJade6.m_backNode then
		SoulJade6.m_backNode:addChild(tolua.cast(pDragNode1, "SCNode"))
	end
	if pImage4 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pImage4, "SCNode"))
	end
	if pLable5 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable5, "SCNode"))
	end
	if SoulJade6.m_closeBtn and pDragNode1 then
		pDragNode1:addChild(tolua.cast(SoulJade6.m_closeBtn, "SCNode"))
	end
	if pDragNode7 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode7, "SCNode"))
	end
	if pDragNode8 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode8, "SCNode"))
	end
	if pDragNode9 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode9, "SCNode"))
	end
	if pDragNode10 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode10, "SCNode"))
	end
	if pDragNode11 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode11, "SCNode"))
	end
	if pDragNode12 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode12, "SCNode"))
	end
	if pDragNode13 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode13, "SCNode"))
	end
	if pDragNode14 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode14, "SCNode"))
	end
	if pLable15 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable15, "SCNode"))
	end
	if pButton16 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton16, "SCNode"))
	end
	if pButton17 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton17, "SCNode"))
	end
	if pButton19 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton19, "SCNode"))
	end
	if pLable20 and pDragNode7 then
		pDragNode7:addChild(tolua.cast(pLable20, "SCNode"))
	end
	if pLable21 and pDragNode8 then
		pDragNode8:addChild(tolua.cast(pLable21, "SCNode"))
	end
	if pLable22 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable22, "SCNode"))
	end
	if pLable23 and pDragNode10 then
		pDragNode10:addChild(tolua.cast(pLable23, "SCNode"))
	end
	if pLable24 and pDragNode11 then
		pDragNode11:addChild(tolua.cast(pLable24, "SCNode"))
	end
	if pLable25 and pDragNode12 then
		pDragNode12:addChild(tolua.cast(pLable25, "SCNode"))
	end
	if pLable26 and pDragNode13 then
		pDragNode13:addChild(tolua.cast(pLable26, "SCNode"))
	end
	if pLable27 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pLable27, "SCNode"))
	end
	if pLable28 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable28, "SCNode"))
	end
	if pLable29 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable29, "SCNode"))
	end
	if pLable30 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable30, "SCNode"))
	end
	return pWindow4203
end
function SoulJade6.releaseControl()
	--m_send_idItem = nil 
	SoulJade6.m_backImg = nil
	SoulJade6.m_backNode = nil
	SoulJade6.m_closeBtn = nil
	if SoulJade6.wndClose then
		SoulJade6.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
function souljade6_close_wnd()
	local wndCtrl = getCurentSceneWindowController(12001);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end
end 
function souljade6_close_wnd1(tag)
	if tag == 1 then
		local wndCtrl = getCurentSceneWindowController(12001);
		if wndCtrl then
			removeWindowCtrl(wndCtrl);
		end
	else
		return 
	end
end 
local function soul6_choose_close()
	luashowConfirmationWindow(L("str21095"), WIN_YES_NO, souljade6_close_wnd1)
end 
local function soul6_choose_close1()
	luashowConfirmationWindow(L("str21096"), WIN_YES_NO, souljade6_close_wnd1)
end 
--发送魂玉洗练
local function SoulJade6_sendWash()
	
	m_lock_num = m_nIndex1+m_nIndex2+m_nIndex3+m_nIndex4
	if m_lock_num == 0 then
		showMessage(L("str3101"))
	else
		m_flage_wash = 0
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
		if dataStream then
			dataStream:writeShort(ENUE_ITEM_SOUL_CHANGE_ATTR)
			dataStream:writeByte(0)
			dataStream:writeInt(m_send_idItem)
			dataStream:writeInt(m_nIndex1)
			dataStream:writeInt(m_nIndex2)
			dataStream:writeInt(m_nIndex3)
			dataStream:writeInt(m_nIndex4)
			dataStream:writeInt(m_flage_wash)
			SCDataTransThread:getSingleton():transData(dataStream)
			SCActivityIndicator:getSingleton():show();
		end
	end
end
--元宝洗练
local function SoulJade6_sendWashemoney()
	m_lock_num = m_nIndex1+m_nIndex2+m_nIndex3+m_nIndex4
	if m_lock_num == 0 then
		showMessage(L("str3101"))
	else
		m_flage_wash = 1
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
		if dataStream then
			dataStream:writeShort(ENUE_ITEM_SOUL_CHANGE_ATTR)
			dataStream:writeByte(0)
			dataStream:writeInt(m_send_idItem)
			dataStream:writeInt(m_nIndex1)
			dataStream:writeInt(m_nIndex2)
			dataStream:writeInt(m_nIndex3)
			dataStream:writeInt(m_nIndex4)
			dataStream:writeInt(m_flage_wash)
			SCDataTransThread:getSingleton():transData(dataStream)
			SCActivityIndicator:getSingleton():show();
		end
	end 
end
---继续洗练-----------
local function SoulJade6_sendWashcontinue()
	m_lock_num = m_nIndex1+m_nIndex2+m_nIndex3+m_nIndex4
	if m_lock_num == 0 then
		showMessage(L("str3101"))
	else
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
		if dataStream then
			dataStream:writeShort(ENUE_ITEM_SOUL_CHANGE_ATTR)
			dataStream:writeByte(0)
			dataStream:writeInt(m_send_idItem)
			dataStream:writeInt(m_nIndex1)
			dataStream:writeInt(m_nIndex2)
			dataStream:writeInt(m_nIndex3)
			dataStream:writeInt(m_nIndex4)
			dataStream:writeInt(m_flage_wash)
			SCDataTransThread:getSingleton():transData(dataStream)
			SCActivityIndicator:getSingleton():show();
		end
	end 
end

--提示
local function onChooseIsTouchBtnClick(tag)
	showMessage(L("str9263"));
end

--------保存属性-----------
local function choose_seve()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
    dataStream:writeShort(ENUE_ITEM_SOUL_SAVE_ATTR);
    dataStream:writeInt(m_send_idItem)
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end 
-------继续洗练-----------
local function choose_del()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
    dataStream:writeShort(ENUE_ITEM_SOUL_CANCEL);
    dataStream:writeInt(m_send_idItem)
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end 
------------锁定按钮---------------
local function choose_lock(tag)
	if tag == 200 then
		local m_lock1 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-80-160",m_dranode_f));
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-80-120",m_dranode_f));
        if m_lock1 and label then
            if 0 == m_nIndex4 then
                m_nIndex4 = 1
                m_lock1:setVisible(false)
                label:setVisible(false)
            elseif 1 == m_nIndex4 then
                m_nIndex4 = 0
                m_lock1:setVisible(true)
                label:setVisible(true)
            end
        end
	elseif tag == 150 then
		local m_lock1 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-60-120",m_dranode_f));
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-60-90",m_dranode_f));
        if m_lock1 and label then
            if 0 == m_nIndex3 then
                m_nIndex3 = 1
                m_lock1:setVisible(false)
                label:setVisible(false)
            elseif 1 == m_nIndex3 then
                m_nIndex3 = 0
                m_lock1:setVisible(true)
                label:setVisible(true)
            end
        end
	elseif tag == 100 then
		local m_lock1 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-40-80",m_dranode_f));
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-40-60",m_dranode_f));
        if m_lock1 and label then
            if 0 == m_nIndex2 then
                m_nIndex2 = 1
                m_lock1:setVisible(false)
                label:setVisible(false)
            elseif 1 == m_nIndex2 then
                m_nIndex2 = 0
                m_lock1:setVisible(true)
                label:setVisible(true)
            end
        end
	elseif tag == 50 then
		local m_lock1 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-20-40",m_dranode_f));
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-20-30",m_dranode_f));
        if m_lock1 and label then
            if 0 == m_nIndex1 then
                m_nIndex1 = 1
                m_lock1:setVisible(false)
                label:setVisible(false)
            elseif 1 == m_nIndex1 then
                m_nIndex1 = 0
                m_lock1:setVisible(true)
                label:setVisible(true)
            end
        end
	end 
	
end

--设置点击
local function setChooseIsTouchTure(count)
	if count == nil then
		return
	end
	
	local wndCtrl = getCurentSceneWindowController(12001);
	if wndCtrl == nil then
		return
	end
	
	local wnd = wndCtrl:getWindow();
	if wnd == nil then
		return
	end
	
	for i=0, count do
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("18-1-"..(20*i).."-"..(50*i), wnd))
		if btn then
			btn:luaSetSelectorOnClicked(choose_lock)
		end
	end
end

-------界面数据加载-----------
local function refreshsouljade6(tmp,backNode)
	--------初始-------------
	local backNode2 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", backNode));
	if backNode2 then
		backNode2:removeChildByTag(8885,true)
		local pButton17 = SCButton:button(1)
		if pButton17 then
			pButton17:setTag(8885)
			pButton17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pButton17:setPosition(AUTO_POS(242.00, 5))
			pButton17:setContentSize(AUTO_SIZE(60, 25))
			pButton17:setTitle(L("str0117"), DEFAULT_FONT_NAME, F(15))
			pButton17:luaSetSelectorOnClicked(soul6_choose_close)
			backNode2:addChild(pButton17)
		end
		--backNode2:setFrameVisibled(false)
		backNode2:setBackgroundColor(ccc4(0,0,0,180))
	end
	local m_btn1 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-6", backNode));
	if m_btn1 then
		m_btn1:luaSetSelectorOnClicked(souljade6_close_wnd)
	end 
	local label1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-29", backNode));
	local label2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-30", backNode));
	if label1 and label2  then
		label1:setText(L("str21051"))
		label2:setText(L("str21052"))
	end 
	for i= 0, 7 do
		local j = 7+i
		local label3 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-"..j.."-2"..i, backNode));
		if label3 then
			label3:removeAllChildrenWithCleanup(true);
			label3:setText(L("str3095"))
		end 
	end 
	local label4 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-15", backNode));
	if label4 then
		label4:setText(L("str21055"))
		label4:setColor(ccc4(255,255,32,255))
	end
	
	local imgPath = getRealUIResourcePath("img/new00544.png")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setScaleX(1.6)
			pImage4:setScaleY(1.4)
			pImage4:setAnchorPoint(ANCHOR_CENTER)
			pImage4:setPosition(AUTO_POS(370, 37))
			pImage4:setVisible(false)
			backNode2:addChild(pImage4)
		end
	end
	local str = "5"..L("str0015")
	local pLable21 = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(6))
	if pLable21 and pImage4 then
		pLable21:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable21:setColor(ccc4(255,255,255,255))
		pLable21:setPosition(AUTO_POS(2, 8))
		pLable21:setVisible(false)
		pImage4:addChild(pLable21)
	end
	---------------------
	----------开启设定-----------
	if 1 == tmp.ucAmount then
		local m_btn2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-222", backNode));
		if m_btn2 then
			m_btn2:setVisible(true)
		end
	elseif 2 == tmp.ucAmount then
		local m_btn2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-222", backNode));
		local m_btn3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-223", backNode));
		if m_btn3 and m_btn2 then
			m_btn2:setVisible(false)
			m_btn3:setVisible(true)
		end
	elseif 3 == tmp.ucAmount then
		local m_btn3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-223", backNode));
		if m_btn3 then
			m_btn3:setVisible(false)
		end
	elseif 4 == tmp.ucAmount  then
		local m_btn4 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-224", backNode));
		if m_btn4 then
			m_btn4:setVisible(false)
		end
	end
	if ADVANCED_SOULJADE <= tmp.idItemtype and UPPER_SOULJADE >= tmp.idItemtype then
		local m_btn4 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-224", backNode));
		if 3 == tmp.ucAmount and m_btn4 then
			m_btn4:setVisible(true)
		end
	end
	
	
	
	--------------
	m_send_idItem = tmp.idItem
	local item = ItemProcessor:getSingleton():getItemByTypeID(tmp.idItemtype)
	if item then
		local image = SoulJade.newSoulJadeImg(item,2)
		local pimage1 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-3", backNode));
		if pimage1 and image then
			image:setAnchorPoint(CCPointMake(0.5, 0.5));
            image:setPosition(CCPointMake(pimage1:getContentSize().width/2, pimage1:getContentSize().height/2));
            image:setTag(item:getID());
			pimage1:addChild(image)
		end 
	end 
	local type = 0;
	if tmp.idItemtype then
        if PRIMARY_SOULJADE <= tmp.idItemtype and INTERMEDIATE_SOULJADE > tmp.idItemtype then
            type = tmp.idItemtype - PRIMARY_SOULJADE
        elseif INTERMEDIATE_SOULJADE <= tmp.idItemtype and ADVANCED_SOULJADE > tmp.idItemtype then
            type = tmp.idItemtype - INTERMEDIATE_SOULJADE
        elseif ADVANCED_SOULJADE <= tmp.idItemtype and UPPER_SOULJADE >= tmp.idItemtype then
            type = tmp.idItemtype - ADVANCED_SOULJADE
        end
    end
	local nIndex1 = 0;
	local nIndex2 = 0;
	local nIndex3 = 0;
	local nIndex4 = 0;
	nIndex1,nIndex2,nIndex3,nIndex4 = soulJade_send_mark()
	local lock = nil 
	if nIndex1 and nIndex2 and nIndex3 and nIndex4 then
		lock = {nIndex1,nIndex2,nIndex3,nIndex4}
		m_nIndex1 = nIndex1
		m_nIndex2 = nIndex2
		m_nIndex3 = nIndex3
		m_nIndex4 = nIndex4
	end 
    local droNode_back = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", backNode));
	for i= 1, tmp.ucAmount do 
		local str = nil 
		str = SoulJade5_analysisSoulJade(tmp.stSoul[i].nAttrType,tmp.stSoul[i].nAttrData,type)
		str = str.."("..tmp.stSoul[i].nAttrDataMin.."-"..tmp.stSoul[i].nAttrDataMax..")"
		local text = getItemTextNode(str);
		local j =6+i;
		local k = 19+i;
		if tmp.stSoul[i].nAttrDataMax ~= 0 then
			local droNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-"..j, backNode));
			local plabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-"..j.."-"..k, backNode));
			if droNode and plabel then
				text:setAnchorPoint(CCPointMake(0.5, 0.5));
				text:setPosition(CCPointMake(plabel:getContentSize().width / 2, plabel:getContentSize().height / 2));
				plabel:setText(" ")
				plabel:removeAllChildrenWithCleanup(true);
				plabel:addChild(text)
				plabel:setAnchorPoint(CCPointMake(0.5, 0.5));
				plabel:setPosition(CCPointMake(droNode:getContentSize().width / 2, droNode:getContentSize().height / 2));
			end 
		end 
		droNode_back:removeChildByTag(20*i,true)
		-------------锁定按钮----------------
		local pDragNode9 = SCDragNode:node()
		if pDragNode9 then
			pDragNode9:setTag(20*i)
			pDragNode9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pDragNode9:setPosition(AUTO_POS(15, 179-i*32.5))
			pDragNode9:setContentSize(AUTO_SIZE(25, 25))
			pDragNode9:setFrameVisibled(true)
			pDragNode9:setDragEnabled(false)
			pDragNode9:setFrameType(EnumFrameTypeListNormal)
		end
		
		local pLable13 = SCLabel:labelWithStringFont(L("str3094"), DEFAULT_FONT_NAME, F(12))
		if pLable13 then
			pLable13:setTag(30*i)
			pLable13:setAnchorPoint(CCPointMake(0.5, 0.5));           -----居中表现
			pLable13:setPosition(pDragNode9:getContentSize().width/2, pDragNode9:getContentSize().height/2)
			pLable13:setColor(ccc4(255,128,0,255))
			if lock[i] == 1 then
				pLable13:setVisible(false)
			end 
		end
		local imgPath = getRealUIResourcePath("img/new00148.png")
		local lock1_img = nil
		if imgPath then
			lock1_img = SCImage:imageWithFile(imgPath:getData())
			if lock1_img then
				lock1_img:setTag(40*i)
				lock1_img:setAnchorPoint(CCPointMake(0.5, 0.5));           -----居中表现
				lock1_img:setPosition(pDragNode9:getContentSize().width/2, pDragNode9:getContentSize().height/2)
				if lock[i] == 1 then
					lock1_img:setVisible(false)
				end
			end
		end
		local lock_Btn = SCButton:button(EnumBtnTypeNormalImg)
		if lock_Btn then
			lock_Btn:setTag(50*i)
			lock_Btn:setAnchorPoint(CCPointMake(0.5, 0.5));           -----居中表现
			lock_Btn:setPosition(pDragNode9:getContentSize().width/2, pDragNode9:getContentSize().height/2)
			lock_Btn:setContentSize(AUTO_SIZE(80, 20))
			lock_Btn:luaSetSelectorOnClicked(onChooseIsTouchBtnClick)
		end
		droNode_back:addChild(pDragNode9)
		m_dranode_f = backNode;
		pDragNode9:addChild(pLable13)
		pDragNode9:addChild(lock1_img)
		pDragNode9:addChild(lock_Btn)
		
	end 
	for i= 1, tmp.ucNewAmount do 
		local str = nil 
		str = SoulJade5_analysisSoulJade(tmp.stnewSoul[i].nAttrType,tmp.stnewSoul[i].nAttrData,type)
		str = str.."("..tmp.stnewSoul[i].nAttrDataMin.."-"..tmp.stnewSoul[i].nAttrDataMax..")"
		local text = getItemTextNode(str);
		local j =10+i;
		local k = 23+i;
		if tmp.stnewSoul[i].nAttrDataMax ~= 0 then
			local droNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-"..j, backNode));
			local plabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-"..j.."-"..k, backNode));
			if droNode and plabel then
				text:setAnchorPoint(CCPointMake(0.5, 0.5));
				text:setPosition(CCPointMake(plabel:getContentSize().width / 2, plabel:getContentSize().height / 2));
				plabel:setText(" ")
				plabel:removeAllChildrenWithCleanup(true);
				plabel:addChild(text)
				plabel:setAnchorPoint(CCPointMake(0.5, 0.5));
				plabel:setPosition(CCPointMake(droNode:getContentSize().width / 2, droNode:getContentSize().height / 2));
			end 
		end 
	end 
	if tmp.ucNewAmount ~= 0   then
		if tmp.stnewSoul[2].nAttrDataMax == 0 then
			local m_lock1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-80",m_dranode_f));
			if m_lock1   then
				m_lock1:setVisible(false)
			end
			local m_lock1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-60",m_dranode_f));
			if m_lock1   then
				m_lock1:setVisible(false)
			end
			local m_lock1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-40",m_dranode_f));
			if m_lock1  then
				m_lock1:setVisible(false)
			end
		elseif  tmp.stnewSoul[3].nAttrDataMax == 0   then
			local m_lock1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-80",m_dranode_f));
			if m_lock1   then
				m_lock1:setVisible(false)
			end
			local m_lock1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-60",m_dranode_f));
			if m_lock1   then
				m_lock1:setVisible(false)
			end
		elseif  tmp.stnewSoul[4].nAttrDataMax == 0 then
			local m_lock1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-80",m_dranode_f));
			if m_lock1  then
				m_lock1:setVisible(false)
			end
		end 
	end
	if tmp.ucAmount ~= 0   then
		if tmp.ucAmount == 2 then
				m_nIndex3 = 0
				m_nIndex4 = 0
		elseif  tmp.ucAmount == 3   then
			m_nIndex4 = 0
		elseif  tmp.ucAmount == 1   then
			m_nIndex2 = 0
			m_nIndex3 = 0
			m_nIndex4 = 0
		end 
	end
	
	----合并第一界面---------------
	if  tmp.ucNewAmount == 0 then
		local m_btn1 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-16", backNode));
		local m_btn2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-17", backNode));
		local m_btn3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-19", backNode));
		if m_btn1 and m_btn2 and m_btn3 then
			m_btn1:setTitle(L("str3099"),DEFAULT_FONT_NAME, F(13))
			m_btn1:setContentSize(AUTO_SIZE(90, 25))
			m_btn1:setButtonType(1)
			m_btn1:luaSetSelectorOnClicked(SoulJade6_sendWash)
			m_btn2:setTitle(L("str3098"),DEFAULT_FONT_NAME, F(13))
			m_btn2:setContentSize(AUTO_SIZE(80, 25))
			m_btn2:setButtonType(1)
			m_btn2:luaSetSelectorOnClicked(SoulJade6_sendWashemoney)
			m_btn3:setTitle(L("str21047"),DEFAULT_FONT_NAME, F(13))
			m_btn3:setContentSize(AUTO_SIZE(70, 25))
			m_btn3:setButtonType(1)
			m_btn3:setVisible(false)
			m_btn3:luaSetSelectorOnClicked(souljade6_choose_piliang)
		end 
		for i =1, tmp.ucAmount do 
		local j =10+i;
		local k = 23+i;
			local droNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-"..j, backNode));
			local plabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-"..j.."-"..k, backNode));
			if droNode and plabel then
				plabel:setText(" ")
				plabel:removeAllChildrenWithCleanup(true);
			end 
		end 
		local m_btn1 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-8885", backNode));
		if m_btn1 then
			m_btn1:luaSetSelectorOnClicked(soul6_choose_close1)
		end 
		setChooseIsTouchTure(tmp.ucAmount)
	else
		local m_btn1 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-16", backNode));
		local m_btn2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-17", backNode));
		local m_btn3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-19", backNode));
		if m_btn1 and m_btn2 and m_btn3 then
			m_btn1:setTitle(L("str21048"),DEFAULT_FONT_NAME, F(13))
			m_btn1:setContentSize(AUTO_SIZE(90, 25))
			m_btn1:setButtonType(1)
			m_btn1:luaSetSelectorOnClicked(choose_seve)
			m_btn2:setTitle(L("str21080"),DEFAULT_FONT_NAME, F(13))
			m_btn2:setContentSize(AUTO_SIZE(80, 25))
			m_btn2:setButtonType(1)
			m_btn2:luaSetSelectorOnClicked(SoulJade6_sendWashcontinue)
			m_btn3:setTitle(L("str21047"),DEFAULT_FONT_NAME, F(13))
			m_btn3:setContentSize(AUTO_SIZE(70, 25))
			m_btn3:setButtonType(1)
			m_btn3:luaSetSelectorOnClicked(souljade6_choose_piliang)
			m_btn3:setVisible(false)
		end
	end 
	return droNode_back;
end 
------批量洗练------
function souljade6_choose_piliang()
	m_lock_num = m_nIndex1+m_nIndex2+m_nIndex3+m_nIndex4
	if m_lock_num == 0 then
		showMessage(L("str3101"))
	else
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
		dataStream:writeShort(ENUE_ITEM_SOUL_MORE_CHANGE_ATTR);
		dataStream:writeByte(0)
		dataStream:writeInt(m_send_idItem)
		dataStream:writeInt(m_nIndex1)
		dataStream:writeInt(m_nIndex2)
		dataStream:writeInt(m_nIndex3)
		dataStream:writeInt(m_nIndex4)
		dataStream:writeInt(0)
		SCDataTransThread:getSingleton():transData(dataStream);
		SCActivityIndicator:getSingleton():show();
    end
end 
--发送激活魂玉消息
local function SoulJade_sendSoulJade6Activate(tag)
	local tag = tag - 221
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
	if dataStream then
		dataStream:writeShort(ENUE_ITEM_SOUL_ACTIVATE_ATTR)
		dataStream:writeByte(0)
		dataStream:writeInt(tag)
		dataStream:writeInt(m_send_idItem)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end
-------锁定标志清除---------
function souljade6_del_mark()
	m_send_idItem = nil 
	m_nIndex1 = 1
	m_nIndex2 = 1
	m_nIndex3 = 1
	m_nIndex4 = 1 
end 
------传输标志-----------
function soul6_send_mark()
	return m_nIndex1,m_nIndex2,m_nIndex3,m_nIndex4
end 
function souljade6_open(tmporwmd,num)
	if not tmporwmd then
	    return
	end
	--[[
	local backNode = nil
	m_maxJadeNum = tmp.ucAmount
	if wndCtrl then
		local wnd = wndCtrl:getWindow()
		local backNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(18));
	    refreshsouljade6(tmp,backNode)
		return;
	end
	]]
	local backNode = nil
	local wnd = nil 
	local wndCtrl = getCurentSceneWindowController(12001);
	if wndCtrl then
		wnd = wndCtrl:getWindow()
	else
		wnd = SoulJade6.initControl()
		wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl);
            wnd:setFrameVisibled(false)
            wnd:setBackButtonVisibled(false);
		    wnd:setCloseButtonVisibled(false);
		end
		-----------开启按钮设置------------------
		local backNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(18));
		local droNode_back = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", backNode));
		for i = 1,4 do 
			local btn1 = SCButton:button(EnumBtnType9Atlas)
			if btn1 then
				btn1:setTag(220+i)
				btn1:setAnchorPoint(ANCHOR_CENTER)
				btn1:setPosition(AUTO_POS(128, 190-i*32.5))
				btn1:setContentSize(AUTO_SIZE(70, 26))
				btn1:setTitle(L("str3093"), DEFAULT_FONT_NAME, F(12))
                btn1:luaSetSelectorOnClicked(SoulJade_sendSoulJade6Activate);
				btn1:setVisible(false)
				droNode_back:addChild(btn1)
			end
		end 
	end 
	if wnd then
		backNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(18));
		if  not backNode then  return end 
		if backNode then
			backNode:setFrameVisibled(false)
			backNode:setBackgroundColor(ccc4(0,0,0,180))
			--backNode:setVisible(false)
		end
	end
	if num == 1 then
		backNode:removeChildByTag(18, true);
		local droNode_back = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", backNode));
		if droNode_back then
			droNode_back:setVisible(true)
		end 
		refreshsouljade6(tmporwmd,backNode)
	elseif  num == 0  then
		local droNode_back = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", backNode));
		if  droNode_back  then
			droNode_back:setVisible(false)
		end 
		backNode:addChild(tmporwmd)
	end 
end 
----------------消息处理区----------------

----------------消息注册区----------------

----------------全局函数区----------------



--函数调用