--定义一个与文件名相同的table
SoulJade = {}
------------------消息--------------------
--[[
const unsigned short _MSG_ITEM_SOUL			=_MSG_GENERAL+623;      //魂玉
ENUE_ITEM_SOUL_ATTR_INFO=1,           //魂玉属性 打开洗炼界面和刷新 
上发:
typedef struct  
{
	OBJID idItem;
}Msg_Info1;

下发:
typedef struct
{
	int nAttrType;  // 0 未开启 属性类型 
	int nAttrData;  // 属性大小 
	int nAttrDataMin; //该属性最小值 
	int nAttrDataMax; //该属性最大值 
}stSoulAttrInfo;
typedef struct  
{
	OBJID idItem;
	OBJID idItemtype;
	UCHAR ucAmount;
	stSoulAttrInfo stSoul[5];
}tMsg_Info1;

ENUE_ITEM_SOUL_ACTIVATE_ATTR=2,       //激活魂玉属性 
typedef struct  
{
	UCHAR ucFlag; //默认 0
	int   nIndex; //激活第几个属性 0-3
	OBJID idItem;
}Msg_Info2;
下发:
刷新属性

ENUE_ITEM_SOUL_CHANGE_ATTR=3,         //魂玉洗练 
上发:
typedef struct  
{
	UCHAR ucFlag; //默认 0
	OBJID idItem;
	int   nIndex1;//第一个属性是否锁定 0锁定 1不锁定 
	int   nIndex2;
	int   nIndex3;
	int   nIndex4;
	int   nCostType;//消费类型 1元宝 0神玉
}Msg_Info3;
下发:
刷新属性

ENUE_ITEM_SOUL_DECOMPOSE=4,           //魂玉分解 
上发:
typedef struct  
{
	int nNum;
	OBJID idItemtype;
}Msg_Info5;

ENUE_ITEM_SOUL_DECOMPOSE_INFO=5,      //魂玉分解信息
typedef struct  
{
	DWORD dwData;
}tMsg_Info2;
]]--

----------------结构定义区----------------
local m_nIndex1 = 1   -----------是否锁定标志
local m_nIndex2 = 1
local m_nIndex3 = 1
local m_nIndex4 = 1
--//魂玉详细属性
local stSoulAttrInfo = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.nAttrType = dt:readInt()
        tmp.nAttrData = dt:readInt()
        tmp.nAttrDataMin = dt:readInt()
        tmp.nAttrDataMax = dt:readInt()
        return tmp
    end
}
--//魂玉属性结构
local tMsg_Info1 = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.idItem = dt:readInt()
        tmp.idItemtype = dt:readInt()
        tmp.ucAmount = dt:readByte()
        tmp.stSoul = {}
        if tmp.ucAmount < 1 then
            tmp.ucAmount = 1
        end
        for i = 1,tmp.ucAmount do
            table.insert(tmp.stSoul, stSoulAttrInfo.initWithStream(dt))
        end
        tmp.flagenum = dt:readInt()  ---------锁定标志
        if tmp.flagenum ~= 0 then
			m_nIndex1 = tmp.flagenum%10
			m_nIndex2 = math.floor(tmp.flagenum/10%10)
			m_nIndex3 = math.floor(tmp.flagenum/100%10)
			m_nIndex4 = math.floor(tmp.flagenum/1000%10)
		else
			m_nIndex1 = 1
			m_nIndex2 = 1
			m_nIndex3 = 1
			m_nIndex4 = 1
        end 
        tmp.ucNewAmount = 0
        return tmp
    end
}
--//魂玉属性结构----两边
local tMsg_Info_two = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.idItem = dt:readInt()
        tmp.idItemtype = dt:readInt()
        tmp.ucAmount = dt:readByte()
        tmp.ucNewAmount = dt:readByte()
        tmp.stSoul = {}
        if tmp.ucAmount < 1 then
            tmp.ucAmount = 1
        end
        for i = 1,tmp.ucAmount do
            table.insert(tmp.stSoul, stSoulAttrInfo.initWithStream(dt))
        end
        if tmp.ucNewAmount <1  then
			tmp.ucNewAmount = 1
        end 
        tmp.stnewSoul = {}
        for i = 1,tmp.ucNewAmount do
            table.insert(tmp.stnewSoul, stSoulAttrInfo.initWithStream(dt))
        end
        tmp.flagenum = dt:readInt()  ---------锁定标志
        if tmp.flagenum ~= 0 then
			m_nIndex1 = tmp.flagenum%10
			m_nIndex2 = math.floor(tmp.flagenum/10%10)
			m_nIndex3 = math.floor(tmp.flagenum/100%10)
			m_nIndex4 = math.floor(tmp.flagenum/1000%10)
		else
			m_nIndex1 = 1
			m_nIndex2 = 1
			m_nIndex3 = 1
			m_nIndex4 = 1
        end 
        return tmp
    end
}
local tMsg_Info1_PLdata = {
	initWithStream = function(dt)
		local tmp = {}
        if not dt then
            return tmp
        end
	
		tmp.times = dt:readInt()
        tmp.ucAmount = dt:readByte()
        if tmp.ucAmount >= 0 then
			tmp.stPLSoul = {}
			for i = 1,tmp.ucAmount do
				table.insert(tmp.stPLSoul, stSoulAttrInfo.initWithStream(dt))
			end
        end 
		return tmp

	end 

}
--//魂玉属性结构 -----批量
local tMsg_Info1_piliang = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.idItem = dt:readInt()
        tmp.idItemtype = dt:readInt()
		tmp.stSoul = {}
        for i=1, 6 do 
			table.insert(tmp.stSoul, tMsg_Info1_PLdata.initWithStream(dt))
        end 
        tmp.flagenum = dt:readInt()  ---------锁定标志
        if tmp.flagenum ~= 0 then
			m_nIndex1 = tmp.flagenum%10
			m_nIndex2 = math.floor(tmp.flagenum/10%10)
			m_nIndex3 = math.floor(tmp.flagenum/100%10)
			m_nIndex4 = math.floor(tmp.flagenum/1000%10)
        else
			m_nIndex1 = 1
			m_nIndex2 = 1
			m_nIndex3 = 1
			m_nIndex4 = 1
        end 
        
        return tmp
    end
}
--//神玉数量
local tMsg_Info2 = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.dwData = dt:readInt()
        return tmp
   end
}
----------------常量定义区----------------
local ENUE_ITEM_SOUL_ATTR_INFO = 1         --//魂玉属性 打开洗炼界面和刷新 
local ENUE_ITEM_SOUL_ACTIVATE_ATTR = 2     --//激活魂玉属性 
local ENUE_ITEM_SOUL_CHANGE_ATTR = 3       --//魂玉洗练 
local ENUE_ITEM_SOUL_DECOMPOSE = 4         --//魂玉分解 
local ENUE_ITEM_SOUL_DECOMPOSE_INFO=5      --//神玉数量
local ENUE_ITEM_SOUL_MORE_CHANGE_ATTR = 8   ----批量洗练

local ITEMACT_EQUIP			= 5 --通知装备物品(带上装备)
local ITEMACT_UNEQUIP		= 6 --position(卸载下装备)
local ITEMACT_MOVE			= 28 --// c/s, 移动物品的位置
local ITEMACT_TIDYUP        = 56
local SOULJADE_BEGINPLACE   = 550
local SOULJADE_SOUL_BEGIN = 71
local SOULJADE_SOUL_END = 76
local ITEMACT_TIDYUP_SOUL = 194 --魂玉整理
SoulJade_playSoulJadeLevel = 0
----------------变量定义区----------------
--变量的定义
local m_curPlayIndex = 0;
local m_curIdItem = nil;
----------------UI控制器区----------------
------传输标志-----------
function soulJade_send_mark()
	return m_nIndex1,m_nIndex2,m_nIndex3,m_nIndex4
end 

function SoulJade.initControl()
	local pWindow4201 = SCWindow:window()
	if pWindow4201 then
		pWindow4201:setTag(4201)
		pWindow4201:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4201:setPosition(AUTO_POS(0.00, 0.00))pWindow4201:setContentSize(AUTO_SIZE(480, 320))
		pWindow4201:luaSetSelectorOnClose(SoulJade.releaseControl)
	end

	local imgPath = getRealUIResourcePath("img/new00246.jpg")
	SoulJade.m_pImage6 = nil
	if imgPath then
		SoulJade.m_pImage6 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_pImage6 then
			SoulJade.m_pImage6:setTag(6)
			SoulJade.m_pImage6:setAnchorPoint(ANCHOR_CENTER)
			SoulJade.m_pImage6:setPosition(AUTO_POS(240.00, 160.00))
		end
	end

	local imgPath = getRealUIResourcePath("jade/new00736.png")
	local pImage1 = nil
	if imgPath then
		pImage1 = SCImage:imageWithFile(imgPath:getData())
		if pImage1 then
			pImage1:setTag(1)
			pImage1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage1:setPosition(AUTO_POS(33.00, 65.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00001.png")
	local pImage2 = nil
	if imgPath then
		pImage2 = SCImage:imageWithFile(imgPath:getData())
		if pImage2 then
			pImage2:setTag(2)
			pImage2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage2:setPosition(AUTO_POS(189.00, 290.00))
		end
	end

	SoulJade.m_name = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(13))
	if SoulJade.m_name then
		SoulJade.m_name:setTag(3)
		SoulJade.m_name:setAnchorPoint(ANCHOR_CENTER)
		SoulJade.m_name:setPosition(AUTO_POS(241.00, 300.50))
		SoulJade.m_name:setColor(ccc4(255,255,255, 543))
	end

	SoulJade.m_pDragNode1 = SCDragNode:node()
	if SoulJade.m_pDragNode1 then
		SoulJade.m_pDragNode1:setTag(4)
		SoulJade.m_pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_pDragNode1:setPosition(AUTO_POS(250.00, 35.00))
		SoulJade.m_pDragNode1:setContentSize(AUTO_SIZE(220, 255))
		SoulJade.m_pDragNode1:setFrameVisibled(true)
		SoulJade.m_pDragNode1:setDragEnabled(false)
		SoulJade.m_pDragNode1:setFrameType(EnumFrameTypeLine)
	end

	SoulJade.m_base1 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_base1 then
		SoulJade.m_base1:setTag(5)
		SoulJade.m_base1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_base1:setPosition(AUTO_POS(40.00, 6.00))
		SoulJade.m_base1:setContentSize(AUTO_SIZE(100, 30))
		local imgPath = getRealUIResourcePath("jade/new00737.png")
		if imgPath then
			SoulJade.m_base1:setTitle(imgPath:getData())
		end
	end

	SoulJade.m_base2 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_base2 then
		SoulJade.m_base2:setTag(7)
		SoulJade.m_base2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_base2:setPosition(AUTO_POS(195.00, 6.00))
		SoulJade.m_base2:setContentSize(AUTO_SIZE(100, 30))
		local imgPath = getRealUIResourcePath("jade/new00740.png")
		if imgPath then
			SoulJade.m_base2:setTitle(imgPath:getData())
		end
	end

	SoulJade.m_base3 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_base3 then
		SoulJade.m_base3:setTag(8)
		SoulJade.m_base3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_base3:setPosition(AUTO_POS(340.00, 6.00))
		SoulJade.m_base3:setContentSize(AUTO_SIZE(100, 30))
		local imgPath = getRealUIResourcePath("img/new00008.png")
		if imgPath then
			SoulJade.m_base3:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	SoulJade.m_backImg6 = nil
	if imgPath then
		SoulJade.m_backImg6 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_backImg6 then
			SoulJade.m_backImg6:setTag(116)
			SoulJade.m_backImg6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_backImg6:setPosition(AUTO_POS(30.00, 195.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	SoulJade.m_backImg5 = nil
	if imgPath then
		SoulJade.m_backImg5 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_backImg5 then
			SoulJade.m_backImg5:setTag(115)
			SoulJade.m_backImg5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_backImg5:setPosition(AUTO_POS(30.00, 105.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	SoulJade.m_backImg4 = nil
	if imgPath then
		SoulJade.m_backImg4 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_backImg4 then
			SoulJade.m_backImg4:setTag(114)
			SoulJade.m_backImg4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_backImg4:setPosition(AUTO_POS(106.00, 75.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	SoulJade.m_backImg3 = nil
	if imgPath then
		SoulJade.m_backImg3 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_backImg3 then
			SoulJade.m_backImg3:setTag(113)
			SoulJade.m_backImg3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_backImg3:setPosition(AUTO_POS(180.00, 105.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	SoulJade.m_backImg1 = nil
	if imgPath then
		SoulJade.m_backImg1 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_backImg1 then
			SoulJade.m_backImg1:setTag(111)
			SoulJade.m_backImg1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_backImg1:setPosition(AUTO_POS(106.00, 245.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00254.png")
	SoulJade.m_backImg2 = nil
	if imgPath then
		SoulJade.m_backImg2 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_backImg2 then
			SoulJade.m_backImg2:setTag(112)
			SoulJade.m_backImg2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_backImg2:setPosition(AUTO_POS(180.00, 195.00))
		end
	end

	SoulJade.m_washBtn6 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_washBtn6 then
		SoulJade.m_washBtn6:setTag(126)
		SoulJade.m_washBtn6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_washBtn6:setPosition(AUTO_POS(24.00, 170.00))
		SoulJade.m_washBtn6:setContentSize(AUTO_SIZE(60, 26))
		local imgPath = getRealUIResourcePath("jade/new00742.png")
		if imgPath then
			SoulJade.m_washBtn6:setTitle(imgPath:getData())
		end
	end

	SoulJade.m_washBtn5 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_washBtn5 then
		SoulJade.m_washBtn5:setTag(125)
		SoulJade.m_washBtn5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_washBtn5:setPosition(AUTO_POS(24.00, 80.00))
		SoulJade.m_washBtn5:setContentSize(AUTO_SIZE(60, 26))
		local imgPath = getRealUIResourcePath("jade/new00742.png")
		if imgPath then
			SoulJade.m_washBtn5:setTitle(imgPath:getData())
		end
	end

	SoulJade.m_washBtn4 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_washBtn4 then
		SoulJade.m_washBtn4:setTag(124)
		SoulJade.m_washBtn4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_washBtn4:setPosition(AUTO_POS(100.00, 50.00))
		SoulJade.m_washBtn4:setContentSize(AUTO_SIZE(60, 26))
		local imgPath = getRealUIResourcePath("jade/new00742.png")
		if imgPath then
			SoulJade.m_washBtn4:setTitle(imgPath:getData())
		end
	end

	SoulJade.m_washBtn1 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_washBtn1 then
		SoulJade.m_washBtn1:setTag(121)
		SoulJade.m_washBtn1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_washBtn1:setPosition(AUTO_POS(100.00, 220.00))
		SoulJade.m_washBtn1:setContentSize(AUTO_SIZE(60, 26))
		local imgPath = getRealUIResourcePath("jade/new00742.png")
		if imgPath then
			SoulJade.m_washBtn1:setTitle(imgPath:getData())
		end
	end

	SoulJade.m_washBtn2 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_washBtn2 then
		SoulJade.m_washBtn2:setTag(122)
		SoulJade.m_washBtn2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_washBtn2:setPosition(AUTO_POS(174.00, 170.00))
		SoulJade.m_washBtn2:setContentSize(AUTO_SIZE(60, 26))
		local imgPath = getRealUIResourcePath("jade/new00742.png")
		if imgPath then
			SoulJade.m_washBtn2:setTitle(imgPath:getData())
		end
	end

	SoulJade.m_washBtn3 = SCButton:button(EnumBtnType9Atlas)
	if SoulJade.m_washBtn3 then
		SoulJade.m_washBtn3:setTag(123)
		SoulJade.m_washBtn3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		SoulJade.m_washBtn3:setPosition(AUTO_POS(174.00, 80.00))
		SoulJade.m_washBtn3:setContentSize(AUTO_SIZE(60, 26))
		local imgPath = getRealUIResourcePath("jade/new00742.png")
		if imgPath then
			SoulJade.m_washBtn3:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	SoulJade.m_img6 = nil
	if imgPath then
		SoulJade.m_img6 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_img6 then
			SoulJade.m_img6:setTag(1160)
			SoulJade.m_img6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_img6:setPosition(AUTO_POS(1.00, 1.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	SoulJade.m_img1 = nil
	if imgPath then
		SoulJade.m_img1 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_img1 then
			SoulJade.m_img1:setTag(1110)
			SoulJade.m_img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_img1:setPosition(AUTO_POS(1.00, 1.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	SoulJade.m_img2 = nil
	if imgPath then
		SoulJade.m_img2 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_img2 then
			SoulJade.m_img2:setTag(1120)
			SoulJade.m_img2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_img2:setPosition(AUTO_POS(1.00, 1.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	SoulJade.m_img3 = nil
	if imgPath then
		SoulJade.m_img3 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_img3 then
			SoulJade.m_img3:setTag(1130)
			SoulJade.m_img3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_img3:setPosition(AUTO_POS(1.00, 1.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	SoulJade.m_img4 = nil
	if imgPath then
		SoulJade.m_img4 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_img4 then
			SoulJade.m_img4:setTag(1140)
			SoulJade.m_img4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_img4:setPosition(AUTO_POS(1.00, 1.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	SoulJade.m_img5 = nil
	if imgPath then
		SoulJade.m_img5 = SCImage:imageWithFile(imgPath:getData())
		if SoulJade.m_img5 then
			SoulJade.m_img5:setTag(1150)
			SoulJade.m_img5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			SoulJade.m_img5:setPosition(AUTO_POS(1.00, 1.00))
		end
	end

	local pButton27 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton27 then
		pButton27:setTag(27)
		pButton27:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton27:setPosition(AUTO_POS(163.00, 285.00))
		pButton27:setContentSize(AUTO_SIZE(22, 30))
		
		local pBackimg = getRealUIResourcePath("img/new00048.png")
		if pBackimg then
			pButton27:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton28 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton28 then
		pButton28:setTag(28)
		pButton28:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton28:setPosition(AUTO_POS(295.00, 285.00))
		pButton28:setContentSize(AUTO_SIZE(22, 30))
		
		local pBackimg = getRealUIResourcePath("img/new00047.png")
		if pBackimg then
			pButton28:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton16 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton16 then
		pButton16:setTag(16)
		pButton16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton16:setPosition(AUTO_POS(9.00, 9.00))
		pButton16:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton16:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton15 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton15 then
		pButton15:setTag(15)
		pButton15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton15:setPosition(AUTO_POS(9.00, 9.00))
		pButton15:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton15:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton14 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton14 then
		pButton14:setTag(14)
		pButton14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton14:setPosition(AUTO_POS(9.00, 9.00))
		pButton14:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton14:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton13 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton13 then
		pButton13:setTag(13)
		pButton13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton13:setPosition(AUTO_POS(9.00, 9.00))
		pButton13:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton13:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton11 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton11 then
		pButton11:setTag(11)
		pButton11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton11:setPosition(AUTO_POS(9.00, 9.00))
		pButton11:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton11:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton12 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton12 then
		pButton12:setTag(12)
		pButton12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton12:setPosition(AUTO_POS(9.00, 9.00))
		pButton12:setContentSize(AUTO_SIZE(28, 28))
		
		local pBackimg = getRealUIResourcePath("img/new00259.png")
		if pBackimg then
			pButton12:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton9 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton9 then
		pButton9:setTag(9)
		pButton9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton9:setPosition(AUTO_POS(362.50, 286.00))
		pButton9:setContentSize(AUTO_SIZE(80, 30))
		local pBackimg = getRealUIResourcePath("pk/new00721.pn")
		if pBackimg then
			pButton9:setTitle(pBackimg:getData())
		end
	end

	if SoulJade.m_pImage6 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_pImage6, "SCNode"))
	end
	if pImage1 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(pImage1, "SCNode"))
	end
	if pImage2 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(pImage2, "SCNode"))
	end
	if SoulJade.m_name and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_name, "SCNode"))
	end
	if SoulJade.m_pDragNode1 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_pDragNode1, "SCNode"))
	end
	if SoulJade.m_base1 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_base1, "SCNode"))
	end
	if SoulJade.m_base2 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_base2, "SCNode"))
	end
	if SoulJade.m_base3 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_base3, "SCNode"))
	end
	if SoulJade.m_backImg6 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_backImg6, "SCNode"))
	end
	if SoulJade.m_backImg5 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_backImg5, "SCNode"))
	end
	if SoulJade.m_backImg4 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_backImg4, "SCNode"))
	end
	if SoulJade.m_backImg3 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_backImg3, "SCNode"))
	end
	if SoulJade.m_backImg1 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_backImg1, "SCNode"))
	end
	if SoulJade.m_backImg2 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_backImg2, "SCNode"))
	end
	if SoulJade.m_washBtn6 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_washBtn6, "SCNode"))
	end
	if SoulJade.m_washBtn5 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_washBtn5, "SCNode"))
	end
	if SoulJade.m_washBtn4 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_washBtn4, "SCNode"))
	end
	if SoulJade.m_washBtn1 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_washBtn1, "SCNode"))
	end
	if SoulJade.m_washBtn2 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_washBtn2, "SCNode"))
	end
	if SoulJade.m_washBtn3 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(SoulJade.m_washBtn3, "SCNode"))
	end
	if SoulJade.m_img6 and SoulJade.m_backImg6 then
		SoulJade.m_backImg6:addChild(tolua.cast(SoulJade.m_img6, "SCNode"))
	end
	if SoulJade.m_img1 and SoulJade.m_backImg1 then
		SoulJade.m_backImg1:addChild(tolua.cast(SoulJade.m_img1, "SCNode"))
	end
	if SoulJade.m_img2 and SoulJade.m_backImg2 then
		SoulJade.m_backImg2:addChild(tolua.cast(SoulJade.m_img2, "SCNode"))
	end
	if SoulJade.m_img3 and SoulJade.m_backImg3 then
		SoulJade.m_backImg3:addChild(tolua.cast(SoulJade.m_img3, "SCNode"))
	end
	if SoulJade.m_img4 and SoulJade.m_backImg4 then
		SoulJade.m_backImg4:addChild(tolua.cast(SoulJade.m_img4, "SCNode"))
	end
	if SoulJade.m_img5 and SoulJade.m_backImg5 then
		SoulJade.m_backImg5:addChild(tolua.cast(SoulJade.m_img5, "SCNode"))
	end
	if pButton27 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(pButton27, "SCNode"))
	end
	if pButton28 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(pButton28, "SCNode"))
	end
	if pButton16 and SoulJade.m_img6 then
		SoulJade.m_img6:addChild(tolua.cast(pButton16, "SCNode"))
	end
	if pButton15 and SoulJade.m_img5 then
		SoulJade.m_img5:addChild(tolua.cast(pButton15, "SCNode"))
	end
	if pButton14 and SoulJade.m_img4 then
		SoulJade.m_img4:addChild(tolua.cast(pButton14, "SCNode"))
	end
	if pButton13 and SoulJade.m_img3 then
		SoulJade.m_img3:addChild(tolua.cast(pButton13, "SCNode"))
	end
	if pButton11 and SoulJade.m_img1 then
		SoulJade.m_img1:addChild(tolua.cast(pButton11, "SCNode"))
	end
	if pButton12 and SoulJade.m_img2 then
		SoulJade.m_img2:addChild(tolua.cast(pButton12, "SCNode"))
	end
	if pButton9 and pWindow4201 then
		pWindow4201:addChild(tolua.cast(pButton9, "SCNode"))
	end
	return pWindow4201
end
function SoulJade.releaseControl()
	SoulJade.m_pImage6 = nil
	SoulJade.m_name = nil
	SoulJade.m_pDragNode1 = nil
	SoulJade.m_base1 = nil
	SoulJade.m_base2 = nil
	SoulJade.m_base3 = nil
	SoulJade.m_backImg6 = nil
	SoulJade.m_backImg5 = nil
	SoulJade.m_backImg4 = nil
	SoulJade.m_backImg3 = nil
	SoulJade.m_backImg1 = nil
	SoulJade.m_backImg2 = nil
	SoulJade.m_washBtn6 = nil
	SoulJade.m_washBtn5 = nil
	SoulJade.m_washBtn4 = nil
	SoulJade.m_washBtn1 = nil
	SoulJade.m_washBtn2 = nil
	SoulJade.m_washBtn3 = nil
	SoulJade.m_img6 = nil
	SoulJade.m_img1 = nil
	SoulJade.m_img2 = nil
	SoulJade.m_img3 = nil
	SoulJade.m_img4 = nil
	SoulJade.m_img5 = nil
	if SoulJade.wndClose then
		SoulJade.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
--魂玉商城
local function onSoulJadeShopBtnClick(tag)
	SoulJade1_showSoulJadeShopWnd();
	if SoulJade1.m_pMultipage1 then
	    SoulJade1.m_pMultipage1:selectPageWithIndex(0);
	end
end
--按钮响应
local function SoulJade_eventForButton()
    --魂玉商店
    local m_base1 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4201-5"));
	if m_base1 then
	   m_base1:luaSetSelectorOnClicked(onSoulJadeShopBtnClick);
	end
	--过关斩将
	local m_base2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4201-7"));
	if m_base2 then
	   m_base2:luaSetSelectorOnClicked(Through_sendOpenWndInfo)
	end
	--整理魂玉
	local m_base3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4201-8"));
	if m_base3 then
	    m_base3:luaSetSelectorOnClicked(SoulJade.sendClearJadeBag)
	end
end
--点击装备
local function onWearBtnClick(tag)
    if m_curIdItem then
        local item = ItemProcessor:getSingleton():getItem(m_curIdItem);
        if item then
            local mark = nil
            if 1901000000 <= item:getIdType() and 1902000000 > item:getIdType() then
                mark = item:getIdType()%1901000000
            elseif 1902000000 <= item:getIdType() and 1903000000 > item:getIdType() then
                mark = item:getIdType()%1902000000
            elseif 1903000000 <= item:getIdType() and 1904000000 > item:getIdType() then
                mark = item:getIdType()%1903000000
            end
            local heroInfo = Hero:getSingleton():getHeroInfo()
            if heroInfo == nil then
                return 
            end
            local level = heroInfo.ucLevel;
            --[[if m_curPlayIndex == 0 then
            else
                local amount = Hero:getSingleton():partnerSize();
                if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
                    local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1); 
                    if partner then
                        level = partner.usLevel;
                    end
                end
            end]]
            --[[
            if 0 == mark then
                if 60 > level then
                    showMessage(_LTParser("str3103"))
                    return
                end
            elseif 1 == mark then
                if 75 > level then
                    showMessage(_LTParser("str3104"))
                    return
                end
            elseif 2 == mark then
                if 90 > level then
                    showMessage(_LTParser("str3105"))
                    return
                end
            elseif 3 == mark then
                if 105 > level then
                    showMessage(_LTParser("str3106"))
                    return
                end
            elseif 4 == mark then
                if 120 > level then
                    showMessage(_LTParser("str3107"))
                    return
                end
            elseif 5 == mark then
                if 135 > level then
                    showMessage(_LTParser("str3108"))
                    return
                end
            end
            ]]
            if SoulJade_playSoulJadeLevel >= (mark* 10)  then
                SoulJade.sendWearSoulJade(item, 0);
            else
                if 0 == mark then
                    showMessage(_LTParser("str3103"))
                elseif 1 == mark then
                    showMessage(_LTParser("str3104"))
                elseif 2 == mark then
                    showMessage(_LTParser("str3105"))
                elseif 3 == mark then
                    showMessage(_LTParser("str3106"))
                elseif 4 == mark then
                    showMessage(_LTParser("str3107"))
                elseif 5 == mark then
                    showMessage(_LTParser("str3108"))
                end
            end
        end
    end
end
--点击查看物品  装备
local function onImageBtnClick(tag)
    local tabelStr = L("str0118");
    local item = ItemProcessor:getSingleton():getItem(tag);
    if item then
        m_curIdItem = tag;
        local tip = showTipExe(item, tabelStr);
        if tip then
            tip:luaSetReturnSelector(onWearBtnClick);
        end
    end
end

--点击脱下
local function onDropBtnClick(tag)
    if m_curIdItem then
        local item = ItemProcessor:getSingleton():getItem(m_curIdItem);
        if item then
            SoulJade.sendTakeOffSoulJade(item, 0);
        end
    end
end

--点击查看物品  脱下
local function onImageBtnClick2(tag)
    local tabelStr = L("str9165");
    local item = ItemProcessor:getSingleton():getItem(tag);
    if item then
        m_curIdItem = tag;
        local tip = showTipExe(item, tabelStr);
        if tip then
            tip:luaSetReturnSelector(onDropBtnClick);
        end
    end
end
--获取节点
local function getHunterImageNode(index)
	local node = nil;
	if index == 11 then
		node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4201-111-1110"))
	elseif index == 12 then
		node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4201-112-1120"))
	elseif index == 13 then
		node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4201-113-1130"))
	elseif index == 14 then
		node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4201-114-1140"))
	elseif index == 15 then
		node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4201-115-1150"))
	elseif index == 16 then
		node = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4201-116-1160"))
	end
	

	return node;
end
--获取洗练按钮
local function getWashBtnNode(index)
	local node = nil;
	if index == 11 then
		node = SoulJade.m_washBtn1
	elseif index == 12 then
		node = SoulJade.m_washBtn2
	elseif index == 13 then
		node = SoulJade.m_washBtn3
	elseif index == 14 then
		node = SoulJade.m_washBtn4
	elseif index == 15 then
		node = SoulJade.m_washBtn5
	elseif index == 16 then
		node = SoulJade.m_washBtn6
	end
	
	return node;
end

--魂玉位置交换
local function swopDragToSoulJade(data)
    if data then
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM);
        if dataStream then
            dataStream:writeShort(ITEMACT_MOVE)
            dataStream:writeInt(data.idItem);
            dataStream:writeInt(data.idToItem);
            dataStream:writeByte(data.ucItemPos)
            dataStream:writeShort(data.usPlace1)
            dataStream:writeShort(data.usPlace2)
            SCDataTransThread:getSingleton():transData(dataStream)
            SCActivityIndicator:getSingleton():show();
        end 
    end
end
--魂玉拖拽
local function onDragToSoulJade(pos, item)
    local m_pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4201-4"));
    if m_pDragNode1 == nil then
        return
    end
    
	local tableBox = SCTypeCast:castNodeToTableBox(m_pDragNode1:getChildByTag(1));
	if tableBox == nil then
		return
	end
	
	local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
	if pTable == nil then
		return;
	end
	
	local row = math.floor(pos.y/SY(55));
	if row <= 0 then
	    row = 3;
	elseif row == 1 then
	    row = 2;
	elseif row == 2 then
	    row = 1;
	elseif row >= 3 and row <= 4 then
	    row = 0;
	end
	
	local column = math.floor(pos.x/SX(55));
	if column <= 0 then
	    column = 0;
	elseif column >= 3 and column <= 4 then
	    column = 3;
	end
	local data = nil
	local tag = row * 4 + column + 550
    local itemTarget = ItemProcessor:getSingleton():getItemByPlace(tag);
    if itemTarget then
        if item:getID() ~= itemTarget:getID() then
            data = {}
            data.idItem = item:getID();
            data.ucItemPos = item:getPostion();
            data.usPlace1 = item:getPlace();
            data.idToItem = itemTarget:getID();
            data.usPlace2 = itemTarget:getPlace();
        end
    else
        data = {}
        data.idItem = item:getID();
        data.ucItemPos = item:getPostion();
        data.usPlace1 = item:getPlace();
        data.idToItem = 0
        data.usPlace2 = tag
    end
    swopDragToSoulJade(data)
end


--拖拽捕获
local function setSelectorOnDragEnd(tag,x,y)
    local item = ItemProcessor:getSingleton():getItem(tag)
	if item == nil then
		return;
	end
	local itemPos = item:getPostion();
	local m_pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4201-4"));
	local m_pImage6 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4201-6"));
	if m_pImage6 and m_pDragNode1 then
		local size = m_pImage6:getContentSize();
		local Pos = m_pDragNode1:convertToNodeSpace(CCPointMake(x, y));
		local isInBag = CCRect:CCRectContainsPoint(CCRectMake(0, 0, size.width, size.height), Pos);
		if isInBag then
		    if itemPos == 0 then
		        onDragToSoulJade(Pos, item);
		        return;
		    else
		        onImageBtnClick2(tag)
		    end
		else
		    if itemPos ~= 0 then
		        return;
		    end
			onImageBtnClick(tag);
		end
	end
end
--填充魂玉窗口数据
local function refreshSoulJadeWnd()
    local role = Hero:getSingleton();
    local m_pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4201-4"));
    if not m_pDragNode1 or not role then
		return;
	end	
	local tableBox = SCTypeCast:castNodeToTableBox(m_pDragNode1:getChildByTag(1));
	if not tableBox then
		return;
	end
	
	local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
	if not pTable then
		return;
	end
	local equipInfo = {}
	local amount = role:partnerSize();
	local iteminfoSize = ItemProcessor:getSingleton():ItemSize();
	for i = 1, iteminfoSize do
        local item = ItemProcessor:getSingleton():getItemInfo(i - 1);
        if 1899999999 < item:getIdType() and item:getIdType() < 1999000009 then --魂玉ID段
            local postion = item:getPostion();
            local place = item:getPlace()
            if 0 == postion then    --背包中魂玉
                local tmpTag = place - SOULJADE_BEGINPLACE
                local tableCell = pTable:getChildByTag(tmpTag)
                if tableCell then
                    local dragButton = SCTypeCast:castNodeToButton(tableCell:getChildByTag(1));
                    if dragButton then
                        local dragNode = SCTypeCast:castNodeToDragNode(dragButton:getChildByTag(1));
                        if dragNode then
                            local image = SoulJade.newSoulJadeImg(item,2)
                            if image then
                                image:setAnchorPoint(CCPointMake(0.5, 0.5));
                                image:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height/2));
                                dragNode:setTag(item:getID());
                                dragNode:addChild(image);
                                --只处理点击事件
                                local eventBtn = SCButton:button();
                                if eventBtn then
                                    eventBtn:setContentSize(image:getContentSize());
                                    eventBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                                    eventBtn:setPosition(CCPointMake(image:getContentSize().width/2, image:getContentSize().height/2));
                                    eventBtn:setTag(item:getID());
                                    eventBtn:luaSetSelectorOnClicked(onImageBtnClick);
                                    image:addChild(eventBtn);
                                end
                            end
                        end
                    end
                end
            elseif postion >= SOULJADE_SOUL_BEGIN and postion <= SOULJADE_SOUL_END then                    --装备的魂玉
                if m_curPlayIndex == 0 and item:getOwnerID() == Hero:getSingleton():getID() then
                    local BgNode = getHunterImageNode(postion - SOULJADE_SOUL_BEGIN + 11);
                    local washBtn = getWashBtnNode(postion - SOULJADE_SOUL_BEGIN + 11)
                    if washBtn then
                        washBtn:setVisible(true)
                        washBtn:setTag(item:getID());
                        washBtn:luaSetSelectorOnClicked(SoulJade_sendSoulJadeOpen);
                    end
                    if BgNode then
                        local dragNode = SCDragNode:node();
                        if dragNode then
                            dragNode:setDragEnabled(true);
                            dragNode:setContentSize(BgNode:getContentSize());
                            dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                            dragNode:setPosition(CCPointMake(BgNode:getContentSize().width/2, BgNode:getContentSize().height/2));
                            dragNode:setTag(item:getID());  
                            dragNode:luaSetSelectorOnDragEnd(setSelectorOnDragEnd);
                            BgNode:addChild(dragNode); 
                            local image = SoulJade.newSoulJadeImg(item,1)
                            if image then
                                image:setAnchorPoint(CCPointMake(0.5, 0.5));
                                image:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height/2));
                                dragNode:setTag(item:getID());
                                dragNode:addChild(image);
                                --只处理点击事件
                                local eventBtn = SCButton:button();
                                if eventBtn then
                                    eventBtn:setContentSize(image:getContentSize());
                                    eventBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                                    eventBtn:setPosition(CCPointMake(image:getContentSize().width/2, image:getContentSize().height/2));
                                    eventBtn:setTag(item:getID());
                                    eventBtn:luaSetSelectorOnClicked(onImageBtnClick2);
                                    image:addChild(eventBtn);
                                end
                            end
                        end
                    end
                else
                    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
                        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
                        if partner then
                            if partner.nID == item:getOwnerID() then
                                local BgNode = getHunterImageNode(postion - SOULJADE_SOUL_BEGIN + 11);
                                local washBtn = getWashBtnNode(postion - SOULJADE_SOUL_BEGIN + 11)
                                if washBtn then
                                    washBtn:setVisible(true)
                                    washBtn:setTag(item:getID());
                                    washBtn:luaSetSelectorOnClicked(SoulJade_sendSoulJadeOpen);
                                end
                                if BgNode then
                                    local dragNode = SCDragNode:node();
                                    if dragNode then
                                        dragNode:setContentSize(BgNode:getContentSize());
                                        dragNode:setDragEnabled(true);
                                        dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        dragNode:setPosition(CCPointMake(BgNode:getContentSize().width/2, BgNode:getContentSize().height/2));
                                        dragNode:setTag(item:getID());  
                                        dragNode:luaSetSelectorOnDragEnd(setSelectorOnDragEnd);
                                        BgNode:addChild(dragNode); 
                                        local image = SoulJade.newSoulJadeImg(item,1)
                                        if image then
                                            image:setAnchorPoint(CCPointMake(0.5, 0.5));
                                            image:setPosition(CCPointMake(dragNode:getContentSize().width/2, dragNode:getContentSize().height/2));
                                            dragNode:setTag(item:getID());
                                            dragNode:addChild(image);
                                            --只处理点击事件
                                            local eventBtn = SCButton:button();
                                            if eventBtn then
                                                eventBtn:setContentSize(image:getContentSize());
                                                eventBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                                                eventBtn:setPosition(CCPointMake(image:getContentSize().width/2, image:getContentSize().height/2));
                                                eventBtn:setTag(item:getID());
                                                eventBtn:luaSetSelectorOnClicked(onImageBtnClick2);
                                                image:addChild(eventBtn);
                                            end
                                        end
                                    end
                                end 
                            end 
                        end
                    end
                end
            end
        end
    end
end


--创建拖拽控件
local function newDragNode()
	local imgPath1 = getRealUIResourcePath("img/new00002.png");
	local imgPath2 = getRealUIResourcePath("img/new00003.png");
	if imgPath1 and imgPath2 then
		local bgButton = SCButton:button();
		if bgButton == nil then
			return nil;
		end
		
		bgButton:setBackgroundImage(imgPath1:getData());
		bgButton:setSelectedImage(imgPath2:getData());
	
		local dragNode = SCDragNode:node();
		if dragNode then
			bgButton:setBackgroundImage(imgPath1:getData());
			bgButton:setSelectedImage(imgPath2:getData());
			dragNode:setTag(1);
			dragNode:setContentSize(bgButton:getContentSize());
			dragNode:setDragEnabled(true);
			dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
			dragNode:setPosition(CCPointMake(bgButton:getContentSize().width/2, bgButton:getContentSize().height/2));
			dragNode:luaSetSelectorOnDragEnd(setSelectorOnDragEnd);
			bgButton:addChild(dragNode);
			
			return bgButton;
		end
	end
	
	return nil;
end

--创建魂玉背包
local function creatHunterBag()
    local m_pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4201-4"));
	if m_pDragNode1 == nil then
		return;
	end	
	m_pDragNode1:removeAllChildrenWithCleanup(true);
	
	local width = m_pDragNode1:getContentSize().width;
	local height = m_pDragNode1:getContentSize().height;
	local tabelBox = SCTableBox:boxWithWidthHeight(AUTO_W(200), AUTO_H(240));
	if tabelBox == nil then
        return;
	end
	
    tabelBox:setAnchorPoint(CCPointMake(0.5, 0.5));
    tabelBox:setPosition(CCPointMake(width/2, height/2+SY(5)));
	tabelBox:setScrollHorizontal(false);
	tabelBox:setTag(1);
    m_pDragNode1:addChild(tabelBox);
	
	local tabel = SCTable:table();
	if tabel == nil then
		return;
	end
	
	tabel:setNumberOfRows(4);
	tabel:setNumberOfColumns(4);
	tabelBox:addTable(tabel);
	
	for i=0, 3 do
		tabel:setWidthForColumn(AUTO_W(50), i);
		tabel:setHeightForRow(AUTO_H(57), i);
	end
	
	tabel:reflashData();
	
	for i=0, 3 do
		for j=0, 3 do
			local tableCell = tabel:cellForRowAndColumn(i, j);
			if tableCell then
				local dragNode = newDragNode();
				if dragNode then
					dragNode:setTag(1);
					dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
					dragNode:setPosition(CCPointMake(tableCell:getContentSize().width/2, tableCell:getContentSize().height/2+SY(5)));
					tableCell:addChild(dragNode);
				end
			end
		end
	end
end



--获取解封个数
local function getUnlockCount()
	local tmpUnlockCount = 10;
    --local heroInfo = Hero:getSingleton():getHeroInfo()
    --if heroInfo == nil then
    --    return tmpUnlockCount;
    --end

	--local level = heroInfo.ucLevel;
	--[[if m_curPlayIndex == 0 then
    else
    	local amount = Hero:getSingleton():partnerSize();
	    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
	        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
	        if partner then
	            level = partner.usLevel;
	        end
	    end
    end]]
	if --[[level >= 135 and]] 60 < SoulJade_playSoulJadeLevel then
		tmpUnlockCount = tmpUnlockCount + 6;
	elseif --[[level >= 120 and]] 50 < SoulJade_playSoulJadeLevel then
		tmpUnlockCount = tmpUnlockCount + 5;
	elseif --[[level >= 105 and]] 40 < SoulJade_playSoulJadeLevel then
		tmpUnlockCount = tmpUnlockCount + 4;
	elseif --[[level >= 90 and]] 30 < SoulJade_playSoulJadeLevel then
		tmpUnlockCount = tmpUnlockCount + 3;
	elseif --[[level >= 75 and]] 20 < SoulJade_playSoulJadeLevel then
		tmpUnlockCount = tmpUnlockCount + 2;
	else--[[if level >= 60 then]]
		tmpUnlockCount = tmpUnlockCount + 1;
	end
	
	return tmpUnlockCount;
end

--填充所有按钮数据
local function addHunterEquipLock()
    for i=11,16 do
		unlockNode = getHunterImageNode(i);
		if unlockNode then
			local node = unlockNode:getChildByTag(i);
			if node == nil then
                local pButton28 = SCButton:button(EnumBtnTypeNormalImg)
                if pButton28 then
                    pButton28:setTag(i)
                    pButton28:setAnchorPoint(ANCHOR_CENTER)
                    pButton28:setPosition(AUTO_POS(23.00, 23.00))
                    pButton28:setContentSize(AUTO_SIZE(28, 28))
                    pButton28:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
                    local pBackimg = getRealUIResourcePath("img/new00259.png")
                    if pBackimg then
                        pButton28:setBackgroundImage(pBackimg:getData())
                    end
                    unlockNode:addChild(pButton28);
                end
			end
		end
	end
end

--点击封印按钮
local function onLockBtnClick(tag)
	local level = 121;
	
	if tag == 11 then
		level = 60;
		showMessage(L("str3198"));
	elseif tag == 12 then
		level = 75;
		showMessage(L("str3199"));
	elseif tag == 13 then
		level = 90;
		showMessage(L("str3200"));
	elseif tag == 14 then
		level = 105;
		showMessage(L("str3201"));
	elseif tag == 15 then
		level = 120;
		showMessage(L("str3202"));
	elseif tag == 16 then
		level = 135;
		showMessage(L("str3203"));
	end
	
	
end

--清空身上魂玉装备
local function clearHunterEquip()
	local tmpUnlockCount = getUnlockCount();

	--处理解封
	local unlockNode = nil;
	local unlockBtn = nil
	for i=11, tmpUnlockCount do
		unlockNode = getHunterImageNode(i);
		if unlockNode then
			unlockNode:removeAllChildrenWithCleanup(true);
		end
	    unlockBtn = getWashBtnNode(i)
        if unlockBtn then
            unlockBtn:setVisible(false)
        end	
	end
end

--清空身上所有魂玉装备
local function clearAllHunterEquip()
	for i=11, 16 do
		unlockNode = getHunterImageNode(i);
		if unlockNode then
			unlockNode:removeAllChildrenWithCleanup(true);
		end
		unlockBtn = getWashBtnNode(i)
        if unlockBtn then
            unlockBtn:setVisible(false)
        end
	end
end


--根据等级解封
local function unlockHunterByLevel()
	clearHunterEquip();
	
	--处理封印
	local tmpUnlockCount = getUnlockCount();
	local lockNode = nil;
	for i=tmpUnlockCount+1, 16 do
		lockNode = getHunterImageNode(i);
		if lockNode then
			local childNode = lockNode:getChildByTag(i);
			if childNode then
				SCTypeCast:castNodeToButton(childNode):luaSetSelectorOnClicked(onLockBtnClick);
			end
			unlockBtn = getWashBtnNode(i)
            if unlockBtn then
                unlockBtn:setVisible(false)
            end
		end
		
	end
end


--设置玩家名字
local function refreshName()
    local m_name = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4201-3"));
    if m_name == nil then
        return;
    end
    
    local heroInfo = Hero:getSingleton():getHeroInfo();
    if heroInfo == nil then
        return;
    end
    
    if m_curPlayIndex == 0 then
        m_name:setText(heroInfo.strName:getData());
    else
    	local amount = Hero:getSingleton():partnerSize();
	    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
	        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
	        if partner then
	            m_name:setText(partner.strName:getData());
	        end
	    end
    end
end

--清空魂玉背包
local function clearSoulJadeBag()
    local m_pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4201-4"));
    if m_pDragNode1 == nil then
        return;
    end
    
	local tableBox = SCTypeCast:castNodeToTableBox(m_pDragNode1:getChildByTag(1));
	if tableBox == nil then
		return;
	end
	
	local pTable = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("0", tableBox));
	if pTable == nil then
		return;
	end
	
	for i=0, 15 do
		local tableCell = pTable:getChildByTag(i);
		if tableCell then
			local dragButton = SCTypeCast:castNodeToButton(tableCell:getChildByTag(1));
			if dragButton then
			    dragButton:removeAllChildrenWithCleanup(true);
		        local dragNode = SCDragNode:node();
		        if dragNode then
			        dragNode:setTag(1);
			        dragNode:setContentSize(dragButton:getContentSize());
			        dragNode:setDragEnabled(true);
			        dragNode:setAnchorPoint(CCPointMake(0.5, 0.5));
			        dragNode:setPosition(CCPointMake(dragButton:getContentSize().width/2, dragButton:getContentSize().height/2));
			        dragNode:luaSetSelectorOnDragEnd(setSelectorOnDragEnd);
			        dragButton:addChild(dragNode); 
                end                  
			end
		end
	end
end

--切换上一个人物
local function onUpPlayerBtnClick(tag)
    if m_curPlayIndex <= 0 then
        return;
    end
    
    m_curPlayIndex = m_curPlayIndex - 1;
    clearAllHunterEquip();
    addHunterEquipLock();
    unlockHunterByLevel();
    refreshSoulJadeWnd();
    refreshName();
end

--切换下一个人物
local function onDownPlayerBtnClick(tag)
    local amount = Hero:getSingleton():partnerSize();
    if m_curPlayIndex + 1 > amount then
        return;
    end
    
    m_curPlayIndex = m_curPlayIndex + 1;
    clearAllHunterEquip();
    addHunterEquipLock();
    unlockHunterByLevel();
    refreshSoulJadeWnd();
    refreshName();
end
----------玩法说明响应
local function addexplain()
--	showMessage(L("str3198"));
	local wnd = SCFunction:getUiNodeByIdlist("4201")
    if wnd and wnd:getChildByTag(10055) == nil then
        local pframeWnd = FrameWindow:frameWnd();
        if pframeWnd then
            pframeWnd:setTag(10055);
            pframeWnd:setContentSize(CCSizeMake(SX(360), SY(200)));
            pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
            pframeWnd:setPosition(CCPointMake(wnd:getContentSize().width / 2, wnd:getContentSize().height / 2 ));
            local pParsedNode = SCTextBox:boxWithWidthHeight(SX(330), SY(160));
            if pParsedNode then
                pParsedNode:setParserDelegate(TextParser:getSingleton());
                pParsedNode:setText(L("str21019"));
                pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                pParsedNode:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, pframeWnd:getContentSize().height / 2));
                pframeWnd:addChild(pParsedNode);
            end
--            wnd:addChild(pframeWnd, 101);
			wnd:addChild(pframeWnd)
            pframeWnd:setCloseBtnVisible(false);
        end
    end
end 
--初始化按钮响应事件
local function initBtnEvent()
    local wndCtrl = getCurentSceneWindowController(4201);
	if wndCtrl == nil then
		return;
	end
	
	local win = wndCtrl:getWindow();
	if win then
	    local btnUp = SCTypeCast:castNodeToButton(win:getChildByTag(27));
	    local btnDown = SCTypeCast:castNodeToButton(win:getChildByTag(28));
	    if btnUp and btnDown then
	        btnUp:luaSetSelectorOnClicked(onUpPlayerBtnClick);
	        btnDown:luaSetSelectorOnClicked(onDownPlayerBtnClick);
	    end
	end
	local exp_button = tolua.cast(SCFunction:getUiNodeByIdlist("4201-9"), "SCButton")  ------玩法说明按钮
	if exp_button then
		exp_button:setTag(9)
		exp_button:luaSetSelectorOnClicked(addexplain)
	end 
end
----------------消息处理区----------------
--接收魂玉系统信息
local function recvSoulJadeInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
	
    local action = dt:readShort()	
	if action == ENUE_ITEM_SOUL_ATTR_INFO then
		--souljade6_del_mark()
		souljade7_close_wnd()
		SoulJade5.releaseControl()
		souljade6_open(tMsg_Info1.initWithStream(dt),1)
		--local souljade5_wnd = SoulJade5_showSoulJadePopWnd(tMsg_Info1.initWithStream(dt))
		--souljade6_open(souljade5_wnd,0)
    elseif action == ENUE_ITEM_SOUL_DECOMPOSE_INFO then
        SoulJade1_refreshMoney(tMsg_Info2.initWithStream(dt))
	elseif action == ENUE_ITEM_SOUL_CHANGE_ATTR  then  -----------新洗练界面
		souljade5_onCloseBtnClick()
		SoulJade5.releaseControl()
		--souljade6_close_wnd()
		--souljade6_del_mark()
		local tmp = tMsg_Info_two.initWithStream(dt)
		souljade6_open(tmp,1)
	elseif action == ENUE_ITEM_SOUL_MORE_CHANGE_ATTR then   --------批量洗练响应
		souljade6_close_wnd()
		--souljade7_close_wnd()
		local tmp = tMsg_Info1_piliang.initWithStream(dt)
		souljade7_open(tmp)
	end
end
--魂玉背包整理
function SoulJade.sendClearJadeBag()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM);
	if dataStream then
		dataStream:writeShort(ITEMACT_TIDYUP_SOUL)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end
--装备魂玉消息
function SoulJade.sendWearSoulJade(item, ucPosition)
    if item == nil or ucPosition == nil then
		return;
	end
	
    local heroInfo = Hero:getSingleton():getHeroInfo();
    if heroInfo == nil then
        return;
    end
    
    local id = Hero:getSingleton():getID();
    local level = 0;
    if m_curPlayIndex == 0 then
        level = Hero:getSingleton():getLeval();
    else
    	local amount = Hero:getSingleton():partnerSize();
	    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
	        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
	        if partner then
	            id = partner.nID;
	            level = partner.usLevel;
	        end
	    end
    end
    
    if level < 21 then
        --return;
    end

	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM);
	if dataStream then
		dataStream:writeShort(ITEMACT_EQUIP)
		dataStream:writeInt(item:getID())
		dataStream:writeByte(71)
		dataStream:writeShort(0)
		dataStream:writeInt(id);
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end
--发送脱装备
function SoulJade.sendTakeOffSoulJade(item, usPlace)
	if item == nil or usPlace == nil then
		return;
	end
	
	local id = Hero:getSingleton():getID();
    if m_curPlayIndex == 0 then
    else
    	local amount = Hero:getSingleton():partnerSize();
	    if m_curPlayIndex <= amount and m_curPlayIndex > 0 then
	        local partner = Hero:getSingleton():getPartnerWithPos(m_curPlayIndex-1);
	        if partner then
	            id = partner.nID;
	        end
	    end
    end

	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM);
	if dataStream then
		dataStream:writeShort(ITEMACT_UNEQUIP)
		dataStream:writeInt(item:getID())
		dataStream:writeByte(item:getPostion())
		dataStream:writeShort(550)
		dataStream:writeInt(id);
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end
--魂玉打开
function SoulJade_sendSoulJadeOpen(idItem)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
	if dataStream then
		dataStream:writeShort(ENUE_ITEM_SOUL_ATTR_INFO)
		dataStream:writeInt(idItem)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end
--魂玉分解
function SoulJade_sendSoulJadeSplit(idItem)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
	if dataStream then
		dataStream:writeShort(ENUE_ITEM_SOUL_DECOMPOSE)
		dataStream:writeInt(1)
		dataStream:writeInt(idItem)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 	
end
--发送魂玉洗练
function SoulJade_sendSoulJadeWash(dt)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
	if dataStream then
		dataStream:writeShort(ENUE_ITEM_SOUL_CHANGE_ATTR)
		dataStream:writeByte(dt.ucFlag)
		dataStream:writeInt(dt.idItem)
		dataStream:writeInt(dt.nIndex1)
		dataStream:writeInt(dt.nIndex2)
		dataStream:writeInt(dt.nIndex3)
		dataStream:writeInt(dt.nIndex4)
		dataStream:writeInt(dt.nCostType)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end
end
--发送激活魂玉消息
function SoulJade_sendSoulJadeActivate(dt)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
	if dataStream then
		dataStream:writeShort(ENUE_ITEM_SOUL_ACTIVATE_ATTR)
		dataStream:writeByte(dt.ucFlag)
		dataStream:writeInt(dt.nIndex)
		dataStream:writeInt(dt.idItem)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end
--请求神玉信息
function SoulJade_sendSoulJadeNum()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM_SOUL);
	if dataStream then
		dataStream:writeShort(ENUE_ITEM_SOUL_DECOMPOSE_INFO)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 	
end
----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recvSoulJadeInfo, _MSG_ITEM_SOUL, 0, nil)
----------------全局函数区----------------
function SoulJade_ShowWndSoulJade()
    local wndCtrl = getCurentSceneWindowController(4201)
    if wndCtrl then
        return
    end
    local wnd = SoulJade.initControl()
    if wnd then
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            SoulJade_eventForButton();
            creatHunterBag();
            refreshName();
            unlockHunterByLevel()
            refreshSoulJadeWnd();
            initBtnEvent();
        end
    end 
end
function SoulJade.newSoulJadeImg(item,type)
    local imgPath = getRealUIResourcePath("item/"..item:getIconID()..".jpg");
    if imgPath == nil then
        imgPath = getRealUIResourcePath("img/ItemTemp.png");
    end
    local itemInfo = item:getData()
    if imgPath then
        local image = SCImage:imageWithFile(imgPath:getData());
        if image then
            image:removeAllChildrenWithCleanup(true);
            local mark = nil
            if 1901000000 <= item:getIdType() and 1902000000 > item:getIdType() then
                mark = 0
            elseif 1902000000 <= item:getIdType() and 1903000000 > item:getIdType() then
                mark = 1
            elseif 1903000000 <= item:getIdType() and 1904000000 > item:getIdType() then
                mark = 2
            end
            
            local pAmiNode = getQualityNode(mark)
            if pAmiNode then
                pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                pAmiNode:setPosition(CCPointMake(image:getContentSize().width / 2, image:getContentSize().height / 2));
                image:addChild(pAmiNode);
            end
            if 1 <= type then
                local count = itemInfo.ucAttrAmount
                local imgPath1 = getRealUIResourcePath("jade/new00735.png");
                local imgPath2 = getRealUIResourcePath("jade/new00738.png");
                if imgPath1 and imgPath2 then
                    for i = 1,4 do 
                        local image1 = SCImage:imageWithFile(imgPath1:getData())
                        if image1 then
                            image1:setAnchorPoint(CCPointMake(0, 0))
                            image1:setPosition(CCPointMake(image:getContentSize().width -SX(3) - i*SX(6), -SY(2)));
                            image1:setTag(5-i)
                            image:addChild(image1);
                        end
                    end
                    for i = 1,count do
                        local image2 = SCTypeCast:castNodeToImage(image:getChildByTag(i))
                        if image2 and imgPath2  then
                            image2:setImage(imgPath2:getData())
                        end
                    end
                end
            end
            if 2 == type then
                local itemName = item:getName()
                local labelName = SCLabel:labelWithStringFont(itemName, DEFAULT_FONT_NAME, F(10))
                if labelName then
                    labelName:setAnchorPoint(ANCHOR_CENTER)
                    labelName:setPosition(image:getContentSize().width /2, -SY(10))
                    if 0 == mark then
                        labelName:setColor(color_green)
                    elseif 1 == mark then
                        labelName:setColor(color_skyBlue)
                    elseif 2 == mark then
                        labelName:setColor(color_purple)
                    end
                    image:addChild(labelName)
                end
            end
            return image
        end
    end
    return nil
end

function SoulJade_refreshSoulJadeWnd()
    clearSoulJadeBag();
	clearHunterEquip();
	refreshSoulJadeWnd();
end
function SoulJade_setSoulJadeLevel(level)
    SoulJade_playSoulJadeLevel = level
end
function SoulJade.wndClose()
    m_curPlayIndex = 0
end

--函数调用