--[[组队功能再次添加--]]

local _MSG_TEAM		= 1023;
local _MSG_TEAMMEMBER	= 1026; --//这个消息的action为byte
local MSG_TEAM_INSTS						= 67;--	//多人副本可参与副本列表
local MSG_TEAM_INST_TEAMS					= 68;--		//多人副本组队列表
local MSG_TEAM_INST_TEAMS_END				= 69;--		//多人副本组队列表end
local MSG_TEAM_CREATE = 0 ---创建队伍
local MSG_TEAM_PROMOTELEADER_TO_CLIENT	    = 35;
local MSG_TEAM_INST_TEAM_ADD				= 71;--		//多人副本组队添加
local MSG_TEAM_INST_TEAM_UPDATE			    = 72;--		//多人副本组队更新
local MSG_TEAM_INST_TEAM_DEL				= 73;--		//多人副本组队删除

local MSG_TEAM_OPEN_INST_TEAM				= 74;--		//打开多人副本主界面
local MSG_TEAM_CLOSE_INST_TEAM			    = 75;--		//关闭多人副本主界面

local MSG_TEAM_JOIN_TEAM			    	= 76;--		//加入队伍
local MSG_TEAM_FAST_JOIN_TEAM				= 77;--		//快速加入

local MSG_TEAM_INST_START					= 78;--		//多人副本战斗开始
local MSG_TEAM_MEMBER_FULL_INST_START		= 79;--		//满员自动开始标志

local MSG_TEAM_OPEN_INST_TEAM				= 74;--		//打开多人副本主界面
local MSG_TEAM_CLOSE_INST_TEAM			= 75;--		//关闭多人副本主界面
local MSG_TEAM_LEAVE = 1;
local MSG_TEAMMEMBER_ADDMEMBER		= 0;	--//将新加入的队员的信息告诉队伍中的现有成员             
local MSG_TEAM_QUIT						= 11;	--// 解散队伍	
local MSG_TEAM_KICKOUT					= 12;	--// 驱逐成员
local MSG_ITEM_INST_INTEAM_CHANGE			= 84; --	//所在队伍变更
local MSG_ITEM_INST_EUDEMON_CHANGE			= 85;--	//伙伴变更(IOS专用)

local MSG_ITEM_INSTPOS_INFO = 80	--//查看布阵
local MSG_ITEM_INSTPOS_REPLACE = 81	--//阵法位子交换
local MSG_ITEM_INSTEUD_CHANGE = 82  --更换伙伴		

local MSG_TEAM_OPEN_ARENA3V3				= 86;--		//0 多人副本， 1 3v3
local MSG_TEAM_CLOSE_ARENA3V3			= 87;--		--//关闭3v3主界面
local MSG_ITEM_3V3_START_PAIR				= 88	--//随机配对
local MSG_ITEM_3v3_BATTLE				= 89	--//请求对战
local MSG_ITEM_3V3_INFO				= 91	--//3v3具体信息
local MSG_TEAM_OPEN_TRIBE_INST_TEAM		= 92	--//打开公会多人副本主界面
local MSG_TEAM_CLOSE_TRIBE_INST_TEAM		= 93	--//关闭公会多人副本主界面
local MSG_TEAM_CALL_HELP					= 94	--//召集成员
local MSG_TEAM_OPEN_PANDORA				= 95	--//打开潘多拉
local MSG_TEAM_CLOSE_PANDORA				= 96	--//关闭潘多拉
local MSG_TEAM_PANDORA_CHANGE				= 97	--//选择箱子
local MSG_TEAM_PANDORA_Bomb				= 98	--//选中剔除
local MSG_TEAM_PANDORA_PREPARE			= 99	--//潘多拉准备
---
local MemberId0 = 0
local MemberId1 = 0;
local MemberId2 = 0;
--[[
m_WndType = 0 --多人副本
m_WndType = 1 --3V3
m_WndType = 2 --公会多人副
m_WndType = 3 --潘多拉魔盒
]]--
local m_WndType = 0
local m_teamInfo = {}
local m_ownTeam = 0
local m_peiDuiFlag = false
local m_countTime = 0  --配对耗时计算
local m_entryId = nil --定时器id
local m_pandoraOpenFlag = false
local m_PandoraBombFlag = false
local m_pandoraBoxFlags = nil
local m_pandorEndFlag = 0
local m_pandorShowMsg = nil
local m_pandorStartFlag = false
local m_pandorSleepFlag = nil
local m_pandorTurnFLag = nil
local m_pandorReadyFlag = nil
-----可参加列表 MSG_TEAM_INSTS						= 67;

local stInstInfo = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		local tmp = {
			__mode = "kv",
		}
		tmp.idInst = dt:readInt() -- 
		local scStr = dt:readString()
		if scStr == nil then
			tmp.stfill = ""
		else
			tmp.stfill = scStr:getData()
		end
		
		tmp.usNeedLev = dt:readShort()
		tmp.nPhoto = dt:readInt()
		tmp.desStr = _LTParser("str5001")
		local scStr = dt:readString()
		if scStr then
			tmp.desStr = scStr:getData()
		end
		tmp.ucflag = dt:readByte()
		return tmp
	end
}

local stInstInfoList = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		local tmp = {
			__mode = "kv"
		}
		tmp.ucAmount = dt:readByte()
		tmp.InstInfo = {}
		
		for i = 1, tmp.ucAmount do
		  table.insert(tmp.InstInfo, stInstInfo.initWithStream(dt))
		end
            
		return tmp
	end
}

-----


-- MSG_TEAM_INST_TEAMS					= 68,	//多人副本组队列表
--MSG_TEAM_INST_TEAMS_END				= 69,	//多人副本组队列表end
	
	
local stInstTeam = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		local tmp = {
			__mode = "kv",
		}
		tmp.idTeam = dt:readInt() -- 队伍ID
		
		local scStr = dt:readString() --队长名字
		if scStr == nil then
			tmp.szLeaderName = ""
		else
			tmp.szLeaderName = scStr:getData()
		end
		
		tmp.ucNum = dt:readByte()  --人数
		tmp.ucMaxNum = dt:readByte() --最大人数
		tmp.idInst = dt:readInt() -- 副本ID
		
		local scStr = dt:readString() --多人副本名字
		if scStr == nil then
			tmp.szInstName = ""
		else
			tmp.szInstName = scStr:getData()
		end
		
			local scStr = dt:readString() --奖励
		if scStr == nil then
			tmp.szAward = ""
		else
			tmp.szAward = scStr:getData()
		end
		
		tmp.usLevel = dt:readShort()
		tmp.byType = dt:readByte()
		return tmp
	end
}

local stInstTeamList = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		local tmp = {
			__mode = "kv"
		}
		tmp.ucAmount = dt:readByte()
		tmp.InstTeam = {}
		
		for i = 1, tmp.ucAmount do
		  table.insert(tmp.InstTeam, stInstTeam.initWithStream(dt))
		end
            
		return tmp
	end
}

---布阵消息
local stFormationInfo = {
initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		local tmp = {
			__mode = "kv",
		}
		local scStr = dt:readString() --名字
		if scStr == nil then
			tmp.szName = ""
		else
			tmp.szName = scStr:getData()
		end
		tmp.id = dt:readInt() --id
		tmp.nFacePhoto = dt:readInt() -- 头像
		tmp.usLevel = dt:readShort() -- 等级
		tmp.ucPos = dt:readByte() --位置
		return tmp
	end
}

local stFormationInfoList = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		local tmp = {
			__mode = "kv"
		}
		tmp.ucAmount = dt:readByte()
		tmp.TeamMemberInfo = {}
		
		for i = 1, tmp.ucAmount do
		  table.insert(tmp.TeamMemberInfo, stFormationInfo.initWithStream(dt))
		end
            
		return tmp
	end
}

local stPandoraBox = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		local tmp = {
			__mode = "kv"
		}
		tmp.roleId = dt:readInt()
		tmp.ucAmount = dt:readShort()
		tmp.boxFlag = {}
		
		for i = 1, tmp.ucAmount do
		  table.insert(tmp.boxFlag, dt:readByte())
		end
        tmp.newTurnFlag = dt:readByte()
		return tmp
	end
}
--定时器回调
local function onTimer()
	local wnd = getCurentSceneWindow(2036)
	if not wnd then
		return
	end
	local timeLabel = tolua.cast(wnd:getChildByTag(5000), "SCLabel")
	if not timeLabel then
		return
	end
	timeLabel:setText(_LTParser("str5094").." "..makeTime(m_countTime, Min_Sec))
	m_countTime = m_countTime + 1
	if m_countTime == 3600 then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		m_entryId = nil
	end
end
--3V3 耗时
local function countTime(dt)
	local wnd = getCurentSceneWindow(2036)
	if not wnd then
		return
	end
	local timeLabel = tolua.cast(wnd:getChildByTag(5000), "SCLabel")
	if not timeLabel then
		return
	end
	local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-7"));
	if not btn then
		return
	end
	local type = dt:readByte()
	m_countTime = dt:readInt()
	if m_countTime == 0 then
		timeLabel:setVisible(false)
		btn:setTitle(_LTParser("str5091"), getDefaultFontName(), getFontSize(15))
		m_peiDuiFlag = false
		if m_entryId then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
			m_entryId = nil
		end
		return
	end
	timeLabel:setVisible(true)
	timeLabel:setText(_LTParser("str5094").." "..makeTime(0, Min_Sec))
	btn:setTitle(_LTParser("str0237"), getDefaultFontName(), getFontSize(15))
	m_peiDuiFlag = true
	if m_entryId == nil then
		m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(onTimer, 1.0, false)
	end
end

----
--快速加入
local function onBtnClickFastGame()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_TEAM_FAST_JOIN_TEAM);
	if m_WndType == 0 then
		dataStream:writeInt(0)
	elseif m_WndType == 1 then
		dataStream:writeInt(1)
	elseif m_WndType == 3 then
		dataStream:writeInt(3)
	end
    SCDataTransThread:getSingleton():transData(dataStream);
end

--获取空dragButton
local function getNullDragBtn()
	local pBtn = DragButton:newDragButton()
	pBtn:setAnchorPoint(CCPointMake(0.5, 0.5))
	pBtn:setDragNodeIsVisible(false)

	local file = getRealUIResourcePath("img/new00002.png")
	if  not file then
		return nil
	end
	pBtn:hsetBackgroundImage(file:getData())

	file = getRealUIResourcePath("img/new00003.png")
	if  not file then
		return nil
	end
	pBtn:hsetSelectedImage(file:getData())
	return pBtn
end

--布阵
local function sendChangeFormation(nId, ucPos)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_ITEM_INSTPOS_REPLACE);
	dataStream:writeInt(nId)
	dataStream:writeByte(ucPos)
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function inWhichPos(x, y)
	local wnd = getCurentSceneWindow(5912)
	if not wnd then
		return -1
	end
	for i=111, 119 do
		local node = wnd:getChildByTag(i)
		if node then
			local mNode = node:getChildByTag(i+10)
			if mNode then
				local tpt = mNode:convertToNodeSpace(CCPointMake(x, y))
				if CCRect:CCRectContainsPoint(CCRectMake(0,0,mNode:getContentSize().width,mNode:getContentSize().height), tpt) then
					return i-111
				end
				--[[
				local xt = wnd:getPosition().x+node:getPosition().x+mNode:getPosition().x
				local yt =  wnd:getPosition().y+node:getPosition().y+mNode:getPosition().y
				if x>=xt and x<=xt+42 and y>=yt and x<=yt+42 then
					return i-110
				end
				]]
			end
		end
	end
	return -1
end

local function dragBegin(tag)

end

local function dragEnd(tag, x, y)
	local pos = inWhichPos(x, y)
	if pos~=-1 then
		sendChangeFormation(tag, pos)
	end
end
---打开 布阵界面
local function showFormationWnd(forList)
	local naviCtrl = getCurentSceneNavigationController()
	if not naviCtrl then
		return
	end
	local wnd = nil
	local wndCtrl = naviCtrl:getWindowControllerByTag(5912)
	if not wndCtrl then
		wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5912))
		local titleImg = getRealUIResourcePath("img/titile58.png")
		if titleImg then
			wnd:setTitleWithImage(titleImg:getData())
		end
		--wnd:setTitle(_LTParser("str2043"))
		--wnd:setFrameVisibled(false)
		wndCtrl = SCWindowController:controllerWithWindow(wnd)
		naviCtrl:pushWindowController(wndCtrl)
	else
		wnd = wndCtrl:getWindow()
	end

	for i=111, 119 do
		local node = wnd:getChildByTag(i)
		if node then
			local pLabel = tolua.cast(node:getChildByTag(1), "SCLabel")
			if not pLabel then
				pLabel = SCLabel:labelWithStringFont(" ", getDefaultFontName(), getFontSize(12))
				pLabel:setTag(1);
				pLabel:setColor(color_yellow);
				pLabel:setPosition(CCPointMake(12*gUIScale().x, 2*gUIScale().y));
				node:addChild(pLabel);
			else
				pLabel:setText(" ")
			end
			local pLabel = tolua.cast(node:getChildByTag(2), "SCLabel")
			if not pLabel then
				pLabel = SCLabel:labelWithStringFont(" ", getDefaultFontName(), getFontSize(12))
				pLabel:setTag(2);
				pLabel:setColor(color_yellow);
				pLabel:setPosition(CCPointMake(12*gUIScale().x, 14*gUIScale().y));
				node:addChild(pLabel);
			else
				pLabel:setText(" ")
			end
			local mNode = node:getChildByTag(i+10)
			if mNode then
				local dragButton = tolua.cast(mNode:getChildByTag(1), "DragButton")
				if not dragButton then
					dragButton = getNullDragBtn()
					dragButton:setTag(1)
					--dragButton:luaSetSelectorOnDragBegin(dragBegin)
					dragButton:luaSetSelectorOnDragEnd(dragEnd)
					dragButton:setChildDragNodeTag(-1)
					dragButton:setPosition(mNode:getContentSize().width/2, mNode:getContentSize().height/2)
					mNode:addChild(dragButton)
				else
					dragButton:setChildDragNodeTag(-1)
					dragButton:hsetTitle(" ", getDefaultFontName(), getFontSize(12))
					dragButton:setDragNodeIsVisible(false)
				end
			end
			local imgNode = node:getChildByTag(i+20)
			if imgNode then
				imgNode:setVisible(false)
			end
		end
	end
	for i=1, forList.ucAmount do
		local node = wnd:getChildByTag(forList.TeamMemberInfo[i].ucPos+111)
		if node then
			local label = tolua.cast(node:getChildByTag(1), "SCLabel")
			if label then
				label:setText(_LTParser("str0003")..forList.TeamMemberInfo[i].usLevel)
				label:setPosition(CCPointMake((node:getContentSize().width-label:getContentSize().width)/2,2*gUIScale().y));
			end
			local label = tolua.cast(node:getChildByTag(2), "SCLabel")
			if label then
				label:setText(forList.TeamMemberInfo[i].szName)
				label:setPosition(CCPointMake((node:getContentSize().width-label:getContentSize().width)/2,14*gUIScale().y));
			end
			local mNode = node:getChildByTag(forList.TeamMemberInfo[i].ucPos+121)
			if mNode then
				local dragBtn = tolua.cast(mNode:getChildByTag(1), "DragButton")
				if dragBtn then
					local file = getFaceImagePath(forList.TeamMemberInfo[i].nFacePhoto)
					if file then
						--if not Hero:getSingleton():iSATeamLeader() then
							dragBtn:hsetTitle(file:getData())
						--else
						--	dragBtn:setDragNodeIsVisible(true)
						--	dragBtn:setDragImg(file:getData(), CCRectMake(0, 0, 36, 36))
						--end
					end
					dragBtn:setChildDragNodeTag(forList.TeamMemberInfo[i].id)
				end
			end
		end
	end
	--[[
	local fCount = 0
	for i=111, 119 do
		local node = wnd:getChildByTag(i)
		if node then
			local mNode = node:getChildByTag(i+10)
			if mNode then
				local dragBtn = tolua.cast(mNode:getChildByTag(1), "DragButton")
				local imgNode = tolua.cast(node:getChildByTag(i+20), "SCImage")
				if dragBtn and imgNode and dragBtn:getChildDragNodeTag()~=-1 then
					imgNode:setVisible(true)
					local file = getRealUIResourcePath("img/img"..5031+fCount..".png")
					if file then
						imgNode:setImage(file:getData())
					end
					fCount = fCount + 1
				end
			end
		end
	end
	]]
end
---点击
local function onClickFormation(tag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_ITEM_INSTPOS_INFO);
    SCDataTransThread:getSingleton():transData(dataStream);
end

--更换伙伴
local function onClickPar(tag)
	local wnd = getCurentSceneWindow(5911)
    if not wnd then
		return
    end
	local pageBox = tolua.cast(wnd:getChildByTag(2), "SCPageScrollBox")
	if not pageBox then
		return
	end
	local label = tolua.cast(pageBox:getChildByTag(1000), "SCLabel")
	if label then
		local oldId = label:getText()+0
		for i=1, pageBox:getPageCount() do
			local node = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent(i.."-"..oldId, pageBox))
			if node then
				node:setFrameType(EnumFrameTypeListNormal)
				break
			end
		end
		label:setText(tag.."")
	end
	for i=1, pageBox:getPageCount() do
		local node = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent(i.."-"..tag, pageBox))
		if node then
			node:setFrameType(EnumFrameTypeListSelect)
			break
		end
	end
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM)
	dataStream:writeShort(MSG_ITEM_INSTEUD_CHANGE)
	dataStream:writeInt(tag)
    SCDataTransThread:getSingleton():transData(dataStream)

end

local function getParPosText(canPushFlag)
	--前中后军可摆放标记
    local enableFlag = {false, false, false}
    --设置标记
    for i=1, 3 do
        if canPushFlag%10 ~= 0 then
            enableFlag[canPushFlag%10] = true
        end
        canPushFlag = getIntPart(canPushFlag/10)
    end
    if enableFlag[1] and enableFlag[2] and enableFlag[3] then
		return	_LTParser("str5116")
    end
    if enableFlag[1] and enableFlag[2] then
		return _LTParser("str5117")
    end
    if enableFlag[2] and enableFlag[3] then
		return _LTParser("str5118")
    end
    if enableFlag[1] and enableFlag[3] then
		return _LTParser("str5119")
    end
    if enableFlag[1] then
		return _LTParser("str5120")
    end
    if enableFlag[2] then
		return _LTParser("str5121")
    end
    if enableFlag[3] then
		return _LTParser("str5122")
    end
end

--更换伙伴UI
local function createChangeParWnd()
	local naviCtrl = getCurentSceneNavigationController()
	if not naviCtrl then
		return
	end
	local wndCtrl = naviCtrl:getWindowControllerByTag(5911)
	if wndCtrl then
		return
	
    end
	
	
	
	local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5911))
	
	if nil == wnd then
	    return
	end
    --wnd:setTitle(_LTParser("str5093"))
    if SCPath:getSingleton() then
        local imgPath = getRealUIResourcePath("img/titile37.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
    end
	wndCtrl = SCWindowController:controllerWithWindow(wnd)
	naviCtrl:pushWindowController(wndCtrl)
	
	local pageBox = tolua.cast(wnd:getChildByTag(2), "SCPageScrollBox")
	if not pageBox then
		return
	end
	pageBox:setPageSize(CCSizeMake(308*gUIScale().x, 137*gUIScale().y))
	local pageHint = tolua.cast(wnd:getChildByTag(3), "SCPageHint")
	if pageHint then
		pageHint:setBoundPageScrollBox(pageBox)
	end

	local pageCount = 0
	local pageWidth = 308*gUIScale().x
	local pageHeight = 137*gUIScale().y
	
	local size = Hero:getSingleton():partnerSize()
	for i=1, size do
		local parInfo = Hero:getSingleton():getPartnerWithPos(i-1)
		if i%3 == 1 then
			pageCount = pageCount + 1
			pageBox:setContentSize(CCSizeMake(pageWidth*pageCount, pageHeight))
			local pageNode = SCNode:node()
			pageNode:setTag(pageCount)
			pageNode:setContentSize(CCSizeMake(pageWidth, pageHeight))
			pageNode:setPosition(CCPointMake(pageWidth*(pageCount-1), 0))
			pageBox:addChild(pageNode)
		end
		local pageNode = pageBox:getChildByTag(pageCount)
		if pageNode then
			local node = tolua.cast(SCFunction:getUiByZipAndId(5911, 101), "SCDragNode")
			if node then
				node:setFrameType(EnumFrameTypeListNormal)
				node:setFrameVisibled(true)
				local btn = tolua.cast(node:getChildByTag(1), "SCButton")
				if btn then
					btn:setTag(parInfo.nID)
					btn:luaSetSelectorOnClicked(onClickPar)
					btn:setContentSize(CCSizeMake(100*gUIScale().x, 110*gUIScale().y))
				end
				local img = tolua.cast(node:getChildByTag(2), "SCImage")
				if img then
					local file1 = getRealUIResourcePath("img/new00002.png")
					local file2 = getFaceImagePath(parInfo.nFacePhoto)
					if file1 and file2 then
						img:setImage(file1:getData())
						local imgNode = SCImage:imageWithFile(file2:getData())
						if imgNode then
							imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
							setNodePostion(imgNode, CCPointMake(getNodeContentSize(img).width/2, getNodeContentSize(img).height/2))
							img:addChild(imgNode)
						end
					end
				end
				local text = "*6".._LTParser("str5112").." *0"..parInfo.strName:getData().."_"
				text = text.."*6".._LTParser("str0013").." *0LV"..parInfo.usLevel.."_"
				text = text.."*6".._LTParser("str5113").."*0 "..getParPosText(parInfo.ucAgrle)
				local parNode = getItemTextNode(text)
				parNode:setAnchorPoint(CCPointMake(0, 1))
				parNode:setPosition(CCPointMake(SX(2), SY(55)))
				node:addChild(parNode)
				local pLabel =  tolua.cast(node:getChildByTag(3), "SCLabel")
				if pLabel then
					pLabel:setText(" ")
				end
				local pLabe2 =  tolua.cast(node:getChildByTag(4), "SCLabel")
				if pLabe2 then
					pLabe2:setText(" ")
				end
				local pLabe3 =  tolua.cast(node:getChildByTag(5), "SCLabel")
				if pLabe3 then
					pLabe3:setText(" ")
				end
				if i%3 == 1 then
					node:setPosition(CCPointMake(0, 10*gUIScale().y))
				elseif i%3 == 2 then
					node:setPosition(CCPointMake(110*gUIScale().x, 10*gUIScale().y))
				else
					node:setPosition(CCPointMake(220*gUIScale().x, 10*gUIScale().y))
				end
				pageNode:addChild(node)
				node:setTag(parInfo.nID)
			end
		end
	end
	local dataLabel = SCLabel:labelWithStringFont("0", getDefaultFontName(), getFontSize(12))
	dataLabel:setTag(1000)
	dataLabel:setPosition(CCPointMake(-1000, -1000))
	pageBox:addChild(dataLabel)

	--[[
	local size = Hero:getSingleton():partnerSize()
	for i=1, size do
		local node = wnd:getChildByTag(i+10)
		if node then
			local parInfo = Hero:getSingleton():getPartnerWithPos(i-1)
			if parInfo then
				local label = tolua.cast(node:getChildByTag(1), "SCLabel")
				if label then
					if parInfo.strName:getData() then
						label:setText(parInfo.strName:getData())
						label:setPosition(CCPointMake((node:getContentSize().width-label:getContentSize().width)/2,2));
					end
				end
				local label = tolua.cast(node:getChildByTag(2), "SCLabel")
				if label then
					if parInfo.strName:getData() then
						label:setText(_LTParser("str0003")..parInfo.usLevel)
						label:setPosition(CCPointMake((node:getContentSize().width-label:getContentSize().width)/2,14));
					end
				end
				local mNode = node:getChildByTag(i+20)
				if mNode then
					local dragBtn = tolua.cast(mNode:getChildByTag(1), "DragButton")
					if dragBtn then
						local file = getRealUIResourcePath("img/img5036.png")
						if file then
							dragBtn:hsetTitle(file:getData(), CCRectMake(0, 0, 36, 36))
						end
						dragBtn:setChildBtnTag(parInfo.nID)
						dragBtn:luaSetClickedSelector(onClickPar)
					end
				end
			end
		end
	end
	
	for i=11, 18 do
		local node = wnd:getChildByTag(i)
		if node then
			local pLabel = SCLabel:labelWithStringFont(" ", getDefaultFontName(), getFontSize(12))
			pLabel:setTag(1);
			pLabel:setColor(color_yellow);
			pLabel:setPosition(CCPointMake(12, 2));
			node:addChild(pLabel);
			local pLabel = SCLabel:labelWithStringFont(" ", getDefaultFontName(), getFontSize(12))
			pLabel:setTag(2);
			pLabel:setColor(color_yellow);
			pLabel:setPosition(CCPointMake(12, 14));
			node:addChild(pLabel);
			local mNode = node:getChildByTag(i+10)
			if mNode then
				if not mNode:getChildByTag(1) then
					local dragButton = getNullDragBtn()
					dragButton:setTag(1)
					dragButton:setPosition(mNode:getContentSize().width/2, mNode:getContentSize().height/2)
					mNode:addChild(dragButton)
				end
			end
		end
	end
	]]

end

--更换伙伴
local function onBtnClickChangePar()
	createChangeParWnd()
end

--选中对战队伍
local function teamItemSelect(tag , itemTag, itemIndex)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM)
	dataStream:writeShort(MSG_ITEM_3v3_BATTLE)
	dataStream:writeInt(itemTag)
    SCDataTransThread:getSingleton():transData(dataStream)
    local naviCtrl = getCurentSceneNavigationController()
    if naviCtrl then
		naviCtrl:removeWindowControllerByTag(5916)
    end
end

--对战队伍列表
local function showHitTeamList()
	local naviCtrl = getCurentSceneNavigationController()
	if not naviCtrl then
		return
	end
	local wnd = nil
	local wndCtrl = naviCtrl:getWindowControllerByTag(5916)
	if not wndCtrl then
		wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5916))
		local titleImg = getRealUIResourcePath("img/titile57.png")
		if titleImg then
			wnd:setTitleWithImage(titleImg:getData())
		end
		--wnd:setFrameVisibled(false)
		wndCtrl = SCWindowController:controllerWithWindow(wnd)
		naviCtrl:pushWindowController(wndCtrl)
		local list = tolua.cast(wnd:getChildByTag(3), "SCListBox")
		if list then
			list:luaSetSelectorOnItemSelected(teamItemSelect)
			for i=1, #m_teamInfo do
				if m_ownTeam ~= m_teamInfo[i].idTeam then --m_teamInfo[i].ucNum == 3 and 
					local dragNode = SCDragNode:node()
					dragNode:setDragEnabled(false)
					dragNode:setFrameVisibled(true)
					dragNode:setFrameType(EnumFrameTypeListNormal)
					dragNode:setContentSize(CCSizeMake(SX(195), SY(30)))
					local text = "*9".._LTParser("str2039").." "..m_teamInfo[i].szLeaderName
					local parNode = getItemTextNode(text)
					if parNode then
						parNode:setPosition(CCPointMake(SX(5), SY(10)))
						dragNode:addChild(parNode)
					end
					local text = "*9".._LTParser("str0013").." "..m_teamInfo[i].usLevel
					local parNode = getItemTextNode(text)
					if parNode then
						parNode:setPosition(CCPointMake(SX(125), SY(10)))
						dragNode:addChild(parNode)
					end
					list:addItem(dragNode)
					dragNode:setTag(m_teamInfo[i].idTeam)
				end
			end
		end
	end
end

--随机邀请
local function onBtnClikAutoInvite()
	if m_WndType == 0 then
		local  MSG_ITEM_INST_ADDUSER				= 83;--	//随机邀请
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
		dataStream:writeShort(MSG_ITEM_INST_ADDUSER);
		SCDataTransThread:getSingleton():transData(dataStream);
	elseif m_WndType == 1 then
		showHitTeamList()
	elseif m_WndType == 2 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
		dataStream:writeShort(MSG_TEAM_CALL_HELP);
		SCDataTransThread:getSingleton():transData(dataStream);
	end
end


--创建对窗口
local function onBtnCreateTeams(tag)

	showGuideStep(GUIDE_TYPE_MORECOPY, -1)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_TEAM_CREATE);
	dataStream:writeInt(0+Hero:getSingleton():getID());
	dataStream:writeInt(tag);
    SCDataTransThread:getSingleton():transData(dataStream);
    local naviCtrl =  getCurentSceneNavigationController();
	if  naviCtrl  then
	    naviCtrl:popWindowController();
    end
end
---选择可以参与队伍UI
local function ctrlEvent2037(tag, eventType)
	if eventType == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_MORECOPY, false)
		showGuideStep(GUIDE_TYPE_MORECOPY, 5, 5)
	elseif eventType == LuaControllerEventPopBegan or eventType == LuaControllerEventRemoveBegan then
		showGuideStep(GUIDE_TYPE_MORECOPY, -1)
	end
end
local function CreateCanJoinTeamWnd()
	local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("2037"));
    if wnd ~= nil  then
		return wnd
    end

	local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2037));
    if wnd == nil then
        return nil 
    end
    wnd:setTag(2037)
       -- create  window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wndCtrl:luaSetSelectorOnEvent(ctrlEvent2037)
     wnd:setBackgroundColor(colorWindowRedBG());
     
    --wnd:setTitle(_LTParser("str2040"))
    local imgPath = getRealUIResourcePath("img/titile41.png")
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);
    end
	
	return wnd
end
--创建队伍
local function onBtnClickCreateTeam()
	if m_WndType == 1 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
		dataStream:writeShort(MSG_TEAM_CREATE);
		dataStream:writeInt(0+Hero:getSingleton():getID())
		dataStream:writeInt(500000000)
		SCDataTransThread:getSingleton():transData(dataStream);
	elseif m_WndType == 3 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
		dataStream:writeShort(MSG_TEAM_CREATE);
		dataStream:writeInt(0+Hero:getSingleton():getID())
		dataStream:writeInt(800000000)
		SCDataTransThread:getSingleton():transData(dataStream);
    elseif m_WndType == 0 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
		dataStream:writeShort(MSG_TEAM_INSTS);
		dataStream:writeByte(1)
		SCDataTransThread:getSingleton():transData(dataStream);
		CreateCanJoinTeamWnd()
	elseif m_WndType == 2 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
		dataStream:writeShort(MSG_TEAM_INSTS);
		dataStream:writeByte(3)
		SCDataTransThread:getSingleton():transData(dataStream);
		--CreateCanJoinTeamWnd()
	end
end


---

---踢掉第一个成员
local function onClickedMember(tag)
    local Id = 0;    
    if tag == 23 then
    Id =MemberId1;
    elseif tag == 33 then
    Id = MemberId2;
    elseif tag == 13 then
    Id = MemberId0
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_TEAM_KICKOUT);
	dataStream:writeInt(Id);
    SCDataTransThread:getSingleton():transData(dataStream);
end
--创建队伍
local function ctrlEvent2036(tag, event)
	if event == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_MORECOPY, true);
		showGuideStep(GUIDE_TYPE_MORECOPY, 4, 4)
	elseif event == LuaControllerEventPopBegan then
		restartBeginnerGuide(GUIDE_TYPE_MORECOPY)
	end
end
local function createTeamWnd(type, num)
	local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("2036"));
    if wnd ~= nil  then
		if type == 1 and num then
			local node = wnd:getChildByTag(100)
			if node then
				node:removeChildByTag(10002, true)
				local text = string.format(_LTParser("str5135"), num)
				local parNode = getItemTextNode(text)
				parNode:setTag(10002)
				parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				parNode:setPosition(CCPointMake(node:getContentSize().width/2, node:getContentSize().height/2-SY(50)))
				node:addChild(parNode)
			end
		elseif type == 2 and num then
			local node = wnd:getChildByTag(100)
			if node then
				node:removeChildByTag(10002, true)
				local text = string.format(_LTParser("str5136"), num)
				local parNode = getItemTextNode(text)
				parNode:setTag(10002)
				parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				parNode:setPosition(CCPointMake(node:getContentSize().width/2, node:getContentSize().height/2-SY(50)))
				node:addChild(parNode)
			end
		elseif type == 3 and num then
			local node = wnd:getChildByTag(100)
			if node then
				node:removeChildByTag(10002, true)
				local text = string.format(_LTParser("str5136"), num)
				local parNode = getItemTextNode(text)
				parNode:setTag(10002)
				parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				parNode:setPosition(CCPointMake(node:getContentSize().width/2, node:getContentSize().height/2-SY(50)))
				node:addChild(parNode)
			end
		end
		return wnd
    end

	local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2036));
    if wnd == nil then
        return nil 
    end
    
    -- create  window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wndCtrl:luaSetSelectorOnEvent(ctrlEvent2036)
    wnd:setBackgroundColor(colorWindowRedBG());
    if type == 0 then
        local titlefile = getRealUIResourcePath("img/titile23.png")
        if titlefile then
            wnd:setTitleWithImage(titlefile:getData())
        end
    elseif type == 1 then
        --wnd:setTitle("3 V 3")
        local imgPath = getRealUIResourcePath("img/titile46.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
	elseif type == 2 then
		local imgPath = getRealUIResourcePath("img/titile63.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
	elseif type == 3 then
		local imgPath = getRealUIResourcePath("img/new00050.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
    end
    
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);
    end
	
	m_WndType = type
	
	local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5000", wnd))
	if pLabel then
		pLabel:setColor(color_green)
		pLabel:setVisible(false)
	end
	
	local node = SCFunction:getUiByZipAndId(2036, 100);
	if node then
		--node:setPosition(CCPoint(300*gUIScale().x, 150*gUIScale().y));
		wnd:addChild(node)
		if type == 1 and num then
			local node = wnd:getChildByTag(100)
			if node then
				node:removeChildByTag(10002, true)
				local text = string.format(_LTParser("str5135"), num)
				local parNode = getItemTextNode(text)
				parNode:setTag(10002)
				parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				parNode:setPosition(CCPointMake(node:getContentSize().width/2, node:getContentSize().height/2-SY(50)))
				node:addChild(parNode)
			end
		elseif type == 2 and num then
			local node = wnd:getChildByTag(100)
			if node then
				node:removeChildByTag(10002, true)
				local text = string.format(_LTParser("str5136"), num)
				local parNode = getItemTextNode(text)
				parNode:setTag(10002)
				parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				parNode:setPosition(CCPointMake(node:getContentSize().width/2, node:getContentSize().height/2-SY(50)))
				node:addChild(parNode)
			end
		elseif type == 3 and num then
			local node = wnd:getChildByTag(100)
			if node then
				node:removeChildByTag(10002, true)
				local text = string.format(_LTParser("str5136"), num)
				local parNode = getItemTextNode(text)
				parNode:setTag(10002)
				parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				parNode:setPosition(CCPointMake(node:getContentSize().width/2, node:getContentSize().height/2-SY(50)))
				node:addChild(parNode)
			end
		end
		
		local pTextBox = tolua.cast(node:getChildByTag(3), "SCTextBox")
		if pTextBox then
			pTextBox:setScrollVertical(false)
			if type == 1 then
				pTextBox:setText(_LTParser("str5086"))
			elseif type == 0 then
				pTextBox:setText(_LTParser("str5087"))
			elseif type == 2 then
				pTextBox:setText(_LTParser("str5102"))
			elseif type == 3 then
				pTextBox:setText(_LTParser("str5124"))
			end
		end
		
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5", node));
		if pBtn ~= nil then
			pBtn:luaSetSelectorOnClicked(onBtnClickCreateTeam);
			if type == 1 or type == 3 then
				pBtn:setTitle(_LTParser("str5088"), getDefaultFontName(), getFontSize(15), Button_Normal_Color)
			else
				pBtn:setTitle(_LTParser("str2040"), getDefaultFontName(), getFontSize(15), Button_Normal_Color)
			end
			pBtn:setAnchorPoint(CCPointMake(0.5, 0.5))
			pBtn:setPosition(CCPointMake(node:getContentSize().width/2, SY(25)))
		end
		
	end
	
	local node2 = SCFunction:getUiByZipAndId(2036, 101);
	if node2 then
	   -- node:setPosition(CCPoint(300, 6));
		wnd:addChild(node2)
		node2:setVisible(false)
		
		if type == 1 then
			local pLabel = node2:getChildByTag(5)
			if pLabel then
				pLabel:setVisible(false)
			end
		end
		
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-2-23"));
		if pBtn ~= nil then
			pBtn:luaSetSelectorOnClicked(onClickedMember);
			pBtn:setVisible(false);
		end
		
		local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-2-22"));
			if pLabel then
				pLabel:setVisible(false);
			end
		
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-3-33"));
		if pBtn ~= nil then
			pBtn:luaSetSelectorOnClicked(onClickedMember);
			pBtn:setVisible(false);
		end
		
		local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-3-32"));
		if pLabel then
			pLabel:setVisible(false);
		end
		
	end
 
	local pBgNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(2));
	if pBgNode then
		pBgNode:setFrameVisibled(true);
    	pBgNode:setFrameType(EnumFrameTypeRound);
		local pNode = SCTypeCast:castNodeToDragNode(pBgNode:getChildByTag(25));
		if pNode then
			pNode:setFrameVisibled(true);
			pNode:setFrameType(EnumFrameTypeListNormal);
		end
	end
	
	local pBgNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(5001));
	if pBgNode then
		pBgNode:setFrameVisibled(true);
    	pBgNode:setFrameType(EnumFrameTypeRound);
	end
	
	local pLabel = SCTypeCast:castNodeToLabel(wnd:getChildByTag(1));
	if pLabel then
		pLabel:setColor(color_lightYellow);
	end
	
	local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-23", node));
	if pLabel then
		--pLabel:setColor(colorGreen());
	--	pLabel:setVisible(false);
	end
	
	local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2-23", wnd));
	if pLabel then
		--pLabel:setColor(colorGreen());
		pLabel:setVisible(false);
	end
	
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-22", wnd));
	if pBtn ~= nil then
		pBtn:luaSetSelectorOnClicked(onBtnClickFastGame);
		--pBtn:setVisible(false);
	end
	
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-24", wnd));
	if pBtn ~= nil then
		pBtn:luaSetSelectorOnClicked(onBtnClickChangePar);
		pBtn:setVisible(false);
	end
	
	local pBgNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("101-8", wnd));
	if pBgNode then
		pBgNode:setFrameVisibled(true);
    	pBgNode:setFrameType(EnumFrameTypeListNormal);
	end
	local pBgNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("101-9", wnd));
	if pBgNode then
		pBgNode:setFrameVisibled(true);
    	pBgNode:setFrameType(EnumFrameTypeListNormal);
	end
	local pBgNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("101-10", wnd));
	if pBgNode then
		pBgNode:setFrameVisibled(true);
    	pBgNode:setFrameType(EnumFrameTypeListNormal);
	end
	local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("100-6", wnd));
	if pLabel then
		pLabel:setColor(color_lightYellow);
	end
	return wnd
end

local function ctrlEvent5926(tag, eventType)
	if event == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_MORECOPY, true)
		showGuideStep(GUIDE_TYPE_MORECOPY, 5, 5)
	elseif event == LuaControllerEventPopBegin then
		showGuideStep(GUIDE_TYPE_MORECOPY, -1)
	end
end

---可参与队伍列表
local function createInits(tmp)
	if m_WndType == 0 then
		local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("2037"));
		if wnd == nil  then
			return 
		end
		local Tb = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("1-0", wnd));
		if Tb ~= nil then
			for i = 1, tmp.ucAmount do
				local pCell =Tb:getChildByTag(i - 1);
				if pCell ~= nil then
					local filePath = getRealUIResourcePath("img/"..tmp.InstInfo[i].nPhoto..".png")
					if not filePath then
						filePath = getRealUIResourcePath("img/3100028.png")
					end
					if filePath then
						local file = getRealUIResourcePath("img/img2024.png")
						if file then
							local backImg = SCImage:imageWithFile(file:getData())
							backImg:setAnchorPoint(CCPointMake(0.5, 0.5))
							backImg:setPosition(CCPointMake(pCell:getContentSize().width/2, pCell:getContentSize().height/2))
							pCell:addChild(backImg)
						end
						local btn = SCButton:button()
						btn:setTag(tmp.InstInfo[i].idInst)
						if tmp.InstInfo[i].usNeedLev > Hero:getSingleton():getLeval() then
							btn:setTitle(file:getData())
						else
							btn:setTitle(filePath:getData())
							if tmp.InstInfo[i].ucflag == 1 then
								local file1 = getRealUIResourcePath("img/img2097.png")
								if file1 then
									local koImg = SCImage:imageWithFile(file1:getData())
									koImg:setAnchorPoint(CCPointMake(0.5, 0.5))
									koImg:setPosition(CCPointMake(btn:getContentSize().width/2, btn:getContentSize().height/2+SY(5)))
									btn:addChild(koImg)
								end
							else
								btn:luaSetSelectorOnClicked(onBtnCreateTeams)
							end
						end
						btn:setAnchorPoint(CCPointMake(0.5, 0.5))
						btn:setPosition(CCPointMake(pCell:getContentSize().width/2, pCell:getContentSize().height/2))
						local label = SCLabel:labelWithStringFont(tmp.InstInfo[i].stfill, getDefaultFontName(), getFontSize(12))
						if label then
							label:setAnchorPoint(CCPointMake(0.5, 0.5))
							label:setPosition(btn:getContentSize().width/2, label:getContentSize().height/2+SY(20))
							btn:addChild(label)
						end
						local label = SCLabel:labelWithStringFont(tmp.InstInfo[i].usNeedLev.._LTParser("str0266"), getDefaultFontName(), getFontSize(12))
						if label then
							label:setAnchorPoint(CCPointMake(0.5, 0.5))
							label:setPosition(btn:getContentSize().width/2, label:getContentSize().height/2+SY(5))
							btn:addChild(label)
						end
						pCell:addChild(btn)
					end
				end
			end
		end
		--[[
		local Tb = SCTypeCast:castNodeToTable(SCFunction:getUiNodeByIdlistAndParent("1-0", wnd));
		if Tb ~= nil then
			for i = 1, tmp.ucAmount do
				local pCell =SCTypeCast:castNodeToTable(Tb:getChildByTag(i - 1));
				if pCell ~= nil then
					local node = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(2037, 104));
		
					if node ~= nil then 
						   local btn1 = SCButton:button();
						   --btn1:setTitle(strFile:getData())
						   --btn1:setPosition(CCPoint(20, -btn1:getContentSize().height));
						   btn1:luaSetSelectorOnClicked(onBtnCreateTeams);
						   btn1:setContentSize(pCell:getContentSize())
						   btn1:setTag(tmp.InstInfo[i].idInst)
						   pCell:addChild(btn1);
						   local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1", node));
						   if pLabel then
							--	pLabel:setColor(colorOrange());
								pLabel:setText(tmp.InstInfo[i].stfill);
						   end
						   
							local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", node));
						   if pLabel then
							--	pLabel:setColor(colorOrange());
								pLabel:setText(_LTParser("str2041")..tmp.InstInfo[i].usNeedLev.._LTParser("str2042"));
						   end
							node:setFrameType(EnumFrameTypeLine);
							node:setFrameVisibled(true);
							pCell:addChild(node);
						   --node:setBackgroundColor(colorOrange())
						   --pCell:setBackgroundColor(ccc4(255, 10 * i, 100, 255))
					end
				end
			end
		end
		]]
	
	elseif m_WndType == 2 then
		local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5926));
		if wnd == nil  then
			return 
		end
		local imgPath = getRealUIResourcePath("img/titile41.png")
		if imgPath then
			wnd:setTitleWithImage(imgPath:getData());
		end
		local pageBox = SCTypeCast:castNodeToPageScrollBox(wnd:getChildByTag(2))
		if not pageBox then
			return
		end
		pageBox:setPageSize(CCSizeMake(325*gUIScale().x, 170*gUIScale().y))
		local pageHint = tolua.cast(wnd:getChildByTag(3), "SCPageHint")
		if pageHint then
			pageHint:setBoundPageScrollBox(pageBox)
		end
		local pageCount = 0
		local pageWidth = 325*gUIScale().x
		local pageHeight = 170*gUIScale().y
		
		for i = 1, tmp.ucAmount do
			if not tmp.InstInfo[i+1] or getIntPart(tmp.InstInfo[i].idInst/10) ~= getIntPart(tmp.InstInfo[i+1].idInst/10) then
				pageCount = pageCount + 1
				pageBox:setContentSize(CCSizeMake(pageWidth*pageCount, pageHeight))
				local pageNode = SCNode:node()
				pageNode:setTag(pageCount)
				pageNode:setContentSize(CCSizeMake(pageWidth, pageHeight))
				pageNode:setPosition(CCPointMake(pageWidth*(pageCount-1), 0))
				pageBox:addChild(pageNode)

				local node = tolua.cast(SCFunction:getUiByZipAndId(5926, 100), "SCImage")
				if node then
					node:setPosition(pageWidth/2, pageHeight/2)
					pageNode:addChild(node)
					
					local label = SCTypeCast:castNodeToLabel(node:getChildByTag(5))
					if label then
						label:setColor(color_skyBlue)
						label:setText(_LTParser("str0003")..tmp.InstInfo[i].usNeedLev.._LTParser("str0266"))
					end
					local label = SCTypeCast:castNodeToLabel(node:getChildByTag(6))
					if label then
						label:setColor(color_skyBlue)
						label:setText(_LTParser("str5104")..":")
					end
					local parNode = ParsedNode:getParsedNode("*4"..tmp.InstInfo[i].desStr, 0, 12)
					if parNode then
						parNode:setAnchorPoint(CCPointMake(0, 1))
						parNode:setPosition(CCPointMake(SX(155), SY(103)))
						node:addChild(parNode)
					end
					local imgNode = SCTypeCast:castNodeToImage(node:getChildByTag(1))
					if imgNode then
						local file = getRealUIResourcePath("img/"..tmp.InstInfo[i].nPhoto..".png")
						if file then
							imgNode:setImage(file:getData())
						end
						local parNode = ParsedNode:getParsedNode("*5"..tmp.InstInfo[i].stfill, 0, 12)
						if parNode then
							parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
							parNode:setPosition(CCPointMake(imgNode:getContentSize().width/2, SY(25)))
							imgNode:addChild(parNode)
						end
					end
					
					local tmpCount = 1
					for j=tmp.InstInfo[i].idInst%10, 1, -1 do
						local btn = SCTypeCast:castNodeToButton(node:getChildByTag(j+1))
						if btn then
							local file = getRealUIResourcePath("img/img"..(8006+(j-1)*2)..".png")
							if file then
								btn:setTitle(file:getData())
								btn:setTag(tmp.InstInfo[i-tmpCount+1].idInst)
								btn:luaSetSelectorOnClicked(onBtnCreateTeams)
							end
						end
						tmpCount = tmpCount + 1
					end
				end

			end
		end
		local wndCtrl = SCWindowController:controllerWithWindow(wnd)
		if not wndCtrl then
			return
		end
		wndCtrl:luaSetSelectorOnEvent(ctrlEvent5926)
		local naviCtrl =  getCurentSceneNavigationController()
		if not naviCtrl then
			return
		end
		naviCtrl:pushWindowController(wndCtrl)
	end
	
end
--窗口关闭
local function onWndClose()
--[[
    if Hero:getSingleton():iSATeamLeader() == true then
         local  MSG_TEAM_QUIT						= 11;--	// 解散队伍
         local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
         dataStream:writeShort(MSG_TEAM_QUIT);
         dataStream:writeInt(0+Hero:getSingleton():getID());
         SCDataTransThread:getSingleton():transData(dataStream);
    elseif Hero:getSingleton():isATeamMember() == true then
         local	MSG_TEAM_LEAVE						= 1;	--// 成员离队(包括队长)
         local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
         dataStream:writeShort(MSG_TEAM_LEAVE);
         dataStream:writeInt(0+Hero:getSingleton():getID());
         SCDataTransThread:getSingleton():transData(dataStream);
    end
   -- ]]
    MemberId0 = 0;
    MemberId1 = 0;
    MemberId2 = 0;
    m_teamInfo = {};
    m_ownTeam = 0
	m_peiDuiFlag = false
	m_countTime = 0
	if m_entryId then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		m_entryId = nil
	end
    local closeAction = MSG_TEAM_CLOSE_INST_TEAM
    if m_WndType == 1 then
		closeAction = MSG_TEAM_CLOSE_ARENA3V3
	elseif m_WndType == 2 then
		closeAction = MSG_TEAM_CLOSE_TRIBE_INST_TEAM
	elseif m_WndType == 3 then
		closeAction = MSG_TEAM_CLOSE_PANDORA
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(closeAction);
	dataStream:writeInt(0+Hero:getSingleton():getID());
    SCDataTransThread:getSingleton():transData(dataStream);
	m_WndType = 0
end

--[[local	MSG_TEAM_OPEN_INST_TEAM				= 74;--	//打开多人副本主界面
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_TEAM_OPEN_INST_TEAM);
	dataStream:writeInt(0+Hero:getSingleton():getID());
    SCDataTransThread:getSingleton():transData(dataStream);
    ]]
    ---加入队伍
local function unSelset(tag, itemTag, itemIndex)
	local node = tolua.cast(SCFunction:getUiNodeByIdlist("2036-2-21-"..itemTag), "SCDragNode");
    
	if node then
		node:setFrameType(EnumFrameTypeListNormal)
		node:setFrameVisibled(true)
	end
end
    ----加入队伍
	local function joinInTeam(tag, itemTag, itemIndex)
	local node = tolua.cast(SCFunction:getUiNodeByIdlist("2036-2-21-"..itemTag), "SCDragNode");
    
	if node then
		node:setFrameType(EnumFrameTypeListSelect)
		node:setFrameVisibled(true)
	end
    
	if node ~= nil then
		local pLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(100))
		if pLabel then
			local idI = 0 + pLabel:getText();
	        local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
            dataStream:writeShort(MSG_TEAM_JOIN_TEAM);
            dataStream:writeInt(idI);
            SCDataTransThread:getSingleton():transData(dataStream);
		end
	end
 end
---已经创建队伍列表
local function createTmams(tmp)
	local wnd = createTeamWnd(0)
	if wnd == nil then
		return
	end
	
	wnd:luaSetSelectorOnClose(onWndClose)
	
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-4"));
	if pBtn ~= nil then
		pBtn:luaSetSelectorOnClicked(onBtnClikAutoInvite);
		--pBtn:setVisible(false);
		if m_WndType == 1 then
			pBtn:setTitle(_LTParser("str5089"), getDefaultFontName(), getFontSize(15), Button_Normal_Color)
		elseif m_WndType == 0 then
			pBtn:setTitle(_LTParser("str5090"), getDefaultFontName(), getFontSize(15), Button_Normal_Color)
		elseif m_WndType == 2 then
			pBtn:setTitle(_LTParser("str5103"), getDefaultFontName(), getFontSize(15), Button_Normal_Color)
		end
	end
	
	local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-5"));
	if label then
		if m_WndType == 1 or m_WndType == 2 then
			label:setVisible(false)
		end
	end
	
	local list = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("2036-2-21"));
	if list == nil then
		return 
	end
	if list:itemCount() > 0 then
		for i = -13, -11 do
			if list:getChildByTag(i) then
				list:removeItemAtIndex(-11-i)
			end
		end
	end
	list:luaSetSelectorOnItemSelected(joinInTeam)
	list:luaSetSelectorOnItemUnSelected(unSelset)		
	for i = 1,  tmp.ucAmount do 
		if m_WndType == 0 then
			local node = tolua.cast(SCFunction:getUiByZipAndId(2036, 103), "SCDragNode");
			if node then
				node:setFrameType(EnumFrameTypeListNormal)
				node:setFrameVisibled(true)
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1", node));
				if pLabel then
					pLabel:setColor(colorOrange());
					pLabel:setText(tmp.InstTeam[i].szInstName);
				end
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", node));
				if pLabel then
					pLabel:setVisible(false)
					--pLabel:setColor(colorOrange());
					pLabel:setText(""..tmp.InstTeam[i].usLevel);
				end
				
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", node));
				if pLabel then
				--	pLabel:setColor(colorOrange());
					pLabel:setText(_LTParser("str2037")..tmp.InstTeam[i].ucNum.._LTParser("str2038"));
				end
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", node));
				if pLabel then
					if tmp.InstTeam[i].byType == 1 then
						pLabel:setText(_LTParser("str2044"))
						pLabel:setColor(colorSkyBlue());
					else
						pLabel:setText(_LTParser("str2045"))  
						pLabel:setColor(colorGreen());
					end
					local bBl = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7", node));
					if bBl then
						if   tmp.InstTeam[i].ucNum   == 3 then
							pLabel:setVisible(false)
							bBl:setColor(colorRed());
							bBl:setVisible(true)
						else
							pLabel:setVisible(true)
							bBl:setVisible(false)
						end
					end
				end
						
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", node));
				if pLabel then
					--pLabel:setColor(colorOrange());
					local parnode = getItemTextNode(tmp.InstTeam[i].szAward);
					parnode:setPosition(pLabel:getPosition());
					node:addChild(tolua.cast(parnode, "SCNode"));
					
					pLabel:setText(tmp.InstTeam[i].szAward);
					pLabel:setVisible(false)
				end
				

				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5", node));
				if pLabel then
				--	pLabel:setColor(colorOrange());
					pLabel:setText(_LTParser("str2039")..tmp.InstTeam[i].szLeaderName);
				end
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("100", node));
				if pLabel then
					pLabel:setText(""..tmp.InstTeam[i].idTeam);
					pLabel:setVisible(false);
				end
				list:addItem(node)
			end
		elseif m_WndType == 2 then
			local node = tolua.cast(SCFunction:getUiByZipAndId(2036, 106), "SCDragNode");
			if node then
				node:setFrameType(EnumFrameTypeListNormal)
				node:setFrameVisibled(true)
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1", node));
				if pLabel then
					pLabel:setColor(colorOrange());
					pLabel:setText(tmp.InstTeam[i].szInstName);
				end
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", node));
				if pLabel then
				--	pLabel:setColor(colorOrange());
					pLabel:setText(_LTParser("str2037")..tmp.InstTeam[i].ucNum.._LTParser("str2038"));
				end
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", node));
				if pLabel then
				--	pLabel:setColor(colorOrange());
					local text = _LTParser("str5105")..":"
					if tmp.InstTeam[i].idInst%10 == 1 then
						text = text.._LTParser("str5106")
					elseif tmp.InstTeam[i].idInst%10 == 2 then
						text = text.._LTParser("str5107")
					else
						text = text.._LTParser("str5108")
					end
					pLabel:setText(text);
				end
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5", node));
				if pLabel then
				--	pLabel:setColor(colorOrange());
					pLabel:setText(_LTParser("str2039")..tmp.InstTeam[i].szLeaderName)
				end
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", node));
				if pLabel then
					if tmp.InstTeam[i].byType == 1 then
					   pLabel:setText(_LTParser("str2044"))
					   pLabel:setColor(colorSkyBlue());
					else
					   pLabel:setText(_LTParser("str2045"))  
					   pLabel:setColor(colorGreen());
					end
					local bBl = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7", node));
					if bBl then
						if   tmp.InstTeam[i].ucNum   == 3 then
							pLabel:setVisible(false)
							bBl:setColor(colorRed());
							bBl:setVisible(true)
						else
							pLabel:setVisible(true)
							bBl:setVisible(false)
						end
					end
				end
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("100", node));
				if pLabel then
					pLabel:setText(""..tmp.InstTeam[i].idTeam);
					pLabel:setVisible(false);
				end
				list:addItem(node)
			end
		elseif m_WndType == 1 or m_WndType == 3 then
			local node = tolua.cast(SCFunction:getUiByZipAndId(2036, 105), "SCDragNode");
			if node then
				node:setFrameType(EnumFrameTypeListNormal)
				node:setFrameVisibled(true)
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1", node));
				if pLabel then
					pLabel:setColor(colorOrange());
					pLabel:setText(_LTParser("str2039")..tmp.InstTeam[i].szLeaderName);
				end
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", node));
				if pLabel then
					pLabel:setColor(colorOrange());
					pLabel:setText(_LTParser("str0013").." "..tmp.InstTeam[i].usLevel);
				end
				
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", node));
				if pLabel then
				--	pLabel:setColor(colorOrange());
					pLabel:setText(_LTParser("str2037")..tmp.InstTeam[i].ucNum.._LTParser("str2038"));
				end
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", node));
				if pLabel then
					if tmp.InstTeam[i].byType == 1 then
					   pLabel:setText(_LTParser("str2044"))
					   pLabel:setColor(colorSkyBlue());
					else
					   pLabel:setText(_LTParser("str2045"))  
					   pLabel:setColor(colorGreen());
					end
					local bBl = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7", node));
					if bBl then
						if   tmp.InstTeam[i].ucNum   == 3 then
							pLabel:setVisible(false)
							bBl:setColor(colorRed());
							bBl:setVisible(true)
						else
							pLabel:setVisible(true)
							bBl:setVisible(false)
						end
					end
				end
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("100", node));
				if pLabel then
					pLabel:setText(""..tmp.InstTeam[i].idTeam);
					pLabel:setVisible(false);
				end
				list:addItem(node)
			end
		--elseif m_WndType == 3 then
		end
	end
	for i = list:itemCount()+1, 3 do
			local node = tolua.cast(SCFunction:getUiByZipAndId(2036, 103), "SCDragNode");
			if node then
				node:setFrameType(EnumFrameTypeListNormal)
				node:setFrameVisibled(true)
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1", node));
				if pLabel then
					pLabel:setVisible(false)
				end
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", node));
				if pLabel then
					pLabel:setVisible(false)
				end
				
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", node));
				if pLabel then
					pLabel:setVisible(false)
				end
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", node));
				if pLabel then
					pLabel:setVisible(false)
					local bBl = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7", node));
					if bBl then
						bBl:setVisible(false)
					end
				end
						
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", node));
				if pLabel then
					pLabel:setVisible(false)
				end
				

				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5", node));
				if pLabel then
					pLabel:setVisible(false)
				end
				
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("100", node));
				if pLabel then
					pLabel:setVisible(false)
				end
				list:addItem(node)
				node:setTag(-10-i)
			end
	end
end

----删除队伍
local function delTeam(id)
	local list = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("2036-2-21"));
	if list == nil then
		return 
	end
	if list:itemCount() > 0 then
		for i = -13, -11 do
			if list:getChildByTag(i) then
				list:removeItemAtIndex(-11-i)
			end
		end
	end
	for i = 1, list:getChildrenCount() do
	    local node = list:getChildByTag(i - 1);
	    if node then
	        local pLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(100))
	        if pLabel then
	            local idI = 0 + pLabel:getText();
	            if idI == id then
	                list:removeItemAtIndex(i - 1);
	                return
	            end
	        end
        end
	end
	for i = list:itemCount()+1, 3 do
		local node = tolua.cast(SCFunction:getUiByZipAndId(2036, 103), "SCDragNode");
		if node then
			node:setFrameType(EnumFrameTypeListNormal)
			node:setFrameVisibled(true)
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1", node));
			if pLabel then
				pLabel:setVisible(false)
			end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", node));
			if pLabel then
				pLabel:setVisible(false)
			end
			
				
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", node));
			if pLabel then
				pLabel:setVisible(false)
			end
				
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", node));
			if pLabel then
				pLabel:setVisible(false)
				local bBl = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7", node));
				if bBl then
					bBl:setVisible(false)
				end
			end
					
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4", node));
			if pLabel then
				pLabel:setVisible(false)
			end
				

			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5", node));
			if pLabel then
				pLabel:setVisible(false)
			end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("100", node));
			if pLabel then
				pLabel:setVisible(false)
			end
			list:addItem(node)
			node:setTag(-10-i)
		end
	end
end

--转换队长
local function changeTeamLeader(dt)
	if m_WndType == 3 then
		local id = dt:readInt()
		if id == Hero:getSingleton():getID() then
			local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("5939-6"))
			if btn and m_pandorStartFlag then
				btn:setVisible(true)
			end
		end
	else
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-4"))
		if pBtn  then---随机邀请按钮隐藏
			pBtn:setVisible(true);
		end    
               
            local plb = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-5"))
            if plb  then---隐藏
				if not m_WndType == 0 then
					plb:setVisible(false);
				else
					plb:setVisible(true);
				end
			end                
             
            local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-6"))
            if pBtn  then--改成阵型
				--pBtn:setTitle(_LTParser("str2046"),getDefaultFontName(), getFontSize(15))
				pBtn:setTitle(_LTParser("str2043"),getDefaultFontName(), getFontSize(15));
                pBtn:luaSetSelectorOnClicked(onClickFormation)
                -- pBtn:setVisible(false);("str2039")
			end 
			
			local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-7"));
            if pBtn  then---随机邀请按钮隐藏
				-- pBtn:setTitle(_LTParser("str2043"));
                pBtn:setVisible(true);
                pBtn:luaSetSelectorOnClicked(startPlay)
				if m_WndType == 1 then
					pBtn:setTitle(_LTParser("str5091"),getDefaultFontName(), getFontSize(15))
				else
					pBtn:setTitle(_LTParser("str5092"),getDefaultFontName(), getFontSize(15))
                end
			end 
	end
end

------解散队伍
local function onTeamQuit()
	MemberId0 = 0;
	MemberId1 = 0;
	MemberId2 = 0;
	if m_WndType == 3 then
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl and not m_PandoraBombFlag then
			naviCtrl:removeWindowControllerByTag(5939)
		end
	else
		local node = SCFunction:getUiNodeByIdlist("2036-100");
		if node ~=nil then
			node:setVisible(true)  
		end

		local node = SCFunction:getUiNodeByIdlist("2036-101");
		if node ~= nil then
			node:setVisible(false)  
		end
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-2-23"));
		if pBtn ~= nil then
			pBtn:luaSetSelectorOnClicked(onClickedMember);
			pBtn:setVisible(false);
		end
		
		local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-2-22"));
			if pLabel then
				pLabel:setVisible(false);
			end
		
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-3-33"));
		if pBtn ~= nil then
			pBtn:luaSetSelectorOnClicked(onClickedMember);
			pBtn:setVisible(false);
		end
		
		local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-3-32"));
			if pLabel then
				pLabel:setVisible(false);
			end
		 
		 
		local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-2-23"));
		if pLabel then
			--pLabel:setColor(colorGreen());
			pLabel:setVisible(false);
		end

		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-2-24"));
		if pBtn ~= nil then
			pBtn:luaSetSelectorOnClicked(onBtnClickChangePar);
			pBtn:setVisible(false);
		end
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-2-22"));
		if pBtn ~= nil then
			pBtn:setVisible(true);
		end
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl then
			naviCtrl:removeWindowControllerByTag(5911)
			naviCtrl:removeWindowControllerByTag(5912)
		end
		local pface = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("2036-101-2"))
		if pface then
			pface:removeChildByTag(1, true)
		end
		local pface = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("2036-101-3"))
		if pface then
			pface:removeChildByTag(1, true)
		end
		local pface = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("2036-101-1"))
		if pface then
			pface:removeChildByTag(1, true)
		end
	end
end

---队员离开队伍
local function onMemberLeaveTeam(id)

	if m_pandorReadyFlag and m_pandorReadyFlag[id] then
		m_pandorReadyFlag[id] = nil
	end
    if id == MemberId2 then
         MemberId2 = 0
		if m_WndType == 3 then
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5939-7-31"));
			if pImg  then
				pImg:removeChildByTag(1, true)
			end
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5939-7-34"));
			if pImg  then
				pImg:setVisible(false)
			end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("5939-7-32"));
			if pLabel then
				pLabel:setText(" ")
			end
		else
			local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-3-33"));
			if pBtn ~= nil then
				pBtn:luaSetSelectorOnClicked(onClickedMember);
				pBtn:setVisible(false);
			end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-3-32"));
				if pLabel then
					pLabel:setVisible(false);
				end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-3-31"));
				if pLabel then
					pLabel:setVisible(true);
				end
			local pface = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("2036-101-3"))
			if pface then
				pface:removeChildByTag(1, true)
			end
		end
    elseif id == MemberId1 then
        MemberId1 = 0 
		if m_WndType == 3 then
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5939-7-21"));
			if pImg  then
				pImg:removeChildByTag(1, true)
			end
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5939-7-24"));
			if pImg  then
				pImg:setVisible(false)
			end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("5939-7-22"));
			if pLabel then
				pLabel:setText(" ")
			end
		else
			local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-2-23"));
			if pBtn ~= nil then
				pBtn:luaSetSelectorOnClicked(onClickedMember);
				pBtn:setVisible(false);
			end
				
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-2-22"));
			if pLabel then
				pLabel:setVisible(false);
			end
				
				
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-2-21"));
			if pLabel then
				pLabel:setVisible(true);
			end
			local pface = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("2036-101-2"))
			if pface then
				pface:removeChildByTag(1, true)
			end
		end
	elseif id == MemberId0 then
		MemberId0 = 0
		if m_WndType == 3 then
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5939-7-11"));
			if pImg  then
				pImg:removeChildByTag(1, true)
			end
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5939-7-14"));
			if pImg  then
				pImg:setVisible(false)
			end				
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("5939-7-12"));
			if pLabel then
				pLabel:setText(" ")
			end
		else
			local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-101-1-13"));
			if pBtn ~= nil then
				pBtn:luaSetSelectorOnClicked(onClickedMember);
				pBtn:setVisible(false);
			end
				
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-1-12"));
			if pLabel then
				pLabel:setVisible(false);
			end
				
				
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-101-1-11"));
			if pLabel then
				pLabel:setVisible(true);
			end
			local pface = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("2036-101-1"))
			if pface then
				pface:removeChildByTag(1, true)
			end
		end
	end
	
	if id == 0+Hero:getSingleton():getID() then
		onTeamQuit()
	end
end
---更新自己队伍信息
local function updateWndForMeTeam(dt)	--//所在队伍变更
      local idTeam = dt:readInt()
        local ucNUm = dt:readByte()
        local scStr = dt:readString() --奖励
        local szLeaderName = nil
        if scStr == nil then
            szLeaderName = ""
        else
            szLeaderName = scStr:getData()
        end
        local byType = dt:readByte()
         local list = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("2036-2-21"));
	    if list == nil then
		return 
	    end
	    for i = 1, list:getChildrenCount() do
	    local node = list:getChildByTag(i - 1);
	    if node then
	        local pLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(100))
	        if pLabel then
	            local idI = 0 + pLabel:getText();
	            if idI == idTeam then
	               -- list:removeItemAtIndex(i - 1);
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", node));
			if pLabel then
			--	pLabel:setColor(colorOrange());
				pLabel:setText(_LTParser("str2037")..ucNUm.._LTParser("str2038"));
			end
			
			  local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", node));
                if pLabel then
                if byType == 1 then
                     pLabel:setText(_LTParser("str2044"))
                     pLabel:setColor(colorSkyBlue());
                    --pLabel:setVisible(true)
			     else
			        --pLabel:setVisible(false)
			        pLabel:setText(_LTParser("str2045"))
			        pLabel:setColor(colorGreen());
			     end
			     
			         local bBl = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7", node));
                    if bBl then
                      if   ucNUm   == 3 then
                            pLabel:setVisible(false)
                            bBl:setVisible(true)
                            bBl:setColor(colorRed());
                      else
                            pLabel:setVisible(true)
                            bBl:setVisible(false)
                      end
                     end
                end



			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5", node));
			if pLabel then
			--	pLabel:setColor(colorOrange());
				pLabel:setText(_LTParser("str2039")..szLeaderName);
			end
	
	      
	
	          
	                return
	            end
	        end
        end
	end
        
        
end
---更新队伍列表信息
local function updateWnd(dt)
        --	//多人副本组队更新
        local idTeam = dt:readInt()
        local ucNUm = dt:readByte()
        local scStr = dt:readString() --奖励
        local szLeaderName = nil
        if scStr == nil then
            szLeaderName = ""
        else
            szLeaderName = scStr:getData()
        end
        
		for i=1, #m_teamInfo do
			if m_teamInfo[i].idTeam == idTeam then
				m_teamInfo[i].ucNum = ucNUm
				m_teamInfo[i].szLeaderName = szLeaderName
			end
        end
        
   local list = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("2036-2-21"));
	if list == nil then
		return 
	end
	for i = 1, list:getChildrenCount() do
	    local node = list:getChildByTag(i - 1);
	    if node then
	        local pLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(100))
	        if pLabel then
	            local idI = 0 + pLabel:getText();
	            if idI == idTeam then
	               -- list:removeItemAtIndex(i - 1);
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", node));
			if pLabel then
			--	pLabel:setColor(colorOrange());
				pLabel:setText(_LTParser("str2037")..ucNUm.._LTParser("str2038"));
			end
			
		 local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", node));
                if pLabel then
			         local bBl = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7", node));
                    if bBl then
                      if   ucNUm   == 3 then
                            pLabel:setVisible(false)
                            bBl:setVisible(true)
                            bBl:setColor(colorRed());
                      else
                            pLabel:setVisible(true)
                            bBl:setVisible(false)
                      end
                     end
                end


			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5", node));
			if pLabel then
			--	pLabel:setColor(colorOrange());
				pLabel:setText(_LTParser("str2039")..szLeaderName);
			end
	
	          
	                return
	            end
	        end
        end
	end
end
--刷新潘多拉盒子
local refreshPandoraBox
local function pandorTimeCount(float)
	if m_pandorSleepFlag then
		m_pandorSleepFlag = m_pandorSleepFlag + 1
		if m_pandorSleepFlag == 2 then
			m_pandorSleepFlag = nil
			refreshPandoraBox(nil, m_pandoraBoxFlags)
		end
	end
	local timeLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("5939-8"))
	if not timeLabel then
		return
	end
	if m_countTime == 0 then
		return
	end
	m_countTime = m_countTime - 1
	if m_countTime<=3 then
		timeLabel:setColor(color_red)
	else
		timeLabel:setColor(color_lightYellow)
	end
	timeLabel:setText(m_countTime.."")
	if m_countTime == 0 then
		for i=2, 5 do
			local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("5939-"..i))
			if btn then
				if btn:isVisible() and btn:isTouchEnabled() then
					if m_pandoraOpenFlag then
						local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM)
						dataStream:writeShort(MSG_TEAM_PANDORA_CHANGE)
						dataStream:writeByte(i-2)
						SCDataTransThread:getSingleton():transData(dataStream)
						--SCActivityIndicator:getSingleton():show()
						m_pandoraOpenFlag = false
					end
					break
				end
			end
		end
		timeLabel:setVisible(false)
	end
end
function refreshPandoraBox(dt, boxFlags)
	m_pandorStartFlag = true
	local pWnd = getCurentSceneWindow(5939)
	if not pWnd then
		return
	end
	if m_PandoraBombFlag then
		m_pandoraBoxFlags = stPandoraBox.initWithStream(dt)
		return
	end
	if dt then
		boxFlags = stPandoraBox.initWithStream(dt)
		if boxFlags.newTurnFlag == 1 and m_entryId ~= nil then
			m_pandoraBoxFlags = boxFlags
			m_pandorSleepFlag = 0
			return
		end
	end
	if boxFlags.newTurnFlag == 1 then
		m_pandorTurnFLag = m_pandorTurnFLag + 1
	end
	local turnLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("5939-9"))
	if turnLabel then
		turnLabel:setVisible(true)
		turnLabel:setText(string.format(_LTParser("str5133"), m_pandorTurnFLag))
	end
	if boxFlags.roleId == Hero:getSingleton():getID() then
		m_pandoraOpenFlag = true
	end
	for i=1, 3 do
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("7-"..(i*10+3), pWnd))
		if img then
			img:setVisible(false)
		end
	end
	if MemberId1 == boxFlags.roleId then
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("7-23", pWnd))
		if img then
			img:setVisible(true)
		end
	elseif MemberId2 == boxFlags.roleId then
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("7-33", pWnd))
		if img then
			img:setVisible(true)
		end
	elseif MemberId0 == boxFlags.roleId then
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("7-13", pWnd))
		if img then
			img:setVisible(true)
		end
	end
	local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("6", pWnd))
	if btn then
		btn:setVisible(false)
	end
	for i=2, 5 do
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(i.."", pWnd))
		if btn then
			btn:setVisible(false)
		end
	end
	for i=1, boxFlags.ucAmount do
		local boxFlag = boxFlags.boxFlag[i]
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent((i+1).."", pWnd))
		if btn then
			btn:setVisible(true)
			if boxFlag == 0 then
				local file = getRealUIResourcePath("img/new000"..(i*2+9)..".png")
				if file then
					btn:setTitle(file:getData())
					btn:setTouchEnabled(true)
				end
			else
				local file = getRealUIResourcePath("img/new000"..(i*2+8)..".png")
				if file then
					btn:setTitle(file:getData())
					btn:setTouchEnabled(false)
				end
			end
		end
	end
	
	m_countTime = 10
	local timeLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("5939-8"))
	if timeLabel then
		timeLabel:setVisible(true)
		timeLabel:setColor(color_lightYellow)
		timeLabel:setText(m_countTime.."")
	end
	if m_entryId == nil then
		m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(pandorTimeCount, 1.0, false)
	end
	m_pandoraBoxFlags = nil
end
--开到潘多拉
local function onMessageWndBtnClick(tag)
	if tag == 1 then
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl and not m_PandoraBombFlag then
			naviCtrl:removeWindowControllerByTag(5939)
		end
	end
end

local function aniEnd1181(tag)
	local pWnd = getCurentSceneWindow(5939)
	if pWnd then
		pWnd:removeChildByTag(5000, true)
	end
	m_PandoraBombFlag = false
	if m_pandorEndFlag == 0 then
		refreshPandoraBox(nil, m_pandoraBoxFlags)
	elseif m_pandorEndFlag == 1 then
		luashowConfirmationWindow(m_pandorShowMsg, WIN_YES, onMessageWndBtnClick)
	end
	--[[
	local naviCtrl = getCurentSceneNavigationController()
	if naviCtrl and not m_PandoraBombFlag then
		naviCtrl:removeWindowControllerByTag(5939)
	end
	]]
end
local function refreshPandoraBomb(dt)
	local pWnd = getCurentSceneWindow(5939)
	if not pWnd then
		return
	end
	m_pandorTurnFLag = 1
	m_countTime = 0
	local timeLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("5939-8"))
	if timeLabel then
		timeLabel:setVisible(false)
	end
	m_PandoraBombFlag = true
	local boxId = dt:readByte()
	local playId = dt:readInt()
	m_pandorEndFlag = dt:readByte()
	m_pandorShowMsg = dt:readString()
	if m_pandorShowMsg then
		m_pandorShowMsg = m_pandorShowMsg:getData()
		if m_pandorEndFlag == 0 then
			luashowConfirmationWindow(m_pandorShowMsg, WIN_AUTO_CLOSE)
		end
	end
	
	local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1182, 1182);
	if pAi then
		local pNode =  SCAnimationNode:nodeWithAnimation(pAi);
		pNode:setTag(5000)
		pNode:setAnchorPoint(CCPointMake(0, 1))
		pNode:setPosition(CCPointMake(SX(5), pWnd:getContentSize().height-SY(5)))
		pWnd:addChild(pNode)
	end
	local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent((boxId+2).."", pWnd))
	if btn then
		local file = getRealUIResourcePath("img/new000"..((boxId+1)*2+8)..".png")
		if file then
			btn:setTitle(file:getData())
		end
		local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1181, 1181);
		if pAi then
			local pNode =  SCAnimationNode:nodeWithAnimation(pAi);
			pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			local actionNode = ActionNode:newActionNode()
			actionNode:setContentSize(pNode:getContentSize())
			pNode:setPosition(CCPointMake(actionNode:getContentSize().width/2, actionNode:getContentSize().height/2))
			actionNode:addChild(pNode)
			actionNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			actionNode:setPosition(CCPointMake(btn:getContentSize().width/2, btn:getContentSize().height/2+SY(15)))
			btn:addChild(actionNode)
			actionNode:luaSetSelectorOnMoveEnd(aniEnd1181)
			actionNode:setAutoRemove(true)
			actionNode:moveTo(CCPointMake(btn:getContentSize().width/2, btn:getContentSize().height/2+SY(65), 3.0, true))
		end
	end
	if MemberId1 == playId then
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("7-21", pWnd))
		if img then
			local node = SCNode:node()
			node:setContentSize(img:getContentSize())
			node:setBackgroundColor(ccc4(0, 0, 0, 120))
			img:addChild(node)
		end
	elseif MemberId2 == playId then
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("7-31", pWnd))
		if img then
			local node = SCNode:node()
			node:setContentSize(img:getContentSize())
			node:setBackgroundColor(ccc4(0, 0, 0, 120))
			img:addChild(node)
		end
	elseif MemberId0 == playId then
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("7-11", pWnd))
		if img then
			local node = SCNode:node()
			node:setContentSize(img:getContentSize())
			node:setBackgroundColor(ccc4(0, 0, 0, 120))
			img:addChild(node)
		end
	end
end
--准备操作
local function readyOper(dt)
	local pwnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("5939"))
	if not pwnd then
		return
	end
	local idRole = dt:readInt()
	local byFlag = dt:readByte()
	if not m_pandorReadyFlag then
		m_pandorReadyFlag = {}
	end
	m_pandorReadyFlag[idRole] = byFlag
	if MemberId1 == idRole then
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5939-7-24"))
		if img then
			if byFlag == 1 then
				img:setVisible(true)
			else
				img:setVisible(false)
			end
		end
	elseif MemberId2 == idRole then
		local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5939-7-34"))
		if img then
			if byFlag == 1 then
				img:setVisible(true)
			else
				img:setVisible(false)
			end
		end
	end
	local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("5939-6"))
	if btn and idRole==Hero:getSingleton():getID() then
		btn:setTouchEnabled(true)
		local file1 = getRealUIResourcePath("img/new00095.png")
		local file2 = getRealUIResourcePath("img/new00096.png")
		local file3 = getRealUIResourcePath("img/new00100.png")
		local file4 = getRealUIResourcePath("img/new00098.png")
		if file1 and file2 and file3 then
			if m_pandorReadyFlag and m_pandorReadyFlag[idRole]==1 then
				btn:setBackgroundImage(file1:getData())
				btn:setSelectedImage(file2:getData())
				btn:setTitle(file4:getData())
				pwnd:setCloseButtonVisibled(false)
			elseif not m_pandorReadyFlag or m_pandorReadyFlag[idRole]==0 then
				btn:setBackgroundImage(file1:getData())
				btn:setSelectedImage(file2:getData())
				btn:setTitle(file3:getData())
				pwnd:setCloseButtonVisibled(true)
			end
		end
	end
	if m_pandorReadyFlag[MemberId1] == 1 and m_pandorReadyFlag[MemberId2] == 1 and Hero:getSingleton():iSATeamLeader() then
		local file1 = getRealUIResourcePath("img/new00032.png")
		local file2 = getRealUIResourcePath("img/new00033.png")
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("5939-6"))
		if btn and file1 and file2 then
			btn:setTouchEnabled(true)
			btn:setBackgroundImage(file1:getData())
			btn:setSelectedImage(file2:getData())
			btn:setTitle(" ", getDefaultFontName(), getFontSize(12))
		end
	elseif Hero:getSingleton():iSATeamLeader() then
		local file1 = getRealUIResourcePath("img/new00095.png")
		local file2 = getRealUIResourcePath("img/new00096.png")
		local file3 = getRealUIResourcePath("img/new00097.png")
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("5939-6"))
		if btn and file1 and file2 and file3 then
			btn:setTouchEnabled(false)
			btn:setBackgroundImage(file2:getData())
			btn:setSelectedImage(file1:getData())
			btn:setTitle(file3:getData());
		end
	end
end
----队伍消息接收
local function recTeamMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
	if dt == nil then 
		return 
	end
    local action = dt:readShort();
    if action == MSG_TEAM_INST_TEAMS or action == MSG_TEAM_INST_TEAMS_END or action == MSG_TEAM_INST_TEAM_ADD  then
		--保存数据
		local tmpInstTeamList = stInstTeamList.initWithStream(dt)
		for i=1, tmpInstTeamList.ucAmount do
			table.insert(m_teamInfo, tmpInstTeamList.InstTeam[i])
		end
		createTmams(tmpInstTeamList)
		--createDamageList(stDamageListMag.initWithStream(dt));
		return
	end
	if action == MSG_TEAM_OPEN_ARENA3V3 then
		createTeamWnd(1, dt:readByte())
		return
	end
	if action == MSG_TEAM_OPEN_TRIBE_INST_TEAM then
		createTeamWnd(2, dt:readByte())
		return
	end
	if action == MSG_TEAM_OPEN_PANDORA then
		createTeamWnd(3, dt:readByte())
		return
	end
    if action == MSG_TEAM_INSTS then
		createInits(stInstInfoList.initWithStream(dt))
		--createBossInfo(stBossMag.initWithStream(dt))
		return
	end
    if action == MSG_TEAM_INST_TEAM_UPDATE then 
		updateWnd(dt)
		--createMyInfo(stmeDamageMag.initWithStream(dt));
		return
	end
    if action == MSG_TEAM_INST_TEAM_DEL then
        local idTeam = dt:readInt();
        --删除保存的数据
        for i=1, #m_teamInfo do
			if m_teamInfo[i].idTeam == idTeam then
				table.remove(m_teamInfo, i)
				break
			end
        end
        delTeam(idTeam)
		-- createTime(time)
		return
	end
    if action ==MSG_TEAM_QUIT then
        onTeamQuit()
		return
	end
    if action == MSG_TEAM_LEAVE then
         local ID = dt:readInt();
        onMemberLeaveTeam(ID)
		return
	end
	if action == MSG_ITEM_INSTPOS_INFO then
		showFormationWnd(stFormationInfoList.initWithStream(dt))
		return
	end
	if action == MSG_ITEM_INST_INTEAM_CHANGE then
	    updateWndForMeTeam(dt)
		return
	end
	if action == MSG_ITEM_INST_EUDEMON_CHANGE then
	    local scStr = dt:readString() 
	    local szLName = nil
        if scStr == nil then
            szLName = ""
        else
            szLName = scStr:getData()
        end
		local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-2-23"));
		if pLabel then   
        --pLabel:setColor(colorGreen());
			pLabel:setVisible(true);
			pLabel:setColor(color_orange)
			pLabel:setText(_LTParser("str5096")..": "..szLName)
		end
		return
	end
	if action == MSG_TEAM_CREATE then
		local id = dt:readInt()
		m_ownTeam = dt:readInt()
		return
	end
	if action == MSG_ITEM_3V3_INFO then
		countTime(dt)
		return
	end
	if action == MSG_TEAM_PANDORA_CHANGE then
		refreshPandoraBox(dt)
		return
	end
	if action == MSG_TEAM_PANDORA_Bomb then
		refreshPandoraBomb(dt)
		return
	end
	if action == MSG_TEAM_PROMOTELEADER_TO_CLIENT then
		changeTeamLeader(dt)
		return
	end
	if action == MSG_TEAM_PANDORA_PREPARE then
		readyOper(dt)
		return
	end
end

local function startPlay(tag)
	if m_WndType == 1 then
		local flag = 1
		if m_peiDuiFlag then
			flag = 0
		end
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
		dataStream:writeShort(MSG_ITEM_3V3_START_PAIR);
		dataStream:writeByte(flag);
		SCDataTransThread:getSingleton():transData(dataStream);
		return
	end
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_TEAM_INST_START);
	dataStream:writeInt(0+Hero:getSingleton():getID());
	--dataStream:writeInt(tag);
    SCDataTransThread:getSingleton():transData(dataStream);
end
---队伍成员消息
local function teamMember(dt)
     local ucAmount = dt:readByte();
	 for i  = 1, ucAmount do
		local node = tolua.cast(SCFunction:getUiNodeByIdlist("2036-101"), "SCDragNode")
		if node == nil then
            return 
        end
            
        node:setVisible(true)
            
        local node2 = tolua.cast(SCFunction:getUiNodeByIdlist("2036-100"), "SCDragNode")
        if node2 ~= nil then
            node2:setVisible(false) 
        end
            
        local szName = nil 
        local scStr = dt:readString()
        if    scStr == nil then
			szName = ""
		else
            szName = scStr:getData()
        end
        local	id = dt:readInt()--;
        local	nFacePhoto = dt:readInt()--;//
        local	usLevel = dt:readShort()--;
        local	ucMemberType = dt:readByte()--; //1: 成员 2:队长
        local   szEudemonName = nil 
        local   scStr = dt:readString()
        if scStr == nil then
			szEudemonName = ""
		else
            szEudemonName = scStr:getData()
        end
        
		if Hero:getSingleton():getID() ==  id then
			local fastGameBtn = SCFunction:getUiNodeByIdlist("2036-2-22")
            if fastGameBtn then
				fastGameBtn:setVisible(false)
			end
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2036-2-23"));
			if pLabel then
				--pLabel:setColor(colorGreen());
				pLabel:setVisible(true);
				pLabel:setColor(color_orange)
				pLabel:setText(_LTParser("str5096")..": "..szEudemonName)
            end
            local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2036-2-24"));
            if pBtn ~= nil then
				pBtn:luaSetSelectorOnClicked(onBtnClickChangePar);
                pBtn:setVisible(true);
            end
			
			local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(4));
			if pBtn  then---随机邀请按钮隐藏
				pBtn:setVisible(false);
			end   
            local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(6));
            if pBtn  then--改成布阵
				--pBtn:setTitle(_LTParser("str2046"),getDefaultFontName(), getFontSize(15));
				pBtn:setTitle(_LTParser("str2043"),getDefaultFontName(), getFontSize(15));
				pBtn:luaSetSelectorOnClicked(onClickFormation)
				-- pBtn:setVisible(false);("str2039")
			end   
			local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(7));
            if pBtn  then---随机邀请按钮隐藏
				-- pBtn:setTitle(_LTParser("str2043"));
                pBtn:setVisible(false);
                pBtn:luaSetSelectorOnClicked(startPlay)
				if m_WndType == 1 then
					pBtn:setTitle(_LTParser("str5091"),getDefaultFontName(), getFontSize(15))
				else
					pBtn:setTitle(_LTParser("str5092"),getDefaultFontName(), getFontSize(15))
                end
			end
		end           
       
         if Hero:getSingleton():iSATeamLeader() then
			local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(4))
            if pBtn  then---随机邀请按钮隐藏
				pBtn:setVisible(true);
			end    
               
            local plb = SCTypeCast:castNodeToLabel(node:getChildByTag(5))
            if plb  then---隐藏
				if not m_WndType == 0 then
					plb:setVisible(false);
				else
					plb:setVisible(true);
				end
			end                
             
            local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(6))
            if pBtn  then--改成阵型
				--pBtn:setTitle(_LTParser("str2046"),getDefaultFontName(), getFontSize(15))
				pBtn:setTitle(_LTParser("str2043"),getDefaultFontName(), getFontSize(15));
                pBtn:luaSetSelectorOnClicked(onClickFormation)
                -- pBtn:setVisible(false);("str2039")
			end 
			
			local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(7));
            if pBtn  then---随机邀请按钮隐藏
				-- pBtn:setTitle(_LTParser("str2043"));
                pBtn:setVisible(true);
                pBtn:luaSetSelectorOnClicked(startPlay)
				if m_WndType == 1 then
					pBtn:setTitle(_LTParser("str5091"),getDefaultFontName(), getFontSize(15))
				else
					pBtn:setTitle(_LTParser("str5092"),getDefaultFontName(), getFontSize(15))
                end
			end  
        end
        
		if ucMemberType == 2 then
			--MemberId0 = id
            local faceImg = node:getChildByTag(1) 
			if faceImg ~= nil then
				faceImg:removeChildByTag(1, true)
                local imgNode = getFaceImg(nFacePhoto)
                if imgNode then
                    imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
                    imgNode:setTag(1)
                    setNodePostion(imgNode, CCPointMake(getNodeContentSize(faceImg).width/2, getNodeContentSize(faceImg).height/2))
                    faceImg:addChild(imgNode)
                end
				local pLabel = SCTypeCast:castNodeToLabel(faceImg:getChildByTag(12))
                if pLabel then
					pLabel:setText(""..szName)
				end        
			end
		elseif  MemberId1 == 0 then
			MemberId1 = id
			local faceImg = node:getChildByTag(2) ---队员1
			if faceImg   then--头像图片
				faceImg:removeChildByTag(1, true)
                local imgNode = getFaceImg(nFacePhoto)
				if imgNode then
                    imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
                    imgNode:setTag(1)
                    setNodePostion(imgNode, CCPointMake(getNodeContentSize(faceImg).width/2, getNodeContentSize(faceImg).height/2))
                    faceImg:addChild(imgNode)
                end
				local pLabel = SCTypeCast:castNodeToLabel(faceImg:getChildByTag(22))
				if pLabel then --名字
                       pLabel:setText(""..szName)
                        pLabel:setVisible(true)
				end   
				local pLabel = SCTypeCast:castNodeToLabel(faceImg:getChildByTag(21))
				if pLabel then---等待加入文字
					pLabel:setVisible(false)
				end     
				local pBtn = SCTypeCast:castNodeToButton(faceImg:getChildByTag(23))
				if pBtn  then---T人按钮
					if Hero:getSingleton():iSATeamLeader() then
						pBtn:setVisible(true)
					else
						pBtn:setVisible(false)
					end
				end     
			end
               
		elseif  MemberId2 == 0 then
			MemberId2 = id
			local faceImg = node:getChildByTag(3) ---队员2
			if faceImg ~= nil    then
				faceImg:removeChildByTag(1, true)
                local imgNode = getFaceImg(nFacePhoto)
                if imgNode then
                    imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
                    imgNode:setTag(1)
                    setNodePostion(imgNode, CCPointMake(getNodeContentSize(faceImg).width/2, getNodeContentSize(faceImg).height/2))
                    faceImg:addChild(imgNode)
                end
				local pLabel = SCTypeCast:castNodeToLabel(faceImg:getChildByTag(32))
				if pLabel  then
					pLabel:setText(""..szName)
                       pLabel:setVisible(true)
				end    
					local pLabel = SCTypeCast:castNodeToLabel(faceImg:getChildByTag(31))
				if pLabel   then
					pLabel:setVisible(false);
				end   
               
				local pBtn = SCTypeCast:castNodeToButton(faceImg:getChildByTag(33))
				if pBtn  then---T人按钮
					if Hero:getSingleton():iSATeamLeader() then
						pBtn:setVisible(true)
					else
						pBtn:setVisible(false)
					end
				end         
			end
		end
	end
end
--潘多拉魔盒
local function onClickBox(tag)
	if m_pandoraOpenFlag then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM)
		dataStream:writeShort(MSG_TEAM_PANDORA_CHANGE)
		dataStream:writeByte(tag-2)
		SCDataTransThread:getSingleton():transData(dataStream)
		--SCActivityIndicator:getSingleton():show()
		m_pandoraOpenFlag = false
	end
end

local function onWndClose5939()
	MemberId1 = 0;
    MemberId2 = 0;
    m_ownTeam = 0;
    m_pandoraOpenFlag = false;
	m_PandoraBombFlag = false;
    m_pandorEndFlag = 0
	m_pandorShowMsg = nil
	m_pandorStartFlag = false
	m_pandorSleepFlag = nil
	m_pandorTurnFLag = nil
	m_pandorReadyFlag = nil
	
	if m_entryId then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		m_entryId = nil
	end
		
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_TEAM_LEAVE);
    dataStream:writeByte(3)
    SCDataTransThread:getSingleton():transData(dataStream);
    --[[
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_TEAM_CLOSE_PANDORA);
	dataStream:writeInt(0+Hero:getSingleton():getID());
    SCDataTransThread:getSingleton():transData(dataStream);
    ]]
end

--准备回调
local function readyCallBack(tag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
	dataStream:writeShort(MSG_TEAM_PANDORA_PREPARE);
	if m_pandorReadyFlag and m_pandorReadyFlag[Hero:getSingleton():getID()]==1 then
		dataStream:writeByte(0)
	else
		dataStream:writeByte(1)
	end
    
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function createPandoraWindow(dt)
	local pWnd = getCurentSceneWindow(5939)
	if not pWnd then
		pWnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5939))
		if not pWnd then
			return
		end
		local pWndCtrl = SCWindowController:controllerWithWindow(pWnd)
		if not pWndCtrl then
			return
		end
		pWnd:luaSetSelectorOnClose(onWndClose5939)
		pWnd:setFrameVisibled(false)
		for i=2, 5 do
			local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(i.."", pWnd))
			if btn then
				btn:setVisible(false)
				btn:luaSetSelectorOnClicked(onClickBox)
			end
		end
		--[[
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2", pWnd))
		if btn then
			local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1181, 1181);
			if pAi then
				local pNode =  SCAnimationNode:nodeWithAnimation(pAi);
				pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				pNode:setPosition(CCPointMake(btn:getContentSize().width/2, btn:getContentSize().height/2))
				btn:addChild(pNode)
			end
		end
		]]
--[[		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("6", pWnd))
		if btn then
			btn:setVisible(false)
			btn:luaSetSelectorOnClicked(startPlay)
		end--]]
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("8", pWnd))
		if label then
			label:setVisible(false)
		end
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9", pWnd))
		if label then
			label:setVisible(false)
		end
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl then
			naviCtrl:pushWindowController(pWndCtrl)
		end
		m_pandorTurnFLag = 1
	end
	local node = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("5939-7"))
	if node == nil then
        return 
    end
	for i=1, 3 do
		local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent((i*10+3).."", node));
		if pImg  then
			pImg:setVisible(false)	
		end
		local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent((i*10+4).."", node));
		if pImg  then
			pImg:setVisible(false)	
		end
	end
	--node:setFrameType(EnumFrameTypeListNormal)
	--node:setFrameVisibled(true)
	local ucAmount = dt:readByte();
	for i  = 1, ucAmount do
        local szName = nil 
        local scStr = dt:readString()
        if    scStr == nil then
			szName = ""
		else
            szName = scStr:getData()
        end
        local	id = dt:readInt()--;
        local	nFacePhoto = dt:readInt()--;//
        local	usLevel = dt:readShort()--;
        local	ucMemberType = dt:readByte()--; //1: 成员 2:队长
        local   szEudemonName = nil 
        local   scStr = dt:readString()
        if scStr == nil then
			szEudemonName = ""
		else
            szEudemonName = scStr:getData()
        end
        local color = color_white
        if Hero:getSingleton():getID() ==  id then
			local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("6", pWnd))
			if btn then
				--btn:setVisible(false)
				btn:setTouchEnabled(true)
				local file1 = getRealUIResourcePath("img/new00095.png")
				local file2 = getRealUIResourcePath("img/new00096.png")
				local file3 = getRealUIResourcePath("img/new00100.png")
				local file4 = getRealUIResourcePath("img/new00098.png")
				if file1 and file2 and file3 then
					if m_pandorReadyFlag and m_pandorReadyFlag[id]==1 then
						btn:luaSetSelectorOnClicked(readyCallBack)
						btn:setBackgroundImage(file1:getData())
						btn:setSelectedImage(file2:getData())
						btn:setTitle(file4:getData())
					elseif not m_pandorReadyFlag or m_pandorReadyFlag[id]==0 then
						btn:luaSetSelectorOnClicked(readyCallBack)
						btn:setBackgroundImage(file1:getData())
						btn:setSelectedImage(file2:getData())
						btn:setTitle(file3:getData())
					end
				end
			end
			color = color_yellow
        end
        if Hero:getSingleton():iSATeamLeader() then
			local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("6", pWnd))
			if btn then
				--btn:setVisible(true)
				btn:setTouchEnabled(false)
				local file1 = getRealUIResourcePath("img/new00095.png")
				local file2 = getRealUIResourcePath("img/new00096.png")
				local file3 = getRealUIResourcePath("img/new00097.png")
				if file1 and file2 and file3 then
					btn:luaSetSelectorOnClicked(startPlay)
					btn:setBackgroundImage(file2:getData())
					btn:setSelectedImage(file1:getData())
					btn:setTitle(file3:getData());
				end
			end
		end
		if MemberId0 == 0 then
			MemberId0 = id
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("11", node));
			if pImg  then
				pImg:removeChildByTag(1, true)
				local imgNode = getFaceImg(nFacePhoto)
				if imgNode then
					imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
					imgNode:setTag(1)
					setNodePostion(imgNode, CCPointMake(getNodeContentSize(pImg).width/2, getNodeContentSize(pImg).height/2))
					pImg:addChild(imgNode)
				end
			end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("12", node));
			if pLabel then
				pLabel:setColor(color)
				pLabel:setText(szName)
			end
		elseif  MemberId1 == 0 then
			MemberId1= id
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("21", node));
			if pImg  then
				pImg:removeChildByTag(1, true)
				local imgNode = getFaceImg(nFacePhoto)
				if imgNode then
					imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
					imgNode:setTag(1)
					setNodePostion(imgNode, CCPointMake(getNodeContentSize(pImg).width/2, getNodeContentSize(pImg).height/2))
					pImg:addChild(imgNode)
				end
			end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("22", node));
			if pLabel then
				pLabel:setColor(color)
				pLabel:setText(szName)
			end
		elseif  MemberId2 == 0 then
			MemberId2 = id
			local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("31", node));
			if pImg  then
				pImg:removeChildByTag(1, true)
				local imgNode = getFaceImg(nFacePhoto)
				if imgNode then
					imgNode:setAnchorPoint(CCPointMake(0.5, 0.5))
					imgNode:setTag(1)
					setNodePostion(imgNode, CCPointMake(getNodeContentSize(pImg).width/2, getNodeContentSize(pImg).height/2))
					pImg:addChild(imgNode)
				end
			end
			
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("32", node));
			if pLabel then
				pLabel:setColor(color)
				pLabel:setText(szName)
			end
		end
	end
end
---接收成员消息
local function recTeamMemberMsg()
	local dt = SCMessageCenter:getSingleton():getDataTransStream()
	if dt == nil then
	return 
	end

   local action = dt:readByte()
	if action == MSG_TEAMMEMBER_ADDMEMBER then
		if m_WndType == 3 then
			createPandoraWindow(dt)
		else
			teamMember(dt)
		end
	end
end

SCMessageCenter:getSingleton():luaRegistCommand(recTeamMsg, _MSG_TEAM, 0, nil)
SCMessageCenter:getSingleton():luaRegistCommand(recTeamMemberMsg, _MSG_TEAMMEMBER, 0, nil)