local ACTQUEST_CUR_MAIN_QUEST_GUIDE    = 38 --当前主线任务引导提示(新加或更新)

local taskID = nil;
local ucType = nil;
local btntitle = nil;
local btnProspectImg = nil;
local btnBackgroundImg = nil;
local btnProspectImgMark = nil;

local tMsg_Info5 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucType = dt:readByte();
        tmp.id = dt:readInt();
        tmp.nPhoto = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.ucFloor = dt:readByte();
        ucType = tmp.ucType;
        taskID = tmp.id;
        btnProspectImgMark = tmp.ucFloor;
        return tmp;
    end
}

function getbtntitle()
    return btntitle;
end
function getbtnProspectImg()
    return btnProspectImg;
end

function getbtnBackgroundImg()
    return btnBackgroundImg;
end

function getbtnProspectImgMark()
    return btnProspectImgMark;
end

function freeBtntmp()
    btntitle = nil;
    btnProspectImg = nil;
    btnBackgroundImg = nil;
    btnProspectImgMark = nil;
end

function onClickThreadGuide(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST);
    dataStream:writeShort(ACTQUEST_CUR_MAIN_QUEST_GUIDE);
    dataStream:writeByte(ucType);
    dataStream:writeInt(taskID);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function showThreadGuide(tmp)
    btntitle = tmp.szName;
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/img1005.png");
        if imgPath == nil then
            return;
        end
    end
    btnBackgroundImg = imgPath:getData();
    local file = nil;
    if tmp.nPhoto ~= 0 then
        local srtPath = "img/" .. tmp.nPhoto .. ".png";
        if SCPath:getSingleton() then
            file = getRealUIResourcePath(srtPath);
        end
        if file then
            --btnProspectImgNode = nil;
            --btnProspectImgNode = SCImage:imageWithFile(file:getData());
            btnProspectImg = file:getData();
        end
        if SCPath:getSingleton() then
            imgPath = getRealUIResourcePath("img/img1006.png");
        end
        btnBackgroundImg = nil;
        btnBackgroundImg = imgPath:getData();
        alterTopMainTaskBtn();
    else
        if tmp.ucType == 0 then
            btnProspectImg = nil;
            alterTopMainTaskBtn();
        else
            local length = 52;
            if SCPath:getSingleton() then            
                file = getRealUIResourcePath("img/img2036.png");
            end
            if file then
                --btnProspectImgNode = SCImage:imageWithFile(file:getData(), setRealRect(CCRectMake(0, 0, length , 32)));
                --btnProspectImgNode:setPosition(CCPointMake(12, 25));
                btnProspectImg = "";
                alterTopMainTaskBtn();
            end
        end
    end
end

local function recvThreadGuide()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream()
    if dt then
        showThreadGuide(tMsg_Info5.initWithStream(dt));
    end
end
if LuaData:getSingleton() then
    --LuaData:getSingleton():luaSetSelectorOnRecvData(recvThreadGuide, LuaData_ACTQUEST_CUR_MAIN_QUEST_GUIDE)
end