local _MSG_INSTANCE         = _MSG_GENERAL + 170;   -- 打开通天塔
local ACTION_OPEN_BABEL     = 24;                   --//打开通天塔界面

local BABLEINFO = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucElement = dt:readByte();  --//当前所在的元素
	    tmp.ucLayer = dt:readByte();    --//当前所在的层数
	    tmp.ucPacksack = dt:readByte(); --//符文背包剩余容量
	    tmp.idTemplate = dt:readInt();  --//该层的副本Id
	    tmp.MonsterFace = dt:readInt(); --//怪物的图片
	    local scStr = dt:readString()
        if scStr == nil then
            tmp.szBableName = ""
        else
            tmp.szBableName = scStr:getData()   --//通天塔 该元素名
        end
        scStr = dt:readString()
        if scStr == nil then
            tmp.szMonsterName = ""
        else
            tmp.szMonsterName = scStr:getData() --//怪物名
        end
        return tmp
    end
}

local m_BABLEINFO = {__mode = "kv"};

local function TongTianTaWndClose()
    m_BABLEINFO = {__mode = "kv"};
end

local function createWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2035));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile--.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(TongTianTaWndClose);
    -- create a test window controller
    wnd:setBackgroundColor(colorWindowRedBG());
    --[[local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("101", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeRound)
        dragNode:setFrameVisibled(true)
    end]]
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    return wndCtrl;
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
    end
end

local function showTongTianTaWnd(tmp)
    local wndCtrl = createWnd();    
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        m_BABLEINFO = tmp;
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        naviCtrl:pushWindowController(wndCtrl, NavigateStyleBottomToTop);
    end
end

local function recTongTianTa()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
    local action = dt:readByte()
    if action == ACTION_OPEN_BABEL then
        showTongTianTaWnd(BABLEINFO.initWithStream(dt))
    elseif action == 1 then
    end
end

SCMessageCenter:getSingleton():luaRegistCommand(recTongTianTa, _MSG_INSTANCE, 0, nil);

