--定义一个与文件名相同的table
TreasureHunt2 = {}
------------------消息--------------------
----------------变量定义------------------
local m_ShopInfo = {}
local m_RoleShopInfo = {}
local m_nSelectBuyPos = nil

----------------结构定义区----------------
----------------常量定义区----------------
local BULB_ID = 3901000021			--七星灯typeid
local ROLE_TAG = 8866				--武将Tag
local ROLE_NAME_TAG = 8867			--武将名tag
local EXCHANGESHOPACT_BUY_HERO = 7 	--兑换武将

----------------函数回调------------------
---点击确认购买---
function TreasureHunt2.onClickSure(tag)
	if tag == 1 then
		if m_ShopInfo.nType and m_ShopInfo.setExchangeGood and m_ShopInfo.setExchangeGood[m_selectGoodPos] then
			local dataStream = SCDataTransStream:streamWithCommand(_MSG_EXCHANGESHOP)
			dataStream:writeByte(EXCHANGESHOPACT_BUY)
			dataStream:writeInt(m_ShopInfo.nType)
			dataStream:writeInt(m_ShopInfo.setExchangeGood[m_selectGoodPos].idGoodType)
			dataStream:writeShort(1)
			SCDataTransThread:getSingleton():transData(dataStream)
			SCActivityIndicator:getSingleton():show()
		end
	end
	m_selectGoodPos = nil
end

---兑换奖励回调---
function TreasureHunt2.luaTipBuyReturn(tag)
	local pWnd = SCFunction:getUiNodeByIdlist("888888")
    if pWnd then
        pWnd:removeFromParentAndCleanup(true)
    end
    
    if tag == 0 then
        if m_nSelectBuyPos then        
            TreasureHunt2.onClickExchange(m_nSelectBuyPos)
            m_nSelectBuyPos = nil
        end
    end
end

---兑换奖励提示---
function TreasureHunt2.onClickShowTip(tag)
    if not m_ShopInfo.setExchangeGood[tag] or not m_ShopInfo.setExchangeGood[tag].idGoodType then return end
    
    m_nSelectBuyPos = tag
	local itemType = m_ShopInfo.setExchangeGood[tag].idGoodType
	
	local itemInfo = TableParser:getSingleton():getItemInfoByKey(itemType)
	
	local str = ""
	if itemInfo.effect_type_1 ~= 0 then
		str = str.."*5"..TreasureHunt2.getAttrNameByIndex(math.modf(itemInfo.effect_type_1/10)).." +"..itemInfo.effect_param_1
	end
	if itemInfo.effect_type_2 ~= 0 then
		str = str.."*5"..TreasureHunt2.getAttrNameByIndex(math.modf(itemInfo.effect_type_2/10)).." +"..itemInfo.effect_param_2
	end
	if itemInfo.effect_type_3 ~= 0 then
		str = str.."*5"..TreasureHunt2.getAttrNameByIndex(math.modf(itemInfo.effect_type_3/10)).." +"..itemInfo.effect_param_3
	end
	str = str.."_*0"..itemInfo.description:getData()
	str = str.."_ _"..L("str8121")..math.modf(itemInfo.price/4)
	
	local title = getColorString(itemType)
	if title == "*0" then
	    title = "*4"
	end
	title = title..itemInfo.name:getData()
	
	local file = getRealUIResourcePath("item/"..itemInfo.icon..".jpg")
	local szBtn = L("str30148")

	local pWnd = showTipEx(L("str30148"), str, title, itemInfo.icon, itemInfo.id)            
    if pWnd then
        local pWnd = tolua.cast(pWnd, "TipWindow")
        pWnd:luaSetReturnSelector(TreasureHunt2.luaTipBuyReturn)
    end
end

---点击武将回调---
function TreasureHunt2.onClikcRoleBtn(tag)
	TreasureHunt.showRoleInfoWnd(true)
end

---点击兑换---
function TreasureHunt2.onClickExchange(tag)
	if not m_ShopInfo.setExchangeGood[tag] then return end
		
	if m_ShopInfo.setExchangeGood[tag].isEnough then
		m_selectGoodPos = tag
		local itemInfo1 = TableParser:getSingleton():getItemInfoByKey(m_ShopInfo.setExchangeGood[tag].idGoodType)
		local itemInfo2 = TableParser:getSingleton():getItemInfoByKey(m_ShopInfo.setExchangeGood[tag].dwCost)
		if itemInfo1 and itemInfo2 then
			luashowConfirmationWindow(string.format(L("str30145"), m_ShopInfo.setExchangeGood[tag].usCostNum, itemInfo2.name:getData(), itemInfo1.name:getData()), WIN_YES_NO, TreasureHunt2.onClickSure)
		end
		return 
	end
        
	local itemInfo2 = TableParser:getSingleton():getItemInfoByKey(m_ShopInfo.setExchangeGood[tag].dwCost)
	if itemInfo2 then
		showMessage(string.format(L("str30146"), itemInfo2.name:getData()))
	end
end

---武将购买---
function TreasureHunt2.onClickSureForRole(tag)
	if tag == 1 then
		local roleInfo = TreasureHunt.getRoleInfo()
		if not roleInfo or not roleInfo[1] then return end
		
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_EXCHANGESHOP)
		dataStream:writeByte(EXCHANGESHOPACT_BUY_HERO)
		dataStream:writeInt(roleInfo[1].idPartnerType)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show()
	end
end

---点击兑换武将---
function TreasureHunt2.onClickExchangeRole(tag)
	--移除购买界面
	local pWnd = getCurentSceneWindow(6002)
	if pWnd then 
		pWnd:removeFromParentAndCleanup(true)
	end
	
	if not m_RoleShopInfo or not m_RoleShopInfo[1] then return end
	
	--判断材料是否足够
	local quantity = ItemProcessor:getSingleton():getItemQuantityWithTypeID(m_RoleShopInfo[1].dwCost)
	if quantity >= m_RoleShopInfo[1].usCostNum then
		local itemInfo1 = TableParser:getSingleton():getItemInfoByKey(m_RoleShopInfo[1].idGoodType)
		local itemInfo2 = TableParser:getSingleton():getItemInfoByKey(m_RoleShopInfo[1].dwCost)
		if itemInfo1 and itemInfo2 then
			luashowConfirmationWindow(string.format(L("str30145"), m_RoleShopInfo[1].usCostNum, itemInfo2.name:getData(), 
										itemInfo1.name:getData()), WIN_YES_NO, TreasureHunt2.onClickSureForRole)
		end
		
		return
	end
	
	local itemInfo2 = TableParser:getSingleton():getItemInfoByKey(m_RoleShopInfo[1].dwCost)
	if itemInfo2 then
		showMessage(string.format(L("str30146"), itemInfo2.name:getData()))
	end
end

----------------UI控制器区----------------
function TreasureHunt2.initControl()
	local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode1:setContentSize(AUTO_SIZE(480, 320))
		pDragNode1:setFrameVisibled(false)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTypeRound)
	end
	
	local pDragNode3 = SCDragNode:node()
	if pDragNode3 then
		pDragNode3:setTag(3)
		pDragNode3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode3:setPosition(AUTO_POS(5.00, 51.00))
		pDragNode3:setContentSize(AUTO_SIZE(170, 210))
		pDragNode3:setFrameVisibled(true)
		pDragNode3:setDragEnabled(false)
		pDragNode3:setFrameType(EnumFrameTypeRound)
	end
	
	local pRoleBack = nil
	local imgPath = getRealUIResourcePath("yanwu/new00863.png")				--武将背景图
	if imgPath then
		pRoleBack = SCImage:imageWithFile(imgPath:getData(), CCRectMake(SX(160), SY(10), SX(156), SY(193)))
		if pRoleBack then
			pRoleBack:setTag(90)
			pRoleBack:setAnchorPoint(ANCHOR_CENTER)
			if pDragNode3 then
				pRoleBack:setPosition(CCPointMake(pDragNode3:getContentSize().width / 2, pDragNode3:getContentSize().height / 2))
				pDragNode3:addChild(pRoleBack)
			end
		end
    end
    
    local pRoleTable = nil													--武将台子
    local imgPath = getRealUIResourcePath("yanwu/new00856.png")				--武将背景图
    if imgPath then
		pRoleTable = SCImage:imageWithFile(imgPath:getData())
		if pRoleTable then
			pRoleTable:setTag(91)
			pRoleTable:setAnchorPoint(ANCHOR_CENTER)
			if pDragNode3 then
				pRoleTable:setPosition(CCPointMake(pDragNode3:getContentSize().width / 2, SY(60)))
				pDragNode3:addChild(pRoleTable)
			end
		end
    end
    
	local pScrollBox2 = SCScrollBox:boxWithWidthHeight(AUTO_W(285), AUTO_H(240))
	if pScrollBox2 then
		tolua.cast(pScrollBox2, "SCNode"):setTag(10)
		tolua.cast(pScrollBox2, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pScrollBox2, "SCNode"):setPosition(AUTO_POS(178.00, 16.00))
	end
	
	local imgPath = getRealUIResourcePath("1.6/treasure/new00888.png")		--七星灯
	if imgPath then
		pImage21 = SCImage:imageWithFile(imgPath:getData())
		if pImage21 then
			pImage21:setTag(21)
			pImage21:setScale(0.6)
			pImage21:setAnchorPoint(CCPointMake(0, 0))
			pImage21:setPosition(AUTO_POS(326.00, 255.00))
		end
    end
    
    local pDragNode51 = SCDragNode:node()									--七星灯底框
	if pDragNode51 then
		pDragNode51:setTag(51)
		pDragNode51:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode51:setPosition(AUTO_POS(353.00, 252.00))
		pDragNode51:setContentSize(AUTO_SIZE(115, 33))
		pDragNode51:setFrameVisibled(true)
		pDragNode51:setDragEnabled(false)
		pDragNode51:setFrameType(EnumFrameTypeRound)
	end
	
    local pLabel22 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(14))		--七星灯值
	if pLabel22 then
		pLabel22:setTag(22)
		pLabel22:setAnchorPoint(CCPointMake(0, 0.0))
		pLabel22:setPosition(AUTO_POS(363.00, 262.00))
		pLabel22:setColor(ccc4(255,255,255,255))
	end
	
	local pLable23 = SCLabel:labelWithStringFont(L("str30142"), DEFAULT_FONT_NAME, F(12))
	if pLable23 then
		pLable23:setTag(23)
		pLable23:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable23:setPosition(AUTO_POS(10.00, 8.00))
		pLable23:setColor(color_orange)
	end
	
	local pButton25 = SCButton:button()
	if pButton25 then
		pButton25:setTag(25)
		pButton25:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton25:setPosition(AUTO_POS(5.00, 35.00))
		pButton25:setContentSize(AUTO_SIZE(157, 165))
	end

	if pDragNode3 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode3, "SCNode"))
	end
	if pScrollBox2 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pScrollBox2, "SCNode"))
	end
	if pImage21 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pImage21, "SCNode"))
	end
	if pDragNode51 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode51, "SCNode"))
	end
	if pLabel22 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLabel22, "SCNode"))
	end
	if pLable23 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable23, "SCNode"))
	end
	if pButton25 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pButton25, "SCNode"))
	end
	
	return pDragNode1
end

function TreasureHunt2.init(pNode)
	--武将属性回调
	pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3-25", pNode))
	if pBtn then
		pBtn:luaSetSelectorOnClicked(TreasureHunt2.onClikcRoleBtn)
	end
	
	--显示武将动作
	TreasureHunt2.showRoleAct()
end

function TreasureHunt2.releaseControl()
	m_ShopInfo = {}
	m_RoleShopInfo = {}
	m_nSelectBuyPos = nil
end

function TreasureHunt2.getHuntPage()
	--获取页面节点
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
    if not pMultiPage then return end
    
    local pageNode = pMultiPage:getPageWithIndex(1)
    if not pageNode then return end

    local pNode = pageNode:getChildByTag(1)
    if not pNode then return end
    
    return pNode
end

--设置武将动作---
function TreasureHunt2.showRoleAct()
	local pPage = TreasureHunt2.getHuntPage()
	if not pPage then return end
	
	pNode = pPage:getChildByTag(3)
	if not pNode then return end
	
	if pNode:getChildByTag(ROLE_TAG) then return end
	
	local roleInfo = TreasureHunt.getRoleInfo()
	if not roleInfo or not roleInfo[1] then return end
    
	--武将动作
	local pAi = SCLookfaceParser:getSingleton():getAnimationByIndex(roleInfo[1].nFacePhoto, roleInfo[1].nFacePhoto)
	if not pAi then return end
	
	local pAnimationNode =  SCAnimationNode:nodeWithAnimation(pAi)
	if pAnimationNode then
		pAnimationNode:setTag(ROLE_TAG)
		pAnimationNode:setAnchorPoint(CCPointMake(0.5, 0))
		if string.match(getAppName():getData(), "KDSG_ANDR960x540") or string.match(getAppName():getData(), "KDSG_ANDR800x480") then
			pAnimationNode:setScale(0.7)
		end
		if roleInfo[1].nFacePhoto == 402601 then 		--吕布位置特殊处理
			pAnimationNode:setPosition(CCPointMake(pNode:getContentSize().width / 2 - SX(5), SY(50)))
		else
			pAnimationNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, SY(65)))
		end
		pNode:addChild(pAnimationNode)
	end
end

---寻宝兑换商店---
function TreasureHunt2.seExchangeShopInfo()
    --获取页面节点
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
    if not pMultiPage then return end
    
    local pageNode = pMultiPage:getPageWithIndex(1)
    if not pageNode then return end

    local pNode = pageNode:getChildByTag(1)
    if not pNode then return end

    local pPage = tolua.cast(pNode:getChildByTag(10), "SCScrollBox")
    if not pPage then return end
        
	pPage:setScrollVertical(false)
	local pChildNode = nil
	local nCount = 0
	
	--删除后保存武将信息
	for i = 1, m_ShopInfo.ucAmount do
		if m_ShopInfo.setExchangeGood[i].usPosition == 0 then	
			table.insert(m_RoleShopInfo, m_ShopInfo.setExchangeGood[i])
			table.remove(m_ShopInfo.setExchangeGood, i)
			m_ShopInfo.ucAmount = m_ShopInfo.ucAmount - 1
			break
		end
	end
	
	--添加物品
	for i = 1, m_ShopInfo.ucAmount do
		local index = i % 2
		--添加新的一页
		if index == 1 then
			nCount = nCount + 1
			pChildNode = SCNode:node()
			if pChildNode then
				pChildNode:setTag(nCount)
				pChildNode:setAnchorPoint(CCPointMake(0, 0))
				pChildNode:setPosition(AUTO_POS((nCount - 1) * 112, 0))
				pChildNode:setContentSize(AUTO_SIZE(112, 250))
				pPage:addChild(pChildNode)
			end
		end
		
		--单个物品背框
		local pDragNode = SCDragNode:node()
		if pChildNode and pDragNode then
			pDragNode:setTag(i)
			pDragNode:setFrameVisibled(true)
			pDragNode:setDragEnabled(false)
			pDragNode:setFrameType(EnumFrameTypeTip3)
			pDragNode:setContentSize(AUTO_SIZE(110, 125))
			pDragNode:setAnchorPoint(CCPointMake(0, 0))
			
			--行数
			if index == 1 then
				pDragNode:setPosition(AUTO_POS(0, 120))
			else
				pDragNode:setPosition(AUTO_POS(0, 0))
			end
			
			--物品购买响应大框
			local pBtn = SCButton:button()
			if pBtn then
				pBtn:setTag(i)
				pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
				pBtn:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, pDragNode:getContentSize().height / 2));
				pBtn:setContentSize(pDragNode:getContentSize())
				pBtn:luaSetSelectorOnClicked(TreasureHunt2.onClickExchange)
				pDragNode:addChild(pBtn)
			end
			
			--物品显示小框
			pBtn = SCButton:button();
			local imgBtn1 = getRealUIResourcePath("img/new00002.png");
			local imgBtn2 = getRealUIResourcePath("img/new00003.png");
			
			if not m_ShopInfo.setExchangeGood[i] then return end
			local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_ShopInfo.setExchangeGood[i].idGoodType);
			if pBtn and imgBtn1 and imgBtn2 and itemInfo then
				--兑换需要材料
				local expendInfo = TableParser:getSingleton():getItemInfoByKey(m_ShopInfo.setExchangeGood[i].dwCost);
				if expendInfo then
					local labelNode = SCLabel:labelWithStringFont(expendInfo.name:getData().." x " .. m_ShopInfo.setExchangeGood[i].usCostNum, getDefaultFontName(), getFontSize(12));
					if labelNode then
						labelNode:setTag(5000)
						labelNode:setAnchorPoint(CCPointMake(0.5, 0))
						labelNode:setPosition(pDragNode:getContentSize().width / 2, SY(27));
						pDragNode:addChild(labelNode)
						
						--获取兑换需要的材料的数量
						local quantity = ItemProcessor:getSingleton():getItemQuantityWithTypeID(m_ShopInfo.setExchangeGood[i].dwCost)
						if quantity >= m_ShopInfo.setExchangeGood[i].usCostNum then	--设置是否可兑换状态和显示
							m_ShopInfo.setExchangeGood[i].isEnough = true
							labelNode:setColor(color_green)
						else
							m_ShopInfo.setExchangeGood[i].isEnough = false
							labelNode:setColor(color_red)
						end
					end
				end
				
				pBtn:setBackgroundImage(imgBtn1:getData());
				pBtn:setSelectedImage(imgBtn2:getData());
				local fileImg = getRealUIResourcePath("item/" .. itemInfo.icon .. ".jpg");
				if fileImg then
					local pImg = SCImage:imageWithFile(fileImg:getData());
					if pImg then
						pImg:setAnchorPoint(CCPointMake(0.5, 0.5));
						pImg:setPosition(CCPointMake(pBtn:getContentSize().width / 2, pBtn:getContentSize().height / 2));
						pBtn:addChild(pImg);
					end
				end
				pBtn:setTag(i);
				pBtn:setAnchorPoint(CCPointMake(0.5, 0));
				pBtn:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, SY(45)));
				pBtn:luaSetSelectorOnClicked(TreasureHunt2.onClickShowTip)
				pDragNode:addChild(pBtn)
				
				--物品名
				local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_ShopInfo.setExchangeGood[i].idGoodType)
				if itemInfo then
					local label = SCLabel:labelWithStringFont(itemInfo.name:getData(), getDefaultFontName(), getFontSize(11));
					if label then
						label:setColor(color_green)
						label:setAnchorPoint(CCPointMake(0.5, 1))
						label:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, pDragNode:getContentSize().height-SY(20)));
						pDragNode:addChild(label);
					end
				end
			end
			pChildNode:addChild(pDragNode)
		end
	end
	
	if m_ShopInfo.ucAmount and m_ShopInfo.ucAmount > 0 then
		pPage:setContentSize(AUTO_SIZE(110 * nCount, 240))
	end
end

---设置武将的兑换信息---
function TreasureHunt2.seExchangeShopRoleInfo()
	local pPage = TreasureHunt2.getHuntPage()
	if not pPage then return end
	
	pNode = pPage:getChildByTag(3)
	if not pNode then return end
	
	if not m_RoleShopInfo[1] then return end
	
	if pNode:getChildByTag(5000) then
		pNode:removeChildByTag(5000, true)
	end
	
	local expendInfo = TableParser:getSingleton():getItemInfoByKey(m_RoleShopInfo[1].dwCost);
	if expendInfo then
		local labelNode = SCLabel:labelWithStringFont(expendInfo.name:getData().." x " .. m_RoleShopInfo[1].usCostNum, 
														getDefaultFontName(), getFontSize(12));
		if labelNode then
			labelNode:setTag(5000)
			labelNode:setAnchorPoint(CCPointMake(0.5, 0))
			labelNode:setPosition(pNode:getContentSize().width / 2, SY(20));
			pNode:addChild(labelNode)
			
			--获取兑换需要的材料的数量
			local quantity = ItemProcessor:getSingleton():getItemQuantityWithTypeID(m_RoleShopInfo[1].dwCost)
			if quantity >= m_RoleShopInfo[1].usCostNum then		--设置是否可兑换显示
				labelNode:setColor(color_green)
			else
				labelNode:setColor(color_red)
			end
		end
	end
end

---设置七星灯的值---
function TreasureHunt2.setBulbNum()
	--获取页面节点
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
    if not pMultiPage then return end
    
    local pageNode = pMultiPage:getPageWithIndex(1)
    if not pageNode then return end

    local pNode = pageNode:getChildByTag(1)
    if not pNode then return end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent(22, pNode))
    if pLabel then
		pLabel:setText(ItemProcessor:getSingleton():getItemQuantityWithTypeID(BULB_ID))
    end
end

---属性获取---
function TreasureHunt2.getAttrNameByIndex(index)
	local strName = "";
	if index == 201 then --力量
		strName = L("str8127")
	elseif index == 202 then --灵力
		strName = L("str8128")
	elseif index == 411 then --物理攻击
		strName = L("str5074")
	elseif index == 421 then --物理防御
		strName = L("str5075")
	elseif index == 455 then --HP上限
		strName = L("str8129")
	elseif index == 456 then --MP上限
		strName = L("str8130")
	elseif index == 457 then --特技攻击
		strName = L("str9175")
	elseif index == 457 then --特技防御
		strName = L("str9178")
	elseif index == 492 then --暴击率
		strName = L("str8131")
	elseif index == 496 then --免暴率
		strName = L("str0405")
	elseif index == 497 then --必杀率
		strName = L("str0406")
	elseif index == 481 then 
		strName = L("str0403") --格挡率
	elseif index == 498 then 
		strName = L("str0402") --破击
	end

	return strName;
end
---刷新商店兑换状态---
function TreasureHunt2.refreshShopInfo()
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
	if not pMultiPage then return end

	local pageNode = pMultiPage:getPageWithIndex(1)
	if not pageNode then return end

	local pNode = pageNode:getChildByTag(1);
	if not pNode then return end

	local pPage = tolua.cast(pNode:getChildByTag(10), "SCScrollBox")
	if not pPage then return end
	
	--刷新商店
	for i = 1, m_ShopInfo.ucAmount do
		local index = math.ceil(i / 2)
		local labelNode = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent(index.."-"..i.."-5000", pPage));
		if labelNode then
			local quantity = ItemProcessor:getSingleton():getItemQuantityWithTypeID(BULB_ID)
			if quantity >= m_ShopInfo.setExchangeGood[i].usCostNum then
				m_ShopInfo.setExchangeGood[i].isEnough = true
				labelNode:setColor(color_green)
			else
				m_ShopInfo.setExchangeGood[i].isEnough = false
				labelNode:setColor(color_red)
			end
		end
	end
	
	--刷新武将
	TreasureHunt2.seExchangeShopRoleInfo()
	
	--刷新七星灯
	TreasureHunt2.setBulbNum()
end

----------------消息处理区----------------
---接收兑换商店信息---
function TreasureHunt2.recvMsg(msg)
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
    if not pMultiPage then return end
    
    local pageNode = pMultiPage:getPageWithIndex(1)
    if not pageNode then return end

	m_ShopInfo = msg
	
	--设置抽奖界面武将兑换信息--
	TreasureHunt1.setRechargeInfo(m_ShopInfo)
end

----------------消息注册区----------------
----------------全局函数区----------------