--定义一个与文件名相同的table
TreasureHunt1 = {}
------------------消息--------------------

----------------变量定义------------------
local mTreasureItem = {}	--寻宝道具图
local m_Value = 1			--当前旋转到的物品
local m_speed = 0.1 		--当前旋转速度
local m_timeID = nil		--旋转定时器
local m_actID = nil			--动作定时器
local m_HuntCount0 = 0 		--寻宝次数 	1次
local m_HuntCount1 = 0		--寻宝次数	5次
local m_HuntCount2 = 0		--寻宝次数	10次
local m_HuntCount3 = 0 		--金币寻宝次数
local m_huntRlt	= {}		--抽奖结果物品列表
local m_huntWndInfo = {}	--抽奖界面信息
local m_huntRltInfo = {}	--抽奖结果信息
local m_huntEnd = 0			--最后停下的pos
local m_realHuntEnd = 0		--实际停止位
local m_rollCount = 0		--转动次数
local m_isNeedStop = false	--是否需要停止转动
local m_RechargeCost = 0	--武将花费
local m_scrollWorldMsg = {}	--滚动消息
local m_scrollTimer = nil	--滚动定时器
local m_scrollInfo = {}		--寻宝滚动消息
local m_worldInfo = {}		--寻宝世界消息

----------------结构定义区----------------
---寻宝物品
local stTreasureHunt1 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv", 
        }
        tmp.nTen = dt:readInt()					--10次寻宝次数
        tmp.nFifty = dt:readInt()				--50次寻宝次数
        tmp.nOne = dt:readInt()
        tmp.usAmount = dt:readShort()
        tmp.info = {}
        for i = 1, tmp.usAmount do
			tmpdata = {}
			tmpdata.idItemtype = dt:readInt()	--物品itemtpye
			tmpdata.nNum = dt:readInt()			--物品数量
			tmpdata.nPosition= dt:readInt()
			tmp.info[i]= tmpdata 
        end
        tmp.nOneUseMoney = dt:readInt()
        
        return tmp
    end
}

---寻宝结果
local stTreasureHuntRlt = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv", 
        }
        tmp.nTen = dt:readInt()
        tmp.nFifty = dt:readInt()
        tmp.nOne = dt:readInt()
        tmp.usAmount = dt:readShort()
        tmp.info = {}
        for i = 1, tmp.usAmount do
			tmpdata = {}
			tmpdata.idItemtype = dt:readInt()
			tmpdata.nNum = dt:readInt()
			tmpdata.nPosition= dt:readInt()
			tmp.info[i]= tmpdata 
        end
        tmp.nOneUseMoney = dt:readInt()
        
        return tmp
    end
}

---寻宝世界信息
local stWorldInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv", 
        }
        
        tmp.usAmount = dt:readShort()
        tmp.info = {}
        for i = 1, tmp.usAmount do
			local tmpdata = {}
			local scStr = dt:readString()
			if scStr == nil then
				tmpdata.szName = ""
			else
				tmpdata.szName = scStr:getData()
			end
			local scStr = dt:readString()
			if scStr == nil then
				tmpdata.szItemName = ""
			else
				tmpdata.szItemName = scStr:getData()
			end
			table.insert(tmp.info, tmpdata)
		end
		
        return tmp
    end
}

----------------常量定义区----------------
local HUNT_IMG_POS = 
{
	{x = 20.00, y = 149.00}, {x = 92.00, y = 149.00}, {x = 164.00, y = 149.00}, {x = 236.00, y = 149.00},
	{x = 236.00, y = 82.00}, {x = 236.00, y = 15.00}, {x = 164.00, y = 15.00}, {x = 92.00, y = 15.00},
	{x = 20.00, y = 15.00}, {x = 19.00, y = 82.00}, {x = 120.00, y = 74.00}
}

local EVENTAWARD_TREASURE_INFO = 17			--寻宝信息 
local EVENTAWARD_TREASURE_HUNT = 18  		--开始寻宝 
local EVENTAWARD_TREASURE_WORLD_MSG = 19	--寻宝秘闻
local EVENTAWARD_TREASURE_WORLD_TIP = 20	--寻宝消息滚动
local EVENTAWARD_TREASURE_CLOSE	 = 21		--关闭寻宝界面
local EVENTAWARD_TREASURE_HUNT_MONEY = 22 	--金币寻宝
local KEY_ID = 3901000020					--金钥匙typeid
local ROLE_TAG = 8866						--武将Tag
local ROLE_NAME_TAG = 8867					--武将名Tag
local EFFECT_TAG = 8888						--寻宝结果特效
local BULB_ID = 3901000021					--七星灯typeid

----------------函数回调------------------
---空回调---
function TreasureHunt1.onClikcNil(tag)
end

---秘闻按钮回调---
function TreasureHunt1.onClikcHistoryBtn()
	m_worldInfo = {}
	
	local dt = SCDataTransStream:streamWithCommand(_MSG_COPYAWARD)
    dt:writeShort(EVENTAWARD_TREASURE_WORLD_MSG)
    
    SCDataTransThread:getSingleton():transData(dt)
    SCActivityIndicator:getSingleton():show()
end

---武将点击回调---
function TreasureHunt1.onClikcRoleBtn(tag)
	TreasureHunt.showRoleInfoWnd(false)
end

---奖品按钮回调---
function TreasureHunt1.onClikcItemBtn(tag)
	for i = 1, 11 do
		if m_huntWndInfo.info and m_huntWndInfo.info[i] and 
			m_huntWndInfo.info[i].nPosition == tag - 3 then
			showTip(m_huntWndInfo.info[i].idItemtype)	
			break
		end
	end
end

---寻宝按钮回调---
function TreasureHunt1.onClikcHuntBtn(tag)	
	local curEmoney = Hero:getSingleton():getEmoney()
	if not curEmoney then return end
	
	local curMoney = Hero:getSingleton():getMoney()
	if not curMoney then return end
	
	local curKey = ItemProcessor:getSingleton():getItemQuantityWithTypeID(KEY_ID)
	
	local moneyCost = nil
	local emoneyCost = nil
	local keyCost = nil
	local times = 1
	local isNeedInfo = true
	
	if tag == 30 then			--金币寻宝
		--超过次数弹提示
		if m_HuntCount3 >= 5 then
			showMessage(L("str30224"))
			return
		end
		moneyCost = 100000
	elseif tag == 15 then		--寻宝1次
		keyCost = 1
		times = 1
		emoneyCost = 10
		if m_HuntCount0 > 0 then isNeedInfo = false end
	elseif tag == 16 then		--寻宝10次
		keyCost = 10
		times = 10
		emoneyCost = 10 * 10 - curKey * 10
		if m_HuntCount1 > 0 then isNeedInfo = false end
	elseif tag == 17 then		--寻宝50次
		keyCost = 50
		times = 50
		emoneyCost = 10 * 50 - curKey * 10
		if m_HuntCount2 > 0 then isNeedInfo = false end
	end

	if tag == 30 then
		if moneyCost <= curMoney then	--身上金币足够
			if m_HuntCount3 == 0 then	--第一次提示
				local msg = string.format(L("str30180"), moneyCost)
				luashowConfirmationWindow(msg, WIN_YES_NO, TreasureHunt1.startHuntMoney)
			else
				TreasureHunt1.startHunt()
				TreasureHunt1.sendStartMoneyHuntMsg()
			end
		else							--金币不足
			GuidePoint_shopBuyTip()
		end
		return
	else
		--判断是否是每天第一次登陆,且使用元宝寻宝
		if isNeedInfo and keyCost > curKey and curEmoney >= emoneyCost then
			local msg = string.format(L("str30130"), emoneyCost, keyCost)
			if tag == 15 then
				luashowConfirmationWindow(msg, WIN_YES_NO, TreasureHunt1.startHuntOne)
			elseif tag == 16 then
				luashowConfirmationWindow(msg, WIN_YES_NO, TreasureHunt1.startHuntTen)
			elseif tag == 17 then
				luashowConfirmationWindow(msg, WIN_YES_NO, TreasureHunt1.startHuntFifty)
			end
				
			return 
		end
	end
	
	--判断钱和钥匙是否足够
	if keyCost <= curKey or emoneyCost <= curEmoney then
		TreasureHunt1.startHunt()
		TreasureHunt1.sendStartHuntMsg(times)
		return
	end
	
	Global_showRechangeWindowPoint(nil, L("str30127").."_"..L("str30128"), L("str30129"), WIN_NULL, true)
end

---说明按钮回调---
function TreasureHunt1.onClikcInfoBtn()
	local wnd = SCFunction:getUiNodeByIdlist("11002");
	if wnd then
		local pframeWnd = FrameWindow:frameWnd()
		if pframeWnd then
			pframeWnd:setContentSize(CCSizeMake(SX(430), SY(205)))
			local pTextBox11 = SCTextBox:boxWithWidthHeightFont(AUTO_W(400), AUTO_H(165), DEFAULT_FONT_NAME, F(12))
			local pParsedNode = getItemTextNode(L("str30115"));
			if pTextBox11 and pParsedNode then
				pParsedNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
				pParsedNode:setPosition(AUTO_POS(7, -15))
				tolua.cast(pTextBox11, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
				tolua.cast(pTextBox11, "SCNode"):setPosition(AUTO_POS(10, 10))
				pTextBox11:setParserDelegate(TextParser:getSingleton())
				pTextBox11:setText(L("str30115"))
				pframeWnd:addChild(pTextBox11);
				wnd:addChild(pframeWnd);
			end
		end
	end
end

---仓库点击回调---
function TreasureHunt1.onClikcHuntBag()
	TreasureHunt3.showTreasureHuntWnd()
end

----------------UI控制器区----------------
function TreasureHunt1.initControl()
	local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode1:setContentSize(AUTO_SIZE(480, 320))
		pDragNode1:setFrameVisibled(false)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTypeRound)
	end
	
	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(173.00, 48.00))
		pDragNode2:setContentSize(AUTO_SIZE(301, 210))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode3 = SCDragNode:node()
	if pDragNode3 then
		pDragNode3:setTag(3)
		pDragNode3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode3:setPosition(AUTO_POS(5.00, 48.00))
		pDragNode3:setContentSize(AUTO_SIZE(170, 210))
		pDragNode3:setFrameVisibled(true)
		pDragNode3:setDragEnabled(false)
		pDragNode3:setFrameType(EnumFrameTypeRound)
	end
	
	local pListBox = SCListBox:boxWithWidthHeight(SX(270), SY(27))
	if pListBox then
		pListBox:setScrollVertical(false)
		pListBox:setTag(350)
		pListBox:setPosition(AUTO_POS(128.00, 254.5))
	end
	
	local pRoleBack = nil
	local imgPath = getRealUIResourcePath("yanwu/new00863.png")				--武将背景图
	if imgPath then
		pRoleBack = SCImage:imageWithFile(imgPath:getData(), CCRectMake(SX(160), SY(10), SX(156), SY(193)))
		if pRoleBack then
			pRoleBack:setTag(90)
			pRoleBack:setAnchorPoint(ANCHOR_CENTER)
			if pDragNode3 then
				pRoleBack:setPosition(CCPointMake(pDragNode3:getContentSize().width / 2, pDragNode3:getContentSize().height / 2))
				pDragNode3:addChild(pRoleBack)
			end
		end
    end
    
    local pRoleTable = nil													--武将台子
    local imgPath = getRealUIResourcePath("yanwu/new00856.png")				--武将背景图
    if imgPath then
		pRoleTable = SCImage:imageWithFile(imgPath:getData())
		if pRoleTable then
			pRoleTable:setTag(91)
			pRoleTable:setAnchorPoint(ANCHOR_CENTER)
			if pDragNode3 then
				pRoleTable:setPosition(CCPointMake(pDragNode3:getContentSize().width / 2, SY(60)))
				pDragNode3:addChild(pRoleTable)
			end
		end
    end

	local pButton4 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton4 then
		pButton4:setTag(4)
		pButton4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton4:setPosition(AUTO_POS(20.00, 149.00))
		pButton4:setContentSize(AUTO_SIZE(46, 46))
		pButton4:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton4:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton5 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton5 then
		pButton5:setTag(5)
		pButton5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton5:setPosition(AUTO_POS(92.00, 149.00))
		pButton5:setContentSize(AUTO_SIZE(46, 46))
		pButton5:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton5:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton6 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton6 then
		pButton6:setTag(6)
		pButton6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton6:setPosition(AUTO_POS(164.00, 149.00))
		pButton6:setContentSize(AUTO_SIZE(46, 46))
		pButton6:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton6:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton7 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton7 then
		pButton7:setTag(7)
		pButton7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton7:setPosition(AUTO_POS(236.00, 149.00))
		pButton7:setContentSize(AUTO_SIZE(46, 46))
		pButton7:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton7:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton8 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton8 then
		pButton8:setTag(8)
		pButton8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton8:setPosition(AUTO_POS(236.00, 82.00))
		pButton8:setContentSize(AUTO_SIZE(46, 46))
		pButton8:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton8:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton9 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton9 then
		pButton9:setTag(9)
		pButton9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton9:setPosition(AUTO_POS(236.00, 15.00))
		pButton9:setContentSize(AUTO_SIZE(46, 46))
		pButton9:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton9:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton10 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton10 then
		pButton10:setTag(10)
		pButton10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10:setPosition(AUTO_POS(164.00, 15.00))
		pButton10:setContentSize(AUTO_SIZE(46, 46))
		pButton10:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton10:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton11 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton11 then
		pButton11:setTag(11)
		pButton11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton11:setPosition(AUTO_POS(92.00, 15.00))
		pButton11:setContentSize(AUTO_SIZE(46, 46))
		pButton11:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton11:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton12 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton12 then
		pButton12:setTag(12)
		pButton12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton12:setPosition(AUTO_POS(20.00, 15.00))
		pButton12:setContentSize(AUTO_SIZE(46, 46))
		pButton12:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton12:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton13 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton13 then
		pButton13:setTag(13)
		pButton13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton13:setPosition(AUTO_POS(19.00, 82.00))
		pButton13:setContentSize(AUTO_SIZE(46, 46))
		pButton13:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton13:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton14 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton14 then
		pButton14:setTag(14)
		pButton14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton14:setScale(1.4)
		pButton14:setPosition(AUTO_POS(120.00, 74.00))
		pButton14:setContentSize(AUTO_SIZE(46, 46))
		pButton14:setTitle(L("title"), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.png")
		if pBackimg then
			pButton14:setBackgroundImage(pBackimg:getData())
		end
	end

	local pButton15 = SCButton:button(EnumBtnType9Atlas)
	if pButton15 then
		pButton15:setTag(15)
		pButton15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		if CLIENT_TYPE == 2 then
			pButton15:setPosition(AUTO_POS(228.00, 18.00)) 
			pButton15:setContentSize(AUTO_SIZE(87, 30))
		else
			pButton15:setPosition(AUTO_POS(253.00, 23.00)) 
			pButton15:setContentSize(AUTO_SIZE(70, 25))
		end 
		pButton15:setTitle(L("str30110"), DEFAULT_FONT_NAME, F(12))
	end

	local pButton16 = SCButton:button(EnumBtnType9Atlas)
	if pButton16 then
		pButton16:setTag(16)
		pButton16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		if CLIENT_TYPE == 2 then
			pButton16:setPosition(AUTO_POS(310.00, 18.00)) 
			pButton16:setContentSize(AUTO_SIZE(87, 30))
		else
			pButton16:setPosition(AUTO_POS(253.00, 23.00)) 
			pButton16:setContentSize(AUTO_SIZE(70, 25))
		end 
		pButton16:setTitle(L("str30111"), DEFAULT_FONT_NAME, F(12))
	end

	local pButton17 = SCButton:button(EnumBtnType9Atlas)
	if pButton17 then
		pButton17:setTag(17)
		pButton17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		if CLIENT_TYPE == 2 then
			pButton17:setPosition(AUTO_POS(391.00, 18.00)) 
			pButton17:setContentSize(AUTO_SIZE(87, 30))
		else
			pButton17:setPosition(AUTO_POS(253.00, 23.00)) 
			pButton17:setContentSize(AUTO_SIZE(70, 25))
		end 
		pButton17:setTitle(L("str30112"), DEFAULT_FONT_NAME, F(12))
	end
	
	local pButton30 = SCButton:button(EnumBtnType9Atlas)
	if pButton30 then
		pButton30:setTag(30)
		pButton30:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		if CLIENT_TYPE == 2 then
			pButton30:setPosition(AUTO_POS(147.00, 18.00)) 
			pButton30:setContentSize(AUTO_SIZE(87, 30))
		else
			pButton30:setPosition(AUTO_POS(179.00, 23.00)) 
			pButton30:setContentSize(AUTO_SIZE(70, 25))
		end 
		pButton30:setTitle(L("str30223"), DEFAULT_FONT_NAME, F(12))
	end
	
	local pButton80 = SCButton:button(EnumBtnType9Atlas)
	if pButton80 then
		pButton80:setTag(80)
		pButton80:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton80:setPosition(AUTO_POS(385.00, 255.00))
		pButton80:setContentSize(AUTO_SIZE(87, 24))
		pButton80:setTitle(L("str30178"), DEFAULT_FONT_NAME, F(13))
	end

	--local pLable18 = SCLabel:labelWithStringFont(L("str30113"), DEFAULT_FONT_NAME, F(12))
	if pLable18 then
		pLable18:setTag(18)
		pLable18:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable18:setPosition(AUTO_POS(150.00, 9.00))
		pLable18:setColor(color_orange)
	end
	
	local pButton55 = SCButton:button(EnumBtnType9Atlas)
	if pButton55 then
		pButton55:setTag(55)
		pButton55:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		if CLIENT_TYPE == 2 then
			pButton55:setPosition(AUTO_POS(10.00, 11.00))
			pButton55:setContentSize(AUTO_SIZE(65, 38))
		else
			pButton55:setPosition(AUTO_POS(12.00, 11.00))
			pButton55:setContentSize(AUTO_SIZE(75, 38))
		end 
		pButton55:setTitle(L("str30126"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton20 = SCButton:button(EnumBtnTypeNormalImg)             --说明
	if pButton20 then
		pButton20:setTag(20)
		pButton20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton20:setPosition(AUTO_POS(140.00, 180.00))
		pButton20:setContentSize(AUTO_SIZE(60, 27))
		local imgPath = getRealUIResourcePath("img/new00875.png")
		if imgPath then
			pButton20:setTitle(imgPath:getData())
		end
	end
	
	local imgPath = getRealUIResourcePath("img/2001008.png")				--元宝
	if imgPath then
		pImage21 = SCImage:imageWithFile(imgPath:getData())
		if pImage21 then
			pImage21:setTag(21)
			pImage21:setScale(0.5)
			pImage21:setAnchorPoint(CCPointMake(0, 0))
			pImage21:setPosition(AUTO_POS(75.00, 30.00))
		end
    end
	
    local pLabel22 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(13))		--元宝值
	if pLabel22 then
		pLabel22:setTag(22)
		pLabel22:setAnchorPoint(CCPointMake(0, 0.0))
		pLabel22:setPosition(AUTO_POS(100.00, 34.00))
		pLabel22:setColor(ccc4(255,255,255,255))
	end
	
	local imgPath = getRealUIResourcePath("1.6/treasure/new00886.png")		--钥匙
	if imgPath then
		pImage23 = SCImage:imageWithFile(imgPath:getData())
		if pImage23 then
			pImage23:setTag(23)
			pImage23:setScale(0.4)
			pImage23:setAnchorPoint(CCPointMake(0, 0))
			pImage23:setPosition(AUTO_POS(77.00, 10.00))
		end
    end
    
    local pLabel24 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(13))
	if pLabel24 then
		pLabel24:setTag(24)
		pLabel24:setAnchorPoint(CCPointMake(0, 0.0))
		pLabel24:setPosition(AUTO_POS(100.00, 12.00))
		pLabel24:setColor(ccc4(255,255,255,255))
	end
	
	local pButton25 = SCButton:button()
	if pButton25 then
		pButton25:setTag(25)
		pButton25:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton25:setPosition(AUTO_POS(5.00, 35.00))
		pButton25:setContentSize(AUTO_SIZE(157, 165))
	end
	

	if pDragNode2 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode2, "SCNode"), 100)
	end
	if pDragNode3 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode3, "SCNode"))
	end
	if pListBox and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pListBox, "SCNode"))
	end
	if pButton4 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton4, "SCNode"))
	end
	if pButton5 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton5, "SCNode"))
	end
	if pButton6 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton6, "SCNode"))
	end
	if pButton7 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton7, "SCNode"))
	end
	if pButton8 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton8, "SCNode"))
	end
	if pButton9 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton9, "SCNode"))
	end
	if pButton10 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton10, "SCNode"))
	end
	if pButton11 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton11, "SCNode"))
	end
	if pButton12 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton12, "SCNode"))
	end
	if pButton13 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton13, "SCNode"))
	end
	if pButton14 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton14, "SCNode"))
	end
	if pButton15 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton15, "SCNode"))
	end
	if pButton16 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton16, "SCNode"))
	end
	if pButton17 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton17, "SCNode"))
	end
	if pButton30 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton30, "SCNode"))
	end
	if pButton80 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton80, "SCNode"))
	end
	if pLable18 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable18, "SCNode"))
	end
	if pButton19 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton19, "SCNode"))
	end
	if pButton55 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton55, "SCNode"))
	end
	if pImage21 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pImage21, "SCNode"))
	end
	if pDragNode51 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode51, "SCNode"))
	end
	if pLabel22 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLabel22, "SCNode"))
	end
	if pImage23 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pImage23, "SCNode"))
	end
	if pDragNode53 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode53, "SCNode"))
	end
	if pLabel24 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLabel24, "SCNode"))
	end
	if pButton25 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pButton25, "SCNode"))
	end
	if pButton20 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pButton20, "SCNode"))
	end
	return pDragNode1
end

function TreasureHunt1.init(pNode)
	--奖品按钮
	for i = 1, 11 do
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-"..i + 3, pNode))
		if pBtn and mTreasureItem[i] then
			pBtn:removeAllChildrenWithCleanup(true)
			
			--物品图标
			local pItemImg = getRealUIResourcePath("item/"..mTreasureItem[i]..".jpg")
			if pItemImg then
				pBtn:setTitle(pItemImg:getData())
				pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcItemBtn)
			end
			
			--奖品数量
			for j = 1, #m_huntWndInfo.info do
				if m_huntWndInfo.info[j] and m_huntWndInfo.info[j].nPosition == i then
					local pLabel = SCLabel:labelWithStringFont(m_huntWndInfo.info[j].nNum, DEFAULT_FONT_NAME, F(12))
					if pLabel then
						pLabel:setAnchorPoint(ANCHOR_RIGHT_BOTTOM)
						pLabel:setPosition(CCPointMake(pBtn:getContentSize().width - SX(6), SY(4)))
						pBtn:addChild(pLabel)
					end
				end
			end
		end
	end
	
	--寻宝按钮回调
	for i = 1, 3 do
		local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(i + 14, pNode))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcHuntBtn)
		end
	end
	
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(30, pNode))
	if pBtn then
		pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcHuntBtn)
	end
	
	--秘闻按钮
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(80, pNode))
	if pBtn then
		pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcHistoryBtn)
	end
	
	--说明按钮
	pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3-20", pNode))
	if pBtn then
		pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcInfoBtn)
	end
	
	--武将属性回调
	pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3-25", pNode))
	if pBtn then
		pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcRoleBtn)
	end
	
	--仓库按钮
	pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("55", pNode))
	if pBtn then
		pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcHuntBag)
	end
	
	--设置元宝值
	TreasureHunt1.setEmoney()
	TreasureHunt1.setKey()
	
	--设置武将动作
	TreasureHunt1.showRoleAct()
end

function TreasureHunt1.releaseControl()
	if m_timeID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
		m_timeID = nil
    end  
    
    if m_ID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_actID)
		m_actID = nil
    end 
    
    if m_scrollTimer then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_scrollTimer)
		m_scrollTimer = nil
	end
    
	mTreasureItem = {}
	m_Value = 1
	m_speed = 0.1 	
	m_HuntCount0 = 0
	m_HuntCount1 = 0	
	m_HuntCount2 = 0
	m_HuntCount3 = 0	
	m_huntRlt	= {}	
	m_huntWndInfo = {}
	m_huntRltInfo = {}
	m_huntEnd = 0		
	m_rollCount = 0
	m_isNeedStop = false
	m_realHuntEnd = 0
	m_RechargeCost = 0
	m_scrollWorldMsg = {}
	m_scrollInfo = {}
	m_worldInfo = {}
	
	local dt = SCDataTransStream:streamWithCommand(_MSG_COPYAWARD)
    dt:writeShort(EVENTAWARD_TREASURE_CLOSE)
    SCDataTransThread:getSingleton():transData(dt)
end

--设置武将动作---
function TreasureHunt1.showRoleAct()
	local pPage = TreasureHunt1.getHuntPage()
	if not pPage then return end
	
	pNode = pPage:getChildByTag(3)
	if not pNode then return end
	
	if pNode:getChildByTag(ROLE_TAG) then return end
	
	local roleInfo = TreasureHunt.getRoleInfo()
	if not roleInfo or not roleInfo[1] then return end
	
	--武将动作
	local pAi = SCLookfaceParser:getSingleton():getAnimationByIndex(roleInfo[1].nFacePhoto, roleInfo[1].nFacePhoto)
	if not pAi then return end
	
	local pAnimationNode =  SCAnimationNode:nodeWithAnimation(pAi)
	if pAnimationNode then
		pAnimationNode:setTag(ROLE_TAG)
		pAnimationNode:setAnchorPoint(CCPointMake(0.5, 0))
		if string.match(getAppName():getData(), "KDSG_ANDR960x540") or string.match(getAppName():getData(), "KDSG_ANDR800x480") then
			pAnimationNode:setScale(0.7)
		end
		if roleInfo[1].nFacePhoto == 402601 then 		--吕布位置特殊处理
			pAnimationNode:setPosition(CCPointMake(pNode:getContentSize().width / 2 - SX(5), SY(50)))
		else
			pAnimationNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, SY(65)))
		end
		pNode:addChild(pAnimationNode)
	end
end

---设置武将兑换信息---
function TreasureHunt1.setRechargeInfo(shopInfo)
	local cost = nil
	
	if shopInfo then 
		--查找武将兑换花费
		for i = 1, shopInfo.ucAmount do
			if shopInfo.setExchangeGood[i] and shopInfo.setExchangeGood[i].usPosition == 0 then
				cost = shopInfo.setExchangeGood[i].usCostNum
				m_RechargeCost = cost
				break
			end
		end
	else
		cost = m_RechargeCost
	end
	
	if not cost or cost == 0 then return end 

	--或者节点，显示武将花费
	local pPage = TreasureHunt1.getHuntPage()
	if not pPage then return end
	
	pNode = pPage:getChildByTag(3)
	if not pNode then return end
	
	pNode:removeChildByTag(300, true)
	
	local curHas = ItemProcessor:getSingleton():getItemQuantityWithTypeID(BULB_ID)
	
	local pLabel = SCLabel:labelWithStringFont(L("str30177")..curHas.."/"..cost, DEFAULT_FONT_NAME, F(12))
	if pLabel then
		pLabel:setTag(300)
		pLabel:setAnchorPoint(CCPointMake(0.5, 0))
		pLabel:setPosition(CCPointMake(pNode:getContentSize().width / 2, SY(20)))
		if curHas < cost then
			pLabel:setColor(color_red)
		else
			pLabel:setColor(color_green)
		end
		pNode:addChild(pLabel)
	end
end

---设置元宝值---
function TreasureHunt1.setEmoney()
	local pNode = TreasureHunt1.getHuntPage()
	if not pNode then return end
	
	local pEmoney = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("22", pNode))
	local nMoney = Hero:getSingleton():getEmoney()
	
	if pEmoney and nMoney then
		pEmoney:setText(nMoney)
	end
end

---设置金钥匙值---
function TreasureHunt1.setKey()
	local pNode = TreasureHunt1.getHuntPage()
	if not pNode then return end
	
	local pKey = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("24", pNode))
	local nKey = ItemProcessor:getSingleton():getItemQuantityWithTypeID(KEY_ID)
	
	if pKey and nKey then
		pKey:setText(nKey)
	end
end

---获得物品效果显示---
function TreasureHunt1.showGetPriceEffect()
	if m_actID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_actID)
		m_actID = nil
	end
 
	TreasureHunt1.showHuntRlt()		--显示寻宝结果
	
	local pNode = TreasureHunt1.getHuntNode()
	if not pNode then return end
	
	--循环创建道具图片
	for i = 1, #m_huntRlt do
		if mTreasureItem[m_huntRlt[i]] then
			local imgPath = getRealUIResourcePath("item/"..mTreasureItem[m_huntRlt[i]]..".jpg")		--道具图片
			if imgPath then
				pImage = SCImage:imageWithFile(imgPath:getData())
				if pImage then
					pImage:setAnchorPoint(CCPointMake(0, 0))
					
					--移动动作
					local pActNode = ActionNode:newActionNode()
					if pActNode then
						pActNode:setTag(100 + i)
						pActNode:setPosition(AUTO_POS(HUNT_IMG_POS[m_huntRlt[i]].x, HUNT_IMG_POS[m_huntRlt[i]].y))
						pActNode:luaSetSelectorOnMoveEnd(TreasureHunt1.priceMoveEnd)
						pActNode:moveTo(AUTO_POS(-142, -38), 1, true)
						pActNode:addChild(pImage)
						pNode:addChild(pActNode)
					end
				end
			end
		end
	end
end

---道具移动结束---
function TreasureHunt1.priceMoveEnd()
	TreasureHunt1.enable(true)
	
	local pNode = TreasureHunt1.getHuntNode()
	if not pNode then return end
	
	for i = 101, 112 do 
		pNode:removeChildByTag(i, true)
	end
end

---寻宝，仓库，充值按钮使能控制---
function TreasureHunt1.enable(isEnable)
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
	if not pMultiPage then return end
	
	local pageNode = pMultiPage:getPageWithIndex(0)
	if not pageNode then return nil end
		
	if isEnable then
		--寻宝按钮使能
		for i = 1, 3 do
			local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-"..i + 14, pageNode))
			if pBtn then
				pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcHuntBtn)
			end
		end
		
		pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-30", pageNode))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcHuntBtn)
		end
	
		--仓库按钮使能
		pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-55", pageNode))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcHuntBag)
		end
		
		--充值按钮
		pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-19", pageNode))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcExcharge)
		end
	else
		--寻宝按钮失效
		for i = 1, 3 do
			local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-"..i + 14, pageNode))
			if pBtn then
				pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcNil)
			end
		end
		
		pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-30", pageNode))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcNil)
		end
		
		--仓库按钮失效
		pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-55", pageNode))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcNil)
		end
		
		--充值按钮
		pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-19", pageNode))
		if pBtn then
			pBtn:luaSetSelectorOnClicked(TreasureHunt1.onClikcNil)
		end
	end
end

---获得寻宝页面---
function TreasureHunt1.getHuntPage()
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
    if not pMultiPage then return nil end
    
    local pageNode = pMultiPage:getPageWithIndex(0)
    if not pageNode then return nil end
    
    local pChildNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", pageNode))
    return pChildNode 
end

---获得寻宝节点---
function TreasureHunt1.getHuntNode()
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
    if not pMultiPage then return nil end
    
    local pageNode = pMultiPage:getPageWithIndex(0)
    if not pageNode then return nil end
    
    local pChildNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-2", pageNode))
    
    return pChildNode
end

---显示寻宝结果---
function TreasureHunt1.showHuntRlt()
	--刷新武将下方的七星灯数量
	TreasureHunt1.setRechargeInfo()
	
	TreasureHunt1.clearHuntRlt()	--清空寻宝结果
	
	local pNode = TreasureHunt1.getHuntNode()
	if not pNode then return end
	
	for i = 1, #m_huntRlt do
		local pButtonCur = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(m_huntRlt[i] + 3, pNode))
		if pButtonCur then
			local imgPath = getRealUIResourcePath("img/new00003.png")
			if imgPath then
				--寻宝结果框高亮
				pButtonCur:setBackgroundImage(imgPath:getData())			
				
				--寻宝结果特效显示
				local pAi = nil
				if m_huntRlt[i] == 11 then 		--大奖
					pAi = SCLookfaceParser:getSingleton():getAnimationByIndex(1015, 1015)
				else							
					pAi = SCLookfaceParser:getSingleton():getAnimationByIndex(1030, 1030)
				end
				if pAi then
					local pAnimationNode =  SCAnimationNode:nodeWithAnimation(pAi)
					if pAnimationNode then
						pButtonCur:removeChildByTag(EFFECT_TAG, true)
						pAnimationNode:setTag(EFFECT_TAG)
						pAnimationNode:setAnchorPoint(ANCHOR_CENTER)
						pAnimationNode:setPosition(CCPointMake(pButtonCur:getContentSize().width / 2, pButtonCur:getContentSize().height / 2))
						pButtonCur:addChild(pAnimationNode)
					end
				end
			end
		end
	end
end

---金钱寻宝按钮变更---
function TreasureHunt1.chgTreasureHuntBtn()
	local pNode = TreasureHunt1.getHuntPage()
	if not pNode then return end
	
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("30", pNode))
	if pBtn and m_HuntCount3 >= 5 then
		pBtn:setButtonType(3)
	end
end

---清寻宝结果---
function TreasureHunt1.clearHuntRlt()
	local pNode = TreasureHunt1.getHuntNode()
	if not pNode then return end
	
	for i = 4, 14 do
		local pButtonCur = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(i, pNode))
		if pButtonCur then
			local imgPath = getRealUIResourcePath("img/new00002.png")
			if imgPath then
				pButtonCur:setBackgroundImage(imgPath:getData())
				pButtonCur:removeChildByTag(EFFECT_TAG, true)
			end
		end
	end
end

---显示秘闻---
function TreasureHunt1.showHistory()
	local pWnd = getCurentSceneWindow(11002)
	if not pWnd then return end
	
	if pWnd:getChildByTag(555) then return end
	
	local pTip = TipWindow:newWindow()
	if not pTip then return end
	
	pTip:setContentSize(AUTO_SIZE(320, 270))
	pTip:setPosition(AUTO_POS(65.00, 14.00))
	pTip:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
	pTip:setTag(555)
	
	--背框
	local pDragNode = SCDragNode:node()
	pDragNode:setContentSize(AUTO_SIZE(320, 270))
	if pDragNode then
		pDragNode:setFrameType(EnumFrameTypeLine)
		pDragNode:setAnchorPoint(ANCHOR_CENTER)
		pDragNode:setPosition(CCPointMake(pTip:getContentSize().width / 2, pTip:getContentSize().height / 2))
	end
	
	--显示列表
	local pList = SCListBox:boxWithWidthHeight(SX(290), SY(250))
	if not pList then return end
	
	pList:setAnchorPoint(ANCHOR_CENTER)
	pList:setPosition(CCPointMake(pTip:getContentSize().width / 2, pTip:getContentSize().height / 2))
	
	if not m_worldInfo.info then return end
	
	for i = #m_worldInfo.info, 1,  -1 do
		local pNode = SCNode:node()
		if pNode then
			pNode:setContentSize(AUTO_SIZE(290, 14))
			if m_worldInfo.info[i] and m_worldInfo.info[i].szName and m_worldInfo.info[i].szItemName then
				local str = string.format(L("str30179"), m_worldInfo.info[i].szName, m_worldInfo.info[i].szItemName)
				local pTextBox = SCTextBox:boxWithWidthHeightFont(SX(290), SY(14), DEFAULT_FONT_NAME, F(12))
				if pTextBox then
					pTextBox:setTouchEnabled(false)
					pTextBox:setScrollVertical(false)
					pTextBox:setParserDelegate(TextParser:getSingleton())
					pTextBox:setAnchorPoint(CCPointMake(0, 0.5))
					pTextBox:setPosition(CCPointMake(0, pNode:getContentSize().height / 2))
					pTextBox:setText(str)
					pNode:addChild(pTextBox)
				end
				pList:addItem(pNode)
			end
		end
	end
	
	pDragNode:addChild(pList)
	pTip:addChild(pDragNode)
	pWnd:addChild(pTip)
end

---开始寻宝---
function TreasureHunt1.startHunt()
	m_isNeedStop = false
	m_rollCount = 0
    m_speed = 0.1
    m_Value = 1
    
    TreasureHunt1.clearHuntRlt()	--清空寻宝结果
    TreasureHunt1.enable(false)		--功能按钮失效
    
    if m_timeID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
		m_timeID = nil
    end 
    
    m_timeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.conspeed, m_speed, false)
end

---匀速旋转---
function TreasureHunt1.conspeed()   	--匀速转动
	m_rollCount = m_rollCount + 1
	if m_rollCount >= 150 then			--无停止消息,转动时间过长,停止转动
		if m_timeID then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
			m_timeID = nil
		end
		
		if m_actID then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_actID)
			m_actID = nil
		end
		
		TreasureHunt1.clearHuntRlt()	--清空寻宝结果
		TreasureHunt1.enable(true)		--功能按钮使能
		
		return
	end
	
    local Value = nil
    if m_Value == 1 then
        Value = 10
    else
        Value = m_Value - 1
    end
    
    --获得需要光效的节点
    local pNode = TreasureHunt1.getHuntNode()
    if not pNode then return end
    
    --前一的节点去除光效
    local pButtonPerv = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(3 + Value, pNode))
    if pButtonPerv then
        local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButtonPerv:setBackgroundImage(imgPath:getData());
		end
    end
    
    --当前节点加光效
    local pButtonCur = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(3 + m_Value, pNode))
    if pButtonCur then
        local imgPath = getRealUIResourcePath("img/new00003.png")
		if imgPath then
			pButtonCur:setBackgroundImage(imgPath:getData())
		end
    end
    
    m_Value = m_Value + 1
    if m_Value >= 11 then
        m_Value = 1
    end
    
    if m_rollCount > 10 and m_isNeedStop then
		TreasureHunt1.stopHunt()
		m_isNeedStop = false
	end
end

---停止寻宝---
function TreasureHunt1.stopHunt()
	if m_timeID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
		m_timeID = nil
	end
	
	m_timeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.readyToReduce, m_speed, false)
end

---减速转动---
function TreasureHunt1.reducespeed()
	m_speed = m_speed + 0.2
	if m_speed > 1 then m_speed = 1 end
	
	if m_timeID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
		m_timeID = nil
	end
    
    --停止滚动
    if m_Value == m_huntEnd and m_speed > 0.4 then
		TreasureHunt1.conspeed()
		if m_realHuntEnd == 11 then			--大奖特殊处理，移动一次后显示效果
			m_timeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.moveToCenterPrice, 1, false)
		else
			m_actID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.showGetPriceEffect, 1, false) 	--显示获得物品特效
		end

        return
    end
	
	TreasureHunt1.conspeed()
    m_timeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.reducespeed, m_speed, false);
end

---准备开始减速---
function TreasureHunt1.readyToReduce()
	local Value = nil
    if m_Value == 1 then
        Value = 10
    else
        Value = m_Value - 1
    end
    
    --获得需要光效的节点
    local pNode = TreasureHunt1.getHuntNode()
    if not pNode then return end
    
    --前一的节点去除光效
    local pButtonPerv = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(3 + Value, pNode))
    if pButtonPerv then
        local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButtonPerv:setBackgroundImage(imgPath:getData());
		end
    end
    
    --当前节点加光效
    local pButtonCur = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(3 + m_Value, pNode))
    if pButtonCur then
        local imgPath = getRealUIResourcePath("img/new00003.png")
		if imgPath then
			pButtonCur:setBackgroundImage(imgPath:getData())
		end
    end
    
    local mTmpHuntEnd = m_huntEnd - 4
    if mTmpHuntEnd < 1 then 
		mTmpHuntEnd = mTmpHuntEnd + 10
	end
	
	if m_Value == mTmpHuntEnd then   	--开始减速的位置
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
		m_timeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.reducespeed, m_speed, false);
	end
	
    m_Value = m_Value + 1
    if m_Value >= 11 then
        m_Value = 1
    end
end

---移动到中心宝物---
function TreasureHunt1.moveToCenterPrice()
	if m_timeID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
		m_timeID = nil
	end

    local pNode = TreasureHunt1.getHuntNode()
    if not pNode then return end
    
	--10号奖励去光效
    local pButtonPerv = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(13, pNode))
    if pButtonPerv then
        local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButtonPerv:setBackgroundImage(imgPath:getData());
		end
    end
    
    --中心奖励加光效
    local pButtonCur = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(14, pNode))
    if pButtonCur then
        local imgPath = getRealUIResourcePath("img/new00003.png")
		if imgPath then
			pButtonCur:setBackgroundImage(imgPath:getData())
		end
    end
    
	if m_actID then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_actID)
	end
    m_actID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.showGetPriceEffect, 1, false) 	--显示获得物品特效
end

---显示寻宝世界消息---
function TreasureHunt1.showWorldMsg()
	local pDragNode = SCTypeCast:castNodeToDragNode(TreasureHunt1.getHuntPage())
	if not pDragNode then return end
	
	local pListBox = SCTypeCast:castNodeToListBox(pDragNode:getChildByTag(350))
	if not pListBox then return end
	
	if not m_scrollInfo.info then return end
	
	if m_scrollTimer then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_scrollTimer)
	end
    m_scrollTimer = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.delayTimeShow, 2, false)
	
	for i = 1, #m_scrollInfo.info do
		local count = pListBox:itemCount()
		if count >= 2 then return end
		
		local pNode = SCNode:node()
		if pNode then
			pNode:setContentSize(AUTO_SIZE(270, 14))
			if m_scrollInfo.info[1] and m_scrollInfo.info[1].szName and m_scrollInfo.info[1].szItemName then
				local str = string.format(L("str30179"), m_scrollInfo.info[1].szName, m_scrollInfo.info[1].szItemName)
				local pTextBox = SCTextBox:boxWithWidthHeightFont(SX(270), SY(14), DEFAULT_FONT_NAME, F(12))
				if pTextBox then
					pTextBox:setTouchEnabled(false)
					pTextBox:setScrollVertical(false)
					pTextBox:setParserDelegate(TextParser:getSingleton())
					pTextBox:setAnchorPoint(CCPointMake(0, 0.5))
					pTextBox:setPosition(CCPointMake(0, pNode:getContentSize().height / 2))
					pTextBox:setText(str)
					pNode:addChild(pTextBox)
				end
				pListBox:addItem(pNode)
				table.remove(m_scrollInfo.info, 1)
				m_scrollInfo.usAmount = m_scrollInfo.usAmount - 1
			end
		end
	end
end

---延迟显示世界消息---
function TreasureHunt1.delayTimeShow()
	if m_scrollTimer then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_scrollTimer)
	end
    
	local pDragNode = SCTypeCast:castNodeToDragNode(TreasureHunt1.getHuntPage())
	if not pDragNode then return end
	
	local pListBox = SCTypeCast:castNodeToListBox(pDragNode:getChildByTag(350))
	if not pListBox then return end

	if #m_scrollInfo.info == 0 then
		pListBox:removeAllItems()
	else
		local pNode = SCNode:node()
		if pNode then
			pNode:setContentSize(AUTO_SIZE(270, 14))
			if m_scrollInfo.info[1] and m_scrollInfo.info[1].szName and m_scrollInfo.info[1].szItemName then
				local str = string.format(L("str30179"), m_scrollInfo.info[1].szName, m_scrollInfo.info[1].szItemName)
				local pTextBox = SCTextBox:boxWithWidthHeightFont(SX(270), SY(14), DEFAULT_FONT_NAME, F(12))
				if pTextBox then
					pTextBox:setTouchEnabled(false)
					pTextBox:setScrollVertical(false)
					pTextBox:setParserDelegate(TextParser:getSingleton())
					pTextBox:setAnchorPoint(CCPointMake(0, 0.5))
					pTextBox:setPosition(CCPointMake(0, pNode:getContentSize().height / 2))
					pTextBox:setText(str)
					pNode:addChild(pTextBox)
				end
				pListBox:addItem(pNode)
				
				local count = pListBox:itemCount()
				if count > 2 then
					pListBox:setOffset(AUTO_POS(0, (count - 2) * 14))
				end
				
				table.remove(m_scrollInfo.info, 1)
				m_scrollInfo.usAmount = m_scrollInfo.usAmount - 1
			end
		end
		m_scrollTimer = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(TreasureHunt1.delayTimeShow, 2, false)
	end
end

----------------消息处理区----------------
---寻宝消息发送---
function TreasureHunt1.sendStartHuntMsg(times)
	local dt = SCDataTransStream:streamWithCommand(_MSG_COPYAWARD)
    dt:writeShort(EVENTAWARD_TREASURE_HUNT)
    dt:writeInt(times)
    
    SCDataTransThread:getSingleton():transData(dt)
    SCActivityIndicator:getSingleton():show()
end

---金币寻宝消息发送---
function TreasureHunt1.sendStartMoneyHuntMsg()
	local dt = SCDataTransStream:streamWithCommand(_MSG_COPYAWARD)
	dt:writeShort(EVENTAWARD_TREASURE_HUNT_MONEY)
	dt:writeInt(1)
	
	SCDataTransThread:getSingleton():transData(dt)
	SCActivityIndicator:getSingleton():show()
end

function TreasureHunt1.startHuntMoney(tag)
	if tag == 1 then
		TreasureHunt1.startHunt()
		TreasureHunt1.sendStartMoneyHuntMsg()
	end
end

function TreasureHunt1.startHuntOne(tag)
	if tag == 1 then
		TreasureHunt1.startHunt()
		TreasureHunt1.sendStartHuntMsg(1)
	end
end

function TreasureHunt1.startHuntTen(tag)
	if tag == 1 then
		TreasureHunt1.startHunt()
		TreasureHunt1.sendStartHuntMsg(10)
	end
end

function TreasureHunt1.startHuntFifty(tag)
	if tag == 1 then
		TreasureHunt1.startHunt()
		TreasureHunt1.sendStartHuntMsg(50)
	end
end

---寻宝界面信息接收---
function TreasureHunt1.recvHuntWndInfo(dt)
	SCActivityIndicator:getSingleton():close()
	if getCurentSceneWindow(11002) then return end
	
	mTreasureItem = {}
	m_huntWndInfo = {}
	m_huntWndInfo = stTreasureHunt1.initWithStream(dt)	--寻宝界面信息
	if not m_huntWndInfo.usAmount then return end
	
	m_HuntCount1 = m_huntWndInfo.nTen					--寻宝次数
	m_HuntCount2 = m_huntWndInfo.nFifty
	m_HuntCount0 = m_huntWndInfo.nOne
	m_HuntCount3 = m_huntWndInfo.nOneUseMoney
	
	for i = 1, m_huntWndInfo.usAmount do				--保存寻宝道具图标
		if m_huntWndInfo.info[i] then
			itemInfo = TableParser:getSingleton():getItemInfoByKey(m_huntWndInfo.info[i].idItemtype)
			if itemInfo then
				mTreasureItem[m_huntWndInfo.info[i].nPosition] = itemInfo.icon
			end
		end
	end
	
	TreasureHunt.showTreasureHuntWnd()
	TreasureHunt1.chgTreasureHuntBtn()
end

---寻宝结果信息接收---
function TreasureHunt1.recvHuntRltInfo(dt)
	SCActivityIndicator:getSingleton():close()
	
	TreasureHunt1.setKey()		--刷新钥匙值
	TreasureHunt1.setEmoney()	--刷新元宝值
	
	m_huntEnd = 0 
	m_realHuntEnd = 0 
	m_huntRlt = {}
	m_huntRltInfo = {}
	m_huntRltInfo = stTreasureHuntRlt.initWithStream(dt)		--寻宝结果信息
	if not m_huntRltInfo.usAmount then return end
	
	m_HuntCount1 = m_huntRltInfo.nTen							--寻宝次数
	m_HuntCount2 = m_huntRltInfo.nFifty
	m_HuntCount0 = m_huntRltInfo.nOne
	m_HuntCount3 = m_huntRltInfo.nOneUseMoney
	
	for i = 1, m_huntRltInfo.usAmount do
		local bIsInsert = true
		
		if m_huntRltInfo.info[i] then
			itemInfo = TableParser:getSingleton():getItemInfoByKey(m_huntRltInfo.info[i].idItemtype)
			if itemInfo then
				for j = 1, #m_huntRlt do						--T除重复
					if m_huntRlt[j] == m_huntRltInfo.info[i].nPosition then
						bIsInsert = false
					end
				end
				
				if bIsInsert then
					table.insert(m_huntRlt, m_huntRltInfo.info[i].nPosition)
				end
				
				if m_huntRltInfo.info[i].nPosition == 11 then
					m_huntEnd = m_huntRltInfo.info[i].nPosition
				else
					if m_huntEnd ~= 11 then
						m_huntEnd = m_huntRltInfo.info[i].nPosition	--抽到最大奖，停在最大奖上
					end
				end
			end
		end
	end
	
	m_realHuntEnd = m_huntEnd
	
	if m_huntEnd == 11 then		--不经过大奖，以前一个道具为停止位
		m_huntEnd = 10 
	end
	
	m_isNeedStop = true

	if m_huntEnd == 0 then
		if m_timeID then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_timeID)
			m_timeID = nil
		end
		TreasureHunt1.clearHuntRlt()	--清空寻宝结果
		TreasureHunt1.enable(true)		--功能按钮使能
	end
	
	TreasureHunt1.chgTreasureHuntBtn()
end

function TreasureHunt1.recvMsg(dt, action)
	SCActivityIndicator:getSingleton():close()
	if action == EVENTAWARD_TREASURE_WORLD_MSG then 		--寻宝秘闻
		local tmpdata = stWorldInfo.initWithStream(dt)
		if not tmpdata then return end
		
		if tmpdata.usAmount == 0 then						--分段消息接收完毕
			TreasureHunt1.showHistory()
		end
		
		if not m_worldInfo.usAmount then
			m_worldInfo = tmpdata
		else
			m_worldInfo.usAmount = m_worldInfo.usAmount + tmpdata.usAmount
			for i = 1, tmpdata.usAmount do
				table.insert(m_worldInfo.info, tmpdata.info[i])
			end
		end
	elseif action == EVENTAWARD_TREASURE_WORLD_TIP then		--寻宝滚动消息
		local tmpScrollInfo = {}
		tmpScrollInfo = stWorldInfo.initWithStream(dt)
		if not tmpScrollInfo then return end
		if not m_scrollInfo.usAmount then 
			m_scrollInfo.usAmount = 0
			m_scrollInfo.info = {}
		end
		
		if m_scrollInfo.usAmount + #tmpScrollInfo.info > 25 then return end
		
		m_scrollInfo.usAmount = m_scrollInfo.usAmount + #tmpScrollInfo.info
		
		for i = 1, #tmpScrollInfo.info do
			table.insert(m_scrollInfo.info, tmpScrollInfo.info[i])
		end

		TreasureHunt1.showWorldMsg()
	end
end

----------------消息注册区----------------
----------------全局函数区----------------


