
VIPShop = {}
-----------------------结构定义区------------------------
local stVipGoods = {
    initStream = function (dt)
        local tmp = {}
        if not dt then return tmp end
        
        tmp.idItemType = dt:readInt()
        tmp.dwOldMoney = dt:readInt()
        tmp.dwNewMoney = dt:readInt()
        tmp.szName     = dt:readString()
        if tmp.szName then
            tmp.szName = tmp.szName:getData()
        else
            tmp.szName = ""
        end
        tmp.nLimitLev  = dt:readInt()
        tmp.ucDayType  = dt:readByte()
        tmp.ucState    = dt:readByte()
        tmp.ucLimitVIPLevel   = dt:readByte()                           --//限制购买的VIP等级			//2表示VIP等级不足不能购买
        return tmp
    end
}

-----------------------结构定义区------------------------
local stVip_vipGoods = {
    initStream = function (dt)
        local tmp = {}
        if not dt then return tmp end
        
        tmp.idItemType = dt:readInt()
        tmp.dwOldMoney = dt:readInt()
        tmp.dwNewMoney = dt:readInt()
        tmp.szName     = dt:readString()
        if tmp.szName then
            tmp.szName = tmp.szName:getData()
        else
            tmp.szName = ""
        end
        tmp.nLimitLev  = dt:readInt()
        tmp.ucDayType  = dt:readByte()
        tmp.ucState    = dt:readByte()
        tmp.ucLimitVIPLevel   = dt:readByte()                           --//限制购买的VIP等级			//2表示VIP等级不足不能购买
        tmp.nLimitLev = tmp.ucLimitVIPLevel
        return tmp
    end
}
-----------------------常量定义区------------------------
local VIPSHOPACT_CLEAR          = 1
local VIPSHOPACT_CLEAR_END      = 5
local VIPSHOPACT_BUY            = 3
local VIPSHOPACT_BUY_SUCCESS    = 4 --,//表示商品购买成功

local VIPSHOP_LIMIT_LEV         = 1 --等级限购
local VIPSHOP_LIMIT_EVERYDAY    = 2 --每天限购
local VIPSHOP_LIMIT_VIP 		 = 3        --//vip限购 
-----------------------变量定义区------------------------
local m_stLevGoods = {}
local m_stDayGoods = {}
local m_stCurItem  = {}
local vip_mark = 0;  --------VIP标志

local m_nCurSelectedPageIndex       --当前选中的多页界面索引 0+                
local m_nCurItemIndex  --1+
local m_isMsgEnd
-----------------------逻辑功能区------------------------
--购买说明
function VIPShop.OnBtnBuyTip(tag)
    --showMessage(L("str20004"))
    --luashowConfirmationWindow(L("str20004"), WIN_ONLY_CLOSE)
    local wnd = SCFunction:getUiNodeByIdlist("9100")
    if not wnd then return end
    
    local tip = wnd:getChildByTag(1000)
    if not tip then
        tip = VIPShop.CreateTipWnd()
        tip:setAnchorPoint(CCPointMake(0.5, 0.5))
        tip:setPosition(wnd:getContentSize().width /2, wnd:getContentSize().height /2)
        wnd:addChild(tip)
    end
end

--点击购买
function VIPShop.onClickItemBuy(tag)
    if not tag then return end     
    
    m_nCurItemIndex = tag
    
    if m_nCurSelectedPageIndex == 0 then
        m_stCurItem = m_stLevGoods[tag]                
    elseif m_nCurSelectedPageIndex == 1 then
        if tag == 1 then
            local vip = Hero:getSingleton():getVipLevel()
            if vip < 4 then
                luashowConfirmationWindowPoint(L("str20104"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
                return
            end
        end
        
        m_stCurItem = m_stDayGoods[tag]        
    elseif m_nCurSelectedPageIndex == 2 then
        m_stCurItem = m_stLevGoods[tag]    
    end
    
    if m_stCurItem and m_stCurItem.idItemType ~= 0 then
        local str = string.format(L("str20040"), m_stCurItem.dwNewMoney, m_stCurItem.szName)
        luashowConfirmationWindow(str, WIN_YES_NO, VIPShop.IsBuyReturn)    
    end
end

function VIPShop.IsBuyReturn(tag)
    if tag == WIN_YES then
        local heroEMoney = Hero:getSingleton():getEmoney()
        
        local tmp = {}
        if m_nCurSelectedPageIndex == 0 then
            if not m_stLevGoods[m_nCurItemIndex] then return end 
            
            if heroEMoney < m_stLevGoods[m_nCurItemIndex].dwNewMoney then
                --GuidePoint_shoprechange()
                luashowConfirmationWindowPoint(L("str20103"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
                return
            end
            
            tmp.idItemType = m_stLevGoods[m_nCurItemIndex].idItemType
            tmp.ucType = VIPSHOP_LIMIT_LEV
            tmp.nLimitLev = m_stLevGoods[m_nCurItemIndex].nLimitLev
            tmp.ucDayType = m_stLevGoods[m_nCurItemIndex].ucDayType
            m_stCurItem = tmp
            
            VIPShop.SendBuyLevGoods()
        elseif m_nCurSelectedPageIndex == 1 then
            if not m_stDayGoods[m_nCurItemIndex] then return end 
            
            if heroEMoney < m_stDayGoods[m_nCurItemIndex].dwNewMoney then
                --GuidePoint_shoprechange()
                luashowConfirmationWindowPoint(L("str20103"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
                return
            end
            
            tmp.idItemType = m_stDayGoods[m_nCurItemIndex].idItemType
            tmp.ucType = VIPSHOP_LIMIT_EVERYDAY
            tmp.nLimitLev = m_stDayGoods[m_nCurItemIndex].nLimitLev
            tmp.ucDayType = m_stDayGoods[m_nCurItemIndex].ucDayType
            m_stCurItem = tmp
            
            VIPShop.SendBuyDayGoods()
		elseif m_nCurSelectedPageIndex == 2 then
            if not m_stLevGoods[m_nCurItemIndex] then return end 
            
            if heroEMoney < m_stLevGoods[m_nCurItemIndex].dwNewMoney then
                --GuidePoint_shoprechange()
                luashowConfirmationWindowPoint(L("str20103"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
                return
            end
            
            tmp.idItemType = m_stLevGoods[m_nCurItemIndex].idItemType
            tmp.ucType = VIPSHOP_LIMIT_VIP
            tmp.nLimitLev = m_stLevGoods[m_nCurItemIndex].nLimitLev
            tmp.ucDayType = m_stLevGoods[m_nCurItemIndex].ucDayType
            m_stCurItem = tmp
            
            VIPShop.SendBuyvipGoods()
        end
    end
end
--商品提示信息
function VIPShop.onBtnItemInfo(tag)
    if not tag then return end 
    
    local index = tag - 100
    if m_nCurSelectedPageIndex == 0 then
        if m_stLevGoods[index] then
            showTip(m_stLevGoods[index].idItemType)
        end
    elseif m_nCurSelectedPageIndex == 1 then
        if m_stDayGoods[index] then
            if m_stDayGoods[index].idItemType == 0 then
                return
            end
            showTip(m_stDayGoods[index].idItemType)
        end
	elseif m_nCurSelectedPageIndex == 2 then
        if m_stLevGoods[index] then
            if m_stLevGoods[index].idItemType == 0 then
                return
            end
            showTip(m_stLevGoods[index].idItemType)
        end
    end
end

--特惠商城关闭回调
function VIPShop.onVIPShopClose(tag)
    m_nCurSelectedPageIndex = nil
    m_nCurItemIndex = nil
    m_isMsgEnd   = nil
    
    m_stLevGoods = {}
    m_stDayGoods = {}
    m_stCurItem  = {}    
end

function VIPShop.onDarkTip(tag)
    luashowConfirmationWindowPoint(L("str20104"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
end

--多页控件选择事件
function VIPShop.tabPageSelected(tag, pageIndex)    
    local muliPage = SCFunction:getUiNodeByIdlist("9100-1")
    if not muliPage then return end 
    
    if pageIndex == 0 then
        --if #m_stLevGoods == 0 then
            VIPShop.SendOpenLevShop()            
        --end
    elseif pageIndex == 1 then
        if #m_stDayGoods == 0 then
            VIPShop.SendOpenDayShop()            
        end
    elseif pageIndex == 2 then
		--m_stLevGoods = {}
        --if #m_stLevGoods == 0 then
            VIPShop.SendOpenvipShop()            
        --end
    end

--[[    local page = muliPage:getPageWithIndex(pageIndex)
    
    local node = page:getChildByTag(1)
    if not node then
        node = VIPShop.CreatePageWithIndex(pageIndex)
        if node then	        
            node:setPosition(SX(10),SY(50))
            node:setTag(1)
            page:addChild(node)                    
        end	
        
        if pageIndex == 1 then
            local parseNode = getItemTextNode(L("str20005"), 12)
            if parseNode then
                parseNode:setPosition(AUTO_POS(30, 30))
                parseNode:setAnchorPoint(CCPointMake(0, 0.5))                
                parseNode:setPerWidthAndHeight(0, 15)
                page:addChild(parseNode)
            end
        end
    end    ]]
    
    m_nCurSelectedPageIndex = pageIndex
    m_nCurItemIndex = nil
end

--特惠商城初始化操作
function VIPShop.init()
    local mulPage = tolua.cast(SCFunction:getUiNodeByIdlist("9100-1"), "SCMultiPage")
    if mulPage then
        mulPage:selectPageWithIndex(0)
    end
end

function VIPShop.SetDarkLayer(node, idFunc)
    if not node then return end 
    if node:getChildByTag(666) then
        return
    end
    
    local szNode = node:getContentSize()    
    local btn = SCButton:button()
    if btn then
        btn:setTag(666)
        btn:setAnchorPoint(CCPointMake(0.5, 0.5))
        btn:setContentSize(CCSizeMake(szNode.width - SX(14), szNode.height - SY(14)))
        btn:setBackgroundColor(ccc4(0, 0, 0, 200))
        btn:setPosition(szNode.width / 2, szNode.height / 2)
        if idFunc then
            btn:luaSetSelectorOnClicked(idFunc)
        end
        node:addChild(btn)
    end
    
    local child = node:getChildByTag(node:getTag())
    if child then
        child:setTouchEnabled(false)
    end
    
    local btnImg = node:getChildByTag(node:getTag() + 100)
    if btnImg then
        local node = btnImg:getChildByTag(22)
        if not node then
            node = SCNode:node()        
            if node then
                btnImg:addChild(node)                
                node:setContentSize(btnImg:getContentSize())
                node:setBackgroundColor(ccc4(0, 0, 0, 200))
                node:setTag(22)
            end        
        end
    end
end

--更新窗口
function VIPShop.UpdateWindow()     
   VIPShop.UpdatePage(m_nCurSelectedPageIndex)    
   local labelMoney = tolua.cast(SCFunction:getUiNodeByIdlist("9100-10"))
    if label then
        strEMoney = Hero:getSingleton():getEmoney()..""
        labelMoney:setText(strEMoney)
    end
end

function VIPShop.Notify(item)
    if not item then return end     
    
    if item.ucType == 1 then
        if m_stCurItem.idItemType == item.idItemType and m_stCurItem.nLimitLev == item.nLimitLev then
            for i = 1, #m_stLevGoods do
                if m_stLevGoods[i].idItemType == item.idItemType and m_stLevGoods[i].nLimitLev == item.nLimitLev then
                    m_stLevGoods[i].ucState = item.ucState
                    VIPShop.ShowBuyScuess(m_stLevGoods[i])
                    --VIPShop.UpdateItem(0, i)                    
                    VIPShop.SortLevGoods()
                    VIPShop.UpdatePage(0)                    
                    break
                --else
                    --VIPShop.UpdatePage(0)
                end
            end    
        end
 --       VIPShop.SendOpenLevShop()
    elseif item.ucType == 2   then        
        if item.ucDayType < #m_stDayGoods or item.ucDayType > 0 then            
            if m_stDayGoods[item.ucDayType].idItemType == item.idItemType and m_stDayGoods[item.ucDayType].nLimitLev == item.nLimitLev and 
                    m_stCurItem.ucDayType == item.ucDayType then
                m_stDayGoods[item.ucDayType].ucState = item.ucState
                VIPShop.ShowBuyScuess(m_stDayGoods[item.ucDayType])
                VIPShop.UpdateItem(1, item.ucDayType)                
            else
                VIPShop.UpdatePage(1)
            end
        end    
	elseif  item.ucType == 3  then
		if m_stCurItem.idItemType == item.idItemType and m_stCurItem.nLimitLev == item.nLimitLev then
            for i = 1, #m_stLevGoods do
                if m_stLevGoods[i].idItemType == item.idItemType and m_stLevGoods[i].ucLimitVIPLevel == item.ucLimitVIPLevel then
                    m_stLevGoods[i].ucState = item.ucState
                    VIPShop.ShowBuyScuess(m_stLevGoods[i])
                    break
                --else
                    --VIPShop.UpdatePage(0)
                end
            end    
        end
		VIPShop.SendOpenvipShop();
    end     
    
    local labelMoney = tolua.cast(SCFunction:getUiNodeByIdlist("9100-10"), "SCLabel")
    if labelMoney then
        strEMoney = Hero:getSingleton():getEmoney()..""
        labelMoney:setText(strEMoney)
    end
    
    m_stCurItem = {}
end

--
function VIPShop.UpdateItem(pageIndex, itemIndex)
    if not pageIndex or not itemIndex then return end     
   
    local multiPage = SCFunction:getUiNodeByIdlist("9100-1")
    if multiPage then        
        local page = multiPage:getPageWithIndex(pageIndex)
        if page then
            local itemNode = SCFunction:getUiNodeByIdlistAndParent("1-1-"..itemIndex, page)
            if itemNode then
                local label = tolua.cast(itemNode:getChildByTag(205), "SCLabel")
                if label then                     
                    local stGoods = m_stLevGoods[itemIndex]
                    if pageIndex == 1 then
                        stGoods = m_stDayGoods[itemIndex]                        
                    end
                    
                    if stGoods.ucState == 3 then
                        VIPShop.SetDarkLayer(itemNode) 
                    elseif stGoods.ucState == 1 then
                        --itemNode:setTouchEnabled(false)
                        VIPShop.SetDarkLayer(itemNode) 
                        label:setText(L("str20061")) 
                    else
                        label:setText(L("str20002")) 
                        local node = itemNode:getChildByTag(itemNode:getTag())
                        if node then
                            node:setTouchEnabled(true)
                        end
                    end
                end    
            end
        end
    end     
end

--更新页面
function VIPShop.UpdatePage(index)
    if not index then return end 
    if index < 0 or index > 2 then return end
    
    local multiPage = SCFunction:getUiNodeByIdlist("9100-1")--..m_nCurSelectedPageIndex.."-1-1")   
    if multiPage then 
        local node = multiPage:getPageWithIndex(index)
        if node then
            local frame = node:getChildByTag(1)            
            if frame then
                frame:removeFromParentAndCleanup(true)
            end
            
            frame = VIPShop.CreatePageWithIndex(index)
            if frame then 
                frame:setPosition(SX(10),SY(50))
                frame:setTag(1)
                node:addChild(frame)                  	
            end
            
            if m_nCurSelectedPageIndex == 1 then
                local parseNode = getItemTextNode(L("str20005"), 12)
                if parseNode then
                    parseNode:setPosition(AUTO_POS(2, 30))
                    parseNode:setAnchorPoint(CCPointMake(0, 0.5))                
                    parseNode:setPerWidthAndHeight(0, 15)
                    node:addChild(parseNode)
                end
            end             
        end        
    end
    
    if index == 0 then
        for i = 1, #m_stLevGoods do
           VIPShop.UpdateItem(0, i)
        end
    elseif index == 1 then
       for j = 1, #m_stDayGoods do
           VIPShop.UpdateItem(1, j)
       end
    end
end
-----------------------UI控制器区------------------------
--创建VIP等级  
local function CreateNumberNode(lev, imagePath, width, height, gap)
    if not imagePath then return end 
    if lev < 0 then return end 
    
    local path = RES(imagePath)
    local node = SCNode:node()
    if not path or not node then return end 
    
    local num = lev    
    if num == 0 then        
        local image = SCImage:imageWithFile(path, CCRectMake(0, 0, width, height));
        if image then
            node:addChild(image);
            node:setContentSize(image:getContentSize())
            return node
        end
    end
    
    local count = getNumberCount(lev)
    local index = count
    while index ~= 0 do
        index = index - 1
        local n = num % 10
        local img = SCImage:imageWithFile(path, CCRectMake((width + gap) * n, 0, width, height))
        if img then
            img:setPosition(width * index, 0)
            node:addChild(img)
        end
        num = math.floor(num / 10)
    end
    local w = width * count
    node:setContentSize(CCSizeMake(w, height))
    return node
end

--创建按钮
local function CreateButton(bgPath,selPath)
    if not bgPath or not selPath then return end 
    
    local bgImg = RES(bgPath)
    local selImg = RES(selPath)
    
    local btn = SCButton:button()    
    if bgImg and selImg and btn then
        btn:setBackgroundImage(bgImg)
        btn:setSelectedImage(selImg)
    end
    
    return btn
end

--创建VIP等级
local function CreateLEVImage(lev)
    local levPath = RES("img/new00486.pn")     
    if not levPath then return end 
    
    local width  = SX(10)
    local height = SX(17)
    local gap    = SX(7)
    local numNode =  CreateNumberNode(lev, "img/new00487.pn", width, height, gap)
    local levImg = SCImage:imageWithFile(levPath)
    local node = SCNode:node()
    if numNode and levImg and node then
        numNode:setPosition(levImg:getContentSize().width, 0)
        
        node:addChild(numNode)
        node:addChild(levImg)
        node:setContentSize(CCSizeMake(levImg:getContentSize().width + numNode:getContentSize().width, levImg:getContentSize().height))
        return node
    end
end
--VIP商城
local function CreateVIPImage(lev)
    local levPath = RES("img/new00116.pn")     
    if not levPath then return end 
    
    local width  = SX(10)
    local height = SX(17)
    local gap    = SX(7)
    local numNode =  CreateNumberNode(lev, "img/new00487.pn", width, height, gap)
    local levImg = SCImage:imageWithFile(levPath)
    local node = SCNode:node()
    if numNode and levImg and node then
        numNode:setPosition(levImg:getContentSize().width, 0)
        
        node:addChild(numNode)
        node:addChild(levImg)
        node:setContentSize(CCSizeMake(levImg:getContentSize().width + numNode:getContentSize().width, levImg:getContentSize().height))
        return node
    end
end
--打开特惠商城
function VIPShop.OpenVIPWnd()
    local wndCtrl = getCurentSceneWindowController(9100)
    if not wndCtrl then
        local wnd = VIPShop.CreateVIPWnd()
        if wnd then
            wndCtrl = SCWindowController:controllerWithWindow(wnd)
            local naviCtrl =  getCurentSceneNavigationController()
            if wndCtrl and naviCtrl then
                naviCtrl:pushWindowController(wndCtrl)                
            end
            
            VIPShop.init()
            VIPShop.UpdateWindow()
        end
    else
        VIPShop.UpdateWindow()
    end
end

--选择创建优惠商品页面
function VIPShop.CreatePageWithIndex(index)
    local frame = SCDragNode:node()
    if not frame then return end 
    
    local szFrame = AUTO_SIZE(460, 220)
    
    frame:setFrameType(0)
    frame:setFrameVisibled(true)
    frame:setContentSize(szFrame)
    --frame:setTag(100)       
    
    local page
    if index == 0 then
        page =  VIPShop.CreateLEVPage()
    elseif index == 1 then
        page = VIPShop.CreateEveryPage() 
    elseif index == 2 then
        page =  VIPShop.CreateLEVPage()   -----VIP
    end
    
    if page then
        page:setTag(1)
        frame:addChild(page)        
        page:setPosition(AUTO_POS(15, 10))
    end
    
    return frame
end

--创建商城特惠商品结点
--param index = 1 or 2 or 3
function VIPShop.CreateShopItemNode(index, tag)
    if not index or not tag then return end 
    
    local node = SCDragNode:node()
    if not node then return end     
    
    local szCell = AUTO_SIZE(130,200)
    local stGoods = m_stLevGoods[tag]
    if index == 2 then
        szCell = AUTO_SIZE(140, 200)
        stGoods = m_stDayGoods[tag]
    end
    
    node:setFrameType(0)
    node:setFrameVisibled(true)
    node:setContentSize(szCell)
    node:setTag(tag)
    
    local btnBackground = SCButton:button()
    if btnBackground then
        btnBackground:setTag(tag)
        btnBackground:setContentSize(szCell)
        btnBackground:luaSetSelectorOnClicked(VIPShop.onClickItemBuy)    
        node:addChild(btnBackground)
    end
    
    local pt = CCPointMake(szCell.width / 2, szCell.height - SY(5))
    local upSpace = SY(5)
    local downSpace = SY(5)
    
    if index == 1 then
        local lev = stGoods.nLimitLev
        local levImg = nil
        if  vip_mark == 0 then
			levImg = CreateLEVImage(lev)
		else
			levImg = CreateVIPImage(lev)
        end 
        if levImg then
            levImg:setAnchorPoint(CCPointMake(0.5, 1))        
            levImg:setPosition(pt.x, pt.y - upSpace)
            node:addChild(levImg) 
            
            pt = CCPointMake(pt.x, levImg:getPosition().y - levImg:getContentSize().height)
        end        
    elseif index == 2 then
        local label = SCLabel:labelWithStringFont(" ", getDefaultFontName(), F(15))
        if label then
            label:setTag(201)
            label:setAnchorPoint(CCPointMake(0.5, 1))
            label:setPosition(pt.x, pt.y - upSpace * 2)
            label:setColor(color_yellow)
            node:addChild(label)
            
            pt = CCPointMake(pt.x, label:getPosition().y - label:getContentSize().height)
        end
    end
--[[    local labelLEV = SCLabel:labelWithStringFont("LV.35", getDefaultFontName(), F(15))
    if labelLEV then
        labelLEV:setAnchorPoint(CCPointMake(0.5, 1))        
        labelLEV:setPosition(pt.x, pt.y - upSpace)
        node:addChild(labelLEV) 
        
        pt = CCPointMake(pt.x, labelLEV:getPosition().y - labelLEV:getContentSize().height)
    end]]
    
    labelName = SCLabel:labelWithStringFont(stGoods.szName, getDefaultFontName(), F(12))
    if labelName then
        labelName:setAnchorPoint(CCPointMake(0.5, 1))        
        labelName:setPosition(pt.x, pt.y - upSpace)
        labelName:setColor(color_orange)
        labelName:setTag(202)
        node:addChild(labelName)
        
        pt = CCPointMake(pt.x, labelName:getPosition().y - labelName:getContentSize().height)
    end
    
    local btnItem = CreateButton("img/new00002.pn", "img/new00003.pn")
    if btnItem then
        btnItem:setTag(tag + 100)
        btnItem:setAnchorPoint(CCPointMake(0.5, 1))
        btnItem:setPosition(pt.x, pt.y - upSpace)
        btnItem:luaSetSelectorOnClicked(VIPShop.onBtnItemInfo)
        node:addChild(btnItem, 1)
        
        pt = CCPointMake(pt.x, szCell.height / 2)
        
        local item = TableParser:getSingleton():getItemInfoByKey(stGoods.idItemType)
        if item then
            local path
            if item.icon ~= 0 then
                path = RES("item/"..item.icon..".jp")
            else
                path = RES("img/ItemTemp.pn")
            end
            
            if path then
                btnItem:setTitle(path)
            end
        end
    end
    
    local linePath = RES("img/new00218.pn")
    if linePath then
        local img = SCImage:imageWithFile(linePath)
        if img then
            img:setAnchorPoint(CCPointMake(0.5, 0.5))
            if index == 2 then
                img:setPosition(pt.x, pt.y - SY(12))
            else
                img:setPosition(pt.x, pt.y - upSpace)
            end
            img:setScaleX(0.4)
            node:addChild(img)
        end
    end
    
    local labelOld = SCLabel:labelWithStringFont(L("str20000") , getDefaultFontName(), F(15))
    if labelOld then
        labelOld:setAnchorPoint(CCPointMake(0, 1))        
        labelOld:setPosition(pt.x - SX(45), pt.y - SY(15))
        labelOld:setColor(color_lightYellow)
        node:addChild(labelOld) 
    
        pt = CCPointMake(pt.x, labelOld:getPosition().y - labelOld:getContentSize().height)
        
        local path = RES("img/2001008.pn")
        if path then
            local img = SCImage:imageWithFile(path)
            if img then
                img:setPosition(pt.x - SX(4), pt.y + labelOld:getContentSize().height / 2)
                img:setAnchorPoint(CCPointMake(0.5, 0.5))                
                img:setScale(0.7)
                node:addChild(img)
            end
        end
        
        local labelPrice ;--SCLabel:labelWithStringFont(stGoods.dwOldMoney, getDefaultFontName(), F(15))
        if stGoods.idItemType ~= 0 then
            labelPrice = getImageNumber(stGoods.dwOldMoney, "img/new00530.png", SX(12.2), SY(18), SX(8))
        else
            labelPrice = SCLabel:labelWithStringFont(stGoods.dwOldMoney, getDefaultFontName(), F(15))
        end
        if labelPrice then
            labelPrice:setAnchorPoint(CCPointMake(0, 0.5))
            labelPrice:setPosition(pt.x + SX(15), pt.y + SY(7))
            if stGoods.idItemType == 0 then
                labelPrice:setColor(color_lightYellow)
            end
            labelPrice:setTag(203)
            node:addChild(labelPrice)
        end
    end
    
    local labelNew = SCLabel:labelWithStringFont(L("str20001"), getDefaultFontName(), F(15))
    if labelNew then
        labelNew:setAnchorPoint(CCPointMake(0, 1))        
        labelNew:setPosition(pt.x - SX(45), pt.y - downSpace)
        labelNew:setColor(color_yellow)
        node:addChild(labelNew) 
        
        pt = CCPointMake(pt.x, labelNew:getPosition().y - labelNew:getContentSize().height)
        
        local path = RES("img/2001008.pn")
        if path then
            local img = SCImage:imageWithFile(path)
            if img then
                img:setPosition(pt.x - SX(4), pt.y + labelNew:getContentSize().height / 2)
                img:setAnchorPoint(CCPointMake(0.5, 0.5))
                img:setScale(0.7)
                node:addChild(img)
            end
        end
        
        local labelPrice --= getImageNumber(stGoods.dwNewMoney, "img/new00530.png", SX(12.2), SY(18), SX(8))--SCLabel:labelWithStringFont(stGoods.dwNewMoney, getDefaultFontName(), F(15))
        if stGoods.idItemType ~= 0 then
            labelPrice = getImageNumber(stGoods.dwNewMoney, "img/new00530.png", SX(12.2), SY(18), SX(8))
        else
            labelPrice = SCLabel:labelWithStringFont(stGoods.dwNewMoney, getDefaultFontName(), F(15))
        end
        if labelPrice then
            labelPrice:setAnchorPoint(CCPointMake(0, 0.5))
            labelPrice:setPosition(pt.x + SX(15), pt.y + SY(7))
            if stGoods.idItemType == 0 then
                labelPrice:setColor(color_lightYellow)
            end
            labelPrice:setTag(204)
            node:addChild(labelPrice)
        end
    end   
    
    local str = L("str20002")
    if stGoods.ucState == 1 then
        str = L("str20061")
    end
    local labelBuy = SCLabel:labelWithStringFont(str, getDefaultFontName(), F(15))
    if labelBuy then
        labelBuy:setColor(color_green)
        labelBuy:setTag(1000)
        labelBuy:setAnchorPoint(CCPointMake(0.5, 1))
        labelBuy:setPosition(pt.x, pt.y - downSpace)
        labelBuy:setTag(205)
        node:addChild(labelBuy)
    end

    return node
end

--创建等级优惠页面
function VIPShop.CreateLEVPage()   
    local szPage = AUTO_SIZE(430, 200) 
    local scrollBox = SCScrollBox:boxWithWidthHeight(szPage.width, szPage.height)
    if scrollBox then
        scrollBox:setScrollVertical(false)
        scrollBox:setTag(1)
        
        local szCell
        local nSpace = SX(2)
        local num = 0
        for i = 1, #m_stLevGoods do
            local cell = VIPShop.CreateShopItemNode(1, i)
            if cell then                
                szCell = cell:getContentSize()
                cell:setTag(i)
                cell:setPosition(CCPointMake((nSpace + szCell.width)  * (i - 1), SY(0)))            
                scrollBox:addChild(cell)
                num = num + 1
                
                if m_stLevGoods[i] then
                    if m_stLevGoods[i].ucState == 3 or m_stLevGoods[i].ucState == 1 then
                        VIPShop.SetDarkLayer(cell)
                    end
                end
            end
        end   
        
        if szCell then
            scrollBox:setContentSize(CCSizeMake((nSpace + szCell.width) * num, szCell.height))
        end
    end
    
    return scrollBox
end

--创建每日精选结点
function VIPShop.CreateEveryPage()
    local szPage = AUTO_SIZE(430, 200) 
    local scrollBox = SCScrollBox:boxWithWidthHeight(szPage.width, szPage.height)
    if scrollBox then
        scrollBox:setScrollVertical(false)
        scrollBox:setScrollHorizontal(false)
        
        local szCell
        local nSpace = SX(5)
        local num = 0
        local strDay = {__mode = "kv", L("str20056"), L("str20057"), L("str20058")}        
        local count = #m_stDayGoods
        --[[local n = 1
        if count == 2 then
            n = 2
            count = count + 1
        end]]
        for i = 1, count do
            local cell = VIPShop.CreateShopItemNode(2, i)
            if cell then
                cell:setTag(i)
                szCell = cell:getContentSize()
                cell:setPosition(CCPointMake((nSpace + szCell.width)  * (i - 1), SY(0)))            
                scrollBox:addChild(cell)
                num = num + 1
                
                local nodeDay = tolua.cast(cell:getChildByTag(201), "SCLabel")
                if nodeDay then
                    nodeDay:setText(strDay[i])
                end
                
                if m_stDayGoods[i] then--and (m_stDayGoods[i].ucState == 2) then
                    if --[[m_stDayGoods[i].ucState == 2 or]] m_stDayGoods[i].ucState == 1 then
                        VIPShop.SetDarkLayer(cell)
                    end
                end
                local vipLev = Hero:getSingleton():getVipLevel()
                if vipLev < 4 and i == 1 then
                    if m_stDayGoods[i].idItemType == 0 then
                        VIPShop.SetDarkLayer(cell)
                    else
                        VIPShop.SetDarkLayer(cell, VIPShop.onDarkTip)
                    end
                end
                if m_stDayGoods[i].idItemType == 0 then--i == count then
                    local btn = tolua.cast(cell:getChildByTag(i + 100), "SCButton")
                    local path = RES("item/2005001.jp")
                    if btn and path then
                        btn:setTitle(path)
                    end
                    VIPShop.SetDarkLayer(cell)
                    --[[local strTmp = {__mode = "kv", L("str20059"), "????", "???", L("str20055")}
                    for j = 2, 5 do
                        local node = tolua.cast(cell:getChildByTag(j + 200), "SCLabel")
                        if node then
                            node:setText(strTmp[j - 1])
                        end
                    end
                    VIPShop.SetDarkLayer(cell)]]
                end
            end
        end   
        if szCell then
            scrollBox:setContentSize(CCSizeMake((nSpace + szCell.width) * num, szCell.height))
        end        
    end   
    
    return scrollBox
end

--创建特惠商城
function VIPShop.CreateVIPWnd()
    local wnd = SCWindow:window()
    if not wnd then return end 
    
    wnd:setTag(9100)
    wnd:luaSetSelectorOnClose(VIPShop.onVIPShopClose)
    wnd:setContentSize(AUTO_SIZE(480, 320))
    local wndImg = RES("shop/new00725.pn")
    if wndImg then
        wnd:setTitleWithImage(wndImg)
    end
    
    local szWnd = AUTO_SIZE(480, 320)
    local szPage = szWnd
    local tabPage = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
    if tabPage then		
		local pageImg = {"new00726.pn", "new00729.pn", "new00728.pn"}
		tabPage:setContentSize(szPage)
		for i = 1, #pageImg do
		    local node = SCNode:node()
		    if node then		        
		        node:setContentSize(szPage)
		        tabPage:addPage(node)		                        
                
		        local path = RES("shop/" .. pageImg[i])
                if path then
                    tabPage:setTitleAtPage(path, i - 1)
                end               
            end	
		end
		
		tabPage:setTag(1)
--		tabPage:setAnchorPoint(CCPointMake(0.5, 1))
--		tabPage:setPosition(szWnd.width / 2, szWnd.height)
		tabPage:luaSetSelectorOnPageSelected(VIPShop.tabPageSelected)		
		wnd:addChild(tabPage)		
    end

    local btn = SCButton:button(1)
    if btn then
        local titlePath = RES("shop/new00727.pn")
        if titlePath then
            btn:setTitle(titlePath)
        end
        btn:setAnchorPoint(CCPointMake(0.5, 0.5))
        btn:setContentSize(AUTO_SIZE(80, 30))        
        btn:setPosition(szWnd.width - SX(70), SY(30))
        btn:luaSetSelectorOnClicked(VIPShop.OnBtnBuyTip)
        wnd:addChild(btn)
    end
    
    local path = RES("img/2001008.pn")
    if path then
        local img = SCImage:imageWithFile(path)
        if img then
            img:setPosition(AUTO_POS(180, 30))
            img:setAnchorPoint(CCPointMake(0.5, 0.5))
            wnd:addChild(img)
        end
    end
    
    local path = RES("img/new00001.pn")
    if path then
        local img = SCImage:imageWithFile(path)
        if img then
            img:setPosition(AUTO_POS(210, 30))
            img:setAnchorPoint(CCPointMake(0, 0.5))
            wnd:addChild(img)
        end
    end
    
    local strEMoney = Hero:getSingleton():getEmoney()..""
    local labelMoney = SCLabel:labelWithStringFont(strEMoney, getDefaultFontName(), F(14))
    if labelMoney then
        labelMoney:setTag(10)
        labelMoney:setAnchorPoint(CCPointMake(0, 0.5))
        labelMoney:setPosition(AUTO_POS(215, 30))
        wnd:addChild(labelMoney)
    end

    return wnd 
end

function VIPShop.CreateTipWnd()
    local pframeWnd = FrameWindow:frameWnd();
    if pframeWnd then
        local szWnd = CCSizeMake(SX(340), SY(150))
        pframeWnd:setTag(1000)
        pframeWnd:setContentSize(szWnd);
        pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
        local str = L("str20004")
        
        local pParsedNode = getItemTextNode(str, 0, 15);
        if pParsedNode then
            pParsedNode:setTag(1)
            pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5))
            --pParsedNode:setContentSize(CCSizeMake(szWnd.width - SX(20), szWnd.height - SY(20)))
            pParsedNode:setPosition(szWnd.width / 2, szWnd.height / 2);
            pframeWnd:addChild(pParsedNode);
        end
        pframeWnd:setCloseBtnVisible(false);
    end
    
    return pframeWnd
end

function VIPShop.ShowBuyScuess(item)
    if not item then return end 
    
    local str = string.format(L("str20100"), "*6"..item.dwNewMoney..L("str0138").."*0", "*5"..item.szName.."*0")
    if str then
        --[[if item.idItemType >= 1899000001 and item.idItemType <= 1899000005 then
            str = str.."_*6"..string.format(L("str20101"), item.szName).."*0"
        end]]
        showMessage(str)
    end
end
-----------------------消息处理区------------------------
--等级商城
function VIPShop.SendOpenLevShop()
	vip_mark = 0;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_VIPSHOP)
    if dataStream then
        dataStream:writeByte(VIPSHOPACT_CLEAR)
        dataStream:writeByte(VIPSHOP_LIMIT_LEV)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end
---VIP商城
function VIPShop.SendOpenvipShop()
	vip_mark = 1;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_VIPSHOP)
    if dataStream then
        dataStream:writeByte(VIPSHOPACT_CLEAR)
        dataStream:writeByte(VIPSHOP_LIMIT_VIP)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end
function VIPShop.SendBuyLevGoods()
    if not m_stCurItem.nLimitLev or not m_stCurItem.ucDayType then
        return
    end 
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_VIPSHOP)
    if dataStream then
        dataStream:writeByte(VIPSHOPACT_BUY)
        dataStream:writeInt(m_stCurItem.idItemType)
        dataStream:writeByte(VIPSHOP_LIMIT_LEV)
        dataStream:writeInt(m_stCurItem.nLimitLev)
        dataStream:writeByte(m_stCurItem.ucDayType)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end
function VIPShop.SendBuyvipGoods()
    if not m_stCurItem.nLimitLev or not m_stCurItem.ucDayType then
        return
    end 
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_VIPSHOP)
    if dataStream then
        dataStream:writeByte(VIPSHOPACT_BUY)
        dataStream:writeInt(m_stCurItem.idItemType)
        dataStream:writeByte(VIPSHOP_LIMIT_VIP)
        dataStream:writeInt(m_stCurItem.nLimitLev)
        dataStream:writeByte(m_stCurItem.ucDayType)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end
function VIPShop.RecvLevData(dt)
    if not dt then return end 
    if m_isMsgEnd then
        m_stLevGoods = {}
        m_isMsgEnd = nil
    end
    
    local ucAmount = dt:readByte()
    for i = 1, ucAmount do
        table.insert(m_stLevGoods, stVipGoods.initStream(dt))
    end
    VIPShop.SortLevGoods()
end
function VIPShop.RecvvipData(dt)
    if not dt then return end 
    if m_isMsgEnd then
        m_stLevGoods = {}
        m_isMsgEnd = nil
    end
    --m_stLevGoods = {}
    local ucAmount = dt:readByte()
    for i = 1, ucAmount do
        table.insert(m_stLevGoods, stVip_vipGoods.initStream(dt))
        --[[
        if  m_stLevGoods[i].ucLimitVIPLevel then
			m_stLevGoods[i].nLimitLev = m_stLevGoods[i].ucLimitVIPLevel
        end 
        local i = 1
        ]]
    end
    --VIPShop.SortLevGoods()
end
--等级商品排序
function VIPShop.SortLevGoods()
    if not m_stLevGoods then return end     
    
    local stLev0 = {}
    local stLev1 = {}
    table.sort(m_stLevGoods, VIPShop.SortComp)
    for i = 1, #m_stLevGoods do
        if m_stLevGoods[i].ucState == 0 then            
            table.insert(stLev0, VIPShop.CopyGoods(m_stLevGoods[i]))
        else
            table.insert(stLev1, VIPShop.CopyGoods(m_stLevGoods[i]))
        end
    end
    
    m_stLevGoods = {}
    for i = 1, #stLev0 do
        table.insert(m_stLevGoods, stLev0[i])
    end
    
    for i = 1, #stLev1 do
        table.insert(m_stLevGoods, stLev1[i])
    end
    stLev0 = {}
    stLev1 = {}
end

function VIPShop.CopyGoods(item)
    if not item then return end 
    
    local tmp = {}
    tmp.idItemType = item.idItemType
    tmp.dwOldMoney = item.dwOldMoney
    tmp.dwNewMoney = item.dwNewMoney
    tmp.szName     = item.szName
    tmp.szName     = item.szName
    tmp.nLimitLev  = item.nLimitLev
    tmp.ucDayType  = item.ucDayType
    tmp.ucState    = item.ucState
    
    return tmp
end

function VIPShop.SortComp(a, b)
    if not a or not b then return end 
    if a.nLimitLev and b.nLimitLev then
		if a.nLimitLev < b.nLimitLev then
			return true    
		end
    end 
    return false
end
-------------------
--VIP商城
function VIPShop.SendOpenDayShop()
	vip_mark = 0;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_VIPSHOP)
    if dataStream then
        dataStream:writeByte(VIPSHOPACT_CLEAR)
        dataStream:writeByte(VIPSHOP_LIMIT_EVERYDAY)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end
--购买
function VIPShop.SendBuyDayGoods()
    if not m_stCurItem.nLimitLev or not m_stCurItem.ucDayType then
        return
    end 
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_VIPSHOP)
    if dataStream then
        dataStream:writeByte(VIPSHOPACT_BUY)
        dataStream:writeInt(m_stCurItem.idItemType)
        dataStream:writeByte(VIPSHOP_LIMIT_EVERYDAY)
        dataStream:writeInt(m_stCurItem.nLimitLev)
        dataStream:writeByte(m_stCurItem.ucDayType)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end

function VIPShop.SendCloseEffect()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(UNLOCK_TYPE_VIP_PERFERENCE_SHOP)
    SCDataTransThread:getSingleton():transData(dataStream)
end

function VIPShop.RecvDayData(dt)
    if not dt then return end 
    if m_isMsgEnd then
        m_stDayGoods = {}
        m_isMsgEnd = nil
    end
    
    local ucAmount = dt:readByte()
    for i = 1, ucAmount do
        table.insert(m_stDayGoods, stVipGoods.initStream(dt))
    end
    --明日特惠
    for i = 1, 3 - ucAmount do 
        local tmp = {}
        tmp.idItemType = 0
        tmp.dwOldMoney = "????"
        tmp.dwNewMoney = "???"
        tmp.szName     = L("str20059")
        
        tmp.nLimitLev  = 0
        tmp.ucDayType  = 3
        tmp.ucState    = 3
        if i == 2 then
            table.insert(m_stDayGoods, 1, tmp)
        else
            table.insert(m_stDayGoods, tmp)
        end
    end
end
--购买成功
function VIPShop.RecvBuyData(dt)
    if not dt then return end
    local tmp = {}
    tmp.ucType      = dt:readByte()
    tmp.idItemType  = dt:readInt()
    tmp.nLimitLev   = dt:readInt()
    tmp.ucDayType   = dt:readByte()
    tmp.ucState     = dt:readByte()
    
    VIPShop.Notify(tmp)
end
--------------
function VIPShop.ReadData()    
	local dt = SCMessageCenter:getSingleton():getDataTransStream();  ---获取当前的数据对象
	if dt == nil then
		return;
	end
	local action = dt:readByte();
	if action == VIPSHOPACT_CLEAR or action == VIPSHOPACT_CLEAR_END then	    
	    local case = dt:readByte()
	    if case == VIPSHOP_LIMIT_LEV then
		    VIPShop.RecvLevData(dt)		    
		elseif case == VIPSHOP_LIMIT_EVERYDAY then
		    VIPShop.RecvDayData(dt)
		elseif  case == VIPSHOP_LIMIT_VIP then
			VIPShop.RecvvipData(dt)		
		end
        
        if action == VIPSHOPACT_CLEAR_END then             
			VIPShop.SortLevGoods()
            VIPShop.OpenVIPWnd()            
            m_isMsgEnd = true            
		end
    elseif action == VIPSHOPACT_BUY_SUCCESS then
		VIPShop.RecvBuyData(dt)		
    end
    SCActivityIndicator:getSingleton():close();   ----关闭等待转圈图标
end
-----------------------消息注册区------------------------
SCMessageCenter:getSingleton():luaRegistCommand(VIPShop.ReadData, _MSG_VIPSHOP, 0, nil);
-----------------------全局函数区------------------------
function VIPShop_ShowVIPShop()
    --return VIPShop.OpenVIPWnd()
    VIPShop.SendCloseEffect()
    VIPShop.SendOpenLevShop()
    --VIPShop.SendOpenDayShop()
end
