
WingAndRevel = {m_idAction}   --保存送翅膀倒计时事件
local GiveWing = {}     --24小时送翅膀
local RevelDay = {}     --服务器30日狂欢抽奖

--------------------------------------------------< 24小时送翅膀 9102--------------------------------------------------

-----------------------结构定义区------------------------

-----------------------常量定义区------------------------
local GIFTINFO_24HOURS_GIVE_WRING = 23  --24小时送翅膀
local HoursGiveWing = 1999000010 --翅膀ID
-----------------------变量定义区------------------------
local m_nTimeLeft = 0
-----------------------函数声明区------------------------

-----------------------逻辑功能区------------------------
--打开窗口
function GiveWing.OpenMainWnd()    
    GiveWing.SendCloseEffect()
    
    local wnd = tolua.cast(SCFunction:getUiNodeByIdlist(9102), "FrameWindow")
    if not wnd then
        wnd = GiveWing.CreateMainWnd()
        local pScene = getCurentScene():getUINode()
        if wnd and pScene then
            pScene:addChild(wnd)                         
        end
    end
    return wnd
end

--窗口关闭回调
function GiveWing.onCloseWnd(tag)
    local wnd = SCFunction:getUiNodeByIdlist(9102)
    if wnd then
        wnd:removeFromParentAndCleanup(true)
    end    
end

--按钮获得翅膀回调
function GiveWing.GetWing(tag)
    GiveWing.SendLoadData()
    --showMessage(L("str0540").."*3"..L("str20021"))
    
    local btn = SCFunction:getUiNodeByIdlist("9102-2-101")
    if btn then     
        btn:setTouchEnabled(false)
        btn:setButtonType(3)
    end
    
    m_nTimeLeft = 0
    GiveWing.UpdateOnLineTime()
    GiveWing.onCloseWnd()
end

--24小时倒计时回调
function GiveWing.TimeOver()
    local btn = SCFunction:getUiNodeByIdlist("9102-2-101")
    if not btn then return end 
    
    btn:setTouchEnabled(true)
    btn:setButtonType(1)
    btn:luaSetSelectorOnClicked(GiveWing.GetWing)
    
    m_nTimeLeft = 0
    if WingAndRevel.m_idAction then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(WingAndRevel.m_idAction)
        WingAndRevel.m_idAction = nil
    end
end

function GiveWing.UpdateOnLineTime()
    if m_nTimeLeft == 0 then
        return
    end
    
    if not WingAndRevel.m_idAction then
        WingAndRevel.m_idAction = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(GiveWing.UpdateOnLineTime, 1, false);
        if not WingAndRevel.m_idAction then return end 
    end    
    
    local nodeTime = tolua.cast(SCFunction:getUiNodeByIdlist("9102-2-1-1"), "CountDownNode")
    if not nodeTime then 
        m_nTimeLeft = m_nTimeLeft - 1
    else
        m_nTimeLeft = nodeTime:getCurTime()
    end    
    
    if m_nTimeLeft <= 0 then
        m_nTimeLeft = 0
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(WingAndRevel.m_idAction)
        WingAndRevel.m_idAction = nil
    end
end

--单击翅膀
function GiveWing.onWingClick(tag)
    --showTip(HoursGiveWing)
    local itemInfo = TableParser:getSingleton():getItemInfoByKey(HoursGiveWing)
    if itemInfo then
        showTip(string.format(L("str6276"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)
    end
end
-----------------------UI控制器区------------------------
function GiveWing.CreateMainWnd()
    local wnd = FrameWindow:frameWnd()
    if not wnd then return end 
    
    local szWnd = AUTO_SIZE(300, 240)
    wnd:setTag(9102)
    wnd:setContentSize(szWnd)
    wnd:setCloseBtnVisible(false)
    wnd:setOutSpaceClickClose(false)
    wnd:setFrameType(EnumFrameTyperedwindowstip)

    local pathCloseNormal = RES("kernal/close-normal.pn")
    local pathCloseSelect = RES("kernal/close-selected.pn")
    if pathCloseNormal and pathCloseSelect then
        local btnClose = SCButton:button()
        btnClose:setBackgroundImage(pathCloseNormal)
        btnClose:setSelectedImage(pathCloseSelect)
        btnClose:luaSetSelectorOnClicked(GiveWing.onCloseWnd)
        btnClose:setAnchorPoint(CCPointMake(1, 1))
        btnClose:setPosition(szWnd.width, szWnd.height)
        btnClose:setMusicPath("closeWindow.mp3");
        btnClose:setTouchRectScale(4.0,4.0)
        btnClose:setScale(0.7)
        wnd:addChild(btnClose)
    end
    
    local titlePath = RES("kernal/redTop.pn")
    local path      = RES("img/new00703.pn")
    if titlePath and path then
        local imgBg = SCImage:imageWithFile(titlePath)
        local img   = SCImage:imageWithFile(path)
        if imgBg and img then
            local szBg = imgBg:getContentSize()
            img:setAnchorPoint(CCPointMake(0.5, 0.5))
            img:setPosition(szBg.width / 2, szBg.height / 2)
            imgBg:addChild(img)
            
            imgBg:setAnchorPoint(CCPointMake(0.5, 1))
            imgBg:setPosition(szWnd.width / 2, szWnd.height)
            wnd:addChild(imgBg)            
        end
    end
    
    local width     = SX(5)
    local height    = SY(5)
    local szRight   = CCSizeMake(SX(126), szWnd.height - SY(30))
    local szLeft    = CCSizeMake(szWnd.width - width * 2 - szRight.width + SX(7), szRight.height)
    local ptLeft    = CCPointMake(width, height)
    
    local nodeLeft  = SCDragNode:node()
    if nodeLeft then
        nodeLeft:setPosition(ptLeft)
        nodeLeft:setTag(1)
        nodeLeft:setContentSize(szLeft)
        nodeLeft:setFrameType(0)
        nodeLeft:setFrameVisibled(true)
        wnd:addChild(nodeLeft)
        
        local pt   = CCPointMake(szLeft.width / 2 + SX(10), SY(50))
        local path = RES("img/new00305.pn")        
        if path then
            local img = SCImage:imageWithFile(path)
            if img then
                img:setAnchorPoint(CCPointMake(0.5, 0.5))
                img:setPosition(pt)
                nodeLeft:addChild(img)
            end
        end
        
        --wing icon = 50101 50201 50301 50401 50501
        --[[local wingIcon = 50101
        local aniWing = SCLookfaceParser :getSingleton():getAnimationByIndex(wingIcon, wingIcon)
        if aniWing then
            local pLookNode = SCAnimationNode:nodeWithAnimation(aniWing);
            if pLookNode then
                pLookNode:setTag(2)
                pLookNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                pLookNode:setPosition(pt.x, pt.y + SY(85))                
                
                nodeLeft:addChild(pLookNode);                 
            end
        end]]
        
        local idIcon = Hero:getSingleton():getLookFace()
        local ani = SCLookfaceParser :getSingleton():getAnimationByLookfaceAndIndex(idIcon)
        if ani then
            local pLookNode = SCAnimationNode:nodeWithAnimation(ani);
            if pLookNode then
                pLookNode:setAnchorPoint(CCPointMake(0.5, 0));
                pLookNode:setPosition(pt)
                local wingIcon = 50101
                local aniWing = SCLookfaceParser :getSingleton():getAnimationByIndex(wingIcon, wingIcon)
                if aniWing then
                    setHeroBackAnimation(aniWing, pLookNode)
                end
                nodeLeft:addChild(pLookNode); 
            end
        end         
        
        local parseNode = getItemTextNode("*6"..L("str20105"), 0, 9)
        if parseNode then
            parseNode:setAnchorPoint(CCPointMake(0.5, 0.5))
            parseNode:setPosition(szLeft.width / 2, szLeft.height - SY(25))
            nodeLeft:addChild(parseNode)
        end
        local parseNode = getItemTextNode("*6"..L("str20106"), 0, 9)
        if parseNode then
            parseNode:setAnchorPoint(CCPointMake(0.5, 0.5))
            parseNode:setPosition(szLeft.width / 2, szLeft.height - SY(40))
            nodeLeft:addChild(parseNode)
        end
    end
    
    local nodeRight = SCDragNode:node()
    if nodeRight then
        nodeRight:setTag(2)
        nodeRight:setAnchorPoint(CCPointMake(1, 0))
        nodeRight:setPosition(szWnd.width - width, ptLeft.y)
        nodeRight:setFrameType(0)
        nodeRight:setFrameVisibled(true)
        nodeRight:setContentSize(szRight)
        wnd:addChild(nodeRight)     
        
        local ptCenter = CCPointMake(szRight.width / 2, szRight.height / 2)
        local nodeBack = SCDragNode:node()
        if nodeBack then
            local szBack = CCSizeMake(szRight.width - SX(20), SY(60))
            nodeBack:setFrameType(0)
            nodeBack:setFrameVisibled(true)
            nodeBack:setAnchorPoint(CCPointMake(0.5, 0.5))
            nodeBack:setContentSize(szBack)
            nodeBack:setTag(1)
            nodeBack:setPosition(ptCenter.x, ptCenter.y + SY(60))
            nodeRight:addChild(nodeBack)
            
            local nodeTime = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second)
            if nodeTime then
                nodeTime:setPosition(szBack.width / 2, SY(15))
                nodeTime:setAnchorPoint(CCPointMake(0.5, 0))
                nodeTime:setTime(m_nTimeLeft)
                nodeTime:setTag(1)
                nodeTime:setColor(color_yellow)
                nodeTime:luasetSelectorOnClose(GiveWing.TimeOver)
                nodeBack:addChild(nodeTime)
            end
            
            local title = SCLabel:labelWithStringFont(L("str6124")..L("str20022"), getDefaultFontName(), F(14))
            if title then
                title:setAnchorPoint(CCPointMake(0.5, 1))
                title:setPosition(CCPointMake(szBack.width / 2, szBack.height - SY(15)))
                title:setColor(color_orange)
                nodeBack:addChild(title)
            end
        end
        
        local pt = CCPointMake(ptCenter.x, ptCenter.y + SY(20))
        local h  = SY(5)
        local labelName = SCLabel:labelWithStringFont(L("str20021"), getDefaultFontName(), F(12))
        if labelName then
            labelName:setAnchorPoint(CCPointMake(0.5, 1))
            labelName:setPosition(pt)
            labelName:setColor(color_green)
            nodeRight:addChild(labelName)
            
            pt = CCPointMake(pt.x, pt.y - labelName:getContentSize().height - h)
            
            local item = TableParser:getSingleton():getItemInfoByKey(HoursGiveWing)
            if item then
                local szName = item.name:getData()
                labelName:setText(szName)
            end
        end
        
        local pathBoxNormal = RES("img/new00002.pn")
        local pathBoxSelect = RES("img/new00003.pn")
        if pathBoxNormal and pathBoxSelect then
            local btnBox = SCButton:button()
            if btnBox then
                btnBox:setBackgroundImage(pathBoxNormal)
                btnBox:setSelectedImage(pathBoxSelect)
                btnBox:setAnchorPoint(CCPointMake(0.5, 1))
                btnBox:setPosition(pt)
                btnBox:luaSetSelectorOnClicked(GiveWing.onWingClick)
                nodeRight:addChild(btnBox)
                
                pt = CCPointMake(pt.x, pt.y - btnBox:getContentSize().height - h)
                
                local item = TableParser:getSingleton():getItemInfoByKey(HoursGiveWing)
                if item then
                    local pathWing = RES("item/"..item.icon..".jp")
                    if pathWing then
                        btnBox:setTitle(pathWing)
                    end                      
                end
            end
        end
        
        local type = 3
        if m_nTimeLeft == 0 then
            type = 1
        end
        local btnGet = SCButton:button(type)
        if btnGet then
            btnGet:setTag(101)
            btnGet:setContentSize(AUTO_SIZE(70, 30))
            btnGet:setAnchorPoint(CCPointMake(0.5, 0.5))
            btnGet:setPosition(pt.x, SY(35))
            btnGet:setTitle(L("str20012"), getDefaultFontName(), F(11)) 
            if m_nTimeLeft ~= 0 then
                btnGet:setTouchEnabled(false)
            else
                btnGet:luaSetSelectorOnClicked(GiveWing.GetWing)
            end
            nodeRight:addChild(btnGet)             
        end
    end
    return wnd
end

-----------------------消息处理区------------------------
function GiveWing.ReadLoadData(dt)
    m_nTimeLeft = 24 * 60 * 60 - dt:readInt()
    if m_nTimeLeft < 0  then
        m_nTimeLeft = 0
    end
    
    local vip = Hero:getSingleton():getVipLevel()            
    if vip > 0 then
        m_nTimeLeft = 0
    end
end

function GiveWing.SendLoadData()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);
    if dataStream then                   
		dataStream:writeShort(GIFTINFO_24HOURS_GIVE_WRING)
        SCDataTransThread:getSingleton():transData(dataStream)        
        --SCActivityIndicator:getSingleton():show()
    end
end

function GiveWing.SendCloseEffect()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(UNLOCK_TYPE_24HOURS_GIVE_WING)
    SCDataTransThread:getSingleton():transData(dataStream)
end
--------------------------------------------------24小时送翅膀>--------------------------------------------------
--------------------------------------------------<服务器30日狂欢抽奖 9103--------------------------------------------

-----------------------结构定义区------------------------
local m_stRechargeItem = {
    initStream = function(dt)
        local tmp = {}
        if not dt then return tmp end
        
        tmp.usAwardType = dt:readShort()
		tmp.idItemType  = dt:readInt()
		tmp.nNum        = dt:readInt()
		
		return tmp
    end
}
-----------------------常量定义区------------------------
local GIFTINFO_ADD_LOTTERDRAWTIMES          = 19 -- //增加抽奖次数 
local GIFTINFO_LOTTERDRAWTIMES_INFO_BEGIN   = 20 -- //发送随机奖励信息
local GIFTINFO_LOTTERDRAWTIMES_INFO_END     = 21 -- //发送随机奖励信息
local GIFTINFO_LOTTERDRAWTIMES_AWARD        = 22--  //抽奖
local AWARD_NUM                             = 8 --奖品数量
-----------------------变量定义区------------------------
local m_stPosAward = {--(46 * 46) 从最左开始顺时针pos
    AUTO_POS(12, 110), AUTO_POS(38, 178), AUTO_POS(110, 205), AUTO_POS(178, 178), --AUTO_POS(185, 160),
    AUTO_POS(202, 110), AUTO_POS(178, 42), AUTO_POS(110, 14), AUTO_POS(38, 42),   --AUTO_POS(32, 70)
}

local m_bEnableClick        --礼券按钮是否可点击
local m_nLeftDrawTimes = 0  --抽奖剩余次数
local m_nLeftTime = 0       --抽奖剩余时间
local m_bEndFlag

local m_stAwardItem = {}    --待抽的奖品列表
local m_stDrawItem = {}     --抽中的奖品
local m_fSpeed = 0
local m_drawAction
local m_nIndexItem = 0  
local m_nState = nil --加速状态--4阶段　加速0　匀速1　减速2  3将减速
local m_nIndexPreItem 
local m_nTimerNum = 0
-----------------------函数声明区------------------------

-----------------------逻辑功能区------------------------
--打开窗口
function RevelDay.OpenMainWnd()    
    local wnd = tolua.cast(SCFunction:getUiNodeByIdlist(9103), "FrameWindow")
    if not wnd then
        wnd = RevelDay.CreateMainWnd()
        local pScene = getCurentScene():getUINode()
        if wnd and pScene then
            pScene:addChild(wnd)
            RevelDay.initControl()
        end
    else
        RevelDay.UpdateWindow()
        RevelDay.initControl()
    end
    return wnd
end

--打开提示窗口
function RevelDay.ShowTipWnd()
    local tipWnd = SCFunction:getUiNodeByIdlist("9103-1000")
    if not tipWnd then
        tipWnd = RevelDay.CreateTipWnd()
        local wnd = SCFunction:getUiNodeByIdlist("9103")        
        if tipWnd and wnd then
            wnd:addChild(tipWnd)
            local szWnd = wnd:getContentSize()
            tipWnd:setAnchorPoint(CCPointMake(0.5, 0.5))
            tipWnd:setPosition(szWnd.width / 2, szWnd.height / 2)--(szWnd.width - tipWnd:getContentSize().width) / 2, (szWnd.height - tipWnd:getContentSize().height) / 2)
        end    
    end
end

--关闭确认框
function RevelDay.OnConfirmReturn(tag)
    if tag == 1 then
        RevelDay.GetDrawAward()
        RevelDay.init()
        local wnd = SCFunction:getUiNodeByIdlist(9103)
        if wnd then
            wnd:removeFromParentAndCleanup(true)
        end        
    end
end
--
function RevelDay.init()    
    m_bEnableClick = nil
    m_nLeftDrawTimes = 0
    m_nLeftTime = 0
    m_bEndFlag = nil
    m_stAwardItem = {}
    m_stDrawItem = {}
    m_fSpeed = 0
    m_nState = nil
    m_nIndexPreItem = nil
    m_nIndexItem = 0
    m_nTimerNum = 0 
    if m_drawAction then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_drawAction);
        m_drawAction = nil
    end
end
--窗口关闭回调
function RevelDay.onCloseWnd(tag)
    if m_drawAction then--m_nState or m_fSpeed ~= 0 then 
        luashowConfirmationWindow(L("str20018"), WIN_YES_NO, RevelDay.OnConfirmReturn)
        return
    end 
    RevelDay.init()
    local wnd = SCFunction:getUiNodeByIdlist(9103)
    if wnd then
        wnd:removeFromParentAndCleanup(true)
    end
end

--明日提示
function RevelDay.ShowTomorrowTip()
    showMessage(L("str20031"))
end
--领取礼券
function RevelDay.onBtnGetGift(tag)
    if tag == 101 then
        local btn = SCFunction:getUiNodeByIdlist("9103-101")
        if btn then 
            btn:setButtonType(3)
            btn:setTitle(L("str0344"), getDefaultFontName(), F(13), color_gray)
            btn:luaSetSelectorOnClicked(RevelDay.ShowTomorrowTip)
        end
        
        RevelDay.SendAddDrawTimes()
    elseif tag == 102 then
        --showMessage(L("str20014"))
        RevelDay.ShowTipWnd()
    end
end

--增加抽奖次数
function RevelDay.AddDrawTimes()
    RevelDay.SendAddDrawTimes()
end
--开始抽奖
function RevelDay.onBtnStart(tag)
    --if not m_bEnableClick then return end 
    if m_nLeftDrawTimes == 0 then
        showMessage(L("str20019"))
        return
    end
    if not m_nState then m_nState = 0 end 
    
    if not m_stDrawItem.idItemType then 
        RevelDay.SendDrawAward()              
    end
    local btn = SCFunction:getUiNodeByIdlist("9103-100-100")
    if btn then
        btn:setVisible(true)
    end
    
    local btn = SCFunction:getUiNodeByIdlist("9103-100-33")
    if btn then
        btn:setTouchEnabled(false)
        local path = RES("qiandao/new00752.pn")
        if path then
            btn:setTitle(path)
        end
    end
end

function RevelDay.LotterDrawRestart()
    local btn = tolua.cast(SCFunction:getUiNodeByIdlist("9103-100-33"), "SCButton")
    if btn then
        btn:luaSetSelectorOnClicked(RevelDay.onBtnStart)
        --btn:setTitle(L("str20018"), getDefaultFontName(), F(18))  
        local path = RES("qiandao/new00747.pn")
        if path then
            btn:setTitle(path)
        end
    end
    
    local pathNormal = RES("img/new00002.pn")
    local pre = tolua.cast(SCFunction:getUiNodeByIdlist("9103-100-".. m_nIndexItem), "SCButton")
    if pre and pathNormal then
        pre:setBackgroundImage(pathNormal)
    end
    
    m_stDrawItem = {}
    m_stAwardItem = {}
    
    m_fSpeed = 0
    m_nState = nil
    m_nIndexItem = 0
    m_nIndexPreItem = nil
    m_nIndexItem = 0
    m_nTimerNum = 0 

    RevelDay.SendLotterDrawInfo()
    RevelDay.onBtnStart()
end
--更新窗口信息
function RevelDay.UpdateWindow()
    local label = tolua.cast(SCFunction:getUiNodeByIdlist("9103-51-11"), "SCLabel")
    if not label then return end 
    
    local text = string.format(L("str20015"), m_nLeftDrawTimes)
    label:setText(text)
end

--更新速度
function RevelDay.UpdateSpeed()
    local fUpLimit = 1
    local inter = 0.1
    
    if m_nState == 0 and m_fSpeed < 0.2 then
        m_fSpeed = 0.2
    end
    if m_nState ~= 1 then
        if m_fSpeed < fUpLimit - inter then
            if m_nState == 0 then
                m_fSpeed = m_fSpeed + inter * 2
                if m_fSpeed > fUpLimit - inter then
                    m_fSpeed = fUpLimit - inter
                end
            elseif m_nState == 2 then
                m_fSpeed = m_fSpeed - inter * 3
                if m_fSpeed < 0 then
                    m_fSpeed = 0
                end
            end              
        else--if m_fSpeed >= fUpLimit - inter * 0.1 then
            if m_nState == 0 then
                m_fSpeed = m_fSpeed + inter * 0.1
                if m_fSpeed >= fUpLimit then
                    m_fSpeed = fUpLimit - inter * 0.1
                    m_nState = 1
                end
            elseif m_nState == 2 then
                m_fSpeed = m_fSpeed - inter * 0.2
                if m_fSpeed < fUpLimit - inter then
                    m_fSpeed = fUpLimit - inter - 0.00001
                end
            end            
        end
    end
    
    if m_nState ~= 1 then
        if m_drawAction then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_drawAction);
        end        
        m_drawAction = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(RevelDay.UpdateCurSelectAward, fUpLimit - m_fSpeed, false);
    end
end
--更新当前奖品
function RevelDay.UpdateCurSelectAward()
    if not m_nIndexItem then return end 
    
    m_nIndexPreItem  = m_nIndexItem
    m_nIndexItem    = m_nIndexItem + 1
    if m_nIndexItem == AWARD_NUM + 1 then
        m_nIndexItem = 1
    end
    
    local box = tolua.cast(SCFunction:getUiNodeByIdlist("9103-100-".. m_nIndexItem), "SCButton")
    if not box then return end   
    
    local pathNormal = RES("img/new00002.pn")
    local pathSelect = RES("img/new00003.pn")
    if pathNormal and pathSelect then
        box:setBackgroundImage(pathSelect)
        if m_nIndexPreItem ~= 0 then
            local pre = tolua.cast(SCFunction:getUiNodeByIdlist("9103-100-".. m_nIndexPreItem), "SCButton")
            if pre then
                pre:setBackgroundImage(pathNormal)
            end
        end
    end
    
    --更新速度
    local tipWnd = SCFunction:getUiNodeByIdlist("888889")    
    if not tipWnd and m_fSpeed ~= 0 then
        m_nTimerNum = m_nTimerNum + 1
        if m_nTimerNum >= AWARD_NUM / 4 then
            RevelDay.UpdateSpeed()
            m_nTimerNum = 0
        end
    end
        
    local index = RevelDay.GetIndexByIDType(m_stDrawItem.idItemType, m_stDrawItem.usAwardType, m_stDrawItem.nNum)
    if m_nState == 2 and m_fSpeed == 0 and index == m_nIndexItem and not tipWnd then
        if m_drawAction then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_drawAction);
            m_drawAction = nil
            RevelDay.GetDrawAward()            
        end
    end
    --RevelDay.UpdateSpeed()
    if m_nState == 3 and m_nIndexItem == index and not tipWnd then
        if m_fSpeed <= 0.5 then
            if m_drawAction then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_drawAction);
                m_drawAction = nil
            end
            RevelDay.GetDrawAward()
        else
            m_nState = 2    
        end        
    end
end

function RevelDay.UpdateTurnTable()
    RevelDay.UpdateSpeed()
    --RevelDay.UpdateCurSelectAward()    
end

--开始抽奖
function RevelDay.LotterDrawAction() 
    m_nLeftDrawTimes = m_nLeftDrawTimes - 1
    RevelDay.UpdateTurnTable()
    RevelDay.UpdateWindow()
end
--减速，得到奖品
function RevelDay.GetDrawAward()
    local index = RevelDay.GetIndexByIDType(m_stDrawItem.idItemType, m_stDrawItem.usAwardType, m_stDrawItem.nNum)
    if not index then return end    
    
    local btn = SCFunction:getUiNodeByIdlist("9103-100-100")
    if btn then
        btn:setVisible(false)
    end
    
    local name = ""
    local num = L("*4")..m_stDrawItem.nNum
    if m_stDrawItem.usAwardType == 1 then
        name = L("str6157")
    elseif m_stDrawItem.usAwardType == 4 then
        name = L("str5172")
    elseif m_stDrawItem.usAwardType == 5 then
        name = L("str0193")
    elseif m_stDrawItem.usAwardType == 7 then
        name = L("str0138")
    elseif m_stDrawItem.usAwardType == 9 then
        name = L("str8158")
    elseif m_stDrawItem.usAwardType == 101 then
        name = L("str6156")
    else
        local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_stDrawItem.idItemType);
        if itemInfo then
            name = itemInfo.name:getData()
            num = "X1"
        end
    end    
    
    local str = string.format(L("str20032"), "*6"..name..num.."*0", m_nLeftDrawTimes)
    showMessage(str)
    
    local btn = tolua.cast(SCFunction:getUiNodeByIdlist("9103-100-33"), "SCButton")
    if btn then
        btn:luaSetSelectorOnClicked(RevelDay.LotterDrawRestart)
        --btn:setTitle(L("str20019"), getDefaultFontName(), F(18))
        local path = RES("qiandao/new00747.pn")
        if path then
            btn:setTitle(path)
        end
        
        btn:setTouchEnabled(true)
    end
    m_nState = nil
end
--将idItemType转成数组所在索引1+
function RevelDay.GetIndexByIDType(idType, ucAwardType, nNum)
    for i = 1, #m_stAwardItem do
        if idType ~= 0 then
            if m_stAwardItem[i].idItemType == idType then
                return i
            end
        elseif m_stAwardItem[i].usAwardType == ucAwardType and m_stAwardItem[i].nNum == nNum then
            return i
        end
    end
end
--单击奖品回调
function RevelDay.onBtnAwardClick(tag)
    if not m_stAwardItem or tag > AWARD_NUM or tag < 1 then return end     

    local ucAwardTyp = m_stAwardItem[tag].usAwardType    
    if ucAwardTyp == 1 or ucAwardTyp == 4 or ucAwardTyp == 5 or ucAwardTyp == 7 or 
        ucAwardTyp == 9 or ucAwardTyp == 101 then
        luaShowTipCpp(ucAwardTyp, m_stAwardItem[tag].nNum)    
    else
        showTip(m_stAwardItem[tag].idItemType)        
    end
end

--停止转动
function RevelDay.onBtnStop(tag)
    local btn = SCFunction:getUiNodeByIdlist("9103-100-100")
    if btn then
        btn:setVisible(false)
    end
    
    m_nState = 3    
    local btn = tolua.cast(SCFunction:getUiNodeByIdlist("9103-100-33"), "SCButton")
    if btn then
        btn:setTitle("", getDefaultFontName(), F(13))
    end
end

-----------------------UI控制器区------------------------
--创建狂欢窗口
function RevelDay.CreateMainWnd()
    local wnd = FrameWindow:frameWnd()
    if not wnd then return end 
    
    local szWnd = AUTO_SIZE(310, 310)
    wnd:setTag(9103)
    wnd:setContentSize(szWnd)
    wnd:setCloseBtnVisible(false)
    wnd:setOutSpaceClickClose(false)
    wnd:setFrameType(EnumFrameTyperedwindowstip)

    local pathCloseNormal = RES("kernal/close-normal.pn")
    local pathCloseSelect = RES("kernal/close-selected.pn")
    if pathCloseNormal and pathCloseSelect then
        local btnClose = SCButton:button()
        btnClose:setBackgroundImage(pathCloseNormal)
        btnClose:setSelectedImage(pathCloseSelect)
        btnClose:luaSetSelectorOnClicked(RevelDay.onCloseWnd)
        btnClose:setAnchorPoint(CCPointMake(1, 1))
        btnClose:setPosition(szWnd.width, szWnd.height)
        btnClose:setMusicPath("closeWindow.mp3");
        btnClose:setTouchRectScale(4.0,4.0)
        btnClose:setScale(0.7)
        wnd:addChild(btnClose)
    end
    
    local titlePath = RES("kernal/redTop.pn")
    local path      = RES("img/new00703.pn")
    if titlePath and path then
        local imgBg = SCImage:imageWithFile(titlePath)
        local img   = SCImage:imageWithFile(path)
        if imgBg and img then
            local szBg = imgBg:getContentSize()
            img:setAnchorPoint(CCPointMake(0.5, 0.5))
            img:setPosition(szBg.width / 2, szBg.height / 2)
            imgBg:addChild(img)
            
            imgBg:setAnchorPoint(CCPointMake(0.5, 1))
            imgBg:setPosition(szWnd.width / 2, szWnd.height)
            wnd:addChild(imgBg)            
        end
    end
    
    local pathDial = RES("qiandao/new00748.pn")
    if pathDial then
        local img = SCImage:imageWithFile(pathDial)
        if img then
            img:setAnchorPoint(CCPointMake(0.5, 0.5))
            img:setPosition(szWnd.width / 2, szWnd.height / 2 )            
            img:setTag(100)
            wnd:addChild(img)
            
            local pathNormal = RES("img/new00002.pn")
            local pathSelect = RES("img/new00003.pn")
            local w = SX(30)
            local h = SY(0)
            if pathNormal and pathSelect then
                for i = 1, #m_stAwardItem do
                    local box = SCButton:button()
                    if box then
                        img:addChild(box)
                        
                        --box:setAnchorPoint(CCPointMake(0.5, 0.5))
                        box:setTag(i)
                        box:setBackgroundImage(pathNormal)
                        box:setSelectedImage(pathSelect)
                        box:setPosition(m_stPosAward[i])
                        box:luaSetSelectorOnClicked(RevelDay.onBtnAwardClick)
                    end
                end
            end
            
            local btnStart = SCButton:button()
            if btnStart then        
                btnStart:setAnchorPoint(CCPointMake(0.5, 0.5))
                btnStart:setPosition(img:getContentSize().width / 2, img:getContentSize().height / 2)        
                --btnStart:setTitle(string.format(L("str20017"), m_nLeftTime), getDefaultFontName(), F(13))
                btnStart:setContentSize(AUTO_SIZE(50, 50))
                btnStart:setTag(33)
                img:addChild(btnStart)
                
                local text = 30 - m_nLeftTime
                if text <= 0 then
                    --btnStart:setTitle(L("str20018"), getDefaultFontName(), F(18))
                    local path = RES("qiandao/new00747.pn")
                    if path then
                        btnStart:setTitle(path)
                    end
                    btnStart:luaSetSelectorOnClicked(RevelDay.onBtnStart)
                else
                    text = string.format(L("str20017"), 30 - m_nLeftTime)
                    local node = getItemTextNode(text, 0 , 13)
                    if node then
                        btnStart:addChild(node)
                        node:setAnchorPoint(CCPointMake(0.5, 0.5))
                        node:setPosition(btnStart:getContentSize().width/2, btnStart:getContentSize().height/2)
                    end
                end        
            end
            
            local btn = SCButton:button()
            if btn then
                btn:setContentSize(img:getContentSize())
                btn:setTag(100)
                btn:luaSetSelectorOnClicked(RevelDay.onBtnStop)
                btn:setVisible(false)
                img:addChild(btn)
            end
        end
    end 
    
    local node = SCDragNode:node()
    if node then
        node:setFrameVisibled(true)
        node:setFrameType(2)
        node:setPosition(SX(5), SY(5))
        node:setContentSize(AUTO_SIZE(80, 20))
        node:setAnchorPoint(CCPointMake(0, 0))
        node:setTag(51)
        wnd:addChild(node)        

        local textNum = string.format(L("str20015"), m_nLeftDrawTimes)
        local labelNum = SCLabel:labelWithStringFont(textNum, getDefaultFontName(), F(12))
        if labelNum then
            labelNum:setPosition(SX(5), node:getContentSize().height / 2)
            labelNum:setAnchorPoint(CCPointMake(0, 0.5))
            labelNum:setTag(11)
            labelNum:setColor(color_green)
            node:addChild(labelNum)
        end
    end
    
    if m_nLeftTime < 30 then
        local type = 1
        if not m_bEnableClick then 
            type = 3
        end
        local btnGet = SCButton:button(type)
        if btnGet then
            btnGet:setContentSize(AUTO_SIZE(70, 26))
            btnGet:setTag(101)
            btnGet:setAnchorPoint(CCPointMake(0.5, 0))
            btnGet:setPosition(szWnd.width / 2, SY(5))
            btnGet:setTitle(L("str20013"), getDefaultFontName(), F(13))
            if m_bEnableClick then
                btnGet:luaSetSelectorOnClicked(RevelDay.onBtnGetGift)
            else
                btnGet:luaSetSelectorOnClicked(RevelDay.ShowTomorrowTip)
            end        
            wnd:addChild(btnGet)
        end
    end
    
    local btnTip = SCButton:button(1)
    if btnTip then
        btnTip:setContentSize(AUTO_SIZE(70, 26))
        btnTip:setTag(102)
        btnTip:setAnchorPoint(CCPointMake(1, 0))
        btnTip:setPosition(szWnd.width - SX(10), SY(5))
        btnTip:setTitle(L("str20003"), getDefaultFontName(), F(13))
        btnTip:luaSetSelectorOnClicked(RevelDay.onBtnGetGift)
        wnd:addChild(btnTip)
    end
    
    local parseNode = getItemTextNode(L("str20052"), 0, 10)
    if parseNode then
        wnd:addChild(parseNode)
        parseNode:setPosition(AUTO_POS(5, 25))
    end
    return wnd 
end

--初始化抽奖物品
function RevelDay.initControl()
    local turnTable = SCFunction:getUiNodeByIdlist("9103-100")
    if not turnTable then return end     

    for i = 1, AWARD_NUM do            
        local box = tolua.cast(turnTable:getChildByTag(i), "SCButton")
        if box then
            local Type = m_stAwardItem[i].usAwardType;
            local name = ""
            local path
            if Type == 1 then                    
                path = RES("item/2001001.jp")  
                name = L("str6157")
            elseif Type == 4 then
                path = RES("item/2001002.jp")
                name = L("str5172")
            elseif Type == 5 then                    
                path = RES("item/2001003.jp")
                name = L("str0193")
            elseif Type == 7 then                    
                path = RES("item/2001008.jp")
                name = L("str0138")
            elseif Type == 9 then                    
                path = RES("item/2001005.jp")
                name = L("str8158")
            elseif Type == 101 then                   
                path = RES("item/2001006.jp")
                name = L("str6156")
            else                   
                local item = TableParser:getSingleton():getItemInfoByKey(m_stAwardItem[i].idItemType)--ItemProcessor:getSingleton():getItemByTypeID(m_stAwardItem[i].idItemType)
                if item and item.id ~= 0 then
                    path = RES("item/"..item.icon..".jp")
                    name = item.name:getData()
                else
                    path = RES("img/ItemTemp.pn")                    
                end
            end            
            
            if path then
                box:setTitle(path)
                local num = m_stAwardItem[i].nNum
                if Type == 1 then                    
                    num = num / 10000 ..L("str0285")
                end
                
                local label = tolua.cast(box:getChildByTag(101), "SCLabel")
                if label then
                    label:setText(num .. "")
                else
                    local label = SCLabel:labelWithStringFont(num.."", getDefaultFontName(), F(9))
                    if label then
                        label:setAnchorPoint(CCPointMake(1, 0))
                        label:setTag(101)
                        label:setPosition(box:getContentSize().width - SX(5), SY(5))
                        box:addChild(label)
                    end                   
                end
                
                local item = TableParser:getSingleton():getItemInfoByKey(m_stAwardItem[i].idItemType)
                if item then --and item.id ~= 0 then                    
                    local label = tolua.cast(box:getChildByTag(100), "SCLabel")
                    if not label then
                        label = SCLabel:labelWithStringFont(name, getDefaultFontName(), F(8))
                        if label then                            
                            label:setTag(100)
                            label:setAnchorPoint(CCPointMake(0.5, 1))
                            label:setPosition(box:getContentSize().width / 2, 0)
                            label:setColor(colorSkyBlue())
                            box:addChild(label)
                        end
                    else
                        label:setText(name)
                    end                
                end
            end                            
        end
    end    
end

--活动说明提示窗口
function RevelDay.CreateTipWnd()
    local pframeWnd = FrameWindow:frameWnd();
    if pframeWnd then
        local szWnd = CCSizeMake(SX(300), SY(170))
        pframeWnd:setTag(1000)
        pframeWnd:setContentSize(szWnd);
        pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
        pframeWnd:luaSetSelectorOnTouched(function () 
            pframeWnd:removeFromParentAndCleanup(true)
        end)
        local pParsedNode = getItemTextNode(L("str20014"), 0, 11);
        if pParsedNode then
            pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            --pParsedNode:setContentSize(CCSizeMake(szWnd.width - SX(20), szWnd.height - SY(20)))
            pParsedNode:setPerWidthAndHeight(0, 15)
            pParsedNode:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, pframeWnd:getContentSize().height / 2));
            pframeWnd:addChild(pParsedNode);
        end
        pframeWnd:setCloseBtnVisible(false);
    end
    
    return pframeWnd
end
-----------------------消息处理区------------------------
--初始化数据
function RevelDay.SendLotterDrawInfo()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);
    if dataStream then                   
		dataStream:writeShort(GIFTINFO_LOTTERDRAWTIMES_INFO_BEGIN)
        SCDataTransThread:getSingleton():transData(dataStream)        
        SCActivityIndicator:getSingleton():show()
    end
end
--发送增加抽奖次数消息
function RevelDay.SendAddDrawTimes()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);
    if dataStream then                   
		dataStream:writeShort(GIFTINFO_ADD_LOTTERDRAWTIMES)
        SCDataTransThread:getSingleton():transData(dataStream)        
        SCActivityIndicator:getSingleton():show()
    end
end
--抽奖
function RevelDay.SendDrawAward()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);
    if dataStream then                   
		dataStream:writeShort(GIFTINFO_LOTTERDRAWTIMES_AWARD)		
        SCDataTransThread:getSingleton():transData(dataStream)        
        SCActivityIndicator:getSingleton():show()
    end  
end
--随机奖品
function RevelDay.ReadLotterDrawTimes(dt)
    if not dt then return end 
    
    if m_bEndFlag then
        m_stAwardItem = {}
        m_bEndFlag = false
    end
    m_bEnableClick   = dt:readByte() == 1 or nil
    m_nLeftDrawTimes = dt:readInt()
    m_nLeftTime      = dt:readInt()
    
    if m_nLeftTime >= 30 and m_bEnableClick then
        m_bEnableClick = nil
    end
    local count      = dt:readByte()
    for i = 1, count do
        table.insert(m_stAwardItem, m_stRechargeItem.initStream(dt))
    end
end

--抽中的奖品信息
function RevelDay.ReadDrawAwardInfo(dt)
    if not dt then return end 
    
    local tmp = {}
    tmp.usAwardType = dt:readByte()
    tmp.idItemType = dt:readInt()
    tmp.nNum = dt:readInt()
    
    m_stDrawItem = tmp
end
-----------------------全局函数区------------------------
function WingAndRevel_Open24HourToGiveWingWnd()
    GiveWing.OpenMainWnd()
end

function WingAndRevel_Open30RevelDayWnd()
    --RevelDay.OpenMainWnd()
    RevelDay.SendLotterDrawInfo()
end

--狂欢抽奖
function WingAndRevel_RecvRevelDayData(dt, ucAction)
    if GIFTINFO_ADD_LOTTERDRAWTIMES == ucAction then
        m_bEnableClick = false
        m_nLeftDrawTimes = m_nLeftDrawTimes + 1
        RevelDay.UpdateWindow()        
        --showMessage(string.format(L("str20046"), m_nLeftDrawTimes, 30 - m_nLeftTime))
    elseif GIFTINFO_LOTTERDRAWTIMES_INFO_BEGIN == ucAction or GIFTINFO_LOTTERDRAWTIMES_INFO_END == ucAction then
        RevelDay.ReadLotterDrawTimes(dt)
        if GIFTINFO_LOTTERDRAWTIMES_INFO_END == ucAction then
            RevelDay.OpenMainWnd()
            m_bEndFlag = nil
        end
    elseif GIFTINFO_LOTTERDRAWTIMES_AWARD == ucAction then
        RevelDay.ReadDrawAwardInfo(dt)
        RevelDay.LotterDrawAction()
    end
end

--送翅膀
function WingAndRevel_RecvWingsData(dt)
    GiveWing.ReadLoadData(dt)
    GiveWing.UpdateOnLineTime()
end
--刷新时间
function WingAndRevel_ResetWingsData()
    local vip = Hero:getSingleton():getVipLevel()            
    if vip > 0 then
        m_nTimeLeft = 0
    end
end