--定义一个与文件名相同的table
Wings4 = {}
------------------消息--------------------
_MSG_EXCHANGESHOP		=   _MSG_GENERAL+615;		---//兑换商店
EXCHANGESHOPACT_ADD     =   2
EXCHANGESHOPACT_BUY     =   3
EXCHANGESHOPACT_END     =   4
EXCHANGESHOPACT_BUY_EMONEY_GOOD = 5
SHOP_ARTIFACT           =   6  --//神器
local EXCHANGESHOPACT_BUY_EMONEY_GOOD_SUCCESS = 6   --//商店购买成功
----------------结构定义区----------------
local stExchangeGood = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idGoodType = dt:readInt();      --//idItemType
        tmp.dwCost = dt:readInt();          --//消耗物品id
        tmp.usPosition = dt:readShort();    --//位置
        tmp.usCostNum = dt:readShort();     --//消耗物品数量
        return tmp
    end
}

local MSG_Info1 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nType = dt:readInt();       --//商店类型
        local str = dt:readString();    --//商店名称
        if str then
            tmp.szShop = str:getData();
        else
            tmp.szShop = "";
        end
        tmp.ucAmount = dt:readByte();   --//数量
        tmp.setExchangeGood = {__mode = "kv"};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.setExchangeGood, stExchangeGood.initWithStream(dt));
        end
        return tmp;
    end
}

----------------常量定义区----------------

----------------变量定义区----------------
local m_goodsInfo = {__mode = "kv"};
local m_selectGoodPos = nil
local m_nSelectBuyPos = nil
----------------UI控制器区----------------
function Wings4.initControl()
	local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode1:setContentSize(AUTO_SIZE(480, 320))
		pDragNode1:setFrameVisibled(false)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTypeRound)
	end

	local pPageScrollBox2 = SCPageScrollBox:boxWithWidthHeight(AUTO_W(442), AUTO_H(242))
	if pPageScrollBox2 then
		tolua.cast(pPageScrollBox2, "SCNode"):setTag(2)
		tolua.cast(pPageScrollBox2, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pPageScrollBox2, "SCNode"):setPosition(AUTO_POS(17.00, 31.00))
	end

	local pPageHint3 = SCPageHint:hintWithType(EnumPgaeHintTypeHorizontal)
	if pPageHint3 then
		pPageHint3:setTag(3)
		pPageHint3:setAnchorPoint(CCPointMake(0.5, 0))
		pPageHint3:setPosition(AUTO_POS(230.50, 8.00))
		pPageHint3:setContentSize(AUTO_SIZE(213, 23))
	end

	if pPageScrollBox2 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pPageScrollBox2, "SCNode"))
	end
	if pPageHint3 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pPageHint3, "SCNode"))
	end
	if pPageHint3 and pPageScrollBox2 then
		pPageHint3:setBoundPageScrollBox(pPageScrollBox2)
	end
	return pDragNode1
end
function Wings4.releaseControl()
	if Wings4.wndClose then
		Wings4.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------

----------------消息处理区----------------
local function onClickSure(tag)
    if tag == 1 then
        if m_goodsInfo.nType and m_goodsInfo.setExchangeGood[m_selectGoodPos] then
			local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
			if pMultiPage == nil then
				return;
			end
			local pageNode = pMultiPage:getPageWithIndex(3);
			if pageNode == nil then
				return;
			end
			local pNode = pageNode:getChildByTag(1);
			if pNode == nil then
				return;
			end
			local pPage = SCTypeCast:castNodeToPageScrollBox(pNode:getChildByTag(2));
			if pPage then
				for i = 1, m_goodsInfo.ucAmount do
					local index = math.modf((i - 1) / 8)+1
					local labelNode = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent(index.."-"..i.."-5000", pPage));
					if labelNode then
						if m_goodsInfo.setExchangeGood[i].dwCost == 7 then
							local quantity = Hero:getSingleton():getEmoney()-m_goodsInfo.setExchangeGood[m_selectGoodPos].usCostNum
							if quantity >= m_goodsInfo.setExchangeGood[i].usCostNum then
								m_goodsInfo.setExchangeGood[i].isEnough = true
								labelNode:setColor(color_green)
							else
								m_goodsInfo.setExchangeGood[i].isEnough = false
								labelNode:setColor(color_red)
							end
						else
							local quantity = ItemProcessor:getSingleton():getItemQuantityWithTypeID(m_goodsInfo.setExchangeGood[i].dwCost)
							if m_goodsInfo.setExchangeGood[i].dwCost == m_goodsInfo.setExchangeGood[m_selectGoodPos].dwCost then
							    quantity = quantity-m_goodsInfo.setExchangeGood[m_selectGoodPos].usCostNum
							end
							if quantity >= m_goodsInfo.setExchangeGood[i].usCostNum then
								m_goodsInfo.setExchangeGood[i].isEnough = true
								labelNode:setColor(color_green)
							else
								m_goodsInfo.setExchangeGood[i].isEnough = false
								labelNode:setColor(color_red)
							end
						end
					end
				end
			end
			if m_goodsInfo.setExchangeGood[m_selectGoodPos].dwCost == 7 then
				local dataStream = SCDataTransStream:streamWithCommand(_MSG_EXCHANGESHOP)
				dataStream:writeByte(EXCHANGESHOPACT_BUY_EMONEY_GOOD)
				dataStream:writeInt(m_goodsInfo.nType)
				dataStream:writeInt(m_goodsInfo.setExchangeGood[m_selectGoodPos].idGoodType)
				dataStream:writeShort(1)
				SCDataTransThread:getSingleton():transData(dataStream)
				SCActivityIndicator:getSingleton():show();
			else
				local dataStream = SCDataTransStream:streamWithCommand(_MSG_EXCHANGESHOP)
				dataStream:writeByte(EXCHANGESHOPACT_BUY)
				dataStream:writeInt(m_goodsInfo.nType)
				dataStream:writeInt(m_goodsInfo.setExchangeGood[m_selectGoodPos].idGoodType)
				dataStream:writeShort(1)
				SCDataTransThread:getSingleton():transData(dataStream)
				SCActivityIndicator:getSingleton():show();
			end
        end
    end
    m_selectGoodPos = nil
end

local function onClickExchange(tag)
    if m_goodsInfo.nType and m_goodsInfo.setExchangeGood[tag] then
        if m_goodsInfo.setExchangeGood[tag].isEnough then
            m_selectGoodPos = tag
			if m_goodsInfo.setExchangeGood[tag].dwCost == 7 then
				local itemInfo1 = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].idGoodType)
				if itemInfo1 then
					luashowConfirmationWindow(string.format(L("str6297"), m_goodsInfo.setExchangeGood[tag].usCostNum, itemInfo1.name:getData()), WIN_YES_NO, onClickSure)
				end
			else
				local itemInfo1 = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].idGoodType)
				local itemInfo2 = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].dwCost)
				if itemInfo1 and itemInfo2 then
					luashowConfirmationWindow(string.format(L("str6274"), m_goodsInfo.setExchangeGood[tag].usCostNum, itemInfo2.name:getData(), itemInfo1.name:getData()), WIN_YES_NO, onClickSure)
				end
			end
			return
        end
		if m_goodsInfo.setExchangeGood[tag].dwCost == 7 then
			GuidePoint_shoprechange()
		else
			local itemInfo2 = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].dwCost)
			if itemInfo2 then
				showMessage(string.format(L("str6296"), itemInfo2.name:getData()))
			end
		end
    end
end

local function getAttrNameByIndex(index)
	local strName = "";
	if index == 201 then --力量
		strName = L("str8127")
	elseif index == 202 then --灵力
		strName = L("str8128")
	elseif index == 411 then --物理攻击
		strName = L("str5074")
	elseif index == 421 then --物理防御
		strName = L("str5075")
	elseif index == 455 then --HP上限
		strName = L("str8129")
	elseif index == 456 then --MP上限
		strName = L("str8130")
	elseif index == 457 then --特技攻击
		strName = L("str9175")
	elseif index == 457 then --特技防御
		strName = L("str9178")
	elseif index == 492 then --暴击率
		strName = L("str8131")
	elseif index == 496 then --免暴率
		strName = L("str0405")
	elseif index == 497 then --必杀率
		strName = L("str0406")
	elseif index == 481 then 
		strName = L("str0403") --格挡率
	elseif index == 498 then 
		strName = L("str0402") --破击
	end

	return strName;
end

local function luaTipBuyReturn(tag)
    local pWnd = SCFunction:getUiNodeByIdlist("888888")
    if pWnd then
        pWnd:removeFromParentAndCleanup(true)
    end
    
    if tag == 0 then
        if m_nSelectBuyPos then        
            onClickExchange(m_nSelectBuyPos)
            m_nSelectBuyPos = nil
        end
    end
end

local function showWingShopTip(itemType)
	local itemInfo = TableParser:getSingleton():getItemInfoByKey(itemType)
	
	local str = ""
	if itemInfo.effect_type_1 ~= 0 then
		str = str.."*5"..getAttrNameByIndex(math.modf(itemInfo.effect_type_1/10)).." +"..itemInfo.effect_param_1
	end
	if itemInfo.effect_type_2 ~= 0 then
		str = str.."*5"..getAttrNameByIndex(math.modf(itemInfo.effect_type_2/10)).." +"..itemInfo.effect_param_2
	end
	if itemInfo.effect_type_3 ~= 0 then
		str = str.."*5"..getAttrNameByIndex(math.modf(itemInfo.effect_type_3/10)).." +"..itemInfo.effect_param_3
	end
	str = str.."_*0"..itemInfo.description:getData()
	str = str.."_ _"..L("str8121")..math.modf(itemInfo.price/4)
	
	local title = getColorString(itemType)
	if title == "*0" then
	    title = "*4"
	end
	title = title..itemInfo.name:getData()
	
	local file = getRealUIResourcePath("item/"..itemInfo.icon..".jpg")
	local szBtn = L("str20039")
	--luaShowTipHaveIcon(str, title, file, szBtn, 1, luaTipBuyReturn)
	local pWnd = showTipEx(L("str20039"), str, title, itemInfo.icon, itemInfo.id)            
    if pWnd then
        local pWnd = tolua.cast(pWnd, "TipWindow")
        pWnd:luaSetReturnSelector(luaTipBuyReturn)
    end
end

local function onClickShowTip(tag)
    if m_goodsInfo == nil then
        return
    end
    
    if m_goodsInfo.setExchangeGood[tag] == nil then
        return
    end
    m_nSelectBuyPos = tag
    if m_goodsInfo.setExchangeGood[tag].idGoodType then
        if 1999000010 == m_goodsInfo.setExchangeGood[tag].idGoodType then
            local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].idGoodType)
            --showTip(string.format(L("str6276"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)
            local pWnd = showTipEx(L("str20039"), string.format(L("str6276"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)            
            if pWnd then
                local pWnd = tolua.cast(pWnd, "TipWindow")
                pWnd:luaSetReturnSelector(luaTipBuyReturn)
            end
        elseif 1999000011 == m_goodsInfo.setExchangeGood[tag].idGoodType then
            local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].idGoodType)
            --showTip(string.format(L("str6277"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)
            local pWnd = showTipEx(L("str20039"), string.format(L("str6277"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)            
            if pWnd then
                local pWnd = tolua.cast(pWnd, "TipWindow")
                pWnd:luaSetReturnSelector(luaTipBuyReturn)
            end
        elseif 1999000012 == m_goodsInfo.setExchangeGood[tag].idGoodType then
            local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].idGoodType)
            --showTip(string.format(L("str6278"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)
            local pWnd = showTipEx(L("str20039"), string.format(L("str6278"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)            
            if pWnd then
                local pWnd = tolua.cast(pWnd, "TipWindow")
                pWnd:luaSetReturnSelector(luaTipBuyReturn)
            end
        elseif 1999000013 == m_goodsInfo.setExchangeGood[tag].idGoodType then
            local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].idGoodType)
            --showTip(string.format(L("str6279"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)
            local pWnd = showTipEx(L("str20039"), string.format(L("str6279"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)            
            if pWnd then
                local pWnd = tolua.cast(pWnd, "TipWindow")
                pWnd:luaSetReturnSelector(luaTipBuyReturn)
            end
        elseif 1999000014 == m_goodsInfo.setExchangeGood[tag].idGoodType then
            local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[tag].idGoodType)
            --showTip(string.format(L("str6280"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)
            local pWnd = showTipEx(L("str20039"), string.format(L("str6280"), itemInfo.description:getData(), math.modf(itemInfo.price/4)), itemInfo.name:getData(), itemInfo.icon, itemInfo.id)            
            if pWnd then
                local pWnd = tolua.cast(pWnd, "TipWindow")
                pWnd:luaSetReturnSelector(luaTipBuyReturn)
            end
        else
            showWingShopTip(m_goodsInfo.setExchangeGood[tag].idGoodType);
        end
    end
end

local function seExchangeShopInfo()
    if m_goodsInfo.ucAmount == nil then
        return;
    end
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local pageNode = pMultiPage:getPageWithIndex(3);
    if pageNode == nil then
        return;
    end
    local pNode = pageNode:getChildByTag(1);
    if pNode == nil then
        return;
    end
    local pPage = SCTypeCast:castNodeToPageScrollBox(pNode:getChildByTag(2));
    if pPage then
        pPage:setScrollVertical(false);
        local size = pPage:getPageSize();
        local pChildNode = nil;
        local nCount = 0;
        for i = 1, m_goodsInfo.ucAmount do
            local index = (i - 1) % 8;
            if index == 0 then
                nCount = nCount + 1;
                pChildNode = SCNode:node();
                if pChildNode then
					pChildNode:setTag(nCount)
                    pChildNode:setPosition(CCPointMake((nCount - 1) * size.width, 0));
                    pChildNode:setContentSize(size);
                    --pChildNode:setBackgroundColor(color_red);
                    pPage:addChild(pChildNode);
                end
            end
            local pDragNode = SCDragNode:node();
            if pChildNode and pDragNode then
				pDragNode:setTag(i)
                pDragNode:setFrameVisibled(true);
                pDragNode:setDragEnabled(false);
                pDragNode:setFrameType(EnumFrameTypeTip3);
                pDragNode:setContentSize(AUTO_SIZE(110, 125));
                pDragNode:setAnchorPoint(CCPointMake(0.5, 0));
                local posX = ((index % 4) * 2 + 1) * size.width / 8
                if index > 3 then
                    pDragNode:setPosition(CCPointMake(posX, SY(0)));
                else
                    pDragNode:setPosition(CCPointMake(posX, SY(118)));
                end
                --[[
                local pBtn = SCButton:button(EnumBtnType9Atlas)
                if pBtn then
                    pBtn:setTitle(L("str6281"), getDefaultFontName(), getFontSize(12));
                    pBtn:setTag(i);
                    pBtn:setAnchorPoint(CCPointMake(0.5, 0));
                    pBtn:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, SY(10)));
                    pBtn:setContentSize(AUTO_SIZE(70, 30));
                    pBtn:luaSetSelectorOnClicked(onClickExchange);
                    pDragNode:addChild(pBtn);
                end
                --]]
                local pBtn = SCButton:button()
                if pBtn then
                    pBtn:setTag(i);
                    pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                    pBtn:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, pDragNode:getContentSize().height / 2));
                    pBtn:setContentSize(pDragNode:getContentSize());
                    pBtn:luaSetSelectorOnClicked(onClickExchange);
                    pDragNode:addChild(pBtn);
                end
                pBtn = SCButton:button();
                local imgBtn1 = getRealUIResourcePath("img/new00002.png");
                local imgBtn2 = getRealUIResourcePath("img/new00003.png");
                local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[i].idGoodType);
                if pBtn and imgBtn1 and imgBtn2 and itemInfo then
					if m_goodsInfo.setExchangeGood[i].dwCost == 7 then
						local labelNode = SCLabel:labelWithStringFont(L("str0138").." x " .. m_goodsInfo.setExchangeGood[i].usCostNum, getDefaultFontName(), getFontSize(12));
						if labelNode then
							labelNode:setTag(5000)
							labelNode:setAnchorPoint(CCPointMake(0.5, 0))
							labelNode:setPosition(pDragNode:getContentSize().width / 2, SY(27));
							pDragNode:addChild(labelNode);
							local quantity = Hero:getSingleton():getEmoney()
							if quantity >= m_goodsInfo.setExchangeGood[i].usCostNum then
								m_goodsInfo.setExchangeGood[i].isEnough = true
								labelNode:setColor(color_green)
							else
								m_goodsInfo.setExchangeGood[i].isEnough = false
								labelNode:setColor(color_red)
							end
						end
					else
						local expendInfo = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[i].dwCost);
						if expendInfo then
							--[[
							local fileImg = getRealUIResourcePath("item/" .. expendInfo.icon .. ".jpg");
							if fileImg then
								local imgNode = SCImage:imageWithFile(fileImg:getData());
								if imgNode then
									imgNode:setScale(0.4);
									imgNode:setPosition(CCPointMake(SX(39), SY(43)));
									pDragNode:addChild(imgNode);
								end
							end
							--]]
							local labelNode = SCLabel:labelWithStringFont(expendInfo.name:getData().." x " .. m_goodsInfo.setExchangeGood[i].usCostNum, getDefaultFontName(), getFontSize(12));
							if labelNode then
								labelNode:setTag(5000)
								labelNode:setAnchorPoint(CCPointMake(0.5, 0))
								labelNode:setPosition(pDragNode:getContentSize().width / 2, SY(27));
								pDragNode:addChild(labelNode);
								local quantity = ItemProcessor:getSingleton():getItemQuantityWithTypeID(m_goodsInfo.setExchangeGood[i].dwCost)
								if quantity >= m_goodsInfo.setExchangeGood[i].usCostNum then
									m_goodsInfo.setExchangeGood[i].isEnough = true
									labelNode:setColor(color_green)
								else
									m_goodsInfo.setExchangeGood[i].isEnough = false
									labelNode:setColor(color_red)
								end
							end
						end
					end
                    pBtn:setBackgroundImage(imgBtn1:getData());
                    pBtn:setSelectedImage(imgBtn2:getData());
                    local fileImg = getRealUIResourcePath("item/" .. itemInfo.icon .. ".jpg");
                    if fileImg then
                        local pImg = SCImage:imageWithFile(fileImg:getData());
                        if pImg then
                            pImg:setAnchorPoint(CCPointMake(0.5, 0.5));
                            pImg:setPosition(CCPointMake(pBtn:getContentSize().width / 2, pBtn:getContentSize().height / 2));
                            pBtn:addChild(pImg);
                        end
                    end
                    pBtn:setTag(i);
                    pBtn:setAnchorPoint(CCPointMake(0.5, 0));
                    pBtn:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, SY(45)));
                    pBtn:luaSetSelectorOnClicked(onClickShowTip);
                    pDragNode:addChild(pBtn);
                    local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_goodsInfo.setExchangeGood[i].idGoodType)
                    if itemInfo then
                        local label = SCLabel:labelWithStringFont(itemInfo.name:getData(), getDefaultFontName(), getFontSize(11));
                        if label then
                            label:setColor(color_green)
                            label:setAnchorPoint(CCPointMake(0.5, 1))
                            label:setPosition(CCPointMake(pDragNode:getContentSize().width / 2, pDragNode:getContentSize().height-SY(20)));
                            pDragNode:addChild(label);
                        end
                    end
                end
                pChildNode:addChild(pDragNode);
            end
        end
        pPage:setContentSize(CCSizeMake(size.width * nCount, size.height));
    end
end

local function addGoodsInfo(tmp)
    m_goodsInfo.nType = tmp.nType;
    m_goodsInfo.szShop = tmp.szShop;
    if m_goodsInfo.ucAmount == nil then 
        m_goodsInfo.ucAmount = tmp.ucAmount;
    else
        m_goodsInfo.ucAmount = m_goodsInfo.ucAmount + tmp.ucAmount;
    end
    if m_goodsInfo.setExchangeGood == nil then
        m_goodsInfo.setExchangeGood = tmp.setExchangeGood;
        return;
    end
    for i = 1, tmp.ucAmount do
        table.insert(m_goodsInfo.setExchangeGood, tmp.setExchangeGood[i]);
    end
end

local function recExchangeShopInfo()
	SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readByte();
    if action == EXCHANGESHOPACT_ADD then
        addGoodsInfo(MSG_Info1.initWithStream(dt));
    elseif EXCHANGESHOPACT_END == action then
        addGoodsInfo(MSG_Info1.initWithStream(dt));
        seExchangeShopInfo();
    elseif   EXCHANGESHOPACT_BUY_EMONEY_GOOD_SUCCESS   == action then   
        --Wings_showWnd()
        --pChildNode = Wings1.initControl();
        --wings1_emoney_buy_success()
        --Wings_upDataInfo()
    end
end

----------------消息注册区----------------

----------------全局函数区----------------
function Wings4.init()  
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_EXCHANGESHOP)
    dataStream:writeByte(EXCHANGESHOPACT_ADD)
    dataStream:writeInt(SHOP_ARTIFACT)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show()
	
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local pageNode = pMultiPage:getPageWithIndex(3);
    if pageNode == nil then
        return;
    end
    local pNode = pageNode:getChildByTag(1);
    if pNode == nil then
        return;
    end
	local textNode = getItemTextNode(L("str6275"))
	if textNode then
	    textNode:setPosition(CCPointMake(SX(20), SY(15)))
	    pNode:addChild(textNode)
	end
end

function Wings4.wndClose()
    m_goodsInfo = {__mode = "kv"};
    m_selectGoodPos = nil
    m_nSelectBuyPos = nil
end

--SCMessageCenter:getSingleton():luaRegistCommand(recExchangeShopInfo, _MSG_EXCHANGESHOP, 0, nil)
--函数调用