--定义一个与文件名相同的table
Wings = {}
------------------消息--------------------
local EQUIPMADE_WINGSTRENGTHEN_INFO     = 100     ---//神器强化信息
local EQUIPMADE_WINGTRANSFORM_INFO      = 103     ---//神器转化信息
local EQUIPMADE_MODE_SUCCESS			= 104     ---//制作成功
local  EXCHANGESHOPACT_BUY_EMONEY_GOOD =  5        --//羽翼购买
local EQUIPMADE_FEATHER_PRICE		    = 106       --灵羽价格
local EQUIPMADE_EMONEY_LIMIT            =107     --//羽翼强化元宝不足
local EQUIPMADE_SDK_INFO = 200
-------------变量定义--------------
local m_curIndex = nil;
local m_material_count = nil;
local m_material_need = nil;
local m_material_id = nil;
local m_wings_hufu_id = 0;  --护符ID
local m_wing_cailiao_flage = 0 --自动购买护符 1 自动 0 否
local m_wings_lev = 0   --羽翼等级
local m_wings1_flage = false;   -------是否可以点击淬炼标志
local m_buylingyu_flage = 0    ----购买灵羽flage
local m_shuaxin_mark = 0 --------刷新护符标志
local m_huafei_false = false ---------消费标志
local m_money_falge = {}
----------------结构定义区----------------
local stWingAttr = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv", 
        }
        tmp.nAttrType = dt:readInt(); ---属性类型 
        tmp.nAttrData = dt:readInt(); ---属性数值
        return tmp;
    end
}

local stWingnowAttr = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv", 
        }
        tmp.nAttrnowType = dt:readInt(); ---当前属性类型 
        tmp.nAttrnowData = dt:readInt(); ---当前属性数值
        return tmp;
    end
}
local stWringInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nCurLev = dt:readInt()--//当前强化等级 
        tmp.nMaxLev = dt:readInt()---//最大强化等级
        tmp.nRand = dt:readInt()---概率 千分比 
        tmp.nCostMoney = dt:readInt()--//需要花费的金钱
		tmp.ucMaterialNum = dt:readByte() ---//需要材料个数 
		tmp.idMaterialType = dt:readInt();	---//材料类型
		tmp.nMaterialEmoney = dt:readInt();	--//购买单价
        m_material_count = tmp.nMaterialEmoney   --单价
        m_material_need = tmp.ucMaterialNum
        m_material_id   = tmp.idMaterialType
        tmp.ucAmount = dt:readByte();
        tmp.stInfo = {};
        tmp.stnowInfo = {};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stInfo, stWingAttr.initWithStream(dt));
        end
        tmp.ucNowAmount = dt:readByte();
        for i = 1, tmp.ucNowAmount do
            table.insert(tmp.stnowInfo, stWingnowAttr.initWithStream(dt));
        end
        m_money_falge = tmp
        return tmp
    end
}
----------------常量定义区----------------
--变量的定义
----------------UI控制器区----------------
function Wings.initControl()
	local pWindow7034 = SCWindow:window()
	if pWindow7034 then
		pWindow7034:setTag(7034)
		pWindow7034:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow7034:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("wings/new00765.png")
		if pImgPath then
			pWindow7034:setTitleWithImage(pImgPath:getData())
		end
		pWindow7034:setContentSize(AUTO_SIZE(480, 320))
		pWindow7034:luaSetSelectorOnClose(Wings.releaseControl)
	end

	local pMultiPage1 = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	if pMultiPage1 then
		pMultiPage1:setTag(1)
		pMultiPage1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pMultiPage1:setPosition(AUTO_POS(0.00, 0.00))
		pMultiPage1:setContentSize(AUTO_SIZE(480, 320))
		local pageImg = {"new00767.png", "new00768.png", "new00766.png", "new00853.png"}
		for i = 1, 4 do
			local pNode = SCNode:node()
			if pNode then
				pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)				   
				pNode:setPosition(ANCHOR_LEFT_BOTTOM)
				pMultiPage1:addPage(pNode)
				local imgPath = getRealUIResourcePath("wings/" .. pageImg[i])				   
				if imgPath then
					pMultiPage1:setTitleAtPage(imgPath:getData(), i - 1)
				end
			end
		end
	end

	if pMultiPage1 and pWindow7034 then
		pWindow7034:addChild(tolua.cast(pMultiPage1, "SCNode"))
	end
	return pWindow7034
end


function Wings.releaseControl()
	if Wings.wndClose then
		Wings.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function setEffectInfo(pLabel, item)
    if pLabel == nil then
        return;
    end
    pLabel:removeAllChildrenWithCleanup(true);
    local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE); 
    if m_curIndex == 0 then
        if item:getusUpLev() >= 15 then
            --Wings.emptyRightData()
            --return
        end
        dt:writeShort(EQUIPMADE_WINGSTRENGTHEN_INFO);
        dt:writeInt(item:getID());
    elseif m_curIndex == 1 then
        if item:getIdType() == 1999000014 then
            Wings.emptyRightData()
            return
        end
        dt:writeShort(EQUIPMADE_WINGTRANSFORM_INFO);
        dt:writeInt(item:getID());
        local iteminfo = item:getTypeData()
        dt:writeInt(iteminfo.data1);
    end
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show();
end

function Wings.emptyRightData()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local pageNode = pMultiPage:getPageWithIndex(m_curIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end
    local labelNode = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9-17", pChildNode));
    if labelNode then
        labelNode:removeAllChildrenWithCleanup(true);
    end
    local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-9-5", pageNode));
    if imgNode then
        imgNode:removeAllChildrenWithCleanup(true);
    end
    local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-9-6", pageNode));
    if imgNode then
        imgNode:removeAllChildrenWithCleanup(true);
    end
    for i = 1, 2 do
        if i == 2 and tmpIndex == 1 then  
            local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9-14", pChildNode));
            if dragNode then
                dragNode:removeChildByTag(1, true);
            end
        end
        local value = (i - 1) * 3;
        local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9-" .. 11 + value .. "-" .. 13 + value, pChildNode));
        if pLabel then
            pLabel:setText(" ")
        end
        local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-" .. 11 + value .. "-" .. 12 + value, pChildNode));
        if imgNode then
            imgNode:removeAllChildrenWithCleanup(true)
        end
        local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-9", pageNode));
        if dragNode then
            dragNode:removeChildByTag(20, true)
        end
    end
end
-------取下护符-----------
function wings_del_hufu()
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local tmpIndex = m_curIndex;
    if mark then
        tmpIndex = mark;
    end
    local pageNode = pMultiPage:getPageWithIndex(tmpIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end
    -------------装上护符----
    local addhufu = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("9-14-15-6656", pChildNode));
    if  addhufu then 
		addhufu:setTitle(L("str21029"),DEFAULT_FONT_NAME, F(9),color_green)
		addhufu:luaSetSelectorOnClicked(wings_hufu_add)
		addhufu:setTag(6656)
		addhufu:setContentSize(AUTO_SIZE(30, 30))
    end
    local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-14-15", pChildNode));
    if imgNode and addhufu then
		imgNode:removeAllChildrenWithCleanup(true);
		m_wings_hufu_id = 0;
		m_shuaxin_mark = 0
		imgNode:addChild(addhufu);
    end 
    
end 
-------护符判断-----
function wings_hufu_add(lev)
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local tmpIndex = m_curIndex;
    if mark then
        tmpIndex = mark;
    end
    local pageNode = pMultiPage:getPageWithIndex(tmpIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end
    local pCheckBox1 = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("9-14-16-2020", pChildNode));
	local item = ItemProcessor:getSingleton():getItemByTypeID(m_wings_hufu_idtoimage);
	if item then
		--------------去下护符按钮-------------
		local delhufu = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("9-14-15-6656", pChildNode));
		if  delhufu then 
			delhufu:setTitle(L("str21037"),DEFAULT_FONT_NAME, F(9),color_green)
			delhufu:luaSetSelectorOnClicked(wings_del_hufu)
			delhufu:setContentSize(AUTO_SIZE(30, 30))
		end
		m_shuaxin_mark = 1;
		m_wings_hufu_id = item:getID()
		local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_wings_hufu_idtoimage)
		local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-14-15", pChildNode));
		local pImgPath = getRealUIResourcePath("item/" .. itemInfo.icon .. ".jpg"); ------新护符item取图片
		if imgNode and itemInfo and pImgPath then
			imgNode:removeAllChildrenWithCleanup(true);
			local pIconNode = SCImage:imageWithFile(pImgPath:getData());
			if mark ==nil and pIconNode then
				pIconNode:setAnchorPoint(CCPointMake(0.5, 0.5));
				local size = imgNode:getContentSize();
				pIconNode:setPosition(CCPointMake(size.width / 2, size.height / 2));
				imgNode:addChild(pIconNode);
				imgNode:addChild(delhufu);
			end
		end 
	if pCheckBox1 then
		elseif pCheckBox1:isSelect() then
			m_wing_cailiao_flage = 1;
		else
			showMessage(L("str21030"));
			m_wings_hufu_id = 0;
		end
	end 
end 
function wings_hufu_add_false()
	showMessage(L("str21032"));
end 
function Wings.setRightData(index, mark)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local tmpIndex = m_curIndex;
    if mark then
        tmpIndex = mark;
    end
    local pageNode = pMultiPage:getPageWithIndex(tmpIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end
    Wings1.setCurIndex(index);
    local itemId = Wings3.getItemId(index);
    if itemId == nil then
        return;
    end
    local labelNode = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9-17", pChildNode));
    local item = ItemProcessor:getSingleton():getItem(itemId);
    local itemType = nil;
    if item and labelNode then
        itemType = item:getIdType();
        if mark == nil then
            setEffectInfo(labelNode, item);
        end
    else
        --清除界面后返回
        --Wings.emptyRightData()
        return;
    end
    local lev = item:getusUpLev();
    local mark = nil;
    for i = 1, 2 do
        if i == 2 then
            if tmpIndex == 1 then
                if item:getIdType() == 1999000014 then
                    mark = true;
                    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9-14", pChildNode));
                    if dragNode then
                        dragNode:removeChildByTag(1, true);
                        pNode = SCNode:node();
                        pNode:setTag(1);
                        pNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pNode:setPosition(CCPointMake(dragNode:getContentSize().width / 2, dragNode:getContentSize().height / 2));
                        pNode:setContentSize(CCSizeMake(dragNode:getContentSize().width - SX(8), dragNode:getContentSize().height - SY(10)));
                        pNode:setBackgroundColor(ccc4(0, 0, 0, 255));
                        dragNode:addChild(pNode); 
                        local labelNode = SCLabel:labelWithStringFont(L("str6271"), DEFAULT_FONT_NAME, F(12));
                        if labelNode then
                            labelNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                            labelNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, pNode:getContentSize().height / 2));
                            --labelNode:setColor(color_green);
                            pNode:addChild(labelNode);
                            Wings1.setSsEnough(2);
                        end
						local childDragNode = dragNode:getChildByTag(15)
						if childDragNode then
							childDragNode:setVisible(false)
						end
                    end
                elseif lev < 9 then
                    mark = true;
                    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9-14", pChildNode));
                    if dragNode then
                        dragNode:removeChildByTag(1, true);
                        pNode = SCNode:node();
                        pNode:setTag(1);
                        pNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pNode:setPosition(CCPointMake(dragNode:getContentSize().width / 2, dragNode:getContentSize().height / 2));
                        pNode:setContentSize(CCSizeMake(dragNode:getContentSize().width - SX(8), dragNode:getContentSize().height - SY(10)));
                        pNode:setBackgroundColor(ccc4(0, 0, 0, 255));
                        dragNode:addChild(pNode); 
                        --[[
                        local labelNode = SCLabel:labelWithStringFont(L("str6268"), DEFAULT_FONT_NAME, F(12));
                        if labelNode then
                            labelNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                            labelNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, pNode:getContentSize().height / 2));
                            --labelNode:setColor(color_green);
                            pNode:addChild(labelNode);
                            Wings1.setSsEnough(2);
                        end]]
                        -----------淬炼可进阶------------
                        local textBox = SCTextBox:boxWithWidthHeightFont(SX(50), SY(45), DEFAULT_FONT_NAME, getFontSize(12))
						if textBox then
							--textBox:setParserDelegate(TextParser:getSingleton());
							textBox:setText(L("str6268"))
							textBox:setAnchorPoint(CCPointMake(0.5, 0.5));
							textBox:setPosition(CCPointMake(pNode:getContentSize().width / 2, pNode:getContentSize().height / 2));
							--textBox:setInputEnabled(false)
							textBox:setScrollHorizontal(false)
							textBox:setScrollVertical(false)
							--textBox:setIsTouchEnabled(false)
							pNode:addChild(textBox)
                            Wings1.setSsEnough(2);
						end
						local childDragNode = dragNode:getChildByTag(15)
						if childDragNode then
							childDragNode:setVisible(false)
						end
                    end
                else
                    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9-14", pChildNode));
                    if dragNode then
                        dragNode:removeChildByTag(1, true);
                    end
					local childDragNode = dragNode:getChildByTag(15)
					if childDragNode then
						childDragNode:setVisible(true)
					end
                end
            elseif tmpIndex == 0 then
                if lev >= 15 then
                    mark = true;
                    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9-14", pChildNode));
                    if dragNode then
                        dragNode:removeChildByTag(1, true);
                        local labelNode = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(12));
                        if labelNode then
							labelNode:setTag(1)
							dragNode:setVisible(false)
							dragNode:setFrameType(3)
                            labelNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                            labelNode:setPosition(CCPointMake(dragNode:getContentSize().width / 2, dragNode:getContentSize().height / 2));
                            --labelNode:setColor(color_green);
                            dragNode:addChild(labelNode);
                            Wings1.setSsEnough(2);
                        end
						local childDragNode = dragNode:getChildByTag(15)
						if childDragNode then
							childDragNode:setVisible(false)
						end
                    end
                end
            end
        end
        if lev < 15 then
			local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9-14", pChildNode));
			if dragNode then
				dragNode:setVisible(true)
				local childDragNode = dragNode:getChildByTag(15)
				if childDragNode then
					childDragNode:setVisible(true)
				end
			end 
        end
        if tmpIndex == 0 then
			local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9", pChildNode));
			local pImage = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-7", pChildNode));
			if pImage and dragNode then
				dragNode:removeChildByTag(7,true)
			end 
        end 
        
        local itemInfo = nil;
        if tmpIndex == 1 and i == 2 then
            itemInfo = TableParser:getSingleton():getItemInfoByKey(itemType + 1);
        else
            itemInfo = TableParser:getSingleton():getItemInfoByKey(itemType); -----淬炼升级窗口item
        end
        for j = 1, 5  do
			if itemType ==  1999000009+j then 
				m_wings_hufu_idtoimage = 3600010001 + j*10
			end 
        end 
        if itemInfo then
            local value = (i - 1) * 3;
            local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9-" .. 11 + value .. "-" .. 13 + value, pChildNode));
            if pLabel then
                if i == 2 then
                    Wings1.setSsEnough(nil);
                    if tmpIndex == 1 then
                        pLabel:setText(itemInfo.name:getData() .. "+" .. lev - 3);
                    else
                        --pLabel:setText(itemInfo.name:getData() .. "+" .. lev + 1); ----等级+1
                        
						local pCheckBox1 = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("9-14-16-2020", pChildNode));
						if pCheckBox1 then
							if  lev <= 7 then
								pCheckBox1:luaSetSelectorOnButtonClicked(choose_onclicked);
							else
								pCheckBox1:luaSetSelectorOnButtonClicked(choose_onclicked_true);
							end 
						end 
						if pCheckBox1 == nil  then
							local pCheckBox20 = SCCheckBox:boxWithDescribe(L("str30073"), DEFAULT_FONT_NAME, F(9), color_yellow)
							if pCheckBox20 then
								pCheckBox20:setTag(2020)
								pCheckBox20:setPosition(AUTO_POS(-45,-12))
								if  lev <= 7 then
									pCheckBox20:luaSetSelectorOnButtonClicked(choose_onclicked);
								else
									pCheckBox20:luaSetSelectorOnButtonClicked(choose_onclicked_true);
								end 
								pLabel:addChild(pCheckBox20);
							end
						end 
                    end
                else
                    pLabel:setText(itemInfo.name:getData() .. "+" .. lev);
                end
                pLabel:setColor(color_orange);
                if mark then
                    pLabel:setText(" ");
                end
            end    
            m_wings_lev = lev 
            if tmpIndex == 0 and i == 2 then
				local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9-14", pChildNode));
				if dragNode then
					dragNode:setFrameVisibled(false)
				end 
				local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9-11", pChildNode));
				if dragNode then
					dragNode:setFrameVisibled(false)
				end 
				local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-" .. 11 + value .. "-" .. 12 + value, pChildNode));
				local addhufu_btn = SCButton:button()
				if m_shuaxin_mark == 1 then  
					local item = ItemProcessor:getSingleton():getItemByTypeID(m_wings_hufu_idtoimage);
					if item  then
						m_shuaxin_mark = 1
						m_wings_hufu_id = item:getID()
					else
						m_shuaxin_mark = 0
						m_wings_hufu_id = 0
					end  
				end 
				if  imgNode and m_shuaxin_mark == 0 then
					imgNode:removeAllChildrenWithCleanup(true);
					if mark ==nil and addhufu_btn   then
						addhufu_btn:setTitle(L("str21029"),DEFAULT_FONT_NAME, F(9),color_green)
						addhufu_btn:setTag(6656)
						addhufu_btn:setContentSize(AUTO_SIZE(30, 30))
						addhufu_btn:setPosition(AUTO_POS(5,-8))
						if lev > 7 then
							addhufu_btn:luaSetSelectorOnClicked(wings_hufu_add)
						else
							addhufu_btn:luaSetSelectorOnClicked(wings_hufu_add_false)
						end 
						imgNode:addChild(addhufu_btn);
					end 
				end 
            else
				local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-" .. 11 + value .. "-" .. 12 + value, pChildNode));
				local pImgPath = getRealUIResourcePath("item/" .. itemInfo.icon .. ".jpg"); ------新护符item取图片
				if imgNode and pImgPath then
					imgNode:removeAllChildrenWithCleanup(true);
					local pIconNode = SCImage:imageWithFile(pImgPath:getData());
					if mark ==nil and pIconNode then
						pIconNode:setAnchorPoint(CCPointMake(0.5, 0.5));
						local size = imgNode:getContentSize();
						pIconNode:setPosition(CCPointMake(size.width / 2, size.height / 2));
						imgNode:addChild(pIconNode);
					end
				end
            end
        end
    end
end
---------------勾选回调-------
function  choose_onclicked()
	showMessage(L("str21032"));
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local tmpIndex = m_curIndex;
    if mark then
        tmpIndex = mark;
    end
    local pageNode = pMultiPage:getPageWithIndex(tmpIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end
	local pCheckBox1 = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("9-14-16-2020", pChildNode));
    if  pCheckBox1 then
		pCheckBox1:setSelect(false);
    end 
end 
function choose_onclicked_true()
	m_wings1_flage = true
end 

local function onClickedMultiPage(tag, index)
    m_curIndex = index;
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local pageNode = pMultiPage:getPageWithIndex(index);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    
    --翅膀进阶提示增加
	pageNode:removeChildByTag(3366, true)
    if index == 1 then
		local pLabel = SCLabel:labelWithStringFont(L("str30221"), DEFAULT_FONT_NAME, F(12))
		if pLabel then
			pLabel:setColor(color_yellow)
			pLabel:setTag(3366)
			pLabel:setPosition(AUTO_POS(209, 266))
			pageNode:addChild(pLabel)
		end
	end
    
    if pChildNode then
        if 0 == index or 1 == index then
            local scrollbox = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-3", pChildNode))
            if scrollbox then
                Wings.setRightData(scrollbox:getPageIndex()+1)
            end
        elseif 2 == index then
            Wings2.upDataInfo(pChildNode);
        end
        return;
    end
    if 0 == index then
    elseif 1 == index then
        pChildNode = Wings1.initControl();
        if pChildNode then
            Wings1.init(pChildNode);
            pChildNode:setPosition(CCPointMake(SX(0), 0));
            local img = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-6", pChildNode));
            if img then
                local file = getRealUIResourcePath("img/new00793.png")
                if file then
		            img:setImage(file:getData())
		        end
            end
            local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("9-19", pChildNode));
            if pBtn then
		        pBtn:setTitle(L("str6262"), DEFAULT_FONT_NAME, F(15))
            end
            local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9-17", pChildNode));
            if pLabel then  
				pLabel:setText("")
                pLabel:removeAllChildrenWithCleanup(true)
                local pLabelCur = SCLabel:labelWithStringFont(L("str30070"), DEFAULT_FONT_NAME, F(12))
                if pLabelCur then
                    pLabelCur:setPosition(AUTO_POS(-42.00, 0))
                    pLabel:addChild(pLabelCur)
                end
                
                local pLabelNext = SCLabel:labelWithStringFont(L("str30071"), DEFAULT_FONT_NAME, F(12))
                if pLabelNext then
                    pLabelNext:setPosition(AUTO_POS(58.00, 0))
                    pLabel:addChild(pLabelNext)
                end
            end
            
            --金币，天晶位置修改
            local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-5", pChildNode))
            if imgNode then
				imgNode:setPosition(AUTO_POS(40.00, 43.00))
			end
            
            local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("9-6", pChildNode))
            if imgNode then
				imgNode:setPosition(AUTO_POS(40.00, 25.00))
			end
            
            Wings3.init(SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-3", pChildNode)));
            pageNode:addChild(pChildNode);
            Wings.setRightData(1);
        end
    elseif 2 == index then
        pChildNode = Wings2.initControl();
        if pChildNode then
            Wings2.init(pChildNode);
            pChildNode:setPosition(CCPointMake(SX(0), 0));
            pageNode:addChild(pChildNode);
        end
    elseif 3 == index then
        pChildNode = Wings5.initControl();
        if pChildNode then
            Wings5.init(pChildNode)
            pChildNode:setPosition(CCPointMake(SX(0), 0));
            Wings3.init(SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-3", pChildNode)))
            pageNode:addChild(pChildNode);
            local itemId = Wings3.getItemId(1)
            Wings5.setGemInfoForWing(itemId)
		end
    end
end

local function ControlOperating(wnd)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(wnd:getChildByTag(1));
    if pMultiPage then
        pMultiPage:luaSetSelectorOnPageSelected(onClickedMultiPage);
        local pNode = pMultiPage:getPageWithIndex(0);
        if pNode then
            local pChildNode = Wings1.initControl();
            if pChildNode then
                m_curIndex = 0;
                Wings1.init(pChildNode);
                pChildNode:setPosition(CCPointMake(SX(0), 0));
                Wings3.init(SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-3", pChildNode)));
                pNode:addChild(pChildNode);
                Wings.setRightData(1);
            end
        end
    end
end

local function getItemSize(itemType)
    local nCount = 0;
    local itemSize = ItemProcessor:getSingleton():ItemSize();
    for i=1, itemSize do
        local item = ItemProcessor:getSingleton():getItemInfo(i - 1);
        if item and item:getIdType() == itemType then
            nCount = nCount + item:getAmount();
        end
    end
    return nCount;
end

local function onClickHelp()
    luashowConfirmationWindow(string.format(L("str30072")), WIN_YES, nil)
end
--------淬炼界面帮助-----
local function onClickHelp_cuilian()
    luashowConfirmationWindow(string.format(L("str21036")), WIN_YES, nil)
end
local function chooseorno()
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local tmpIndex = m_curIndex;
    if mark then
        tmpIndex = mark;
    end
    local pageNode = pMultiPage:getPageWithIndex(tmpIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end
	local pCheckBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("9-2021", pChildNode));
    if  pCheckBox:isSelect() then
		
    else
		wings_send_flage_true()
    end 
end 
local function setRightRecInfo(tmp, index)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    Wings1.moneycol(nil)  
    if nil == index then
        index = 0
    end
    local muPageIndex = pMultiPage:selectedPageIndex()
    if index ~= muPageIndex then
        return
    end
    local pageNode = pMultiPage:getPageWithIndex(index);
    if pageNode == nil then
        return;
    end
    local labelNode = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-9-17", pageNode));
    if labelNode and tmp.ucAmount then
        labelNode:removeAllChildrenWithCleanup(true);
        if index == 0 then              --淬炼界面
            labelNode:setText(" ")
            local pLabelCur = SCLabel:labelWithStringFont(L("str21034"), DEFAULT_FONT_NAME, F(12))
            if pLabelCur then
                pLabelCur:setPosition(AUTO_POS(-42.00, 0))
                labelNode:addChild(pLabelCur)
            end
            
            local pLabelNext = SCLabel:labelWithStringFont(L("str21035"), DEFAULT_FONT_NAME, F(12))
            if pLabelNext then
                pLabelNext:setPosition(AUTO_POS(58.00, 0))
                pLabelNext:setColor(color_green)
                labelNode:addChild(pLabelNext)
            end
            --m_wings_hufu_id = 0
            local pBuf = "";
            local pBuf1 = "";
            for i = 1, tmp.ucNowAmount do
                local stEffectName = ItemProcessor:getSingleton():getItemAttrName(tmp.stnowInfo[i].nAttrnowType);
                if stEffectName then
                        pBuf = pBuf .. "*0" .. stEffectName:getData() .. " +" .. tmp.stnowInfo[i].nAttrnowData .. "_";
                end
			end
			for i = 1, tmp.ucAmount do
                local stEffectNameNext = ItemProcessor:getSingleton():getItemAttrName(tmp.stInfo[i].nAttrType);
                if stEffectNameNext then
                        pBuf1 = pBuf1 .. "*3" .. stEffectNameNext:getData() .. " +" .. tmp.stInfo[i].nAttrData .. "_";
                end
            end
            local pParsedNode = getItemTextNode(pBuf);
            if pParsedNode then
                pParsedNode:setAnchorPoint(CCPointMake(0, 1));
                pParsedNode:setPosition(CCPointMake(SX(-70), 0));
                labelNode:addChild(pParsedNode);
            end
            pParsedNode = getItemTextNode(pBuf1);
            if pParsedNode then
                pParsedNode:setAnchorPoint(CCPointMake(0, 1));
                pParsedNode:setPosition(CCPointMake(SX(30), 0));
                labelNode:addChild(pParsedNode);
            end
            
 			local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-9", pageNode))
			local pCheckBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("1-9-2021", pageNode));
			if pCheckBox == nil  then
				if pDragNode  then
					local pCheckBox21 = SCCheckBox:boxWithDescribe(L("str30073"), DEFAULT_FONT_NAME, F(9), color_yellow)
					if pCheckBox21 then
						pCheckBox21:setTag(2021)
						pCheckBox21:luaSetSelectorOnButtonClicked(chooseorno)
						pCheckBox21:setPosition(AUTO_POS(20,10))
						pDragNode:addChild(pCheckBox21);
					end
				end 
			end 
        elseif index == 1 then          --进阶界面
            --进阶前，进阶后文字添加
            labelNode:setText("")
            labelNode:removeAllChildrenWithCleanup(true)
            local pLabelCur = SCLabel:labelWithStringFont(L("str30070"), DEFAULT_FONT_NAME, F(12))
            if pLabelCur then
                pLabelCur:setPosition(AUTO_POS(-42.00, 0))
                labelNode:addChild(pLabelCur)
            end
            
            local pLabelNext = SCLabel:labelWithStringFont(L("str30071"), DEFAULT_FONT_NAME, F(12))
            if pLabelNext then
                pLabelNext:setPosition(AUTO_POS(58.00, 0))
                pLabelNext:setColor(color_green)
                labelNode:addChild(pLabelNext)
            end
            
            local pCurBuf = ""          --进阶前属性
            local pNextBuf = ""         --进阶后属性
            
            for i = 1, tmp.ucAmount do
                if tmp.stInfo[i].nAttrTypeCur ~= 0 then
                    local stEffectNameCur = ItemProcessor:getSingleton():getItemAttrName(tmp.stInfo[i].nAttrTypeCur);
                    if stEffectNameCur then
                        pCurBuf = pCurBuf .. "*0" .. stEffectNameCur:getData() .. " +" .. tmp.stInfo[i].nAttrDataCur .. "_"
                    end
                end
                
                if tmp.stInfo[i].nAttrType ~= 0 then
                    local stEffectNameNext = ItemProcessor:getSingleton():getItemAttrName(tmp.stInfo[i].nAttrType);
                    if stEffectNameNext then
                        pNextBuf = pNextBuf .. "*3" .. stEffectNameNext:getData() .. " +" .. tmp.stInfo[i].nAttrData .. "_"
                    end
                end
            end
            
            local pParsedNode = getItemTextNode(pCurBuf);           --创建属性节点
            if pParsedNode then
                pParsedNode:setAnchorPoint(CCPointMake(0, 1));
                pParsedNode:setPosition(CCPointMake(SX(-70), 0));
                labelNode:addChild(pParsedNode);
            end
            pParsedNode = getItemTextNode(pNextBuf);
            if pParsedNode then
                pParsedNode:setAnchorPoint(CCPointMake(0, 1));
                pParsedNode:setPosition(CCPointMake(SX(30), 0));
                labelNode:addChild(pParsedNode);
            end
        end
    end
    
    --金币显示
    local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-9-5", pageNode));
    if imgNode then
        imgNode:removeAllChildrenWithCleanup(true);
        if index == 0 then      --淬炼界面
            imgNode:setPosition(AUTO_POS(40.00, 55.00))
        elseif index == 1 then  --进阶界面
            imgNode:setPosition(AUTO_POS(40.00, 43.00))
        end
        local labelNode = SCLabel:labelWithStringFont(L("money") .. tmp.nCostMoney, DEFAULT_FONT_NAME, F(12));
        if labelNode then
            labelNode:setAnchorPoint(CCPointMake(0, 0.5));
            local size = imgNode:getContentSize();
            labelNode:setPosition(CCPointMake(size.width, size.height / 2));
            labelNode:setScale(2);
            if tmp.nCostMoney > Hero:getSingleton():getMoney() then
                labelNode:setColor(color_red);
                Wings1.setSsEnough(3)
                Wings1.moneycol(5)
            else
                labelNode:setColor(color_green);
                Wings1.setSsEnough(nil)
            end
            imgNode:addChild(labelNode);
        end
    end
    
    --天晶显示
    imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-9-6", pageNode));
    if imgNode then
        imgNode:removeAllChildrenWithCleanup(true)
        if index == 0 then      --淬炼界面
            imgNode:setPosition(AUTO_POS(40.00, 40.00))
        elseif index == 1 then  --进阶界面
            imgNode:setPosition(AUTO_POS(40.00, 25.00))
        end
        if index == 0  then
			m_nNum = 0
			local iteminfoSize = ItemProcessor:getSingleton():ItemSize();    
			for i = 1, iteminfoSize do
				local item = ItemProcessor:getSingleton():getItemInfo(i - 1);
				local itemcount = item:getIdType();
				if itemcount == tmp.idMaterialType then
					m_nNum = item:getAmount() + m_nNum
				end
			end
			local itemInfo = TableParser:getSingleton():getItemInfoByKey(tmp.idMaterialType);
			if itemInfo then
				local labelNode = SCLabel:labelWithStringFont(itemInfo.name:getData() .. ": " ..m_nNum.."/".. tmp.ucMaterialNum, DEFAULT_FONT_NAME, F(12));
				if labelNode then
					labelNode:setAnchorPoint(CCPointMake(0, 0.5));
					local size = imgNode:getContentSize();
					labelNode:setPosition(CCPointMake(size.width, size.height / 2));
					labelNode:setScale(2);
					if tmp.ucMaterialNum > getItemSize(tmp.idMaterialType) then
						labelNode:setColor(color_red);
						Wings1.setSsEnough(1);
					else
						labelNode:setColor(color_green);
						Wings1.setSsEnough(nil);
					end
					imgNode:addChild(labelNode);
				end
			end
        
        elseif index == 1   then 
			local itemInfo = TableParser:getSingleton():getItemInfoByKey(tmp.idMaterialType);
			if itemInfo then
				local labelNode = SCLabel:labelWithStringFont(itemInfo.name:getData() .. ": " .. tmp.ucMaterialNum, DEFAULT_FONT_NAME, F(12));
				if labelNode then
					labelNode:setAnchorPoint(CCPointMake(0, 0.5));
					local size = imgNode:getContentSize();
					labelNode:setPosition(CCPointMake(size.width, size.height / 2));
					labelNode:setScale(2);
					if tmp.ucMaterialNum > getItemSize(tmp.idMaterialType) then
						labelNode:setColor(color_red);
						Wings1.setSsEnough(1);
					else
						labelNode:setColor(color_green);
						Wings1.setSsEnough(nil);
					end
					imgNode:addChild(labelNode);
				end
			end
        end 
    end
    
    --横线位置变化
    local pImgLine = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-9-4", pageNode))
    if pImgLine then
        if index == 0 then      --淬炼界面
            pImgLine:setPosition(AUTO_POS(112.00, 70.00))
        elseif index == 1 then  --进阶界面
            pImgLine:setPosition(AUTO_POS(112.00, 64.00))
        end
    end
    
    --帮助按钮
    if index == 1 then  --进阶界面
        local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-9", pageNode))
        local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-9-80", pageNode))
        if pDragNode and not pBtn then
            local pPath = getRealUIResourcePath("img/new00875.png")
            pBtn = SCButton:button()
            pBtn:setTag(80)
            pBtn:luaSetSelectorOnClicked(onClickHelp)
            pBtn:setContentSize(AUTO_SIZE(30, 30))
            pBtn:setPosition(AUTO_POS(118.00, 15.00))
            pBtn:setTitle(pPath:getData())
            pDragNode:addChild(pBtn)
        end
	elseif  index == 0 then 
		local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-9", pageNode))
        local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-9-80", pageNode))
        if pDragNode and not pBtn then
            local pPath = getRealUIResourcePath("img/new00875.png")
            pBtn = SCButton:button()
            pBtn:setTag(80)
            pBtn:luaSetSelectorOnClicked(onClickHelp_cuilian)
            pBtn:setContentSize(AUTO_SIZE(30, 30))
            pBtn:setPosition(AUTO_POS(118.00, 10.00))
            pBtn:setTitle(pPath:getData())
            pDragNode:addChild(pBtn)
        end
    end
    
    --按钮位置变换
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1-9-19", pageNode));
    if pBtn then
        if index == 0 then      --淬炼界面
            pBtn:setPosition(AUTO_POS(143.00, 17.00))
        elseif index == 1 then  --进阶界面
            pBtn:setPosition(AUTO_POS(143.00, 17.00))
        end
    end
    
	local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-9", pageNode));
    if dragNode then
        dragNode:removeChildByTag(20, true)
        if tmp.nRand then
            local label = SCLabel:labelWithStringFont(L("str6270"), getDefaultFontName(), getFontSize(12))
            if label then
                local numNode = Wings.getBFBNode(math.modf(tmp.nRand/10))
                numNode:setAnchorPoint(CCPointMake(1, 1))
                numNode:setPosition(CCPointMake(label:getContentSize().width+SX(8), SY(-5)))
                label:addChild(numNode)
                
                label:setTag(20)
                label:setColor(color_green)
                label:setPosition(CCPointMake(SX(85), SY(230)))
                dragNode:addChild(label)
            end
        end
    end
end
function wings_return_cailiao()
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local tmpIndex = m_curIndex;
    if mark then
        tmpIndex = mark;
    end
    local pageNode = pMultiPage:getPageWithIndex(tmpIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end
	local pCheckBox1 = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("9-14-16-2020", pChildNode));
	if pCheckBox1 then
		if  pCheckBox1:isSelect() then
			m_wing_cailiao_flage = 1
		else
			m_wing_cailiao_flage = 0;
		end 
    end 
    return m_wing_cailiao_flage
end 
function wings_send_node()
	local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local tmpIndex = m_curIndex;
    if mark then
        tmpIndex = mark;
    end
    local pageNode = pMultiPage:getPageWithIndex(tmpIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end

	return pChildNode
end 
function wing_getmaterial()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local tmpIndex = m_curIndex;
    if mark then
        tmpIndex = mark;
    end
    local pageNode = pMultiPage:getPageWithIndex(tmpIndex);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode == nil then
        return;
    end
    local pCheckBox1 = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("9-14-16-2020", pChildNode));
    if  pCheckBox1:isSelect() then
		m_wing_cailiao_flage = 1
	else
		m_wing_cailiao_flage = 0;
    end 
    local pCheckBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlistAndParent("9-2021", pChildNode));
    if  pCheckBox:isSelect() then
		wing_choose(1)
    else
		m_wing_cailiao_flage = 0;
		local count =   getItemSize(m_material_id)
		local  emoey_need_count = (m_material_need - count )*m_material_count
		local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_material_id);
		local str = nil;
		if itemInfo  then
			luashowConfirmationWindow(string.format(L("str21001"),itemInfo.name:getData(),emoey_need_count,(m_material_need - getItemSize(m_material_id))), WIN_YES_NO, wing_choose);  -------------购买二次确认
		end 
    end
end 
function wing_gethufu_id()
	return m_wings_hufu_id;
end 
function wing_gethufu_id_ling()
	m_wings_hufu_id = 0;
end 
function wing_sendbuy_flage()
	return m_buylingyu_flage;
end 
function wing_sendbuy_flage_flase()
	m_buylingyu_flage = 0;
end 
function wing_choose(tag)
    if  tag == 1  then
		m_buylingyu_flage = 1
		wings1_emoney_buy_success()
    elseif  tag == 0   then
		m_buylingyu_flage = 0
		return;
    end 
end 
function wing_success()
    Wings_showWnd()
end 
----------------消息处理区----------------

----------------消息注册区----------------


local function recWinsInfo()
	m_huafei_false = false
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    local action = dt:readShort();
    if action == EQUIPMADE_WINGSTRENGTHEN_INFO then
		m_wings1_flage = true;
        setRightRecInfo(stWringInfo.initWithStream(dt), 0);
    elseif action == EQUIPMADE_WINGTRANSFORM_INFO then
	    local tmp = {};
	    tmp.nCostMoney = dt:readInt();
	    tmp.ucMaterialNum = dt:readInt();
	    tmp.idMaterialType = dt:readInt();
	    tmp.ucAmount = dt:readByte();
	    tmp.stInfo = {};
	    for i = 1, tmp.ucAmount do
	        local childTmp = {};
	        childTmp.nAttrType = dt:readInt();
	        childTmp.nAttrData = dt:readInt();
	        childTmp.nAttrTypeCur = dt:readInt();
	        childTmp.nAttrDataCur = dt:readInt()
	        table.insert(tmp.stInfo, childTmp);
	    end
	    
        local itemId = Wings3.getItemId(Wings1.getCurIndex())
        local item = ItemProcessor:getSingleton():getItem(itemId)
        if item then
            if item:getIdType() == 1999000014 then
                return
            end
        end
        setRightRecInfo(tmp, 1);
	    --[[
	    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
        if pMultiPage then
            local pageNode = pMultiPage:getPageWithIndex(1);
            if pageNode then
                local childPageNode = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("1-2-3", pageNode));
                if childPageNode then
                    local itemId = Wings3.getItemId(childPageNode)
                end
            end
        end
        setRightRecInfo(tmp, 1);
        --]]
	elseif action == EQUIPMADE_MODE_SUCCESS then
	    local wndCtrl = getCurentSceneWindowController(8007);
        if wndCtrl then
            removeWindowCtrl(wndCtrl);
        end
    elseif action == EQUIPMADE_FEATHER_PRICE then       --灵羽价格
        Wings2.recInfo(dt)
	elseif  action == EQUIPMADE_EMONEY_LIMIT     then
		showMessage(_LTParser("str21091"))
		m_huafei_false = true
	elseif action == EQUIPMADE_SDK_INFO then
		local dwItemtype = dt:readInt();
		local ucMadeTimes = dt:readByte();
		local YMTJ_INTENSIFY = 13;
		local item = TableParser:getSingleton():getItemInfoByKey(dwItemtype)
		if item.id ~= 0 then
			SCPay:getSingleton():statisticalInterface(YMTJ_INTENSIFY, item.name:getData().."_"..ucMadeTimes);
		end
    end
end
-------设置羽翼标志-------
function wings_send_flage()
	return m_wings1_flage;
end 
function wings_send_flage_false()
	m_wings1_flage = false;
end 
function wings_send_flage_true()
	m_wings1_flage = true;
end 
----------------全局函数区----------------

--获取百分比node
function Wings.getBFBNode(value)
    local numPath = getRealUIResourcePath("img/new00069.png")
    local fPath = getRealUIResourcePath("img/new00034.png")
    if not numPath or not fPath then
        return
    end
    local numNode = SCNode:node()
    local fNode = SCImage:imageWithFile(fPath:getData())
    if not fNode then
        return
    end
    numNode:setContentSize(fNode:getContentSize())
    fNode:setAnchorPoint(CCPointMake(1, 0))
    fNode:setPosition(CCPointMake(numNode:getContentSize().width, 0))
    numNode:addChild(fNode)
    local width = numNode:getContentSize().width
    local gw = value%10
    value = math.modf(value/10)
    while gw~=0 or value~=0 do
        local numImg = SCImage:imageWithFile(numPath:getData(), CCRectMake(gw*SX(16),0,SX(16),SY(18)))
        if numImg then
            numImg:setAnchorPoint(CCPointMake(1, 0))
            numImg:setPosition(CCPointMake(numNode:getContentSize().width - width, 0))
            width = width + numImg:getContentSize().width
            --numNode:setContentSize(CCSizeMake(width, numNode:getContentSize().height))
            numNode:addChild(numImg)
        end
        gw = value%10
        value = math.modf(value/10)
    end
    
    return numNode
end

function Wings.wndClose()
    Wings1.releaseControl();
    Wings2.releaseControl();
    Wings3.releaseControl();
    Wings5.releaseControl();
    m_wings_hufu_id = 0
	m_shuaxin_mark = 0
	wing_sendbuy_flage_flase()
end

function Wings.getCurIndex()
    return m_curIndex;
end

function Wings.reqWingCost()
    local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE)
    dt:writeShort(EQUIPMADE_FEATHER_PRICE)

    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show();
end

function Wings_showWnd()
    Wings.reqWingCost()
    
    local wnd = Wings.initControl();
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            ControlOperating(wnd);
            return
        end
    end
end

function Wings_upDataInfo()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return;
    end
    local index = pMultiPage:selectedPageIndex();
    local pageNode = pMultiPage:getPageWithIndex(index);
    if pageNode == nil then
        return;
    end
    local pChildNode = pageNode:getChildByTag(1);
    if pChildNode then
        if index == 1 then
            local page = pMultiPage:getPageWithIndex(0);
            local pNode = nil;
            if page then
                pNode = page:getChildByTag(1);
            end
            if pNode then
				Wings1.upDataInfo(pChildNode, pNode);
				Wings.setRightData(Wings1.getCurIndex(), 0);
				Wings.setRightData(Wings1.getCurIndex(), 1);
				Wings3.upDataInfo(pChildNode, pNode)

			--宝石镶嵌刷新
				local page = pMultiPage:getPageWithIndex(3);
				local pNode = nil;
				if page then
					pNode = page:getChildByTag(1);
				end
				if pNode then
					Wings3.upDataInfo(pNode)
				end 
            end
        elseif index == 2 then
            Wings2.upDataInfo(pChildNode);
        elseif index == 0 then            
            Wings.setRightData(Wings1.getCurIndex(), 0);
            Wings.setRightData(Wings1.getCurIndex(), 1);
        end
    end
end
---------钱不够跳转赚钱界面-----
function wing_kong(tag)
    if tag == 1  then
        cornucopia_ClickBtn()
        local wndCtrl = getCurentSceneWindowController(7034);
        if wndCtrl then
            removeWindowCtrl(wndCtrl);
        end	
	elseif tag == 0  then
	    return;
	
	end 
end 

--羽翼商城购买完刷新
function wings_refreshWnd()
	onClickedMultiPage(tag, m_curIndex)
end
----护符刷新标记----------
function wings_send_hufu()
	m_shuaxin_mark = 0 
end 
function wings_huafei()
	return m_huafei_false
end 
function wings_huafei_true()
	if m_money_falge.nCostMoney > Hero:getSingleton():getMoney() then
		Wings1.moneycol(5)
	end 
end 

SCMessageCenter:getSingleton():luaRegistCommand(recWinsInfo, _MSG_MATERIALMADE, 0, nil)

--函数调用