--定义一个类 ，其实也就是一个table
WizardGuardian = {};

function WizardGuardian:new(o)	--类中的方法,放在外面相当于类的静态方法，
	local class = o or {};	--这样使用使类可被继承
	
	--定义变量
	class.elfGuardInfo = {__mode = "kv"}
	
	--定义方法
	--初始化
	class.init = function ()
		--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_ELF_GUARD_OPEN
		LuaData:getSingleton():luaSetSelectorOnRecvData(class.processElfGuard, LuaData_USERINFO_ELF_GUARD_OPEN);

		--set callBackFunction when recive _MSG_USERINFO action = USERINFO_ELF_GUARD_TRAIN
		LuaData:getSingleton():luaSetSelectorOnRecvData(class.processElfTrain, LuaData_USERINFO_ELF_GUARD_TRAIN);
	end
	--窗口关闭时
	class.onCloseWnd = function()
		class.elfGuardInfo = {__mode = "kv"};
	end
	--获取守护精灵界面的数据
	class.getElfGuardInfo = function()
		return class.elfGuardInfo;
	end
	--打开窗口消息回调
	class.processElfGuard = function()
		local dt = LuaData:getSingleton():getDataTransStream();
		class.readElfGuardData(dt);
		class.showElfWnd();
	end
	--刷新经验和次数回调
	class.processElfTrain = function()
		local dt = LuaData:getSingleton():getDataTransStream();
		class.readElfTrain(dt);
		class.refreshElfInfo();
	end
	--读取数据
	class.readElfGuardData = function (dt)
		local scStr = dt:readString();
		if scStr == nil then
			class.elfGuardInfo["name"] = "";
		else
			class.elfGuardInfo["name"] = scStr:getData();
		end
		class.elfGuardInfo["level"] = dt:readShort();
		class.elfGuardInfo["currExp"] = dt:readInt();
		class.elfGuardInfo["needExp"] = dt:readInt();
		local scStr = dt:readString();
		if scStr == nil then
			class.elfGuardInfo["state"] = "";	--hp 攻击 防御 组装起来的字符串
		else
			class.elfGuardInfo["state"] = scStr:getData();
		end
		--class.elfGuardInfo["hp"] = dt:readInt();
		--class.elfGuardInfo["atk"] = dt:readInt();
		--class.elfGuardInfo["def"] = dt:readInt();
		class.elfGuardInfo["remain"] = dt:readByte();
		class.elfGuardInfo["needMoney"] = dt:readInt()
		class.elfGuardInfo["needEMoney"] = dt:readInt()
		local scStr = dt:readString();
		if scStr == nil then
			class.elfGuardInfo["descroption"] = "";
		else
			class.elfGuardInfo["descroption"] = scStr:getData();
		end
		class.elfGuardInfo[4] = {};	    --"cirtRate"
		class.elfGuardInfo[5] = {};		--"resilience"
		class.elfGuardInfo[6] = {};	    --"hit"
		class.elfGuardInfo[7] = {};	    --"dodge"
		class.elfGuardInfo[8] = {};	   	--"block"
		class.elfGuardInfo[9] = {};	    --"unblock"
		class.elfGuardInfo[10] = {};	    --"critDmg"
		for i=1, 2 do
			--为方便使用，这里key设置成4-10
			--1和2分别为当前加成和下一级加成
			class.elfGuardInfo[4][i] = dt:readShort();	    --"cirtRate"
			class.elfGuardInfo[5][i] = dt:readShort();		--"resilience"
			class.elfGuardInfo[6][i] = dt:readShort();	    --"hit"
			class.elfGuardInfo[7][i] = dt:readShort();	    --"dodge"
			class.elfGuardInfo[8][i] = dt:readShort();	   	--"block"
			class.elfGuardInfo[9][i] = dt:readShort();	    --"unblock"
			class.elfGuardInfo[10][i] = dt:readShort();	    --"critDmg"
		end
	end
	--读取数据
	class.readElfTrain = function (dt)
		local exp = dt:readInt();
		class.elfGuardInfo["currExp"] = class.elfGuardInfo["currExp"] + exp;
		class.elfGuardInfo["remain"] = dt:readByte();
		local type = dt:readByte()
		class.showMoveExp(exp, type)
	end
	--暴击光效结束
	class.baojiEnd = function(tag)
		local wnd = getCurentSceneWindow(5904)
		if not wnd then
			return
		end
		if wnd:getChildByTag(6003) then
			wnd:removeChildByTag(6003, true)
		end
		if wnd:getChildByTag(6006) then
			wnd:removeChildByTag(6006, true)
		end
	end
	--飘经验结束回调
	class.moveEndback = function(tag)
		local wnd = getCurentSceneWindow(5904)
		if not wnd then
			return
		end
		
		if wnd:getChildByTag(tag) then
			wnd:removeChildByTag(tag, true)
		end
	end
	--飘经验
	class.showMoveExp = function(exp, type)
		local wnd = getCurentSceneWindow(5904)
		if not wnd then
			return
		end
		local tag = 100
		for i = 100, 110 do
			if not wnd:getChildByTag(i) then
				tag = i
				break
			end
		end

		if type == 1 then
			if wnd:getChildByTag(6003) then
				wnd:removeChildByTag(6003, true)
			end
			local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1105, 1122)
			pAi:luaSetSelectorOnComplete(class.baojiEnd)
			pAi:setAutoremoveOnComplete(true)
			local pNode =  SCAnimationNode:nodeWithAnimation(pAi)
			pNode:setTag(6003)
			pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			setNodePostion(pNode, CCPointMake(getNodeContentSize(wnd).width/2, getNodeContentSize(wnd).height/2))
			--pNode:setPosition(CCPointMake(wnd:getContentSize().width/2, wnd:getContentSize().height/2))
			wnd:addChild(pNode, 30)
			
			local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1104, 1121)
			if pAi then
				pAi:luaSetSelectorOnComplete(class.baojiEnd)
				pAi:setAutoremoveOnComplete(true)
				local pNode =  SCAnimationNode:nodeWithAnimation(pAi)
				pNode:setTag(6006)
				pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				setNodePostion(pNode, CCPointMake(257, 166))
				wnd:addChild(pNode, 30)
		    end
		elseif type == 2 then
			if wnd:getChildByTag(6003) then
				wnd:removeChildByTag(6003, true)
			end
			local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1106, 1123)
			if pAi then
				pAi:luaSetSelectorOnComplete(class.baojiEnd)
				pAi:setAutoremoveOnComplete(true)
				local pNode =  SCAnimationNode:nodeWithAnimation(pAi)
				pNode:setTag(6003)
				pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				setNodePostion(pNode, CCPointMake(getNodeContentSize(wnd).width/2, getNodeContentSize(wnd).height/2))
				--pNode:setPosition(CCPointMake(wnd:getContentSize().width/2, wnd:getContentSize().height/2))
				wnd:addChild(pNode, 30)
			end
			
			local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1104, 1121)
			if pAi then
				pAi:luaSetSelectorOnComplete(class.baojiEnd)
				pAi:setAutoremoveOnComplete(true)
				local pNode =  SCAnimationNode:nodeWithAnimation(pAi)
				pNode:setTag(6006)
				pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
				setNodePostion(pNode, CCPointMake(257, 166))
				wnd:addChild(pNode, 30)
			end
		end
		local text = ""
		if exp ~= 0 then
			text = text.._LTParser("str0192").."+"..exp
		else
			text = text.._LTParser("str0236").."+1"
		end
		local label = SCLabel:labelWithStringFont(text, getDefaultFontName(), getFontSize(12))
		label:setColor(colorGreen())
		local actionNode = ActionNode:newActionNode()
		setNodeContentSize(actionNode, CCSizeMake(getNodeContentSize(label)))
		actionNode:addChild(label)
		actionNode:setTag(tag)
		--actionNode:setAnchorPoint(CCPointMake(0.5,0.5))
		setNodePostion(actionNode, CCPointMake(275, 100))
		--actionNode:setPosition(275, 100)
		wnd:addChild(actionNode, 20)
		actionNode:luaSetSelectorOnMoveEnd(class.moveEndback)
		actionNode:moveTo(CCPointMake(275*gUIScale().x, 230*gUIScale().y), 3, true)
	end
	--找出精灵类型
	class.GuardianKinds = function(level)
		if level == 0 then
			return 0  --无
		elseif level >= 1 and level <= 20 then
			return 1  --风
		elseif level >= 21 and level <= 40 then
			return 2  --火
		elseif level >= 41 and level <= 60 then
			return 3  --水
		elseif level >= 61 and level <= 70 then
			return 4  --雷
		elseif level >= 71 and level <= 80 then
			return 5  --冰
		elseif level >= 81 and level <= 90 then
			return 6  --暗
		else
			return 7  --光
		end
	end
	--属性加成是不全时显示tip
	class.showDescroption = function ()
		luaShowTip(class.elfGuardInfo["descroption"])
	end
	
	class.ctrlEvent = function(tag, eventType)
		if eventType == LuaControllerEventPushEnded then
			setRestartGuideFlag(GUIDE_TYPE_ELFGUARD, false)
			showGuideStep(GUIDE_TYPE_ELFGUARD, 4, 3)
		elseif eventType == LuaControllerEventPopBegan then
			if getRestartGuideFlag(GUIDE_TYPE_ELFGUARD) then
				restartBeginnerGuide(GUIDE_TYPE_ELFGUARD)
			else
				showGuideStep(GUIDE_TYPE_ELFGUARD, -1)
			end
		end
	end
	--显示窗口
	class.showElfWnd = function ()
		if getCurentSceneWindowController(5904) ~= nil then
			class.refreshElfInfo();
			return;
		end
		local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5904));
		wnd:luaSetSelectorOnClose(class.onCloseWnd);
		wnd:setBackgroundColor(colorWindowRedBG());
		local titlefile = getRealUIResourcePath("img/titile06.png")
		if titlefile then
			wnd:setTitleWithImage(titlefile:getData())
		end
		--wnd:setTitle(_LTParser("str5002"), getDefaultFontName(), gDefaultFontSize);
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5", tolua.cast(wnd, "SCNode")))
		if btn then
			btn:luaSetSelectorOnClicked(class.showDescroption)
			wnd:reorderChild(btn, 20)
			if class.elfGuardInfo["descroption"] == "" then
				btn:setVisible(false)
			else
				btn:setVisible(true)
			end
		end
		
		local backNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("55", tolua.cast(wnd, "SCNode")));
		if backNode then
			wnd:reorderChild(backNode, 20)
		end
		
		local framNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("56", tolua.cast(wnd, "SCNode")));
		if framNode then
			framNode:setFrameType(EnumFrameTypeRound)
			framNode:setFrameVisibled(true)
		end
		local framNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("57", tolua.cast(wnd, "SCNode")));
		if framNode then
			framNode:setFrameType(EnumFrameTypeRound)
			framNode:setFrameVisibled(true)
		end
		local framNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("58", tolua.cast(wnd, "SCNode")));
		if framNode then
			framNode:setFrameType(EnumFrameTypeLine)
			framNode:setFrameVisibled(true)
		end
		local framNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("59", tolua.cast(wnd, "SCNode")));
		if framNode then
			framNode:setFrameType(EnumFrameTypeLine)
			framNode:setFrameVisibled(true)
		end
		
		local consumeLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("60", tolua.cast(wnd, "SCNode")));
		if consumeLabel then
			consumeLabel:setColor(color_lightYellow)
			consumeLabel:setText(_LTParser("str5101")..":"..class.elfGuardInfo["needMoney"])
		end
		local consumeLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("61", tolua.cast(wnd, "SCNode")));
		if consumeLabel then
			consumeLabel:setColor(color_lightYellow)
			consumeLabel:setText(_LTParser("str5101")..":"..class.elfGuardInfo["needEMoney"])
		end
		
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
		label:setColor(colorGreen());
		label:setText(class.elfGuardInfo["name"].."("..class.elfGuardInfo["level"].._LTParser("str0266")..")");
		wnd:reorderChild(label, 20)
		
		local text = "*9".._LTParser("str0192").." "..class.elfGuardInfo["currExp"].."/"..class.elfGuardInfo["needExp"].."_";
		--text = text.._LTParser("str5003").." +"..elfGuardInfo["hp"].."_";
		--text = text.._LTParser("str5004").." +"..elfGuardInfo["atk"].."_";
		--text = text.._LTParser("str5005").." +"..elfGuardInfo["def"].."_";
		if class.elfGuardInfo["state"] ~= "" then
			text = text..class.elfGuardInfo["state"].."_";
			--text = text.."*4".._LTParser("str5006");
		end
		local textBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
		textBox:setScrollVertical(false);
		textBox:setText(text);
		wnd:reorderChild(textBox, 20)
		
		local skillPosX = 35
		local skillPosY = 110
		for i=4, 10 do
			if class.elfGuardInfo[i][1]~=0 then
				local button = tolua.cast(wnd:getChildByTag(i), "SCButton")
				if not button then
					local file = getRealUIResourcePath("img/img"..5064+i..".png")
					button = SCButton:button()
					button:setTag(i)
					button:luaSetSelectorOnClicked(class.onClickAtriBtn)
					button:setTitle(file:getData())
					setNodePostion(button, CCPointMake(skillPosX, skillPosY))
					--button:setPosition(CCPointMake(skillPosX, skillPosY))
					wnd:addChild(button, 20)
				end
				skillPosX = skillPosX + 7 + getNodeContentSize(button).width
			end
		end
		
		for i=4, 10 do
			if class.elfGuardInfo[i][1]==0 and class.elfGuardInfo[i][2]~=0 then
				local button = tolua.cast(wnd:getChildByTag(i), "SCButton")
				if not button then
					local file = getRealUIResourcePath("img/img"..5064+i..".png")
					button = SCButton:button()
					button:setTag(i)
					button:luaSetSelectorOnClicked(class.onClickAtriBtn)
					button:setTitle(file:getData())
					setNodePostion(button, CCPointMake(skillPosX, skillPosY))
					--button:setPosition(CCPointMake(skillPosX, skillPosY))
					local node = SCNode:node()
					node:setTag(1)
					node:setContentSize(button:getContentSize())
					node:setBackgroundColor(getColorBlackTransparent())
					button:addChild(node)
					wnd:addChild(button, 20)
				end
				skillPosX = skillPosX + 7 + getNodeContentSize(button).width
			end
		end
		
		--local text = _LTParser("str5007").."_"..class.elfGuardInfo["remain"].._LTParser("str0015");
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("12", tolua.cast(wnd, "SCNode")));
		if label then
			--textBox:setScrollVertical(false);
			label:setColor(color_lightYellow)
			label:setText(class.elfGuardInfo["remain"].."");
			--label:setColor(color_lightYellow)
		end
		
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("15", tolua.cast(wnd, "SCNode")));
		if label then
			label:setColor(color_green)
		end
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("16", tolua.cast(wnd, "SCNode")));
		if label then
			label:setColor(color_green)
		end
		
		local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("13", tolua.cast(wnd, "SCNode")));
		if button then
			button:setTag(0);
			button:luaSetSelectorOnClicked(class.onClickStartTrain);
			wnd:reorderChild(button, 20)
		end
		local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("14", tolua.cast(wnd, "SCNode")));
		if button then
			button:setTag(1);
			button:luaSetSelectorOnClicked(class.onClickStartTrain);
			wnd:reorderChild(button, 20)
		end
		--[[
			local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1104, 1121)
			--pAi:luaSetSelectorOnComplete(class.baojiEnd)
			--pAi:setAutoremoveOnComplete(true)
			local pNode =  SCAnimationNode:nodeWithAnimation(pAi)
			--pNode:setTag(6006)
			pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			setNodePostion(pNode, CCPointMake(257, 166))
			--pNode:setPosition(CCPointMake(100, 40))
			wnd:addChild(pNode, 30)
			]]
			
		local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1107, 1125);
		local pNode = nil
		if pAi then
			pNode = SCAnimationNode:nodeWithAnimation(pAi);
			pNode:setTag(6007)
			pNode:setAnchorPoint(CCPointMake(0.5, 0.5))
			setNodePostion(pNode, CCPointMake(257, 168))
			--pNode:setPosition(CCPointMake(257, 166))
			wnd:addChild(pNode, 10)
		end
		
		if pNode == nil then
			return;
		end
		
		local path = getRealUIResourcePath("img/img"..5122+class.GuardianKinds(class.elfGuardInfo["level"])..".png")
		if path then
			local width = 60 * gUIScale().x
			local height = 168 * (class.elfGuardInfo.currExp/class.elfGuardInfo.needExp) * gUIScale().y
			local imgbg = SCImage:imageWithFile(path:getData(), CCRectMake(0, 0, width, height))
			imgbg:setAnchorPoint(CCPointMake(0.5, 0.5))
			imgbg:setTag(6004)
			setNodePostion(imgbg, CCPointMake(getNodePostion(pNode).x, getNodePostion(pNode).y-getNodeContentSize(pNode).height/2+getNodeContentSize(imgbg).height/2+25))
			--imgbg:setPosition(CCPointMake(pNode:getPosition().x+(pNode:getContentSize().width-60)/2, pNode:getPosition().y+(pNode:getContentSize().height-168)/2))
			wnd:addChild(imgbg)
			local pAi1 = LookfaceParser:getSingleton():getAnimationByIndex(1100, 1124);
			local pNode1 =  SCAnimationNode:nodeWithAnimation(pAi1);
			pNode1:setAnchorPoint(CCPointMake(0.5, 0.5))
			setNodePostion(pNode1, CCPointMake(getNodePostion(imgbg).x, getNodePostion(imgbg).y+getNodeContentSize(imgbg).height/2))
			--pNode1:setPosition(CCPointMake(imgbg:getPosition().x, imgbg:getPosition().y+imgbg:getContentSize().height-pNode1:getContentSize().height/2))
			pNode1:setTag(6005)
			wnd:addChild(pNode1)
		end
		
		local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("11", tolua.cast(wnd, "SCNode")));
		if imgNode then
			local path = getRealUIResourcePath("img/img"..5074+class.GuardianKinds(class.elfGuardInfo["level"])..".png")
			imgNode:setImage(path:getData())
			wnd:reorderChild(imgNode, 20)
		end
		
		if not luaIsUnlock(UNLOCK_TYPE_EXTRA27) then
			local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
			if button then
				button:setVisible(false)
			end
			local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("59", tolua.cast(wnd, "SCNode")));
			if dragNode then
				dragNode:setVisible(false)
			end
			local lable = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("61", tolua.cast(wnd, "SCNode")));
			if lable then
				lable:setVisible(false)
			end
			local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("0", tolua.cast(wnd, "SCNode")));
			if button then
				setNodePostion(button, CCPointMake(125, 20))
			end
			local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("58", tolua.cast(wnd, "SCNode")));
			if dragNode then
				setNodePostion(dragNode, CCPointMake(219, 16))
			end
			local lable = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("60", tolua.cast(wnd, "SCNode")));
			if lable then
				setNodePostion(lable, CCPointMake(229, 30))
			end
		end
		
		local naviCtrl =  getCurentSceneNavigationController();
		wndCtrl = SCWindowController:controllerWithWindow(wnd);
		wndCtrl:luaSetSelectorOnEvent(class.ctrlEvent)
		naviCtrl:pushWindowController(wndCtrl);
		
	end
	--刷新窗口
	class.refreshElfInfo = function ()
		local wndCtrl = getCurentSceneWindowController(5904);
		if wndCtrl == nil then
			return;
		end	
		local wnd = wndCtrl:getWindow();
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5", tolua.cast(wnd, "SCNode")))
		if btn then
			btn:luaSetSelectorOnClicked(class.showDescroption)
			wnd:reorderChild(btn, 20)
			if class.elfGuardInfo["descroption"] == "" then
				btn:setVisible(false)
			else
				btn:setVisible(true)
			end
		end
		
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
		label:setText(class.elfGuardInfo["name"].."("..class.elfGuardInfo["level"].._LTParser("str0266")..")");
		
		local text = "*9".._LTParser("str0192").." "..class.elfGuardInfo["currExp"].."/"..class.elfGuardInfo["needExp"].."_";
		if class.elfGuardInfo["state"] ~= "" then
			text = text..class.elfGuardInfo["state"].."_";
			--text = text.."*4".._LTParser("str5006");
		end
		local textBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
		textBox:setText(text);
		
		local skillPosX = 35
		local skillPosY = 110
		for i=4, 10 do
			if class.elfGuardInfo[i][1]~=0 then
				local button = tolua.cast(wnd:getChildByTag(i), "SCButton")
				if not button then
					local file = getRealUIResourcePath("img/img"..5064+i..".png")
					button = SCButton:button()
					button:setTag(i)
					button:luaSetSelectorOnClicked(class.onClickAtriBtn)
					button:setTitle(file:getData())
					wnd:addChild(button)
				else
					if button:getChildByTag(1) then
						button:removeChildByTag(1, true)
					end
				end
				setNodePostion(button, CCPointMake(skillPosX, skillPosY))
				--button:setPosition(CCPointMake(skillPosX, skillPosY))
				skillPosX = skillPosX + 7 + getNodeContentSize(button).width
			end
		end
		for i=4, 10 do
			if class.elfGuardInfo[i][1]==0 and class.elfGuardInfo[i][2]~=0 then
				local button = tolua.cast(wnd:getChildByTag(i), "SCButton")
				if not button then
					local file = getRealUIResourcePath("img/img"..5064+i..".png")
					button = SCButton:button()
					button:setTag(i)
					button:luaSetSelectorOnClicked(class.onClickAtriBtn)
					button:setTitle(file:getData())
					local node = SCNode:node()
					node:setTag(1)
					setNodeContentSize(node, getNodeContentSize(button))
					--node:setContentSize(button:getContentSize())
					node:setBackgroundColor(getColorBlackTransparent())
					button:addChild(node)
					wnd:addChild(button)
				end
				setNodePostion(button, CCPointMake(skillPosX, skillPosY))
				--button:setPosition(CCPointMake(skillPosX, skillPosY))
				skillPosX = skillPosX + 7 + getNodeContentSize(button).width
			end
		end
		
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("12", tolua.cast(wnd, "SCNode")));
		if label then
			--textBox:setScrollVertical(false);
			label:setText(class.elfGuardInfo["remain"].."");
			label:setColor(color_lightYellow)
		end
		
		local path = getRealUIResourcePath("img/img"..5122+class.GuardianKinds(class.elfGuardInfo["level"])..".png")
		if path then
			local pNode = tolua.cast(wnd:getChildByTag(6007), "SCAnimationNode")
			if not pNode then
				return
			end
			local width = 60 * gUIScale().x
			local height = 168 * (class.elfGuardInfo.currExp/class.elfGuardInfo.needExp) * gUIScale().y
			local imgbg = tolua.cast(wnd:getChildByTag(6004), "SCImage")
			if imgbg then
				imgbg:setImage(path:getData(), CCRectMake(0, 0, width, height))
				setNodePostion(imgbg, CCPointMake(getNodePostion(pNode).x, getNodePostion(pNode).y-getNodeContentSize(pNode).height/2+getNodeContentSize(imgbg).height/2+25))
			end
			--imgbg:setAnchorPoint(CCPointMake(0.5, 0.5))
			--imgbg:setPosition(CCPointMake(pNode:getPosition().x+(pNode:getContentSize().width-60)/2, pNode:getPosition().y+(pNode:getContentSize().height-168)/2))
			--wnd:addChild(imgbg)
			--local pAi1 = LookfaceParser:getSingleton():getAnimationByIndex(1100, 1124);
			if pAi1 then
				local pNode1 =  tolua.cast(wnd:getChildByTag(6005), "SCAnimationNode")
				if pNode1 then
					setNodePostion(pNode1, CCPointMake(getNodePostion(imgbg).x, getNodePostion(imgbg).y+getNodeContentSize(imgbg).height/2))
					--pNode1:setPosition(CCPointMake(imgbg:getPosition().x, imgbg:getPosition().y+imgbg:getContentSize().height-pNode1:getContentSize().height/2))
				end
			end
		end
		local path = getRealUIResourcePath("img/img"..5074+class.GuardianKinds(class.elfGuardInfo["level"])..".png")
		if path then
			local img = tolua.cast(wnd:getChildByTag(11), "SCImage")
			if img then
				img:setImage(path:getData())
			end
		end
	end
	--培养按钮回调
	class.onClickStartTrain = function (tag)
		local dt = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
		dt:writeShort(USERINFO_ELF_GUARD_TRAIN);
		dt:writeByte(0);
		dt:writeInt(tag);
		SCDataTransThread:getSingleton():transData(dt);
		if tag == 0 then
			setRestartGuideFlag(GUIDE_TYPE_ELFGUARD, false)
			showGuideStep(GUIDE_TYPE_ELFGUARD, 5, 4)
		end
	end
	--点击加成属性按钮
	class.onClickAtriBtn = function (tag)
		local elfInfo = class.getElfGuardInfo();
		local text = ""
		if elfInfo[tag][1] ~= 0 then
			text = text.._LTParser("str5059")..":".._LTParser("str"..(5004+tag)).." +"..getIntPart(elfInfo[tag][1]/10).."%"
		else
			text = text.._LTParser("str5060")..":".._LTParser("str"..(5004+tag)).." +"..getIntPart(elfInfo[tag][2]/10).."%"
		end
		luaShowTip(text, 3);
	end
	
	class.__mode = "kv";
	--下面两句相当于new出一个新的实例
	setmetatable(class, self);
	self.__index = self;
	return class;	--返回一个实例
end

local newWizardGuardian = WizardGuardian:new();
newWizardGuardian.init();


--0~6 风 火 水 雷 冰 暗 光
function getWizardKing(level)
	return newWizardGuardian.GuardianKinds(level)
end