--定义一个与文件名相同的table
armyGroupFight2 = {}
------------------消息--------------------
local m_myTribeRand = nil
----------------结构定义区----------------
local stSignGameSociaty = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            usNo,                --//编号
            idTribe,		    --//军团id
            szTribeName,        --//公会名称
            usLevel,            --//公会等级
            nReputation,        --//公会贡献
            ucCurAmount,		--//当前军团人数
	        ucMaxAmount,		--//军团人数上限
        }
        tmp.usNo = dt:readShort()
        tmp.idTribe = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribeName = ""
        else
            tmp.szTribeName = scStr:getData()
        end
        tmp.usLevel = dt:readShort();
        tmp.nReputation = dt:readInt();
        tmp.ucCurAmount = dt:readByte();
        tmp.ucMaxAmount = dt:readByte();
        local myTribeId = Hero:getSingleton():getIdTribe() 
		if tmp.idTribe == myTribeId then
			m_myTribeRand = tmp.usNo
		end
        return tmp
    end;
}


local tMSG_Info20 = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            ucAmount,
        }
        tmp.stfill = {};
        tmp.ucAmount = dt:readByte();
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stSignGameSociaty.initWithStream(dt))
        end
        return tmp
    end
}
----------------常量定义区----------------

----------------变量定义区----------------
--变量的定义
local m_applyArmyGroupList = nil
local m_armyGroupFight2ListBox = nil
local m_selectID = nil
----------------UI控制器区----------------
function armyGroupFight2.initControl()
	local pWindow4222 = SCWindow:window()
	if pWindow4222 then
		pWindow4222:setTag(4222)
		pWindow4222:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4222:setPosition(AUTO_POS(0.00, 0.00))pWindow4222:setContentSize(AUTO_SIZE(480, 320))
		pWindow4222:luaSetSelectorOnClose(armyGroupFight2.releaseControl)
	end

	local pLable2 = SCLabel:labelWithStringFont(L("str3181"), DEFAULT_FONT_NAME, F(15))
	if pLable2 then
		pLable2:setTag(2)
		pLable2:setAnchorPoint(ANCHOR_CENTER)
		pLable2:setPosition(AUTO_POS(252.50, 300.00))
		pLable2:setColor(ccc4(60,255,0,245))
	end

	local pLable3 = SCLabel:labelWithStringFont(L("str3005"), DEFAULT_FONT_NAME, F(14))
	if pLable3 then
		pLable3:setTag(3)
		pLable3:setAnchorPoint(ANCHOR_CENTER)
		pLable3:setPosition(AUTO_POS(50.00, 250.00))
		pLable3:setColor(ccc4(255,254,0,255))
	end

	local pLable4 = SCLabel:labelWithStringFont(L("str3008"), DEFAULT_FONT_NAME, F(14))
	if pLable4 then
		pLable4:setTag(4)
		pLable4:setAnchorPoint(ANCHOR_CENTER)
		pLable4:setPosition(AUTO_POS(130.00, 250.00))
		pLable4:setColor(ccc4(255,254,0,255))
	end

	local pLable5 = SCLabel:labelWithStringFont(L("str8047"), DEFAULT_FONT_NAME, F(14))
	if pLable5 then
		pLable5:setTag(5)
		pLable5:setAnchorPoint(ANCHOR_CENTER)
		pLable5:setPosition(AUTO_POS(210.00, 250.00))
		pLable5:setColor(ccc4(255,254,0,255))
	end

	local pLable6 = SCLabel:labelWithStringFont(L("str8048"), DEFAULT_FONT_NAME, F(14))
	if pLable6 then
		pLable6:setTag(6)
		pLable6:setAnchorPoint(ANCHOR_CENTER)
		pLable6:setPosition(AUTO_POS(290.00, 250.00))
		pLable6:setColor(ccc4(255,254,0,255))
	end

	local pLable7 = SCLabel:labelWithStringFont(L("str3182"), DEFAULT_FONT_NAME, F(14))
	if pLable7 then
		pLable7:setTag(7)
		pLable7:setAnchorPoint(ANCHOR_CENTER)
		pLable7:setPosition(AUTO_POS(412.00, 250.00))
		pLable7:setColor(ccc4(255,254,0,255))
	end

	local pListBox1 = SCListBox:boxWithWidthHeight(AUTO_W(460), AUTO_H(200))
	if pListBox1 then
		tolua.cast(pListBox1, "SCNode"):setTag(1)
		tolua.cast(pListBox1, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pListBox1, "SCNode"):setPosition(AUTO_POS(10.00, 30.00))
	end

	local pLable8 = SCLabel:labelWithStringFont(L("  "), DEFAULT_FONT_NAME, F(14))
	if pLable8 then
		pLable8:setTag(8)
		pLable8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable8:setPosition(AUTO_POS(320.00, 10.00))
		pLable8:setColor(ccc4(255,132,0,125))
	end

	if pLable2 and pWindow4222 then
		pWindow4222:addChild(tolua.cast(pLable2, "SCNode"))
	end
	if pLable3 and pWindow4222 then
		pWindow4222:addChild(tolua.cast(pLable3, "SCNode"))
	end
	if pLable4 and pWindow4222 then
		pWindow4222:addChild(tolua.cast(pLable4, "SCNode"))
	end
	if pLable5 and pWindow4222 then
		pWindow4222:addChild(tolua.cast(pLable5, "SCNode"))
	end
	if pLable6 and pWindow4222 then
		pWindow4222:addChild(tolua.cast(pLable6, "SCNode"))
	end
	if pLable7 and pWindow4222 then
		pWindow4222:addChild(tolua.cast(pLable7, "SCNode"))
	end
	if pListBox1 and pWindow4222 then
		pWindow4222:addChild(tolua.cast(pListBox1, "SCNode"))
	end
	if pLable8 and pWindow4222 then
		pWindow4222:addChild(tolua.cast(pLable8, "SCNode"))
	end
	return pWindow4222
end
function armyGroupFight2.releaseControl()
	if armyGroupFight2.wndClose then
		armyGroupFight2.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
--点击申请按钮
local function applyBtnAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_REQUEST_SOCIATY)--//申请公会
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--查看详细
local function detailButtonAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_VIEW_SOCIATY_INFO2)--//查看公会信息
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_MEMBER_LIST2)--//查看公会成员
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end
local function onClickMenuList(tag)
	if tag == 0 then
		local idTribe = m_applyArmyGroupList[m_selectID+1].idTribe
        applyBtnAction(idTribe)
	elseif tag == 1 then
		local idTribe = m_applyArmyGroupList[m_selectID+1].idTribe
		detailButtonAction(idTribe)
	end
end


local function listBoxItemSelected(tag,itemTag,itemIndex)
	local pmenuList = menuList:newStringList()
    if pmenuList and m_applyArmyGroupList then
        pmenuList:createMenu(m_applyArmyGroupList[itemIndex+1].szTribeName, 2, _LTParser("str0238").."_".._LTParser("str6096"));
        pmenuList:luasetSelector(onClickMenuList);
		m_selectID = itemIndex
    end
end

local function createListMenuItem(showWidth,showHeight,rank,societyName,level,numberStr,nReputation,type)
	
	local contentLayer = SCDragNode:node()
	contentLayer:setFrameVisibled(false)
	contentLayer:setFrameType(EnumFrameTypeListNormal)
	contentLayer:setContentSize(CCSizeMake(showWidth,showHeight))

	--上分割线
	local imgPath = getRealUIResourcePath("img/new00346.png")
	if imgPath then
	    local cuttingLine = SCImage:imageWithFile(imgPath:getData());
	    if cuttingLine then
	        local size = contentLayer:getContentSize();
	        cuttingLine:setScaleX(2.0);
            cuttingLine:setAnchorPoint(CCPointMake(0.5,0.5));
            cuttingLine:setPosition(CCPointMake(size.width/2 ,size.height - 2 * cuttingLine:getContentSize().height));
            contentLayer:addChild(cuttingLine);
	    end
	end

     --排名
    if rank == nil then
        rank = ""
    end
    local rankLabel = SCLabel:labelWithStringFont(""..rank,getDefaultFontName(), getFontSize(12))
    if rankLabel then
        rankLabel:setColor(getColorYellow())
        rankLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        rankLabel:setPosition(CCPointMake(SX(50),showHeight/2));
        contentLayer:addChild(rankLabel)
    end
    --公会
    if societyName == nil then
        societyName = ""
    end
    local societyLabel = SCLabel:labelWithStringFont(""..societyName,getDefaultFontName(), getFontSize(12))
    if societyLabel then
        societyLabel:setColor(getColorYellow())
        societyLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        societyLabel:setPosition(CCPointMake(showWidth*0.28,showHeight/2));
        contentLayer:addChild(societyLabel)
    end
    
    --等级
    if level == nil then
        level = ""
    end
    local levelLabel = SCLabel:labelWithStringFont(""..level,getDefaultFontName(), getFontSize(12))
    if levelLabel then
        levelLabel:setColor(getColorYellow())
        levelLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        levelLabel:setPosition(CCPointMake(showWidth*0.455,showHeight/2));
        contentLayer:addChild(levelLabel)
    end
    --人数
    if numberStr == nil then
        numberStr = ""
    end
    local numberLabel = SCLabel:labelWithStringFont(""..numberStr,getDefaultFontName(), getFontSize(12))
    if numberLabel then
        numberLabel:setColor(getColorYellow())
        numberLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        numberLabel:setPosition(CCPointMake(showWidth*0.63,showHeight/2));
        contentLayer:addChild(numberLabel)
    end
    
    --贡献
    if nReputation == nil then
        nReputation = ""
    end
    local nReputationLabel = SCLabel:labelWithStringFont(""..nReputation,getDefaultFontName(), getFontSize(12))
    if nReputationLabel then
        nReputationLabel:setColor(getColorYellow())
        nReputationLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        nReputationLabel:setPosition(CCPointMake(showWidth*0.83,showHeight/2));
        contentLayer:addChild(nReputationLabel)
    end
    
    return contentLayer
end

local function otherListScrollEnd()
    if not m_armyGroupFight2ListBox or not m_applyArmyGroupList then
        return
    end
    local count = m_armyGroupFight2ListBox:itemCount()
	if count <=0 then
		return
	end
	local showWidth = m_armyGroupFight2ListBox:getContentSize().width
    local showHeight = m_armyGroupFight2ListBox:getContentSize().height
    local hero = Hero:getSingleton()
    local typeRank = hero:getRank()--0无公会
    
    local menuWidth  = showWidth
    local menuHeight = SY(40)
    for i=count+1, count+10 do
		if m_applyArmyGroupList[i] then
            local idTribe       =   m_applyArmyGroupList[i].idTribe
            local usNo          =   m_applyArmyGroupList[i].usNo
            local szTribeName   =   m_applyArmyGroupList[i].szTribeName
            local usLevel       =   m_applyArmyGroupList[i].usLevel
            local ucCurAmount   =   m_applyArmyGroupList[i].ucCurAmount
            local ucMaxAmount   =   m_applyArmyGroupList[i].ucMaxAmount
            local nReputation   =   m_applyArmyGroupList[i].nReputation
            
            local menuItem = createListMenuItem(menuWidth,menuHeight,usNo,szTribeName,usLevel,ucCurAmount.."/"..ucMaxAmount,nReputation,typeRank)
            menuItem:setTag(idTribe)
            menuItem:setAnchorPoint(CCPointMake(0.5,0));
            menuItem:setPosition(CCPointMake(showWidth/2,0));
            m_armyGroupFight2ListBox:addItem(menuItem)
        end
	end
end


local function showApplyArmyGroupList()
    if not m_armyGroupFight2ListBox or not m_applyArmyGroupList then
        return
    end
    if m_armyGroupFight2ListBox:itemCount() > 0 then
		return
	end
	local showWidth = m_armyGroupFight2ListBox:getContentSize().width
    local showHeight = m_armyGroupFight2ListBox:getContentSize().height
    local hero = Hero:getSingleton()
    local typeRank = hero:getRank()--0无公会
    
    local menuWidth  = showWidth
    local menuHeight = SY(40)
    local amount = 10
    for i=1,amount do
        if m_applyArmyGroupList[i] then
            local idTribe       =   m_applyArmyGroupList[i].idTribe
            local usNo          =   m_applyArmyGroupList[i].usNo
            local szTribeName   =   m_applyArmyGroupList[i].szTribeName
            local usLevel       =   m_applyArmyGroupList[i].usLevel
            local ucCurAmount   =   m_applyArmyGroupList[i].ucCurAmount
            local ucMaxAmount   =   m_applyArmyGroupList[i].ucMaxAmount
            local nReputation   =   m_applyArmyGroupList[i].nReputation
            
            local menuItem = createListMenuItem(menuWidth,menuHeight,usNo,szTribeName,usLevel,ucCurAmount.."/"..ucMaxAmount,nReputation,typeRank)
            if idTribe then
                menuItem:setTag(idTribe)
            end
            menuItem:setAnchorPoint(CCPointMake(0.5,0));
            menuItem:setPosition(CCPointMake(showWidth/2,0));
            m_armyGroupFight2ListBox:addItem(menuItem)
        end
    end
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4222-8"))
    if pLabel then
		if m_myTribeRand then
			pLabel:setText(L("str3303")..m_myTribeRand)
		else
			pLabel:setText(L("str3304"))
		end 
    end
    m_armyGroupFight2ListBox:luaSetSelectorOnScrollToEnd(otherListScrollEnd)
end
----------------消息处理区----------------
local function recArmyGroupFight2View()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        if m_applyArmyGroupList == nil then
            m_applyArmyGroupList = {}
        end
        local ucAmount = dt:readByte()
        for i=1,ucAmount do
            table.insert(m_applyArmyGroupList,stSignGameSociaty.initWithStream(dt))
        end
        showApplyArmyGroupList()
        if m_myTribeRand then
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("4222-8"))
			if pLabel then
				pLabel:setText(L("str3303")..m_myTribeRand)
			end
        end
    end
end
local function sendQueryApplyArmyGroupListMsg()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    if dataStream then
        dataStream:writeShort(MSG_SOCIATY_SIGN_GAME_LIST)
        SCDataTransThread:getSingleton():transData(dataStream); 
	    SCActivityIndicator:getSingleton():show();
    end
end
----------------消息注册区----------------
LuaData:getSingleton():luaSetSelectorOnRecvData(recArmyGroupFight2View, LuaData_MSG_SOCIATY_SIGN_GAME_LIST)
----------------全局函数区----------------
function armyGroupFight2_showArmyGroupFight2Wnd()
    local wndCtrl = getCurentSceneWindowController(4222)
    if wndCtrl then
        return
    end
    local wnd = armyGroupFight2.initControl()
    if wnd then
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
        end
        local titlefile = getRealUIResourcePath("tribe/new00824.png")
        if titlefile then
            wnd:setTitleWithImage(titlefile:getData())
        end
         m_armyGroupFight2ListBox = SCTypeCast:castNodeToListBox(wnd:getChildByTag(1));
         if m_armyGroupFight2ListBox then
            m_armyGroupFight2ListBox:luaSetSelectorOnItemSelected(listBoxItemSelected)
         end
    end
    sendQueryApplyArmyGroupListMsg()
    
    
    --[[
    m_applyArmyGroupList = {}
    for i = 1,20 do
        m_applyArmyGroupList[i] = {}
        m_applyArmyGroupList[i].idTribe = 1
        m_applyArmyGroupList[i].usNo = 100
        m_applyArmyGroupList[i].szTribeName = 100
        m_applyArmyGroupList[i].usLevel = 100
        m_applyArmyGroupList[i].ucCurAmount = 100
        m_applyArmyGroupList[i].ucMaxAmount = 100
        m_applyArmyGroupList[i].nReputation = 100
    end
    showApplyArmyGroupList()
    ]]
end
function armyGroupFight2.wndClose()
    m_applyArmyGroupList = nil
    m_armyGroupFight2ListBox = nil
    m_selectID = nil
    m_myTribeRand = nil
end

--函数调用