--定义一个与文件名相同的table
challengeView = {}
------------------消息--------------------

----------------结构定义区----------------
local stMenuInfo = {
    initWithStream = function(dt)
        if dt == nil then
            return {}
        end

        local self = {
            __mode = "kv",
        }
        self.RemainTimes = dt:readInt();     --剩余次数
        self.PurchaseTimes = dt:readInt();   --可购买次数
        self.BoughtTimes = dt:readInt();     --已购买次数
        return self;
	end
}

local stInstanceMenuInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		
		self.nCount = dt:readInt();
		self.MenuInfo = {};
		for i= 1, self.nCount do
            table.insert(self.MenuInfo, stMenuInfo.initWithStream(dt));
        end 
		return self;
	end
}

----------------常量定义区----------------
local MSG_SEND_MENU_INFO    = 1   		--发送界面
local MSG_BUY_INSTANCE_TIME = 2   		--购买挑战次数
local ARENASCRITP_ADD_PVP_TIMES = 75	--购买虎符 

----------------变量定义区----------------
local Info    = {}
local Flag = nil;
local m_Value = 0   --标志刷新
--变量的定义
----------------UI控制器区----------------
function challengeView.initControl()
	local pWindow4427 = SCWindow:window()
	if pWindow4427 then
		pWindow4427:setTag(4427)
		pWindow4427:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4427:setPosition(AUTO_POS(0.00, 0.00))pWindow4427:setContentSize(AUTO_SIZE(480, 320))
		pWindow4427:luaSetSelectorOnClose(challengeView.releaseControl)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode2:setContentSize(AUTO_SIZE(480, 320))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTyperedwindowstip)
	end

	local imgPath = getRealUIResourcePath("kernal/redtop.pn")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage3:setPosition(AUTO_POS(135.00, 295.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00322.png")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage4:setPosition(AUTO_POS(222.00, 298.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00310.jp")
	local pImage5 = nil
	if imgPath then
		pImage5 = SCImage:imageWithFile(imgPath:getData())
		if pImage5 then
			pImage5:setTag(5)
			pImage5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage5:setPosition(AUTO_POS(5.00, 22.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00319.jp")
	local pImage6 = nil
	if imgPath then
		pImage6 = SCImage:imageWithFile(imgPath:getData())
		if pImage6 then
			pImage6:setTag(6)
			pImage6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage6:setPosition(AUTO_POS(99.00, 22.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00313.jp")
	local pImage7 = nil
	if imgPath then
		pImage7 = SCImage:imageWithFile(imgPath:getData())
		if pImage7 then
			pImage7:setTag(7)
			pImage7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage7:setPosition(AUTO_POS(194.00, 22.00))
		end
	end
	
	local pLabel70 = SCLabel:labelWithStringFont(L("str30188"), DEFAULT_FONT_NAME, F(11))
	if pLabel70 then
		pLabel70:setTag(70)
		pLabel70:setAnchorPoint(CCPointMake(0.5, 0))
		pLabel70:setPosition(AUTO_POS(46.00, 85.00))
		pLabel70:setColor(color_green)
	end
	
	local imgPath = getRealUIResourcePath("challenge/new00734.jp")
	local pImage8 = nil
	if imgPath then
		pImage8 = SCImage:imageWithFile(imgPath:getData())
		if pImage8 then
			pImage8:setTag(8)
			pImage8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage8:setPosition(AUTO_POS(288.00, 22.00))
		end
	end
	
	local pLabel80 = SCLabel:labelWithStringFont(L("str30188"), DEFAULT_FONT_NAME, F(11))
	if pLabel80 then
		pLabel80:setTag(80)
		pLabel80:setAnchorPoint(CCPointMake(0.5, 0))
		pLabel80:setPosition(AUTO_POS(46.00, 85.00))
		pLabel80:setColor(color_green)
	end

	local imgPath = getRealUIResourcePath("challenge/new00732.jp")
	local pImage9 = nil
	if imgPath then
		pImage9 = SCImage:imageWithFile(imgPath:getData())
		if pImage9 then
			pImage9:setTag(9)
			pImage9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage9:setPosition(AUTO_POS(383.00, 22.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00570.png")
	local pImage10 = nil
	if imgPath then
		pImage10 = SCImage:imageWithFile(imgPath:getData())
		if pImage10 then
			pImage10:setTag(10)
			pImage10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10:setPosition(AUTO_POS(14.00, 7.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00309.pn")
	local pImage11 = nil
	if imgPath then
		pImage11 = SCImage:imageWithFile(imgPath:getData())
		if pImage11 then
			pImage11:setTag(11)
			pImage11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage11:setPosition(AUTO_POS(10.00, 257.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00318.pn")
	local pImage12 = nil
	if imgPath then
		pImage12 = SCImage:imageWithFile(imgPath:getData())
		if pImage12 then
			pImage12:setTag(12)
			pImage12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage12:setPosition(AUTO_POS(106.00, 257.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00311.pn")
	local pImage13 = nil
	if imgPath then
		pImage13 = SCImage:imageWithFile(imgPath:getData())
		if pImage13 then
			pImage13:setTag(13)
			pImage13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage13:setPosition(AUTO_POS(200.00, 257.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00733.pn")
	local pImage14 = nil
	if imgPath then
		pImage14 = SCImage:imageWithFile(imgPath:getData())
		if pImage14 then
			pImage14:setTag(14)
			pImage14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage14:setPosition(AUTO_POS(294.00, 257.00))
		end
	end

	local imgPath = getRealUIResourcePath("challenge/new00731.pn")
	local pImage15 = nil
	if imgPath then
		pImage15 = SCImage:imageWithFile(imgPath:getData())
		if pImage15 then
			pImage15:setTag(15)
			pImage15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage15:setPosition(AUTO_POS(389.00, 257.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00321.png")
	local pImage16 = nil
	if imgPath then
		pImage16 = SCImage:imageWithFile(imgPath:getData())
		if pImage16 then
			pImage16:setTag(16)
			pImage16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage16:setPosition(AUTO_POS(8.00, 78.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00317.png")
	local pImage17 = nil
	if imgPath then
		pImage17 = SCImage:imageWithFile(imgPath:getData())
		if pImage17 then
			pImage17:setTag(17)
			pImage17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage17:setPosition(AUTO_POS(8.00, 56.00))
		end
	end

	local pButton18 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton18 then
		pButton18:setTag(18)
		pButton18:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton18:setPosition(AUTO_POS(70.00, 53.00))
		pButton18:setContentSize(AUTO_SIZE(14, 14))
		local imgPath = getRealUIResourcePath("img/new00308.png")
		if imgPath then
			pButton18:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00642.pn")
	local pImage19 = nil
	if imgPath then
		pImage19 = SCImage:imageWithFile(imgPath:getData())
		if pImage19 then
			pImage19:setTag(19)
			pImage19:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage19:setPosition(AUTO_POS(93.00, 78.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00644.png")
	local pImage20 = nil
	if imgPath then
		pImage20 = SCImage:imageWithFile(imgPath:getData())
		if pImage20 then
			pImage20:setTag(20)
			pImage20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage20:setPosition(AUTO_POS(101.00, 56.00))
		end
	end

	local imgPath = getRealUIResourcePath("1.7/img/new00907.png")
	local pImage21 = nil
	if imgPath then
		pImage21 = SCImage:imageWithFile(imgPath:getData())
		if pImage21 then
			pImage21:setTag(21)
			pImage21:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage21:setPosition(AUTO_POS(197.00, 78.00))
		end
	end

	local imgPath = getRealUIResourcePath("1.7/img/new00907.png")
	local pImage22 = nil
	if imgPath then
		pImage22 = SCImage:imageWithFile(imgPath:getData())
		if pImage22 then
			pImage22:setTag(22)
			pImage22:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage22:setPosition(AUTO_POS(291.00, 78.00))
		end
	end

	--[[local imgPath = getRealUIResourcePath("img/new00321.png")
	local pImage23 = nil
	if imgPath then
		pImage23 = SCImage:imageWithFile(imgPath:getData())
		if pImage23 then
			pImage23:setTag(23)
			pImage23:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage23:setPosition(AUTO_POS(386.00, 75.00))
		end
	end]]

	local imgPath = getRealUIResourcePath("img/new00643.png")
	local pImage24 = nil
	if imgPath then
		pImage24 = SCImage:imageWithFile(imgPath:getData())
		if pImage24 then
			pImage24:setTag(24)
			pImage24:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage24:setPosition(AUTO_POS(198.00, 56.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00643.png")
	local pImage25 = nil
	if imgPath then
		pImage25 = SCImage:imageWithFile(imgPath:getData())
		if pImage25 then
			pImage25:setTag(25)
			pImage25:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage25:setPosition(AUTO_POS(292.00, 56.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00851.png")
	local pImage26 = nil
	if imgPath then
		pImage26 = SCImage:imageWithFile(imgPath:getData())
		if pImage26 then
			pImage26:setTag(26)
			pImage26:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage26:setPosition(AUTO_POS(386.00, 56.00))
		end
	end

	local pButton28 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton28 then
		pButton28:setTag(28)
		pButton28:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton28:setPosition(AUTO_POS(259.00, 53.00))
		pButton28:setContentSize(AUTO_SIZE(14, 14))
		local imgPath = getRealUIResourcePath("img/new00308.png")
		if imgPath then
			pButton28:setTitle(imgPath:getData())
		end
	end

	local pButton29 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton29 then
		pButton29:setTag(29)
		pButton29:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton29:setPosition(AUTO_POS(354.00, 53.00))
		pButton29:setContentSize(AUTO_SIZE(14, 14))
		local imgPath = getRealUIResourcePath("img/new00308.png")
		if imgPath then
			pButton29:setTitle(imgPath:getData())
		end
	end

	local pButton30 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton30 then
		pButton30:setTag(30)
		pButton30:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton30:setPosition(AUTO_POS(448.00, 53.00))
		pButton30:setContentSize(AUTO_SIZE(14, 14))
		local imgPath = getRealUIResourcePath("img/new00308.png")
		if imgPath then
			pButton30:setTitle(imgPath:getData())
		end
	end

	local pButton31 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton31 then
		pButton31:setTag(31)
		pButton31:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton31:setPosition(AUTO_POS(458.00, 299.00))
		pButton31:setContentSize(AUTO_SIZE(20, 20))
		local imgPath = getRealUIResourcePath("img/new00123.pn")
		if imgPath then
			pButton31:setTitle(imgPath:getData())
		end
	end

	local pButton32 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton32 then
		pButton32:setTag(32)
		pButton32:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton32:setPosition(AUTO_POS(6.00, 97.00))
		pButton32:setContentSize(AUTO_SIZE(90, 195))
		
	end

	local pButton33 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton33 then
		pButton33:setTag(33)
		pButton33:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton33:setPosition(AUTO_POS(100.00, 97.00))
		pButton33:setContentSize(AUTO_SIZE(90, 195))
		
	end

	local pButton34 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton34 then
		pButton34:setTag(34)
		pButton34:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton34:setPosition(AUTO_POS(195.00, 97.00))
		pButton34:setContentSize(AUTO_SIZE(90, 195))
		
	end

	local pButton35 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton35 then
		pButton35:setTag(35)
		pButton35:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton35:setPosition(AUTO_POS(289.00, 97.00))
		pButton35:setContentSize(AUTO_SIZE(90, 195))
		
	end

	local pButton36 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton36 then
		pButton36:setTag(36)
		pButton36:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton36:setPosition(AUTO_POS(384.00, 97.00))
		pButton36:setContentSize(AUTO_SIZE(90, 195))
		
	end

	local pDragNode27 = SCDragNode:node()
	if pDragNode27 then
		pDragNode27:setTag(27)
		pDragNode27:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode27:setPosition(AUTO_POS(0.00, 18.00))
		pDragNode27:setContentSize(AUTO_SIZE(100, 50))
		pDragNode27:setFrameVisibled(false)
		pDragNode27:setDragEnabled(false)
		pDragNode27:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode37 = SCDragNode:node()
	if pDragNode37 then
		pDragNode37:setTag(37)
		pDragNode37:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode37:setPosition(AUTO_POS(94.00, 18.00))
		pDragNode37:setContentSize(AUTO_SIZE(100, 50))
		pDragNode37:setFrameVisibled(false)
		pDragNode37:setDragEnabled(false)
		pDragNode37:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode38 = SCDragNode:node()
	if pDragNode38 then
		pDragNode38:setTag(38)
		pDragNode38:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode38:setPosition(AUTO_POS(189.00, 18.00))
		pDragNode38:setContentSize(AUTO_SIZE(100, 50))
		pDragNode38:setFrameVisibled(false)
		pDragNode38:setDragEnabled(false)
		pDragNode38:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode39 = SCDragNode:node()
	if pDragNode39 then
		pDragNode39:setTag(39)
		pDragNode39:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode39:setPosition(AUTO_POS(283.00, 18.00))
		pDragNode39:setContentSize(AUTO_SIZE(100, 50))
		pDragNode39:setFrameVisibled(false)
		pDragNode39:setDragEnabled(false)
		pDragNode39:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode40 = SCDragNode:node()
	if pDragNode40 then
		pDragNode40:setTag(40)
		pDragNode40:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode40:setPosition(AUTO_POS(378.00, 18.00))
		pDragNode40:setContentSize(AUTO_SIZE(100, 50))
		pDragNode40:setFrameVisibled(false)
		pDragNode40:setDragEnabled(false)
		pDragNode40:setFrameType(EnumFrameTypeRound)
	end
	
	if ActivityAll_isUnlock(S_WONDERFULEVENT_TYPE_COPYDOUBLEEXP) then
        local pLabel = SCLabel:labelWithStringFont(L("str6302"), DEFAULT_FONT_NAME, F(15))
        if pLabel and pButton32 then
            pLabel:setColor(color_red)
            pLabel:setAnchorPoint(CCPointMake(0.5, 0))
            pLabel:setPosition(CCPointMake(pButton32:getContentSize().width/2, SY(10)))
            pButton32:addChild(pLabel)
        end
        
        local pLabel = SCLabel:labelWithStringFont(L("str6302"), DEFAULT_FONT_NAME, F(15))
        if pLabel and pButton32 then
            pLabel:setColor(color_red)
            pLabel:setAnchorPoint(CCPointMake(0.5, 0))
            pLabel:setPosition(CCPointMake(pButton32:getContentSize().width/2, SY(10)))
            pButton33:addChild(pLabel)
        end
    end

	if pDragNode2 and pWindow4427 then
		pWindow4427:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pImage3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if pImage4 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage4, "SCNode"))
	end
	if pImage5 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage5, "SCNode"))
	end
	if pImage6 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage6, "SCNode"))
	end
	if pImage7 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage7, "SCNode"))
	end
	if pImage7 and pLabel70 then
		pImage7:addChild(tolua.cast(pLabel70, "SCNode"))
	end
	if pImage8 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage8, "SCNode"))
	end
	if pImage8 and pLabel80 then
		pImage8:addChild(tolua.cast(pLabel80, "SCNode"))
	end
	if pImage9 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage9, "SCNode"))
	end
	if pImage10 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage10, "SCNode"))
	end
	if pImage11 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage11, "SCNode"))
	end
	if pImage12 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage12, "SCNode"))
	end
	if pImage13 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage13, "SCNode"))
	end
	if pImage14 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage14, "SCNode"))
	end
	if pImage15 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage15, "SCNode"))
	end
	if pImage16 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage16, "SCNode"))
	end
	if pImage17 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage17, "SCNode"))
	end
	if pButton18 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton18, "SCNode"))
	end
	if pImage19 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage19, "SCNode"))
	end
	if pImage20 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage20, "SCNode"))
	end
	if pImage21 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage21, "SCNode"))
	end
	if pImage22 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage22, "SCNode"))
	end
	--[[if pImage23 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage23, "SCNode"))
	end]]
	if pImage24 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage24, "SCNode"))
	end
	if pImage25 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage25, "SCNode"))
	end
	if pImage26 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage26, "SCNode"))
	end
	if pButton28 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton28, "SCNode"))
	end
	if pButton29 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton29, "SCNode"))
	end
	if pButton30 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton30, "SCNode"))
	end
	if pButton31 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton31, "SCNode"))
	end
	if pButton32 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton32, "SCNode"))
	end
	if pButton33 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton33, "SCNode"))
	end
	if pButton34 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton34, "SCNode"))
	end
	if pButton35 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton35, "SCNode"))
	end
	if pButton36 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton36, "SCNode"))
	end
	if pDragNode27 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode27, "SCNode"))
	end
	if pDragNode37 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode37, "SCNode"))
	end
	if pDragNode38 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode38, "SCNode"))
	end
	if pDragNode39 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode39, "SCNode"))
	end
	if pDragNode40 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode40, "SCNode"))
	end
	return pWindow4427
end
function challengeView.releaseControl()
	if challengeView.wndClose then
		challengeView.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function onCheck(tag)    --进入各个界面按钮
    if tag == 32 then                   --精英入口
        BattleTeam.setTempInstanceType(2)
        showGameCopyWnd(2);     
    elseif tag == 33 then               --魔王入口
         BattleTeam.setTempInstanceType(3)
        showGameCopyWnd(3);     
    elseif tag == 34 then               --竞技场入口
        GuidePoint_LuaAddCount(8, 1)
        ArenaController_openWnd();
    elseif tag == 35 then               --决斗入口
        DuelTemple_sendHeroData();               
    elseif tag == 36 then               --过关入口
        Through_sendOpenWndInfo(0)
    end
    local pNaVigationCtrl =  getCurentSceneNavigationController();
	if pNaVigationCtrl then
	    pNaVigationCtrl:removeWindowControllerByTag(4427);   --这里挑战引导也需要改
	end
end

local function BuyCheck(tag)    --购买次数
    local nMoney = Hero:getSingleton():getEmoney()
    if tag == 18 then       --精英
        Flag = 1
        challengeView_sendBuyData(Flag)
    elseif tag == 27 then   --魔王
    
    elseif tag == 28 then   --竞技场
        Flag = 2
        challengeView_sendBuyByHufuMsg()
    elseif tag == 29 then   --决斗
        Flag = 3
        challengeView_sendBuyByHufuMsg()
        g_DuelTemple_bBuyTimes = false;
    elseif tag == 30 then   --过关
		Flag = 4
        challengeView_sendBuyData(Flag)
		g_Through_bBuyTimes = false;
    end
end

local function getshowTip(num, num1, num2, sum, node)   --下面小图标封装
    local pDragNode = SCDragNode:node()		
    if pDragNode then
        pDragNode:setAnchorPoint(CCPointMake(0.5, 0))
        pDragNode:setPosition(CCPointMake(node:getContentSize().width/2, SY(5)))
        pDragNode:setContentSize(AUTO_SIZE(82, 23))
        pDragNode:setFrameVisibled(true);
        pDragNode:setDragEnabled(false)
        node:addChild(pDragNode);
    end
    if sum == 2 then
        local imgPath = getRealUIResourcePath("img/"..num..".pn")
        local pImage = nil
        if imgPath then
            pImage = SCImage:imageWithFile(imgPath:getData())
            if pImage then
                pImage:setAnchorPoint(CCPointMake(0, 0.5))
                pImage:setPosition(CCPointMake(0, pDragNode:getContentSize().height/2));
                pImage:setScale(0.5);
                pDragNode:addChild(pImage);
            end
        end
        local imgPath1 = getRealUIResourcePath("img/"..num1..".pn")
        local pImage1 = nil
        if imgPath1 then
            pImage1 = SCImage:imageWithFile(imgPath1:getData())
            if pImage1 then
                pImage1:setAnchorPoint(CCPointMake(0, 0.5))
                pImage1:setPosition(CCPointMake(SX(62), pDragNode:getContentSize().height/2));
                pImage1:setScale(0.5);
                pDragNode:addChild(pImage1);
            end
        end
    elseif sum == 3 then
        local imgPath = getRealUIResourcePath("img/"..num..".pn")
        local pImage = nil
        if imgPath then
            pImage = SCImage:imageWithFile(imgPath:getData())
            if pImage then
                pImage:setAnchorPoint(CCPointMake(0, 0.5))
                pImage:setPosition(CCPointMake(0, pDragNode:getContentSize().height/2));
                pImage:setScale(0.5);
                pDragNode:addChild(pImage);
            end
        end
        local imgPath1 = getRealUIResourcePath("img/"..num1..".pn")
        local pImage1 = nil
        if imgPath1 then
            pImage1 = SCImage:imageWithFile(imgPath1:getData())
            if pImage1 then
                pImage1:setAnchorPoint(CCPointMake(0, 0.5))
                pImage1:setPosition(CCPointMake(SX(32), pDragNode:getContentSize().height/2));
                pImage1:setScale(0.5);
                pDragNode:addChild(pImage1);
            end
        end
        local imgPath2 = getRealUIResourcePath("img/"..num2..".pn")
        local pImage2 = nil
        if imgPath2 then
            pImage2 = SCImage:imageWithFile(imgPath2:getData())
            if pImage2 then
                pImage2:setAnchorPoint(CCPointMake(0, 0.5))
                pImage2:setPosition(CCPointMake(SX(62), pDragNode:getContentSize().height/2));
                pImage2:setScale(0.5);
                pDragNode:addChild(pImage2);
            end
        end
    end
end

local function setResTimes(times, node, flag)  --设置剩余次数封装
    if node == nil then 
       return
    end
    local pDragNode = SCDragNode:node()		
    if pDragNode then
        pDragNode:setTag(1);
        pDragNode:setAnchorPoint(CCPointMake(0, 0));
        pDragNode:setPosition(AUTO_POS(54, 57));
        pDragNode:setContentSize(AUTO_SIZE(28, 17));
        pDragNode:setFrameVisibled(true);
        pDragNode:setDragEnabled(false);
        node:addChild(pDragNode);
    end
    local pNodeImage = getImageNumber(times, "img/new00530.png", SX(12.2), SY(18))   --剩余次数图标
    if pNodeImage then
        pNodeImage:setAnchorPoint(CCPointMake(0.5, 0.5));
        if flag ~= nil and flag == 1 then
            if times > 9 then
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2 + SX(5), pDragNode:getContentSize().height/2));
            elseif times == 0 then
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2 - SX(7), pDragNode:getContentSize().height/2));
            else
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2 - SX(1), pDragNode:getContentSize().height/2));
            end
		elseif   flag ~= nil and flag == 2 then
            if times > 9 then
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2 + SX(20), pDragNode:getContentSize().height/2));
            elseif times == 0 then
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2 + SX(8), pDragNode:getContentSize().height/2));
            else
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2 + SX(15), pDragNode:getContentSize().height/2));
            end
        else
            if times > 9 then
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2, pDragNode:getContentSize().height/2));
            elseif times == 0 then
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2 - SX(12), pDragNode:getContentSize().height/2));
            else
                pNodeImage:setPosition(CCPointMake(pDragNode:getContentSize().width/2 - SX(6), pDragNode:getContentSize().height/2));
            end
        end
        pDragNode:addChild(pNodeImage);
    end
end

local function setBuyTimes(times, node)  --设置可购买次数封装
    local pNodeImage = getImageNumber(times, "img/new00530.png", SX(12.2), SY(18))   --剩余次数图
    if pNodeImage then
        pNodeImage:setTag(2);
        pNodeImage:setAnchorPoint(CCPointMake(0, 0));
        if times > 9 then
            pNodeImage:setPosition(AUTO_POS(43, 34));
        else
            pNodeImage:setPosition(AUTO_POS(51, 34));
        end
        node:addChild(pNodeImage);
    end
end

local function setLock(str, node)  --设置可购买次数封装  num对第几图片蒙灰
    if node then
        local pDragNode = SCNode:node()            --半透明标志
        if pDragNode then
            pDragNode:setTag(10)
            pDragNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode:setPosition(AUTO_POS(5.00,3.00))
            pDragNode:setContentSize(AUTO_SIZE(92, 271))
            pDragNode:setBackgroundColor(ccc4(0,0,0,205))
            node:addChild(tolua.cast(pDragNode, "SCNode"));
            local str = string.format(str, 35)
            local Lable = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(10))
            if Lable then
                Lable:setTag(11)
                Lable:setAnchorPoint(ANCHOR_CENTER)
                Lable:setPosition(CCPointMake(pDragNode:getContentSize().width/2, pDragNode:getContentSize().height/2))
                pDragNode:addChild(tolua.cast(Lable, "SCNode"))
            end
        end
    end
end

local function CloseWin()
    POP_TOP_CTRL();
end

local function setWindow()
    --设置购买次数按钮红色+
    local imgPath = getRealUIResourcePath("img/new00307.png");
    if imgPath == nil then
        return;
    end
    local pButton18 = SCFunction:getUiNodeByIdlist("4427-2-18"); --精英
    if pButton18 then
        pButton18:setBackgroundImage(imgPath:getData());
        pButton18:luaSetSelectorOnClicked(BuyCheck)
    end
    local pButton28 = SCFunction:getUiNodeByIdlist("4427-2-28"); --竞技场
    if pButton28 then
        pButton28:setBackgroundImage(imgPath:getData());
        pButton28:luaSetSelectorOnClicked(BuyCheck)
    end
    local pButton29 = SCFunction:getUiNodeByIdlist("4427-2-29"); --决斗神殿
    if pButton29 then
        pButton29:setBackgroundImage(imgPath:getData());
        pButton29:luaSetSelectorOnClicked(BuyCheck)
    end
    local pButton30 = SCFunction:getUiNodeByIdlist("4427-2-30"); --过关斩将
    if pButton30 then
        pButton30:setBackgroundImage(imgPath:getData());
        pButton30:luaSetSelectorOnClicked(BuyCheck)
    end
    
    --设置进入功能按钮
    local pButton32 = SCFunction:getUiNodeByIdlist("4427-2-32"); --精英
    if pButton32 then
        pButton32:luaSetSelectorOnClicked(onCheck)
    end
    local pButton33 = SCFunction:getUiNodeByIdlist("4427-2-33"); --魔王
    if pButton33 then
        pButton33:luaSetSelectorOnClicked(onCheck);
    end
    local pButton34 = SCFunction:getUiNodeByIdlist("4427-2-34"); --竞技场
    if pButton34 then
        pButton34:luaSetSelectorOnClicked(onCheck);
    end
    local pButton35 = SCFunction:getUiNodeByIdlist("4427-2-35"); --决斗神殿
    if pButton35 then
        pButton35:luaSetSelectorOnClicked(onCheck);
    end
    local pButton36 = SCFunction:getUiNodeByIdlist("4427-2-36"); --过关斩将
    if pButton36 then
        pButton36:luaSetSelectorOnClicked(onCheck);
    end
    
    --设置下面小图标
    local pImage5 = SCFunction:getUiNodeByIdlist("4427-2-5");  --精英
    if pImage5 then
        getshowTip(2001001, 2001002, 2001006, 3, pImage5);
      if Info[1] ~= nil and Info[1].MenuInfo[1] ~= nil then
        setResTimes(Info[1].MenuInfo[1].RemainTimes, pImage5);
        setBuyTimes(Info[1].MenuInfo[1].PurchaseTimes, pImage5);
      end
    end
    local pImage6 = SCFunction:getUiNodeByIdlist("4427-2-6");   --魔王
    if pImage6 then
        getshowTip(2001001, 2001002, 2001006, 3, pImage6);
         if Info[1] ~= nil and Info[1].MenuInfo[2] ~= nil then
            setResTimes(Info[1].MenuInfo[2].BoughtTimes, pImage6, 2);
            setBuyTimes(Info[1].MenuInfo[2].PurchaseTimes, pImage6);
        end
    end
    local pImage7 = SCFunction:getUiNodeByIdlist("4427-2-7");   --竞技场
    if pImage7 then
        getshowTip(2001001, 2001003, 0, 2, pImage7);
		if Info[1] ~= nil and Info[1].MenuInfo[3] ~= nil then
			setResTimes(Info[1].MenuInfo[3].RemainTimes, pImage7,2)
		end
    end
    local pImage8 = SCFunction:getUiNodeByIdlist("4427-2-8");   --决斗神殿
    if pImage8 then
        getshowTip(2001001, 2001012, 0, 2, pImage8);
		if Info[1] ~= nil and Info[1].MenuInfo[4] ~= nil then
			setResTimes(Info[1].MenuInfo[4].RemainTimes, pImage8,2);
		end
        --setBuyTimes(14, pImage8);
    end
    local pImage9 = SCFunction:getUiNodeByIdlist("4427-2-9");   --过关斩将
    if pImage9 then
        getshowTip(2001002, "new00852", 0, 2, pImage9);
        if Info[1] ~= nil and Info[1].MenuInfo[5] ~= nil then
            setBuyTimes(Info[1].MenuInfo[5].RemainTimes, pImage9);
            --setResTimes(Info[1].MenuInfo[5].RemainTimes, pImage9);
            --setResTimes(0, pImage9)
        end
        --setBuyTimes(23, pImage9);
    end
    
    --功能未开启进行蒙灰操作
    if luaIsUnlock(UNLOCK_TYPE_HERO_COPY) == false then  --精英副本未解锁
        local pNode = SCFunction:getUiNodeByIdlist("4427-2-27");   --精英
        if pNode then
            setLock(string.format(L("str0442"), 35), pNode);
        end
        pButton18:setVisible(false);
        pButton32:setVisible(false);
    end
    if luaIsUnlock(UNLOCK_TYPE_DEVIL_COPY) == false then  --魔王副本未解锁
        local pNode = SCFunction:getUiNodeByIdlist("4427-2-37");    --魔王
        if pNode then
            setLock(string.format(L("str0442"), 41), pNode);
        end
        pButton33:setVisible(false);
    end
    if luaIsUnlock(UNLOCK_TYPE_AREAN) == false then          --竞技场未解锁
        local pNode = SCFunction:getUiNodeByIdlist("4427-2-38");   --竞技场
        if pNode then
            setLock(string.format(L("str0442"), 30), pNode);
        end
        pButton28:setVisible(false);
        pButton34:setVisible(false);
    end
    if luaIsUnlock(UNLOCK_TYPE_DUELTEMPLE) == false then          --决斗未解锁
        local pNode = SCFunction:getUiNodeByIdlist("4427-2-39");   --决斗神殿
        if pNode then
            setLock(string.format(L("str0442"), 43), pNode);
        end
        pButton29:setVisible(false);
        pButton35:setVisible(false);
    end
    if luaIsUnlock(UNLOCK_TYPE_THROUGH) == false then          --过关未解锁
        local pNode = SCFunction:getUiNodeByIdlist("4427-2-40");   --过关斩将
        if pNode then
            setLock(string.format(L("str0442"), 60), pNode);
        end
        pButton30:setVisible(false);
        pButton36:setVisible(false);
    end
end

local function refreshView()   --刷新界面
    for i = 5, 9 do
        local pImage = SCFunction:getUiNodeByIdlist("4427-2-"..i);
        if pImage then
            pImage:removeChildByTag(1, true);
            pImage:removeChildByTag(2, true);
        end
    end
    
    if Info[1] == nil then
        return
    end
    
    local pImage5 = SCFunction:getUiNodeByIdlist("4427-2-5");  --精英
    if pImage5 and Info[1].MenuInfo[1] then
        setResTimes(Info[1].MenuInfo[1].RemainTimes, pImage5);
        setBuyTimes(Info[1].MenuInfo[1].PurchaseTimes, pImage5);
    end
    local pImage6 = SCFunction:getUiNodeByIdlist("4427-2-6");   --魔王
    if pImage6 and Info[1].MenuInfo[2] then
        setResTimes(Info[1].MenuInfo[2].BoughtTimes, pImage6, 2);
        setBuyTimes(Info[1].MenuInfo[2].PurchaseTimes, pImage6);
    end
    local pImage7 = SCFunction:getUiNodeByIdlist("4427-2-7");   --竞技场
	if pImage7 and Info[1].MenuInfo[3] then
		setResTimes(Info[1].MenuInfo[3].RemainTimes, pImage7,2);
	end
    local pImage8 = SCFunction:getUiNodeByIdlist("4427-2-8");   --决斗
    if pImage8 and Info[1].MenuInfo[4] then
		setResTimes(Info[1].MenuInfo[4].RemainTimes, pImage8,2);
		--setBuyTimes(Info[1].MenuInfo[4].PurchaseTimes, pImage8);
    end
    local pImage9 = SCFunction:getUiNodeByIdlist("4427-2-9");   --过关
    if pImage9 and Info[1].MenuInfo[5] then
        --setResTimes(Info[1].MenuInfo[5].RemainTimes, pImage9);
        setBuyTimes(Info[1].MenuInfo[5].RemainTimes, pImage9);
    end
end

local function showWin(tag, type)
    if type == LuaControllerEventPushEnded then
        setWindow();
    end
end

----------------消息处理区----------------
function challengeView_recvData()
    Info = {}
	SCActivityIndicator:getSingleton():close();   ----关闭等待转圈图标
	local dt = SCMessageCenter:getSingleton():getDataTransStream();  ---获取当前的数据对象
	if dt == nil then
	    return
	end
	action = dt:readShort()
	if action == MSG_SEND_MENU_INFO then 
		table.insert(Info, stInstanceMenuInfo.initWithStream(dt))
		if m_Value == 0 then
            m_Value = m_Value + 1;
			if g_Through_bBuyTimes ~= true and g_DuelTemple_bBuyTimes ~= true then
				challengeView.Window();
			end
        else
            if g_Through_bBuyTimes ~= true and g_DuelTemple_bBuyTimes ~= true then
				challengeView.Window();
			end
		    refreshView();
		end
	end
	
	g_Through_bBuyTimes = false
	g_DuelTemple_bBuyTimes = false
end

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(challengeView_recvData, _MSG_INSTANCE_MENU, 0, nil);

----------------全局函数区----------------
function challengeView_sendData()    --挑战界面数据
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE_MENU);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(MSG_SEND_MENU_INFO)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show()
    end
end

function challengeView_sendBuyData(num) --挑战购买次数数据
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE_MENU);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(MSG_BUY_INSTANCE_TIME)
        dataStream:writeByte(num)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show()
    end
end

function challengeView_sendBuyByHufuMsg()	--虎符购买
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then            	
        dataStream:writeShort(ARENASCRITP_ADD_PVP_TIMES)
        dataStream:writeByte(0)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    end
end

function challengeView.Window()
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4427);
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
	else
		wnd = challengeView.initControl();
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd);
			local naviCtrl = getCurentSceneNavigationController();
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl);
				wndCtrl:luaSetSelectorOnEvent(showWin);
				wnd:setBackButtonVisibled(false);
                wnd:setCloseButtonVisibled(false);
                wnd:setFrameVisibled(false);
                    --设置关闭窗口按钮
                local pButton31 = SCFunction:getUiNodeByIdlist("4427-2-31");
                if pButton31 then
                    pButton31:luaSetSelectorOnClicked(CloseWin);
                    pButton31:setMusicPath("closeWindow.mp3");
                    pButton31:setTouchRectScale(4.0,4.0)
                end
                
                --[[local pNode = SCFunction:getUiNodeByIdlist("4427-2-40");   --过关斩将
                if pNode then
                    setLock(L("str9168"), pNode);
                end]]
			end
		 end
    end
end

function challengeView.wndClose()
	m_Value = 0;
	Flag = nil;
	Info = {}
	GuidePoint_FreeChData()
end

function refreshChallengeViewHufuTimes(times)
	local pImage7 = SCFunction:getUiNodeByIdlist("4427-2-7")	   --竞技场
	if pImage7 and times then
		pImage7:removeChildByTag(1, true)
		setResTimes(times, pImage7,2)
	end
    local pImage8 = SCFunction:getUiNodeByIdlist("4427-2-8")	   --决斗
    if pImage8 and times then
		pImage8:removeChildByTag(1, true)
		setResTimes(times, pImage8,2)
    end
end

function refreshPvPValueWnd()
	if SCFunction:getUiNodeByIdlist("4427") then		--虎符更新，挑战界面
		refreshView()
	end
end

--函数调用