-----------------------struct--------------------------------------
--打开护戒主界面
local stOpenConvoy = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            byRemainConvoy,                        --//剩余护戒次数
            byRemainHelp,                        --//剩余帮助次数
            byRemainTake,                        --//剩余夺戒次数
            dwCallTime,                        --//甘道夫剩余时间
            szCall,
            dwTakeTime,                        --//拦截cd
            dwRemainTime,                        --//护送cd
            szInfo                        --//当前情况
        }
        tmp.byRemainConvoy = dt:readByte()
        tmp.byRemainHelp = dt:readByte()
        tmp.byRemainTake = dt:readByte()
        tmp.dwCallTime = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szCall = ""
        else
            tmp.szCall = scStr:getData()
        end
        tmp.dwTakeTime = dt:readInt()
        tmp.dwRemainTime = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szInfo = ""
        else
            tmp.szInfo = scStr:getData()
        end
        return tmp
    end
}

local stRingConvoy = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            idUser,                        --//玩家id
            szUserName,            --//玩家名字
            usLev,                        --//玩家等级
            ucType,                        --//使者类型
            szConvoy,            --//使者名字
            dwEscortTime,                    --//护送总时间
            dwRemaintime,                    --//护送剩余时间
            nMoney,                        --//拦截金钱
            usReputation,                    --//拦截声望
            byTakeTimes,                    --//被拦截次数
            byTotalTimes,                    --//可拦截次数
        }
        tmp.idUser = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szUserName = ""
        else
            tmp.szUserName = scStr:getData()
        end
        tmp.usLev = dt:readShort()
        tmp.ucType = dt:readByte()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szConvoy = ""
        else
            tmp.szConvoy = scStr:getData()
        end
        tmp.dwEscortTime = dt:readInt()
        tmp.dwRemaintime = dt:readInt()
        tmp.nMoney = dt:readInt()
        tmp.usReputation = dt:readShort()
        tmp.byTakeTimes = dt:readByte()
        tmp.byTotalTimes = dt:readByte()
        
        return tmp
    end
}

local stChoiceConvoy = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            szState,                    --//当前护戒使者        
            byType,                        --//哪个使者
            szInfo,            --//当前情况
        }
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szState = ""
        else
            tmp.szState = scStr:getData()
        end
        tmp.byType = dt:readByte()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szInfo = ""
        else
            tmp.szInfo = scStr:getData()
        end
        
        return tmp
    end
}

local stFriend = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            idUser,
            szName,
            usLev,
            byRemainTimes,        --//剩余次数
        }
        tmp.idUser = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.usLev = dt:readShort()
        tmp.byRemainTimes = dt:readByte()
		tmp.dwRank = dt:readInt()
        return tmp
    end
}

local stFriendHelp = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            byType,    --0为邀请等待，1为邀请成功,2为邀请状态
            szName,
            usRemainTime,
        }
        tmp.byType = dt:readByte()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.usRemainTime = dt:readShort()

        return tmp
    end
}
-------------------------struct end--------------------------------

------------------------user data start---------------------------------
local selfId = nil;
local m_lanJieId = nil;
local openConvoyWnd = nil;
local m_openConvoy = {__mode = "kv"}
local m_interceptInfos = {__mode = "kv"}
local uScheduleScriptEntryID = nil
local m_frendList = {__mode = "kv"}
local m_frendNode = nil
local selectFrendId = nil
local m_frendHelpTimeLabel = nil
local m_entryId = nil
local m_frendHelpTime = 0
local m_showTrashFlag = true
local m_fitLevelFlag = false
local m_countList = nil
------------------------user data end------------------------------
-------------------------single function-------------------------
local function sendCloseWindowMsg()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_CLOSE_CONVOY);
    SCDataTransThread:getSingleton():transData(dataStream);
end
local function onTimer(time)
    local wnd = openConvoyWnd;
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("11", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorDeepBlue());
        if m_openConvoy.dwTakeTime == 0 then
            label:setVisible(false)
        else
            label:setVisible(true)
            m_openConvoy.dwTakeTime = m_openConvoy.dwTakeTime - 1;
            label:setText(_LTParser("str5065").." "..makeTime(m_openConvoy.dwTakeTime));
        end
    end
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("12", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorDeepBlue());
        if m_openConvoy.dwRemainTime == 0 then
            label:setVisible(false)
        else
            label:setVisible(true)
            m_openConvoy.dwRemainTime = m_openConvoy.dwRemainTime - 1;
            label:setText(_LTParser("str5066").." "..makeTime(m_openConvoy.dwRemainTime));
        end
    end
    
    local img = wnd:getChildByTag(13)
    if img then
        local label = tolua.cast(img:getChildByTag(2), "SCLabel")
        if label then
            if m_openConvoy.dwCallTime == 0 then
                img:setVisible(false)
            else
                img:setVisible(true)
                m_openConvoy.dwCallTime = m_openConvoy.dwCallTime - 1
                label:setText(_LTParser("str5061")..": "..makeTime(m_openConvoy.dwCallTime))
            end
        end
    end
    
    --[[
    for i=1, #m_interceptInfos do
        if m_interceptInfos[i].dwRemaintime<=m_interceptInfos[i].dwEscortTime then
            local btn = SCTypeCast:castNodeToButton(openConvoyWnd:getChildByTag(m_interceptInfos[i]["idUser"]));
            m_interceptInfos[i].dwRemaintime = m_interceptInfos[i].dwRemaintime - 1;
            local dwRemaintime = m_interceptInfos[i].dwRemaintime;
            local dwEscortTime = m_interceptInfos[i].dwEscortTime;
            local positionX = (1-m_interceptInfos[i].dwRemaintime/m_interceptInfos[i].dwEscortTime)*480;
            btn:setPosition(CCPointMake(positionX,100));
        end
    end
    ]]
end

local function closeWnd(tag)
    local naviCtrl =  getCurentSceneNavigationController()
    if naviCtrl:getWindowControllerByTag(5702) ~= nil then
        naviCtrl:removeWindowControllerByTag(5702);
    end
end

local function ringWndClose()
    if uScheduleScriptEntryID then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(uScheduleScriptEntryID);
        uScheduleScriptEntryID = nil;
    end
    
    selfId = nil
    m_lanJieId = nil
    
    m_openConvoy = {__mode = "kv"}
    m_interceptInfos = {__mode = "kv"}
    
    m_showTrashFlag = true
    m_fitLevelFlag = false
    
    m_countList = nil
    
    sendCloseWindowMsg();
end

local function convoyWndClose()
    m_frendList = {__mode = "kv"}
    
    m_frendNode = nil
    selectFrendId = nil
    m_frendHelpTimeLabel = nil
    m_entryId = nil
    m_frendHelpTime = 0
    
    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryID);
    m_entryID = nil;
end

local function sendCalloutGandalf(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_CALLOUT_GANDALF);
    dataStream:writeByte(0);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function openStartRingWndMsg(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_CONVOYRING_INFO);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function showOrHideTrash(tag)
    if openConvoyWnd == nil then
        return
    end
    for i=1, #m_interceptInfos do
        if m_interceptInfos[i].ucType == 1 then
            local btn = openConvoyWnd:getChildByTag(m_interceptInfos[i].idUser)
            if btn then
                if m_showTrashFlag == true then
                    btn:setVisible(false)
                else
                    btn:setVisible(true)
                end
            end
        end
    end
    m_showTrashFlag = not m_showTrashFlag
end

local function fitLevel(tag)
    if openConvoyWnd == nil then
        return
    end
    
    local heroLev = Hero:getSingleton():getLeval()
    for i=1, #m_interceptInfos do
        local levSub = heroLev - m_interceptInfos[i].usLev
        if levSub < -3 or levSub > 10 then
            local btn = openConvoyWnd:getChildByTag(m_interceptInfos[i].idUser)
            if btn then
                if m_fitLevelFlag == false then
                    btn:setVisible(false)
                else
                    btn:setVisible(true)
                end
            end
        end
    end
    m_fitLevelFlag = not m_fitLevelFlag
end

local function sendCalloutHobbitMsg(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_CALLOUT_HOBBIT);
    dataStream:writeByte(0);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function sendRefreshEnvoyMsg(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_REFRESHCONVOY);
    dataStream:writeByte(0);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function sendInspireMsg(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_ENCOURAGE);
    dataStream:writeByte(0);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function sendStartRingMsg(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_START_RING);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function sendLanJieMsg(id)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_RING_BATTLE);
    dataStream:writeInt(id);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function onClickLanJie(tag)
    if tag == 0 then
        sendLanJieMsg(m_lanJieId)
    end
end

local function showLanJieTip(id)
    for i=1, #m_interceptInfos do
        if m_interceptInfos[i].idUser == id then
            m_lanJieId = id
            local text = "*6"..m_interceptInfos[i].szUserName.."_".._LTParser("str0003")..m_interceptInfos[i].usLev.."_"
            text = text.."*0".._LTParser("str5041")..": "..m_interceptInfos[i].szConvoy.."_"
            text = text.."*0".._LTParser("str5042")..": "..m_interceptInfos[i].byTakeTimes.."/"..m_interceptInfos[i].byTotalTimes.."_"
            text = text.."*3".._LTParser("str5043")..": "..m_interceptInfos[i].usReputation.._LTParser("str0193").." "..m_interceptInfos[i].nMoney.._LTParser("str0139").."_"
            text = text.."*9".._LTParser("str5044").."_"
            local btnName = _LTParser("str5045").."_".._LTParser("str0237")
            luaShowTip(text, btnName, 2, onClickLanJie)
        end
    end
end

local function selectPlayer(tag)
    showLanJieTip(m_countList[tag+1].id)
end

local function onClickPlayer(tag)
    local hitPlayer = openConvoyWnd:getChildByTag(tag)
    if not hitPlayer then
        return
    end
    m_countList = {__mode = "kv"}
    local ps = hitPlayer:getPosition()
    for i=1, #m_interceptInfos do
        if m_interceptInfos[i].idUser~=selfId then
            local player = openConvoyWnd:getChildByTag(m_interceptInfos[i].idUser)
            if player and player:isVisible() then
                local tps = player:getPosition()
                if (tps.x-ps.x>=-30 and tps.x-ps.x<=30) and (tps.y-ps.y>=-30 and tps.y-ps.y<=30) then
                    local tP = {id=m_interceptInfos[i].idUser, name=m_interceptInfos[i].szUserName, lev=m_interceptInfos[i].usLev}
                    table.insert(m_countList, tP)
                end
            end
        end
    end
    if #m_countList == 0 then
        return
    end
    if #m_countList == 1 then
        showLanJieTip(tag)
        return
    end
    
    local text = ""
    for i=1, #m_countList do
        text = text..m_countList[i].name.." "..m_countList[i].lev.._LTParser("str5016").."_"
    end
    local strList = menuList:newStringList()
    strList:createMenu(_LTParser("str5082"), 1, text)
    strList:luasetSelector(selectPlayer)
end

local function onClickChooseFrend(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_FRIENDLIST);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function onClickPleaseFrend(tag)
    if selectFrendId == nil or selectFrendId == 0 then
        return
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_FRIEND_HELP);
    dataStream:writeByte(0);
    dataStream:writeInt(selectFrendId);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function onClickPleaseFrendCancel(tag)
    if selectFrendId == nil or selectFrendId == 0 then
        return
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_FRIEND_HELP);
    dataStream:writeByte(2);
    dataStream:writeInt(selectFrendId);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function onSelectItem(tag, itemTag, index)
    local scene = SCBaseScene:getRunningScene()
    local naviCtrl =  scene:getNavigationController()
    local wndCtrl = naviCtrl:getWindowControllerByTag(5701)
    if wndCtrl == nil then
        return
    end
    local wnd = wndCtrl:getWindow()
    local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("7", tolua.cast(wnd, "SCNode")))
    if btn then
        selectFrendId = itemTag
        if selectFrendId == 0 then
            btn:setTitle(_LTParser("str5050"), getDefaultFontName(), getFontSize(15), colorBlack())
        else
            for i=1, #m_frendList do
                if m_frendList[i].idUser == selectFrendId then
                    btn:setTitle(m_frendList[i].szName, getDefaultFontName(), getFontSize(12), colorWhite())
                    break
                end
            end
            
        end
        m_frendNode:removeFromParentAndCleanup(true)
    end
end

local function countFrendTime(time)
    if m_frendHelpTime == 0 then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryID)
        return
    end
    if m_frendHelpTimeLabel == nil then
        return
    end
    m_frendHelpTime = m_frendHelpTime - 1
    m_frendHelpTimeLabel:setText(string.format(_LTParser("str5052"), m_frendHelpTime))
end

local function sendSpeenUp(type)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_SPEEDUP_CONVOY);
    dataStream:writeByte(0);
    dataStream:writeInt(type);
    SCDataTransThread:getSingleton():transData(dataStream);
end

local function onClickSpeenUp(tag)
    local type = 0
    if tag == 121 then
        type = 1
    end
    sendSpeenUp(type)        
end
-------------------------single function end---------------------
------------------------normal function----------------------------
local function refreshInterceptInfo(wndCtrl, interceptInfo)
    --get the window pointer
    local wnd = wndCtrl:getWindow()
    if wnd == nil then
        return false
    end
    
    for i=1, table.getn(interceptInfo) do
        local btn = tolua.cast(wnd:getChildByTag(interceptInfo[i].idUser), "SCButton")
        if btn == nil then
            local tmpNum = interceptInfo[i].ucType
            if tmpNum == 6 then
                tmpNum = 5
            end
            if interceptInfo[i].idUser == selfId then
                tmpNum = tmpNum + 6
            end
            local filePath = getRealUIResourcePath("img/img"..(5088+tmpNum)..".png")
            btn = SCButton:button()
            btn:luaSetSelectorOnClicked(onClickPlayer)
            btn:setTitle(filePath:getData())
            btn:setTag(interceptInfo[i].idUser)
            local actionNode = ActionNode:newActionNode()
            actionNode:setTag(interceptInfo[i].idUser)
            setNodeContentSize(actionNode, CCSizeMake(getNodeContentSize(btn)))
            actionNode:addChild(btn)
            local dwRemaintime = interceptInfo[i].dwRemaintime;
            local dwEscortTime = interceptInfo[i].dwEscortTime;
            local positionX = (1-interceptInfo[i].dwRemaintime/interceptInfo[i].dwEscortTime)*480;
            actionNode:setPosition(CCPointMake(positionX, ((i-1)%3+1)*50))--100
            wnd:addChild(actionNode)
            actionNode:moveTo(CCPointMake(480-btn:getContentSize().width, ((i-1)%3+1)*50), interceptInfo[i].dwRemaintime, false)
        end
    end
end

local function showGanDaoFu()
    if openConvoyWnd == nil then
        return
    end
    local imgNode = SCTypeCast:castNodeToImage(openConvoyWnd:getChildByTag(13));
    if not imgNode then
        local file = getRealUIResourcePath("img/img5094.png")
        if not file then
            return
        end
        imgNode = SCImage:imageWithFile(file:getData())
        imgNode:setTag(13)
        imgNode:setPosition(CCPointMake(SX(176), SY(202)))
        local parNode = getItemTextNode(m_openConvoy.szCall, 0, 12)
        parNode:setPosition(CCPointMake(SX(5), 0))
        parNode:setTag(1)
        imgNode:addChild(parNode)
        local label = SCLabel:labelWithStringFont(_LTParser("str5061")..": "..makeTime(m_openConvoy.dwCallTime), getDefaultFontName(), getFontSize(12))
        label:setColor(colorBlack())
        label:setTag(2)
        label:setAnchorPoint(CCPointMake(0.5, 0.5))
        label:setPosition(CCPointMake(imgNode:getContentSize().width/2, SY(97)))
        imgNode:addChild(label)
        openConvoyWnd:addChild(imgNode)
    else
		imgNode:removeChildByTag(1, true)
		local parNode = getItemTextNode(m_openConvoy.szCall, 0, 12)
        parNode:setPosition(CCPointMake(SX(5), 0))
        parNode:setTag(1)
        imgNode:addChild(parNode)
        local label = tolua.cast(imgNode:getChildByTag(2), "SCLabel")
        if label then
            label:setText(_LTParser("str5061")..": "..makeTime(m_openConvoy.dwCallTime))
        end
    end
end

local function refreshConvoyInfo(wndCtrl, openConvoy)
    --get the window pointer
    local wnd = wndCtrl:getWindow();
    if wnd == nil then
        return
    end
    
    local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    if button then
        if openConvoy.dwRemainTime ~= 0 or openConvoy.byRemainConvoy == 0 then
            button:setVisible(false)
        else
            button:setVisible(true)
        end
    end
    
    local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
    if button then
        if not luaIsUnlock(UNLOCK_TYPE_EXTRA20) or openConvoy.dwCallTime ~= 0 then
            button:setVisible(false)
        end
        button:luaSetSelectorOnClicked(sendCalloutGandalf);
    end
    
    if openConvoy.dwCallTime ~= 0 then
        showGanDaoFu()
    end
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("8", tolua.cast(wnd, "SCNode")));
    if label then
        label:setText(string.format(_LTParser("str5062"), openConvoy.byRemainTake));
    end
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9", tolua.cast(wnd, "SCNode")));
    if label then
        label:setText(string.format(_LTParser("str5063"), openConvoy.byRemainConvoy));
    end
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("10", tolua.cast(wnd, "SCNode")));
    if label then
        label:setText(string.format(_LTParser("str5064"), openConvoy.byRemainHelp));
    end
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("11", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorDeepBlue());
        if openConvoy.dwTakeTime == 0 then
            label:setVisible(false)
        else
            label:setVisible(true)
            label:setText(_LTParser("str5065").." "..makeTime(openConvoy.dwTakeTime));
        end
    end
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("12", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorDeepBlue());
        if openConvoy.dwRemainTime == 0 then
            label:setVisible(false)
        else
            label:setVisible(true)
            label:setText(_LTParser("str5066").." "..makeTime(openConvoy.dwRemainTime));
        end
    end
end

local function ctrlEvent5702(tag, eventType)
	if eventType == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_BUDDHIST_SCRIPTURES, true)
		showGuideStep(GUIDE_TYPE_BUDDHIST_SCRIPTURES, 4, 4)
	elseif eventType == LuaControllerEventPopBegan or eventType == LuaControllerEventRemoveBegan then
		if getRestartGuideFlag(GUIDE_TYPE_BUDDHIST_SCRIPTURES) then
			restartBeginnerGuide(GUIDE_TYPE_BUDDHIST_SCRIPTURES)
		else
			showGuideStep(GUIDE_TYPE_BUDDHIST_SCRIPTURES, -1)
		end
	end
end

local function createMainWnd(openConvoy)
    --get the UI file
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5702));
    openConvoyWnd = wnd;
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    if wndCtrl == nil then
        return nil;
    end
    wndCtrl:luaSetSelectorOnEvent(ctrlEvent5702)
    wnd:setFrameVisibled(false)
    wnd:luaSetSelectorOnClose(ringWndClose)
 
    local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("7", tolua.cast(wnd, "SCNode")));
    if button then    
        button:luaSetSelectorOnClicked(closeWnd);
    end
    
    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    if button then
        button:luaSetSelectorOnClicked(openStartRingWndMsg);
        if openConvoy.dwRemainTime ~= 0 or openConvoy.byRemainConvoy == 0 then
            button:setVisible(false)
        end
    end
    
    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(wnd, "SCNode")));
    if button then
        if not luaIsUnlock(UNLOCK_TYPE_EXTRA20) or openConvoy.dwCallTime ~= 0 then
            button:setVisible(false)
        end
        button:luaSetSelectorOnClicked(sendCalloutGandalf);
    end
    
    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("6", tolua.cast(wnd, "SCNode")));
    if button then
         button:luaSetSelectorOnClicked(showOrHideTrash);
    end
    
    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5", tolua.cast(wnd, "SCNode")));
    if button then
        button:luaSetSelectorOnClicked(fitLevel);
    end
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("8", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorDeepBlue());
        label:setText(string.format(_LTParser("str5062"), openConvoy.byRemainTake));
    end
    
    label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorDeepBlue());
        label:setText(string.format(_LTParser("str5063"), openConvoy.byRemainConvoy));
    end
    
    label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("10", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorDeepBlue());
        label:setText(string.format(_LTParser("str5064"), openConvoy.byRemainHelp));
    end
    
    label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("11", tolua.cast(wnd, "SCNode")));
    if label then
        wnd:reorderChild(label, 100000)
        local btn = tolua.cast(label:getChildByTag(111), "SCButton")
        if btn then
            btn:luaSetSelectorOnClicked(onClickSpeenUp)
            if not luaIsUnlock(UNLOCK_TYPE_EXTRA17) then
                btn:setVisible(false)
            else
                btn:setVisible(true)
            end
        end
        label:setColor(colorDeepBlue());
        if openConvoy.dwTakeTime == 0 then
            label:setVisible(false)
        else
            label:setVisible(true)
            label:setText(_LTParser("str5065").." "..makeTime(openConvoy.dwTakeTime));
        end
    end
    
    label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("12", tolua.cast(wnd, "SCNode")));
    if label then
        wnd:reorderChild(label, 100000)
        local btn = tolua.cast(label:getChildByTag(121), "SCButton")
        if btn then
            btn:luaSetSelectorOnClicked(onClickSpeenUp)
            if not luaIsUnlock(UNLOCK_TYPE_EXTRA17) then
                btn:setVisible(false)
            else
                btn:setVisible(true)
            end
        end
        label:setColor(colorDeepBlue());
        if openConvoy.dwRemainTime == 0 then
            label:setVisible(false)
        else
            label:setVisible(true)
            label:setText(_LTParser("str5066").." "..makeTime(openConvoy.dwRemainTime));
        end
    end
    
    return wndCtrl;
end

local function openMainRingWnd(info, flag)    
    --if the node on scene only refresh info
    --else create window and show
    local scene = SCBaseScene:getRunningScene()
    local naviCtrl =  scene:getNavigationController()
    local wndCtrl = naviCtrl:getWindowControllerByTag(5702)
    if wndCtrl ~= nil then
        if flag == 1 then
            refreshConvoyInfo(wndCtrl, info)
        elseif flag == 2 then
            refreshInterceptInfo(wndCtrl, info)
        end
        return
    end
    
    wndCtrl = createMainWnd(info)
    if wndCtrl ~= nil then
        if info.dwCallTime ~= 0 then
            showGanDaoFu()
        end
        uScheduleScriptEntryID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(onTimer, 1.0, false)
    end
    naviCtrl:pushWindowController(wndCtrl)
    local wnd = wndCtrl:getWindow()
    if wnd then
        wnd:setCloseButtonVisibled(false)
    end
end

local function ctrlEvent5701(tag, eventType)
	if eventType == LuaControllerEventPushEnded then
		setRestartGuideFlag(GUIDE_TYPE_BUDDHIST_SCRIPTURES, false)
		showGuideStep(GUIDE_TYPE_BUDDHIST_SCRIPTURES, 5, 5)
	elseif eventType == LuaControllerEventPopBegan or eventType == LuaControllerEventRemoveBegan then
		if getRestartGuideFlag(GUIDE_TYPE_BUDDHIST_SCRIPTURES) then
			restartBeginnerGuide(GUIDE_TYPE_BUDDHIST_SCRIPTURES)
		else
			showGuideStep(GUIDE_TYPE_BUDDHIST_SCRIPTURES, -1)
		end
	end
end

local function createChoiceWnd(ChoiceConvoy)
    --get the UI file
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5701));
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    if wndCtrl == nil then
        return
    end
    wndCtrl:luaSetSelectorOnEvent(ctrlEvent5701)
    --set BackgroundColor
    wnd:setBackgroundColor(colorWindowRedBG())
    --wnd:setTitle(_LTParser("str5054"), getDefaultFontName(), gDefaultFontSize)
    local imgPath = getRealUIResourcePath("img/titile39.png")
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(convoyWndClose)

    --set Childrens
    for i=1, 4 do
        local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent(i.."", tolua.cast(wnd, "SCNode")));
        if dragNode then
            dragNode:setFrameVisibled(true);
            dragNode:setFrameType(EnumFrameTypeRound);
        end
    end
    
    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("6", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorLightYellow());
    end
    
    label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("11", tolua.cast(wnd, "SCNode")));
    if label then
        label:setColor(colorLightYellow());
    end
    
    local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5", tolua.cast(wnd, "SCNode")));
    if button then
        button:luaSetSelectorOnClicked(sendStartRingMsg);
    end
    
    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("9", tolua.cast(wnd, "SCNode")));
    if button then
        button:luaSetSelectorOnClicked(sendInspireMsg);
        if not luaIsUnlock(UNLOCK_TYPE_EXTRA19) then
            button:setVisible(false)
        else
            button:setVisible(true)
        end
    end
    
    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("10", tolua.cast(wnd, "SCNode")));
    if button then
        button:luaSetSelectorOnClicked(sendRefreshEnvoyMsg);
    end
    
    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("17", tolua.cast(wnd, "SCNode")));
    if button then
        if not luaIsUnlock(UNLOCK_TYPE_EXTRA18) then
            button:setVisible(false)
        else
            button:setVisible(true)
        end
        button:luaSetSelectorOnClicked(sendCalloutHobbitMsg);
    end
    
    local parNode = getItemTextNode(string.format(_LTParser("str5049"), ChoiceConvoy["szState"]:getData()), 0, 15)
    parNode:setTag(18)
    parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
    parNode:setPosition(CCPointMake(wnd:getContentSize().width/2, SY(252)))
    wnd:addChild(parNode)
    
    local parNode = getItemTextNode(ChoiceConvoy["szInfo"]:getData(), 0, 12)
    parNode:setTag(19)
    parNode:setAnchorPoint(CCPointMake(0, 1))
    parNode:setPosition(CCPointMake(SX(150), SY(123)))
    wnd:addChild(parNode)
    
    local tmpNum = ChoiceConvoy["byType"];
    if ChoiceConvoy["byType"] == 6 then
        tmpNum = tmpNum-1;
    end
	if ChoiceConvoy["byType"] == 5 or ChoiceConvoy["byType"] == 6 then
		local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("17", tolua.cast(wnd, "SCNode")));
        if button then
            button:setVisible(false);
        end
	end

    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1"..(tmpNum+1), tolua.cast(wnd, "SCNode")));
    if button then
        local file = getRealUIResourcePath("img/img"..5083+tmpNum..".png")
        if file then
            button:setTitle(file:getData())
        end
    end

    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("7", tolua.cast(wnd, "SCNode")));
    if button then
        button:luaSetSelectorOnClicked(onClickChooseFrend)
    end
    button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("8", tolua.cast(wnd, "SCNode")));
    if button then
        button:luaSetSelectorOnClicked(onClickPleaseFrend)
    end
    return wndCtrl;
end

local function refreshChoiceConvoyInfo(wndCtrl, ChoiceConvoy)
    local wnd = wndCtrl:getWindow();
    
    wnd:removeChildByTag(18, true)
    local parNode = getItemTextNode(string.format(_LTParser("str5049"), ChoiceConvoy["szState"]:getData()), 0, 15)
    parNode:setTag(18)
    parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
    parNode:setPosition(CCPointMake(wnd:getContentSize().width/2, SY(252)))
    wnd:addChild(parNode)
    
	wnd:removeChildByTag(19, true)
    local parNode = getItemTextNode(ChoiceConvoy["szInfo"]:getData(), 0, 12)
    parNode:setTag(19)
    parNode:setAnchorPoint(CCPointMake(0, 1))
    parNode:setPosition(CCPointMake(SX(150), SY(123)))
    wnd:addChild(parNode)
    
    for i=12, 16 do
        local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(i.."", tolua.cast(wnd, "SCNode")));
        if button then
            local file = getRealUIResourcePath("img/img"..(5104+i-11)..".png")
            if file then
                button:setTitle(file:getData())
            end
        end
    end
    
    local tmpNum = ChoiceConvoy["byType"];
    if ChoiceConvoy["byType"] == 6 then
        tmpNum = tmpNum-1;
    end
	if ChoiceConvoy["byType"] == 5 or ChoiceConvoy["byType"] == 6 then
		local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("17", tolua.cast(wnd, "SCNode")));
        if button then
            button:setVisible(false);
        end
	end
    local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("1"..(tmpNum+1), tolua.cast(wnd, "SCNode")));
    if button then
        local file = getRealUIResourcePath("img/img"..(5083+tmpNum)..".png")
        if file then
            button:setTitle(file:getData())
        end
    end
end

local function openStartRingWnd(ChoiceConvoy)
    --get running scene
    local scene = SCBaseScene:getRunningScene();
    local naviCtrl =  scene:getNavigationController();
    local wndCtrl = naviCtrl:getWindowControllerByTag(5701);
    if wndCtrl ~= nil then
        refreshChoiceConvoyInfo(wndCtrl, ChoiceConvoy);
        return;
    end
    
    wndCtrl = createChoiceWnd(ChoiceConvoy);
    naviCtrl:pushWindowController(wndCtrl);
end

local function refreshEncourageData(encourage)
    local scene = SCBaseScene:getRunningScene();
    local naviCtrl =  scene:getNavigationController();
    local wndCtrl = naviCtrl:getWindowControllerByTag(5701);
    if wndCtrl == nil then
        return;
    end
    local wnd = wndCtrl:getWindow();
    
    wnd:removeChildByTag(20, true)
    local parNode = getItemTextNode(encourage.."", 0, 12)
    parNode:setTag(20)
    parNode:setAnchorPoint(CCPointMake(0, 1))
    parNode:setPosition(CCPointMake(SX(150), SY(95)))
    wnd:addChild(parNode)
end

local function showFrendList(frendList)
    local wnd = getCurentSceneWindow(5701)
    if not wnd then
        return
    end
    if wnd:getChildByTag(6002) then
        wnd:removeChildByTag(6002, true)
        return
    end
    m_frendNode = FrameWindow:frameWnd()
    m_frendNode:setTag(6002)
    m_frendNode:setOutSpaceClickClose(true)
    --m_frendNode:setDragEnabled(false)
    --m_frendNode:setFrameType(EnumFrameTypeLine)
    --m_frendNode:setFrameVisibled(true)
    m_frendNode:setAnchorPoint(CCPointMake(0.5, 0.5))
    m_frendNode:setPosition(CCPointMake(wnd:getContentSize().width/2, wnd:getContentSize().height/2))
    m_frendNode:setContentSize(CCSizeMake(SX(150), SY(250)))
    local dragNode = SCDragNode:node()
    dragNode:setDragEnabled(false)
    --dragNode:setFrameType(EnumFrameTypeListNormal)
    --dragNode:setFrameVisibled(true)
    local parserNode = getItemTextNode(_LTParser("str5050"))
    parserNode:setAnchorPoint(CCPointMake(0.5, 0.5))
    parserNode:setPosition(CCPointMake(m_frendNode:getContentSize().width/2, m_frendNode:getContentSize().height-SY(20)))
    dragNode:setContentSize(CCSizeMake(m_frendNode:getContentSize().width, parserNode:getContentSize().height+SY(10)))
    dragNode:addChild(parserNode)
    m_frendNode:addChild(dragNode)
    local listBox = SCListBox:boxWithWidthHeight(SX(130), SY(200))
    listBox:setTag(1)
    --listBox:setBackgroundColor(colorBlack())
    --listBox:setAnchorPoint(CCPointMake(0.5, 0.5))
    listBox:setPosition(CCPointMake(SX(10), SY(10)))
    listBox:luaSetSelectorOnItemSelected(onSelectItem)
    m_frendNode:addChild(listBox)
    wnd:addChild(m_frendNode)

    local pListBox = tolua.cast(m_frendNode:getChildByTag(1), "SCListBox")
    if pListBox then
        pListBox:removeAllItems()
        for i=1, #m_frendList do
            local dragNode = SCDragNode:node()
            dragNode:setDragEnabled(false)
            dragNode:setFrameType(EnumFrameTypeListNormal)
            dragNode:setFrameVisibled(true)
            local text = string.format(_LTParser("str5046"), m_frendList[i].szName, m_frendList[i].byRemainTimes)
            local parserNode = getItemTextNode(text)
            parserNode:setPosition(0, SY(5))
            dragNode:setContentSize(CCSizeMake(pListBox:getContentSize().width, parserNode:getContentSize().height+SY(10)))
            dragNode:addChild(parserNode)
            pListBox:addItem(dragNode)
            dragNode:setTag(m_frendList[i].idUser)
        end
    end
end

local function refreshFrendHelpNode(friendHelp)
    local wndCtrl = getCurentSceneWindowController(5701)
    if wndCtrl == nil then
        return
    end
    local wnd = wndCtrl:getWindow()
    local dragNode = tolua.cast(wnd:getChildByTag(2), "SCDragNode")
    local pBtn1 = tolua.cast(wnd:getChildByTag(7), "SCButton")
    local pBtn2 = tolua.cast(wnd:getChildByTag(8), "SCButton")
    local pLabel1 = tolua.cast(dragNode:getChildByTag(1), "SCLabel")
    --local pLabel2 = tolua.cast(pBtn1:getChildByTag(2), "SCLabel")
    if pLabel1==nil then
        pLabel1 = SCLabel:labelWithStringFont(" ", getDefaultFontName(), getFontSize(12))
        pLabel1:setTag(1)
        pLabel1:setColor(colorRed())
        pLabel1:setAnchorPoint(CCPointMake(0.5, 0.5))
        pLabel1:setPosition(CCPointMake(dragNode:getContentSize().width/2, 40))
        dragNode:addChild(pLabel1)
    end
    --if pLabel2==nil then
    --    pLabel1 = labelWithStringFont(" ", getDefaultFontName(), getFontSize(12))
    --end
    if m_frendHelpTimeLabel == nil then
        m_frendHelpTimeLabel = SCLabel:labelWithStringFont(" ", getDefaultFontName(), getFontSize(12))
        m_frendHelpTimeLabel:setAnchorPoint(CCPointMake(0.5, 0.5))
        m_frendHelpTimeLabel:setPosition(CCPointMake(dragNode:getContentSize().width/2, 15))
        dragNode:addChild(m_frendHelpTimeLabel)
    end
    
    if friendHelp.byType == 0 then
        pLabel1:setVisible(true)
        m_frendHelpTimeLabel:setVisible(false)
        pBtn1:setVisible(false)
        pBtn2:setVisible(true)
        pLabel1:setText(string.format(_LTParser("str5053"), friendHelp.szName))
        pBtn2:setTitle(_LTParser("str0117"), getDefaultFontName(), getFontSize(15))
        pBtn2:luaSetSelectorOnClicked(onClickPleaseFrendCancel)
    elseif friendHelp.byType == 1 then
        pLabel1:setVisible(true)
        m_frendHelpTimeLabel:setVisible(true)
        pBtn1:setVisible(false)
        pBtn2:setVisible(false)
        pLabel1:setText(string.format(_LTParser("str5051"), friendHelp.szName))
        m_frendHelpTime = friendHelp.usRemainTime
        m_frendHelpTimeLabel:setColor(colorLightYellow())
        m_frendHelpTimeLabel:setText(string.format(_LTParser("str5052"), m_frendHelpTime))
        m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(countFrendTime, 1.0, false)
    else
        pLabel1:setVisible(false)
        m_frendHelpTimeLabel:setVisible(false)
        pBtn1:setVisible(true)
        pBtn2:setVisible(true)
        pLabel1:setText(string.format(_LTParser("str5053"), friendHelp.szName))
        pBtn2:setTitle(_LTParser("str0287"), getDefaultFontName(), getFontSize(15))
        pBtn2:luaSetSelectorOnClicked(onClickPleaseFrend)
    end
end
------------------------normal function end----------------------

------------------------msg data process--------------------------
local function recvOpenData()
    local dt = LuaData:getSingleton():getDataTransStream()
    if dt == nil then
        return
    end
    m_openConvoy = stOpenConvoy.initWithStream(dt)
    
    --open main window
    openMainRingWnd(m_openConvoy, 1);
end

local function recvInterceptData()
    local dt = LuaData:getSingleton():getDataTransStream()
    selfId = dt:readInt()
    local num = dt:readShort()
    for j=1, num do
        tmpInterceptInfo = stRingConvoy.initWithStream(dt)
        local count = 0
        for i=1, #m_interceptInfos do
            if tmpInterceptInfo.idUser == m_interceptInfos[i].idUser then
                table.remove(m_interceptInfos, i)
                table.insert(m_interceptInfos, i, tmpInterceptInfo)
                break;
            end
            count = count + 1
        end
        if count == #m_interceptInfos then
            table.insert(m_interceptInfos, tmpInterceptInfo)
        end
    end
    
    --open main window
    openMainRingWnd(m_interceptInfos, 2);
end

local function delInterceptInfo()
    local dataStream = LuaData:getSingleton():getDataTransStream();
    if dataStream ~= nil then
        delId = dataStream:readInt();
        for i=1, #m_interceptInfos do
            if m_interceptInfos[i].idUser == delId then
                table.remove(m_interceptInfos, i)
                openConvoyWnd:removeChildByTag(delId, true);
                if delId == selfId then
                    local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(openConvoyWnd, "SCNode")));
                    if button then
                        if m_openConvoy.byRemainConvoy ~= 0 then
                            button:setVisible(true)
                        end
                    end
                    local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("12", tolua.cast(openConvoyWnd, "SCNode")));
                    if label then
                        if m_openConvoy.dwRemainTime ~= 0 then
                            label:setVisible(false)
                        end
                    end
                end
                break
            end
        end
    end
end

local function updateInterceptInfo(tag)
    local dataStream = LuaData:getSingleton():getDataTransStream();
    if dataStream ~= nil then
        updateId = dataStream:readInt();
        for i=1, #m_interceptInfos do
            if m_interceptInfos[i].idUser == updateId then
                m_interceptInfos[i].byTakeTimes = dataStream:readByte();
            end
        end
    end
end

local function recvConvoyRingData()
    local dataStream = LuaData:getSingleton():getDataTransStream();
    local ChoiceConvoy = {};
    if dataStream ~= nil then
        ChoiceConvoy.szState = dataStream:readString();        --当前护戒使者
        ChoiceConvoy.byType = dataStream:readByte();          --哪个使者
        ChoiceConvoy.szInfo = dataStream:readString();         --当前情况
    end
    --open start ring window
    openStartRingWnd(ChoiceConvoy);
end

local function recvEncourageData()
    local dataStream = LuaData:getSingleton():getDataTransStream()
    local Encourage = dataStream:readString():getData();
    refreshEncourageData(_LTParser("str5040")..Encourage);
end

local function recvFriendListData()
    local dataStream = LuaData:getSingleton():getDataTransStream()
    local num = dataStream:readShort()
    for i=1, num do
        local tmpFriend = stFriend.initWithStream(dataStream)
        local count = 0
        for j=1, #m_frendList do
            if tmpFriend.idUser == m_frendList[j].idUser then
                table.remove(m_frendList, j)
                table.insert(m_frendList, j, tmpFriend)
                break
            end
            count = count + 1
        end
        if count == #m_frendList then
            table.insert(m_frendList, tmpFriend)
        end
    end
    
    showFrendList(m_frendList)
end

local function recvFriendHelpData()
    local dt = LuaData:getSingleton():getDataTransStream()
    local friendHelp = stFriendHelp.initWithStream(dt)
    refreshFrendHelpNode(friendHelp)
end

local function recvCloseWnd()
    local naviCtrl = getCurentSceneNavigationController()
    if naviCtrl then
        local wndCtrl = naviCtrl:getWindowControllerByTag(5701)
        if wndCtrl then
            naviCtrl:removeWindowControllerByTag(5701)
        end
    end
end

local function recvData()
end
------------------------msg data process end--------------------------



--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_OPEN_CONVOYRING
LuaData:getSingleton():luaSetSelectorOnRecvData(recvOpenData, LuaData_USERINFO_OPEN_CONVOYRING);

--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_TAKERING_INFO
LuaData:getSingleton():luaSetSelectorOnRecvData(recvInterceptData, LuaData_USERINFO_TAKERING_INFO);

--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_MEMBER_DEL
LuaData:getSingleton():luaSetSelectorOnRecvData(delInterceptInfo, LuaData_USERINFO_MEMBER_DEL);

--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_MEMBER_CHANGE
LuaData:getSingleton():luaSetSelectorOnRecvData(updateInterceptInfo, LuaData_USERINFO_MEMBER_CHANGE);

--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_CONVOYRING_INFO
LuaData:getSingleton():luaSetSelectorOnRecvData(recvConvoyRingData, LuaData_USERINFO_CONVOYRING_INFO);

--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_ENCOURAGE
LuaData:getSingleton():luaSetSelectorOnRecvData(recvEncourageData, LuaData_USERINFO_ENCOURAGE);

--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_FRIENDLIST
LuaData:getSingleton():luaSetSelectorOnRecvData(recvFriendListData, LuaData_USERINFO_FRIENDLIST);

--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_FRIEND_HELP
LuaData:getSingleton():luaSetSelectorOnRecvData(recvFriendHelpData, LuaData_USERINFO_FRIEND_HELP);

--set callBackFunction when recive _MSG_USERINFO, action = USERINFO_START_RING
LuaData:getSingleton():luaSetSelectorOnRecvData(recvCloseWnd, LuaData_USERINFO_START_RING);