----------------------------消息-----------------------------
--[[
10级礼包：3461000507

const unsigned short _MSG_USER_GUID			=_MSG_GENERAL+90;
GUID_OPEN_GIFTBOX = 1,	//10级礼包引导
下发：
typedef struct  
{
	BYTE	ByFlag;		//0为开礼包，1为穿装备
	USHORT usPlace;	
}tMsg_Info1;
--]]
----------------结构定义区------------------------------------
local stSpreeTen = {
	initWithStream = function(dt)
		local tmp = {} 
		if not dt then
			return tmp
		end
		tmp.byFlag = dt:readByte() --0开礼包，1为穿装备
		tmp.usPlace = dt:readShort()
		return tmp
	end
}
----------------常量定义区------------------------------------
local Right_Direction = 1
local Left_Direction = 2
local Top_Direction = 3
local Bottom_Direction = 4

local GUID_OPEN_GIFTBOX = 1 --//10级礼包引导
local GUID_COPY_FAILE = 2	-- //失败引导
local GUID_OPEN_LEVELUP = 3	--//升级引导窗口
local GUID_OPEN_HELP_WINDOW = 4	--//打开对应窗口
local GUID_OPEN_LEARN_SKILL = 5	--//学习技能
----------------变量定义区------------------------------------
local m_spreeGuideSteps = nil
local m_nowStep = nil
local m_entryId = nil
local m_tenGuideInFlag = nil
--m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(countFrendTime, 1.0, false)
--CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryID)
----------------函数声明区-------------------------------------
local createGuideNode
local initSpreeGuideStep
local recvSpreeGuide
local onGuideNodeClicked
local onGuideNodeEnterExit
local onTenSpreeTimer
local clearSpreeData
----------------UI控制器区-------------------------------------
--事件回调
function onGuideNodeClicked(tag)
	m_spreeGuideSteps[m_nowStep].clickFlag = true
	local guideBtn = SCFunction:getUiNodeByIdlist(m_spreeGuideSteps[m_nowStep].strlist)
	if guideBtn and guideBtn:getChildByTag(6004) then
		guideBtn:removeChildByTag(6004, true)
	end
	m_nowStep = m_nowStep + 1
	if m_nowStep>#m_spreeGuideSteps then
		clearSpreeData()
	end
end
function onGuideNodeEnterExit(event)
	if event == kCCNodeOnEnter then
	elseif event == kCCNodeOnExit then
		if not m_spreeGuideSteps[m_nowStep].clickFlag then
			m_nowStep = m_nowStep - 1
			if m_nowStep < 1 then
				m_nowStep = 1
			end
			m_spreeGuideSteps[m_nowStep].clickFlag = false
		end
	end
end
--创建引导节点
function createGuideNode()
	if not m_spreeGuideSteps then
		return
	end
	local guideBtn = SCFunction:getUiNodeByIdlist(m_spreeGuideSteps[m_nowStep].strlist)
	if not guideBtn or guideBtn:getChildByTag(6004) then
		return
	end
	if m_spreeGuideSteps[m_nowStep].needReorderList then
		local reorderNode = SCFunction:getUiNodeByIdlist(m_spreeGuideSteps[m_nowStep].needReorderList)
		if reorderNode then
			local parNode = reorderNode:getParent()
			if parNode then
				parNode:reorderChild(reorderNode, 999)
			end
		end
	end
	local guideNode = GuideNode:newGuideNode(CCRectMake(0, 0, guideBtn:getContentSize().width, guideBtn:getContentSize().height), 1010, m_spreeGuideSteps[m_nowStep].dir)
	if not guideNode then
		return
	end
	--guideNode:setBackgroundColor(color_red)
	guideNode:setTag(6004)
	guideNode:luaSetSelectorOnClicked(onGuideNodeClicked)
	guideNode:registerScriptHandler(onGuideNodeEnterExit)
	guideBtn:addChild(guideNode)
end

----------------逻辑功能区-------------------------------------
--清除数据
function clearSpreeData()
	m_tenGuideInFlag = nil
	m_spreeGuideSteps = nil
	m_nowStep = nil
	if m_entryId then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryID)
		m_entryId = nil
	end
end
--定时器
function onTenSpreeTimer(float)
	createGuideNode()
end
--初始化步骤
function initSpreeGuideStep(spreeInfo)
	local page = getIntPart(spreeInfo.usPlace/25)
	local row = getIntPart(spreeInfo.usPlace%25/5)
	local col = spreeInfo.usPlace%25%5
	if not m_spreeGuideSteps then
		m_spreeGuideSteps = {}
	end
	local pos = 1
	if getIsBottomButtonHide() then
		local tmp = {}
		tmp.strlist = "5918-5931"	--idlist
		tmp.dir = Right_Direction
		table.insert(m_spreeGuideSteps, pos, tmp)
		pos = pos + 1
	end
	local tmp = {}
	tmp.strlist = "5918-5933-1001"	--idlist
	tmp.dir = Right_Direction
	table.insert(m_spreeGuideSteps, pos, tmp)
	pos = pos + 1
	local tmp = {}
	tmp.strlist = "2011-9999-2008-2008-1-"..page.."-"..(spreeInfo.usPlace%25).."-"..spreeInfo.usPlace --idlist
	tmp.needReorderList = "2011-9999-2008-2008-1-"..page.."-"..(spreeInfo.usPlace%25)
	tmp.dir = Top_Direction
	if row > 1 then
		tmp.dir = Bottom_Direction
	end
	table.insert(m_spreeGuideSteps, pos, tmp)
	pos = pos + 1
	local tmp = {}
	tmp.strlist = "888888-0"	--idlist
	tmp.dir = Right_Direction
	table.insert(m_spreeGuideSteps, pos, tmp)
	pos = pos + 1
	m_nowStep = 1
	if spreeInfo.byFlag==1 and isWindControllerExistence(2011) then
		m_nowStep = 2
	end
	if not m_entryId then
		m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(onTenSpreeTimer, 0, false)
	end
end

----------------消息处理区-------------------------------------
function recvSpreeGuide()
	local dt = SCMessageCenter:getSingleton():getDataTransStream();
	if not dt then
		return
	end
	local action = dt:readShort()
	if action == GUID_OPEN_GIFTBOX then
		GuidePoint_setStepInfo(dt)
	elseif action == GUID_COPY_FAILE then
		LoseGuidance_recvLoseStrengthenGuide(dt)
	elseif action == GUID_OPEN_LEVELUP then
		LevelFunGuide_ProcessorLevelUpGuideMsg(dt)
	elseif action == GUID_OPEN_HELP_WINDOW then
		LevelFunGuide_ProcessorLevelUpOpenWndMsg(dt)
	elseif action == GUID_OPEN_LEARN_SKILL then
		GuidePoint_setStepSkillInfo(dt)
	end
end

----------------消息注册区-------------------------------------
SCMessageCenter:getSingleton():luaRegistCommand(recvSpreeGuide, _MSG_USER_GUID, 0, nil);

----------------全局函数区-------------------------------------
function levelTenSpree_IsGuideIn()
	if m_tenGuideInFlag then
		return 1
	end
	return 0
end

function levelTenSpree_ClearData()
	clearSpreeData()
end