--定义一个与文件名相同的table
Wings5 = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------
local nGemTypeIndex = {3900110001, 3900120001, 3900130001};
local nCostMoney = {0,50000,150000,300000,450000,20,40,60,80,100,120,140}
local nImgBtnIndex = {4,5,12,13,22,23}
local nLableIndex = {9, 10, 19, 20, 27, 28}
local nBtnIndex = {11, 21, 29}
local ITEMACT_PLUGGEM_FAST = 67

----------------变量定义区----------------
local m_nGemPlugFlag = 0
local m_curIndex = 1
local m_GemTypeID = {}
local nLev = {}
local onClickGemPlug

----------------UI控制器区----------------
function Wings5.resetGemInfo()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then return end
    
    local pageNode = pMultiPage:getPageWithIndex(3);
    if not pageNode then return end
    
    local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("1-9", pageNode), "SCPageScrollBox")
    if not pDragNode3 then return end
    
    for i = 0, 2 do
        local pImgNodeBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(nImgBtnIndex[i * 2 + 1]));
        if pImgNodeBtn then
            pImgNodeBtn:removeAllChildrenWithCleanup(true)
        end
        local pNextImgNodeBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(nImgBtnIndex[i * 2 + 2]));
        if pNextImgNodeBtn then
            pNextImgNodeBtn:removeAllChildrenWithCleanup(true)
        end
        
        --[[local pImgNodeEx = SCTypeCast:castNodeToImage(pDragNode3:getChildByTag(nImgIndex[i+1]));
        if pImgNodeEx==nil then
            break;
        end--]]

        local pLableNode2 = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(nLableIndex[i * 2 + 1]));
        if pLableNode2 then
            pLableNode2:setText("")
            pLableNode2:removeAllChildrenWithCleanup(true)
        end
        local pLableNode3 = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(nLableIndex[i * 2 + 2]));
        if pLableNode3 then
            pLableNode3:setText("")
        end
        
        local pBtnNode = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(nBtnIndex[i + 1]));
        if pBtnNode then
            local pImgPath1 = getRealUIResourcePath("img/new00202.png")
            if pImgPath1 then
                pBtnNode:setTitle(pImgPath1:getData())
                pBtnNode:setButtonType(3)
            end
        end
        
        m_nGemPlugFlag = 0
        m_GemTypeID = {}
        nLev = {}
    end
end

local function getPageNode()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then
        return nil;
    end
    local pageNode = pMultiPage:getCurrentPage();
    if pageNode == nil then
        return nil;
    end
    return SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("1-2-3", pageNode));
end

--羽翼后滚
local function onPageDown(tag)    
    local pNode = getPageNode();
    if pNode then
        local index = pNode:getPageIndex();
        if index < pNode:getPageCount() - 1 then
            pNode:setOffset(CCPointMake((1 + index) * pNode:getPageSize().width, 0));
            index = pNode:getPageIndex();
            local itemId = Wings3.getItemId(index + 1)
            
            Wings5.resetGemInfo()
            Wings5.setGemInfoForWing(itemId);
        end
    end
end

--羽翼前滚
local function onPageUp(tag)
    local pNode = getPageNode();
    if pNode then
        local index = pNode:getPageIndex();
        if index > 0 then
            pNode:setOffset(CCPointMake((index - 1) * pNode:getPageSize().width, 0));
            index = pNode:getPageIndex();
            local itemId = Wings3.getItemId(index + 1)
            
            Wings5.resetGemInfo()
            Wings5.setGemInfoForWing(itemId);
        end
    end
end

local function onSlidePageNext(tag)
    local pNode = getPageNode();
    if pNode then
        local index = pNode:getPageIndex();
        local itemId = Wings3.getItemId(index + 1)
        
        Wings5.resetGemInfo()
        Wings5.setGemInfoForWing(itemId);
    end
end

local function onSlidePagePrevious(tag)
    local pNode = getPageNode();
    if pNode then
        local index = pNode:getPageIndex();      
        local itemId = Wings3.getItemId(index + 1)
        
        Wings5.resetGemInfo()
        Wings5.setGemInfoForWing(itemId);
    end
end

function Wings5.initControl()
    local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode1:setContentSize(AUTO_SIZE(480, 320))
		pDragNode1:setFrameVisibled(false)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTypeRound)
	end
    
	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(3.00, 1.00))
		pDragNode2:setContentSize(AUTO_SIZE(246, 267))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTypeTip3)
	end

	local pDragNode9 = SCDragNode:node()
	if pDragNode9 then
		pDragNode9:setTag(9)
		pDragNode9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode9:setPosition(AUTO_POS(248.00, 1.00))
		pDragNode9:setContentSize(AUTO_SIZE(227, 267))
		pDragNode9:setFrameVisibled(true)
		pDragNode9:setDragEnabled(false)
		pDragNode9:setFrameType(EnumFrameTypeTip3)
	end
	
	local pPageScrollBox3 = SCPageScrollBox:boxWithWidthHeight(AUTO_W(225), AUTO_H(244))
	if pPageScrollBox3 then
		tolua.cast(pPageScrollBox3, "SCNode"):setTag(3)
		tolua.cast(pPageScrollBox3, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pPageScrollBox3, "SCNode"):setPosition(AUTO_POS(10.00, 11.00))
	end

	local pButton8 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton8 then
		pButton8:setTag(8)
		pButton8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton8:setPosition(AUTO_POS(182.00, 218.00))
		pButton8:setContentSize(AUTO_SIZE(22, 30))
		local imgPath = getRealUIResourcePath("img/new00047.png")
		if imgPath then
			pButton8:setTitle(imgPath:getData())
		end
	end

	local pButton10 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton10 then
		pButton10:setTag(10)
		pButton10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10:setPosition(AUTO_POS(39.00, 218.00))
		pButton10:setContentSize(AUTO_SIZE(22, 30))
		local imgPath = getRealUIResourcePath("img/new00048.png")
		if imgPath then
			pButton10:setTitle(imgPath:getData())
		end
	end

    --右半宝石界面
    local pLable9 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(10))
	if pLable9 then
		pLable9:setTag(9)
		pLable9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable9:setPosition(AUTO_POS(26.00, 193.00))
		pLable9:setColor(ccc4(255,255,255,255))
	end

	local pLable10 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(10))
	if pLable10 then
		pLable10:setTag(10)
		pLable10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable10:setPosition(AUTO_POS(26.00, 183.00))
		pLable10:setColor(ccc4(255,255,255,255))
	end

	local pButton11 = SCButton:button(EnumBtnType9Atlas)
	if pButton11 then
		pButton11:setTag(11)
		pButton11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton11:setPosition(AUTO_POS(148.00, 181.00))
		pButton11:setContentSize(AUTO_SIZE(58, 25))
		local imgPath = getRealUIResourcePath("img/new00198.png")
		if imgPath then
			pButton11:setTitle(imgPath:getData())
		end
	end

    local imgPath = getRealUIResourcePath("img/new00047.png")
	local pImage6 = nil
	if imgPath then
		pImage6 = SCImage:imageWithFile(imgPath:getData())
		if pImage6 then
			pImage6:setTag(6)
			pImage6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage6:setPosition(AUTO_POS(102.00, 213.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00047.png")
	local pImage14 = nil
	if imgPath then
		pImage14 = SCImage:imageWithFile(imgPath:getData())
		if pImage14 then
			pImage14:setTag(14)
			pImage14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage14:setPosition(AUTO_POS(102.00, 144.00))
		end
	end

	local pLable19 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(10))
	if pLable19 then
		pLable19:setTag(19)
		pLable19:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable19:setPosition(AUTO_POS(26.00, 124.00))
		pLable19:setColor(ccc4(255,255,255,255))
	end

	local pLable20 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(10))
	if pLable20 then
		pLable20:setTag(20)
		pLable20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable20:setPosition(AUTO_POS(26.00, 113.00))
		pLable20:setColor(ccc4(255,255,255,255))
	end

	local pButton21 = SCButton:button(EnumBtnType9Atlas)
	if pButton21 then
		pButton21:setTag(21)
		pButton21:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton21:setPosition(AUTO_POS(147.00, 111.00))
		pButton21:setContentSize(AUTO_SIZE(58, 25))
		local imgPath = getRealUIResourcePath("img/new00198.png")
		if imgPath then
			pButton21:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00047.png")
	local pImage24 = nil
	if imgPath then
		pImage24 = SCImage:imageWithFile(imgPath:getData())
		if pImage24 then
			pImage24:setTag(24)
			pImage24:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage24:setPosition(AUTO_POS(101.00, 73.00))
		end
	end

	local pLable27 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(10))
	if pLable27 then
		pLable27:setTag(27)
		pLable27:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable27:setPosition(AUTO_POS(26.00, 54.00))
		pLable27:setColor(ccc4(255,255,255,255))
	end

	local pLable28 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(10))
	if pLable28 then
		pLable28:setTag(28)
		pLable28:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable28:setPosition(AUTO_POS(26.00, 42.00))
		pLable28:setColor(ccc4(255,255,255,255))
	end

	local pButton29 = SCButton:button(EnumBtnType9Atlas)
	if pButton29 then
		pButton29:setTag(29)
		pButton29:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton29:setPosition(AUTO_POS(148.00, 41.00))
		pButton29:setContentSize(AUTO_SIZE(58, 25))
		local imgPath = getRealUIResourcePath("img/new00198.png")
		if imgPath then
			pButton29:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/img0015.png")
	local pImage30 = nil
	if imgPath then
		pImage30 = SCImage:imageWithFile(imgPath:getData())
		if pImage30 then
			pImage30:setTag(30)
			pImage30:setAnchorPoint(CCPointMake(0.5, 0))
			pImage30:setPosition(AUTO_POS(107.00, 35.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/2001001.pn")
	local pImage31 = nil
	if imgPath then
		pImage31 = SCImage:imageWithFile(imgPath:getData())
		if pImage31 then
			pImage31:setTag(31)
			pImage31:setScale(0.45);
			pImage31:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage31:setPosition(AUTO_POS(77.00, 11.00))
		end
	end

	local pLable32 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(12))
	if pLable32 then
		pLable32:setTag(32)
		pLable32:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable32:setPosition(AUTO_POS(100.00, 15.00))
		pLable32:setColor(ccc4(255,255,255,255))
	end

	local pButton4 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton4 then
		pButton4:setTag(4)
		pButton4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton4:setPosition(AUTO_POS(25.00, 205.00))
		pButton4:setContentSize(AUTO_SIZE(46, 46))
		local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButton4:setTitle(imgPath:getData())
		end
	end

	local pButton5 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton5 then
		pButton5:setTag(5)
		pButton5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton5:setPosition(AUTO_POS(155.00, 205.00))
		pButton5:setContentSize(AUTO_SIZE(46, 46))
		local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButton5:setTitle(imgPath:getData())
		end
	end

	local pButton12 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton12 then
		pButton12:setTag(12)
		pButton12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton12:setPosition(AUTO_POS(25.00, 136.00))
		pButton12:setContentSize(AUTO_SIZE(46, 46))
		local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButton12:setTitle(imgPath:getData())
		end
	end

	local pButton13 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton13 then
		pButton13:setTag(13)
		pButton13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton13:setPosition(AUTO_POS(154.00, 136.00))
		pButton13:setContentSize(AUTO_SIZE(46, 46))
		local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButton13:setTitle(imgPath:getData())
		end
	end

	local pButton22 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton22 then
		pButton22:setTag(22)
		pButton22:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton22:setPosition(AUTO_POS(25.00, 66.00))
		pButton22:setContentSize(AUTO_SIZE(46, 46))
		local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButton22:setTitle(imgPath:getData())
		end
	end

	local pButton23 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton23 then
		pButton23:setTag(23)
		pButton23:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton23:setPosition(AUTO_POS(155.00, 66.00))
		pButton23:setContentSize(AUTO_SIZE(46, 46))
		local imgPath = getRealUIResourcePath("img/new00002.png")
		if imgPath then
			pButton23:setTitle(imgPath:getData())
		end
	end
    
    --框架
	if pDragNode2 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pDragNode9 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pDragNode9, "SCNode"))
	end
	if pDragNode11 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pDragNode11, "SCNode"))
	end
	if pImage12 and pDragNode11 then
		pDragNode11:addChild(tolua.cast(pImage12, "SCNode"))
	end
	if pLable13 and pDragNode11 then
		pDragNode11:addChild(tolua.cast(pLable13, "SCNode"))
	end
	if pDragNode14 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pDragNode14, "SCNode"))
	end
	if pImage15 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pImage15, "SCNode"))
	end
	if pLable16 and pDragNode14 then
		pDragNode14:addChild(tolua.cast(pLable16, "SCNode"))
	end
	if pLable17 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable17, "SCNode"))
	end
	if pImage18 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage18, "SCNode"))
	end
	if pButton19 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton19, "SCNode"))
	end
	if pPageScrollBox3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pPageScrollBox3, "SCNode"))
	end
	if pImage4 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage4, "SCNode"))
	end
	if pImage5 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage5, "SCNode"))
	end
	if pImage6 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage6, "SCNode"))
	end
	if pImage7 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage7, "SCNode"))
	end
	if pButton8 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton8, "SCNode"))
	end
	if pButton10 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton10, "SCNode"))
	end
	
	--右半宝石界面
	if pLable9 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable9, "SCNode"))
	end
	if pLable10 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable10, "SCNode"))
	end
	if pButton11 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton11, "SCNode"))
	end
	if pImage14 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage14, "SCNode"))
	end
	if pLable19 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable19, "SCNode"))
	end
	if pLable20 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable20, "SCNode"))
	end
	if pButton21 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton21, "SCNode"))
	end
	if pImage24 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage24, "SCNode"))
	end
	if pLable27 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable27, "SCNode"))
	end
	if pLable28 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable28, "SCNode"))
	end
	if pButton29 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton29, "SCNode"))
	end
	if pImage30 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage30, "SCNode"))
	end
	if pImage31 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pImage31, "SCNode"))
	end
	if pLable32 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pLable32, "SCNode"))
	end
	if pButton4 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton4, "SCNode"))
	end
	if pButton5 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton5, "SCNode"))
	end
	if pButton12 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton12, "SCNode"))
	end
	if pButton13 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton13, "SCNode"))
	end
	if pButton22 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton22, "SCNode"))
	end
	if pButton23 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton23, "SCNode"))
	end
	
	return pDragNode1 
end

function Wings5.init(pNode)
    local pageNode = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-3", pNode));
    if pageNode then
        pageNode:luaSetSelectorOnScrollToPrevious(onSlidePagePrevious);
        pageNode:luaSetSelectorOnScrollToNext(onSlidePageNext);
    end
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-8", pNode));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onPageDown);
    end    
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-10", pNode));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onPageUp);
    end
    
    --镶嵌、升级按钮
    local btn1 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("9-11", pNode));
    if btn1 then
        btn1:luaSetSelectorOnClicked(onClickGemPlug);
    end
    
    local btn2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("9-21", pNode));
    if btn2 then
        btn2:luaSetSelectorOnClicked(onClickGemPlug);
    end
    
    local btn3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("9-29", pNode));
    if btn3 then
        btn3:luaSetSelectorOnClicked(onClickGemPlug);
    end
end

function Wings5.wndClose()
    local m_nGemPlugFlag = 0
    local m_curIndex = 1
    local m_GemTypeID = {}
    local nLev = {}
end

function Wings5.releaseControl()
	if Wings5.wndClose then
		Wings5.wndClose()
	end
end

----------------逻辑功能区----------------
--获取待升级宝石信息
function Wings5.getCurGemPlugFlag()
    return m_nGemPlugFlag, nLev[1], nLev[2], nLev[3];
end

--点击镶嵌、升级
function onClickGemPlug(tag)
	if CLIENT_VERSION <= 328 then
		showMessage(L("str9236"))
		return
	end

    local idCurItem = nil
    local pNode = getPageNode();
    if pNode then
        local index = pNode:getPageIndex();
        idCurItem = Wings3.getItemId(index + 1)
    end
    
    if not idCurItem or idCurItem == 0 then return end

    local item = ItemProcessor:getSingleton():getItem(idCurItem);
    if item == nil then
        return;
    end
    
    local idKeeper = item:getOwnerID();
    
    local ucPos = 0;
    if tag == 11 then
        ucPos = 1;
    elseif tag == 21 then
        ucPos = 2;
    elseif tag == 29 then
        ucPos = 3;
    end
    
    local nGemPlugFlag, lev1, lev2, lev3 = Wings5.getCurGemPlugFlag();
    local nYflag = getLeftMoveBit(ucPos - 1);
    if getAndBit(nGemPlugFlag, nYflag)==0 then
        local money = Hero:getSingleton():getMoney()
        local emoney = Hero:getSingleton():getEmoney()
        if ucPos == 1 then
            if lev1 < 5 and lev1 > 0 then
                if money < nCostMoney[lev1 + 1] then
                    GuidePoint_shopBuyTip();
                    return
                end
            elseif lev1 >= 5 then
                if emoney < nCostMoney[lev1+1] then
                    luashowConfirmationWindow(_LTParser("str0439"), WIN_YES_NO, Open_rechange)
                    return
                end
            end
        elseif ucPos == 2 then
            if lev2 < 5 and lev2 > 0 then
                if money < nCostMoney[lev2+1] then
                    GuidePoint_shopBuyTip();
                    return
                end
            elseif lev2 >= 5 then
                if emoney < nCostMoney[lev2+1] then
                    luashowConfirmationWindow(_LTParser("str0439"), WIN_YES_NO, Open_rechange)
                    return
                end
            end
        elseif ucPos == 3 then
            if lev3 < 5 and lev3 > 0 then
                if money < nCostMoney[lev3+1] then
                    GuidePoint_shopBuyTip();
                    return
                end
            elseif lev3 >= 5 then
                if emoney < nCostMoney[lev3+1] then
                    luashowConfirmationWindow(_LTParser("str0439"), WIN_YES_NO, Open_rechange)
                    return
                end
            end
        end
        
        --一键镶嵌
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM)
		dataStream:writeShort(ITEMACT_PLUGGEM_FAST);
		dataStream:writeByte(0);
		dataStream:writeInt(idKeeper);
		dataStream:writeInt(idCurItem);
		dataStream:writeInt(ucPos);
		SCDataTransThread:getSingleton():transData(dataStream);
		SCActivityIndicator:getSingleton():show()
        return
    end
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM);
    dataStream:writeShort(ITEMACT_PLUGGEM);
    dataStream:writeInt(idKeeper);
    dataStream:writeInt(idCurItem);
    dataStream:writeByte(ucPos);
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end

--点击宝石
local function onClickGem(tag)
    if tag == nil then
        return;
    end
    
    local key_end = 0
    local str = nil
    
    for i = 1, 6 do
        if tag == nImgBtnIndex[i] then
            if m_GemTypeID[i] == nil then
                return;
            end
            
            if m_GemTypeID[i] > 0 then
                if tag == 4 or tag == 5 then
                    key_end = 100 * 1000 + 100 + m_GemTypeID[i] % 10
                elseif  tag == 12 or tag == 13 then
                    key_end = 100 * 1000 + 200 + m_GemTypeID[i] % 10
                elseif  tag == 22 or tag == 23 then    
                    key_end = 100 * 1000 + 300 + m_GemTypeID[i] % 10
                end
                
                if CLIENT_VERSION <= 328 then
					showMessage(L("str9236"))
					return
				end
				
                showTipforbs(key_end)
                return;
            end
        end 
    end
end

--查找材料
function Wings5.getItemTypeAmount(idItemType)
    local nCount = 0;
    local iteminfoSize = ItemProcessor:getSingleton():ItemSize();
    for i=1, iteminfoSize do
        local item = ItemProcessor:getSingleton():getItemInfo(i - 1);
        local postion = item:getPostion();
        if item:getIdType()==idItemType and postion==0 then
            if item:isPileAble() then
                nCount = nCount + item:getAmount();
            else
                nCount = nCount + 1;
            end
            
        end
    end
    return nCount;
end

--设置羽翼宝石
function Wings5.setGemInfoForWing(id) 
    if not id or id == 0 then return end
    
    local item = ItemProcessor:getSingleton():getItem(id)
    if not item then return end
    
    local pMultiPage1 = tolua.cast(SCFunction:getUiNodeByIdlist("7034-1"), "SCMultiPage")
    if not pMultiPage1 then return end 
    
    local pPage = tolua.cast(pMultiPage1:getCurrentPage(), "SCDragNode")
    if not pPage then return end
    
    local pDragNode3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("1-9", pPage), "SCPageScrollBox")
    if not pDragNode3 then return end 
    
    m_nGemPlugFlag = 0;
    local idEquipType = item:getIdType();

    --宝石孔位和说明文字节点获取
    for i = 0, 2 do
        local pImgNodeBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(nImgBtnIndex[i * 2 + 1]));
        if pImgNodeBtn==nil then
            break;
        end
        local pNextImgNodeBtn = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(nImgBtnIndex[i * 2 + 2]));
        if pNextImgNodeBtn==nil then
            break;
        end
        
        --[[local pImgNodeEx = SCTypeCast:castNodeToImage(pDragNode3:getChildByTag(nImgIndex[i+1]));
        if pImgNodeEx==nil then
            break;
        end--]]

        local pLableNode2 = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(nLableIndex[i * 2 + 1]));
        if pLableNode2==nil then
            break;
        end
        local pLableNode3 = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(nLableIndex[i * 2 + 2]));
        if pLableNode3==nil then
            break;
        end
        
        local pBtnNode = SCTypeCast:castNodeToButton(pDragNode3:getChildByTag(nBtnIndex[i + 1]));
        if pBtnNode==nil then
            break;
        end
        
        local itemGem = item:getvecGem(i+1);
        if itemGem then
            idGemType = itemGem.idType;
        else
            idGemType = 0
        end
        
        --当前宝石等级
        local nCurGemLev = math.mod(idGemType, 100);
        if i == 0 then
            nLev[1] = nCurGemLev;
        elseif i == 1 then
            nLev[2] = nCurGemLev;
        elseif i == 2 then
            nLev[3] = nCurGemLev;
        end
        
        --下级宝石等级
        local idNextGemType = 0;
        if idGemType == 0 then
            idNextGemType = nGemTypeIndex[i + 1];
        else
            if nCurGemLev < 9 then
                idNextGemType = idGemType + 1
            else
                idNextGemType = 999999999;
            end
        end
        
        local bCanPro = true;
        if Wings5.getItemTypeAmount(idNextGemType) <= 0 then
            bCanPro = false;
        end
        
        pLableNode2:removeAllChildrenWithCleanup(true);
        pImgNodeBtn:setVisible(true);
        --pImgNodeEx:setVisible(true);
        pLableNode2:setVisible(true);
        pLableNode3:setVisible(true);
        pNextImgNodeBtn:setVisible(true);
        pBtnNode:setVisible(true);
        
        if idGemType > 0 then
        
            --itemtype表信息
            local stGemTypeInfo = TableParser:getSingleton():getItemInfoByKey(idGemType)
            local key = 25000 + (i + 1) * 100 + idGemType % 10 
            
            local pImgPath = getRealUIResourcePath("item/" .. stGemTypeInfo.icon .. ".jpg");
            if pImgPath then
                local pImg = SCImage:imageWithFile(pImgPath:getData());
                if pImg then
                    pImg:setAnchorPoint(CCPointMake(0.5, 0.5));
                    pImg:setPosition(CCPointMake(pImgNodeBtn:getContentSize().width / 2, pImgNodeBtn:getContentSize().height / 2));
                    pImgNodeBtn:removeAllChildrenWithCleanup(true);
                    pImgNodeBtn:addChild(pImg);
                    m_GemTypeID[i * 2 + 1] = idGemType;
                    pImgNodeBtn:luaSetSelectorOnClicked(onClickGem);
                    
                    local pLableLev = SCLabel:labelWithStringFont("Lv."..nCurGemLev, DEFAULT_FONT_NAME, F(10));
                    if pLableLev then
                        pImg:removeAllChildrenWithCleanup(true);
                        pLableLev:setAnchorPoint(CCPointMake(0,0));
                        pLableLev:setPosition(CCPointMake(0, pImg:getContentSize().height-pLableLev:getContentSize().height));
                        pLableLev:setColor(color_lightYellow);
                        pImg:addChild(pLableLev);
                    end
                end
            end
        else
            m_GemTypeID[i * 2 + 1] = 0;
            pImgNodeBtn:removeAllChildrenWithCleanup(true);
        end
        
        if 0 == idNextGemType then --无镶嵌
            pImgNodeBtn:setVisible(false);
            --pImgNodeEx:setVisible(false);
            pLableNode2:setVisible(false);
            pLableNode3:setVisible(false);
            pNextImgNodeBtn:setVisible(false);
            pBtnNode:setVisible(false);
            m_GemTypeID[i * 2 + 2] = 0;
        elseif 999999999 == idNextGemType then --已满级
            pLableNode2:setText(L("str0169"));
            pLableNode2:setColor(color_orange);
            
            pLableNode3:setVisible(false);
            pBtnNode:setVisible(false);
            --pImgNodeEx:setVisible(false);
            pNextImgNodeBtn:setVisible(false);
        else
            m_GemTypeID[i * 2 + 2] = idNextGemType;
            
            --itemtype表信息
            local stNextGemTypeInfo = TableParser:getSingleton():getItemInfoByKey(idNextGemType);
            local key = 25000 + (i + 1) * 100 + idGemType % 10 
            
            local pImgPath = getRealUIResourcePath("item/" .. stNextGemTypeInfo.icon .. ".jpg");
            if pImgPath then
                local pImg = SCImage:imageWithFile(pImgPath:getData());
                if pImg then
                    pImg:removeAllChildrenWithCleanup(true);
                    pImg:setAnchorPoint(CCPointMake(0.5, 0.5));
                    pImg:setPosition(CCPointMake(pNextImgNodeBtn:getContentSize().width / 2, pNextImgNodeBtn:getContentSize().height / 2));
                    pNextImgNodeBtn:removeAllChildrenWithCleanup(true);
                    pNextImgNodeBtn:addChild(pImg);
                    pNextImgNodeBtn:luaSetSelectorOnClicked(onClickGem);
                    
                    local pLableLev = SCLabel:labelWithStringFont("Lv."..nCurGemLev+1, DEFAULT_FONT_NAME, F(10));
                    if pLableLev then
                        pLableLev:setAnchorPoint(CCPointMake(0,0));
                        pLableLev:setPosition(CCPointMake(0, pImg:getContentSize().height-pLableLev:getContentSize().height));
                        pLableLev:setColor(color_lightYellow);
                        pImg:addChild(pLableLev);
                    end
                    
                    if bCanPro==true then
                        local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1018, 1018);
                        if pAni then
                            local pAniNodeEx = SCAnimationNode:nodeWithAnimation(pAni);
                            if pAniNodeEx then
                                pAniNodeEx:setAnchorPoint(CCPointMake(0.5, 0.5));
                                pAniNodeEx:setPosition(CCPointMake(pImg:getContentSize().width / 2, pImg:getContentSize().height / 2));                                            
                                pImg:addChild(pAniNodeEx);
                            end
                        end
                    else
                        local pNode = SCNode:node()
                        if pNode then
                            pNode:setAnchorPoint(CCPointMake(0.5,0.5));
                            pNode:setPosition(CCPointMake(pImg:getContentSize().width/2, pImg:getContentSize().height/2));
                            pNode:setContentSize(CCSizeMake(pImg:getContentSize().width,pImg:getContentSize().height));
                            pNode:setBackgroundColor(ccc4(0, 0, 0, 90));
                            pImg:addChild(pNode);
                        end
                    end
                end
            end
            
            pLableNode2:setText(L("str8146"));
            if bCanPro==true then
                pLableNode2:setColor(color_white);
            else
                pLableNode2:setColor(color_gray);
            end
            
            local pLableTmp = SCLabel:labelWithStringFont(stNextGemTypeInfo.name:getData(), DEFAULT_FONT_NAME, F(10));
            if pLableTmp then
                local nColor = color_white;
                if idNextGemType>=3900120001 and idNextGemType<=3900120009 then
                    nColor = color_yellow;
                elseif idNextGemType>=3900110001 and idNextGemType<=3900110009 then
                    nColor = color_red;
                elseif idNextGemType>=3900130001 and idNextGemType<=3900130009 then
                    nColor = color_blue;
                end
                pLableTmp:setColor(nColor);
                pLableTmp:setAnchorPoint(CCPointMake(0, 0));
                pLableTmp:setPosition(CCPointMake(pLableNode2:getContentSize().width, 0));
                pLableNode2:addChild(pLableTmp);
            end
            
            local strCost = L("str8148");
            local nCostValue = nCostMoney[nCurGemLev + 1];
            if nCostValue == 0 then
                pLableNode3:setVisible(false);
            else
                pLableNode3:setVisible(true);
                if nCurGemLev+1<6 then
                    pLableNode3:setText(strCost..nCostValue..L("str0139"));
                    local money = Hero:getSingleton():getMoney();
                    if money<nCostValue then
                        bCanPro = false;
                        pLableNode3:setColor(color_gray);
                    else
                        pLableNode3:setColor(color_white);
                    end
                else
                    pLableNode3:setText(strCost..nCostValue..L("str0138"));
                    local emoney = Hero:getSingleton():getEmoney();
                    if emoney<nCostValue then
                        bCanPro = false;
                        pLableNode3:setColor(color_gray);
                    else
                        pLableNode3:setColor(color_white);
                    end
                end
            end
            
            --升级镶嵌按钮
            if bCanPro==true then
                local nBitFlag = getLeftMoveBit(i);
                m_nGemPlugFlag = getOrBit(m_nGemPlugFlag, nBitFlag);
                
                local pImgPath1 = getRealUIResourcePath("img/new00201.png");
                local pImgPath3 = getRealUIResourcePath("img/new00198.png");
                if nCurGemLev==0 and pImgPath1 then
                    pBtnNode:setTitle(pImgPath1:getData());
                elseif nCurGemLev>0 and pImgPath3 then
                    pBtnNode:setTitle(pImgPath3:getData());
                end
                pBtnNode:setButtonType(1)
            else
                local pImgPath2 = getRealUIResourcePath("img/new00202.png");
                local pImgPath4 = getRealUIResourcePath("img/new00199.png");
                if nCurGemLev==0 and pImgPath2 then
                    pBtnNode:setTitle(pImgPath2:getData());
                elseif nCurGemLev>0 and pImgPath4 then
                    pBtnNode:setTitle(pImgPath4:getData());
                end
                pBtnNode:setButtonType(1);
            end
        end
    end
    
    local pMoneyLableNode = SCTypeCast:castNodeToLabel(pDragNode3:getChildByTag(32));
    if pMoneyLableNode then
        pMoneyLableNode:setText(Hero:getSingleton():getMoney());
    end
end

--羽翼滚动控件刷新
function Wings5.upDataInfo(pNode, firstNode)
    if firstNode then
        Wings3.upDataInfo(firstNode);
    end
    local pageNode = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("2-3", pNode));
    if pageNode then
        for i=1, pageNode:getPageCount() do
            local pChildNode = pageNode:getChildByTag(i);
            if pChildNode then
                local item = ItemProcessor:getSingleton():getItem(m_itemId[i])
                if item then
                    local pIconNode = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("3-"..m_itemId[i], pChildNode), "SCButton");
                    local pImgPath = getRealUIResourcePath("item/" .. item:getIconID() .. ".jpg");
                    if pIconNode and pImgPath then
                        pIconNode:setTitle(pImgPath:getData())
                        --pIconNode:luaSetSelectorOnClicked(Wings3.showItemTip)
                        --pIconNode:setTag(itemId)
                    end
                end
            end
        end
    end
end

--羽翼镶嵌成功消息--
function Wings5.reShowGemInfo()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7034-1"));
    if pMultiPage == nil then return end
    
    local pageIndex = pMultiPage:selectedPageIndex();
    if pageIndex == nil or pageIndex ~= 3 then
        return
    end
    
    local pNode = getPageNode()
    local index = pNode:getPageIndex();
    local itemId = Wings3.getItemId(index + 1)
    
    Wings5.init(pMultiPage)
    Wings5.setGemInfoForWing(itemId)
end
