--定义一个与文件名相同的table
yanwu = {}
------------------消息--------------------
----------------变量定义区----------------
local yanwu_mark = {};  
local xingji_mark = 0;
-------主界面信息-----------
local styanwuAttr = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nType = dt:readInt(); ---属性类型
        tmp.nNum = dt:readInt(); ---人数
        return tmp;
    end
}

local styanwuInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte()--//演武场数量
        tmp.stYanWuFieldInfo = {}

        for i = 1, tmp.ucAmount do
            table.insert(tmp.stYanWuFieldInfo, styanwuAttr.initWithStream(dt));
        end
        return tmp
    end
}
-------------------各级界面信息----------------
local styanwu1Attr = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idPlayer = dt:readInt(); ---玩家id
        local str = dt:readString(); --玩家名字
		if str then
			tmp.szName = str:getData();
		else
            tmp.szName = "";    
		end
		tmp.usLevel = dt:readShort()  --玩家等级
		tmp.ucClan = dt:readByte()  --玩家职业 
		local str = dt:readString(); --军团名 
		if str then
			tmp.szTribeName = str:getData();
		else
            tmp.szTribeName = "";    
		end
		tmp.nType = dt:readInt()  --演武场类型
		tmp.nPosition = dt:readInt()  --演武场位置 
		tmp.ucInBattle = dt:readByte()  --是否战斗中 默认0  1 在战斗中 
		tmp.dwAwardCD = dt:readInt()  --奖励CD
        return tmp;
    end
}

local styanwu1Info = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte()--//演武场内人物数量
        tmp.stYanWuPlayerInfo = {}

        for i = 1, tmp.ucAmount do
            table.insert(tmp.stYanWuPlayerInfo, styanwu1Attr.initWithStream(dt));
        end
		yanwu_mark = tmp
        return tmp
    end
}
---------更新战斗状态-----------
local styanwu1gengxInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idPlayer = dt:readInt()--//人物ID
        tmp.ucBattle = dt:readByte() --默认 0 1正在战斗 	

        return tmp
    end
}
------------演武场添加人物---------------
local styanwu1addInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idPlayer = dt:readInt()--//人物ID
        tmp.nType = dt:readInt() --类型
        tmp.nPosition = dt:readInt() --位置

        return tmp
    end
}
------------演武场奖励-------------
local stYanWuAwardInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nPartaleTimes = dt:readInt()--//已参与次数 
        tmp.nAwardExp = dt:readInt() --//每次可获得的经验(每30秒一次经验)
        tmp.dwSupTime = dt:readInt() --//剩余时间
        tmp.dwLootTime = dt:readInt() --//剩余抢夺时间
        tmp.nCondition1 = dt:readInt() --//条件1
        tmp.idAwardItem1 = dt:readInt() --//满足条件1可获得的礼包
        tmp.nCondition2 = dt:readInt() --//条件2
        tmp.idAwardItem2 = dt:readInt() --//满足条件2可获得的礼包
        tmp.nCondition3 = dt:readInt() --//条件3
        tmp.idAwardItem3 = dt:readInt() --//满足条件3可获得的礼包

        return tmp
    end
}
-------演武场历史信息-----------------
local stYanWuhistoryInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idBattle = dt:readInt()--//战斗时间
        local str = dt:readString(); --战斗已过时间 
		if str then
			tmp.szPastTime = str:getData();
		else
            tmp.szPastTime = "";    
		end
        tmp.ucRiseFightFlag = dt:readByte() --//是否自己发起挑战  1 自己发起挑战
        tmp.idTarget = dt:readInt() --//目标ID
        local str = dt:readString(); --目标名字 
		if str then
			tmp.szTargetName = str:getData();
		else
            tmp.szTargetName = "";    
		end
        tmp.ucWinFlag = dt:readByte() --//是否胜利  1胜利
        tmp.nOldRank = dt:readInt() --//旧排名
        tmp.nNewRank = dt:readInt() --//新排名

        return tmp
    end
} 
local styanwuhisnumInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte()--//历史信息条数
        tmp.stYanWunewsInfo = {}

        for i = 1, tmp.ucAmount do
            table.insert(tmp.stYanWunewsInfo, stYanWuhistoryInfo.initWithStream(dt));
        end
		yanwu_mark = tmp
        return tmp
    end
}
----------------结构定义区----------------
local   ARENASCRITP_YANWU_INFO                  = 60       --//演武场信息 
local   YANWUFIELD_COMMON = 1		--//普通 
local	YANWUFIELD_PRIMARY = 2		--//初级 
local	YANWUFIELD_INTERMEDIATE = 3 --//中级 
local	YANWUFIELD_ADVANCED = 4	--//高级 
local	YANWUFIELD_EPIC = 5		--//史诗
local	YANWUFIELD_LEGEND = 6		--//传说
local   ARENASCRITP_YANWU_PLAYERINFO            = 61       --//演武场内玩家信息 
local   ARENASCRITP_YANWU_PLAYERINFO_END        = 62       --//演武场内玩家信息下发结束 
local   ARENASCRITP_YANWU_AWARDINFO             = 72       --//玩家奖励信息 
local   ARENASCRITP_YANWU_LATELYINFO            = 71       --//演武场最近5场战斗信息 
local   ARENASCRITP_YANWU_OPEN_VIEW             = 68       --//打开演武场界面 
----------------常量定义区----------------


--变量的定义
----------------UI控制器区----------------
function yanwu.initControl()
	local pWindow1 = SCWindow:window()
	if pWindow1 then
		pWindow1:setTag(50050)
		pWindow1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow1:setPosition(AUTO_POS(0.50, -0.00))pWindow1:setContentSize(AUTO_SIZE(480, 320))
		pWindow1:luaSetSelectorOnClose(yanwu.releaseControl)
	end

	local imgPath = getRealUIResourcePath("yanwu/new00862.png")
	local pImage2 = nil
	if imgPath then
		pImage2 = SCImage:imageWithFile(imgPath:getData())
		if pImage2 then
			pImage2:setTag(2)
			pImage2:setAnchorPoint(ANCHOR_CENTER)
			pImage2:setPosition(AUTO_POS(240, 160))
		end
	end

	local pButton3 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton3 then
		pButton3:setTag(3)
		pButton3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton3:setPosition(AUTO_POS(53.50, 17.50))
		pButton3:setContentSize(AUTO_SIZE(130, 120))
		local imgPath = getRealUIResourcePath("yanwu/new00858.png")
		if imgPath then
			pButton3:setTitle(imgPath:getData())
		end
	end

	local pButton4 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton4 then
		pButton4:setTag(4)
		pButton4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton4:setPosition(AUTO_POS(89.50, 139.00))
		pButton4:setContentSize(AUTO_SIZE(130, 120))
		local imgPath = getRealUIResourcePath("yanwu/new00859.png")
		if imgPath then
			pButton4:setTitle(imgPath:getData())
		end
	end

	local pButton5 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton5 then
		pButton5:setTag(5)
		pButton5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton5:setPosition(AUTO_POS(248.00, 64.00))
		pButton5:setContentSize(AUTO_SIZE(130, 120))
		local imgPath = getRealUIResourcePath("yanwu/new00860.png")
		if imgPath then
			pButton5:setTitle(imgPath:getData())
		end
	end

	local pButton6 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton6 then
		pButton6:setTag(6)
		pButton6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton6:setPosition(AUTO_POS(277.50, 193.00))
		pButton6:setContentSize(AUTO_SIZE(130, 120))
		local imgPath = getRealUIResourcePath("yanwu/new00861.png")
		if imgPath then
			pButton6:setTitle(imgPath:getData())
		end
	end

	local imgPath = getRealUIResourcePath("yanwu/new00855.png")
	local pImage7 = nil
	if imgPath then
		pImage7 = SCImage:imageWithFile(imgPath:getData())
		if pImage7 then
			pImage7:setTag(7)
			pImage7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage7:setPosition(AUTO_POS(21.00, 280.50))
		end
	end

	local imgPath = getRealUIResourcePath("yanwu/new00854.png")
	local pImage8 = nil
	if imgPath then
		pImage8 = SCImage:imageWithFile(imgPath:getData())
		if pImage8 then
			pImage8:setTag(8)
			pImage8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage8:setPosition(AUTO_POS(56.50, 18.00))
		end
	end

	local imgPath = getRealUIResourcePath("yanwu/new00854.png")
	local pImage9 = nil
	if imgPath then
		pImage9 = SCImage:imageWithFile(imgPath:getData())
		if pImage9 then
			pImage9:setTag(9)
			pImage9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage9:setPosition(AUTO_POS(93.00, 141.50))
		end
	end

	local imgPath = getRealUIResourcePath("yanwu/new00854.png")
	local pImage10 = nil
	if imgPath then
		pImage10 = SCImage:imageWithFile(imgPath:getData())
		if pImage10 then
			pImage10:setTag(10)
			pImage10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10:setPosition(AUTO_POS(281.00, 194.50))
		end
	end

	local imgPath = getRealUIResourcePath("yanwu/new00854.png")
	local pImage11 = nil
	if imgPath then
		pImage11 = SCImage:imageWithFile(imgPath:getData())
		if pImage11 then
			pImage11:setTag(11)
			pImage11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage11:setPosition(AUTO_POS(252.00, 66.00))
		end
	end

	local pButton12 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton12 then
		pButton12:setTag(12)
		pButton12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton12:setPosition(AUTO_POS(400.00, 5.00))
		pButton12:setContentSize(AUTO_SIZE(74, 28))
		local imgPath = getRealUIResourcePath("img/new00264.png")
		if imgPath then
			pButton12:setTitle(imgPath:getData())
		end
	end

	local pLable13 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(12))
	if pLable13 then
		pLable13:setTag(13)
		pLable13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable13:setPosition(AUTO_POS(190, 7.85))
		pLable13:setColor(ccc4(255,255,255,255))
	end

	local pLable14 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable14 then
		pLable14:setTag(14)
		pLable14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable14:setPosition(AUTO_POS(67.71, 26.26))
		pLable14:setColor(ccc4(255,255,255,255))
	end

	local pLable15 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable15 then
		pLable15:setTag(15)
		pLable15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable15:setPosition(AUTO_POS(103.15, 150.80))
		pLable15:setColor(ccc4(255,255,255,255))
	end

	local pLable16 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable16 then
		pLable16:setTag(16)
		pLable16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable16:setPosition(AUTO_POS(263.67, 73.78))
		pLable16:setColor(ccc4(255,255,255,255))
	end

	local pLable17 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable17 then
		pLable17:setTag(17)
		pLable17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable17:setPosition(AUTO_POS(291.12, 203.31))
		pLable17:setColor(ccc4(255,255,255,255))
	end

	if pImage2 and pWindow1 then
		pWindow1:addChild(tolua.cast(pImage2, "SCNode"))
	end
	if pButton3 and pWindow1 then
		pWindow1:addChild(tolua.cast(pButton3, "SCNode"))
	end
	if pButton4 and pWindow1 then
		pWindow1:addChild(tolua.cast(pButton4, "SCNode"))
	end
	if pButton5 and pWindow1 then
		pWindow1:addChild(tolua.cast(pButton5, "SCNode"))
	end
	if pButton6 and pWindow1 then
		pWindow1:addChild(tolua.cast(pButton6, "SCNode"))
	end
	if pImage7 and pWindow1 then
		pWindow1:addChild(tolua.cast(pImage7, "SCNode"))
	end
	if pImage8 and pWindow1 then
		pWindow1:addChild(tolua.cast(pImage8, "SCNode"))
	end
	if pImage9 and pWindow1 then
		pWindow1:addChild(tolua.cast(pImage9, "SCNode"))
	end
	if pImage10 and pWindow1 then
		pWindow1:addChild(tolua.cast(pImage10, "SCNode"))
	end
	if pImage11 and pWindow1 then
		pWindow1:addChild(tolua.cast(pImage11, "SCNode"))
	end
	if pButton12 and pWindow1 then
		pWindow1:addChild(tolua.cast(pButton12, "SCNode"))
	end
	if pLable13 and pWindow1 then
		pWindow1:addChild(tolua.cast(pLable13, "SCNode"))
	end
	if pLable14 and pWindow1 then
		pWindow1:addChild(tolua.cast(pLable14, "SCNode"))
	end
	if pLable15 and pWindow1 then
		pWindow1:addChild(tolua.cast(pLable15, "SCNode"))
	end
	if pLable16 and pWindow1 then
		pWindow1:addChild(tolua.cast(pLable16, "SCNode"))
	end
	if pLable17 and pWindow1 then
		pWindow1:addChild(tolua.cast(pLable17, "SCNode"))
	end
	return pWindow1
end
function yanwu.releaseControl()
	if yanwu.wndClose then
		yanwu.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
---------打开界面消息-------------
function yanwu_init()
    local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if   dt  then
        dt:writeShort(ARENASCRITP_YANWU_INFO);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show();
    end     
end 
-------------玩法说明-------------
local function yanwu_explain()
	local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("50050"))
	local pframeWnd = FrameWindow:frameWnd();
    if pframeWnd and wnd then
        local szWnd = CCSizeMake(SX(450), SY(200))
        pframeWnd:setTag(1000)
        pframeWnd:setContentSize(szWnd);
        pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
        pframeWnd:luaSetSelectorOnTouched(function () 
		pframeWnd:removeFromParentAndCleanup(true)
        end)
        local pParsedNode = getItemTextNode(L("str21061"), 0, 11);
        if pParsedNode then
            pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            pParsedNode:setPerWidthAndHeight(0, 15)
            pParsedNode:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, pframeWnd:getContentSize().height / 2));
            pframeWnd:addChild(pParsedNode);
        end
        pframeWnd:setCloseBtnVisible(false);
        pframeWnd:setPosition(CCPointMake(wnd:getContentSize().width / 2, wnd:getContentSize().height / 2));
        wnd:addChild(pframeWnd)
    end
end 

--演武主界面
function yanwu_showWnd(tmp)
    local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(50050);
    --local wndCtrl =  nil;
	if wndCtrl then
	    wnd = wndCtrl:getWindow();   -----不是很清楚
	else
        wnd = yanwu.initControl();   -----不是很清楚
        if wnd then
            local wndCtrl = SCWindowController:controllerWithWindow(wnd)
            local naviCtrl = getCurentSceneNavigationController()
            if wndCtrl and naviCtrl then
                naviCtrl:pushWindowController(wndCtrl)
                wnd:setCloseButtonVisibled(false)
                wnd:setFrameVisibled(false);
            end
        end
	end
	--------关闭按钮--------
	local pimage = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("50050-2"))
	local close_btn = SCButton:button(EnumBtnTypeNormalImg)
	if close_btn and pimage then
		close_btn:luaSetSelectorOnClicked(yanwu_close_wnd)
		close_btn:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		close_btn:setPosition(CCPointMake(pimage:getContentSize().width - SX(25), pimage:getContentSize().height - SY(25)))
		close_btn:setTouchRectScale(2.0, 2.0)
		local imgPath = getRealUIResourcePath("img/new00123.png")
		if imgPath then
			close_btn:setTitle(imgPath:getData())
		end
		pimage:addChild(close_btn)
	end 
	-------人物头像   玩家数量---------tmp.stYanWuFieldInfo[].nNum
	local imgPath = nil 
	local profession = Hero:getSingleton():getProfessionID()
	if 1 == profession then
		imgPath = getRealUIResourcePath("img/new00627.png")
	elseif 2 == profession then
		imgPath = getRealUIResourcePath("img/new00630.png")
	elseif 3 == profession then
		imgPath = getRealUIResourcePath("img/new00629.png")
	elseif 4 == profession then
		imgPath = getRealUIResourcePath("img/new00628.png")
	end
	if imgPath then
		local pimage = SCImage:imageWithFile(imgPath:getData())
		if pimage then
			pimage:setScale(0.7)
			if  tmp.nType == 1 then
				pimage:setPosition(AUTO_POS(160, 26.26))
			elseif  tmp.nType == 2 then
				pimage:setPosition(AUTO_POS(170, 150))
			elseif  tmp.nType == 3 then
				pimage:setPosition(AUTO_POS(340, 70))
			elseif  tmp.nType == 4 then
				pimage:setPosition(AUTO_POS(372, 202))
			else
				pimage:setVisible(false)
			end 
			wnd:addChild(pimage)
		end 
	end 
	local str = tmp.stYanWuFieldInfo[1].nNum..L("str21086")
	local popnum = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(12));
	if popnum then
		popnum:setPosition(AUTO_POS(30,13))
	end 
	local str = tmp.stYanWuFieldInfo[2].nNum..L("str21081")
	local popnum1 = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(12));
	if popnum1 then
		popnum1:setPosition(AUTO_POS(30,13))
	end 
	local str = tmp.stYanWuFieldInfo[3].nNum..L("str21081")
	local popnum2 = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(12));
	if popnum2 then
		popnum2:setPosition(AUTO_POS(30,13))
	end 
	local str = tmp.stYanWuFieldInfo[4].nNum..L("str21081")
	local popnum3 = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(12));
	if popnum3 then
		popnum3:setPosition(AUTO_POS(30,13))
	end 
	
	------------------------
	--[[
	local pLable13 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("50050-13"))
	if pLable13 then
	    pLable13:setText(L("str21012"))
	    pLable13:setColor(color_green)
	end 
	]]
	local pLable14 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("50050-14"))
	if pLable14 then
	    pLable14:setText(L("str21008"))
	    pLable14:addChild(popnum)
	end 
	local pLable15 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("50050-15"))
	if pLable15 then
	    pLable15:setText(L("str21009"))
	    pLable15:addChild(popnum1)
	end 
	local pLable16 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("50050-16"))
	if pLable16 then
	    pLable16:setText(L("str21010"))
	    pLable16:addChild(popnum2)
	end 
	local pLable17 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("50050-17"))
	if pLable17 then
	    pLable17:setText(L("str21011"))
	    pLable17:addChild(popnum3)
	end 
	local pButton3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("50050-3"))
	if pButton3 then
		pButton3:setTag(3)
	    pButton3:luaSetSelectorOnClicked(yanwu_chosselev)
	end 
	local pButton4 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("50050-4"))
	if pButton4 then
		pButton4:setTag(4)
	    pButton4:luaSetSelectorOnClicked(yanwu_chosselev)
	end 
	local pButton5 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("50050-5"))
	if pButton5 then
		pButton5:setTag(5)
	    pButton5:luaSetSelectorOnClicked(yanwu_chosselev)
	end 
	local pButton6 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("50050-6"))
	if pButton6 then
		pButton6:setTag(6)
	    pButton6:luaSetSelectorOnClicked(yanwu_chosselev)
	end 
	local pButton = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("50050-12"))
	if pButton then
	    pButton:luaSetSelectorOnClicked(yanwu_explain)
	end 
end
---------演武场等级选择--------------------
--[[
function yanwu_chosselev(tag)
    if  tag == 3  then
        --yanwu1_showWnd()
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if   dt  then
            dt:writeShort(ARENASCRITP_YANWU_OPEN_VIEW);
            dt:writeInt(YANWUFIELD_COMMON);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show();
        end 
        xingji_mark = tag
    elseif  tag == 4 then
        --yanwu2_init()
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if   dt  then
            dt:writeShort(ARENASCRITP_YANWU_OPEN_VIEW);
            dt:writeInt(YANWUFIELD_PRIMARY);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show();
        end 
        xingji_mark = tag
    elseif   tag == 5 then
        --yanwu1_showWnd()
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if   dt  then
            dt:writeShort(ARENASCRITP_YANWU_OPEN_VIEW);
            dt:writeInt(YANWUFIELD_INTERMEDIATE);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show();
        end 
        xingji_mark = tag
    elseif   tag == 6  then
        --yanwu1_showWnd()
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if   dt  then
            dt:writeShort(ARENASCRITP_YANWU_OPEN_VIEW);
            dt:writeInt(YANWUFIELD_ADVANCED);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show();
        end 
        xingji_mark = tag
    end
end
-------------位置空否标记----------------
function send_yanwumark(tag)
    if   yanwu_mark.ucAmount ~= 0  then
        return yanwu_mark.stYanWuPlayerInfo[tag];
    else
        return xingji_mark;
    end
end 
]]
--------关闭演武场选择界面-----
function yanwu_close_wnd()
	local wndCtrl = getCurentSceneWindowController(50050);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end
end 
----------------消息处理区----------------
local function yanwu_recWinsInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    local action = dt:readShort();
    if  action ==  ARENASCRITP_YANWU_INFO then
        local tmp = styanwuInfo.initWithStream(dt)
        yanwu_showWnd(tmp)
    elseif  action == ARENASCRITP_YANWU_PLAYERINFO  then
        local tmp = styanwu1Info.initWithStream(dt)
        
    elseif  action == ARENASCRITP_YANWU_PLAYERINFO_END  then    
		local tmp = styanwu1Info.initWithStream(dt)
		yanwu1_showWnd()
        yanwu1_showpeo(yanwu_mark)
        yanwu1_show_new(yanwu_mark)
    elseif  action == ARENASCRITP_YANWU_AWARDINFO  then
        local tmp = stYanWuAwardInfo.initWithStream(dt)    
        yanwu1_time_end(tmp)
	elseif action == ARENASCRITP_YANWU_LATELYINFO  then
		local tmp = styanwuhisnumInfo.initWithStream(dt)
		yanwu1_news(tmp)
    end 
end 
------------人物信息TIP-----------
--[[
function yanwu_hero_show()
	
	yanuw3_init(38,yanwu_mark)
	tag = tag - 37;
    if yanwu_mark[tag].idPlayer ~= nil  then
		yanuw3_init();
	end
	
end ]]
----------------消息注册区----------------

--//SCMessageCenter:getSingleton():luaRegistCommand(yanwu_recWinsInfo, _MSG_ARENA, 0, nil)
----------------全局函数区----------------



--函数调用