local m_nLastSetCount = nil;
local m_select = nil;
local m_selectPage = nil;
local m_initPointX = nil;
local m_initPointY = nil;
local m_showOrHide = nil;

-----------------------------------------------------------------------------------
local haveUserControllerFlag = 0;  -- 0 官网 1 有进入社区 2 没有进入社区和用户中心 3有用户中心
local appName = getAppName():getData();

local YKAccountInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.usActionType = dt:readByte();
        local scStr = dt:readString()
            if scStr == nil then
                tmp.strAccount = ""
            else
                tmp.strAccount = scStr:getData()
        end
        scStr = dt:readString()
            if scStr == nil then
                tmp.strPwd = ""
            else
                tmp.strPwd = scStr:getData()
        end
        return tmp
    end
}

local Info = {
    __mode = "kv",
    strAccName,
    strPwd,
    strServerName,
    nLine,
}

local function saveShowPlaerCount()
    local toSaveFile = SCPath:getSingleton():getDocumentPath():getData();
    if nil == toSaveFile then
        return;
    end
    toSaveFile = toSaveFile .. "otherSetting";
    local SOS = SCOutputStream:stream();
    if SOS then
        SOS:writeInt(m_nLastSetCount);
        SOS:saveToFile(toSaveFile);
    end
end

local function AccountWndClose()
    saveShowPlaerCount();
    m_nLastSetCount = nil;
    m_select = nil;
    m_selectPage = nil;
    m_initPointX = nil;
    m_initPointY = nil;
    Info = {__mode = "kv"}
end

local function saveSoundIsOpenSet( mute, backgroundmusic, gamesound, keyboard )
    local toSaveFile = SCPath:getSingleton():getDocumentPath():getData();
    if nil == toSaveFile then
        return;
    end
    toSaveFile = toSaveFile .. "SoundIsOpenSet";
    local SOS = SCOutputStream:stream();
    if SOS then
        SOS:writeByte(mute);
        SOS:writeByte(backgroundmusic);
        SOS:writeByte(gamesound);
        SOS:writeByte(keyboard);
        SOS:saveToFile(toSaveFile);
    end
end

local function onClickDefaultSound(tag)
    local pNode  = SCFunction:getUiNodeByIdlist("2012-1-107");
    if nil == pNode then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(106));
    if node then
        local checkbox = SCTypeCast:castNodeToCheckBox(node:getChildByTag(111));
        if checkbox then
            if false == checkbox:isSelect() then
                setBackGroundMusicEnable(true);
            end
            checkbox:setSelect(true);
        end
        checkbox = SCTypeCast:castNodeToCheckBox(node:getChildByTag(112));
        if checkbox then
            if false == checkbox:isSelect() then
                setEffectMusicEnable(true);
            end
            checkbox:setSelect(true);
        end
        checkbox = SCTypeCast:castNodeToCheckBox(node:getChildByTag(110));
        if checkbox then
            checkbox:setSelect(false);
        end
        saveSoundIsOpenSet(0, 1, 1);
    end
end

local function onCheckBox(tag)
    local pNode  = SCFunction:getUiNodeByIdlist("2012-1-107");
    if nil == pNode then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(106));
    if node then
        local checkbox0 = SCTypeCast:castNodeToCheckBox(node:getChildByTag(110));   
        local checkbox1 = SCTypeCast:castNodeToCheckBox(node:getChildByTag(111));            
        local checkbox2 = SCTypeCast:castNodeToCheckBox(node:getChildByTag(112));         
        local checkbox3 = SCTypeCast:castNodeToCheckBox(node:getChildByTag(113));         
        local checkbox4 = SCTypeCast:castNodeToCheckBox(node:getChildByTag(114));
        if checkbox0 and checkbox1 and checkbox2 then
            if 110 == tag then
                local b = checkbox0:isSelect();
                if false == b then
                    setBackGroundMusicEnable(true);
                    checkbox1:setSelect(true);
                    setEffectMusicEnable(true);
                    checkbox2:setSelect(true);
                else
                    checkbox1:setSelect(false);
                    checkbox2:setSelect(false);
                    setBackGroundMusicEnable(false);
                    setEffectMusicEnable(false);
                end
            elseif 111 == tag then
                local b = checkbox1:isSelect();
                if false == b then
                    setBackGroundMusicEnable(false);
                end
                if true == b then
                    checkbox0:setSelect(false);
                    setBackGroundMusicEnable(true);
                elseif checkbox2:isSelect() == false then
                    checkbox0:setSelect(true);
                end
            elseif 112 == tag then
                local b = checkbox2:isSelect();
                if false == b then
                    setEffectMusicEnable(false);
                end
                if true == b then
                    checkbox0:setSelect(false);
                    setEffectMusicEnable(true);
                elseif checkbox1:isSelect() == false then
                    checkbox0:setSelect(true);
                end            
            elseif 113 == tag then
                local b = checkbox3:isSelect();
                if true == b then
                    checkbox4:setSelect(false);
                else
                    checkbox4:setSelect(true);
                end         
            elseif 114 == tag then
                local b = checkbox4:isSelect();
                if true == b then
                    checkbox3:setSelect(false);
                else
                    checkbox3:setSelect(true);
                end
            end
            local mute = nil;
            local backgroundmusic = nil;
            local gamesound = nil;
            local keyboard = nil;
            if true == checkbox0:isSelect() then
                mute = 1;
            else
                mute = 0;
            end
            if true == checkbox1:isSelect() then
                backgroundmusic = 1;
            else
                backgroundmusic = 0;
            end
            if true == checkbox2:isSelect() then
                gamesound = 1;
            else
                gamesound = 0;
            end
            if true == checkbox3:isSelect() then
                keyboard = 1;
                Hero:getSingleton():setKeyboardType(false);
            else
                keyboard = 0;
                Hero:getSingleton():setKeyboardType(true);
            end
            saveSoundIsOpenSet(mute, backgroundmusic, gamesound, keyboard);
        end
    end
end

local function onClickCheckType(tag)
    local pNode  = SCFunction:getUiNodeByIdlist("2012-1-107");
    if nil == pNode then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(106));
    if node then
        local index = 108 + tag;
        if tag > 9 then
            index = 103 + tag;
        end
        local checkbox = SCTypeCast:castNodeToCheckBox(node:getChildByTag(index));
        if checkbox then
            local b = checkbox:isSelect();
            if true == b then
                checkbox:setSelect(false);
            else
                checkbox:setSelect(true);
            end            
            onCheckBox(index);
        end
    end
end

local function loadSoundInitSet()
    local toReadFile = SCPath:getSingleton():getDocumentPath():getData();
    toReadFile = toReadFile .. "SoundIsOpenSet";
    if false == SCFile:isFileExists(SCString:stringWithString(toReadFile)) then
        return 0, 1, 1, 1;
    end
    local SIS = SCInputStream:streamWithFile(toReadFile);
    if 0~=SIS:getSize()then        
        local mute = SIS:readByte();
        local backgroundmusic = SIS:readByte();
        local gamesound = SIS:readByte();
        local keyboard = SIS:readByte();
        return mute, backgroundmusic, gamesound, keyboard
    else
        return 0, 1, 1, 1;
    end
end

local function SoundInitValue()
    local pNode  = SCFunction:getUiNodeByIdlist("2012-1-107");
    if nil == pNode then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(106));
    if node then
        node:setFrameVisibled(true);
        node:setFrameType(EnumFrameTypeRound);
        for i = 1, 3 do
            local pDragNode = SCTypeCast:castNodeToDragNode(node:getChildByTag(i + 4));
            if pDragNode then
                pDragNode:setFrameVisibled(true);
                pDragNode:setFrameType(EnumFrameTypeListNormal);
            end
        end
        setNodePostion(node,CCPointMake(33, 17));   
        local b1, b2, b3, b4 = loadSoundInitSet();     
        local checkbox = SCCheckBox:boxWithDescribe(_LTParser("str6025"), getDefaultFontName(), getFontSize(12));
        if checkbox then
            setNodePostion(checkbox, CCPointMake(100, 180));
            checkbox:setTag(110);
            checkbox:luaSetSelectorOnButtonClicked(onCheckBox);
            node:addChild(checkbox);
            if b1 == 1 then
                checkbox:setSelect(true);
            else
                checkbox:setSelect(false);
            end
        end
        checkbox = SCCheckBox:boxWithDescribe(_LTParser("str6026"), getDefaultFontName(), getFontSize(12));
        if checkbox then
            setNodePostion(checkbox, CCPointMake(200, 180));
            checkbox:setTag(111);
            checkbox:luaSetSelectorOnButtonClicked(onCheckBox);
            node:addChild(checkbox);
            if b2 == 1 then
                checkbox:setSelect(true);
            else
                checkbox:setSelect(false);
            end
        end
        checkbox = SCCheckBox:boxWithDescribe(_LTParser("str6027"), getDefaultFontName(), getFontSize(12));
        if checkbox then
            setNodePostion(checkbox, CCPointMake(300, 180));
            checkbox:setTag(112);
            checkbox:luaSetSelectorOnButtonClicked(onCheckBox);
            node:addChild(checkbox);
            if b3 == 1 then
                checkbox:setSelect(true);
            else
                checkbox:setSelect(false);
            end
        end
        checkbox = SCCheckBox:boxWithDescribe(_LTParser("str6258"), getDefaultFontName(), getFontSize(12));
        if checkbox then
            setNodePostion(checkbox, CCPointMake(110, 126));
            checkbox:setTag(113);
            checkbox:luaSetSelectorOnButtonClicked(onCheckBox);
            node:addChild(checkbox);
            if b4 == 1 then
                checkbox:setSelect(true);
            else
                checkbox:setSelect(false);
            end
        end
        checkbox = SCCheckBox:boxWithDescribe(_LTParser("str6259"), getDefaultFontName(), getFontSize(12));
        if checkbox then
            setNodePostion(checkbox, CCPointMake(259, 126));
            checkbox:setTag(114);
            checkbox:luaSetSelectorOnButtonClicked(onCheckBox);
            node:addChild(checkbox);
            if b4 == 1 then
                checkbox:setSelect(false);
            else
                checkbox:setSelect(true);
            end
        end
        for i = 2, 4 do
            local btn = SCTypeCast:castNodeToButton(node:getChildByTag(i));
            if btn then
                btn:luaSetSelectorOnClicked(onClickCheckType);
                btn:setContentSize(AUTO_SIZE(90, 30));
                --btn:setBackgroundColor(color_window_red_bg);
            end
        end
        for i = 10, 11 do
            local btn = SCTypeCast:castNodeToButton(node:getChildByTag(i));
            if btn then
                btn:luaSetSelectorOnClicked(onClickCheckType);
                btn:setContentSize(AUTO_SIZE(110, 30));
            end
        end
        local btn = SCTypeCast:castNodeToButton(node:getChildByTag(1));
        if btn then
            btn:luaSetSelectorOnClicked(onClickDefaultSound);
        end
    end
end

local function joinInTeam(tag, itemIndex)
    local setCount = 0;
    if 0 == itemIndex then
        setCount = 0;
    elseif 1 == itemIndex then
        setCount = 4;
    elseif 2 == itemIndex then
        setCount = 5;
    elseif 3 == itemIndex then
        setCount = 10;
    elseif 4 == itemIndex then
        setCount = 20;
    elseif 5 == itemIndex then
        setCount = 999;
    end
    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
    if mapLay then
        m_nLastSetCount = setCount;
        mapLay:showPlayer(setCount);
    end
end

local function unSelset(tag, itemIndex)
end

local function getLastID(id)
    local nRet = 0;
    if 0 == id then
        nRet = 0;
    elseif 4 == id then
        nRet = 1;
    elseif 5 == id then
        nRet = 2;
    elseif 10 == id then
        nRet = 3;
    elseif 20 == id then
        nRet = 4;
    elseif 999 == id then
        nRet = 5;
    end
    return nRet;
end

local function onClickType(tag)
    --[[local pNode  = SCFunction:getUiNodeByIdlist("2012-1-107");
    if nil == pNode then
        return;
    end]]
    local pmultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("2012-1-107"));
    if nil == pmultiPage then
        return;
    end
    local pNode = pmultiPage:getPageWithIndex(2);
    if nil == pNode then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(105));
    if node then
        local rg = SCTypeCast:castNodeToRadioGroup(node:getChildByTag(109));
        if rg then
            rg:setSelectIndex(tag - 3);
        end
    end
end

local function onClickDefaultDisplay(tag)
    local pmultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("2012-1-107"));
    if nil == pmultiPage then
        return;
    end
    local pNode = pmultiPage:getPageWithIndex(2);
    if nil == pNode then
        return;
    end
    --[[local pNode  = SCFunction:getUiNodeByIdlist("2012-1-107");
    if nil == pNode then
        return;
    end]]
    local node = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(105));
    if node then
        local rg = SCTypeCast:castNodeToRadioGroup(node:getChildByTag(109));
        if rg then
            rg:setSelectIndex(4);
        end
    end
end

local function functionInitValue(node)
    --[[local pNode  = SCFunction:getUiNodeByIdlist("2012-1-107");
    if nil == pNode then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(105));]]
    if node then
        node:setFrameVisibled(true);
        node:setFrameType(EnumFrameTypeRound);
        setNodePostion(node,CCPointMake(33, 17));
        local rg = SCRadioGroup:newSCRadioGroup();
        if rg then
            rg:luaSetSelectorOnItemSelected(joinInTeam)
            rg:luaSetSelectorOnItemUnSelected(unSelset)
            rg:setRowAndColumnCount(3, 2);
            rg:setRowWidthAncColumnHeight(193, 46);
            local str = "str60";
            for i = 1, 6 do
                rg:setDescribe(i - 1, _LTParser(str .. (19 + i - 1)), getDefaultFontName(), getFontSize(12));
            end
        end
        setNodePostion(rg, CCPointMake(50,18));
        rg:setTag(109);
        node:addChild(rg);
        rg:setSelectIndex(getLastID(m_nLastSetCount));
        for i = 3, 8 do
            local btn = SCTypeCast:castNodeToButton(node:getChildByTag(i));
            if btn then
                btn:luaSetSelectorOnClicked(onClickType);
            end
        end
        local btn = SCTypeCast:castNodeToButton(node:getChildByTag(2));
        if btn then
            btn:luaSetSelectorOnClicked(onClickDefaultDisplay);
        end
    end
end

local function onClickedDelete(tag)
    if 1 == tag then
        local dwTimeStamp = 0;
        local idUser = Hero:getSingleton():getID();
        local unPosX = 0;
        local unPosY = 0;
        local unDir = 0;
        local dwData = 0;
        local usAction = 149;
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_ACTION);
        dataStream:writeInt(dwTimeStamp);
        dataStream:writeInt(idUser);
        dataStream:writeShort(unPosX);
        dataStream:writeShort(unPosY);
        dataStream:writeShort(unDir);
        dataStream:writeInt(dwData);
        dataStream:writeShort(usAction);
        SCDataTransThread:getSingleton():transData(dataStream);
        
        --[[local toReadFile = SCPath:getSingleton():getDocumentPath():getData();  --删除角色会重新弹出引导界面
        toReadFile = toReadFile .. "FristIsLogonSet";
        if true == SCFile:isFileExists(SCString:stringWithString(toReadFile)) then
            FirstLoginVeiw_saveFile(2)
        end]]
        FirstLoginVeiw_setIsClose(false)
        GuidePoint_CloseTimer()
		InitshowIconStatus();
    end
end

local function onIsDelete(tag)
	showMessage(L("str3287"))
    --luashowConfirmationWindow(_LTParser("str0004"), WIN_YES_NO, onClickedDelete);
end

local function getUserLoginInfoIndex(index)
	local pInfo = LoginLogic:getSingleton():getLoginInfo()
	if pInfo and pInfo.strAccName and pInfo.strPwd and pInfo.strServerName and pInfo.nLine 
		and pInfo.strAccName:length() ~= 0 and pInfo.strPwd:length() ~= 0 then
		Info.strAccName = pInfo.strAccName
		Info.strPwd = pInfo.strPwd
		Info.strServerName = pInfo.strServerName
		Info.nLine = pInfo.nLine
		return Info
	end
	
    local bRet = true;
    local toReadFile = SCPath:getSingleton():getDocumentPath():getData();
    toReadFile = toReadFile .. "Account_login_info";
    if false == SCFile:isFileExists(SCString:stringWithString(toReadFile)) then
        bRet = false;
        return nil;
    end
    local SIS = SCInputStream:streamWithFile(toReadFile);
    local accoutCount = SIS:readInt();
    if 0==SIS:getSize() or 0==accoutCount or index>=accoutCount then
        Info.strAccName = "";
        Info.strPwd = "";
        Info.strServerName = "";
        Info.nLine = -1;
        bRet = false;
        return Info;
    end

    for i = 1, accoutCount do
        if i - 1 == index then
            Info.strAccName = SIS:readString();
            Info.strPwd = SIS:readString();
            Info.strServerName = SIS:readString();
            Info.nLine = SIS:readInt();
            break;
        end
        SIS:readString();
        SIS:readString();
        SIS:readString();
        SIS:readInt();
    end
    return Info;
end

local function accountMgrInitValue(node)
    --[[local pNode  = SCFunction:getUiNodeByIdlist("2012-1-107");
    if nil == pNode then
        return;
    end
    local node = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(101));]]
    if node then
        node:setFrameVisibled(true);
        node:setFrameType(EnumFrameTypeRound);
        setNodePostion(node,CCPointMake(33, 17));
        local dragNode = SCTypeCast:castNodeToDragNode(node:getChildByTag(12));
        if dragNode then
            dragNode:setFrameVisibled(true);
            dragNode:setFrameType(EnumFrameTypeListNormal);
        end
        local data = getUserLoginInfoIndex(0);
        local serverName = LoginLogic:getSingleton():getServerName();
        local pLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(5));
        if pLabel then
            if nil == serverName then
                pLabel:setText("");
            else
                local isOneLine = LoginLogic:getSingleton():getisOneLine();
                if isOneLine == 1 then
                    pLabel:setText(serverName .. _LTParser("str0001"));
                else
                    pLabel:setText(serverName .. _LTParser("str0001") .. (data.nLine + 1) .. _LTParser("str0002"));
                end
            end
            pLabel:setColor(color_yellow);
        end

    
        local pInfo = Hero:getSingleton():getHeroInfo();
        pLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(6));
        local pLabel2 = SCTypeCast:castNodeToLabel(node:getChildByTag(7));
        local pLabel3 = SCTypeCast:castNodeToLabel(node:getChildByTag(11));
        if pLabel and pInfo and pLabel2 and pLabel3 then
            pLabel:setText(pInfo.strName:getData());
            pLabel2:setText(pInfo.ucLevel);
            pLabel3:setText(getProfession());
        end
        
        local imgPath = getRealUIResourcePath("img/img2548.png")
        if imgPath then
            local img = SCImage:imageWithFile(imgPath:getData());
            if img then
                img:setAnchorPoint(CCPointMake(0.5, 0.5));                        
                setNodePostion(img,CCPointMake(80, 105));
                node:addChild(img);
            end
        end
        --local ani = LookfaceParser:getSingleton():getAnimationByLookFaceAndIndex(Hero:getSingleton():getLookFace());
        local ani = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(Hero:getSingleton():getLookFace(), dirAction_Stand);
        if ani then    
            --ani:setTransMirror(true);
            ani:setFrameAnchor(EnumFrameAnchorFoot);
            local pLookNode = SCAnimationNode:nodeWithAnimation(ani);
            if pLookNode then
                pLookNode:setAnchorPoint(CCPointMake(0.5, 0));
                setNodePostion(pLookNode,CCPointMake(80, 100));
                
                node:addChild(pLookNode);
            end
        end

        local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(3));
        if pBtn then
            pBtn:luaSetSelectorOnClicked(onIsDelete);
			pBtn:setButtonType(EnumBtnTypeAsh)
        end
    end
end

local function onPageFunctionSelected(tag, pageIndex)
    local pmultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("2012-1-107"));
    if nil == pmultiPage then
        return;
    end
    local pNode = pmultiPage:getPageWithIndex(pageIndex);
    if nil == pNode then
        return;
    end
    if 0 == pageIndex then
        m_select = pageIndex;
    elseif 1 == pageIndex then
        POP_TOP_CTRL()
        FirstLoginVeiw_setIsLogin(false)
        showAnnouncementWnd();
        --[[
        if nil == m_select then
            m_select = 0;
        end
        pmultiPage:selectPageWithIndex(m_select);
        ]]
    elseif 2 == pageIndex then
        m_select = pageIndex;
        local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(105));
        if nil == pDragNode then
            pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(2012, 105));
			local pDragNode1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1",pDragNode));
			if pDragNode1 then
				pDragNode1:setAnchorPoint(CCPointMake(0.5, 0));
				pDragNode1:setPosition(CCPointMake(pDragNode:getContentSize().width/2, pDragNode1:getPosition().y));
			end 
            if pDragNode then
                pNode:addChild(pDragNode);
                functionInitValue(pDragNode);
            end               
        end
    elseif 3 == pageIndex then
        m_select = pageIndex;
        local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(101));
        if nil == pDragNode then
            pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(2012, 101));
            if pDragNode then
                pNode:addChild(pDragNode);
                accountMgrInitValue(pDragNode);
            end               
        end
     elseif 4 == pageIndex then
         m_select = 0;
         pmultiPage:selectPageWithIndex(0);
         if CLIENT_VERSION <326 then  --版本判断
             enterForumCenter();   --登录论坛
         end
    end
end

local function functionInit()
    local pmultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("2012-1-107"));
    if pmultiPage then
        pmultiPage:luaSetSelectorOnPageSelected(onPageFunctionSelected);
        SoundInitValue();
        --functionInitValue();
    end
end

local function onClickMenuList(tag)    
    LoginLogic:getSingleton():showAccountManagement(tag);
end

local function onClickedChangeLoginBtn(tag)
	local edtAccount = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-108-102-5"));
    if nil == edtAccount then
        return;
    end
	local edtPassword = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-108-102-6"));
    if nil == edtPassword then
        return;
    end
    local pInfo = LoginLogic:getSingleton():getLoginInfo();
    local isMac = LoginLogic:getSingleton():returnAccountStateFlag();
    if pInfo and isMac == 0 and 10 ~= tag then
        LoginLogic:getSingleton():showFastRegitsterWin();
    elseif 9 == tag then    --切换账号
        if nil == edtAccount:getContentText() or #edtAccount:getContentText() == 0 then
            showMessage(_LTParser("str0005"));
            return;
        end

        if nil == edtPassword:getContentText() or #edtPassword:getContentText() == 0 then
            showMessage(_LTParser("str0006"));
            return;
        end
		
        LoginLogic:getSingleton():luasaveUserLoginInfo(edtAccount:getContentText(), edtPassword:getContentText());
        LoginLogic:getSingleton():startLoginScene();
        --SCDataTransThread *nd = SCDataTransThread::getSingleton();
        SCDataTransThread:getSingleton():stop();
		Announcement_clearAnnouncementTabel()
        LoginLogic:getSingleton():sendMsgToAccountServer(OperationStartGame);
        GuidePoint_CloseTimer();
		InitshowIconStatus();
        GuidePoint_InitFlag();
    elseif 10 == tag then   --切换服务器
      if pInfo and isMac == 0 then
      else
        --LoginLogic:getSingleton():luasaveUserLoginInfo(edtAccount:getContentText(), edtPassword:getContentText());
      end
      CopymapSweep_setIsSweeping(false);
      FirstLoginVeiw_setIsClose(false)
		Announcement_clearAnnouncementTabel()
        LoginLogic:getSingleton():startLoginScene();
        SCDataTransThread:getSingleton():stop();
        LoginLogic:getSingleton():sendMsgToAccountServer(OperationSwitchServer);
    elseif 11 == tag then     --账号注册
        --LoginLogic:getSingleton():startLoginScene();
        --SCDataTransThread:getSingleton():stop();
        LoginLogic:getSingleton():showFastRegitsterWin();
    elseif 12 == tag then  --修改密码
		local info = LoginLogic:getSingleton():getLoginInfo()
		if info.nCmpType == 103 then
			return
		end
        openU9501();
        --[[local pmenuList = menuList:newStringList()
        if pmenuList then
            pmenuList:createMenu(_LTParser("str6079"), 2, _LTParser("str6080") .. "_" .. _LTParser("str6081") .. "_" .. _LTParser("str6082") .. "_" .. _LTParser("str6083"));
            pmenuList:luasetSelector(onClickMenuList);
        end]]
    end
end

local function onEditBeginInput(tag)   
    local m_wnd = getCurentSceneWindow(2012);
    if nil == m_wnd then
        return;
    end
    local pNode = nil;
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("2012-1"));
    if pMultiPage then
        pNode = SCTypeCast:castNodeToDragNode(pMultiPage:getCurrentPage());
    end
    if 1 == pMultiPage:selectedPageIndex() then
        pNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(102));
    else
        pNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(103));
    end
    if nil == pNode then
        return;
    end
    local moveSize = 0;
    local pNode = SCTypeCast:castNodeToEdit(pNode:getChildByTag(tag));
    while pNode ~= nil do
        if m_wnd:getTag() == pNode:getTag() then
            break;
        end
        moveSize = moveSize + pNode:getPosition().y - pNode:getAnchorPoint().y * pNode:getContentSize().height;
        pNode = tolua.cast(pNode:getParent(), "SCNode");
    end
    m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPointX, m_initPointY + 200 * gUIScale().y - moveSize)));
end

local function onEditEndInput(tag)
    local m_wnd = getCurentSceneWindow(2012);
    if nil == m_wnd then
        return;
    end
    m_wnd:runAction(CCMoveTo:create(0.2, CCPointMake(m_initPointX, m_initPointY)));
end

local function changeLoginInit(pNode)
    if nil == pNode then
        return;
    end

    local pInfo = Hero:getSingleton():getHeroInfo();

    local data = getUserLoginInfoIndex(0);

     local edtAccount = SCTypeCast:castNodeToEdit(pNode:getChildByTag(5));
     if edtAccount then
         edtAccount:setBottomColor(color_transparent);
         edtAccount:setFontColor(color_white);
         if nil == data then
            edtAccount:setContentText("");     
         else
            edtAccount:setContentText(data.strAccName:getData());     
         end    
     end
    
     local edtPassword = SCTypeCast:castNodeToEdit(pNode:getChildByTag(6));
     if edtPassword then
         edtPassword:setBottomColor(color_transparent);
         edtPassword:setFontColor(color_white);
         if nil == data then
            edtPassword:setContentText("");
         else
            edtPassword:setContentText(data.strPwd:getData());
         end
         edtPassword:setIsPasswordText(true);         
         edtPassword:luaSetSelectorOnBeginInput(onEditBeginInput);
         edtPassword:luaSetSelectorOnEndInput(onEditEndInput);
     end

     local pServerName = SCTypeCast:castNodeToLabel(pNode:getChildByTag(8));
     local serverName = LoginLogic:getSingleton():getServerName();
     if pServerName and serverName then
         if nil == data then
            pServerName:setText("");
         else            
            local isOneLine = LoginLogic:getSingleton():getisOneLine();
            if isOneLine == 1 then
                pServerName:setText(L("str0001")..L("colon")..serverName .. _LTParser("str0001"));
            else
                pServerName:setText(L("str0001")..L("colon")..serverName .. (_LTParser("str0001")) .. (data.nLine + 1) .. (_LTParser("str0002")));
            end
         end
         pServerName:setColor(color_yellow);
		pServerName:setAnchorPoint(CCPointMake(0.5, 0))
		pServerName:setPosition(CCPointMake(pNode:getContentSize().width/2, pServerName:getPosition().y))
     end

	local svLabel = pNode:getChildByTag(7)
	if svLabel then
		svLabel:setVisible(false);
	end

     for i = 9, 12 do
         local btn =SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
         if btn then
            local resPath = "img/img803";
            resPath = resPath .. (i - 4);
            resPath = resPath .. ".png";
            local res = getRealUIResourcePath(resPath);
            if res then
                btn:setTitle(res:getData());
            end
            if i == 9 then
				btn:setTitle(L("str36532"), DEFAULT_FONT_NAME, F(15))
			end
            btn:luaSetSelectorOnClicked(onClickedChangeLoginBtn);
        end
     end
	
	pNode:removeChildByTag(11, true)
	pNode:removeChildByTag(12, true)
	 
    local pInfo = LoginLogic:getSingleton():getLoginInfo();
    local isMac = LoginLogic:getSingleton():returnAccountStateFlag();
    if pInfo and isMac == 0 then
        local res = getRealUIResourcePath("img/new00538.png");
        local btn =SCTypeCast:castNodeToButton(pNode:getChildByTag(11));
        if btn and res then
            btn:setBackgroundImage(res:getData());
            btn:setSelectedImage(res:getData());
            btn:setTitle(res:getData());
        end
    end

     local pdNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(20));
     local pdNode2 = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(21));
     if pdNode2 and pdNode then
         pdNode:setFrameType(EnumFrameTypeRound);
         pdNode:setFrameVisibled(true);
         pdNode2:setFrameType(EnumFrameTypeRound);
         pdNode2:setFrameVisibled(true);
     end
end

local function onClickedRegister(tag)
    if tag == 22 then
        LoginLogic:getSingleton():startLoginScene();
        return;
    end
    local pEdtAccount = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-100-103-7"));
    if nil == pEdtAccount then
        return;
    end
    if #pEdtAccount:getContentText() == 0 then
        showMessage(_LTParser("str0005"));
        return;
    end
    local pEdtPassword01 = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-100-103-8"));
    if nil == pEdtPassword01 then
        return;
    end
    local pEdtPassword02 = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-100-103-9"));
    if nil == pEdtPassword02 then
        return;
    end
    if #pEdtPassword01:getContentText() == 0 or #pEdtPassword02:getContentText() == 0 then
        showMessage(_LTParser("str0006"));
        return;
    end
    if pEdtPassword02:getContentText() ~= pEdtPassword01:getContentText() then
        showMessage(_LTParser("str0008"));
        return;
    end
    local pSuperEdtPassword = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-100-103-9"));
    if nil == pSuperEdtPassword then
        return;
    end
    if #pSuperEdtPassword:getContentText() == 0 then
        showMessage(_LTParser("str0009"));
        return;
    end
    
    local strName = _LTParser("str0010");
    
    local str1 = pEdtAccount:getContentText();
    local str2 = pEdtPassword01:getContentText();
    local str3 = pSuperEdtPassword:getContentText();
    local str4 = strName;

    
    LoginLogic:getSingleton():luasaveResterData(str1, str2, str3);
    
    LoginLogic:getSingleton():processMACRegister(str1, str2);
    
    --[[
    local str1 = SCString:stringWithString(pEdtAccount:getContentText());
    local str2 = SCString:stringWithString(pEdtPassword01:getContentText());
    local str3 = SCString:stringWithString(pSuperEdtPassword:getContentText());
    local str4 = SCString:stringWithString(strName);
    local _MSG_YK_REGISTER = 1055;
    local ucActionType = 3;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_YK_REGISTER);
    dataStream:writeByte(ucActionType);
    dataStream:writeString(str1);
    dataStream:writeString(str2);
    dataStream:writeString(str3);
    dataStream:writeString(str4);
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();]]
end

local function registerInit(pNode)
    --[[local pNode = SCFunction:getUiNodeByIdlist("2012-1-103");
    if nil == pNode then
        return;
    end]]
    if nil == pNode then
        return;
    end
    for i = 11, 14 do
        local dragnode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(i));
        if dragnode then
            dragnode:setFrameType(EnumFrameTypeRound);
            dragnode:setFrameVisibled(true);
        end
    end
    local pEdtAccount = SCTypeCast:castNodeToEdit(pNode:getChildByTag(7));
    if pEdtAccount then
        pEdtAccount:setBottomColor(color_transparent);
        pEdtAccount:setFontColor(color_white);      
    end

    local pEdtPassword01 = SCTypeCast:castNodeToEdit(pNode:getChildByTag(8));
    if pEdtPassword01 then
        pEdtPassword01:setBottomColor(color_transparent);
        pEdtPassword01:setFontColor(color_white);
        pEdtPassword01:luaSetSelectorOnBeginInput(onEditBeginInput);
        pEdtPassword01:luaSetSelectorOnEndInput(onEditEndInput);
    end

    local pEdtPassword02 = SCTypeCast:castNodeToEdit(pNode:getChildByTag(9));
    if pEdtPassword02 then
        pEdtPassword02:setBottomColor(color_transparent);
        pEdtPassword02:setFontColor(color_white);
        pEdtPassword02:luaSetSelectorOnBeginInput(onEditBeginInput);
        pEdtPassword02:luaSetSelectorOnEndInput(onEditEndInput);
    end

    local pSuperEdtPassword = SCTypeCast:castNodeToEdit(pNode:getChildByTag(10));
    if pSuperEdtPassword then
        pSuperEdtPassword:setBottomColor(color_transparent);
        pSuperEdtPassword:setFontColor(color_white);
        pSuperEdtPassword:luaSetSelectorOnBeginInput(onEditBeginInput);
        pSuperEdtPassword:luaSetSelectorOnEndInput(onEditEndInput);
    end

    for i = 21, 22 do
        local btn = SCTypeCast:castNodeToButton(pNode:getChildByTag(i));
        if btn then
            local resPath = "img/img00";
            resPath = resPath .. i;
            resPath = resPath .. ".png";
            local res = getRealUIResourcePath(resPath);
            if res then
                btn:setTitle(res:getData());
            end
            btn:luaSetSelectorOnClicked(onClickedRegister);
        end
    end
end

local function onWindowTouched(tag)
	local edtAccount = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-108-102-5"));
    if edtAccount ~= nil and edtAccount:getIsInputing() then
        edtAccount:detachWithIME();
    end
    local edtPassword = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-108-102-6"));
    if edtPassword ~= nil and edtPassword:getIsInputing() then
        edtPassword:detachWithIME();
    end
    local pEdtAccount = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-100-103-7"));
    if pEdtAccount ~= nil and pEdtAccount:getIsInputing() then
        pEdtAccount:detachWithIME();
    end
    local pEdtPassword01 = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-100-103-8"));
    if pEdtPassword01 ~= nil and pEdtPassword01:getIsInputing() then
        pEdtPassword01:detachWithIME();
    end
    local pEdtPassword02 = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-100-103-9"));
    if pEdtPassword02 ~= nil and pEdtPassword02:getIsInputing() then
        pEdtPassword02:detachWithIME();
    end
    local pSuperEdtPassword = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-100-103-10"));
    if pSuperEdtPassword ~= nil and pSuperEdtPassword:getIsInputing() then
        pSuperEdtPassword:detachWithIME();
    end
end

local function onPageSelected(tag, pageIndex)
    onWindowTouched(0);
    local pNode = nil;
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("2012-1"));
    if pMultiPage then
        pNode = pMultiPage:getPageWithIndex(pageIndex);
        if pNode then
            if 0 == pageIndex then
                m_selectPage = pageIndex;
            elseif 1 == pageIndex then
              if haveUserControllerFlag == 0 then
                        local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(102));
                        if nil == pDragNode then
                            pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(2012, 102));
                            if pDragNode then
                                pNode:addChild(pDragNode);
                                changeLoginInit(pDragNode);
                            end               
                        end                
                        local isMac = LoginLogic:getSingleton():returnAccountStateFlag();
                        if isMac~=2 then
                            local pEdit = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-108-102-5"));
                            if pEdit then
                                pEdit:setPlaceHolder(L("str6187"));
                            end
                            pEdit = SCTypeCast:castNodeToEdit(SCFunction:getUiNodeByIdlist("2012-1-108-102-6"));
                            if pEdit then
                                pEdit:setPlaceHolder(L("str6187"));
                            end
                        end
                elseif  haveUserControllerFlag == 1 then --进入社区
                       enterUserCenter();
                       pMultiPage:selectPageWithIndex(0);
                        m_selectPage = 0;
                  
                elseif haveUserControllerFlag == 2 then --返回登录界面      
                      returnLoginScreen();
		elseif  haveUserControllerFlag == 3 then --用户中心
                       OpenUserCentre6021();
                       pMultiPage:selectPageWithIndex(0);
                        m_selectPage = 1;      
                end
                m_selectPage = pageIndex;
            elseif 2 == pageIndex then
                 if haveUserControllerFlag == 0 then
                       -- local pInfo = LoginLogic:getSingleton():getLoginInfo();
                        --local pInfo = Hero:getSingleton():getHeroInfo();
                        --if pInfo and pInfo.ucYk ~= 0 then
                       -- if pInfo and pInfo.strAccName:getData() == "" then
                       local isMac = LoginLogic:getSingleton():returnAccountStateFlag();
                       if isMac~=2 then
                            local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(103));
                            if nil == pDragNode then
                                pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(2012, 103));
                                if pDragNode then
                                    pNode:addChild(pDragNode);
                                    registerInit(pDragNode);
                                end               
                            end
                        else
                            showMessage(_LTParser("str0011"));
                            if nil == m_selectPage then
                                pMultiPage:selectPageWithIndex(0);
                            else
                                pMultiPage:selectPageWithIndex(m_selectPage);
                            end
                        end
                  else   --返回登录界面
                      returnLoginScreen();
                  end
        end
    end
   end   
    --[[local pInfo = Hero:getSingleton():getHeroInfo();
    if 2 == pageIndex and pInfo and m_pRegisterNode and pInfo.ucYk ~= 0 then
        m_pRegisterNode:setVisible(true);
    elseif 2 == pageIndex then
        showMessage(_LTParser("str0011"));
    end]]
end

-----------------------------------------------------------------
local function createWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2012));
    if wnd == nil then
        return nil 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/new00651.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(AccountWndClose);
    wnd:luaSetSelectorOnTouched(onWindowTouched);
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    local pmultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if pmultiPage then
        pmultiPage:luaSetSelectorOnPageSelected(onPageSelected);
        
        local imgPath1 = getRealUIResourcePath("img/new00650.png");  --功能
        local imgPath2 = getRealUIResourcePath("img/new00649.png");  --用户中心
        local imgPath3 = getRealUIResourcePath("img/new00698.png");  --返回登录
        local imgPath4 = getRealUIResourcePath("img/new00697.png");  --进入社区
        if imgPath1 and imgPath2 and imgPath3 and imgPath4 then
            pmultiPage:setTitleAtPage(imgPath1:getData(), 0);
            if getPlatFormFlag() == 0 then       --官网
                haveUserControllerFlag = 0;
                pmultiPage:setTitleAtPage(imgPath2:getData(), 1);              
            elseif CLIENT_VERSION <326 then   --版本判断
                   if string.match(appName, "_5GWAN") or string.match(appName, "_HUAWEI") or string.match(appName, "_XIAOMI") or string.match(appName, "_GFEN") then
                         haveUserControllerFlag = 2;
                         pmultiPage:setTitleAtPage(imgPath3:getData(), 1);
                   elseif string.match(appName, "_360") then
                         haveUserControllerFlag = 3;
                         pmultiPage:setTitleAtPage(imgPath2:getData(), 1);
                         
                         local pNode = SCNode:node()
                         if pNode then
                           pmultiPage:addPage(pNode);
                           pmultiPage:setTitleAtPage(imgPath3:getData(), 2); 
                         end
                   else
                         haveUserControllerFlag = 1;
                         pmultiPage:setTitleAtPage(imgPath4:getData(), 1);
                         
                         local pNode = SCNode:node()
                         if pNode then
                           pmultiPage:addPage(pNode);
                           pmultiPage:setTitleAtPage(imgPath3:getData(), 2); 
                         end
                   
                   end
             else
                haveUserControllerFlag = 3;
                pmultiPage:setTitleAtPage(imgPath2:getData(), 1);
            end    
        end
    end 
    return wndCtrl;
end

local function loadShowPlayer()
    local toReadFile = SCPath:getSingleton():getDocumentPath():getData();
    if nil == toReadFile then
        return;
    end
    toReadFile = toReadFile .. "otherSetting";
    if SCFile:isFileExists(SCString:stringWithString(toReadFile)) then
        local SIS = SCInputStream:streamWithFile(toReadFile);
        if SIS then
            m_nLastSetCount = SIS:readInt();
        end
    else
        m_nLastSetCount = 20;
    end
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        loadShowPlayer();
        functionInit();
        --changeLoginInit();
        --registerInit();        
        local m_wnd = getCurentSceneWindow(2012);
        if m_wnd then
            m_initPointX = m_wnd:getPosition().x;
            m_initPointY = m_wnd:getPosition().y;
        else
            m_initPointX = 0;
            m_initPointY = 0;
        end
    end
end

function showAccountWnd()
    local wndCtrl = createWnd();
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
    end
end

function OnClossAccountWnd()
    local pNavigationController = getCurentSceneNavigationController();
    if pNavigationController then
        pNavigationController:removeWindowControllerByTag(2012);
    end
end

local function processYKRegister(Data)
    if 3 == Data.usActionType then
        LoginLogic:getSingleton():luasaveUserLoginInfo(Data.strAccount, Data.strPwd);
		local str = _LTParser("str2069");
		str = str .. Data.strAccName;
		str = str .. _LTParser("str2068");
		str = str .. Data.strPwd;
		showMessage(str);
		OnClossAccountWnd();
	end
end

local function recvYKRegisterInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
    processYKRegister(YKAccountInfo.initWithStream(dt));
end

function AccountController_ShowOrHide(tag)
    if m_showOrHide == nil and tag == 999 then
        m_showOrHide = true; --显示
    end
    
    if tag == 12 then
        if m_showOrHide == true then
            m_showOrHide = false; --隐藏
        elseif m_showOrHide == false then
            m_showOrHide = true
        else
            m_showOrHide = true
        end
    end

    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
    if mapLay == nil then
        return;
    end
    
    local file1 = getRealUIResourcePath("img/new00542.png");
    local file2 = getRealUIResourcePath("img/new00541.png");
    if not file1 or not file2 then
        return
    end
    
    if m_nLastSetCount == nil then
        loadShowPlayer();
    end
    
    if m_nLastSetCount == nil then
        m_nLastSetCount = 20;
    end
    
    if m_showOrHide == true then
        mapLay:showPlayer(m_nLastSetCount);
        local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5918-5936-18"))
        if pImg then
            pImg:setImage(file1:getData())
        end
    elseif m_showOrHide == false then
        mapLay:showPlayer(0);
        local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("5918-5936-18"))
        if pImg then
            pImg:setImage(file2:getData())
        end
    end
end

--SCMessageCenter:getSingleton():luaRegistCommand(recvYKRegisterInfo, _MSG_YK_REGISTER_OK, 0, nil)