local ACHIEVEMENT_ACTION_GROP_LIST    =4 
local ACHIEVEMENT_ACTION_USE_GROUP    =5
local ACHIEVEMENT_ACTION_CHAT_SHOW    =7   --//已完成成就的展示
local ACHIEVEMENT_ACTION_GUID_INFO    =9--,   // 成就引导信息 
-------------------------------------第一层消息

local GroupListValue = {
    __mode = "kv",
}
local SecondGroupListValue = {
    __mode = "kv",
}

local stGroupListMag = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nGroup = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szGroupName = ""
        else
            tmp.szGroupName = scStr:getData()
        end
        tmp.idPhoto = dt:readInt();
        tmp.ucShow = dt:readByte();
        return tmp
    end
}

local stGroupListBag = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            ucAmount,
            setList = {},
        }
        tmp.ucAmount = dt:readByte()
        
        for i = 1, tmp.ucAmount do
            
          table.insert(tmp.setList, stGroupListMag.initWithStream(dt))
        end
            
        return tmp
    end
}

-------------------------------------第二层消息
local stAchieveListMag = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        ucShow,-- //0正常显示 1灰色显示。
        nPoints,    --    // 该成就的点数
        idPhoto,   --     // 图标ID
        szAchieveName, --//成就名
        szAchievems, --//成就描述
        }
        tmp.ucShow = dt:readByte()
        tmp.nPoints = dt:readInt()
        tmp.idPhoto = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szAchieveName = ""
        else
            tmp.szAchieveName = scStr:getData()
        end
        
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szAchievems = ""
        else
            tmp.szAchievems = scStr:getData()
        end
        return tmp
    end
}

local stAchieveListBag = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.First = dt:readByte()
        tmp.nTotalPoints = dt:readInt()
        tmp.nCompletedNum = dt:readInt()
        tmp.nTotalNum = dt:readInt()
        tmp.ucShow = dt:readByte()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szGroupName = ""
        else
            tmp.szGroupName = scStr:getData()
        end
        
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szGroupEffect = ""
        else
            tmp.szGroupEffect = scStr:getData()
        end
        tmp.ucAmount = dt:readByte()
        tmp.setList = {};
        for i = 1, tmp.ucAmount do
          table.insert(tmp.setList, stAchieveListMag.initWithStream(dt))
        end

        return tmp
    end
}
local function AchieveWndClose()
    GroupListValue = {__mode = "kv",};
    SecondGroupListValue = {__mode = "kv",};
end
local function createWnd()
      --get the UI file
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2033));
    if wnd == nil then
        return nil 
    end
    if SCPath:getSingleton() then
        local imgPath = getRealUIResourcePath("img/titile17.png")
        if imgPath then
            wnd:setTitleWithImage(imgPath:getData());
        end
    end
    -- create a test window controller
    wnd:luaSetSelectorOnClose(AchieveWndClose);
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeNone)
        dragNode:setFrameVisibled(true)
    end
    return wndCtrl;
end

local function onClickAchieveType(tag)
    SecondGroupListValue = {__mode = "kv",};
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ACHIEVE);
    dataStream:writeShort(ACHIEVEMENT_ACTION_USE_GROUP);
    dataStream:writeInt(tag);
    SCDataTransThread:getSingleton():transData(dataStream);
    SCActivityIndicator:getSingleton():show();
end

local function DisplaySecondAchieve(tmp)
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiByZipAndId(2033, 7005));
    if wnd == nil then
        return; 
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/titile17.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
   
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl);
    end
    local dragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if dragNode then
        dragNode:setFrameType(EnumFrameTypeNone);
        dragNode:setFrameVisibled(true);
        local dragnode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(2033, 102));
        if dragnode then
            dragnode:setFrameType(EnumFrameTypeRound);
            dragnode:setFrameVisibled(true);
            dragnode:setPosition(CCPointMake(35 * gUIScale().x, 217 * gUIScale().y));
            dragNode:addChild(dragnode);
            local img = SCTypeCast:castNodeToImage(dragnode:getChildByTag(1));
            if img then
                local imgPath = getRealUIResourcePath("img/" .. tmp[1].setList[1].idPhoto .. ".png")
                if imgPath then
                    img:setImage(imgPath:getData());
                end
            end
            local label1 = SCTypeCast:castNodeToLabel(dragnode:getChildByTag(2));
            if label1 then
                label1:setText("- " .. tmp[1].szGroupName .. " -");                
                label1:setColor(colorYellow());
                --label1:setPosition(CCPointMake(60 * gUIScale().x,35 * gUIScale().y));
            end
            local label2 = SCTypeCast:castNodeToLabel(dragnode:getChildByTag(3));
            if label2 then
                label2:setText(tmp[1].szGroupEffect);                
                label2:setColor(colorYellow());
                --label2:setPosition(CCPointMake(60 * gUIScale().x,21 * gUIScale().y));
            end
            --[[local progress = ProgressBarEx:newProgressBarEx(EnumProgressBarTypeBlue, 100);
            if progress then
                local value = getIntPart(tmp[1].nTotalNum) - 1;
                progress:setMaxValue(value);
                value = getIntPart(tmp[1].nCompletedNum);
                progress:setValue(value);
                progress:setPosition(CCPointMake(60 * gUIScale().x,4 * gUIScale().y));
                dragnode:addChild(progress);
            end]]
            if tmp[1].nCompletedNum == tmp[1].nTotalNum then
                tmp[1].nCompletedNum = tmp[1].nCompletedNum - 1;
            end
            local label3 = SCLabel:labelWithStringFont(tmp[1].nCompletedNum .. '/' .. tmp[1].nTotalNum - 1, getDefaultFontName(), getFontSize(14));
            if label3 then
                label3:setAnchorPoint(CCPointMake(0.5, 0));
                label3:setPosition(CCPointMake(350 * gUIScale().x, 20 * gUIScale().y));
                label3:setColor(colorYellow());
                dragnode:addChild(label3);
            end
            if tmp[1].ucShow == 0 then
                label1:setColor(colorWhite());
                label2:setColor(colorWhite());
                label3:setColor(colorWhite());
            end
        end
        local tablebox = SCTableBox:boxWithWidthHeight(448 * gUIScale().x, 240 * gUIScale().y);
        if tablebox then
            local pPageHint = SCPageHint:hintWithType(EnumPgaeHintTypeHorizontal);
            if pPageHint then
                pPageHint:setBoundPageScrollBox(tablebox);
                pPageHint:setAnchorPoint(CCPointMake(0.5, 0));
                pPageHint:setPosition(CCPointMake(wnd:getContentSize().width / 2, 10 * gUIScale().y));
                pPageHint:setContentSize(CCSizeMake(10 * gUIScale().x, 10 * gUIScale().y));
                wnd:addChild(pPageHint);
            end            
            local n = 0;
            for i = 1, #tmp do
                n = n + tmp[i].ucAmount;
            end
            local nPage = (n - 1) / 6 + 1;
            for i = 1, nPage do 
                local table = SCTable:table();
                table:setNumberOfRows(3);
                table:setTag(i - 1);
                table:setNumberOfColumns(2);                
                tablebox:addTable(table);
                for i = 1, 2 do
                    table:setWidthForColumn(222 * gUIScale().x, i - 1);
                end
                for i = 1, 3 do
                    table:setHeightForRow(55 * gUIScale().y,i - 1);
                end
                table:reflashData();
            end
            for k = 1, #tmp do
                for i = 1, tmp[k].ucAmount do  
                    n = 0; 
                    for j = 1, k - 1 do
                        n = n + tmp[j].ucAmount;
                    end
                    n = n + i - 1;
                    local nRow = getIntPart((n % 6) / 2);
                    local nTag = getIntPart((n % 6) % 2);
                    local index = getIntPart(n / 6);
                    local table = tolua.cast(tablebox:getChildByTag(index), "SCTable");
                    if table then
                        local pCell = table:cellForRowAndColumn(nRow, nTag);
                        if pCell then
                            local Node = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(2033, 103));    
                            if Node == nil then
                                return
                            end                        
                            Node:setFrameType(EnumFrameTypeRound);
                            Node:setFrameVisibled(true);
                            node = SCTypeCast:castNodeToDragNode(Node:getChildByTag(3));
                            if node == nil then
                                return
                            end
                            node:setFrameType(EnumFrameTypeRound);
                            node:setFrameVisibled(false);
                            if node then
                                local img = SCTypeCast:castNodeToImage(Node:getChildByTag(2));
                                if img then
                                    local imgPath = getRealUIResourcePath("img/" .. tmp[k].setList[i].idPhoto .. ".png")
                                    if imgPath then
                                        img:setImage(imgPath:getData());
                                    end
                                end
                                local label1 = SCLabel:labelWithStringFont("- " .. tmp[k].setList[i].szAchieveName .. " -", getDefaultFontName(), getFontSize(14));
                                if label1 then
                                    label1:setPosition(CCPointMake(10 * gUIScale().x, 27 * gUIScale().y));
                                    node:addChild(label1);
                                    label1:setColor(colorYellow());
                                end
                                local label2 = SCLabel:labelWithStringFont(tmp[k].setList[i].nPoints, getDefaultFontName(), getFontSize(12));
                                --[[if label2 then
                                    label2:setPosition(CCPointMake(120 * gUIScale().x, 27 * gUIScale().y));
                                    node:addChild(label2);
                                    label2:setColor(colorYellow());
                                end]]
                                local label3 = SCLabel:labelWithStringFont(tmp[k].setList[i].szAchievems, getDefaultFontName(), getFontSize(12));
                                if label3 then
                                    label3:setPosition(CCPointMake(10 * gUIScale().x, 10 * gUIScale().y));
                                    node:addChild(label3);
                                    label3:setColor(colorYellow());
                                end
                                if tmp[k].setList[i].ucShow == 0 then
                                    label1:setColor(colorWhite());
                                    --label2:setColor(colorWhite());
                                    label3:setColor(colorWhite());
                                end
                                Node:setAnchorPoint(CCPointMake(0.5, 0));
                                Node:setPosition(CCPointMake(pCell:getContentSize().width / 2, 0));
                                pCell:addChild(Node);
                            end
                        end
                    end
                end
            end
            tablebox:setPosition(CCPointMake(17 * gUIScale().x, 50 * gUIScale().y));
            dragNode:addChild(tablebox);
        end
    end
end

local function DisplayFirstAchieve(tmp)
    local pnode = SCFunction:getUiNodeByIdlist("2033-1");
    if pnode then
        local tablebox = SCTableBox:boxWithWidthHeight(448 * gUIScale().x, 240 * gUIScale().y);
        if tablebox then            
            local pPageHint = SCPageHint:hintWithType(EnumPgaeHintTypeHorizontal);
            local wnd = getCurentSceneWindow(2033);
            if pPageHint and wnd then
                pPageHint:setBoundPageScrollBox(tablebox);
                pPageHint:setAnchorPoint(CCPointMake(0.5, 0));
                pPageHint:setPosition(CCPointMake(wnd:getContentSize().width / 2, 10 * gUIScale().y));
                pPageHint:setContentSize(CCSizeMake(10 * gUIScale().x, 10 * gUIScale().y));
                wnd:addChild(pPageHint);
            end     
            local n = 0;
            for i = 1, #tmp do
                n = n + tmp[i].ucAmount;
            end
            local nPage = (n - 1) / 12 + 1;
            for i = 1, nPage do 
                local table = SCTable:table();
                table:setNumberOfRows(4);
                table:setTag(i - 1);
                table:setNumberOfColumns(3);                
                tablebox:addTable(table);
                for i = 1, 3 do
                    table:setWidthForColumn(135 * gUIScale().x, i - 1);
                end
                for i = 1, 4 do
                    table:setHeightForRow(55 * gUIScale().y,i - 1);
                end
                table:reflashData();
            end
            for k = 1, #tmp do
                for i = 1, tmp[k].ucAmount do  
                    n = 0; 
                    for j = 1, k - 1 do
                        n = n + tmp[j].ucAmount;
                    end
                    n = n + i - 1;
                    local nRow = getIntPart((n % 12) / 3);
                    local nTag = getIntPart((n % 12) % 3);
                    local index = getIntPart(n / 12);
                    local table = tolua.cast(tablebox:getChildByTag(index), "SCTable");
                    if table then
                        local pCell = table:cellForRowAndColumn(nRow, nTag);
                        if pCell then
                            local Node = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(2033, 101));
                            if Node == nil then
                                return
                            end                            
                            Node:setFrameType(EnumFrameTypeRound);
                            Node:setFrameVisibled(true);
                            local img = SCTypeCast:castNodeToImage(Node:getChildByTag(2));
                            if img then
                                local imgPath = getRealUIResourcePath("img/" .. tmp[k].setList[i].idPhoto .. ".png")
                                if imgPath then
                                    img:setImage(imgPath:getData());
                                end
                            end
                            node = SCTypeCast:castNodeToDragNode(Node:getChildByTag(3));
                            if node == nil then
                                return
                            end
                            node:setFrameVisibled(false);
                            if node then
                                local btn = SCTypeCast:castNodeToButton(Node:getChildByTag(1));
                                if btn then
                                    btn:setTag(tmp[k].setList[i].nGroup);
                                    btn:luaSetSelectorOnClicked(onClickAchieveType);
                                    btn:setContentSize(CCSizeMake(134 * gUIScale().x, 42 * gUIScale().y));
                                end
                                local label = SCLabel:labelWithStringFont("- " .. tmp[k].setList[i].szGroupName .. " -", getDefaultFontName(), getFontSize(12));
                                if label then
                                    label:setAnchorPoint(CCPointMake(0, 0.5));
                                    --label:setPosition(CCPointMake(42 * gUIScale().x, 22 * gUIScale().y));
                                    label:setPosition(CCPointMake(10 * gUIScale().x, 22 * gUIScale().y));
                                    node:addChild(label);                                    
                                    --[[if tmp[k].setList[i].ucShow == 0 then
                                        label:setColor(colorGray());
                                    else]]
                                        label:setColor(colorYellow());
                                    --end
                                end
                                --[[label = SCLabel:labelWithStringFont(tmp[k].setList[i].nCompletedNum.."/"..tmp[k].setList[i].nTotalNum, getDefaultFontName(), getFontSize(12));
                                if label then
                                    label:setPosition(CCPointMake(60, 15));
                                    node:addChild(label);
                                    label:setColor(colorYellow());
                                end]]
                                pCell:addChild(Node);
                            end
                        end
                    end
                end
            end
            setNodePostion(tablebox, CCPointMake(17, 45));
            pnode:addChild(tablebox);
        end
    end
end

local function setGroupListValue(tmp)
    table.insert(GroupListValue, tmp);
    DisplayFirstAchieve(GroupListValue);
end

local function setSecondGroupListValue(tmp)
    table.insert(SecondGroupListValue, tmp);
    if tmp.First == 0 then
        DisplaySecondAchieve(SecondGroupListValue);
    end
end

function createAchieveWnd()


    local wndCtrl = createWnd();
    --wndCtrl:luaSetSelectorOnEvent(endWinCtrl);
   
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
    naviCtrl:pushWindowController(wndCtrl);
   -- local node = SCFunction:getUiByZipAndId(2033, 101);

         local dataStream = SCDataTransStream:streamWithCommand(_MSG_ACHIEVE);
              dataStream:writeShort(ACHIEVEMENT_ACTION_GROP_LIST);
              if SCDataTransThread:getSingleton() then
                SCDataTransThread:getSingleton():transData(dataStream);
                SCActivityIndicator:getSingleton():show();
              end
    end 
    return 
    
end

function showAchieveWnd()
    createAchieveWnd();
end

local function recAchieveMsg()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return;
    end
    local action = dt:readShort();
    if action == ACHIEVEMENT_ACTION_GROP_LIST then
        setGroupListValue(stGroupListBag.initWithStream(dt));
    elseif action == ACHIEVEMENT_ACTION_USE_GROUP then
        setSecondGroupListValue(stAchieveListBag.initWithStream(dt));
    elseif action == ACHIEVEMENT_ACTION_CHAT_SHOW then
        local scStr = dt:readString()
        if scStr == nil then
        else
            luaShowTip(scStr:getData());
        end
    elseif action == ACHIEVEMENT_ACTION_GUID_INFO then
        AchieveGuide_RecvData(dt)
    end
end


SCMessageCenter:getSingleton():luaRegistCommand(recAchieveMsg, _MSG_ACHIEVE, 0, nil);

