local m_ActivityList = {}
local m_bWorldAtvtFlag = false
local m_bPartyAtvtFlag = false
--显示绕圈圈
local function showActivityAnimation()
	if #m_ActivityList > 0 then
		setLightEfficiency(UNLOCK_TYPE_TYPE12, true)
		setLightEfficiency(UNLOCK_TYPE_WOLRD_BOSS, true)
	else
		setLightEfficiency(UNLOCK_TYPE_TYPE12, false)
		setLightEfficiency(UNLOCK_TYPE_WOLRD_BOSS, false)
	end
	m_bWorldAtvtFlag = false
	m_bPartyAtvtFlag = false
	for i=1, #m_ActivityList do
		if m_ActivityList[i].byType == 1 then
			m_bPartyAtvtFlag = true
			--setLightEfficiency(UNLOCK_TYPE_WOLRD_BOSS, false)
		end
		if m_ActivityList[i].byType == 2 then
			m_bWorldAtvtFlag = true
		end
		local node = tolua.cast(SCFunction:getUiNodeByIdlist("5201-1-"..(m_ActivityList[i].byType+1).."-401-1-"..m_ActivityList[i].nData.."-1000"), "BtnMainInterface")
		if node then
			node:setApertureVisible(true)
		end
	end
	if m_bWorldAtvtFlag then
    local pScene = getCurentScene():getUINode();
    if pScene==nil then
    return;
    end
    local AssWnd= getCurNode_(pScene,5201);
	    if not AssWnd then
	        return
	    end
	    local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1109, 1149)
	    if not pAni then
	        return
	    end
	    if not AssWnd:getChildByTag(1008) then
            if pAni then
				local pAniNode =  SCAnimationNode:nodeWithAnimation(pAni)
                pAniNode:setTag(1008)
                pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
                setNodePostion(pAniNode, CCPointMake(368, 284))
                AssWnd:addChild(pAniNode)
            end
        end
	end
	
	if m_bPartyAtvtFlag then
    local pScene = getCurentScene():getUINode();
    if pScene==nil then
    return;
    end
    local AssWnd= getCurNode_(pScene,5201);
	 --   local AssWnd = getCurentSceneWindow(5201)
	    if not AssWnd then
	        return
	    end
	    local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1109, 1149)
	    if not pAni then
	        return
	    end
	    if not AssWnd:getChildByTag(1009) then
            if pAni then
                local pAniNode =  SCAnimationNode:nodeWithAnimation(pAni)
                pAniNode:setTag(1009)
                pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
                setNodePostion(pAniNode, CCPointMake(280, 284))
                AssWnd:addChild(pAniNode)
            end
        end
	end
	
end
--接收数据
local function recvShowActivityData()
	local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
		return
	end
	local tmp = {}
	tmp.nData = dt:readInt() --//对应相应的枚举
	tmp.byType = dt:readByte() --//1,公会，2世界
	tmp.byflag = dt:readByte() --//开启标志（1开启，0，关闭）
	if tmp.byflag == 1 then
		table.insert(m_ActivityList, tmp)
	else
		for key, value in pairs(m_ActivityList) do
			if value.nData == tmp.nData then
				table.remove(m_ActivityList, key)				
			end
		end
		if tmp.nData == 1 then
		    if SCFunction:getUiNodeByIdlist(9110) then--押送军粮关闭界面
		        --添加押镖版本限制
                if CLIENT_VERSION >= 328 then
                    VanFood_CloseEscortWnd()
                end                
            end
		end
	end
	showActivityAnimation()
	showUnlockMainBtn()
end
--活动开启表现
LuaData:getSingleton():luaSetSelectorOnRecvData(recvShowActivityData, LuaData_USERINFO_SHOW_ACTIVITY)

NONE_ACTIVITY	= 0  --没有活动开启
WORLD_ACTIVITY	= 1  --世界活动开启
PARTY_ACTIVITY	= 2  --公会活动开启
ALL_ACTIVITY	= 3  --公会活动世界活动都开启
WORLDEVENT_TYPE_SYNWAR = 10 --//军团战
--是否有活动开启
function getIsActivityVisible()
	if m_bWorldAtvtFlag and m_bPartyAtvtFlag then
		return ALL_ACTIVITY
	elseif m_bWorldAtvtFlag then
		return WORLD_ACTIVITY
	elseif m_bPartyAtvtFlag then
		return PARTY_ACTIVITY
	else
		return NONE_ACTIVITY
	end
end

function IsActivityVisible(data)
	for key, value in pairs(m_ActivityList) do
		if value.nData == data then
			return true		
		end
	end
	return false
end

function activityVisibleAnimation()
	showActivityAnimation()
	Noviceguidelines()
end

function freeActivitiesPromptedData()
	m_ActivityList = {}
	m_bWorldAtvtFlag = false
	m_bPartyAtvtFlag = false
end

function Noviceguidelines()
    if isGuideCanStart(GUIDE_TYPE_HELPER) then
        showGuideStep(GUIDE_TYPE_HELPER, -1)
    elseif isGuideCanStart(GUIDE_TYPE_AREAN) then	
        setGuideRestartFlag(GUIDE_TYPE_AREAN, true);
        showGuideStep(GUIDE_TYPE_AREAN, 2, 2);	
    elseif isGuideCanStart(GUIDE_TYPE_WOLRD_BOSS) then
        setGuideRestartFlag(GUIDE_TYPE_WOLRD_BOSS, true);
        showGuideStep(GUIDE_TYPE_WOLRD_BOSS, 2, 2);
    elseif isGuideCanStart(GUIDE_TYPE_MORECOPY) then
        setGuideRestartFlag(GUIDE_TYPE_MORECOPY, true);
        showGuideStep(GUIDE_TYPE_MORECOPY, 2, 2);
    elseif isGuideCanStart(GUIDE_TYPE_PVPBATTLE) then
        setGuideRestartFlag(GUIDE_TYPE_PVPBATTLE, true);
        showGuideStep(GUIDE_TYPE_PVPBATTLE, 2, 2);
    elseif isGuideCanStart(GUIDE_TYPE_3V3) then
        setGuideRestartFlag(GUIDE_TYPE_3V3, true);
        showGuideStep(GUIDE_TYPE_3V3, 2, 2);
    elseif isGuideCanStart(GUIDE_TYPE_BUDDHIST_SCRIPTURES) then
        setGuideRestartFlag(GUIDE_TYPE_BUDDHIST_SCRIPTURES, true);
        showGuideStep(GUIDE_TYPE_BUDDHIST_SCRIPTURES, 2, 2);
    end
end