local ARENASCRITP_ADD_ARENA_AFFIRM             = 11;    --/*使用仙晶增加竞技场数二次*/
local ARENASCRITP_RANK_INFO                     = 12;    --/*个人竞技信息*/
local ARENASCRITP_PLAYER_LIST                 = 13;    --/*比自己排名高的玩家列表*/
local ARENASCRITP_HISTORY_LIST                 = 14;    --/*最近几场战斗*/
local ARENASCRITP_BEGIN_FIGHT                 = 15;    --/*发起挑战*/
local ARENASCRITP_CLEAR_CD_AND_FIGHT         = 16;    --/*消除CD并挑战二次确认*/
local ARENASCRITP_CLEAR_CD                     = 17;    --/*消除CD二次确认*/
local ARENASCRITP_GET_AWARD                     = 18;    --/*领取奖励*/
local ARENASCRITP_CLOSE_ARENA                 = 19;    --/*关闭竞技场界面*/
local ARENASCRITP_PVPBATTLE_INFO             = 30;    --/*个人战斗信息*/
local ARENASCRITP_PVPBATTLE_MAXWIN             = 31;    --/*下发最高三连胜*/
local ARENASCRITP_PVPBATTLE_RESULT             = 32;    --/*个人战报*/
local ARENASCRITP_PVPBATTLE_RESULT_END         = 33;    --/*个人战报(最后一个包)*/
local ARENASCRITP_PVPBATTLE_UPDATE_RESULT     = 34;    --/*更新一个个人战报*/
local ARENASCRITP_PVPBATTLE_ADD_RESULT         = 35;    --/*添加一个个人战报*/
local ARENASCRITP_PVPBATTLE_CLOSE_WND         = 37;    --/*关闭大乱斗*/
local ARENASCRITP_PVPBATTLE_GAME_OVER         = 38;    --/*大乱斗活动结束*/
local ARENASCRITP_PVPBATTLE_EVERYBODY_RESULT = 39;  --/**全部战报*/
local ARENASCRIPT_TRIBEWAR_GIFT_LIST		= 43;		--//分配战利品列表
local ARENASCRIPT_TRIBEWAR_GIFT_MEMBER		= 44;		--//分配战利品下发参与玩家
local ARENASCRITP_DUEL_USETINFO    = 48       --决斗战神殿玩家信息 
local ARENASCRITP_DUEL_LATELYINFO  = 49       --决斗战神殿最近5场战斗信息
local ARENASCRITP_DUEL_RIVALINFO   = 50       --决斗战神殿对手信息
local ARENASCRITP_DUEL_OPENPAIR    = 51       --决斗战神殿开始配对  
local ARENASCRITP_DUEL_CLOSEPAIR   = 52       --决斗战神殿取消配对 
local ARENASCRITP_DUEL_LEAVE       = 53       --离开战神殿 
local ARENASCRITP_DUEL_AWARD	   = 54       --获得奖励
local ARENASCRITP_DUEL_DAYMATCH    = 55       --刷新今日荣誉次数
---------演武场---------
local   ARENASCRITP_YANWU_INFO                  = 60       --//演武场信息 
local   ARENASCRITP_YANWU_PLAYERINFO            = 61       --//演武场内玩家信息 
local   ARENASCRITP_YANWU_PLAYERINFO_END        = 62       --//演武场内玩家信息下发结束  
local   ARENASCRITP_YANWU_AWARDINFO             = 72       --//玩家奖励信息 
local   ARENASCRITP_YANWU_LATELYINFO            = 71       --//演武场最近5场战斗信息 
local   ARENASCRITP_YANWU_OPEN_VIEW             = 68       --//打开演武场界面 
local    ARENASCRITP_YANWU_ADD                  = 64       --//添加
local   ARENASCRITP_YANWU_DEL                   = 65          --//删除
local  ARENASCRITP_YANWU_SEIZE_POSITION        = 66      --//抢占位置 
local  ARENASCRITP_YANWU_GETAWARD              = 70      --//获取演武场奖励
local  ARENASCRITP_YANWU_ADDTIME               = 74       --//增加次数 
local  ARENASCRITP_YANWU_CHALLENGE             = 67       --//挑战玩家 
local ARENASCRITP_ADD_PVP_TIMES               = 75       --//购买虎符

local   YANWUFIELD_COMMON = 1		--//普通 
local	YANWUFIELD_PRIMARY = 2		--//初级 
local	YANWUFIELD_INTERMEDIATE = 3 --//中级 
local	YANWUFIELD_ADVANCED = 4	--//高级 
local	YANWUFIELD_EPIC = 5		--//史诗
local	YANWUFIELD_LEGEND = 6		--//传说

local m_ArenaPlayer = {__mode = "kv"};

local m_curIdPlayer = nil;
local m_isFirst = nil;
local m_listArenaHistory = {__mode = "kv"};
local m_RankInfo = {__mode = "kv"};
local m_OtherPlayerInfo = {__mode = "kv"};
local m_ArenaHistory = {__mode = "kv"};
local m_time = nil;
local m_strTip = nil;
local m_lastTime = nil;
local m_tmpTag = nil;
local m_yanwu_add = {}
--------演武场------------
local yanwu_mark = {};  
local xingji_mark = 0;
-------主界面信息-----------
local styanwuAttr = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nType = dt:readInt(); ---属性类型
        tmp.nNum = dt:readInt(); ---人数
        return tmp;
    end
}

local styanwuInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte()--//演武场数量
        tmp.stYanWuFieldInfo = {}

        for i = 1, tmp.ucAmount do
            table.insert(tmp.stYanWuFieldInfo, styanwuAttr.initWithStream(dt));
        end
        tmp.nType = dt:readInt() --------人物所在位置 
        return tmp
    end
}
-------------------各级界面信息----------------
local styanwu1Attr = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idPlayer = dt:readInt(); ---玩家id
        local str = dt:readString(); --玩家名字
		if str then
			tmp.szName = str:getData();
		else
            tmp.szName = "";    
		end
		tmp.usLevel = dt:readShort()  --玩家等级
		tmp.ucClan = dt:readByte()  --玩家职业 
		local str = dt:readString(); --军团名 
		if str then
			tmp.szTribeName = str:getData();
		else
            tmp.szTribeName = "";    
		end
		tmp.nType = dt:readInt()  --演武场类型
		tmp.nPosition = dt:readInt()  --演武场位置 
		tmp.ucInBattle = dt:readByte()  --是否战斗中 默认0  1 在战斗中 
		tmp.dwAwardCD = dt:readInt()  --奖励CD
        return tmp;
    end
}

local styanwu1Info = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nPlayerNum = dt:readInt()   ----普通演武人数
        tmp.ucAmount = dt:readByte()--//演武场内人物数量
        tmp.stYanWuPlayerInfo = {}

        for i = 1, tmp.ucAmount do
            table.insert(tmp.stYanWuPlayerInfo, styanwu1Attr.initWithStream(dt));
        end
        tmp.ntype = dt:readByte()
		yanwu_mark = tmp
        return tmp
    end
}
---------更新战斗状态-----------
local styanwu1gengxInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idPlayer = dt:readInt()--//人物ID
        tmp.ucBattle = dt:readByte() --默认 0 1正在战斗 	

        return tmp
    end
}
------------演武场添加人物---------------
local styanwu1addInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idPlayer = dt:readInt(); ---玩家id
        local str = dt:readString(); --玩家名字
		if str then
			tmp.szName = str:getData();
		else
            tmp.szName = "";    
		end
		tmp.usLevel = dt:readShort()  --玩家等级
		tmp.ucClan = dt:readByte()  --玩家职业 
		local str = dt:readString(); --军团名 
		if str then
			tmp.szTribeName = str:getData();
		else
            tmp.szTribeName = "";    
		end
		tmp.nType = dt:readInt()  --演武场类型
		tmp.nPosition = dt:readInt()  --演武场位置 
		tmp.ucInBattle = dt:readByte()  --是否战斗中 默认0  1 在战斗中 
		tmp.dwAwardCD = dt:readInt()  --奖励CD
        return tmp;
    end
}
local styanwu1add_NumInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nPlayerNum = dt:readInt()  -----普通演武人数
        tmp.ucAmount = dt:readByte()--//演武场内人物数量
        tmp.stYanWuPlayerInfo = {}

        for i = 1, tmp.ucAmount do
            table.insert(tmp.stYanWuPlayerInfo, styanwu1addInfo.initWithStream(dt));
        end
        m_yanwu_add = tmp
        return tmp
    end
}
-----------演武场历史信息--------------
local styanwu1newsInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idBattle = dt:readInt(); ---战斗ID
        local str = dt:readString(); --战斗已过时间
		if str then
			tmp.szPastTime = str:getData();
		else
            tmp.szPastTime = "";    
		end
		tmp.ucRiseFightFlag = dt:readByte()  --玩家等级
		tmp.idTarget = dt:readInt()  ---目标玩家ID
		local str = dt:readString(); --目标名字
		if str then
			tmp.szTargetName = str:getData();
		else
            tmp.szTargetName = "";    
		end
		tmp.ucWinFlag = dt:readByte()  --1胜利  是否胜利
		tmp.nOldRank = dt:readInt()  --旧排名
		tmp.nNewRank = dt:readInt()  --新排名
        return tmp;
    end
}
local styanwu1newscountInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucAmount = dt:readByte(); ---战斗ID
        tmp.stnewsInfo = {}
        
		for i=1,tmp.ucAmount do
			table.insert(tmp.stnewsInfo, styanwu1newsInfo.initWithStream(dt));
		end 
        return tmp;
    end
}
------------演武场奖励-------------stArenaHistory
local stYanWuAwardInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nPartaleTimes = dt:readInt()--//已参与次数 
        tmp.nAwardExp = dt:readInt() --//每次可获得的经验(每30秒一次经验)
        tmp.dwSupTime = dt:readInt() --//剩余时间
        tmp.dwLootTime = dt:readInt() --//剩余抢夺时间
        tmp.nCondition1 = dt:readInt() --//条件1
        tmp.idAwardItem1 = dt:readInt() --//满足条件1可获得的礼包
        tmp.nCondition2 = dt:readInt() --//条件2
        tmp.idAwardItem2 = dt:readInt() --//满足条件2可获得的礼包
        tmp.nCondition3 = dt:readInt() --//条件3
        tmp.idAwardItem3 = dt:readInt() --//满足条件3可获得的礼包
		tmp.dwGetTimes  = dt:readInt() ---已经领取的时间
        return tmp
    end
}
--------删除人物----------
local styanwu1delInfo  = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idPlayer = dt:readInt()--//人物ID
        tmp.nType = dt:readInt() --类型
        tmp.nPosition = dt:readInt() --类型

        return tmp
    end
}
-------------位置空否标记----------------
function send_yanwumark(tag) 
    if   #yanwu_mark.stYanWuPlayerInfo ~= 0  then
        return yanwu_mark.stYanWuPlayerInfo[tag];
    else
        return xingji_mark;
    end
end 
function yanwu_hero_show(tag)
--	yanuw3_init(tag,m_yanwu_add)
	yanuw3_init(tag,yanwu_mark,xingji_mark)
	--[[
	tag = tag - 37;
    if yanwu_mark[tag].idPlayer ~= nil  then
		yanuw3_init();
	end
	]]
end 
------------争夺按钮响应-----------
function yanwu1_zdclick(tag)
    local tag = tag -16;
    --local stYanWuPlayerInfo = send_yanwumark(tag)
   -- if stYanWuPlayerInfo == 3 or stYanWuPlayerInfo == 4 or stYanWuPlayerInfo == 5 or stYanWuPlayerInfo == 6 then
   local mark = 0;
   local idplayer = 0 
   for i = 1,#yanwu_mark.stYanWuPlayerInfo do 
		if   Hero:getSingleton():getID() == yanwu_mark.stYanWuPlayerInfo[i].idPlayer  then
			if yanwu_mark.stYanWuPlayerInfo[i].nPosition == tag then
				showMessage(L("str21063"));
				return;
			end 
		end 
	end 
	for i=1, #yanwu_mark.stYanWuPlayerInfo do
		if not yanwu_mark.stYanWuPlayerInfo[i] then  return end
		if yanwu_mark.stYanWuPlayerInfo[i].nPosition == tag and  yanwu_mark.stYanWuPlayerInfo[i].idPlayer ~= 1 then
			idplayer = yanwu_mark.stYanWuPlayerInfo[i].idPlayer
			mark = 1;
		else
			mark = 2;
		end 
	end 
	if xingji_mark ~= 3 then
		if mark == 2 or #yanwu_mark.stYanWuPlayerInfo == 0 then
			local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
			if   dt  then
				dt:writeShort(ARENASCRITP_YANWU_SEIZE_POSITION);
				dt:writeInt(xingji_mark - 2);
				dt:writeInt(tag);
				SCDataTransThread:getSingleton():transData(dt);
				SCActivityIndicator:getSingleton():show();
			end 
		elseif mark == 1 then
			local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
			if   dt  then
				dt:writeShort(ARENASCRITP_YANWU_CHALLENGE);
				dt:writeInt(idplayer);
				SCDataTransThread:getSingleton():transData(dt);
				SCActivityIndicator:getSingleton():show();
			end 
		else
			return;
		end 
	else
		showMessage(L("str21089"));
    end 
end 
-------------普通演武场争夺--------------
function yanwu1pt_zd()
	local tag = #yanwu_mark.stYanWuPlayerInfo +1
	local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
	if   dt  then
		dt:writeShort(ARENASCRITP_YANWU_SEIZE_POSITION);
		dt:writeInt(1);
		dt:writeInt(tag);
		SCDataTransThread:getSingleton():transData(dt);
		SCActivityIndicator:getSingleton():show();
	end 
end 
---------演武场等级选择--------------------
function yanwu_chosselev(tag)
    if  tag == 3  then
        --yanwu1_showWnd()
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if   dt  then
            dt:writeShort(ARENASCRITP_YANWU_OPEN_VIEW);
            dt:writeInt(YANWUFIELD_COMMON);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show();
        end 
        xingji_mark = tag
    elseif  tag == 4 then
        --yanwu2_init()
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if   dt  then
            dt:writeShort(ARENASCRITP_YANWU_OPEN_VIEW);
            dt:writeInt(YANWUFIELD_PRIMARY);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show();
        end 
        xingji_mark = tag
    elseif   tag == 5 then
        --yanwu1_showWnd()
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if   dt  then
            dt:writeShort(ARENASCRITP_YANWU_OPEN_VIEW);
            dt:writeInt(YANWUFIELD_INTERMEDIATE);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show();
        end 
        xingji_mark = tag
    elseif   tag == 6  then
        --yanwu1_showWnd()
        local dt = SCDataTransStream:streamWithCommand(_MSG_ARENA);
        if   dt  then
            dt:writeShort(ARENASCRITP_YANWU_OPEN_VIEW);
            dt:writeInt(YANWUFIELD_ADVANCED);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show();
        end 
        xingji_mark = tag
    end
end

--------演武场end-----

local ArenaRankInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            nRank,                    --/*排名*/
            ucParticipantTimes,        --/*今天可参加场数*/
            dwCoolTime,                --/*冷却时间*/
            nContinueTimes,            --/*连胜次数*/
            szAwardMsg,                --/*所在名次奖励信息*/
            dwTime,
            idPhoto,             --/*npc图片id*/
            nPowerTime   			--/已购买次数
        }
        tmp.nRank = dt:readInt();
        tmp.ucParticipantTimes = dt:readInt();
        tmp.dwCoolTime = dt:readInt();
        tmp.nContinueTimes = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szAwardMsg = ""
        else
            tmp.szAwardMsg = scStr:getData()
        end
        tmp.dwTime = dt:readInt();            
        tmp.idPhoto = dt:readInt();    
        tmp.nPowerTime = dt:readInt();   
        return tmp
    end
}

local stArenaPlayer = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            idPlayer,
            szName,
            usLevel,    --/*等级*/
            nRank,        --/*排名*/
            szAward,    --/*所在排名获得奖励*/
            nPhoto,
        }
        tmp.idPlayer = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.usLevel = dt:readShort();
        tmp.nRank = dt:readInt();
        scStr = dt:readString()
        if scStr == nil then
            tmp.szAward = ""
        else
            tmp.szAward = scStr:getData()
        end
        tmp.nPhoto = dt:readInt();            
        return tmp
    end
}

local AllArenaPlayer = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            ucAmount,
        }
        tmp.ucAmount = dt:readByte()
        tmp.vecArenaPlayer = {};
        
        for i = 1, tmp.ucAmount do
            table.insert(tmp.vecArenaPlayer, stArenaPlayer.initWithStream(dt))
        end
            
        return tmp
    end;
}

local vecArenaHistory = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",            
            idBattle,            --/*战斗ID*/
            szPastTime,            --/*战斗已过时间*/
            ucRiseFightFlag,    --/*1:自己发起挑战*/
            idTarget,            --/*目标ID*/
            szTargetName,        --/*目标名字*/
            ucWinFlag,            --/*1:胜利*/
            nOldRank,            --/*旧排名*/
            nNewRank,            --/*新排名*/
        }
        tmp.idBattle = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szPastTime = ""
        else
            tmp.szPastTime = scStr:getData()
        end
        tmp.ucRiseFightFlag = dt:readByte();
        tmp.idTarget = dt:readInt();
        scStr = dt:readString()
        if scStr == nil then
            tmp.szTargetName = ""
        else
            tmp.szTargetName = scStr:getData()
        end
        tmp.ucWinFlag = dt:readByte();    
        tmp.nOldRank = dt:readInt(); 
        tmp.nNewRank = dt:readInt();   
        return tmp
    end
}

local NearestArenaHistory = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            ucAmount,
        }
        tmp.ucAmount = dt:readByte()
        tmp.vecArenaHistory = {};
        
        for i = 1, tmp.ucAmount do
            table.insert(tmp.vecArenaHistory, vecArenaHistory.initWithStream(dt))
        end
            
        return tmp
    end;
}

local function sendCloseArena()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then        
        dataStream:writeShort(ARENASCRITP_CLOSE_ARENA);
        SCDataTransThread:getSingleton():transData(dataStream);
    end
end

local function ArenaWndClose()
    m_ArenaPlayer = {__mode = "kv"};
    m_curIdPlayer = nil;
    m_isFirst = nil;
    m_listArenaHistory = {__mode = "kv"};
    m_RankInfo = {__mode = "kv"};
    m_OtherPlayerInfo = {__mode = "kv"};
    m_ArenaHistory = {__mode = "kv"};
    m_time = nil;
    m_strTip = nil;
    m_lastTime = nil;
    sendCloseArena();
    if getRestartGuideFlag(GUIDE_TYPE_AREAN) then
        restartBeginnerGuide(GUIDE_TYPE_AREAN);
    else
        showGuideStep(GUIDE_TYPE_AREAN, -1);
    end
    GuidePoint_FreeChData1(); --关闭挑战引导
end

local function onClickHeroRanking(tag)
    RankInterface_sendConData();
end

local function onClickClearCDBtn(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then        
        dataStream:writeShort(ARENASCRITP_CLEAR_CD);
        dataStream:writeByte(0);
        dataStream:writeByte(0);
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function Open_rechange(tag)
    if tag == 1 then
        showVIPrechargeableWnd();
    end
end

local function onClickAddBtn(tag)
    challengeView_sendBuyByHufuMsg()
end

local function createWnd()
    local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(1012));
    if wnd == nil then
        return nil;
    end
    local imgPath = nil;
    if SCPath:getSingleton() then
        imgPath = getRealUIResourcePath("img/new00312.png")
    end
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    wnd:luaSetSelectorOnClose(ArenaWndClose);
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());  
    local pButton = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("3-6", tolua.cast(wnd, "SCNode")));
    if pButton then
        pButton:setButtonType(EnumBtnType9Atlas)
        pButton:luaSetSelectorOnClicked(onClickHeroRanking);
    end
    local pBackgroundImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(wnd, "SCNode")));
    if pBackgroundImg then
        wnd:reorderChild(pBackgroundImg, -1000);      
        local pBgColorNode = SCNode:node();
        if pBgColorNode then
            pBgColorNode:setAnchorPoint(CCPointMake(0, 0));
            setNodePostion(pBgColorNode, CCPointMake(0, 0));
            setNodeContentSize(pBgColorNode, CCSizeMake(getScreenWidth(), getScreenHeight()));
            pBackgroundImg:addChild(pBgColorNode);
        end
    end

    local pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("3", tolua.cast(wnd, "SCNode")));
    local pNode2 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("7", tolua.cast(wnd, "SCNode")));
    local pNode3 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("2", tolua.cast(wnd, "SCNode")));
    
    if nil ~= pNode and nil ~= pNode2 and pNode3 then
        pNode3:setFrameVisibled(true);
        pNode3:setFrameType(EnumFrameTypeLine);
        pNode3:setDragEnabled(false)
        pNode:setFrameVisibled(true);
        pNode:setFrameType(EnumFrameTypeLine);
        pNode:setDragEnabled(false)
        pNode2:setFrameVisibled(false);
        pNode2:setFrameType(EnumFrameTypeListNormal);
        pNode2:setDragEnabled(false)

        local pClearCDBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("7-9", tolua.cast(wnd, "SCNode")));
        local pAddTimes = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("7-11", tolua.cast(wnd, "SCNode")));
        local pCoolTime = SCFunction:getUiNodeByIdlistAndParent("7-15", tolua.cast(wnd, "SCNode"));
        if nil ~= pClearCDBtn and nil ~= pAddTimes and nil ~= pCoolTime then                
            pClearCDBtn:luaSetSelectorOnClicked(onClickClearCDBtn);
            pAddTimes:setTitle(L("str30185"), DEFAULT_FONT_NAME, F(12))
            pAddTimes:luaSetSelectorOnClicked(onClickAddBtn);
            local pCountDownNode = CountDownNode:newCountDownNode();
            if nil == pCountDownNode then
                return;
            end
            pCountDownNode:setTag(1)
            setNodePostion(pCountDownNode, CCPointMake(0, 0));
            pCoolTime:addChild(pCountDownNode);
        end
        local pBgImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("3-302", tolua.cast(wnd, "SCNode")));
        if pBgImg then
            pBgImg:setScaleX(getNodeContentSize(pNode).width / getNodeContentSize(pBgImg).width);
            pBgImg:setScaleY(getNodeContentSize(pNode).height / getNodeContentSize(pBgImg).height);
        end
    end
    return wndCtrl;
end

local function fillRankInfo(tmp)
    if tmp == nil or tmp.nContinueTimes == nil then
        return
    end
    
    local pParticipantTimesLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("1012-7-10"));
    local pRankLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("1012-3-4"));
    local pWinningStreakLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("1012-3-1"));
    local pAwardMsgLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("1012-20"));
    if nil == pParticipantTimesLab or nil == pAwardMsgLab or nil == pRankLab or nil == pWinningStreakLab then
        return;
    end
    setNodePostion(pAwardMsgLab,CCPointMake(SX(8),getNodePostion(pAwardMsgLab).y))
    setNodePostion(pRankLab,CCPointMake(SX(6),getNodePostion(pRankLab).y))
    local num = getNodePostion(pAwardMsgLab).x
    local pCountDownNode = tolua.cast(SCFunction:getUiNodeByIdlist("1012-7-15-1"), "CountDownNode")
    if pCountDownNode and tmp.dwCoolTime ~= nil then
		pCountDownNode:setTime(tmp.dwCoolTime);
	end
	
	local winTmp = L("str2023");
	winTmp = winTmp .. " " .. tmp.nContinueTimes;
	pWinningStreakLab:setText(winTmp);
	pWinningStreakLab:setColor(color_yellow);

    local szTmp = string.format(L("str30187"), tmp.ucParticipantTimes)
    pParticipantTimesLab:setText(szTmp);

    szTmp = _LTParser("str0016");
    szTmp = szTmp .. tmp.nRank;
    pRankLab:setText(szTmp);
    pRankLab:setColor(color_yellow);  
    setNodePostion(pWinningStreakLab,CCPointMake(getNodePostion(pRankLab).x + getNodeContentSize(pRankLab).width,getNodePostion(pWinningStreakLab).y))

    pAwardMsgLab:setColor(color_yellow);    
    if tmp.dwTime == 0 then        
        local pNode = SCFunction:getUiNodeByIdlist("1012");
        if pNode then
            pNode:removeChildByTag(999, true);
        end
        pAwardMsgLab:setText(tmp.szAwardMsg);
    else
        m_time = tmp.dwTime;
        m_strTip = tmp.szAwardMsg;
        pAwardMsgLab:setText(m_strTip);        
        local pNode = SCFunction:getUiNodeByIdlist("1012");
        if pNode then
            pNode:removeChildByTag(999, true);
            local pCountDownNode = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second);
            if pCountDownNode then
                pCountDownNode:setTime(m_time);
                pCountDownNode:setTag(999);
                setNodePostion(pCountDownNode, CCPointMake(getNodePostion(pAwardMsgLab).x + getNodeContentSize(pAwardMsgLab).width, getNodePostion(pAwardMsgLab).y));
                pNode:addChild(pCountDownNode);
            end
        end
    end

    local pHeroInfo = Hero:getSingleton():getHeroInfo();
    if pHeroInfo then
        local strTmp = _LTParser("str0017");
        strTmp = strTmp .. pHeroInfo.nPrestige;

        local pReputationLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("1012-3-5"));
        if nil == pReputationLab then
            return;
        end
		setNodePostion(pReputationLab,CCPointMake(getNodePostion(pWinningStreakLab).x + getNodeContentSize(pWinningStreakLab).width,getNodePostion(pReputationLab).y))
        pReputationLab:setColor(color_yellow);  
        pReputationLab:setText(strTmp);
    
    end
    
    local imgPath = getRealUIResourcePath("img/" .. tmp.idPhoto .. ".png");
    if imgPath then
        local imgNode = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("1012-2"));
        if imgNode then
            imgNode:setImage(imgPath:getData());
            imgNode:setFlipX(true);
        end
    end
    m_lastTime = tmp.nPowerTime;
end

local function setArenaPlayer(tmp)
    table.insert(m_ArenaPlayer, tmp);
end

function getArenaPlayer(mark)
    return m_ArenaPlayer[mark];
end

local function onClickImgBtn(tag)
    local dt = getArenaPlayer(tag);
    if dt == nil then
        return;
    end
    --SCActivityIndicator:getSingleton():show();
    ViewPlayInfo_sendData(dt.idPlayer, 0, "")
    --luaLookPlayerInfo(dt.idPlayer, "");
    --showArenaSelectedWnd(tag);
    showGuideStep(GUIDE_TYPE_AREAN, -1);
end
local function sendToFight(tag)
    GuidePoint_LuaAddCount(8, 2)   --增加挑战引导
    local dt = getArenaPlayer(tag);
    if dt == nil then
        return;
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then
        dataStream:writeShort(ARENASCRITP_BEGIN_FIGHT);
        dataStream:writeInt(dt.idPlayer);
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function leaveTeam(tag)
    if 1 == tag then
        local MSG_TEAM_LEAVE						= 1;	--// 成员离队(包括队长)
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
        if nil == dataStream then
            return;
        end
        dataStream:writeShort(MSG_TEAM_LEAVE);
        if SCDataTransThread:getSingleton() then
            SCDataTransThread:getSingleton():transData(dataStream);
            SCActivityIndicator:getSingleton():show();
        end
        sendToFight(m_tmpTag)
    end
end

local function sendBeginFight(tag)
    
    local tmpFlg1 = Hero:getSingleton():iSATeamLeader()
    local tmpFlg2 = Hero:getSingleton():isATeamMember()
    if tmpFlg1 or tmpFlg2 then
        m_tmpTag = tag
        luashowConfirmationWindow(_LTParser("str3172"), WIN_YES_NO, leaveTeam);
        return
    end
    sendToFight(tag)
end

local function fillOtherPlayerInfo(tmp)
    local pImgNode = SCFunction:getUiNodeByIdlist("1012-3-21");
    if nil == pImgNode then
        return;
    end
    pImgNode:removeAllChildrenWithCleanup(true);
    local imgPath = getRealUIResourcePath("img/new00314.jpg")
    if not imgPath then
        local pImg = SCImage:imageWithFile(imgPath:getData())
        if pImg then
            pImg:setAnchorPoint(CCPointMake(0, 0))
            pImg:setPosition(CCPointMake(SX(0),SY(0)))
            pImgNode:addChild(pImg)
        end
    end
    m_ArenaPlayer = {__mode = "kv"};
    for i=1, #tmp.vecArenaPlayer do
        local pNode = SCFunction:getUiByZipAndId(1012, 101);
        if pNode then
            pNode:setAnchorPoint(CCPointMake(0, 0));
            setNodePostion(pNode, CCPointMake(90*(i - 1), 2));

            local pNameLab = SCTypeCast:castNodeToLabel(pNode:getChildByTag(3));
            local pLevelLab = SCTypeCast:castNodeToLabel(pNode:getChildByTag(4));
            local pImgBtn = SCTypeCast:castNodeToButton(pNode:getChildByTag(2));
            local pRankingLab = SCTypeCast:castNodeToLabel(pNode:getChildByTag(5));
            if pNameLab and pLevelLab and pImgBtn and pRankingLab then
                pNameLab:setText(tmp.vecArenaPlayer[i].szName);

                local szLev = _LTParser("str0013");
                szLev = szLev .. tmp.vecArenaPlayer[i].usLevel;
                szLev = szLev .. " ";
                --szLev = szLev .. tmp.vecArenaPlayer[i].nRank;
                --szLev = szLev .. _LTParser("str5034");
                pLevelLab:setText(szLev);
                pRankingLab:setText(tmp.vecArenaPlayer[i].nRank);
                setArenaPlayer(tmp.vecArenaPlayer[i]);   
                local pImgPath = getRealUIResourcePath("img/new00304.png");
                if pImgPath then
                    pImgBtn:setTitle(pImgPath:getData());
                    pImgBtn:setTag(i);
                end             
                pImgBtn:luaSetSelectorOnClicked(onClickImgBtn);
                --[[local filePath = getFaceImagePath(tmp.vecArenaPlayer[i].nPhoto);
                if filePath then
                    pImgBtn:setTitle(filePath:getData());
                    pImgBtn:setTag(i);
                end]]
                local partnerRole = SCLookfaceParser:getSingleton():getAnimationByLookfaceAndIndex(tmp.vecArenaPlayer[i].nPhoto, dirAction_Stand);
                if partnerRole then
                    local roleNode = SCAnimationNode:nodeWithAnimation(partnerRole);
                    if roleNode then
                        --local appName = getAppName():getData();
                        --local flag = string.match(appName, "KDSG_ANDR960x540")   --表示不是兽兽官网
                        --local flag1 = string.match(appName, "KDSG_ANDR800x480")
                        --if flag or flag1 then
                        --    roleNode:setScale(0.8)
                        --end
                        if currentDeviceType() == SC_DEVICE_TYPE_960x540 or currentDeviceType() == SC_DEVICE_TYPE_800x480 then
                            roleNode:setScale(0.7)
                        end
                        roleNode:setAnchorPoint(CCPointMake(0.5, 0));
                        roleNode:setPosition(CCPointMake(pNode:getContentSize().width/2, SY(17)));
                        pNode:addChild(roleNode);
                    end
                end	
                local pBtn = SCButton:button()
                if pBtn then
                    pBtn:setContentSize(CCSizeMake(SX(50), SY(85)));
                    pBtn:setTag(i);
                    pBtn:setAnchorPoint(CCPointMake(0.5, 0));
                    pBtn:setPosition(CCPointMake(pNode:getContentSize().width/2, SY(17)));
                    pBtn:luaSetSelectorOnClicked(sendBeginFight);
                    pNode:addChild(pBtn);
                end
                --[[local imgFace = getFaceImg(tmp.vecArenaPlayer[i].nPhoto);
                if imgFace then
                    imgFace:setAnchorPoint(CCPointMake(0.5, 0.5));
                    imgFace:setPosition(CCPointMake(pImgBtn:getContentSize().width / 2, pImgBtn:getContentSize().height / 2));
                    pImgBtn:addChild(imgFace);
                end]]
                pImgNode:addChild(pNode);
            end
        end
    end
end

local function fillArenaHistory(tmp)
    local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("1012-30"));
    if nil == pListBox then
        return;
    end
    pListBox:removeAllItems();
    pListBox:setTouchEnabled(false);
    pListBox:setScrollHorizontal(false);
    pListBox:setScrollVertical(false);
    local cout = #tmp.vecArenaHistory;
    for i = 1, cout do
        table.insert(m_listArenaHistory, i, tmp.vecArenaHistory[cout - i + 1]);
    end

    for i = 1, #m_listArenaHistory do
        if 5 == i then
            break;
        end
        
        local pNode = SCFunction:getUiByZipAndId(1012, 102);
        if pNode then
            local pBgImg = SCTypeCast:castNodeToImage(pNode:getChildByTag(3));
            if pBgImg then
                pBgImg:setScaleX(getNodeContentSize(pNode).width / getNodeContentSize(pBgImg).width);
            end

            local pInfoLab = SCTypeCast:castNodeToLabel(pNode:getChildByTag(2));
            if nil == pInfoLab then
                return;
            end
            local szInfo = m_listArenaHistory[i].szPastTime;
            if m_listArenaHistory[i].ucRiseFightFlag == 1 then
                szInfo = szInfo .. _LTParser("str0018");
                szInfo = szInfo .. m_listArenaHistory[i].szTargetName;
                szInfo = szInfo .. ", ";
            else
                szInfo = szInfo .. " *6";
                szInfo = szInfo .. m_listArenaHistory[i].szTargetName;
                szInfo = szInfo .. _LTParser("str0019");
            end

            if m_listArenaHistory[i].ucWinFlag == 1 then
                szInfo = szInfo .. _LTParser("str0020");
            else
                szInfo = szInfo .. _LTParser("str0021");
            end

            local pParseNode = getItemTextNode(szInfo);
            if pParseNode then
                pParseNode:setAnchorPoint(CCPointMake(0,0));
                setNodePostion(pParseNode, CCPointMake(0,0));
                pInfoLab:addChild(pParseNode);
            end
            pNode = SCTypeCast:castNodeToDragNode(pNode);
            if pNode then
                pNode:setFrameType(EnumFrameTypeListNormal);
                pNode:setFrameVisibled(false);
                pNode:setDragEnabled(false)
            end

            pListBox:addItem(pNode);
        end
    end
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        fillRankInfo(m_RankInfo);
        fillOtherPlayerInfo(m_OtherPlayerInfo);
        fillArenaHistory(m_ArenaHistory);
        setRestartGuideFlag(GUIDE_TYPE_AREAN, true);
        showGuideStep(GUIDE_TYPE_AREAN, 4, 4);
    end
end

local function showArenaWnd()
    local wndCtrl = createWnd();
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
        naviCtrl:pushWindowController(wndCtrl, NavigateStyleBottomToTop);
        wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
    end
end

local function setRankInfo(tmp)
    m_RankInfo = tmp;
end

local function setOtherPlayerInfo(tmp)
    m_OtherPlayerInfo = tmp;
end

local function setArenaHistory(tmp)
    m_ArenaHistory = tmp;
    showArenaWnd();
end

function ArenaController_openWnd()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ARENA);
    if dataStream then        
        dataStream:writeShort(ARENASCRITP_RANK_INFO);
        SCDataTransThread:getSingleton():transData(dataStream);
    end
end

function refreshArenaControllerHufuTimes(times)
	local pParticipantTimesLab = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("1012-7-10"))
	if pParticipantTimesLab then
		local szTmp = string.format(L("str30187"), times)
		pParticipantTimesLab:setText(szTmp);
	end
end

local function recvArenaInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
    local action = dt:readShort()
    if action == ARENASCRITP_RANK_INFO then
        local wnd = getCurentSceneWindow(1012);
        if wnd then
            fillRankInfo(ArenaRankInfo.initWithStream(dt));
        else
            setRankInfo(ArenaRankInfo.initWithStream(dt));
        end
    elseif action == ARENASCRITP_PLAYER_LIST then
        local wnd = getCurentSceneWindow(1012);
        if wnd then
            fillOtherPlayerInfo(AllArenaPlayer.initWithStream(dt));
        else
            setOtherPlayerInfo(AllArenaPlayer.initWithStream(dt));
        end
    elseif action == ARENASCRITP_HISTORY_LIST then
        local wnd = getCurentSceneWindow(1012);
        if wnd then
            fillArenaHistory(NearestArenaHistory.initWithStream(dt));
        else
            setArenaHistory(NearestArenaHistory.initWithStream(dt));
        end
    elseif action == ARENASCRITP_PVPBATTLE_INFO then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_INFO, dt);
    elseif action == ARENASCRITP_PVPBATTLE_MAXWIN then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_MAXWIN, dt);
    elseif action == ARENASCRITP_PVPBATTLE_RESULT then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_RESULT, dt);
    elseif action == ARENASCRITP_PVPBATTLE_RESULT_END then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_RESULT_END, dt);
    elseif action == ARENASCRITP_PVPBATTLE_UPDATE_RESULT then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_UPDATE_RESULT, dt);
    elseif action == ARENASCRITP_PVPBATTLE_ADD_RESULT then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_ADD_RESULT, dt);
    elseif action == ARENASCRITP_PVPBATTLE_CLOSE_WND then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_CLOSE_WND, dt);
    elseif action == ARENASCRITP_PVPBATTLE_GAME_OVER then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_GAME_OVER, dt);
    elseif action == ARENASCRITP_PVPBATTLE_EVERYBODY_RESULT then
        LuaData:getSingleton():setDataTransStream(LuaData_ARENASCRITP_PVPBATTLE_EVERYBODY_RESULT, dt);
    elseif action == ARENASCRIPT_TRIBEWAR_GIFT_LIST then
        setTrophieInfo(action, dt);
    elseif action == ARENASCRIPT_TRIBEWAR_GIFT_MEMBER then
        setTrophieInfo(action, dt);
	elseif action == ARENASCRITP_DUEL_USETINFO then
        DuelTemple_revcHeroData(dt);
    elseif action == ARENASCRITP_DUEL_LATELYINFO then
        DuelTemple_revcHistoryData(dt);
	elseif action == ARENASCRITP_DUEL_OPENPAIR then
        DuelTemple_setCancleButton();
	elseif action == ARENASCRITP_DUEL_RIVALINFO then
        DuelTemple_revcPlayData(dt);
	elseif action == ARENASCRITP_DUEL_CLOSEPAIR then
        DuelTemple_setOkButton();
    elseif action == ARENASCRITP_DUEL_DAYMATCH then
        DuelTemple_refreshFightTimes(dt);
    elseif action == ARENASCRITP_DUEL_AWARD then
        DuelTemple_showAward(dt);
	elseif action ==  ARENASCRITP_YANWU_INFO then
        local tmp = styanwuInfo.initWithStream(dt)
        yanwu_showWnd(tmp)
    elseif  action == ARENASCRITP_YANWU_PLAYERINFO  then
        local tmp = styanwu1Info.initWithStream(dt)
    elseif  action == ARENASCRITP_YANWU_PLAYERINFO_END  then    
		local tmp = styanwu1Info.initWithStream(dt)
		xingji_mark = tmp.ntype+2
		yanwu_close_wnd()
		yanwu1_showWnd()
        yanwu1_showpeo(yanwu_mark,xingji_mark)
        yanwu1_show_new(yanwu_mark)
        yanwu1_xing(yanwu_mark,xingji_mark)
        yanwu1_zdbutton(xingji_mark)
    elseif  action == ARENASCRITP_YANWU_AWARDINFO  then
        local tmp = stYanWuAwardInfo.initWithStream(dt)    
        yanwu1_time_end(tmp,yanwu_mark)
	elseif  action ==  ARENASCRITP_YANWU_ADD  then
		local tmp = styanwu1add_NumInfo.initWithStream(dt)
		yanwu1_del_owe(tmp,yanwu_mark)
		yanwu1_addpeop(tmp,yanwu_mark,xingji_mark)
		yanwu1_xing(yanwu_mark,xingji_mark)
	elseif action == ARENASCRITP_YANWU_DEL then
		local tmp = styanwu1delInfo.initWithStream(dt)    
		yanwu1_del_peo(tmp,yanwu_mark)
	elseif action == ARENASCRITP_YANWU_LATELYINFO  then
		local tmp = styanwu1newscountInfo.initWithStream(dt)
		yanwu1_news(tmp)
	elseif action == ARENASCRITP_ADD_PVP_TIMES then
		local times = dt:readInt()
		refreshDuelTempleHufuTimes(times)
		refreshArenaControllerHufuTimes(times)
		refreshChallengeViewHufuTimes(times)
		yanwu1_buy_hufu(times)
    end 
end

SCMessageCenter:getSingleton():luaRegistCommand(recvArenaInfo, _MSG_ARENA, 0, nil)