
--小助手界面
local MSG_SOCIATY_TAKE_PART_CAMPAIGN		= 35;--	//参与活动
local MSG_SOCIATY_CAMPAIGNS				= 30;	--公会活动
local USERINFO_OPEN_WORLD_EVENT         = 75;   --打开世界活动

local USERINFO_INTERIM_AWARD=54
local USERINFO_USE_EVERYDAY	= 52 --点击使用或找回
local USERINFO_JION_WORLD_EVENT= 76	--参与世界活动或改按钮

stDailyTaskInfo = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.usIndex = dt:readShort()
		tmp.szName = dt:readString()
		if tmp.szName then
			tmp.szName = tmp.szName:getData()
		else
			tmp.szName = ""
		end
		tmp.szState = dt:readString()
		if tmp.szState then
			tmp.szState = tmp.szState:getData()
		else
			tmp.szState = ""
		end
		tmp.usRemain = dt:readShort()
		tmp.byType = dt:readByte()
		tmp.szButton = dt:readString()
		if tmp.szButton then
			tmp.szButton = tmp.szButton:getData()
		else
			tmp.szButton = ""
		end
		return tmp
	end
}
stSignPics = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.usNum = dt:readShort()
		tmp.byType = dt:readByte()
		tmp.taskInfo = {}
		for i=1, tmp.usNum do
			table.insert(tmp.taskInfo, stDailyTaskInfo.initWithStream(dt))
		end
		return tmp
	end
}

stDailyPlayerInfo = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.usRanking = dt:readShort()
		tmp.dwPower = dt:readInt()
		tmp.dwReputation = dt:readInt()
		tmp.dwSee = dt:readInt()
		tmp.usMaxFriend = dt:readShort()
		tmp.usOwnFriend = dt:readShort()
		tmp.dwAchieve = dt:readInt()
		return tmp
	end
}

stDailyAwardInfo = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.byType = dt:readByte()
		tmp.szdata = dt:readString()
		if tmp.szdata then
			tmp.szdata = tmp.szdata:getData()
		else
			tmp.szdata = ""
		end
		return tmp
	end
}

stWorldActivitySingle = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.usIndex = dt:readShort()
		tmp.szName = dt:readString()
		if tmp.szName then
			tmp.szName = tmp.szName:getData()
		else
			tmp.szName = ""
		end
		tmp.szState = dt:readString()
		if tmp.szState then
			tmp.szState = tmp.szState:getData()
		else
			tmp.szState = ""
		end
		tmp.byType = dt:readByte()
		tmp.szButton = dt:readString()
		if tmp.szButton then
			tmp.szButton = tmp.szButton:getData()
		else
			tmp.szButton = ""
		end
		tmp.nPhoto = dt:readInt()
		return tmp
	end
}
stWorldActivityInfo = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.byNum = dt:readByte()
		tmp.worldActiInfos = {}
		for i=1, tmp.byNum do
			table.insert(tmp.worldActiInfos, stWorldActivitySingle.initWithStream(dt))
		end
		return tmp
	end
}

stSociatyCampaignSingle = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.usCampaignType = dt:readShort()
		tmp.szName = dt:readString()
		if tmp.szName then
			tmp.szName = tmp.szName:getData()
		else
			tmp.szName = ""
		end
		tmp.nPhoto = dt:readInt()
		tmp.szMsg = dt:readString()
		if tmp.szMsg then
			tmp.szMsg = tmp.szMsg:getData()
		else
			tmp.szMsg = ""
		end
		tmp.ucFlag = dt:readByte()
		tmp.ucTakePartIn = dt:readByte()
		tmp.szBtn = dt:readString()
		if tmp.szBtn then
			tmp.szBtn = tmp.szBtn:getData()
		else
			tmp.szBtn = ""
		end
		return tmp
	end
}
stSociatyCampaignInfo = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		tmp.ucAmount = dt:readByte()
		tmp.stfill = {}
		for i=1, tmp.ucAmount do
			table.insert(tmp.stfill, stSociatyCampaignSingle.initWithStream(dt))
		end
		return tmp
	end
}

--公会活动中的按钮点击
local function onClickPartyNode(tag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE)
    dataStream:writeShort(MSG_SOCIATY_TAKE_PART_CAMPAIGN)
    dataStream:writeShort(tag)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show();
end
--刷新公会活动信息
local function refreshPartyActivityInfo(wnd, socCampaign)
	local listNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-2-401", wnd))
	if not listNode then
		return
	end
	local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("1", listNode))
	if pListBox then
		for i=1, socCampaign.ucAmount do
			local pNode = pListBox:getChildByTag(socCampaign.stfill[i].usCampaignType)
			if not pNode then
				local pNode = SCDragNode:node();
				pNode:setDragEnabled(false);
				pNode:setFrameType(EnumFrameTypeListNormal);
				pNode:setFrameVisibled(true);
				setNodeContentSize(pNode, CCSizeMake(420, 48));

				local pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..socCampaign.stfill[i].nPhoto..".png");
				if not pBtn then
					return 
				end
				setNodePostion(pBtn, CCPointMake(0, 5));
				pBtn:setTag(1000);
				pNode:addChild(pBtn);

				local pLable = SCLabel:labelWithStringFont(socCampaign.stfill[i].szName, getDefaultFontName(), getFontSize(15));
				if pLable then
					pLable:setColor(color_orange);
					setNodePostion(pLable, CCPointMake(getNodeContentSize(pBtn).width+10, getNodeContentSize(pNode).height-getNodeContentSize(pLable).height-5));
					pNode:addChild(pLable);
				end

				local parseNode = getItemTextNode(socCampaign.stfill[i].szMsg);
				setNodePostion(parseNode, CCPointMake(getNodeContentSize(pBtn).width+10, 5));
				pNode:addChild(parseNode);

				if socCampaign.stfill[i].ucFlag == 1 then
					if socCampaign.stfill[i].ucTakePartIn == 1 then
						local pButton = SCButton:button(EnumBtnType9Atlas);
						setNodeContentSize(pButton, small_btn_size);
						pButton:luaSetSelectorOnClicked(onClickPartyNode);
						pButton:setTitle(socCampaign.stfill[i].szBtn, getDefaultFontName(), getFontSize(12), button_title_color);
						pButton:setAnchorPoint(CCPointMake(0.5, 0.5));
						setNodePostion(pButton, CCPointMake(410-getNodeContentSize(pButton).width/2, getNodeContentSize(pNode).height/2));
						pButton:setTag(socCampaign.stfill[i].usCampaignType);
						pNode:addChild(pButton);
					else
						local pLable = SCLabel:labelWithStringFont(socCampaign.stfill[i].szBtn, getDefaultFontName(), getFontSize(12));
						pLable:setAnchorPoint(CCPointMake(0.5, 0.5));
						setNodePostion(pLable, CCPointMake(400-getNodeContentSize(pLable).width/2, getNodeContentSize(pNode).height/2));
						pLable:setColor(button_title_color);
						pNode:addChild(pLable);
					end
				else
					local pLable = SCLabel:labelWithStringFont(socCampaign.stfill[i].szBtn, getDefaultFontName(), getFontSize(12));
					pLable:setAnchorPoint(CCPointMake(0.5, 0.5));
					setNodePostion(pLable, CCPointMake(410-getNodeContentSize(pLable).width/2, getNodeContentSize(pNode).height/2));
					pLable:setColor(button_title_color);
					pNode:addChild(pLable);
				end
				pListBox:addItem(pNode);
				pNode:setTag(socCampaign.stfill[i].usCampaignType);
			end
		end
	end
	activityVisibleAnimation()
end
--公会活动信息
local function partyActivityInfo(dt)
	if not dt then
		return
	end
	local wnd = getCurentSceneWindow(5201)
	if wnd then
		refreshPartyActivityInfo(wnd, stSociatyCampaignInfo.initWithStream(dt))
	end
end
--更改替身娃娃状态
local function changeDollType(wnd, dt)
	local index = dt.readShort();
	local type = dt.readByte();
	local checkBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("5201-1-3-401-"..index.."-"..index))
	if checkBox then
		if type == 1 then
			checkBox:setSelect(true)
		else
			checkBox:setSelect(false)
		end
	end
end
--替身娃娃
local function dollTypeInfo()
	local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
		return
	end
	local wnd = getCurentSceneWindow(5201)
	if wnd then
		changeDollType(wnd, dt)
	end
end
--世界活动中替身娃娃点击
local function onWorldCheckBoxClick(tag, select)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_JION_WORLD_EVENT)
    dataStream:writeShort(tag)
    dataStream:writeByte(select)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show()
	local checkBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("5201-1-3-401-"..tag.."-"..tag))
	if checkBox then
		if select == 1 then
			checkBox:setSelect(false)
		else
			checkBox:setSelect(true)
		end
	end
end
--世界活动中的按钮点击
local function onClickWorldNode(tag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_JION_WORLD_EVENT)
    dataStream:writeShort(tag)
    dataStream:writeByte(2)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show();
end
--刷新世界活动数据
local function refreshWorldActivityInfo(wnd, worldActivInfo)
	local listNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-3-401", wnd))
	if not listNode then
		return
	end
	local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("1", listNode))
	if pListBox then
		for i=1, worldActivInfo.byNum do
			local pNode = pListBox:getChildByTag(worldActivInfo.worldActiInfos[i].usIndex)
			if not pNode then
				local pNode = SCDragNode:node();
				pNode:setDragEnabled(false);
				pNode:setFrameType(EnumFrameTypeListNormal);
				pNode:setFrameVisibled(true);
				setNodeContentSize(pNode, CCSizeMake(420, 48));

				local pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..worldActivInfo.worldActiInfos[i].nPhoto..".png");
				if not pBtn then
					return 
				end
				setNodePostion(pBtn, CCPointMake(0, 5));
				pBtn:setTag(1000);
				pNode:addChild(pBtn);

				local pLable = SCLabel:labelWithStringFont(worldActivInfo.worldActiInfos[i].szName, getDefaultFontName(), getFontSize(15));
				if pLable then
					pLable:setColor(color_orange);
					setNodePostion(pLable, CCPointMake(getNodeContentSize(pBtn).width+10, getNodeContentSize(pNode).height-getNodeContentSize(pLable).height-5));
					pNode:addChild(pLable);
				end

				local pLable = SCLabel:labelWithStringFont(worldActivInfo.worldActiInfos[i].szState, getDefaultFontName(), getFontSize(12));
				if pLable then
					setNodePostion(pLable, CCPointMake(getNodeContentSize(pBtn).width+10, 5));
					pNode:addChild(pLable);
				end
				
				if worldActivInfo.worldActiInfos[i].byType == 0 then
				
				elseif worldActivInfo.worldActiInfos[i].byType == 1 then
					local pButton = SCButton:button(EnumBtnType9Atlas);
					setNodeContentSize(pButton, small_btn_size);
					pButton:luaSetSelectorOnClicked(onClickWorldNode);
					pButton:setTitle(worldActivInfo.worldActiInfos[i].szButton, getDefaultFontName(), getFontSize(12), button_title_color);
					pButton:setAnchorPoint(CCPointMake(0.5, 0.5));
					setNodePostion(pButton, CCPointMake(410-getNodeContentSize(pButton).width/2, getNodeContentSize(pNode).height/2));
					pButton:setTag(worldActivInfo.worldActiInfos[i].usIndex);
					pNode:addChild(pButton);
				elseif worldActivInfo.worldActiInfos[i].byType == 2 then
					local pLable = SCLabel:labelWithStringFont(_LTParser("str5015"), getDefaultFontName(), getFontSize(12));
					pLable:setAnchorPoint(CCPointMake(0.5, 0.5));
					setNodePostion(pLable, CCPointMake(400-getNodeContentSize(pLable).width/2, getNodeContentSize(pNode).height/2));
					pLable:setColor(button_title_color);
					pNode:addChild(pLable);
				elseif worldActivInfo.worldActiInfos[i].byType == 3 then
					local checkBox = SCCheckBox:boxWithDescribe(_LTParser("str5098"), getDefaultFontName(), getFontSize(12), color_orange);
					checkBox:luaSetSelectorOnButtonClicked(onWorldCheckBoxClick);
					checkBox:setTag(worldActivInfo.worldActiInfos[i].usIndex);
					checkBox:setSelect(false);
					checkBox:setAnchorPoint(CCPointMake(0.5, 0.5));
					setNodePostion(checkBox, CCPointMake(410-getNodeContentSize(checkBox).width/2, getNodeContentSize(pNode).height/2));
					pNode:addChild(checkBox);
				elseif worldActivInfo.worldActiInfos[i].byType == 4 then
					local checkBox = SCCheckBox:boxWithDescribe(_LTParser("str5098"), getDefaultFontName(), getFontSize(12), color_orange);
					checkBox:luaSetSelectorOnButtonClicked(onWorldCheckBoxClick);
					checkBox:setTag(worldActivInfo.worldActiInfos[i].usIndex);
					checkBox:setSelect(true);
					checkBox:setAnchorPoint(CCPointMake(0.5, 0.5));
					setNodePostion(checkBox, CCPointMake(410-getNodeContentSize(checkBox).width/2, getNodeContentSize(pNode).height/2));
					pNode:addChild(checkBox);
				end
				pListBox:addItem(pNode);
				pNode:setTag(worldActivInfo.worldActiInfos[i].usIndex);
			end
		end
	end
	activityVisibleAnimation()
end
--世界活动信息
local function worldActivityInfo()
	local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
		return
	end
	yanwu2_recvWorldEvent(dt)
	--PopularActivities_recvWorldEvent(dt);
--[[	local wnd = getCurentSceneWindow(5201)
	if wnd then
		refreshWorldActivityInfo(wnd, stWorldActivityInfo.initWithStream(dt))
	end
	if isGuideCanStart(GUIDE_TYPE_AREAN) then
		setGuideRestartFlag(GUIDE_TYPE_AREAN, true);
		showGuideStep(GUIDE_TYPE_AREAN, 3, 3);
	elseif isGuideCanStart(GUIDE_TYPE_WOLRD_BOSS) then
		showGuideStep(GUIDE_TYPE_WOLRD_BOSS, -1);
	elseif isGuideCanStart(GUIDE_TYPE_MORECOPY) then
		setGuideRestartFlag(GUIDE_TYPE_MORECOPY, true);
		showGuideStep(GUIDE_TYPE_MORECOPY, 3, 3);
	elseif isGuideCanStart(GUIDE_TYPE_PVPBATTLE) then
		showGuideStep(GUIDE_TYPE_PVPBATTLE, -1);
	elseif isGuideCanStart(GUIDE_TYPE_3V3) then
		showGuideStep(GUIDE_TYPE_3V3, -1);
	elseif isGuideCanStart(GUIDE_TYPE_BUDDHIST_SCRIPTURES) then
		setGuideRestartFlag(GUIDE_TYPE_BUDDHIST_SCRIPTURES, true);
		showGuideStep(GUIDE_TYPE_BUDDHIST_SCRIPTURES, 3, 3);
	end--]]
end
--刷新每日任务奖励
local function refreshAwardInfo(wnd, awardInfo)
	local playerInfoNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-1-301", wnd))
	if not playerInfoNode then
		return
	end
	local pTextBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("16", playerInfoNode))
	if pTextBox then
		pTextBox:setVisible(true);
		pTextBox:setText(awardInfo.szdata);
	end

	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("17", playerInfoNode))
	if pBtn then
		if awardInfo.byType == 0 or awardInfo.byType == 1 then
			pBtn:setVisible(true)
		elseif awardInfo.byType == 2 then
			pBtn:setVisible(false)
		end
	end
end
--每日任务奖励
local function everyDayAwardInfo()
	local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
		return
	end
	local wnd = getCurentSceneWindow(5201)
	if wnd then
		refreshAwardInfo(wnd, stDailyAwardInfo.initWithStream(dt))
	end
end
--刷新每日任务任务信息
local function refreshPlayerInfo(wnd, playerInfo)
	local playerInfoNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-1-301", wnd))
	if not playerInfoNode then
		return
	end
	for i=9, 14 do
		local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent(i.."", playerInfoNode))
		if pLabel then
			if i == 9 then
				pLabel:setText(playerInfo.usRanking.."");
			elseif i==10 then
				pLabel:setText(playerInfo.dwPower.."");
			elseif i==11 then
				pLabel:setText(playerInfo.dwReputation.."");
			elseif i==12 then
				pLabel:setText(playerInfo.dwSee.."");
			elseif i==13 then
				pLabel:setText(playerInfo.usOwnFriend.."/"..playerInfo.usMaxFriend);
			elseif i==14 then
				pLabel:setText(playerInfo.dwAchieve.."");
			end
		end
	end
end
--每日任务任务信息
local function everyDayPlayerInfo()
	local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
		return
	end
	local wnd = getCurentSceneWindow(5201)
	if wnd then
		refreshPlayerInfo(wnd, stDailyPlayerInfo.initWithStream(dt))
	end
end
--点击领取奖励
local function onClickGetAward(tag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_INTERIM_AWARD)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show();
end
--选择分页
local function onAssistantMultPageSelect(tag, pageIndex)
	endGuideWnd()
	local multiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("5201-1"))
	if not multiPage then
		return
	end
	if 2 == pageIndex then
		if multiPage:isPageFirstTimeSelected(pageIndex) then
			local dt = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
			dt:writeShort(USERINFO_OPEN_WORLD_EVENT)
			SCDataTransThread:getSingleton():transData(dt)
			SCActivityIndicator:getSingleton():show()
		end
	elseif 1 == pageIndex then
		if multiPage:isPageFirstTimeSelected(pageIndex) then
			local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE)
			dt:writeShort(MSG_SOCIATY_CAMPAIGNS_SIGNPICS)
			SCDataTransThread:getSingleton():transData(dt)
			SCActivityIndicator:getSingleton():show()
		end
	elseif 0 == pageIndex then
		if multiPage:isPageFirstTimeSelected(pageIndex) then
			local dt = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
			dt:writeShort(USERINFO_OPEN_EVERYDAY)
			SCDataTransThread:getSingleton():transData(dt)
			SCActivityIndicator:getSingleton():show()
		end
	end
end
--创建小助手窗口
local function createAssistantWnd()
	local wnd = getCurentSceneWindow(5201)
	if wnd then
		return wnd
	end
	
	wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(5201))
	if not wnd then
		return nil
	end
	local title = getRealUIResourcePath("img/titile20.png");
	if title then
		wnd:setTitleWithImage(title:getData())
	end
	multiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlistAndParent("1", wnd))
	if multiPage then
		multiPage:luaSetSelectorOnPageSelected(onAssistantMultPageSelect)
		multiPage:setTitleAtPage(_LTParser("str0028"), getDefaultFontName(), getFontSize(15), 0);
		multiPage:setTitleAtPage(_LTParser("str0027"), getDefaultFontName(), getFontSize(15), 1);
		multiPage:setTitleAtPage(_LTParser("str0026"), getDefaultFontName(), getFontSize(15), 2);
	end
	local pNode = multiPage:getPageWithIndex(0)
	if pNode then
		local playerInfoNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(5201, 301))
		if playerInfoNode then
			playerInfoNode:setPosition(CCPointMake(SX(15), SY(15)))
			playerInfoNode:setFrameType(EnumFrameTypeRound);
			playerInfoNode:setFrameVisibled(true);
			playerInfoNode:setDragEnabled(false);
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1", playerInfoNode))
			if pLabel then
				pLabel:setColor(color_orange);
			end
			local pImage = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("2", playerInfoNode))
			if pImage then
				pImage:setScaleX(0.85);
			end
			for i=3, 8 do
				local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent(i.."", playerInfoNode))
				if pLabel then
					pLabel:setColor(color_lightYellow)
				end
			end

			local pTextBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("16", playerInfoNode))
			if pTextBox then
				pTextBox:setScrollVertical(false);
				pTextBox:setVisible(false);
			end

			local pButton = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("17", playerInfoNode))
			if pButton then
				pButton:luaSetSelectorOnClicked(onClickGetAward)
				pButton:setVisible(false);
			end
			pNode:addChild(playerInfoNode);
		end
		local taskInfoNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(5201, 302))
		if taskInfoNode then
			taskInfoNode:setAnchorPoint(CCPointMake(1,0));
			taskInfoNode:setPosition(CCPointMake(SX(WindowsWidth-15), SY(15)));
			taskInfoNode:setFrameType(EnumFrameTypeRound);
			taskInfoNode:setFrameVisibled(true);
			taskInfoNode:setDragEnabled(false);
			local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1", taskInfoNode))
			if pLabel then
				pLabel:setColor(color_orange);
			end
			pNode:addChild(taskInfoNode);
		end
	end
	local pNode = multiPage:getPageWithIndex(1)
	if pNode then
		local listNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(5201, 401))
		if listNode then
			listNode:setDragEnabled(false);
			listNode:setFrameType(EnumFrameTypeRound);
			listNode:setFrameVisibled(true);
			pNode:addChild(listNode);
		end
	end
	local pNode = multiPage:getPageWithIndex(2)
	if pNode then
		local listNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(5201, 401))
		if listNode then
			listNode:setDragEnabled(false);
			listNode:setFrameType(EnumFrameTypeRound);
			listNode:setFrameVisibled(true);
			pNode:addChild(listNode);
		end
	end
	return wnd
end
--点击每日任务中的按钮
local function onClickDailyNode(tag)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_USE_EVERYDAY)
    dataStream:writeByte(0)
    dataStream:writeInt(tag)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show()
	if tag == 13 then
		showFriendWnd()
	end	
end
--刷新每日任务信息
local function refreshDailyInfo(wnd, signPics)
	local taskInfoNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1-1-302", wnd))
	if not taskInfoNode then
		return
	end
	local pListBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlistAndParent("2", taskInfoNode))
	if pListBox then
		if signPics.byType == 1 then
			for i=1, signPics.usNum do
				local pNode = pListBox:getChildByTag(signPics.taskInfo[i].usIndex)
				if not pNode then
					local pNode = SCDragNode:node();
					pNode:setDragEnabled(false);
					pNode:setFrameType(EnumFrameTypeListNormal);
					pNode:setFrameVisibled(true);
					pNode:setContentSize(CCSizeMake(pListBox:getContentSize().width, SY(40)))
					
					local pParsedNode = getItemTextNode(signPics.taskInfo[i].szState);
					pParsedNode:setPosition(CCPointMake(SX(5), SY(16)))
					pParsedNode:setTag(1);
					pNode:addChild(pParsedNode);
					
					local pButton = SCButton:button(EnumBtnType9Atlas)
					setNodeContentSize(pButton, small_btn_size);
					pButton:luaSetSelectorOnClicked(onClickDailyNode);
					pButton:setTitle(signPics.taskInfo[i].szButton, getDefaultFontName(), getFontSize(15), button_title_color);
					if signPics.taskInfo[i].byType == 2 then
						pButton:setVisible(false);
					end
					pButton:setAnchorPoint(CCPointMake(1, 0));
					pButton:setPosition(CCPointMake(pNode:getContentSize().width-SX(5), (pNode:getContentSize().height-pButton:getContentSize().height)/2))
					pButton:setTag(signPics.taskInfo[i].usIndex);
					pNode:addChild(pButton);
					
					pListBox:addItem(pNode);
					pNode:setTag(signPics.taskInfo[i].usIndex);
				end
			end
		elseif signPics.byType == 2 then
			for i=1, signPics.usNum do
				local pNode = pListBox:getChildByTag(signPics.taskInfo[i].usIndex)
				if not pNode then
					pNode:removeChildByTag(1, true);
					local pParsedNode = getItemTextNode(signPics.taskInfo[i].szState);
					pParsedNode:setPosition(CCPointMake(SX(5), SY(16)))
					pParsedNode:setTag(1);
					pNode:addChild(pParsedNode);

					local pButton = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(signPics.taskInfo[i].usIndex.."", pNode))
					pButtonsetTitle(signPics.taskInfo[i].szButton, getDefaultFontName(), getFontSize(15), color_white);
					if signPics.taskInfo[i].byType == 2 then
						pButton:setVisible(false);
					else
						pButton:setVisible(true);
					end
				end
			end
		end
	end
end
--窗口进出回调
local function wndCtrl5201(tag, evetype)
	if evetype == LuaControllerEventPushEnded then
		activityVisibleAnimation()
		if isGuideCanStart(GUIDE_TYPE_HELPER) then
			showGuideStep(GUIDE_TYPE_HELPER, -1)
		elseif isGuideCanStart(GUIDE_TYPE_AREAN) then	
			setGuideRestartFlag(GUIDE_TYPE_AREAN, true);
			showGuideStep(GUIDE_TYPE_AREAN, 2, 2);	
		elseif isGuideCanStart(GUIDE_TYPE_WOLRD_BOSS) then
			setGuideRestartFlag(GUIDE_TYPE_WOLRD_BOSS, true);
			showGuideStep(GUIDE_TYPE_WOLRD_BOSS, 2, 2);
		elseif isGuideCanStart(GUIDE_TYPE_MORECOPY) then
			setGuideRestartFlag(GUIDE_TYPE_MORECOPY, true);
			showGuideStep(GUIDE_TYPE_MORECOPY, 2, 2);
		elseif isGuideCanStart(GUIDE_TYPE_PVPBATTLE) then
			setGuideRestartFlag(GUIDE_TYPE_PVPBATTLE, true);
			showGuideStep(GUIDE_TYPE_PVPBATTLE, 2, 2);
		elseif isGuideCanStart(GUIDE_TYPE_3V3) then
			setGuideRestartFlag(GUIDE_TYPE_3V3, true);
			showGuideStep(GUIDE_TYPE_3V3, 2, 2);
		elseif isGuideCanStart(GUIDE_TYPE_BUDDHIST_SCRIPTURES) then
			setGuideRestartFlag(GUIDE_TYPE_BUDDHIST_SCRIPTURES, true);
			showGuideStep(GUIDE_TYPE_BUDDHIST_SCRIPTURES, 2, 2);
		end	
   elseif evetype == LuaControllerEventRemoveBegan or evetype == LuaControllerEventPopBegan then
		if isGuideCanStart(GUIDE_TYPE_AREAN) then
			if getGuideRestartFlag(GUIDE_TYPE_AREAN) then	
				restartGuideStep(GUIDE_TYPE_AREAN);		
			else		
				showGuideStep(GUIDE_TYPE_AREAN, -1);
			end
		elseif isGuideCanStart(GUIDE_TYPE_WOLRD_BOSS) then
			if getGuideRestartFlag(GUIDE_TYPE_WOLRD_BOSS) then
				restartGuideStep(GUIDE_TYPE_WOLRD_BOSS);
			end
		elseif isGuideCanStart(GUIDE_TYPE_MORECOPY) then
			if getGuideRestartFlag(GUIDE_TYPE_MORECOPY) then
				restartGuideStep(GUIDE_TYPE_MORECOPY);
			else
				showGuideStep(GUIDE_TYPE_MORECOPY, -1);
			end
		elseif isGuideCanStart(GUIDE_TYPE_PVPBATTLE) then
			if getGuideRestartFlag(GUIDE_TYPE_PVPBATTLE) then
				restartGuideStep(GUIDE_TYPE_PVPBATTLE);
			end
		elseif isGuideCanStart(GUIDE_TYPE_3V3) then
			if getGuideRestartFlag(GUIDE_TYPE_3V3) then
				restartGuideStep(GUIDE_TYPE_3V3);
			end
		elseif isGuideCanStart(GUIDE_TYPE_BUDDHIST_SCRIPTURES) then
			if getGuideRestartFlag(GUIDE_TYPE_BUDDHIST_SCRIPTURES) then
				restartGuideStep(GUIDE_TYPE_BUDDHIST_SCRIPTURES);
			end
		end
   end
end
--每日任务信息
local function everyDayTaskInfo()
	local dt = LuaData:getSingleton():getDataTransStream()
	if not dt then
		return
	end
	local wnd = getCurentSceneWindow(5201)
	if not wnd then
		wnd = createAssistantWnd()
		refreshDailyInfo(wnd, stSignPics.initWithStream(dt))
		local wndCtrl = SCWindowController:controllerWithWindow(wnd)
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl and wndCtrl then
			wndCtrl:luaSetSelectorOnEvent(wndCtrl5201)
			naviCtrl:pushWindowController(wndCtrl)
		end
	else
		refreshDailyInfo(wnd, stSignPics.initWithStream(dt))
	end
end

function showPartActivityInfo(dt)
	partyActivityInfo(dt)
end

--日常任务
LuaData:getSingleton():luaSetSelectorOnRecvData(everyDayTaskInfo, LuaData_USERINFO_OPEN_EVERYDAY)
--小助手玩家信息
LuaData:getSingleton():luaSetSelectorOnRecvData(everyDayPlayerInfo, LuaData_USERINFO_SEND_USERINFO)
--LuaData_USERINFO_INTERIM_AWARD 日常奖励
LuaData:getSingleton():luaSetSelectorOnRecvData(everyDayAwardInfo, LuaData_USERINFO_INTERIM_AWARD)
---打开世界活动
LuaData:getSingleton():luaSetSelectorOnRecvData(worldActivityInfo, LuaData_USERINFO_OPEN_WORLD_EVENT)
--更改替身娃娃
LuaData:getSingleton():luaSetSelectorOnRecvData(dollTypeInfo, LuaData_USERINFO_JION_WORLD_EVENT)