--定义一个与文件名相同的table
BattleStrengthen = {}
------------------消息--------------------

----------------结构定义区----------------
--[[
	typedef struct
	{
		UCHAR flag;//是否开启
		char szname[64];
		char describe[128];//如果已开启，显示功能已开启，未开启，显示几级开启
		int idphoto;
	}stFunctionInfo;
	
	const unsigned short _MSG_USERINFO			=_MSG_GENERAL+6;

    USERINFO_SEND_UNLOCK_TIP = 109,    //发送解锁条件Tip

    上发:
    typedef struct  
    {
        USHORT usType;  //解锁类型 
    }Msg_tInfo6;

    下发:

    typedef struct  
    {
        char szMsgBuf[_MAX_MSGSIZE];
    }Msg_DescriptionView;
]]

local stFunctionInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local tmp = {
			__mode = "kv",
		}
		tmp.flag = dt:readByte();
		tmp.idName = dt:readInt();

        local str = dt:readString();
		if str == nil then
			tmp.strDescribe = "";
		else
		    tmp.strDescribe = str:getData();
		end
		
		tmp.idphoto = dt:readInt();
		
		return tmp;
	end
}

local m_stHelperInfo = {}
----------------常量定义区----------------
local m_unLockType = {UNLOCK_TYPE_MAGIC_LEVELUP, UNLOCK_TYPE_EQUIP_STRENGTHEN, UNLOCK_TYPE_EQUIP_STRENGTHEN, UNLOCK_TYPE_RECRUITPARTNER, UNLOCK_TYPE_WING,
					UNLOCK_TYPE_TYPE4, UNLOCK_TYPE_TREASURE, UNLOCK_TYPE_TRIBE, UNLOCK_TYPE_RUNE_STONE}
local m_unLockImage = {"new00101", "new00113", "new00095", "new00110", "new00107", "new00109", "new00112", "new00104", "new00099"}
local m_unLockLevel = {6, 14, 14, 31, 50, 50, 52, 58, 70}
local USERINFO_SEND_UNLOCK_TIP = 109
----------------变量定义区----------------
--处理当前页
local m_curPage = nil
--变量的定义
----------------UI控制器区----------------
function BattleStrengthen.initControl()
	BattleStrengthen.m_pWnd = SCWindow:window()
	if BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:setTag(1040)
		BattleStrengthen.m_pWnd:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BattleStrengthen.m_pWnd:setPosition(AUTO_POS(0.00, 0.00))BattleStrengthen.m_pWnd:setContentSize(AUTO_SIZE(480, 320))
		BattleStrengthen.m_pWnd:luaSetSelectorOnClose(BattleStrengthen.releaseControl)
	end

	local imgPath = getRealUIResourcePath("img/new00097.png")
	local pImage1 = nil
	if imgPath then
		pImage1 = SCImage:imageWithFile(imgPath:getData())
		if pImage1 then
			pImage1:setTag(1)
			pImage1:setAnchorPoint(ANCHOR_CENTER)
			pImage1:setPosition(AUTO_POS(240.00, 160.00))
		end
	end

	BattleStrengthen.m_pButton2 = SCButton:button()
	if BattleStrengthen.m_pButton2 then
		BattleStrengthen.m_pButton2:setTag(2)
		BattleStrengthen.m_pButton2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BattleStrengthen.m_pButton2:setPosition(AUTO_POS(7.00, 220.00))
		BattleStrengthen.m_pButton2:setContentSize(AUTO_SIZE(32, 58))
		BattleStrengthen.m_pButton2:setTitle(L(""), DEFAULT_FONT_NAME, F(20))
		local pBackimg = getRealUIResourcePath("img/new00096.png")
		if pBackimg then
			BattleStrengthen.m_pButton2:setBackgroundImage(pBackimg:getData())
		end
	end

	BattleStrengthen.m_pButton3 = SCButton:button()
	if BattleStrengthen.m_pButton3 then
		BattleStrengthen.m_pButton3:setTag(3)
		BattleStrengthen.m_pButton3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BattleStrengthen.m_pButton3:setPosition(AUTO_POS(7.00, 150.00))
		BattleStrengthen.m_pButton3:setContentSize(AUTO_SIZE(32, 58))
		BattleStrengthen.m_pButton3:setTitle(L(""), DEFAULT_FONT_NAME, F(20))
		local pBackimg = getRealUIResourcePath("img/new00096.png")
		if pBackimg then
			BattleStrengthen.m_pButton3:setBackgroundImage(pBackimg:getData())
		end
	end

	BattleStrengthen.m_pButton4 = SCButton:button()
	if BattleStrengthen.m_pButton4 then
		BattleStrengthen.m_pButton4:setTag(4)
		BattleStrengthen.m_pButton4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BattleStrengthen.m_pButton4:setPosition(AUTO_POS(396.00, 25.00))
		BattleStrengthen.m_pButton4:setContentSize(AUTO_SIZE(30, 26))
		BattleStrengthen.m_pButton4:setTitle(L(""), DEFAULT_FONT_NAME, F(20))
		local pBackimg = getRealUIResourcePath("img/new00102.png")
		if pBackimg then
			BattleStrengthen.m_pButton4:setBackgroundImage(pBackimg:getData())
		end
	end

	BattleStrengthen.m_pListBox6 = SCListBox:boxWithWidthHeight(AUTO_W(172), AUTO_H(225))
	if BattleStrengthen.m_pListBox6 then
		tolua.cast(BattleStrengthen.m_pListBox6, "SCNode"):setTag(6)
		tolua.cast(BattleStrengthen.m_pListBox6, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(BattleStrengthen.m_pListBox6, "SCNode"):setPosition(AUTO_POS(55.00, 60.00))
	end

	BattleStrengthen.m_pListBox7 = SCListBox:boxWithWidthHeight(AUTO_W(172), AUTO_H(225))
	if BattleStrengthen.m_pListBox7 then
		tolua.cast(BattleStrengthen.m_pListBox7, "SCNode"):setTag(7)
		tolua.cast(BattleStrengthen.m_pListBox7, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(BattleStrengthen.m_pListBox7, "SCNode"):setPosition(AUTO_POS(255.00, 60.00))
	end

	BattleStrengthen.m_pButton5 = SCButton:button()
	if BattleStrengthen.m_pButton5 then
		BattleStrengthen.m_pButton5:setTag(5)
		BattleStrengthen.m_pButton5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BattleStrengthen.m_pButton5:setPosition(AUTO_POS(55.00, 25.00))
		BattleStrengthen.m_pButton5:setContentSize(AUTO_SIZE(30, 26))
		BattleStrengthen.m_pButton5:setTitle(L(""), DEFAULT_FONT_NAME, F(20))
		local pBackimg = getRealUIResourcePath("img/new00103.png")
		if pBackimg then
			BattleStrengthen.m_pButton5:setBackgroundImage(pBackimg:getData())
		end
	end

	BattleStrengthen.m_pTextBox = SCTextBox:boxWithWidthHeightFont(AUTO_W(172), AUTO_H(225), DEFAULT_FONT_NAME, F(15))
	if BattleStrengthen.m_pTextBox then
		tolua.cast(BattleStrengthen.m_pTextBox, "SCNode"):setTag(9)
		tolua.cast(BattleStrengthen.m_pTextBox, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(BattleStrengthen.m_pTextBox, "SCNode"):setPosition(AUTO_POS(55.00, 60.00))
		BattleStrengthen.m_pTextBox:setText(L(""))
	end

	BattleStrengthen.m_pButton8 = SCButton:button()
	if BattleStrengthen.m_pButton8 then
		BattleStrengthen.m_pButton8:setTag(8)
		BattleStrengthen.m_pButton8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		BattleStrengthen.m_pButton8:setPosition(AUTO_POS(7.00, 80.00))
		BattleStrengthen.m_pButton8:setContentSize(AUTO_SIZE(32, 58))
		BattleStrengthen.m_pButton8:setTitle(L(""), DEFAULT_FONT_NAME, F(20))
		local pBackimg = getRealUIResourcePath("img/new00096.png")
		if pBackimg then
			BattleStrengthen.m_pButton8:setBackgroundImage(pBackimg:getData())
		end
	end

	if pImage1 and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(pImage1, "SCNode"))
	end
	if BattleStrengthen.m_pButton2 and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(BattleStrengthen.m_pButton2, "SCNode"))
	end
	if BattleStrengthen.m_pButton3 and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(BattleStrengthen.m_pButton3, "SCNode"))
	end
	if BattleStrengthen.m_pButton4 and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(BattleStrengthen.m_pButton4, "SCNode"))
	end
	if BattleStrengthen.m_pListBox6 and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(BattleStrengthen.m_pListBox6, "SCNode"))
	end
	if BattleStrengthen.m_pListBox7 and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(BattleStrengthen.m_pListBox7, "SCNode"))
	end
	if BattleStrengthen.m_pButton5 and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(BattleStrengthen.m_pButton5, "SCNode"))
	end
	if BattleStrengthen.m_pTextBox and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(BattleStrengthen.m_pTextBox, "SCNode"))
	end
	if BattleStrengthen.m_pButton8 and BattleStrengthen.m_pWnd then
		BattleStrengthen.m_pWnd:addChild(tolua.cast(BattleStrengthen.m_pButton8, "SCNode"))
	end
	return BattleStrengthen.m_pWnd
end
function BattleStrengthen.releaseControl()
	BattleStrengthen.m_pWnd = nil
	BattleStrengthen.m_pButton2 = nil
	BattleStrengthen.m_pButton3 = nil
	BattleStrengthen.m_pButton4 = nil
	BattleStrengthen.m_pListBox6 = nil
	BattleStrengthen.m_pListBox7 = nil
	BattleStrengthen.m_pButton5 = nil
	BattleStrengthen.m_pTextBox = nil
	BattleStrengthen.m_pButton8 = nil
	if BattleStrengthen.wndClose then
		BattleStrengthen.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function wndSetSelectorOnEvent(tag, type)
    if type == LuaControllerEventPushEnded then
        local wndCtrl = getCurentSceneWindowController(2011);
        if wndCtrl then
            local window = wndCtrl:getWindow();
            if window == nil then
                return;
            end
            
            local pPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlistAndParent("10", window));
            if pPage then
                pPage:selectPageWithIndex(1);
            end
        end
    end
end

--查看功能开启条件
local function BattleStrengthen_clickSendFightGuide(tag)
    if 1000 == tag then
        showMessage(_LTParser("str6194"))
        return
    end
	local dt = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dt:writeShort(USERINFO_SEND_UNLOCK_TIP);
    dt:writeShort(tag)
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--左边列表
local function onLeftListBoxSelected(tag, itemIndex)
	local index = (m_curPage - 1) * 6 + itemIndex + 1;
	if 9 < index then
		return;
	end
	
	if isUnLock(m_unLockType[index]) then
	   	if itemIndex == 0 then
            if m_curPage == 1 then
				local pMainInterface = getMainInterface()
				if pMainInterface ~= nil then
					pMainInterface:onClickHero(tag)
				end
				
				local wndCtrl = getCurentSceneWindowController(2011);
				if wndCtrl then
					wndCtrl:luaSetSelectorOnEvent(wndSetSelectorOnEvent);
				end
            else
				treasure.showTreasureWnd();
            end 
		elseif itemIndex == 1 then
            if m_curPage == 1 then
                Equipmentstrengthen_showEquipmentstrengthenWnd()--打开强化界面
            else
				ArmyTraining_sendData();
            end
		elseif itemIndex == 2 then
			Equipmentstrengthen_showEquipmentstrengthenWnd()--打开强化界面
			if Equipmentstrengthen.m_multipage == nil then
				return;
			end
			if m_curPage == 1 then
				Equipmentstrengthen.m_multipage:selectPageWithIndex(1);
			else
				Equipmentstrengthen.m_multipage:selectPageWithIndex(2);
			end
        end 
    else
        BattleStrengthen_clickSendFightGuide(m_unLockType[index])
	end
end
--右边列表
local function onRightListBoxSelected(tag, itemIndex)
	local index = (m_curPage - 1) * 6 + 3 + itemIndex + 1;
	if 9 < index then
		return;
	end
	
	if isUnLock(m_unLockType[index]) then
		if itemIndex == 0 then
			BlowRecruit_showBlowRecruitWnd();
		elseif itemIndex == 1 then
		    Wings_showWnd()
		elseif itemIndex == 2 then
			Hunter_showHunterWnd();
		end
    else
        BattleStrengthen_clickSendFightGuide(m_unLockType[index])
	end 
end

local function fillBattleStrengthenWndData()
    local pListBox6 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-6"), "SCListBox")
    local pListBox7 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-7"), "SCListBox")
	if pListBox6 == nil or pListBox7 == nil then
		return;
	end
	pListBox6:removeAllItems();
	pListBox7:removeAllItems();
	
	local tmpIndex = 0;
	local imgPath = nil;
	local curIndex = (m_curPage-1) * 6 + 1;
	for i=curIndex, 9 do
		tmpIndex = math.mod(i, 6);
		if tmpIndex == 1 and i ~= curIndex then
			return;
		end
		
		local itemNode = BattleStrengthen1.initControl(i);
		if not itemNode then return end 
		
		local pImage2 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-2"), itemNode),"SCImage")
		local pImage3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-3"), itemNode),"SCImage")
		local pLabel4 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(("1-3-4"), itemNode),"SCLabel")
		if pImage2 and pImage3 and pLabel4 then
			imgPath = getRealUIResourcePath("img/"..m_unLockImage[i]..".png");
			if imgPath then
				pImage3:setImage(imgPath:getData());
			end
			
			if isUnLock(m_unLockType[i]) then
			    if i == 50 then
			        pLabel4:setText(L("str9168"));
			        pLabel4:setColor(color_red);
			    else
			        pLabel4:setColor(color_green);
			    end
			else
				pLabel4:setColor(color_red);
				local strLev = L("str9168")
				pLabel4:setText(strLev);
			end
			
			if tmpIndex > 0 and tmpIndex < 4 then
				pListBox6:addItem(itemNode);
			else
				pListBox7:addItem(itemNode);
			end
		end
	end
end

local function onBattleStrengthenOnEvent(tag, type)
	if type == LuaControllerEventPushEnded then 
		m_curPage = 1;		
	end 
	fillBattleStrengthenWndData();
end

--下一页
local function onNextPageBtnClick(tag)
    local pButton4 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-4"), "SCButton")
    local pButton5 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-5"), "SCButton")
	if pButton4 == nil or pButton5 == nil then
		return;
	end
	pButton5:setVisible(true);

	m_curPage = m_curPage + 1;
	if m_curPage > 2 then
	    m_curPage = 2
	end
	if m_curPage * 6 > 9 then
		pButton4:setVisible(false);
	end
	fillBattleStrengthenWndData()
end

--上一页
local function onPreviousPageBtnClick(tag)
    local pButton4 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-4"), "SCButton")
    local pButton5 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-5"), "SCButton")
	if pButton4 == nil or pButton5 == nil then
		return;
	end
	pButton4:setVisible(true);
	
	m_curPage = m_curPage - 1;
	if m_curPage > 0 then
		if m_curPage == 1 then
			pButton5:setVisible(false);
		end
		fillBattleStrengthenWndData()
    else
        m_curPage = 1
	end
end

--返回按钮
local function onReturnBtnClick(tag)
    local pListBox6 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-6"), "SCListBox")
    local pListBox7 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-7"), "SCListBox")
	if pListBox6 and pListBox7 then
		pListBox6:setVisible(true);
		pListBox7:setVisible(true);
	end

    local pTextBox9 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-9"), "SCTextBox")
	if pTextBox9 then
		pTextBox9:setVisible(false);
	end
	
	local pButton4 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-4"), "SCButton")
	local pButton5 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-5"), "SCButton")
	if pButton4 and pButton5 then
		pButton4:setTouchEnabled(true);
		pButton5:setTouchEnabled(true);
		
		if m_curPage == 1 then
		    pButton4:setVisible(true)
		elseif m_curPage == 2 then
		    pButton5:setVisible(true)
		end
	end
end

--说明按钮
local function onDescribeBtnClick(tag)
    local pListBox6 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-6"), "SCListBox")
    local pListBox7 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-7"), "SCListBox")
	if pListBox6 and pListBox7 then
		pListBox6:setVisible(false);
		pListBox7:setVisible(false);
	end
	
	local pTextBox9 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-9"), "SCTextBox")
	if pTextBox9 then
		pTextBox9:setVisible(true);
	end
	
	local pButton4 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-4"), "SCButton")
	local pButton5 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-5"), "SCButton")
	if pButton4 and pButton5 then
		pButton4:setTouchEnabled(false);
		pButton5:setTouchEnabled(false);		
		pButton4:setVisible(false)
		pButton5:setVisible(false)
	end
end

--说明按钮
local function onCloseBtnClick(tag)
    local wndCtrl = getCurentSceneWindowController(1040);
    if wndCtrl then
        removeWindowCtrl(wndCtrl);
    end
end

----------------消息处理区----------------
function BattleStrengthen_process(dt)
	SCActivityIndicator:getSingleton():close()
	if dt == nil then
	    return;
	end
	
	local ncount = dt:readInt();
	for i=1, ncount do
		table.insert(m_stHelperInfo, stFunctionInfo.initWithStream(dt));
	end
end

function BattleStrengthen_process(dt)
	SCActivityIndicator:getSingleton():close()
	 local dt = LuaData:getSingleton():getDataTransStream()
        if not dt then
            return
        end

	local tipNews = nil
	tipNews = dt:readString()
    if tipNews then
        tipNews = tipNews:getData()
    else
	    tipNews = " "
	end
	 showMessage(tipNews)
end
----------------消息注册区----------------

----------------全局函数区----------------
function BattleStrengthen.wndCloss()
	m_stHelperInfo = {};
	m_curPage = nil;
	BattleStrengthen1.releaseControl();
end

function BattleStrengthen_show()
    local wnd1040 = tolua.cast(SCFunction:getUiNodeByIdlist("1040"), "SCWindow")
	if wnd1040 == nil then
		local window = BattleStrengthen.initControl();
		local wndCtrl = SCWindowController:controllerWithWindow(window)
		local naviCtrl =  getCurentSceneNavigationController()
		if wndCtrl and naviCtrl then
			naviCtrl:pushWindowController(wndCtrl)
			wndCtrl:luaSetSelectorOnEvent(onBattleStrengthenOnEvent)
			SCActivityIndicator:getSingleton():close();
		end
		
		local pListBox6 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-6"), "SCListBox")
		local pListBox7 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-7"), "SCListBox")
		if pListBox6 and pListBox7 then
			pListBox6:setScrollVertical(false);
			pListBox6:luaSetSelectorOnItemSelected(onLeftListBoxSelected);
			pListBox7:setScrollVertical(false);
			pListBox7:luaSetSelectorOnItemSelected(onRightListBoxSelected);
		end
		
		local pButton4 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-4"), "SCButton")
		local pButton5 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-5"), "SCButton")
		if pButton4 and pButton5 then
			pButton4:setVisible(true);
			pButton4:luaSetSelectorOnClicked(onNextPageBtnClick);
			pButton5:setVisible(false);
			pButton5:luaSetSelectorOnClicked(onPreviousPageBtnClick);
		end
		
		local pButton2 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-2"), "SCButton")
		local pButton3 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-3"), "SCButton")
		local pButton8 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-8"), "SCButton")
		if pButton2 and pButton3 and pButton8 then
			local imgPath = getRealUIResourcePath("img/new00108.png");
			if imgPath then
				pButton2:setTitle(imgPath:getData());
			end
			
			imgPath = getRealUIResourcePath("img/new00098.png");
			if imgPath then
				pButton3:setTitle(imgPath:getData());
			end
			
			imgPath = getRealUIResourcePath("img/new00100.png");
			if imgPath then
				pButton8:setTitle(imgPath:getData());
			end
			
			pButton2:luaSetSelectorOnClicked(onDescribeBtnClick);
			pButton3:luaSetSelectorOnClicked(onReturnBtnClick);
			pButton8:luaSetSelectorOnClicked(onCloseBtnClick);
		end
		
		local pTextBox9 = tolua.cast(SCFunction:getUiNodeByIdlist("1040-9"), "SCTextBox")
		if pTextBox9 then
			pTextBox9:setVisible(false);
			pTextBox9:setScrollVertical(false);
			TextParser:getSingleton():setText(pTextBox9, L("str9141"));
		end
		
		if window then
			window:setFrameVisibled(false);
			window:setBackButtonVisibled(false);
			window:setCloseButtonVisibled(false);
		end
	end
end

--数字图片滚动效果
local m_entryId = nil;
local m_curNumber = nil;
local m_lastNumber = nil;
local m_actionNode = nil;

local function clearDataForNumberAction()
	local scene = SCBaseScene:getRunningScene()
	if scene then
		scene:getUINode():removeChildByTag(17001, true);
	end
	m_entryId = nil;
	m_curNumber = nil;
	m_lastNumber = nil;
	m_actionNode = nil;
end

local function runAction(time)
	if m_lastNumber <= m_curNumber then
		if m_entryId then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
			clearDataForNumberAction();
			return;
		end		
	end
	
	m_curNumber = math.floor(m_curNumber + 1);
	if m_actionNode then
		local node = getImageNumber(m_curNumber, "img/new00085.png", 11.8, 14);
		if node then
			m_actionNode:removeAllChildrenWithCleanup(true);
			node:setAnchorPoint(CCPointMake(0, 0.5));
			node:setPosition(CCPointMake(m_actionNode:getContentSize().width+2, m_actionNode:getContentSize().height/2));
			m_actionNode:addChild(node);
		end
	end
end

function BattleStrengthen_AnimationEnd()
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    
    local uiNode = scene:getUINode():getChildByTag(90000);
    if uiNode then
        scene:getUINode():removeChildByTag(90000, true);
    end
end

function BattleStrengthen_runNumberAction(curNumber, lastNumber)
	if curNumber == nil or lastNumber == nil then
		return;
	end
	
	m_curNumber = curNumber;
	m_lastNumber = lastNumber;
	
	if m_lastNumber > m_curNumber then
	    local scene = SCBaseScene:getRunningScene()
        if scene == nil then
            return
        end
        
        local uiNode = scene:getUINode():getChildByTag(90000);
        if uiNode == nil then
            local pAni = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1017, 1017) 
            if pAni then
                pAni:setFPS(10.0);
                pAni:setAutoremoveOnComplete(true)
                pAni:luaSetSelectorOnComplete(BattleStrengthen_AnimationEnd)
                local pAniNode =  SCAnimationNode:nodeWithAnimation(pAni)
                if pAniNode then
                    pAniNode:setTag(90000)
                    pAniNode:setAnchorPoint(CCPointMake(0.5, 0))
                    pAniNode:setPosition(CCPointMake(HALF_WIN_WIDTH, HALF_WIN_HEIGHT * 1 / 2));
                    scene:getUINode():addChild(pAniNode, 1100);
                end
            end
         end	    
	end
end

function BattleStrengthen_saveCurPrestige()
    local heroInfo = Hero:getSingleton():getHeroInfo()
    if heroInfo == nil then
        return
    end
	
	m_curNumber = heroInfo.nPrestige;
end

--数字滚动动画
function BattleStrengthen_getNumberAction()
    
    if true then
        local heroInfo = Hero:getSingleton():getHeroInfo()
		if heroInfo then
			m_lastNumber = heroInfo.nPrestige;
			BattleStrengthen_runNumberAction(m_curNumber, m_lastNumber)
		end
        return
    end
	
	
	
	local filePath = getRealUIResourcePath("img/new00111.png");
	if filePath == nil then
		return nil;
	end
	m_actionNode = SCImage:imageWithFile(filePath:getData());
	if m_actionNode then
		local heroInfo = Hero:getSingleton():getHeroInfo()
		if heroInfo then
			m_lastNumber = heroInfo.nPrestige;
			BattleStrengthen_runNumberAction(m_curNumber, m_lastNumber)
			local pMainInterface = getMainInterface();
			if pMainInterface then
			    local pInfoImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("5936-6", pMainInterface));
			    if pInfoImg then
			        pInfoImg:removeChildByTag(2, true);
			        local node = getImageNumber(heroInfo.nPrestige, "img/new00115.png", 6, 8);
                    if node then
                        node:setTag(2);
                        node:setPosition(CCPointMake(SX(80), SY(3)));
                        pInfoImg:addChild(node);
                    end
			    end
			end
		end
		
		local scene = SCBaseScene:getRunningScene()
        if scene then
            m_actionNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            m_actionNode:setPosition(CCPointMake(HALF_WIN_WIDTH, HALF_WIN_HEIGHT));
            m_actionNode:setTag(17001);
            scene:getUINode():addChild(m_actionNode);
        end
		
		return m_actionNode;
	end
end

--发送查询战斗力资料馆
function BattleStrengthen_sendFightGuide()
	local dt = SCDataTransStream:streamWithCommand(_MSG_HELP_MANUAL);
    dt:writeByte(HELP_FIGHT_GUIDE);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

LuaData:getSingleton():luaSetSelectorOnRecvData(BattleStrengthen_process, LuaData_USERINFO_SEND_UNLOCK_TIP)


--函数调用