--定义一个与文件名相同的table
BlowRecruit7 = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------

----------------变量定义区----------------
--变量的定义
----------------UI控制器区----------------
function BlowRecruit7.initControl()
	local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode1:setContentSize(AUTO_SIZE(480, 320))
		pDragNode1:setFrameVisibled(true)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTypeNone)
	end

	local pButton2 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton2 then
		pButton2:setTag(2)
		pButton2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton2:setPosition(AUTO_POS(2.00, 150.00))
		pButton2:setContentSize(AUTO_SIZE(22, 30))
		local imgPath = getRealUIResourcePath("img/new00048.png")
		if imgPath then
			pButton2:setTitle(imgPath:getData())
		end
	end

	local pButton3 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton3 then
		pButton3:setTag(3)
		pButton3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton3:setPosition(AUTO_POS(452.00, 150.00))
		pButton3:setContentSize(AUTO_SIZE(22, 30))
		local imgPath = getRealUIResourcePath("img/new00047.png")
		if imgPath then
			pButton3:setTitle(imgPath:getData())
		end
	end

	local pLable4 = SCLabel:labelWithStringFont(L("str3301"), DEFAULT_FONT_NAME, F(12))
	if pLable4 then
		pLable4:setTag(4)
		pLable4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable4:setPosition(AUTO_POS(40.00, 8.00))
		pLable4:setColor(ccc4(255,132,0,125))
	end

	local pPageScrollBox5 = SCPageScrollBox:boxWithWidthHeight(AUTO_W(434), AUTO_H(270))
	if pPageScrollBox5 then
		tolua.cast(pPageScrollBox5, "SCNode"):setTag(5)
		tolua.cast(pPageScrollBox5, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pPageScrollBox5, "SCNode"):setPosition(AUTO_POS(22.00, 20.00))
	end

	if pButton2 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton2, "SCNode"))
	end
	if pButton3 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pButton3, "SCNode"))
	end
	if pLable4 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable4, "SCNode"))
	end
	if pPageScrollBox5 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pPageScrollBox5, "SCNode"))
	end
	return pDragNode1
end
function BlowRecruit7.releaseControl()
	if BlowRecruit7.wndClose then
		BlowRecruit7.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function onClickLeftPage()
end
local function onClickRightPage()
end
local function refreshHotePartnerList(pDragNode)
    if not pDragNode then
        return
    end
    local pPageBox1 = SCTypeCast:castNodeToPageScrollBox(pDragNode:getChildByTag(5))
    if pPageBox1 == nil then
        return;
    end
    pPageBox1:setScrollVertical(false);
	pPageBox1:removeAllChildrenWithCleanup(true);
    local width = pPageBox1:getContentSize().width;
    local height = pPageBox1:getContentSize().height;
	local pNode = nil;
	local pageCount = 0;
	local childIndex = 0;
	for i = 1,5 do
	    childIndex = math.mod(i, 3);
	    if childIndex == 1 then
			pNode = SCNode:node();
			pNode:setPosition(CCPointMake(width * pageCount, 0));
			pPageBox1:addChild(pNode);
			pNode:setTag(pageCount);
			pPageBox1:setContentSize(CCSizeMake(width * pPageBox1:getPageCount(), height));
			pageCount = pageCount + 1;
		end
		
		if pNode then
			local pChildNode = BlowRecruit8.initControl();
			if pChildNode then
				if childIndex == 0 then
					childIndex = 3;
				end
				pChildNode:setPosition(CCPointMake((childIndex - 1) * SX(147), SY(0)));
				pNode:addChild(pChildNode);				
				pChildNode:setTag(i);
		    end
		end
	end
end
----------------消息处理区----------------

----------------消息注册区----------------

----------------全局函数区----------------
function BlowRecruit7_ControlOperating()
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("7020-1"))
	if pMultiPage == nil then
		return;
	end	
	
	local pNode = pMultiPage:getPageWithIndex(2);
	if pNode == nil then
		return;
	end
	
	local pDragNode = SCTypeCast:castNodeToDragNode(pNode:getChildByTag(1));
	if nil == pDragNode then
		pDragNode = BlowRecruit7.initControl();
		if pDragNode then
			pNode:addChild(pDragNode);
            local btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(2));
            if  btn  then
                btn:luaSetSelectorOnClicked(onClickLeftPage);
            end 
            local btn = SCTypeCast:castNodeToButton(pDragNode:getChildByTag(3));
            if  btn  then
                btn:luaSetSelectorOnClicked(onClickRightPage);
            end 
            refreshHotePartnerList(pDragNode);
		end
	end	
end


--函数调用