--定义一个与文件名相同的table
ChargeFirst = {}
------------------消息--------------------

----------------结构定义区----------------
local stChargeStatus = {
    initWithStream = function(dt)
        if dt == nil then
            return {}
        end

        local tmp = {__mode = "kv", }
        tmp.nData = dt:readInt();
        tmp.nRecharge = dt:readInt();
        tmp.nData2 = dt:readInt();
        return tmp;
	end
};

local stRechargeItem = {
      initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {__mode = "kv", }
        tmp.usAwardType = dt:readShort();
        tmp.idItemType = dt:readInt();
        tmp.nNum = dt:readInt();
      return tmp;
	 end
};
local stRechargeGift = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = { __mode = "kv", }
        tmp.ucLevel = dt:readByte();
        tmp.idGiftType = dt:readInt();
        tmp.nRecharge = dt:readInt();
        tmp.szDescription = dt:readString();
        tmp.ucAmount = dt:readByte();
        tmp.stfill = { __mode = "kv" }
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stRechargeItem.initWithStream(dt))
        end
        return tmp;
	end
};
local stChargeDetail = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = { __mode = "kv", }
        tmp.ucAmount = dt:readByte();
        tmp.stfill = { __mode = "kv" }
        for i = 0, tmp.ucAmount do 
            table.insert(tmp.stfill, stRechargeGift.initWithStream(dt))
        end
        return tmp;
	end
};
----------------常量定义区----------------

local GIFTINFO_FIRST_RECHARGE_FLAG  = 1 --//首冲奖励状态
local GIFTINFO_FIRST_RECHARE_DETAIL =2  -- //首冲奖励信息(只需请求一次)
local GIFTINFO_RECHARE_GIFT_FLAG  = 3  --	//充值奖励状态
local GIFTINFO_RECHARE_DETAIL = 4    --	//充值奖励信息(只需请求一次)
local GIFTINFO_GET_RECHARGE_AWARD = 5 ---	//领取奖励
local GIFTINFO_RECHARE_DETAIL_END = 6		--//充值奖励信息(只需请求一次)(下发的最后一个包)
local GIFTINFO_NEWBIE_PRIVILEGE = 7  --//新手特权信息
local GIFTINFO_OPEN_PRISON_DIALOG = 10 --//外挂监狱
local GIFTINFO_SEND_GIFT_INFO_BEGIN = 11  --礼包信息下发开始 
local GIFTINFO_SEND_GIFT_INFO_END   = 12  --礼包信息下发解锁 
local GIFTINFO_GET_GIFT_AWARD       = 13  --获取礼包
local GIFTINFO_RAND_GIFT_INFO_BEGIN = 14  --随机礼包信息下发开始 
local GIFTINFO_RAND_GIFT_INFO_END   = 15  --随机礼包信息下发结束
local GIFTINFO_GET_RAND_GIFT_AWARD  = 16  --获取随机礼包奖励 
local GIFTINFO_LOGIN_AWARD = 17 --　送香香
local GIFTINFO_ADD_LOTTERDRAWTIMES  = 19 -- //增加抽奖次数 
local GIFTINFO_LOTTERDRAWTIMES_INFO_BEGIN = 20 -- //发送随机奖励信息
local GIFTINFO_LOTTERDRAWTIMES_INFO_END = 21 -- //发送随机奖励信息
local GIFTINFO_LOTTERDRAWTIMES_AWARD = 22--  //抽奖
local GIFTINFO_24HOURS_GIVE_WRING = 23-- //24小时送翅膀
local GIFTINFO_RUSH_TO_PURCHASE = 24--,//限时抢购信息 
local GIFTINFO_GETTOTAL_RECHARGE_FAIL = 26 --//领取旷世金蛋失败 
----------------变量定义区----------------
--变量的定义
ChargeFirst.stChargeDetail = {}
local m_ptnAwards = {}
local m_giftItemType = {}

----------------UI控制器区----------------
function ChargeFirst.initControl()
	local pWindow10000 = SCWindow:window()
	if pWindow10000 then
		pWindow10000:setTag(4423)
		pWindow10000:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow10000:setPosition(AUTO_POS(4.00, 40.00))pWindow10000:setContentSize(AUTO_SIZE(472, 240))
		pWindow10000:luaSetSelectorOnClose(ChargeFirst.releaseControl)
	end

	ChargeFirst.m_DragNode = SCDragNode:node()
	if ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:setTag(1)
		ChargeFirst.m_DragNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ChargeFirst.m_DragNode:setPosition(AUTO_POS(0.00, 0.00))
		ChargeFirst.m_DragNode:setContentSize(AUTO_SIZE(472, 240))
		ChargeFirst.m_DragNode:setFrameVisibled(false)
		ChargeFirst.m_DragNode:setDragEnabled(false)
		ChargeFirst.m_DragNode:setFrameType(EnumFrameTypeListNormal)
	end

	local imgPath = getRealUIResourcePath("img/new00124.pn")
	local pImage10003 = nil
	if imgPath then
		pImage10003 = SCImage:imageWithFile(imgPath:getData())
		if pImage10003 then
			pImage10003:setTag(10003)
			pImage10003:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10003:setPosition(AUTO_POS(43.00, 0.00))
			pImage10003:setScaleX(0.8)
		end
	end

	local imgPath = getRealUIResourcePath("img/new00459.pn")
	ChargeFirst.m_TitleImg = nil
	if imgPath then
		ChargeFirst.m_TitleImg = SCImage:imageWithFile(imgPath:getData())
		if ChargeFirst.m_TitleImg then
			ChargeFirst.m_TitleImg:setTag(10002)
			ChargeFirst.m_TitleImg:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			ChargeFirst.m_TitleImg:setPosition(AUTO_POS(210.00, 220.00))
		end
	end

	ChargeFirst.m_ptnClose = SCButton:button()
	if ChargeFirst.m_ptnClose then
		ChargeFirst.m_ptnClose:setTag(10006)
		ChargeFirst.m_ptnClose:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ChargeFirst.m_ptnClose:setPosition(AUTO_POS(400.00, 219.00))
		ChargeFirst.m_ptnClose:setContentSize(AUTO_SIZE(38, 38))
		ChargeFirst.m_ptnClose:setTitle(L(""), DEFAULT_FONT_NAME, F(20))
		local pBackimg = getRealUIResourcePath("img/new00123.png")
		if pBackimg then
			ChargeFirst.m_ptnClose:setBackgroundImage(pBackimg:getData())
		end
	end

	ChargeFirst.m_getcharge = SCButton:button(EnumBtnTypeNormalImg)
	if ChargeFirst.m_getcharge then
		ChargeFirst.m_getcharge:setTag(10007)
		ChargeFirst.m_getcharge:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ChargeFirst.m_getcharge:setPosition(AUTO_POS(205.00, 4.00))
		ChargeFirst.m_getcharge:setContentSize(AUTO_SIZE(74, 27))
		ChargeFirst.m_getcharge:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00529.pn")
		if pBackimg then
			ChargeFirst.m_getcharge:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00529.pn")
		if pBackimg then
			ChargeFirst.m_getcharge:setSelectedImage(pPressimg:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00451.pn")
	local pImage10008 = nil
	if imgPath then
		pImage10008 = SCImage:imageWithFile(imgPath:getData())
		if pImage10008 then
			pImage10008:setTag(10008)
			pImage10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10008:setPosition(AUTO_POS(135.00, 179.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00454.pn")
	local pImage10009 = nil
	if imgPath then
		pImage10009 = SCImage:imageWithFile(imgPath:getData())
		if pImage10009 then
			pImage10009:setTag(10009)
			pImage10009:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10009:setPosition(AUTO_POS(175.50, 128.50))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00453.pn")
	local pImage10010 = nil
	if imgPath then
		pImage10010 = SCImage:imageWithFile(imgPath:getData())
		if pImage10010 then
			pImage10010:setTag(10010)
			pImage10010:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10010:setPosition(AUTO_POS(332.50, 128.50))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00701.pn")
	local pImage10012 = nil
	if imgPath then
		pImage10012 = SCImage:imageWithFile(imgPath:getData())
		if pImage10012 then
			pImage10012:setTag(10012)
			pImage10012:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage10012:setPosition(AUTO_POS(-5.00, -60.00))
		end
	end

	ChargeFirst.m_charge = SCButton:button(EnumBtnTypeNormalImg)
	if ChargeFirst.m_charge then
		ChargeFirst.m_charge:setTag(10013)
		ChargeFirst.m_charge:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ChargeFirst.m_charge:setPosition(AUTO_POS(341.00, 38.00))
		ChargeFirst.m_charge:setContentSize(AUTO_SIZE(62, 30))
		local imgPath = getRealUIResourcePath("img/new00119.png")
		if imgPath then
			ChargeFirst.m_charge:setTitle(imgPath:getData())
		end
		local pBackimg = getRealUIResourcePath("img/new00118.png")
		if pBackimg then
			ChargeFirst.m_charge:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00118.png")
		if pBackimg then
			ChargeFirst.m_charge:setSelectedImage(pPressimg:getData())
		end
	end

	ChargeFirst.m_award1 = SCButton:button(EnumBtnTypeNormalImg)
	if ChargeFirst.m_award1 then
		ChargeFirst.m_award1:setTag(10014)
		ChargeFirst.m_award1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ChargeFirst.m_award1:setPosition(AUTO_POS(180.00, 35.00))
		ChargeFirst.m_award1:setContentSize(AUTO_SIZE(47, 45))
		ChargeFirst.m_award1:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.pn")
		if pBackimg then
			ChargeFirst.m_award1:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00003.pn")
		if pBackimg then
			ChargeFirst.m_award1:setSelectedImage(pPressimg:getData())
		end
	end

	ChargeFirst.m_award2 = SCButton:button(EnumBtnTypeNormalImg)
	if ChargeFirst.m_award2 then
		ChargeFirst.m_award2:setTag(10015)
		ChargeFirst.m_award2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ChargeFirst.m_award2:setPosition(AUTO_POS(228.00, 35.00))
		ChargeFirst.m_award2:setContentSize(AUTO_SIZE(47, 47))
		ChargeFirst.m_award2:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.pn")
		if pBackimg then
			ChargeFirst.m_award2:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00003.pn")
		if pBackimg then
			ChargeFirst.m_award2:setSelectedImage(pPressimg:getData())
		end
	end

	ChargeFirst.m_award3 = SCButton:button(EnumBtnTypeNormalImg)
	if ChargeFirst.m_award3 then
		ChargeFirst.m_award3:setTag(10016)
		ChargeFirst.m_award3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ChargeFirst.m_award3:setPosition(AUTO_POS(276.00, 35.00))
		ChargeFirst.m_award3:setContentSize(AUTO_SIZE(46, 44))
		ChargeFirst.m_award3:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.pn")
		if pBackimg then
			ChargeFirst.m_award3:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00003.pn")
		if pBackimg then
			ChargeFirst.m_award3:setSelectedImage(pPressimg:getData())
		end
	end
	
	ChargeFirst.m_award4 = SCButton:button(EnumBtnTypeNormalImg)
	if ChargeFirst.m_award4 then
		ChargeFirst.m_award4:setTag(10017)
		ChargeFirst.m_award4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ChargeFirst.m_award4:setPosition(AUTO_POS(132.00, 35.00))
		ChargeFirst.m_award4:setContentSize(AUTO_SIZE(46, 44))
		ChargeFirst.m_award4:setTitle(L(""), DEFAULT_FONT_NAME, F(15))
		local pBackimg = getRealUIResourcePath("img/new00002.pn")
		if pBackimg then
			ChargeFirst.m_award4:setBackgroundImage(pBackimg:getData())
		end
		local pPressimg = getRealUIResourcePath("img/new00003.pn")
		if pBackimg then
			ChargeFirst.m_award4:setSelectedImage(pPressimg:getData())
		end
	end

	ChargeFirst.m_textDesc = SCTextBox:boxWithWidthHeightFont(AUTO_W(210), AUTO_H(41), DEFAULT_FONT_NAME, F(10))
	if ChargeFirst.m_textDesc then
		tolua.cast(ChargeFirst.m_textDesc, "SCNode"):setTag(10011)
		tolua.cast(ChargeFirst.m_textDesc, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(ChargeFirst.m_textDesc, "SCNode"):setPosition(AUTO_POS(195.50, 84.00))
		ChargeFirst.m_textDesc:setText(L("text_control"))
	end

	if ChargeFirst.m_DragNode and pWindow10000 then
		pWindow10000:addChild(tolua.cast(ChargeFirst.m_DragNode, "SCNode"))
	end
	if pImage10003 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(pImage10003, "SCNode"))
	end
	
	local imgPath = getRealUIResourcePath("img/new00181.pn")  --龙背景
	local pImageback = nil
	if imgPath then
		pImageback = SCImage:imageWithFile(imgPath:getData())
		if pImageback then
			pImageback:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImageback:setPosition(AUTO_POS(43.00, -23.00))
			ChargeFirst.m_DragNode:addChild(tolua.cast(pImageback, "SCNode"))
		end
	end
	
	local imgPath = getRealUIResourcePath("img/new00185.pn")  --凤背景
	local pImageback1 = nil
	if imgPath then
		pImageback1 = SCImage:imageWithFile(imgPath:getData())
		if pImageback1 then
			pImageback1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImageback1:setPosition(AUTO_POS(244.00, -23.00))
			ChargeFirst.m_DragNode:addChild(tolua.cast(pImageback1, "SCNode"))
		end
	end
	
	if ChargeFirst.m_TitleImg and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_TitleImg, "SCNode"))
	end
	if ChargeFirst.m_ptnClose and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_ptnClose, "SCNode"))
	end
	if ChargeFirst.m_getcharge and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_getcharge, "SCNode"))
	end
	if pImage10008 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(pImage10008, "SCNode"))
	end
	if pImage10009 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(pImage10009, "SCNode"))
	end
	if pImage10010 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(pImage10010, "SCNode"))
	end
	if pImage10012 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(pImage10012, "SCNode"))
	end
	if ChargeFirst.m_charge and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_charge, "SCNode"))
	end
	if ChargeFirst.m_award1 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_award1, "SCNode"))
	end
	if ChargeFirst.m_award2 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_award2, "SCNode"))
	end
	if ChargeFirst.m_award3 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_award3, "SCNode"))
	end
	if ChargeFirst.m_award4 and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_award4, "SCNode"))
	end
	if ChargeFirst.m_textDesc and ChargeFirst.m_DragNode then
		ChargeFirst.m_DragNode:addChild(tolua.cast(ChargeFirst.m_textDesc, "SCNode"))
	end
	return pWindow10000
end
function ChargeFirst.releaseControl()
	ChargeFirst.m_DragNode = nil
	ChargeFirst.m_TitleImg = nil
	ChargeFirst.m_ptnClose = nil
	ChargeFirst.m_getcharge = nil
	ChargeFirst.m_charge = nil
	ChargeFirst.m_award1 = nil
	ChargeFirst.m_award2 = nil
	ChargeFirst.m_award3 = nil
	ChargeFirst.m_award4 = nil
	ChargeFirst.m_textDesc = nil
	if ChargeFirst.wndCloss then
		ChargeFirst.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------

--充值按钮
local function onClickeCharge(tag)
--屏蔽充值
    --[[if 1 then
        showMessage(_LTParser("str6192"))
        return
    end]]
 --   SCActivityIndicator:getSingleton():show()
    GuidePoint_EndGuide(12)  --释放引导计数
    POP_TOP_CTRL()
    showVIPrechargeableWnd() 
end

--领取奖励
local function onClickGetCharge(tag)
    GuidePoint_LuaAddCount(12, 2)   --已充值引导计数
 --   SCActivityIndicator:getSingleton():show()
    if ChargeFirst.stChargeDetail.ucAmount == nil then
        return
    end
    if ChargeFirst.stChargeDetail.ucAmount == 0 then
        return
    end
    local nData = 0;  --礼包类型
    for j=1, #ChargeFirst.stChargeDetail.stfill do
        local tmpRechargeGift = ChargeFirst.stChargeDetail.stfill[j]
        nData = tmpRechargeGift.idGiftType;
        if j >= 1 then
            break;
        end
    end
    if nData <= 0 then
        return
    end
    local eType = UNLOCK_TYPE_FIRST_RECHARGE_GIFT
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO)
    dataStream:writeShort(GIFTINFO_GET_RECHARGE_AWARD)
    dataStream:writeInt(nData)
    dataStream:writeInt(eType)
    SCDataTransThread:getSingleton():transData(dataStream)
end

local function onClickClose(tag)
    GuidePoint_EndGuide(12) --释放引导计数
    local naviCtrl = getCurentSceneNavigationController();
    if naviCtrl then
        naviCtrl:removeWindowControllerByTag(4423);
    end
end

--查看物品
local function onClickShowItem(tag)
    --[[if tag >= 1 and tag <= 3 then
        if #m_giftItemType >= tag then
            showTip(m_giftItemType[tag])
        end
    end--]]
    local Wnd = SCFunction:getUiNodeByIdlist("4423");
    local pframeWnd = FrameWindow:frameWnd();
    if tag == 1 or tag == 4 then
        showTip(m_giftItemType[tag])
        return;
    elseif tag == 2 then
        luaShowTipCpp(1, 500000)
    elseif tag == 3 then
        luaShowTipCpp(9, 50)
    end
end

--奖励的物品显示
local function ChargeAwardShow()
    if ChargeFirst.stChargeDetail.ucAmount == nil then
        return
    end
    if ChargeFirst.stChargeDetail.ucAmount == 0 then
        return
    end
    local m=1
    for j=1, #ChargeFirst.stChargeDetail.stfill do
        local tmpRechargeGift = ChargeFirst.stChargeDetail.stfill[j]
        for k=1, #tmpRechargeGift.stfill do
            local tmpRechargeItem = tmpRechargeGift.stfill[k]
            --if 0 == tmpRechargeItem.usAwardType then
                --if tmpRechargeItem.idItemType > 0 and tmpRechargeItem.nNum > 0 then
                    if tmpRechargeItem.usAwardType == 0 then
                        local infoItemtype = TableParser:getSingleton():getItemInfoByKey(tmpRechargeItem.idItemType)
                        if infoItemtype then
                            local idIcon = infoItemtype.icon
                            local szItemPath = "item/"..idIcon..".jp"
                            local pImg = getRealUIResourcePath(szItemPath)
                            if m_ptnAwards[m] ~= nil and pImg then
                                m_giftItemType[m] = tmpRechargeItem.idItemType
                                m_ptnAwards[m]:setTag(m)
                                m_ptnAwards[m]:setTitle(pImg:getData())
                                m_ptnAwards[m]:luaSetSelectorOnClicked(onClickShowItem)
                                local ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1022, 1022);
                                if ani then
                                    ani:setFPS(10.0);
                                    local aniNode = SCAnimationNode:nodeWithAnimation(ani);
                                    if aniNode then
                                        aniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        aniNode:setPosition(CCPointMake(m_ptnAwards[m]:getContentSize().width/2, m_ptnAwards[m]:getContentSize().height/2));
                                        m_ptnAwards[m]:addChild(aniNode);
                                        aniNode:setTag(9999);
                                    end
                                end
                                local ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1015, 1015);
                                if ani then
                                    ani:setFPS(10.0);
                                    local aniNode = SCAnimationNode:nodeWithAnimation(ani);
                                    if aniNode then
                                        aniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                        aniNode:setPosition(CCPointMake(m_ptnAwards[m]:getContentSize().width/2, m_ptnAwards[m]:getContentSize().height/2));
                                        m_ptnAwards[m]:addChild(aniNode);
                                        aniNode:setTag(9998);
                                    end
                                end
                            end
                            m = m+1
                        end
                    else
                        local imgPath = nil
                        if tmpRechargeItem.usAwardType == 1 then
                            imgPath = getRealUIResourcePath("item/2001001.jp")
                        elseif tmpRechargeItem.usAwardType == 2 then
                            imgPath = getRealUIResourcePath("item/2001001.jp")
                        elseif tmpRechargeItem.usAwardType == 3 then
                            imgPath = getRealUIResourcePath("item/2001001.jp")
                        elseif tmpRechargeItem.usAwardType == 4 then
                            imgPath = getRealUIResourcePath("item/2001002.jp")
                        elseif tmpRechargeItem.usAwardType == 5 then
                            imgPath = getRealUIResourcePath("item/2001003.jp")
                        elseif tmpRechargeItem.usAwardType == 6 then
                            imgPath = getRealUIResourcePath("item/2001001.jp")
                        elseif tmpRechargeItem.usAwardType == 7 then
                            imgPath = getRealUIResourcePath("item/2001001.jp")
                        elseif tmpRechargeItem.usAwardType == 8 then
                            imgPath = getRealUIResourcePath("item/2001001.jp")
                        elseif tmpRechargeItem.usAwardType == 9 then
                            imgPath = getRealUIResourcePath("item/2001005.jp")
                        elseif tmpRechargeItem.usAwardType == 101 then
                            imgPath = getRealUIResourcePath("item/2001006.jp")
                        elseif tmpRechargeItem.usAwardType == 102 then
                            imgPath = getRealUIResourcePath("item/2001008.jp")
                        elseif tmpRechargeItem.usAwardType == 103 then
                            imgPath = getRealUIResourcePath("item/2001001.jp")
                        end
                        if m_ptnAwards[m] ~= nil and imgPath then
                            m_giftItemType[m] = tmpRechargeItem.idItemType
                            m_ptnAwards[m]:setTag(m)
                            m_ptnAwards[m]:setTitle(imgPath:getData())
                            m_ptnAwards[m]:luaSetSelectorOnClicked(onClickShowItem)
                            local Label = SCLabel:labelWithStringFont(recharge_itoa(tmpRechargeItem.nNum), DEFAULT_FONT_NAME, F(10))
                            if Label then
                                Label:setAnchorPoint(ANCHOR_RIGHT_BOTTOM)
                                Label:setPosition(AUTO_POS(40.00, 4.00))
                                m_ptnAwards[m]:addChild(tolua.cast(Label, "SCNode"))
                            end
                        end
                        m = m+1
                    end
                   
                --end
            --end

            if m>4 then break end
        end
        break;
    end
end

local function ControlOperating()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO)
    dataStream:writeShort(GIFTINFO_FIRST_RECHARGE_FLAG)
    SCDataTransThread:getSingleton():transData(dataStream)
	
	m_ptnAwards[1] = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10014"), "SCButton")
    m_ptnAwards[2] = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10015"), "SCButton")
    m_ptnAwards[3] = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10016"), "SCButton")
    m_ptnAwards[4] = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10017"), "SCButton")
    
	if ChargeFirst.stChargeDetail.ucAmount == nil then
        dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO)
        dataStream:writeShort(GIFTINFO_FIRST_RECHARE_DETAIL)
        SCDataTransThread:getSingleton():transData(dataStream)
    else
        ChargeAwardShow()
	end
    
    local pButton10013 = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10013"), "SCButton")
    if pButton10013 then
        pButton10013:luaSetSelectorOnClicked(onClickeCharge);
    end
    
    local pButton10007 = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10007"), "SCButton")
    if pButton10007 then
        pButton10007:luaSetSelectorOnClicked(onClickGetCharge);
    end
    
    local pButton10006 = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10006"), "SCButton")
    if pButton10006 then
        pButton10006:setMusicPath("closeWindow.mp3");
        pButton10006:luaSetSelectorOnClicked(onClickClose)
        pButton10006:setTouchRectScale(4.0,4.0)  
    end
    
    local pTextBox10011 = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10011"), "SCTextBox")
    if pTextBox10011 then
        TextParser:getSingleton():setText(pTextBox10011, L("str0408"))
    end
   
    SCActivityIndicator:getSingleton():show()
end




----------------消息处理区----------------
local function processChargeMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    if dt == nil then
        return
    end
    SCActivityIndicator:getSingleton():close()
    local usAction = dt:readShort()
    if GIFTINFO_FIRST_RECHARGE_FLAG == usAction then
        local tmpStatus = stChargeStatus.initWithStream(dt)
        local pButton10007 = tolua.cast(SCFunction:getUiNodeByIdlist("4423-1-10007"), "SCButton")
        if not pButton10007 then return end 
        
        if tmpStatus.nData2 == 1 then  --已领取
            if pButton10007 then --设已领取灰
                pButton10007:setTouchEnabled(false)
                local pBackimg = getRealUIResourcePath("img/new00577.pn")
                if pBackimg then
                    pButton10007:setBackgroundImage(pBackimg:getData())
                end
                local pPressimg = getRealUIResourcePath("img/new00577.pn")
                if pPressimg then
                    pButton10007:setSelectedImage(pPressimg:getData())
                end
            end
        else
            if tmpStatus.nData == 1 then  --可领取
                if pButton10007 then --设可领取
                    pButton10007:setTouchEnabled(true)
                    pButton10007:luaSetSelectorOnClicked(onClickGetCharge);
                    local pBackimg = getRealUIResourcePath("img/new00457.pn")
                    if pBackimg then
                        pButton10007:setBackgroundImage(pBackimg:getData())
                    end
                    local pPressimg = getRealUIResourcePath("img/new00458.pn")
                    if pPressimg then
                        pButton10007:setSelectedImage(pPressimg:getData())
                    end
                end
            else
                if pButton10007 then --设灰
                    pButton10007:setTouchEnabled(false)
                    local pBackimg = getRealUIResourcePath("img/new00529.pn")
                    if pBackimg then
                        pButton10007:setBackgroundImage(pBackimg:getData())
                    end
                end
            end
        end
    elseif GIFTINFO_FIRST_RECHARE_DETAIL == usAction then
        ChargeFirst.stChargeDetail = stChargeDetail.initWithStream(dt)
        ChargeAwardShow()
	elseif GIFTINFO_RECHARE_GIFT_FLAG == usAction then
        recharge_recvDataState(dt);
	elseif GIFTINFO_RECHARE_DETAIL == usAction then
        recharge_recvDataInfo(dt);
	elseif GIFTINFO_RECHARE_DETAIL_END == usAction then
        recharge_recvDataInfoEnd(dt);
	elseif GIFTINFO_NEWBIE_PRIVILEGE == usAction then
        newPlayerPriv.Window(dt)  --新手特权信息
    elseif GIFTINFO_OPEN_PRISON_DIALOG == usAction then
        PlugIn_recvData(dt) --外挂监狱
    elseif GIFTINFO_LOGIN_AWARD == usAction then
        MarryXiang.ReceData(dt)
	elseif GIFTINFO_SEND_GIFT_INFO_BEGIN == usAction then   --礼包信息下发开始 
        NewDailyAttend_RecvDataBegin(dt);
    elseif GIFTINFO_SEND_GIFT_INFO_END == usAction then     --礼包信息下发解锁 
        NewDailyAttend_RecvDataStop(dt);
    elseif GIFTINFO_GET_GIFT_AWARD == usAction then         --获取礼包
        NewDailyAttend_RecvGetAward();    
    elseif GIFTINFO_RAND_GIFT_INFO_BEGIN == usAction then   --随机礼包信息下发开始 
        TurnTable_RecvDataBegin(dt);
    elseif GIFTINFO_RAND_GIFT_INFO_END == usAction then     --随机礼包信息下发结束
        TurnTable_RecvDataStop(dt);
    elseif GIFTINFO_GET_RAND_GIFT_AWARD == usAction then    --获取随机礼包奖励 
        NewDailyAttend_RecvAward(dt);
    elseif GIFTINFO_ADD_LOTTERDRAWTIMES == usAction or GIFTINFO_LOTTERDRAWTIMES_INFO_BEGIN == usAction or --狂欢抽奖
        GIFTINFO_LOTTERDRAWTIMES_INFO_END == usAction or GIFTINFO_LOTTERDRAWTIMES_AWARD == usAction then
        WingAndRevel_RecvRevelDayData(dt, usAction)
    elseif GIFTINFO_24HOURS_GIVE_WRING == usAction then     --24小时送翅膀
        WingAndRevel_RecvWingsData(dt)
    elseif GIFTINFO_RUSH_TO_PURCHASE == usAction then       --限时抢购信息
        GiftActivity_ReadData(dt, usAction)
    elseif GIFTINFO_GETTOTAL_RECHARGE_FAIL == usAction then --金蛋领取失败
        GiftActivity_ReadData(dt, usAction)
    end
end

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(processChargeMsg, _MSG_GIFTINFO, 0, nil);

----------------全局函数区----------------
function ChargeFirst.showWnd()
    local wnd = ChargeFirst.initControl();
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            wnd:setCloseButtonVisibled(false)
            wnd:setFrameVisibled(false);
            ControlOperating();
            return
        end
    end
end


function ChargeFirst.wndCloss()
    ChargeFirst.stChargeDetail = {}
    m_ptnAwards = {}
    m_giftItemType = {}
end

--函数调用