local IDLE = 0
local COOL = 1
local READY = 2

local TRIGGER_TYPE_NONE = 0
local TRIGGER_TYPE1 = 1 --//怪物出场后血量低于某个%点触发一次（如果多个%条件同时达成，全部依次触发）
local TRIGGER_TYPE2 = 2 --//怪物出场后某个时间点触发一次
local TRIGGER_TYPE3 = 3 --//怪物出场后每隔一段时间循环触发

local m_monsterInfos = nil
--[[
function CheckMonsterAddAi_isReady()
    local eventStatus = IDLE
    local roleId = LuaReCall:getSingleton():getuID()
	if 0 == roleId then
		return eventStatus
	end
	local checkIndex = LuaReCall:getSingleton():getnID()
	if checkIndex >= 5 then
	    return eventStatus
	end
	local nbRole = NewBattleMessage:getSingleton():getFighterById(roleId)
	if nil == nbRole then
		return eventStatus
	end 
	if nil == m_monsterInfos then
		m_monsterInfos = {}
	end
	if nil == m_monsterInfos[roleId] then
		m_monsterInfos[roleId] = {}
		m_monsterInfos[roleId].nPlayingTime = timeForLua()
		m_monsterInfos[roleId].nLastTriggerTime = timeForLua()
		m_monsterInfos[roleId].nLifeTriggerNum = 0
		m_monsterInfos[roleId].nCycleTriggerNum = 0
		m_monsterInfos[roleId].mapStatusCoolTime = {}
		m_monsterInfos[roleId].mapStatusNums = {}
	end
	local nCurTime = timeForLua()
	
	local fightInfo = nbRole:getInfo()
	local pMonsterAddAi = CMonsterAi:getSingleton():GetMonsterAddAi(fightInfo.dwMonsterEvent)
	if nil == pMonsterAddAi then
	    return eventStatus
	end
	
	if pMonsterAddAi.nTriggerType[checkIndex] == TRIGGER_TYPE1 then
        local nMaxLife=1;
        if fightInfo:getnMaxLife()>0 then
            nMaxLife=fightInfo:getnMaxLife()
        end
        local nLifePecent=nbRole:getCurLife()*100/nMaxLife;
        if pMonsterAddAi.nTypeParam1[checkIndex]/10>=nLifePecent and pMonsterAddAi.nTypeParam2[checkIndex]/10<=nLifePecent and m_monsterInfos[roleId].nLifeTriggerNum==0 then
            eventStatus = READY;
        end
    elseif pMonsterAddAi.nTriggerType[checkIndex] == TRIGGER_TYPE2 then
    --//出场时间n秒后触发事件
        if nCurTime-m_monsterInfos[roleId].nPlayingTime >= pMonsterAddAi.nTypeParam1[checkIndex] and m_monsterInfos[roleId].nPlayingTime>0 then
            eventStatus = READY;
        end
    elseif pMonsterAddAi.nTriggerType[checkIndex] == TRIGGER_TYPE3 then
        if nCurTime-m_monsterInfos[roleId].nLastTriggerTime >= pMonsterAddAi.nTypeParam1[checkIndex] and m_monsterInfos[roleId].nCycleTriggerNum==0 then
            eventStatus = READY;
            m_monsterInfos[roleId].nLastTriggerTime = nCurTime;
        end
    end
	if eventStatus == IDLE then
		return eventStatus
	end
	if pMonsterAddAi.nEventType[checkIndex] == 1 then
		if m_monsterInfos[roleId].mapStatusCoolTime[1] then
			if nCurTime - m_monsterInfos[roleId].mapStatusCoolTime[1] < 0 then
				eventStatus = IDLE
			end
		end
		if eventStatus ~= IDLE then
			nbRole:setProperty(1, pMonsterAddAi.nEventParam1[checkIndex]/1000)
			m_monsterInfos[roleId].mapStatusCoolTime[1] = nCurTime+pMonsterAddAi.nEventParam1[checkIndex]/1000+pMonsterAddAi.nEventParam2[checkIndex]/1000
		end
	elseif pMonsterAddAi.nEventType[checkIndex] == 2 then
		if m_monsterInfos[roleId].mapStatusCoolTime[2] then
			if nCurTime - m_monsterInfos[roleId].mapStatusCoolTime[2] < 0 then
				eventStatus = IDLE
			end
		end
		if eventStatus ~= IDLE then
			nbRole:setProperty(3, pMonsterAddAi.nEventParam1[checkIndex]/1000)
			m_monsterInfos[roleId].mapStatusCoolTime[2] = nCurTime+pMonsterAddAi.nEventParam1[checkIndex]/1000+pMonsterAddAi.nEventParam2[checkIndex]/1000
		end
	elseif pMonsterAddAi.nEventType[checkIndex] == 3 then
		local rIndex = pMonsterAddAi.nEventParam1[checkIndex]
		if m_monsterInfos[roleId].mapStatusCoolTime[rIndex] then
			if nCurTime - m_monsterInfos[roleId].mapStatusCoolTime[rIndex] < 0 then
				eventStatus = IDLE
			end
		end
		if eventStatus ~= IDLE then
		    if ptMonster.x-ptRole.x>0 then
                nbRole:setDirection(0);
			else 
                nbRole:setDirection(1)
            end
		    for j=1, pMonsterAddAi.nEventParam2[checkIndex] do
			    nbRole:MonsterAttack(pMonsterAddAi.nEventParam1[checkIndex])
			end
			local skill = TableParser:getSingleton():getMagicTypeByKey(pMonsterAddAi.nEventParam1[checkIndex]);
			m_monsterInfos[roleId].nLastTriggerTime = m_monsterInfos[roleId].nLastTriggerTime + skill.costTime/1000*pMonsterAddAi.nEventParam2[checkIndex]+1;
			m_monsterInfos[roleId].mapStatusCoolTime[rIndex] = nCurTime+skill.costTime/1000*pMonsterAddAi.nEventParam2[checkIndex]+1;
		end
	elseif pMonsterAddAi.nEventType[checkIndex] == 4 then
		local rIndex = pMonsterAddAi.nEventParam1[checkIndex]
		if m_monsterInfos[roleId].mapStatusNums[rIndex] then
			if m_monsterInfos[roleId].mapStatusNums[rIndex]>=pMonsterAddAi.nEventParam2[checkIndex] then
				eventStatus = IDLE
			else
				m_monsterInfos[roleId].mapStatusNums[rIndex] = m_monsterInfos[roleId].mapStatusNums[rIndex]+1
			end
		else
			m_monsterInfos[roleId].mapStatusNums[rIndex] = 1
		end
		nbRole:addStatusAttribute(pMonsterAddAi.nEffectType1[checkIndex], pMonsterAddAi.nEffectValue1[checkIndex]);
		nbRole:addStatusAttribute(pMonsterAddAi.nEffectType2[checkIndex], pMonsterAddAi.nEffectValue2[checkIndex]);
		nbRole:addStatusAttribute(pMonsterAddAi.nEffectType3[checkIndex], pMonsterAddAi.nEffectValue3[checkIndex]);
	end
    return IDLE--eventStatus
end
--]]
function CheckMonsterAddAi_getPlayTime(roleId)
    if nil == roleId then
        roleId = LuaReCall:getSingleton():getuID()
    end
    if m_monsterInfos and m_monsterInfos[roleId] and m_monsterInfos[roleId].nPlayingTime then
        return m_monsterInfos[roleId].nPlayingTime
    end
    return 0
end

function CheckMonsterAddAi_setPlayTime(roleId, value)
    if nil == roleId then
        roleId = LuaReCall:getSingleton():getuID()
    end
    if nil == value then
        value = LuaReCall:getSingleton():getnID()
    end
    if m_monsterInfos and m_monsterInfos[roleId] then
        m_monsterInfos[roleId].nPlayingTime = value
    end
end

function CheckMonsterAddAi_getLastTriggerTime(roleId)
    if 1 then
        return
    end
    if nil == roleId then
        roleId = LuaReCall:getSingleton():getuID()
    end
    if m_monsterInfos and m_monsterInfos[roleId] and m_monsterInfos[roleId].nLastTriggerTime then
        return m_monsterInfos[roleId].nLastTriggerTime
    end
    return 0
end

function CheckMonsterAddAi_setLastTriggerTime(roleId, value)
    if 1 then
        return
    end
    if nil == roleId then
        roleId = LuaReCall:getSingleton():getuID()
    end
    if nil == value then
        value = LuaReCall:getSingleton():getnID()
    end
    if m_monsterInfos and m_monsterInfos[roleId] then
        m_monsterInfos[roleId].nLastTriggerTime = value
    end
end

function CheckMonsterAddAi_getLifeTriggerNum(roleId)
    if nil == roleId then
        roleId = LuaReCall:getSingleton():getuID()
    end
    if m_monsterInfos and m_monsterInfos[roleId] and m_monsterInfos[roleId].nLifeTriggerNum then
        return m_monsterInfos[roleId].nLifeTriggerNum
    end
    return 0
end

function CheckMonsterAddAi_setLifeTriggerNum(roleId, value)
    if nil == roleId then
        roleId = LuaReCall:getSingleton():getuID()
    end
    if nil == value then
        value = LuaReCall:getSingleton():getnID()
    end
    if m_monsterInfos and m_monsterInfos[roleId] then
        m_monsterInfos[roleId].nLifeTriggerNum = value
    end
end

function CheckMonsterAddAi_getCycleTriggerNum(roleId)
    if nil == roleId then
        roleId = LuaReCall:getSingleton():getuID()
    end
    if m_monsterInfos and m_monsterInfos[roleId] and m_monsterInfos[roleId].nCycleTriggerNum then
        return m_monsterInfos[roleId].nCycleTriggerNum
    end
    return 0
end

function CheckMonsterAddAi_setCycleTriggerNum(roleId, value)
    if nil == roleId then
        roleId = LuaReCall:getSingleton():getuID()
    end
    if nil == value then
        value = LuaReCall:getSingleton():getnID()
    end
    if m_monsterInfos and m_monsterInfos[roleId] then
        m_monsterInfos[roleId].nCycleTriggerNum = value
    end
end

function CheckMonsterAddAi_triggerReady()
    local roleId = LuaReCall:getSingleton():getuID()
    local checkIndex = LuaReCall:getSingleton():getnID()
end

function CheckMonsterAddAi_triggerSuc(roleId, checkIndex)
	if nil == roleId then
		roleId = LuaReCall:getSingleton():getuID()
	end
	if 0 == roleId then
		return
	end
	if nil == checkIndex then
		checkIndex = LuaReCall:getSingleton():getnID()
	end
	local nbRole = NewBattleMessage:getSingleton():getFighterById(roleId)
	if nil == nbRole then
		return
	end 
	local fightInfo = nbRole:getInfo()
	local pMonsterAddAi = CMonsterAi:getSingleton():GetMonsterAddAi(fightInfo.dwMonsterEvent)
	if nil == pMonsterAddAi then
	    return
	end
	local addAi = pMonsterAddAi:getAddAiWithIndex(checkIndex)
	if addAi.nTriggerType == TRIGGER_TYPE1 then
	    if addAi.nEventData == 1 then
	        CheckMonsterAddAi_setLifeTriggerNum(roleId, CheckMonsterAddAi_getLifeTriggerNum(roleId)+1)
	    end
	    if addAi.nEventType == 3 then
	        CheckMonsterAddAi_setLifeTriggerNum(roleId, CheckMonsterAddAi_getLifeTriggerNum(roleId)+1)
	    end
	elseif addAi.nTriggerType == TRIGGER_TYPE2 then
	    if addAi.nEventData == 1 then
	        CheckMonsterAddAi_setPlayTime(roleId, 0)
	    end
	    if addAi.nEventType == 3 then
	        CheckMonsterAddAi_setLifeTriggerNum(roleId, CheckMonsterAddAi_getLifeTriggerNum(roleId)+1)
	    end
	elseif addAi.nTriggerType == TRIGGER_TYPE3 then
        
	end
end

function CheckMonsterAddAi_clearData()
    m_monsterInfos = nil
    ArenaUserAi_clearData()
	DuelTempleAi_clearData()
end

function CheckMonsterAddAi_isMonsterID(idRole)
	return (idRole >= 400001 and idRole <= 699999)
end

function CheckMonsterAddAi_isEudemonID(idRole)
	return (idRole >= 1000000000 and idRole <= 3999999999)
end

function CheckMonsterAddAi_checkMonsterAddAi()
	local roleId = LuaReCall:getSingleton():getuID()
	if 0 == roleId then
		return false
	end
	local nbRole = NewBattleMessage:getSingleton():getFighterById(roleId)
	if nil == nbRole then
		return false
	end 
	if nil == m_monsterInfos then
		m_monsterInfos = {}
	end
	if nil == m_monsterInfos[roleId] then
		m_monsterInfos[roleId] = {}
		m_monsterInfos[roleId].nPlayingTime = timeForLua()
		m_monsterInfos[roleId].nLastTriggerTime = {}
		m_monsterInfos[roleId].nLifeTriggerNum = 0
		m_monsterInfos[roleId].nCycleTriggerNum = 0
		m_monsterInfos[roleId].mapStatusCoolTime = {}
		m_monsterInfos[roleId].mapStatusNums = {}
	end
	local nCurTime = timeForLua()
	
	local fightInfo = nbRole:getInfo()
	local pMonsterAddAi = CMonsterAi:getSingleton():GetMonsterAddAi(fightInfo.dwMonsterEvent)
	if nil == pMonsterAddAi then
	    return false
	end
	
	--增加死亡检测
	if nbRole:getCurLife()<=0 then
		return false;
	end
	
	local lyr = getMapLayer();
	if nil==lyr then
		return false
	end
	local manager = lyr:getNewBattleManager();
	if nil == manager then
		return false
	end
	if manager:IsGoStatus() then
		return false;
	end
	local pBattleMessage = NewBattleMessage:getSingleton();
	if nil == pBattleMessage then
		return false;
	end
	if not CheckMonsterAddAi_isMonsterID(fightInfo.idRole)
		and not CheckMonsterAddAi_isEudemonID(fightInfo.idRole) then
		return false;
	end
	local pRole = nil;
	if nbRole:getAttackTarget()>0 then
		pRole=NewBattleMessage:getSingleton():getFighterById(nbRole:getAttackTarget());
	end
	if not pRole or pRole:getStatus()==4 or pRole:getHurtStatus() == 3 then
		nbRole:FindNewTarget();
		if nbRole:getAttackTarget()>0 then
			pRole=NewBattleMessage:getSingleton():getFighterById(nbRole:getAttackTarget());
		end
	end
	if nil == pRole then
		return false;
	end
	local ptRole=pRole:getPosition();
	local ptMonster=nbRole:getPosition()
	
	for i=0, pMonsterAddAi.ucEventAmount-1 do
		local eventStatus = IDLE
		local addAi = pMonsterAddAi:getAddAiWithIndex(i)
		if addAi then
			if addAi.nTriggerType == TRIGGER_TYPE1 then
				local nMaxLife=1;
				if fightInfo:getnMaxLife()>0 then
					nMaxLife=fightInfo:getnMaxLife()
				end
				local nLifePecent=nbRole:getCurLife()*100/nMaxLife;
				if addAi.nTypeParam1/10>=nLifePecent and addAi.nTypeParam2/10<=nLifePecent and m_monsterInfos[roleId].nLifeTriggerNum==0 then
					eventStatus = READY;
				end
			elseif addAi.nTriggerType == TRIGGER_TYPE2 then
			--//出场时间n秒后触发事件
				if nCurTime-m_monsterInfos[roleId].nPlayingTime >= addAi.nTypeParam1 and m_monsterInfos[roleId].nPlayingTime>0 then
					eventStatus = READY;
				end
			elseif addAi.nTriggerType == TRIGGER_TYPE3 then
			    if nil == m_monsterInfos[roleId].nLastTriggerTime[i] then
			        m_monsterInfos[roleId].nLastTriggerTime[i] = timeForLua()
			    end
				if nCurTime-m_monsterInfos[roleId].nLastTriggerTime[i] >= addAi.nTypeParam1 and m_monsterInfos[roleId].nCycleTriggerNum==0 then
					eventStatus = READY;
					m_monsterInfos[roleId].nLastTriggerTime[i] = nCurTime;
				end
			end
			if eventStatus ~= IDLE then
				if addAi.nEventType == 1 then
					if m_monsterInfos[roleId].mapStatusCoolTime[1] then
						if nCurTime - m_monsterInfos[roleId].mapStatusCoolTime[1] < 0 then
							eventStatus = IDLE
						end
					end
					if eventStatus ~= IDLE then
						nbRole:setProperty(1, addAi.nEventParam1/1000)
						m_monsterInfos[roleId].mapStatusCoolTime[1] = nCurTime+addAi.nEventParam1/1000+addAi.nEventParam2/1000
						CheckMonsterAddAi_triggerSuc(roleId, i)
					end
				elseif addAi.nEventType == 2 then
					if m_monsterInfos[roleId].mapStatusCoolTime[2] then
						if nCurTime - m_monsterInfos[roleId].mapStatusCoolTime[2] < 0 then
							eventStatus = IDLE
						end
					end
					if eventStatus ~= IDLE then
						nbRole:setProperty(2, addAi.nEventParam1/1000)
						m_monsterInfos[roleId].mapStatusCoolTime[2] = nCurTime+addAi.nEventParam1/1000+addAi.nEventParam2/1000
						CheckMonsterAddAi_triggerSuc(roleId, i)
					end
				elseif addAi.nEventType == 3 then
					local rIndex = addAi.nEventParam1
					if m_monsterInfos[roleId].mapStatusCoolTime[rIndex] then
						if nCurTime - m_monsterInfos[roleId].mapStatusCoolTime[rIndex] < 0 then
							eventStatus = IDLE
						end
					end
					if eventStatus ~= IDLE then
					    if ptMonster.x-ptRole.x>0 then nbRole:setDirection(0)
	                    else nbRole:setDirection(1) end
	                    if addAi.nEventParam2 > 10 then
	                        addAi.nEventParam2 = 10;
	                    end
						for j=1, addAi.nEventParam2 do
							nbRole:MonsterAttack(addAi.nEventParam1)
						end
						local skill = TableParser:getSingleton():getMagicTypeByKey(addAi.nEventParam1);
						m_monsterInfos[roleId].nLastTriggerTime[i] = m_monsterInfos[roleId].nLastTriggerTime[i] + skill.costTime/1000*addAi.nEventParam2+1;
						m_monsterInfos[roleId].mapStatusCoolTime[rIndex] = nCurTime+skill.costTime/1000*addAi.nEventParam2+1;
						CheckMonsterAddAi_triggerSuc(roleId, i)
					end
				elseif addAi.nEventType == 4 then
					local rIndex = addAi.nEventParam1
					if m_monsterInfos[roleId].mapStatusNums[rIndex] then
						if m_monsterInfos[roleId].mapStatusNums[rIndex]>=addAi.nEventParam2 then
							eventStatus = IDLE
						else
							m_monsterInfos[roleId].mapStatusNums[rIndex] = m_monsterInfos[roleId].mapStatusNums[rIndex]+1
						end
					else
						m_monsterInfos[roleId].mapStatusNums[rIndex] = 1
					end
					if eventStatus ~= IDLE then
						nbRole:addStatusAttribute(addAi.nEffectType1, addAi.nEffectValue1);
						nbRole:addStatusAttribute(addAi.nEffectType2, addAi.nEffectValue2);
						nbRole:addStatusAttribute(addAi.nEffectType3, addAi.nEffectValue3);
						CheckMonsterAddAi_triggerSuc(roleId, i)
					end
				end
			end
		end
	end
	return true
end

--伤害计算
function CheckMonsterAddAi_getDamageValue()
	--返回的个位是暴击标记,十位以上是伤害
	local nDamage = 1
	local isBaoji = 0
	local strVaule = LuaReCall:getSingleton():getText():getData()
	local roleIds = Split(strVaule, "_")
	if #roleIds ~=2 then
		return nDamage*10+isBaoji
	end
	local attackerId = roleIds[1] + 0
	local targetId = roleIds[2] + 0
	local attacker = NewBattleMessage:getSingleton():getFighterById(attackerId)
	local target = NewBattleMessage:getSingleton():getFighterById(targetId)
	if not attacker or not target then
		return nDamage*10+isBaoji
	end
	local attackFighterInfo = attacker:getInfo()
	attackFighterInfo:decryptAttackData()
	local attackSkill = attacker:getSkill()
	local targetFighterInfo = target:getInfo()
	targetFighterInfo:decryptAttackData()

	local reltargetDef = targetFighterInfo.nDef+target:getStatusAttributeAdd(421);
	local reltargetSkillDef = targetFighterInfo.nSkillDef+target:getStatusAttributeAdd(428);
	local reltargetDefDamage = targetFighterInfo.nDefDamage+target:getStatusAttributeAdd(481);
	local relattackAtk = attackFighterInfo.nAtk+attacker:getStatusAttributeAdd(411);
	local relattackSkillAtk = attackFighterInfo.nSkillAtk+attacker:getStatusAttributeAdd(457);
	local relattackDamage =  attackFighterInfo.nDamage+attacker:getStatusAttributeAdd(498);
	if target:getProperty() ~= NBPropertyInvincibleDownOne then
		if NewBattleMessage:getSingleton():isBaseSkillAttack(attackSkill.id) then
			local fDefRate = 0.0;
			if targetFighterInfo.ucLevel > 100 then
				fDefRate = reltargetDef/(reltargetDef+4000+(targetFighterInfo.ucLevel-100)*100);
			else
				fDefRate = reltargetDef/(reltargetDef+4000);
			end
			fDefRate = G_Min(fDefRate, 0.85);
			nDamage = relattackAtk * (attackSkill.power / 1000) * (1-fDefRate)- reltargetDefDamage;
			nDamage = G_Max(nDamage, 1);
			nDamage = nDamage + attackSkill.damage + relattackDamage
		else
			local fDefRate = 0.0
			if targetFighterInfo.ucLevel > 100 then
				fDefRate = reltargetSkillDef/(reltargetSkillDef+4000+(targetFighterInfo.ucLevel-100)*100);
			else
				fDefRate = reltargetSkillDef/(reltargetSkillDef+4000);
			end
			fDefRate = G_Min(fDefRate, 0.85);
			nDamage = relattackSkillAtk * (attackSkill.power / 1000) * (1-fDefRate);
			nDamage = G_Max(nDamage, 1);
			nDamage = nDamage + attackSkill.damage + relattackDamage - reltargetDefDamage;
		end

		local reltargetDefBaojiRate = targetFighterInfo.nDefBaojiRate+target:getStatusAttributeAdd(496);
		local relattackBaojiRate = attackFighterInfo.nBaojiRate+attacker:getStatusAttributeAdd(492);
		local relattackBaojiDmg = attackFighterInfo.nBaojiDmg+attacker:getStatusAttributeAdd(497);
		local nBaojiRate = relattackBaojiRate - reltargetDefBaojiRate;
		if nBaojiRate > 0 and nBaojiRate > math.random(10000) then
			nDamage = nDamage * ( 2 + relattackBaojiDmg / 1000);
			isBaoji = 1;
		end

		nDamage = G_Max(nDamage, 1);
	end
	attackFighterInfo:encryptAttackData();
	targetFighterInfo:encryptAttackData();
	return math.modf(nDamage)*10+isBaoji
end