--定义一个与文件名相同的table
DailyAttend = {}
----------------变量定义区----------------
local m_stfill = {};
local m_stInfo = {};
local m_Day = 0;       --签到天数
local m_Flag = nil;    --领取标记 用来刷新界面
local m_isLogin = nil; --今天是否签到

----------------结构定义区----------------
local stRechargeItem = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
				
		self.usAwardType = dt:readShort();    --物品类型
	    self.idItemType = dt:readInt();       --物品id
	    self.nNum = dt:readInt();             --物品个数
		return self
	end
}

local stGiftInfo = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
				
		self.ucFlag = dt:readByte();        --领取标记 0 未达到 1 达到条件 2 已领取
	    self.nCondition = dt:readInt();     --条件  各个礼包天数
	    self.idGiftType = dt:readInt();     --礼包模版id
	    self.ucAmount = dt:readByte();		--奖励个数
	    self.stfill = {}
	    for i = 1, self.ucAmount do
            table.insert(self.stfill, stRechargeItem.initWithStream(dt))
        end
		return self
	end
}
----------------常量定义区----------------
local GIFTINFO_SEND_GIFT_INFO_BEGIN = 11  --礼包信息下发开始 
local GIFTINFO_SEND_GIFT_INFO_END   = 12  --礼包信息下发解锁 
local GIFTINFO_GET_GIFT_AWARD       = 13  --获取礼包

--变量的定义
----------------UI控制器区----------------
function DailyAttend.initControl()
	local pWindow4437 = SCWindow:window()
	if pWindow4437 then
		pWindow4437:setTag(4437)
		pWindow4437:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4437:setPosition(AUTO_POS(0.00, -1.00))pWindow4437:setContentSize(AUTO_SIZE(480, 320))
		pWindow4437:luaSetSelectorOnClose(DailyAttend.releaseControl)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(0.00, 0.00))
		pDragNode2:setContentSize(AUTO_SIZE(480, 320))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTyperedwindowstip)
	end

	local imgPath = getRealUIResourcePath("kernal/redtop.pn")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage3:setPosition(AUTO_POS(135.00, 296.00))
		end
	end

	local imgPath = getRealUIResourcePath("qiandao/new00749.png")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage4:setPosition(AUTO_POS(210.00, 300.00))
		end
	end

	local pButton5 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton5 then
		pButton5:setTag(5)
		pButton5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton5:setPosition(AUTO_POS(458.00, 299.00))
		pButton5:setContentSize(AUTO_SIZE(20, 20))
		local imgPath = getRealUIResourcePath("img/new00123.pn")
		if imgPath then
			pButton5:setTitle(imgPath:getData())
		end
	end

	local pDragNode6 = SCDragNode:node()
	if pDragNode6 then
		pDragNode6:setTag(6)
		pDragNode6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode6:setPosition(AUTO_POS(3.00, 32.00))
		pDragNode6:setContentSize(AUTO_SIZE(473, 265))
		pDragNode6:setFrameVisibled(true)
		pDragNode6:setDragEnabled(false)
		pDragNode6:setFrameType(EnumFrameTypeTip3)
	end

	local pDragNode7 = SCDragNode:node()
	if pDragNode7 then
		pDragNode7:setTag(7)
		pDragNode7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode7:setPosition(AUTO_POS(18.00, 161.00))
		pDragNode7:setContentSize(AUTO_SIZE(82, 84))
		pDragNode7:setFrameVisibled(true)
		pDragNode7:setDragEnabled(false)
		pDragNode7:setFrameType(EnumFrameTypeTip3)
	end

	local pButton8 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton8 then
		pButton8:setTag(8)
		pButton8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton8:setPosition(AUTO_POS(11.00, 12.00))
		pButton8:setContentSize(AUTO_SIZE(60, 60))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton8:setTitle(imgPath:getData())
		end
	end

	local pDragNode9 = SCDragNode:node()
	if pDragNode9 then
		pDragNode9:setTag(9)
		pDragNode9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode9:setPosition(AUTO_POS(129.00, 161.00))
		pDragNode9:setContentSize(AUTO_SIZE(82, 84))
		pDragNode9:setFrameVisibled(true)
		pDragNode9:setDragEnabled(false)
		pDragNode9:setFrameType(EnumFrameTypeTip3)
	end

	local pButton10 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton10 then
		pButton10:setTag(10)
		pButton10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10:setPosition(AUTO_POS(11.00, 12.00))
		pButton10:setContentSize(AUTO_SIZE(60, 60))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton10:setTitle(imgPath:getData())
		end
	end

	local pDragNode11 = SCDragNode:node()
	if pDragNode11 then
		pDragNode11:setTag(11)
		pDragNode11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode11:setPosition(AUTO_POS(338.00, 95.00))
		pDragNode11:setContentSize(AUTO_SIZE(111, 116))
		pDragNode11:setFrameVisibled(true)
		pDragNode11:setDragEnabled(false)
		pDragNode11:setFrameType(EnumFrameTypeTip3)
	end

	local pButton12 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton12 then
		pButton12:setTag(12)
		pButton12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton12:setPosition(AUTO_POS(11.00, 14.00))
		pButton12:setContentSize(AUTO_SIZE(88, 88))
		local imgPath = getRealUIResourcePath("app/new00678.pn")
		if imgPath then
			pButton12:setTitle(imgPath:getData())
		end
	end

	local pDragNode13 = SCDragNode:node()
	if pDragNode13 then
		pDragNode13:setTag(13)
		pDragNode13:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode13:setPosition(AUTO_POS(240.00, 161.00))
		pDragNode13:setContentSize(AUTO_SIZE(82, 84))
		pDragNode13:setFrameVisibled(true)
		pDragNode13:setDragEnabled(false)
		pDragNode13:setFrameType(EnumFrameTypeTip3)
	end

	local pButton14 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton14 then
		pButton14:setTag(14)
		pButton14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton14:setPosition(AUTO_POS(11.00, 12.00))
		pButton14:setContentSize(AUTO_SIZE(60, 60))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton14:setTitle(imgPath:getData())
		end
	end

	local pDragNode15 = SCDragNode:node()
	if pDragNode15 then
		pDragNode15:setTag(15)
		pDragNode15:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode15:setPosition(AUTO_POS(18.00, 47.00))
		pDragNode15:setContentSize(AUTO_SIZE(82, 84))
		pDragNode15:setFrameVisibled(true)
		pDragNode15:setDragEnabled(false)
		pDragNode15:setFrameType(EnumFrameTypeRound)
	end

	local pButton16 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton16 then
		pButton16:setTag(16)
		pButton16:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton16:setPosition(AUTO_POS(11.00, 12.00))
		pButton16:setContentSize(AUTO_SIZE(60, 60))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton16:setTitle(imgPath:getData())
		end
	end

	local pDragNode17 = SCDragNode:node()
	if pDragNode17 then
		pDragNode17:setTag(17)
		pDragNode17:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode17:setPosition(AUTO_POS(129.00, 47.00))
		pDragNode17:setContentSize(AUTO_SIZE(82, 84))
		pDragNode17:setFrameVisibled(true)
		pDragNode17:setDragEnabled(false)
		pDragNode17:setFrameType(EnumFrameTypeRound)
	end

	local pButton18 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton18 then
		pButton18:setTag(18)
		pButton18:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton18:setPosition(AUTO_POS(11.00, 12.00))
		pButton18:setContentSize(AUTO_SIZE(60, 60))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton18:setTitle(imgPath:getData())
		end
	end

	local pDragNode19 = SCDragNode:node()
	if pDragNode19 then
		pDragNode19:setTag(19)
		pDragNode19:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode19:setPosition(AUTO_POS(240.00, 47.00))
		pDragNode19:setContentSize(AUTO_SIZE(82, 84))
		pDragNode19:setFrameVisibled(true)
		pDragNode19:setDragEnabled(false)
		pDragNode19:setFrameType(EnumFrameTypeRound)
	end

	local pButton20 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton20 then
		pButton20:setTag(20)
		pButton20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton20:setPosition(AUTO_POS(11.00, 12.00))
		pButton20:setContentSize(AUTO_SIZE(60, 60))
		local imgPath = getRealUIResourcePath("qiandao/new00745.png")
		if imgPath then
			pButton20:setTitle(imgPath:getData())
		end
	end

	local pButton21 = SCButton:button(EnumBtnType9Atlas)
	if pButton21 then
		pButton21:setTag(21)
		pButton21:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton21:setPosition(AUTO_POS(205.00, 7.00))
		pButton21:setContentSize(AUTO_SIZE(69, 27))
		local imgPath = getRealUIResourcePath("qiandao/new00750.png")
		if imgPath then
			pButton21:setTitle(imgPath:getData())
		end
	end

	local pLable22 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
	if pLable22 then
		pLable22:setTag(22)
		pLable22:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable22:setPosition(AUTO_POS(300.00, 16.00))
		pLable22:setColor(ccc4(0,255,0,255))
	end

	if pDragNode2 and pWindow4437 then
		pWindow4437:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pImage3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if pImage4 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage4, "SCNode"))
	end
	if pButton5 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton5, "SCNode"))
	end
	if pDragNode6 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode6, "SCNode"))
	end
	if pDragNode7 and pDragNode6 then
		pDragNode6:addChild(tolua.cast(pDragNode7, "SCNode"))
	end
	if pButton8 and pDragNode7 then
		pDragNode7:addChild(tolua.cast(pButton8, "SCNode"))
	end
	if pDragNode9 and pDragNode6 then
		pDragNode6:addChild(tolua.cast(pDragNode9, "SCNode"))
	end
	if pButton10 and pDragNode9 then
		pDragNode9:addChild(tolua.cast(pButton10, "SCNode"))
	end
	if pDragNode11 and pDragNode6 then
		pDragNode6:addChild(tolua.cast(pDragNode11, "SCNode"))
	end
	if pButton12 and pDragNode11 then
		pDragNode11:addChild(tolua.cast(pButton12, "SCNode"))
	end
	if pDragNode13 and pDragNode6 then
		pDragNode6:addChild(tolua.cast(pDragNode13, "SCNode"))
	end
	if pButton14 and pDragNode13 then
		pDragNode13:addChild(tolua.cast(pButton14, "SCNode"))
	end
	if pDragNode15 and pDragNode6 then
		pDragNode6:addChild(tolua.cast(pDragNode15, "SCNode"))
	end
	if pButton16 and pDragNode15 then
		pDragNode15:addChild(tolua.cast(pButton16, "SCNode"))
	end
	if pDragNode17 and pDragNode6 then
		pDragNode6:addChild(tolua.cast(pDragNode17, "SCNode"))
	end
	if pButton18 and pDragNode17 then
		pDragNode17:addChild(tolua.cast(pButton18, "SCNode"))
	end
	if pDragNode19 and pDragNode6 then
		pDragNode6:addChild(tolua.cast(pDragNode19, "SCNode"))
	end
	if pButton20 and pDragNode19 then
		pDragNode19:addChild(tolua.cast(pButton20, "SCNode"))
	end
	if pButton21 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton21, "SCNode"))
	end
	if pLable22 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable22, "SCNode"))
	end
	return pWindow4437
end
function DailyAttend.releaseControl()
	if DailyAttend.wndClose then
		DailyAttend.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
local function CloseWin()
    POP_TOP_CTRL();
end

local function setLock(node, flag, num)  --flag 1表示小箱子 2表示大箱子蒙灰 蒙灰封装  --num 1表示已领取
    local pDragNode = SCNode:node()            --半透明标志
    if pDragNode then
        pDragNode:setTag(99)
        pDragNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pDragNode:setPosition(AUTO_POS(5.00,6.00))
         if flag == 1 then
            pDragNode:setContentSize(AUTO_SIZE(72, 72))
        else
            pDragNode:setContentSize(AUTO_SIZE(101, 104))
        end
        pDragNode:setBackgroundColor(ccc4(0,0,0,155))
        node:addChild(tolua.cast(pDragNode, "SCNode"));
    end
    
    if num == 1 then
        local pLabel = SCLabel:labelWithStringFont(_LTParser("str0541"), DEFAULT_FONT_NAME, F(15))
        if pLabel then
            pLabel:setAnchorPoint(ANCHOR_CENTER)
            pLabel:setPosition(CCPointMake(pDragNode:getContentSize().width/2, pDragNode:getContentSize().height/2))
            pDragNode:addChild(tolua.cast(pLabel, "SCNode"));
        end
    end
end

local function setDays(num, pNode, x)
    local imgPath = getRealUIResourcePath("qiandao/new00751.png")
	local pImage = nil
	if imgPath then
		pImage = SCImage:imageWithFile(imgPath:getData())
		if pImage then
			pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage:setPosition(AUTO_POS(x, -15.00))
			pNode:addChild(pImage)
		end
	end
	local pBattleNumber = getImageNumber(num, "img/new00530.png", SX(12.2), SY(18), SX(8));
    if pBattleNumber then
        pBattleNumber:setAnchorPoint(CCPointMake(1, 0))
        if num < 10 then
            pBattleNumber:setPosition(CCPointMake(SX(8), 0));
        else
            pBattleNumber:setPosition(CCPointMake(SX(20), 0));
        end
        pImage:addChild(pBattleNumber);
    end
end

local function showArwad(tag)
    local num = 1;
    if tag == 8 then
        num = 1;
    elseif tag == 10 then
        num = 2;
    elseif tag == 14 then
        num = 3;
    elseif tag == 16 then
        num = 4;
    elseif tag == 18 then
        num = 5;
    elseif tag == 20 then
        num = 6;
    elseif tag == 12 then
        num = 7;
    end
    local text = L("str0544");
    for i = 1, m_stInfo[num].ucAmount do    
        if m_stInfo[num].stfill[i].usAwardType == 1 then
            text = text..L("*6")..L("str6157")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 4 then
            text = text..L("*6")..L("str5172")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 5 then
            text = text..L("*6")..L("str0193")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 7 then
            text = text..L("*6")..L("str0138")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 9 then
            text = text..L("*6")..L("str8158")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        elseif m_stInfo[num].stfill[i].usAwardType == 101 then
            text = text..L("*6")..L("str6156")..":"..L("*4")..m_stInfo[num].stfill[i].nNum..L("*0").." ";
        else
            local itemInfo = TableParser:getSingleton():getItemInfoByKey(m_stInfo[num].stfill[i].idItemType);
            if itemInfo then
                text = text..L("*6")..itemInfo.name:getData().."X1"..L("*0").." ";
            end
        end
    end
    showMessage(text);
end
local function clickNoFun()
end
local function clickSignin()
    local pButton21 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-21"), "SCButton");
    if pButton21 then
        pButton21:setTouchEnabled(false);--设置无法点击
        pButton21:setButtonType(EnumBtnTypeAsh)
        pButton21:luaSetSelectorOnClicked(clickNoFun);
    end
    TurnTable_sendData()
end
local function setWindow()
    --设置宝箱物品显示
    local pButton8 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-7-8"), "SCButton");
    if pButton8 then
        pButton8:luaSetSelectorOnClicked(showArwad)
    end
    local pButton10 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-9-10"), "SCButton");
    if pButton10 then
        pButton10:luaSetSelectorOnClicked(showArwad)
    end
    local pButton14 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-13-14"), "SCButton");
    if pButton14 then
        pButton14:luaSetSelectorOnClicked(showArwad)
    end
    local pButton16 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-15-16"), "SCButton");
    if pButton16 then
        pButton16:luaSetSelectorOnClicked(showArwad)
    end
    local pButton18 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-17-18"), "SCButton");
    if pButton18 then
        pButton18:luaSetSelectorOnClicked(showArwad)
    end
    local pButton20 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-19-20"), "SCButton");
    if pButton20 then
        pButton20:luaSetSelectorOnClicked(showArwad)
    end
    local pButton12 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-11-12"), "SCButton");
    if pButton12 then
        pButton12:luaSetSelectorOnClicked(showArwad)
    end
    --设置宝箱是否蒙灰
    local pNode7 = SCFunction:getUiNodeByIdlist("4437-2-6-7");
    if pNode7 then
        if m_stInfo[1] then
            if m_stInfo[1].ucFlag == 0 then
                setLock(pNode7, 1);
            elseif m_stInfo[1].ucFlag == 1 then
                pButton8:luaSetSelectorOnClicked(DailyAttend_sendGetAward)
            elseif m_stInfo[1].ucFlag == 2 then
                setLock(pNode7, 1, 1);
            end
            setDays(m_stInfo[1].nCondition, pNode7, 23);
        end
    end
    local pNode9 = SCFunction:getUiNodeByIdlist("4437-2-6-9");
    if pNode9 then
        if m_stInfo[2] then
            if m_stInfo[2].ucFlag == 0 then
                setLock(pNode9, 1);
            elseif m_stInfo[2].ucFlag == 1 then
                pButton10:luaSetSelectorOnClicked(DailyAttend_sendGetAward)
            elseif m_stInfo[2].ucFlag == 2 then
                setLock(pNode9, 1, 1);
            end
            setDays(m_stInfo[2].nCondition, pNode9, 23)
        end
    end
    local pNode13 = SCFunction:getUiNodeByIdlist("4437-2-6-13");
    if pNode13 then
        if m_stInfo[3] then
            if m_stInfo[3].ucFlag == 0 then
                setLock(pNode13, 1);
            elseif m_stInfo[3].ucFlag == 1 then
                pButton14:luaSetSelectorOnClicked(DailyAttend_sendGetAward)
            elseif m_stInfo[3].ucFlag == 2 then
                setLock(pNode13, 1, 1);
            end
            setDays(m_stInfo[3].nCondition, pNode13, 23)
        end
    end
    local pNode15 = SCFunction:getUiNodeByIdlist("4437-2-6-15");
    if pNode15 then
        if m_stInfo[4] then
            if m_stInfo[4].ucFlag == 0 then
                setLock(pNode15, 1);
            elseif m_stInfo[4].ucFlag == 1 then
                pButton16:luaSetSelectorOnClicked(DailyAttend_sendGetAward)
            elseif m_stInfo[4].ucFlag == 2 then
                setLock(pNode15, 1, 1);
            end
            setDays(m_stInfo[4].nCondition, pNode15, 23)
        end
    end
    local pNode17 = SCFunction:getUiNodeByIdlist("4437-2-6-17");
    if pNode17 then
        if m_stInfo[5] then
            if m_stInfo[5].ucFlag == 0 then
                setLock(pNode17, 1);
            elseif m_stInfo[5].ucFlag == 1 then
                pButton18:luaSetSelectorOnClicked(DailyAttend_sendGetAward)
            elseif m_stInfo[5].ucFlag == 2 then
                setLock(pNode17, 1, 1);
            end
            setDays(m_stInfo[5].nCondition, pNode17, 25)
        end
    end
    local pNode19 = SCFunction:getUiNodeByIdlist("4437-2-6-19");
    if pNode19 then
        if m_stInfo[6] then
            if m_stInfo[6].ucFlag == 0 then
                setLock(pNode19, 1);
            elseif m_stInfo[6].ucFlag == 1 then
                pButton20:luaSetSelectorOnClicked(DailyAttend_sendGetAward)
            elseif m_stInfo[6].ucFlag == 2 then
                setLock(pNode19, 1, 1);
            end
            setDays(m_stInfo[6].nCondition, pNode19, 25)
        end
    end
    local pNode11 = SCFunction:getUiNodeByIdlist("4437-2-6-11");
    if pNode11 then
        if m_stInfo[7] then
            if m_stInfo[7].ucFlag == 0 then
                setLock(pNode11, 2);
            elseif m_stInfo[7].ucFlag == 1 then
                pButton12:luaSetSelectorOnClicked(DailyAttend_sendGetAward)
            elseif m_stInfo[7].ucFlag == 2 then
                setLock(pNode11, 2, 1);
            end
            setDays(m_stInfo[7].nCondition, pNode11, 40)
        end
    end
    local pLable22 = SCFunction:getUiNodeByIdlist("4437-2-22");
    if pLable22 then
        pLable22:setText(string.format(L("str0539"), m_Day));
    end
    --设置签到按钮
    local pButton21 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-21"), "SCButton");
    if pButton21 then
        if m_isLogin == 1 then
            pButton21:luaSetSelectorOnClicked(clickSignin);
        else
            pButton21:setButtonType(EnumBtnTypeAsh)
        end
    end
end

local function showWin(tag, type)
    if type == LuaControllerEventPushEnded then
        setWindow();
    end
end

----------------消息处理区----------------
function DailyAttend_sendData()    --发送礼包信息
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);
    if dataStream then                   ----消息发送提示
		dataStream:writeShort(GIFTINFO_SEND_GIFT_INFO_BEGIN)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show()
    end
end

function DailyAttend_sendGetAward(tag)    --获取礼包信息
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);
    if dataStream then                   ----消息发送提示
		dataStream:writeShort(GIFTINFO_GET_GIFT_AWARD)
		if tag == 8 then
		    m_Flag = 1;
		    dataStream:writeInt(m_stInfo[1].idGiftType);
		elseif tag == 10 then
		    m_Flag = 2;
		    dataStream:writeInt(m_stInfo[2].idGiftType);
		elseif tag == 14 then
		    m_Flag = 3;
		    dataStream:writeInt(m_stInfo[3].idGiftType);
		elseif tag == 16 then
		    m_Flag = 4;
		    dataStream:writeInt(m_stInfo[4].idGiftType);
		elseif tag == 18 then
		    m_Flag = 5;
		    dataStream:writeInt(m_stInfo[5].idGiftType);
		elseif tag == 20 then
		    m_Flag = 6;
		    dataStream:writeInt(m_stInfo[6].idGiftType);
		elseif tag == 12 then
		    m_Flag = 7;
		    dataStream:writeInt(m_stInfo[7].idGiftType);
		end
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show()
    end
end

function DailyAttend_RecvGetAward()    --领取礼包后刷新界面
    if m_Flag == 1 then
        local pNode7 = SCFunction:getUiNodeByIdlist("4437-2-6-7");
        if pNode7 then
            local pButton8 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-7-8"), "SCButton");
            if pButton8 then
                pButton8:luaSetSelectorOnClicked(showArwad)
            end
            setLock(pNode7, 1, 1);
        end
    elseif m_Flag == 2 then
        local pNode9 = SCFunction:getUiNodeByIdlist("4437-2-6-9");
        if pNode9 then
            local pButton10 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-9-10"), "SCButton");
            if pButton10 then
                pButton10:luaSetSelectorOnClicked(showArwad)
            end
            setLock(pNode9, 1, 1);
        end
    elseif m_Flag == 3 then
        local pNode13 = SCFunction:getUiNodeByIdlist("4437-2-6-13");
        if pNode13 then
            local pButton14 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-13-14"), "SCButton");
            if pButton14 then
                pButton14:luaSetSelectorOnClicked(showArwad)
            end
            setLock(pNode13, 1, 1);
        end
    elseif m_Flag == 4 then
        local pNode15 = SCFunction:getUiNodeByIdlist("4437-2-6-15");
        if pNode15 then
            local pButton16 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-15-16"), "SCButton");
            if pButton16 then
                pButton16:luaSetSelectorOnClicked(showArwad)
            end
            setLock(pNode15, 1, 1);
        end
    elseif m_Flag == 5 then
        local pNode17 = SCFunction:getUiNodeByIdlist("4437-2-6-17");
        if pNode17 then
            local pButton18 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-17-18"), "SCButton");
            if pButton18 then
                pButton18:luaSetSelectorOnClicked(showArwad)
            end
            setLock(pNode17, 1, 1);
        end
    elseif m_Flag == 6 then
        local pNode19 = SCFunction:getUiNodeByIdlist("4437-2-6-19");
        if pNode19 then        
            local pButton20 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-19-20"), "SCButton");
            if pButton20 then
                pButton20:luaSetSelectorOnClicked(showArwad)
            end
            setLock(pNode19, 1, 1);
        end
    elseif m_Flag == 7 then
        local pNode11 = SCFunction:getUiNodeByIdlist("4437-2-6-11");
        if pNode11 then
            local pButton12 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-6-11-12"), "SCButton");
            if pButton12 then
                pButton12:luaSetSelectorOnClicked(showArwad)
            end
            setLock(pNode11, 2, 1);
        end
    end
    m_Flag = nil;
end

function DailyAttend_RecvDataBegin(dt)    --分包开始接收
    m_isLogin = dt:readByte();         --0不可点击 1可点击
    m_Day = dt:readInt();              --签到天数 
	local ucAmount = dt:readByte();
	for i = 1, ucAmount do
	    table.insert(m_stInfo, stGiftInfo.initWithStream(dt));
	end
end

function DailyAttend_RecvDataStop(dt)    --分包结束接收
    m_isLogin = dt:readByte();         --0不可点击 1可点击
    m_Day = dt:readInt();              --签到天数 
	local ucAmount = dt:readByte();
	for i = 1, ucAmount do
	    table.insert(m_stInfo, stGiftInfo.initWithStream(dt));
	end
	DailyAttend.Window();
end

----------------消息注册区----------------

----------------全局函数区----------------
function DailyAttend.Window()
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4437);
	if wndCtrl then
		wnd = wndCtrl:getWindow();  
        local pLable22 = SCFunction:getUiNodeByIdlist("4437-2-22");
        if pLable22 then
            pLable22:setText(string.format(L("str0539"), m_Day));
        end 
	else
		wnd = DailyAttend.initControl();
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd);
			local naviCtrl = getCurentSceneNavigationController();
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl);
				wndCtrl:luaSetSelectorOnEvent(showWin);
				wnd:setBackButtonVisibled(false);
                wnd:setCloseButtonVisibled(false);
                wnd:setFrameVisibled(false);
                --设置关闭按钮
                local pButton5 = tolua.cast(SCFunction:getUiNodeByIdlist("4437-2-5"), "SCButton");
                if pButton5 then
                    pButton5:luaSetSelectorOnClicked(CloseWin);
                end
			end
		 end
    end
end

function DailyAttend.wndClose()
    m_stfill = {};
    m_stInfo = {};
    m_Day = 0;      --签到天数
    m_Flag = nil;   --领取标记 用来刷新界面
    m_isLogin = nil;
end

--函数调用