-------8007装备卷轴制作、装备升级

_MSG_MATERIALMADE        =_MSG_GENERAL+521;--装备卷轴制作
local _MSG_INSTANCE      =_MSG_GENERAL + 170--//副本 任务界面指令
local _MSG_SHOP			 =_MSG_GENERAL+33;
local ACTION_COPYLAYER_INFO_BY_ID = 14;

--_MSG_MATERIALMADE --装备卷轴制作
    MADE_EQUIP_SCRIPT = 3;		           	--//装备制造
    EQUIPMADE_EQUIPSTRENGTHEN_ITEMS                        = 80    --/*装备强化装备下发*/
    EQUIPMADE_EQUIPSTRENGTHEN_OK                        = 81    --/*确定强化装备*/
    EQUIPMADE_EQUIPSTRENGTHEN_ALL_ROLE_ITEMS            = 82    --/*所有装备强化装备下发*/
    EQUIPMADE_EQUIPSTRENGTHEN_OK_CAN_STRENGTH_UPDATE    = 89    --/*确定强化装备更新其它可强化标志*/
    EQUIPMADE_EQUIPSTRENGTHEN_ALL_ITEMS_OVER            = 90    --/*可强装备下发完毕*/
    EQUIPMADE_EQUIPSTRENGTHEN_UPDATE_ITEMS                = 91    --/*用于强化后同一装备的更新*/
    EQUIPMADE_EQUIPMENTRECASTING_ITEMS = 92    --//装备重铸选择
    EQUIPMADE_EQUIPMENTRECASTING_OPEN= 94        --//打开重铸界面
    EQUIPMADE_EQUIPSTRENGTHEN_SUCCESS= 96        --//强化成功
    EQUIPMADE_EQUIPMENTRECASTING_OK    = 93        --//确定重铸装备
    EQUIPMADE_LEVELUP_VIEW        = 83    --/*打开装备升级界面请求*/
    EQUIPMADE_LEVELUP_OK        = 84    --/*确认升级*/
    EQUIPMADE_REEL_VIEW            = 86  --/*制作卷轴*/
    EQUIPMADE_EMONEY_OK            = 88    --/*点卷制作*/
    EQUIPMADE_ITEMUP_SUCCESS1    = 41    --/*升级成功*/    
    EQUIPMADE_RAPID_STRENGTHEN  = 105    --, //一键强化 

local m_wnd = nil
local m_bMadeAble = nil;
local m_madeItemDetail = {__mode = "kv"};--合成后物品信息
local m_requestItemList = {__mode = "kv"};--所需材料列表
local m_idBuyItemType = nil
local m_idFormulaType = nil; 
local m_bTreasureFlag = false;
local m_ucLayer = nil;
local m_nIcon = nil;

local m_idNeedMatrialType = nil;
local m_idNeedMatrialNum = nil;

local ITEMID_GEM_BEGIN	= 3900000000;           --/*宝石begin*/
local ITEMID_GEM_END	= 3900999999;			--/*宝石end*/
local ITEMID_REEL_BEGIN	= 3101000000;			--/*制作书begin*/
local ITEMID_REEL_END	= 3101999999;			--/*制作书end*/
local ITEMID_TREAUSREEL_BEGIN	= 3903002001;	--/*珍宝卷轴begin*/
local ITEMID_TREAUSREEL_END	= 3903002999;		--/*珍宝卷轴end*/

local m_GemType = {3900100009,3900090009,3900080009,3900070009,3900060009,3900050009,3900040009,3900030009,3900020009,3900010009,3900000009,3900110009,3900120009,3900130009};  --9级宝石id

local processEquiptInfo;

local function createMenuItem(width,height,icon,name,num,reqNum,idItemType)
    
    local menuItem = SCButton:button();
    menuItem:setContentSize(CCSizeMake(width,height));
    
    --物品图标
    local itemBtn = SCButton:button()
    if icon~=0 then
        local itemFile = getItemImageByIcon(icon)
        if itemFile then
             itemBtn:setTitle(itemFile:getData())
        end
    end
    
    itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Normal_ImagePath):getData())
    itemBtn:setSelectedImage(getRealUIResourcePath(ItemBack_Click_ImagePath):getData())
    itemBtn:setAnchorPoint(CCPointMake(0.5,0));
    itemBtn:setPosition(CCPointMake(menuItem:getContentSize().width/2,menuItem:getContentSize().height-itemBtn:getContentSize().height));
    menuItem:addChild(itemBtn)
    
    if idItemType>=ITEMID_REEL_BEGIN and idItemType<=ITEMID_REEL_END then
        local pImgPath = getRealUIResourcePath("img/new00115.png")
        if pImgPath then
            local nIndex = math.mod(idItemType,10);
            local pImg = SCImage:imageWithFile(pImgPath:getData(), CCRectMake(SX(6)*nIndex,0,SX(6),SY(8)));
            if pImg then
                pImg:removeAllChildrenWithCleanup(true);
                pImg:setAnchorPoint(CCPointMake(0.5,0.5));
                pImg:setPosition(CCPointMake(itemBtn:getContentSize().width/2,itemBtn:getContentSize().height/2));
                itemBtn:addChild(pImg)
            end
        end
    end
    
    --物品名称
    local itemName = ""
    if name then
        itemName = name:getData();
    end
    
    --local titleLabel = SCLabel:labelWithStringFont(itemName,getDefaultFontName(), getFontSize(10))
    local titleLabel = ParsedNode:getParsedNode(itemName,0)
    titleLabel:setAnchorPoint(CCPointMake(0.5,0));
    titleLabel:setPosition(CCPointMake(menuItem:getContentSize().width/2,menuItem:getContentSize().height-itemBtn:getContentSize().height-titleLabel:getContentSize().height));
    menuItem:addChild(titleLabel)
    
    --物品个数
    local numStr = ""
    local color = getColorWhite()
    if num and reqNum then
        numStr = num.."/"..reqNum
        if num >= reqNum then
            color = getColorGreen()
        end
    end
    
    local numLabel = SCLabel:labelWithStringFont(numStr,getDefaultFontName(), getFontSize(10))
    if numLabel then
        numLabel:setAnchorPoint(CCPointMake(0.5,0));
        numLabel:setPosition(CCPointMake(menuItem:getContentSize().width/2,menuItem:getContentSize().height-itemBtn:getContentSize().height-titleLabel:getContentSize().height-numLabel:getContentSize().height));
        numLabel:setColor(color)
        menuItem:addChild(numLabel)
    end
    
    return menuItem,itemBtn
end 

--物品点击响应
local function itemButtonAction()
    if m_wnd == nil then
        return
    end
    local fatherLayer = m_wnd:getChildByTag(800701);
    if fatherLayer == nil then
        return
    end
    
    if m_madeItemDetail == nil or m_madeItemDetail.szProductionTip == nil then
        return
    end
    local showWidth  = SX(220)
    local showHeight = SY(150)
    local tmpX  = getScreenWidth()/2--当前屏幕宽
    local tmpY = getScreenHeight()/2--当前屏幕高
    
    local itemButton = fatherLayer:getChildByTag(1);
    if itemButton then
        tmpX = fatherLayer:getPosition().x+itemButton:getPosition().x+itemButton:getContentSize().width/2
       -- tmpY = fatherLayer:getPosition().y+itemButton:getPosition().y+itemButton:getContentSize().height/2
    end
    local frameWndNode = FrameWindow:frameWnd()
    frameWndNode:setContentSize(CCSizeMake(showWidth, showHeight))
    frameWndNode:setOutSpaceClickClose(true)
    frameWndNode:setCloseBtnVisible(true)--是否显示关闭按钮
    frameWndNode:setAnchorPoint(CCPointMake(0, 0.5))
    frameWndNode:setPosition(CCPointMake(tmpX,tmpY))
    
    local detailLabel = SCTextBox:boxWithWidthHeight(showWidth*0.8,showHeight*0.9);
    detailLabel:setParserDelegate(TextParser:getSingleton())
    detailLabel:setAnchorPoint(CCPointMake(0,0));
    detailLabel:setPosition(CCPointMake(SX(15),showHeight-detailLabel:getContentSize().height-SY(15)));
    detailLabel:setText(m_madeItemDetail.szProductionTip)
    detailLabel:setScrollHorizontal(false)
    detailLabel:setScrollVertical(false)
    frameWndNode:addChild(detailLabel)   

    m_wnd :addChild(frameWndNode)
end

--二次确认购买
local function onClickedBuyVip(tag)
    if 1 == tag and m_idBuyItemType~=nil then
        LuaShopBuyItem(2,m_idBuyItemType,1);
        m_idBuyItemType = nil;
    end
end

local function onClickedBuyNormal(tag)
    if 1 == tag and m_idBuyItemType~=nil then
        LuaShopBuyItem(1,m_idBuyItemType,1);
        m_idBuyItemType = nil;
    end
end

local function onClickedBuyEx(tag)
    if 1 == tag then
        treasure.openTreasureShop()
    end
end

function refreshProcessEquipt()
    processEquiptInfo(m_idFormulaType,m_ucLayer,m_nIcon);
end

function EquipMake_getNeedMaterialInfo()
    return m_idNeedMatrialType,m_idNeedMatrialNum;
end

function EquipMake_setNeedMaterialInfo(idType,nAmount)
    m_idNeedMatrialType = idType;
    m_idNeedMatrialNum = nAmount;
end
--[[
----红宝石   3101020002   3101200002  黄宝石  3101000002   3101300002   蓝宝石  
function itemid_to_new(itemtype)  --------新旧宝石itemtype转换
	local newitemtype = 0;
	local lev = math.mod(idItemType,10)   ----等级
	local type = itemtype/10000;
	type = math.mod(type,100)
	if  type == 2 then
		newitemtype = 3101200000+type
	end 
	
	return newitemtype
end 
]]
--右边材料物品点击响应
local function menuItemButtonAction(tag)
    local idItemType = m_requestItemList[tag].idMaterialType;
    local idPath = m_requestItemList[tag].idPath;
    local stItemInfo = TableParser:getSingleton():getItemInfoByKey(idItemType);
    if stItemInfo==nil then
        return;
    end
    EquipMake_setNeedMaterialInfo(0,0);
    if idItemType>=ITEMID_GEM_BEGIN and idItemType<=ITEMID_GEM_END then --宝石
        local idFormulaType = stItemInfo.data1;
        if idFormulaType>0 then
			if  idFormulaType%10 ~= 1 then
				processEquiptInfo(idFormulaType,0,0);
			else
				return;
			end 
        end
    elseif idItemType>=ITEMID_REEL_BEGIN and idItemType<=ITEMID_REEL_END then --宝石卷轴
        if math.mod(idItemType,10)==2 then
            local strTip = L("str8165")..stItemInfo.price..L("str8175")..stItemInfo.name:getData()..L("str8167");
            m_idBuyItemType = idItemType;
            luashowConfirmationWindow(strTip, WIN_YES_NO, onClickedBuyNormal);
        else
            local strTip = L("str8165")..stItemInfo.emoney..L("str8166")..stItemInfo.name:getData()..L("str8167");
            m_idBuyItemType = idItemType;
            luashowConfirmationWindow(strTip, WIN_YES_NO, onClickedBuyVip);
        end
    elseif idItemType>=ITEMID_TREAUSREEL_BEGIN and idItemType<=ITEMID_TREAUSREEL_END then --珍宝卷轴
        luashowConfirmationWindow(L("str8174"), WIN_YES_NO, onClickedBuyEx);
    elseif idPath>0 then
        
        local reqNum    = m_requestItemList[tag].needNum;
        local totalNum = m_requestItemList[tag].totalNum;
        local nAmount = 0;
        if reqNum>totalNum then
            nAmount = reqNum-totalNum;
            EquipMake_setNeedMaterialInfo(idItemType,nAmount);
        end
        
        local stInstance = TableParser:getSingleton():getInstanceTemplate(idPath);
        if GameCopyController_showGameCopyWnd(stInstance.nGroup, stInstance.type, stInstance.id)==false then
            showMessage(L("str8169")..stInstance.name:getData()..L("str8170"));
        end
        --CopymapSweep.sendOpenWnd(stInstance);--现在的
        --[[CopymapSweep.OpenCopymaoSweep(stInstance.id,1,stInstance.type,true);
        local pScene = getRunningScene();
        if pScene then
            if pScene:getUINode():getChildByTag(5917) then
                pScene:getUINode():removeChildByTag(5917, true);
            end
        end]]
    end
end

--点击确认制作
local function makeButtonAction()
    if m_bMadeAble==false then
        showMessage(L("str8164"));
        return;
    end
    
    if m_madeItemDetail then
        if m_bTreasureFlag==false then
            local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE);
            dt:writeShort(MADE_EQUIP_SCRIPT);
            dt:writeInt(m_idFormulaType);
            dt:writeByte(0);
            --dt:writeByte(0);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show()
        else
            treasure.sendMake();
            local wndCtrl = getCurentSceneWindowController(8007);
            if wndCtrl then
                removeWindowCtrl(wndCtrl);
            end
        end
    end
end
-----一键合成珍宝-----------------
local function makeonekeyButtonAction()
	treasure.onekey_sendMake();
	local wndCtrl = getCurentSceneWindowController(8007);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end
end
--点击点券制作
local function noVipButtonAction()
    luashowConfirmationWindowPoint(L("str3114"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
end
local function makeVipButtonAction()
    local flag = nil;
    for i = 1, #m_GemType do
        if m_GemType[i] == m_idFormulaType then
            flag = nil;
        end
    end
    
    if flag == nil then
        if m_bMadeAble==false then
            if m_madeItemDetail then
                if m_idFormulaType then
                    local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE);
                    dt:writeShort(MADE_EQUIP_SCRIPT);
                    dt:writeInt(m_idFormulaType);   --宝石一键制作和一键合成区别 一键合成多加一个字段
                    dt:writeByte(0);
                    dt:writeByte(1);
                    SCDataTransThread:getSingleton():transData(dt);
                    SCActivityIndicator:getSingleton():show()
                    --[[local wndCtrl = getCurentSceneWindowController(8007);
                    if wndCtrl then
                        removeWindowCtrl(wndCtrl);
                    end--]]
                 end
            end
            return;
        end
    end
    
    if m_madeItemDetail then
        if m_idFormulaType then
            local dt = SCDataTransStream:streamWithCommand(_MSG_MATERIALMADE);
            dt:writeShort(MADE_EQUIP_SCRIPT);
            dt:writeInt(m_idFormulaType);
            dt:writeByte(1);
            dt:writeByte(0);
            SCDataTransThread:getSingleton():transData(dt);
            SCActivityIndicator:getSingleton():show()
            --[[local wndCtrl = getCurentSceneWindowController(8007);
            if wndCtrl then
                removeWindowCtrl(wndCtrl);
            end--]]
         end
    end
end

--显示左边制作后物品
local function showLeftContent()
    if m_wnd == nil then
        return
    end
    local fatherLayer = m_wnd:getChildByTag(800701);
    if fatherLayer == nil then
        return
    end
    fatherLayer:removeAllChildrenWithCleanup(true);
    
    local showWidth = fatherLayer:getContentSize().width;
    local showHeight = fatherLayer:getContentSize().height;
    
   --背景图
    local imgBkFile = getRealUIResourcePath("img/new00196.png");
    if imgBkFile then
        local bgImageLabel = SCImage:imageWithFile(imgBkFile:getData()) 
        bgImageLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        bgImageLabel:setPosition(CCPointMake(showWidth/2,showHeight/2));
        fatherLayer:addChild(bgImageLabel);
    end
    
    if m_madeItemDetail == nil then
        return
    end
    
    --物品图片
    local startY = showHeight-SY(30);
    local itemFile = getItemImageByIcon(m_madeItemDetail.icon)
    if itemFile then
        local itemButton = SCButton:button();
        itemButton:setTag(1);
        itemButton:setTitle(itemFile:getData())
        itemButton:setBackgroundImage(getRealUIResourcePath(ItemBack_Normal_ImagePath):getData())
        itemButton:setSelectedImage(getRealUIResourcePath(ItemBack_Click_ImagePath):getData())
        itemButton:setAnchorPoint(CCPointMake(0.5,0.5));
        itemButton:luaSetSelectorOnClicked(itemButtonAction);--设置回调
        fatherLayer:addChild(itemButton);
        if m_ucLayer==0 then
            itemButton:setPosition(CCPointMake(showWidth/2,startY - itemButton:getContentSize().height/2));
            startY = startY - itemButton:getContentSize().height;
        else
            itemButton:setPosition(CCPointMake(showWidth/2,showHeight/2+itemButton:getContentSize().height/2));--[[-itemButton:getContentSize().height]]
            startY = showHeight/2;
        end
    end
    
    --物品名称
    if m_madeItemDetail.szName then
        local titleLabelName = ParsedNode:getParsedNode(m_madeItemDetail.szName:getData(),0)
        titleLabelName:setAnchorPoint(CCPointMake(0.5,0.5));
        titleLabelName:setPosition(CCPointMake(showWidth/2,startY-titleLabelName:getContentSize().height/2));
        fatherLayer:addChild(titleLabelName);
        startY = startY-titleLabelName:getContentSize().height;
    end
    
    --物品描述
    if m_madeItemDetail.szDesc then
        --[[local titleLabelDesc = ParsedNode:getParsedNode(m_madeItemDetail.szDesc,0)
        titleLabelDesc:setAnchorPoint(CCPointMake(0.5,0.5));
        titleLabelDesc:setPosition(CCPointMake(showWidth/2,startY-titleLabelDesc:getContentSize().height/2-SY(5)));
        fatherLayer:addChild(titleLabelDesc)]]
        local titleLabelDesc = SCTextBox:boxWithWidthHeight(SX(140), SY(110));
        if m_ucLayer == 0 then
        else
			titleLabelDesc = SCTextBox:boxWithWidthHeight(SX(140), SY(80));
        end
        titleLabelDesc:setAnchorPoint(CCPointMake(0.5,0.5));
        titleLabelDesc:setPosition(CCPointMake(showWidth/2,startY-titleLabelDesc:getContentSize().height/2-SY(5)));
        titleLabelDesc:setParserDelegate(TextParser:getSingleton())
        titleLabelDesc:setText(m_madeItemDetail.szDesc);
        fatherLayer:addChild(titleLabelDesc)
    end
end

--显示右边物品制作所需材料
local function showRightContent()
     if m_wnd == nil then
        return
    end
    local fatherLayer = m_wnd:getChildByTag(800702);
    if fatherLayer == nil then
        return
    end
    fatherLayer:removeAllChildrenWithCleanup(true)
    
    local showWidth = fatherLayer:getContentSize().width
    local showHeight = fatherLayer:getContentSize().height
    
    local startX = SX(5)
    local startY = showHeight*0.95
    
    --所需材料
    local titleLabel = SCLabel:labelWithStringFont(_LTParser("str8032"),getDefaultFontName(), getFontSize(15));
    titleLabel:setAnchorPoint(CCPointMake(0.5,0));
    titleLabel:setPosition(CCPointMake(showWidth/2,startY-titleLabel:getContentSize().height));
    fatherLayer:addChild(titleLabel);
    startY = startY-titleLabel:getContentSize().height;
    
    if m_requestItemList == nil then
        return
    end
    
    local amount = #m_requestItemList;
    if amount > 6 then
        amount = 6;
    end
    
    local imgFile = getRealUIResourcePath("img/img0015.png");
    if imgFile then
        local lineBgImgLabel = SCImage:imageWithFile(imgFile:getData());
        lineBgImgLabel:setAnchorPoint(CCPointMake(0.5,0));
        lineBgImgLabel:setPosition(CCPointMake(showWidth/2,startY-lineBgImgLabel:getContentSize().height));
        fatherLayer:addChild(lineBgImgLabel);
        startY = startY-lineBgImgLabel:getContentSize().height;
    end
     
    local menuWidth = (showWidth-SX(20))/3;
    local menuHeight = (startY-SY(15))/2;
    local tmpX = startX;
    for i=1,amount do
        local row = math.floor((i+2)/3);
        local col = math.mod(i+2,3)
        if i==4 then
            row = 2;
            col = 1;
        elseif i==5 then
            row = 2;
            col = 0;
        elseif i==6 then
            row = 2;
            col = 2;
        end
        
        tmpX = startX + (menuWidth+SX(5))*col;
        if m_requestItemList[i] then
            local icon   = m_requestItemList[i].icon;
            local name   = m_requestItemList[i].name;
            local reqNum    = m_requestItemList[i].needNum;
            local totalNum = m_requestItemList[i].totalNum;
            local menuItem,itemBtn = createMenuItem(menuWidth,menuHeight,icon,name,totalNum,reqNum, m_requestItemList[i].idMaterialType)
            menuItem:setAnchorPoint(CCPointMake(0,0));
            menuItem:setPosition(CCPointMake(tmpX,startY-(menuHeight+SY(5))*row));
            itemBtn:luaSetSelectorOnClicked(menuItemButtonAction)
            itemBtn:setTag(i)
            fatherLayer:addChild(menuItem)
        end
    end
end

function processEquiptInfo(idFormulaType,ucLayer,icon)
    if idFormulaType==nil then
        return;
    end
    
    if m_wnd==nil then
        return;
    end
    
    m_idFormulaType = idFormulaType;
    m_ucLayer = ucLayer;
    m_nIcon = icon;
    
    if ucLayer>0 then
        m_bTreasureFlag = true;
    else
        m_bTreasureFlag = false;
    end
    
    local stFormulaType = TableParser:getSingleton():getFormulaTypeByKey(idFormulaType);
    m_madeItemDetail = {}
    if ucLayer==0 then
        local idProduction = stFormulaType.production1; --制作产品类型id
        if idProduction==0 then
            return;
        end
        local stProduction = TableParser:getSingleton():getItemInfoByKey(idProduction);
        m_madeItemDetail.szName = stProduction.name;
        m_madeItemDetail.icon = stProduction.icon;
        m_madeItemDetail.szDesc = stProduction.description:getData();
    elseif ucLayer>=1 and ucLayer<=4 then
        local nAddMaxLife = {200,400,600,800};
        m_madeItemDetail.icon = icon;
        m_madeItemDetail.szName = stFormulaType.name;
        m_madeItemDetail.szDesc = L("str6165")..nAddMaxLife[ucLayer];
    end                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
    
    m_bMadeAble = true;
    local idMatType = {stFormulaType.material1,stFormulaType.material2,stFormulaType.material3,stFormulaType.material4,stFormulaType.material5,stFormulaType.material6};
    local nMatNum = {stFormulaType.material_num1,stFormulaType.material_num2,stFormulaType.material_num3,stFormulaType.material_num4,stFormulaType.material_num5,stFormulaType.material_num6};
    m_requestItemList = {}
    for i=1,6 do
        local idMaterialType = idMatType[i]; --所需材料1类型id
        if idMaterialType>0 then
            local tmpDetail = {}
            tmpDetail.idMaterialType = idMaterialType;
            local stMaterialType = TableParser:getSingleton():getItemInfoByKey(idMaterialType);
            tmpDetail.name = stMaterialType.name;
            tmpDetail.icon = stMaterialType.icon;
            tmpDetail.needNum = nMatNum[i];
            tmpDetail.idPath = stMaterialType.idPath;
            local MatTotalNum = 0;
            local iteminfoSize = ItemProcessor:getSingleton():ItemSize()
            for i = 1, iteminfoSize do
                local itemStor = ItemProcessor:getSingleton():getItemInfo(i - 1);
                if itemStor:getIdType()==idMaterialType then
                    if itemStor:isPileAble()==true then
                        MatTotalNum = MatTotalNum+itemStor:getAmount();
                    else
                        MatTotalNum = MatTotalNum+1;
                    end
                end
            end
            tmpDetail.totalNum = MatTotalNum;
            if tmpDetail.totalNum<tmpDetail.needNum then
                m_bMadeAble = false;
            end
            
            table.insert(m_requestItemList,tmpDetail);
        end
    end
    
    
    local makeButton = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("8007-800703"));
    if makeButton then
        makeButton:setButtonType(EnumBtnType9Atlas)
        makeButton:removeAllChildrenWithCleanup(true);
        if m_bMadeAble==false then
            makeButton:setButtonType(EnumBtnTypeAsh)
            local imgTitleFile = getRealUIResourcePath("img/new00660.png");
            if imgTitleFile then
                local pImg = SCImage:imageWithFile(imgTitleFile:getData());
                pImg:setAnchorPoint(CCPointMake(0.5,0.5));
                pImg:setPosition(CCPointMake(makeButton:getContentSize().width/2,makeButton:getContentSize().height/2));
                makeButton:addChild(pImg);
            end
        end
    end
    
    --[[local flag = nil;
    for i = 1, #m_GemType do
        if m_GemType[i] == m_idFormulaType then
            flag = 1;
        end
    end
    
    local makeButton = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("8007-800704"));
    if makeButton then
        makeButton:setButtonType(EnumBtnType9Atlas)
        makeButton:removeAllChildrenWithCleanup(true);
        if m_bMadeAble==false and flag == 1 then
            makeButton:setButtonType(EnumBtnTypeAsh)
        end
    end--]]
    
    
    showLeftContent()
    showRightContent()
end

--发送请求材料物品获取路径
function sendQueryMaterialMsg(idPath)
    if idPath then
        local dt = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
        dt:writeShort(ACTION_COPYLAYER_INFO_BY_ID);
        dt:writeInt(idPath);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end


--关闭界面清除所有数据
local function removeAllData()
    m_wnd = nil;
    m_bMadeAble = nil;
    m_madeItemDetail = {__mode = "kv"};--合成后物品信息
    m_requestItemList = {__mode = "kv"};--所需材料列表
    m_idBuyItemType = nil;
    m_idFormulaType = nil;
    m_ucLayer = nil;
    m_nIcon = nil;
    m_idNeedMatrialType = nil;
    m_idNeedMatrialNum = nil;
end

function open_EquiptMakeScreen()
    local idFormulaType = LuaReCall:getSingleton():getuID();
    if idFormulaType==nil then
        return;
    end
    if idFormulaType%100 == 10 then
		showMessage(L("str21046"));
		return;
    end 
    if getCurentSceneWindowController(8007) then
        return;
    end
    
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setContentSize(CCSizeMake(SX(480), SY(320)))
    wnd:setTag(8007);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(removeAllData);
    local imgFile = getRealUIResourcePath("img/new00204.png");
    if imgFile then
       wnd:setTitleWithImage(imgFile:getData())
    end
    
    local wndCtrl = SCWindowController:controllerWithWindow(wnd)
    local scene = SCBaseScene:getRunningScene()
    local naviCtrl =  scene:getNavigationController()
    naviCtrl:pushWindowController(wndCtrl)

--  if 1 then
--     return;
--  end    

    m_wnd =  getCurentSceneWindowController(8007):getWindow();
    
    local left_width  = wnd:getContentSize().width*0.45
    local left_height = wnd:getContentSize().height*0.69
    local left_startX = SX(12)
    local left_startY = SY(45)
    
    --左边内容层
    local leftContentLayer = SCDragNode:node()
    leftContentLayer:setTag(800701)
    leftContentLayer:setFrameVisibled(true)
    leftContentLayer:setFrameType(EnumFrameTypeRound)
    leftContentLayer:setAnchorPoint(CCPointMake(0,0));
    leftContentLayer:setPosition(CCPointMake(left_startX,left_startY));
    leftContentLayer:setContentSize(CCSizeMake(left_width,left_height))
    m_wnd:addChild(leftContentLayer)
    
    local right_width  = wnd:getContentSize().width*0.47
    local right_height = left_height
    local right_startX = wnd:getContentSize().width-right_width-SX(18)
    local right_startY = left_startY
    
    --右边内容层
    local rightContentLayer = SCDragNode:node()
    rightContentLayer:setTag(800702)
    rightContentLayer:setFrameType(EnumFrameTypeRound)
    rightContentLayer:setFrameVisibled(true)
    rightContentLayer:setAnchorPoint(CCPointMake(0,0));
    rightContentLayer:setPosition(CCPointMake(right_startX,right_startY));
    rightContentLayer:setContentSize(CCSizeMake(right_width,right_height))
    m_wnd:addChild(rightContentLayer)
    
    --一键制作
    local makeButtonX = wnd:getContentSize().width/2;
    local makeButtonY = SY(28);
    local viplev = Hero:getSingleton():getVipLevel() 
    --if luaIsUnlock(UNLOCK_TYPE_MADEGEM)  then  --一键制作解锁
        makeButtonX = wnd:getContentSize().width*0.38;
        local makeVipButton = SCButton:button(EnumBtnType9Atlas);
        setNodeContentSize(makeVipButton, BigButton_Size);
        makeVipButton:setTag(800704);
        local imgTitleFile1 = getRealUIResourcePath("img/new00203.png");
        if imgTitleFile1 then
            makeVipButton:setTitle(imgTitleFile1:getData());
        end
        --makeVipButton:setTitle(_LTParser("str8041"),getDefaultFontName(), getFontSize(15),getColorYellow())
        makeVipButton:setAnchorPoint(CCPointMake(0.5,0.5));
        makeVipButton:setPosition(CCPointMake(wnd:getContentSize().width*0.59,makeButtonY));
        makeVipButton:luaSetSelectorOnClicked(makeVipButtonAction)--设置回调
        --[[if viplev < 6 and not luaIsUnlock(UNLOCK_TYPE_MADEGEM) then
            makeVipButton:luaSetSelectorOnClicked(noVipButtonAction)--设置回调
        end--]]
        m_wnd:addChild(makeVipButton);
    --end
    
    --确定制作
    local makeButton = SCButton:button(EnumBtnType9Atlas);
    setNodeContentSize(makeButton, BigButton_Size);
    makeButton:setTag(800703);
    local imgTitleFile2 = getRealUIResourcePath("img/new00197.png");
    if imgTitleFile2 then
        makeButton:setTitle(imgTitleFile2:getData());
    end

    --makeButton:setTitle(_LTParser("str8033"),getDefaultFontName(), getFontSize(15),getColorYellow())
    makeButton:setAnchorPoint(CCPointMake(0.5,0.5));
    makeButton:setPosition(CCPointMake(makeButtonX,makeButtonY));
    makeButton:luaSetSelectorOnClicked(makeButtonAction)--设置回调
    m_wnd:addChild(makeButton)
    
    processEquiptInfo(idFormulaType,0,0)
end

function open_EquiptMakeScreenEx(idFormulaType,ucLayer,icon)
    if getCurentSceneWindowController(8007) then
        return;
    end
    
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setContentSize(CCSizeMake(SX(480), SY(320)))
    wnd:setTag(8007);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(removeAllData);
    local imgFile = getRealUIResourcePath("img/new00204.png");
    if imgFile then
       wnd:setTitleWithImage(imgFile:getData())
    end
    
    local wndCtrl = SCWindowController:controllerWithWindow(wnd)
    local scene = SCBaseScene:getRunningScene()
    local naviCtrl =  scene:getNavigationController()
    naviCtrl:pushWindowController(wndCtrl)

    m_wnd =  getCurentSceneWindowController(8007):getWindow();
    
    local left_width  = wnd:getContentSize().width*0.45
    local left_height = wnd:getContentSize().height*0.69
    local left_startX = SX(12)
    local left_startY = SY(45)
    
    --左边内容层
    local leftContentLayer = SCDragNode:node()
    leftContentLayer:setTag(800701)
    leftContentLayer:setFrameVisibled(true)
    leftContentLayer:setFrameType(EnumFrameTypeRound)
    leftContentLayer:setAnchorPoint(CCPointMake(0,0));
    leftContentLayer:setPosition(CCPointMake(left_startX,left_startY));
    leftContentLayer:setContentSize(CCSizeMake(left_width,left_height))
    m_wnd:addChild(leftContentLayer)
    
    local right_width  = wnd:getContentSize().width*0.47
    local right_height = left_height
    local right_startX = wnd:getContentSize().width-right_width-SX(18)
    local right_startY = left_startY
    
    --右边内容层
    local rightContentLayer = SCDragNode:node()
    rightContentLayer:setTag(800702)
    rightContentLayer:setFrameType(EnumFrameTypeRound)
    rightContentLayer:setFrameVisibled(true)
    rightContentLayer:setAnchorPoint(CCPointMake(0,0));
    rightContentLayer:setPosition(CCPointMake(right_startX,right_startY));
    rightContentLayer:setContentSize(CCSizeMake(right_width,right_height))
    m_wnd:addChild(rightContentLayer)
    
    --一键制作
    local makeButtonX = wnd:getContentSize().width/2;
    local makeButtonY = SY(28);
    
    --确定制作
    local makeButton = SCButton:button(EnumBtnType9Atlas);
    setNodeContentSize(makeButton, BigButton_Size);
    makeButton:setTag(800703);
    local imgTitleFile2 = getRealUIResourcePath("img/new00197.png");
    if imgTitleFile2 then
        makeButton:setTitle(imgTitleFile2:getData());
    end

    
    --makeButton:setTitle(_LTParser("str8033"),getDefaultFontName(), getFontSize(15),getColorYellow())
    makeButton:setAnchorPoint(CCPointMake(0.5,0.5));
    makeButton:setPosition(CCPointMake(makeButtonX-100,makeButtonY));
    makeButton:luaSetSelectorOnClicked(makeButtonAction)--设置回调
    m_wnd:addChild(makeButton)
    
    
    local makeButton = SCButton:button(EnumBtnType9Atlas);
    setNodeContentSize(makeButton, BigButton_Size);
    makeButton:setTag(800755);
    local imgTitleFile2 = getRealUIResourcePath("img/new00203.png");
    if imgTitleFile2 then
        makeButton:setTitle(imgTitleFile2:getData());
    end

    
    --makeButton:setTitle(_LTParser("str8033"),getDefaultFontName(), getFontSize(15),getColorYellow())
    makeButton:setAnchorPoint(CCPointMake(0.5,0.5));
    makeButton:setPosition(CCPointMake(makeButtonX+100,makeButtonY));
    makeButton:luaSetSelectorOnClicked(makeonekeyButtonAction)--设置回调
    m_wnd:addChild(makeButton)
    
    processEquiptInfo(idFormulaType,ucLayer,icon)
    
end
