
----------------------------消息-----------------------------
--[[
伙伴经验卡
const unsigned short _MSG_ITEM              =_MSG_GENERAL+9;
USHOR ACTION : ITEMACT_SEND_EUDEMONADDEXP        = 192,              //发送宠物经验卡信息
下发:
typedef struct  
{
    OBJID idItem;
    DWORD dwAddExp;
    int count;
}tMsg_Info16;

ITEMACT_EUDEMONUSE_ADDEXPCARD     = 191,              //使用宠物经验卡
上发:
typedef struct  
{
    OBJID idItem;
	OBJID idTarget;
}stAddExpItem;
--]]
----------------结构定义区------------------------------------
local stExpCard = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.idItem = dt:readInt()
        tmp.dwAddExp = dt:readInt()
        tmp.count = dt:readInt()
        return tmp
    end
}
----------------常量区-----------------------------------
local MSG_ITEMACT_SEND_EUDEMONADDEXP        = 192             --发送伙伴经验卡信息
local MSG_ITEMACT_EUDEMONUSE_ADDEXPCARD     = 191			  --使用伙伴经验卡
----------------变量区----------------------------------
local tmpIdItem = nil			--使用物品ID
local tmpDwAddExp = nil			--经验卡所加经验值
local tmpIdTarget = {}			--伙伴ID列表
----------------函数声明------------------------------------
local getMateNode
local onExpCardWndClose
local createExpCardWnd
local showExpCardCrtl3100
local recvExpCard
local onClickCancel
local onClickConfirm
local onClickBatch
local usedExpCard
----------------UI控制器区-----------------------------------

function getMateNode(num,data)                                         --经验卡伙伴详细界面
    local roleNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiByZipAndId(3100,301))
    if not roleNode then
        return 
    end
    roleNode:setFrameType(EnumFrameTypeRound)
    roleNode:setFrameVisibled(false) 
    roleNode:setDragEnabled(false)
    roleNode:setPosition(CCPointMake(SX(10) + SX(210) * num, SY(10)))

    local mateImgNode =  SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", roleNode))
    if mateImgNode then
        
        local imgId = data.nFacePhoto
        local imgAddress = "faceicon/"..imgId..".png"
        local file = getRealUIResourcePath(imgAddress)
        if file then
            local pBtn =  DragButton:newDragButton()
            if pBtn then
                pBtn:setAnchorPoint(CCPointMake(0, 0))
                pBtn:setDragNodeIsVisible(false)
                pBtn:hsetBackgroundImage(file:getData())
                mateImgNode:addChild(pBtn)
            end
        end
    end

    local expNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("2", roleNode))
    local nowExp = data.dwExp
    local maxExp = data.dwMaxExp
    local str = nowExp.."/"..maxExp
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("22", roleNode))
    if pLabel then
        pLabel:setText(str)
    end
    if expNode  then
        expNode:setFrameType(EnumFrameTypeRound)
        expNode:setFrameVisibled(false) 
        expNode:setDragEnabled(false)


        pBarBack = SCProgressBar:barWithType(EnumProgressBarTypeBlack)
        pBarBack:setTag(201)
        pBarBack:setMaxValue(480)
        pBarBack:setValue(140)
        setNodePostion(pBarBack, CCPointMake(0, 0))
        expNode:addChild(pBarBack)

        pBarFront = SCProgressBar:barWithType(EnumProgressBarTypeBlue)
        pBarFront:setTag(202)
        pBarFront:setMaxValue(480)
        if nowExp < maxExp then
            pBarFront:setValue(140*nowExp/maxExp)
        else 
            pBarFront:setValue(140)
        end
        setNodePostion(pBarFront, CCPointMake(0, 0))
        expNode:addChild(pBarFront)
    end

    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3", roleNode))
    if pLabel then
        local str = data.strName
        if str then
            str = str:getData()
            pLabel:setText(str)
        end
    end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("5", roleNode))
    if pLabel then
        local str = data.usLevel
        if str then
            str = tostring(str)
            pLabel:setText(str)
        end
    end

    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("9", roleNode))
    if pLabel then
        local str = tmpDwAddExp
        if str then
            str = "+"..str
            pLabel:setText(str)

        end
        pLabel:setColor(colorYellow())
    end
    

    return roleNode
end


function createExpCardWnd()                                   --伙伴经验卡窗口创建
    local wnd =  SCTypeCast:castNodeToWindow(SCFunction:getUiById(3100))
    if not wnd then
        return
    end
    wnd:setBackgroundColor(color_window_red_bg);
    wnd:luaSetSelectorOnClose(onExpCardWndClose)

    local pNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("101", wnd))
    if pNode then
        pNode:setDragEnabled(false)
        pNode:setFrameType(EnumFrameTypeRound)
        pNode:setFrameVisibled(true)
    end
    local scrollBox = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlistAndParent("102", wnd))
    if scrollBox then 
        scrollBox:setScrollHorizontal(true)
        scrollBox:setScrollVertical(false)
        scrollBox:setPageSize(CCSizeMake(SX(210),SY(120)))

        local mateNum = Hero:getSingleton():partnerSize()
        for i = 0,(mateNum - 1) do
            local mateData = {}
            mateData = Hero:getSingleton():getPartnerWithPos(i)
            if mateData then
                local mateNode = getMateNode(i,mateData)
                scrollBox:addChild(mateNode)
                scrollBox:setContentSize(CCSizeMake(SX(210)*(i+1),SY(120)))
            end
        end

    end
	
	local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("31", pNode))
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onClickConfirm)
    end
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("32", pNode))
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onClickBatch)
    end

    return wnd
end


function showExpCardCrtl3100(dt)                                           --伙伴经验卡窗口控制器
    if dt then
        tmpIdItem = dt.idItem
        tmpDwAddExp = dt.dwAddExp
    end
	local wnd = getCurentSceneWindow(3100)
    if not wnd then
        wnd = createExpCardWnd()
        if not wnd then
            return
        end
    end
    local wndCtrl = SCWindowController:controllerWithWindow(wnd)
    if not wndCtrl then
        return
    end
    local naviCtrl =  getCurentSceneNavigationController()
    if not naviCtrl then
        return
    end
    naviCtrl:pushWindowController(wndCtrl)
end
----------------逻辑实现区-----------------------------------

function onExpCardWndClose()                        --退出经验卡界面回调函数
    tmpIdItem = nil
    tmpDwAddExp = nil
    tmpIdTarget = {}
end

function onClickCancel()                            --取消按钮回调
    local naviCtrl =  getCurentSceneNavigationController()
    if not naviCtrl then
        return
    end
    onExpCardWndClose()
    naviCtrl:removeWindowControllerByTag(3100)
end
function onClickConfirm()                       --确定按钮回调
	local scrollBox = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlist("3100-102"))
	if scrollBox then
		local count =  scrollBox:getPageIndex()
		local mateData = {}
        mateData = Hero:getSingleton():getPartnerWithPos(count)
        local myIdTarget = 0
        local myIdItem = 0
        local myCount = 0
        if mateData then 
            myIdTarget = mateData.nID
            myIdItem = tmpIdItem
            myCount = 0
        end
        usedExpCard(myIdTarget,myIdItem,myCount)
    end
    onClickCancel()
end

function onClickBatch()                       --批量按钮回调
    local scrollBox = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlist("3100-102"))
    if scrollBox then
        local count =  scrollBox:getPageIndex()
        local mateData = {}
        mateData = Hero:getSingleton():getPartnerWithPos(count)
        local myIdTarget = 0
        local myIdItem = 0
        local myCount = 0
        if mateData then 
            myIdTarget = mateData.nID
            myIdItem = tmpIdItem
            myCount = 1
        end
        usedExpCard(myIdTarget,myIdItem,myCount)
    end
    onClickCancel()
end


----------------消息收发区-----------------------------------
function recvExpCard()                              --接收经验卡消息
    local dt = LuaData:getSingleton():getDataTransStream()
    if not dt then
        return
    end
    showExpCardCrtl3100(stExpCard.initWithStream(dt))
end

function usedExpCard(idTarget,idItem,count)                --使用经验卡发送消息
    if idTarget == 0 and idItem == 0 then
        local theTitle = "*6--".._LTParser("str8124").."--"
        local theMsg = _LTParser("str8123")
        luaShowTip(theMsg,nil,nil,nil,theTitle,18)
        return
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEM)
    dataStream:writeShort(MSG_ITEMACT_EUDEMONUSE_ADDEXPCARD)
    dataStream:writeInt(idItem)
    dataStream:writeInt(idTarget)
    dataStream:writeInt(count)
    SCDataTransThread:getSingleton():transData(dataStream)
end
----------------消息注册区------------------------------------
LuaData:getSingleton():luaSetSelectorOnRecvData(recvExpCard, LuaData_ITEMACT_SEND_EUDEMONADDEXP)
----------------全局函数区-----------------------------------

