local    ACTION_MAPWOLRD_COPYGROUP_LIST = 13; --/*世界地图进入各分类副本*/
local ACTION_COPYLAYER_INFO_BY_ID = 14; --/*单个副本列表*/
local ACTION_COPYLAYER_INFO = 11;
local ACTION_COPYLAYER_INFO_END = 15; --/**单层副本列表*/
local ACTION_COPYLAYER_LIST = 10;
local ACTION_RESET_CHALLENGE_LAYER = 8;--/*重置某group闯关副本 */
local ACTION_COPY_MONSTOR_NAME = 17; --/**副本中怪物的名字*/
local ACTION_COPY_WIPE_END=22;     --/**扫荡结束时使用*/
local ACTION_COPY_WIPEGROUP_END=23;    --/**扫荡层结束时使用*/
local MSG_TEAM_OPEN_COPY_TEAM = 99;	--//打开副本主界面
local ACTION_FINISH_SCORE = 28		--//下发胜利评分奖励
local ACTION_BUY_HERO_TIMES	= 29	--//下发精英副本购买次数信息
local ACTION_BUY_HERO_TIMES_AFFIRM	= 30	--//精英副本购买次数二次确认
local ACTION_REFRESH_DEVIL_TIMES = 32  --//下发魔王副本购买次数信息
local ACTION_COPYLAYER_UPDATE_INFO = 31;	--//更新单层信息(更新或添加)
local ACTION_REFRESH_DEVIL_TIMES_AFFIRM	= 33;	--//魔王副本刷新二次确认
local ACTION_COPYWIPE_TIMES = 34; --//发送已扫荡次数
local ACTION_COPYLAYER_CLS_INFO = 35 --//清空所有副本
local ACTION_CLOSE_INSTANCE_MENU = 36 --//关闭副本界面
local ACTION_OPEN_QUESTCOPY = 37 --//任务触发打开副本界面
local ACTION_FINISH_ALL_SCORE = 38	--//所有胜利评分的奖励
local ACTION_SEND_INSTANCE_NAME = 42		--//发送副本名
local ACTION_WIPE_INSTANCE_SUPTIMES = 43	--//扫荡剩余时间(上线时发送)
local ACTION_WIPE_INSTANCE_BEGINWIPE = 44   --//开始扫荡 
local ACTION_WIPE_INSTANCE_FAIL = 45        --//副本失败

local m_allGopyList = {__mode = "kv"};
local m_GopyList = {__mode = "kv"};
local m_layerList = {__mode = "kv"};
local m_frequency = {__mode = "kv"};--//精英本可用次数和可购买次数
local m_frequencyDevil = {__mode = "kv"}--//魔王本可用次数和可购买次数
local m_frequencyNum = {__mode = "kv"}--//精英可扫荡次数
local m_bLock = nil;
local m_isFirstRemove = nil;
local m_InstanceType = nil;
local m_nGroup = nil;
local m_curIndex = nil;

local m_pImgNormalBg = nil;
local m_pImgUnalbeBg = nil;
local m_pBtnInGameCopy = nil;
local m_pBtnAutoPlay = nil; --//扫荡按钮
local m_pBtnTeam = nil;    --//组队按钮
local m_pLabel = nil;
--local m_pStar = {__mode = "kv"};
local m_GameCopyData = {__mode = "kv"};
local m_bElite = nil;
local m_bCanSendMsg = nil;
local m_TimeLastID = nil;

local m_pTableBox = nil;
local m_pNode = nil;
local m_bIsElite = nil;--/**精英*/
local m_pLabelName = nil;
local m_id = nil;
local m_pBtnUp = nil;
local m_pBtnDown = nil;
local m_curGameCopyId = nil;
local m_IsDevil = nil --//魔王标记
local m_IsOpen = nil
local m_IsPass = nil

local m_Allpage = nil
local m_Curpage = nil

local m_battleCopyName = nil;
local m_battleCopyType = nil
local m_battleAiEntryId = nil;

local stCurrencyAward = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.ucType = dt:readByte();
        tmp.dwAwardValue = dt:readInt();
        return tmp
    end
}

local struScore = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
	    --tmp.nScoreLife = dt:readInt();			--//抗击评分
        tmp.nScoreOper = dt:readInt();			--//操作评分
        tmp.nScoreCombo = dt:readInt();		    --//连击评分
        tmp.nScoreTime = dt:readInt() ;		    --//时间评分
        tmp.nScoreKill = dt:readInt() ;		    --//杀敌
            
        tmp.BonusExp = dt:readInt();			--//经验
        tmp.BonusMoney = dt:readInt();			--//银两
        tmp.BonusEmoney = dt:readInt();			--//点劵
        tmp.BonusGodExp = dt:readInt();			--//修为
        tmp.BonusProffer = dt:readInt();		--//阅历
        tmp.nBonusReputation = dt:readInt();	--//声望
        tmp.nBonusSynMoney = dt:readInt();		--//军团资金
	    tmp.nBonusSynContribute = dt:readInt();	--//军团贡献
	    tmp.nBonusBattleHonor = dt:readInt();    --//战功
        return tmp
    end
}

local stChallengeCopy = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idTemplate = dt:readInt();        --/*副本ID*/
        --local scStr = dt:readString()
        --if scStr == nil then
        --    tmp.strName = ""
        --else
        --    tmp.strName = scStr:getData()   --//副本名字
        --end
		local stuInsTemplate = TableParser:getSingleton():getInstanceTemplate(tmp.idTemplate);
		if stuInsTemplate.id ~= 0 then
			tmp.strName = stuInsTemplate.name:getData();
		else
			tmp.strName = "";
		end
        tmp.nImg = dt:readInt();            --/*图片*/
        tmp.ucGradeLev = dt:readByte();        --/*0:没有星,即没有通关 1,2,3:通关星级*/
--        tmp.ucGradeLev = 1;
        tmp.ucOpen = dt:readByte();            --/*1:开启  0:未开  2:当天已打过(未重置)   
    	tmp.usProgress = dt:readShort();	--//副本编号 
    	tmp.nBossPhoto = dt:readInt();	--//boss图片
        return tmp
    end
}

local stChallengeCopyList = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nGroup = dt:readInt();--//当前group
        tmp.ucInstanceType = dt:readByte();--//副本类型(2,主线副本 3,英雄副本)
        tmp.ucAmount = dt:readByte();
        tmp.vecChallengeCopy = {__mode = "kv"};
        for i = 1, tmp.ucAmount do
            table.insert(tmp.vecChallengeCopy, stChallengeCopy.initWithStream(dt));
        end    
        return tmp;
    end
}

local stGameCopyLayer = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nGroup = dt:readInt();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.strLayerName = ""
        else
            tmp.strLayerName = scStr:getData()   --//每层名字
        end
        return tmp
    end
}

local stGameCopyLayerList = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nGroup = dt:readInt();    --/*当前group*/
        tmp.ucInstanceType = dt:readByte();--/*副本类型(2,主线副本 3,英雄副本)*/
        tmp.ucAmount = dt:readByte();
        tmp.vecGameCopyLayer = {__mode = "kv"};
        
        for i = 1, tmp.ucAmount do
            table.insert(tmp.vecGameCopyLayer, stGameCopyLayer.initWithStream(dt));
        end    
        return tmp;
    end
}

local setCopyList

local function onMsgGameCopyList( dataStream )
    m_GopyList = {};
    m_GopyList.nGroup = dataStream:readInt();
    m_GopyList.ucInstanceType = dataStream:readByte();
    local strbuf = dataStream:readString(); 	--//剧情名称
    if strbuf then
        m_GopyList.szGroupName = strbuf:getData();
    else
        m_GopyList.szGroupName = "";
    end
    m_GopyList.ucAmount = dataStream:readByte();
    m_GopyList.vecChallengeCopy = {__mode = "kv"};
    for i = 1, m_GopyList.ucAmount do
        table.insert(m_GopyList.vecChallengeCopy, stChallengeCopy.initWithStream(dataStream));
    end
    table.insert(m_allGopyList, m_GopyList);
end

local function sortProgressAsc(a, b)
    if a.usProgress < b.usProgress then
        return true;
    end
    if a.usProgress > b.usProgress then
        return false;
    end
    return a.idTemplate < b.idTemplate;
end

--更新单层信息
local function undataGameCopyList(dataStream)
    local tmp = {};
    tmp.nGroup = dataStream:readInt();
    tmp.ucInstanceType = dataStream:readByte();
    local strbuf = dataStream:readString(); 	--//剧情名称
    if strbuf then
        tmp.szGroupName = strbuf:getData();
    else
        tmp.szGroupName = "";
    end
    tmp.ucAmount = dataStream:readByte();
    tmp.vecChallengeCopy = {__mode = "kv"};
    for i = 1, tmp.ucAmount do
        table.insert(tmp.vecChallengeCopy, stChallengeCopy.initWithStream(dataStream));
    end
    local mark = nil;
    --tmp.vecChallengeCopy[1].ucGradeLev = 1
    for i = 1, #m_allGopyList do
        if m_allGopyList[i].nGroup == tmp.nGroup then
            for j = 1, #m_allGopyList[i].vecChallengeCopy do
                if m_allGopyList[i].vecChallengeCopy[j].idTemplate == tmp.vecChallengeCopy[1].idTemplate then
                    m_allGopyList[i].vecChallengeCopy[j] = tmp.vecChallengeCopy[1];
                    m_GopyList = m_allGopyList[i].vecChallengeCopy;
                    mark = 0;
                    break;
                end                
            end
            if mark == 0 then
                mark = 1;
                break;
            end
        end
    end
    if mark ~= 1 then
        table.insert(m_allGopyList, tmp);
    end
    if isWindControllerExistence(2023) then
        local pCtrl = getCurentSceneWindowController(2023);
        if pCtrl then
            local nGroup = m_nGroup;
            m_GopyList = {__mode = "kv"};
            m_GopyList.vecChallengeCopy = {__mode = "kv"};
            for i = 1, #m_allGopyList do
                if (m_allGopyList[i].nGroup == nGroup and m_InstanceType == m_allGopyList[i].ucInstanceType) or
                (m_InstanceType > 1 and m_InstanceType == m_allGopyList[i].ucInstanceType) then
                    m_GopyList.nGroup = m_allGopyList[i].nGroup;
                    m_GopyList.ucInstanceType = m_allGopyList[i].ucInstanceType;
                    m_GopyList.szGroupName = m_allGopyList[i].szGroupName;
                    m_GopyList.ucAmount = m_allGopyList[i].ucAmount;
                    for j = 1, m_allGopyList[i].ucAmount do
                        table.insert(m_GopyList.vecChallengeCopy, m_allGopyList[i].vecChallengeCopy[j]);
                    end
                end
            end
            if m_InstanceType > 1 then
                table.sort(m_GopyList.vecChallengeCopy, sortProgressAsc);
            end
            setCopyList(m_GopyList);
        end
    end
end

--进入副本
local function sendInGameCopy(id)
    if id == nil then
    	return
    end
    
    if CLIENT_VERSION > 328 then
        NewBattleMessage:getSingleton():setCurMapID(id);
		--NewBattleMessage:getSingleton():checkIsSmallMemory(60);
    end
    
    local ACTION_ENTER_CHALLENGE = 12;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
    dataStream:writeShort(ACTION_ENTER_CHALLENGE);
    dataStream:writeByte(0);
    dataStream:writeInt(id);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function onTimeLastClick(float)
    m_bCanSendMsg = true;
    if nil ~= m_TimeLastID then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_TimeLastID);
    end -- /*先销毁*/
end

function GameCopyController_onClickInGameCopy(tag)
	GameCopyController_InGameCopyWithInstanceId(m_GameCopyData[tag].idTemplate)
end

function GameCopyController_InGameCopyWithInstanceId(copyId)
    if false == m_bCanSendMsg then
        return ;
    end
    m_bCanSendMsg = false;
    if nil ~= m_TimeLastID then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_TimeLastID);
    end
    if m_InstanceType then
        Hero:getSingleton():setNowMapType(m_InstanceType);
    end
    m_TimeLastID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(onTimeLastClick, 3.0, false);
    sendInGameCopy(copyId);

    local pWndCtrl = getCurentSceneWindowController(1000);
    if pWndCtrl then
        if wnd:getParent() then
            removeFromParentAndCleanup(true);
        end
    end

    local pScene = getRunningScene();
    if pScene then
        if pScene:getUINode():getChildByTag(5917) then
            pScene:getUINode():removeChildByTag(5917, true);
        end
    end
    showGuideStep(GUIDE_TYPE_OVER_MAINQUEST, -1);
	SCActivityIndicator:getSingleton():show();
end

local function onClickSweepTwice(tag)
    if tag == 1 then
        local naviCtrl = getCurentSceneNavigationController()
        if not naviCtrl then
            return
        end
        naviCtrl:removeWindowControllerByTag(5905)
        
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
	    dataStream:writeShort(ACTION_COPY_WIPE_END);
	    SCDataTransThread:getSingleton():transData(dataStream);
    end
end

local function onClickAutoPlay(tag)
    if m_GopyList.ucInstanceType == 2 and m_frequency.usLeaveUseTimes == 0 then
        showMessage(L("str0514"))
        return;
    end
    local idTemplate = Hero:getSingleton():getSweepTeamplateID();
    if idTemplate>0 then
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE)
        dataStream:writeShort(ACTION_COPY_MONSTOR_NAME)
        dataStream:writeInt(idTemplate)
        SCDataTransThread:getSingleton():transData(dataStream)
        SCActivityIndicator:getSingleton():show()
    elseif CopymapSweep_getIsSweeping() == true then
        if m_GameCopyData[tag] ~= nil then
            local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE)
            dataStream:writeShort(ACTION_COPY_MONSTOR_NAME)
            dataStream:writeInt(m_GameCopyData[tag].idTemplate)
            SCDataTransThread:getSingleton():transData(dataStream)
            SCActivityIndicator:getSingleton():show()
       end
    else
        CopymapSweep.OpenCopymaoSweep(m_GameCopyData[tag].idTemplate,1,m_GopyList.ucInstanceType,true);
        local pScene = getRunningScene();
        if pScene then
            if pScene:getUINode():getChildByTag(5917) then
                pScene:getUINode():removeChildByTag(5917, true);
            end
        end
        getCurentSceneNavigationController():removeWindowControllerByTag(2023);
    end
end

local function setBtnVisible( bTrue)
    if nil == m_pBtnInGameCopy or nil == m_pImgNormalBg or nil == m_pImgNormalBg then
        return ;
    end
    if 0 == m_IsOpen  then
        m_pBtnAutoPlay:setVisible(false)
        m_pBtnTeam:setVisible(false)
        
         local dis = 12;

    --if bTrue then
        setNodeContentSize(this, CCSizeMake(getNodeContentSize(m_pBtnInGameCopy).width, getNodeContentSize(m_pBtnInGameCopy).height + getNodeContentSize(m_pBtnAutoPlay).height + dis));
        m_pBtnAutoPlay:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pBtnAutoPlay, CCPointMake(getNodePostion(m_pBtnAutoPlay).x, 13));
    

        m_pBtnInGameCopy:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pBtnInGameCopy, CCPointMake(0, getNodeContentSize(m_pBtnAutoPlay).height + dis));

        m_pImgNormalBg:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pImgNormalBg, CCPointMake(0, getNodeContentSize(m_pBtnAutoPlay).height + dis));
        return
    end
    
    if m_pBtnAutoPlay then
        if 0 == m_IsPass or not luaIsUnlock(UNLOCK_TYPE_WIPEOUT_COPY) then
            bTrue = false
        end
        m_pBtnAutoPlay:setVisible(bTrue);
        if bTrue == false then            
            setNodePostion(m_pBtnTeam, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2 - getNodeContentSize(m_pBtnTeam).width / 2, 13));
        else            
            setNodePostion(m_pBtnTeam, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2 + getNodeContentSize(m_pBtnTeam).width - 55, 13));
        end
        if not luaIsUnlock(UNLOCK_TYPE_TEAM) then
            m_pBtnTeam:setVisible(false)
            setNodePostion(m_pBtnAutoPlay, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2 - getNodeContentSize(m_pBtnTeam).width / 2, 13))
        end
    end
    
    local dis = 12;

    --if bTrue then
        setNodeContentSize(this, CCSizeMake(getNodeContentSize(m_pBtnInGameCopy).width, getNodeContentSize(m_pBtnInGameCopy).height + getNodeContentSize(m_pBtnAutoPlay).height + dis));
        m_pBtnAutoPlay:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pBtnAutoPlay, CCPointMake(getNodePostion(m_pBtnAutoPlay).x, 13));
    

        m_pBtnInGameCopy:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pBtnInGameCopy, CCPointMake(0, getNodeContentSize(m_pBtnAutoPlay).height + dis));

        m_pImgNormalBg:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pImgNormalBg, CCPointMake(0, getNodeContentSize(m_pBtnAutoPlay).height + dis));

        --[[for i = 1, 3 do
            if m_pStar[i] then
                setNodePostion(m_pStar[i], CCPointMake(getNodePostion(m_pStar[i]).x, getNodeContentSize(m_pBtnAutoPlay).height + dis));
            end
        end]]
    --[[else
        setNodeContentSize(this, CCSizeMake(getNodeContentSize(m_pBtnInGameCopy).width, getNodeContentSize(m_pBtnInGameCopy).height ));
        m_pBtnAutoPlay:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pBtnAutoPlay, CCPointMake(getNodePostion(m_pBtnAutoPlay).x, 0));
        m_pBtnInGameCopy:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pBtnInGameCopy, CCPointMake(0, 0));
        m_pImgNormalBg:setAnchorPoint(CCPointMake(0, 0));
        setNodePostion(m_pImgNormalBg, CCPointMake(0, 0));
        for i = 1, 3 do
            if m_pStar[i] then
                setNodePostion(m_pStar[i], CCPointMake(getNodePostion(m_pStar[i]).x, 0));
            end
        end
    end   ]] 
end

local function GameCopyCellNodeExitEvent(event)
    if event == kCCNodeOnEnter then
        if isGuideCanStart(GUIDE_TYPE_AUTOINST) then
    		showGuideStep(GUIDE_TYPE_AUTOINST, 2, 2);
        end
	elseif tag == kCCNodeOnExit then
	    if isGuideCanStart(GUIDE_TYPE_AUTOINST) then
    		restartGuideStep(GUIDE_TYPE_AUTOINST);
    	end
	end
end

local function onClickTeam(tag)    --//组队按钮回调


    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TEAM);
    dataStream:writeShort(MSG_TEAM_OPEN_COPY_TEAM);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
    BattleTeam.setcurGameCopyID(m_GameCopyData[tag].idTemplate);    
    BattleTeam3.m_gameCopyIndex = tag;

end

local function onClickDevilRefresh(tag)  --//刷新按钮回调
     
    if 0 == m_frequencyDevil.usLeaveUseTimes then
        
    end
    if m_frequencyDevil.usLeaveBuyTimes  == m_frequencyDevil.usLeaveUseTimes then
        
    end
    
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
    dataStream:writeShort(ACTION_REFRESH_DEVIL_TIMES_AFFIRM);
    dataStream:writeByte(0);
    dataStream:writeInt(tag)
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function getGameCopyCellNode(tag)
    local wnd = FrameWindow:frameWnd();
    if nil == wnd then
        return nil;
    end
    wnd:setTag(tag);
    wnd:setTouchEnabled(true);
    wnd:setFrameVisibled(false);
    wnd:setCloseBtnVisible(false);
    wnd:registerScriptHandler(GameCopyCellNodeExitEvent);
    local file = getRealUIResourcePath("instance/ins00013.png");
    if nil == file then
        return nil;
    end
    m_pBtnInGameCopy = SCButton:button();
    if nil == m_pBtnInGameCopy then
        return nil;
    end
    m_pBtnInGameCopy:setTitle(file:getData());
    m_pBtnInGameCopy:luaSetSelectorOnClicked(GameCopyController_onClickInGameCopy);
    m_pBtnInGameCopy:setTag(tag);
    wnd:addChild(m_pBtnInGameCopy);
    if m_GopyList.vecChallengeCopy[tag].idTemplate == m_curGameCopyId then
	    --当前任务箭头
	    local ActionNode = ActionNode:newActionNode();
	    local pImgPath = getRealUIResourcePath("img/new00638.png");
        if ActionNode and pImgPath then
            local pImg = SCImage:imageWithFile(pImgPath:getData());
            local pLabel = SCLabel:labelWithStringFont(L("str6203"), getDefaultFontName(), getFontSize(12));
            if pImg and pLabel then
                pLabel:setColor(color_red);
                pImg:addChild(pLabel);
                pLabel:setAnchorPoint(CCPointMake(0.5, 0));
                pLabel:setPosition(CCPointMake(pImg:getContentSize().width / 2, SY(28)));
                ActionNode:setContentSize(pImg:getContentSize());
                ActionNode:setAnchorPoint(CCPointMake(0.5, 0));
                local size = m_pBtnInGameCopy:getContentSize();
                ActionNode:setPosition(CCPointMake(size.width / 2, size.height  - SY(12)));
                ActionNode:moveToRetuen(CCPointMake(size.width / 2, size.height  - SY(12)), CCPointMake(size.width / 2, size.height  - SY(7)), 0.2);
                ActionNode:addChild(tolua.cast(pImg, "SCNode"))
                --ActionNode:setBackgroundColor(color_red);
                m_pBtnInGameCopy:addChild(tolua.cast(ActionNode, "SCNode"), 100)
            end
        end
        m_curIndex = tag;
        m_curGameCopyId = nil;
    end
    m_pBtnAutoPlay = SCButton:button(EnumBtnType9Atlas);
    if nil == m_pBtnAutoPlay then   
        return nil;
    end
    --扫荡按钮
    setNodeContentSize(m_pBtnAutoPlay, CCSizeMake(54, 30));
     m_pBtnAutoPlay:setTitle(_LTParser("str8150"), getDefaultFontName(), getFontSize(15));
    m_pBtnAutoPlay:setAnchorPoint(CCPointMake(0, 1));
    setNodePostion(m_pBtnAutoPlay, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2 - getNodeContentSize(m_pBtnAutoPlay).width - 2, 0));
    m_pBtnAutoPlay:luaSetSelectorOnClicked(onClickAutoPlay);
    m_pBtnAutoPlay:setTag(tag);
    wnd:addChild(m_pBtnAutoPlay);
    
    m_pBtnTeam = SCButton:button(EnumBtnType9Atlas);
    if nil == m_pBtnTeam then   
        return nil;
    end
    ---组队按钮
    setNodeContentSize(m_pBtnTeam, CCSizeMake(54, 30));
    m_pBtnTeam:setTag(tag);
    m_pBtnTeam:setTitle(_LTParser("str0060"), getDefaultFontName(), getFontSize(15));
    setNodePostion(m_pBtnTeam, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2 + getNodeContentSize(m_pBtnTeam).width - 55, 13));
    m_pBtnTeam:luaSetSelectorOnClicked(onClickTeam);
    wnd:addChild(m_pBtnTeam);

    m_pImgNormalBg = SCImage:imageWithFile(file:getData());
    if m_pImgNormalBg then
        m_pImgNormalBg:setVisible(false);
        setNodeContentSize(wnd, getNodeContentSize(m_pImgNormalBg));
        m_pBtnInGameCopy:addChild(m_pImgNormalBg);
    end
    
    m_pLabel = SCLabel:labelWithStringFont(" ", getDefaultFontName(), getFontSize(12));
    if m_pLabel then
        m_pLabel:setAnchorPoint(CCPointMake(0.5, 0));
        setNodePostion(m_pLabel, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2, 5));
        m_pBtnInGameCopy:addChild(m_pLabel);
    end

    setBtnVisible(true);
    wnd:setAnchorPoint(CCPointMake(0.5, 0.5));
    wnd:setPosition(CCPointMake(getScreenWidth() / 2, getScreenHeight() / 2));
    return wnd;
end

local setMapData;

local function onMsgSingleCopyCell( dataStream )
    local data = stChallengeCopyList.initWithStream(dataStream);
    local pCell = getGameCopyCellNode(1);
    if #data.vecChallengeCopy > 0 then
        if data.vecChallengeCopy[1].ucGradeLev == 0 then
            setBtnVisible(false);
        else
            local scene = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
            if scene then
                if scene:isUnlock(UNLOCK_TYPE_WIPEOUT_COPY) and  0 == data.vecChallengeCopy[1].ucOpen then
                    setBtnVisible(true);
                end
            end
        end
        m_GameCopyData = {};
        setMapData(data.vecChallengeCopy[1]);
        m_isFirstRemove = false;
    end
    pCell:setTouchEnabled(true);
    pCell:setTag(5917);

    
    local pScene = getRunningScene();
    if pScene then
        pScene:getUINode():addChild(pCell);
    end
end

local function onPopBegan()
	if isGuideCanStart(GUIDE_TYPE_INST) and m_InstanceType==2 then
		if getGuideRestartFlag(GUIDE_TYPE_INST) then
			setGuideRestartFlag(GUIDE_TYPE_INST, true);
			showGuideStep(GUIDE_TYPE_INST, 4, 3);
		else
			setGuideRestartFlag(GUIDE_TYPE_INST, false);
			showGuideStep(GUIDE_TYPE_INST, 8, 7);
		end
	elseif isGuideCanStart(GUIDE_TYPE_HERO_COPY) and m_InstanceType==3 then
		if getGuideRestartFlag(GUIDE_TYPE_HERO_COPY) then
			restartGuideStep(GUIDE_TYPE_HERO_COPY);
		else
			showGuideStep(GUIDE_TYPE_HERO_COPY, -1);
		end
	end
end

local function GameCopyControllerWndClose()
    onPopBegan();
    m_GopyList = {__mode = "kv"};
    m_layerList = {__mode = "kv"};
    m_bLock = nil;
    m_isFirstRemove = nil;
    m_InstanceType = nil;
    m_nGroup = nil;

    m_pImgNormalBg = nil;
    m_pImgUnalbeBg = nil;
    m_pBtnInGameCopy = nil;
    m_pBtnAutoPlay = nil;
    m_pBtnTeam = nil;
    m_pLabel = nil;
    --m_pStar = {__mode = "kv"};
    --m_GameCopyData = {__mode = "kv"};
    m_bElite = nil;
    m_bCanSendMsg = nil;
    m_TimeLastID = nil;

    m_pTableBox = nil;
    m_pNode = nil;
    m_bIsElite = nil;--/**精英*/
    m_pLabelName = nil;
    m_id = nil;
    m_pBtnUp = nil;
    m_pBtnDown = nil;
    m_Allpage = nil
    m_Curpage = nil
end

local function getCopyLayerUpID(id)
    for i = 1,  #m_layerList.vecGameCopyLayer - 1 do
        if id == m_layerList.vecGameCopyLayer[i + 1].nGroup then
            return m_layerList.vecGameCopyLayer[i].nGroup;
        end
    end
    return 0;
end

local function getCopyLayerDownID(id)
    for i = 1, #m_layerList.vecGameCopyLayer - 1 do
        if id == m_layerList.vecGameCopyLayer[i].nGroup then
            return m_layerList.vecGameCopyLayer[i + 1].nGroup;
        end
    end
    return 0;
end

function sendQueryCopyList(type, id)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
    dataStream:writeShort(ACTION_COPYLAYER_INFO);
    dataStream:writeByte(type);
    dataStream:writeInt(id);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

function setIsFirstRemoveTrue()
    m_isFirstRemove = true;
end

local function setIsFirstRemove(flag)
    m_isFirstRemove = flag;
end

local function onClickUp(tag)
    local type = 2;
    local id = 0;
    if m_bIsElite then
        id = getCopyLayerUpID(tag);
        type = 3;
    else
        type = 2;
        id = getCopyUpID(tag);
    end
    if id == 0 then
        return;
    end
    sendQueryCopyList(type, id);
    setIsFirstRemove(true);
end

local function onClickDown(tag)
    local type = 2;
    local id = 0;
    if m_bIsElite then
        id = getCopyLayerDownID(tag);
        type = 3;
    else
        type = 2;
        id = getCopyDownID(tag);    
    end
    if id == 0 then
        return ;
    end
    sendQueryCopyList(type, id);
    setIsFirstRemove(true);
end

local function onClickBuyPower(tag)
	local USERINFO_BUY_TIREDNESS	= 43;--//买体力
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
    dataStream:writeShort(USERINFO_BUY_TIREDNESS);
    dataStream:writeByte(0);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
    end
end

local function onClickReward(tag)
    local ACTION_COPY_GROUP_AWARD = 16; --/*查看过关奖励*/
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
    dataStream:writeShort(ACTION_COPY_GROUP_AWARD);
    dataStream:writeByte(3);
    dataStream:writeInt(m_id);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function onClickAutoPaly(tag)
    RaidsCopyProcessor:getSingleton():sendOpenRaid(3, m_id);
end

local function sendResetCopy(id)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
    dataStream:writeShort(ACTION_RESET_CHALLENGE_LAYER);
    dataStream:writeByte(0);
    dataStream:writeInt(3);
    dataStream:writeInt(id);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end

local function onClickRefresh(tag)
    sendResetCopy(m_id);
end

local function refreshPower()   
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2023-1-3"));
    if pLabel then
        local str = _LTParser("str0107");
        str = str .. Hero:getSingleton():getTiredness();
        pLabel:setText(str);
    end
end

local function onClickUpPage(tag)
    local index = m_pTableBox:getPageIndex();
    if index < 1 or getIntPart(m_Curpage) == 1 then
        return;
    end
    if getIntPart(m_Curpage) > 1 then
        m_Curpage = m_Curpage - 1
    end
    GameCopy_setCopyListMore();
    m_pTableBox:setOffset(CCPointMake((index - 1) * m_pTableBox:getWidth(), 0));
end

local function onClickDownPage(tag)
    local index = m_pTableBox:getPageIndex();
    local count = m_pTableBox:getPageCount();
    if index > count - 2 or getIntPart(m_Curpage) == getIntPart(m_Allpage) then
        return;
    end
    if getIntPart(m_Curpage) < getIntPart(m_Allpage) then
        m_Curpage = m_Curpage + 1
    end
    GameCopy_setCopyListMore();
    m_pTableBox:setOffset(CCPointMake((index + 1) * m_pTableBox:getWidth(), 0));
end

local function onSrcDownPage()
    if getIntPart(m_Curpage) == getIntPart(m_Allpage) then
        return;
    end
    if getIntPart(m_Curpage) < getIntPart(m_Allpage) then
        m_Curpage = m_Curpage + 1
    end
    GameCopy_setCopyListMore();
end

local function onSrcUpPage()
    if m_Curpage == 1 then
        return;
    end
    if m_Curpage > 1 then
        m_Curpage = m_Curpage - 1
    end
    GameCopy_setCopyListMore();
end

--购买次数
local function onClickBuy(tag)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_INSTANCE);
    dataStream:writeShort(ACTION_BUY_HERO_TIMES_AFFIRM);
    dataStream:writeByte(0);
    if SCDataTransThread:getSingleton() then
        SCDataTransThread:getSingleton():transData(dataStream);
        SCActivityIndicator:getSingleton():show();
    end
end
--创建副本入口界面
local function createGameCopyControllerWnd(isElite)
    local pWnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2023));
    if pWnd == nil then
        return nil 
    end
    pWnd:setBackgroundColor(colorWindowRedBG());
    pWnd:luaSetSelectorOnClose(GameCopyControllerWndClose);
    m_pBtnUp = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("5", tolua.cast(pWnd, "SCNode")));
    if m_pBtnUp then
        m_pBtnUp:luaSetSelectorOnClicked(onClickUp);
    end
    m_pBtnDown = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("6", tolua.cast(pWnd, "SCNode")));
    if m_pBtnDown then
        m_pBtnDown:luaSetSelectorOnClicked(onClickDown);
    end

    local flieTitle = nil;
    m_bIsElite = isElite;

    if 1 == m_GopyList.ucInstanceType then
        m_pNode = SCFunction:getUiByZipAndId(2023, 2602);
        flieTitle = getRealUIResourcePath("instance/ins00014.png");
    elseif 2 == m_GopyList.ucInstanceType then 
        m_pNode = SCFunction:getUiByZipAndId(2023, 2601);
        local pLabel = SCLabel:labelWithStringFont(m_frequency.usLeaveUseTimes, getDefaultFontName(), getFontSize(12));
        if pLabel then
            pLabel:setPosition(CCPointMake(SX(120), SY(20)));
            pLabel:setColor(color_red);
            pLabel:setTag(3);
            pWnd:addChild(pLabel);
        end
        local pNode = m_pNode:getChildByTag(10752);
        if pNode then
            pNode:setVisible(false);
        end
        flieTitle = getRealUIResourcePath("instance/ins00015.png");
    elseif 3 == m_GopyList.ucInstanceType then
        m_pNode = SCFunction:getUiByZipAndId(2023, 2602);
        local now = 0
        local all = 0
        if m_frequencyDevil and m_frequencyDevil.usLeaveBuyTimes and m_frequencyDevil.usLeaveUseTimes then
            now = m_frequencyDevil.usLeaveBuyTimes
            all = m_frequencyDevil.usLeaveUseTimes
        end
        local pLabel = SCLabel:labelWithStringFont(_LTParser("str3026")..now.."/"..all, getDefaultFontName(), getFontSize(12));
        if pLabel then
            pLabel:setPosition(CCPointMake(SX(40), SY(20)));
            pLabel:setColor(color_red);
            pLabel:setTag(3);
            pWnd:addChild(pLabel);
        end
        flieTitle = getRealUIResourcePath("instance/ins00016.png");
    end
    if flieTitle then
        pWnd:setTitleWithImage(flieTitle:getData());
    end
    --[[local file = getRealUIResourcePath("img/img5021.png");
    local pImgT = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-2", tolua.cast(pWnd, "SCNode")));
    local pNodeT = pWnd:getChildByTag(1);
    if file and pImgT and pNodeT then
        local btn = SCButton:button()
        if btn then
            btn:setTitle(file:getData(), setRealRect(CCRectMake(0, 0, 16, 16)));
            btn:luaSetSelectorOnClicked(onClickBuyPower);
            btn:setTouchRectScale(2, 3);
            setNodePostion(btn, getNodePostion(pImgT));
            pImgT:setVisible(false);
            pNodeT:addChild(btn);
        end
    end]]
    
    
    if nil == m_pNode then
		if 3 == m_InstanceType then
			showMessage(L("str3320"))
		end
        return false;
    end
    local pNode = SCTypeCast:castNodeToDragNode(m_pNode:getChildByTag(13));
    if pNode then
        pNode:setFrameType(EnumFrameTypeLine);
        pNode:setFrameVisibled(true);
    end
    setNodePostion(m_pNode, CCPointMake(6, 6));
    pWnd:addChild(m_pNode);

    m_pTableBox = SCTypeCast:castNodeToTableBox(m_pNode:getChildByTag(1));
    if nil == m_pTableBox then
        return false;
    end
    m_pTableBox:luaSetSelectorOnScrollToPrevious(onSrcUpPage)
    m_pTableBox:luaSetSelectorOnScrollToNext(onSrcDownPage)
    local pBtn = SCTypeCast:castNodeToButton(m_pNode:getChildByTag(10));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onClickReward);
    end
        
    pBtn = SCTypeCast:castNodeToButton(m_pNode:getChildByTag(11));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onClickAutoPaly);
    end
    
    pBtn = SCTypeCast:castNodeToButton(m_pNode:getChildByTag(12));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onClickDevilRefresh);
        local pMapLayer = getMapLayer();
        if pMapLayer then                     
            if pMapLayer:isUnlock(UNLOCK_TYPE_DEVIL_COPY_REFRESH) then
                m_bLock = false;
            end
        end
        if m_bLock == true then
            pBtn:setVisible(false);
        end
        --[[local emoney = Hero:getSingleton():getEmoney()
        if emoney < 10 then
            pBtn:setButtonType(EnumBtnTypeAsh)
        end--]]
    end
    

    local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("1", tolua.cast(pWnd, "SCNode")));
    if pDragNode then
        pDragNode:setFrameType(EnumFrameTypeListNormal);
        pDragNode:setFrameVisibled(true);
    end
    pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("4", tolua.cast(pWnd, "SCNode")));
    if pDragNode then
        pDragNode:setFrameType(EnumFrameTypeListNormal);
        pDragNode:setFrameVisibled(true);
    end




    m_pLabelName = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("4-7", tolua.cast(pWnd, "SCNode")));
    
    local pBtn = SCButton:button(EnumBtnType9Atlas)
    local file = getRealUIResourcePath("instance/ins00007.png");
    if pBtn and file then
        pBtn:setTag(100);
        pBtn:setContentSize(CCSizeMake(AUTO_W(80), AUTO_H(28)));
        pBtn:setAnchorPoint(CCPointMake(1, 0));
        pBtn:setPosition(CCPointMake(SX(460), SY(10)));
        pBtn:luaSetSelectorOnClicked(onClickDownPage);
        pBtn:setTitle(file:getData());
        pWnd:addChild(pBtn);
    end 
    file = getRealUIResourcePath("instance/ins00005.png");
    pBtn = SCButton:button(EnumBtnType9Atlas)
    if pBtn then
        pBtn:setTag(200);
        pBtn:setContentSize(CCSizeMake(AUTO_W(80), AUTO_H(28)));
        pBtn:setAnchorPoint(CCPointMake(1, 0));
        pBtn:setPosition(CCPointMake(SX(360), SY(10)));
        pBtn:luaSetSelectorOnClicked(onClickUpPage);
        pBtn:setTitle(file:getData());
        pWnd:addChild(pBtn);
    end    
    if 2 == m_GopyList.ucInstanceType  then
        file = getRealUIResourcePath("instance/ins00004.png");
        pBtn = SCButton:button(EnumBtnType9Atlas)
        if pBtn then
            pBtn:setContentSize(CCSizeMake(SX(120), SY(28)));
            pBtn:setAnchorPoint(CCPointMake(0, 0));
            pBtn:setPosition(CCPointMake(SX(140), SY(10)));
            pBtn:luaSetSelectorOnClicked(onClickBuy);
            pBtn:setTitle(file:getData());
            pWnd:addChild(pBtn);
            pBtn:setTag(4);
            local pLabel = SCLabel:labelWithStringFont("(" .. m_frequency.usLeaveBuyTimes .. ")", getDefaultFontName(), getFontSize(12));
            if pLabel then
                pLabel:setAnchorPoint(CCPointMake(1, 0.5));
                pLabel:setPosition(pBtn:getContentSize().width - SX(8), pBtn:getContentSize().height / 2);
                pLabel:setTag(1);
                pBtn:addChild(pLabel);
            end
            if m_frequency.usLeaveBuyTimes == 0 then
                pBtn:setButtonType(EnumBtnTypeAsh)
            end
        end
    end    
    local wndCtrl = SCWindowController:controllerWithWindow(pWnd);
    return wndCtrl;
end

local function setFrequency(tag)  
    if 3 == tag then
        local now = 0
        local all = 0
        if m_frequencyDevil and m_frequencyDevil.usLeaveBuyTimes and m_frequencyDevil.usLeaveUseTimes then
            now = m_frequencyDevil.usLeaveBuyTimes
            all = m_frequencyDevil.usLeaveUseTimes
        end
        local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2023-3"));
        if pLabel then
            pLabel:setText(_LTParser("str3026")..now.."/"..all);
        end  
        return
    end  
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2023-3"));
    if pLabel then
        pLabel:setText(m_frequency.usLeaveUseTimes);
    end  
    pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2023-4-1"));
    if pLabel then
        pLabel:setText("(" .. m_frequency.usLeaveBuyTimes .. ")");
    end
    
    if m_frequency.usLeaveBuyTimes == 0 then
        local button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2023-4"));
        if button then
            button:setButtonType(EnumBtnTypeAsh)
        end
    end
end

local function getCopyLayerName(group)
    for i = 1, #m_layerList.vecGameCopyLayer do
        if group == m_layerList.vecGameCopyLayer[i].nGroup then
            return m_layerList.vecGameCopyLayer[i].strLayerName;
        end
    end
    return nil;
end

local function setMainTaskType(pNode)
    setBtnVisible( true );
    if m_pBtnAutoPlay then
        m_pBtnAutoPlay:setVisible(false);
        setNodePostion(m_pBtnTeam, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2 - getNodeContentSize(m_pBtnTeam).width / 2, 10));
    end
end

function setMapData( data, mark )
    if m_pBtnInGameCopy and mark == nil then
        local tag = m_pBtnInGameCopy:getTag();
        m_GameCopyData[tag] = data;
    else
        table.insert(m_GameCopyData, data);
        return;
    end
    --m_GameCopyData = data;
    
    --/**没开启*/
    if data.ucOpen == 0 then
        local file = getRealUIResourcePath("instance/ins00248.pn");
        if file and m_pBtnInGameCopy then
            m_pBtnInGameCopy:setTitle(file:getData());
        end

        return ;
    end

    --/**星星*/
    --[[for i = 1, 3 do
        m_pStar[i]:setVisible(true);
    end
    for i = 1, data.ucGradeLev do
        local file = getRealUIResourcePath("img/img1004.png"); --//暗星星 img1003.png //Boss img1006.png
        if file then
            m_pStar[i]:setVisible(true);
            if m_pStar[i] then        
                m_pStar[i]:setImage(file:getData());
            end
        end
    end]]

    if m_pLabel then
        m_pLabel:setText(data.strName);
    end

    --/**怪物或者数字图片*/
    if data.nImg then
        local srtPath = "instance/" .. data.nImg .. ".png";
        local file = getRealUIResourcePath(srtPath);
        local BtnFile = getRealUIResourcePath("instance/ins00013.png");
        if file and m_pImgNormalBg and m_pBtnAutoPlay and BtnFile and m_pBtnInGameCopy then
            m_pBtnInGameCopy:setTitle(BtnFile:getData());
            m_pImgNormalBg:setImage(file:getData());
            if data.nBossPhoto then
                local imgFile = getRealUIResourcePath("PlotPhoto/" .. data.nBossPhoto .. ".png");
                if imgFile then
                    local pImg = SCImage:imageWithFile(imgFile:getData());
                    if pImg then
                        local size = m_pImgNormalBg:getContentSize();
                        pImg:setAnchorPoint(CCPointMake(0.5, 1));
                        pImg:setPosition(CCPointMake(size.width / 2, size.height));
                        pImg:setScale(0.7);
                        local imgSize = pImg:getContentSize();
                        pImg:setImage(imgFile:getData(), CCRectMake(0, 0, imgSize.width, imgSize.height * 0.6));
                        m_pImgNormalBg:addChild(pImg);
                    end
                end
            end
            m_pImgNormalBg:setAnchorPoint(CCPointMake(0.5, 0.5));
            setNodePostion(m_pImgNormalBg, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2, getNodeContentSize(m_pBtnInGameCopy).height / 2));
            m_pImgNormalBg:setVisible(true); 
            if 3 == m_GopyList.ucInstanceType and 2 == data.ucOpen then
                local pNode = SCDragNode:node()
                if pNode then
                    pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pNode:setPosition(AUTO_POS(4.00, 17.00))
                    pNode:setContentSize(AUTO_SIZE(100,52))
                    pNode:setFrameVisibled(true)
                    pNode:setDragEnabled(false)
                    pNode:setBackgroundColor(ccc4(0, 0, 0, 120))
                    m_pImgNormalBg:addChild(pNode)
                end
            end 
        end
    else
        local length = 52;
        local file = getRealUIResourcePath("img/img2036.png");
        if  m_pImgNormalBg and m_pBtnAutoPlay and m_pBtnTeam then
            local tag = data.idTemplate
            m_pImgNormalBg:setImage(file:getData(), setRealRect(CCRectMake((data.usNo - 1) * length, 0,length , 32)));
            m_pBtnTeam:setTitle(_LTParser("str0168"), getDefaultFontName(), getFontSize(15))
            m_pBtnTeam:luaSetSelectorOnClicked(onClickDevilRefresh)
            --[[local emoney = Hero:getSingleton():getEmoney()
            if emoney < 10 then
                m_pBtnTeam:setButtonType(EnumBtnTypeAsh)
            end--]]
            m_pBtnTeam:setTag(tag)
            m_pImgNormalBg:setAnchorPoint(CCPointMake(0.5, 0.5));
            setNodePostion(m_pImgNormalBg, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2, getNodeContentSize(m_pBtnInGameCopy).height / 2 + 15));
            m_pImgNormalBg:setVisible(true);
                local pNode = SCDragNode:node()
                if pNode then
                    pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pNode:setPosition(AUTO_POS(4.00, 17.00))
                    pNode:setContentSize(AUTO_SIZE(100,52))
                    pNode:setFrameVisibled(true)
                    pNode:setDragEnabled(false)
                    pNode:setBackgroundColor(ccc4(0, 0, 0, 120))
                    m_pImgNormalBg:addChild(pNode)
                end
        end
    end

    --/**是否打过*/
    local heroCopyStausOpenAndPass = 2;
    if data.ucOpen == heroCopyStausOpenAndPass then
        --local file = getRealUIResourcePath("img/img2097.png");
        --if file and m_pBtnInGameCopy then
        if m_pBtnInGameCopy and m_pImgNormalBg and m_pBtnTeam then
            --[[
            local img = SCImage:imageWithFile(file:getData());
            if img then            
                img:setAnchorPoint(CCPointMake(0.5, 0.5));
                setNodePostion(img, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width / 2, getNodeContentSize(m_pBtnInGameCopy).height / 2));
                m_pBtnInGameCopy:addChild(img);
            end
            m_pBtnInGameCopy:setTouchEnabled(false);
            ]]--
            local tag = data.idTemplate
            m_pBtnTeam:setTitle(_LTParser("str0168"), getDefaultFontName(), getFontSize(15))
            m_pBtnTeam:luaSetSelectorOnClicked(onClickDevilRefresh)
            --[[local emoney = Hero:getSingleton():getEmoney()
            if emoney < 10 then
                m_pBtnTeam:setButtonType(EnumBtnTypeAsh)
            end--]]
            m_pBtnTeam:setTag(tag)
            local pNode = SCDragNode:node()
                if pNode then
                    pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pNode:setPosition(AUTO_POS(4.00, 17.00))
                    pNode:setContentSize(AUTO_SIZE(100,52))
                    pNode:setFrameVisibled(true)
                    pNode:setDragEnabled(false)
                    pNode:setBackgroundColor(ccc4(0, 0, 0, 120))
                    m_pImgNormalBg:addChild(pNode)
                end
        end
    end
end

local function setNewOpenAnimation( bShow )
    if bShow then
        if nil == m_pBtnInGameCopy:getChildByTag(5001) then
            local id = 1101 * 10000 + 1139;
            local fps = LookfaceParser:getSingleton():getEffectFPS(id);
            local pAni = LookfaceParser:getSingleton():getAnimationWithFPS(1101, 1139, fps);
            if pAni then
                --pAni:setFPS(fps);
                local pAniNode = SCAnimationNode:nodeWithAnimation(pAni);
                if true == LookfaceParser:getSingleton():isNeedScale(id) then
                    pAniNode:setScaleX(LookfaceParser:getSingleton():getEffectScaleValue(id).x);
                    pAniNode:setScaleY(LookfaceParser:getSingleton():getEffectScaleValue(id).y);
                end
                pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                setNodePostion(pAniNode, CCPointMake(getNodeContentSize(m_pBtnInGameCopy).width/2, getNodeContentSize(m_pBtnInGameCopy).height/2));
                m_pBtnInGameCopy:addChild(pAniNode);
            end
        end
    else
        if m_pBtnInGameCopy:getChildByTag(5001) then
            m_pBtnInGameCopy:removeChildByTag(5001, true);
        end
    end
end

local function createGuideCopyDes(dialog)
	local file = getRealUIResourcePath("img/new00089.png");
	if not file then
		return nil
	end
	local img = SCImage:imageWithFile(file:getData());
	if not img then
		return nil
	end
	local pParsedNode = ParsedNode:getParsedNode(getStringLine(dialog, 6), 0, 11)
	if pParsedNode then
		pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5))
		pParsedNode:setPosition(CCPointMake(img:getContentSize().width/2, img:getContentSize().height/2+SY(5)))
		img:addChild(pParsedNode)
	end
--[[	local textBox = SCTextBox:boxWithWidthHeightFont(SX(104), SY(38), getDefaultFontName(), getFontSize(12));
	textBox:setAnchorPoint(CCPointMake(0.5, 0.5));
	textBox:setPosition(CCPointMake(img:getContentSize().width/2+SX(10), img:getContentSize().height/2-SY(2)));
	textBox:setText(dialog);
	img:addChild(tolua.cast(textBox, "SCNode"));--]]
	return img
end

function setCopyList(data)
    local nPageCount = 0;

    if nil == m_pNode then
        return ;
    end

    m_id = data.nGroup;
    local pszName = data.szGroupName;

    if m_pLabelName and pszName then
        m_pLabelName:setText(pszName);    
    end
    
    m_pTableBox = SCTypeCast:castNodeToTableBox(m_pNode:getChildByTag(1));
    if nil == m_pTableBox then
        return;
    end
    
    local pTable = SCTypeCast:castNodeToTable(m_pTableBox:getChildByTag(0));
    if nil == pTable then
        return ;
    end

    local nRow = pTable:getNumberOfRows();
    local nColoum = pTable:getNumberOfColumns();
    local nTableCount = nil
    if #data.vecChallengeCopy % 8 == 0 then   
        nTableCount = #data.vecChallengeCopy / (nRow * nColoum);
    else
        nTableCount = #data.vecChallengeCopy / (nRow * nColoum) + 1;
    end
    
    local pCell = tolua.cast(pTable:getChildByTag(0), "SCTableCell")   --SCTypeCast:castNodeToTableCel(pTable:getChildByTag(0));
    
    if nil == pCell then
        return ;
    end
    local size = getNodeContentSize(pCell);
    local tableSize = getNodeContentSize(pTable);
    m_pTableBox:removeAllTables();

    local count = m_pTableBox:getPageCount();
    m_Allpage = nTableCount;
    m_Curpage = 1;
    for i = 1, nTableCount do
        local table = SCTable:table();
        if table then
            table:setNumberOfColumns(nColoum);
            table:setNumberOfRows(nRow);


            for j = 1, nColoum do
                setNodeWidthForColumn(table, size.width, j - 1);
            end

            for k=1, nRow do
                setNodeHeightForRow(table, size.height, k - 1);
            end

            table:reflashData();
            m_pTableBox:addTable(table);
        end
    end
    m_GameCopyData = {};
    local mark = nil;
    local page = nil;
    for i = 1, #data.vecChallengeCopy do      
        if m_GopyList.vecChallengeCopy[i].idTemplate == m_curGameCopyId then
            m_Curpage = i;
        end
    end
    if m_Curpage % 8 == 0 then   
        m_Curpage = getIntPart(m_Curpage / 8);
    else
        m_Curpage = getIntPart(m_Curpage / 8) + 1;
    end
    if #data.vecChallengeCopy > m_Curpage*8 then
        page = m_Curpage * 8;
    else
        page = #data.vecChallengeCopy;
    end
    for i = 1 + (m_Curpage - 1) * 8, page do
        local nPage = (i - 1) / (nRow * nColoum);
        local nTag = (i - 1) % (nRow * nColoum);
        local pTable = SCTypeCast:castNodeToTable(m_pTableBox:getChildByTag(nPage));
        
        
        m_IsOpen = data.vecChallengeCopy[i].ucOpen
        m_IsPass = data.vecChallengeCopy[i].ucGradeLev
        
        if pTable then
            local tableSize = getNodeContentSize(pTable);
            local pt = getNodePostion(pTable);
            local pCell = tolua.cast(pTable:getChildByTag(nTag), "SCTableCell") --SCTypeCast:castNodeToTableCell(pTable:getChildByTag(nTag));
            if pCell then
                local pNode = getGameCopyCellNode(i)
                if pNode then
                    pNode:setOutSpaceClickClose(false);
                    pNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                    pNode:setTouchEnabled(false);
                    setBtnVisible(false);
                    if false == m_bIsElite then
                        setMainTaskType(pNode);
                    end
                    if false == m_bIsElite then
                        local scene = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
                        if scene then                     
                            if scene:isUnlock(UNLOCK_TYPE_WIPEOUT_COPY) and 1 == data.vecChallengeCopy[i].ucOpen then
                                
                                setBtnVisible(true,isPass)
                            end
                        end
                    end
                    if false == m_bIsElite then
                        setNodePostion(pNode, CCPointMake(getNodeContentSize(pCell).width / 2 + 6, getNodeContentSize(pCell).height / 2 - 3));
                    else
                        setNodePostion(pNode, CCPointMake(getNodeContentSize(pCell).width / 2 + 6, getNodeContentSize(pCell).height / 2 - 3));
                    end

                
                    setMapData(data.vecChallengeCopy[i]);
                    if data.vecChallengeCopy[i].ucGradeLev==0 and data.vecChallengeCopy[i].ucOpen==1 then               
                        setNewOpenAnimation(true);
                    else
                        setNewOpenAnimation(false);
                    end
					if data.vecChallengeCopy[i].ucFlag==1 then
						local img = createGuideCopyDes(_LTParser("str5138"))
						if img then
							img:setAnchorPoint(CCPointMake(0.5, 0.5))
							img:setPosition(CCPointMake(pCell:getContentSize().width/2, pCell:getContentSize().height/2+SY(42)))
							pCell:addChild(img, 100)
						end
					elseif data.vecChallengeCopy[i].ucFlag==2 then
						local img = createGuideCopyDes(_LTParser("str5139"))
						if img then
							img:setAnchorPoint(CCPointMake(0.5, 0.5))
							img:setPosition(CCPointMake(pCell:getContentSize().width/2, pCell:getContentSize().height/2+SY(42)))
							pCell:addChild(img, 100)
						end
					end
                    pCell:addChild(pNode);
                end                
            end
        end
    end
    if m_curIndex then
        m_curIndex = getIntPart((m_curIndex - 1) / 8);
        m_pTableBox:setOffset(CCPointMake(m_pTableBox:getPageSize().width * m_curIndex, 0));
        m_curIndex = nil;
    end
end

function GameCopy_setCopyListMore()
    if m_pTableBox == nil then
        return;
    end
    local pTable = SCTypeCast:castNodeToTable(m_pTableBox:getChildByTag(m_Curpage - 1));
    if pTable then
        local pCell = pTable:getChildByTag(0);
        if pCell then
            local pNode = pCell:getChildByTag((m_Curpage - 1) * 8 + 1);
            if pNode then
                return;
            end
        end
    end
    local page = nil;
    if #m_GopyList.vecChallengeCopy >= m_Curpage * 8 then
        page = m_Curpage * 8;
    else
        page = #m_GopyList.vecChallengeCopy;
    end
    for i = (m_Curpage - 1)*8 + 1, page do
        local nPage = (i - 1) / (8);
        local nTag = (i - 1) % (8);
        local pTable = SCTypeCast:castNodeToTable(m_pTableBox:getChildByTag(nPage));
        
        
        m_IsOpen = m_GopyList.vecChallengeCopy[i].ucOpen
        m_IsPass = m_GopyList.vecChallengeCopy[i].ucGradeLev
        
        if pTable then
            local tableSize = getNodeContentSize(pTable);
            local pt = getNodePostion(pTable);
            local pCell = tolua.cast(pTable:getChildByTag(nTag), "SCTableCell") --SCTypeCast:castNodeToTableCell(pTable:getChildByTag(nTag));
            if pCell then
                local pNode = getGameCopyCellNode(i)
                if pNode then
                    pNode:setOutSpaceClickClose(false);
                    pNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                    pNode:setTouchEnabled(false);
                    setBtnVisible(false);
                    if false == m_bIsElite then
                        setMainTaskType(pNode);
                    end
                    if false == m_bIsElite then
                        local scene = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
                        if scene then                     
                            if scene:isUnlock(UNLOCK_TYPE_WIPEOUT_COPY) and 1 == m_GopyList.vecChallengeCopy[i].ucOpen then
                                
                                setBtnVisible(true,isPass)
                            end
                        end
                    end
                    if false == m_bIsElite then
                        setNodePostion(pNode, CCPointMake(getNodeContentSize(pCell).width / 2 + 6, getNodeContentSize(pCell).height / 2 - 3));
                    else
                        setNodePostion(pNode, CCPointMake(getNodeContentSize(pCell).width / 2 + 6, getNodeContentSize(pCell).height / 2 - 3));
                    end

                
                    setMapData(m_GopyList.vecChallengeCopy[i]);
                    if m_GopyList.vecChallengeCopy[i].ucGradeLev==0 and m_GopyList.vecChallengeCopy[i].ucOpen==1 then               
                        setNewOpenAnimation(true);
                    else
                        setNewOpenAnimation(false);
                    end
					if m_GopyList.vecChallengeCopy[i].ucFlag==1 then
						local img = createGuideCopyDes(_LTParser("str5138"))
						if img then
							img:setAnchorPoint(CCPointMake(0.5, 0.5))
							img:setPosition(CCPointMake(pCell:getContentSize().width/2, pCell:getContentSize().height/2+SY(42)))
							pCell:addChild(img, 100)
						end
					elseif m_GopyList.vecChallengeCopy[i].ucFlag==2 then
						local img = createGuideCopyDes(_LTParser("str5139"))
						if img then
							img:setAnchorPoint(CCPointMake(0.5, 0.5))
							img:setPosition(CCPointMake(pCell:getContentSize().width/2, pCell:getContentSize().height/2+SY(42)))
							pCell:addChild(img, 100)
						end
					end
                    pCell:addChild(pNode);
                end                
            end
        end
    end
end

function luarefreshPower()
    local pCtrl = getCurentSceneWindowController(2023);
    if pCtrl then
        refreshPower();
    end
end

local function onPushEnded()
	if isGuideCanStart(GUIDE_TYPE_INST) and m_InstanceType==2 then
		setGuideRestartFlag(GUIDE_TYPE_INST, true);
		showGuideStep(GUIDE_TYPE_INST, 5, 4);
	elseif isGuideCanStart(GUIDE_TYPE_HERO_COPY) and m_InstanceType==3 then
		setGuideRestartFlag(GUIDE_TYPE_HERO_COPY, false);
		showGuideStep(GUIDE_TYPE_HERO_COPY, 4, 3);
	end
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        --onPushEnded();
        --refreshPower();
        setCopyList(m_GopyList);
    end
end

local function onMsgGameCopyListEnd(dataStream)
    m_GopyList.nGroup = dataStream:readInt();
    m_GopyList.ucInstanceType = dataStream:readByte();
    local strbuf = dataStream:readString(); 	--//剧情名称
    if strbuf then
        m_GopyList.szGroupName = strbuf:getData();
    else
        m_GopyList.szGroupName = "";
    end
    m_InstanceType = m_GopyList.ucInstanceType;
    m_GopyList.ucAmount = dataStream:readByte();
    m_GopyList.vecChallengeCopy = {};
    for i = 1, m_GopyList.ucAmount do
        table.insert(m_GopyList.vecChallengeCopy, stChallengeCopy.initWithStream(dataStream));
    end


    if isWindControllerExistence(2023) then
        local pCtrl = getCurentSceneWindowController(2023);
        if pCtrl then
            setCopyList(m_GopyList);
        end
    else
        if false == m_isFirstRemove then
            return;
        end
        local isElite = false;
        if m_GopyList.ucInstanceType == 3 then
            isElite =true;
        end
        local pCtrl = createGameCopyControllerWnd(isElite);
        local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and pCtrl then
            naviCtrl:pushWindowController(pCtrl);
            pCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        else
            return;
        end
        --setCopyList(m_GopyList);
    end
    

    local pWndCtrl = getCurentSceneWindowController(1000);
    if pWndCtrl then
        local pNavCtrl = getCurentSceneNavigationController();
        if nil == pNavCtrl then
            return;
        end
        pNavCtrl:removeWindowController(pWndCtrl);
        local pCtrl1 = getCurentSceneWindowController(2023);
        if nil == pCtrl1 then
            return;
        end
        pNavCtrl:removeWindowController(pCtrl1);
        m_isFirstRemove = false;
    end
end



function showGameCopyWnd(ucInstanceType, mark)
    local scene = SCBaseScene:getRunningScene()
    if scene then
        if scene:getUINode():getChildByTag(Hero:getSingleton():getID()) then
            scene:getUINode():removeChildByTag(Hero:getSingleton():getID(), true)--窗口移除
        end
    end
    if isWindControllerExistence(2023) and mark == nil then
        local pCtrl = getCurentSceneWindowController(2023);
        if pCtrl then
            setCopyList(m_GopyList);
        end
    else
        if false == m_isFirstRemove then
            return;
        end
        local nGroup = GameCommonMsgRecive:getSingleton():getMapID();
        nGroup = getIntPart(nGroup / 100) * 100;
        m_nGroup = nGroup;
        m_GopyList = {__mode = "kv"};
        m_GopyList.vecChallengeCopy = {__mode = "kv"};
        m_InstanceType = ucInstanceType;
        for i = 1, #m_allGopyList do
            if (m_allGopyList[i].nGroup == nGroup and ucInstanceType == m_allGopyList[i].ucInstanceType) or
                (ucInstanceType > 1 and ucInstanceType == m_allGopyList[i].ucInstanceType) then
                m_GopyList.nGroup = m_allGopyList[i].nGroup;
                 m_GopyList.ucInstanceType = m_allGopyList[i].ucInstanceType;
                m_GopyList.szGroupName = m_allGopyList[i].szGroupName;
                m_GopyList.ucAmount = m_allGopyList[i].ucAmount;
                for j = 1, m_allGopyList[i].ucAmount do
                    table.insert(m_GopyList.vecChallengeCopy, m_allGopyList[i].vecChallengeCopy[j]);
                end
            end
        end    
        if ucInstanceType > 1 then
            table.sort(m_GopyList.vecChallengeCopy, sortProgressAsc);
        end
        if mark == 0 then      
            m_GameCopyData = {};
            for i = 1, #m_GopyList.vecChallengeCopy do
                setMapData(m_GopyList.vecChallengeCopy[i], 1);
            end
            --BattleTeam.setcurGameCopyID(m_GameCopyData[1].idTemplate);         
            --BattleTeam3.m_gameCopyIndex = 1;
            return;
        end
        local isElite = false;
        if m_GopyList.ucInstanceType == 3 then
            isElite =true;
        end
        local pCtrl = createGameCopyControllerWnd(isElite);
        local naviCtrl =  getCurentSceneNavigationController();
        if  naviCtrl and pCtrl then
            naviCtrl:pushWindowController(pCtrl);
            pCtrl:luaSetSelectorOnEvent(setWindowAttribute);
        else
            return;
        end
        --setCopyList(m_GopyList);
    end
    

    local pWndCtrl = getCurentSceneWindowController(1000);
    if pWndCtrl then
        local pNavCtrl = getCurentSceneNavigationController();
        if nil == pNavCtrl then
            return;
        end
        pNavCtrl:removeWindowController(pWndCtrl);
        local pCtrl1 = getCurentSceneWindowController(2023);
        if nil == pCtrl1 then
            return;
        end
        pNavCtrl:removeWindowController(pCtrl1);
        m_isFirstRemove = false;
    end
end

function GameCopyController_showGameCopyWnd(nGroup, ucInstanceType, gameCopyId)
    local MAP_CHEAT_PROSON	= 1080400--,			// 外挂监狱
    if MAP_CHEAT_PROSON == math.floor(GameCommonMsgRecive:getSingleton():getMapID() / 100) * 100 then
        showMessage(L("str20047"))
        return
    end
    nGroup = getIntPart(nGroup / 100) * 100;
    m_GopyList = {__mode = "kv"};
    m_GopyList.vecChallengeCopy = {__mode = "kv"};
    for i = 1, #m_allGopyList do
        if (m_allGopyList[i].nGroup == nGroup and ucInstanceType == m_allGopyList[i].ucInstanceType) or
            (ucInstanceType > 1 and ucInstanceType == m_allGopyList[i].ucInstanceType) then
            m_GopyList.nGroup = m_allGopyList[i].nGroup;
            m_GopyList.ucInstanceType = m_allGopyList[i].ucInstanceType;
            m_GopyList.szGroupName = m_allGopyList[i].szGroupName;
            m_GopyList.ucAmount = m_allGopyList[i].ucAmount;
            for j = 1, m_allGopyList[i].ucAmount do
                table.insert(m_GopyList.vecChallengeCopy, m_allGopyList[i].vecChallengeCopy[j]);
                if gameCopyId == m_allGopyList[i].vecChallengeCopy[j].idTemplate then
                    if m_allGopyList[i].vecChallengeCopy[j].ucOpen == 1 then
                        m_curGameCopyId = gameCopyId;
                    end
                end
            end
        end
    end    
    if m_curGameCopyId == nil then
        return false;
    end
    local isElite = false;
    if m_GopyList.ucInstanceType == 3 then
        isElite =true;
    end
    
    if ucInstanceType > 1 then
        table.sort(m_GopyList.vecChallengeCopy, sortProgressAsc);
    end
    
    local pCtrl = createGameCopyControllerWnd(isElite);
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and pCtrl then
        naviCtrl:pushWindowController(pCtrl);
        pCtrl:luaSetSelectorOnEvent(setWindowAttribute);
    else
        return false;
    end
    --setCopyList(m_GopyList);
    return true;
end

function GameCopyConstroller_showWnd()
    local mark = Hero:getSingleton():getIDCopy();
    if 0 ~= mark then
        m_curGameCopyId = mark;
    end
    Hero:getSingleton():clearIDCopy();
    BattleTeam.setTempInstanceType(1)
    showGameCopyWnd(1);
end

local function onMsgGameCopyLayer( dataStream )
    m_layerList = {__mode = "kv"};
    m_layerList = stGameCopyLayerList.initWithStream(dataStream);
    m_InstanceType = m_layerList.ucInstanceType;
end

function setIsResetLookFalse()
    m_bLock = false;
end

function GameCopyController_getGameName(idTemplate)
    if idTemplate == nil then
        return L("str6182");
    end
    for i = 1, #m_GameCopyData do
        if m_GameCopyData[i].idTemplate == idTemplate then
            return m_GameCopyData[i].strName;
        end
    end
    return "";
end

function GameCopyController_getGameImgId(idTemplate)
    if idTemplate == nil then
        return L("str6182");
    end
    for i = 1, #m_GameCopyData do
        if m_GameCopyData[i].idTemplate == idTemplate then
            return m_GameCopyData[i].nImg, m_GameCopyData[i].nBossPhoto;
        end
    end
    return "";
end

function GameCopyController_getGameNameIndex(index)
    if index == nil then
        return nil;
    end
    for i = 1, #m_GameCopyData do
        if m_GameCopyData[i].idTemplate == index then
            return i;
        end
    end
    return "";
end

function GameCopyController_getGameNameToIndex(index)
    if index == nil or index == "" then
        return L("str6182");
    end
    return m_GameCopyData[index].strName;
end

local function joinInTeam(tag, itemTag, itemIndex)
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("7023-70231-1-"..itemTag), "SCDragNode");
    if node then
        node:setFrameType(EnumFrameTypeListSelect);
        node:setFrameVisibled(true);        
        if Hero:getSingleton():iSATeamLeader() == true then
            BattleTeam.setcurGameCopyID(m_GameCopyData[itemTag].idTemplate);    
            BattleTeam.setGameCopyName();
            BattleTeam.ReplacementLevel();  
            BattleTeam3.m_gameCopyIndex = itemTag;
            BattleTeam.setInstanceType();
            BattleTeam3.init();
            BattleTeam.setTeamInfo();
            BattleTeam3.m_gameCopyIndex = itemTag;
        end
    end
    local wnd = SCFunction:getUiNodeByIdlist("7023");
    if wnd then
        wnd:removeChildByTag(70231, true);
    end
end

--副本选择
function GameCopyController_selectList(pListBox)
    if pListBox == nil then
        return;
    end    
    pListBox:luaSetSelectorOnItemSelected(joinInTeam)
    pListBox:removeAllItems();
    for i = 1, #m_GameCopyData do
        local pNode = SCDragNode:node();
        if pNode then
            pNode:setFrameVisibled(true)
            pNode:setDragEnabled(false)
            pNode:setFrameType(EnumFrameTypeListNormal)
            pNode:setContentSize(CCSizeMake(SX(250), SY(30)));
            local pLabel = SCLabel:labelWithStringFont(m_GameCopyData[i].strName, DEFAULT_FONT_NAME, F(20))
            if pLabel then
                pLabel:setAnchorPoint(CCPointMake(0.5, 0.5));
                local size = pNode:getContentSize();
                pLabel:setPosition(CCPointMake(size.width / 2, size.height / 2));
                pNode:addChild(pLabel);
            end
            pListBox:addItem(pNode);
            pNode:setTag(i);
        end
    end
end

function GameCopyController_getLeaveUseTimes()
    return m_frequency.usLeaveUseTimes;
end

function GameCopyController_getFrequencyNum()
    return m_frequencyNum
end

function GameCopyController_getInstanceType()
    return m_GopyList.ucInstanceType;
end

function GameCopyController_getBattleCopyType()
	local battleType = m_battleCopyType
	m_battleCopyType = nil
    return battleType;
end

local function updataIsBeginBattleAi()	
	beginBossBattle(true);
	if m_battleAiEntryId then--关闭定时器
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_battleAiEntryId)
        m_battleAiEntryId = nil
    end
end

function GameCopyController_showBattleCopyName()
    local pMapLayer = tolua.cast(getMapLayer(), "MapLayer");
    if m_battleCopyName and pMapLayer then
        local pNBManager = tolua.cast(pMapLayer:getNewBattleManager(), "NBManager");
        if pNBManager then
            local pNode = tolua.cast(pNBManager:getChildByTag(2018), "SCNode");
            if pNode then
                local pLabel = SCLabel:labelWithStringFont(m_battleCopyName, DEFAULT_FONT_NAME, F(30));
                m_battleCopyId = nil;
                if pLabel then
                    pLabel:setTag(9006);
                    pLabel:setAnchorPoint(CCPointMake(0.5, 0.5));
                    pLabel:setPosition(CCPointMake(pNode:getContentSize().width / 2, getScreenHeight() - SY(50)));
                    pLabel:setDoubleRenderWithColor(color_black);
                    pNode:addChild(pLabel);
                end
            end
        end
    end
    m_battleCopyName = nil;
    
    if CLIENT_VERSION < 335 then
		local MAPTYPE_COPYMAP = 2097152;
		local MAPTYPE_NEWBIE_COPY = 4096;
		local MAPTYPE_BOSS_MAP = 131072;
		if GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_COPYMAP) == false and GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_NEWBIE_COPY) == false and GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_BOSS_MAP) == false then
			if m_battleAiEntryId == nil then
				m_battleAiEntryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(updataIsBeginBattleAi, 5.5, false)
			end
		end
	end
end

local function showBattleFail()
    local MAPTYPE_BATTLE_DISABLE = 0x0010
    if GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_BATTLE_DISABLE) == false then
        if Hero:getSingleton():iSATeamLeader() == true or Hero:getSingleton():isATeamMember() == true then
            local pMapLayer = tolua.cast(getMapLayer(), "MapLayer");
            if pMapLayer then
                local pNBManager = tolua.cast(pMapLayer:getNewBattleManager(), "NBManager");
                if pNBManager then
                    pNBManager:showBattleLost();
                end
            end
        end
    end
end

local function recGameCopyInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end    
    local action = dt:readShort()
    if action == ACTION_MAPWOLRD_COPYGROUP_LIST then
        onMsgGameCopyList(dt);
    elseif action == ACTION_COPYLAYER_INFO then
        onMsgGameCopyList(dt);
    elseif action == ACTION_COPYLAYER_INFO_BY_ID then
        onMsgSingleCopyCell(dt);
    elseif action == ACTION_COPYLAYER_INFO_END then
        onMsgGameCopyList(dt);
        --/** 结束后清空数据 */
        --m_GopyList.vecChallengeCopy = {__mode = "kv"};
    elseif action == ACTION_COPYLAYER_INFO_END then
        onMsgGameCopyListEnd(dt);
        --/** 结束后清空数据 */
        m_GopyList.vecChallengeCopy = {__mode = "kv"};
    elseif action == ACTION_COPYLAYER_LIST then
        onMsgGameCopyLayer(dt);
    elseif action == ACTION_COPY_MONSTOR_NAME then
        LuaData:getSingleton():setDataTransStream(LuaData_ACTION_COPY_MONSTOR_NAME, dt);
    --elseif action == ACTION_COPY_WIPE_END or action == ACTION_COPY_WIPEGROUP_END then
    --    LuaData:getSingleton():setDataTransStream(LuaData_ACTION_COPY_WIPE_END, dt);
    elseif action == ACTION_FINISH_SCORE then
        BattleRewards.setCopyTreasure(struScore.initWithStream(dt));
    elseif action == ACTION_BUY_HERO_TIMES then
        m_frequency.usLeaveBuyTimes = dt:readShort(); --剩余购买次数
        m_frequency.usLeaveUseTimes = dt:readShort(); --剩余能打次数
        m_frequencyNum = m_frequency.usLeaveUseTimes
        setFrequency(2);
    elseif action == ACTION_REFRESH_DEVIL_TIMES then
        m_frequencyDevil.usLeaveBuyTimes = dt:readShort(); --剩余购买次数
        m_frequencyDevil.usLeaveUseTimes = dt:readShort(); --剩余能打次数
        setFrequency(3);
    elseif action == ACTION_COPYLAYER_UPDATE_INFO then
        undataGameCopyList(dt);
    elseif action == ACTION_COPYWIPE_TIMES then
        CopymapSweep.recCopyTimsShow(dt);
    elseif action == ACTION_COPYLAYER_CLS_INFO then
        m_allGopyList = {};
    elseif action == ACTION_CLOSE_INSTANCE_MENU then
        local naviCtrl = getCurentSceneNavigationController();
        if naviCtrl then
            naviCtrl:removeWindowControllerByTag(2023);
        end
    elseif action == ACTION_COPY_WIPE_END then
        MainInterface_endCopySweep();
        CopymapSweep_setIsSweeping(false);
    elseif action == ACTION_OPEN_QUESTCOPY then
        local idTemple = dt:readInt(); 
		local ntype = dt:readByte();
		GameCopyController_showGameCopyWnd(0, ntype, idTemple);
	elseif action == ACTION_FINISH_ALL_SCORE then
		BattleRewards_FinishAllScore(dt)
    elseif action == ACTION_SEND_INSTANCE_NAME then
        m_battleCopyName = dt:readString();
        if m_battleCopyName then
            m_battleCopyName = m_battleCopyName:getData();
        end
		m_battleCopyType = dt:readByte()
	elseif action == ACTION_WIPE_INSTANCE_SUPTIMES then
		local dwDiffTimes = dt:readInt();
		Hero:getSingleton():setSweepLeaveTime(dwDiffTimes);
		MainInterface_AddCopySweepTime();
		if dwDiffTimes > 0 then
		    CopymapSweep_setIsSweeping(true);
		end
    elseif action == ACTION_WIPE_INSTANCE_BEGINWIPE then
        CopymapSweep_beginSweep();
    elseif action == ACTION_WIPE_INSTANCE_FAIL then
        showBattleFail();
    end
end

function GameCopyController_clearData()
	m_battleCopyName = nil
end

SCMessageCenter:getSingleton():luaRegistCommand(recGameCopyInfo, _MSG_INSTANCE, 0, nil);