--定义一个与文件名相同的table
GetPrice = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------
local GETPRICE_WND_TAG = 11003   
local GIFT_GROUP_SCALE_USERLEV = 9  --礼包类型

--奖励内按钮
local m_topBtnChildType = {UNLOCK_TYPE_MOODS_GIFT,UNLOCK_TYPE_FRIENDS_GIFT,UNLOCK_TYPE_TIRNED_AWARD, UNLOCK_TYPE_TYPE1,UNLOCK_TYPE_VIP_GIFT,
                            UNLOCK_TYPE_ARENA_GIFT, UNLOCK_TYPE_ADDUP_ONLINE_GIFT, UNLOCK_TYPE_RECHARGE_GIFT, UNLOCK_TYPE_TYPE2, 
                            UNLOCK_TYPE_SEVEN_GIFT, UNLOCK_TYPE_SIGN_IN, UNLOCK_TYPE_ACHIEVE_AWARD, UNLOCK_TYPE_TRIBE_GIFT, UNLOCK_TYPE_SOCIATY_WAR_AWARD}

--图片转奖励名
mPicToPriceName = {[5052] = L("str30044"), [5001] = L("str30033"), [5013] = L("str30000"), [5022] = L("str30002"),
                            [5029] = L("str30005"), [5036] = L("str30001"), [5043] = L("        "), [5044] = L("str30003"),
                            [5045] = L("str30000"), [5032] = L("        "), [5054] = L("str30008"), [5055] = L("str30009"),
                            [5010] = L("str30006"), [5059] = L("str30004"), [5061] = L("str30011"), [5043] = L("str30032"),
                            [5057] = L("str30034"), [5046] = L("str30096"), [5066] = L("str3284")
}
                            
--图片转领奖按钮状态文字(可领取)
m_chgPicToBtnNameOK = {[5052] = L("str30044"), [5001] = L("str30041"), [5013] = L("str30040"), [5022] = L("str30041"),
                            [5029] = L("str30041"), [5036] = L("str30040"), [5043] = L("str30040"), [5044] = L("str30040"),
                            [5045] = L("str30040"), [5032] = L("        "), [5054] = L("str30040"), [5055] = L("str30040"),
                            [5010] = L("str30040"), [5059] = L("str30041"), [5061] = L("str30041"), [5043] = L("str30041"),
                            [5057] = L("str30040"), [5046] = L("str30040"), [5066] = L("str30040")
}

--图片转领奖按钮状态文字(不可领取)
m_chgPicToBtnNameNo = {[5052] = L("str30045"), [5001] = L("str30045"), [5013] = L("str30040"), [5022] = L("str30042"),
                            [5029] = L("str30042"), [5036] = L("str30040"), [5043] = L("str30041"), [5044] = L("str30042"),
                            [5045] = L("str30040"), [5032] = L("        "), [5054] = L("str30041"), [5055] = L("str30041"),
                            [5010] = L("str30043"), [5059] = L("str30041"), [5061] = L("str30041"), [5057] = L("str30041"),
                            [5046] = L("str30189"), [5066] = L("str30042")
}

--奖励优先级
m_pricePrio = {[5045] = 21, [5044]= 20, [5066] = 19, [5022] = 18, [5059] = 16, [5029] = 15, [5054] = 14, [5055] = 13,  
				[5036] = 12, [5052] = 11, [5057] = 10, [5046] = 9, [5010] = 8, [5001] = 7, [5043] = 6, [5061] = 5, [5013] = 4 
}

--暗色奖励优先级
m_priceBlackPrio = {[5036] = 18, [5052]= 17, [5057] = 16, [5046] = 15, [5054] = 14, [5055] = 13, [5010] = 12, [5001] = 11, [5043] = 10, [5045] = 9, 
					[5013] = 8, [5044] = 7, [5066] = 6, [5022] = 5, [5059] = 4, [5029] = 3, [5061] = 2
} 


----------------变量定义区----------------
local mPriceInfo = {}
local m_downloadTag = -1
local m_downloadInfo = -1
local m_bDownPath = nil

----------------UI控制器区----------------
--领奖主窗口--
function GetPrice.initControl()
	local pWindow = SCWindow:window()
	if pWindow then
		pWindow:setTag(GETPRICE_WND_TAG)
		pWindow:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("1.6/wenzi/new00890.png")
		if pImgPath then
			pWindow:setTitleWithImage(pImgPath:getData())
		end
		pWindow:setContentSize(AUTO_SIZE(480, 320))
		pWindow:luaSetSelectorOnClose(GetPrice.releaseControl)
	end
	
	--活动listbox
    local pList = SCListBox:boxWithWidthHeight(AUTO_W(455), AUTO_H(260))
    pList:setTag(1)
	
	if pWindow and pList then
	    pList:setPosition(AUTO_POS(11, 9))
        pWindow:addChild(tolua.cast(pList, "SCNode"))
    end
	
	return pWindow
end

--领奖内容显示--
function GetPrice.init()
    --获取礼包内容
    m_downloadInfo = getDownLoadInfoForGetPriceWnd()
    
    local pList = tolua.cast(SCFunction:getUiNodeByIdlist(GETPRICE_WND_TAG.."-1"), "SCListBox")
    if pList then 
        pList:removeAllItems()
    end
    
    mPriceInfo = {}
    local nSum = 0
    local extraSum = 1
    local downloadInfoFlg = getDownLoadFlgForGetPriceWnd()
    local playerLevel = Hero:getSingleton():getLeval()
    
    nSum = nSum + extraSum
    
    for i = 1, #m_topBtnChildType do
        if luaIsUnlock(m_topBtnChildType[i]) then
            nSum = nSum + 1
        end
    end
	
	
	if CLIENT_TYPE == 2 then
		if downloadInfoFlg == 0 and playerLevel >= 19 then
			nSum = nSum + 1
			extraSum = extraSum + 1
			m_bDownPath = true
		end
		if downloadInfoFlg == 1 and playerLevel >= 29 then
			nSum = nSum + 1
			extraSum = extraSum + 1
			m_bDownPath = true
		end
	else
		if downloadInfoFlg == 0 and playerLevel >= 29 then
			nSum = nSum + 1
			extraSum = extraSum + 1
			m_bDownPath = true
		end
	end
    
    --获取信息
    for i = 1, (#m_topBtnChildType + extraSum) do
        if i >= (#m_topBtnChildType + 1) or i <= (#m_topBtnChildType + extraSum) or luaIsUnlock(m_topBtnChildType[i]) then
            local unInfo = nil
            if i < (#m_topBtnChildType + 1) then
                unInfo = luaGetUnlockInfoWithType(m_topBtnChildType[i])
            else
				if CLIENT_TYPE == 2 then
					if i == #m_topBtnChildType + 2 and m_bDownPath then
						unInfo = {}
						if playerLevel < 19 or downloadInfoFlg > 2 then
							unInfo.nPhoto = 0
							unInfo.byFlag = 2
							unInfo.dwTimeCountDown = 0
						elseif downloadInfoFlg == 0 and playerLevel == 19 then
							unInfo.nPhoto = 5010
							unInfo.byFlag = 2
							unInfo.dwTimeCountDown = 0
							m_downloadTag = 19000
						elseif downloadInfoFlg == 0 and playerLevel > 19 then
							unInfo.nPhoto = 5010
							unInfo.byFlag = 1
							unInfo.dwTimeCountDown = 0
							m_downloadTag = 19001
						elseif downloadInfoFlg == 1 and playerLevel == 29 then 
							unInfo.nPhoto = 5010
							unInfo.byFlag = 2
							unInfo.dwTimeCountDown = 0
							m_downloadTag = 29000
						elseif downloadInfoFlg == 1 and playerLevel > 29 then 
							unInfo.nPhoto = 5010
							unInfo.byFlag = 1
							unInfo.dwTimeCountDown = 0
							m_downloadTag = 29001
						else
							unInfo.nPhoto = 0
						end
					elseif i == #m_topBtnChildType + 1 then
						unInfo = {}
						 unInfo.nPhoto = 5061
						 unInfo.byFlag = 0
						 unInfo.dwTimeCountDown = 0
					end
				else
					if i == #m_topBtnChildType + 2 and m_bDownPath then
						unInfo = {}
						if playerLevel < 19 or downloadInfoFlg > 2 then
							unInfo.nPhoto = 0
							unInfo.byFlag = 2
							unInfo.dwTimeCountDown = 0
						elseif downloadInfoFlg == 0 and playerLevel == 29 then 
							unInfo.nPhoto = 5010
							unInfo.byFlag = 2
							unInfo.dwTimeCountDown = 0
							m_downloadTag = 29000
						elseif downloadInfoFlg == 0 and playerLevel > 29 then 
							unInfo.nPhoto = 5010
							unInfo.byFlag = 1
							unInfo.dwTimeCountDown = 0
							m_downloadTag = 29001
						else
							unInfo.nPhoto = 0
						end
					elseif i == #m_topBtnChildType + 1 then
						unInfo = {}
						 unInfo.nPhoto = 5061
						 unInfo.byFlag = 0
						 unInfo.dwTimeCountDown = 0
					end
				end
			end
            
            if unInfo then 
                --设置按钮的tag
                unInfo.tag = m_topBtnChildType[i]
                table.insert(mPriceInfo, unInfo)
            end
        end
    end
    
    --领奖信息排序
    GetPrice.reorderData(mPriceInfo)
    
    --创建领奖节点
    for i = 1, #mPriceInfo do
        local pNode = GetPrice.createPriceNode(mPriceInfo[i])
        if pNode then
            pList:addItem(pNode)
        end
    end
    
end

--创建领奖节点--
function GetPrice.createPriceNode(unInfo)
    local pNode = SCDragNode:node()
    if not pNode then return nil end
    
    if not unInfo or unInfo.nPhoto == 0  then return nil end
    
    pNode:setContentSize(AUTO_SIZE(455, 76))
    pNode:setDragEnabled(false)
    
    --背景图片
    local imgPath = getRealUIResourcePath("active/new00868.pn")
    if imgPath then
        pImage = SCImage:imageWithFile(imgPath:getData())
        if pImage then
            pImage:setAnchorPoint(CCPointMake(0.5, 0.5))
            pImage:setPosition(CCPointMake(pNode:getContentSize().width / 2, pNode:getContentSize().height / 2))
            pNode:addChild(pImage)
        end
    end
    
    local mark = nil
    if unInfo then    
        local pImg = nil 
        --local pBtn = nil
        local time = unInfo.dwTimeCountDown
        
        --设置奖励图标
        if unInfo.byFlag == 2 or unInfo.byFlag == 3 then
            --领奖图标暗
            local imgPath = getRealUIResourcePath("MainInterfaceImg/"..unInfo.nPhoto.."1.png")
	        local pImage = nil
            if imgPath then
                pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage then
                    pImage:setAnchorPoint(CCPointMake(0, 0.5))
                    pImage:setPosition(CCPointMake(SX(38), pNode:getContentSize().height / 2))
                    pNode:addChild(pImage)
                end
            end
        else
            --领奖图标亮
            local imgPath = getRealUIResourcePath("MainInterfaceImg/"..unInfo.nPhoto..".png")
	        local pImage = nil
            if imgPath then
                pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage then
                    pImage:setAnchorPoint(CCPointMake(0, 0.5))
                    pImage:setPosition(CCPointMake(SX(38), pNode:getContentSize().height / 2))
                    pNode:addChild(pImage)
                end
            end
        end
        
        --奖励名字
        local str = mPicToPriceName[unInfo.nPhoto]
        if not str then str = "" end
        
        local pLabelName = SCLabel:labelWithStringFont(str, DEFAULT_FONT_NAME, F(13))
        if pLabelName then
            pLabelName:setPosition(AUTO_POS(80, 40))
            pLabelName:setColor(color_white)
            pNode:addChild(pLabelName)
        end
        
        --奖励进度提示
        local str = ""
        local color = color_white
        
        if unInfo.byFlag == 0 then                      --只有一种状态
            str = GetPrice.strForFlag(unInfo)
        elseif unInfo.byFlag == 1 then                  --奖励可领
            str = GetPrice.strForFlag1(unInfo)
        elseif unInfo.byFlag == 2 then                  --不可领取状态
            str, color = GetPrice.strForFlag2(unInfo)
            GetPrice.setTimer(unInfo, pNode)
        elseif unInfo.byFlag == 3 then                  --领取完成，没有更多领取       
            str, color = GetPrice.strForFlag3(unInfo)
        end
        
        local pLabelRate = SCTextBox:boxWithWidthHeightFont(SX(175), SY(30), DEFAULT_FONT_NAME, F(11))
        if pLabelRate then
			pLabelRate:setParserDelegate(TextParser:getSingleton())
			pLabelRate:setText(str)
			pLabelRate:setScrollVertical(false)
			pLabelRate:setPosition(AUTO_POS(80, 10))
            pNode:addChild(pLabelRate)
        end
        
        --设置奖励内容
        local pPriceInfo = GetPrice.getPriceInfo(unInfo)
        if pPriceInfo then
            pPriceInfo:setAnchorPoint(CCPointMake(0, 0.5))
            pPriceInfo:setPosition(CCPointMake(SX(240), SY(76) / 2))
            pNode:addChild(pPriceInfo)
        end
        
        --设置领奖按钮
        local pBtn = nil
        
        if unInfo.byFlag == 0 then
            pBtn = GetPrice.getPriceBtnForFlag(unInfo, m_bDownPath)
        elseif unInfo.byFlag == 1 then
            pBtn = GetPrice.getPriceBtnForFlag1(unInfo, m_bDownPath)
        elseif unInfo.byFlag == 2 then
            pBtn = GetPrice.getPriceBtnForFlag2(unInfo, m_bDownPath)
        elseif unInfo.byFlag == 3 then
            pBtn = GetPrice.getPriceBtnForFlag3(unInfo, m_bDownPath)
        end 
    
        if pBtn then
            pBtn:setAnchorPoint(CCPointMake(0, 0.5))
            pBtn:setPosition(CCPointMake(SX(345), pNode:getContentSize().height / 2))
            pNode:addChild(pBtn)
        end
    end
    
    return pNode
end

--窗口关闭回调--
function GetPrice.releaseControl()
	if GetPrice.wndCloss then
		GetPrice.wndCloss()
	end
end

--窗口释放--
function GetPrice.wndCloss()
    mPriceInfo = {}
end

--逻辑功能区--
--活动优先级排序--
function GetPrice.reorderData(priceInfo)
    if not priceInfo then return end
    local pTmpInfo = {}
    local pos = 1   --亮暗分隔位置
    
    --排序
    for i = 1, #priceInfo do
        if priceInfo[i].byFlag == 2 or priceInfo[i].byFlag == 3 then    --图标暗
            if pos > #pTmpInfo then                                    	--没有暗图标，插入
                table.insert(pTmpInfo, priceInfo[i])
            else                                                        --从分隔位开始按优先级查找插入
                for j = pos, #pTmpInfo do
                    if not m_priceBlackPrio[priceInfo[i].nPhoto] or not m_priceBlackPrio[pTmpInfo[j].nPhoto] then
                        break
                    end
                    if m_priceBlackPrio[priceInfo[i].nPhoto] > m_priceBlackPrio[pTmpInfo[j].nPhoto] then  --优先级高，插入
                        table.insert(pTmpInfo, j, priceInfo[i])
                        break
                    end
                    
                    if j == #pTmpInfo then          --优先级最低，执行
                        table.insert(pTmpInfo, priceInfo[i])
                    end
                end
            end
        end
        
        if priceInfo[i].byFlag == 0 or priceInfo[i].byFlag == 1 then    --图标亮
            if pos == 1 then                                            --为空直接插入
                table.insert(pTmpInfo, 1, priceInfo[i])
                pos = pos + 1
            else                                                        --从分隔位开始按优先级查找插入
                for j = 1, pos - 1 do
					if not m_pricePrio[priceInfo[i].nPhoto] or not m_pricePrio[pTmpInfo[j].nPhoto] then
                        break
                    end
                    if m_pricePrio[priceInfo[i].nPhoto] > m_pricePrio[pTmpInfo[j].nPhoto] then  --优先级高，插入
                        table.insert(pTmpInfo, j, priceInfo[i])
                        pos = pos + 1
                        break
                    end
                    
                    if j == pos - 1 then            --优先级最低，执行
                        table.insert(pTmpInfo, j + 1, priceInfo[i])
                        pos = pos + 1
                    end
                end
            end
        end
    end
    
    mPriceInfo = pTmpInfo
end

--只有一种状态的文字判断--
function GetPrice.strForFlag(unInfo)
    local str = ""
    if 5061 == unInfo.nPhoto then           --激活码
        str = L("str30012")
    elseif 5057 == unInfo.nPhoto then       --成就
        str = unInfo.nNum.." / "..unInfo.nTotal
	elseif 5001 == unInfo.nPhoto then       --充值
        str = unInfo.nNum.." / "..unInfo.nTotal
	elseif 5046 == unInfo.nPhoto then		--军团礼包
		str = L("str30039")
    end
    
    return str
end

--可以领取状态文字判断--
function GetPrice.strForFlag1(unInfo)
    local str = ""
    if 5052 == unInfo.nPhoto then           --体力
        str = "0 / 1"
    elseif 5001 == unInfo.nPhoto then       --充值
        str = unInfo.nNum.." / "..unInfo.nTotal
    elseif unInfo.nPhoto == 5013 then       --每日
        str = "0 / 1"
    elseif unInfo.nPhoto == 5022 then       --七日
        str = unInfo.nNum.." / "..unInfo.nTotal
    elseif unInfo.nPhoto == 5029 then       --行善
        str = unInfo.nNum.." / "..unInfo.nTotal
    elseif unInfo.nPhoto == 5036 then       --在线
        str = "0 / 1"
    elseif 5043 == unInfo.nPhoto then       --VIP
        str = L("str30031")
    elseif 5044 == unInfo.nPhoto then       --竞技
        str = "0 / 1".."  "..L("str30020")..unInfo.idItemType
    elseif 5045 == unInfo.nPhoto then       --每日
        str = "0 / 1"
    elseif 5032 == unInfo.nPhoto then       --首冲(无)
        str = L("")
    elseif 5054 == unInfo.nPhoto then       --人气
        str = unInfo.nNum.." / "..unInfo.nTotal
    elseif 5055 == unInfo.nPhoto then       --友好
        str = unInfo.nNum.." / "..unInfo.nTotal
    elseif 5010 == unInfo.nPhoto then       --下载
        str = "0 / 1"
    elseif 5059 == unInfo.nPhoto then       --签到
        str = "0 / 1"
    elseif 5061 == unInfo.nPhoto then       --激活码
        str = L("str30012")
    elseif 5057 == unInfo.nPhoto then       --成就
        str = unInfo.nNum.." / "..unInfo.nTotal
	elseif 5046 == unInfo.nPhoto then		--军团礼包
		str = L("str30039")
	elseif 5066 == unInfo.nPhoto then		--军团俸禄
		str = "0 / 1"
    end
    
    return str
end

---不可领取状态---
function GetPrice.strForFlag2(unInfo)
    local str = ""
    local color = color_white
    
    if 5052 == unInfo.nPhoto then           --体力
        str = ""
    elseif 5001 == unInfo.nPhoto then       --充值
        str = unInfo.nNum.." / "..unInfo.nTotal
    elseif unInfo.nPhoto == 5013 then       --每日
        str = L("str30023")
    elseif unInfo.nPhoto == 5022 then       --七日
        str = unInfo.nNum.." / "..unInfo.nTotal.."     "..L("str30023")
    elseif unInfo.nPhoto == 5029 then       --行善
        str = L("str30024")
    elseif unInfo.nPhoto == 5036 then       --在线
        str = ""
    elseif 5043 == unInfo.nPhoto then       --VIP
        str = ""
    elseif 5044 == unInfo.nPhoto then       --竞技
        str = L("str30025")
    elseif 5045 == unInfo.nPhoto then       --每日
        str = L("str30023")
    elseif 5032 == unInfo.nPhoto then       --首冲(无)
        str = L("")
    elseif 5054 == unInfo.nPhoto then       --人气
        str = unInfo.nNum.." / "..unInfo.nTotal
    elseif 5055 == unInfo.nPhoto then       --友好
        str = unInfo.nNum.." / "..unInfo.nTotal
    elseif 5010 == unInfo.nPhoto then       --下载
        str = L("str30021")
    elseif 5059 == unInfo.nPhoto then       --签到
        str = L("str30026")..unInfo.nTotal..L("str30027")
    elseif 5061 == unInfo.nPhoto then       --激活码
        str = L("str30012")
    elseif 5057 == unInfo.nPhoto then       --成就
        str = unInfo.nNum.." / "..unInfo.nTotal
	elseif 5066 == unInfo.nPhoto then		--军团俸禄
		str = "0 / 1"
	elseif 5046 == unInfo.nPhoto then		--军团礼包
		str = L("str30039")
    end
    
    return str, color
end

--领取完成，没有多余领取--
function GetPrice.strForFlag3(unInfo)
    local str = ""
    local color = color_white
    
    if 5054 == unInfo.nPhoto then       --人气
        str = L("str30022")
    elseif 5055 == unInfo.nPhoto then   --友好
        str = L("str30022")
    end
    
    return str, color
end

---获取宝箱名---
function GetPrice.getNameByItemId(id)
    local stProduction = TableParser:getSingleton():getItemInfoByKey(id)
    if stProduction and stProduction.name then
        return stProduction.name
    end
    
    return nil
end

--设置定时器---
function GetPrice.setTimer(unInfo, pNode)
    if 5036 == unInfo.nPhoto or 5052 == unInfo.nPhoto then       --在线、体力
        local pTimer = CountDownNode:newCountDownNode(DisplayTimeType_Hour_Minute_Second, 14)
        if pTimer and unInfo.dwTimeCountDown > 0 then
            pTimer:setTime(unInfo.dwTimeCountDown)
            pTimer:setPosition(AUTO_POS(80, 21))
            pNode:addChild(pTimer)
        end
    end
end

--领奖按钮--
function GetPrice.getPriceBtnForFlag(unInfo, m_bDownPath)
    local pBtn = SCButton:button(EnumBtnType9Atlas)
    if not pBtn then return nil end
    pBtn:setContentSize(AUTO_SIZE(100, 35))
    
    --设置按钮
    if m_chgPicToBtnNameOK[unInfo.nPhoto] then
		pBtn:setTitle(m_chgPicToBtnNameOK[unInfo.nPhoto], DEFAULT_FONT_NAME, F(15), color_white)
	end
	
    if 5061 == unInfo.nPhoto then       --激活码
        pBtn:setTitle(L("str30041"), DEFAULT_FONT_NAME, F(15), color_white)
    end
    pBtn:setButtonType(1)
    
    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
        
    if 5010 == unInfo.nPhoto and m_bDownPath then
        pBtn:setTag(m_downloadTag)
        pBtn:luaSetSelectorOnClicked(GetPrice.sendDownloadAward)  
    elseif 5061 == unInfo.nPhoto then
        pBtn:luaSetSelectorOnClicked(CdkeyWnd_Window)  
	elseif 5001 == unInfo.nPhoto then
		pBtn:setTitle(L("str30041"), DEFAULT_FONT_NAME, F(15), color_white)
		pBtn:setTag(unInfo.tag)
    else
        if unInfo.tag then
            pBtn:setTag(unInfo.tag)
        end
    end                 
    
    return pBtn
end

function GetPrice.getPriceBtnForFlag1(unInfo, m_bDownPath)
    local pBtn = SCButton:button(EnumBtnType9Atlas)
    if not pBtn then return nil end
    pBtn:setContentSize(AUTO_SIZE(100, 35))
    
    --设置按钮
    pBtn:setTitle(m_chgPicToBtnNameOK[unInfo.nPhoto], DEFAULT_FONT_NAME, F(15), color_white)
    pBtn:setButtonType(1)
    pBtn:luaSetSelectorOnClicked(onMainBtnClick)

    if 5010 == unInfo.nPhoto and m_bDownPath then
        pBtn:setTag(m_downloadTag)
        pBtn:luaSetSelectorOnClicked(GetPrice.sendDownloadAward)  
    elseif 5061 == unInfo.nPhoto then
        pBtn:luaSetSelectorOnClicked(CdkeyWnd_Window)  
	elseif 5046 == unInfo.nPhoto then
		pBtn:luaSetSelectorOnClicked(sendTribeGift)
		pBtn:setTag(unInfo.tag)
    else
        if unInfo.tag then
            pBtn:setTag(unInfo.tag)
        end
    end                 
    
    return pBtn
end

function GetPrice.getPriceBtnForFlag2(unInfo, m_bDownPath)
    local pBtn = SCButton:button(EnumBtnType9Atlas)
    if not pBtn then return nil end
    pBtn:setContentSize(AUTO_SIZE(100, 35))
    
    --设置按钮
    pBtn:setTitle(m_chgPicToBtnNameNo[unInfo.nPhoto], DEFAULT_FONT_NAME, F(15), color_white)
    pBtn:setButtonType(3)
    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
        
    if 5010 == unInfo.nPhoto and m_bDownPath then
        pBtn:setTag(m_downloadTag)
        pBtn:luaSetSelectorOnClicked(GetPrice.sendDownloadAward)  
    elseif 5061 == unInfo.nPhoto then
        pBtn:luaSetSelectorOnClicked(CdkeyWnd_Window)     
	elseif 5022 == unInfo.nPhoto then 	--七日
		pBtn:setVisible(true)
	elseif 5044 == unInfo.nPhoto then 	--竞技场
		pBtn:setVisible(true)
	elseif 5059 == unInfo.nPhoto then 	--签到
		pBtn:setVisible(true)
		pBtn:setTag(unInfo.tag)
	elseif 5029 == unInfo.nPhoto then 	--日行一善
		pBtn:setVisible(true)
    else
        if unInfo.tag then
            pBtn:setTag(unInfo.tag)
        end
    end                 
    
    return pBtn
end

function GetPrice.getPriceBtnForFlag3(unInfo, m_bDownPath)
    local pBtn = SCButton:button(EnumBtnType9Atlas)
    if not pBtn then return nil end
    pBtn:setContentSize(AUTO_SIZE(100, 35))
    
    --设置按钮
    pBtn:setTitle(m_chgPicToBtnNameNo[unInfo.nPhoto], DEFAULT_FONT_NAME, F(15), color_white)
    pBtn:setButtonType(3)
    pBtn:luaSetSelectorOnClicked(onMainBtnClick)
        
    if 5010 == unInfo.nPhoto and m_bDownPath then
        pBtn:setTag(m_downloadTag)
        pBtn:luaSetSelectorOnClicked(GetPrice.sendDownloadAward)  
    elseif 5061 == unInfo.nPhoto then
        pBtn:luaSetSelectorOnClicked(CdkeyWnd_Window)
	elseif 5022 == unInfo.nPhoto then 	--七日
		pBtn:setVisible(true)
	elseif 5044 == unInfo.nPhoto then 	--竞技场
		pBtn:setVisible(true)
	elseif 5059 == unInfo.nPhoto then 	--签到
		pBtn:setVisible(true)
	elseif 5029 == unInfo.nPhoto then 	--日行一善
		pBtn:setVisible(true)
    else
        if unInfo.tag then
            pBtn:setTag(unInfo.tag)
        end
    end                 
    
    return pBtn
end

--设置要获得的奖励信息--
function GetPrice.getPriceInfo(unInfo)
    local pNode = SCNode:node()
    if not pNode then return nil end
    
    pNode:setContentSize(AUTO_SIZE(190, 35))
    
    if 5045 == unInfo.nPhoto then                   --每日
        if not unInfo.nTotal or not unInfo.nNum then return nil end
        local pVal = SCLabel:labelWithStringFont(Hero:getSingleton():getLeval() * unInfo.nTotal + unInfo.nNum, DEFAULT_FONT_NAME, F(14))
        if pVal then                                --每日奖励值
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
        
        imgPath = getRealUIResourcePath("img/2001001.png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
                pNode:addChild(pImg)
                GetPrice.setPriceName(2001001, pNode, pImg)
            end
        end
    elseif 5036 == unInfo.nPhoto then               --在线奖励
        if not unInfo.idItemType or unInfo.idItemType == 0 then return nil end
        stItemInfo = TableParser:getSingleton():getItemInfoByKey(unInfo.idItemType)
        
        if not stItemInfo or not stItemInfo.name or not stItemInfo.icon then return nil end
        local pVal = SCLabel:labelWithStringFont(stItemInfo.name:getData(), DEFAULT_FONT_NAME, F(14))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
        
        imgPath = getRealUIResourcePath("img/"..stItemInfo.icon..".png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
                pNode:addChild(pImg)
                GetPrice.setPriceName(stItemInfo.icon, pNode, pImg)
            end
        end
    elseif 5010 == unInfo.nPhoto then               --下载礼包
        if m_downloadInfo == 0 then return nil end
        
        local pVal = SCLabel:labelWithStringFont(m_downloadInfo, DEFAULT_FONT_NAME, F(14))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
        
        imgPath = getRealUIResourcePath("img/2001008.png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
                pNode:addChild(pImg)
                GetPrice.setPriceName(2001008, pNode, pImg)
            end
        end
    elseif 5052 == unInfo.nPhoto then               --体力
        if not unInfo.idItemType or unInfo.idItemType == 0 then return nil end
        local pVal = SCLabel:labelWithStringFont(unInfo.idItemType, DEFAULT_FONT_NAME, F(14))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
        
        imgPath = getRealUIResourcePath("img/2001005.png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
                pNode:addChild(pImg)
                GetPrice.setPriceName(2001005, pNode, pImg)
            end
        end
    elseif 5022 == unInfo.nPhoto then               --七日
        local pVal = SCLabel:labelWithStringFont(L("str30028"), DEFAULT_FONT_NAME, F(14))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
    elseif 5059 == unInfo.nPhoto then                --签到 
        local pVal = SCLabel:labelWithStringFont(L("str30029"), DEFAULT_FONT_NAME, F(14))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
    elseif 5029 == unInfo.nPhoto then               --日行一善
        local pVal = SCLabel:labelWithStringFont(L("str30030"), DEFAULT_FONT_NAME, F(14))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
    elseif  5061 == unInfo.nPhoto then              --激活码
        imgPath = getRealUIResourcePath("item/2005005.jpg")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
                pNode:addChild(pImg)
                GetPrice.setPriceName(2005005, pNode, pImg)
            end
        end
    elseif 5044 == unInfo.nPhoto then               --竞技场
        GetPrice.createPriceInfoForTwoTing(pNode, unInfo.nTotal, unInfo.nNum, 2001001, 2001003)
    elseif 5054 == unInfo.nPhoto then               --人气
        GetPrice.createPriceInfoForTwoTing(pNode, unInfo.dwTimeCountDown, unInfo.idItemType, 2001001, 2001005)
    elseif 5055 == unInfo.nPhoto then               --友好
        GetPrice.createPriceInfoForTwoTing(pNode, unInfo.dwTimeCountDown, unInfo.idItemType, 2001001, 2001005)
	elseif 5046 == unInfo.nPhoto then				--军团礼包
		local pVal = SCLabel:labelWithStringFont(20, DEFAULT_FONT_NAME, F(14))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
        
        imgPath = getRealUIResourcePath("img/2001008.png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
                pNode:addChild(pImg)
                GetPrice.setPriceName(2001008, pNode, pImg)
            end
        end
	elseif 5066 == unInfo.nPhoto then				--军团俸禄
		if unInfo.idItemType == 1 then				--冠军
			GetPrice.createPriceInfoForTwoTing(pNode, 500000, 50000, 2001001, 2001006)
		else
			GetPrice.createPriceInfoForTwoTing(pNode, 300000, 30000, 2001001, 2001006)
		end
    end
    return pNode
end


--奖励具体内容节点创建--
function GetPrice.createPriceInfoForTwoTing(pNode, data1, data2, img1, img2)
    if data1 ~= 0 and data2 ~= 0 then
        imgPath = getRealUIResourcePath("img/"..img1..".png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2 + SY(15)))
                pNode:addChild(pImg)
                GetPrice.setPriceName(img1, pNode, pImg)
            end
        end
        if  img2 == 2001003  then
			local pVal = SCLabel:labelWithStringFont(data1, DEFAULT_FONT_NAME, F(12))
			if pVal then                       
				pVal:setAnchorPoint(CCPointMake(0, 0.5))
				pVal:setPosition(CCPointMake(SX(51), pNode:getContentSize().height / 2 + SY(15)))
				pNode:addChild(pVal)
			end
		else
			local pVal = SCLabel:labelWithStringFont(data1, DEFAULT_FONT_NAME, F(15))
			if pVal then                       
				pVal:setAnchorPoint(CCPointMake(0, 0.5))
				pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2 + SY(15)))
				pNode:addChild(pVal)
			end
        end 
		
        imgPath = getRealUIResourcePath("img/"..img2..".png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2 - SY(10)))
                pNode:addChild(pImg)
                GetPrice.setPriceName(img2, pNode, pImg)
            end
        end
        
        if  img2 == 2001003  then
			local pVal = SCLabel:labelWithStringFont(data2, DEFAULT_FONT_NAME, F(12))
			if pVal then                       
				pVal:setAnchorPoint(CCPointMake(0, 0.5))
				pVal:setPosition(CCPointMake(SX(51), pNode:getContentSize().height / 2 - SY(10)))
				pNode:addChild(pVal)
			end
		else
			local pVal = SCLabel:labelWithStringFont(data2, DEFAULT_FONT_NAME, F(15))
			if pVal then                       
				pVal:setAnchorPoint(CCPointMake(0, 0.5))
				pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2 - SY(10)))
				pNode:addChild(pVal)
			end
		end 
    elseif data1 ~= 0 then
        imgPath = getRealUIResourcePath("img/"..img1..".png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
                pNode:addChild(pImg)
				GetPrice.setPriceName(img1, pNode, pImg)
            end
        end
        
        local pVal = SCLabel:labelWithStringFont(data1, DEFAULT_FONT_NAME, F(15))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
    elseif data2 ~= 0 then
        imgPath = getRealUIResourcePath("img/"..img2..".png")
        if imgPath then
            local pImg = SCImage:imageWithFile(imgPath:getData())
            if pImg then
                pImg:setScale(0.6)
                pImg:setAnchorPoint(CCPointMake(0, 0.5))
                pImg:setPosition(CCPointMake(SX(20), pNode:getContentSize().height / 2))
                pNode:addChild(pImg)
                GetPrice.setPriceName(img2, pNode, pImg)
            end
        end
        
        local pVal = SCLabel:labelWithStringFont(data2, DEFAULT_FONT_NAME, F(15))
        if pVal then                       
            pVal:setAnchorPoint(CCPointMake(0, 0.5))
            pVal:setPosition(CCPointMake(SX(55), pNode:getContentSize().height / 2))
            pNode:addChild(pVal)
        end
    end
end

--奖励名获取--
function GetPrice.setPriceName(img, pNode, pImg)
	if not pNode or not img or not pImg then return end
	local pName = nil
	
	if img == 2001001 then			--金币
		pName = SCLabel:labelWithStringFont(L("str30120"), DEFAULT_FONT_NAME, F(10))
	elseif img == 2001003 then		--声望
		pName = SCLabel:labelWithStringFont(L("str30121"), DEFAULT_FONT_NAME, F(10))
	elseif img == 2001005 then		--体力
		pName = SCLabel:labelWithStringFont(L("str30122"), DEFAULT_FONT_NAME, F(10))
	elseif img == 2001006 then		--战功
		pName = SCLabel:labelWithStringFont(L("str30123"), DEFAULT_FONT_NAME, F(10))
	elseif img == 2001008 then		--元宝
		pName = SCLabel:labelWithStringFont(L("str30124"), DEFAULT_FONT_NAME, F(10))
	elseif img == 2005005 then		--礼包
		pName = SCLabel:labelWithStringFont(L("str30125"), DEFAULT_FONT_NAME, F(10))
	end
	
	if pName then
		pName:setAnchorPoint(CCPointMake(0, 0))
		if img == 2005005 then	--礼包位置特别处理
			pName:setPosition(CCPointMake(pImg:getPosition().x + SX(1), pImg:getPosition().y - SY(14)))
		else
			pName:setPosition(CCPointMake(pImg:getPosition().x + SX(3), pImg:getPosition().y - SY(14)))
		end
		pNode:addChild(pName)
	end
end

--下载礼包消息发送--
function GetPrice.sendDownloadAward(tag)
    if tag == 19001 or tag == 29001 then
        local num = nil
        if tag == 19001 then
            num = 1
        else
            num = 2
        end
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO);
        if dataStream then                   ----消息发送提示
            dataStream:writeShort(USERINFO_SCALE_AWARD)
            dataStream:writeByte(num);
            dataStream:writeInt(GIFT_GROUP_SCALE_USERLEV);
            SCDataTransThread:getSingleton():transData(dataStream)
            SCActivityIndicator:getSingleton():show();
        end
    end

    if tag == 19000 then
		if string.find(getAppName():getData(), "IOS") then
			showMessage(_LTParser("str9215"))
		else
			showMessage(_LTParser("str3079"))
		end
    elseif tag == 29000 then
		if string.find(getAppName():getData(), "IOS") then
			showMessage(_LTParser("str9216"))
		else
			showMessage(_LTParser("str3080"))
		end
    end
end

----------------全局函数区----------------
function GetPrice.showGetPriceWnd()
    local wnd = GetPrice.initControl();
    if wnd == nil then
        return;
    end
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
        end
    end
end

---重刷界面---
function GetPriceRefreshForC()
    local wnd = getCurentSceneWindow(11003)
    if not wnd then return end
    GetPrice.init()
end

---下载礼包刷新界面---
function GetPrice.refreshWnd()
	GetPriceRefreshForC()
end
