
GiftActivity = {nodeTag}

-----------------------结构定义区------------------------

-----------------------常量定义区------------------------
local GIFTINFO_RUSH_TO_PURCHASE     = 24--,//限时抢购信息 
local GIFTINFO_GETRUSH_TO_PURCHASE  = 25--,//限时抢购 

local GIFTINFO_GETTOTAL_RECHARGE_FAIL = 26--, //领取旷世金蛋失败 
local GIFTINFO_GETTOTAL_RECHARGE  = 27--, //领取旷世金蛋

local TOTAL_GIFT_REGRESSION = 3461000208------旷世金蛋ID
-----------------------变量定义区------------------------
local m_bIsBuy
-----------------------函数声明区------------------------

-----------------------逻辑功能区------------------------
function GiftActivity.onCloseWnd()
    local wnd = SCFunction:getUiNodeByIdlist(9106)
    if wnd then
        REMOVE_CTRL_BY_TAG(9106)
    end
    
    GiftActivity.nodeTag = nil
    GiftActivity.bIsBuy  = nil
    m_bIsBuy = nil
end

function GiftActivity.OpenDayByMoneyWnd()
    local wndCtrl = getCurentSceneWindowController(9106)
    if not wndCtrl then
        wnd = GiftActivity.CreateMainWnd()
        if wnd then
            wnd:setTag(9106) 
            wndCtrl = SCWindowController:controllerWithWindow(wnd)            
            if wndCtrl then
                PUSH_CTRL(wndCtrl)                
            end            
            
            wnd:setFrameVisibled(false)
            wnd:setBackButtonVisibled(false);
            wnd:setCloseButtonVisibled(false);  
            GiftActivity.InitData()
        end
    end
end

function GiftActivity.onBtnClicked(tag)
    if GiftActivity.nodeTag == 0 then
        if tag == 101 then
            luaShowTipCpp(1, 5000000)
        elseif tag == 102 then            
            if GiftActivity.bIsBuy then
                return
            end
            local eMoney = Hero:getSingleton():getEmoney()
            if eMoney < 188 then
                luashowConfirmationWindow(_LTParser("str0439"), WIN_YES_NO, GiftActivity.EMoneyLess)
                return
            end
            local str = string.format(L("str20040"), 188, 500 .. L("str20048"))
            if not str then
                str = ""
            end
            luashowConfirmationWindowPoint(str, "*6"..L("str20041"), nil, WIN_YES_NO, GiftActivity.ConfirmationReturn)            
        end
    elseif GiftActivity.nodeTag == 1 then
        if tag == 101 then
            showTip(TOTAL_GIFT_REGRESSION)
        elseif tag == 102 then
            GiftActivity.SendGetEgg()
            GiftActivity.onCloseWnd()
        end
    end
end

function GiftActivity.ConfirmationReturn(tag)
    if tag == 1 then        
        --[[btn = GiftActivity.btnOK
        if btn then
            btn:setTitle(L("str6209"), getDefaultFontName(), F(13))
            btn:setButtonType(3)
            btn:setTouchEnabled(false)
        end]]
        
        GiftActivity.SendBuyPurchase()
    end
end
--创建左部分结点

function GiftActivity.SetLeftNode()
    local nodeLeft  = tolua.cast(SCFunction:getUiNodeByIdlist("9106-1"), "SCDragNode")
    if not nodeLeft then return end 
    
    nodeLeft:removeAllChildrenWithCleanup(true)  
    
    local text = ""
    if GiftActivity.nodeTag == 0 then
        text = L("str20038")
    elseif GiftActivity.nodeTag == 1 then
        text = L("str20042")
    end
    local contextNode = getItemTextNode(text, 0, 10)
    if contextNode then
        contextNode:setTag(51)
        contextNode:setPerWidthAndHeight(0, 18)
        contextNode:setAnchorPoint(ANCHOR_CENTER)
        local szLeft = nodeLeft:getContentSize()
        contextNode:setPosition(szLeft.width / 2, szLeft.height / 2)
        nodeLeft:addChild(contextNode)        
    end
end
--创建右部结点
function GiftActivity.SetRightNode()
    local nodeRight = tolua.cast(SCFunction:getUiNodeByIdlist("9106-2"), "SCDragNode")
    if not nodeRight then return end 
    
    local szRight = nodeRight:getContentSize()
    
    GiftActivity.labelName = SCLabel:labelWithStringFont(" ", getDefaultFontName(), F(12))    
    if GiftActivity.labelName then
        GiftActivity.labelName:setColor(color_orange)
        GiftActivity.labelName:setTag(100)
        GiftActivity.labelName:setAnchorPoint(CCPointMake(0.5, 0.5))
        GiftActivity.labelName:setPosition(szRight.width / 2, szRight.height - SY(25))
        nodeRight:addChild(GiftActivity.labelName)
    end
    
    local pt = CCPointMake(szRight.width - SX(70), szRight.height / 2 + SY(5))
    
    GiftActivity.btnItem = SCButton:button()

    if GiftActivity.btnItem then
        local pathNormal = RES("img/new00002.pn")
        local pathSelect = RES("img/new00003.pn")
        if pathNormal and pathSelect then
            GiftActivity.btnItem:setBackgroundImage(pathNormal)
            GiftActivity.btnItem:setSelectedImage(pathSelect)                
            height = GiftActivity.btnItem:getContentSize().height / 4
        end            
        
        GiftActivity.btnItem:luaSetSelectorOnClicked(GiftActivity.onBtnClicked)
        GiftActivity.btnItem:setAnchorPoint(CCPointMake(0.5, 0.5))
        if GiftActivity.nodeTag == 0 then
            GiftActivity.btnItem:setPosition(SX(42), pt.y)
        else 
            GiftActivity.btnItem:setPosition(szRight.width / 2, pt.y)
        end
        GiftActivity.btnItem:setTag(101)
        
        nodeRight:addChild(GiftActivity.btnItem)
        
        --[[if GiftActivity.nodeTag == 0 then
            local label = SCLabel:labelWithStringFont("500"..L("str0285"), getDefaultFontName(), F(9))
            if label then
                label:setAnchorPoint(CCPointMake(1, 0))
                label:setPosition(btn:getContentSize().width - SX(5), SY(5))
                btn:addChild(label)
            end
        end]]
    end
        
    GiftActivity.btnOK = SCButton:button(1)    
    if GiftActivity.btnOK then
        GiftActivity.btnOK:setTag(102)
        GiftActivity.btnOK:setContentSize(AUTO_SIZE(70, 30))
        --btn:setTitle(L("str20039"), getDefaultFontName(), F(13))
        GiftActivity.btnOK:setAnchorPoint(ANCHOR_CENTER)
        GiftActivity.btnOK:setPosition(szRight.width / 2, SY(28))
        GiftActivity.btnOK:luaSetSelectorOnClicked(GiftActivity.onBtnClicked)
        nodeRight:addChild(GiftActivity.btnOK)
    end    
    
    if GiftActivity.nodeTag == 0 then
        local node = GiftActivity.CreateRightNode()
        if node then
            nodeRight:addChild(node)
        end
    end
end

function GiftActivity.UpdateData()
    local tag = GiftActivity.nodeTag
    local itemName 
    local imgPath
    local btnName
    if  tag == 0 then
        itemName = "500" .. L("str20048")
        imgPath  = RES("item/2005001.jp")
        if m_bIsBuy then
            btnName = L("str6209")
        else
            btnName = L("str20039")
        end
    elseif tag == 1 then
        itemName = L("str20049")
        imgPath  = RES("item/2000150.jp")
        btnName  = L("str20050")
    end
    local labelName = tolua.cast(SCFunction:getUiNodeByIdlist("9106-2-100"), "SCLabel")
    if labelName and itemName then
        labelName:setText(itemName)
    end
    local btnItem =  tolua.cast(SCFunction:getUiNodeByIdlist("9106-2-101"), "SCButton")
    if btnItem and imgPath then
        btnItem:setTitle(imgPath)
    end
    local btnOK =  tolua.cast(SCFunction:getUiNodeByIdlist("9106-2-102"), "SCButton")
    if btnOK and btnName then
        btnOK:setTitle(btnName, getDefaultFontName(), F(13))
        local type = 1 
        local enable = true
        if m_bIsBuy then
            type = 3
            enable = false
			btnOK:setContentSize(AUTO_SIZE(80, 30))
        end
        btnOK:setButtonType(type)
        btnOK:setTouchEnabled(enable)
    end
end
--
function GiftActivity.InitData()
    GiftActivity.SetLeftNode()
    GiftActivity.SetRightNode()
    GiftActivity.UpdateData()
end

function GiftActivity.OpenWindow(tag)
    GiftActivity.nodeTag = tag
    GiftActivity.OpenDayByMoneyWnd()    
        
end

function GiftActivity.EMoneyLess(tag)
    if tag == WIN_YES then
        showVIPrechargeableWnd()
    end
end

function GiftActivity.onBtnOK()
    showVIPrechargeableWnd()
    GiftActivity.onBtnCancel()
end

function GiftActivity.onBtnCancel()
    local wnd = SCFunction:getUiNodeByIdlist("788889")
    if wnd then
        wnd:removeFromParentAndCleanup(true)
    end
end
-----------------------UI控制器区------------------------
function GiftActivity.CreateMainWnd()
    local wnd = SCWindow:window()
    if not wnd then return end
    
    local szWnd = AUTO_SIZE(380, 180)    
    if GiftActivity.nodeTag == 1 then
        szWnd = AUTO_SIZE(330, 180)        
    end
    wnd:setContentSize(szWnd)    
    
    local pDragNode1 = SCDragNode:node()
	if pDragNode1 then						
		pDragNode1:setContentSize(szWnd)
		pDragNode1:setFrameVisibled(true)		
		pDragNode1:setFrameType(EnumFrameTyperedwindowstip)
		wnd:addChild(pDragNode1)
	end  
  
    local pathCloseNormal = RES("kernal/close-normal.pn")
    local pathCloseSelect = RES("kernal/close-selected.pn")
    if pathCloseNormal and pathCloseSelect then
        local btnClose = SCButton:button()
        btnClose:setBackgroundImage(pathCloseNormal)
        btnClose:setSelectedImage(pathCloseSelect)
        btnClose:luaSetSelectorOnClicked(GiftActivity.onCloseWnd)
        btnClose:setAnchorPoint(CCPointMake(1, 1))
        btnClose:setPosition(szWnd.width, szWnd.height)
        btnClose:setMusicPath("closeWindow.mp3");
        btnClose:setTouchRectScale(4.0,4.0)
        btnClose:setScale(0.7)
        wnd:addChild(btnClose)
    end
    
    local titlePath = RES("kernal/redTop.pn")
    local path      = RES("img/new00703.pn")
    if titlePath and path then
        local imgBg = SCImage:imageWithFile(titlePath)
        local img   = SCImage:imageWithFile(path)
        if imgBg and img then
            local szBg = imgBg:getContentSize()
            img:setAnchorPoint(CCPointMake(0.5, 0.5))
            img:setPosition(szBg.width / 2, szBg.height / 2)
            imgBg:addChild(img)
            
            imgBg:setAnchorPoint(CCPointMake(0.5, 1))
            imgBg:setPosition(szWnd.width / 2, szWnd.height)
            wnd:addChild(imgBg)            
        end
    end
    
    local szLeft = CCSizeMake(SX(200), szWnd.height - SY(30))
    local width = SX(5)
    local szRight = CCSizeMake(szWnd.width - szLeft.width - width * 2, szLeft.height)
    
    GiftActivity.nodeLeft = SCDragNode:node()    
    if GiftActivity.nodeLeft then
        GiftActivity.nodeLeft:setContentSize(szLeft)
        GiftActivity.nodeLeft:setFrameVisibled(true)
        GiftActivity.nodeLeft:setFrameType(0)
        GiftActivity.nodeLeft:setPosition(width, width)
        GiftActivity.nodeLeft:setTag(1)
        wnd:addChild(GiftActivity.nodeLeft)       
    end    
    
    GiftActivity.nodeRight = SCDragNode:node()    
    if GiftActivity.nodeRight then
        GiftActivity.nodeRight:setContentSize(szRight)
        GiftActivity.nodeRight:setFrameVisibled(true)
        GiftActivity.nodeRight:setFrameType(0)
        GiftActivity.nodeRight:setTag(2)
        GiftActivity.nodeRight:setAnchorPoint(CCPointMake(1, 0))
        GiftActivity.nodeRight:setPosition(szWnd.width - width, width)        
        wnd:addChild(GiftActivity.nodeRight)  
    end

    return wnd 
end

function GiftActivity.CreateRightNode()
    local node = SCNode:node()
    if not node then return end 
    
    local nodeRight = tolua.cast(SCFunction:getUiNodeByIdlist("9106-2"), "SCDragNode")
    local szRight = nodeRight:getContentSize()
    local pt = CCPointMake(szRight.width - SX(60), szRight.height / 2 + SY(5))
    local height = SY(18)
    local space = SX(20)
    
    node:setContentSize(szRight)
    
    local labelOld = SCLabel:labelWithStringFont(L("str20000") , getDefaultFontName(), F(15))        
    if labelOld then            
        labelOld:setAnchorPoint(CCPointMake(1, 0.5))        
        labelOld:setPosition(pt.x - space, pt.y + height)
        labelOld:setColor(colorLightYellow())
        labelOld:setTag(1)
        node:addChild(labelOld) 
        
        local path = RES("img/2001008.pn")
        if path then
            local img = SCImage:imageWithFile(path)
            if img then
                img:setPosition(pt.x, pt.y + height)
                img:setAnchorPoint(CCPointMake(0.5, 0.5))                
                img:setTag(2)
                node:addChild(img)
            end
        end
        
        local labelPrice = SCLabel:labelWithStringFont("500", getDefaultFontName(), F(15))
        if labelPrice then
            labelPrice:setAnchorPoint(CCPointMake(0, 0.5))
            labelPrice:setPosition(pt.x + space, pt.y + height)
            labelPrice:setColor(colorLightYellow())
            labelPrice:setTag(3)
            node:addChild(labelPrice)
        end
    end
    
    local labelNew = SCLabel:labelWithStringFont(L("str20001"), getDefaultFontName(), F(15))
    if labelNew then
        labelNew:setAnchorPoint(CCPointMake(1, 0.5))        
        labelNew:setPosition(pt.x - space, pt.y - height)
        labelNew:setColor(color_yellow)
        labelNew:setTag(4)
        node:addChild(labelNew)             
        
        local path = RES("img/2001008.pn")
        if path then
            local img = SCImage:imageWithFile(path)
            if img then
                img:setPosition(pt.x, pt.y - height)
                img:setAnchorPoint(CCPointMake(0.5, 0.5))
                img:setTag(5)
                node:addChild(img)
            end
        end
        
        local labelPrice = SCLabel:labelWithStringFont("188", getDefaultFontName(), F(15))
        if labelPrice then
            labelPrice:setAnchorPoint(CCPointMake(0, 0.5))
            labelPrice:setPosition(pt.x + space, pt.y - height)
            labelPrice:setColor(color_yellow)
            labelPrice:setTag(6)
            node:addChild(labelPrice)
        end
    end
    
    return node
end
-----------------------消息处理区------------------------
--购买金钱
function GiftActivity.SendBuyPurchase()
    local dt = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);  
    dt:writeShort(GIFTINFO_GETRUSH_TO_PURCHASE)  
    SCDataTransThread:getSingleton():transData(dt); 
    SCActivityIndicator:getSingleton():show() 
end
--打开窗口
function GiftActivity.SendInitPurchase()
    local dt = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);  
    dt:writeShort(GIFTINFO_RUSH_TO_PURCHASE)  
    SCDataTransThread:getSingleton():transData(dt); 
    SCActivityIndicator:getSingleton():show() 
end

function GiftActivity.SendDayByMoneyRelease()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(UNLOCK_TYPE_RUSH_TO_PURCHASE)
    SCDataTransThread:getSingleton():transData(dataStream)
end
------------------------
--领取金蛋
function GiftActivity.SendGetEgg()
    local dt = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);  
    dt:writeShort(GIFTINFO_GETTOTAL_RECHARGE)  
    SCDataTransThread:getSingleton():transData(dt);     
end

function GiftActivity.SendEggRelease()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(UNLOCK_TYPE_GRAND_TOTAL_RECHARGE)
    SCDataTransThread:getSingleton():transData(dataStream)
end
-----------------------消息注册区------------------------
function GiftActivity_ReadData(dt, action)
    if not dt or not action then return end 
    
    if action == GIFTINFO_RUSH_TO_PURCHASE then--24
        local isBuy = dt:readByte()
        if isBuy == 0 then
            m_bIsBuy = false
        else
            m_bIsBuy = true
        end 
        GiftActivity.bIsBuy = m_bIsBuy
        GiftActivity.OpenWindow(0)
        GiftActivity.UpdateData()
        GiftActivity.SendDayByMoneyRelease()
    elseif action == GIFTINFO_GETTOTAL_RECHARGE_FAIL then--26
        luashowConfirmationWindowPoint(L("str20053"), L("str20054"), L("str20030"), WIN_NULL, GiftActivity.onBtnOK, GiftActivity.onBtnCancel, 1)
    end 
end
-----------------------全局函数区------------------------
--每日限时购金币
function GiftActivity_ShowDayByMoneyWnd()
    --GiftActivity.OpenWindow(0)
    GiftActivity.SendInitPurchase()
end

--送土豪金活动
function GiftActivity_ShowGoldenEggWnd()
    GiftActivity.OpenWindow(1)    
    GiftActivity.SendEggRelease()
end

function GiftActivity_GetDayByMoneyString()
    local str = L("str20051")
    if GiftActivity.bIsBuy then
        str = L("str6209")
    end
    return str
end

function GiftActivity_GetGoldenEggString()
    return L("str20049")
end