--定义一个与文件名相同的table
GuidePoint = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------
local OPEN_GIFTBOX           = 0  	--1级礼包引导(单独使用)
local GUID_OPEN_LEARN_SKILL  = 5 

local GUIDE_TYPE_NewPlayer   = 1  --1级礼包引导
local GUIDE_TYPE_Skill       = 2  --技能引导
local GUIDE_TYPE_Award       = 3  --宝箱奖励引导
local GUIDE_TYPE_SevenDay    = 4  --七日奖励引导
local GUIDE_TYPE_CSkill      = 5  --副本技能引导
local GUIDE_TYPE_Strong      = 6  --强化装备引导
local GUIDE_TYPE_Strength    = 7  --增加体力引导
local GUIDE_TYPE_Challenge   = 8  --挑战引导
local GUIDE_TYPE_Reward      = 9  --奖励引导
local GUIDE_TYPE_FirstRech   = 10 --首冲未充值引导 
local GUIDE_TYPE_Salary      = 11 --每日俸禄引导
local GUIDE_TYPE_FirstRech1  = 12 --首冲已充值引导 
--local GUIDE_TYPE_Copy      = 13 --大泽山斩魔2副本引导
local GUIDE_TYPE_BlowRecruit = 14 --武将招募引导
local GUIDE_TYPE_Goods       = 15 --成长礼包领取引导
local GUIDE_TYPE_Tree        = 16 --摇钱树引导
local GUIDE_TYPE_Sports      = 17 --竞技礼包引导
local GUIDE_TYPE_Inlay       = 18 --镶嵌引导
local GUIDE_TYPE_Mark        = 19 --刻印引导
local GUIDE_TYPE_Escort      = 20 --押镖引导

local GUIDE_TYPE_LEARN_SKILL          = 2000     --副本学习技能
local GUIDE_TYPE_CHALLENGE_COPY       = 2001     --挑战副本 这个是领取礼包时报
local GUIDE_TYPE_BUY_POWER		      = 2002     --购买体力引导
local GUIDE_TYPE_AREAN                = 2003     --竞技场引导
local GUIDE_TYPE_NEWBIE_EMONEY        = 2004     --新手领取元宝引导
local GUIDE_TYPE_FIRST_RECHARGE_GIFT  = 2005     --首充礼包引导
--local GUIDE_TYPE_FLIP_OVER          = 2006     --翻页引导
local GUIDE_TYPE_RECRUITPARTNER       = 2007     --武将招募引导
local GUIDE_TYPE_MONEY_TREE           = 2008     --摇钱树引导
local GUIDE_TYPE_ADDUP_ONLINE_GIFT    = 2009     --在线礼包引导
local GUIDE_TYPE_AREAN_AWARD          = 2010     --竞技场礼包 
local GUIDE_TYPE_GEM_INLAY            = 2011     --宝石镶嵌
local GUIDE_TYPE_SEVEN_GIFT           = 2012     --七日礼包引导
local GUIDE_TYPE_RUNE_STONE           = 2013     --符石刻印
local GUIDE_TYPE_EQUIP_STRENGTHEN     = 2014     --装备强化
local GUIDE_TYPE_LOOT_ESCORT          = 2017     --押镖被截

----------------变量定义区----------------
local m_entryId = nil
local m_entryId1 = nil
local m_entryId2 = nil
local m_Value = {}
local m_guidetable = {}
local pNeedNode = nil
local isOpenTimer = 0
local m_flag = 0
local m_flag1 = nil  --判断nil 表示 自动 1 表示 手动 
local m_flag2 = nil  --判断第2个定时器
local m_idtype = nil
local m_idtype1 = nil  --判断镶嵌是否打开宝箱
local m_isStartCSkillGuide = nil
----------------本地函数------------------
local Escort_StartGuideTimeDown --押镖引导有效时限函数声明

----------------UI控制器区----------------

----------------全局函数区----------------
function GuidePoint_Init(Flag)
	local tmp = {}
	tmp.num = 0
	tmp.info = {}
	m_Value[Flag] = tmp
end

function isDelGuide()
    local flag = nil
    for i = 1, #m_guidetable do
        if m_Value[m_guidetable[i]] ~= nil then
            flag = m_guidetable[i];
            break;
        end
    end
    if flag == nil then
        if GuidePoint_isOpenTime() == true then
            LuaReCall:getSingleton():setnID(11);
        else
            LuaReCall:getSingleton():setnID(21);
        end
    else
        if GuidePoint_isOpenTime() == true then
            LuaReCall:getSingleton():setnID(12);
        else
            LuaReCall:getSingleton():setnID(22);
        end
    end
end

function isDelGuide1()
    local flag = nil
    for i = 1, #m_guidetable do
        if m_Value[m_guidetable[i]] ~= nil then
            flag = m_guidetable[i];
            break;
        end
    end
    if flag == nil then
        return true;
    else
        return false;
    end
end

function isDelGuide2()
    local flag = nil
    for i = 1, #m_guidetable do
        if m_Value[m_guidetable[i]] ~= nil then
            flag = m_guidetable[i];
            break;
        end
    end
    return flag;
end

function BeginLoop()
    local flag = nil
    for i = 1, #m_guidetable do
        if m_Value[m_guidetable[i]] ~= nil then
            flag = m_guidetable[i];
            local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007"), "SCNode")
            local pNode1 = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007-1000"), "SCNode")
            if pNode and pNode1 then
                pNode:removeChild(pNode1, true)
            end
            break;
        end
    end
    
    if flag == nil then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
        m_entryId = nil
        m_Value = {}
        m_guidetable = {}
        pNeedNode = nil
        isOpenTimer = 0
        GuidePoint_topGuide()
        return;
    end
    if flag == GUIDE_TYPE_NewPlayer then
	    GuidePoint_NewPlayer()
	elseif flag == GUIDE_TYPE_Skill then
	    GuidePoint_Skill()
	elseif flag == GUIDE_TYPE_Award then
        GuidePoint_Award()
    elseif flag == GUIDE_TYPE_SevenDay then  --七日奖励引导
        GuidePoint_SevenDay()
    elseif flag == GUIDE_TYPE_CSkill then
        GuidePoint_CSkill()
    elseif flag == GUIDE_TYPE_Strong then
        GuidePoint_Strong()
    elseif flag == GUIDE_TYPE_Strength then
        GuidePoint_Strength()
    elseif flag == GUIDE_TYPE_Challenge then
        GuidePoint_Challenge()
    elseif flag == GUIDE_TYPE_Reward then
        GuidePoint_Reward()
    elseif flag == GUIDE_TYPE_FirstRech then
        GuidePoint_FirstRech()
    elseif flag == GUIDE_TYPE_Salary then
        GuidePoint_Salary()
    elseif flag == GUIDE_TYPE_FirstRech1 then
        GuidePoint_FirstRech1()
    elseif flag == GUIDE_TYPE_BlowRecruit then
        --GuidePoint_Copy()
        GuidePoint_BlowRecruit()
    elseif flag == GUIDE_TYPE_Goods then
        GuidePoint_Goods2()
    elseif flag == GUIDE_TYPE_Tree then
        GuidePoint_Tree()
    elseif flag == GUIDE_TYPE_Sports then
        GuidePoint_Sports()
    elseif flag == GUIDE_TYPE_Inlay then
        --if m_idtype1 == 1 then
        --    GuidePoint_Inlay()
        --else
            GuidePoint_Inlay1()
        --end
    elseif flag == GUIDE_TYPE_Mark then
        GuidePoint_Mark()
    elseif flag == GUIDE_TYPE_Escort then
        GuidePoint_Escort()
    end
    --GuidePoint_CSkill()
end


--1级礼包引导增计数
function GuidePoint_AddFlag()
	if m_Value[GUIDE_TYPE_NewPlayer] ~= nil then
		m_Value[GUIDE_TYPE_NewPlayer].num = m_Value[GUIDE_TYPE_NewPlayer].num + 1;
		local pReMoveNode = nil
        pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_NewPlayer].info[2].strlist)
        if pReMoveNode then
            pReMoveNode:removeChildByTag(1000, true);
        end
	end
end

--成长礼包引导增计数
function GuidePoint_AddGoodsFlag()
	if m_Value[GUIDE_TYPE_Goods] ~= nil then
		m_Value[GUIDE_TYPE_Goods].num = m_Value[GUIDE_TYPE_Goods].num + 1;
		local pReMoveNode = nil
        pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Goods].info[1].strlist)
        if pReMoveNode then
            pReMoveNode:removeChildByTag(1000, true);
        end
	end
end

--镶嵌引导增计数
function GuidePoint_AddGoodsFlag1()
	if m_Value[GUIDE_TYPE_Inlay] ~= nil then
		m_Value[GUIDE_TYPE_Inlay].num = m_Value[GUIDE_TYPE_Inlay].num + 1;    
	end
end

function GuidePoint_AddGoodsFlag2()
	if m_Value[GUIDE_TYPE_Mark] ~= nil then
		m_Value[GUIDE_TYPE_Mark].num = m_Value[GUIDE_TYPE_Mark].num + 1;    
	end
end

--1级礼包引导减计数
function GuidePoint_SubFlag()
	if m_Value[GUIDE_TYPE_NewPlayer] ~= nil then
		m_Value[GUIDE_TYPE_NewPlayer].num = m_Value[GUIDE_TYPE_NewPlayer].num - 1;
	end
end

--脚本引导增加计数
function GuidePoint_LuaAddCount(Flag, index)   --index 引导到第几步
    local flag = nil
    for i = 1, #m_guidetable do
        if m_Value[m_guidetable[i]] ~= nil then
            flag = m_guidetable[i];
            break;
        end
    end
    if flag and m_Value[flag].num == index then
		m_Value[flag].num = m_Value[flag].num + 1;
        return true;
    else
        return false;
    end
	--[[if m_Value[Flag] ~= nil and m_Value[Flag].num == index then
		m_Value[Flag].num = m_Value[Flag].num + 1;
        return true;
    else
        return false;
	end]]
end

--C中引导增加计数
function GuidePoint_AddCount()   --index 引导到第几步
    --[[local num = lua
    local flag = getIntPart(num / 100)
    loacl index = getIntPart(num % 100)
	if m_Value[Flag] ~= nil and m_Value[Flag].num == index then
		m_Value[Flag].num = m_Value[Flag].num + 1;
        return true;
    else
        return false;
	end--]]
end

--释放数据
function GuidePoint_FreeData()
    if m_Value[GUIDE_TYPE_NewPlayer] ~= nil then
        if m_Value[GUIDE_TYPE_NewPlayer].num > 0 then
            m_Value[GUIDE_TYPE_NewPlayer] = nil
            isOpenTimer = isOpenTimer - 1;
            if isOpenTimer == 0 then		
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                isOpenTimer = 0
                GuidePoint_topGuide()
            end
        end
    end
    if m_Value[GUIDE_TYPE_Skill] ~= nil then
        if m_Value[GUIDE_TYPE_Skill].num > 0 then
            m_Value[GUIDE_TYPE_Skill] = nil
            isOpenTimer = isOpenTimer - 1;
            if isOpenTimer == 0 then		
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                stepInfo = {}
                GuidePoint_topGuide()
            end
        end
    end
    if m_Value[GUIDE_TYPE_Goods] ~= nil then
        if m_Value[GUIDE_TYPE_Goods].num > 0 then
            m_Value[GUIDE_TYPE_Goods] = nil
            isOpenTimer = isOpenTimer - 1;
            if isOpenTimer == 0 then		
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                m_idtype = nil
                stepInfo = {}
                GuidePoint_topGuide()
            end
        end
    end
    if m_Value[GUIDE_TYPE_Inlay] ~= nil then
        if m_Value[GUIDE_TYPE_Inlay].num > 0 then
            m_Value[GUIDE_TYPE_Inlay] = nil
            isOpenTimer = isOpenTimer - 1;
            if isOpenTimer == 0 then		
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_idtype1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                m_idtype = nil
                stepInfo = {}
                GuidePoint_topGuide()
            end
        end
    end
    if m_Value[GUIDE_TYPE_Mark] ~= nil then
        if m_Value[GUIDE_TYPE_Mark].num > 0 then
            m_Value[GUIDE_TYPE_Mark] = nil
            isOpenTimer = isOpenTimer - 1;
            if isOpenTimer == 0 then		
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                m_idtype = nil
                stepInfo = {}
                GuidePoint_topGuide()
            end
        end
    end
    --[[if isOpenTimer > 0 then		
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
        m_entryId = nil
        Value = nil
        pNeedNode = nil
        stepInfo = {}
    end--]]
end

--释放挑战引导数据
function GuidePoint_FreeChData()
    if m_Value[GUIDE_TYPE_Challenge] ~= nil then
        if m_Value[GUIDE_TYPE_Challenge].num == 1 then
            m_Value[GUIDE_TYPE_Challenge] = nil
            isOpenTimer = isOpenTimer - 1;
            if isOpenTimer == 0 then		
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                isOpenTimer = 0
                GuidePoint_topGuide()
            end
        end
    end
end

--释放挑战引导数据1
function GuidePoint_FreeChData1()
    if m_Value[GUIDE_TYPE_Challenge] ~= nil then
        if m_Value[GUIDE_TYPE_Challenge].num > 1 then
            m_Value[GUIDE_TYPE_Challenge] = nil
            isOpenTimer = isOpenTimer - 1;
            if isOpenTimer == 0 then		
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                isOpenTimer = 0
                GuidePoint_topGuide()
            end
        end
    end
end

--增加挑战引用计数
function GuidePoint_AddChCount()
    if m_Value[GUIDE_TYPE_Challenge] ~= nil then
		m_Value[GUIDE_TYPE_Challenge].num = m_Value[GUIDE_TYPE_Challenge].num + 1;
	end
end

--提前结束引导释放数据
function GuidePoint_EndGuide(Flag)   
	if m_Value[Flag] ~= nil then
        m_Value[Flag] = nil
        isOpenTimer = isOpenTimer - 1;
        if isOpenTimer == 0 then		
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
            m_entryId = nil
            m_entryId1 = nil
            m_idtype1 = nil
            m_Value = {}
            m_guidetable = {}
            pNeedNode = nil
            stepInfo = {}
            GuidePoint_topGuide()
        end
    end
end

function GuidePoint_CloseTimer()
    if isOpenTimer ~= 0 then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
        m_entryId = nil
        m_entryId1 = nil
        m_idtype1 = nil
        m_Value = {}
        m_guidetable = {}
        pNeedNode = nil
        stepInfo = {}
        isOpenTimer = 0
    end
end

--移除方向键引导
function GuidePoint_removeCtrl()
    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
    if mapLay then
        local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
        local pNode = nil  --方向结点
        local pNode1 = nil --手指结点
        if pBattleNode then
           pNode = SCFunction:getUiNodeByIdlistAndParent("2020-2013", pBattleNode);
           if pNode == nil then
                return;
           end
           pNode1 = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
           if pNode1 == nil then
                return;
           end
           pNode:removeChild(pNode1, true)
        end
    end
end

--创建普通向右引导按键上面不会被覆盖
function GuidePoint_createRectGuideNode(pNode)  --可以继续传参数
    if pNode == nil then
        return
    end
    local partent = pNode:getParent();
    if partent == nil then
        return;
    end
    partent:reorderChild(pNode, 1001)
	local imgPath = getRealUIResourcePath("img/new00447.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData()) 
	local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
	if imgPath and pImage and pLabel then
		--pImage:setFlipX(true)
		pImage:setTag(1001)
		pImage:setScale(0.9)
		pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage:setPosition(AUTO_POS(0.00, 0.00))
		pLabel:setAnchorPoint(ANCHOR_CENTER)
		pLabel:setPosition(CCPointMake(SX(44), pImage:getContentSize().height/2))
		pLabel:setColor(ccc4(255, 0, 0, 255))
		pImage:addChild(tolua.cast(pLabel, "SCNode"))
	end
	
	local ActionNode = ActionNode:newActionNode();
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_CENTER);
		ActionNode:setPosition(CCPointMake(0 - pImage:getContentSize().width/2 +SX(15), pNode:getContentSize().height/2));
		ActionNode:moveToRetuen(CCPointMake(0 - pImage:getContentSize().width/2 +SX(15), pNode:getContentSize().height/2), CCPointMake(0 - pImage:getContentSize().width/2 +SX(11), pNode:getContentSize().height/2), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"))
	end
end

--创建普通向右引导按键下面
function GuidePoint_createRightGuideNode(pNode)  --可以继续传参数
    if pNode == nil then
        return
    end
    local ActNode = pNode:getChildByTag(1000)
    if ActNode then
        pNode:removeChildByTag(1000,true)
    end
	local imgPath = getRealUIResourcePath("img/new00447.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData())
	if pImage == nil then
	    return;
	end
	local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
	if pLabel then
		--pImage:setFlipX(true)
		pImage:setTag(1001)
		pImage:setScale(0.9)
		pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage:setPosition(AUTO_POS(0.00, 0.00))
		pLabel:setAnchorPoint(ANCHOR_CENTER)
		pLabel:setPosition(CCPointMake(SX(44), pImage:getContentSize().height/2))
		pLabel:setColor(ccc4(255, 0, 0, 255))
		pImage:addChild(tolua.cast(pLabel, "SCNode"))
	end
	
	local ActionNode = ActionNode:newActionNode();
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_CENTER);
		ActionNode:setPosition(CCPointMake(0 - pImage:getContentSize().width/2 +SX(15), pNode:getContentSize().height/2));
		ActionNode:moveToRetuen(CCPointMake(0 - pImage:getContentSize().width/2 +SX(15), pNode:getContentSize().height/2), CCPointMake(0 - pImage:getContentSize().width/2 +SX(11), pNode:getContentSize().height/2), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"))
	end
end

--创建普通向左不会被覆盖引导按键
function GuidePoint_createLeftUpGuideNode(pNode)  --可以继续传参数
    if pNode == nil then
        return
    end
    local partent = pNode:getParent();
    if partent == nil then
        return;
    end
    partent:reorderChild(pNode, 10001)
	local imgPath = getRealUIResourcePath("img/new00447.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData())
	if pImage == nil then
	    return;
	end
	local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
	if pLabel then
		pImage:setFlipX(true)
		pImage:setTag(1001)
		pImage:setScale(0.9)
		pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage:setPosition(AUTO_POS(-10.00, 0.00))
		pLabel:setAnchorPoint(ANCHOR_CENTER)
		pLabel:setPosition(CCPointMake(SX(62), pImage:getContentSize().height/2))
		pLabel:setColor(ccc4(255, 0, 0, 255))
		pImage:addChild(tolua.cast(pLabel, "SCNode"))
	end
	
	local width = pNode:getContentSize().width + pImage:getContentSize().width/2
	local height = pNode:getContentSize().height/2
	local ActionNode = ActionNode:newActionNode();
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_CENTER);
		ActionNode:setPosition(CCPointMake(width + SX(2), height));
		ActionNode:moveToRetuen(CCPointMake(width + SX(2), height), CCPointMake(width + SX(6), height), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"))
	end
end

--创建普通向左引导按键
function GuidePoint_createLeftGuideNode(pNode)  --可以继续传参数
    if pNode == nil then
        return
    end
	local imgPath = getRealUIResourcePath("img/new00447.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData())
	if pImage == nil then
	    return;
	end
	local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
	if pLabel then
		pImage:setFlipX(true)
		pImage:setTag(1001)
		pImage:setScale(0.9)
		pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage:setPosition(AUTO_POS(-10.00, 0.00))
		pLabel:setAnchorPoint(ANCHOR_CENTER)
		pLabel:setPosition(CCPointMake(SX(62), pImage:getContentSize().height/2))
		pLabel:setColor(ccc4(255, 0, 0, 255))
		pImage:addChild(tolua.cast(pLabel, "SCNode"))
	end
	
	local width = pNode:getContentSize().width + pImage:getContentSize().width/2
	local height = pNode:getContentSize().height/2
	local ActionNode = ActionNode:newActionNode();
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_CENTER);
		ActionNode:setPosition(CCPointMake(width + SX(2), height));
		ActionNode:moveToRetuen(CCPointMake(width + SX(2), height), CCPointMake(width + SX(6), height), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"))
	end
end

--创建普通向上引导按键(黄色箭头)
function GuidePoint_createSetUpGuideNode(pNode)  --可以继续传参数
    if pNode == nil then
        return
    end
	local imgPath = getRealUIResourcePath("img/new00638.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData())
	if pImage == nil then
	    return;
	end
	local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
	if pLabel then
		--pImage:setFlipX(true)
		pImage:setTag(1001)
		pImage:setFlipY(true)
		pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage:setPosition(AUTO_POS(0.00, 0.00))
		pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLabel:setPosition(AUTO_POS(17.00, 12.00))
		pLabel:setColor(ccc4(255, 0, 0, 255))
		pImage:addChild(tolua.cast(pLabel, "SCNode"))
	end
	
	local width = pNode:getContentSize().width/2
	local height = 0-pImage:getContentSize().height/2
	local ActionNode = ActionNode:newActionNode();
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_CENTER);
		ActionNode:setPosition(CCPointMake(width, height));
		ActionNode:moveToRetuen(CCPointMake(width, height), CCPointMake(width, height - SY(4)), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"))
	end
end

--创建普通向下引导按键(黄色箭头)
function GuidePoint_createSetDownGuideNode(pNode)  --可以继续传参数
    if pNode == nil then
        return
    end

	local imgPath = getRealUIResourcePath("img/new00621.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData())
	if pImage == nil then
	   return;
	end
    pImage:setTag(1001)
    pImage:setFlipY(true)
    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
    pImage:setPosition(AUTO_POS(0.00, 0.00))
	
	local width = pNode:getContentSize().width/2
	local height = pNode:getContentSize().height+pImage:getContentSize().height/2
	local ActionNode = ActionNode:newActionNode();
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_CENTER);
		ActionNode:setPosition(CCPointMake(width, height-SY(4)));
		ActionNode:moveToRetuen(CCPointMake(width, height-SY(4)), CCPointMake(width, height-SY(8)), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"));
	end
end

--创建关闭窗口引导按键
function GuidePoint_createCloseWndGuideNode(pNode)  --可以继续传参数
    if pNode == nil then
        return
    end
	local imgPath = getRealUIResourcePath("img/new00447.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData())
	if pImage == nil then
	    return;
	end
	local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
	if pLabel then
		--pImage:setFlipX(true)
		pImage:setTag(1001)
		pImage:setScale(0.9)
		pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage:setPosition(AUTO_POS(0.00, -6.00))
		pLabel:setAnchorPoint(ANCHOR_CENTER)
		pLabel:setPosition(CCPointMake(SX(44), pImage:getContentSize().height/2))
		pLabel:setColor(ccc4(255, 0, 0, 255))
		pImage:addChild(tolua.cast(pLabel, "SCNode"))
	end
	
	local ActionNode = ActionNode:newActionNode();
	local width = pNode:getContentSize().width - pImage:getContentSize().width - SX(22)
	local height = pNode:getContentSize().height - pImage:getContentSize().height --+ SY(293)
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
		ActionNode:setPosition(CCPointMake(width, height));
		ActionNode:moveToRetuen(CCPointMake(width - SX(2), height), CCPointMake(width - SX(6), height), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"))
	end
end

--创建向上引导箭头
function GuidePoint_createUpGuideNode(pNode)
    if pNode == nil then
        return
    end
    local partent = pNode:getParent();
    if partent == nil then
        return;
    end
    partent:reorderChild(pNode, 999)

	local imgPath = getRealUIResourcePath("img/new00621.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData())
	if pImage == nil then
	    return;
	end
    pImage:setTag(1001)
    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
    pImage:setPosition(AUTO_POS(0.00, 0.00))
	
	local ActionNode = ActionNode:newActionNode();
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_CENTER);
		ActionNode:setPosition(CCPointMake(pNode:getContentSize().width/2, SY(-8)));
		ActionNode:moveToRetuen(CCPointMake(pNode:getContentSize().width/2, SY(-8)), CCPointMake(pNode:getContentSize().width/2, SY(-12)), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"));
	end
end

--创建向下手指引导
function GuidePoint_createUpHandGuideNode(pNode)
    if pNode == nil then
        return
    end

	local imgPath = getRealUIResourcePath("img/img3000055.png")
	if imgPath == nil then
	    return;
	end
	local pImage = SCImage:imageWithFile(imgPath:getData())
	if pImage == nil then
	    return;
	end
    pImage:setTag(1001)
    pImage:setFlipY(true)
    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
    pImage:setPosition(AUTO_POS(0.00, 0.00))
	
	local ActionNode = ActionNode:newActionNode();
	if ActionNode then
		ActionNode:setTag(1000)
		ActionNode:setContentSize(pImage:getContentSize());
		ActionNode:setAnchorPoint(ANCHOR_CENTER);
		ActionNode:setPosition(CCPointMake(pNode:getContentSize().width/2, pNode:getContentSize().height+SY(12)));
		ActionNode:moveToRetuen(CCPointMake(pNode:getContentSize().width/2, pNode:getContentSize().height+SY(12)), CCPointMake(pNode:getContentSize().width/2, pNode:getContentSize().height+SY(16)), 0.2);
		ActionNode:addChild(tolua.cast(pImage, "SCNode"))
		pNode:addChild(tolua.cast(ActionNode, "SCNode"));
	end
end

--1级礼包引导事件
function GuidePoint_setStepInfo(dt)
    if dt == nil then
        return;
    end
	local ByFlag = dt:readByte()   
	local usPlace = dt:readShort()
	if ByFlag == OPEN_GIFTBOX then   --1级礼包
	    table.insert(m_guidetable, GUIDE_TYPE_NewPlayer);
		if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_NewPlayer);
			GuidePoint_createNewPlayer(m_Value[GUIDE_TYPE_NewPlayer].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_NewPlayer);
			GuidePoint_createNewPlayer(m_Value[GUIDE_TYPE_NewPlayer].info)
			isOpenTimer = isOpenTimer + 1
		end
	end
end

--技能升级引导事件
function GuidePoint_setStepSkillInfo(dt)
    if dt == nil then
        return;
    end
	local Skill = dt:readInt()   --学习技能引导
	if Skill == 101005001 or Skill == 104007001 or Skill == 102005001 or Skill == 103007001 then
	    table.insert(m_guidetable, GUIDE_TYPE_Skill);
        --不写
        if isOpenTimer == 0 then
            GuidePoint_Init(GUIDE_TYPE_Skill);
            GuidePoint_createSkill(m_Value[GUIDE_TYPE_Skill].info)
            isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
        else
            GuidePoint_Init(GUIDE_TYPE_Skill);
            GuidePoint_createSkill(m_Value[GUIDE_TYPE_Skill].info)
            isOpenTimer = isOpenTimer + 1
        end
    elseif Skill == 101009001 or Skill == 104006001 or Skill == 102009001 or Skill == 103009001 then
        SkillView.Init(Skill)
        SkillView.Window()
    else
        SkillView.Init(Skill)
        SkillView.Window()
    end
end

--自动引导事件
function GuidePoint_setAutoInfo(unLock)
	if unLock == UNLOCK_TYPE_EQUIP_STRENGTHEN then  --强化引导
	    --[[table.insert(m_guidetable, GUIDE_TYPE_Strong);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Strong);
			GuidePoint_creaInlayrong(m_Value[GUIDE_TYPE_Strong].info)
			isOpenTimer = isOpenTimer + 1
			m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		else
			GuidePoint_Init(GUIDE_TYPE_Strong);
			GuidePoint_creaInlayrong(m_Value[GUIDE_TYPE_Strong].info)
			isOpenTimer = isOpenTimer + 1
		end--]]
	elseif unLock == UNLOCK_TYPE_TYPE1 then  --每日俸禄引导
	    table.insert(m_guidetable, GUIDE_TYPE_Salary);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Salary);
			GuidePoint_createSalary(m_Value[GUIDE_TYPE_Salary].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Salary);
			GuidePoint_createSalary(m_Value[GUIDE_TYPE_Salary].info)
			isOpenTimer = isOpenTimer + 1
		end
	elseif unLock == UNLOCK_TYPE_SEVEN_GIFT then  --七日引导
	    table.insert(m_guidetable, GUIDE_TYPE_SevenDay);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_SevenDay);
			GuidePoint_createSevenDay(m_Value[GUIDE_TYPE_SevenDay].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_SevenDay);
			GuidePoint_createSevenDay(m_Value[GUIDE_TYPE_SevenDay].info)
			isOpenTimer = isOpenTimer + 1
		end
	elseif unLock == 1000 then  --镶嵌引导
	    table.insert(m_guidetable, GUIDE_TYPE_Challenge);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Challenge);
			GuidePoint_createChallenge(m_Value[GUIDE_TYPE_Challenge].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Challenge);
			GuidePoint_createChallenge(m_Value[GUIDE_TYPE_Challenge].info)
			isOpenTimer = isOpenTimer + 1
		end
    end
end

function GuidePoint_EquipWeapon()
	local item = nil
	local flag = Hero:getSingleton():getProfessionID();
	if flag == 1 then    --龙骑
		item = ItemProcessor:getSingleton():getItemByTypeID(100000105);
	elseif flag == 3 then   --弓箭
		item = ItemProcessor:getSingleton():getItemByTypeID(100000305);
	elseif flag == 4 then   --军师
		item = ItemProcessor:getSingleton():getItemByTypeID(100000405);
	elseif flag == 2 then   --双剑
		item = ItemProcessor:getSingleton():getItemByTypeID(100000205);
	end	
	
	return item
end

local function FreeAllData()
	if m_entryId then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		m_entryId = nil
	end
	
	if m_entryId1 then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId1)
		m_entryId1 = nil
	end
	
	if m_entryId2 then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId2)
		m_entryId2 = nil
	end
	
	m_Value = {}
	m_guidetable = {}
	pNeedNode = nil
	isOpenTimer = 0
	
	local node = SCFunction:getUiNodeByIdlist("5918-5936-12-1-28")
	if node then
		node:removeChildByTag(1000, true);
	end
end

--服务端引导事件
function GuidePoint_setSeverInfo()
    local dt = LuaData:getSingleton():getDataTransStream();  ---获取当前的数据对象
	if dt == nil then
	    return
	end
    local type   = dt:readInt()
    local id     = dt:readInt()
    if type == GUIDE_TYPE_CHALLENGE_COPY then  --宝箱引导
        table.insert(m_guidetable, GUIDE_TYPE_Award);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Award);
			GuidePoint_createAward(m_Value[GUIDE_TYPE_Award].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Award);
			GuidePoint_createAward(m_Value[GUIDE_TYPE_Award].info)
			isOpenTimer = isOpenTimer + 1
		end
	elseif type == GUIDE_TYPE_LEARN_SKILL then  --副本技能引导
	    table.insert(m_guidetable, GUIDE_TYPE_CSkill);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_CSkill);
			local tmp = {}
            local typeId = TableParser:getSingleton():getMagicTypeByKey(id)
            local value = nil
            if typeId.id ~= 0 then
                value = typeId.position - 1
            end
			if value == 1 then
                tmp.strlist = "5002"
            elseif value == 2 then
                tmp.strlist = "5003"
            elseif value == 3 then
                tmp.strlist = "5004"
            elseif value == 4 then
                tmp.strlist = "5005"
            elseif value == 5 then
                tmp.strlist = "5006-5006"
            end
            table.insert(m_Value[GUIDE_TYPE_CSkill].info, tmp)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_CSkill);
			local tmp = {}
            local typeId = TableParser:getSingleton():getMagicTypeByKey(id)
            local value = nil
            if typeId.id ~= 0 then
                value = typeId.position - 1
            end
			if value == 1 then
                tmp.strlist = "5002"
            elseif value == 2 then
                tmp.strlist = "5003"
            elseif value == 3 then
                tmp.strlist = "5004"
            elseif value == 4 then
                tmp.strlist = "5005"
            elseif value == 5 then
                tmp.strlist = "5006-5006"
            end
            table.insert(m_Value[GUIDE_TYPE_CSkill].info, tmp)
			isOpenTimer = isOpenTimer + 1
		end
	elseif type == GUIDE_TYPE_BUY_POWER then  --体力引导  100 then   --
	    table.insert(m_guidetable, GUIDE_TYPE_Strength);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Strength);
			GuidePoint_creaInlayrength(m_Value[GUIDE_TYPE_Strength].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Strength);
			GuidePoint_creaInlayrength(m_Value[GUIDE_TYPE_Strength].info)
			isOpenTimer = isOpenTimer + 1
		end
	elseif type == GUIDE_TYPE_AREAN then  --竞技引导
	    table.insert(m_guidetable, GUIDE_TYPE_Challenge);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Challenge);
			GuidePoint_createChallenge(m_Value[GUIDE_TYPE_Challenge].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Challenge);
			GuidePoint_createChallenge(m_Value[GUIDE_TYPE_Challenge].info)
			isOpenTimer = isOpenTimer + 1
		end
	elseif type == GUIDE_TYPE_NEWBIE_EMONEY then  --奖励引导
	    --[[table.insert(m_guidetable, GUIDE_TYPE_Reward);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Reward);
			GuidePoint_createReward(m_Value[GUIDE_TYPE_Reward].info)
			isOpenTimer = isOpenTimer + 1
			m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		else
			GuidePoint_Init(GUIDE_TYPE_Reward);
			GuidePoint_createReward(m_Value[GUIDE_TYPE_Reward].info)
			isOpenTimer = isOpenTimer + 1
		end--]]
	elseif type == GUIDE_TYPE_FIRST_RECHARGE_GIFT then  --首冲引导
	    --[[table.insert(m_guidetable, GUIDE_TYPE_FirstRech1);
	    if id == 1 then  --已充值
            if isOpenTimer == 0 then
                GuidePoint_Init(GUIDE_TYPE_FirstRech1);
                GuidePoint_createFirstRech1(m_Value[GUIDE_TYPE_FirstRech1].info)
                isOpenTimer = isOpenTimer + 1
                m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
            else
                GuidePoint_Init(GUIDE_TYPE_FirstRech1);
                GuidePoint_createFirstRech1(m_Value[GUIDE_TYPE_FirstRech1].info)
                isOpenTimer = isOpenTimer + 1
            end
        else  
            if isOpenTimer == 0 then
                GuidePoint_Init(GUIDE_TYPE_FirstRech);
                GuidePoint_createFirstRech(m_Value[GUIDE_TYPE_FirstRech].info)
                isOpenTimer = isOpenTimer + 1
                m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
            else
                GuidePoint_Init(GUIDE_TYPE_FirstRech);
                GuidePoint_createFirstRech(m_Value[GUIDE_TYPE_FirstRech].info)
                isOpenTimer = isOpenTimer + 1
            end
        end--]]
    --[[elseif type == GUIDE_TYPE_FLIP_OVER then  --大泽山斩魔2副本引导
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Copy);
			GuidePoint_createCopy(m_Value[GUIDE_TYPE_Copy].info)
			isOpenTimer = isOpenTimer + 1
			m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		else
			GuidePoint_Init(GUIDE_TYPE_Copy);
			GuidePoint_createCopy(m_Value[GUIDE_TYPE_Copy].info)
			isOpenTimer = isOpenTimer + 1
		end--]]
	elseif type == GUIDE_TYPE_RECRUITPARTNER then  --武将招募引导
		FreeAllData();
	    table.insert(m_guidetable, GUIDE_TYPE_BlowRecruit);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_BlowRecruit);
			GuidePoint_createBlowRecruit(m_Value[GUIDE_TYPE_BlowRecruit].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_BlowRecruit);
			GuidePoint_createBlowRecruit(m_Value[GUIDE_TYPE_BlowRecruit].info)
			isOpenTimer = isOpenTimer + 1
		end
		MainInterface_ShowBtn();
		local Wnd = SCFunction:getUiNodeByIdlist("2011")
		if Wnd then
			Wnd:removeChildByTag(1000, true);
		end
	elseif type == GUIDE_TYPE_MONEY_TREE then  --摇钱树引导
	    table.insert(m_guidetable, GUIDE_TYPE_Tree);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Tree);
			GuidePoint_createTree(m_Value[GUIDE_TYPE_Tree].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Tree);
			GuidePoint_createTree(m_Value[GUIDE_TYPE_Tree].info)
			isOpenTimer = isOpenTimer + 1
		end
    elseif type == GUIDE_TYPE_ADDUP_ONLINE_GIFT then  --在线礼包引导
	
		
		if true then
			return
		end
	    table.insert(m_guidetable, GUIDE_TYPE_Reward);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Reward);
			GuidePoint_createReward(m_Value[GUIDE_TYPE_Reward].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Reward);
			GuidePoint_createReward(m_Value[GUIDE_TYPE_Reward].info)
			isOpenTimer = isOpenTimer + 1
		end
	elseif type == GUIDE_TYPE_AREAN_AWARD then  --竞技礼包引导
	    table.insert(m_guidetable, GUIDE_TYPE_Sports);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Sports);
			GuidePoint_createSports(m_Value[GUIDE_TYPE_Sports].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Sports);
			GuidePoint_createSports(m_Value[GUIDE_TYPE_Sports].info)
			isOpenTimer = isOpenTimer + 1
		end
	elseif type == GUIDE_TYPE_GEM_INLAY then  --镶嵌引导
	    local item = GuidePoint_EquipWeapon();
	    if item then
	        if item:getPostion() > 0 then
                local item = ItemProcessor:getSingleton():getItemByTypeID(3900110001);
                if item then
					table.insert(m_guidetable, GUIDE_TYPE_Inlay);
                    m_idtype1 = 1;
                    if isOpenTimer == 0 then
                        MainInterface_ShowBtn();
                        GuidePoint_Init(GUIDE_TYPE_Inlay);
                        GuidePoint_createInlay1(m_Value[GUIDE_TYPE_Inlay].info)
                        isOpenTimer = isOpenTimer + 1
                        if m_entryId == nil then
                            m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
                        end
                    else
                        GuidePoint_Init(GUIDE_TYPE_Inlay);
                        GuidePoint_createInlay1(m_Value[GUIDE_TYPE_Inlay].info)
                        isOpenTimer = isOpenTimer + 1
                    end
                else
                    --[[if isOpenTimer == 0 then
                        GuidePoint_Init(GUIDE_TYPE_Inlay);
                        GuidePoint_createInlay1(m_Value[GUIDE_TYPE_Inlay].info)
                        isOpenTimer = isOpenTimer + 1
                        if m_entryId == nil then
                            m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
                        end
                    else
                        GuidePoint_Init(GUIDE_TYPE_Inlay);
                        GuidePoint_createInlay1(m_Value[GUIDE_TYPE_Inlay].info)
                        isOpenTimer = isOpenTimer + 1
                    end]]
                end
            end
        end
	elseif type == GUIDE_TYPE_SEVEN_GIFT then  --七日引导
	    table.insert(m_guidetable, GUIDE_TYPE_SevenDay);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_SevenDay);
			GuidePoint_createSevenDay(m_Value[GUIDE_TYPE_SevenDay].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_SevenDay);
			GuidePoint_createSevenDay(m_Value[GUIDE_TYPE_SevenDay].info)
			isOpenTimer = isOpenTimer + 1
		end
	elseif type == GUIDE_TYPE_RUNE_STONE then  --刻印引导
	    local str = {3801100000, 3801200000, 3801300000, 3801400000, 3801500000, 3801600000}
        local item = nil
        for i = 1, 6 do
            item = ItemProcessor:getSingleton():getItemByTypeID(str[i]);
            if item then
                break;
            end
        end
        if item then
	        table.insert(m_guidetable, GUIDE_TYPE_Mark);
            if isOpenTimer == 0 then
                GuidePoint_Init(GUIDE_TYPE_Mark);
                GuidePoint_createMark(m_Value[GUIDE_TYPE_Mark].info)
                isOpenTimer = isOpenTimer + 1
                if m_entryId == nil then
                    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
                end
            else
                GuidePoint_Init(GUIDE_TYPE_Mark);
                GuidePoint_createMark(m_Value[GUIDE_TYPE_Mark].info)
                isOpenTimer = isOpenTimer + 1
            end
        end
	elseif type == GUIDE_TYPE_EQUIP_STRENGTHEN then  --强化引导
	    table.insert(m_guidetable, GUIDE_TYPE_Strong);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Strong);
			GuidePoint_creaInlayrong(m_Value[GUIDE_TYPE_Strong].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Strong);
			GuidePoint_creaInlayrong(m_Value[GUIDE_TYPE_Strong].info)
			isOpenTimer = isOpenTimer + 1
		end
    elseif type == GUIDE_TYPE_LOOT_ESCORT then
        --添加押镖版本限制
        if CLIENT_VERSION < 328 then
            return
        end
        Escort_StartGuideTimeDown()
        table.insert(m_guidetable, GUIDE_TYPE_Escort);
        if isOpenTimer == 0 then
			GuidePoint_Init(GUIDE_TYPE_Escort);
			GuidePoint_CreateEscort(m_Value[GUIDE_TYPE_Escort].info)
			isOpenTimer = isOpenTimer + 1
			if m_entryId == nil then
			    m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		    end
		else
			GuidePoint_Init(GUIDE_TYPE_Escort);
			GuidePoint_CreateEscort(m_Value[GUIDE_TYPE_Escort].info)
			isOpenTimer = isOpenTimer + 1
		end
    end
end

--1级礼包引导表
function GuidePoint_createNewPlayer(stepInfo)
    if stepInfo == nil then
        return;
    end
	--1、点击人物
	local tmp = {}
	tmp.strlist = "5918-5933-1-1001"
	table.insert(stepInfo, tmp)
	--2、点击礼包
	local tmp = {}
	local item = ItemProcessor:getSingleton():getItemByTypeID(3461000140);
    if item then
        local id = item:getPlace();
        local page = getIntPart(id / 16)
        local row = getIntPart(id%20/5)
        local col = id%25%5
        tmp.strlist = "2011-9999-2008-2008-1-"..page.."-"..id;
        table.insert(stepInfo, tmp)
    end
    --3、打开礼包
	local tmp = {}
	tmp.strlist = "888888-0"
	table.insert(stepInfo, tmp)
	--4、装备武器
	local tmp = {}
	tmp.strlist = "888888-1-1-0"
	table.insert(stepInfo, tmp)
end

--技能引导
function GuidePoint_createSkill(stepInfo)
    if stepInfo == nil then
        return;
    end
	--1、点击技能图标
	local tmp = {}
	tmp.strlist = "5918-5936-12-1-17"
	table.insert(stepInfo, tmp)
	--2、点击技能
	local tmp = {}
	tmp.strlist = "2011-1-2-17-0-4-1005"
	table.insert(stepInfo, tmp)
	--2、点击升级
	local tmp = {}
	tmp.strlist = "2011-1-3-9"
	table.insert(stepInfo, tmp)
end

--宝箱奖励引导
function GuidePoint_createAward(stepInfo)
    if stepInfo == nil then
        return;
    end
	--1、点击确定
	local tmp = {}
	tmp.strlist = "7025-13"
	table.insert(stepInfo, tmp)
	--2、点击宝箱
	local tmp = {}
	tmp.strlist = "7025-1000"
	table.insert(stepInfo, tmp)
    --3、点击确定
	local tmp = {}
	tmp.strlist = "7025-7026-2"
	table.insert(stepInfo, tmp)
end

--七日奖励引导
function GuidePoint_createSevenDay(stepInfo)
    if stepInfo == nil then
        return;
    end
	--1、点击确定
	local tmp = {}
	tmp.strlist = "5918-5932-1010"
	table.insert(stepInfo, tmp)
	--2、点击宝箱
	local tmp = {}
	tmp.strlist = "11003-1-1-2-25"
	table.insert(stepInfo, tmp)
	--3、点击领取按钮
	local tmp = {}
	tmp.strlist = "7027-1-1-100091"
	table.insert(stepInfo, tmp)
	--4、点击关闭按钮
	local tmp = {}
	tmp.strlist = "7027-1-10006"
	table.insert(stepInfo, tmp)
end

--强化装备引导
function GuidePoint_creaInlayrong(stepInfo)
    if stepInfo == nil then
        return;
    end
	--1、点击强化
	local tmp = {}
	tmp.strlist = "5918-5936-12-1-28"
	table.insert(stepInfo, tmp)
	--2、点击装备
	local tmp = {}
	tmp.strlist = "0-4"
	table.insert(stepInfo, tmp)
	--3、点击强化
	local tmp = {}
	tmp.strlist = "9"
	table.insert(stepInfo, tmp)
	--4、点击关闭窗口
	local tmp = {}
	tmp.strlist = "7022"
	table.insert(stepInfo, tmp)
end

--增加体力引导
function GuidePoint_creaInlayrength(stepInfo)
    if stepInfo == nil then
        return;
    end
	--1、点击加体力
	local tmp = {}
	tmp.strlist = "5918-5936-20-15"
	table.insert(stepInfo, tmp)
end

--增加挑战引导
function GuidePoint_createChallenge(stepInfo)
    if stepInfo == nil then
        return;
    end
	--1、点击挑战
	local tmp = {}
	tmp.strlist = "5918-5932-6"
	table.insert(stepInfo, tmp)
	--2、点击竞技场
	local tmp = {}
	--tmp.strlist = "4427-10004-103"
	tmp.strlist = "4427-2-34"   --新挑战界面需要改引导
	table.insert(stepInfo, tmp)
	--3、点击人物
	local tmp = {}
	tmp.strlist = "1012-3-21-101-1"
	table.insert(stepInfo, tmp)
	--4、无用节点
	local tmp = {}
	tmp.strlist = "1012-3-21-101-1"
	table.insert(stepInfo, tmp)
	--5、点击关闭
	local tmp = {}
	tmp.strlist = "1012"
	table.insert(stepInfo, tmp)
end

--奖励引导
function GuidePoint_createReward(stepInfo)
    if stepInfo == nil then
        return;
    end
    --1、点击奖励
	local tmp = {}
	tmp.strlist = "5918-5932-1010"
	table.insert(stepInfo, tmp)
	--2、点击奖励
	local tmp = {}
	tmp.strlist = "11003-1-1-2-62"
	table.insert(stepInfo, tmp)
end

--首冲引导未充值
function GuidePoint_createFirstRech(stepInfo)
    if stepInfo == nil then
        return;
    end
    --1、点击奖励
	local tmp = {}
	tmp.strlist = "5918-5932-1010"
	table.insert(stepInfo, tmp)
	--2、点击首冲
	local tmp = {}
	tmp.strlist = "5918-5932-1010-5914-51"
	table.insert(stepInfo, tmp)
	--3、点击充值
	local tmp = {}
	tmp.strlist = "4423-1-10013"
	table.insert(stepInfo, tmp)
end

--首冲引导已充值
function GuidePoint_createFirstRech1(stepInfo)
    if stepInfo == nil then
        return;
    end
    --1、点击奖励
	local tmp = {}
	tmp.strlist = "5918-5932-1010"
	table.insert(stepInfo, tmp)
	--2、点击首冲
	local tmp = {}
	tmp.strlist = "5918-5932-1010-5914-51"
	table.insert(stepInfo, tmp)
	--3、点击领取
	local tmp = {}
	tmp.strlist = "4423-1-10007"
	table.insert(stepInfo, tmp)
	--4、点击关闭
	local tmp = {}
	tmp.strlist = "4423-1-10006"
	table.insert(stepInfo, tmp)
end

--每日俸禄引导
function GuidePoint_createSalary(stepInfo)
    if stepInfo == nil then
        return;
    end
    --1、点击每日
	local tmp = {}
	tmp.strlist = "5918-5932-1"
	table.insert(stepInfo, tmp)
	--2、点击领取
	local tmp = {}
	tmp.strlist = "9006-10005"
	table.insert(stepInfo, tmp)
	--3、点击关闭
	local tmp = {}
	tmp.strlist = "9006-10013"
	table.insert(stepInfo, tmp)
end

--大泽山斩魔2副本引导
--[[function GuidePoint_createCopy(stepInfo)
    --1、点击下一页
	local tmp = {}
	tmp.strlist = "2023-100"
	table.insert(stepInfo, tmp)
end--]]

--武将招募引导
function GuidePoint_createBlowRecruit(stepInfo)
    if stepInfo == nil then
        return;
    end
    --1、点击武将
	local tmp = {}
	tmp.strlist = "5918-5933-1-32"
	table.insert(stepInfo, tmp)
	--2、点击天牢
	local tmp = {}
	tmp.strlist = "7020-1"
	table.insert(stepInfo, tmp)
	--3、点击招募
	local tmp = {}
	tmp.strlist = "7020-1-2-2-3"
	table.insert(stepInfo, tmp)
	--4、点击培养
	local tmp = {}
	tmp.strlist = "6001-1-7-11"
	table.insert(stepInfo, tmp)
	--5、点击招降
	local tmp = {}
	tmp.strlist = "6001-1-14"
	table.insert(stepInfo, tmp)
	--6、点击武将
	local tmp = {}
	tmp.strlist = "7020-10003"
	table.insert(stepInfo, tmp)
	--7、点击出战
	local tmp = {}
	tmp.strlist = "7020-1-1-1-2-7"
	table.insert(stepInfo, tmp)
	--8、点击关闭
	local tmp = {}
	tmp.strlist = "7020-5918742"
	table.insert(stepInfo, tmp)
end

--成长礼包引导表
function GuidePoint_createGoods(stepInfo, itemtypeid)
    if stepInfo == nil then
        return;
    end
	--1、点击礼包
	local tmp = {}
	local item = ItemProcessor:getSingleton():getItemByTypeID(itemtypeid);
    if item then
        local id = (item:getPlace())%16;
        local page = getIntPart((item:getPlace()) / 16)
        --local row = getIntPart(id%20/5)
        --local col = id%25%5
        tmp.strlist = "2011-9999-2008-2008-1-"..page.."-"..id;
        table.insert(stepInfo, tmp)
    end
    --2、打开礼包
	local tmp = {}
	tmp.strlist = "888888-0"
	table.insert(stepInfo, tmp)
end

--摇钱树引导
function GuidePoint_createTree(stepInfo)
    if stepInfo == nil then
        return;
    end
    --1、点击赚钱
	local tmp = {}
	tmp.strlist = "5918-5932-9"
	table.insert(stepInfo, tmp)
	--2、点击立即进入
	local tmp = {}
	tmp.strlist = "9002-10022-6003-3"
	table.insert(stepInfo, tmp)
end

--竞技场礼包引导
function GuidePoint_createSports(stepInfo)
    if stepInfo == nil then
        return;
    end
    --1、点击奖励
	local tmp = {}
	tmp.strlist = "5918-5932-1010"
	table.insert(stepInfo, tmp)
	--2、点击礼包
	local tmp = {}
	tmp.strlist = "5918-5932-1010-5914-64"
	table.insert(stepInfo, tmp)
end

function GuidePoint_createInlay(stepInfo)  --宝箱 红宝石
    if stepInfo == nil then
        return;
    end
    --1、点击人物
	local tmp = {}
	tmp.strlist = "5918-5933-1-1001"
	table.insert(stepInfo, tmp)
    --2、点击礼包
	local tmp = {}
	local item = ItemProcessor:getSingleton():getItemByTypeID(3461000141); --宝箱
    if item then
        local id = (item:getPlace())%16;
        local page = getIntPart((item:getPlace()) / 16)
        tmp.strlist = "2011-9999-2008-2008-1-"..page.."-"..id;
        table.insert(stepInfo, tmp)
    end
    --3、打开礼包
	local tmp = {}
	tmp.strlist = "888888-0"
	table.insert(stepInfo, tmp)
end

function GuidePoint_createInlay1(stepInfo)  --红宝石
    if stepInfo == nil then
        return;
    end
    --1、点击人物
	local tmp = {}
	tmp.strlist = "5918-5933-1-1001"
	table.insert(stepInfo, tmp)
	--2、点击红宝石
	local tmp = {}
	local item = ItemProcessor:getSingleton():getItemByTypeID(3900110001);  --红宝石
    if item then
        local id = (item:getPlace())%16;
        local page = getIntPart((item:getPlace()) / 16)
        tmp.strlist = "2011-9999-2008-2008-1-"..page.."-"..id;
        table.insert(stepInfo, tmp)
    end
    --3、打开镶嵌
	local tmp = {}
	tmp.strlist = "888888-0"
	table.insert(stepInfo, tmp)
	--4、点击镶嵌
	local tmp = {}
	tmp.strlist = "11"
	table.insert(stepInfo, tmp)
	--5、点击关闭
	local tmp = {}
	tmp.strlist = "7022"
	table.insert(stepInfo, tmp)
end

--刻印引导表
function GuidePoint_createMark(stepInfo)
    if stepInfo == nil then
        return;
    end
    --1、点击人物
	local tmp = {}
	tmp.strlist = "5918-5933-1-1001"
	table.insert(stepInfo, tmp)
	--2、点击符石
	local tmp = {}
	local str = {3801100000, 3801200000, 3801300000, 3801400000, 3801500000, 3801600000}
	local item = nil
	for i = 1, 6 do
	    item = ItemProcessor:getSingleton():getItemByTypeID(str[i]);
	    if item then
	        break;
	    end
	end
    if item then
        local id = (item:getPlace())%16;
        local page = getIntPart((item:getPlace()) / 16)
        tmp.strlist = "2011-9999-2008-2008-1-"..page.."-"..id;
        table.insert(stepInfo, tmp)
    else
        tmp.strlist = "0";
        table.insert(stepInfo, tmp)
    end
    --3、打开刻印
	local tmp = {}
	tmp.strlist = "888888-0"
	table.insert(stepInfo, tmp)
	--4、元宝刻印
	local tmp = {}
	tmp.strlist = "14"
	table.insert(stepInfo, tmp)
	--5、点击关闭
	local tmp = {}
	tmp.strlist = "7022"
	table.insert(stepInfo, tmp)
end

function GuidePoint_CreateEscort(stepInfo)
    if not stepInfo then return end 
     --1、点击邮件
	local tmp = {}
	tmp.strlist = "9115"
	table.insert(stepInfo, tmp)
	--2、点击前往
	local tmp = {}
	tmp.strlist = "788889-1"	
	table.insert(stepInfo, tmp)
	--3、点击仇人
	local tmp = {}
	tmp.strlist = "9110-51"	
	table.insert(stepInfo, tmp)
	--4、夺回物资
	local tmp = {}
	tmp.strlist = "9112-101"
	table.insert(stepInfo, tmp)
end
--1级礼包引导顺序
function GuidePoint_NewPlayer()
    local pNode = nil
    local pReMoveNode = nil
	if m_Value[GUIDE_TYPE_NewPlayer] ~= nil then
		if m_Value[GUIDE_TYPE_NewPlayer].num == 0 then   --点击人物
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_NewPlayer].info[m_Value[GUIDE_TYPE_NewPlayer].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				if not getCurentSceneWindowController(7002) then
				    removeAllWindwoController();
				end
			end
			--m_Value[GUIDE_TYPE_NewPlayer].num = m_Value[GUIDE_TYPE_NewPlayer].num + 1
		elseif m_Value[GUIDE_TYPE_NewPlayer].num == 1 then   --点击礼包
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_NewPlayer].info[m_Value[GUIDE_TYPE_NewPlayer].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_NewPlayer].info[m_Value[GUIDE_TYPE_NewPlayer].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			GuidePoint_createUpGuideNode(pNode)
			m_Value[GUIDE_TYPE_NewPlayer].num = m_Value[GUIDE_TYPE_NewPlayer].num + 1;
			--CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		elseif m_Value[GUIDE_TYPE_NewPlayer].num == 2 then   --点击打开
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_NewPlayer].info[m_Value[GUIDE_TYPE_NewPlayer].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_NewPlayer].num == 3 then
			local item = nil;
			local num = nil;
			if pNeedNode then
				pNeedNode:removeChildByTag(1000, true);
				pNeedNode = nil
			end
			local flag = Hero:getSingleton():getProfessionID();
			if flag == 1 then    --龙骑
                for i = 1, 6 do
                    local j = nil
                    if i == 2 then
                        j = 3
                    elseif i == 3 then
                        j = 2
                    else
                        j = i
                    end
                    item = ItemProcessor:getSingleton():getItemByTypeID(105 + j*100000000);
                    if item then
                        num = item:getPostion()
                        if num == 0 then
                            local id = item:getPlace();
                            local page = getIntPart(id / 16)
                            pNode = SCFunction:getUiNodeByIdlist("2011-9999-2008-2008-1-"..page.."-"..id);
                            pNeedNode = pNode;
                            break;
                        end
                    end
                end
            elseif flag == 3 then   --弓箭
                for i = 1, 6 do
                    if i == 1 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(100000305);
                    elseif i == 2 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(300000305);
                    elseif i == 3 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(200000105);
                    elseif i == 4 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(400000105);
                    elseif i == 5 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(500000105);
                    elseif i == 6 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(600000105);
                    end
                    if item then
                        num = item:getPostion()
                        if num == 0 then
                            local id = item:getPlace();
                            local page = getIntPart(id / 16)
                            pNode = SCFunction:getUiNodeByIdlist("2011-9999-2008-2008-1-"..page.."-"..id);
                            pNeedNode = pNode;
                            break;
                        end
                    end
                end
            elseif flag == 4 then   --军师
                for i = 1, 6 do
                    if i == 1 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(100000405);
                    elseif i == 2 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(300000405);
                    elseif i == 3 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(200000105);
                    elseif i == 4 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(400000105);
                    elseif i == 5 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(500000105);
                    elseif i == 6 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(600000105);
                    end
                    if item then
                        num = item:getPostion()
                        if num == 0 then
                            local id = item:getPlace();
                            local page = getIntPart(id / 16)
                            pNode = SCFunction:getUiNodeByIdlist("2011-9999-2008-2008-1-"..page.."-"..id);
                            pNeedNode = pNode;
                            break;
                        end
                    end
                end
            elseif flag == 2 then   --双剑
                for i = 1, 6 do
                    if i == 1 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(100000205);
                    elseif i == 2 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(300000205);
                    elseif i == 3 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(200000105);
                    elseif i == 4 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(400000105);
                    elseif i == 5 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(500000105);
                    elseif i == 6 then
                        item = ItemProcessor:getSingleton():getItemByTypeID(600000105);
                    end
                    if item then
                        num = item:getPostion()
                        if num == 0 then
                            local id = item:getPlace();
                            local page = getIntPart(id / 16)
                            pNode = SCFunction:getUiNodeByIdlist("2011-9999-2008-2008-1-"..page.."-"..id);
                            pNeedNode = pNode;
                            break;
                        end
                    end
                end
            end
			if num == nil then
				return;
			end
			if num > 0 then
				local Wnd = SCFunction:getUiNodeByIdlist("2011")
				if Wnd == nil then
				   return;
				end
				GuidePoint_createCloseWndGuideNode(Wnd)
				isOpenTimer = isOpenTimer - 1;
				m_Value[GUIDE_TYPE_NewPlayer] = nil
				if isOpenTimer == 0 then
					CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
					m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    GuidePoint_topGuide()
				end
                return;
			end        
			GuidePoint_createUpGuideNode(pNode)
			if m_Value[GUIDE_TYPE_NewPlayer] then
			    m_Value[GUIDE_TYPE_NewPlayer].num = m_Value[GUIDE_TYPE_NewPlayer].num + 1;
			end
		elseif m_Value[GUIDE_TYPE_NewPlayer].num == 4 then
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_NewPlayer].info[m_Value[GUIDE_TYPE_NewPlayer].num].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		end
	end
end

local function GuidePoint_Skill_Clear()
	local pNode = SCFunction:getUiNodeByIdlist("5918-5936-12-1-17")
	if pNode then
		pNode:removeChildByTag(1000, true);
		isOpenTimer = isOpenTimer - 1;
		m_Value[GUIDE_TYPE_Skill] = nil
		if isOpenTimer == 0 then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
			m_entryId = nil
			m_Value = {}
			m_guidetable = {}
			pNeedNode = nil
			GuidePoint_topGuide()
		end
	end
end

--技能引导顺序
function GuidePoint_Skill()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Skill] ~= nil then
		if m_Value[GUIDE_TYPE_Skill].num == 0 then   --点击技能图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Skill].info[m_Value[GUIDE_TYPE_Skill].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createLeftGuideNode(pNode)
			end
			--m_Value[GUIDE_TYPE_Skill].num = m_Value[GUIDE_TYPE_Skill].num + 1;
		elseif m_Value[GUIDE_TYPE_Skill].num == 1 then   --点击技能
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Skill].info[m_Value[GUIDE_TYPE_Skill].num+1].strlist)
			if pNode == nil then
				GuidePoint_Skill_Clear();
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Skill].info[m_Value[GUIDE_TYPE_Skill].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createSetDownGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Skill].num == 2 then   --点击升级技能
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Skill].info[m_Value[GUIDE_TYPE_Skill].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Skill].info[m_Value[GUIDE_TYPE_Skill].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Skill].num == 3 then   --点击关闭窗口
		    local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Skill].info[m_Value[GUIDE_TYPE_Skill].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
            local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Skill].info[m_Value[GUIDE_TYPE_Skill].num-1].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local Wnd = SCFunction:getUiNodeByIdlist("2011")
			if Wnd == nil then
			    return;
			end
			GuidePoint_createCloseWndGuideNode(Wnd)
			--GuideTip.Window(3);
			isOpenTimer = isOpenTimer - 1;
			m_Value[GUIDE_TYPE_Skill] = nil
			if isOpenTimer == 0 then
				CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
				m_entryId = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                GuidePoint_topGuide()
			end
		end
	end
end

function GuidePoint_Award_Clear()
	if m_Value[GUIDE_TYPE_Award] ~= nil then
		isOpenTimer = isOpenTimer - 1;
		m_Value[GUIDE_TYPE_Award] = nil
		if isOpenTimer == 0 then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
			m_entryId = nil
			m_Value = {}
			m_guidetable = {}
			pNeedNode = nil
			GuidePoint_topGuide()
		end
	end
end

--宝箱奖励引导顺序
function GuidePoint_Award()
	local pNode = nil
	if m_Value[GUIDE_TYPE_Award] ~= nil then
		if m_Value[GUIDE_TYPE_Award].num == 0 then   --点击技能图标
		    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
            if mapLay then
                local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
                if pBattleNode then
                   pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Award].info[m_Value[GUIDE_TYPE_Award].num+1].strlist, pBattleNode);
                   if pNode == nil then
                        return;
                   end
                else
                    return;
                end
            else
                return
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
			if m_Value[GUIDE_TYPE_Award] then
			    m_Value[GUIDE_TYPE_Award].num = m_Value[GUIDE_TYPE_Award].num + 1;
			end
	    elseif m_Value[GUIDE_TYPE_Award].num == 1 then   --点击技能图标
			local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
			local pBattleNode = nil
            if mapLay then
                pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
                if pBattleNode and m_Value[GUIDE_TYPE_Award] then
                   pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Award].info[m_Value[GUIDE_TYPE_Award].num+1].strlist, pBattleNode);
                   if pNode == nil then
                        return;
                   end
                else
                    return;
                end
            else
                return
            end
            local pReMoveNode = nil
            if m_Value[GUIDE_TYPE_Award] == nil then
                return;
            end
			pReMoveNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Award].info[m_Value[GUIDE_TYPE_Award].num].strlist, pBattleNode);
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRightGuideNode(pNode)
			end
			m_Value[GUIDE_TYPE_Award].num = m_Value[GUIDE_TYPE_Award].num + 1;
		elseif m_Value[GUIDE_TYPE_Award].num == 2 then   --点击技能图标
			local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
			local pBattleNode = nil
            if mapLay then
                pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
                if pBattleNode then
                   pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Award].info[m_Value[GUIDE_TYPE_Award].num+1].strlist, pBattleNode);
                   if pNode == nil then
                        return;
                   end
                else
                    return;
                end
            else
                return
            end
            local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Award].info[m_Value[GUIDE_TYPE_Award].num].strlist, pBattleNode);
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRightGuideNode(pNode)
			end
			isOpenTimer = isOpenTimer - 1;
			m_Value[GUIDE_TYPE_Award] = nil
			if isOpenTimer == 0 then
				CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
				m_entryId = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                GuidePoint_topGuide()
			end
	    end 
	end
end

local function GuidePoint_SevenDay_Clear()
	local pNode = SCFunction:getUiNodeByIdlist("5918-5932-1010")
	if pNode then
		pNode:removeChildByTag(1000, true);
	end
	isOpenTimer = isOpenTimer - 1;
	m_Value[GUIDE_TYPE_SevenDay] = nil
	if isOpenTimer == 0 then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		m_entryId = nil
		m_Value = {}
		m_guidetable = {}
		pNeedNode = nil
		m_idtype1 = nil
		GuidePoint_topGuide()
		stepInfo = {}
	end
end

--七日引导顺序
function GuidePoint_SevenDay()
	local pNode = nil
	if m_Value[GUIDE_TYPE_SevenDay] ~= nil then
		if m_Value[GUIDE_TYPE_SevenDay].num == 0 then   --点击奖励图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_SevenDay].info[m_Value[GUIDE_TYPE_SevenDay].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
			--m_Value[GUIDE_TYPE_SevenDay].num = m_Value[GUIDE_TYPE_SevenDay].num + 1;
	    elseif m_Value[GUIDE_TYPE_SevenDay].num == 1 then   --点击七日图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_SevenDay].info[m_Value[GUIDE_TYPE_SevenDay].num+1].strlist)
			if pNode == nil then
				GuidePoint_SevenDay_Clear();
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_SevenDay].info[m_Value[GUIDE_TYPE_SevenDay].num].strlist)
			if pReMoveNode then
			    pReMoveNode:removeChildByTag(1000, true);
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createLeftUpGuideNode(pNode)
				--m_Value[GUIDE_TYPE_SevenDay].num = m_Value[GUIDE_TYPE_SevenDay].num + 1;
			end
	     elseif m_Value[GUIDE_TYPE_SevenDay].num == 2 then   --点击领取按钮
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_SevenDay].info[m_Value[GUIDE_TYPE_SevenDay].num+1].strlist)
			if pNode == nil then
				GuidePoint_SevenDay_Clear();
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_SevenDay].num == 3 then   --点击关闭按钮
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_SevenDay].info[m_Value[GUIDE_TYPE_SevenDay].num+1].strlist)
			if pNode == nil then
				GuidePoint_SevenDay_Clear();
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_SevenDay].info[m_Value[GUIDE_TYPE_SevenDay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				--[[m_Value[GUIDE_TYPE_SevenDay].num = m_Value[GUIDE_TYPE_SevenDay].num + 1;
				isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_SevenDay] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    GuidePoint_topGuide()
                end]]
			end
		elseif m_Value[GUIDE_TYPE_SevenDay].num == 4 then
		    
	    end 
	end
end
--第一个副本引导
local function OnCheck()
    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");  
    if mapLay then
        local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
        if pBattleNode then
            local pNode = SCFunction:getUiNodeByIdlistAndParent("10", pBattleNode);
            if pNode then
                pNode:setBackgroundColor(ccc4(0,0,0,0));
                local pImage = SCFunction:getUiNodeByIdlistAndParent("11", pNode);
                if pImage then
                    pNode:removeChild(pImage, true);
                end
                local Wnd = SCFunction:getUiNodeByIdlistAndParent("58410", pBattleNode);
                if Wnd then
                    pBattleNode:removeChild(Wnd, true);
                end
            end
        end
    end
end

local function GuidePoint_FirstBattle()
    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");  
    if mapLay then
        local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
        if pBattleNode then
            --pBattleNode:setGoStatus(true);
           pNode = SCFunction:getUiNodeByIdlistAndParent("2020-2013", pBattleNode);
           if pNode == nil then
                return;
           end
           
           local PDragNode1 = SCFunction:getUiNodeByIdlistAndParent("1002", pBattleNode);
           if PDragNode1 then
                return;
           end
           

            local PDragNode = SCDragNode:node();
            if PDragNode then
                PDragNode:setTag(1002)
                PDragNode:setAnchorPoint(ANCHOR_CENTER)
                PDragNode:setContentSize(AUTO_SIZE(260, 50))
                PDragNode:setPosition(CCPointMake(pBattleNode:getContentSize().width/2 , pBattleNode:getContentSize().height/2 + SY(100)));
                PDragNode:setFrameVisibled(true)
                PDragNode:setDragEnabled(false)
                PDragNode:setFrameType(EnumFrameTypeRound)
                pBattleNode:addChild(PDragNode);
            end
            local pLabel = SCLabel:labelWithStringFont(L("str0445"), DEFAULT_FONT_NAME, F(13))
            if pLabel then
                pLabel:setTag(999)
                pLabel:setAnchorPoint(ANCHOR_CENTER)
                pLabel:setPosition(CCPointMake(PDragNode:getContentSize().width/2 , PDragNode:getContentSize().height/2));
                PDragNode:addChild(pLabel);
            end
         
            local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");  
            if mapLay then
                local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
                if pBattleNode then
                   pNode = SCFunction:getUiNodeByIdlistAndParent("2020-2013", pBattleNode);
                   if pNode == nil then
                        return;
                   end
                    local imgPath = getRealUIResourcePath("img/new00621.png")
                    local pImage = SCImage:imageWithFile(imgPath:getData())
                    if imgPath and pImage then
                        pImage:setTag(1001)
                        pImage:setTransform(7)  --转换度数
                        pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                        pImage:setPosition(AUTO_POS(0.00, 0.00))
                    end
                    
                    local ActionNode = ActionNode:newActionNode();
                    if ActionNode then
                        ActionNode:setTag(1000)
                        ActionNode:setContentSize(pImage:getContentSize());
                        ActionNode:setAnchorPoint(ANCHOR_CENTER);
                        ActionNode:setPosition(CCPointMake(pNode:getContentSize().width/2+ SX(46), pNode:getContentSize().height - SY(67)));
                        ActionNode:moveToRetuen(CCPointMake(pNode:getContentSize().width/2+ SX(46), pNode:getContentSize().height - SY(67)), CCPointMake(pNode:getContentSize().width/2 + SX(50), pNode:getContentSize().height - SY(67)), 0.2);
                        ActionNode:addChild(tolua.cast(pImage, "SCNode"))
                        pNode:addChild(tolua.cast(ActionNode, "SCNode"));
                    end
                    --OpenAnimation_UnlockKey(false);    --接触方向解锁
                    --local Wnd = SCFunction:getUiNodeByIdlistAndParent("58410", pBattleNode);
                    local pNode = SCFunction:getUiNodeByIdlistAndParent("10", pBattleNode);
                    if pNode == nil then
                        pNode = SCNode:node();
                        if pNode then
                            pNode:setTag(10)
                            pNode:setBackgroundColor(ccc4(0,0,0,220));
                            pNode:setAnchorPoint(ANCHOR_CENTER)
                            pNode:setContentSize(CCSizeMake(CCDirector:sharedDirector():getWinSize().width, CCDirector:sharedDirector():getWinSize().height))
                            pNode:setPosition(CCPointMake(pBattleNode:getContentSize().width/2 , pBattleNode:getContentSize().height/2));
                            pBattleNode:addChild(pNode);
                        end
                        local imgPath = getRealUIResourcePath("img/new00631.jp")   --图片
                        local pImage = SCImage:imageWithFile(imgPath:getData())
                        if pImage and imgPath then
                            pImage:setTag(11)
                            pImage:setAnchorPoint(ANCHOR_CENTER)
                            pImage:setPosition(CCPointMake(pNode:getContentSize().width/2 , pNode:getContentSize().height/2));
                            pNode:addChild(pImage);
                        end
                        
                        local imgPath = getRealUIResourcePath("img/new00637.png")
                        local pButton = SCButton:button(EnumBtnType9Atlas)      --我知道了
                        if pButton and imgPath then
                            pButton:setTag(12)
                            pButton:setTitle(imgPath:getData())
                            pButton:setAnchorPoint(ANCHOR_CENTER)
                            pButton:setPosition(CCPointMake(pImage:getContentSize().width/2 , SY(23)));
                            pButton:setContentSize(AUTO_SIZE(90, 34))
                            pButton:luaSetSelectorOnClicked(OnCheck);
                            GuidePoint_createRightGuideNode(pButton);
                            pImage:addChild(pButton);
                        end
                    end
                end
            end
        end
    end
end
--副本技能顺序
function GuidePoint_CSkill()
    local pNode = nil
	if m_Value[GUIDE_TYPE_CSkill] ~= nil then
		if m_Value[GUIDE_TYPE_CSkill].num == 0 then   --点击奖励图标
		    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
            if mapLay then
                local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
                if pBattleNode then
                   pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_CSkill].info[m_Value[GUIDE_TYPE_CSkill].num+1].strlist, pBattleNode);
                   if pNode == nil then
                        return;
                   end
                else
                    return;
                end
            else
                return
            end
            if nil == m_Value[GUIDE_TYPE_CSkill] then
                return
            end
            if m_Value[GUIDE_TYPE_Award] and nil == m_isStartCSkillGuide then
                return
            end
			GuidePoint_createUpHandGuideNode(pNode)
            isOpenTimer = isOpenTimer - 1;
            m_Value[GUIDE_TYPE_CSkill] = nil
            m_isStartCSkillGuide = nil
            if isOpenTimer == 0 then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                GuidePoint_topGuide()
            end
		end
    end
end

--强化装备顺序
function GuidePoint_Strong()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Strong] ~= nil then
		if m_Value[GUIDE_TYPE_Strong].num == 0 then   --点击强化图标
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Strong].info[m_Value[GUIDE_TYPE_Strong].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createLeftGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Strong].num == 1 then   --点击装备
		    if Equipmentstrengthen1.m_pPage == nil then
		        return;
		    else
                pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Strong].info[m_Value[GUIDE_TYPE_Strong].num+1].strlist, Equipmentstrengthen1.m_pPage)
                if pNode == nil then
                    return;
                end
            end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Strong].info[m_Value[GUIDE_TYPE_Strong].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createLeftUpGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Strong].num == 2 then   --点击强化
		    if Equipmentstrengthen1.m_pDragNode == nil then
		        return;
		    else
                pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Strong].info[m_Value[GUIDE_TYPE_Strong].num+1].strlist, Equipmentstrengthen1.m_pDragNode)
                if pNode == nil then
                    return;
                end
            end
            local pReMoveNode = nil
            if Equipmentstrengthen1.m_pPage == nil then
		        return;
		    else
                pReMoveNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Strong].info[m_Value[GUIDE_TYPE_Strong].num].strlist, Equipmentstrengthen1.m_pPage)
                if pReMoveNode == nil then
                    return;
                end
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Strong].num == 3 then   --点击关闭窗口
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Strong].info[m_Value[GUIDE_TYPE_Strong].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
			if Equipmentstrengthen1.m_pDragNode == nil then
		        return;
		    else
                pReMoveNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Strong].info[m_Value[GUIDE_TYPE_Strong].num].strlist, Equipmentstrengthen1.m_pDragNode)
                if pReMoveNode == nil then
                    return;
                end
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
			    --GuideTip.Window(1);
				GuidePoint_createCloseWndGuideNode(pNode)
			end
			isOpenTimer = isOpenTimer - 1;
            m_Value[GUIDE_TYPE_Strong] = nil
            if isOpenTimer == 0 then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                GuidePoint_topGuide()
            end
		end
    end
end

--增加体力引导顺序
function GuidePoint_Strength()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Strength] ~= nil then
		if m_Value[GUIDE_TYPE_Strength].num == 0 then   --点击体力图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Strength].info[m_Value[GUIDE_TYPE_Strength].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createLeftUpGuideNode(pNode)
			end
        elseif m_Value[GUIDE_TYPE_Strength].num == 1 then   --点击确定
            local scene = getRunningScene();
            if scene~= nil and scene:getUINode() then
                pNode = scene:getUINode():getChildByTag(5);
            end
            if pNode == nil then
                return;
            end
            local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Strength].info[m_Value[GUIDE_TYPE_Strength].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			isOpenTimer = isOpenTimer - 1;
            m_Value[GUIDE_TYPE_Strength] = nil
            if isOpenTimer == 0 then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                GuidePoint_topGuide()
            end
            local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
            if ChildNode == nil then
                local imgPath = getRealUIResourcePath("img/new00447.png")
                if imgPath == nil then
                    return;
                end
                local pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage == nil then
                    return;
                end
                local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
                if imgPath and pImage and pLabel then
                    --pImage:setFlipX(true)
                    pImage:setTag(1001)
                    pImage:setScale(0.9)
                    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pImage:setPosition(AUTO_POS(0.00, 0.00))
                    pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pLabel:setPosition(AUTO_POS(17.00, 12.00))
                    pLabel:setColor(ccc4(255, 0, 0, 255))
                    pImage:addChild(tolua.cast(pLabel, "SCNode"))
                end
                
                local pLabel0040 = SCLabel:labelWithStringFont(L("str0438"), DEFAULT_FONT_NAME, F(13))
                if pLabel0040 then
                    pLabel0040:setColor(ccc4( 255,187,0,255));
                    pLabel0040:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pLabel0040:setPosition(AUTO_POS(29.00, 61.00))
                    pNode:addChild(tolua.cast(pLabel0040, "SCNode"))
                end
                
                local ActionNode = ActionNode:newActionNode();
                if ActionNode then
                    ActionNode:setTag(1000)
                    ActionNode:setContentSize(pImage:getContentSize());
                    ActionNode:setAnchorPoint(ANCHOR_CENTER);
                    ActionNode:setPosition(CCPointMake(0 - pImage:getContentSize().width/2 +SX(107), pNode:getContentSize().height/2 - SY(40)));
                    ActionNode:moveToRetuen(CCPointMake(0 - pImage:getContentSize().width/2 +SX(107), pNode:getContentSize().height/2 - SY(40)), CCPointMake(0 - pImage:getContentSize().width/2 +SX(103), pNode:getContentSize().height/2 - SY(40)), 0.2);
                    ActionNode:addChild(tolua.cast(pImage, "SCNode"))
                    pNode:addChild(tolua.cast(ActionNode, "SCNode"))
                end
            end
        end
    end
end

--增加挑战引导顺序
function GuidePoint_Challenge()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Challenge] ~= nil then
		if m_Value[GUIDE_TYPE_Challenge].num == 0 then   --点击挑战图标
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Challenge].info[m_Value[GUIDE_TYPE_Challenge].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Challenge].num == 1 then   --点击竞技场副本
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Challenge].info[m_Value[GUIDE_TYPE_Challenge].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Challenge].info[m_Value[GUIDE_TYPE_Challenge].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Challenge].num == 2 then   --点击人物挑战
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Challenge].info[m_Value[GUIDE_TYPE_Challenge].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
                local imgPath = getRealUIResourcePath("img/new00621.png")
                if imgPath == nil then
                    return;
                end
                local pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage == nil then
                    return;
                end
                pImage:setTag(1001)
                pImage:setFlipY(true)
                pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage:setPosition(AUTO_POS(0.00, 0.00))
            
                local ActionNode = ActionNode:newActionNode();
                if ActionNode then
                    ActionNode:setTag(1000)
                    ActionNode:setContentSize(pImage:getContentSize());
                    ActionNode:setAnchorPoint(ANCHOR_CENTER);
                    ActionNode:setPosition(CCPointMake(pNode:getContentSize().width/2 + SX(29), SY(9)));
                    ActionNode:moveToRetuen(CCPointMake(pNode:getContentSize().width/2 + SX(29), SY(9)), CCPointMake(pNode:getContentSize().width/2 + SX(29), SY(5)), 0.2);
                    ActionNode:addChild(tolua.cast(pImage, "SCNode"))
                    pNode:addChild(tolua.cast(ActionNode, "SCNode"));
                end
			end
		elseif m_Value[GUIDE_TYPE_Challenge].num == 3 then   --点击确定
            local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Challenge].info[m_Value[GUIDE_TYPE_Challenge].num].strlist)
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pReMoveNode);
			if ChildNode then
			    pReMoveNode:removeChildByTag(1000, true);
			end
		    local scene = getRunningScene();
            if scene~= nil and scene:getUINode() then
                pNode = scene:getChildByTag(256);
                if pNode then
                    pNode = tolua.cast(pNode:getChildByTag(5), "SCNode");
                end
            end
            if pNode == nil then
                return;
            end
            --[[local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
            if ChildNode == nil then
                local imgPath = getRealUIResourcePath("img/new00447.png")
                local pImage = SCImage:imageWithFile(imgPath:getData())
                local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
                if imgPath and pImage and pLabel then
                    --pImage:setFlipX(true)
                    pImage:setTag(1001)
                    pImage:setScale(0.9)
                    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pImage:setPosition(AUTO_POS(0.00, 0.00))
                    pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pLabel:setPosition(AUTO_POS(17.00, 12.00))
                    pLabel:setColor(ccc4(255, 0, 0, 255))
                    pImage:addChild(tolua.cast(pLabel, "SCNode"))
                end
                
                local ActionNode = ActionNode:newActionNode();
                if ActionNode then
                    ActionNode:setTag(1000)
                    ActionNode:setContentSize(pImage:getContentSize());
                    ActionNode:setAnchorPoint(ANCHOR_CENTER);
                    ActionNode:setPosition(CCPointMake(0 - pImage:getContentSize().width/2 +SX(162), pNode:getContentSize().height/2 - SY(35)));
                    ActionNode:moveToRetuen(CCPointMake(0 - pImage:getContentSize().width/2 +SX(162), pNode:getContentSize().height/2 - SY(35)), CCPointMake(0 - pImage:getContentSize().width/2 +SX(158), pNode:getContentSize().height/2 - SY(35)), 0.2);
                    ActionNode:addChild(tolua.cast(pImage, "SCNode"))
                    pNode:addChild(tolua.cast(ActionNode, "SCNode"))
                end
            end--]]
		    m_Value[GUIDE_TYPE_Challenge].num = m_Value[GUIDE_TYPE_Challenge].num + 1
		elseif m_Value[GUIDE_TYPE_Challenge].num == 4 then   --点击关闭
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Challenge].info[m_Value[GUIDE_TYPE_Challenge].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createCloseWndGuideNode(pNode)
				isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_Challenge] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    GuidePoint_topGuide()
                end
			end
		end
    end
end

local function GuidePoint_Reward_Clear()
	local pNode = SCFunction:getUiNodeByIdlist("5918-5932-1010")
	if pNode then
		pNode:removeChildByTag(1000, true);
	end
	
	isOpenTimer = isOpenTimer - 1;
	m_Value[GUIDE_TYPE_Reward] = nil
	if isOpenTimer == 0 then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		m_entryId = nil
		m_Value = {}
		m_guidetable = {}
		pNeedNode = nil
	end
end

--增加奖励引导顺序
function GuidePoint_Reward()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Reward] ~= nil then
		if m_Value[GUIDE_TYPE_Reward].num == 0 then   --点击奖励图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Reward].info[m_Value[GUIDE_TYPE_Reward].num+1].strlist)
			if pNode == nil then
				GuidePoint_Reward_Clear()
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
			--m_Value[GUIDE_TYPE_Reward].num = m_Value[GUIDE_TYPE_Reward].num + 1;
	    elseif m_Value[GUIDE_TYPE_Reward].num == 1 then   --点击奖励图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Reward].info[m_Value[GUIDE_TYPE_Reward].num+1].strlist)
			if pNode == nil then
				GuidePoint_Reward_Clear()
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Reward].info[m_Value[GUIDE_TYPE_Reward].num].strlist)
			if pReMoveNode then
			    pReMoveNode:removeChildByTag(1000, true);
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Reward].num == 2 then   --点击奖励图标
            isOpenTimer = isOpenTimer - 1;
            m_Value[GUIDE_TYPE_Reward] = nil
            if isOpenTimer == 0 then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                --GuidePoint_topGuide()
            end
        end
    end
end

--增加首冲未充值引导顺序
function GuidePoint_FirstRech()
    local pNode = nil
	if m_Value[GUIDE_TYPE_FirstRech] ~= nil then
		if m_Value[GUIDE_TYPE_FirstRech].num == 0 then   --点击奖励图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech].info[m_Value[GUIDE_TYPE_FirstRech].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
			--m_Value[GUIDE_TYPE_FirstRech].num = m_Value[GUIDE_TYPE_FirstRech].num + 1;
	    elseif m_Value[GUIDE_TYPE_FirstRech].num == 1 then   --点击首冲图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech].info[m_Value[GUIDE_TYPE_FirstRech].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech].info[m_Value[GUIDE_TYPE_FirstRech].num].strlist)
			if pReMoveNode then
			    pReMoveNode:removeChildByTag(1000, true);
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				m_Value[GUIDE_TYPE_FirstRech].num = m_Value[GUIDE_TYPE_FirstRech].num + 1;
			end
	     elseif m_Value[GUIDE_TYPE_FirstRech].num == 2 then   --点击充值按钮
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech].info[m_Value[GUIDE_TYPE_FirstRech].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_FirstRech] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    GuidePoint_topGuide()
                end
			end
        end
    end
end

--增加首冲已充值引导顺序
function GuidePoint_FirstRech1()
    local pNode = nil
	if m_Value[GUIDE_TYPE_FirstRech1] ~= nil then
		if m_Value[GUIDE_TYPE_FirstRech1].num == 0 then   --点击奖励图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech1].info[m_Value[GUIDE_TYPE_FirstRech1].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
			m_Value[GUIDE_TYPE_FirstRech1].num = m_Value[GUIDE_TYPE_FirstRech1].num + 1;
	    elseif m_Value[GUIDE_TYPE_FirstRech1].num == 1 then   --点击首冲图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech1].info[m_Value[GUIDE_TYPE_FirstRech1].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech1].info[m_Value[GUIDE_TYPE_FirstRech1].num].strlist)
			if pReMoveNode then
			    pReMoveNode:removeChildByTag(1000, true);
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				--m_Value[GUIDE_TYPE_FirstRech1].num = m_Value[GUIDE_TYPE_FirstRech1].num + 1;
			end
	     elseif m_Value[GUIDE_TYPE_FirstRech1].num == 2 then   --点击领取按钮
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech1].info[m_Value[GUIDE_TYPE_FirstRech1].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_FirstRech1].num == 3 then   --点击关闭按钮
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech1].info[m_Value[GUIDE_TYPE_FirstRech1].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_FirstRech1].info[m_Value[GUIDE_TYPE_FirstRech1].num].strlist)
			if pReMoveNode then
			    pReMoveNode:removeChildByTag(1000, true);
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_FirstRech1] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    GuidePoint_topGuide()
                end
			end
        end
    end
end

--增加每日俸禄引导顺序
function GuidePoint_Salary()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Salary] ~= nil then
		if m_Value[GUIDE_TYPE_Salary].num == 0 then   --点击每日图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Salary].info[m_Value[GUIDE_TYPE_Salary].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
			m_Value[GUIDE_TYPE_Salary].num = m_Value[GUIDE_TYPE_Salary].num + 1;
        elseif m_Value[GUIDE_TYPE_Salary].num == 1 then   --点击领取图标
            pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Salary].info[m_Value[GUIDE_TYPE_Salary].num+1].strlist)
            if pNode == nil then
                return;
            end
            local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Salary].info[m_Value[GUIDE_TYPE_Salary].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
            local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
            if ChildNode == nil then
                GuidePoint_createRectGuideNode(pNode)
            end
        elseif m_Value[GUIDE_TYPE_Salary].num == 2 then   --点击关闭图标
            pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Salary].info[m_Value[GUIDE_TYPE_Salary].num+1].strlist)
            if pNode == nil then
                return;
            end
            local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Salary].info[m_Value[GUIDE_TYPE_Salary].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
            local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
            if ChildNode == nil then
                GuidePoint_createRectGuideNode(pNode)
                isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_Salary] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    GuidePoint_topGuide()
                end
            end
		end
    end
end

--增加大泽山斩魔2副本引导顺序
--[[function GuidePoint_Copy()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Copy] ~= nil then
		if m_Value[GUIDE_TYPE_Copy].num == 0 then   --点击每日图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Copy].info[m_Value[GUIDE_TYPE_Copy].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_Copy] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    pNeedNode = nil
                end
			end
	    end
    end
end--]]

function GuidePoint_AddBlowRecruit()
	if 1 then
		return
	end
	if m_Value[GUIDE_TYPE_BlowRecruit] ~= nil then
		if m_Value[GUIDE_TYPE_BlowRecruit].num == 0 then
			m_Value[GUIDE_TYPE_BlowRecruit].num = 1;
		end
	end
end

--增加武将招募引导顺序
function GuidePoint_BlowRecruit()
    local pNode = nil
	if m_Value[GUIDE_TYPE_BlowRecruit] ~= nil then
		if m_Value[GUIDE_TYPE_BlowRecruit].num == 0 then   --点击武将图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
			    MainInterface_ShowBtn();
				GuidePoint_createRectGuideNode(pNode)
			end
			m_Value[GUIDE_TYPE_BlowRecruit].num = m_Value[GUIDE_TYPE_BlowRecruit].num + 1;
        elseif m_Value[GUIDE_TYPE_BlowRecruit].num == 1 then   --点击天牢图标
            pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			
            pNode1 = SCFunction:getUiNodeByIdlist("7020")
			if pNode1 == nil then
				return;
			end
			
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode1);
			if ChildNode == nil then
				local imgPath = getRealUIResourcePath("img/new00447.png")
				if imgPath == nil then
				    return;
				end
                local pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage == nil then
                    return;
                end
                local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
                if imgPath and pImage and pLabel then
                    pImage:setFlipX(true)
                    pImage:setTag(1001)
                    pImage:setScale(0.9)
                    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pImage:setPosition(AUTO_POS(-10.00, 0.00))
                    pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pLabel:setPosition(AUTO_POS(36.00, 12.00))
                    pLabel:setColor(ccc4(255, 0, 0, 255))
                    pImage:addChild(tolua.cast(pLabel, "SCNode"))
                end
                
                local width = pNode:getContentSize().width + pImage:getContentSize().width/2 - SX(188)
                local height = pNode:getContentSize().height/2 + SY(139)
                local ActionNode = ActionNode:newActionNode();
                if ActionNode then
                    ActionNode:setTag(1000)
                    ActionNode:setContentSize(pImage:getContentSize());
                    ActionNode:setAnchorPoint(ANCHOR_CENTER);
                    ActionNode:setPosition(CCPointMake(width + SX(2), height));
                    ActionNode:moveToRetuen(CCPointMake(width + SX(2), height), CCPointMake(width + SX(6), height), 0.2);
                    ActionNode:addChild(tolua.cast(pImage, "SCNode"))
                    pNode1:addChild(tolua.cast(ActionNode, "SCNode"))
                end
			end
			m_Value[GUIDE_TYPE_BlowRecruit].num = m_Value[GUIDE_TYPE_BlowRecruit].num + 1;
        elseif m_Value[GUIDE_TYPE_BlowRecruit].num == 2 then   --点击招募
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			
			pNode1 = SCFunction:getUiNodeByIdlist("7020")
			if pNode1 then
				pNode1:removeChildByTag(1000, true);
			end
			
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
			    local imgPath = getRealUIResourcePath("img/new00447.png")
			    if imgPath == nil then
			        return;
			    end
                local pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage == nil then
                    return;
                end
                local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
                if imgPath and pImage and pLabel then
                    pImage:setFlipX(true)
                    pImage:setTag(1001)
                    pImage:setScale(0.9)
                    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pImage:setPosition(AUTO_POS(-10.00, 0.00))
                    pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pLabel:setPosition(AUTO_POS(36.00, 12.00))
                    pLabel:setColor(ccc4(255, 0, 0, 255))
                    pImage:addChild(tolua.cast(pLabel, "SCNode"))
                end
                
                local width = pNode:getContentSize().width + pImage:getContentSize().width/2 + SX(35)
                local height = pNode:getContentSize().height/2 + SY(44)
                local ActionNode = ActionNode:newActionNode();
                if ActionNode then
                    ActionNode:setTag(1000)
                    ActionNode:setContentSize(pImage:getContentSize());
                    ActionNode:setAnchorPoint(ANCHOR_CENTER);
                    ActionNode:setPosition(CCPointMake(width + SX(2), height-SY(5)));
                    ActionNode:moveToRetuen(CCPointMake(width + SX(2), height-SY(5)), CCPointMake(width + SX(6), height-SY(5)), 0.2);
                    ActionNode:addChild(tolua.cast(pImage, "SCNode"))
                    pNode:addChild(tolua.cast(ActionNode, "SCNode"))
                end
            end
			m_Value[GUIDE_TYPE_BlowRecruit].num = m_Value[GUIDE_TYPE_BlowRecruit].num + 2;
		elseif m_Value[GUIDE_TYPE_BlowRecruit].num == 3 then   --点击培养图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_BlowRecruit].num == 4 then   --点击招降图标
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_BlowRecruit].num == 5 then   --点击武将图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
                local imgPath = getRealUIResourcePath("img/new00447.png")
                if imgPath == nil then
                    return;
                end
                local pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage == nil then
                    return;
                end
                local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
                if imgPath and pImage and pLabel then
                    --pImage:setFlipX(true)
                    pImage:setTag(1001)
                    pImage:setScale(0.9)
                    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pImage:setPosition(AUTO_POS(0.00, 0.00))
                    pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pLabel:setPosition(AUTO_POS(17.00, 12.00))
                    pLabel:setColor(ccc4(255, 0, 0, 255))
                    pImage:addChild(tolua.cast(pLabel, "SCNode"))
                end
                
                local ActionNode = ActionNode:newActionNode();
                if ActionNode then
                    ActionNode:setTag(1000)
                    ActionNode:setContentSize(pImage:getContentSize());
                    ActionNode:setAnchorPoint(ANCHOR_CENTER);
                    ActionNode:setPosition(CCPointMake(0 - pImage:getContentSize().width/2 +SX(122), pNode:getContentSize().height/2));
                    ActionNode:moveToRetuen(CCPointMake(0 - pImage:getContentSize().width/2 +SX(122), pNode:getContentSize().height/2), CCPointMake(0 - pImage:getContentSize().width/2 +SX(118), pNode:getContentSize().height/2), 0.2);
                    ActionNode:addChild(tolua.cast(pImage, "SCNode"))
                    pNode:addChild(tolua.cast(ActionNode, "SCNode"))
                end
			end
			--m_Value[GUIDE_TYPE_BlowRecruit].num = m_Value[GUIDE_TYPE_BlowRecruit].num + 1;
		elseif m_Value[GUIDE_TYPE_BlowRecruit].num == 6 then   --点击出战
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
			    local partent = pNode:getParent();
                if partent == nil then
                    return;
                end
                partent:reorderChild(pNode, 1000)
                local imgPath = getRealUIResourcePath("img/new00447.png")
                if imgPath == nil then
                    return;
                end
                local pImage = SCImage:imageWithFile(imgPath:getData())
                if pImage == nil then
                    return;
                end
                local pLabel = SCLabel:labelWithStringFont(L("str0436"), DEFAULT_FONT_NAME, F(13))
                if imgPath and pImage and pLabel then
                    --pImage:setFlipX(true)
                    pImage:setTag(1001)
                    pImage:setScale(0.9)
                    pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pImage:setPosition(AUTO_POS(0.00, 0.00))
                    pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pLabel:setPosition(AUTO_POS(17.00, 12.00))
                    pLabel:setColor(ccc4(255, 0, 0, 255))
                    pImage:addChild(tolua.cast(pLabel, "SCNode"))
                end
                
                local ActionNode = ActionNode:newActionNode();
                if ActionNode then
                    ActionNode:setTag(1000)
                    ActionNode:setContentSize(pImage:getContentSize());
                    ActionNode:setAnchorPoint(ANCHOR_CENTER);
                    ActionNode:setPosition(CCPointMake(0 - pImage:getContentSize().width/2 +SX(147), pNode:getContentSize().height/2 + SY(75)));
                    ActionNode:moveToRetuen(CCPointMake(0 - pImage:getContentSize().width/2 +SX(147), pNode:getContentSize().height/2 + SY(75)), CCPointMake(0 - pImage:getContentSize().width/2 +SX(143), pNode:getContentSize().height/2 + SY(75)), 0.2);
                    ActionNode:addChild(tolua.cast(pImage, "SCNode"))
                    pNode:addChild(tolua.cast(ActionNode, "SCNode"))
                end
			end
		elseif m_Value[GUIDE_TYPE_BlowRecruit].num == 7 then   --点击关闭窗口
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num+1].strlist)
			if pNode == nil then
				return;
			end
			local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_BlowRecruit].info[m_Value[GUIDE_TYPE_BlowRecruit].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				--GuideTip.Window(4);
				isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_BlowRecruit] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    GuidePoint_topGuide()
                end
			end
	    end
	end
end

--成长礼包领取引导顺序
function GuidePoint_Goods2()
    local pNode = nil
    local pReMoveNode = nil
	if m_Value[GUIDE_TYPE_Goods] ~= nil then
 		if m_Value[GUIDE_TYPE_Goods].num == 1 then   --点击礼包
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Goods].info[m_Value[GUIDE_TYPE_Goods].num].strlist)
			if pNode == nil then
				return;
			end
			local item = ItemProcessor:getSingleton():getItemByTypeID(m_idtype);
			local page = nil
            if item then
                page = getIntPart((item:getPlace()) / 16)
            end
			local plistbox = SCTypeCast:castNodeToTableBox(SCFunction:getUiNodeByIdlist("2011-9999-2008-2008-1"))
            if plistbox then
                plistbox:setOffset(AUTO_POS(page * 192, 0.00))
            end
			GuidePoint_createUpGuideNode(pNode)
			m_Value[GUIDE_TYPE_Goods].num = m_Value[GUIDE_TYPE_Goods].num + 1;
		elseif m_Value[GUIDE_TYPE_Goods].num == 2 then   --点击打开
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Goods].info[m_Value[GUIDE_TYPE_Goods].num].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
	    elseif m_Value[GUIDE_TYPE_Goods].num == 3 then   --点击关闭
			local Wnd = SCFunction:getUiNodeByIdlist("2011")
			if Wnd == nil then
			    return;
			end
            GuidePoint_createCloseWndGuideNode(Wnd)
            isOpenTimer = isOpenTimer - 1;
            m_Value[GUIDE_TYPE_Goods] = nil
            if isOpenTimer == 0 then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                m_idtype = nil
                stepInfo = {}
                GuidePoint_topGuide();
            end
	    end
    end
end

--增加摇钱树引导顺序
function GuidePoint_Tree()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Tree] ~= nil then
		if m_Value[GUIDE_TYPE_Tree].num == 0 then   --点击赚钱图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Tree].info[m_Value[GUIDE_TYPE_Tree].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Tree].num == 1 then   --点击立即进入图标
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Tree].info[m_Value[GUIDE_TYPE_Tree].num+1].strlist)
            if pNode == nil then
                return;
            end
            local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Tree].info[m_Value[GUIDE_TYPE_Tree].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
            local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
            if ChildNode == nil then
                GuidePoint_createLeftUpGuideNode(pNode)
                isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_Tree] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    GuidePoint_topGuide()
                end
            end
        end
    end
end

--增加竞技礼包引导顺序
function GuidePoint_Sports()
    local pNode = nil
	if m_Value[GUIDE_TYPE_Sports] ~= nil then
		if m_Value[GUIDE_TYPE_Sports].num == 0 then   --点击赚钱图标
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Sports].info[m_Value[GUIDE_TYPE_Sports].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Sports].num == 1 then   --点击立即进入图标
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Sports].info[m_Value[GUIDE_TYPE_Sports].num+1].strlist)
            if pNode == nil then
                return;
            end
            local pReMoveNode = nil
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Sports].info[m_Value[GUIDE_TYPE_Sports].num].strlist)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
            local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
            if ChildNode == nil then
                GuidePoint_createLeftUpGuideNode(pNode)
                isOpenTimer = isOpenTimer - 1;
                m_Value[GUIDE_TYPE_Sports] = nil
                if isOpenTimer == 0 then
                    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                    m_entryId = nil
                    m_Value = {}
                    m_guidetable = {}
                    pNeedNode = nil
                    --GuidePoint_topGuide()
                end
            end
        end
    end
end

function GuidePoint_Inlay()
    local pNode = nil
    local pReMoveNode = nil
	if m_Value[GUIDE_TYPE_Inlay] ~= nil then
		if m_Value[GUIDE_TYPE_Inlay].num == 0 then   --点击人物
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				if not getCurentSceneWindowController(7002) then
				    removeAllWindwoController();
				end
				
			end
			--m_Value[GUIDE_TYPE_NewPlayer].num = m_Value[GUIDE_TYPE_NewPlayer].num + 1
		elseif m_Value[GUIDE_TYPE_Inlay].num == 1 then   --点击礼包
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			GuidePoint_createUpGuideNode(pNode)
			m_Value[GUIDE_TYPE_Inlay].num = m_Value[GUIDE_TYPE_Inlay].num + 1;
			--CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
		elseif m_Value[GUIDE_TYPE_Inlay].num == 2 then   --点击打开
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Inlay].num == 3 then   --点击红宝石
		    if m_Value[GUIDE_TYPE_Inlay].info[4] == nil then
		        --4、点击红宝石
                local tmp = {}
                local item = ItemProcessor:getSingleton():getItemByTypeID(3900110001);  --红宝石
                if item then
                    local id = (item:getPlace())%16;
                    local page = getIntPart((item:getPlace()) / 16)
                    tmp.strlist = "2011-9999-2008-2008-1-"..page.."-"..id;
                    table.insert(m_Value[GUIDE_TYPE_Inlay].info, tmp)
                else
                    return;
                end
                --5、打开镶嵌
                local tmp = {}
                tmp.strlist = "888888-0"
                table.insert(m_Value[GUIDE_TYPE_Inlay].info, tmp)
                --6、点击镶嵌
                local tmp = {}
                tmp.strlist = "11"
                table.insert(m_Value[GUIDE_TYPE_Inlay].info, tmp)
                --7、点击关闭
                local tmp = {}
                tmp.strlist = "7022"
                table.insert(m_Value[GUIDE_TYPE_Inlay].info, tmp)
		    end
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			GuidePoint_createUpGuideNode(pNode)
			m_Value[GUIDE_TYPE_Inlay].num = m_Value[GUIDE_TYPE_Inlay].num + 1;
	    elseif m_Value[GUIDE_TYPE_Inlay].num == 4 then   --点击镶嵌
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				m_Value[GUIDE_TYPE_Inlay].num = m_Value[GUIDE_TYPE_Inlay].num + 1;
			end
	    elseif m_Value[GUIDE_TYPE_Inlay].num == 5 then   --点击升级镶嵌
	        if EquipmentGemPlug.m_pDragNode == nil then
		        return;
		    else
                pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist, EquipmentGemPlug.m_pDragNode)
                if pNode == nil then
                    return;
                end
            end
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Inlay].num == 6 then   --点击关闭
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
            local pReMoveNode = nil
			if EquipmentGemPlug.m_pDragNode == nil then
		        return;
		    else
                pReMoveNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist, EquipmentGemPlug.m_pDragNode)
                if pReMoveNode == nil then
                    return;
                end
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createCloseWndGuideNode(pNode)
				--GuideTip.Window(2);
			end
			isOpenTimer = isOpenTimer - 1;
            m_Value[GUIDE_TYPE_Inlay] = nil
            if isOpenTimer == 0 then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_idtype1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                GuidePoint_topGuide()
            end
	    end
    end
end

function GuidePoint_Inlay1()
    local pNode = nil
    local pReMoveNode = nil
	if m_Value[GUIDE_TYPE_Inlay] ~= nil then
		if m_Value[GUIDE_TYPE_Inlay].num == 0 then   --点击人物
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				if not getCurentSceneWindowController(7002) then
				    removeAllWindwoController();
				end
			end
			--m_Value[GUIDE_TYPE_NewPlayer].num = m_Value[GUIDE_TYPE_NewPlayer].num + 1
		elseif m_Value[GUIDE_TYPE_Inlay].num == 1 then   --点击红宝石
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			GuidePoint_createUpGuideNode(pNode)
			m_Value[GUIDE_TYPE_Inlay].num = m_Value[GUIDE_TYPE_Inlay].num + 1;
	    elseif m_Value[GUIDE_TYPE_Inlay].num == 2 then   --点击镶嵌
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				m_Value[GUIDE_TYPE_Inlay].num = m_Value[GUIDE_TYPE_Inlay].num + 1;
			end
	    elseif m_Value[GUIDE_TYPE_Inlay].num == 3 then   --点击升级镶嵌
	        if EquipmentGemPlug.m_pDragNode == nil then
		        return;
		    else
                pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist, EquipmentGemPlug.m_pDragNode)
                if pNode == nil then
                    return;
                end
            end
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Inlay].num == 4 then   --点击关闭
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num+1].strlist)
			if pNode == nil then
				return;
			end
            local pReMoveNode = nil
			if EquipmentGemPlug.m_pDragNode == nil then
		        return;
		    else
                pReMoveNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Inlay].info[m_Value[GUIDE_TYPE_Inlay].num].strlist, EquipmentGemPlug.m_pDragNode)
                if pReMoveNode == nil then
                    return;
                end
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createCloseWndGuideNode(pNode)
				--GuideTip.Window(2);
			end
			isOpenTimer = isOpenTimer - 1;
            m_Value[GUIDE_TYPE_Inlay] = nil
            if isOpenTimer == 0 then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_idtype1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                GuidePoint_topGuide()
            end
	    end
    end
end

function GuidePoint_Mark()
    local pNode = nil
    local pReMoveNode = nil
	if m_Value[GUIDE_TYPE_Mark] ~= nil then
		if m_Value[GUIDE_TYPE_Mark].num == 0 then   --点击人物
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num+1].strlist)
			if pNode == nil then
				return;
			end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
			    MainInterface_ShowBtn();
				GuidePoint_createRectGuideNode(pNode)
				if not getCurentSceneWindowController(7002) then
				    removeAllWindwoController();
				end
			end
		elseif m_Value[GUIDE_TYPE_Mark].num == 1 then   --点击符石
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local str = {3801100000, 3801200000, 3801300000, 3801400000, 3801500000, 3801600000}
            local item = nil
            for i = 1, 6 do
                item = ItemProcessor:getSingleton():getItemByTypeID(str[i]);
                if item then
                    break;
                end
            end
			local page = nil
            if item then
                page = getIntPart((item:getPlace()) / 16)
            else
                return;
            end
			local plistbox = SCTypeCast:castNodeToTableBox(SCFunction:getUiNodeByIdlist("2011-9999-2008-2008-1"))
            if plistbox then
                plistbox:setOffset(AUTO_POS(page * 192, 0.00))
            end
			GuidePoint_createUpGuideNode(pNode)
			m_Value[GUIDE_TYPE_Mark].num = m_Value[GUIDE_TYPE_Mark].num + 1;
		elseif m_Value[GUIDE_TYPE_Mark].num == 2 then   --点击刻印
			pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num+1].strlist)
			if pNode == nil then
				return;
			end
			pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
				m_Value[GUIDE_TYPE_Mark].num = m_Value[GUIDE_TYPE_Mark].num + 1;
			end
		elseif m_Value[GUIDE_TYPE_Mark].num == 3 then   --点击元宝刻印
	        if EquipmentMark.m_pDragNode == nil then
		        return;
		    else
                pNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num+1].strlist, EquipmentMark.m_pDragNode)
                if pNode == nil then
                    return;
                end
            end
            pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num].strlist)
			if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createRectGuideNode(pNode)
			end
		elseif m_Value[GUIDE_TYPE_Mark].num == 4 then   --点击关闭
		    pNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num+1].strlist)
			if pNode == nil then
				return;
			end
            local pReMoveNode = nil
			if EquipmentMark.m_pDragNode == nil then
		        return;
		    else
                pReMoveNode = SCFunction:getUiNodeByIdlistAndParent(m_Value[GUIDE_TYPE_Mark].info[m_Value[GUIDE_TYPE_Mark].num].strlist, EquipmentMark.m_pDragNode)
                if pReMoveNode == nil then
                    return;
                end
                pReMoveNode:removeChildByTag(1000, true);
            end
			local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
			if ChildNode == nil then
				GuidePoint_createCloseWndGuideNode(pNode)
			end
			isOpenTimer = isOpenTimer - 1;
            m_Value[GUIDE_TYPE_Mark] = nil
            if isOpenTimer == 0 then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
                m_entryId = nil
                m_entryId1 = nil
                m_Value = {}
                m_guidetable = {}
                pNeedNode = nil
                GuidePoint_topGuide()
            end
		end
    end
end

--押镖引导
--引导5分钟时限，过期删除引导
--将计时器改为结点实现，防止切换服务器等问题计时id未删除
local function EscortTimeEnd()        
    if not m_Value[GUIDE_TYPE_Escort] then return end 
    
    showMessage(L("str20156"))
    
    if m_Value[GUIDE_TYPE_Escort].num == 2 then
        local id = VanFood_GetEnemyIdWithPos(1)
        if id then
            local pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num].strlist.."-"..id)
            if pReMoveNode then
                pReMoveNode:removeChildByTag(1000, true);
            end
        end
    elseif m_Value[GUIDE_TYPE_Escort].num == 3 then
        local pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num].strlist)
        if pReMoveNode then
            pReMoveNode:removeChildByTag(1000, true);
        end
    end
    
    isOpenTimer = isOpenTimer - 1;
    m_Value[GUIDE_TYPE_Escort] = nil
    if isOpenTimer == 0 then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
        m_entryId = nil
        m_entryId1 = nil
        m_Value = {}
        m_guidetable = {}
        pNeedNode = nil
        GuidePoint_topGuide()
    end    
    local node = SCFunction:getUiNodeByIdlist("9117")
    if node then
        node:removeFromParentAndCleanup(true)
    end    
end
function Escort_StartGuideTimeDown()
    local wnd = getMainInterface()
    if not wnd then return end 
    
    local node = SCFunction:getUiNodeByIdlist("9117")
    if not node then
        node = ActionNode:newActionNode()
        if node then
            wnd:addChild(node)                   
            node:setContentSize(AUTO_SIZE(10, 10))
            node:setAutoRemove(true)
            node:setPosition(AUTO_POS(240, 160))
            node:moveTo(AUTO_POS(240, 310), 300, true)
            node:setTag(9117)
            node:luaSetSelectorOnMoveEnd(EscortTimeEnd)
        end
    end
end
function GuidePoint_Escort()    
    
    if not m_Value[GUIDE_TYPE_Escort] then return end 
    
    if m_Value[GUIDE_TYPE_Escort].num == 0 then   --0点击邮件
        local st = m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num + 1]
        if not st then return end 
        
        local wnd = SCFunction:getUiNodeByIdlist(st.strlist)
        if wnd then
            --GuidePoint_createRightGuideNode(wnd)
            local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", wnd);
            if ChildNode == nil then
                --GuidePoint_createRectGuideNode(wnd)
            end
            m_Value[GUIDE_TYPE_Escort].num = m_Value[GUIDE_TYPE_Escort].num + 1;
        else
            local wndMain = SCFunction:getUiNodeByIdlist("9110")
            if wndMain then
                m_Value[GUIDE_TYPE_Escort].num = 2
            end            
        end        
    elseif m_Value[GUIDE_TYPE_Escort].num == 1 then--1点击前往
        local st = m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num + 1]
        if not st then return end        
        
        local node = SCFunction:getUiNodeByIdlist(st.strlist)
        if not node then return end 
        
        local pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num].strlist)
        if pReMoveNode then
            pReMoveNode:removeChildByTag(1000, true);
        end
        
        --GuidePoint_createRightGuideNode(node)
        local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", node);
        if ChildNode == nil then
            --GuidePoint_createRectGuideNode(node)
        end
                
        m_Value[GUIDE_TYPE_Escort].num = m_Value[GUIDE_TYPE_Escort].num + 1;
    elseif m_Value[GUIDE_TYPE_Escort].num == 2 then--2、点击仇人
        local st = m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num + 1]
        if not st then return end 
        
        local id = VanFood_GetEnemyIdWithPos(1)
        if not id then return end 
        local node = SCFunction:getUiNodeByIdlist(st.strlist.."-"..id)
        if not node then return end 
        
        local pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num].strlist)
        if pReMoveNode then
            pReMoveNode:removeChildByTag(1000, true);
        end
        
        GuidePoint_createLeftGuideNode(node)        
        local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", node);
        if ChildNode == nil then
            GuidePoint_createLeftGuideNode(node)
        end
        m_Value[GUIDE_TYPE_Escort].num = m_Value[GUIDE_TYPE_Escort].num + 1;
    elseif m_Value[GUIDE_TYPE_Escort].num == 3 then--3、夺回物资
        local st = m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num + 1]
        if not st then return end 
        
        local node = SCFunction:getUiNodeByIdlist(st.strlist)
        if not node then return end 
        
        local id = VanFood_GetEnemyIdWithPos(1)
        if not id then return end         
        local pReMoveNode = SCFunction:getUiNodeByIdlist(m_Value[GUIDE_TYPE_Escort].info[m_Value[GUIDE_TYPE_Escort].num].strlist.."-"..id)
        if pReMoveNode then
            pReMoveNode:removeChildByTag(1000, true);
        end        
        if node:getChildByTag(1000) then
            return
        end
        GuidePoint_createLeftGuideNode(node)
        local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", node);
        if ChildNode == nil then
            GuidePoint_createLeftGuideNode(node)
        end        
    elseif m_Value[GUIDE_TYPE_Escort].num == 4 then--4关闭
        local node = SCFunction:getUiNodeByIdlist("9117")
        if node then
            node:removeFromParentAndCleanup(true)
        end
        m_idTimerPlayer = nil
        isOpenTimer = isOpenTimer - 1;
        m_Value[GUIDE_TYPE_Escort] = nil
        if isOpenTimer == 0 then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
            m_entryId = nil
            m_entryId1 = nil
            m_Value = {}
            m_guidetable = {}
            pNeedNode = nil
            GuidePoint_topGuide()
        end
    end 
end
------------------成长礼包开启做单独处理------------------------------------

--人物引导向下箭头(黄色图标)
function GuidePoint_AddGoods()   --判断是否是自动关闭消失定时器
    if m_flag1 then
        m_flag1 = m_flag1 + 1;
    end
end

local function isRemoveWin()
    CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId2)
    m_entryId2 = nil
    if not getCurentSceneWindowController(7002) then
	    removeAllWindwoController();
    end
end

function GuidePoint_Goods()
    GuidePoint_DeltopGuide();
    local pNode = SCFunction:getUiNodeByIdlist("5918-5933-1-1001")  --人物引导图标
    if pNode == nil then
        return
    end
    local partent = pNode:getParent();
    if partent == nil then
        return;
    end
    local partent1 = partent:getParent();
    if partent1 == nil then
        return;
    end
    partent1:reorderChild(partent, 1000)
    local pActionNode = SCFunction:getUiNodeByIdlist("5918-5933-1-1001-2000")
    if pActionNode == nil then
        GuidePoint_DeltopGuide();
        local imgPath = getRealUIResourcePath("img/new00638.png")
        if imgPath == nil then
            return;
        end
        local pImage = SCImage:imageWithFile(imgPath:getData())
        if pImage == nil then
            return;
        end
        local pLabel = SCLabel:labelWithStringFont(L("str0443"), DEFAULT_FONT_NAME, F(8.5))
        if imgPath and pImage and pLabel then
            --pImage:setTag(10046)
            --pImage:setFlipY(true)
            pImage:setTag(1001)
            pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage:setPosition(AUTO_POS(0.00, 0.00))
            pLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pLabel:setPosition(AUTO_POS(5.00, 30.00))
            pLabel:setColor(ccc4(255, 0, 0, 255))
            --pNode:addChild(tolua.cast(pImage, "SCNode"))
            pImage:addChild(tolua.cast(pLabel, "SCNode"))
        end
        
        local width = pNode:getContentSize().width/2
        local height = pNode:getContentSize().height + pImage:getContentSize().height/2
        local ActionNode = ActionNode:newActionNode();
        if ActionNode then
            ActionNode:setTag(2000)
            ActionNode:setContentSize(pImage:getContentSize());
            ActionNode:setAnchorPoint(ANCHOR_CENTER);
            ActionNode:setPosition(CCPointMake(width, height -SY(2)));
            ActionNode:moveToRetuen(CCPointMake(width, height -SY(2)), CCPointMake(width, height +SY(2)), 0.2);
            ActionNode:addChild(tolua.cast(pImage, "SCNode"))
            pNode:addChild(tolua.cast(ActionNode, "SCNode"))
        end
        m_flag1 = 0;
        if m_flag2 == nil then
            m_entryId2 = nil
            if m_entryId1 == nil then
				m_entryId1 = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(GuidePoint_removeGoods, 16, false)
			end
            m_entryId2 = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(isRemoveWin, 0.7, false)
            m_flag2 = 1;
        end
    end
end

--移除人物引导向下箭头(黄色图标)
function GuidePoint_removeGoods()
    local pNode = SCFunction:getUiNodeByIdlist("5918-5933-1-1001")  --人物引导图标
    if pNode == nil then
        return
    end
    GuidePoint_AddGuideFlag()
    local ActionNode = SCFunction:getUiNodeByIdlist("5918-5933-1-1001-2000") 
    if ActionNode then
        pNode:removeChildByTag(2000, true);
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId1)
        m_entryId1 = nil
        m_flag2 = nil
    end
    if m_flag1 == 0 then   --判断如果是自动删除的话自动关闭定时引导
        if m_entryId1 then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId1)
            m_entryId1 = nil
            m_flag2 = nil
        end
        --CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
        m_flag1 = nil
    elseif m_flag1 == 1 then
        if m_entryId1 then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId1)
            m_entryId1 = nil
            m_flag2 = nil
        end
        table.insert(m_guidetable, GUIDE_TYPE_Goods);
        if isOpenTimer == 0 then
            GuidePoint_Init(GUIDE_TYPE_Goods);
            GuidePoint_createGoods(m_Value[GUIDE_TYPE_Goods].info, m_idtype)
            isOpenTimer = isOpenTimer + 1
            if m_entryId == nil then
                m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
            end
        else
            GuidePoint_Init(GUIDE_TYPE_Goods);
            GuidePoint_createGoods(m_Value[GUIDE_TYPE_Goods].info, m_idtype)
            isOpenTimer = isOpenTimer + 1
        end
        m_flag1 = nil
    end
    GuidePoint_topGuide();
end

--查找是否找到物品
function GuidePoint_SearchGoods(Typeid, Value)
    for i = 1, Value do
        local item = ItemProcessor:getSingleton():getItemByTypeID(Typeid[i]);   --判断是否能获取item  
        if item then
            m_idtype = Typeid[i]
            return true
        end
    end
    return false
end

--判断背包是否有可开启礼包
function GuidePoint_TellGifts()
    local Lev = Hero:getSingleton():getLeval();
    local Typeid = {3461000141, 3461000142, 3461000143, 3461000144, 3461000145, 3461000146, 3461000147, 3461000148, 3461000149, 3461000150} --礼包id
    if Lev >= 10 and Lev < 20 then
        if GuidePoint_SearchGoods(Typeid, 1) == true then
            return true
        else
            return false
        end
    elseif Lev >= 20 and Lev < 30 then
        if GuidePoint_SearchGoods(Typeid, 2) == true then
            return true
        else
            return false
        end
    elseif Lev >= 30 and Lev < 40 then
        if GuidePoint_SearchGoods(Typeid, 3) == true then
            return true
        else
            return false
        end
    elseif Lev >= 40 and Lev < 50 then
        if GuidePoint_SearchGoods(Typeid, 4) == true then
            return true
        else
            return false
        end
    elseif Lev >= 50 and Lev < 60 then
        if GuidePoint_SearchGoods(Typeid, 5) == true then
            return true
        else
            return false
        end
    elseif Lev >= 60 and Lev < 70 then
        if GuidePoint_SearchGoods(Typeid, 6) == true then
            return true
        else
            return false
        end
    elseif Lev >= 70 and Lev < 80 then
        if GuidePoint_SearchGoods(Typeid, 7) == true then
            return true
        else
            return false
        end
    elseif Lev >= 80 and Lev < 90 then
        if GuidePoint_SearchGoods(Typeid, 8) == true then
            return true
        else
            return false
        end
    elseif Lev >= 90 and Lev < 100 then
        if GuidePoint_SearchGoods(Typeid, 9) == true then
            return true
        else
            return false
        end
    elseif Lev >= 100 then
        if GuidePoint_SearchGoods(Typeid, 10) == true then
            return true
        else
            return false
        end
    end
end

--添加礼包引导
function GuidePoint_AddGiftsGuide()
    local flag = GuidePoint_TellGifts();
    if flag == true then
        if m_flag == 0 then
            GuidePoint_DeltopGuide();
            MainInterface_ShowBtn();
            GuidePoint_Goods();
        end
    end
end

function GuidePoint_AddGuideFlag()
    m_flag = m_flag + 1
end

function GuidePoint_InitFlag()
    m_flag = 0
end
--添加自动寻路边框
local function GuidePoint_addFrame()
    local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007"), "SCNode");
    if pNode == nil then
        return;
    end
    local imgPath = getRealUIResourcePath("img/new00699.png")
	if imgPath then
        local pImage = SCImage:imageWithFile(imgPath:getData())
		if pImage then
            pImage:setTag(2000)
            --pImage:setScale(0.9)
            pImage:setAnchorPoint(ANCHOR_CENTER)
            pImage:setPosition(CCPointMake(pNode:getContentSize().width/2, pNode:getContentSize().height/2))
            pNode:addChild(tolua.cast(pImage, "SCNode"), 10000)
        end
	end
end

--添加任务引导
function GuidePoint_topGuide()
    local isClose = FirstLoginVeiw_getIsClose()
    if isClose == false then
        return
    end
    local lev = Hero:getSingleton():getLeval()
    if lev <= 27 then
        local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007"), "SCNode");
        if pNode == nil then
            return;
        end
        local ChildNode = SCFunction:getUiNodeByIdlistAndParent("1000", pNode);
        if ChildNode == nil then
            if isDelGuide1() == true and GuidePoint_isOpenTime() == true then 
                GuidePoint_createRightGuideNode(pNode)
                GuidePoint_addFrame()
            end
        end
    end
end

--删除任务引导
function GuidePoint_DeltopGuide()
    local pNode = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007"), "SCNode")
    local pNode1 = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007-1000"), "SCNode")
    local pNode2 = tolua.cast(SCFunction:getUiNodeByIdlist("5918-5932-1007-2000"), "SCNode")
    if pNode and pNode1 and pNode2 then
        pNode:removeChild(pNode1, true)
        pNode:removeChild(pNode2, true)
    end
end

--成长礼包定时器是否开启
function GuidePoint_isOpenTime()
    if m_entryId1 == nil then
        return true;
    else
        return false;
    end
end
function GuidePoint_isGuideFirstCSkill()
    if m_Value[GUIDE_TYPE_Award] and m_Value[GUIDE_TYPE_CSkill] then
        return true
    end
    return false
end
function GuidePoint_startSkillNode()
    m_isStartCSkillGuide = true
    GuidePoint_CSkill()
end
function GuidePoint_openRewardsFunction()
	table.insert(m_guidetable, GUIDE_TYPE_Reward);
	if isOpenTimer == 0 then
		GuidePoint_Init(GUIDE_TYPE_Reward);
		GuidePoint_createReward(m_Value[GUIDE_TYPE_Reward].info)
		isOpenTimer = isOpenTimer + 1
		if m_entryId == nil then
			m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(BeginLoop, 0, false)
		end
	else
		GuidePoint_Init(GUIDE_TYPE_Reward);
		GuidePoint_createReward(m_Value[GUIDE_TYPE_Reward].info)
		isOpenTimer = isOpenTimer + 1
	end
end
----------------消息注册区----------------
LuaData:getSingleton():luaSetSelectorOnRecvData(GuidePoint_setSeverInfo, LuaData_USERINFO_GUIDE_BEGIN)



