--定义一个与文件名相同的table
Kits = {}
------------------消息--------------------
local ACTION_ACTIVE_SHOW        = 0; --//活跃度玩法查询 
local ACTION_ACTIVE_SHOWEND     = 1; 
local ACTION_ACTIVE_GETAWARD    = 2; --//领取活跃度礼包 

----------------结构定义区----------------
local stActiveInfoSet = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {__mode = "kv"}
        tmp.idActive = dt:readInt()         --活跃表ID
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szActiveName = ""           --名称
        else
            tmp.szActiveName = scStr:getData()
        end
        tmp.nActiveNum = dt:readInt()       --当前活跃度
        tmp.nCurTimes = dt:readInt()        --当前次数
        tmp.nMaxTimes = dt:readInt()        --总次数
        tmp.ucUnLock = dt:readByte()        --是否解锁
        tmp.usUnLockLev = dt:readShort()    --解锁等级
        return tmp
    end
}
local stActiveInfoSet = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {__mode = "kv"}
        tmp.dwTodayActive = dt:readInt()
        tmp.dwAwardFlag = dt:readInt()
        tmp.ucAmount = dt:readByte()
        tmp.setActiveData = {__mode = "kv"};
        for i = 1, tmp.ucAmount do            
          table.insert(tmp.setActiveData, stActiveInfoSet.initWithStream(dt))
        end
        return tmp
    end
}

----------------常量定义区----------------

----------------变量定义区----------------
--变量的定义
----------------UI控制器区----------------
function Kits.initControl()
	local pWindow7024 = SCWindow:window()
	if pWindow7024 then
		pWindow7024:setTag(7024)
		pWindow7024:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow7024:setPosition(AUTO_POS(0.00, 0.00))
		pWindow7024:setContentSize(AUTO_SIZE(480, 320))
		pWindow7024:luaSetSelectorOnClose(Kits.releaseControl)
	end

	return pWindow7024
end
function Kits.releaseControl()
	if Kits.wndCloss then
		Kits.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------
local function ControlOperating()
end

local function setWindowAttribute(tag, type)
    if type == LuaControllerEventPushEnded then
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_ACTIVE);
        if dataStream then
            dataStream:writeShort(ACTION_ACTIVE_SHOW);
            SCDataTransThread:getSingleton():transData(dataStream);
            SCActivityIndicator:getSingleton():show();
        end
    end
end

----------------消息处理区----------------
local function recvKitsInfo()
    SCActivityIndicator:getSingleton():close();
    local dt = SCMessageCenter:getSingleton():getDataTransStream()
    if dt == nil then
        return;
    end
    local action = dt:readShort()
    if action == ACTION_ACTIVE_SHOW then
    elseif action == ACTION_ACTIVE_SHOWEND then
    elseif action == ACTION_ACTIVE_GETAWARD then
    end
end

----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(recvKitsInfo, _MSG_ACTIVE, 0, nil)
----------------全局函数区----------------
function Kits.showKitsWnd()
    local wnd = Kits.initControl();
    if wnd == nil then
        return;
    end
    ControlOperating();
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            wndCtrl:luaSetSelectorOnEvent(setWindowAttribute);
            return
        end
    end
end


--函数调用