local partnerLevelUpInfo = {};
local EntryID = nil;
local partnerLevelUpNode = nil;
local m_bIsShow = false
local m_bIsBatter = false
local LEVELUP_SDK_DATA = 6
local function leadLevelUpAnimationEnd()
	local UINode = getRunningScene():getUINode()
	if UINode:getChildByTag(5922) then
		UINode:removeChildByTag(5922, true);
	end
	m_bIsShow = false
	m_bIsBatter = false
	if getIsShowNewFunAnimation() then
		showNewFunOpenAnimation()
	end
end

local function btnEndOpenList()
    local scene = SCBaseScene:getRunningScene()
    if scene == nil or scene:getUINode() == nil then
        return;
    end
    scene:getUINode():removeChildByTag(8004,true)--窗口移除
	SkillView_TipShow(3);
end

local function onClickBtn(tag)
    local scene = SCBaseScene:getRunningScene()
    if scene == nil or scene:getUINode() == nil then
        return;
    end
    scene:getUINode():removeChildByTag(8004,true)--窗口移除
    local frameWndNode = FrameWindow:frameWnd()
    local imgFile = getRealUIResourcePath("MainInterfaceImg/5010.png");
    if imgFile and frameWndNode then
        frameWndNode:setTag(8004)
        frameWndNode:setOutSpaceClickClose(false)
        frameWndNode:setCloseBtnVisible(false)
        frameWndNode:setContentSize(CCSizeMake(getScreenWidth(), getScreenHeight()))
        frameWndNode:setFrameVisibled(false)
        scene:getUINode():addChild(frameWndNode);
        local titleImage = SCImage:imageWithFile(imgFile:getData()) 
        if titleImage then
            local pnode = ActionNode:newActionNode();
            if pnode then
                pnode:setContentSize(titleImage:getContentSize());
                pnode:setAnchorPoint(CCPointMake(0, 0));
                pnode:setPosition(CCPointMake(SX(262), SY(192)));
                local pNode = MainInterface_getMainBtn(1010);
                if pNode then
                    local pt = pNode:convertToWorldSpace(CCPointMake(0, 0));
                    pnode:moveAndSpawnTo(pt, 1.2);--参数2 秒
                end
                pnode:luaSetSelectorOnMoveEnd(btnEndOpenList);
                pnode:addChild(titleImage)
                frameWndNode:addChild(pnode);
            end
        end
    end
end

local function showLevelUpdata()
	local playerLevel = Hero:getSingleton():getLeval();
	if CLIENT_TYPE == 2 then
		if playerLevel ~= 19 and playerLevel ~= 29 then
		--if playerLevel ~= 19 then
		    return;
		end
	else
		--if playerLevel ~= 19 and playerLevel ~= 29 then
		if playerLevel ~= 29 then
		    return;
		end
	end
    local naviCtrl = getCurentSceneNavigationController()
	if naviCtrl then--移除除主界面其他窗口
		naviCtrl:removeAllWindowControllers()
	end
    local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(62.00, 8.00))
		pDragNode2:setContentSize(AUTO_SIZE(356, 268))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTypeLine)
	end

	local imgPath = getRealUIResourcePath("img/new00701.pn")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage3:setPosition(AUTO_POS(10.00, 46.00))
		end
	end

	local pDragNode4 = SCDragNode:node()
	if pDragNode4 then
		pDragNode4:setTag(4)
		pDragNode4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode4:setPosition(AUTO_POS(12.00, 34.00))
		pDragNode4:setContentSize(AUTO_SIZE(335, 137))
		pDragNode4:setFrameVisibled(true)
		pDragNode4:setDragEnabled(false)
		pDragNode4:setFrameType(EnumFrameTypeTip3)
	end

	local pDragNode5 = SCDragNode:node()
	if pDragNode5 then
		pDragNode5:setTag(5)
		pDragNode5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode5:setPosition(AUTO_POS(257.00, 168.00))
		pDragNode5:setContentSize(AUTO_SIZE(90, 90))
		pDragNode5:setFrameVisibled(true)
		pDragNode5:setDragEnabled(false)
		pDragNode5:setFrameType(EnumFrameTypeTip3)
	end

	local pButton6 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton6 then
		pButton6:setTag(6)
		pButton6:setAnchorPoint(ANCHOR_CENTER)
		pButton6:setPosition(CCPointMake(pDragNode5:getContentSize().width/2, pDragNode5:getContentSize().height/2))
		pButton6:setContentSize(AUTO_SIZE(54, 54))
		local imgPath = getRealUIResourcePath("img/new00448.png")
		if imgPath then
			pButton6:setTitle(imgPath:getData())
		end
		local imgFile = getRealUIResourcePath("MainInterfaceImg/5010.png");
        if imgFile then
            pButton6:setBackgroundImage(imgFile:getData())  
        end
	end
	local pButton7 = SCButton:button(EnumBtnType9Atlas)
	if pButton7 then
		pButton7:setTag(7)
		pButton7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton7:setPosition(AUTO_POS(148.00, 9.00))
		pButton7:setContentSize(AUTO_SIZE(76, 29))
		local imgPath = getRealUIResourcePath("img/new00024.png")
		if imgPath then
			pButton7:setTitle(imgPath:getData())
		end
		--pButton7:setTouchRectScale(WIN_SIZE.width, WIN_SIZE.height)
		pButton7:luaSetSelectorOnClicked(onClickBtn);
	end
	local pLable8 = nil;
	local pText9 = nil;
        pLable8 = SCLabel:labelWithStringFont(L("str6257"), DEFAULT_FONT_NAME, F(15))
        if pLable8 then
            pLable8:setColor(color_orange);
            pLable8:setTag(8)
            pLable8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pLable8:setPosition(AUTO_POS(10.00, 107.00))
        end

        pText9 = SCTextBox:boxWithWidthHeightFont(AUTO_W(314), AUTO_H(75), DEFAULT_FONT_NAME, F(12));
        if pText9 then
            pText9:setTag(9)
            pText9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pText9:setPosition(AUTO_POS(10.00, 27.00))
            pText9:setScrollVertical(false)
            if playerLevel == 19 then
				if CLIENT_TYPE == 2 then
					if string.find(getAppName():getData(), "IOS") then
						TextParser:getSingleton():setText(pText9, L("str9217"))
					else
						TextParser:getSingleton():setText(pText9, L("str6255"))
					end
				end
            elseif playerLevel == 29 then
				if string.find(getAppName():getData(), "IOS") then
					TextParser:getSingleton():setText(pText9, L("str9218"))
				else
					TextParser:getSingleton():setText(pText9, L("str6256"))
				end
            end
        end

	if pImage3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if pDragNode4 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode4, "SCNode"))
	end
	if pDragNode5 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode5, "SCNode"))
	end
	if pButton6 and pDragNode5 then
		pDragNode5:addChild(tolua.cast(pButton6, "SCNode"))
	end
	if pButton7 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton7, "SCNode"))
	end
	if pLable8 and pDragNode4 then
		pDragNode4:addChild(tolua.cast(pLable8, "SCNode"))
	end
	if pText9 and pDragNode4 then
		pDragNode4:addChild(tolua.cast(pText9, "SCNode"))
	end                
    m_window_Width  = getScreenWidth()
    m_window_Height = getScreenHeight()  
	m_titleCenterX = SX(262);
    m_titleCenterY = SY(192);
    
    frameWndNode = FrameWindow:frameWnd()
    frameWndNode:setTag(8004)
    frameWndNode:setOutSpaceClickClose(false)
    frameWndNode:setCloseBtnVisible(false)
    frameWndNode:setContentSize(CCSizeMake(m_window_Width, m_window_Height))
    frameWndNode:setFrameVisibled(false)
    
    local scene = SCBaseScene:getRunningScene();
    if scene then
        local pNode = scene:getUINode();
        if pNode then
            frameWndNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            frameWndNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, pNode:getContentSize().height / 2));
            if pDragNode2 then
                frameWndNode:addChild(pDragNode2);
                pDragNode2:setAnchorPoint(CCPointMake(0.5, 0.5));
                pDragNode2:setPosition(CCPointMake(frameWndNode:getContentSize().width / 2, frameWndNode:getContentSize().height / 2 - SY(25)));
            end
            m_Value = 200
            frameWndNode:setBackgroundColor(ccc4(0, 0, 0, m_Value))--设置灰色透明背景
            pNode:addChild(frameWndNode, Max_Int)
        end
    end
end

local function leadLevelUpAnimation()
    if m_bIsShow == false then
        return;
    end
    if m_bIsBatter then
        BattleStrengthen_runNumberAction(1, 2)
    end
	local pNde = SCNode:node();
	pNde:setTag(5922);
	pNde:setBackgroundColor(ccc4(0, 0, 0, 120));
	local pAi = SCLookfaceParser:getSingleton():getAnimationByIndex(1011, 1011);
	if not pAi then
		return
	end
	pAi:luaSetSelectorOnComplete(leadLevelUpAnimationEnd);
	pAi:setAutoremoveOnComplete(true);
	local pNode =  SCAnimationNode:nodeWithAnimation(pAi);
 	pNode:setAnchorPoint(CCPointMake(0.5,0));
 	pNode:setPosition(CCPointMake(getScreenWidth()/2, getScreenHeight()/2));
	pNde:addChild(pNode);
	local UINode = getRunningScene():getUINode()
	if UINode:getChildByTag(5922) == nil then
		UINode:addChild(pNde);
	end
	playEffectMusic("upgrade.mp3");
	refreshCurrencyInfo()	
    local lev = Hero:getSingleton():getLeval();
    if lev%10 == 0 then
        GuidePoint_InitFlag()
		GuidePoint_DeltopGuide();
		if isDelGuide1() == true then
        	GuidePoint_AddGiftsGuide();
		end
        GuidePoint_AddGuideFlag()
    end
    showLevelUpdata();
end

--[[
local function leadLevelUpAnimation()
	triggerEffect:createShowedEffect(1104, 1134, CCPointMake(240, 250));
end
]]


local showPartnerLevelUp
local function onTimer(time)
	local isChange = false;
    for i=table.getn(partnerLevelUpInfo), 1, -1 do
		partnerLevelUpInfo[i]["showTime"] = partnerLevelUpInfo[i]["showTime"] - 1;
		if partnerLevelUpInfo[i]["showTime"] == 0 then
			partnerLevelUpNode:removeChildByTag(partnerLevelUpInfo[i]["id"], true);
			table.remove(partnerLevelUpInfo, i);
			i = i - 1;
			isChange = true;
		end
    end
    if isChange == true then
		showPartnerLevelUp();
	end
	if table.getn(partnerLevelUpInfo) == 0 then
		CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(EntryID);
		EntryID = nil;
		local mainInterface = getMainInterface()
		if mainInterface then
			mainInterface:removeChildByTag(10087, true);
		end

	end
end

local function onClickDialog(tag)
	for i=1, table.getn(partnerLevelUpInfo) do
		if partnerLevelUpInfo[i]["id"] == tag then
			partnerLevelUpNode:removeChildByTag(partnerLevelUpInfo[i]["id"], true);
			table.remove(partnerLevelUpInfo, i);
			showPartnerLevelUp();
			break;
		end
    end
end

local function makePartnerDialog(imgfile, dialog)
	local btn = SCButton:button();
	local file = getRealUIResourcePath("faceicon/"..imgfile..".png");
	if file then
		btn:setTitle(file:getData());
	end
	btn:luaSetSelectorOnClicked(onClickDialog);
	
	file = getRealUIResourcePath("img/img5051.png");
	local img = SCImage:imageWithFile(file:getData());
	img:setPosition(CCPointMake(btn:getContentSize().width/2+SX(5), SY(2)));
	
	local textBox = SCTextBox:boxWithWidthHeightFont(SX(104), SY(38), getDefaultFontName(), getFontSize(12));
	textBox:setAnchorPoint(CCPointMake(0.5, 0.5));
	textBox:setPosition(CCPointMake(img:getContentSize().width/2+SX(10), img:getContentSize().height/2-SY(2)));
	textBox:setText(dialog);
	img:addChild(tolua.cast(textBox, "SCNode"));
	
	btn:addChild(tolua.cast(img, "SCNode"));
	
	return btn;
end

function showPartnerLevelUp()
    if EntryID == nil then
		EntryID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(onTimer, 1.0, false);
    end
    local mainInterface = getMainInterface()
    if mainInterface then
		 if mainInterface:getChildByTag(10087) == nil then
			partnerLevelUpNode = SCNode:node();
			partnerLevelUpNode:setTag(10087);
			partnerLevelUpNode:setPosition(CCPointMake(SX(4), SY(110)));
			mainInterface:addChild(partnerLevelUpNode);
		end
    end
    
    for i=1, table.getn(partnerLevelUpInfo) do
		local btn = SCTypeCast:castNodeToButton(partnerLevelUpNode:getChildByTag(partnerLevelUpInfo[i]["id"]));
		if btn == nil then
			btn = makePartnerDialog(partnerLevelUpInfo[i]["photo"], partnerLevelUpInfo[i]["showDialogInfo"]);
			btn:setTag(partnerLevelUpInfo[i]["id"]);
			partnerLevelUpNode:addChild(tolua.cast(btn, "SCNode"));
		end
		btn:setPosition(CCPointMake(0, (i-1)*(btn:getContentSize().height+SY(5))));
		partnerLevelUpNode:setContentSize(CCSizeMake(btn:getContentSize().width, (btn:getContentSize().height+5)*i));
    end
end

local function recvLevelUpMsg()
	local dt = SCMessageCenter:getSingleton():getDataTransStream();
	local id = dt:readInt();
    local action = dt:readShort();
    if action == 1 then
		m_bIsShow = true
		if Hero:getSingleton():getBatter() == true then
		    m_bIsBatter = true
		    return;
		end
		--if BattleProcessor:getSingleton():getIsInBattle() then
		--	BattleProcessor:getSingleton():setIsShowLevelUpAnimation(true)
		--else
		    --GuidePoint_setStepInfo()
		    --GuidePoint_setAutoInfo()
		    
			leadLevelUpAnimation()
		--end
    elseif action == 2 then
        local tmp = {};
        tmp["id"] = id;
        tmp["usData"] = dt:readShort();
        tmp["usHp"] = dt:readShort();
        tmp["usMp"] = dt:readShort();
        tmp["usAtk"] = dt:readShort();
        tmp["usDef"] = dt:readShort();
        tmp["usSpeed"] = dt:readShort();
        tmp["usDodge"] = dt:readShort();
        tmp["usHit"] = dt:readShort();
        tmp["photo"] = dt:readInt();
        tmp["showDialogInfo"] = dt:readString();
        if tmp["showDialogInfo"] then
			tmp["showDialogInfo"] = tmp["showDialogInfo"]:getData();
        end        
        tmp["showTime"] = 100;
        for i=1, table.getn(partnerLevelUpInfo) do
			if tmp["id"] == partnerLevelUpInfo[i]["id"] then
				return;
			end
		end
		if tmp["showDialogInfo"] then
			table.insert(partnerLevelUpInfo, tmp);
			showPartnerLevelUp();
		end
	elseif action == LEVELUP_SDK_DATA then
		
    end
end

--registCommand
SCMessageCenter:getSingleton():luaRegistCommand(recvLevelUpMsg, _MSG_LEVELUP, 0, nil);

function showPlayerLevelUpAnimation()
	leadLevelUpAnimation()
end

function getIsShowLevelUpAnimation()
	return m_bIsShow
end