local MSG_ITEM_INFO_PERVIEW = 15  --根据itemid物品查看
local MSG_ITEMTYPEINFO_QUERY = 2  --根据itemType查看物品

local function sendLookItemInfoMsg(itemId)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEMTYPEINFO)
	dataStream:writeByte(MSG_ITEM_INFO_PERVIEW)
	dataStream:writeInt(itemId)
	SCDataTransThread:getSingleton():transData(dataStream)
end

local function showItemInfo(title, content, itemImgId, itemTypeId)
	showTip(content, title, itemImgId, itemTypeId);
	--[[
	local runScene = getRunningScene()
	if not runScene then
		return
	end

	local tipWnd = runScene:getUINode():getChildByTag(5909)
	if not tipWnd then
		tipWnd = TipWindow:newWindow()
		if not tipWnd then
			return
		end
		tolua.cast(tipWnd, "SCNode"):setContentSize(CCSizeMake(120, tolua.cast(tipWnd, "SCNode"):getContentSize().height))
		tipWnd:setContent(itemStr)
		tolua.cast(tipWnd, "SCNode"):setContentSize(CCSizeMake(160, tolua.cast(tipWnd, "SCNode"):getContentSize().height))
		runScene:getUINode():addChild(tolua.cast(tipWnd, "SCNode"), 2147483647, 5909)
	end
	if tolua.cast(tipWnd, "SCNode"):getChildByTag(101) then
		tolua.cast(tipWnd, "SCNode"):removeChildByTag(101, true)
	end	
	local imgFile, rect= getItemImageByIcon(imgId)
	local imgNode = SCImage:imageWithFile(imgFile:getData(), rect)
	imgNode:setTag(101)
	imgNode:setAnchorPoint(CCPointMake(1, 1))
	imgNode:setPosition(CCPointMake(tolua.cast(tipWnd, "SCNode"):getContentSize().width-10, tolua.cast(tipWnd, "SCNode"):getContentSize().height-10))
	tolua.cast(tipWnd, "SCNode"):addChild(imgNode)
	]]
end

local function sendLookItemTypeMsg(itemType)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ITEMTYPEINFO)
	dataStream:writeByte(MSG_ITEMTYPEINFO_QUERY)
	dataStream:writeInt(itemType)
	SCDataTransThread:getSingleton():transData(dataStream)
end

local function showItemTypeInfo(title, content, itemImgId, itemTypeId)
    showTip(content, title, itemImgId, itemTypeId);
end

local function recvItemInfo()
	SCActivityIndicator:getSingleton():close()
	local dt = SCMessageCenter:getSingleton():getDataTransStream()
	if not dt then
		return
	end
	local action = dt:readByte()
	if action == MSG_ITEM_INFO_PERVIEW then
		local tmpStr = ""
		local scStr = dt:readString()
		if scStr then
			tmpStr = scStr:getData()
		end
		local tmpStr = Split(tmpStr, "_")
		local title = tmpStr[1];
		if title == "" then
			title = " "
		end
		local content = ""
		for i=3, #tmpStr do
			content = content..tmpStr[i]
			content = content.."_"
		end
		local scStr = dt:readString()
		if scStr then
			content = content..scStr:getData()
		end
		local itemImgId = dt:readInt()
		local itemTypeId = dt:readInt()
		showItemInfo(title, content, itemImgId, itemTypeId)
	elseif action == MSG_ITEMTYPEINFO_QUERY then
	    local tmpStr = ""
		local scStr = dt:readString()
		if scStr then
			tmpStr = scStr:getData()
		end
		local tmpStr = Split(tmpStr, "_")
		local title = tmpStr[1];
		if title == "" then
			title = " "
		end
		local content = ""
		for i=3, #tmpStr do
			content = content..tmpStr[i]
			content = content.."_"
		end
		local scStr = dt:readString()
		if scStr then
			content = content..scStr:getData()
		end
		local itemImgId = dt:readInt()
		local itemTypeId = dt:readInt()
		showItemTypeInfo(title, content, itemImgId, itemTypeId)
	end
end

--/**item id 非 itemType id*/
function luaLookItemInfo(itemId)
	sendLookItemInfoMsg(itemId)
end

--/**itemType id 非 item id*/
function luaLookItemType(itemType)
    sendLookItemTypeMsg(itemType)
end


SCMessageCenter:getSingleton():luaRegistCommand(recvItemInfo, _MSG_ITEMTYPEINFO, 0, nil);