--宫殿牌占卜8017界面

MSG_SOCIATY_OPEN_LOTTERY1            = 65--//打开宫殿牌界面
MSG_SOCIATY_CHICK_LOTTERY1          = 66--/点击全服塔罗牌抽奖
MSG_SOCIATY_CHICK_ENSURE            = 68--//点击确定
MSG_SOCIATY_CHICK_RUFFLE            = 67--//点击洗牌

local m_frameWndNode  = nil 

local m_currentSendCardIndex = nil

local m_isShuffle = nil--是否洗牌发牌中

local m_cardImageList = nil--获得的牌列表

local m_topTimeStr = nil--玩家剩余次数、免费次数字符串
local m_topUserDetail = nil

local m_titleAwardName = nil
local m_awardStr = nil--奖励数据

local m_totalTime = nil--洗牌次数
local m_freeTime = nil--免费换牌次数

local m_currentExp = nil
local m_maxExp = nil

local function removeAllData()
    closeWindowById(80171)
    m_frameWndNode  = nil 

    m_currentSendCardIndex = nil

    m_isShuffle = nil--是否洗牌发牌中

    m_cardImageList = nil--获得的牌列表

    m_topTimeStr = nil--玩家剩余次数、免费次数字符串
    m_topUserDetail = nil
    
    m_titleAwardName = nil
    m_awardStr = nil--奖励数据

    m_totalTime = nil--洗牌次数
    m_freeTime = nil--免费换牌次数
    
    m_currentExp = nil
    m_maxExp = nil
end

local function colseWnd()
    if m_isShuffle == true then--洗牌中
        return
    end
    closeWindowById(8017)
end

--显示头部剩余次数
local function showTopContent()
    if m_frameWndNode == nil then
        return
    end
    local topContentLayer = m_frameWndNode:getChildByTag(8017001)
    if topContentLayer then
        m_frameWndNode:removeChildByTag(8017001,true)
    end
        
    local width  = m_frameWndNode:getContentSize().width
    local height = m_frameWndNode:getContentSize().height
    
   
    local showWidth  = width*0.7
    local showHeight = height*0.12
    local startX = (width-showWidth)/2
    local startY = height-showHeight
    
    topContentLayer = SCDragNode:node()
    topContentLayer:setTag(8017001)
    topContentLayer:setFrameVisibled(true)
    --topContentLayer:setFrameType(EnumFrameTypeRound)
    topContentLayer:setAnchorPoint(CCPointMake(0,0));
	topContentLayer:setPosition(CCPointMake(startX,startY));
	topContentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
    m_frameWndNode:addChild(topContentLayer)
    
    --洗牌次数
    if m_topTimeStr then
        local totalNumNode = ParsedNode:getParsedNode(m_topTimeStr,0,14)
        totalNumNode:setAnchorPoint(CCPointMake(0.5,0));
        totalNumNode:setPosition(CCPointMake(showWidth/2,showHeight-totalNumNode:getContentSize().height-SY(5)));
        topContentLayer:addChild(totalNumNode)   
    end
     
    --玩家数据
    if m_topUserDetail then
        local detailNode = ParsedNode:getParsedNode(m_topUserDetail,0,12)
        detailNode:setAnchorPoint(CCPointMake(0.5,0));
        detailNode:setPosition(CCPointMake(showWidth/2,SY(0)));
        topContentLayer:addChild(detailNode) 
    end
    
    if m_currentExp and m_maxExp then
        
        --修为经验
        local titleStrNode = ParsedNode:getParsedNode("*6".._LTParser("str8111"),0,12)
        titleStrNode:setAnchorPoint(CCPointMake(0,0.5));
        titleStrNode:setPosition(CCPointMake(showWidth*0.2-titleStrNode:getContentSize().width,-SY(10)));
        topContentLayer:addChild(titleStrNode) 
        
        local pBarBack = SCProgressBar:barWithType(EnumProgressBarTypeBlack)
        pBarBack:setMaxValue(480)
        pBarBack:setValue(220)
        pBarBack:setAnchorPoint(CCPointMake(0,0.5));
        pBarBack:setPosition(CCPointMake(showWidth*0.2,-SY(10)));
        topContentLayer:addChild(pBarBack)
        
        if m_currentExp > m_maxExp then
            m_currentExp = m_maxExp
        end
        
        if m_maxExp <= 0 then
            m_currentExp = 1
            m_maxExp = 1
        end
        
        local bar = SCProgressBar:barWithType(EnumProgressBarTypeBlue)
        if bar then
            bar:setAnchorPoint(CCPointMake(0,0.5));
            bar:setPosition(CCPointMake(showWidth*0.2,-SY(10)));
            bar:setMaxValue(480)
            bar:setValue(220*m_currentExp/m_maxExp)
            topContentLayer:addChild(bar)
        end
	
	local strLabel = SCLabel:labelWithStringFont(m_currentExp.."/"..m_maxExp ,getDefaultFontName(), getFontSize(10))
    	strLabel :setAnchorPoint(CCPointMake(0.5,0.5));
    	strLabel :setPosition(CCPointMake(showWidth*0.2+SX(120),-SY(10)));
    	topContentLayer:addChild(strLabel)
    end
    
end

--显示结果牌
local function showResultCard()
    if m_frameWndNode == nil then
        return
    end
    
    if m_cardImageList == nil or #m_cardImageList < 1 then
        return
    end
    
    local width  = m_frameWndNode:getContentSize().width
    local height = m_frameWndNode:getContentSize().height
    
    local amount = #m_cardImageList
    if amount > 6 then
        amount = 6
    end
    local tmpX = width*0.1
    local tmpY = height*0.16
    local spaceW = width*0.12
    for i=1,amount do
        local cardImageNode = m_frameWndNode:getChildByTag(801700+i)
        if cardImageNode then
            m_frameWndNode:removeChildByTag(801700+i,true)--移除背面牌
        end
        
        local imgFile = getRealUIResourcePath("item/img"..m_cardImageList[i]..".jpg");
        if imgFile then
            local cardImage = SCImage:imageWithFile(imgFile:getData()) 
            cardImage:setTag(801700+i)
            cardImage:setAnchorPoint(CCPointMake(0.5,0.5));
            cardImage:setPosition(CCPointMake(tmpX+i*spaceW,tmpY));
            m_frameWndNode:addChild(cardImage)
        end
    end
end



--确认按钮
local function confirmBtnAction()
    closeWindowById(80171)
    m_isShuffle = false
    
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_CHICK_ENSURE);
    SCDataTransThread:getSingleton():transData(dt);
end

--点击洗牌换牌
local function changerBtnAction()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_CHICK_RUFFLE);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--弹出确认框
function showConfirmWindow()
    
     --界面背景
    local imgFile = getRealUIResourcePath("img/new00001.png");
    if imgFile == nil then
        return
    end
    local bgImage = SCImage:imageWithFile(imgFile:getData()) 
    
    local width  = getScreenWidth()
    local height = getScreenHeight()
    
    local showWidth  = bgImage:getContentSize().width
    local showHeight = bgImage:getContentSize().height
    
    local scene = SCBaseScene:getRunningScene()
    
    local frameWndNode = scene:getUINode():getChildByTag(80171)
    
    if frameWndNode == nil then
        frameWndNode = FrameWindow:frameWnd()
        frameWndNode:setTag(80171)
        frameWndNode:setOutSpaceClickClose(false)
        frameWndNode:setContentSize(CCSizeMake(showWidth, showHeight))
        frameWndNode:setFrameVisibled(false)
        frameWndNode:setCloseBtnVisible(false)
        frameWndNode:setAnchorPoint(CCPointMake(0.5,0.5));
        frameWndNode:setPosition(CCPointMake(width/2,height/2));
        frameWndNode:addChild(bgImage)
        
        scene:getUINode():addChild(frameWndNode, Max_Int)
    else
        frameWndNode:removeAllChildrenWithCleanup(true)
        frameWndNode:addChild(bgImage)
    end
    
    
   
    --奖励名称
    if m_titleAwardName then
        local totalNumNode = ParsedNode:getParsedNode(m_titleAwardName,0,24)
        totalNumNode:setAnchorPoint(CCPointMake(0.5,0.5));
        totalNumNode:setPosition(CCPointMake(showWidth/2,showHeight*0.7));
        frameWndNode:addChild(totalNumNode)   
    end
    
    
    --奖励详细
    if m_awardStr then
        local detailNode = ParsedNode:getParsedNode(m_awardStr,0,12)
        detailNode:setAnchorPoint(CCPointMake(0.5,0));
        detailNode:setPosition(CCPointMake(showWidth/2,showHeight*0.38));
        frameWndNode:addChild(detailNode) 
    end
    
    
    --确定按钮
    local okBtn = SCButton:button(EnumBtnTypeNormalImg)
    okBtn:setTitle(_LTParser("str8108"),getDefaultFontName(), getFontSize(15),getColorWhite())
    okBtn:setBackgroundImage(getRealUIResourcePath("img/img2086.png"):getData())
    okBtn:setSelectedImage(getRealUIResourcePath("img/img2087.png"):getData())
    okBtn:setAnchorPoint(CCPointMake(0.5,0));
    okBtn:setPosition(CCPointMake(showWidth*0.3,SY(5)));
    okBtn:luaSetSelectorOnClicked(confirmBtnAction)
    frameWndNode:addChild(okBtn)
    
    local tmpBtnName = ""
    if m_freeTime and m_freeTime > 0 then
       tmpBtnName = _LTParser("str8109")--免费洗牌
    else
        tmpBtnName = _LTParser("str8110")--上帝之手
    end
    --免费洗牌按钮
    local changeBtn = SCButton:button(EnumBtnTypeNormalImg)
    changeBtn:setTitle(tmpBtnName,getDefaultFontName(), getFontSize(15),getColorWhite())
    changeBtn:setBackgroundImage(getRealUIResourcePath("img/img2086.png"):getData())
    changeBtn:setSelectedImage(getRealUIResourcePath("img/img2087.png"):getData())
    changeBtn:setAnchorPoint(CCPointMake(0.5,0));
    changeBtn:setPosition(CCPointMake(showWidth*0.7,SY(5)));
    changeBtn:luaSetSelectorOnClicked(changerBtnAction)
    frameWndNode:addChild(changeBtn)
    
    
end

--发牌一张结束
local function sendCardMoveEnd()
    if m_currentSendCardIndex then
        m_currentSendCardIndex = m_currentSendCardIndex + 1
        if m_currentSendCardIndex <= 6 then
            startSendCard_lotteryScreen()
        else
            showResultCard()     
            showConfirmWindow()      
        end
    end
end

--开始发牌
function startSendCard_lotteryScreen()
    if m_frameWndNode == nil then
        return
    end
    local imgFile = getRealUIResourcePath("img/new00003.png");
    local cardBgImage = nil
    if imgFile then
        cardBgImage = SCImage:imageWithFile(imgFile:getData()) 
    else
        return
    end
    local width  = m_frameWndNode:getContentSize().width
    local height = m_frameWndNode:getContentSize().height
    local startX = width*0.51
    local startY = height*0.6
    local spaceW = width*0.12
    local moveEndX = width*0.1
    local moveEndY = height*0.16
    if cardBgImage then
        local pnode = ActionNode:newActionNode();
        if pnode then
            pnode:setContentSize(cardBgImage:getContentSize());
            pnode:setAnchorPoint(CCPointMake(0.5,0.5));
            pnode:setPosition(CCPointMake(startX,startY));
            pnode:moveTo(CCPoint(moveEndX+m_currentSendCardIndex*spaceW, moveEndY),0.5);--参数2 秒
            pnode:luaSetSelectorOnMoveEnd(sendCardMoveEnd);
            pnode:setTag(801700+m_currentSendCardIndex)
            
            pnode:addChild(cardBgImage)
            m_frameWndNode:addChild(pnode)
        end
    end
    
end

--显示洗牌动画
local function showShuffle()
    if m_frameWndNode == nil then
        return
    end
    
    for i=1,6 do
        local cardImageNode = m_frameWndNode:getChildByTag(801700+i)
        if cardImageNode then
            m_frameWndNode:removeChildByTag(801700+i,true)
        end
    end
        
    local width = m_frameWndNode:getContentSize().width
    local height = m_frameWndNode:getContentSize().height
    
    local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1180, 1180);--洗牌
    local pNode = nil
    if pAi then
        pAi:luaSetSelectorOnComplete(startSendCard_lotteryScreen);
        pAi:setAutoremoveOnComplete(true);
        pNode =  SCAnimationNode:nodeWithAnimation(pAi); 
        if pNode then
            pNode:setAnchorPoint(CCPointMake(0.5,0.5));
            pNode:setPosition(CCPointMake(width*0.51,height*0.6));
            m_frameWndNode:addChild(pNode)   
        end        
    end
end

--点击洗牌
local function clickShuffleAction()
    if m_isShuffle == true then--洗牌中
        return
    end
    sendClickCardMsg_lotteryScren()
end


function open_lotteryScreen()
    if m_frameWndNode then
        return;
    end
    
    local width  = getScreenWidth()
    local height = getScreenHeight()
    local imgFile = getRealUIResourcePath("img/new00002.png");
    local bgImage = nil
    if imgFile then
        bgImage = SCImage:imageWithFile(imgFile:getData()) 
        width   = bgImage:getContentSize().width
        height  = bgImage:getContentSize().height
    end
    
    m_frameWndNode = SCWindow:window()
    m_frameWndNode:setTag(8017)
    m_frameWndNode:setContentSize(CCSizeMake(width, height))
    m_frameWndNode:setFrameVisibled(false)
    m_frameWndNode:luaSetSelectorOnClose(removeAllData)--设置关闭回调
    
    --关闭按钮
    local colseBtn = SCButton:button(EnumBtnTypeNormalImg)
    colseBtn:setBackgroundImage(getRealUIResourcePath("img/Btn2110.png"):getData())
    colseBtn:setSelectedImage(getRealUIResourcePath("img/Btn2111.png"):getData())
    colseBtn:setAnchorPoint(CCPointMake(0,0));
    colseBtn:setPosition(CCPointMake(width-colseBtn:getContentSize().width-SX(15),height-colseBtn:getContentSize().height-SY(10)));
    colseBtn:luaSetSelectorOnClicked(colseWnd)
    
    --界面背景
    if bgImage then
        bgImage:setAnchorPoint(CCPointMake(0.5,0.5));
        bgImage:setPosition(CCPointMake(width*0.5,height*0.5));
        m_frameWndNode:addChild(bgImage)
        colseBtn:setPosition(CCPointMake(bgImage:getPosition().x+bgImage:getContentSize().width/2-colseBtn:getContentSize().width-SX(15),height-colseBtn:getContentSize().height-SY(10)));
    end
    
    --初始化宫殿牌整副牌背景
    local imgFile = getRealUIResourcePath("img/new00004.png");
    if imgFile then
        local bgCardImage = SCImage:imageWithFile(imgFile:getData()) 
        bgCardImage:setAnchorPoint(CCPointMake(0.5,0.5));
        bgCardImage:setPosition(CCPointMake(width*0.51,height*0.6));
        m_frameWndNode:addChild(bgCardImage)
    end

    
    
    m_frameWndNode:addChild(colseBtn)
    
   
    
    --设置点击区域
    local centerContentLayer  = SCButton:button(EnumBtnTypeNormalImg)
    centerContentLayer:setAnchorPoint(CCPointMake(0.5,0.5));
    centerContentLayer:setPosition(CCPointMake(width/2,height*0.6));
	centerContentLayer:setContentSize(CCSizeMake(width*0.5,height*0.55))
	centerContentLayer:luaSetSelectorOnClicked(clickShuffleAction)
	m_frameWndNode:addChild(centerContentLayer)
	
    
    m_currentSendCardIndex = 1
    m_isShuffle = false
    m_freeTime = 0
    m_totalTime = 0
    
    local scene = SCBaseScene:getRunningScene()
    if scene then
        --scene:getUINode():addChild(m_frameWndNode, Max_Int)
        local wndCtrl = SCWindowController:controllerWithWindow(m_frameWndNode)
	    local naviCtrl =  scene:getNavigationController()
	    naviCtrl:pushWindowController(wndCtrl)
        m_frameWndNode:setCloseButtonVisibled(false)
    end
end

--发送抽奖消息
function sendClickCardMsg_lotteryScren()
	SCActivityIndicator:getSingleton():show()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_CHICK_LOTTERY1);
    SCDataTransThread:getSingleton():transData(dt);
end


function processLotteryMsg_lotteryScreen(dt)
    if dt == nil then
        return
    end
    
    local usTime     = dt:readShort()
    local usFreeTime = dt:readShort()--免费次数
    local szInfo     = dt:readString()
    m_currentExp     = dt:readInt()--当前修为
    m_maxExp         = dt:readInt()--
    
    m_totalTime = usTime--可抽奖次数
    m_freeTime = usFreeTime--免费换牌次数
    m_topTimeStr = "*0".._LTParser("str8117")..m_totalTime.."  ".._LTParser("str8107")..m_freeTime--剩余次数
    if szInfo then
        m_topUserDetail = szInfo:getData()
    end

    showTopContent()

end

--获取下发的牌列表
function processCardList_lotteryScreen(dt)
    if dt == nil then
        return
    end
    m_cardImageList = {}
    local szAwardName = dt:readString()
    for i=1,6 do
        local idPhoto = dt:readInt() 
         table.insert(m_cardImageList,idPhoto);
    end
    local szAward = dt:readString()
    if szAwardName then
         m_titleAwardName = szAwardName:getData()
    end
    if szAward then
        m_awardStr = szAward:getData()
    end
    
    --开始播放洗牌
	if m_isShuffle ~= true then
		m_currentSendCardIndex = 1
		m_isShuffle = true
		showShuffle()
	end
end

function processChanageAward_lotteryScreen(dt)
     if dt == nil then
        return
    end
    m_cardImageList = {}
    local szAwardName = dt:readString()
    for i=1,6 do
        local idPhoto = dt:readInt() 
         table.insert(m_cardImageList,idPhoto);
    end
    local szAward = dt:readString()
    if szAwardName then
         m_titleAwardName = szAwardName:getData()
    end
    if szAward then
        m_awardStr = szAward:getData()
    end
    
    showResultCard()--刷新牌
    showConfirmWindow()--刷新确认框
end
