MarryXiang = {}

-----------------------结构定义区------------------------

-----------------------常量定义区------------------------ 
local _MSG_GIFTINFO	                      =_MSG_GENERAL+622		--//礼包
local GIFTINFO_LOGIN_AWARD                = 17  --//7天送香香(发送)
local GIFTINFO_GET_LOGIN_AWARD            = 18  --//7天送香香(获取)
-----------------------变量定义区------------------------
local m_nGetCount = 0
local bClickEnable
-----------------------函数声明区------------------------

-----------------------逻辑功能区------------------------
--打开迎娶香香界面
function MarryXiang.OpenMainWnd()    
    local wnd = tolua.cast(SCFunction:getUiNodeByIdlist(9101), "FrameWindow")
    if not wnd then
        wnd = MarryXiang.CreateMainWnd()
        local pScene = getCurentScene():getUINode()
        if wnd and pScene then
            pScene:addChild(wnd)            
        end
    else
        MarryXiang.UpdateWindow()
    end
end

--窗口关闭回调
function MarryXiang.onCloseWnd()
    local wnd = SCFunction:getUiNodeByIdlist(9101)
    if wnd then
        wnd:removeFromParentAndCleanup(true)
    end
    
    bClickEnable = nil
end

--迎娶香香按钮回调
function MarryXiang.onMarryXiang(tag)     
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("9101-3-101"), "SCButton")
    if node then
        if bClickEnable == 0 then
            node:setTouchEnabled(false)
            node:setButtonType(3)
            return
        end
        
        if m_nGetCount < 6 then
            --showMessage(string.format(L("str20044"), 7 - m_nGetCount - 1))
        elseif m_nGetCount == 6 then
            node:setTitle(L("str20008"), getDefaultFontName(), F(15), color_white)      
            --showMessage(L("str20045"))
        elseif m_nGetCount > 6 then
            node:setTitle(L("str20008"), getDefaultFontName(), F(15), color_white)
            MarryXiang.onCloseWnd()
        end
    end
    
    --m_nGetCount = m_nGetCount + 1  
    MarryXiang.SendGetAward()    
end

--刷新窗口
function MarryXiang.UpdateWindow()
    local wnd = SCFunction:getUiNodeByIdlist("9101")
    if wnd then
        local node = wnd:getChildByTag(102)
        if node then
            node:removeFromParentAndCleanup(true)
        end
        
        local strText = L("str20009")
        strText = string.format(strText, m_nGetCount)
        local nodeText = getItemTextNode(strText)
        if nodeText then
            nodeText:setAnchorPoint(CCPointMake(0, 0.5))
            nodeText:setPosition(SX(45), SY(25))
            nodeText:setTag(102)
            wnd:addChild(nodeText)
        end
    end
    
    local node = tolua.cast(SCFunction:getUiNodeByIdlist("9101-3-101"), "SCButton")
    if node then
        if bClickEnable == 0 then
            node:setTouchEnabled(false)
            node:setButtonType(3)
            return
        end
    end
end

--单击头像
function MarryXiang.onPhotoClick(tag)
    --id = ID3461010004    
    MarryXiang.ShowTipWnd()    
end
-----------------------UI控制器区------------------------
function MarryXiang.CreateMainWnd()
    local wnd = FrameWindow:frameWnd()
    if not wnd then return end 
    
    wnd:setOutSpaceClickClose(false)
--    wnd:luaSetReturnSelector(MarryXiang.onCloseWnd)    
    local szWnd = AUTO_SIZE(340, 300)
    wnd:setContentSize(szWnd)
--    wnd:setCloseBtnVisible(true)
    wnd:setTag(9101)
    wnd:setFrameType(EnumFrameTyperedwindowstip)
    
    local width     = SX(-4)
    local height    = SY(-3)
    local szTop     = CCSizeMake(szWnd.width - SX(20), SY(100))
    local szLeft    = CCSizeMake(SX(120), szWnd.height - szTop.height - SY(58))
    local szRight   = CCSizeMake(szTop.width - szLeft.width - width, szLeft.height + SY(30))
    local ptTop     = CCPointMake((szWnd.width - szTop.width) / 2, szWnd.height - szTop.height - SY(24))
    local ptLeft    = CCPointMake(ptTop.x, ptTop.y - height)
    local ptRight   = CCPointMake(ptLeft.x + szLeft.width + width, ptLeft.y)
    
    local titlePath = RES("kernal/redTop.pn")
    local path      = RES("img/new00703.pn")
    if titlePath and path then
        local imgBg = SCImage:imageWithFile(titlePath)
        local img   = SCImage:imageWithFile(path)
        if imgBg and img then
            local szBg = imgBg:getContentSize()
            img:setAnchorPoint(CCPointMake(0.5, 0.5))
            img:setPosition(szBg.width / 2, szBg.height / 2)
            imgBg:addChild(img)
            
            imgBg:setAnchorPoint(CCPointMake(0.5, 1))
            imgBg:setPosition(szWnd.width / 2, szWnd.height)
            wnd:addChild(imgBg)            
        end
    end
    
    local pathCloseNormal = RES("kernal/close-normal.pn")
    local pathCloseSelect = RES("kernal/close-selected.pn")
    if pathCloseNormal and pathCloseSelect then
        local btnClose = SCButton:button()
        btnClose:setBackgroundImage(pathCloseNormal)
        btnClose:setSelectedImage(pathCloseSelect)
        btnClose:luaSetSelectorOnClicked(MarryXiang.onCloseWnd)
        btnClose:setAnchorPoint(CCPointMake(1, 1))
        btnClose:setPosition(szWnd.width, szWnd.height)
        btnClose:setTouchRectScale(3.0,3.0)  
        btnClose:setScale(0.7)
        wnd:addChild(btnClose)
    end
    
    local nodeTop   = SCDragNode:node()
    if nodeTop then
        nodeTop:setContentSize(szTop)
        nodeTop:setFrameType(0)
        nodeTop:setFrameVisibled(true)
        nodeTop:setTag(1)
        nodeTop:setPosition(ptTop)
        wnd:addChild(nodeTop)
        
        local labelTop = getItemTextNode(_LTParser("str20006"), 0, 14)
        if labelTop then
            --labelTop:setColor(color_orange)
            labelTop:setAnchorPoint(CCPointMake(0, 0.5))
            labelTop:setPosition(CCPointMake(SX(15), szTop.height / 2))
            nodeTop:addChild(labelTop)
        end
    end

    local nodeLeft = SCDragNode:node()
    if nodeLeft then
        nodeLeft:setContentSize(szLeft)
        nodeLeft:setFrameType(0)
        nodeLeft:setFrameVisibled(true)
        nodeLeft:setTag(2)
        nodeLeft:setAnchorPoint(CCPointMake(0, 1))
        nodeLeft:setPosition(ptLeft)
        wnd:addChild(nodeLeft)
        
        local pathXiang = RES("PlotPhoto/5000010.pn")
        local btnPhoto = SCButton:button()
        if pathXiang and btnPhoto then     
            nodeLeft:addChild(btnPhoto)       
            btnPhoto:setContentSize(szLeft)
            btnPhoto:luaSetSelectorOnClicked(MarryXiang.onPhotoClick)
            local img = SCImage:imageWithFile(pathXiang)
            if img then
                img:setAnchorPoint(CCPointMake(0.5, 0.5))
                img:setPosition(szLeft.width / 2, szLeft.height / 2 + SY(5))
                btnPhoto:addChild(img)
            end
        end
    end
    
    local nodeRight = SCDragNode:node()
    if nodeRight then
        nodeRight:setContentSize(szRight)
        nodeRight:setFrameType(0)
        nodeRight:setFrameVisibled(true)
        nodeRight:setTag(3)
        nodeRight:setAnchorPoint(CCPointMake(0, 1))
        nodeRight:setPosition(ptRight)
        nodeRight:setTag(3)
        wnd:addChild(nodeRight)
        
        local labelTip = SCLabel:labelWithStringFont(L("str20003"), getDefaultFontName(), F(15))
        if labelTip then
            labelTip:setAnchorPoint(CCPointMake(0.5, 1))
            labelTip:setColor(color_orange)
            labelTip:setPosition(CCPointMake(szRight.width / 2, szRight.height - SY(20)))
            nodeRight:addChild(labelTip)
        end
        
        local parseNode = getItemTextNode(L("str20007"))
        if parseNode then
            local ptLT = ptRight            
            parseNode:setPerWidthAndHeight(0, 15)
            parseNode:setAnchorPoint(CCPointMake(0.5, 0.5))
            parseNode:setPosition(szRight.width / 2, szRight.height / 2 + SY(4))            
            nodeRight:addChild(parseNode)
        end
        
        local type = 1
        if bClickEnable == 0 then
            type = 3
        end
        local btnMarry = SCButton:button(type)
        if btnMarry then
            btnMarry:setContentSize(AUTO_SIZE(80, 30))
            btnMarry:setAnchorPoint(CCPointMake(0.5, 0))
            btnMarry:setPosition(szRight.width / 2, SY(10))
            
            local text = L("str20008")
            if m_nGetCount < 7 then
                text = L("str20010")
            end
            btnMarry:setTitle(text, getDefaultFontName(), F(15), color_white)
            btnMarry:luaSetSelectorOnClicked(MarryXiang.onMarryXiang)
            btnMarry:setTag(101)
            if bClickEnable == 0 then
                btnMarry:setTouchEnabled(false)
            end
            nodeRight:addChild(btnMarry)
        end
    end 
    
    local pt = CCPointMake(SX(20), SY(25))
    local pathBox = RES("qiandao/new00745.pn")
    if pathBox then
        local img = SCImage:imageWithFile(pathBox)
        if img then
            img:setAnchorPoint(CCPointMake(0, 0.5))
            img:setScale(0.5)
            img:setPosition(pt)
            wnd:addChild(img)
        end
    end
    
    local strText = L("str20009")
    strText = string.format(strText, m_nGetCount)
    local nodeText = getItemTextNode(strText)
    if nodeText then
        nodeText:setAnchorPoint(CCPointMake(0, 0.5))
        nodeText:setPosition(pt.x + SX(25), pt.y)
        nodeText:setTag(102)
        wnd:addChild(nodeText)
    end
    return wnd 
end

function MarryXiang.ShowTipWnd()
    local wnd = FrameWindow:frameWnd()
    if not wnd then return end 
    
    local szWnd = AUTO_SIZE(155, 210)
    wnd:setContentSize(szWnd)
    wnd:setCloseBtnVisible(false)
    wnd:setOutSpaceClickClose(true)
    
    local node = getItemTextNode(L("str20043"), 0, 15)
    if node then
        node:setPerWidthAndHeight(0, 15)
        node:setPosition(AUTO_POS(15, 190))
        node:setAnchorPoint(CCPointMake(0, 1))
        wnd:addChild(node)
    end
    
    local parent = SCFunction:getUiNodeByIdlist("9101")
    if parent then
        parent:addChild(wnd)
        wnd:setPosition(AUTO_POS(200, 140))
    end
end
-----------------------消息处理区------------------------
function MarryXiang.SendLoginAward()
    local dt = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);    
    dt:writeShort(GIFTINFO_LOGIN_AWARD)
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show() 
end

function MarryXiang.SendGetAward()
    local dt = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO);  
    dt:writeShort(GIFTINFO_GET_LOGIN_AWARD)  
    SCDataTransThread:getSingleton():transData(dt); 
    SCActivityIndicator:getSingleton():show() 
end

function MarryXiang.ReceData(dt)        
    local bFlag = dt:readByte()
    local count = dt:readInt()
    
    bClickEnable = bFlag
    m_nGetCount = count        
    
    MarryXiang.OpenMainWnd()
    SCActivityIndicator:getSingleton():close()
end
-----------------------消息注册区------------------------
--SCMessageCenter:getSingleton():luaRegistCommand(MarryXiang.ReceData, _MSG_GIFTINFO, 0, nil);
-----------------------全局函数区------------------------
function MarryXiang_ShowMarryXiangWnd()
    --MarryXiang.OpenMainWnd()  
    MarryXiang.SendLoginAward()
end