--新洛神殿
NewFairy = {}
-----------------------结构定义区------------------------

-----------------------常量定义区------------------------
local _MSG_MEETFAIRY = 1706
local MSG_MEETFAIRYACTION_SENDREWARD = 2
-----------------------变量定义区------------------------
local m_nNum = 0 --珠宝数量
local m_stItemAward = {}
-----------------------函数声明区------------------------

-----------------------逻辑功能区------------------------
--关闭界面
function NewFairy.onCloseWnd()
    local wndNavi  = getCurentSceneNavigationController()
    if wndNavi then
        wndNavi:removeWindowControllerByTag(9104)
    end
end
--打开界面
function NewFairy.OpenMainWnd()
    local wndCtrl = getCurentSceneWindowController(9104)
    local wnd
    if not wndCtrl then
        wnd = NewFairy.CreateMainWnd()
        if wnd then
            local wndCtrl = SCWindowController:controllerWithWindow(wnd)
            local naviCtrl = getCurentSceneNavigationController()
            if wndCtrl and naviCtrl then
                naviCtrl:pushWindowController(wndCtrl)
                wnd:setCloseButtonVisibled(false)
                wnd:setFrameVisibled(false);
            end
            NewFairy.init()
        end        
    else
        wnd = wndCtrl:getWindow()
    end
    return wnd
end

--按钮点击
function NewFairy.onBtnClick(tag)    
    if tag == 11 then
        NewFairy.init()
        if m_nNum > 0 then
            --NewFairy.SendJewel()
            luashowConfirmationWindow(string.format(L("str20026"), m_nNum), WIN_YES_NO, NewFairy.ConfirmWndReturn)
            --luaShowTip(string.format(L("str20026"), m_nNum), L("str20027").."_"..L("str8084"), 2, NewFairy.ConfirmWndReturn)
        else        
            showMessage(L("str20024"))  
        end 
    elseif tag == 12 then
        --showTipLua(L("str20023"))
        NewFairy.ShowTipWnd()
    end
end

--
function NewFairy.ConfirmWndReturn(tag)
    if tag == 1 then
        NewFairy.SendJewel()
        local btnAward = SCFunction:getUiNodeByIdlist("9104-55")
        if btnAward then            
            btnAward:removeFromParentAndCleanup(true)
        end
    end
end
--显示物品特效
function NewFairy.ShowAward()
    local wnd = SCFunction:getUiNodeByIdlist("9104")
    if not wnd then return end     
    
    local szWnd = wnd:getContentSize()
    local ptDesc = CCPointMake(szWnd.width / 2 + SX(64), szWnd.height / 2 + SY(6))

    local pAni = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1033, 1033) 
    if pAni then
        --pAni:setFPS(10.0);
        pAni:setAutoremoveOnComplete(true)
        pAni:luaSetSelectorOnComplete(NewFairy.GetAward)
        local pAniNode =  SCAnimationNode:nodeWithAnimation(pAni)
        if pAniNode then
            pAniNode:setTag(1033)
            pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5))
            pAniNode:setPosition(ptDesc);
            wnd:addChild(pAniNode, 1033)
        end
    end
end

--数据初始化
function NewFairy.init()
    m_nNum = 0
    local iteminfoSize = ItemProcessor:getSingleton():ItemSize();    
    for i = 1, iteminfoSize do
        local item = ItemProcessor:getSingleton():getItemInfo(i - 1);
        local itemcount = item:getIdType();
        if itemcount == 3901000001 then
            m_nNum = item:getAmount() + m_nNum
        end
    end      
end

--领取奖品
function NewFairy.GetAward()     
    local wnd = SCFunction:getUiNodeByIdlist("9104")
    if not wnd then return end 
    
    local node = wnd:getChildByTag(1033)
    if node then            
        node:removeFromParentAndCleanup(true)
    end
        
    local szWnd = wnd:getContentSize()
    local btnAward = SCButton:button()
    if not btnAward then return end 
    
    local Type = m_stItemAward.idItemType
    local path
    if Type == 1 then                    
        path = RES("img/2001001.png")  
    elseif Type == 4 then
        path = RES("img/2001002.png")
    elseif Type == 5 then                    
        path = RES("img/2001003.png")
    elseif Type == 7 then                    
        path = RES("img/2001008.png")
    elseif Type == 9 then                    
        path = RES("img/2001005.png")
    elseif Type == 101 then                   
        path = RES("img/2001006.png")
    else                   
        local item = TableParser:getSingleton():getItemInfoByKey(m_stItemAward.idItemType)
        if item and item.id ~= 0 then
            path = RES("item/"..item.icon..".jp")            
        else
            path = RES("img/ItemTemp.pn")
        end
    end
    
    if not path then
        return        
    end 
    
    local pathNormal = RES("img/new00002.pn")
    local pathSelect = RES("img/new00003.pn")
    if pathNormal and pathSelect then
        btnAward:setBackgroundImage(pathNormal)
        btnAward:setSelectedImage(pathSelect)
    end    
    btnAward:setTitle(path)
    wnd:addChild(btnAward)
    btnAward:setTag(55)
    btnAward:setAnchorPoint(ANCHOR_CENTER)    
    btnAward:luaSetSelectorOnClicked(NewFairy.AwardDetail)    
    btnAward:setScale(0.1)
--    local ptSrc = CCPointMake(szWnd.width + SX(50), 0)
--    math.randomseed(os.time())
--    ptSrc.y = szWnd.height / 2 + szWnd.height * math.random(0.5, 1)
    local ptDesc = CCPointMake(szWnd.width / 2 + SX(64), szWnd.height / 2 + SY(6))
    btnAward:setPosition(ptDesc)    
    local aScale = CCScaleTo:create(0.05, 1)
    btnAward:runAction(aScale)    
end

--奖品详细信息
function NewFairy.AwardDetail(tag)
    if not m_stItemAward then return end 
    
    local num = m_stItemAward.nNum
    local type = m_stItemAward.idItemType
    
    local itemInfo = TableParser:getSingleton():getItemInfoByKey(type);
    if itemInfo then
        showTip(itemInfo.id)
    end
end
--提示窗口
function NewFairy.ShowTipWnd()
    local tipWnd = SCFunction:getUiNodeByIdlist("9104-1000")
    if not tipWnd then
        tipWnd = NewFairy.CreateTipWnd()
        local wnd = SCFunction:getUiNodeByIdlist("9104")        
        if tipWnd and wnd then
            wnd:addChild(tipWnd)
            local szWnd = wnd:getContentSize()
            tipWnd:setAnchorPoint(CCPointMake(0.5, 0.5))
            tipWnd:setPosition(szWnd.width / 2, szWnd.height / 2)--(szWnd.width - tipWnd:getContentSize().width) / 2, (szWnd.height - tipWnd:getContentSize().height) / 2)
        end    
    end
end
-----------------------UI控制器区------------------------
function NewFairy.CreateMainWnd()
    local wnd = SCWindow:window()
    if not wnd then return end 
    
    local szWnd = AUTO_SIZE(380, 318)
    wnd:setTag(9104)    
    wnd:setContentSize(szWnd)
    
    local path = RES("img/new00302.pn")
    if path then
        local img = SCImage:imageWithFile(path)
        if img then
            img:setAnchorPoint(ANCHOR_CENTER)
            img:setPosition(szWnd.width / 2, szWnd.height / 2)
            wnd:addChild(img)
        end
    end
    
    local pathCloseNormal = RES("kernal/close-normal.pn")
    local pathCloseSelect = RES("kernal/close-selected.pn")
    if pathCloseNormal and pathCloseSelect then
        local btnClose = SCButton:button()
        btnClose:setBackgroundImage(pathCloseNormal)
        btnClose:setSelectedImage(pathCloseSelect)
        btnClose:luaSetSelectorOnClicked(NewFairy.onCloseWnd)
        btnClose:setAnchorPoint(CCPointMake(1, 1))
        btnClose:setPosition(szWnd.width - SX(40), szWnd.height - SY(20))
        btnClose:setScale(0.7)
        wnd:addChild(btnClose)
    end
    
    local width = SX(30)
    local btnDescribe = SCButton:button(1)
    if btnDescribe then
        btnDescribe:setAnchorPoint(CCPointMake(0.5, 0.5))
        --btnDescribe:setContentSize(AUTO_SIZE(70, 30))
        btnDescribe:setPosition(szWnd.width / 2 - SX(45), SY(79))
        btnDescribe:setTag(12)
        btnDescribe:luaSetSelectorOnClicked(NewFairy.onBtnClick)
        
        local pathNormal  = RES("img/new00264.pn")
        local pathSelect  = RES("img/new00265.pn")
        if pathNormal and pathSelect then
            btnDescribe:setBackgroundImage(pathNormal)
            btnDescribe:setSelectedImage(pathSelect)
        end
        --btnDescribe:setTitle(L("str0517"), getDefaultFontName(), F(13))
        wnd:addChild(btnDescribe)
    end
    
    local btnSend = SCButton:button(1)
    if btnSend then
        btnSend:setAnchorPoint(CCPointMake(0.5, 0.5))
        --btnSend:setContentSize(AUTO_SIZE(70, 30))
        btnSend:setPosition(szWnd.width / 2 + SX(64), SY(79))
        btnSend:setTag(11)
        btnSend:luaSetSelectorOnClicked(NewFairy.onBtnClick)
        --btnSend:setTitle(L("str20025"), getDefaultFontName(), F(13))
        local pathNormal = RES("img/new00300.pn")
        local pathSelect = RES("img/new00301.pn")
        if pathNormal and pathSelect then
            btnSend:setBackgroundImage(pathNormal)
            btnSend:setSelectedImage(pathSelect)
        end
        wnd:addChild(btnSend)
    end    
    
    local node = SCNode:node()
    if node then 
        node:setContentSize(WIN_SIZE)
        node:setBackgroundColor(ccc4(0, 0, 0, 220))
        node:setAnchorPoint(ANCHOR_CENTER)
        node:setPosition(SX(190), SY(159))
        wnd:addChild(node, -1)
    end
    
    return wnd 
end

--玩法说明提示窗口
function NewFairy.CreateTipWnd()
    local pframeWnd = FrameWindow:frameWnd();
    if pframeWnd then
        local szWnd = CCSizeMake(SX(250), SY(150))
        pframeWnd:setTag(1000)
        pframeWnd:setContentSize(szWnd);
        pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
        pframeWnd:luaSetSelectorOnTouched(function () 
            pframeWnd:removeFromParentAndCleanup(true)
        end)
        local pParsedNode = getItemTextNode(L("str20023"), 0, 11);
        if pParsedNode then
            pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            pParsedNode:setPerWidthAndHeight(0, 15)
            --pParsedNode:setContentSize(CCSizeMake(szWnd.width - SX(20), szWnd.height - SY(20)))
            pParsedNode:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, pframeWnd:getContentSize().height / 2));
            pframeWnd:addChild(pParsedNode);
        end
        pframeWnd:setCloseBtnVisible(false);
    end
    
    return pframeWnd
end

-----------------------消息处理区------------------------
function NewFairy.SendJewel()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_MEETFAIRY);
    if dataStream then                   ----消息发送提示
        dataStream:writeShort(MSG_MEETFAIRYACTION_SENDREWARD)
        dataStream:writeInt(m_nNum)
        dataStream:writeByte(0)
        SCDataTransThread:getSingleton():transData(dataStream)
        --showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end

function NewFairy.ReadJewel(dt)
    local tmp = {}
    --tmp.usAwardType = dt:readByte()
    tmp.idItemType = dt:readInt()
    tmp.nNum = dt:readInt()
    
    m_stItemAward = tmp
    NewFairy.init()
    NewFairy.ShowAward()
end
--
function NewFairy.RecvData()
    SCActivityIndicator:getSingleton():close();   ----关闭等待转圈图标
	local dt = SCMessageCenter:getSingleton():getDataTransStream();  ---获取当前的数据对象
	if dt == nil then
		return;
	end
	local action = dt:readShort();
	if action == MSG_MEETFAIRYACTION_SENDREWARD  then	    
		NewFairy.ReadJewel(dt)
    end
    cornucopia_mine(action,dt);--旧版使用，意义不明
end
-----------------------消息注册区------------------------
SCMessageCenter:getSingleton():luaRegistCommand(NewFairy.RecvData, _MSG_MEETFAIRY, 0, nil);
-----------------------全局函数区------------------------
function NewFairy_OpenNewFairyWnd()
    sanlogin_del(); --旧版有使用，用义不明
    NewFairy.OpenMainWnd()    
end

function NewFairy_GetMainInterfaceTitle()
    NewFairy.init()
    local str = ""
    if NewFairy.bHasActivityGetAll then 
        str = "str6209"
    else
        if m_nNum == 0 then
            str = L("str20028")
        elseif m_nNum > 0 then
            str = L("str20033")
        end
    end
    return str
end

function NewFairy_GetActivityReward()
    NewFairy.bHasActivityGetAll = true
end