--新功能开启提示 8004界面
local m_window_Width = nil
local m_window_Height = nil
local m_titleCenterX = nil--标题图片居中X坐标
local m_titleCenterY = nil--标题图片相对居中Y坐标
local m_functionTypeId      = nil
local m_functionImageId = nil

local m_positionType = nil--1头部，2底部

local m_entryId = nil
local m_entryId1 = nil
local m_Value = nil
local m_flgOpenTip = nil

local m_bIsShow = false

local m_bShowTopFlag = nil
local m_bShowBottomlag = nil

--无操作函数，重复点击防止
local function clickNull(tag)    
end

local function getBtnPosition(tag)
    local pNode = MainInterface_getMainBtn(tag);
    if pNode then
        local pt = pNode:convertToWorldSpace(CCPointMake(0, 0));
        return pt.x, pt.y;
    else
        return SCREEN_SIZE.width - SX(39), SCREEN_SIZE.height - SY(42);
    end
    --[[if pNode then
        local ptX = pNode:getPosition().x;
        local ptY = pNode:getPosition().y;
        while pNode do
            pNode = tolua.cast(pNode:getParent(), "SCNode");
            local tempPt = pNode:getPosition();
            local size = pNode:getContentSize();
            local anPt = pNode:getAnchorPoint();
            ptX = ptX + tempPt.x - size.width * anPt.x;
            ptY = ptY + tempPt.y - size.height * anPt.y;
            if pNode == getMainInterface() then
                break;
            end
        end
        return ptX, ptY - SY(20);
    end]]
end

local function close_NewFunctionOpenTip()
	m_bIsShow = false
	setMainTopNodeIsVisible(true, m_positionType);
    m_window_Width = nil
    m_window_Height = nil
    m_titleCenterX = nil
    m_titleCenterY = nil
    
    m_functionTypeId      = nil
    m_functionImageId = nil

    m_positionType = nil--1头部，2底部
    if m_entryId then
        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId)
        m_entryId = nil
    end
    local scene = SCBaseScene:getRunningScene()
    if scene then
        local frameWndNode = tolua.cast(scene:getUINode():getChildByTag(8004), "FrameWindow")
        if frameWndNode then
            frameWndNode:luaSetSelectorOnTouched(clickNull)--设置点击界面回调
        end
		
		if m_entryId1 then
			CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_entryId1)
			m_entryId1 = nil
		end
        scene:getUINode():removeChildByTag(8004,true)--窗口移除
    end
    restartAllBeginnerGuide()
end

--获取已有的按钮
local nWidth = nil
local nHeight = nil;
local function getHaveBtn()
    if m_functionTypeId ~= nil and m_functionTypeId == UNLOCK_TYPE_THROUGH then
        return nil;
    end
    
    local pNode = nil;
    local perWidth = SX(0);
    if m_positionType == 6 or m_positionType == 7 then
        return nil;
    end
    if m_positionType == 3 or m_positionType == 2 then
        perWidth = -12 * gUIScale().y;
    elseif m_positionType == 4 then
        perWidth = SY(3);
    end
    local nStartX = 0;
    local nStartY = 0;
    local pBtnList = MainInterface_getBtnList(m_positionType);
    local count = #pBtnList;
    local mark = nil;
    for i=1, count do
        if m_functionTypeId ~=pBtnList[count - i + 1].tag and pBtnList[count - i + 1].tag~=1002
            and pBtnList[count - i + 1].tag~=1004 and pBtnList[count - i + 1].tag~=1003 
            and pBtnList[count - i + 1].photo ~= m_functionImageId then
            if pNode == nil then
                pNode = SCNode:node();
                if pNode == nil then
                    return nil;
                end
            end
            --local pBtn = BtnMainInterface:getMainInterfaceButton("MainInterfaceImg/"..pBtnList[count - i + 1].photo..".png", nil)
            for j = 1, i - 1 do
                if pBtnList[count - i + 1].photo == pBtnList[count - i + 1 + j].photo then
                    mark = 1;
                    break;
                end
            end
            if mark == nil then
                local imgFile = getRealUIResourcePath("MainInterfaceImg/"..pBtnList[count - i + 1].photo..".png");
                if imgFile == nil then
                    return;
                end
                local pBtn = SCImage:imageWithFile(imgFile:getData()) 
                if pBtn ~=nil then
                    pNode:addChild(pBtn)
                end
                if nWidth == nil then
                    nWidth = pBtn:getContentSize().width
                end
                if nHeight == nil then
                    nHeight = pBtn:getContentSize().height
                end
                if 4 == m_positionType then
                    pBtn:setPosition(CCPointMake(0, nStartY))
                    nStartY =  nStartY + SY(49.5) + perWidth
                else
                    pBtn:setPosition(CCPointMake(nStartX, 0))
                    nStartX =  nStartX + nWidth + perWidth
                end
            else
                mark = nil;
            end
        end
    end
    if pNode then  
        if 4 == m_positionType then
            pNode:setContentSize(CCSizeMake(nWidth, nStartY));
            pNode:setAnchorPoint(CCPointMake(0, 1));
            pNode:setPosition(CCPointMake(SX(-4.5), getScreenHeight() - SY(95)));
        else
            pNode:setContentSize(CCSizeMake(nStartX, nHeight));
            pNode:setAnchorPoint(CCPointMake(1, 0));
            if 1 == m_positionType then
                pNode:setPosition(CCPointMake(getScreenWidth() - SX(4), getScreenHeight() - SY(42)));
            elseif 2 == m_positionType then
                pNode:setPosition(CCPointMake(getScreenWidth() - SX(89), SY(10)));
            elseif 3 == m_positionType then
                pNode:setPosition(CCPointMake(getScreenWidth() - SX(47), SY(58)));
            elseif 5 == m_positionType then
                pNode:setPosition(CCPointMake(getScreenWidth() - SX(97), getScreenHeight() - SY(92)));
            end
        end
    end
    return pNode;
end

--移动结束回调的函数
local function moveEndOpenList()
    close_NewFunctionOpenTip()
    GuidePoint_FreeData();
    if m_functionTypeId == UNLOCK_TYPE_SEVEN_GIFT then --七日解锁
		GuidePoint_setAutoInfo(m_functionTypeId)
	elseif  m_functionTypeId == UNLOCK_TYPE_TYPE1 then --每日俸禄解锁
		GuidePoint_setAutoInfo(m_functionTypeId)
	end
	--[[if m_positionType == 6 then
	    setLightEfficiency(1010, true);
        local pMapLayer = getMapLayer();
        if pMapLayer then
            pMapLayer:setMainBtnFlag(m_functionTypeId, 1);
        end
	else
	    setLightEfficiency(m_functionTypeId, true);
	end]]
	if m_positionType ~= 6 then
	    setLightEfficiency(m_functionTypeId, true);
	end
    setNewFunctionType(m_functionTypeId)
    --功能开启吞噬表现
    if m_positionType == 6 then
        SkillView_TipShow(3)
    elseif m_positionType == 7 then
        SkillView_TipShow(4)
    elseif m_functionTypeId == UNLOCK_TYPE_RUNE_STONE then
        SkillView_TipShow(1)
    end

    GuidePoint_topGuide()
end

--插入结束回调的函数
local function insertEndOpenList()
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    local frameWndNode = tolua.cast(scene:getUINode():getChildByTag(8004), "FrameWindow")
    if frameWndNode == nil then
        return
    end
    frameWndNode:removeChildByTag(1, true)
    local moveEndX = nil;
    local moveEndY = nil;  
    if m_positionType == 1 then
        moveEndX, moveEndY = getBtnPosition(m_functionTypeId);
    elseif m_positionType == 3 or m_positionType == 2 then
        moveEndX, moveEndY = getBtnPosition(m_functionTypeId);
    elseif m_positionType == 4 then --1头部，2底部  
        if m_functionTypeId ~= UNLOCK_TYPE_RUNE_STONE then
            moveEndX, moveEndY = getBtnPosition(m_functionTypeId);
        else
            moveEndX, moveEndY = getBtnPosition(UNLOCK_TYPE_EQUIP_STRENGTHEN);
        end
    elseif m_positionType == 5 then
    elseif m_positionType == 6 then
        moveEndX, moveEndY = getBtnPosition(1010);
    elseif m_positionType == 7 then
        moveEndX, moveEndY = getBtnPosition(10111);
    end
    local imgFile = getRealUIResourcePath("MainInterfaceImg/"..m_functionImageId..".png");
    if imgFile then
        local titleImage = SCImage:imageWithFile(imgFile:getData())
        if titleImage then 
            local pActionNode = ActionNode:newActionNode();
            if pActionNode then
                pActionNode:setContentSize(titleImage:getContentSize());
                pActionNode:setPosition(CCPointMake(m_titleCenterX, m_titleCenterY));
                pActionNode:moveTo(CCPoint(moveEndX, moveEndY),0.6);
                pActionNode:luaSetSelectorOnMoveEnd(moveEndOpenList);
                local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1102, 1139);--光圈
				if pAi then
					local pNode = SCAnimationNode:nodeWithAnimation(pAi);
					if pNode then
						pActionNode:addChild(pNode)
					end
				end
                pActionNode:addChild(titleImage)
                frameWndNode:addChild(pActionNode)
            end
        end
    end
end

--已有按钮移动结束回调的函数
local function btnEndOpenList()
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    local frameWndNode = tolua.cast(scene:getUINode():getChildByTag(8004), "FrameWindow")
    if frameWndNode == nil then
        return
    end
    frameWndNode:removeChildByTag(2, true)
    local pActionNode = ActionNode:newActionNode();
    if pActionNode then
        local pNode = getHaveBtn();
        if pNode then
            pActionNode:addChild(pNode)
        end
        if 4 == m_positionType then
            pActionNode:moveTo(CCPointMake(0, -nHeight+SY(3)),0.7);
        elseif 1 == m_positionType or 5 == m_positionType then
            pActionNode:moveTo(CCPointMake(-nWidth, 0),0.7);
        else
            pActionNode:moveTo(CCPointMake(-nWidth+SX(12), 0),0.7);
        end
        pActionNode:luaSetSelectorOnMoveEnd(insertEndOpenList);
        frameWndNode:addChild(pActionNode)
        nWidth = nil;
    end
end

local function setColorWnd()
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    local frameWndNode = tolua.cast(scene:getUINode():getChildByTag(8004), "FrameWindow")
    if frameWndNode == nil then
        return
    end
    m_Value = m_Value - 10;
    if m_Value < 0 then
        m_Value = 0;
    end
    frameWndNode:setBackgroundColor(ccc4(0, 0, 0, m_Value))--设置灰色透明背景
    if 2 == m_flgOpenTip then
		GuidePoint_openRewardsFunction()
		m_flgOpenTip = 0
	end
end

--点击屏幕移动
local function showMoveAction()
	m_bIsShow = false
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    local frameWndNode = tolua.cast(scene:getUINode():getChildByTag(8004), "FrameWindow")
    if frameWndNode == nil then
        return
    end
    frameWndNode:removeAllChildrenWithCleanup(true)
    frameWndNode:luaSetSelectorOnTouched(clickNull)--防止重复点击
    
    m_entryId1 = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(setColorWnd, 0.05, false)--8秒后自动关闭
 
    local moveEndX = nil;
    local moveEndY = nil;

    if m_positionType == 1 then
        moveEndX, moveEndY = getBtnPosition(m_functionTypeId);
        moveEndY = moveEndY - SY(50);
    elseif m_positionType == 3 or m_positionType == 2 then
        moveEndX, moveEndY = getBtnPosition(m_functionTypeId);
        moveEndY = moveEndY + SY(50);
    elseif m_positionType == 4 then --1头部，2底部  
        if m_functionTypeId ~= UNLOCK_TYPE_RUNE_STONE then
            moveEndX, moveEndY = getBtnPosition(m_functionTypeId);
        else
            moveEndX, moveEndY = getBtnPosition(UNLOCK_TYPE_EQUIP_STRENGTHEN);
        end
        moveEndX = moveEndX + SX(50);
    elseif m_positionType == 5 then
    elseif m_positionType == 6 then
        moveEndX, moveEndY = getBtnPosition(1010);
        moveEndY = moveEndY - SY(50);
    elseif m_positionType == 7 then
        moveEndX, moveEndY = getBtnPosition(10111);
        moveEndY = moveEndY - SY(50);
    end
        
    local imgFile = getRealUIResourcePath("MainInterfaceImg/"..m_functionImageId..".png");
    if imgFile then
        local titleImage = SCImage:imageWithFile(imgFile:getData()) 
        if titleImage then
            titleImage:setVisible(true)
            local pnode = ActionNode:newActionNode();
            if pnode then
                pnode:setContentSize(titleImage:getContentSize());
                pnode:setAnchorPoint(CCPointMake(0,0));
                pnode:setPosition(CCPointMake(m_titleCenterX, m_titleCenterY));
                m_titleCenterX = moveEndX;
                m_titleCenterY = moveEndY;
                --pnode:setBackgroundColor(ccc4(110, 100, 100, 255));
                pnode:moveAndSpawnTo(CCPoint(moveEndX, moveEndY),0.8);--参数2 秒
                pnode:luaSetSelectorOnMoveEnd(btnEndOpenList);
        
                --[[local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1102, 1139);--光圈
				if pAi then
					local pNode = SCAnimationNode:nodeWithAnimation(pAi);
					pnode:addChild(pNode)
				end]]
                pnode:addChild(titleImage)
                frameWndNode:addChild(pnode) 
                pnode:setTag(1);      
                if m_positionType == 1 then
                    imgFile = nil; --getRealUIResourcePath("MainInterfaceImg/5006.png");
                elseif m_positionType == 2 then
                    imgFile = getRealUIResourcePath("MainInterfaceImg/5002.png");
                elseif m_positionType == 3 then
                    imgFile = getRealUIResourcePath("MainInterfaceImg/5005.png");
                elseif m_positionType == 6 then
                    imgFile = getRealUIResourcePath("MainInterfaceImg/5046.png");
                elseif m_positionType == 7 then
                    imgFile = getRealUIResourcePath("MainInterfaceImg/5004.png");
                elseif m_positionType == 4 or m_positionType == 5 then
                    imgFile = nil;
                end
                if imgFile then
                    local pImg = SCImage:imageWithFile(imgFile:getData());
                    if pImg then
                        if m_positionType == 1 then 
                            pImg:setPosition(CCPointMake(getScreenWidth() - SX(39), getScreenHeight() - SY(46)));
                        elseif m_positionType == 2 then
                            pImg:setPosition(CCPointMake(getScreenWidth() - SX(89), SY(10)));
                        elseif m_positionType == 3 then
                            pImg:setPosition(CCPointMake(getScreenWidth() - SX(47), SY(58)));
                        elseif m_positionType == 6 then
                            pImg:setPosition(CCPointMake(moveEndX, moveEndY + SY(50)));
                        elseif m_positionType == 7 then
                            pImg:setPosition(CCPointMake(moveEndX, moveEndY + SY(50)));
                        end
                        frameWndNode:addChild(pImg);
                    end
                end
                local pNode = getHaveBtn();
                if pNode then
                    frameWndNode:addChild(pNode);
                    pNode:setTag(2);
                    if m_functionTypeId == UNLOCK_TYPE_RUNE_STONE then
                        pnode:luaSetSelectorOnMoveEnd(insertEndOpenList);
                    end
                else                    
                    pnode:luaSetSelectorOnMoveEnd(insertEndOpenList);
                end
            end
        end
    end
end

--显示提示内容
local function showTipContent()
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    local frameWndNode = tolua.cast(scene:getUINode():getChildByTag(8004), "FrameWindow")
    if frameWndNode == nil then
        return
    end
    frameWndNode:removeAllChildrenWithCleanup(true)
    if m_positionType == 1 or m_positionType == 2 then
        frameWndNode:luaSetSelectorOnTouched(showMoveAction)--设置点击界面回调
    else--否则直接关闭
        frameWndNode:luaSetSelectorOnTouched(close_NewFunctionOpenTip)--设置点击界面回调
    end    

    local height = 0
    local imgFile = getRealUIResourcePath("img/img8001.png");
    if imgFile then
        local titleImage = SCImage:imageWithFile(imgFile:getData())  
        if titleImage then
            m_titleCenterY = m_window_Height/2+titleImage:getContentSize().height/2
        end
        height  = titleImage:getContentSize().height
        titleImage:setVisible(true)
        titleImage:setAnchorPoint(CCPointMake(0.5,0.5));
        titleImage:setPosition(CCPointMake(m_window_Width/2,m_window_Height/2+height/2));
        frameWndNode:addChild(titleImage) 
    end
    
    
    --开启的功能图标
    local imgFile = getRealUIResourcePath("MainInterfaceImg/"..m_functionImageId..".png");
    if imgFile then
        local titleImage = SCImage:imageWithFile(imgFile:getData())  
        titleImage:setVisible(true)
        titleImage:setAnchorPoint(CCPointMake(0.5,0.5));
        titleImage:setPosition(CCPointMake(m_window_Width/2+SX(1),m_window_Height/2+height/2+SY(1)));
        frameWndNode:addChild(titleImage) 
    end
    
    
    local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1102, 1142);--按任意键继续
    local pNode = nil
    if pAi then
        pNode =  SCAnimationNode:nodeWithAnimation(pAi); 
        if pNode then
            pNode:setPosition(CCPointMake((m_window_Width-pNode:getContentSize().width)/2,m_window_Height/2-pNode:getContentSize().height-SY(5)));
            frameWndNode:addChild(pNode)   
        end        
    end
end

local function init_NewFunctionOpenTip()
    local scene = SCBaseScene:getRunningScene()
    if scene == nil then
        return
    end
    local frameWndNode = tolua.cast(scene:getUINode():getChildByTag(8004), "FrameWindow")
    if frameWndNode then
        return
    end
    
    m_positionType = MainInterface_getPos(m_functionTypeId);
    if m_positionType == nil then
        if m_functionTypeId == 7 then
            m_positionType = MainInterface_getPos(9);
            m_functionTypeId = 9;
        elseif m_functionTypeId == 9 then
            m_positionType = MainInterface_getPos(7);
            m_functionTypeId = 7;
        end
        if m_positionType == nil then
            return;
        end
    end
    --Hero:getSingleton():stopAutoMove();--//自动寻路停止
    local naviCtrl = getCurentSceneNavigationController()
	if naviCtrl then--移除除主界面其他窗口
		naviCtrl:removeAllWindowControllers()
	end

    if m_positionType ~= 6 and m_functionTypeId ~= UNLOCK_TYPE_THROUGH then
	    setMainTopNodeIsVisible(false, m_positionType);
    end
    
    --主界面下方需解锁表现的功能：强化、布阵、修行（天赋、修炼、精灵）、社交（邮件、好友、公会）、冥想	
    --主界面上方需解锁表现的功能：功能、排行、挑战、小助手、奖励

    --主界面菜单隐藏
    --[[m_bShowTopFlag = not getIsTopButtonHide()
    m_bShowBottomlag = not getIsBottomButtonHide()
    showOrHideTopButton(false)--隐藏头部菜单
    showOrHideBottomButton(false)--隐藏底部菜单
    
    if m_functionTypeId == UNLOCK_TYPE_SKILL or --冥想
        m_functionTypeId == UNLOCK_TYPE_NORMAL_WORK or--公会
        m_functionTypeId == UNLOCK_TYPE_BOOK or--修炼
        m_functionTypeId == UNLOCK_TYPE_ELFGUARD or--精灵
        m_functionTypeId == UNLOCK_TYPE_EQUIP_STRENGTHEN or--强化
        m_functionTypeId == UNLOCK_TYPE_USER_TALENT or--天赋
        m_functionTypeId == UNLOCK_TYPE_FRIEND or--好友
        m_functionTypeId == UNLOCK_TYPE_MAIL or --邮件
        m_functionTypeId == UNLOCK_TYPE_FORMAT then--布阵

        m_positionType = 2--向下飘
    elseif  m_functionTypeId == UNLOCK_TYPE_RANK or --排行榜
            m_functionTypeId == 1002 or --功能
            m_functionTypeId == 1003 or --挑战
            m_functionTypeId == UNLOCK_TYPE_HELPER  then --小助手 
        m_positionType = 1--向上飘
    else
        m_positionType = nil
        m_entryId = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(close_NewFunctionOpenTip, 8.0, false)--8秒后自动关闭
    end
    
    m_window_Width  = getScreenWidth()
    m_window_Height = getScreenHeight()
    
    frameWndNode = FrameWindow:frameWnd()
    frameWndNode:setTag(8004)
    frameWndNode:setOutSpaceClickClose(false)
    frameWndNode:setContentSize(CCSizeMake(m_window_Width, m_window_Height))
    frameWndNode:setFrameVisibled(false)
    frameWndNode:setCloseBtnVisible(false)
    frameWndNode:setBackgroundColor(ccc4(0, 0, 0, 220))--设置灰色透明背景
     
    m_titleCenterX = m_window_Width/2
    m_titleCenterY = m_window_Height/2
    
    local height = 0    
    local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1106, 1141);--新功能开启特效
    pAi:luaSetSelectorOnComplete(showTipContent);
    pAi:setAutoremoveOnComplete(true);
    local pNode = nil
    
    if pAi then
        pNode =  SCAnimationNode:nodeWithAnimation(pAi); 
        if pNode then
            height = pNode:getContentSize().height
            pNode:setAnchorPoint(CCPointMake(0.5,0.5));
            pNode:setPosition(CCPointMake(m_window_Width/2,m_window_Height/2+height/2));
            frameWndNode:addChild(pNode)   
        end        
    end]]
    
    
    local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(62.00, 8.00))
		pDragNode2:setContentSize(AUTO_SIZE(356, 268))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTypeLine)
	end

	local imgPath = getRealUIResourcePath("img/new00701.pn")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			--pImage3:setScale(0.9)
			pImage3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage3:setPosition(AUTO_POS(10.00, 46.00))
		end
	end

	local pDragNode4 = SCDragNode:node()
	if pDragNode4 then
		pDragNode4:setTag(4)
		pDragNode4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode4:setPosition(AUTO_POS(12.00, 34.00))
		pDragNode4:setContentSize(AUTO_SIZE(335, 137))
		pDragNode4:setFrameVisibled(true)
		pDragNode4:setDragEnabled(false)
		pDragNode4:setFrameType(EnumFrameTypeTip3)
	end

	local pDragNode5 = SCDragNode:node()
	if pDragNode5 then
		pDragNode5:setTag(5)
		pDragNode5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode5:setPosition(AUTO_POS(257.00, 168.00))
		pDragNode5:setContentSize(AUTO_SIZE(90, 90))
		pDragNode5:setFrameVisibled(true)
		pDragNode5:setDragEnabled(false)
		pDragNode5:setFrameType(EnumFrameTypeTip3)
	end

	local pButton6 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton6 then
		pButton6:setTag(6)
		pButton6:setAnchorPoint(ANCHOR_CENTER)
		pButton6:setPosition(CCPointMake(pDragNode5:getContentSize().width/2, pDragNode5:getContentSize().height/2))
		pButton6:setContentSize(AUTO_SIZE(54, 54))
		local imgPath = getRealUIResourcePath("img/new00448.png")
		if imgPath then
			pButton6:setTitle(imgPath:getData())
		end
		local imgFile = getRealUIResourcePath("MainInterfaceImg/"..m_functionImageId..".png");
        if imgFile then
            pButton6:setBackgroundImage(imgFile:getData())  
        end
	end

	local pButton7 = SCButton:button(EnumBtnType9Atlas)
	if pButton7 then
		pButton7:setTag(7)
		pButton7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton7:setPosition(AUTO_POS(148.00, 9.00))
		pButton7:setContentSize(AUTO_SIZE(76, 29))
		local imgPath = getRealUIResourcePath("img/new00024.png")
		if imgPath then
			pButton7:setTitle(imgPath:getData())
		end
		pButton7:luaSetSelectorOnClicked(showMoveAction)
		local lev = Hero:getSingleton():getLeval()
		if lev <= 27 then
		    GuidePoint_DeltopGuide();
		    GuidePoint_createRightGuideNode(pButton7)
		end
	end
	local pLable8 = nil;
	local pText9 = nil;
	local unInfo = luaGetUnlockInfoWithType(m_functionTypeId);
    if unInfo then
        pLable8 = SCLabel:labelWithStringFont(unInfo.szName:getData(), DEFAULT_FONT_NAME, F(15))
        if pLable8 then
            pLable8:setColor(color_orange);
            pLable8:setTag(8)
            pLable8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pLable8:setPosition(AUTO_POS(10.00, 107.00))
        end

        pText9 = SCTextBox:boxWithWidthHeightFont(AUTO_W(314), AUTO_H(75), DEFAULT_FONT_NAME, F(12));
        if pText9 then
            pText9:setTag(9)
            pText9:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pText9:setPosition(AUTO_POS(10.00, 27.00))
            pText9:setScrollVertical(false)
            TextParser:getSingleton():setText(pText9, unInfo.szTip:getData())
        end
    end

	if pImage3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if pDragNode4 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode4, "SCNode"))
	end
	if pDragNode5 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pDragNode5, "SCNode"))
	end
	if pButton6 and pDragNode5 then
		pDragNode5:addChild(tolua.cast(pButton6, "SCNode"))
	end
	if pButton7 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton7, "SCNode"))
	end
	if pLable8 and pDragNode4 then
		pDragNode4:addChild(tolua.cast(pLable8, "SCNode"))
	end
	if pText9 and pDragNode4 then
		pDragNode4:addChild(tolua.cast(pText9, "SCNode"))
	end                
    m_window_Width  = getScreenWidth()
    m_window_Height = getScreenHeight()  
	m_titleCenterX = SX(262);
    m_titleCenterY = SY(192);
    
    frameWndNode = FrameWindow:frameWnd()
	if frameWndNode == nil then
		return;
	end
    frameWndNode:setTag(8004)
    frameWndNode:setOutSpaceClickClose(false)
    frameWndNode:setCloseBtnVisible(false)
    frameWndNode:setContentSize(CCSizeMake(m_window_Width, m_window_Height))
    frameWndNode:setFrameVisibled(false)
    
    local scene = SCBaseScene:getRunningScene();
    if scene then
        local pNode = scene:getUINode();
        if pNode then
            frameWndNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            frameWndNode:setPosition(CCPointMake(pNode:getContentSize().width / 2, pNode:getContentSize().height / 2));
            if pDragNode2 then
                frameWndNode:addChild(pDragNode2);
                pDragNode2:setAnchorPoint(CCPointMake(0.5, 0.5));
                pDragNode2:setPosition(CCPointMake(frameWndNode:getContentSize().width / 2, frameWndNode:getContentSize().height / 2 - SY(25)));
            end
            m_Value = 200
            frameWndNode:setBackgroundColor(ccc4(0, 0, 0, m_Value))--设置灰色透明背景
            pNode:addChild(frameWndNode, Max_Int)
        end
    end
	playEffectMusic("functionOpen.mp3");
end

function open_RewardsFunctionTip()
	local roleLevel = Hero:getSingleton():getLeval()
	if 3 > roleLevel then
		m_flgOpenTip = 1
	end
	if m_bIsLevelGife then
		m_flgOpenTip = 0
	end
	if 3 == roleLevel and 1 == m_flgOpenTip then
		m_functionImageId = 5036
		m_functionTypeId = 62
		Hero:getSingleton():stopAutoMove();
		m_bIsShow = true--做缓存判断
		if Hero:getSingleton():getBatter() == false then
			init_NewFunctionOpenTip()
			m_flgOpenTip = 2
		end
	end
	
end

function open_NewFunctionOpenTip()
    --获取数据
    --[[m_functionImageId = 5010;
    m_functionTypeId = 17;    
    m_bIsShow = true
    if m_bIsShow == true then
        init_NewFunctionOpenTip();
        return;
    end--]]
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        m_functionImageId  = dt:readInt()--//图片id
        m_functionTypeId   = dt:readShort()--//功能解锁类型id 
        Hero:getSingleton():stopAutoMove();
    else
       return
    end
    m_bIsShow = true--做缓存判断
    if Hero:getSingleton():getBatter() == false then
        init_NewFunctionOpenTip()
    end
 
	--if BattleProcessor:getSingleton():getIsInBattle() then
	--	BattleProcessor:getSingleton():setIsShowNewFunAnimation(true)
	--else
	--	if not getIsShowLevelUpAnimation() then
	--	    m_bIsShow = false
	--		init_NewFunctionOpenTip()--初始化显示界面
	--	end
	--end

end

function showNewFunOpenAnimation()
    if m_bIsShow == true then--显示缓存
        init_NewFunctionOpenTip()
    end
end

function getIsShowNewFunAnimation()
	return m_bIsShow
end

LuaData:getSingleton():luaSetSelectorOnRecvData(open_NewFunctionOpenTip, LuaData_USERINFO_UNLOCK_EFFECT);