local isAsideDailog = false;
local plotInfo = {};
local plotInfoBeforBattle = {};
local plotInfoAfterBattle = {};
local plotInfoStartTask = {};
local plotInfoEndTask = {};
local plotInfoBoss = {};
local bBeforBattle = false;
local bAfterBattle = false;
local bStartTask = false;
local bEndTask = false;
local bFirst = false;
local bBoss = false;
local bIsShow = false
local MSG_PLOT_INFO_BEGIN = 0		    --//对白内容
local MSG_PLOT_INFO_END	= 1		        --//对白内容end
local MSG_PLOT_NEXT_PAGE = 2			--//队长点击剧情(控制ai的玩家)
local MSG_PLOT_LAST_PAGE = 3			--//队长点击最后剧情

local EM_TRIGGER_TYPE_RECEIVE_QUEST = 1	--//=1玩家通过某个NPC接到任务后，触发剧情对话
local EM_TRIGGER_TYPE_RETRODE_QUEST = 2	--//=2玩家通过某个NPC交还任务后，触发剧情对话
local EM_TRIGGER_TYPE_ENTER_COPY_FIRST_TIME = 3	--//=3初次挑战某个主线副本时，触发剧情对话
local EM_TRIGGER_TYPE_FINISH_COPY_FIRST_TIME = 4	--//=4初次挑战完某个主线副本后，触发剧情对话
local EM_TRIGGER_TYPE_BOSS_DIALOG = 5	--//=5与BOSS对话，触发剧情对话

local function getTextBoxWidthHeight(str, size, maxLen)
	local x, y;
	
	
	local var = Split(str, "_");
	
	x = 0;
	y = size*table.getn(var);
	
	for i=1, table.getn(var) do
	    local len = string.len(var[i])*(size)+1;
	    if x < len then
	        x = len
	    end
	    while len > maxLen do
            len = len - maxLen;
            y = y + size;
            x = maxLen;
		end
	end
		
	return x, SY(150);
end

local function onClickClose()
--[[
	plotInfo = nil;
	plotInfoBeforBattle = nil;
	plotInfoAfterBattle = nil;
	plotInfoStartTask = nil;
	plotInfoEndTask = nil;
	plotInfoBeforBattle = {};
	plotInfoAfterBattle = {};
	plotInfoStartTask = {};
	plotInfoEndTask = {};
	bBeforBattle = false;
	bAfterBattle = false;
	bStartTask = false;
	bEndTask = false;
	bFirst = false;
]]
end

function PlotDailog_onRemoveNode()    
    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
    if mapLay then
        local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
        if pBattleNode then
            pBattleNode:removeChildByTag(70001, true);
            GuidePoint_startSkillNode()
        end
    end
end

local function onClickedSure(tag)
    local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
    if mapLay then
        local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
        if pBattleNode then
            pBattleNode:removeChildByTag(70001, true);
            local actNode = pBattleNode:getChildByTag("2011")
            if actNode then
                local pImgPath = getRealUIResourcePath("img/img3000055.png");
                local ActionNode = ActionNode:newActionNode();
                if ActionNode and pImgPath then
                    local pImg = SCImage:imageWithFile(pImgPath:getData());
                    if pImg then
                        ActionNode:setContentSize(pImg:getContentSize());
                        ActionNode:setAnchorPoint(ANCHOR_CENTER);
                        --ActionNode:setPosition(CCPointMake(actNode:getContentSize().width/2, actNode:getContentSize().height/2));
                        setNodePostion(ActionNode,CCPointMake(actNode:getContentSize().width/2, actNode:getContentSize().height/2));
                        ActionNode:addChild(pImg);
                        ActionNode:moveToRetuen(CCPointMake(actNode:getContentSize().width/2, actNode:getContentSize().height/2-SY(20)), CCPointMake(actNode:getContentSize().width/2, actNode:getContentSize().height/2-SY(10)), 0.2);
                        ActionNode:setTag(70001);
                        actNode:addChild(ActionNode);
                    end
                end
            end
        end
    end
    beginBattle();    
end

local function FirstBatter_Window()
    local imgPath = getRealUIResourcePath("img/new00631.jpg");
    local btnPath = getRealUIResourcePath("img/new00637.png");
    if imgPath and btnPath then
        local pImg = SCImage:imageWithFile(imgPath:getData());
        local pBtn = SCButton:button(EnumBtnType9Atlas);
        if pImg and pBtn then
            pBtn:setTitle(btnPath:getData());
            pBtn:setContentSize(CCSizeMake(SX(100), SY(30)));
            pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
            pBtn:setPosition(CCPointMake(pImg:getContentSize().width / 2, SY(23)));
            pBtn:luaSetSelectorOnClicked(onClickedSure);
            pImg:addChild(pBtn);
            local mapLay = tolua.cast(tolua.cast(Hero:getSingleton(), "SCSceneElement"):getMainScene(), "MapLayer");
            if mapLay then
                local pBattleNode = tolua.cast(mapLay:getNewBattleManager(), "SCNode");
                if pBattleNode then
                    pImg:setAnchorPoint(CCPointMake(0.5, 0.5));
                    local size = pBattleNode:getContentSize();
                    pImg:setPosition(CCPointMake(size.width / 2, size.height / 2));    
                    local frameWndNode = FrameWindow:frameWnd()
                    if frameWndNode then
                        frameWndNode:setContentSize(size);
                        frameWndNode:setBackgroundColor(ccc4(0, 0, 0, 220))
                        frameWndNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        frameWndNode:setPosition(CCPointMake(size.width / 2, size.height / 2)); 
                        frameWndNode:setTag(70001);
                        frameWndNode:addChild(pImg);
                        frameWndNode:setOutSpaceClickClose(false)
                        frameWndNode:setFrameVisibled(false)
                        frameWndNode:setCloseBtnVisible(false)
                        pBattleNode:addChild(frameWndNode);
                    end
                end
            end
			GuidePoint_createRightGuideNode(pBtn)
        end
    end
end

local function isFirstBatter()
	local MAPTYPE_NEWBIE_COPY = 4096;
    if GuidePoint_isGuideFirstCSkill() then
		if CLIENT_VERSION >= 331 and GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_NEWBIE_COPY) then
			return false
		else
			FirstBatter_Window()
		end
        return true
    end
    return false;
    --[[local toReadFile = SCPath:getSingleton():getDocumentPath():getData();
    toReadFile = toReadFile .. "FristIsLogonSet";
    local SIS = SCInputStream:streamWithFile(toReadFile);
    if 0~=SIS:getSize()then        
        local Value = SIS:readByte();
        if Value == 1 then
            local toSaveFile = SCPath:getSingleton():getDocumentPath():getData();
            if nil == toSaveFile then
                return;
            end
            toSaveFile = toSaveFile .. "FristIsLogonSet";
            local SOS = SCOutputStream:stream();
            if SOS then
                SOS:writeByte(3);
                SOS:saveToFile(toSaveFile);
            end
            FirstBatter_Window()
            return true;
        else
            return false;
        end
    end]]
end

local function endPlotDailog()
   	local scene = SCBaseScene:getRunningScene();
	if scene then
		scene:removeChildByTag(5811, true)
	end
	plotInfo = nil
	bIsShow = false
	bFirst = false
	if bBeforBattle==true then
		bBeforBattle = false;
		plotInfoBeforBattle = {}
		if isFirstBatter() == false then
		    beginBattle();
		end
	elseif bAfterBattle==true then
		bAfterBattle = false;
		plotInfoAfterBattle = {}
		endBattle();
		BattleRewards_showBattleRewardsWnd()
	elseif bStartTask==true then
		bStartTask = false;
		plotInfoStartTask = {}
		local scene = SCBaseScene:getRunningScene();
		if scene then
			scene:getUINode():setVisible(true)
		end
		local mapLayer = getMapLayer()
		if mapLayer then
			mapLayer:showPlayer(AccountController_getShowPlayerNum())
			mapLayer:showOrHideNpc(true)
			mapLayer:showOrHideHero(true)
		end
		showNewFunOpenAnimation()
	elseif bEndTask==true then
		bEndTask = false;
		plotInfoEndTask = {}
		local scene = SCBaseScene:getRunningScene();
		if scene then
			scene:getUINode():setVisible(true)
		end
		local mapLayer = getMapLayer()
		if mapLayer then
			mapLayer:showPlayer(AccountController_getShowPlayerNum())
			mapLayer:showOrHideNpc(true)
			mapLayer:showOrHideHero(true)
		end
		showNewFunOpenAnimation()
    elseif bBoss == true then
        bBoss = false;
		plotInfoBoss = {}
        beginBossBattle(true);
	end
end

local function getHeroPhoto()
    local profession = Hero:getSingleton():getProfessionID();
    if 1 == profession then
        return 5000020;
    elseif 2 == profession then
        return 5000017;
    elseif 3 == profession then
        return 5000018;
    elseif 4 == profession then
        return 5000019;
    end
end

local function onClickSkip(tag)
    endPlotDailog();
end

local function showPlayerDailog(node, onePlotInfo)	
	node:removeAllChildrenWithCleanup(true);
    node:setBackgroundColor(colorTransparent());	
	isAsideDailog = false;
	
	local image = nil
	imgPath = getRealUIResourcePath("img/new00527.png");
	if imgPath then
		image = SCImage:imageWithFile(imgPath:getData());
		image:setTag(1);
        local size = node:getContentSize();
        image:setAnchorPoint(ANCHOR_CENTER);
        image:setPosition(CCPointMake(size.width / 2, size.height / 2));
        size = SCREEN_SIZE;
        local imgSize = image:getContentSize();
        image:setScaleX(size.width / imgSize.width);
        image:setScaleY(size.height / imgSize.height);
		node:addChild(tolua.cast(image, "SCNode"));	
		local pBtn = SCButton:button()
		local pBtnFile = getRealUIResourcePath("img/new00528.png");
		if pBtn then
		    pBtn:setTitle(pBtnFile:getData());
		    pBtn:setAnchorPoint(CCPointMake(1, 1));
		    local size = node:getContentSize();
		    pBtn:setPosition(CCPointMake(size.width - SX(25), size.height - SY(7)));
            pBtn:luaSetSelectorOnClicked(onClickSkip);
		    node:addChild(pBtn);
		end
	end
	local img1 = nil
	local imgPath = nil;
	if onePlotInfo["nPhoto"] == 0 then
		imgPath = getRealUIResourcePath("PlotPhoto/"..getHeroPhoto()..".png");
    else
		imgPath = getRealUIResourcePath("PlotPhoto/"..onePlotInfo["nPhoto"]..".png");
	end
    if imgPath then
        img1 = SCImage:imageWithFile(imgPath:getData())
        node:addChild(img1)
    end
	
	local verbatimNode = nil
	if image then
		local x, y = getTextBoxWidthHeight(onePlotInfo["szDialog"], getFontSize(12), 320*gUIScale().y);
		verbatimNode = VerbatimDisplay:newVerbatimDisplay(x, y, getDefaultFontName(), getFontSize(12))
		tolua.cast(verbatimNode, "SCNode"):setTag(5000);
		verbatimNode:setVerbatimText(onePlotInfo["szDialog"], true)
		tolua.cast(verbatimNode, "SCNode"):setAnchorPoint(CCPointMake(0, 1))		
		local nWidth = 0
		if img1 then
			nWidth = img1:getContentSize().width+10*gUIScale().x
		end
		if CLIENT_TYPE == 2 then
			tolua.cast(verbatimNode, "SCNode"):setPosition(CCPointMake(nWidth, SY(50)));
		else
			tolua.cast(verbatimNode, "SCNode"):setPosition(CCPointMake(nWidth, SY(43)));
		end
		node:addChild(tolua.cast(verbatimNode, "SCNode"))
	end
	
	--[[local img2 = nil
	imgPath = getRealUIResourcePath("img/img5048.png");
	if imgPath then
		img2 = SCImage:imageWithFile(imgPath:getData());
		img2:setTag(3);
		local nWidth = 0
		if img1 then
			nWidth = img1:getContentSize().width
		end
		local nHeight = 0
		if image then
			nHeight = image:getContentSize().height
		end
		img2:setPosition(CCPointMake(nWidth, SY(55) * SCREEN_SIZE.height / image:getContentSize().height));
		node:addChild(tolua.cast(img2, "SCNode"));
	end

	if img2 then
		local parNode = getItemTextNode("*2"..onePlotInfo["szSpeakerName"], 0, 12)
		parNode:setAnchorPoint(CCPointMake(0.5, 0.5))
		parNode:setPosition(CCPointMake(img2:getContentSize().width/2, img2:getContentSize().height/2-SY(1)))
		img2:addChild(parNode)
	end]]


	if onePlotInfo["ucPosition"]==1 then
		if img1 then
			img1:setAnchorPoint(CCPointMake(1, 0));
			img1:setPosition(CCPointMake(node:getContentSize().width, 0));
		end
		--[[if img2 then
			img2:setAnchorPoint(CCPointMake(1, 0));
			local nWidth = 0
			if img1 then
				nWidth = node:getContentSize().width-img1:getContentSize().width
			end
			local nHeight = 0
			if image then
				nHeight = image:getContentSize().height
			end
			img2:setPosition(CCPointMake(nWidth, SY(55) * SCREEN_SIZE.height / image:getContentSize().height));
		end]]
		if verbatimNode then
			tolua.cast(verbatimNode, "SCNode"):setAnchorPoint(CCPointMake(1, 1));
			local nWidth = 0	
            if img1 then
                nWidth = node:getContentSize().width - img1:getContentSize().width-10*gUIScale().x
            end
            if CLIENT_TYPE == 2 then
				tolua.cast(verbatimNode, "SCNode"):setPosition(CCPointMake(nWidth, SY(50)));
            else
				tolua.cast(verbatimNode, "SCNode"):setPosition(CCPointMake(nWidth, SY(43)));
			end
		end
	end
end

local function showAsideDailog(node, onePlotInfo)
	node:removeAllChildrenWithCleanup(true);
	node:setBackgroundColor(colorBlack());
	
	isAsideDailog = false;
	
	local cNode = SCNode:node()
	cNode:setContentSize(node:getContentSize())
	cNode:setBackgroundColor(ccc4(0,0,0,180))
	node:addChild(cNode)
	
	local x, y = getTextBoxWidthHeight(onePlotInfo["szDialog"], getFontSize(15), 320*gUIScale().y);
	local verbatimNode = VerbatimDisplay:newVerbatimDisplay(x, y, getDefaultFontName(), gDefaultFontSize)
	tolua.cast(verbatimNode, "SCNode"):setTag(5000);
	verbatimNode:setVerbatimText(onePlotInfo["szDialog"], true)
	tolua.cast(verbatimNode, "SCNode"):setAnchorPoint(CCPointMake(0.5, 0.5))
	tolua.cast(verbatimNode, "SCNode"):setPosition(CCPointMake(getScreenWidth()/2, getScreenHeight()/2));
	node:addChild(tolua.cast(verbatimNode, "SCNode"))
end

local function showImageDailog(node, onePlotInfo)
	node:removeAllChildrenWithCleanup(true);
    node:setBackgroundColor(colorTransparent());
	
	isAsideDailog = false;
	
	--local imgPath = getRealUIResourcePath("img/9000021.png");
	local img = nil
	local imgPath = getRealUIResourcePath("PlotPhoto/"..onePlotInfo["nDialogPhoto"]..".png");
	if imgPath then
		img = SCImage:imageWithFile(imgPath:getData());
		img:setTag(1);
		img:setAnchorPoint(CCPointMake(0.5,0.5));
		img:setPosition(CCPointMake(node:getContentSize().width/2, node:getContentSize().height/2+40*gUIScale().y));
		node:addChild(tolua.cast(img, "SCNode"));
	end

	
	local x, y = getTextBoxWidthHeight(onePlotInfo["szDialog"], getFontSize(12), 180*gUIScale().y);
	local verbatimNode = VerbatimDisplay:newVerbatimDisplay(x, y, getDefaultFontName(), getFontSize(12))
	tolua.cast(verbatimNode, "SCNode"):setTag(5000);
	verbatimNode:setVerbatimText(onePlotInfo["szDialog"], true)
	tolua.cast(verbatimNode, "SCNode"):setAnchorPoint(CCPointMake(0.5, 0.5))
	local nHeight = node:getContentSize().height/2
	if img then
		nHeight = nHeight-img:getContentSize().height/2-tolua.cast(verbatimNode, "SCNode"):getContentSize().height/2+35*gUIScale().y
	end
	tolua.cast(verbatimNode, "SCNode"):setPosition(CCPointMake(node:getContentSize().width/2, nHeight))
	node:addChild(tolua.cast(verbatimNode, "SCNode"))
end

local function onFixClick(Tag)
	local scene = SCBaseScene:getRunningScene();
	if not scene then
		return true
	end
	local wnd = tolua.cast(scene:getChildByTag(5811), "SCWindow")
	if not wnd then
		return true
	end
	local img = tolua.cast(wnd:getChildByTag(1), "SCImage")
	if not img then
		return
	end
	local verbatimNode = tolua.cast(img:getChildByTag(1), "VerbatimDisplay")
	if not verbatimNode then
		return
	end
	verbatimNode:stopVerbatim();
	if not plotInfo or table.getn(plotInfo)==0 then
		isAsideDailog = false;
        endPlotDailog();
        return;
    end
    if plotInfo[1]["ucType"]==1 or plotInfo[1]["ucType"]==2 then
        showPlayerDailog(wnd, plotInfo[1]);
    elseif plotInfo[1]["ucType"]==3 then
        showAsideDailog(wnd, plotInfo[1]);
    elseif plotInfo[1]["ucType"]==4 then
        verbatimNode:setVerbatimText(plotInfo[1]["szDialog"], true);
	elseif plotInfo[1]["ucType"]==5 then
		showImageDailog(wnd, plotInfo[1]);
    end
    table.remove(plotInfo, 1);
end

local function showFixDailog(node, onePlotInfo)
    node:removeAllChildrenWithCleanup(true);
    node:setBackgroundColor(colorTransparent());
	
	isAsideDailog = true;
	
	local imgPath = getRealUIResourcePath("img/new00527.png");
	if not imgPath then
		return
	end
	local image = SCImage:imageWithFile(imgPath:getData());
	image:setTag(1);
	image:setAnchorPoint(CCPointMake(0.5,0.5));
	image:setPosition(CCPointMake(node:getContentSize().width/2, node:getContentSize().height/2));
	node:addChild(tolua.cast(image, "SCNode"));	
	
	local x, y = getTextBoxWidthHeight(onePlotInfo["szDialog"], getFontSize(15), 320*gUIScale().y);
	local verbatimNode = VerbatimDisplay:newVerbatimDisplay(x, y, getDefaultFontName(), gDefaultFontSize)
	tolua.cast(verbatimNode, "SCNode"):setTag(1);
	verbatimNode:setVerbatimText(onePlotInfo["szDialog"], true)
	tolua.cast(verbatimNode, "SCNode"):setAnchorPoint(CCPointMake(0.5, 0.5));
	tolua.cast(verbatimNode, "SCNode"):setPosition(CCPointMake(image:getContentSize().width/2, image:getContentSize().height-y/2-SY(10)));
	image:addChild(tolua.cast(verbatimNode, "SCNode"));
	
	local btn = SCButton:button(EnumBtnType9Atlas);
	setNodeContentSize(btn, SmallButton_Size)
	--btn:setContentSize(SmallButton_Size)
	btn:setTag(2);
	btn:setTitle(_LTParser("str0287"), getDefaultFontName(), getFontSize(12));
	btn:luaSetSelectorOnClicked(onFixClick);
	btn:setAnchorPoint(CCPointMake(0.5, 0.5));
	btn:setPosition(CCPointMake(image:getContentSize().width/2, 20*gUIScale().y))
	--btn:setPosition(CCPointMake(image:getContentSize().width/2, 20));
	image:addChild(tolua.cast(btn, "SCNode"));
end

local function stopVerbatims()
	local scene = SCBaseScene:getRunningScene();
	if not scene then
		return true
	end
	local wnd = tolua.cast(scene:getChildByTag(5811), "SCWindow")
	if not wnd then
		return true
	end
	local verbatimNode = tolua.cast(wnd:getChildByTag(5000), "VerbatimDisplay")
	if verbatimNode then
		return verbatimNode:stopVerbatim()
	end
	local img = tolua.cast(wnd:getChildByTag(1), "SCImage")
	if not img then
		return true
	end
	local verbatimNode = tolua.cast(img:getChildByTag(5000), "VerbatimDisplay")
	if verbatimNode then
		return verbatimNode:stopVerbatim()
	end
	return true
end

local function selectorOnTouched()
	local scene = SCBaseScene:getRunningScene();
	if not scene then
		return true
	end
	local wnd = tolua.cast(scene:getChildByTag(5811), "SCWindow")
	if not wnd then
		return true
	end
	--[[
	if isAsideDailog==true then
		return;
	end
	]]
	if not stopVerbatims() then
		return
	end
	if #plotInfo==0 then
		isAsideDailog = false;
        endPlotDailog();
        if Hero:getSingleton():iSATeamLeader() == true then        
          local dataStream = SCDataTransStream:streamWithCommand(_MSG_PLOT);
          dataStream:writeShort(MSG_PLOT_LAST_PAGE);
          SCDataTransThread:getSingleton():transData(dataStream);
        end
        return;
    end
    if plotInfo[1]["ucType"]==1 or plotInfo[1]["ucType"]==2 then
        showPlayerDailog(wnd, plotInfo[1]);
    elseif plotInfo[1]["ucType"]==3 then
        showAsideDailog(wnd, plotInfo[1]);
    elseif plotInfo[1]["ucType"]==4 then
        showFixDailog(wnd, plotInfo[1]);
	elseif plotInfo[1]["ucType"]==5 then
		showImageDailog(wnd, plotInfo[1]);
    end
    table.remove(plotInfo, 1);
    if Hero:getSingleton():iSATeamLeader() == true then        
      local dataStream = SCDataTransStream:streamWithCommand(_MSG_PLOT);
      dataStream:writeShort(MSG_PLOT_NEXT_PAGE);
      SCDataTransThread:getSingleton():transData(dataStream);
    end
end

local function createPlotDailog()
	local scene = SCBaseScene:getRunningScene();
	if not scene then
		return
	end
	if scene:getChildByTag(5811) then
		return tolua.cast(scene:getChildByTag(5811), "SCWindow")
	end
	local wnd = SCWindow:window();
	--setNodeContentSize(dialogNode, CCSizeMake(480, 320))
	wnd:setTag(5811);
	wnd:luaSetSelectorOnClose(onClickClose);
	if Hero:getSingleton():iSATeamLeader() == true or Hero:getSingleton():isATeamMember() == false then
	    wnd:luaSetSelectorOnTouched(selectorOnTouched);
	end
	local size = scene:getContentSize();
	wnd:setAnchorPoint(ANCHOR_CENTER);
	wnd:setPosition(CCPointMake(size.width / 2, size.height / 2));
	scene:addChild(wnd, Max_Int)
	wnd:setFrameVisibled(false);
	wnd:setCloseButtonVisibled(false);
	wnd:setBackButtonVisibled(false);
	wnd:setAutoCloseOnTouchSpace(false);
	
	return wnd;
end

local function beforBattle()
	node = createPlotDailog();
	plotInfo = plotInfoBeforBattle;
	selectorOnTouched();
end

local function afterBattle()
	node = createPlotDailog();
	plotInfo = plotInfoAfterBattle;
	selectorOnTouched();
end

function PlotDailog_showPlotDailog()
	--if bFirst==false then
		--bFirst = true;
    if bIsShow == true then
		if bStartTask==true then
				local scene = SCBaseScene:getRunningScene();
				if scene then
					scene:getUINode():setVisible(false)
				end
				--[[local mapLayer = getMapLayer()
				if mapLayer then
					mapLayer:showPlayer(0)
					mapLayer:showOrHideNpc(false)
					mapLayer:showOrHideHero(false)
				end]]
				createPlotDailog();
				plotInfo = plotInfoStartTask;
				selectorOnTouched();
		elseif bEndTask==true then
            local scene = SCBaseScene:getRunningScene();
            if scene then
                scene:getUINode():setVisible(false)
            end
            --[[local mapLayer = getMapLayer()
            if mapLayer then
                mapLayer:showPlayer(0)
                mapLayer:showOrHideNpc(false)
                mapLayer:showOrHideHero(false)
            end]]
            createPlotDailog();
            plotInfo = plotInfoEndTask;
            selectorOnTouched();
		elseif bBoss==true then
            local scene = SCBaseScene:getRunningScene();
            if scene then
                scene:getUINode():setVisible(false)
            end
           --[[ local mapLayer = getMapLayer()
            if mapLayer then
                mapLayer:showPlayer(0)
                --mapLayer:showOrHideNpc(false)
                --mapLayer:showOrHideHero(false)
            end]]
            beginBossBattle(false);
            createPlotDailog();
            plotInfo = plotInfoBoss;
            selectorOnTouched();
		end
	end
    local mark = LuaReCall:getSingleton():getnID();
    if mark == 1 then
        bBeforBattle = true;
    elseif mark == 2 then
        bAfterBattle = true;
    elseif mark == 3 then
        bBoss = true;
    end
    if mark ~= 1 and mark ~= 2 and mark ~= 3 then
        return;
    end
    LuaReCall:getSingleton():setnID(0);
    if bBeforBattle == true then           
        createPlotDailog();
        plotInfo = plotInfoBeforBattle
        if #plotInfo > 0 then
            selectorOnTouched();
        else
            endPlotDailog();
        end
    elseif bAfterBattle == true then        
        createPlotDailog();
        plotInfo = plotInfoAfterBattle
        if #plotInfo > 0 then
            selectorOnTouched();
        else
            endPlotDailog();
        end
    elseif bBoss == true then        
        createPlotDailog();        
        local scene = SCBaseScene:getRunningScene();
        if scene then
            scene:getUINode():setVisible(false)
        end
        --[[local mapLayer = getMapLayer()
        if mapLayer then
            mapLayer:showPlayer(0)
            --mapLayer:showOrHideNpc(false)
            --mapLayer:showOrHideHero(false)
        end]]
        beginBossBattle(false);
        plotInfo = plotInfoBoss
        if #plotInfo > 0 then
            selectorOnTouched();
        else
            endPlotDailog();
        end
    end
	return 1
end

local function recvPlotDailogMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    local action = dt:readShort();
    if action == MSG_PLOT_INFO_BEGIN or action == MSG_PLOT_INFO_END then
        local ucAmount = dt:readByte();
        for i=1, ucAmount do
            local tmpplotInfo = {};
			local idPlot = dt:readInt();
			local plotInfo = TableParser:getSingleton():getPlotDialog(idPlot);
			if plotInfo.id ~= 0 then
				tmpplotInfo["ucType"] = plotInfo.type;
				tmpplotInfo["szSpeakerName"] = plotInfo.name:getData();
				if tmpplotInfo["szSpeakerName"] == " " then
					tmpplotInfo["szSpeakerName"] = Hero:getSingleton():getName():getData();
				end
				
				tmpplotInfo["nPhoto"] = plotInfo.photo;
				tmpplotInfo["szDialog"] = plotInfo.dialog:getData();
				tmpplotInfo["nDialogPhoto"] = 0;
				tmpplotInfo["ucTriggerType"] = plotInfo.trigger_type;
				tmpplotInfo["ucPosition"] = plotInfo.position;
				tmpplotInfo["ucFace"] = 0;
			end
            --[[tmpplotInfo["ucType"] = dt:readByte();
            local scstr = dt:readString();
            if scstr~=nil then
				tmpplotInfo["szSpeakerName"] = scstr:getData();
			else
				tmpplotInfo["szSpeakerName"] = Hero:getSingleton():getName():getData();
			end
            tmpplotInfo["nPhoto"] = dt:readInt();
            local scstr = dt:readString();
            if scstr~=nil then
				tmpplotInfo["szDialog"] = scstr:getData();
			else
				tmpplotInfo["szDialog"] = " ";
			end
            tmpplotInfo["nDialogPhoto"] = dt:readInt();
            tmpplotInfo["ucTriggerType"] = dt:readByte();
            tmpplotInfo["ucPosition"] = dt:readByte();
			tmpplotInfo["ucFace"] = dt:readByte();]]
            if tmpplotInfo["ucTriggerType"]==EM_TRIGGER_TYPE_RECEIVE_QUEST then
				if not BattleProcessor:getSingleton():getIsInBattle() then
					table.insert(plotInfoStartTask, tmpplotInfo);
					bStartTask = true;
				end
			elseif tmpplotInfo["ucTriggerType"]==EM_TRIGGER_TYPE_RETRODE_QUEST then
				if not BattleProcessor:getSingleton():getIsInBattle() then
					table.insert(plotInfoEndTask, tmpplotInfo);
					bEndTask = true;
				end
			elseif tmpplotInfo["ucTriggerType"]==EM_TRIGGER_TYPE_ENTER_COPY_FIRST_TIME then
				table.insert(plotInfoBeforBattle, tmpplotInfo);
				--bBeforBattle = true;
			elseif tmpplotInfo["ucTriggerType"]==EM_TRIGGER_TYPE_FINISH_COPY_FIRST_TIME then
				table.insert(plotInfoAfterBattle, tmpplotInfo);
				--bAfterBattle = true;
			elseif tmpplotInfo["ucTriggerType"]==EM_TRIGGER_TYPE_BOSS_DIALOG then
			    --bBoss = true;
				table.insert(plotInfoBoss, tmpplotInfo);			
			end
        end
        if action == MSG_PLOT_INFO_END then
            bIsShow = true
            PlotDailog_showPlotDailog();
        end
    elseif MSG_PLOT_NEXT_PAGE == action then
        selectorOnTouched();
    elseif MSG_PLOT_LAST_PAGE == action then
		isAsideDailog = false;
        endPlotDailog();
    end
end

function getIsInPlotDailog()
	return bIsShow
end

function PlotDailog_clearData()
    plotInfoBeforBattle = {};
    plotInfoAfterBattle = {}
    plotInfoBoss = {};
    plotInfo = {};
end

SCMessageCenter:getSingleton():luaRegistCommand(recvPlotDailogMsg, _MSG_PLOT, 0, nil);