--定义一个与文件名相同的table
PopularActivities = {}
------------------消息--------------------

----------------结构定义区----------------
local stWorldEvent = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		
		tmp.usIndex = dt:readShort();
		tmp.szName = dt:readString();
		if tmp.szName then
			tmp.szName = tmp.szName:getData();
		else
			tmp.szName = "";
		end
		
		tmp.szState = dt:readString();
		if tmp.szState then
			tmp.szState = tmp.szState:getData();
		else
			tmp.szState = "";
		end
		
		tmp.byType = dt:readByte();
		tmp.usNeedLevel = dt:readShort();
		tmp.dwPhoto = dt:readInt();	
		
		return tmp;
	end
}

----------------常量定义区----------------
local WORLDEVENT_TYPE_WORLD_BOSS1 = 1	--//世界boss1
local WORLDEVENT_TYPE_WORLD_TREE = 2	--//世界摇钱树
local WORLDEVENT_TYPE_WORLD_BOSS2 = 3	--//世界boss2s
local WORLDEVENT_TYPE_WORLD_QUIZ = 4	--//世界答题竞猜
--local WORLDEVENT_TYPE_WORLD_ZHENBA = 5	--//三国争霸
local WORLDEVENT_TYPE_ESCORT = 5 --押送军粮
local USERINFO_OPEN_WORLD_EVENT = 75 -- //打开世界活动
local USERINFO_JION_WORLD_EVENT = 76 -- //参与世界活动或改按钮

----------------变量定义区----------------

local stAllWorldEvent = {}
local m_curIndex = nil;

--变量的定义
----------------UI控制器区----------------
function PopularActivities.initControl()
	local pWindow6010 = SCWindow:window()
	if pWindow6010 then
		pWindow6010:setTag(6010)
		pWindow6010:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow6010:setPosition(AUTO_POS(4.00, 40.00))pWindow6010:setContentSize(AUTO_SIZE(472, 240))
		pWindow6010:luaSetSelectorOnClose(PopularActivities.releaseControl)
	end

	PopularActivities.m_DragNode = SCDragNode:node()
	if PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:setTag(1)
		PopularActivities.m_DragNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		PopularActivities.m_DragNode:setPosition(AUTO_POS(0.00, 0.00))
		PopularActivities.m_DragNode:setContentSize(AUTO_SIZE(472, 240))
		PopularActivities.m_DragNode:setFrameVisibled(true)
		PopularActivities.m_DragNode:setDragEnabled(false)
		PopularActivities.m_DragNode:setFrameType(EnumFrameTyperedwindowstip)
	end

	PopularActivities.m_pButton6 = SCButton:button()
	if PopularActivities.m_pButton6 then
		PopularActivities.m_pButton6:setTag(6)
		PopularActivities.m_pButton6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		PopularActivities.m_pButton6:setPosition(AUTO_POS(452.00, 219.00))
		PopularActivities.m_pButton6:setContentSize(AUTO_SIZE(20, 20))
		local imgPath = getRealUIResourcePath("img/new00123.png")
		if imgPath then
			PopularActivities.m_pButton6:setTitle(imgPath:getData())
		end
	end

	local pDragNode10 = SCDragNode:node()
	if pDragNode10 then
		pDragNode10:setTag(10)
		pDragNode10:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10:setPosition(AUTO_POS(0.00, 37.00))
		pDragNode10:setContentSize(AUTO_SIZE(96, 180))
		pDragNode10:setFrameVisibled(true)
		pDragNode10:setDragEnabled(false)
		pDragNode10:setFrameType(EnumFrameTypeLine)
	end

	local imgPath = getRealUIResourcePath("img/new00348.png")
	local pImage11 = nil
	if imgPath then
		pImage11 = SCImage:imageWithFile(imgPath:getData())
		if pImage11 then
			pImage11:setTag(11)
			pImage11:setAnchorPoint(ANCHOR_CENTER)
			pImage11:setPosition(AUTO_POS(48.00, 124.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00350.png")
	local pImage12 = nil
	if imgPath then
		pImage12 = SCImage:imageWithFile(imgPath:getData())
		if pImage12 then
			pImage12:setTag(12)
			pImage12:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage12:setPosition(AUTO_POS(11.00, 55.00))
		end
	end

	local pLable13 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable13 then
		pLable13:setTag(13)
		pLable13:setAnchorPoint(ANCHOR_CENTER)
		pLable13:setPosition(AUTO_POS(48.00, 48.00))
		pLable13:setColor(ccc4(255,255,255,255))
	end

	local pLable14 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable14 then
		pLable14:setTag(14)
		pLable14:setAnchorPoint(ANCHOR_CENTER)
		pLable14:setPosition(AUTO_POS(48.00, 34.00))
		pLable14:setColor(ccc4(255,255,255,255))
	end

	local pLable15 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable15 then
		pLable15:setTag(15)
		pLable15:setAnchorPoint(ANCHOR_CENTER)
		pLable15:setPosition(AUTO_POS(48.00, 20.00))
		pLable15:setColor(ccc4(255,255,255,255))
	end

	local pButton16 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton16 then
		pButton16:setTag(16)
		pButton16:setAnchorPoint(ANCHOR_CENTER)
		pButton16:setPosition(AUTO_POS(48.00, -17.00))
		pButton16:setContentSize(AUTO_SIZE(82, 30))
		local imgPath = getRealUIResourcePath("img/new00356.png")
		if imgPath then
			pButton16:setTitle(imgPath:getData())
		end
		local pBackimg = getRealUIResourcePath("img/new00155.png")
		if pBackimg then
			pButton16:setBackgroundImage(pBackimg:getData())
		end
	end

	local pDragNode20 = SCDragNode:node()
	if pDragNode20 then
		pDragNode20:setTag(20)
		pDragNode20:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode20:setPosition(AUTO_POS(94.00, 37.00))
		pDragNode20:setContentSize(AUTO_SIZE(96, 180))
		pDragNode20:setFrameVisibled(true)
		pDragNode20:setDragEnabled(false)
		pDragNode20:setFrameType(EnumFrameTypeLine)
	end

	local pDragNode30 = SCDragNode:node()
	if pDragNode30 then
		pDragNode30:setTag(30)
		pDragNode30:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode30:setPosition(AUTO_POS(188.00, 37.00))
		pDragNode30:setContentSize(AUTO_SIZE(96, 180))
		pDragNode30:setFrameVisibled(true)
		pDragNode30:setDragEnabled(false)
		pDragNode30:setFrameType(EnumFrameTypeLine)
	end

	local pDragNode40 = SCDragNode:node()
	if pDragNode40 then
		pDragNode40:setTag(40)
		pDragNode40:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode40:setPosition(AUTO_POS(282.00, 37.00))
		pDragNode40:setContentSize(AUTO_SIZE(96, 180))
		pDragNode40:setFrameVisibled(true)
		pDragNode40:setDragEnabled(false)
		pDragNode40:setFrameType(EnumFrameTypeLine)
	end

	local imgPath = getRealUIResourcePath("img/new00357.png")
	local pImage21 = nil
	if imgPath then
		pImage21 = SCImage:imageWithFile(imgPath:getData())
		if pImage21 then
			pImage21:setTag(21)
			pImage21:setAnchorPoint(ANCHOR_CENTER)
			pImage21:setPosition(AUTO_POS(52.00, 121.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00786.png")
	local pImage22 = nil
	if imgPath then
		pImage22 = SCImage:imageWithFile(imgPath:getData())
		if pImage22 then
			pImage22:setTag(22)
			pImage22:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage22:setPosition(AUTO_POS(19.00, 55.00))
		end
	end

	local pLable23 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable23 then
		pLable23:setTag(23)
		pLable23:setAnchorPoint(ANCHOR_CENTER)
		pLable23:setPosition(AUTO_POS(48.00, 48.00))
		pLable23:setColor(ccc4(255,255,255,255))
	end

	local pLable24 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable24 then
		pLable24:setTag(24)
		pLable24:setAnchorPoint(ANCHOR_CENTER)
		pLable24:setPosition(AUTO_POS(48.00, 34.00))
		pLable24:setColor(ccc4(255,255,255,255))
	end

	local pLable25 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable25 then
		pLable25:setTag(25)
		pLable25:setAnchorPoint(ANCHOR_CENTER)
		pLable25:setPosition(AUTO_POS(48.00, 20.00))
		pLable25:setColor(ccc4(255,255,255,255))
	end

	local pButton26 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton26 then
		pButton26:setTag(26)
		pButton26:setAnchorPoint(ANCHOR_CENTER)
		pButton26:setPosition(AUTO_POS(48.00, -17.00))
		pButton26:setContentSize(AUTO_SIZE(82, 30))
		local imgPath = getRealUIResourcePath("img/new00356.png")
		if imgPath then
			pButton26:setTitle(imgPath:getData())
		end
		local pBackimg = getRealUIResourcePath("img/new00155.png")
		if pBackimg then
			pButton26:setBackgroundImage(pBackimg:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00359.png")
	local pImage31 = nil
	if imgPath then
		pImage31 = SCImage:imageWithFile(imgPath:getData())
		if pImage31 then
			pImage31:setTag(31)
			pImage31:setAnchorPoint(ANCHOR_CENTER)
			pImage31:setPosition(AUTO_POS(50.00, 126.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00355.png")
	local pImage32 = nil
	if imgPath then
		pImage32 = SCImage:imageWithFile(imgPath:getData())
		if pImage32 then
			pImage32:setTag(32)
			pImage32:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage32:setPosition(AUTO_POS(11.00, 55.00))
		end
	end

	local pLable33 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable33 then
		pLable33:setTag(33)
		pLable33:setAnchorPoint(ANCHOR_CENTER)
		pLable33:setPosition(AUTO_POS(48.00, 48.00))
		pLable33:setColor(ccc4(255,255,255,255))
	end

	local pLable34 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable34 then
		pLable34:setTag(34)
		pLable34:setAnchorPoint(ANCHOR_CENTER)
		pLable34:setPosition(AUTO_POS(48.00, 34.00))
		pLable34:setColor(ccc4(255,255,255,255))
	end

	local pLable35 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable35 then
		pLable35:setTag(35)
		pLable35:setAnchorPoint(ANCHOR_CENTER)
		pLable35:setPosition(AUTO_POS(48.00, 20.00))
		pLable35:setColor(ccc4(255,255,255,255))
	end

	local pButton36 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton36 then
		pButton36:setTag(36)
		pButton36:setAnchorPoint(ANCHOR_CENTER)
		pButton36:setPosition(AUTO_POS(48.00, -17.00))
		pButton36:setContentSize(AUTO_SIZE(82, 30))
		local imgPath = getRealUIResourcePath("img/new00356.png")
		if imgPath then
			pButton36:setTitle(imgPath:getData())
		end
		local pBackimg = getRealUIResourcePath("img/new00155.png")
		if pBackimg then
			pButton36:setBackgroundImage(pBackimg:getData())
		end
	end

	local imgPath = getRealUIResourcePath("img/new00353.png")
	local pImage41 = nil
	if imgPath then
		pImage41 = SCImage:imageWithFile(imgPath:getData())
		if pImage41 then
			pImage41:setTag(41)
			pImage41:setAnchorPoint(ANCHOR_CENTER)
			pImage41:setPosition(AUTO_POS(48.00, 125.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00355.png")
	local pImage42 = nil
	if imgPath then
		pImage42 = SCImage:imageWithFile(imgPath:getData())
		if pImage42 then
			pImage42:setTag(42)
			pImage42:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage42:setPosition(AUTO_POS(11.00, 55.00))
		end
	end

	local pLable43 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable43 then
		pLable43:setTag(43)
		pLable43:setAnchorPoint(ANCHOR_CENTER)
		pLable43:setPosition(AUTO_POS(48.00, 48.00))
		pLable43:setColor(ccc4(255,255,255,255))
	end

	local pLable44 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable44 then
		pLable44:setTag(44)
		pLable44:setAnchorPoint(ANCHOR_CENTER)
		pLable44:setPosition(AUTO_POS(48.00, 34.00))
		pLable44:setColor(ccc4(255,255,255,255))
	end

	local pLable45 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable45 then
		pLable45:setTag(45)
		pLable45:setAnchorPoint(ANCHOR_CENTER)
		pLable45:setPosition(AUTO_POS(48.00, 20.00))
		pLable45:setColor(ccc4(255,255,255,255))
	end

	local pButton46 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton46 then
		pButton46:setTag(46)
		pButton46:setAnchorPoint(ANCHOR_CENTER)
		pButton46:setPosition(AUTO_POS(48.00, -17.00))
		pButton46:setContentSize(AUTO_SIZE(82, 30))
		local imgPath = getRealUIResourcePath("img/new00356.png")
		if imgPath then
			pButton46:setTitle(imgPath:getData())
		end
		local pBackimg = getRealUIResourcePath("img/new00155.png")
		if pBackimg then
			pButton46:setBackgroundImage(pBackimg:getData())
		end
	end

	local pDragNode50 = SCDragNode:node()
	if pDragNode50 then
		pDragNode50:setTag(50)
		pDragNode50:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode50:setPosition(AUTO_POS(376.00, 37.00))
		pDragNode50:setContentSize(AUTO_SIZE(96, 180))
		pDragNode50:setFrameVisibled(true)
		pDragNode50:setDragEnabled(false)
		pDragNode50:setFrameType(EnumFrameTypeLine)
	end

	local imgPath = getRealUIResourcePath("img/new00353.png")
	local pImage51 = nil
	if imgPath then
		pImage51 = SCImage:imageWithFile(imgPath:getData())
		if pImage51 then
			pImage51:setTag(51)
			pImage51:setAnchorPoint(ANCHOR_CENTER)
			pImage51:setPosition(AUTO_POS(49.00, 125.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00352.png")
	local pImage52 = nil
	if imgPath then
		pImage52 = SCImage:imageWithFile(imgPath:getData())
		if pImage52 then
			pImage52:setTag(52)
			pImage52:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage52:setPosition(AUTO_POS(11.00, 55.00))
		end
	end

	local pLable53 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable53 then
		pLable53:setTag(53)
		pLable53:setAnchorPoint(ANCHOR_CENTER)
		pLable53:setPosition(AUTO_POS(48.00, 48.00))
		pLable53:setColor(ccc4(255,255,255,255))
	end

	PopularActivities.label54 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if PopularActivities.label54 then
		PopularActivities.label54:setTag(54)
		PopularActivities.label54:setAnchorPoint(ANCHOR_CENTER)
		PopularActivities.label54:setPosition(AUTO_POS(48.00, 34.00))
		PopularActivities.label54:setColor(ccc4(255,255,255,255))
	end

	local pLable55 = SCLabel:labelWithStringFont(L(""), DEFAULT_FONT_NAME, F(8))
	if pLable55 then
		pLable55:setTag(55)
		pLable55:setAnchorPoint(ANCHOR_CENTER)
		pLable55:setPosition(AUTO_POS(48.00, 20.00))
		pLable55:setColor(ccc4(255,255,255,255))
	end

	local pButton56 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton56 then
		pButton56:setTag(56)
		pButton56:setAnchorPoint(ANCHOR_CENTER)
		pButton56:setPosition(AUTO_POS(48.00, -17.00))
		pButton56:setContentSize(AUTO_SIZE(82, 30))
		local imgPath = getRealUIResourcePath("img/new00356.png")
		if imgPath then
			pButton56:setTitle(imgPath:getData())
		end
		local pBackimg = getRealUIResourcePath("img/new00155.png")
		if pBackimg then
			pButton56:setBackgroundImage(pBackimg:getData())
		end
	end

	local imgPath = getRealUIResourcePath("kernal/redtop.png")
	local pImage2 = nil
	if imgPath then
		pImage2 = SCImage:imageWithFile(imgPath:getData())
		if pImage2 then
			pImage2:setTag(2)
			pImage2:setAnchorPoint(CCPointMake(0.5, 0))
			pImage2:setPosition(AUTO_POS(155.00, 218.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00351.png")
	PopularActivities.m_TitleImg = nil
	if imgPath then
		PopularActivities.m_TitleImg = SCImage:imageWithFile(imgPath:getData())
		if PopularActivities.m_TitleImg then
			PopularActivities.m_TitleImg:setTag(10002)
			PopularActivities.m_TitleImg:setAnchorPoint(CCPointMake(0.5, 0))
			PopularActivities.m_TitleImg:setPosition(AUTO_POS(155.00, 222.00))
		end
	end

	local imgPath = getRealUIResourcePath("kernal/redtop.png")
	local pImage3 = nil
	if imgPath then
		pImage3 = SCImage:imageWithFile(imgPath:getData())
		if pImage3 then
			pImage3:setTag(3)
			pImage3:setAnchorPoint(CCPointMake(0.5, 0))
			pImage3:setPosition(AUTO_POS(317.00, 218.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00548.png")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(CCPointMake(0.5, 0))
			pImage4:setPosition(AUTO_POS(317.00, 222.00))
		end
	end

	if PopularActivities.m_DragNode and pWindow6010 then
		pWindow6010:addChild(tolua.cast(PopularActivities.m_DragNode, "SCNode"))
	end
	if PopularActivities.m_pButton6 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(PopularActivities.m_pButton6, "SCNode"))
	end
	if pDragNode10 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(pDragNode10, "SCNode"))
	end
	if pImage11 and pDragNode10 then
		pDragNode10:addChild(tolua.cast(pImage11, "SCNode"))
	end
	if pImage12 and pDragNode10 then
		pDragNode10:addChild(tolua.cast(pImage12, "SCNode"))
	end
	if pLable13 and pDragNode10 then
		pDragNode10:addChild(tolua.cast(pLable13, "SCNode"))
	end
	if pLable14 and pDragNode10 then
		pDragNode10:addChild(tolua.cast(pLable14, "SCNode"))
	end
	if pLable15 and pDragNode10 then
		pDragNode10:addChild(tolua.cast(pLable15, "SCNode"))
	end
	if pButton16 and pDragNode10 then
		pDragNode10:addChild(tolua.cast(pButton16, "SCNode"))
	end
	if pDragNode20 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(pDragNode20, "SCNode"))
	end
	if pDragNode30 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(pDragNode30, "SCNode"))
	end
	if pDragNode40 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(pDragNode40, "SCNode"))
	end
	if pImage21 and pDragNode20 then
		pDragNode20:addChild(tolua.cast(pImage21, "SCNode"))
	end
	if pImage22 and pDragNode20 then
		pDragNode20:addChild(tolua.cast(pImage22, "SCNode"))
	end
	if pLable23 and pDragNode20 then
		pDragNode20:addChild(tolua.cast(pLable23, "SCNode"))
	end
	if pLable24 and pDragNode20 then
		pDragNode20:addChild(tolua.cast(pLable24, "SCNode"))
	end
	if pLable25 and pDragNode20 then
		pDragNode20:addChild(tolua.cast(pLable25, "SCNode"))
	end
	if pButton26 and pDragNode20 then
		pDragNode20:addChild(tolua.cast(pButton26, "SCNode"))
	end
	if pImage31 and pDragNode30 then
		pDragNode30:addChild(tolua.cast(pImage31, "SCNode"))
	end
	if pImage32 and pDragNode30 then
		pDragNode30:addChild(tolua.cast(pImage32, "SCNode"))
	end
	if pLable33 and pDragNode30 then
		pDragNode30:addChild(tolua.cast(pLable33, "SCNode"))
	end
	if pLable34 and pDragNode30 then
		pDragNode30:addChild(tolua.cast(pLable34, "SCNode"))
	end
	if pLable35 and pDragNode30 then
		pDragNode30:addChild(tolua.cast(pLable35, "SCNode"))
	end
	if pButton36 and pDragNode30 then
		pDragNode30:addChild(tolua.cast(pButton36, "SCNode"))
	end
	if pImage41 and pDragNode40 then
		pDragNode40:addChild(tolua.cast(pImage41, "SCNode"))
	end
	if pImage42 and pDragNode40 then
		pDragNode40:addChild(tolua.cast(pImage42, "SCNode"))
	end
	if pLable43 and pDragNode40 then
		pDragNode40:addChild(tolua.cast(pLable43, "SCNode"))
	end
	if pLable44 and pDragNode40 then
		pDragNode40:addChild(tolua.cast(pLable44, "SCNode"))
	end
	if pLable45 and pDragNode40 then
		pDragNode40:addChild(tolua.cast(pLable45, "SCNode"))
	end
	if pButton46 and pDragNode40 then
		pDragNode40:addChild(tolua.cast(pButton46, "SCNode"))
	end
	if pDragNode50 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(pDragNode50, "SCNode"))
	end
	if pImage51 and pDragNode50 then
		pDragNode50:addChild(tolua.cast(pImage51, "SCNode"))
	end
	if pImage52 and pDragNode50 then
		pDragNode50:addChild(tolua.cast(pImage52, "SCNode"))
	end
	if pLable53 and pDragNode50 then
		pDragNode50:addChild(tolua.cast(pLable53, "SCNode"))
	end
	if PopularActivities.label54 and pDragNode50 then
		pDragNode50:addChild(tolua.cast(PopularActivities.label54, "SCNode"))
	end
	if pLable55 and pDragNode50 then
		pDragNode50:addChild(tolua.cast(pLable55, "SCNode"))
	end
	if pButton56 and pDragNode50 then
		pDragNode50:addChild(tolua.cast(pButton56, "SCNode"))
	end
	if pImage2 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(pImage2, "SCNode"))
	end
	if PopularActivities.m_TitleImg and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(PopularActivities.m_TitleImg, "SCNode"))
	end
	if pImage3 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(pImage3, "SCNode"))
	end
	if pImage4 and PopularActivities.m_DragNode then
		PopularActivities.m_DragNode:addChild(tolua.cast(pImage4, "SCNode"))
	end
	return pWindow6010
end
function PopularActivities.releaseControl()
	PopularActivities.m_DragNode = nil
	PopularActivities.m_pButton6 = nil
	PopularActivities.label54 = nil
	PopularActivities.m_TitleImg = nil
	if PopularActivities.wndClose then
		PopularActivities.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
--发送参与消息
local function sendJoinWorldEvent(index)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_JION_WORLD_EVENT)
	dataStream:writeShort(index)
	dataStream:writeByte(1)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show();	
end

--点击关闭
local function onCloseBtnClick(tag)
	local wndCtrl = getCurentSceneWindowController(6010);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end	
end

--点击参加
local function onEnterSureBtnClick(tag)
    if m_curIndex ~= nil then
        if m_curIndex <= #stAllWorldEvent then
		    sendJoinWorldEvent(stAllWorldEvent[m_curIndex].usIndex);
		    onCloseBtnClick(nil);
	    end
	end
end

--点击参加按钮
local function onEnterBtnClick(tag)
	local index = 1;
	if tag == 16 then
		index = 1;
	elseif tag == 26 then
		index = 2;
	elseif tag == 36 then
		index = 3;
	elseif tag == 46 then
		AnswerGuess.showAnswerGuessWnd();
		return;
	elseif tag == 56 then
	    if CLIENT_VERSION >= 328 then
            REMOVE_TOP_CTRL()
            VanFood_OpenVanFoodWnd()
            return		
	    end
	end
	m_curIndex = index;
	luashowConfirmationWindow(_LTParser("str9220"), WIN_YES, onEnterSureBtnClick);
end
local function levelNoToEnter()
    showMessage(L("str3132"))
end
local function sendEnterToArmyActivity()
     local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
     if dt then
        dt:writeShort(MSG_SOCIATY_CAMPAIGNS);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
     end
end
--刷新窗口
local function refreshWorldEventWnd()
	local wnd = getCurentSceneWindow(6010)
	if wnd == nil then
		wnd = PopularActivities.initControl();
		if wnd == nil then
			return;
		end
	
		local wndCtrl = SCWindowController:controllerWithWindow(wnd)
		local naviCtrl = getCurentSceneNavigationController()
		if naviCtrl and wndCtrl then
			naviCtrl:pushWindowController(wndCtrl)
		end
		
		local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("6010-1-6"), "SCButton")
		if pButton6 then
            pButton6:setMusicPath("closeWindow.mp3");
			pButton6:luaSetSelectorOnClicked(onCloseBtnClick);
			pButton6:setTouchRectScale(4.0,4.0)    
		end
		local pNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(1));
		if pNode then
            local pImg = SCTypeCast:castNodeToImage(pNode:getChildByTag(3));
            if pImg then
                local pBtn = SCButton:button()
                local size = pImg:getContentSize();
                local nWidth = size.width;
                local nHeight = size.height;
                if pBtn then
                    pBtn:setContentSize(CCSizeMake(nWidth, nHeight));
                    pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
                    pBtn:setPosition(CCPointMake(nWidth/2, nHeight/2));
                    pBtn:luaSetSelectorOnClicked(sendEnterToArmyActivity);
                    pImg:addChild(pBtn);
                end
            end
        end
		
		wnd:setBackButtonVisibled(false);
		wnd:setCloseButtonVisibled(false);
	end
	
	local bgImg = SCFunction:getUiNodeByIdlistAndParent("1", wnd);
	if bgImg == nil then
		return;
	end
	
	local indexBgNode = 10
	local indexImage1 = 11;
	local indexImage2 = 12;
	local indexLabel1 = 13;
	local indexLabel2 = 14;
	local indexLabel3 = 15;
	local indexButton = 16;
	local btnimgPath1 = getRealUIResourcePath("img/new00154.png");
	local btnimgPath2 = getRealUIResourcePath("img/new00349.png");
	local btnimgPath3 = getRealUIResourcePath("img/new00358.png");
	local btnimgPath4 = getRealUIResourcePath("img/new00516.png");
	for i=1, #stAllWorldEvent do
		indexBgNode = i * 10;
		indexImage1 = indexBgNode + 1;
		indexImage2 = indexBgNode + 2;
		indexLabel1 = indexBgNode + 3;
		indexLabel2 = indexBgNode + 4;
		indexLabel3 = indexBgNode + 5;
		indexButton = indexBgNode + 6;
		local bgNode = SCFunction:getUiNodeByIdlistAndParent(""..indexBgNode, bgImg);
		if bgNode then
			local Image1 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent(""..indexImage1, bgNode));
			local Image2 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent(""..indexImage2, bgNode));
			local Label3 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent(""..indexLabel3, bgNode));
			if Image1 and Image2 and Label3 then
				Label3:setText(L("str9160"));
				Label3:setColor(color_red);
				if stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_BOSS1 then
					local imgPath1 = getRealUIResourcePath("img/new00348.png");
					local imgPath2 = getRealUIResourcePath("img/new00350.png");
					if imgPath1 and imgPath2 then
						Image1:setImage(imgPath1:getData());
						Image2:setImage(imgPath2:getData());
					end
				elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_TREE then
					local imgPath1 = getRealUIResourcePath("img/new00357.png");
					local imgPath2 = getRealUIResourcePath("img/new00786.png");
					if imgPath1 and imgPath2 then
						Image1:setImage(imgPath1:getData());
						Image2:setImage(imgPath2:getData());
					end
				elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_BOSS2 then
					local imgPath1 = getRealUIResourcePath("img/new00359.png");
					local imgPath2 = getRealUIResourcePath("img/new00355.png");
					if imgPath1 and imgPath2 then
						Image1:setImage(imgPath1:getData());
						Image2:setImage(imgPath2:getData());
					end
				elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_QUIZ then
					local imgPath1 = getRealUIResourcePath("img/new00347.png");
					local imgPath2 = getRealUIResourcePath("img/new00285.png");
					if imgPath1 and imgPath2 then
						Image1:setImage(imgPath1:getData());
						Image2:setImage(imgPath2:getData());
						Label3:setText(L("str9161"));
						Label3:setColor(color_deepBlue);
					end
				elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_ESCORT then
				    Label3:setText(L("str20147"))
				    Label3:setColor(color_deepBlue);
				    local imgPath1 = getRealUIResourcePath("escort/new00840.png");
					local imgPath2 = getRealUIResourcePath("escort/new00842.png");
					if imgPath1 and imgPath2 then
						Image1:setImage(imgPath1:getData());
						Image1:setScale(0.8)
						Image1:setPosition(AUTO_POS(49, 118))
						Image2:setImage(imgPath2:getData());						
					end
				end
			end
			
			local Label1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent(""..indexLabel1, bgNode));
			if Label1 then
				Label1:setText(stAllWorldEvent[i].szState);
				Label1:setColor(color_lightgreen);
			end
		
			local Label2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent(""..indexLabel2, bgNode));
			if Label2 then
				local str = L("str9159");
				str = str..stAllWorldEvent[i].usNeedLevel;
				Label2:setText(str);
				
				if stAllWorldEvent[i].byType == 0 then
					Label2:setColor(color_red);
				else
					Label2:setColor(color_lightgreen);
				end
			end
			
			local Button = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent(""..indexButton, bgNode));
			if Button and btnimgPath1 and btnimgPath2 and btnimgPath3 and btnimgPath4 then
				Button:luaSetSelectorOnClicked(onEnterBtnClick);
				if stAllWorldEvent[i].byType == 0 then
					Button:setTitle(btnimgPath4:getData());
					Button:luaSetSelectorOnClicked(levelNoToEnter);
				elseif stAllWorldEvent[i].byType == 1 then
					Button:setBackgroundImage(btnimgPath1:getData());
					Button:setTitle(btnimgPath2:getData());
				elseif stAllWorldEvent[i].byType == 2 then
					Button:setTouchEnabled(false);
				elseif stAllWorldEvent[i].byType == 3 then
					Button:setTouchEnabled(false);
					Button:setTitle(btnimgPath3:getData());
				else
				    Button:setVisible(false);
				end
			end
		end
	end
end

----------------消息处理区----------------
function PopularActivities_recvWorldEvent(dt)
	if not dt then
		return
	end
	stAllWorldEvent = {};
	local byNum = dt:readByte();
	for i=1, byNum do
		table.insert(stAllWorldEvent, stWorldEvent.initWithStream(dt));
	end
	
	refreshWorldEventWnd();
end

----------------消息注册区----------------

----------------全局函数区----------------
--请求打开世界活动
function PopularActivities_sendOpenWorldEvent()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_OPEN_WORLD_EVENT)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show();	
end

function PopularActivities.wndClose()
	stAllWorldEvent = {};
	m_curIndex = nil;
end

--函数调用