RankInterface = {}    ----like namespace

----------------常量定义区----------------
local ACT_OPEN_RANK 	= 4
local ACT_QUERY_RANK_END  = 5
local ACT_QUERY_RANK  	= 1

local ACT_QUERY_RANK_EUD = 6       --//查看宠物榜
local ACT_SEND_RANK_EUD_BEGIN = 7  --//宠物榜下发开始 
local ACT_SEND_RANK_EUD_END = 8    --//宠物榜下发结束
local ACT_QUERY_RANK_ARMYGROUP = 9 --//查看军团榜
local ACT_SEND_RANK_ARMYGROUP_BEGIN = 10 --,//军团榜下发开始 
local ACT_SEND_RANK_ARMYGROUP_END = 11   --//军团榜下发结束
local ACT_SEND_RANK_WING = 12 --, //羽翼榜
local ACT_SEND_RANK_RECHARGE = 13--, //充值榜
local ACT_SEND_RANK_SPENDEMONEY = 14--,//消费排行榜
local ACT_SEND_RANK_CURRENCY8 = 15--, //荣誉排行榜

local PLAYER_WAR_RANK         = 1   --,//1战力总排行榜
local PLAYER_ARENA_RANK       = 2   --,//2=竞技场总排行榜
local PLAYER_HONOUR_RANK      = 7   --,//荣誉排行
local PLAYER_LEVEL_RANK		= 8   --,//等级排行
local PLAYER_TOTAL_MONEY      = 9   --,//财富排行榜
local EUDEMON_RANK_STRENGTH   = 100 --, //武将战力排行 
local ARMYGROUP_RANK_STRENGTH = 200 --, //军团排行 
----------------变量定义区----------------
local RankInfo = {}
local RankIntface = {}
local RankInfoScreen = {}
local RankIntforArmy = {}
local RankIntforGeneral = {}
local picture = nil
local times = nil
local titleLable = nil
local titleImage = nil
local ImgChilk = nil
local HonView = nil   --显示荣誉标志
local ListBox = nil
local LBox = nil
local RoleId = nil
local RoleName = nil
local m_bShield = {}
----------------结构定义区----------------
local SubRankInfo = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		self.nType = dt:readInt()
		self.count = dt:readInt()
		self.szname = {}
		self.szname[1] = " "
		self.szname[2] = " "
		self.szname[3] = " "
		for j = 1, self.count do
			local str = dt:readString()
			if str then
				self.szname[j] = str:getData()
			else
				self.szname[j] = " "
			end
		end
		return self
	end
}

local OpenRankInfo = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		
		self.count = dt:readInt()
		self.Rank_Info = {}
		for i = 1, self.count do
			table.insert(self.Rank_Info, SubRankInfo.initWithStream(dt))
		end
		return self
	end
}
---------------------单项排行表----------------------------
local stRankData = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		
		self.index = dt:readByte()
		self.idUser = dt:readInt()
		self.dwData = dt:readInt()
		self.ucLevel = dt:readShort()
		local str = dt:readString()
		self.szUserName = " "
		if str then
			self.szUserName = str:getData()
		else
			self.szUserName = " "
		end
		self.idPhoto = dt:readInt()
		self.ucType = dt:readByte()		
		return self
	end
}

local RankContent = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		self.userrank = dt:readInt()
		self.Type = dt:readByte()
		self.count = dt:readInt()
		self.currentsend = dt:readInt()
		self.stRankdata = {}
		for i = 1, self.currentsend do
			table.insert(self.stRankdata, stRankData.initWithStream(dt))
		end
		return self
	end
}
-----------------武将排行-----------------
local stEudRankData = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.ucIndex = dt:readByte()
        tmp.szEudName = dt:readString()
        if tmp.szEudName then
            tmp.szEudName = tmp.szEudName:getData()
        else
            tmp.szEudName = " "
        end
        tmp.szUserName = dt:readString()
        if tmp.szUserName then
            tmp.szUserName = tmp.szUserName:getData()
        else
            tmp.szUserName = " "
        end
        tmp.dwData = dt:readInt()      --//战力值 
        tmp.ucType = dt:readByte()     --//0 不变 1 上升 2下降 
        tmp.idEudemon = dt:readInt()
        tmp.idKeepPlayer = dt:readInt()
        return tmp
    end
}

local MSG_Info7 = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.nPos = dt:readInt()
        tmp.ucAmount = dt:readByte()
        tmp.stEudRankData = {}
        for i = 1,tmp.ucAmount do 
            table.insert(tmp.stEudRankData,stEudRankData.initWithStream(dt))
        end
        return tmp
    end
}

-----------------军团排行-----------------
local stArmyGroupRankData = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.ucIndex = dt:readByte()
        tmp.szArmyGroupName = dt:readString()
        if tmp.szArmyGroupName then
            tmp.szArmyGroupName = tmp.szArmyGroupName:getData()
        else
            tmp.szArmyGroupName = " "
        end
        tmp.szLeaderName = dt:readString()
        if tmp.szLeaderName then
            tmp.szLeaderName = tmp.szLeaderName:getData()
        else
            tmp.szLeaderName = " "
        end
        tmp.ucArmyGrouplev = dt:readInt() --//军团实力
        tmp.ucType = dt:readByte()     --//0 不变 1 上升 2下降 
        tmp.idTribe = dt:readInt()
        return tmp
    end
}

local MSG_Info8 = {
    initWithStream = function(dt)
        local tmp = {}
        if not dt then
            return tmp
        end
        tmp.nPos = dt:readInt()
        tmp.ucAmount = dt:readByte()
        tmp.stArmyGroupRankData = {}
        for i = 1,tmp.ucAmount do 
            table.insert(tmp.stArmyGroupRankData,stArmyGroupRankData.initWithStream(dt))
        end
        return tmp
    end
}
local function detailButtonAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_VIEW_SOCIATY_INFO2)--//查看公会信息
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_MEMBER_LIST2)--//查看公会成员
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end
--点击申请按钮
local function applyBtnAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_REQUEST_SOCIATY)--//申请公会
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end
-----------------回调函数-----------------
local function onClickMenuList(tag)
    if tag == 0 then
        applyBtnAction(RoleId)
    elseif tag == 1 then
        detailButtonAction(RoleId)
    end
end
local function start(tag, itemTag, itemIndex)	--选中信息
    LBox = ListBox:getChildByTag(itemIndex)
    ImgChilk = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("10023", LBox))
    if ImgChilk then
        ImgChilk:setImage(RES("img/new00225.png"));
    end
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("10024", LBox))
    if 100 == HonView then
        RoleId = RankIntforGeneral[pLabel:getText() + 0].idKeepPlayer
        RoleName = RankIntforGeneral[pLabel:getText() + 0].szUserName
    elseif 200 == HonView then
        RoleId = RankIntforArmy[pLabel:getText() + 0].idTribe
        RoleName = RankIntforArmy[pLabel:getText() + 0].szArmyGroupName
        
        
        local pmenuList = menuList:newStringList()
        if pmenuList then
            pmenuList:createMenu(RoleName, 2, _LTParser("str0238").."_".._LTParser("str6096"));
            pmenuList:luasetSelector(onClickMenuList);
        end
        return
    else
        RoleId = RankIntface.stRankdata[pLabel:getText() + 0].idUser
        RoleName = RankIntface.stRankdata[pLabel:getText() + 0].szUserName
    end
	RankInterface.dailWindow(RoleId, RoleName)
end

local function stop(tag, itemTag, itemIndex)	--停止选中信息
    ImgChilk:setImage(RES("img/new00224.png"));
end

local function OnSelectButton(tag)
	--local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("10024", LBox))	
    --RankIntface.stRankdata[pLabel:getText() + 0].idUser   获取玩家id
    if RoleName == nil then
        return;
    end
	if tag == 10101 then
	    ViewPlayInfo_sendData(RoleId, 0, "");      --查看资料
	elseif tag == 10102 then
	    BattleTeam5.onBtnInvite(RoleId)     --邀请组队
	elseif tag == 10103 then
	    gTalkTo(RoleName)  --发送私聊
	elseif tag == 10104 then
	    gAddFriend(RoleId, RoleName)     --加为好友
	elseif tag == 10105 then  --加为对手
	    showMessage(_LTParser("str6192"))
        return
	elseif tag == 10106 then
	    send_Dekaron(RoleId)  --发起挑战
	elseif tag == 10107 then --军团邀请
	    showMessage(_LTParser("str6192"))
        return
	elseif tag == 10108 then
	    --showMessage(L("str0444"))
		local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4404-10108"))
		if btn then
			local nfalg = nil
			for i = 1, #m_bShield do
				if m_bShield[i] == RoleName then
					nfalg = i
					break
				end
			end
			if nil == nfalg then
				btn:setTitle(L("str0104"), DEFAULT_FONT_NAME, F(13))
				table.insert(m_bShield, RoleName)
			else
				btn:setTitle(L("str0324"), DEFAULT_FONT_NAME, F(13))
				table.remove(m_bShield, nfalg)
			end
		end
	    ChatProcessor:getSingleton():setShield(RoleName, true)  --屏蔽发言
	end
end
----------------UI控制器区----------------
function RankInterface.initControl()		----打开排行榜ui界面
	local wnd = SCWindow:window()
	if wnd then
		wnd:setTag(4402)
		wnd:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		wnd:setPosition(AUTO_POS(-0.00, 0.00))
		wnd:setContentSize(AUTO_SIZE(480, 320))
		wnd:luaSetSelectorOnClose(RankInterface.releaseControl)
	end
	
	return wnd
end

function RankInterface.releaseControl()
	if RankInterface.wndCloss then
		RankInterface.wndCloss()
	end
end

--上一页
local function onScrollToPreviousPage(tag)
    if RankInterface_m_page == nil then
        return;
    end
	if RankInterface_m_pLabePage then
		RankInterface_m_pLabePage:setText("1/2");
	end

end

--下一页
local function onScrollToNextPage(tag)
    if RankInterface_m_page == nil then
        return;
    end
    
	if RankInterface_m_pLabePage then
		RankInterface_m_pLabePage:setText("2/2");
	end
end

--//左右按钮切换
local function onClickUpPage(tag)
    if not RankInterface_m_page then
        return
    end
    local index = RankInterface_m_page:getPageIndex();
    if index < 1 then
        return;
    end
    
    RankInterface_m_page:setOffset(CCPointMake((index - 1) * RankInterface_m_page:getWidth(), 0));

    if RankInterface_m_pLabePage then
        RankInterface_m_pLabePage:setText("1/2");
    end
end

local function onClickDownPage(tag)
    if not RankInterface_m_page then
        return
    end
   
    local index = RankInterface_m_page:getPageIndex();
    local count = RankInterface_m_page:getPageCount();
    if index > count - 2 then
        return;
    end
    RankInterface_m_page:setOffset(CCPointMake((index + 1) * RankInterface_m_page:getWidth(), 0));

    if RankInterface_m_pLabePage then
        RankInterface_m_pLabePage:setText("2/2");
    end   
end

local function screenData() --筛选数据
    for i = 1,7 do 
        if PLAYER_WAR_RANK == RankInfo.Rank_Info[i].nType then
            RankInfoScreen[1] = {}
            RankInfoScreen[1] = RankInfo.Rank_Info[i]
        elseif ARMYGROUP_RANK_STRENGTH == RankInfo.Rank_Info[i].nType then
            RankInfoScreen[2] = {}
            RankInfoScreen[2] = RankInfo.Rank_Info[i]
        elseif PLAYER_LEVEL_RANK == RankInfo.Rank_Info[i].nType then
            RankInfoScreen[3] = {}
            RankInfoScreen[3] = RankInfo.Rank_Info[i]
        elseif PLAYER_ARENA_RANK == RankInfo.Rank_Info[i].nType then
            RankInfoScreen[4] = {}
            RankInfoScreen[4] = RankInfo.Rank_Info[i]
        elseif PLAYER_TOTAL_MONEY == RankInfo.Rank_Info[i].nType then
            RankInfoScreen[5] = {}
            RankInfoScreen[5] = RankInfo.Rank_Info[i]
        elseif EUDEMON_RANK_STRENGTH == RankInfo.Rank_Info[i].nType then
            RankInfoScreen[6] = {}
            RankInfoScreen[6] = RankInfo.Rank_Info[i]
        elseif PLAYER_HONOUR_RANK == RankInfo.Rank_Info[i].nType then
            RankInfoScreen[7] = {}
            RankInfoScreen[7] = RankInfo.Rank_Info[i]
        end
    end
end

local function setRankInterWindow()
    local wnd = SCFunction:getUiNodeByIdlist("4402");
    if wnd == nil then
        return;
    end
    local imgPath = getRealUIResourcePath("img/new00232.png")
	--local tilImage = SCImage:imageWithFile(imgPath:getData())
	if  imgPath then
		wnd:setTitleWithImage(imgPath:getData())
	end
	screenData()
    RankInterface_m_page = SCPageScrollBox:boxWithWidthHeight(AUTO_W(460), AUTO_H(245))
	if RankInterface_m_page then
		RankInterface_m_page:setTag(1)
		tolua.cast(RankInterface_m_page, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(RankInterface_m_page, "SCNode"):setPosition(AUTO_POS(10.00, 30.00))
		wnd:addChild(RankInterface_m_page)
		RankInterface_m_page:setScrollVertical(false);
		RankInterface_m_page:luaSetSelectorOnScrollToPrevious(onScrollToPreviousPage)
		RankInterface_m_page:luaSetSelectorOnScrollToNext(onScrollToNextPage);
	end
	
	local width = RankInterface_m_page:getContentSize().width;
    local height = RankInterface_m_page:getContentSize().height;
	local pNode = nil;
	for i = 1,2 do
	    pNode = SCNode:node();
	    pNode:setPosition(CCPointMake(width * ( i - 1 ), 0));
		RankInterface_m_page:addChild(pNode);
		pNode:setTag(i);
		RankInterface_m_page:setContentSize(CCSizeMake(width * RankInterface_m_page:getPageCount(), height));
		if pNode and i == 1 then
		    for j = 1,4 do
		        local childNode = RankInterfaceNode.initControl()
		        if childNode then
		            childNode:setPosition(CCPointMake((j - 1) * SX(115), SY(0)));
		            pNode:addChild(childNode);				
				    childNode:setTag(j);
				    for k = 1,3 do
                        local nameLabel = SCTypeCast:castNodeToLabel(childNode:getChildByTag(k+6))
                        if nameLabel and RankInfoScreen[j] then
                            nameLabel:setText(RankInfoScreen[j].szname[k])
                        end
                    end
                    local imgPath = nil
                    local imgPathTitle = nil
                    local pBtn = SCTypeCast:castNodeToButton(childNode:getChildByTag(10))
                    if 1 == j and pBtn then
                        imgPath = getRealUIResourcePath("img/new00229.jp")
                        imgPathTitle = getRealUIResourcePath("img/new00230.png")
                        pBtn:luaSetSelectorOnClicked(RankInterface_sendPowData) --战力排行
                    elseif 2 == j and pBtn then
                        imgPath = getRealUIResourcePath("img/new00219.jp")
                        imgPathTitle = getRealUIResourcePath("rank/new00797.png")
                        pBtn:luaSetSelectorOnClicked(RankInterface_sendGroupData)  --军团排行
                    elseif 3 == j and pBtn then
                        imgPath = getRealUIResourcePath("img/new00216.jp")
                        imgPathTitle = getRealUIResourcePath("img/new00217.png")
                        pBtn:luaSetSelectorOnClicked(RankInterface_sendClsData)   --等级排行
                    elseif 4 == j and pBtn then
                        imgPath = getRealUIResourcePath("img/new00226.jp")
                        imgPathTitle = getRealUIResourcePath("img/new00220.png")
                        pBtn:luaSetSelectorOnClicked(RankInterface_sendConData)  --竞技排行
                    end
                    if imgPath and imgPathTitle then
                        local blackImg = SCTypeCast:castNodeToImage(childNode:getChildByTag(2))
                        local titleImg = SCTypeCast:castNodeToImage(childNode:getChildByTag(3))
                        if blackImg and titleImg then
                            blackImg:setImage(imgPath:getData())
                            titleImg:setImage(imgPathTitle:getData())
                        end
                    end
		        end
		    end
		end
		if pNode and i == 2 then
		    for j = 1,3 do
		        local childNode = RankInterfaceNode.initControl()
		        if childNode then
		            childNode:setPosition(CCPointMake((j - 1) * SX(115), SY(0)));
		            pNode:addChild(childNode);				
				    childNode:setTag(j);
				    
				    for k = 1,3 do
                        local nameLabel = SCTypeCast:castNodeToLabel(childNode:getChildByTag(k+6))
                        if nameLabel and RankInfoScreen[j+4] then
                            nameLabel:setText(RankInfoScreen[j+4].szname[k])
                        end
                    end
                    local imgPath = nil
                    local imgPathTitle = nil
                    local pBtn = SCTypeCast:castNodeToButton(childNode:getChildByTag(10))
                    if 1 == j and pBtn then
                        imgPath = getRealUIResourcePath("img/new00229.jp")
                        imgPathTitle = getRealUIResourcePath("rank/new00796.png")
                        pBtn:luaSetSelectorOnClicked(RankInterface_sendMoneyData) --富豪排行
                    elseif 2 == j and pBtn then
                        imgPath = getRealUIResourcePath("img/new00219.jp")
                        imgPathTitle = getRealUIResourcePath("rank/new00798.png")
                        pBtn:luaSetSelectorOnClicked(RankInterface_sendEudemonData)  --武将排行
                    elseif 3 == j and pBtn then
                        imgPath = getRealUIResourcePath("img/new00216.jp")
                        imgPathTitle = getRealUIResourcePath("img/new00227.png")
                        pBtn:luaSetSelectorOnClicked(RankInterface_sendHonData)   --荣誉排行
                    end
                    if imgPath and imgPathTitle then
                        local blackImg = SCTypeCast:castNodeToImage(childNode:getChildByTag(2))
                        local titleImg = SCTypeCast:castNodeToImage(childNode:getChildByTag(3))
                        if blackImg and titleImg then
                            blackImg:setImage(imgPath:getData())
                            titleImg:setImage(imgPathTitle:getData())
                        end
                    end
                    
		        end
		    end
		end
	end
	local imgPath = getRealUIResourcePath("img/new00253.png")
	local pImage23 = nil
	if imgPath then
		pImage23 = SCImage:imageWithFile(imgPath:getData())
		if pImage23 then
			pImage23:setAnchorPoint(CCPointMake(0.5, 0.5))
			pImage23:setPosition(AUTO_POS(240.00, 19.00))
			wnd:addChild(pImage23)
		end
	end
	RankInterface_m_pLabePage = SCLabel:labelWithStringFont(L("1/2"), DEFAULT_FONT_NAME, F(12))
	if RankInterface_m_pLabePage and pImage23 then
		RankInterface_m_pLabePage:setAnchorPoint(ANCHOR_CENTER)
		RankInterface_m_pLabePage:setPosition(CCPointMake(pImage23:getContentSize().width/2, SY(8)))
		RankInterface_m_pLabePage:setColor(ccc4(255,255,255,255))
		pImage23:addChild(RankInterface_m_pLabePage)
	end
	
	local pButton5 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton5 then
		pButton5:setTag(501)
		pButton5:setAnchorPoint(ANCHOR_CENTER)
		pButton5:setPosition(AUTO_POS(200.00, 20.00))
		pButton5:setContentSize(AUTO_SIZE(30, 30))
		local imgPath = getRealUIResourcePath("img/new00048.png")
		if imgPath then
			pButton5:setTitle(imgPath:getData())
		end
		wnd:addChild(pButton5)
		pButton5:luaSetSelectorOnClicked(onClickUpPage)
	end

	local pButton4 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton4 then
		pButton4:setTag(502)
		pButton4:setAnchorPoint(ANCHOR_CENTER)
		pButton4:setPosition(AUTO_POS(280.00, 20.00))
		pButton4:setContentSize(AUTO_SIZE(30, 30))
		local imgPath = getRealUIResourcePath("img/new00047.png")
		if imgPath then
			pButton4:setTitle(imgPath:getData())
		end
		wnd:addChild(pButton4)
		pButton4:luaSetSelectorOnClicked(onClickDownPage)
	end

end



local function showRankInterWin(tag, type)
    if type == LuaControllerEventPushEnded then
        setRankInterWindow();
    end
end

----------------------单个排行榜ui界面--------------------------------------
function RankInterface.initstControl()
	local wnd = SCWindow:window()
	if wnd then
		wnd:setTag(4403)
		wnd:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		wnd:setPosition(AUTO_POS(-0.00, 0.00))
		wnd:setContentSize(AUTO_SIZE(480, 320))
		wnd:luaSetSelectorOnClose(RankInterface.releasestControl)
	end

	local imgPath = getRealUIResourcePath("img/new00232.png")
	--local titlepImage = SCImage:imageWithFile(imgPath:getData())
	if  imgPath then
		wnd:setTitleWithImage(imgPath:getData())
	end
	
	return wnd
end

local function setinitstWindow()
    local wnd = SCFunction:getUiNodeByIdlist("4403");
    if wnd == nil then
        return;
    end
    local fatherDragNode = SCDragNode:node()
	if fatherDragNode then
		fatherDragNode:setTag(10002)
		fatherDragNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		fatherDragNode:setPosition(AUTO_POS(14.00, 9.00))
		fatherDragNode:setContentSize(AUTO_SIZE(452, 252))
		fatherDragNode:setFrameVisibled(true)
		fatherDragNode:setDragEnabled(false)
		fatherDragNode:setFrameType(EnumFrameTypeRound)
	end
    
    --战力刷新时间提示
    local labelTip = SCLabel:labelWithStringFont(L("str0519"),getDefaultFontName(), F(11))
    if labelTip then
        labelTip:setPosition(AUTO_POS(305, 262))
        labelTip:setColor(color_green)
        wnd:addChild(labelTip)
    end
    local imgPath = nil;
	if RankIntface.Type == 1 then
		imgPath = getRealUIResourcePath("img/new00230.png")
		--titleLable = SCLabel:labelWithStringFont(L("str0312"), DEFAULT_FONT_NAME, F(13))
	elseif RankIntface.Type == 2 then
		imgPath = getRealUIResourcePath("img/new00220.png")
		--titleLable = SCLabel:labelWithStringFont(L("str0309"), DEFAULT_FONT_NAME, F(13))
	elseif RankIntface.Type == 7 then
		imgPath = getRealUIResourcePath("img/new00227.png")
		--titleLable = SCLabel:labelWithStringFont(L("str0311"), DEFAULT_FONT_NAME, F(13))
	elseif RankIntface.Type == 8 then
		imgPath = getRealUIResourcePath("img/new00217.png")
		--titleLable = SCLabel:labelWithStringFont(L("str0310"), DEFAULT_FONT_NAME, F(13))
    elseif RankIntface.Type == 9 then
        imgPath = getRealUIResourcePath("rank/new00796.png")
	end
	if HonView == 200 then
	    imgPath = getRealUIResourcePath("rank/new00797.png")
	elseif HonView == 100 then
	    imgPath = getRealUIResourcePath("rank/new00798.png")
	end 
	
	if imgPath then
	    titleImage = SCImage:imageWithFile(imgPath:getData())
	end
	
	if titleImage and imgPath then
        titleImage:setTag(10003)
        titleImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        titleImage:setPosition(AUTO_POS(187.00, 254.50))
        titleImage:setContentSize(AUTO_SIZE(106, 30))
     end

	--[[if titleLable then
        titleLable:setTag(10012)
        titleLable:setColor(ccc4(65, 207, 17, 255))
        titleLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        titleLable:setPosition(AUTO_POS(175.00, 292.00))
    end--]]

	local plaLable = SCLabel:labelWithStringFont(L("str0304"), DEFAULT_FONT_NAME, F(13))
	if plaLable then
		plaLable:setTag(10007)
		plaLable:setColor(ccc4(223, 204, 48, 255))
		plaLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		plaLable:setPosition(AUTO_POS(35.00, 215.0))
	end

	local nameLable = SCLabel:labelWithStringFont(L("str0305"), DEFAULT_FONT_NAME, F(13))
	if nameLable then
		nameLable:setTag(10008)
		nameLable:setColor(ccc4(223, 204, 48, 255))
		nameLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		nameLable:setPosition(AUTO_POS(105.00, 215.0))
		if HonView == 200 then
		    nameLable:setText(L("str8085"));
		end
	end

	local clsLable = SCLabel:labelWithStringFont(L("str0306"), DEFAULT_FONT_NAME, F(13))
	if clsLable then
		clsLable:setTag(10009)
		clsLable:setColor(ccc4(223, 204, 48, 255))
		clsLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		clsLable:setPosition(AUTO_POS(240.00, 215.0))
		if HonView == 100 then
		    clsLable:setText(L("str5096"));
		elseif 200 == HonView then
		    clsLable:setText(L("str6075"));
		    clsLable:setPosition(AUTO_POS(220.00, 215.0))
		end
	end
    

	local powLable = SCLabel:labelWithStringFont(L("str0307"), DEFAULT_FONT_NAME, F(13))
	if powLable then
		powLable:setTag(10010)
		powLable:setColor(ccc4(223, 204, 48, 255))
		powLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		powLable:setPosition(AUTO_POS(315.00, 215.0))
		if HonView == 7 then
		    powLable:setText(L("str0340"));
		elseif 9 == HonView then
		    powLable:setText(L("str6012"));
		elseif 200 == HonView then
		    powLable:setText(L("str3168"));
		end
		
	end

	local rankLable = SCLabel:labelWithStringFont(L("str0308"), DEFAULT_FONT_NAME, F(13))
	if rankLable then
		rankLable:setTag(10011)
		rankLable:setColor(ccc4(223, 204, 48, 255))
		rankLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		rankLable:setPosition(AUTO_POS(390.00, 214.0))
	end
    
    local NumLable = nil
    local UsLable = nil
    if RankIntface.userrank == 0 then
        NumLable = SCLabel:labelWithStringFont(L("str0316"), DEFAULT_FONT_NAME, F(10))
        if NumLable then
            NumLable:setTag(10091)
            NumLable:setColor(ccc4(223, 204, 48, 255))
            NumLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            NumLable:setPosition(AUTO_POS(230.00, 19.00))
        end
        if HonView == 200 then
            local idTribe = Hero:getSingleton():getIdTribe()
            if idTribe == 0 then
                NumLable:setText(L("str3165"))
            else
                NumLable:setText(L("str3166"))
            end
        end
    else
        UsLable = SCLabel:labelWithStringFont(L("str0313")..RankIntface.userrank, DEFAULT_FONT_NAME, F(10))
        if UsLable then
            UsLable:setTag(10090)
            UsLable:setColor(ccc4(223, 204, 48, 255))
            UsLable:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            UsLable:setPosition(AUTO_POS(373.00, 19.00))
        end
        if HonView == 200 then
            local str = L("str3167")..RankIntface.userrank
            UsLable:setText(str)
        end
    end
	
	ListBox = SCListBox:boxWithWidthHeight(AUTO_W(435), AUTO_H(187))
	if ListBox then
		ListBox:luaSetSelectorOnItemSelected(start)
	    ListBox:luaSetSelectorOnItemUnSelected(stop);
		ListBox:setTag(10012)
		ListBox:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ListBox:setPosition(AUTO_POS(11.00, 22.00))
	end
	
	local imgPath = getRealUIResourcePath("img/new00218.png")
    local columnImage = SCImage:imageWithFile(imgPath:getData())
    if columnImage and imgPath then
        columnImage:setTag(10022)
        columnImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        columnImage:setPosition(AUTO_POS(14.50, 210.00))
        columnImage:setContentSize(AUTO_SIZE(420, 2))
    end
	
	---------------------------循环取数据-----------------------------
	for k = 1 , RankIntface.count do	
        local pDragNode10021 = SCDragNode:node()
        if pDragNode10021 then
            pDragNode10021:setTag(10021)
            pDragNode10021:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10021:setPosition(AUTO_POS(11.50, 168.50))
            pDragNode10021:setContentSize(AUTO_SIZE(424, 27))
            pDragNode10021:setFrameVisibled(true)
            pDragNode10021:setDragEnabled(false)
            pDragNode10021:setFrameType(EnumFrameTypeNone)
        end

        local imgPath = getRealUIResourcePath("img/new00224.png")
        local pImage10023 = SCImage:imageWithFile(imgPath:getData())
        if pImage10023 and imgPath then
            pImage10023:setTag(10023)
            pImage10023:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage10023:setPosition(AUTO_POS(7.00, 2.00))
            pImage10023:setContentSize(AUTO_SIZE(410, 24))
        end
        local str1 = nil
        local str2 = nil 
        local str3 = nil 
        local str4 = nil
        local picture = nil
        if HonView == 100 then
		    if RankIntforGeneral[k] then
		        str1 = RankIntforGeneral[k].ucIndex
		        if not str1 then
		            str1 = " "
		        end
		        str2 = RankIntforGeneral[k].szUserName
		        if not str2 then
		            str2 = " "
		        end
		        str3 = RankIntforGeneral[k].szEudName
		        if not str3 then
		            str3 = " "
		        end
		        str4 = RankIntforGeneral[k].dwData
		        if not str4 then
		            str4 = " "
		        end
		    end
		    if RankIntforGeneral[k] then
                if RankIntforGeneral[k].ucType == 0 then
                    local imgPath = getRealUIResourcePath("img/new00221.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                elseif RankIntforGeneral[k].ucType == 1 then
                    local imgPath = getRealUIResourcePath("img/new00223.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                elseif RankIntforGeneral[k].ucType == 2 then
                    local imgPath = getRealUIResourcePath("img/new00222.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                end
            end
		elseif 200 == HonView then
		    if RankIntforArmy[k] then
		        str1 = RankIntforArmy[k].ucIndex
		        if not str1 then
		            str1 = " "
		        end
		        str2 = RankIntforArmy[k].szArmyGroupName
		        if not str2 then
		            str2 = " "
		        end
		        str3 = RankIntforArmy[k].szLeaderName
		        if not str3 then
		            str3 = " "
		        end
		        str4 = RankIntforArmy[k].ucArmyGrouplev
		        if not str4 then
		            str4 = " "
		        end
		    end
		    if RankIntforArmy[k] then
                if RankIntforArmy[k].ucType == 0 then
                    local imgPath = getRealUIResourcePath("img/new00221.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                elseif RankIntforArmy[k].ucType == 1 then
                    local imgPath = getRealUIResourcePath("img/new00223.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                elseif RankIntforArmy[k].ucType == 2 then
                    local imgPath = getRealUIResourcePath("img/new00222.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                end
            end
		else
		    if RankIntface.stRankdata[k] then
		        str1 = RankIntface.stRankdata[k].index
		        if not str1 then
		            str1 = " "
		        end
		        str2 = RankIntface.stRankdata[k].szUserName
		        if not str2 then
		            str2 = " "
		        end
		        str3 = RankIntface.stRankdata[k].ucLevel
		        if not str3 then
		            str3 = " "
		        end
		        str4 = RankIntface.stRankdata[k].dwData
		        if not str4 then
		            str4 = " "
		        end
		    end
		    if RankIntface.stRankdata and RankIntface.stRankdata[k] then
                if RankIntface.stRankdata[k].ucType == 0 then
                    local imgPath = getRealUIResourcePath("img/new00221.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                elseif RankIntface.stRankdata[k].ucType == 1 then
                    local imgPath = getRealUIResourcePath("img/new00223.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                elseif RankIntface.stRankdata[k].ucType == 2 then
                    local imgPath = getRealUIResourcePath("img/new00222.png")
                    if imgPath then
                        picture = SCImage:imageWithFile(imgPath:getData())
                    end
                end
            end
		end
        local pLable10024 = SCLabel:labelWithStringFont(str1, DEFAULT_FONT_NAME, F(13))
        if pLable10024 then
            pLable10024:setTag(10024)
            pLable10024:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pLable10024:setPosition(AUTO_POS(38.00, 6.00))
        end
        
        local pLable10025 = SCLabel:labelWithStringFont(str2, DEFAULT_FONT_NAME, F(13))
        if pLable10025 then
            pLable10025:setTag(10025)
            pLable10025:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pLable10025:setPosition(AUTO_POS(96.00, 6.00))
        end
        
        local pLable10026 = SCLabel:labelWithStringFont(str3, DEFAULT_FONT_NAME, F(13))
        if pLable10026 then
            pLable10026:setTag(10026)
            pLable10026:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pLable10026:setPosition(AUTO_POS(233.00, 6.00))
            if HonView == 200 then
                pLable10026:setPosition(AUTO_POS(210.00, 6.00))
            end
        end
        
        local pLable10027 = SCLabel:labelWithStringFont(str4, DEFAULT_FONT_NAME, F(13))
        if pLable10027 then
            pLable10027:setTag(10027)
            pLable10027:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pLable10027:setPosition(AUTO_POS(303.00, 6.00))
        end
        
        
        
		if picture then
            picture:setTag(10030)
            picture:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            picture:setPosition(AUTO_POS(377.00, 6.00))
            picture:setContentSize(AUTO_SIZE(30, 18))
        end
      
        if pImage10023 and pDragNode10021 then
            pDragNode10021:addChild(tolua.cast(pImage10023, "SCNode"))
        end
        if pLable10024 and pDragNode10021 then
            pDragNode10021:addChild(tolua.cast(pLable10024, "SCNode"))
        end
        if pLable10025 and pDragNode10021 then
            pDragNode10021:addChild(tolua.cast(pLable10025, "SCNode"))
        end
        if pLable10026 and pDragNode10021 then
            pDragNode10021:addChild(tolua.cast(pLable10026, "SCNode"))
        end
        if pLable10027 and pDragNode10021 then
            pDragNode10021:addChild(tolua.cast(pLable10027, "SCNode"))
        end
        if picture and pDragNode10021 then
            pDragNode10021:addChild(tolua.cast(picture, "SCNode"))
        end
        if pDragNode10021 and ListBox then
            ListBox:addItem(pDragNode10021)
        end
    end

	if fatherDragNode and wnd then
		wnd:addChild(tolua.cast(fatherDragNode, "SCNode"))
	end
	if clsImage and wnd then
		wnd:addChild(tolua.cast(clsImage, "SCNode"))
	end
	if plaLable and fatherDragNode then
		fatherDragNode:addChild(tolua.cast(plaLable, "SCNode"))
	end
	if nameLable and fatherDragNode then
		fatherDragNode:addChild(tolua.cast(nameLable, "SCNode"))
	end
	if clsLable and fatherDragNode then
		fatherDragNode:addChild(tolua.cast(clsLable, "SCNode"))
	end
	if powLable and fatherDragNode then
		fatherDragNode:addChild(tolua.cast(powLable, "SCNode"))
	end
	if rankLable and fatherDragNode then
		fatherDragNode:addChild(tolua.cast(rankLable, "SCNode"))
	end
	if titleLable and wnd then
		wnd:addChild(tolua.cast(titleLable, "SCNode"))
	end
	if ListBox and fatherDragNode then
		fatherDragNode:addChild(tolua.cast(ListBox, "SCNode"))
	end
	if titleImage and wnd then
		wnd:addChild(tolua.cast(titleImage, "SCNode"))
	end
	if titlepImage and wnd then
		wnd:addChild(tolua.cast(titlepImage, "SCNode"))
	end
    if columnImage and fatherDragNode then
        fatherDragNode:addChild(tolua.cast(columnImage, "SCNode"))
    end
    if NumLable and wnd then
        wnd:addChild(tolua.cast(NumLable, "SCNode"))
    end
    if UsLable and wnd then
        wnd:addChild(tolua.cast(UsLable, "SCNode"))
    end
end

local function showinitstWin(tag, type)
    if type == LuaControllerEventPushEnded then
        setinitstWindow();
    end
end

function RankInterface.releasestControl()
	if RankInterface.wndstCloss then
		RankInterface.wndstCloss()
	end
end
----------------------个人信息对话框---------------------------
function RankInterface.initWinControl(name)
	local pWindow10000 = SCWindow:window()
	if pWindow10000 then
		pWindow10000:setTag(4404)
		pWindow10000:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow10000:setPosition(AUTO_POS(138.00, 69.50))
		pWindow10000:setContentSize(AUTO_SIZE(221, 193))
		pWindow10000:setAutoCloseOnTouchSpace(true)
		pWindow10000:setCloseButtonVisibled(true)
		pWindow10000:setFrameVisibled(true)
		pWindow10000:luaSetSelectorOnClose(RankInterface.releaseWinControl)
	end

	local pButton10001 = SCButton:button(EnumBtnType9Atlas)       --查看资料
	if pButton10001 then
		pButton10001:setTag(10101)
		pButton10001:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10001:setPosition(AUTO_POS(12.00, 111.00))
		pButton10001:setContentSize(AUTO_SIZE(90, 30))
		pButton10001:setTitle(L("str0317"), DEFAULT_FONT_NAME, F(13))
		pButton10001:luaSetSelectorOnClicked(OnSelectButton);
	end

	local pButton10002 = SCButton:button(EnumBtnType9Atlas)   --邀请组队
	if pButton10002 then
		pButton10002:setTag(10102)
		pButton10002:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10002:setPosition(AUTO_POS(117.00, 111.00))
		pButton10002:setContentSize(AUTO_SIZE(90, 30))
		pButton10002:setTitle(L("str0318"), DEFAULT_FONT_NAME, F(13))
		pButton10002:luaSetSelectorOnClicked(OnSelectButton);
	end

	local pButton10003 = SCButton:button(EnumBtnType9Atlas)     --发送私聊
	if pButton10003 then
		pButton10003:setTag(10103)
		pButton10003:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10003:setPosition(AUTO_POS(12.00, 77.00))
		pButton10003:setContentSize(AUTO_SIZE(90, 30))
		pButton10003:setTitle(L("str0319"), DEFAULT_FONT_NAME, F(13))
		pButton10003:luaSetSelectorOnClicked(OnSelectButton);
	end

	local pButton10004 = SCButton:button(EnumBtnType9Atlas)         --加为好友
	if pButton10004 then
		pButton10004:setTag(10104)
		pButton10004:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10004:setPosition(AUTO_POS(117.00, 77.00))
		pButton10004:setContentSize(AUTO_SIZE(90, 30))
		pButton10004:setTitle(L("str0320"), DEFAULT_FONT_NAME, F(13))
		pButton10004:luaSetSelectorOnClicked(OnSelectButton);
	end

	local pButton10005 = SCButton:button(EnumBtnType9Atlas)         --加为对手
	if pButton10005 then
		pButton10005:setTag(10105)
		pButton10005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10005:setPosition(AUTO_POS(12.00, 43.00))
		pButton10005:setContentSize(AUTO_SIZE(90, 30))
		pButton10005:setTitle(L("str0321"), DEFAULT_FONT_NAME, F(13))
		pButton10005:luaSetSelectorOnClicked(OnSelectButton);
	end

	local pButton10006 = SCButton:button(EnumBtnType9Atlas)     --发起挑战
	if pButton10006 then
		pButton10006:setTag(10106)
		pButton10006:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10006:setPosition(AUTO_POS(117.00, 43.00))
		pButton10006:setContentSize(AUTO_SIZE(90, 30))
		pButton10006:setTitle(L("str0322"), DEFAULT_FONT_NAME, F(13))
		pButton10006:luaSetSelectorOnClicked(OnSelectButton);
	end

	local pButton10007 = SCButton:button(EnumBtnType9Atlas)     --军团邀请
	if pButton10007 then
		pButton10007:setTag(10107)
		pButton10007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10007:setPosition(AUTO_POS(12.00, 9.00))
		pButton10007:setContentSize(AUTO_SIZE(90, 30))
		pButton10007:setTitle(L("str0323"), DEFAULT_FONT_NAME, F(13))
		pButton10007:luaSetSelectorOnClicked(OnSelectButton);
	end

	local pButton10008 = SCButton:button(EnumBtnType9Atlas)     --屏蔽发言
	if pButton10008 then
		pButton10008:setTag(10108)
		pButton10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10008:setPosition(AUTO_POS(117.00, 9.00))
		pButton10008:setContentSize(AUTO_SIZE(90, 30))
		--pButton10008:setTitle(L("str0324"), DEFAULT_FONT_NAME, F(13))
		local nfalg = nil
		for i = 1, #m_bShield do
			if m_bShield[i] == RoleName then
				nfalg = i
				break
			end
		end
		if nil == nfalg then
			pButton10008:setTitle(L("str0324"), DEFAULT_FONT_NAME, F(13))
		else
			pButton10008:setTitle(L("str0104"), DEFAULT_FONT_NAME, F(13))
		end
		pButton10008:luaSetSelectorOnClicked(OnSelectButton);
	end
	
	local NameLabel = SCLabel:labelWithStringFont(name, DEFAULT_FONT_NAME, F(13))
	local windowWidth = pWindow10000:getContentSize().width/2
	if NameLabel then
		NameLabel:setTag(10109)
		NameLabel:setColor(ccc4(223, 204, 48, 255))
		NameLabel:setAnchorPoint(CCPointMake(0.5, 0.5))
		NameLabel:setPosition(CCPointMake(windowWidth, SY(167)))
	end

	if pButton10001 and pWindow10000 then
		pWindow10000:addChild(tolua.cast(pButton10001, "SCNode"))
	end
	if pButton10002 and pWindow10000 then
		pWindow10000:addChild(tolua.cast(pButton10002, "SCNode"))
	end
	if pButton10003 and pWindow10000 then
		pWindow10000:addChild(tolua.cast(pButton10003, "SCNode"))
	end
	if pButton10004 and pWindow10000 then
		pWindow10000:addChild(tolua.cast(pButton10004, "SCNode"))
	end
	if pButton10005 and pWindow10000 then
		pWindow10000:addChild(tolua.cast(pButton10005, "SCNode"))
	end
	if pButton10006 and pWindow10000 then
		pWindow10000:addChild(tolua.cast(pButton10006, "SCNode"))
	end
	if pButton10007 and pWindow10000 then
		pWindow10000:addChild(tolua.cast(pButton10007, "SCNode"))
	end
	if pButton10008 and pWindow10000 then
		pWindow10000:addChild(tolua.cast(pButton10008, "SCNode"))
	end
	if NameLabel and pWindow10000 then
		pWindow10000:addChild(tolua.cast(NameLabel, "SCNode"))
	end
	return pWindow10000
end

function RankInterface.releaseWinControl()
	if RankInterface.wndDailCloss then
		RankInterface.wndDailCloss()
	end
end
----------------逻辑功能区----------------
function RankInt_sendData()   
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    if dataStream then                   ----消息发送提示
        dataStream:writeByte(ACT_OPEN_RANK)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end

function RankInterface_sendConData() --竞技场排行
    --POP_TOP_CTRL()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    if dataStream then                   ----消息发送提示
        dataStream:writeByte(ACT_QUERY_RANK)
		dataStream:writeByte(2)
		dataStream:writeByte(1)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end

function RankInterface_sendClsData()  --等级排行
    --POP_TOP_CTRL()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    if dataStream then                   ----消息发送提示
        dataStream:writeByte(ACT_QUERY_RANK)
		dataStream:writeByte(8)
		dataStream:writeByte(2)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end

function RankInterface_sendHonData()  --荣誉排行
    --POP_TOP_CTRL()
    HonView = 7;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    if dataStream then                   ----消息发送提示
        dataStream:writeByte(ACT_QUERY_RANK)
		dataStream:writeByte(7)
		dataStream:writeByte(3)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end

function RankInterface_sendPowData(mark) --战力排行
    if mark == nil then
        POP_TOP_CTRL()  
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    if dataStream then                   ----消息发送提示
        dataStream:writeByte(ACT_QUERY_RANK)
		dataStream:writeByte(1)
		dataStream:writeByte(4)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end

function RankInterface_sendMoneyData()  --富豪排行
    --POP_TOP_CTRL()
    HonView = 9;
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    if dataStream then                   ----消息发送提示
        dataStream:writeByte(ACT_QUERY_RANK)
		dataStream:writeByte(PLAYER_TOTAL_MONEY)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end
function RankInterface_sendGroupData()  --军团排行
    --POP_TOP_CTRL()
    HonView = 200;
    RankIntface.count = 0
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    if dataStream then                   ----消息发送提示
        dataStream:writeByte(ACT_QUERY_RANK_ARMYGROUP)
		dataStream:writeByte(ARMYGROUP_RANK_STRENGTH)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end
function RankInterface_sendEudemonData()  --武将排行
    --POP_TOP_CTRL()
    HonView = 100;
    RankIntface.count = 0
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_RANK);
    if dataStream then                   ----消息发送提示
        dataStream:writeByte(ACT_QUERY_RANK_EUD)
		dataStream:writeByte(EUDEMON_RANK_STRENGTH)
        SCDataTransThread:getSingleton():transData(dataStream)
        showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
        SCActivityIndicator:getSingleton():show();
    end
end
----------------消息处理区----------------
function RankInterface_recvData()
	local dt = SCMessageCenter:getSingleton():getDataTransStream();  ---获取当前的数据对象
	if not dt then
	    return
	end
	SCActivityIndicator:getSingleton():close()
	local action = dt:readByte()
	if dt and action == ACT_OPEN_RANK then
        RankInfo = OpenRankInfo.initWithStream(dt)
        RankInterface.Window()
	elseif dt and action == ACT_QUERY_RANK then
	    if times == nil then
		    RankIntface = RankContent.initWithStream(dt)
		    times = 1
		else
		    dt:readInt()
		    dt:readByte()
		    dt:readInt()
		    local currentsend = dt:readInt()
		    for i = 1, currentsend do
                table.insert(RankIntface.stRankdata, stRankData.initWithStream(dt))
            end
		end
	elseif dt and action == ACT_QUERY_RANK_END then
	    RankInterface.stWindow()
	elseif ACT_SEND_RANK_EUD_BEGIN ==  action then
		RankIntface.userrank = dt:readInt()
	    local currentsend = dt:readByte()
	    RankIntface.count = currentsend + RankIntface.count
		for i = 1, currentsend do
            table.insert(RankIntforGeneral, stEudRankData.initWithStream(dt))
        end
	elseif ACT_SEND_RANK_EUD_END ==  action then
	    RankIntface.userrank = dt:readInt()
	    local currentsend = dt:readByte()
	    RankIntface.count = currentsend + RankIntface.count
		for i = 1, currentsend do
            table.insert(RankIntforGeneral, stEudRankData.initWithStream(dt))
        end
	    RankInterface.stWindow()
	elseif ACT_SEND_RANK_ARMYGROUP_BEGIN == action then
	    RankIntface.userrank = dt:readInt()
	    local currentsend = dt:readByte()
	    RankIntface.count = currentsend + RankIntface.count
		for i = 1, currentsend do
            table.insert(RankIntforArmy, stArmyGroupRankData.initWithStream(dt))
        end
	elseif ACT_SEND_RANK_ARMYGROUP_END == action then
	    RankIntface.userrank = dt:readInt()
	    local currentsend = dt:readByte()
	    RankIntface.count = currentsend + RankIntface.count
		for i = 1, currentsend do
            table.insert(RankIntforArmy, stArmyGroupRankData.initWithStream(dt))
        end
	    RankInterface.stWindow()
	elseif ACT_SEND_RANK_WING == action then
		ActivityAll_recvRankWingData(dt)
	elseif ACT_SEND_RANK_RECHARGE == action or ACT_SEND_RANK_SPENDEMONEY == action or ACT_SEND_RANK_CURRENCY8 == action then
		ActivityAll_recvRankRechargeData(dt, action)
    end
end
----------------消息注册区----------------
SCMessageCenter:getSingleton():luaRegistCommand(RankInterface_recvData, _MSG_RANK, 0, nil);
----------------全局函数区----------------
function RankInterface.Window()
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4402);
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
	else
		wnd = RankInterface.initControl()
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd)
			local naviCtrl = getCurentSceneNavigationController()
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl)
				wndCtrl:luaSetSelectorOnEvent(showRankInterWin);
			end
		 end
	end
end

function RankInterface.wndCloss()
	RankInfo = {}
     RankInfo = {}
     RankIntface = {}
     RankInfoScreen = {}
     RankIntforArmy = {}
     RankIntforGeneral = {}
     picture = nil
     times = nil
     titleLable = nil
     titleImage = nil
     ImgChilk = nil
     HonView = nil   --显示荣誉标志
     ListBox = nil
     LBox = nil
     RoleId = nil
     RoleName = nil
	 --m_bShield = nil
end

function RankInterface.stWindow()
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4403);
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
	else
		wnd = RankInterface.initstControl()
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd)
			local naviCtrl = getCurentSceneNavigationController()
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl)
				wndCtrl:luaSetSelectorOnEvent(showinitstWin);
			end
		end
	end
end

function RankInterface.wndstCloss()
	RankIntface = {}
	picture = nil
	times = nil
	titleLable = nil
	titleImage = nil
	ImgChilk = nil
	ListBox = nil
	LBox = nil
	HonView = nil

end

function RankInterface.dailWindow(id, name)
    RoleId = id;
	RoleName = name;
	if Hero:getSingleton():getID() == id then
	    showMessage(L("str0518"));
	    return;
	end
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4404);
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
	else
		wnd = RankInterface.initWinControl(RoleName)
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd)
			local naviCtrl = getCurentSceneNavigationController()
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl)
			end
		end
	end
end

function RankInterface.wndDailCloss()
	RoleId = nil
	RoleName = nil
end

--函数调用