--8015 公会创建
local m_mainLayer = nil 
local m_money = nil

function removeAllData_SocietyCreateLayer()
    m_mainLayer = nil
    m_money = nil
end

local function okCreateButtonAction()
    if m_mainLayer == nil then
        return
    end
    local nameEdit = m_mainLayer:getChildByTag(801501)
    local nameStr = nil 
    if nameEdit then--发送者名称
        nameEdit = SCTypeCast:castNodeToEdit(nameEdit)
        nameStr = nameEdit:getContentText()
        if nameStr == nil or nameStr == "" or DelS(nameStr) == "" then
            showMessage(_LTParser("str8098"),3)
            return
        end
    end
    local money = Hero:getSingleton():getMoney()
    if money < 5000000 then
        GuidePoint_shopBuyTip()
        return;
    end
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_CREATE_SOCIATY_OK);--//创建公会
    dt:writeByte(0)
    dt:writeInt(0)
    dt:writeString(SCString:stringWithString(nameStr))
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

local function cancelCreateButtonAction()
    closeWindowById(8012)
end


local function sendQueryCreateInfo()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_CREATE_SOCIATY_INFO);--//创建公会条件
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

function open_SocietyCreateScreen(fatherLayer)
    if fatherLayer == nil then
        return
    end
    if m_mainLayer then
        return
    end
    m_mainLayer = fatherLayer
    m_mainLayer:removeAllChildrenWithCleanup(true)  
    
    sendQueryCreateInfo()
                
    local width = m_mainLayer:getContentSize().width
    local height = m_mainLayer:getContentSize().height
    
    local titleLabel = SCLabel:labelWithStringFont("".._LTParser("str8098"),getDefaultFontName(), getFontSize(14))
    titleLabel:setAnchorPoint(CCPointMake(0.5,0));
    titleLabel:setPosition(CCPointMake(width/2,height*0.8));
    m_mainLayer:addChild(titleLabel)

    local editWidth = width*0.45
    local editHeight = SY(30)
    local editStartY = height*0.7
    
    local editBgLayer = SCDragNode:node()
	editBgLayer:setFrameVisibled(true)
	editBgLayer:setFrameType(EnumFrameTypeRound)
    editBgLayer:setAnchorPoint(CCPointMake(0.5,0.5));
    editBgLayer:setPosition(CCPointMake(width/2,editStartY));
	editBgLayer:setContentSize(CCSizeMake(editWidth,editHeight))
	m_mainLayer:addChild(editBgLayer)
	local titleEditLabel = SCEdit:edit()
	titleEditLabel:setTag(801501)
	titleEditLabel:setContentSize(CCSizeMake(editWidth*0.98,editHeight*0.95))
	titleEditLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    titleEditLabel:setPosition(CCPointMake(width/2,editStartY));
    titleEditLabel:setBottomColor(getColorWhite())
    titleEditLabel:setFontColor(getColorBlack())
    titleEditLabel:setMaxCharCount(10)
    m_mainLayer:addChild(titleEditLabel)
    
    local moneyStr = string.format(_LTParser("str8099"),"0")
    local moneyDetailLabel = SCLabel:labelWithStringFont(moneyStr,getDefaultFontName(), getFontSize(14))
    moneyDetailLabel:setTag(801502)
    moneyDetailLabel:setAnchorPoint(CCPointMake(0.5,0));
    moneyDetailLabel:setPosition(CCPointMake(width/2,height*0.56));
    m_mainLayer:addChild(moneyDetailLabel)
    
    local detailLabel = SCLabel:labelWithStringFont(_LTParser("str8100"),getDefaultFontName(), getFontSize(14))
    detailLabel:setAnchorPoint(CCPointMake(0.5,0));
    detailLabel:setPosition(CCPointMake(width/2,height*0.49));
    m_mainLayer:addChild(detailLabel)
    
    local bottomBtnY = SY(40)
    --确定创建
    local createButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(createButton, BigButton_Size)
    local imgPath = getRealUIResourcePath("img/new00368.png")
    if imgPath then
        createButton:setTitle(imgPath:getData());
    end
    createButton:setAnchorPoint(CCPointMake(0.5,0.5));
    createButton:setPosition(CCPointMake(width*0.3,bottomBtnY));
    createButton:luaSetSelectorOnClicked(okCreateButtonAction)
    local money = Hero:getSingleton():getMoney()
    if money < 5000000 then
        createButton:setButtonType(EnumBtnTypeAsh)
    end
    m_mainLayer:addChild(createButton)
    --取消
    local cancelButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(cancelButton, BigButton_Size)
    local imgPath = getRealUIResourcePath("img/new00380.png")
    if imgPath then
        cancelButton:setTitle(imgPath:getData());
    end
    cancelButton:setAnchorPoint(CCPointMake(0.5,0.5));
    cancelButton:setPosition(CCPointMake(width*0.7,bottomBtnY));
    cancelButton:luaSetSelectorOnClicked(cancelCreateButtonAction)
    m_mainLayer:addChild(cancelButton)
end

function processCreateSocietyInfo_societyCreate(dt)
    if dt == nil then
        return
    end
    m_money = dt:readInt()
    if m_mainLayer then
        local moneyLabel = m_mainLayer:getChildByTag(801502)
        if moneyLabel then
            moneyLabel = SCTypeCast:castNodeToLabel(moneyLabel)
            moneyLabel:setText(string.format(_LTParser("str8099"),""..m_money))
        end
    end
end