--宫殿牌占卜8016界面

MSG_SOCIATY_OPEN_LOTTERY            = 62--//打开公会塔罗牌界面
MSG_SOCIATY_CHICK_LOTTERY           = 63--//点击公会塔罗牌抽奖
MSG_SOCIATY_RANK_LOTTERY			= 64--//点击公会塔罗牌抽奖积分榜

local m_frameWndNode  = nil 

local m_currentSendCardIndex = nil

local m_isShuffle = nil--是否洗牌发牌中

local m_cardImageList = nil--获得的牌列表

local m_topTimeStr = nil--玩家剩余次数、免费次数字符串
local m_topUserDetail = nil

local m_titleAwardName = nil
local m_awardStr = nil--奖励数据

local m_societyRankList = nil--公会成员积分排名列表

local function removeAllData()
    closeWindowById(80161)
    closeWindowById(80162)
    m_frameWndNode  = nil 

    m_currentSendCardIndex = nil

    m_isShuffle = nil--是否洗牌发牌中

    m_cardImageList = nil--获得的牌列表

    m_topTimeStr = nil--玩家剩余次数、免费次数字符串
    m_topUserDetail = nil
    
    m_titleAwardName = nil
    m_awardStr = nil--奖励数据

    m_societyRankList = nil--公会成员积分排名列表
end

local function colseWnd()
    closeWindowById(8016)
end

--显示头部剩余次数
local function showTopContent()
    if m_frameWndNode == nil then
        return
    end
    local topContentLayer = m_frameWndNode:getChildByTag(8016001)
    if topContentLayer then
        m_frameWndNode:removeChildByTag(8016001,true)
    end
        
    local width  = m_frameWndNode:getContentSize().width
    local height = m_frameWndNode:getContentSize().height
    
   
    local showWidth  = width*0.7
    local showHeight = height*0.12
    local startX = (width-showWidth)/2
    local startY = height-showHeight
    
    topContentLayer = SCDragNode:node()
    topContentLayer:setTag(8016001)
    topContentLayer:setFrameVisibled(true)
    --topContentLayer:setFrameType(EnumFrameTypeRound)
    topContentLayer:setAnchorPoint(CCPointMake(0,0));
	topContentLayer:setPosition(CCPointMake(startX,startY));
	topContentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
    m_frameWndNode:addChild(topContentLayer)
    
    --洗牌次数
    if m_topTimeStr then
        local totalNumNode = ParsedNode:getParsedNode(m_topTimeStr,0,14)
        totalNumNode:setAnchorPoint(CCPointMake(0.5,0));
        totalNumNode:setPosition(CCPointMake(showWidth/2,showHeight-totalNumNode:getContentSize().height-SY(5)));
        topContentLayer:addChild(totalNumNode)   
    end
     
    --玩家数据
    if m_topUserDetail then
        local detailNode = ParsedNode:getParsedNode(m_topUserDetail,0,12)
        detailNode:setAnchorPoint(CCPointMake(0.5,0));
        detailNode:setPosition(CCPointMake(showWidth/2,SY(0)));
        topContentLayer:addChild(detailNode) 
    end
    
end

--显示结果牌
local function showResultCard()
    if m_frameWndNode == nil then
        return
    end
    
    if m_cardImageList == nil or #m_cardImageList < 1 then
        return
    end
    
    local width  = m_frameWndNode:getContentSize().width
    local height = m_frameWndNode:getContentSize().height
    
    local amount = #m_cardImageList
    if amount > 6 then
        amount = 6
    end
    local tmpX = width*0.1
    local tmpY = height*0.16
    local spaceW = width*0.12
    for i=1,amount do
        local cardImageNode = m_frameWndNode:getChildByTag(801600+i)
        if cardImageNode then
            m_frameWndNode:removeChildByTag(801600+i,true)--移除背面牌
        end
        
        local imgFile = getRealUIResourcePath("item/img"..m_cardImageList[i]..".jpg");
        if imgFile then
            local cardImage = SCImage:imageWithFile(imgFile:getData()) 
            cardImage:setTag(801600+i)
            cardImage:setAnchorPoint(CCPointMake(0.5,0.5));
            cardImage:setPosition(CCPointMake(tmpX+i*spaceW,tmpY));
            m_frameWndNode:addChild(cardImage)
        end
    end
end

--显示公会成员积分排名
local function showSocietyRankList()
    if m_societyRankList == nil then
        return
    end
    local width  = getScreenWidth()
    local height = getScreenHeight()
    
    local showWidth  = SX(170)
    local showHeight = SY(220)
    
    local scene = SCBaseScene:getRunningScene()
    
    local frameWndNode = scene:getUINode():getChildByTag(80162)
    
    if frameWndNode == nil then
        frameWndNode = FrameWindow:frameWnd()
        frameWndNode:setTag(80162)
        frameWndNode:setOutSpaceClickClose(true)
        frameWndNode:setContentSize(CCSizeMake(showWidth, showHeight))
        frameWndNode:setFrameVisibled(true)
        frameWndNode:setCloseBtnVisible(true)
        frameWndNode:setAnchorPoint(CCPointMake(0.5,0.5));
        frameWndNode:setPosition(CCPointMake(width/2,height/2));
        
        scene:getUINode():addChild(frameWndNode, Max_Int)
    else
        frameWndNode:removeAllChildrenWithCleanup(true)
    end
    
    --最高当日积分排名
    local nameLabel = SCLabel:labelWithStringFont(_LTParser("str8118"),getDefaultFontName(), getFontSize(14))
    nameLabel:setAnchorPoint(CCPointMake(0.5,0));
    nameLabel:setPosition(CCPointMake(showWidth/2,showHeight-nameLabel:getContentSize().height-SY(15)));
    nameLabel:setColor(getColorYellow())
    frameWndNode:addChild(nameLabel)
    
    
    local listBoxWidth  =   showWidth*0.85
    local listBoxHeight =   showHeight*0.8
    local listBox = SCListBox:boxWithWidthHeight(listBoxWidth,listBoxHeight)
    listBox:setAnchorPoint(CCPointMake(0.5,0));
    listBox:setPosition(CCPointMake(showWidth/2,SY(13)));
	frameWndNode:addChild(listBox)
	
	local amount = #m_societyRankList
	local rowHeight = SY(15)
    local detailStr = ""--排名数据
    for i=1,amount do
        if m_societyRankList[i] then
            local rank = m_societyRankList[i].nRank
            local name = m_societyRankList[i].szName
            local value = m_societyRankList[i].nIntegral
            
            local content = SCNode:node()
            content:setAnchorPoint(CCPointMake(0,0));
	        content:setContentSize(CCSizeMake(listBoxWidth,rowHeight))
	    
	        --排名名称
	        local rankAndNameLabel = SCLabel:labelWithStringFont(rank.." "..name,getDefaultFontName(), getFontSize(12))
            rankAndNameLabel:setAnchorPoint(CCPointMake(0,0.5));
            rankAndNameLabel:setPosition(CCPointMake(SX(3),rowHeight/2));
            content:addChild(rankAndNameLabel)
        
            --积分
            local valueLabel = SCLabel:labelWithStringFont(value,getDefaultFontName(), getFontSize(12))
            valueLabel:setAnchorPoint(CCPointMake(0,0.5));
            valueLabel:setPosition(CCPointMake(listBoxWidth*0.75,rowHeight/2));
            content:addChild(valueLabel)
            
	        listBox:addItem(content)
        end
    end

end

--确认按钮
local function confirmBtnAction()
    showTopContent()
    closeWindowById(80161)
    m_isShuffle = false
end

--弹出确认框
local function showConfirmWindow()
    
    closeWindowById(80162)
     --界面背景
    local imgFile = getRealUIResourcePath("img/new00001.png");
    if imgFile == nil then
        return
    end
    local bgImage = SCImage:imageWithFile(imgFile:getData()) 
    
    local width  = getScreenWidth()
    local height = getScreenHeight()
    
    local showWidth  = bgImage:getContentSize().width
    local showHeight = bgImage:getContentSize().height
    
    local scene = SCBaseScene:getRunningScene()
    
    local frameWndNode = scene:getUINode():getChildByTag(80161)
    
    if frameWndNode == nil then
        frameWndNode = FrameWindow:frameWnd()
        frameWndNode:setTag(80161)
        frameWndNode:setOutSpaceClickClose(false)
        frameWndNode:setContentSize(CCSizeMake(showWidth, showHeight))
        frameWndNode:setFrameVisibled(false)
        frameWndNode:setCloseBtnVisible(false)
        frameWndNode:setAnchorPoint(CCPointMake(0.5,0.5));
        frameWndNode:setPosition(CCPointMake(width/2,height/2));
        frameWndNode:addChild(bgImage)
    
        scene:getUINode():addChild(frameWndNode, Max_Int)
    else
        frameWndNode:removeAllChildrenWithCleanup(true)
        frameWndNode:addChild(bgImage)
    end
    
   
    --奖励名称
    if m_titleAwardName then
        local totalNumNode = ParsedNode:getParsedNode(m_titleAwardName,0,24)
        totalNumNode:setAnchorPoint(CCPointMake(0.5,0.5));
        totalNumNode:setPosition(CCPointMake(showWidth/2,showHeight*0.7));
        frameWndNode:addChild(totalNumNode)   
    end
    
    
    --奖励详细
    if m_awardStr then
        local detailNode = ParsedNode:getParsedNode(m_awardStr,0,12)
        detailNode:setAnchorPoint(CCPointMake(0.5,0));
        detailNode:setPosition(CCPointMake(showWidth/2,showHeight*0.38));
        frameWndNode:addChild(detailNode) 
    end
    
    
    --确定按钮
    local okBtn = SCButton:button(EnumBtnTypeNormalImg)
    okBtn:setTitle(_LTParser("str8108"),getDefaultFontName(), getFontSize(15),getColorWhite())
    okBtn:setBackgroundImage(getRealUIResourcePath("img/img2086.png"):getData())
    okBtn:setSelectedImage(getRealUIResourcePath("img/img2087.png"):getData())
    okBtn:setAnchorPoint(CCPointMake(0.5,0));
    okBtn:setPosition(CCPointMake(showWidth/2,SY(5)));
    okBtn:luaSetSelectorOnClicked(confirmBtnAction)
    frameWndNode:addChild(okBtn)
    
end

--发牌一张结束
local function sendCardMoveEnd()
    if m_currentSendCardIndex then
        m_currentSendCardIndex = m_currentSendCardIndex + 1
        if m_currentSendCardIndex <= 6 then
            startSendCard_societyLotteryScreen()
        else
            showResultCard()     
            showConfirmWindow()      
        end
    end
end

--开始发牌
function startSendCard_societyLotteryScreen()
    if m_frameWndNode == nil then
        return
    end
    local imgFile = getRealUIResourcePath("img/new00003.png");
    local cardBgImage = nil
    if imgFile then
        cardBgImage = SCImage:imageWithFile(imgFile:getData()) 
    else
        return
    end
    local width  = m_frameWndNode:getContentSize().width
    local height = m_frameWndNode:getContentSize().height
    local startX = width*0.51
    local startY = height*0.6
    local spaceW = width*0.12
    local moveEndX = width*0.1
    local moveEndY = height*0.16
    if cardBgImage then
        local pnode = ActionNode:newActionNode();
        if pnode then
            pnode:setContentSize(cardBgImage:getContentSize());
            pnode:setAnchorPoint(CCPointMake(0.5,0.5));
            pnode:setPosition(CCPointMake(startX,startY));
            pnode:moveTo(CCPoint(moveEndX+m_currentSendCardIndex*spaceW, moveEndY),0.5);--参数2 秒
            pnode:luaSetSelectorOnMoveEnd(sendCardMoveEnd);
            pnode:setTag(801600+m_currentSendCardIndex)
            
            pnode:addChild(cardBgImage)
            m_frameWndNode:addChild(pnode)
        end
    end
    
end

--显示洗牌动画
local function showShuffle()
    if m_frameWndNode == nil then
        return
    end
    
    for i=1,6 do
        local cardImageNode = m_frameWndNode:getChildByTag(801600+i)
        if cardImageNode then
            m_frameWndNode:removeChildByTag(801600+i,true)
        end
    end
        
    local width = m_frameWndNode:getContentSize().width
    local height = m_frameWndNode:getContentSize().height
    
    local pAi = LookfaceParser:getSingleton():getAnimationByIndex(1180, 1180);--洗牌
    local pNode = nil
    if pAi then
        pAi:luaSetSelectorOnComplete(startSendCard_societyLotteryScreen);
        pAi:setAutoremoveOnComplete(true);
        pNode =  SCAnimationNode:nodeWithAnimation(pAi); 
        if pNode then
            pNode:setAnchorPoint(CCPointMake(0.5,0.5));
            pNode:setPosition(CCPointMake(width*0.51,height*0.6));
            m_frameWndNode:addChild(pNode)   
        end        
    end
end

--点击洗牌
local function clickShuffleAction()
    if m_isShuffle == true then--洗牌中
        return
    end
    sendClickCardMsg_societyLotteryScreen()
end

--点击公会积分排名响应
local function rankListButtonAction()
    m_societyRankList = nil
    sendQureryRankListMsg_societyLotteryScreen()
end

function open_societyLotteryScreen()
    if m_frameWndNode then
        return;
    end

    local width  = getScreenWidth()
    local height = getScreenHeight()
    local imgFile = getRealUIResourcePath("img/new00002.png");
    local bgImage = nil
    if imgFile then
        bgImage = SCImage:imageWithFile(imgFile:getData()) 
        width   = bgImage:getContentSize().width
        height  = bgImage:getContentSize().height
    end
    m_frameWndNode = SCWindow:window()
    m_frameWndNode:setTag(8016)
    m_frameWndNode:setContentSize(CCSizeMake(width, height))
    m_frameWndNode:setFrameVisibled(false)
    m_frameWndNode:luaSetSelectorOnClose(removeAllData)--设置关闭回调
    
     --关闭按钮
    local colseBtn = SCButton:button(EnumBtnTypeNormalImg)
    colseBtn:setBackgroundImage(getRealUIResourcePath("img/Btn2110.png"):getData())
    colseBtn:setSelectedImage(getRealUIResourcePath("img/Btn2111.png"):getData())
    colseBtn:setAnchorPoint(CCPointMake(0,0));
    colseBtn:setPosition(CCPointMake(width-colseBtn:getContentSize().width-SX(15),height-colseBtn:getContentSize().height-SY(10)));
    colseBtn:luaSetSelectorOnClicked(colseWnd)
    
    
    --公会积分排名
    local rankListButton = SCButton:button(EnumBtnTypeNormalImg)
    rankListButton:setAnchorPoint(CCPointMake(0.5,0));
    rankListButton:setPosition(width*0.9,height*0.8)
    rankListButton:setTitle(_LTParser("str8119"),getDefaultFontName(), getFontSize(14),getColorLightYellow())
    rankListButton:setUnderlineVisibled(true)
    rankListButton:luaSetSelectorOnClicked(rankListButtonAction)--设置回调
    
    
    --界面背景
    if bgImage then
        bgImage:setAnchorPoint(CCPointMake(0.5,0.5));
        bgImage:setPosition(CCPointMake(width*0.5,height*0.5));
        m_frameWndNode:addChild(bgImage)
        colseBtn:setPosition(CCPointMake(bgImage:getPosition().x+bgImage:getContentSize().width/2-colseBtn:getContentSize().width-SX(15),height-colseBtn:getContentSize().height-SY(10)));
        rankListButton:setPosition(bgImage:getPosition().x+bgImage:getContentSize().width*0.4,height*0.8)
    end
    m_frameWndNode:addChild(colseBtn)
    m_frameWndNode:addChild(rankListButton)
    
    --初始化宫殿牌整副牌背景
    local imgFile = getRealUIResourcePath("img/new00004.png");
    if imgFile then
        local bgCardImage = SCImage:imageWithFile(imgFile:getData()) 
        bgCardImage:setAnchorPoint(CCPointMake(0.5,0.5));
        bgCardImage:setPosition(CCPointMake(width*0.51,height*0.6));
        m_frameWndNode:addChild(bgCardImage)
    end
    
    
    --设置点击区域
    local centerContentLayer  = SCButton:button(EnumBtnTypeNormalImg)
    centerContentLayer:setAnchorPoint(CCPointMake(0.5,0.5));
    centerContentLayer:setPosition(CCPointMake(width/2,height*0.6));
	centerContentLayer:setContentSize(CCSizeMake(width*0.5,height*0.55))
	centerContentLayer:luaSetSelectorOnClicked(clickShuffleAction)
	m_frameWndNode:addChild(centerContentLayer)
	


    
    m_currentSendCardIndex = 1
    m_isShuffle = false
    
    local scene = SCBaseScene:getRunningScene()
    if scene then
        --scene:getUINode():addChild(m_frameWndNode, Max_Int)
        local wndCtrl = SCWindowController:controllerWithWindow(m_frameWndNode)
	    local naviCtrl =  scene:getNavigationController()
	    naviCtrl:pushWindowController(wndCtrl)
        m_frameWndNode:setCloseButtonVisibled(false)
    end
end

--发送抽奖消息
function sendClickCardMsg_societyLotteryScreen()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_CHICK_LOTTERY);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--获取公会积分排名
function sendQureryRankListMsg_societyLotteryScreen()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_RANK_LOTTERY);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

function processSocietyLotteryMsg_societyLotteryScreen(dt)
    if dt == nil then
        return
    end
    
    local usTime = dt:readShort()
    local szInfo = dt:readString()
    m_topTimeStr = "*0".._LTParser("str8117").." "..usTime--剩余次数
    if szInfo then
        m_topUserDetail = szInfo:getData()
    end
    if m_isShuffle ~= true then--不在洗牌中
        showTopContent()
    end
    
end

--获取下发的牌列表
function processSocietyCardList_societyLotteryScreen(dt)
    if dt == nil then
        return
    end
    m_cardImageList = {}
    
    local titleName = dt:readString()
    for i=1,6 do
        local idPhoto = dt:readInt() 
        table.insert(m_cardImageList,idPhoto);
    end
    local szAward = dt:readString()
    
    --保佑、一太阳、二太阳、三太阳、光辉灿烂、万丈光芒、神圣光辉
    if titleName then
        m_titleAwardName = titleName:getData()
    end
    
    
    if szAward then
        m_awardStr = szAward:getData()
    end
    
    --开始播放洗牌
    if m_isShuffle ~= true then
		m_currentSendCardIndex = 1
		m_isShuffle = true
		showShuffle()
	end
end

function processSocietyRankList_societyLotteryScreen(dt)
    if dt == nil then
        return
    end
    if m_societyRankList == nil then
        m_societyRankList = {}
    end
    
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local nRank     = dt:readInt()
        local szName    = dt:readString()
        local nIntegral = dt:readInt()
        local tmpDetail = {}
        tmpDetail.nRank = nRank
        if szName then
            tmpDetail.szName = szName:getData()
        end
        tmpDetail.nIntegral = nIntegral
        table.insert(m_societyRankList,tmpDetail);
    end
    showSocietyRankList()
end
