--8011公会主界面
local  m_mainLayer = nil
local m_societyMemberList = nil
local m_societyInfo = nil
local m_societyLogList =nil --公会训练
local m_societyActivityList = nil--公会活动列表
local m_societyApplyList = nil--公会申请列表
local TrainTable = {}   --工会技能升级表
local showActivityWindow = {}

local m_activityDataList = {} --活动数据

local m_currentIndex = nil

local m_rank = nil--公会职务0：无家族,01会长,02会长夫人,3副会长,4,成员

local m_idTribe = nil--公会id

local m_accuseStatus = nil--弹劾状态0正常，1成员可弹劾会长，2会长或副会长的话显示显示弹劾按钮

local nClanProffer = nil --保存士气值

local m_viceChairman = nil  --副会长列表

local m_activityNum = nil --军团活动种类

local m_isPOP_TOP_CTRL_Flg = nil --军团活动前界面是否关闭标志

local m_flg = 0 --标记
local TRIBE_CAMPAIGN_NONE		= 0
local TRIBE_CAMPAIGN_MORALE     = 1 --//士气训练
local TRIBE_CAMPAIGN_RAPPZLE	= 2	--//桃园结义
local TRIBE_CAMPAIGN_FATTY		= 4	--//肥肥大战
local TRIBE_INDIANA_ACTIVETIES  = 3 --//深渊夺宝
local TRIBE_DEVIL_INSIDE        = 5 --//大战心魔

local SetMagicInfo = {		--技能升级表
    initWithStream = function(dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.nMagicType = dt:readInt();
        tmp.ucLevel = dt:readByte();
        return tmp
    end
}

function removeAllData_SocietyMainLayer()
    m_mainLayer = nil
    m_societyMemberList = nil
    m_societyInfo = nil
    m_societyLogList = nil
    m_societyActivityList = nil
    m_societyApplyList = nil
    m_rank = nil
    m_idTribe = nil
    m_viceChairman = nil
    m_activityNum = nil
    m_isPOP_TOP_CTRL_Flg = nil
end

local function createListMenuItem(showWidth,showHeight,name,level,rankName,rank,profer,szLoginTime)	
	local contentLayer = SCDragNode:node()
	contentLayer:setFrameVisibled(false)
	contentLayer:setFrameType(EnumFrameTypeListNormal)
	contentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	--contentLayer:addChild(bgLayer)
	
	--上分割线
	local imgPath = getRealUIResourcePath("img/new00346.png")
	if imgPath then
	    local cuttingLine = SCImage:imageWithFile(imgPath:getData());
	    if cuttingLine then
	        local size = contentLayer:getContentSize();
            cuttingLine:setAnchorPoint(CCPointMake(0.5,0.5));
            cuttingLine:setPosition(CCPointMake(size.width/2 ,size.height - 2 * cuttingLine:getContentSize().height));
            contentLayer:addChild(cuttingLine);
	    end
	end
	local flg = nil
	if szLoginTime and string.match(szLoginTime,L("str3285")) then
	    flg = true
	end
	
    --成员名称
    if name == nil then
        name =""
    end
    local memberNameLabel = SCLabel:labelWithStringFont(""..name,getDefaultFontName(), getFontSize(10))
    if memberNameLabel then
        memberNameLabel:setColor(getColorYellow())
        if not flg then
            memberNameLabel:setColor(getColorGray())
        end
        memberNameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        memberNameLabel:setPosition(CCPointMake(showWidth*0.13,showHeight/2));
        contentLayer:addChild(memberNameLabel)
    end
    --等级
    if level == nil then
        level = ""
    end
    local levelLabel = SCLabel:labelWithStringFont(""..level,getDefaultFontName(), getFontSize(10))
    if levelLabel then
        levelLabel:setColor(getColorYellow())
        if not flg then
            levelLabel:setColor(getColorGray())
        end
        levelLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        levelLabel:setPosition(CCPointMake(showWidth*0.29,showHeight/2));
        contentLayer:addChild(levelLabel)
    end
    
    --职务
    if rankName == nil then
        rankName = ""
    end
    local memberNameLabel = SCLabel:labelWithStringFont(""..rankName,getDefaultFontName(), getFontSize(10))
    if memberNameLabel then
        memberNameLabel:setColor(getColorYellow())
        if not flg then
            memberNameLabel:setColor(getColorGray())
        end
        memberNameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        memberNameLabel:setPosition(CCPointMake(showWidth*0.42,showHeight/2));
        contentLayer:addChild(memberNameLabel)
    end
    --竞技排名
    if rank==nil then
        rank = ""
    end
    local rankLabel = SCLabel:labelWithStringFont(""..rank,getDefaultFontName(), getFontSize(10))
    if rankLabel then
        rankLabel:setColor(getColorYellow())
        if not flg then
            rankLabel:setColor(getColorGray())
        end
        rankLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        rankLabel:setPosition(CCPointMake(showWidth*0.58,showHeight/2));
        contentLayer:addChild(rankLabel)
    end
    
    --贡献
    if profer == nil then
        profer =""
    end
    local contributionLabel = SCLabel:labelWithStringFont(""..profer,getDefaultFontName(), getFontSize(10))
    if contributionLabel then
        contributionLabel:setColor(getColorYellow())
        if not flg then
            contributionLabel:setColor(getColorGray())
        end
        contributionLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        contributionLabel:setPosition(CCPointMake(showWidth*0.76,showHeight/2));
        contentLayer:addChild(contributionLabel)
    end
    --登陆
    if szLoginTime == nil then
        szLoginTime = ""
    end
    local timeLabel = SCLabel:labelWithStringFont(""..szLoginTime,getDefaultFontName(), getFontSize(10))
    if timeLabel then
        timeLabel:setColor(getColorYellow())
        if not flg then
            timeLabel:setColor(getColorGray())
        end
        timeLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        timeLabel:setPosition(CCPointMake(showWidth*0.91,showHeight/2));
        contentLayer:addChild(timeLabel)
    end
    return contentLayer
end

--贡献列表MenuItem
local function createLogListMenuItem(showWidth,showHeight,detail,timeStr)	
	local contentLayer = SCDragNode:node()
	contentLayer:setFrameVisibled(true)
	contentLayer:setFrameType(EnumFrameTypeListNormal)
	contentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
    --成员名称
    if detail == nil then
        detail = ""
    end
    local memberNameLabel = ParsedNode:getParsedNode(""..detail,0,9)
    memberNameLabel:setAnchorPoint(CCPointMake(0,0.5));
    memberNameLabel:setPosition(CCPointMake(SX(2),showHeight/2));
    contentLayer:addChild(memberNameLabel)
    
    --时间
    if timeStr == nil then
        timeStr = ""
    end
    local levelLabel = SCLabel:labelWithStringFont(""..timeStr,getDefaultFontName(), getFontSize(10))
	levelLabel:setColor(getColorYellow())
    levelLabel:setAnchorPoint(CCPointMake(0,0.5));
    levelLabel:setPosition(CCPointMake(showWidth*0.83,showHeight/2));
    contentLayer:addChild(levelLabel)
    
    return contentLayer
end

--申请列表menuItem
local function createApplyListMenuItem(showWidth,showHeight,name,level,nArenaRank,timeStr)
	local contentLayer = SCDragNode:node()
	contentLayer:setFrameVisibled(true)
	contentLayer:setFrameType(EnumFrameTypeListNormal)
	contentLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
	 --成员名称
    if name == nil then
        name = ""
    end
    local applyNameLabel = SCLabel:labelWithStringFont(""..name,getDefaultFontName(), getFontSize(11))
	applyNameLabel:setColor(getColorYellow())
    applyNameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    applyNameLabel:setPosition(CCPointMake(showWidth*0.12,showHeight/2));
    contentLayer:addChild(applyNameLabel)
    
     --等级
    if level == nil then
        level = ""
    end
    local levelLabel = SCLabel:labelWithStringFont(""..level,getDefaultFontName(), getFontSize(11))
	levelLabel:setColor(getColorYellow())
    levelLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    levelLabel:setPosition(CCPointMake(showWidth*0.28,showHeight/2));
    contentLayer:addChild(levelLabel)
    
    --竞技排名
    if nArenaRank == nil then
        nArenaRank = ""
    end
    local rankLabel = SCLabel:labelWithStringFont(""..nArenaRank,getDefaultFontName(), getFontSize(11))
	rankLabel:setColor(getColorYellow())
    rankLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    rankLabel:setPosition(CCPointMake(showWidth*0.45,showHeight/2));
    contentLayer:addChild(rankLabel)
    
    --时间
    if timeStr == nil then
        timeStr = ""
    end
    local timeLabel = SCLabel:labelWithStringFont(""..timeStr,getDefaultFontName(), getFontSize(11))
	timeLabel:setColor(getColorYellow())
    timeLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    timeLabel:setPosition(CCPointMake(showWidth*0.59,showHeight/2));
    contentLayer:addChild(timeLabel)
    
    local okButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(okButton, CCSizeMake(40, 26))
	okButton:setTitle(_LTParser("str8074"),getDefaultFontName(), getFontSize(10),getColorYellow())
    okButton:setAnchorPoint(CCPointMake(0.5,0.5));
    okButton:setPosition(CCPointMake(showWidth*0.78,showHeight/2));
    contentLayer:addChild(okButton)

    
    local cancelButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(cancelButton, CCSizeMake(40, 26))
	cancelButton:setTitle(_LTParser("str8075"),getDefaultFontName(), getFontSize(10),getColorYellow())
    cancelButton:setAnchorPoint(CCPointMake(0.5,0.5));
    cancelButton:setPosition(CCPointMake(showWidth*0.93,showHeight/2));
    contentLayer:addChild(cancelButton)
    
    return contentLayer,okButton,cancelButton
end
local function onClickTribeSuccession(tag)
    if 0 == tag then
        flg = nil
        return
    end
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_TRIBE_SUCCESSION);--转让会长
    dt:writeByte(1)
           
    local idMember = flg        
    dt:writeInt(idMember)
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
    flg = nil
    POP_TOP_CTRL()
end

local function onClickMenuList(index)
        
        local memberInfo = m_societyMemberList[m_currentIndex]
        if m_societyMemberList and m_societyMemberList[m_currentIndex] then
            local idMember = m_societyMemberList[m_currentIndex].idMember
            local hero = Hero:getSingleton()
            local rank = hero:getRank()
            if index == 0 then--查看信息
				ViewPlayInfo_sendData(idMember, 0, "")
            elseif index ==1 then--添加好友
                gAddFriend(idMember,"")
            elseif index ==2 then--发送私聊
                gTalkTo(m_societyMemberList[m_currentIndex].szName);
            elseif index == 3 then--赠送鲜花 挑战
                --luaSendFlowersTo(idMember)
				send_Dekaron(idMember)
            elseif index == 4 then
                if rank == 4 and m_accuseStatus ~=0 then--弹劾会长
                    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
                    dt:writeShort(MSG_SOCIATY_ACCUSE_LEADER);--弹劾会长
                    dt:writeByte(0)
                    dt:writeInt(idMember)
                    SCDataTransThread:getSingleton():transData(dt);
                else--踢出公会
                    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
                    dt:writeShort(MSG_TRIBE_KICKOUT);--踢出公会
                    dt:writeByte(0)
                    dt:writeInt(idMember)
                    SCDataTransThread:getSingleton():transData(dt);
                    SCActivityIndicator:getSingleton():show()
                end
                
            elseif index == 5 then--任命或取消任命
                if rank~= 1 and m_accuseStatus ~= 0 then--弹劾
                    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
                    dt:writeShort(MSG_SOCIATY_ACCUSE_LEADER);--弹劾会长
                    dt:writeByte(0)
                    dt:writeInt(idMember)
                    SCDataTransThread:getSingleton():transData(dt);
                else
                    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
                    dt:writeShort(MSG_SOCIATY_SET_RANK);--任命
                    dt:writeByte(0)
                    dt:writeInt(idMember)
                    if m_societyMemberList[m_currentIndex].ucRank == 4 then--成员
                         m_viceChairman = nil 
                        dt:writeInt(3)--任命副会长
                    else
                        m_viceChairman = nil 
                        dt:writeInt(4)--取消任命
                    end
                    SCDataTransThread:getSingleton():transData(dt);
                    SCActivityIndicator:getSingleton():show()
                end
            elseif index == 6 then--转让会长
                local playerName = nil
                for i=1, #m_viceChairman do
                    if m_viceChairman[i].idMember == idMember then
                        playerName =  m_viceChairman[i].szName
                    end
                end
                if nil == playerName then
                    showMessage(_LTParser("str3017"))
                    return
                end
                local theTitle = _LTParser("str3019").."*6"..playerName.."*0?"
                local bWnd =  SCFunction:getUiNodeByIdlist("8012")
                if  bWnd then
                    bWnd:removeChildByTag(99,true)
                end
                flg = idMember
                luashowConfirmationWindow(theTitle, WIN_YES_NO, onClickTribeSuccession)
                --[[
                local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
                dt:writeShort(MSG_TRIBE_SUCCESSION);--转让会长
                dt:writeByte(0)
                dt:writeInt(idMember)
                SCDataTransThread:getSingleton():transData(dt);
                SCActivityIndicator:getSingleton():show()
                --]]
            end
        end
        
end

local function createMenuWindow()
    local memberInfo = m_societyMemberList[m_currentIndex]
    if m_mainLayer == nil or memberInfo == nil then
        return
    end
    local hero = Hero:getSingleton()
    
    if memberInfo.idMember == hero:getID() then--自己
        return
    end
    local rank = hero:getRank()
    
    --查看信息，添加好友,发送私聊，赠送鲜花
    local menuListStr = _LTParser("str8090").."_".._LTParser("str8091").."_".._LTParser("str8092").."_".._LTParser("str8093") 

    if rank == 1 then--会长
        if memberInfo.ucRank == 4 then--成员
            --踢出公会，任命职务
            menuListStr = menuListStr.."_".._LTParser("str8094").."_".._LTParser("str8095")
        elseif memberInfo.ucRank==2 or memberInfo.ucRank == 3 then--副会长，夫人
            --踢出公会，取消任命,转让会长
            menuListStr = menuListStr.."_".._LTParser("str8094").."_".._LTParser("str8096").."_".._LTParser("str8097")
        end
    elseif rank == 2 or rank == 3 then--副会长
        --踢出公会，弹劾会长
         menuListStr = menuListStr.."_".._LTParser("str8094")
         if m_accuseStatus ~= 0 and memberInfo.ucRank == 1 then
             menuListStr = menuListStr.."_".._LTParser("str8102")
        end
    else--成员
        if m_accuseStatus ~= 0 and memberInfo.ucRank == 1 then
            --弹劾会长
            menuListStr = menuListStr.."_".._LTParser("str8102")
        end
    end
    
    local pmenuList = menuList:newStringList()
    if pmenuList then
        pmenuList:createMenu(memberInfo.szName, 2, menuListStr);
        pmenuList:luasetSelector(onClickMenuList);
    end
end

--列表点击tag=1001 成员列表，tag==2001 日志列表，tag==4001 申请列表
local function listBoxItemSelected(tag,itemTag,itemIndex)
    if tag == 2001 then--日志
        return
    end
    if m_mainLayer == nil then
        return
    end
    local listBox = SCFunction:getUiNodeByIdlistAndParent("2-"..tag,m_mainLayer)
    if listBox == nil then
        return
    end
    listBox = SCTypeCast:castNodeToListBox(listBox)
    local menuItem = listBox:getChildByTag(itemTag)
    if menuItem == nil then
        return
    end
    menuItem = SCTypeCast:castNodeToDragNode(menuItem)
    menuItem:setFrameType(EnumFrameTypeListSelect)
    
    m_currentIndex = itemIndex+1
    
    if tag == 1001 then--成员列表
        createMenuWindow()
    end
end

--成员列表取消
local function listBoxUnItemSelected(tag,itemTag,itemIndex)
     if m_mainLayer == nil then
        return
    end
    local listBox = SCFunction:getUiNodeByIdlistAndParent("2-"..tag,m_mainLayer)
    if listBox == nil then
        return
    end
    listBox = SCTypeCast:castNodeToListBox(listBox)
    local menuItem = listBox:getChildByTag(itemTag)
    if menuItem == nil then
        return
    end
    menuItem = SCTypeCast:castNodeToDragNode(menuItem)
    menuItem:setFrameType(EnumFrameTypeListNormal)
end

--忽略所有申请
local function cancelAllApplyButtonAction()
    if m_societyApplyList == nil then
        return
    end
    local amount = #m_societyApplyList
    if 0 == amount then
        showMessage(_LTParser("str3021"))
    end
    for i=1,amount do
        if m_societyApplyList[i] and m_societyApplyList[i].idMember then
            local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
            dt:writeShort(MSG_SOCIATY_PROPOSER_REFUSE)--拒绝
            dt:writeInt(m_societyApplyList[i].idMember)--// (申请人id)
            SCDataTransThread:getSingleton():transData(dt);
        end
    end
end

--点击同意申请按钮响应
local function applyListOkBtnAction(tag)
     if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_PROPOSER_ADMIT);--同意
        dt:writeInt(tag)--// (申请人id)
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
        --POP_TOP_CTRL();
    end
end

--点击拒绝申请响应
local function applyListCancelBtnAction(tag)
     if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_PROPOSER_REFUSE)--拒绝
        dt:writeInt(tag)--// (申请人id)
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--点击活动列表图标
local function activityListButtonAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_TAKE_PART_CAMPAIGN);--//参与活动
        dt:writeShort(tag)--usCampaignType //活动类型
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--点击日志
local function journalButtonAction()
   -- if m_societyLogList then
    --    showSocietyLog()
   -- else
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_EXP_SEND_LIST);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
        m_societyLogList = nil
   -- end
end



--点击训练
function SocietyMainLayer_logButtonAction(tag)
    --showSocietyLog()
	local dt = SCDataTransStream:streamWithCommand(_MSG_MAGICINFO);
	if tag == 4 then
	    TrainTable = {};
	    nClanProffer = nil
		dt:writeShort(SCRIPT_ARMYGROUP_QUERY_MAGIC);
		dt:writeInt(Hero:getSingleton():getID());   --发送人物id
	elseif tag == 10025 then
	    if TrainTable[1].ucLevel > 99 then
	        showMessage(_LTParser("str3063"))
	        return
	    end
	    nClanProffer = nil
		dt:writeShort(SCRIPT_ARMYGROUP_LEVEL_UP_OK);
		dt:writeInt(Hero:getSingleton():getID());
		local idMagicType = TrainTable[1].nMagicType * 1000 + TrainTable[1].ucLevel + 1
		dt:writeInt(idMagicType);   --玄甲
	elseif tag == 10030 then
	    if TrainTable[2].ucLevel > 99 then
	        showMessage(_LTParser("str3063"))
	        return
	    end
	    nClanProffer = nil
		dt:writeShort(SCRIPT_ARMYGROUP_LEVEL_UP_OK);
		dt:writeInt(Hero:getSingleton():getID());
		local idMagicType = TrainTable[2].nMagicType * 1000 + TrainTable[2].ucLevel + 1
		dt:writeInt(idMagicType);   --射声
	elseif tag == 10035 then
	    if TrainTable[3].ucLevel > 99 then
	        showMessage(_LTParser("str3063"))
	        return
	    end
	    nClanProffer = nil
		dt:writeShort(SCRIPT_ARMYGROUP_LEVEL_UP_OK);
		dt:writeInt(Hero:getSingleton():getID());
		local idMagicType = TrainTable[3].nMagicType * 1000 + TrainTable[3].ucLevel + 1
		dt:writeInt(idMagicType);   --折冲
	elseif tag == 10040 then
	    if TrainTable[4].ucLevel > 99 then
	        showMessage(_LTParser("str3063"))
	        return
	    end
	    nClanProffer = nil
		dt:writeShort(SCRIPT_ARMYGROUP_LEVEL_UP_OK);
		dt:writeInt(Hero:getSingleton():getID());
		local idMagicType = TrainTable[4].nMagicType * 1000 + TrainTable[4].ucLevel + 1
		dt:writeInt(idMagicType);   --虎贲
	end
	SCDataTransThread:getSingleton():transData(dt);
	SCActivityIndicator:getSingleton():show()
	m_societyLogList = nil
end

--显示公会成员列表
local function showSocietyMemberList()
    if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local showWidth  = contentLayer:getContentSize().width
    local showHeight = contentLayer:getContentSize().height
    local titleStartY = showHeight*0.9
    --成员名称
    local memberNameLabel = SCLabel:labelWithStringFont(_LTParser("str8066"),getDefaultFontName(), getFontSize(11))
	memberNameLabel:setColor(getColorYellow())
    memberNameLabel:setAnchorPoint(CCPointMake(0.5,0));
    memberNameLabel:setPosition(CCPointMake(showWidth*0.13,titleStartY));
    contentLayer:addChild(memberNameLabel)
    
    --等级
    local levelLabel = SCLabel:labelWithStringFont(_LTParser("str8047"),getDefaultFontName(), getFontSize(11))
	levelLabel:setColor(getColorYellow())
    levelLabel:setAnchorPoint(CCPointMake(0.5,0));
    levelLabel:setPosition(CCPointMake(showWidth*0.30,titleStartY));
    contentLayer:addChild(levelLabel)
    
    --职务
    local rankNameLabel = SCLabel:labelWithStringFont(_LTParser("str8067"),getDefaultFontName(), getFontSize(11))
	rankNameLabel:setColor(getColorYellow())
    rankNameLabel:setAnchorPoint(CCPointMake(0.5,0));
    rankNameLabel:setPosition(CCPointMake(showWidth*0.42,titleStartY));
    contentLayer:addChild(rankNameLabel)
    
    --竞技排名
    local rankLabel = SCLabel:labelWithStringFont(_LTParser("str8068"),getDefaultFontName(), getFontSize(11))
	rankLabel:setColor(getColorYellow())
    rankLabel:setAnchorPoint(CCPointMake(0.5,0));
    rankLabel:setPosition(CCPointMake(showWidth*0.58,titleStartY));
    contentLayer:addChild(rankLabel)
    
    --贡献
    local contributionLabel = SCLabel:labelWithStringFont(_LTParser("str8069"),getDefaultFontName(), getFontSize(11))
	contributionLabel:setColor(getColorYellow())
    contributionLabel:setAnchorPoint(CCPointMake(0.5,0));
    contributionLabel:setPosition(CCPointMake(showWidth*0.75,titleStartY));
    contentLayer:addChild(contributionLabel)
    
    --登陆
    local timeLabel = SCLabel:labelWithStringFont(_LTParser("str8070"),getDefaultFontName(), getFontSize(11))
	timeLabel:setColor(getColorYellow())
    timeLabel:setAnchorPoint(CCPointMake(0.5,0));
    timeLabel:setPosition(CCPointMake(showWidth*0.9,titleStartY));
    contentLayer:addChild(timeLabel)
    
    if m_societyMemberList == nil then
        return
    end
    local listBoxWidth  = showWidth*0.98
    local listBoxHeight = showHeight*0.85
    local listBox = SCListBox:boxWithWidthHeight(listBoxWidth,listBoxHeight)
    listBox:setTag(1001)
    listBox:setAnchorPoint(CCPointMake(0.5,0));
    listBox:setPosition(CCPointMake(showWidth/2,SY(5)));
    listBox:luaSetSelectorOnItemSelected(listBoxItemSelected)
    listBox:luaSetSelectorOnItemUnSelected(listBoxUnItemSelected)
    
    local menuWidth  = listBoxWidth
    local menuHeight = SY(40)
    local amount = #m_societyMemberList
    for i=1,amount do
        --idMember
        local name = m_societyMemberList[i].szName
        local level = m_societyMemberList[i].usLevel
        local rankName = _LTParser("str8080")
        if m_societyMemberList[i].ucRank==1 then--会长
            rankName = _LTParser("str8081")
        elseif m_societyMemberList[i].ucRank == 2 then--会长夫人
            rankName = _LTParser("str8082")
        elseif m_societyMemberList[i].ucRank==3 then--副会长
            if not m_viceChairman then
                m_viceChairman = {}
            end 
            table.insert(m_viceChairman, m_societyMemberList[i])
            rankName = _LTParser("str8083")
        end
        local rank        = m_societyMemberList[i].nArenaRank
        local profer      = m_societyMemberList[i].dwSumProfer
        local szLoginTime = m_societyMemberList[i].szLoginTime
        local menuItem = createListMenuItem(menuWidth,menuHeight,name,level,rankName,rank,profer,szLoginTime)
        menuItem:setTag(i)
        menuItem:setAnchorPoint(CCPointMake(0.5,0));
        menuItem:setPosition(CCPointMake(showWidth/2,0));
        listBox:addItem(menuItem)
    end
    contentLayer:addChild(listBox)
end

--显示军团界面
local function ViewSocietyLog()
    if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    
    local pNode1 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("1", contentLayer), "SCNode")    --玄甲
    local width = pNode1:getContentSize().width
    local height = pNode1:getContentSize().height
	local imgPath = getRealUIResourcePath("img/new00496.pn")  --旗子图标
	local pImage10003 = SCImage:imageWithFile(imgPath:getData())
	if pImage10003 and imgPath then
		pImage10003:setTag(10003)
		pImage10003:setScale(0.9)
		pImage10003:setAnchorPoint(ANCHOR_CENTER)
		pImage10003:setPosition(CCPointMake(width/2, height/2))
		pImage10003:setContentSize(AUTO_SIZE(102, 104))
		pNode1:addChild(tolua.cast(pImage10003, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00504.png")      --玄甲营
	local pImage10004 = SCImage:imageWithFile(imgPath:getData())
	if pImage10004 and imgPath then
		pImage10004:setTag(10004)
		pImage10004:setScale(0.9)
		pImage10004:setAnchorPoint(ANCHOR_CENTER)
		pImage10004:setPosition(CCPointMake(width/2 - SX(1), SY(88)))
		pImage10004:setContentSize(AUTO_SIZE(54, 20))
		pNode1:addChild(tolua.cast(pImage10004, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00486.pn")   --LV 图标
	local pImage10005 = SCImage:imageWithFile(imgPath:getData())
	if pImage10005 and imgPath then
		pImage10005:setTag(10005)
		pImage10005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10005:setPosition(AUTO_POS(30.50, 63.50))
		--[[
		if TrainTable[1].ucLevel > 99 then
		    pImage10005:setPosition(AUTO_POS(28.00, 63.50))
		end
		]]
		pImage10005:setContentSize(AUTO_SIZE(24, 16))
		pNode1:addChild(tolua.cast(pImage10005, "SCNode"))
	end
	local pNodeNum = nil
    if TrainTable[1].ucLevel < 100 then
	    pNodeNum = getImageNumber(TrainTable[1].ucLevel, "img/new00530.pn", SX(12.2), SY(18))   --等级显示图标
	else
	    pNodeNum = getImageNumber(TrainTable[1].ucLevel, "img/new00530.png", SX(12.2), SY(18), SX(9))   --等级显示图标
	end
	if pNodeNum then
		pNodeNum:setTag(10042)
		pNodeNum:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pNodeNum:setPosition(AUTO_POS(57, 63.50))
		if TrainTable[1].ucLevel > 99 then
		    pNodeNum:setPosition(AUTO_POS(53.00, 63.50))
		end
		pNode1:addChild(tolua.cast(pNodeNum, "SCNode"))
	end

	local pLable10008 = SCLabel:labelWithStringFont(L(L("str0336")..(TrainTable[1].ucLevel + 1) * 10*TrainTable[1].ucLevel), DEFAULT_FONT_NAME, F(9))   ---生命文字
	if pLable10008 then
		pLable10008:setTag(10022)
		pLable10008:setAnchorPoint(ANCHOR_CENTER)
		pLable10008:setPosition(CCPointMake(width/2 - SX(1), SY(58.5)))
		pNode1:addChild(tolua.cast(pLable10008, "SCNode"))
	end

	local pButton10009 = SCButton:button()
	if pButton10009 then
		pButton10009:setTag(10025)
		pButton10009:setAnchorPoint(ANCHOR_CENTER)
		pButton10009:setPosition(CCPointMake(width/2 - SX(1), SY(42)))
		pButton10009:setContentSize(AUTO_SIZE(35, 20))
		pButton10009:setTitle(RES("img/new00501.png"))
		pButton10009:setBackgroundImage(RES("img/new00194.png"))
		pButton10009:luaSetSelectorOnClicked(SocietyMainLayer_logButtonAction)--设置回调
		pNode1:addChild(tolua.cast(pButton10009, "SCNode"))
	end

	local pLable10010 = SCLabel:labelWithStringFont(L(L("str0335")..(TrainTable[1].ucLevel + 1) * (TrainTable[1].ucLevel + 1) * 100 + (TrainTable[1].ucLevel + 1) * 300 + 200), DEFAULT_FONT_NAME, F(9))  --士气 60000
	if pLable10010 then
		pLable10010:setTag(10024)
		pLable10010:setAnchorPoint(ANCHOR_CENTER)
		pLable10010:setPosition(CCPointMake(width/2 - SX(1), SY(25)))
		pLable10010:setColor(ccc4(15, 255, 240, 255));
		pNode1:addChild(tolua.cast(pLable10010, "SCNode"))
		if TrainTable[1].ucLevel > 99 then
		    pLable10010:setVisible(false)
		end
	end
	
	local pNode2 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("2", contentLayer), "SCNode")    --射声
	local imgPath = getRealUIResourcePath("img/new00496.pn")  --旗子图标
	local pImage10003 = SCImage:imageWithFile(imgPath:getData())
	if pImage10003 and imgPath then
		pImage10003:setTag(10003)
		pImage10003:setScale(0.9)
		pImage10003:setAnchorPoint(ANCHOR_CENTER)
		pImage10003:setPosition(CCPointMake(width/2, height/2))
		pImage10003:setContentSize(AUTO_SIZE(102, 104))
		pNode2:addChild(tolua.cast(pImage10003, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00500.png")      --射声营
	local pImage10004 = SCImage:imageWithFile(imgPath:getData())
	if pImage10004 and imgPath then
		pImage10004:setTag(10004)
		pImage10004:setScale(0.9)
		pImage10004:setAnchorPoint(ANCHOR_CENTER)
		pImage10004:setPosition(CCPointMake(width/2 - SX(1), SY(88)))
		pImage10004:setContentSize(AUTO_SIZE(54, 20))
		pNode2:addChild(tolua.cast(pImage10004, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00486.pn")   --LV 图标
	local pImage10005 = SCImage:imageWithFile(imgPath:getData())
	if pImage10005 and imgPath then
		pImage10005:setTag(10005)
		pImage10005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10005:setPosition(AUTO_POS(30.50, 63.50))
		
		pImage10005:setContentSize(AUTO_SIZE(24, 16))
		pNode2:addChild(tolua.cast(pImage10005, "SCNode"))
	end
    local pNodeNum = nil
    if TrainTable[2].ucLevel < 100 then
	    pNodeNum = getImageNumber(TrainTable[2].ucLevel, "img/new00530.pn", SX(12.2), SY(18))   --等级显示图标
	else
	    pNodeNum = getImageNumber(TrainTable[2].ucLevel, "img/new00530.png", SX(12.2), SY(18), SX(9))   --等级显示图标
	end
	if pNodeNum then
		pNodeNum:setTag(10043)
		pNodeNum:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pNodeNum:setPosition(AUTO_POS(57, 63.50))
		if TrainTable[2].ucLevel > 99 then
		    pNodeNum:setPosition(AUTO_POS(53.00, 63.50))
		end
		pNode2:addChild(tolua.cast(pNodeNum, "SCNode"))
	end

	local pLable10008 = SCLabel:labelWithStringFont(L(L("str0337")..(TrainTable[2].ucLevel + 1) * TrainTable[2].ucLevel), DEFAULT_FONT_NAME, F(9))   ---技攻文字
	if pLable10008 then
		pLable10008:setTag(10027)
		pLable10008:setAnchorPoint(ANCHOR_CENTER)
		pLable10008:setPosition(CCPointMake(width/2 - SX(1), SY(58.5)))
		pNode2:addChild(tolua.cast(pLable10008, "SCNode"))
	end

	local pButton10009 = SCButton:button()
	if pButton10009 then
		pButton10009:setTag(10030)
		pButton10009:setAnchorPoint(ANCHOR_CENTER)
		pButton10009:setPosition(CCPointMake(width/2 - SX(1), SY(42)))
		pButton10009:setContentSize(AUTO_SIZE(35, 20))
		pButton10009:setTitle(RES("img/new00501.png"))
		pButton10009:setBackgroundImage(RES("img/new00194.png"))
		pButton10009:luaSetSelectorOnClicked(SocietyMainLayer_logButtonAction)--设置回调
		pNode2:addChild(tolua.cast(pButton10009, "SCNode"))
	end

	local pLable10010 = SCLabel:labelWithStringFont(L(L("str0335")..(TrainTable[2].ucLevel + 1) * (TrainTable[2].ucLevel + 1) * 100 + (TrainTable[2].ucLevel + 1) * 300 + 200), DEFAULT_FONT_NAME, F(9))  --士气 60000
	if pLable10010 then
		pLable10010:setTag(10029)
		pLable10010:setAnchorPoint(ANCHOR_CENTER)
		pLable10010:setPosition(CCPointMake(width/2 - SX(1), SY(25)))
		pLable10010:setColor(ccc4(15, 255, 240, 255));
		pNode2:addChild(tolua.cast(pLable10010, "SCNode"))
		if TrainTable[2].ucLevel > 99 then
		    pLable10010:setVisible(false)
		end
	end
	
	local pNode3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("3", contentLayer), "SCNode")    --折冲
	local imgPath = getRealUIResourcePath("img/new00496.pn")  --旗子图标
	local pImage10003 = SCImage:imageWithFile(imgPath:getData())
	if pImage10003 and imgPath then
		pImage10003:setTag(10003)
		pImage10003:setScale(0.9)
		pImage10003:setAnchorPoint(ANCHOR_CENTER)
		pImage10003:setPosition(CCPointMake(width/2, height/2))
		pImage10003:setContentSize(AUTO_SIZE(102, 104))
		pNode3:addChild(tolua.cast(pImage10003, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00505.png")      --折冲营
	local pImage10004 = SCImage:imageWithFile(imgPath:getData())
	if pImage10004 and imgPath then
		pImage10004:setTag(10004)
		pImage10004:setScale(0.9)
		pImage10004:setAnchorPoint(ANCHOR_CENTER)
		pImage10004:setPosition(CCPointMake(width/2 - SX(1), SY(88)))
		pImage10004:setContentSize(AUTO_SIZE(54, 20))
		pNode3:addChild(tolua.cast(pImage10004, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00486.pn")   --LV 图标
	local pImage10005 = SCImage:imageWithFile(imgPath:getData())
	if pImage10005 and imgPath then
		pImage10005:setTag(10005)
		pImage10005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10005:setPosition(AUTO_POS(30.50, 63.50))
		
		pImage10005:setContentSize(AUTO_SIZE(24, 16))
		pNode3:addChild(tolua.cast(pImage10005, "SCNode"))
	end
    local pNodeNum = nil
    if TrainTable[3].ucLevel < 100 then
	    pNodeNum = getImageNumber(TrainTable[3].ucLevel, "img/new00530.pn", SX(12.2), SY(18))   --等级显示图标
	else
	    pNodeNum = getImageNumber(TrainTable[3].ucLevel, "img/new00530.png", SX(12.2), SY(18), SX(9))   --等级显示图标
	end
	if pNodeNum then
		pNodeNum:setTag(10044)
		pNodeNum:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pNodeNum:setPosition(AUTO_POS(57, 63.50))
		if TrainTable[3].ucLevel > 99 then
		    pNodeNum:setPosition(AUTO_POS(53.00, 63.50))
		end
		pNode3:addChild(tolua.cast(pNodeNum, "SCNode"))
	end

	local pLable10008 = SCLabel:labelWithStringFont(L(L("str0338")..(TrainTable[3].ucLevel + 1) * 2 * TrainTable[3].ucLevel), DEFAULT_FONT_NAME, F(9))   --物攻文字
	if pLable10008 then
		pLable10008:setTag(10032)
		pLable10008:setAnchorPoint(ANCHOR_CENTER)
		pLable10008:setPosition(CCPointMake(width/2 - SX(1), SY(58.5)))
		pNode3:addChild(tolua.cast(pLable10008, "SCNode"))
	end

	local pButton10009 = SCButton:button()
	if pButton10009 then
		pButton10009:setTag(10035)
		pButton10009:setAnchorPoint(ANCHOR_CENTER)
		pButton10009:setPosition(CCPointMake(width/2 - SX(1), SY(42)))
		pButton10009:setContentSize(AUTO_SIZE(35, 20))
		pButton10009:setTitle(RES("img/new00501.png"))
		pButton10009:setBackgroundImage(RES("img/new00194.png"))
		pButton10009:luaSetSelectorOnClicked(SocietyMainLayer_logButtonAction)--设置回调
		pNode3:addChild(tolua.cast(pButton10009, "SCNode"))
	end

	local pLable10010 = SCLabel:labelWithStringFont(L(L("str0335")..(TrainTable[3].ucLevel + 1) * (TrainTable[3].ucLevel + 1) * 100 + (TrainTable[3].ucLevel + 1) * 300 + 200), DEFAULT_FONT_NAME, F(9))  --士气 60000
	if pLable10010 then
		pLable10010:setTag(10034)
		pLable10010:setAnchorPoint(ANCHOR_CENTER)
		pLable10010:setPosition(CCPointMake(width/2 - SX(1), SY(25)))
		pLable10010:setColor(ccc4(15, 255, 240, 255));
		pNode3:addChild(tolua.cast(pLable10010, "SCNode"))
		if TrainTable[3].ucLevel > 99 then
		    pLable10010:setVisible(false)
		end
	end
	
	local pNode4 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("4", contentLayer), "SCNode")    --虎贲
	local imgPath = getRealUIResourcePath("img/new00496.pn")  --旗子图标
	local pImage10003 = SCImage:imageWithFile(imgPath:getData())
	if pImage10003 and imgPath then
		pImage10003:setTag(10003)
		pImage10003:setScale(0.9)
		pImage10003:setAnchorPoint(ANCHOR_CENTER)
		pImage10003:setPosition(CCPointMake(width/2, height/2))
		pImage10003:setContentSize(AUTO_SIZE(102, 104))
		pNode4:addChild(tolua.cast(pImage10003, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00488.png")      --虎贲营
	local pImage10004 = SCImage:imageWithFile(imgPath:getData())
	if pImage10004 and imgPath then
		pImage10004:setTag(10004)
		pImage10004:setScale(0.9)
		pImage10004:setAnchorPoint(ANCHOR_CENTER)
		pImage10004:setPosition(CCPointMake(width/2 - SX(1), SY(88)))
		pImage10004:setContentSize(AUTO_SIZE(54, 20))
		pNode4:addChild(tolua.cast(pImage10004, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00486.pn")   --LV 图标
	local pImage10005 = SCImage:imageWithFile(imgPath:getData())
	if pImage10005 and imgPath then
		pImage10005:setTag(10005)
		pImage10005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10005:setPosition(AUTO_POS(30.50, 63.50))
		
		pImage10005:setContentSize(AUTO_SIZE(24, 16))
		pNode4:addChild(tolua.cast(pImage10005, "SCNode"))
	end
    local pNodeNum = nil
    if TrainTable[4].ucLevel < 100 then
	    pNodeNum = getImageNumber(TrainTable[4].ucLevel, "img/new00530.pn", SX(12.2), SY(18))   --等级显示图标
	else
	    pNodeNum = getImageNumber(TrainTable[4].ucLevel, "img/new00530.png", SX(12.2), SY(18), SX(9))   --等级显示图标
	end
	if pNodeNum then
		pNodeNum:setTag(10045)
		pNodeNum:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pNodeNum:setPosition(AUTO_POS(57, 63.50))
		if TrainTable[4].ucLevel > 99 then
		    pNodeNum:setPosition(AUTO_POS(53.00, 63.50))
		end
		pNode4:addChild(tolua.cast(pNodeNum, "SCNode"))
	end

	local pLable10008 = SCLabel:labelWithStringFont(L(L("str0339")..(TrainTable[4].ucLevel + 1) * TrainTable[4].ucLevel / 2), DEFAULT_FONT_NAME, F(9))   ---破甲文字
	if pLable10008 then
		pLable10008:setTag(10037)
		pLable10008:setAnchorPoint(ANCHOR_CENTER)
		pLable10008:setPosition(CCPointMake(width/2 - SX(1), SY(58.5)))
		pNode4:addChild(tolua.cast(pLable10008, "SCNode"))
	end

	local pButton10009 = SCButton:button()
	if pButton10009 then
		pButton10009:setTag(10040)
		pButton10009:setAnchorPoint(ANCHOR_CENTER)
		pButton10009:setPosition(CCPointMake(width/2 - SX(1), SY(42)))
		pButton10009:setContentSize(AUTO_SIZE(35, 20))
		pButton10009:setTitle(RES("img/new00501.png"))
		pButton10009:setBackgroundImage(RES("img/new00194.png"))
		pButton10009:luaSetSelectorOnClicked(SocietyMainLayer_logButtonAction)--设置回调
		pNode4:addChild(tolua.cast(pButton10009, "SCNode"))
	end

	local pLable10010 = SCLabel:labelWithStringFont(L(L("str0335")..(TrainTable[4].ucLevel + 1) * (TrainTable[4].ucLevel + 1) * 100 + (TrainTable[4].ucLevel + 1) * 300 + 200), DEFAULT_FONT_NAME, F(9))  --士气 60000
	if pLable10010 then
		pLable10010:setTag(10039)
		pLable10010:setAnchorPoint(ANCHOR_CENTER)
		pLable10010:setPosition(CCPointMake(width/2 - SX(1), SY(25)))
		pLable10010:setColor(ccc4(15, 255, 240, 255));
		pNode4:addChild(tolua.cast(pLable10010, "SCNode"))
		if TrainTable[4].ucLevel > 99 then
		    pLable10010:setVisible(false)
		end
	end
    
end


--日志显示
local function showSocietyjournal()
    if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local showWidth  = contentLayer:getContentSize().width
    local showHeight = contentLayer:getContentSize().height
    local titleStartY = showHeight*0.9
    --成员名称
    local titleLabel = SCLabel:labelWithStringFont(_LTParser("str8071"),getDefaultFontName(), getFontSize(11))
	titleLabel:setColor(getColorYellow())
    titleLabel:setAnchorPoint(CCPointMake(0,0));
    titleLabel:setPosition(CCPointMake(SX(20),titleStartY));
    contentLayer:addChild(titleLabel)
    
    --时间
    local timeLabel = SCLabel:labelWithStringFont(_LTParser("str8072"),getDefaultFontName(), getFontSize(11))
	timeLabel:setColor(getColorYellow())
    timeLabel:setAnchorPoint(CCPointMake(0,0));
    timeLabel:setPosition(CCPointMake(showWidth*0.82,titleStartY));
    contentLayer:addChild(timeLabel)
    
    if m_societyLogList == nil then
        return
    end
    
    local listBoxWidth  = showWidth*0.96
    local listBoxHeight = showHeight*0.85
    local listBox = SCListBox:boxWithWidthHeight(listBoxWidth,listBoxHeight)
    listBox:setTag(2001)
    listBox:setAnchorPoint(CCPointMake(0.5,0));
    listBox:setPosition(CCPointMake(showWidth/2,SY(5)));
    listBox:luaSetSelectorOnItemSelected(listBoxItemSelected)
    listBox:luaSetSelectorOnItemUnSelected(listBoxUnItemSelected)
    
    local menuWidth  = listBoxWidth
    local menuHeight = SY(25)
    local amount =#m_societyLogList
    for i=1,amount do
        local index = i
        local idPlayer = m_societyLogList[index].idPlayer
        local szName   = m_societyLogList[index].szName
        local szWords  = m_societyLogList[index].szWords
        local szTime   = m_societyLogList[index].szTime
        local menuItem = createLogListMenuItem(menuWidth,menuHeight,"*6"..szName..szWords,szTime)
        menuItem:setTag(i)
        menuItem:setAnchorPoint(CCPointMake(0.5,0));
        menuItem:setPosition(CCPointMake(showWidth/2,0));
        listBox:addItem(menuItem)
    end
    contentLayer:addChild(listBox)
end


--显示军团Ui
local function showSocietyLog()
    if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local pDragNode1 = SCDragNode:node()            --玄甲
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(30.00, 118.50))
		pDragNode1:setContentSize(AUTO_SIZE(110, 112))
		pDragNode1:setFrameVisibled(false)
		pDragNode1:setDragEnabled(false)
		contentLayer:addChild(tolua.cast(pDragNode1, "SCNode"))
	end
	
	local pDragNode2 = SCDragNode:node()            --射声
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(153.00, 118.50))
		pDragNode2:setContentSize(AUTO_SIZE(110, 112))
		pDragNode2:setFrameVisibled(false)
		pDragNode2:setDragEnabled(false)
		contentLayer:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	
	local pDragNode3 = SCDragNode:node()            --折冲
	if pDragNode3 then
		pDragNode3:setTag(3)
		pDragNode3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode3:setPosition(AUTO_POS(30.00, 23.50))
		pDragNode3:setContentSize(AUTO_SIZE(110, 112))
		pDragNode3:setFrameVisibled(false)
		pDragNode3:setDragEnabled(false)
		contentLayer:addChild(tolua.cast(pDragNode3, "SCNode"))
	end
	
	local pDragNode4 = SCDragNode:node()            --虎贲
	if pDragNode4 then
		pDragNode4:setTag(4)
		pDragNode4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode4:setPosition(AUTO_POS(153.00, 23.50))
		pDragNode4:setContentSize(AUTO_SIZE(110, 112))
		pDragNode4:setFrameVisibled(false)
		pDragNode4:setDragEnabled(false)
		contentLayer:addChild(tolua.cast(pDragNode4, "SCNode"))
	end
	
	local imgPath = getRealUIResourcePath("img/new00502.png")   --士气图标
	local pImage10006 = SCImage:imageWithFile(imgPath:getData())
	if pImage10006 and imgPath then
		pImage10006:setTag(10006)
		pImage10006:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10006:setPosition(AUTO_POS(7.00, 7.00))
		pImage10006:setContentSize(AUTO_SIZE(42, 20))
		contentLayer:addChild(tolua.cast(pImage10006, "SCNode"))
	end
	
	local numNode = getIamgeNum(nClanProffer, "img/new00487.png", SX(17), SX(10), SY(18))     --士气值数字显示
    if numNode then
        numNode:setTag(10041)
        numNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
        numNode:setPosition(AUTO_POS(50, 8));
        contentLayer:addChild(tolua.cast(numNode, "SCNode"))
    end
	
    local pButton10016 = SCButton:button(EnumBtnType9Atlas)  --士气训练按钮
	if pButton10016 then
		pButton10016:setTag(10016)
		pButton10016:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10016:setPosition(AUTO_POS(206.00, 7.00))
		pButton10016:setContentSize(AUTO_SIZE(80, 26))
		pButton10016:setTitle(RES("img/new00503.png"))
		pButton10016:luaSetSelectorOnClicked(ArmyTraining_sendData)
		contentLayer:addChild(tolua.cast(pButton10016, "SCNode"))
	end
	
	ViewSocietyLog();
end

--发送军团活动信息
local function sendActivityInfo(index)
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dataStream:writeShort(MSG_SOCIATY_TAKE_PART_CAMPAIGN)
	dataStream:writeShort(index)
    SCDataTransThread:getSingleton():transData(dataStream); 
	SCActivityIndicator:getSingleton():show();
	POP_TOP_CTRL();
end
local function onClickActivityBtnTwo(tag)
    if 0 == tag then
        return
    end
    sendActivityInfo(TRIBE_INDIANA_ACTIVETIES)
end
----------新人气调用----
function clickto_onClickActivityBtnTwo()
	onClickActivityBtnTwo(1)
end

--军团战活动
local function sendArmyGroupFight()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    if dataStream then
        dataStream:writeShort(MSG_SOCIATY_SIGN_GAME_INFO)
        SCDataTransThread:getSingleton():transData(dataStream); 
	    SCActivityIndicator:getSingleton():show();
    end
end
--点击军团活动
local function onActivityBtnClick(tag)
    if 6 == tag then
        if 327 < CLIENT_VERSION then
            sendArmyGroupFight()
            --showMessage(_LTParser("str6194"))
        else
            --showMessage(_LTParser("str6194"))
        end
        return
    end
    if m_activityDataList[tag].usCampaignType == TRIBE_CAMPAIGN_RAPPZLE then
	    POP_TOP_CTRL()
		TaoyuanSworn.showWnd()
		return
    end 
    
    local hero = Hero:getSingleton()
    local rank = hero:getRank()
    
    
	local index = #m_activityDataList;
	if tag < 0 or tag > index then
		return;
	end
	if m_activityDataList[tag].ucFlag == 0 then
	    showMessage(_LTParser("str3022"))
	    return;
	end
	--军团BOSS二次确认
	if TRIBE_INDIANA_ACTIVETIES == m_activityDataList[tag].usCampaignType and 5 == m_activityDataList[tag].ucTakePartIn then
	    if 1 == rank or 3 ==rank then
	        local theTitle = _LTParser("str3024")
            luashowConfirmationWindow(theTitle, WIN_YES_NO, onClickActivityBtnTwo)
            return
        end 
	end
	
	if m_activityDataList[tag].usCampaignType == TRIBE_CAMPAIGN_RAPPZLE then
	    POP_TOP_CTRL()
		TaoyuanSworn.showWnd();
	else
		sendActivityInfo(m_activityDataList[tag].usCampaignType);
	end
end
local function onUnActivityBtnClick()
    showMessage(_LTParser("str3023"))
end
--显示活动内容
local function showActivityContent()
    --[[if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)]]
    local wndCtrl = getCurentSceneWindowController(6010);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end	
    m_activityDataList = m_societyActivityList
    if m_isPOP_TOP_CTRL_Flg then
        POP_TOP_CTRL()
    end
    showActivityWindow.Window()
    --[[if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local showWidth  = contentLayer:getContentSize().width
    local showHeight = contentLayer:getContentSize().height
    
    local topStartY = showHeight*0.73
	local leftImage = nil;
	local imgFile = getRealUIResourcePath("img/new00048.png");
	if imgFile then
		leftImage = SCImage:imageWithFile(imgFile:getData());
        leftImage:setAnchorPoint(CCPointMake(0.5,0.5));
        leftImage:setPosition(CCPointMake(leftImage:getContentSize().width/2,showHeight/2));
        contentLayer:addChild(leftImage)
	end
	
	local rightImage = nil;
	local imgFile = getRealUIResourcePath("img/new00047.png");
	if imgFile then
		rightImage = SCImage:imageWithFile(imgFile:getData());
        rightImage:setAnchorPoint(CCPointMake(0.5,0.5));
        rightImage:setPosition(CCPointMake(showWidth-rightImage:getContentSize().width/2,showHeight/2));
        contentLayer:addChild(rightImage)
	end
	
	if leftImage == nil or rightImage == nil then
		return;
	end
	
	showActivityWindow.Window()
	
	local pageScrollBoxWidth = 180;
	local pageScrollBoxHeight = 222;
	local pageScrollBox = SCPageScrollBox:boxWithWidthHeight(pageScrollBoxWidth, pageScrollBoxHeight);
	if pageScrollBox == nil then
		return;
	end
	pageScrollBox:setAnchorPoint(CCPointMake(0.5,0.5));
	pageScrollBox:setPosition(CCPointMake(showWidth/2,showHeight/2));
	pageScrollBox:setScrollVertical(false);
	setRealPagtSize(pageScrollBox, pageScrollBoxWidth, pageScrollBoxHeight);
	contentLayer:addChild(pageScrollBox);
	
	local imgPath1 = nil;
	local imgPath2 = nil;
	for i=1, #m_societyActivityList do
		local node = SCTypeCast:castNodeToImage(SocietyScreenTemplate.initControl());       --剩余  次数
		if node then
			if m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_MORALE then
				imgPath1 = getRealUIResourcePath("img/new00403.jpg");          --士气训练 文字图片
				imgPath2 = getRealUIResourcePath("img/new00402.png");
			elseif m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_RAPPZLE then
				imgPath1 = getRealUIResourcePath("img/new00405.jpg");
				imgPath2 = getRealUIResourcePath("img/new00404.png");
			elseif m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_FATTY then
				imgPath1 = getRealUIResourcePath("img/new00430.jpg");
				imgPath2 = getRealUIResourcePath("img/new00433.png");
			elseif m_societyActivityList[i].usCampaignType == TRIBE_INDIANA_ACTIVETIES then
				imgPath1 = getRealUIResourcePath("img/new00431.jpg");
				imgPath2 = getRealUIResourcePath("img/new00434.png");			    
			end
			
			local titleImage = SCTypeCast:castNodeToImage(node:getChildByTag(1));
			if imgPath1 and imgPath2 and titleImage then
				titleImage:setImage(imgPath2:getData());
				node:setImage(imgPath1:getData());
			end
			
			--文字Label
			local titleLabel = SCLabel:labelWithStringFont(L("每日凌晨0点刷新次数"), DEFAULT_FONT_NAME, F(8));
			if titleLabel then
			    titleLabel:setTag(10034)
                titleLabel:setColor(ccc4(58, 236, 0, 255));
                titleLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                titleLabel:setPosition(AUTO_POS(6.00, 165.00))
                titleLabel:setContentSize(AUTO_SIZE(86, 16))
                node:addChild(titleLabel);
			end
			--Node 添加小图标容器
			local SmallNode = SCNode:node();
			if SmallNode then
			    SmallNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                SmallNode:setPosition(AUTO_POS(9.00, 3.00))
                SmallNode:setContentSize(AUTO_SIZE(82, 16))
                node:addChild(SmallNode);
			end
            
            local imgPath3 = getRealUIResourcePath("img/2001001.pn");	
            if imgPath3 then	
                local sImg1 = SCImage:imageWithFile(imgPath3:getData());
                if sImg1 then
                    sImg1:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
                    sImg1:setPosition(10, 2);
                    sImg1:setScale(0.4);
                    SmallNode:addChild(sImg1)
                end
            end
			
			local imgPath4 = getRealUIResourcePath("img/2001008.pn");
			if imgPath4 then
                local sImg2 = SCImage:imageWithFile(imgPath4:getData());
                if sImg2 then
                    sImg2:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
                    sImg2:setPosition(46, 2);
                    sImg2:setScale(0.4);
                    SmallNode:addChild(sImg2)
                end
            end
			
			local text = SCTypeCast:castNodeToTextBox(node:getChildByTag(4));
			if text then
				text:setScrollHorizontal(false);
				text:setScrollVertical(false);
				text:setText(m_societyActivityList[i].szMsg);  --设置文字
			end
			
			local timesNode = node:getChildByTag(5);
			if timesNode then
				local numImage = getIamgeNum(m_societyActivityList[i].ucFlag, "img/new00487.png", 17, 10, 18)  --显示剩余次数
                if numImage then
                    --numImage:setTag(10012)
                    numImage:setAnchorPoint(CCPointMake(0.5, 0.5))
                    if m_societyActivityList[i].ucFlag < 10 then
                        numImage:setPosition(AUTO_POS(8.00, 12))
                    else
                        numImage:setPosition(AUTO_POS(13.00, 12))
                    end
                    timesNode:addChild(numImage);
                end
			end
			
			local btn = SCButton:button();
			if btn then
				btn:setContentSize(node:getContentSize());
				btn:luaSetSelectorOnClicked(onActivityBtnClick);
				btn:setTag(i);
				node:addChild(btn);
			end
			
			local nodeSize = getNodeContentSize(node);
			node:setAnchorPoint(CCPointMake(0, 0));
			node:setPosition(CCPointMake(nodeSize.width * (i-1), 0));
			setNodeContentSize(pageScrollBox, CCSizeMake(nodeSize.width * (math.floor((i-1)/2) + 1) * 2, nodeSize.height));
			pageScrollBox:addChild(node);
		end
	end--]]
    --公会图标
--[[    local imgFile = getRealUIResourcePath("img/img5008.png");
	local imageLabel = nil
	if imgFile then
	    imageLabel = SCImage:imageWithFile(imgFile:getData())
	    imageLabel:setVisible(true)
        imageLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        imageLabel:setPosition(CCPointMake(showWidth*0.15,topStartY));
        contentLayer:addChild(imageLabel)
	end
	if m_societyInfo==nil then
	    return
    end
	--等级
	local levelStr = string.format(_LTParser("str8077"),m_societyInfo.usLevel)
    local societyLevelLabel = ParsedNode:getParsedNode(levelStr,0,12)
    societyLevelLabel:setAnchorPoint(CCPointMake(0,0));
    societyLevelLabel:setPosition(CCPointMake(showWidth*0.26,topStartY+SY(10)));
    contentLayer:addChild(societyLevelLabel)
    
    
    
    --进度条
	local bar = ProgressBarEx:newProgressBarEx(EnumProgressBarTypeYellow)--SCProgressBar:barWithType(EnumProgressBarTypeYellow)
    if bar then
        bar:setTag(2)
        bar:setWidth(180)
        bar:setAnchorPoint(CCPointMake(0,0.5));
        bar:setPosition(CCPointMake(showWidth*0.26,topStartY));
        bar:setMaxValue(m_societyInfo.dwMaxExp)--dwMaxExp
        bar:setValue(m_societyInfo.dwExp)--dwExp        
        contentLayer:addChild(bar)
        
        local valueStrLabel = SCLabel:labelWithStringFont(m_societyInfo.dwExp.."/"..m_societyInfo.dwMaxExp,getDefaultFontName(), getFontSize(12))
        valueStrLabel:setAnchorPoint(CCPointMake(0.5,0.5));
        valueStrLabel:setPosition(CCPointMake(bar:getPosition().x+bar:getContentSize().width/2,topStartY));
        contentLayer:addChild(valueStrLabel)
    end
    --经验,在获取xx经验，将升级到xx级
    local expStr = getNewLinStr(string.format(_LTParser("str8078"),(m_societyInfo.dwMaxExp-m_societyInfo.dwExp),(m_societyInfo.usLevel+1)),16)--公会经验,处理换行
    local expLabel = ParsedNode:getParsedNode(expStr,0,12)
    expLabel:setAnchorPoint(CCPointMake(0,0));
    expLabel:setPosition(CCPointMake(showWidth*0.26,topStartY-expLabel:getContentSize().height-SY(10)));
    contentLayer:addChild(expLabel)
    
    if m_societyActivityList == nil then
        return
    end
    --活动图标
    local menuWidth  = SX(50)
    local menuHeight = SY(50)
    local rowAmount  = 5
    local tmpX = 0
    local tmpY = showHeight*0.58
    local amount = #m_societyActivityList
    for i=1,amount do
        local row = math.ceil(i/rowAmount)--例如：1/2 = 1
        local col = math.mod(i,rowAmount)
        if row < 1 then
            row = 1
        end
        if  col == 0 then
            col = rowAmount
        end 
        tmpX = SX(15) + (menuWidth+SX(5))*(col-1)
        
        local id = m_societyActivityList[i].usCampaignType
        local nPhoto = m_societyActivityList[i].nPhoto 
        local itemBtn = SCButton:button()
        itemBtn:setTag(id)
        if nPhoto and nPhoto ~=0 then
            local itemFile = getRealUIResourcePath( "MainInterfaceImg/"..nPhoto..".png");
            if itemFile then
                itemBtn:setTitle(itemFile:getData())
            end
        end
        itemBtn:setBackgroundImage(getRealUIResourcePath(ItemBack_Click_ImagePath):getData())
        itemBtn:setAnchorPoint(CCPointMake(0,0));
        itemBtn:setPosition(CCPointMake(tmpX,tmpY-(menuHeight+SY(10))*row));
        itemBtn:luaSetSelectorOnClicked(activityListButtonAction)
        contentLayer:addChild(itemBtn)
    end--]]
end

--审核申请列表
local function showApplyList()
    if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local showWidth  = contentLayer:getContentSize().width
    local showHeight = contentLayer:getContentSize().height
    local titleStartY = showHeight*0.93
    
    --成员名称
    local applyNameLabel = SCLabel:labelWithStringFont(_LTParser("str8073"),getDefaultFontName(), getFontSize(11))
	applyNameLabel:setColor(getColorYellow())
    applyNameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    applyNameLabel:setPosition(CCPointMake(showWidth*0.12,titleStartY));
    contentLayer:addChild(applyNameLabel)
    
     --等级
    local levelLabel = SCLabel:labelWithStringFont(_LTParser("str8047"),getDefaultFontName(), getFontSize(11))
	levelLabel:setColor(getColorYellow())
    levelLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    levelLabel:setPosition(CCPointMake(showWidth*0.28,titleStartY));
    contentLayer:addChild(levelLabel)
    
    --竞技排名
    local rankLabel = SCLabel:labelWithStringFont(_LTParser("str8068"),getDefaultFontName(), getFontSize(11))
	rankLabel:setColor(getColorYellow())
    rankLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    rankLabel:setPosition(CCPointMake(showWidth*0.45,titleStartY));
    contentLayer:addChild(rankLabel)
    
    --时间
    local timeLabel = SCLabel:labelWithStringFont(_LTParser("str8072"),getDefaultFontName(), getFontSize(11))
	timeLabel:setColor(getColorYellow())
    timeLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    timeLabel:setPosition(CCPointMake(showWidth*0.59,titleStartY));
    contentLayer:addChild(timeLabel)
    
    --忽略所有
    local cancelAllButton = SCButton:button()
    local imageFile1 = getRealUIResourcePath("kernal/multi-page-large-other.png")
    local imageFile2 = getRealUIResourcePath("kernal/multi-page-large-current.png")
    local imageFile3 = getRealUIResourcePath("img/new00370.png")
    if imageFile1 and imageFile2 and imageFile3 then
        cancelAllButton:setBackgroundImage(imageFile1:getData());
        cancelAllButton:setSelectedImage(imageFile2:getData());
        cancelAllButton:setTitle(imageFile3:getData());        
    end
    cancelAllButton:setAnchorPoint(CCPointMake(0.5,0.5));
    cancelAllButton:setPosition(CCPointMake(showWidth*0.85,titleStartY - SY(5)));
    cancelAllButton:luaSetSelectorOnClicked(cancelAllApplyButtonAction)
    contentLayer:addChild(cancelAllButton)
    
    if m_societyApplyList == nil then
        return
    end
    local listBoxWidth  = showWidth*0.96
    local listBoxHeight = showHeight*0.84
    local listBox = SCListBox:boxWithWidthHeight(listBoxWidth,listBoxHeight)
    listBox:setTag(4001)
    listBox:setAnchorPoint(CCPointMake(0.5,0));
    listBox:setPosition(CCPointMake(showWidth/2,SY(5)));
    
    local menuWidth  = listBoxWidth
    local menuHeight = SY(40)
    local amount = #m_societyApplyList
    for i=1,amount do
        if m_societyApplyList[i] then
            local idMember   = m_societyApplyList[i].idMember
            local szName     = m_societyApplyList[i].szName
            local usLevel    = m_societyApplyList[i].usLevel
            local nArenaRank = m_societyApplyList[i].nArenaRank
            local timeStr    = m_societyApplyList[i].szProposerTim
            local menuItem,okButton,cancelButton = createApplyListMenuItem(menuWidth,menuHeight,szName,usLevel,nArenaRank,timeStr)
            menuItem:setTag(i)
            menuItem:setAnchorPoint(CCPointMake(0.5,0));
            menuItem:setPosition(CCPointMake(showWidth/2,0));
            if okButton then
                okButton:setTag(idMember)
                okButton:luaSetSelectorOnClicked(applyListOkBtnAction)
            end
            if cancelButton then
                cancelButton:setTag(idMember)
                cancelButton:luaSetSelectorOnClicked(applyListCancelBtnAction)
            end
            listBox:addItem(menuItem)
        end
    end
    contentLayer:addChild(listBox)
end



--点击进入公会集会所按钮响应
local function enterSocietyButtonAction()
    POP_TOP_CTRL();
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_GOTO_MAP);--进入集会所
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
    --closeWindowById(8012)--公会主界面
    --closeWindowById(8014)--公会设置
end

--点击公会设置
local function societySetButtonAction()
    local msg  = nil
    local msg2 = nil
    if m_societyInfo then
        msg  = m_societyInfo.szMsg
        msg2 = m_societyInfo.szMsg1
    end
    open_SocietySetScreen(msg,msg2)
end


local function leaveButtonAction()
    local hero = Hero:getSingleton()
    if hero:getRank() == 1 then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_TRIBE_DISMISS);--//解散公会
        dt:writeByte(0)
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    else
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_TRIBE_LEAVE);--//离开公会
        dt:writeByte(0)
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--支持
local function agreeAccuseButtonAction()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_ACCUSE_STATUS);--弹劾
    dt:writeByte(1)
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
    closeWindowById(8011001)
end

--反对
local function disagreeAccuseButtonAction()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_ACCUSE_STATUS);--弹劾
    dt:writeByte(2)
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
    closeWindowById(8011001)
end

--弹劾
local function accuseButtonAction()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_ACCUSE_STATUS);--弹劾
    dt:writeByte(0)
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--点击邮件响应
local function mailButtonAction()
    openSendFamilyMailWnd()
end



--点击公会活动
function  SocietyMainLayer_activityButtonAction()
   -- if m_societyActivityList then
   --     showActivityContent()
   -- else
        m_isPOP_TOP_CTRL_Flg = true
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_CAMPAIGNS);
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
        m_societyActivityList = nil
   -- end
end

--公会审核申请人列表
local function applyButtonAction()

    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_PROPOSER_LIST);
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
    m_societyApplyList = nil
end



local flg = nil
local function onNilClick()
end
local function onClickTwo(tag)
    if 0 == tag then
        flg = nil
        return
    end
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_TRIBE_SUCCESSION);--转让会长
        dt:writeByte(1)
               
        local idMember = 0        
        if 1 == flg then
            idMember = m_viceChairman[1].idMember
        elseif 2 == flg then
            idMember = m_viceChairman[2].idMember
        end
        dt:writeInt(idMember)
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
        flg = nil
        POP_TOP_CTRL()
end
local function onClickDemiseButtonAction(tag)
    local imgPath3 = getRealUIResourcePath("img/new00286.png")	--
	local imgPath4 = getRealUIResourcePath("img/new00287.png")	--
	if not imgPath3 or not imgPath4 then
	    return
	end
    if 104 == tag then
        if 2 == flg then
            local nameLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("8012-99-4500-25"))
            if nameLabel2 then
                nameLabel2:setColor(getColorWhite())
            end
            local grade1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("8012-99-4500-35"))
            if grade1 then
                grade1:setColor(getColorWhite())
            end
            local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("8012-99-4500-105"))
            if pBtn then
                pBtn:setBackgroundImage(imgPath3:getData());
                pBtn:setSelectedImage(imgPath4:getData());
                pBtn:luaSetSelectorOnClicked(onClickDemiseButtonAction)
            end
        end
        local nameLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("8012-99-4500-24"))
        if nameLabel1 then
            nameLabel1:setColor(getColorYellow())
        end
        local grade1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("8012-99-4500-34"))
        if grade1 then
            grade1:setColor(getColorYellow())
        end
        local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("8012-99-4500-104"))
        if pBtn then
            pBtn:setBackgroundImage(imgPath4:getData());
            --pBtn:setSelectedImage(imgPath3:getData());
            pBtn:luaSetSelectorOnClicked(onNilClick)
        end
        flg = 1
        
    elseif 105 == tag then
        if 1 == flg then
            local nameLabel2 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("8012-99-4500-24"))
            if nameLabel2 then
                nameLabel2:setColor(getColorWhite())
            end
            local grade1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("8012-99-4500-34"))
            if grade1 then
                grade1:setColor(getColorWhite())
            end
            local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("8012-99-4500-104"))
            if pBtn then
                pBtn:setBackgroundImage(imgPath3:getData());
                pBtn:setSelectedImage(imgPath4:getData());
                pBtn:luaSetSelectorOnClicked(onClickDemiseButtonAction)
            end
        end
        local nameLabel1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("8012-99-4500-25"))
        if nameLabel1 then
            nameLabel1:setColor(getColorYellow())
        end
        local grade1 = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("8012-99-4500-35"))
        if grade1 then
            grade1:setColor(getColorYellow())
        end
        local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("8012-99-4500-105"))
        if pBtn then
            pBtn:setBackgroundImage(imgPath4:getData());
            --pBtn:setSelectedImage(imgPath3:getData());
            pBtn:luaSetSelectorOnClicked(onNilClick)
        end
        flg = 2
        
    elseif 101 == tag then
        if not flg then
            showMessage(_LTParser("str3017"))
            return
        end
         local playerName  =  nil     
        if 1 == flg then
            playerName = m_viceChairman[1].szName
        elseif 2 == flg then
            playerName = m_viceChairman[2].szName
        end
        local theTitle = _LTParser("str3019").."*6"..playerName.."*0?"
        local bWnd =  SCFunction:getUiNodeByIdlist("8012")
        if  bWnd then
            bWnd:removeChildByTag(99,true)
        end
        
        luashowConfirmationWindow(theTitle, WIN_YES_NO, onClickTwo)
    elseif 102 == tag then
        local bWnd =  SCFunction:getUiNodeByIdlist("8012")
        if  bWnd then
            bWnd:removeChildByTag(99,true)
        end
        flg = nil
    end
end
--转让公会
local function onClickDemiseButton()
    if not m_viceChairman then
        showMessage(_LTParser("str3016"))
        return
    end
    local tmpList = m_viceChairman
    local bWnd =  SCFunction:getUiNodeByIdlist("8012")
    if not bWnd then
        return
    end
    local w = 300 * gUIScale().x
    local h = 180 * gUIScale().y
    local wnd = FrameWindow:frameWnd();
    if not wnd then
        return
    end
    local pNode = SCDragNode:node()
    wnd:setTag(99)
    wnd:setCloseBtnVisible(false)
	wnd:setContentSize(CCSize(w ,h))
    if pNode then
        pNode:setTag(4500)
        pNode:setPosition(AUTO_POS(5.00, 40.00))
		pNode:setContentSize(AUTO_SIZE(290, 110))
        pNode:setFrameVisibled(true)
		pNode:setDragEnabled(false)
		pNode:setFrameType(EnumFrameTypeRound)
		--wnd:setContentSize(pNode:getContentSize())
		wnd:addChild(pNode)
		local nameLabel = SCLabel:labelWithStringFont(_LTParser("str3018"),getDefaultFontName(), getFontSize(13))
        if nameLabel then
            nameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
            nameLabel:setPosition(CCPointMake(SX(145),SY(90)));
            nameLabel:setColor(getColorGreen())
            pNode:addChild(nameLabel)
        end
        local imgPath = getRealUIResourcePath("img/new00346.png")
        if imgPath then
            local cuttingLine = SCImage:imageWithFile(imgPath:getData());
            if cuttingLine then
                cuttingLine:setAnchorPoint(CCPointMake(0.5,0.5));
                cuttingLine:setPosition(CCPointMake(SX(145),SY(80)));
                pNode:addChild(cuttingLine);
            end
        end
        for i = 1,#m_viceChairman do
            local nameLabel1 = SCLabel:labelWithStringFont(m_viceChairman[i].szName,getDefaultFontName(), getFontSize(12))
            if nameLabel1 then
                nameLabel1:setTag(23 + i)
                nameLabel1:setAnchorPoint(CCPointMake(0.5,0.5));
                nameLabel1:setPosition(CCPointMake(SX(80),SY(90 - i*30)));
                nameLabel1:setColor(getColorWhite())
                pNode:addChild(nameLabel1)
            end
            local pLevel = m_viceChairman[i].usLevel.._LTParser("str0266")
            local grade1 = SCLabel:labelWithStringFont(pLevel,getDefaultFontName(), getFontSize(12))
            if grade1 then
                grade1:setTag(33 + i)
                grade1:setAnchorPoint(CCPointMake(0.5,0.5));
                grade1:setPosition(CCPointMake(SX(160),SY(90 - i*30)));
                grade1:setColor(getColorWhite())
                pNode:addChild(grade1)
            end
            
            
            local imgPath3 = getRealUIResourcePath("img/new00286.png")	--
	        local imgPath4 = getRealUIResourcePath("img/new00287.png")	--
	        if imgPath3 and imgPath4 then
	            local confirmButton = SCButton:button()
                if confirmButton then
                    confirmButton:setTag(103 + i)
                    confirmButton:setBackgroundImage(imgPath3:getData());
                    confirmButton:setSelectedImage(imgPath4:getData());
                    --confirmButton:setTitle(imgPath3:getData())
                    confirmButton:setAnchorPoint(CCPointMake(0.5,0.5));
                    confirmButton:setPosition(CCPointMake(SX(230),SY(90 - i*30)))
                    confirmButton:luaSetSelectorOnClicked(onClickDemiseButtonAction)--设置回调
                    pNode:addChild(confirmButton)
                end
	        end
            if i > 1 then
                local imgPath = getRealUIResourcePath("img/new00346.png")
                if imgPath then
                    local cuttingLine = SCImage:imageWithFile(imgPath:getData());
                    if cuttingLine then
                        cuttingLine:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine:setPosition(CCPointMake(SX(145),SY(45)));
                        pNode:addChild(cuttingLine);
                    end
                end
            end
        end
    end
    
    imgPath = getRealUIResourcePath("img/new00551.png")
	if imgPath then
		local titleImage = SCImage:imageWithFile(imgPath:getData());
		if titleImage then
			titleImage:setAnchorPoint(CCPointMake(0.5,0.5));
			titleImage:setPosition(CCPointMake(SX(150),SY(160)));
			wnd:addChild(titleImage)
		end
	end
    
    
    
    
    
    local imgPath1 = getRealUIResourcePath("kernal/multi-page-large-other.png")
	local imgPath2 = getRealUIResourcePath("kernal/multi-page-large-current.png")
	local imgPath3 = getRealUIResourcePath("img/new00024.png")	--确认
	local imgPath4 = getRealUIResourcePath("img/new00023.png")	--取消
	if imgPath1 and imgPath2 and imgPath3 and imgPath4 then
	    local confirmButton = SCButton:button()
	    if confirmButton then
            confirmButton:setTag(101)
            confirmButton:setBackgroundImage(imgPath1:getData());
            confirmButton:setSelectedImage(imgPath2:getData());
            confirmButton:setTitle(imgPath3:getData())
            confirmButton:setAnchorPoint(CCPointMake(0.5,0.5));
            confirmButton:setPosition(CCPointMake(SX(80),SY(30)));
            confirmButton:luaSetSelectorOnClicked(onClickDemiseButtonAction)--设置回调
            wnd:addChild(confirmButton)
        end
        
        local cancelButton = SCButton:button()
	    if cancelButton then
            cancelButton:setTag(102)
            cancelButton:setBackgroundImage(imgPath1:getData());
            cancelButton:setSelectedImage(imgPath2:getData());
            cancelButton:setTitle(imgPath4:getData())
            cancelButton:setAnchorPoint(CCPointMake(0.5,0.5));
            cancelButton:setPosition(CCPointMake(SX(220),SY(30)));
            cancelButton:luaSetSelectorOnClicked(onClickDemiseButtonAction)--设置回调
            wnd:addChild(cancelButton)
        end
	end
    
    
	wnd:setOutSpaceClickClose(true)
	
    bWnd:addChild(wnd)
end
--左边公会信息
local function showLeftSocietyInfoContent()
    if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(1);
    if contentLayer == nil then
        return
    end
    contentLayer = SCTypeCast:castNodeToDragNode(contentLayer)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local width = contentLayer:getContentSize().width
    local height = contentLayer:getContentSize().height
    
    if m_societyInfo == nil then
        return
    end
    
    local societyName =m_societyInfo.szTribeName
    if societyName == nil then
        societyName = ""
    end    
    
    --公会名称
    local nameLabel = SCLabel:labelWithStringFont(societyName,getDefaultFontName(), getFontSize(14))
    nameLabel:setAnchorPoint(CCPointMake(0.5,0));
    nameLabel:setPosition(CCPointMake(width*0.35,height*0.89));
    nameLabel:setColor(getColorGreen())
    contentLayer:addChild(nameLabel)
    
    --公会信息
    local tmpStr = "*5".._LTParser("str8051").." *0"..m_societyInfo.usLevel--公会等级
    tmpStr = tmpStr.."_*5".._LTParser("str8052").." *0"..m_societyInfo.nRank--公会排名
    tmpStr = tmpStr.."_*5".._LTParser("str8053").." *0"..m_societyInfo.nCurrMemberCount.."/"..m_societyInfo.nMaxMemberCount--公会人数
    tmpStr = tmpStr.."_*5".._LTParser("str8055").." *0"..m_societyInfo.nConTime --本周贡献
    tmpStr = tmpStr.."_*5".._LTParser("str3027").."   *0"..m_societyInfo.sumDevote--可用贡献
    tmpStr = tmpStr.."_*5".._LTParser("str8054").." *0"..m_societyInfo.dwExp.."/"..m_societyInfo.dwMaxExp  --公会经验
    local detailLabel = ParsedNode:getParsedNode(tmpStr,0,12)
    detailLabel:setPerWidthAndHeight(12,18)
    detailLabel:setAnchorPoint(CCPointMake(0,0));
    detailLabel:setPosition(CCPointMake(SX(7),height*0.85-detailLabel:getContentSize().height));
    contentLayer:addChild(detailLabel)
    
    
    if m_rank >0 and m_rank<4 then
        local topBtnStartX = width* 0.81
        local topBtnStartY = height* 0.92
        
        if m_accuseStatus == 2 then
            local accuseButton = SCButton:button(EnumBtnType9Atlas)
            setNodeContentSize(accuseButton, CCSizeMake(50, 26))
            accuseButton:setTitle(_LTParser("str8103"),getDefaultFontName(), getFontSize(12),getColorYellow())
	        local imgFile = getRealUIResourcePath(Img0008_ImagePath);
            accuseButton:setAnchorPoint(CCPointMake(0.5,0.5));
            accuseButton:setPosition(CCPointMake(topBtnStartX,topBtnStartY));
            accuseButton:luaSetSelectorOnClicked(accuseButtonAction)
            contentLayer:addChild(accuseButton)    
            topBtnStartY = topBtnStartY-accuseButton:getContentSize().height-SY(4)
        end
        --解散、离开按钮
        local leaveButton = SCButton:button(EnumBtnType9Atlas)
        setNodeContentSize(leaveButton, CCSizeMake(50, 26))
        leaveButton:setAnchorPoint(CCPointMake(0.5,0.5));
        leaveButton:setPosition(CCPointMake(topBtnStartX - SX(5),topBtnStartY - SY(5)));
        if m_rank == 1 then
             topBtnStartY = topBtnStartY-leaveButton:getContentSize().height-SY(4)
    
            --邮件按钮
            local mailButton = SCButton:button(EnumBtnType9Atlas)
            setNodeContentSize(mailButton, CCSizeMake(50, 26))
	        imgPath = getRealUIResourcePath("img/new00385.png")
			if imgPath then
				mailButton:setTitle(imgPath:getData())
			end
			
            mailButton:setAnchorPoint(CCPointMake(0.5,0.5));
            mailButton:setPosition(CCPointMake(topBtnStartX - SX(5),topBtnStartY - SY(5)));
            mailButton:luaSetSelectorOnClicked(mailButtonAction)
            contentLayer:addChild(mailButton)    
        
		    imgPath = getRealUIResourcePath("img/new00373.png")
			if imgPath then
				leaveButton:setTitle(imgPath:getData())--解散
			end
			
			--转让
			topBtnStartY = topBtnStartY-leaveButton:getContentSize().height-SY(4)
			local demiseButton = SCButton:button(EnumBtnType9Atlas)
			setNodeContentSize(demiseButton, CCSizeMake(50, 26))
			imgPath = getRealUIResourcePath("img/new00387.png")
			if imgPath then
				demiseButton:setTitle(imgPath:getData())
			end
			
            demiseButton:setAnchorPoint(CCPointMake(0.5,0.5));
			demiseButton:setTag(6);
            demiseButton:setPosition(CCPointMake(topBtnStartX - SX(5),topBtnStartY - SY(5)));
            demiseButton:luaSetSelectorOnClicked(onClickDemiseButton)
            contentLayer:addChild(demiseButton)    
        else
			local imgPath = getRealUIResourcePath("img/new00384.png")
			if imgPath then
				leaveButton:setTitle(imgPath:getData())--退出
			end
        end
        leaveButton:luaSetSelectorOnClicked(leaveButtonAction)
        contentLayer:addChild(leaveButton)
        
       
        
        --公会设置按钮
        local societySetButton = SCButton:button(EnumBtnType9Atlas)
		setNodeContentSize(societySetButton, CCSizeMake(75, 30))
        local imgPath = getRealUIResourcePath("img/new00549.png")
		if imgPath then
			societySetButton:setTitle(imgPath:getData());
		end
        societySetButton:setAnchorPoint(CCPointMake(0.5,0.5));
        societySetButton:setPosition(CCPointMake(width*0.73,SY(25)));
        societySetButton:luaSetSelectorOnClicked(societySetButtonAction)
        contentLayer:addChild(societySetButton)
    else
        --退出公会
        local leaveButton = SCButton:button(EnumBtnType9Atlas)
        setNodeContentSize(leaveButton, CCSizeMake(75, 30))
        local imgPath = getRealUIResourcePath("img/new00550.png")
		if imgPath then
			leaveButton:setTitle(imgPath:getData());
		end
	    --leaveButton:setTitle(_LTParser("str8079").._LTParser("str8045"),getDefaultFontName(), getFontSize(13),getColorYellow())
        leaveButton:setAnchorPoint(CCPointMake(0.5,0.5));
        leaveButton:setPosition(CCPointMake(width*0.73,SY(25)));
        leaveButton:luaSetSelectorOnClicked(leaveButtonAction)
        contentLayer:addChild(leaveButton)
    end
    
     --公会公告
	--[[
	imgPath = getRealUIResourcePath("img/new00376.png")
	if imgPath then
		local titleImage = SCImage:imageWithFile(imgPath:getData());
		if titleImage then
			titleImage:setAnchorPoint(CCPointMake(0,0));
			titleImage:setPosition(CCPointMake(SX(9),height*0.36));
			contentLayer:addChild(titleImage)
		end
	end
	--]]
	local titleLabel = ParsedNode:getParsedNode("*6".._LTParser("str8087"),0,18)
	if titleLabel then
		titleLabel:setAnchorPoint(CCPointMake(0,0));
		titleLabel:setPosition(CCPointMake(SX(9),height*0.36));
		contentLayer:addChild(titleLabel)
	end
    
    --公会公告
    local detailStr = m_societyInfo.szMsg
    if detailStr == nil then
        detailStr = ""
    end
    local showTextLabel = SCTextBox:boxWithWidthHeight(width*0.9,height*0.20);
    showTextLabel:setParserDelegate(TextParser:getSingleton())
    showTextLabel:setAnchorPoint(CCPointMake(0.5,0));
    showTextLabel:setPosition(CCPointMake(width/2,height*0.36-showTextLabel:getContentSize().height));
    showTextLabel:setText(detailStr)
    contentLayer:addChild(showTextLabel)
    
    
    --集会所按钮
    local enterButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(enterButton, CCSizeMake(75, 30))
	imgPath = getRealUIResourcePath("img/new00377.png")
	if imgPath then
		enterButton:setTitle(imgPath:getData());
	end
    enterButton:setAnchorPoint(CCPointMake(0.5,0.5));
    enterButton:setPosition(CCPointMake(width*0.27,SY(25)));
    enterButton:luaSetSelectorOnClicked(enterSocietyButtonAction)
    contentLayer:addChild(enterButton)
end

--获取公会信息
local function sendQuerySocietyInfoMsg()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_VIEW_SOCIATY_INFO);
    if m_idTribe then
        dt:writeInt(m_idTribe);
    end
    
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--获取成员列表
local function sendQueryMemberListMsg()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_MEMBER_LIST);
    if m_idTribe then
        dt:writeInt(m_idTribe);
    end
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--点击成员按钮响应
local function memberButtonAction()
    m_societyMemberList = nil
    sendQueryMemberListMsg()
    --showSocietyMemberList()
end

--打开显示公会主界面
function open_SocietyMainScreen(fatherLayer)
    if fatherLayer == nil then
        return
    end
    m_mainLayer = fatherLayer
    m_mainLayer:removeAllChildrenWithCleanup(true)
    local hero = Hero:getSingleton()
	if hero == nil then
		return;
	end
    
    m_rank = hero:getRank()
    m_idTribe = hero:getIdTribe()
    sendQuerySocietyInfoMsg()
    sendQueryMemberListMsg()
    
    local width = m_mainLayer:getContentSize().width
    local height = m_mainLayer:getContentSize().height
	
    local showLeftWidth  = width*0.40
	local showLeftHeight = height*0.98
	
	local leftStartX = SX(-4)
	local leftStartY = SY(5)
	
	local leftContentLayer = SCDragNode:node()
	leftContentLayer:setTag(1)
	leftContentLayer:setFrameType(EnumFrameTypeRound)
	leftContentLayer:setFrameVisibled(true)
	leftContentLayer:setAnchorPoint(CCPointMake(0,0));
	leftContentLayer:setPosition(CCPointMake(leftStartX,leftStartY));
	leftContentLayer:setContentSize(CCSizeMake(showLeftWidth,showLeftHeight))
    m_mainLayer:addChild(leftContentLayer)
	  
	local showRightWidth  = width*0.63
	local showRightHeight = height*0.88
	
	local rightStartX = leftStartX+showLeftWidth-SX(5)
	local rightStartY = SY(5)
	
	local rightContentLayer = SCDragNode:node()
	rightContentLayer:setTag(2)
	rightContentLayer:setFrameType(EnumFrameTypeRound)
	rightContentLayer:setFrameVisibled(true)
	rightContentLayer:setAnchorPoint(CCPointMake(0,0));
	rightContentLayer:setPosition(CCPointMake(rightStartX,rightStartY));
	rightContentLayer:setContentSize(CCSizeMake(showRightWidth,showRightHeight))
    m_mainLayer:addChild(rightContentLayer)
  
  
    --右上角按钮
    local rigthTopX = leftStartX+showLeftWidth+SX(5)
    local rigthTopY = height*0.96
    
	local imgPath1 = getRealUIResourcePath("kernal/multi-page-large-other.png")
	local imgPath2 = getRealUIResourcePath("kernal/multi-page-large-current.png")
	local imgPath3 = getRealUIResourcePath("img/new00367.png")	--成员
	local imgPath4 = getRealUIResourcePath("img/new00382.png")	--日志
	local imgPath5 = getRealUIResourcePath("img/new00371.png")	--活动
	local imgPath6 = getRealUIResourcePath("img/new00383.png")	--审核
	if imgPath1 == nil or imgPath2 == nil or imgPath3 == nil or imgPath4 == nil or imgPath5 == nil or imgPath6 == nil then
		return;
	end
	
    --成员按钮
    local memberButton = SCButton:button()
	memberButton:setTag(3)
	memberButton:setButtonType(EnumBtnType9Atlas)
	memberButton:setContentSize(AUTO_SIZE(70, 30))
	--memberButton:setBackgroundImage(imgPath1:getData());
	--memberButton:setSelectedImage(imgPath2:getData());
	memberButton:setTitle(imgPath3:getData())
    memberButton:setAnchorPoint(CCPointMake(0,0.5));
    memberButton:setPosition(CCPointMake(rigthTopX,rigthTopY));
    memberButton:luaSetSelectorOnClicked(memberButtonAction)--设置回调
    m_mainLayer:addChild(memberButton)
    
    
    rigthTopX = rigthTopX+memberButton:getContentSize().width+SX(1)
    --训练按钮
    local logButton = SCButton:button()
	logButton:setTag(4)
	logButton:setButtonType(EnumBtnType9Atlas)
	logButton:setContentSize(AUTO_SIZE(70, 30))
	logButton:setTitle(RES("img/new00489.png"))
    logButton:setAnchorPoint(CCPointMake(0,0.5));
    logButton:setPosition(CCPointMake(rigthTopX,rigthTopY));
    logButton:luaSetSelectorOnClicked(SocietyMainLayer_logButtonAction)--设置回调
    m_mainLayer:addChild(logButton)
    
    rigthTopX = rigthTopX+logButton:getContentSize().width+SX(1)
    --活动按钮
    local activityButton = SCButton:button()
	activityButton:setTag(5)
	activityButton:setButtonType(EnumBtnType9Atlas)
	activityButton:setContentSize(AUTO_SIZE(70, 30))
	activityButton:setTitle(imgPath4:getData())
    activityButton:setAnchorPoint(CCPointMake(0,0.5));
    activityButton:setPosition(CCPointMake(rigthTopX,rigthTopY));
    activityButton:luaSetSelectorOnClicked(journalButtonAction)--设置回调
    m_mainLayer:addChild(activityButton)
    
    if m_rank > 0 and m_rank < 4 then
        rigthTopX = rigthTopX+logButton:getContentSize().width+SX(1)
        --审核按钮
        local applyButton = SCButton:button(EnumBtnType9Atlas)
	    applyButton:setTag(6)
		applyButton:setButtonType(EnumBtnType9Atlas)
		applyButton:setContentSize(AUTO_SIZE(70, 30))
	    applyButton:setTitle(imgPath6:getData())
        applyButton:setAnchorPoint(CCPointMake(0,0.5));
        applyButton:setPosition(CCPointMake(rigthTopX,rigthTopY));
        applyButton:luaSetSelectorOnClicked(applyButtonAction)--设置回调
        m_mainLayer:addChild(applyButton)
    end
    
end

--获取公会信息
function processSocietyInfo_societyMain(dt)
    if m_mainLayer == nil then
        return
    end
    if dt == nil then
        return
    end

    local idTribe          = dt:readInt()--//公会ID
    local usLevel          = dt:readShort()--//等级
    local szTribeName      = dt:readString()--//名称
    local szLeaderName     = dt:readString()--//会长
    local nCurrMemberCount = dt:readShort()--//当前公会人数
    local nMaxMemberCount  = dt:readShort()--//最大公会人数
    local nRank            = dt:readInt()--//公会排名
    local dwExp            = dt:readInt()--//公会当前经验
    local dwMaxExp         = dt:readInt()--//公会升级经验
    local szMsg            = dt:readString()--公告
    local szMsg1           = dt:readString()--公会介绍
    local nConTime         = dt:readInt()--  /** 个人周贡献*/
    m_accuseStatus         = dt:readByte()--弹劾标记
    local sumDevote        = dt:readInt()--//个人总贡献
    local societyInfo = {}
    societyInfo.idTribe = idTribe
    societyInfo.usLevel = usLevel
    if szTribeName then
        societyInfo.szTribeName = szTribeName:getData()
    end
    if szLeaderName then
        societyInfo.szLeaderName = szLeaderName:getData()
    end
    
    societyInfo.nCurrMemberCount = nCurrMemberCount
    societyInfo.nMaxMemberCount = nMaxMemberCount
    societyInfo.nRank = nRank
    societyInfo.dwExp = dwExp
    societyInfo.dwMaxExp = dwMaxExp
    if szMsg then
        societyInfo.szMsg = szMsg:getData()
    end
    if szMsg1 then
        societyInfo.szMsg1 = szMsg1:getData()
    end
    societyInfo.nConTime = nConTime
    societyInfo.sumDevote = sumDevote
    m_societyInfo = societyInfo
    
    showLeftSocietyInfoContent()
end
--更新公会信息
function upProcessSocietyInfo_societyMain(dt)
    if m_mainLayer == nil then
        return
    end
    if dt == nil then
        return
    end

    local idTribe          = dt:readInt()--//公会ID
    local usLevel          = dt:readShort()--//等级
    local szTribeName      = dt:readString()--//名称
    local szLeaderName     = dt:readString()--//会长
    local nCurrMemberCount = dt:readShort()--//当前公会人数
    local nMaxMemberCount  = dt:readShort()--//最大公会人数
    local nRank            = dt:readInt()--//公会排名
    local dwExp            = dt:readInt()--//公会当前经验
    local dwMaxExp         = dt:readInt()--//公会升级经验
    local szMsg            = dt:readString()--公告
    local szMsg1           = dt:readString()--公会介绍
    local nConTime         = dt:readInt()--  /** 贡献*/
    m_accuseStatus         = dt:readByte()--弹劾标记
    local societyInfo = {}
    societyInfo.idTribe = idTribe
    societyInfo.usLevel = usLevel
    if szTribeName then
        societyInfo.szTribeName = szTribeName:getData()
    end
    if szLeaderName then
        societyInfo.szLeaderName = szLeaderName:getData()
    end
    
    societyInfo.nCurrMemberCount = nCurrMemberCount
    societyInfo.nMaxMemberCount = nMaxMemberCount
    societyInfo.nRank = nRank
    societyInfo.dwExp = dwExp
    societyInfo.dwMaxExp = dwMaxExp
    if szMsg then
        societyInfo.szMsg = szMsg:getData()
    end
    if szMsg1 then
        societyInfo.szMsg1 = szMsg1:getData()
    end
    societyInfo.nConTime = nConTime

    m_societyInfo = societyInfo
    
    
end


--获取公会成员列表
function processSocietyMemberList_societyMain(dt)
    if dt == nil then
        return
    end
    if m_societyMemberList == nil then
        m_societyMemberList = {}
    end
    
    local idTribe  = dt:readInt()
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local idMember      = dt:readInt()
        local szName        = dt:readString()
        local usLevel       = dt:readShort()
        local ucRank        = dt:readByte()--//职务
        local nArenaRank    = dt:readInt()--//竞技排名
        local ucSex         = dt:readByte()--//性别
        local dwTodayProfer = dt:readInt()--//今日贡献
        local dwSumProfer   = dt:readInt()--//总贡献
        local szLoginTime   = dt:readString()--//登录时间
        
        local tmpDetail = {}
        tmpDetail.idMember = idMember
        if szName then
            tmpDetail.szName = szName:getData()
        end
        
        tmpDetail.usLevel       = usLevel
        tmpDetail.ucRank        = ucRank
        tmpDetail.nArenaRank    = nArenaRank
        tmpDetail.ucSex         = ucSex
        tmpDetail.dwTodayProfer = dwTodayProfer
        tmpDetail.dwSumProfer   = dwSumProfer
        if szLoginTime then
            tmpDetail.szLoginTime = szLoginTime:getData()
        end
        
        table.insert(m_societyMemberList,tmpDetail);
    end
    m_viceChairman = nil
    showSocietyMemberList()
end

--成员信息更新
function processSocietyMemberUpdate_societyMain(dt)
    if dt == nil then
        return
    end
    SCActivityIndicator:getSingleton():close();
    if m_societyMemberList == nil then
        return
    end    
    local listAmount = #m_societyMemberList
    if listAmount < 1 then
        return
    end
    
    local idTribe  = dt:readInt()--入口已经读过
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local idMember      = dt:readInt()
        local szName        = dt:readString()
        local usLevel       = dt:readShort()
        local ucRank        = dt:readByte()--//职务
        local nArenaRank    = dt:readInt()--//竞技排名
        local ucSex         = dt:readByte()--//性别
        local dwTodayProfer = dt:readInt()--//今日贡献
        local dwSumProfer   = dt:readInt()--//总贡献
        local szLoginTime   = dt:readString()--//登录时间
        
        local tmpDetail = {}
        tmpDetail.idMember = idMember
        if szName then
            tmpDetail.szName = szName:getData()
        end
        
        tmpDetail.usLevel       = usLevel
        tmpDetail.ucRank        = ucRank
        tmpDetail.nArenaRank    = nArenaRank
        tmpDetail.ucSex         = ucSex
        tmpDetail.dwTodayProfer = dwTodayProfer
        tmpDetail.dwSumProfer   = dwSumProfer
        if szLoginTime then
            tmpDetail.szLoginTime = szLoginTime:getData()
        end
        
        for j=1,listAmount do
            if m_societyMemberList[j] and m_societyMemberList[j].idMember == idMember then
                table.remove(m_societyMemberList,j)
                table.insert(m_societyMemberList,j,tmpDetail);
                break
            end
        end
    end
    showSocietyMemberList()
end

function processDeleteMember_societyMain(idMember)
    m_viceChairman = nil
    if m_societyMemberList then
        local amount = #m_societyMemberList
        for i=1,amount do
            if m_societyMemberList[i] then
                if m_societyMemberList[i].idMember == idMember then
                    table.remove(m_societyMemberList,i)
                    showSocietyMemberList()
                    return
                end
            end
        end
    end
end

--处理公会日志
function processJournal_societyMain(dt)
    if dt == nil then
        return
    end
    if m_societyLogList == nil then
        m_societyLogList = {}
    end
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local idPlayer = dt:readInt()
        local szName   = dt:readString()
        local szWords  = dt:readString()
        local szTime   = dt:readString()
        local tmpDetail = {}
        tmpDetail.idPlayer = idPlayer
        if szName then
            tmpDetail.szName = szName:getData()
        else
            tmpDetail.szName = ""
        end
        if szWords then
            tmpDetail.szWords = szWords:getData()
        else
            tmpDetail.szWords = ""
        end
        if szTime then
            tmpDetail.szTime = szTime:getData()
        else
            tmpDetail.szTime = ""
        end
        table.insert(m_societyLogList,tmpDetail);
    end
    showSocietyjournal()
end



--处理公会训练
function processLog_societyMain()   --还未接受完成
	local dt = LuaData:getSingleton():getDataTransStream();  ---获取当前的数据对象
    if dt == nil then
        return
    end
    nClanProffer = dt:readInt()
    local ucAmount = dt:readByte();
    for i = 1, ucAmount do		--服务端最好要家一个这次传多少数据过来
        table.insert(TrainTable, SetMagicInfo.initWithStream(dt))
    end
    SCActivityIndicator:getSingleton():close();   ----关闭等待转圈图标
end

function processLog_societyMainEnd()    --最后一条接受完成
	local dt = LuaData:getSingleton():getDataTransStream();  ---获取当前的数据对象
    if dt == nil then
        return
    end
    nClanProffer = dt:readInt()
    local ucAmount = dt:readByte();
    for i = 1, ucAmount do		
        table.insert(TrainTable, SetMagicInfo.initWithStream(dt))
    end
	showSocietyLog()
	SCActivityIndicator:getSingleton():close();   ----关闭等待转圈图标
end

function processLog_societyMainup()     --技能更新后刷新界面
	local dt = LuaData:getSingleton():getDataTransStream();  ---获取当前的数据对象
    if dt == nil then
        return
    end
    nClanProffer = dt:readInt()
    local ucAmount = dt:readByte();
    local nMagicType = dt:readInt();  --210001 210002 210003 210004
	local ucLevel = dt:readByte() + 1;
	local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    if nMagicType == 210001 then
        TrainTable[1].ucLevel = ucLevel - 1
        local pNode1 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("1", contentLayer), "SCNode")
        local Label = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("10022", pNode1), "SCLabel")
        Label:setText(L("str0336")..ucLevel * (ucLevel - 1) * 10);
        Label = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("10024", pNode1), "SCLabel")
        Label:setText(L("str0335")..ucLevel * ucLevel * 100 + ucLevel * 300 + 200);
        if ucLevel > 100 then
		    Label:setVisible(false)
		end
        pNode1:removeChildByTag(10042, true)
        local pNode = getImageNumber(ucLevel - 1, "img/new00530.pn", SX(12.2), SY(18))     --玄甲值数字显示
        if ucLevel > 100 then
            pNode = getImageNumber(ucLevel - 1, "img/new00530.png", SX(12.2), SY(18), SX(9))
        end
        if pNode then
            pNode:setTag(10042)
            pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
            pNode:setPosition(AUTO_POS(55, 63.50))
            if ucLevel > 100 then
                pNode:setPosition(AUTO_POS(53, 63.50))
            end
        end
        if pNode and pNode1 then
            pNode1:addChild(tolua.cast(pNode, "SCNode"))
        end
        contentLayer:removeChildByTag(10041, true)
        local pNodePow = getIamgeNum(nClanProffer, "img/new00487.png", SX(17), SX(10), SY(18))     --士气值数字显示
        if pNodePow then
            pNodePow:setTag(10041)
            pNodePow:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
            pNodePow:setPosition(AUTO_POS(50.00, 8.00))
        end
        if pNodePow and contentLayer then
            contentLayer:addChild(tolua.cast(pNodePow, "SCNode"))
        end
    elseif nMagicType == 210002 then
        TrainTable[2].ucLevel = ucLevel - 1
        local pNode2 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("2", contentLayer), "SCNode")
        local Label = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("10027", pNode2), "SCLabel")
        Label:setText(L("str0337")..ucLevel * (ucLevel - 1));
        Label = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("10029", pNode2), "SCLabel")
        Label:setText(L("str0335")..ucLevel * ucLevel * 100 + ucLevel * 300 + 200);
        if ucLevel > 100 then
		    Label:setVisible(false)
		end
        pNode2:removeChildByTag(10043, true)
        local pNode = getImageNumber(ucLevel - 1, "img/new00530.pn", SX(12.2), SY(18))     --射声值数字显示
        if ucLevel > 100 then
            pNode = getImageNumber(ucLevel - 1, "img/new00530.png", SX(12.2), SY(18), SX(9))
        end
        if pNode then
            pNode:setTag(10043)
            pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
            pNode:setPosition(AUTO_POS(55, 63.50))
            if ucLevel > 100 then
                pNode:setPosition(AUTO_POS(53, 63.50))
            end
        end
        if pNode and pNode2 then
            pNode2:addChild(tolua.cast(pNode, "SCNode"))
        end
        contentLayer:removeChildByTag(10041, true)
        local pNodePow = getIamgeNum(nClanProffer, "img/new00487.png", SX(17), SX(10), SY(18))     --士气值数字显示
        if pNodePow then
            pNodePow:setTag(10041)
            pNodePow:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
            pNodePow:setPosition(AUTO_POS(50.00, 8.00))
        end
        if pNodePow and contentLayer then
            contentLayer:addChild(tolua.cast(pNodePow, "SCNode"))
        end
    elseif nMagicType == 210003 then
        TrainTable[3].ucLevel = ucLevel - 1
        local pNode3 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("3", contentLayer), "SCNode")
        local Label = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("10032", pNode3), "SCLabel")
        Label:setText(L("str0338")..ucLevel * (ucLevel - 1) * 2);
        Label = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("10034", pNode3), "SCLabel")
        Label:setText(L("str0335")..ucLevel * ucLevel * 100 + ucLevel * 300 + 200);
        if ucLevel > 100 then
		    Label:setVisible(false)
		end
        pNode3:removeChildByTag(10044, true)
        local pNode = getImageNumber(ucLevel - 1, "img/new00530.pn", SX(12.2), SY(18))     --折冲值数字显示
        if ucLevel > 100 then
            pNode = getImageNumber(ucLevel - 1, "img/new00530.png", SX(12.2), SY(18), SX(9))
        end
        if pNode then
            pNode:setTag(10044)
            pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
            pNode:setPosition(AUTO_POS(55, 63.50))
            if ucLevel > 100 then
                pNode:setPosition(AUTO_POS(53, 63.50))
            end
        end
        if pNode and pNode3 then
            pNode3:addChild(tolua.cast(pNode, "SCNode"))
        end
        contentLayer:removeChildByTag(10041, true)
        local pNodePow = getIamgeNum(nClanProffer, "img/new00487.png", SX(17), SX(10), SY(18))     --士气值数字显示
        if pNodePow then
            pNodePow:setTag(10041)
            pNodePow:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
            pNodePow:setPosition(AUTO_POS(50.00, 8.00))
        end
        if pNodePow and contentLayer then
            contentLayer:addChild(tolua.cast(pNodePow, "SCNode"))
        end
    elseif nMagicType == 210004 then
        TrainTable[4].ucLevel = ucLevel - 1
        local pNode4 = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("4", contentLayer), "SCNode")
        local Label = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("10037", pNode4), "SCLabel")
        Label:setText(L("str0339")..ucLevel * (ucLevel - 1) / 2);
        Label = tolua.cast(SCFunction:getUiNodeByIdlistAndParent("10039", pNode4), "SCLabel")
        Label:setText(L("str0335")..ucLevel * ucLevel * 100 + ucLevel * 300 + 200);
        if ucLevel > 100 then
		    Label:setVisible(false)
		end
        pNode4:removeChildByTag(10045, true)
        local pNode = getImageNumber(ucLevel - 1, "img/new00530.pn", SX(12.2), SY(18))
        if ucLevel > 100 then
            pNode = getImageNumber(ucLevel - 1, "img/new00530.png", SX(12.2), SY(18), SX(9))
        end
        if pNode then
            pNode:setTag(10045)
            pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
            pNode:setPosition(AUTO_POS(55, 63.50))
            if ucLevel > 100 then
                pNode:setPosition(AUTO_POS(53, 63.50))
            end
        end
        if pNode and pNode4 then
            pNode4:addChild(tolua.cast(pNode, "SCNode"))
        end
        contentLayer:removeChildByTag(10041, true)
        local pNodePow = getIamgeNum(nClanProffer, "img/new00487.png", SX(17), SX(10), SY(18))     --士气值数字显示
        if pNodePow then
            pNodePow:setTag(10041)
            pNodePow:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
            pNodePow:setPosition(AUTO_POS(50.00, 8.00))
        end
        if pNodePow and contentLayer then
            contentLayer:addChild(tolua.cast(pNodePow, "SCNode"))
        end
    end
    SCActivityIndicator:getSingleton():close();   ----关闭等待转圈图标
end
--获取活动列表数据
function processsActivityList_societyMain(dt)
    if dt == nil then
        return
    end
    if m_societyActivityList == nil then
        m_societyActivityList = {}
    end
    m_societyActivityList = {}
    local ucAmount = dt:readByte()
    m_activityNum = ucAmount
    for i=1,ucAmount do
        local usCampaignType = dt:readShort()
        local szMsg          = dt:readString()--//活动说明
        local ucFlag         = dt:readByte()--//挑战次数
        local ucTakePartIn   = dt:readByte()--//1: 可参与
        
        local tmpDetail = {}
        tmpDetail.usCampaignType = usCampaignType
		if szMsg == nil then
			tmpDetail.szMsg	= ""
		else
			tmpDetail.szMsg	= szMsg:getData()
		end
        tmpDetail.ucFlag         = ucFlag
        tmpDetail.ucTakePartIn   = ucTakePartIn
        table.insert(m_societyActivityList,tmpDetail);
    end
    showActivityContent()
end

--获取申请人列表
function processApplyList_societyMain(dt)
    if dt == nil then
        return
    end
     if m_societyApplyList == nil then
        m_societyApplyList = {}
    end
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local idMember = dt:readInt()
        local szName         = dt:readString()--
        local usLevel        = dt:readShort()
        local nArenaRank     = dt:readInt()
        local szProposerTim  = dt:readString()--//申请时间
        
        local tmpDetail = {}
        tmpDetail.idMember     = idMember
        if szName then
             tmpDetail.szName   = szName:getData()
        end
        tmpDetail.usLevel      = usLevel
        tmpDetail.nArenaRank   = nArenaRank
        if szProposerTim then
            tmpDetail.szProposerTim   = szProposerTim:getData()
        end
        table.insert(m_societyApplyList,tmpDetail);
    end
    showApplyList()
end

--更新申请列表
function processDeleteApplyList_societyMain(dt)
    if dt == nil then
        return
    end
    local idMember = dt:readInt()
    if m_societyApplyList == nil then
        return
    end
    local amount = #m_societyApplyList
    local index = -1
    for i=1,amount do
        if m_societyApplyList[i] and m_societyApplyList[i].idMember == idMember then
            table.remove(m_societyApplyList,i)
            index = i
            break
        end
    end
    if index == -1 then
        return
    end
    if m_mainLayer == nil then
        return
    end
    local contentLayer = m_mainLayer:getChildByTag(2);
    if contentLayer == nil then
        return
    end
    local listBox = contentLayer:getChildByTag(4001)
    if listBox then
        listBox = SCTypeCast:castNodeToListBox(listBox)
        listBox:removeItemAtIndex(index-1)
    end
end

--是否支持弹劾
function processAccuse_societyMain(dt)
    if dt == nil then
        return
    end
    local szMsg1 = dt:readString()
    if szMsg1 then
        szMsg1 = szMsg1:getData()
    else
        return     
    end
    
    local width = SX(300)
    local height = SY(120)
    local frameWndNode = FrameWindow:frameWnd()
    frameWndNode:setTag(8011001)
    frameWndNode:setOutSpaceClickClose(true)
    frameWndNode:setContentSize(CCSizeMake(width, height))
    frameWndNode:setFrameVisibled(true)
    frameWndNode:setCloseBtnVisible(false)

    if szMsg1 then
	    local showTextLabel = SCTextBox:boxWithWidthHeightFont(width*0.8,height*0.5,getDefaultFontName(), getFontSize(14));
	    showTextLabel:setParserDelegate(TextParser:getSingleton())
	    showTextLabel:setAnchorPoint(CCPointMake(0,0));
	    showTextLabel:setPosition(CCPointMake(width*0.1,height*0.8-showTextLabel:getContentSize().height));
	    showTextLabel:setText(szMsg1)
	    showTextLabel:setScrollHorizontal(false)
	    showTextLabel:setScrollVertical(false)
        frameWndNode:addChild(showTextLabel)
    end
    
    local agreeButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(agreeButton, CCSizeMake(50, 26))
    agreeButton:setTitle(_LTParser("str8104"),getDefaultFontName(), getFontSize(12),getColorYellow())
    local imgFile = getRealUIResourcePath(Img0008_ImagePath);
    agreeButton:setAnchorPoint(CCPointMake(0.5,0));
    agreeButton:setPosition(CCPointMake(width*0.3,SY(10)));
    agreeButton:luaSetSelectorOnClicked(agreeAccuseButtonAction)
    frameWndNode:addChild(agreeButton)   

    local disagreeButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(disagreeButton, CCSizeMake(50, 26))
    disagreeButton:setTitle(_LTParser("str8105"),getDefaultFontName(), getFontSize(12),getColorYellow())
    local imgFile = getRealUIResourcePath(Img0008_ImagePath);
    disagreeButton:setAnchorPoint(CCPointMake(0.5,0));
    disagreeButton:setPosition(CCPointMake(width*0.7,SY(10)));
    disagreeButton:luaSetSelectorOnClicked(disagreeAccuseButtonAction)
    frameWndNode:addChild(disagreeButton)    
            
    local scene = SCBaseScene:getRunningScene()
    if scene then
        scene:getUINode():addChild(frameWndNode, Max_Int)
    end
end

local function ButtonLeft()  --左按钮回调
    --local pageScrollBox = SCFunction:getUiNodeByIdlist("4421-1-6")
    --pageScrollBox:setOffset(CCPointMake(108, 0))
end

local function ButtonRight()  --右按钮回调
    
end

local function ButtonClsWnd()  --右按钮回调
    POP_TOP_CTRL()
end

----------------UI控制器区----------------
--翻页处理
local function nextPageAction()
    local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4421-77"));
    if pImg then
        --pImg:setVisible(false)
    end
end
local function upPageAction()
    local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4421-77"));
    if pImg then
        --pImg:setVisible(true)
    end
end
function showActivityWindow.initControl()
	local Wnd = SCWindow:window()
	if Wnd then
		Wnd:setTag(4421)
		Wnd:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Wnd:setPosition(AUTO_POS(0.00, 0.00))
		Wnd:setContentSize(AUTO_SIZE(480, 320))
		Wnd:setBackButtonVisibled(false);
		Wnd:setCloseButtonVisibled(false);
		Wnd:setFrameVisibled(false); 
		Wnd:luaSetSelectorOnClose(showActivityWindow.releaseControl)
	end
	
	local width = Wnd:getContentSize().width
	local height = Wnd:getContentSize().height
	
	local pDragNode = SCDragNode:node()
	if pDragNode then
	    pDragNode:setTag(1)
		pDragNode:setAnchorPoint(ANCHOR_CENTER)
		pDragNode:setPosition(CCPointMake(width/2 - SX(1), height/2))
		pDragNode:setContentSize(AUTO_SIZE(480, 264))
		pDragNode:setDragEnabled(false)
		Wnd:addChild(tolua.cast(pDragNode, "SCNode"))
	end
    if not pDragNode then
        return
    end
	local imgPath = getRealUIResourcePath("img/new00124.pn")
	local pImage10001 = SCImage:imageWithFile(imgPath:getData())
	if pImage10001 and imgPath then
		pImage10001:setTag(2)
		pImage10001:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10001:setPosition(AUTO_POS(5.00, -24.00))
		--pImage10001:setContentSize(AUTO_SIZE(472, 240))
		pImage10001:setScaleY(1.3)
		pDragNode:addChild(tolua.cast(pImage10001, "SCNode"))
	end
    
    local imgPath = getRealUIResourcePath("img/new00568.png")
    local pImage = SCImage:imageWithFile(imgPath:getData())
    if pImage and imgPath then
        pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pImage:setPosition(AUTO_POS(210.00, 265.00))
        --pImage:setContentSize(AUTO_SIZE(472, 240))
        pDragNode:addChild(pImage)
    end
    
    local imgPath = getRealUIResourcePath("img/new00570.png")
    local pImage = SCImage:imageWithFile(imgPath:getData())
    if pImage and imgPath then
        pImage:setTag(77)
        pImage:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pImage:setPosition(AUTO_POS(40.00, 7.00))
        --pImage:setContentSize(AUTO_SIZE(472, 240))
        Wnd:addChild(pImage)
    end
    
    local ClsButton = SCButton:button()    --关闭窗口按钮
	if ClsButton then
		ClsButton:setTag(3)
		ClsButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		ClsButton:setPosition(AUTO_POS(455.50, 265.50))
		ClsButton:setContentSize(AUTO_SIZE(38, 38))
		ClsButton:setTouchRectScale(4.0,4.0)
		ClsButton:setTitle(RES("img/new00123.png"))
		ClsButton:luaSetSelectorOnClicked(ButtonClsWnd)
        pDragNode:addChild(tolua.cast(ClsButton, "SCNode"))
	end
	
	
	
	
	
	
	local showWidth  = SX(460)
    local showHeight = SY(290)
    local scrollBox = SCPageScrollBox:boxWithWidthHeight(showWidth,showHeight)
    if not scrollBox then
	    return
	end
    scrollBox:setTag(10)
	scrollBox:setAnchorPoint(CCPointMake(0.5,0));
	scrollBox:setPosition(CCPointMake(SX(240),SY(18)));
	scrollBox:setScrollHorizontal(true)
    scrollBox:setScrollVertical(false)
    scrollBox:setPageSize(CCSizeMake(showWidth,showHeight));
    scrollBox:luaSetSelectorOnScrollToPrevious(upPageAction)
    scrollBox:luaSetSelectorOnScrollToNext(nextPageAction)
	
	Wnd:addChild(scrollBox)
	local pNode = nil;
	for k = 1,2 do
	    pNode = SCNode:node();
	    if pNode then
            pNode:setPosition(CCPointMake(showWidth * ( k - 1 ), 0));
            scrollBox:addChild(pNode);
            pNode:setTag(k);
            scrollBox:setContentSize(CCSizeMake(showWidth * scrollBox:getPageCount(), showHeight));
        end
        if pNode and k == 1 then
            for q = 1,5 do
                local flg = 0
                local count1 = 0
                local count2 = 0
                local i = 0
                if 3 > q then
                    i = q
                elseif 3 == q then
                    i = 6
                    flg = 1
                else
                    i = q - 1
                end
                if m_societyActivityList[i] then
                    count1 = m_societyActivityList[i].ucFlag 
                    if count1 < 10 then
                        count1 = 0
                    elseif count1 > 9 then
                        count1 = getIntPart(count1/10)
                    end
                    count2 = m_societyActivityList[i].ucFlag 
                    if count2 > 9 then
                        count2 = count2%10
                    end
                        
                        
                    if m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_MORALE then    --//士气训练
                        if luaIsUnlock(UNLOCK_TYPE_MORALE_TRAIN) then
                            flg = 1
                        end
                    elseif m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_RAPPZLE then  --//桃园结义
                        if luaIsUnlock(UNLOCK_TYPE_TRIBE_CAMPAIGN_RAPPZLE) then
                            flg = 1
                        end
                    elseif m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_FATTY then   --//肥肥大战
                        if luaIsUnlock(UNLOCK_TYPE_TRIBE_CAMPAIGN_FATTY) then
                            flg = 1
                        end
                    elseif m_societyActivityList[i].usCampaignType == TRIBE_INDIANA_ACTIVETIES then --//深渊挑战
                        if luaIsUnlock(UNLOCK_TYPE_TRIBE_CAMPAIGN_TRIBE_BOSS) then
                            flg = 1
                        end
                    elseif m_societyActivityList[i].usCampaignType == TRIBE_DEVIL_INSIDE then      --//心魔大战
                        if luaIsUnlock(UNLOCK_TYPE_TRIBE_CAMPAIGN_FATTY) then
                            flg = 1
                        end
                    end
                end
                local pDragNode = SCDragNode:node()
                if pDragNode then
                    pDragNode:setTag(i * 10)
                    pDragNode:setAnchorPoint(CCPointMake(0,0))
                    pDragNode:setPosition(AUTO_POS(92* (q - 1),0))
                    pDragNode:setContentSize(AUTO_SIZE(92, 264))
                    pDragNode:setDragEnabled(false)
                    pNode:addChild(tolua.cast(pDragNode, "SCNode"))
                    local imgPath = nil
                    local imgPath2 = nil
                    if 1 == i then 
                        imgPath = getRealUIResourcePath("img/new00403.jpg")
                        imgPath2 = getRealUIResourcePath("img/new00402.png")
                    elseif 2 == i then
                        imgPath = getRealUIResourcePath("img/new00405.jpg")
                        imgPath2 = getRealUIResourcePath("img/new00404.png")
                    elseif 6 == i then
                        imgPath = getRealUIResourcePath("tribe/new00827.png")
                        imgPath2 = getRealUIResourcePath("tribe/new00828.png")
                        
                    elseif 3 == i then
                        imgPath = getRealUIResourcePath("img/new00431.jpg")
                        imgPath2 = getRealUIResourcePath("img/new00434.png")
                        
                    elseif 4 == i then
                        imgPath = getRealUIResourcePath("img/new00430.jpg")
                        imgPath2 = getRealUIResourcePath("img/new00433.png")
                        
                    end
                    
                    if imgPath and imgPath2 then
                        local cuttingLine = SCImage:imageWithFile(imgPath:getData());
                        if cuttingLine then
                            cuttingLine:setAnchorPoint(CCPointMake(0,0));
                            cuttingLine:setPosition(CCPointMake(SX(0),SY(0)));
                            pDragNode:addChild(cuttingLine);
                        end
                        local cuttingLine2 = SCImage:imageWithFile(imgPath2:getData());
                        if cuttingLine2 then
                            cuttingLine2:setAnchorPoint(CCPointMake(0.5,0.5));
                            cuttingLine2:setPosition(CCPointMake(SX(46),SY(250)));
                            pDragNode:addChild(cuttingLine2);
                        end
                    end
                    local imgPath3 = getRealUIResourcePath("img/new00571.png")
                    if imgPath3 then
                        local cuttingLine3 = SCImage:imageWithFile(imgPath3:getData());
                        if cuttingLine3 then
                            
                            cuttingLine3:setAnchorPoint(CCPointMake(0,0));
                            cuttingLine3:setPosition(CCPointMake(SX(0),SY(0)));
                            pDragNode:addChild(cuttingLine3);
                            if 1 == flg then
                                cuttingLine3:setVisible(false)
                            end
                            
                        end
                    end
                    local imgPath4 = getRealUIResourcePath("img/2001001.png") --金钱小图标
                    if 6 == i then
                        imgPath4 = getRealUIResourcePath("img/2001008.png")
                    end
                    if imgPath4 then
                        local cuttingLine4 = SCImage:imageWithFile(imgPath4:getData());
                        if cuttingLine4 then
                            cuttingLine4:setScale(0.6,0.6) --//缩小
                            cuttingLine4:setAnchorPoint(CCPointMake(0.5,0.5));
                            cuttingLine4:setPosition(CCPointMake(SX(15),SY(20)));
                            pDragNode:addChild(cuttingLine4);
                            if i ~= 3 and 4 ~= i and 6 ~= i then
                                cuttingLine4:setVisible(false)
                            end
                            if 0 == flg then
                                cuttingLine4:setVisible(false)
                            end
                        end
                    end
                    local imgPath5 = nil
                    --设置中间小图标
                    if 7 == i then
                        imgPath5 = getRealUIResourcePath("img/2001003.png")  --声望小图标
                    else
                        imgPath5 = getRealUIResourcePath("img/new00582.png") --士气小图标
                    end
                    if imgPath5 then
                        local cuttingLine5 = SCImage:imageWithFile(imgPath5:getData());
                        if cuttingLine5 then
                            cuttingLine5:setScale(0.7,0.7)
                            cuttingLine5:setAnchorPoint(CCPointMake(0.5,0.5));
                            cuttingLine5:setPosition(CCPointMake(SX(45),SY(20)));
                            pDragNode:addChild(cuttingLine5);
                            if 0 == flg or 4 == i or 3 == i or 6 == i then
                                cuttingLine5:setVisible(false)
                            end
                        end
                    end
                    local imgPath6 = getRealUIResourcePath("img/2001006.png") --战功小图标
                    if 3 == i or 5 == i then
                        imgPath6 = getRealUIResourcePath("img/2001003.png")   --声望小图标
                    elseif 6 == i then
                        imgPath6 = getRealUIResourcePath("tribe/new00825.pn")
                    end
                    if imgPath6 then
                        local cuttingLine6 = SCImage:imageWithFile(imgPath6:getData());
                        if cuttingLine6 then
                            cuttingLine6:setScale(0.7,0.7)
                            cuttingLine6:setAnchorPoint(CCPointMake(0.5,0.5));
                            cuttingLine6:setPosition(CCPointMake(SX(75),SY(20)));
                            pDragNode:addChild(cuttingLine6);
                            if i ~= 3 and 4 ~= i and 6 ~= i then
                                cuttingLine6:setVisible(false)
                            end
                            if 0 == flg then
                                cuttingLine6:setVisible(false)
                            end
                        end
                    end
                    local imgPath7 = getRealUIResourcePath("img/new00401.png")
                    if imgPath7 and i~=6 then
                        local cuttingLine7 = SCImage:imageWithFile(imgPath7:getData());
                        if cuttingLine7 then
                            --cuttingLine7:setScale(0.7,0.7)
                            cuttingLine7:setAnchorPoint(CCPointMake(0.5,0.5));
                            cuttingLine7:setPosition(CCPointMake(SX(46),SY(40)));
                            pDragNode:addChild(cuttingLine7);
                            if 0 == flg then
                                cuttingLine7:setVisible(false)
                            end
                        end
                    end
                    local imgPath8 = getRealUIResourcePath("img/new00085.png")
                    if imgPath8 and i~=6 then
                        local cuttingLine8 = SCImage:imageWithFile(imgPath8:getData(), CCRectMake(SX(11.8*count1), SY(0), SX(11.8), SY(20)))
                        --cuttingLine8:setScale(1.2,1.2)
                        cuttingLine8:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine8:setPosition(CCPointMake(SX(48),SY(38)));
                        pDragNode:addChild(cuttingLine8);
                        if 0 == flg then
                            cuttingLine8:setVisible(false)
                        end
                    end
                    
                    local imgPath9 = getRealUIResourcePath("img/new00085.png")
                    if imgPath9 and i~=6 then
                        
                        local cuttingLine9 = SCImage:imageWithFile(imgPath9:getData(), CCRectMake(SX(11.8*count2), SY(0), SX(11.8), SY(20)))
                        --cuttingLine9:setScale(1.2,1.2)
                        cuttingLine9:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine9:setPosition(CCPointMake(SX(62),SY(38)));
                        pDragNode:addChild(cuttingLine9);
                        if 0 == flg then
                            cuttingLine9:setVisible(false)
                        end
                    end
                    local pBtn = SCButton:button();
                    if pBtn then
                        pBtn:setContentSize(pDragNode:getContentSize());
                        pBtn:luaSetSelectorOnClicked(onUnActivityBtnClick)
                        if 1 == flg then
                            pBtn:luaSetSelectorOnClicked(onActivityBtnClick);
                        end
                       
                        pBtn:setTag(i);
                        
                        pDragNode:addChild(pBtn);
                    end
                    --[[
                    local imgPath10 = getRealUIResourcePath("img/new00085.png")
                    if imgPath10 then
                        local count = 0
                        if m_societyActivityList[i] then
                            count = m_societyActivityList[i].ucFlag
                        end
                        local numImage = getIamgeNum(count, "img/new00085.png", 28, 23, 28)
                        if numImage then
                            numImage:setAnchorPoint(CCPointMake(0.5,0.5));
                            numImage:setPosition(CCPointMake(SX(66),SY(40)));
                            pDragNode:addChild(numImage)
                        end
                    end
                    ]]--
                end
                
            end
        elseif pNode and 2 == k then
            local pDragNode = SCDragNode:node()
            if pDragNode then
                pDragNode:setTag(60)
                pDragNode:setAnchorPoint(CCPointMake(0,0))
                pDragNode:setPosition(AUTO_POS(0,0))
                pDragNode:setContentSize(AUTO_SIZE(92, 264))
                pDragNode:setDragEnabled(false)
                pNode:addChild(tolua.cast(pDragNode, "SCNode"))
                imgPath = getRealUIResourcePath("img/new00429.jpg")
                imgPath2 = getRealUIResourcePath("img/new00432.png")
                if imgPath and imgPath2 then
                    local cuttingLine = SCImage:imageWithFile(imgPath:getData());
                    if cuttingLine then
                        cuttingLine:setAnchorPoint(CCPointMake(0,0));
                        cuttingLine:setPosition(CCPointMake(SX(0),SY(0)));
                        pDragNode:addChild(cuttingLine);
                    end
                    local cuttingLine2 = SCImage:imageWithFile(imgPath2:getData());
                    if cuttingLine2 then
                        cuttingLine2:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine2:setPosition(CCPointMake(SX(46),SY(250)));
                        pDragNode:addChild(cuttingLine2);
                    end
                end
                local flg = 0
                if luaIsUnlock(UNLOCK_TYPE_TRIBE_CAMPAIGN_FATTY) then
                    flg = 1
                end
                local imgPath3 = getRealUIResourcePath("img/new00571.png")
                if imgPath3 then
                    local cuttingLine3 = SCImage:imageWithFile(imgPath3:getData());
                    if cuttingLine3 then
                        cuttingLine3:setAnchorPoint(CCPointMake(0,0));
                        cuttingLine3:setPosition(CCPointMake(SX(0),SY(0)));
                        pDragNode:addChild(cuttingLine3);
                        if 1 == flg then
                            cuttingLine3:setVisible(false)
                        end
                        
                    end
                end
                local imgPath4 = getRealUIResourcePath("img/2001001.png") --金钱小图标
                if imgPath4 then
                    local cuttingLine4 = SCImage:imageWithFile(imgPath4:getData());
                    if cuttingLine4 then
                        cuttingLine4:setScale(0.6,0.6) --//缩小
                        cuttingLine4:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine4:setPosition(CCPointMake(SX(15),SY(20)));
                        pDragNode:addChild(cuttingLine4);
                    end
                    if 0 == flg then
                        cuttingLine4:setVisible(false)
                    end
                end
                local imgPath6 = getRealUIResourcePath("img/2001003.png") --战功小图标
                if imgPath6 then
                    local cuttingLine6 = SCImage:imageWithFile(imgPath6:getData());
                    if cuttingLine6 then
                        cuttingLine6:setScale(0.7,0.7)
                        cuttingLine6:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine6:setPosition(CCPointMake(SX(75),SY(20)));
                        pDragNode:addChild(cuttingLine6);
                    end
                    if 0 == flg then
                        cuttingLine6:setVisible(false)
                    end
                end
                local count1 = 0
                local count2 = 0
                if m_societyActivityList[5] then
                    count1 = m_societyActivityList[5].ucFlag 
                    if count1 < 10 then
                        count1 = 0
                    elseif count1 > 9 then
                        count1 = getIntPart(count1/10)
                    end
                    count2 = m_societyActivityList[5].ucFlag 
                    if count2 > 9 then
                        count2 = count2%10
                    end
                end
                local imgPath7 = getRealUIResourcePath("img/new00401.png")
                if imgPath7 then
                    local cuttingLine7 = SCImage:imageWithFile(imgPath7:getData());
                    if cuttingLine7 then
                        --cuttingLine7:setScale(0.7,0.7)
                        cuttingLine7:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine7:setPosition(CCPointMake(SX(46),SY(40)));
                        pDragNode:addChild(cuttingLine7);
                        if 0 == flg then
                            cuttingLine7:setVisible(false)
                        end
                    end
                end
                local imgPath8 = getRealUIResourcePath("img/new00085.png")
                if imgPath8 then
                    local cuttingLine8 = SCImage:imageWithFile(imgPath8:getData(), CCRectMake(SX(11.8*count1), SY(0), SX(11.8), SY(20)))
                    if cuttingLine8 then
                        --cuttingLine8:setScale(1.2,1.2)
                        cuttingLine8:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine8:setPosition(CCPointMake(SX(48),SY(38)));
                        pDragNode:addChild(cuttingLine8);
                        if 0 == flg then
                            cuttingLine8:setVisible(false)
                        end
                    end
                end
                local imgPath9 = getRealUIResourcePath("img/new00085.png")
                if imgPath9 then
                    
                    local cuttingLine9 = SCImage:imageWithFile(imgPath9:getData(), CCRectMake(SX(11.8*count2), SY(0), SX(11.8), SY(20)))
                    if cuttingLine9 then
                        --cuttingLine9:setScale(1.2,1.2)
                        cuttingLine9:setAnchorPoint(CCPointMake(0.5,0.5));
                        cuttingLine9:setPosition(CCPointMake(SX(62),SY(38)));
                        pDragNode:addChild(cuttingLine9);
                        if 0 == flg then
                            cuttingLine9:setVisible(false)
                        end
                    end
                end
                local pBtn = SCButton:button();
                if pBtn then
                    pBtn:setContentSize(pDragNode:getContentSize());
                    pBtn:luaSetSelectorOnClicked(onUnActivityBtnClick)
                    if 1 == flg then
                        pBtn:luaSetSelectorOnClicked(onActivityBtnClick);
                    end
                    pBtn:setTag(5);
                    pDragNode:addChild(pBtn);
                end
            end
        end
        
    end
    
	
	
	--[[
	
	local LeftButton = SCButton:button()    --左按钮
	if LeftButton then
		LeftButton:setTag(4)
		LeftButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		LeftButton:setPosition(AUTO_POS(3.50, 122.50))
		LeftButton:setContentSize(AUTO_SIZE(14, 14))
		LeftButton:setTitle(RES("img/new00048.png"))
		LeftButton:luaSetSelectorOnClicked(ButtonLeft)
        pDragNode:addChild(tolua.cast(LeftButton, "SCNode"))
	end
	
	local RightButton = SCButton:button()    --右按钮
	if RightButton then
		RightButton:setTag(5)
		RightButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		RightButton:setPosition(AUTO_POS(457.50, 122.50))
		RightButton:setContentSize(AUTO_SIZE(14, 14))
		RightButton:setTitle(RES("img/new00047.png"))
		RightButton:luaSetSelectorOnClicked(ButtonRight)
        pDragNode:addChild(tolua.cast(RightButton, "SCNode"))
	end
	
	local pageScrollBoxWidth = 432;
	local pageScrollBoxHeight = 222;
	local pageScrollBox = SCPageScrollBox:boxWithWidthHeight(pageScrollBoxWidth, pageScrollBoxHeight);
	if pageScrollBox == nil then
		return;
	end
	pageScrollBox:setTag(6)
	pageScrollBox:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
	pageScrollBox:setPosition(CCPointMake(25.00, 12.00));
	pageScrollBox:setScrollVertical(false);
	setRealPagtSize(pageScrollBox, pageScrollBoxWidth, pageScrollBoxHeight);
	pDragNode:addChild(pageScrollBox);
	
	local imgPath1 = nil;
	local imgPath2 = nil;
	
	for i=1, #m_societyActivityList do
		local node = SCTypeCast:castNodeToImage(SocietyScreenTemplate.initControl());       --剩余  次数
		if node then
			if m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_MORALE then
				imgPath1 = getRealUIResourcePath("img/new00403.jpg");          --士气训练 文字图片
				imgPath2 = getRealUIResourcePath("img/new00402.png");
			elseif m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_RAPPZLE then
				imgPath1 = getRealUIResourcePath("img/new00405.jpg");
				imgPath2 = getRealUIResourcePath("img/new00404.png");
			elseif m_societyActivityList[i].usCampaignType == TRIBE_CAMPAIGN_FATTY then
				imgPath1 = getRealUIResourcePath("img/new00430.jpg");
				imgPath2 = getRealUIResourcePath("img/new00433.png");
			elseif m_societyActivityList[i].usCampaignType == TRIBE_INDIANA_ACTIVETIES then
				imgPath1 = getRealUIResourcePath("img/new00431.jpg");
				imgPath2 = getRealUIResourcePath("img/new00434.png");			    
			end
			
			local titleImage = SCTypeCast:castNodeToImage(node:getChildByTag(1));
			if imgPath1 and imgPath2 and titleImage then
				titleImage:setImage(imgPath2:getData());
				node:setImage(imgPath1:getData());
			end
			
			--文字Label
			local titleLabel = SCLabel:labelWithStringFont(L("str0356"), DEFAULT_FONT_NAME, F(8));
			if titleLabel then
			    titleLabel:setTag(10034)
                titleLabel:setColor(ccc4(58, 236, 0, 255));
                titleLabel:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                titleLabel:setPosition(AUTO_POS(6.00, 165.00))
                titleLabel:setContentSize(AUTO_SIZE(86, 16))
                node:addChild(titleLabel);
			end
			--Node 添加小图标容器
			local SmallNode = SCNode:node();
			if SmallNode then
			    SmallNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                SmallNode:setPosition(AUTO_POS(9.00, 3.00))
                SmallNode:setContentSize(AUTO_SIZE(82, 16))
                node:addChild(SmallNode);
			end
            
            local imgPath3 = getRealUIResourcePath("img/2001001.pn");	
            if imgPath3 then	
                local sImg1 = SCImage:imageWithFile(imgPath3:getData());
                if sImg1 then
                    sImg1:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
                    sImg1:setPosition(10, 2);
                    sImg1:setScale(0.4);
                    SmallNode:addChild(sImg1)
                end
            end
			
			local imgPath4 = getRealUIResourcePath("img/2001008.pn");
			if imgPath4 then
                local sImg2 = SCImage:imageWithFile(imgPath4:getData());
                if sImg2 then
                    sImg2:setAnchorPoint(ANCHOR_LEFT_BOTTOM);
                    sImg2:setPosition(46, 2);
                    sImg2:setScale(0.4);
                    SmallNode:addChild(sImg2)
                end
            end
			
			local text = SCTypeCast:castNodeToTextBox(node:getChildByTag(4));
			if text then
				text:setScrollHorizontal(false);
				text:setScrollVertical(false);
				text:setText(m_societyActivityList[i].szMsg);  --设置文字
			end
			
			local timesNode = node:getChildByTag(5);
			if timesNode then
				local numImage = getIamgeNum(m_societyActivityList[i].ucFlag, "img/new00487.png", 17, 10, 18)  --显示剩余次数
                if numImage then
                    --numImage:setTag(10012)
                    numImage:setAnchorPoint(CCPointMake(0.5, 0.5))
                    if m_societyActivityList[i].ucFlag < 10 then
                        numImage:setPosition(AUTO_POS(8.00, 12))
                    else
                        numImage:setPosition(AUTO_POS(13.00, 12))
                    end
                    timesNode:addChild(numImage);
                end
			end
			
			local btn = SCButton:button();
			if btn then
				btn:setContentSize(node:getContentSize());
				btn:luaSetSelectorOnClicked(onActivityBtnClick);
				btn:setTag(i);
				node:addChild(btn);
			end
			
			local nodeSize = getNodeContentSize(node);
			node:setAnchorPoint(CCPointMake(0, 0));
			node:setPosition(CCPointMake((nodeSize.width * 1.2) * (i-1), 0));
			setNodeContentSize(pageScrollBox, CCSizeMake(480, 260));
			pageScrollBox:addChild(node);
		end
	end
	--]]
	--[[local imgPath = getRealUIResourcePath("img/new00123.pn")
	local pImage10002 = SCImage:imageWithFile(imgPath:getData())
	if pImage10002 and imgPath then
		pImage10002:setTag(10002)
		pImage10002:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10002:setPosition(AUTO_POS(459.50, 243.50))
		pImage10002:setContentSize(AUTO_SIZE(14, 14))
		pDragNode:addChild(tolua.cast(pImage10002, "SCNode"))
	end--]]

	return Wnd
end
function showActivityWindow.releaseControl()
	if showActivityWindow.wndCloss then
		showActivityWindow.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------
local function OnEvent(tag, event)
    local Wnd = SCFunction:getUiNodeByIdlist("4421")
	if event == LuaControllerEventPushEnded then
		Wnd:setBackButtonVisibled(false);
		Wnd:setCloseButtonVisibled(false);
		Wnd:setFrameVisibled(false); 
	end
end

----------------全局函数区----------------
function societyMain_refreshInfo()
	showLeftSocietyInfoContent()
end

function showActivityWindow.Window()
   
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4421);
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
	else
		wnd = showActivityWindow.initControl()
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd)
			wndCtrl:luaSetSelectorOnEvent(OnEvent);
			local naviCtrl = getCurentSceneNavigationController()
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl)
			end
		 end
	end
end

function showActivityWindow.wndCloss()

end
--函数调用
