--8010 公会创建于其他公会列表界面

local m_mainLayer = nil

local m_otherSocietyList = nil

local m_selectID = nil

function removeAllData_otherSocietyListLayer()
    m_mainLayer = nil
    m_otherSocietyList = nil
	m_selectID = nil
end

local function createListMenuItem(showWidth,showHeight,rank,societyName,name,level,numberStr,type)
	
	local contentLayer = SCDragNode:node()
	contentLayer:setFrameVisibled(false)
	contentLayer:setFrameType(EnumFrameTypeListNormal)
	contentLayer:setContentSize(CCSizeMake(showWidth,showHeight))

	--上分割线
	local imgPath = getRealUIResourcePath("img/new00346.png")
	if imgPath then
	    local cuttingLine = SCImage:imageWithFile(imgPath:getData());
	    if cuttingLine then
	        local size = contentLayer:getContentSize();
	        cuttingLine:setScaleX(2.0);
            cuttingLine:setAnchorPoint(CCPointMake(0.5,0.5));
            cuttingLine:setPosition(CCPointMake(size.width/2 ,size.height - 2 * cuttingLine:getContentSize().height));
            contentLayer:addChild(cuttingLine);
	    end
	end

     --排名
    if rank == nil then
        rank = ""
    end
    local rankLabel = SCLabel:labelWithStringFont(""..rank,getDefaultFontName(), getFontSize(12))
	rankLabel:setColor(getColorYellow())
    rankLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    rankLabel:setPosition(CCPointMake(SX(60),showHeight/2));
    contentLayer:addChild(rankLabel)
    
    --公会
    if societyName == nil then
        societyName = ""
    end
    local societyLabel = SCLabel:labelWithStringFont(""..societyName,getDefaultFontName(), getFontSize(12))
	societyLabel:setColor(getColorYellow())
    societyLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    societyLabel:setPosition(CCPointMake(showWidth*0.31,showHeight/2));
    contentLayer:addChild(societyLabel)
    
    --会长
    if name == nil then
        name = ""
    end
    local nameLabel = SCLabel:labelWithStringFont(""..name,getDefaultFontName(), getFontSize(12))
	nameLabel:setColor(getColorYellow())
    nameLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    nameLabel:setPosition(CCPointMake(showWidth*0.53,showHeight/2));
    contentLayer:addChild(nameLabel)
    
    --等级
    if level == nil then
        level = ""
    end
    local levelLabel = SCLabel:labelWithStringFont(""..level,getDefaultFontName(), getFontSize(12))
	levelLabel:setColor(getColorYellow())
    levelLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    levelLabel:setPosition(CCPointMake(showWidth*0.71,showHeight/2));
    contentLayer:addChild(levelLabel)
    
    --人数
    if numberStr == nil then
        numberStr = ""
    end
    local numberLabel = SCLabel:labelWithStringFont(""..numberStr,getDefaultFontName(), getFontSize(12))
	numberLabel:setColor(getColorYellow())
    numberLabel:setAnchorPoint(CCPointMake(0.5,0.5));
    numberLabel:setPosition(CCPointMake(showWidth*0.825,showHeight/2));
    contentLayer:addChild(numberLabel)
--[[    
    --申请
    local applyButton = nil
    if type == 0 then
        applyButton = SCButton:button(EnumBtnType9Atlas)
        setNodeContentSize(applyButton, CCSizeMake(45, 26))
	    local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	    applyButton:setTitle(_LTParser("str8049"),getDefaultFontName(), getFontSize(12),getColorYellow())
        applyButton:setAnchorPoint(CCPointMake(0.5,0.5));
        applyButton:setPosition(CCPointMake(showWidth*0.84,showHeight/2));
        contentLayer:addChild(applyButton)
    end
    
    --查看
    local detailButton = SCButton:button(EnumBtnType9Atlas)
    setNodeContentSize(detailButton, CCSizeMake(45, 26))
	local imgFile = getRealUIResourcePath(Img0008_ImagePath);
	detailButton:setTitle(_LTParser("str8050"),getDefaultFontName(), getFontSize(12),getColorYellow())
    detailButton:setAnchorPoint(CCPointMake(0.5,0.5));
    detailButton:setPosition(CCPointMake(showWidth*0.95,showHeight/2));
    contentLayer:addChild(detailButton)
  --]]  
    return contentLayer
end

--点击申请按钮
local function applyBtnAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_REQUEST_SOCIATY)--//申请公会
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--点击取消申请按钮
local function cancelApplyBtnAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_CLEAR_REQUEST_SOCIATY)--//撤消申请公会
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

--查看详细
local function detailButtonAction(tag)
    if tag then
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_VIEW_SOCIATY_INFO2)--//查看公会信息
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        
        local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dt:writeShort(MSG_SOCIATY_MEMBER_LIST2)--//查看公会成员
        dt:writeInt(tag)-- //公会ID
        SCDataTransThread:getSingleton():transData(dt);
        SCActivityIndicator:getSingleton():show()
    end
end

local function otherListScrollEnd(tag)
	local listBox = SCTypeCast:castNodeToListBox(m_mainLayer:getChildByTag(1))
    if listBox == nil then
        return
    end
	local count = listBox:itemCount()
	if count <=0 then
		return
	end
	local showWidth = listBox:getContentSize().width
    local showHeight = listBox:getContentSize().height
    local hero = Hero:getSingleton()
    local typeRank = hero:getRank()--0无公会
    
    local menuWidth  = showWidth
    local menuHeight = SY(38)
    
	for i=count+1, count+10 do
		if m_otherSocietyList[i] then
            local idTribe         = m_otherSocietyList[i].idTribe
            local usRank          = m_otherSocietyList[i].usRank
            local szTribeName     = m_otherSocietyList[i].szTribeName
            local szLeaderName    = m_otherSocietyList[i].szLeaderName
            local usLevel         = m_otherSocietyList[i].usLevel
            local usTribeNum      = m_otherSocietyList[i].usTribeNum
            local usMaxNum        = m_otherSocietyList[i].usMaxNum
            local ucRequestedFlag = m_otherSocietyList[i].ucRequestedFlag
            
            local menuItem = createListMenuItem(menuWidth,menuHeight,usRank,szTribeName,szLeaderName,usLevel,usTribeNum.."/"..usMaxNum,typeRank)
            menuItem:setTag(idTribe)
            menuItem:setAnchorPoint(CCPointMake(0.5,0));
            menuItem:setPosition(CCPointMake(showWidth/2,0));
            
--[[            if applyButton then
                applyButton:setTag(idTribe)
                if ucRequestedFlag == 1 then--已申请
                    --取消
                    applyButton:setTitle(_LTParser("str8084"),getDefaultFontName(), getFontSize(12),getColorYellow())
                    applyButton:luaSetSelectorOnClicked(cancelApplyBtnAction)
                else
                    applyButton:luaSetSelectorOnClicked(applyBtnAction)
                end
            end
            if detailButton then
                detailButton:setTag(idTribe)
                detailButton:luaSetSelectorOnClicked(detailButtonAction)
            end--]]
            listBox:addItem(menuItem)
        end
	end
end

local function showSocietyList()
    if m_mainLayer == nil then
        return
    end
    local listBox = m_mainLayer:getChildByTag(1)
    if listBox == nil then
        return
    end
    listBox = SCTypeCast:castNodeToListBox(listBox)
	if listBox:itemCount() > 0 then
		return
	end
    if m_otherSocietyList == nil then
        return
    end
    local showWidth = listBox:getContentSize().width
    local showHeight = listBox:getContentSize().height
    local hero = Hero:getSingleton()
    local typeRank = hero:getRank()--0无公会
    
    local menuWidth  = showWidth
    local menuHeight = SY(40)
    local amount = 10
    for i=1,amount do
        if m_otherSocietyList[i] then
            local idTribe         = m_otherSocietyList[i].idTribe
            local usRank          = m_otherSocietyList[i].usRank
            local szTribeName     = m_otherSocietyList[i].szTribeName
            local szLeaderName    = m_otherSocietyList[i].szLeaderName
            local usLevel         = m_otherSocietyList[i].usLevel
            local usTribeNum      = m_otherSocietyList[i].usTribeNum
            local usMaxNum        = m_otherSocietyList[i].usMaxNum
            local ucRequestedFlag = m_otherSocietyList[i].ucRequestedFlag
            
            local menuItem = createListMenuItem(menuWidth,menuHeight,usRank,szTribeName,szLeaderName,usLevel,usTribeNum.."/"..usMaxNum,typeRank)
            menuItem:setTag(idTribe)
            menuItem:setAnchorPoint(CCPointMake(0.5,0));
            menuItem:setPosition(CCPointMake(showWidth/2,0));
            listBox:addItem(menuItem)
        end
    end
	listBox:luaSetSelectorOnScrollToEnd(otherListScrollEnd)
end

local function sendQueryOtherSocietyListMsg()
    local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_SOCIATY_LIST)--其他公会列表
    SCDataTransThread:getSingleton():transData(dt);
    SCActivityIndicator:getSingleton():show()
end

--点击快速申请
local function onClickedFastApply(tag)
	local dt = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    dt:writeShort(MSG_FAST_REQUEST_SOCIATY)--快速申请
    SCDataTransThread:getSingleton():transData(dt);
end

local function onClickMenuList(tag)
	if tag == 0 then
		local ucRequestedFlag = m_otherSocietyList[m_selectID+1].ucRequestedFlag
		local idTribe = m_otherSocietyList[m_selectID+1].idTribe
		if ucRequestedFlag == 1 then--已申请
            --取消
            cancelApplyBtnAction(idTribe)
            --m_otherSocietyList[m_selectID+1].ucRequestedFlag = 0
        else
            applyBtnAction(idTribe)
            --m_otherSocietyList[m_selectID+1].ucRequestedFlag = 1
        end
	elseif tag == 1 then
		local idTribe = m_otherSocietyList[m_selectID+1].idTribe
		detailButtonAction(idTribe)
	end
end

local function listBoxItemSelected(tag,itemTag,itemIndex)
	local pmenuList = menuList:newStringList()
    if pmenuList then
		local ucRequestedFlag = m_otherSocietyList[itemIndex+1].ucRequestedFlag
		if ucRequestedFlag == 1 then--已申请
            --取消
            pmenuList:createMenu(m_otherSocietyList[itemIndex+1].szTribeName, 2, _LTParser("str8084").."_".._LTParser("str6096"));
        else
            pmenuList:createMenu(m_otherSocietyList[itemIndex+1].szTribeName, 2, _LTParser("str0238").."_".._LTParser("str6096"));
        end
        pmenuList:luasetSelector(onClickMenuList);
		m_selectID = itemIndex
    end
end

--显示其他公会列表
function open_otherSocietyListWnd(contentLayer)    
    if contentLayer == nil then
        return
    end
    m_mainLayer = contentLayer
    m_mainLayer:removeAllChildrenWithCleanup(true)
    
    local width = m_mainLayer:getContentSize().width
    local height = m_mainLayer:getContentSize().height
    
    local topStartX = SX(20)
    local topStartY = height*0.93
    
    --排名
    local rankLabel = SCLabel:labelWithStringFont(_LTParser("str8044"),getDefaultFontName(), getFontSize(15))
	rankLabel:setColor(getColorYellow())
    rankLabel:setAnchorPoint(CCPointMake(0.5,0));
    rankLabel:setPosition(CCPointMake(SX(65),topStartY));
    m_mainLayer:addChild(rankLabel)
    
    --公会
    local societyLabel = SCLabel:labelWithStringFont(_LTParser("str8045"),getDefaultFontName(), getFontSize(15))
	societyLabel:setColor(getColorYellow())
    societyLabel:setAnchorPoint(CCPointMake(0.5,0));
    societyLabel:setPosition(CCPointMake(width*0.32,topStartY));
    m_mainLayer:addChild(societyLabel)
    
    --会长
    local nameLabel = SCLabel:labelWithStringFont(_LTParser("str8046"),getDefaultFontName(), getFontSize(15))
	nameLabel:setColor(getColorYellow())
    nameLabel:setAnchorPoint(CCPointMake(0.5,0));
    nameLabel:setPosition(CCPointMake(width*0.53,topStartY));
    m_mainLayer:addChild(nameLabel)
    
    --等级
    local levelLabel = SCLabel:labelWithStringFont(_LTParser("str8047"),getDefaultFontName(), getFontSize(15))
	levelLabel:setColor(getColorYellow())
    levelLabel:setAnchorPoint(CCPointMake(0.5,0));
    levelLabel:setPosition(CCPointMake(width*0.71,topStartY));
    m_mainLayer:addChild(levelLabel)
    
    --人数
    local numberLabel = SCLabel:labelWithStringFont(_LTParser("str8048"),getDefaultFontName(), getFontSize(15))
	numberLabel:setColor(getColorYellow())
    numberLabel:setAnchorPoint(CCPointMake(0.5,0));
    numberLabel:setPosition(CCPointMake(width*0.82,topStartY));
    m_mainLayer:addChild(numberLabel)
    
    
    local showWidth = width*0.98
    local showHeight = height*0.77
	
    local listBox = SCListBox:boxWithWidthHeight(showWidth,showHeight)
    listBox:setTag(1)
    listBox:setAnchorPoint(CCPointMake(0.5,0));
    listBox:setPosition(CCPointMake(width/2,SY(40)));
	listBox:luaSetSelectorOnItemSelected(listBoxItemSelected)
    --listBox:luaSetSelectorOnItemUnSelected(listBoxUnItemSelected)
    m_mainLayer:addChild(listBox)
	
	--快速申请
	if Hero:getSingleton():getRank()==0 then
        local fastBtn = SCButton:button(EnumBtnType9Atlas)
        fastBtn:setContentSize(AUTO_SIZE(90, 32))
        local imgPath = getRealUIResourcePath("img/new00378.png")
        if imgPath then
            fastBtn:setTitle(imgPath:getData());
        end
        fastBtn:setAnchorPoint(CCPointMake(0.5, 0))
        fastBtn:setPosition(CCPointMake(width/2,SY(0)))
        fastBtn:luaSetSelectorOnClicked(onClickedFastApply)
        m_mainLayer:addChild(fastBtn)
	end
	sendQueryOtherSocietyListMsg()
end
--[[
--显示创建公会
local function showCreateSociety()
    if m_wnd ==nil then
        return;
    end
    local multiTabLayer = m_wnd:getChildByTag(801001);
    if multiTabLayer ==  nil then
        return
    end
    local contentLayer = multiTabLayer:getPageWithTag(1)
    contentLayer:removeAllChildrenWithCleanup(true)
    
    local width = contentLayer:getContentSize().width
    local height = contentLayer:getContentSize().height
    
end


function open_SocietyCreateScreen()
    if getCurentSceneWindowController(8010) then
        return;
    end
    local width = SX(480)
	local height = SY(320)
	
    --获取创建窗口
    local wnd = SCWindow:window()
    wnd:setTag(8010);
    wnd:luaSetSelectorOnClose(onClickClose);
    wnd:setBackgroundColor(colorWindowRedBG());
    wnd:luaSetSelectorOnClose(removeAllData);
    wnd:setContentSize(CCSizeMake(width,height))
    local imgFile = getRealUIResourcePath("img/titile08.png");
	if imgFile then
	   wnd:setTitleWithImage(imgFile:getData())
	end
	
	local wndCtrl = SCWindowController:controllerWithWindow(wnd)
	
	local scene = SCBaseScene:getRunningScene()
	local naviCtrl =  scene:getNavigationController()
	naviCtrl:pushWindowController(wndCtrl)
	
	m_wnd =  getCurentSceneWindowController(8010):getWindow();
	
	local showWidth  = width*0.96
	local showHeight = height*0.8
	local startX = (width-showWidth)/2
	local startY = SY(10)
	
	--公会列表
	local societyListLayer = SCDragNode:node()
	societyListLayer:setTag(0)
	societyListLayer:setFrameVisibled(true)
	societyListLayer:setAnchorPoint(CCPointMake(0,0));
	societyListLayer:setPosition(CCPointMake(startX,startY));
	societyListLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
	--公会创建
	local societyCreateLayer = SCDragNode:node()
	societyCreateLayer:setTag(1)
	societyCreateLayer:setFrameVisibled(true)
	societyCreateLayer:setAnchorPoint(CCPointMake(0,0));
	societyCreateLayer:setPosition(CCPointMake(startX,startY));
	societyCreateLayer:setContentSize(CCSizeMake(showWidth,showHeight))
	
	local multiTabLayer = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	multiTabLayer:setTag(801001)
	multiTabLayer:addPage(societyListLayer)
	multiTabLayer:addPage(societyCreateLayer)
	multiTabLayer:setTitleAtPage( _LTParser("str8042"), getDefaultFontName(),getFontSize(14), 0); 
	multiTabLayer:setTitleAtPage( _LTParser("str8043"), getDefaultFontName(),getFontSize(14), 1);
    multiTabLayer:luaSetSelectorOnPageSelected(multiTabAction)
	m_wnd:addChild(multiTabLayer)
	
	showOtherSocietyList()
end
--]]

function processOtherList_SocietyCreateScreen(dt)
    if dt == nil then
        return
    end
    if m_otherSocietyList == nil then
        m_otherSocietyList = {}
    end
    
    local ucAmount = dt:readByte()
    for i=1,ucAmount do
        local idTribe          = dt:readInt()
        local usRank           = dt:readShort()
        local szTribeName      = dt:readString()
        local szLeaderName     = dt:readString()
        local usLevel          = dt:readShort()
        local usTribeNum       = dt:readShort()--//成员数
        local usMaxNum         = dt:readShort()
        local ucRequestedFlag  = dt:readByte()--//1:已申请标志
        
        local tmpDetail = {}
        tmpDetail.idTribe      = idTribe
        tmpDetail.usRank       = usRank
        if szTribeName then
            tmpDetail.szTribeName  = szTribeName:getData()
		else
			tmpDetail.szTribeName  = " "
        end
        if szLeaderName then
            tmpDetail.szLeaderName = szLeaderName:getData()
		else
			tmpDetail.szLeaderName = " "
        end
        tmpDetail.usLevel           = usLevel
        tmpDetail.usTribeNum        = usTribeNum
        tmpDetail.usMaxNum          = usMaxNum
        tmpDetail.ucRequestedFlag   = ucRequestedFlag
        table.insert(m_otherSocietyList,tmpDetail);
    end
    
    showSocietyList()
end

--更新列表数据
function processUpdate_SocietyCreateScreen(dt)
    if dt == nil or m_mainLayer == nil or m_otherSocietyList == nil then
        return
    end
    local ucAmount = dt:readByte()
    if ucAmount < 1 then
        return
    end
    --不做循环，正常就一条记录ucAmount=1
    local idTribe          = dt:readInt()
    local usRank           = dt:readShort()
    local szTribeName      = dt:readString()
    local szLeaderName     = dt:readString()
    local usLevel          = dt:readShort()
    local usTribeNum       = dt:readShort()--//成员数
    local usMaxNum         = dt:readShort()
    local ucRequestedFlag  = dt:readByte()--//1:已申请标志
	local tmpDetail = {}
    tmpDetail.idTribe      = idTribe
    tmpDetail.usRank       = usRank
    if szTribeName then
        tmpDetail.szTribeName  = szTribeName:getData()
	else
		tmpDetail.szTribeName  = " "
    end
    if szLeaderName then
        tmpDetail.szLeaderName = szLeaderName:getData()
	else
		tmpDetail.szLeaderName = " "
    end
    tmpDetail.usLevel           = usLevel
    tmpDetail.usTribeNum        = usTribeNum
    tmpDetail.usMaxNum          = usMaxNum
    tmpDetail.ucRequestedFlag   = ucRequestedFlag
    
    local amount = #m_otherSocietyList
    local index = nil
    for i=1,amount do
        if m_otherSocietyList[i] and m_otherSocietyList[i].idTribe == idTribe then
            index = i
            break
        end
    end
    if index == nil then
        return
    end
    index = index-1--索引从0开始的不是1
    local listBox = m_mainLayer:getChildByTag(1)
    if listBox == nil then
        return
    end
    local oldOffY = listBox:getOffset().y
    listBox = SCTypeCast:castNodeToListBox(listBox)
    if listBox:itemCount() >= index + 1 then
        listBox:removeItemAtIndex(index)
    end
	table.remove(m_otherSocietyList, index+1)
    
    local showWidth = listBox:getContentSize().width
    local showHeight = listBox:getContentSize().height
    local hero = Hero:getSingleton()
    local typeRank = hero:getRank()--0无公会
    local menuWidth  = showWidth
    local menuHeight = SY(40)
            
--[[    if applyButton then
        applyButton:setTag(idTribe)
        if ucRequestedFlag == 1 then--已申请
            --取消
            applyButton:setTitle(_LTParser("str8084"),getDefaultFontName(), getFontSize(12),getColorYellow())
            applyButton:luaSetSelectorOnClicked(cancelApplyBtnAction)
        else
            applyButton:luaSetSelectorOnClicked(applyBtnAction)
        end
    end
    if detailButton then
        detailButton:setTag(idTribe)
        detailButton:luaSetSelectorOnClicked(detailButtonAction)
    end--]]
	table.insert(m_otherSocietyList, index+1, tmpDetail)
	if listBox:itemCount() >= index then
        local menuItem = createListMenuItem(menuWidth,menuHeight,usRank,tmpDetail.szTribeName,tmpDetail.szLeaderName,usLevel,usTribeNum.."/"..usMaxNum,typeRank)
        if menuItem then
            menuItem:setTag(idTribe)
            menuItem:setAnchorPoint(CCPointMake(0.5,0));
            menuItem:setPosition(CCPointMake(showWidth/2,0));
            local oldHeight = listBox:getContentSize().height
            listBox:insertItemAtIndex(menuItem,index)
            listBox:setOffset(CCPointMake(0, oldOffY))
        end
    end    
end