--定义一个与文件名相同的table
TaskForDay = {}
------------------消息--------------------

----------------结构定义区----------------

----------------常量定义区----------------
local QUEST_STATUS_NONE			= 4
local QUEST_STATUS_DOING		= 1	--//接受未完成
local QUEST_STATUS_FINISHED		= 2	--//完成(交还)
local QUEST_STATUS_FAILED		= 3	--//失败
local ACTQUEST_RAPID_EVETYDAY_QUEST = 54 --//一键完成

local CARNET_COPY 				= 75--//通关副本 
local CARNET_STRENGTHEN 		= 76--//强化装备
local CARNET_UPGRADE  			= 77--//升级技能
local CARNET_ARENA_CHALLENGE 	= 78--//竞技场挑战
local CARNET_COMBO 				= 79--//连机目标
local CARNET_FORM_TEAM 			= 80--//组队完成副本 

----------------变量定义区----------------
local m_stEveryDayQuestList = {};
local m_isCanRefresh = nil;
local m_szRefreshMsg = nil;
local m_bSendRefreshMsg = nil;
local m_nRefreshTimes = nil;
--变量的定义
----------------UI控制器区----------------
function TaskForDay.initControl()
	local pWindow6007 = SCWindow:window()
	if pWindow6007 then
		pWindow6007:setTag(6007)
		pWindow6007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow6007:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("img/new00027.png")
		if pImgPath then
			pWindow6007:setTitleWithImage(pImgPath:getData())
		end
		pWindow6007:setContentSize(AUTO_SIZE(480, 320))
		pWindow6007:luaSetSelectorOnClose(TaskForDay.releaseControl)
	end

	TaskForDay.m_pDragNode1 = SCDragNode:node()
	if TaskForDay.m_pDragNode1 then
		TaskForDay.m_pDragNode1:setTag(1)
		TaskForDay.m_pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		TaskForDay.m_pDragNode1:setPosition(AUTO_POS(15.00, 150.00))
		TaskForDay.m_pDragNode1:setContentSize(AUTO_SIZE(450, 120))
		TaskForDay.m_pDragNode1:setFrameVisibled(true)
		TaskForDay.m_pDragNode1:setDragEnabled(false)
		TaskForDay.m_pDragNode1:setFrameType(EnumFrameTypeLine)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(15.00, 15.00))
		pDragNode2:setContentSize(AUTO_SIZE(450, 140))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTypeLine)
	end

	local pLable10004 = SCLabel:labelWithStringFont(L("str9153"), DEFAULT_FONT_NAME, F(15))
	if pLable10004 then
		pLable10004:setTag(10004)
		pLable10004:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable10004:setPosition(AUTO_POS(145.00, 100.00))
		pLable10004:setColor(ccc4(255,255,255,255))
	end

	TaskForDay.m_pLabel5 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(15))
	if TaskForDay.m_pLabel5 then
		TaskForDay.m_pLabel5:setTag(5)
		TaskForDay.m_pLabel5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		TaskForDay.m_pLabel5:setPosition(AUTO_POS(245.00, 100.00))
		TaskForDay.m_pLabel5:setColor(ccc4(255,255,255,255))
	end

	local pLable3 = SCLabel:labelWithStringFont(L("str3162"), DEFAULT_FONT_NAME, F(15))
	if pLable3 then
		pLable3:setTag(3)
		pLable3:setAnchorPoint(ANCHOR_CENTER)
		pLable3:setPosition(AUTO_POS(220.00, 79.50))
		pLable3:setColor(ccc4(255,252,0,255))
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	local pImage4 = nil
	if imgPath then
		pImage4 = SCImage:imageWithFile(imgPath:getData())
		if pImage4 then
			pImage4:setTag(4)
			pImage4:setAnchorPoint(ANCHOR_CENTER)
			pImage4:setPosition(AUTO_POS(185.00, 40.00))
		end
	end

	local imgPath = getRealUIResourcePath("img/new00002.png")
	local pImage35 = nil
	if imgPath then
		pImage35 = SCImage:imageWithFile(imgPath:getData())
		if pImage35 then
			pImage35:setTag(35)
			pImage35:setAnchorPoint(ANCHOR_CENTER)
			pImage35:setPosition(AUTO_POS(245.00, 40.00))
		end
	end
	
	TaskForDay.m_button6 = SCButton:button(EnumBtnTypeNormalImg)
	if TaskForDay.m_button6 then
		TaskForDay.m_button6:setTag(6)
		TaskForDay.m_button6:setAnchorPoint(ANCHOR_CENTER)
		TaskForDay.m_button6:setPosition(AUTO_POS(23.00, 23.00))
		TaskForDay.m_button6:setContentSize(AUTO_SIZE(36, 36))
		
		local pBackimg = getRealUIResourcePath("item/2001005.jp")
		if pBackimg then
			TaskForDay.m_button6:setBackgroundImage(pBackimg:getData())
		end
	end
	
	TaskForDay.m_button35 = SCButton:button(EnumBtnTypeNormalImg)
	if TaskForDay.m_button35 then
		TaskForDay.m_button35:setTag(35)
		TaskForDay.m_button35:setAnchorPoint(ANCHOR_CENTER)
		TaskForDay.m_button35:setPosition(AUTO_POS(23.00, 23.00))
		TaskForDay.m_button35:setContentSize(AUTO_SIZE(36, 36))
		
		local pBackimg = getRealUIResourcePath("item/2000300.jp")
		if pBackimg then
			TaskForDay.m_button35:setBackgroundImage(pBackimg:getData())
		end
	end
	
	if TaskForDay.m_pDragNode1 and pWindow6007 then
		pWindow6007:addChild(tolua.cast(TaskForDay.m_pDragNode1, "SCNode"))
	end
	if pDragNode2 and pWindow6007 then
		pWindow6007:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pLable10004 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable10004, "SCNode"))
	end
	if TaskForDay.m_pLabel5 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(TaskForDay.m_pLabel5, "SCNode"))
	end
	if pLable3 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pLable3, "SCNode"))
	end
	if pImage4 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage4, "SCNode"))
	end
	if pImage35 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pImage35, "SCNode"))
	end
	if TaskForDay.m_button6 and pImage4 then
		pImage4:addChild(tolua.cast(TaskForDay.m_button6, "SCNode"))
	end
	if TaskForDay.m_button35 and pImage35 then
		pImage35:addChild(tolua.cast(TaskForDay.m_button35, "SCNode"))
	end
	return pWindow6007
end
function TaskForDay.releaseControl()
	TaskForDay.m_pDragNode1 = nil
	TaskForDay.m_pLabel5 = nil
	TaskForDay.m_button6 = nil
	if TaskForDay.wndClose then
		TaskForDay.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
--放弃任务
local function sendGiveUpTaskInfo()
	local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
	dt:writeShort(ACTQUEST_SEND_EVERYDAY_GAVE_UP)
	SCDataTransThread:getSingleton():transData(dt)
	SCActivityIndicator:getSingleton():show()
end

--发送接受任务
local function sendAcceptTaskInfo()
	local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
	dt:writeShort(ACTQUEST_SEND_EVERYDAY_ACCEPT)
	SCDataTransThread:getSingleton():transData(dt)
	SCActivityIndicator:getSingleton():show()
end

--发送领取奖励
local function sendReceiveRewardsInfo()
	local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
	dt:writeShort(ACTQUEST_SEND_EVERYDAY_FINISH)
	SCDataTransThread:getSingleton():transData(dt)
	SCActivityIndicator:getSingleton():show()
end

--发送一键完成
local function sendOneKeyAchieve(tag)
    if 0 == tag then
        return
    end
    local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
	dt:writeShort(ACTQUEST_RAPID_EVETYDAY_QUEST)
	SCDataTransThread:getSingleton():transData(dt)
	SCActivityIndicator:getSingleton():show()
end
--发送刷新消息
local function sendRefreshInfo(tag)
    if m_bSendRefreshMsg == false then
        m_bSendRefreshMsg = true;
        if tag == 1 then
            local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
            dt:writeShort(ACTQUEST_SEND_REFRSH_EVETYDAY)
            dt:writeByte(1);
            SCDataTransThread:getSingleton():transData(dt)
            SCActivityIndicator:getSingleton():show()
        end
    end
end

local function sendRefreshInfoEx(tag)
	if tag == 1 then
		local dt = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST)
		dt:writeShort(ACTQUEST_SEND_REFRSH_EVETYDAY)
		dt:writeByte(1);
		SCDataTransThread:getSingleton():transData(dt)
		SCActivityIndicator:getSingleton():show()
	end
end

--点击放弃任务
local function onGiveUpBtnClick(tag)
	sendGiveUpTaskInfo();
end

local function wndSetSelectorOnEvent(tag, type)
    if type == LuaControllerEventPushEnded then
        local wndCtrl = getCurentSceneWindowController(2011);
        if wndCtrl then
            local window = wndCtrl:getWindow();
            if window == nil then
                return;
            end
            
            local pPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlistAndParent("10", window));
            if pPage then
                pPage:selectPageWithIndex(1);
            end
        end
    end
end

--自动寻路
local function onAutoFindRoadBtnClick(tag)
	if m_stEveryDayQuestList.nQuestType == nil then
		return;
	end
	
	if  m_stEveryDayQuestList.nQuestType == CARNET_COMBO or m_stEveryDayQuestList.nQuestType == CARNET_FORM_TEAM then	
	    GameCopyConstroller_showWnd();
    elseif m_stEveryDayQuestList.nQuestType == CARNET_COPY then
        CopyQuest_setNeedCopySweepInfo(m_stEveryDayQuestList.nQuestParm);
        GameCopyController_showGameCopyWnd(m_stEveryDayQuestList.idMap, m_stEveryDayQuestList.ucType, m_stEveryDayQuestList.idCopy);
	elseif m_stEveryDayQuestList.nQuestType == CARNET_STRENGTHEN then
		Equipmentstrengthen_showEquipmentstrengthenWnd();
	elseif m_stEveryDayQuestList.nQuestType == CARNET_UPGRADE then
        SkillNode1_showMainInterfaceSkill();   
	elseif m_stEveryDayQuestList.nQuestType == CARNET_ARENA_CHALLENGE then
	    ArenaController_openWnd();
	end
	
	local wndCtrl = getCurentSceneWindowController(6007);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end
end

--接受任务
local function onAcceptBtnClick(tag)
	sendAcceptTaskInfo();
end

--点击领取奖励
local function onReceiveRewardsBtnClick(tag)
	sendReceiveRewardsInfo();
end
local function Open_rechange(tag)
    if tag == 1 then
        showVIPrechargeableWnd();
    end
end
--点击一键完成
local function onClickOneKeyAchieve()
    local vipLevel = Hero:getSingleton():getVipLevel()
    local emoney = Hero:getSingleton():getEmoney()
    if vipLevel > 2 then
    --if luaIsUnlock(UNLOCK_TYPE_RAPID_EVERYDAY_QUEST) then
        if emoney < 10 then
            luashowConfirmationWindow(_LTParser("str0439"), WIN_YES_NO, Open_rechange)
            return
        else
            luashowConfirmationWindow(L("str3163"), 2, sendOneKeyAchieve)
            return
        end
    end
    luashowConfirmationWindowPoint(L("str3161"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
end

--刷新任务二次确认框
local function showConfirmationWnd()
    local lev = Hero:getSingleton():getVipLevel()
    local num = 0
    if lev >= 8 then
        num = 2
    elseif lev >= 1 then
        num = 1
    end
--    local str = string.format(L("str9196"), lev, num - m_isCanRefresh)
    local str = string.format(L("str9196"), lev, m_isCanRefresh)
	luashowConfirmationWindow(str, 2, sendRefreshInfo)
end

--日常礼包TIP
local function showEverydayGiftTip()
    showTip(3461030000)
end

local function showEverydayGiftTipForKey()
    showTip(3901000020)
end


--点击刷新任务
local function onRefreshBtnClick(tag)
	if CLIENT_TYPE == 2 then
		if m_nRefreshTimes and m_nRefreshTimes > 0 then
			luashowConfirmationWindow(string.format(L("str9311"), m_nRefreshTimes), 2, sendRefreshInfoEx)
			return
		end
	end
	if m_isCanRefresh == nil and m_szRefreshMsg == nil then
		return
	end
	local viplev = Hero:getSingleton():getHeroInfo().ucVipLevel

	if m_isCanRefresh > 0 then
	    local emoney = Hero:getSingleton():getEmoney();
        if emoney < 100 then
            GuidePoint_shoprechange();
            return
        end
        m_bSendRefreshMsg = false;
		showConfirmationWnd();
	elseif m_isCanRefresh == 0 then
	    if viplev < 8 then 
	        luashowConfirmationWindowPoint(L("str3142"), nil, L("str20030"), WIN_NULL, ShowFastLittleVip5TipOK, ShowFastLittleVip5TipCancel, 1)
	    else
	        showMessage(m_szRefreshMsg);
	    end
	end
end

local function refresEverydayTaskWnd()
	if m_isCanRefresh then
	    local pDragNode = SCFunction:getUiNodeByIdlist("6007-1")
	    if pDragNode then
		    pDragNode:removeAllChildrenWithCleanup(true);
		end
		m_isCanRefresh = nil;
		m_szRefreshMsg = nil;
	end
	
	local child = SCFunction:getUiNodeByIdlist("6007-1-1");
	if child == nil then
		child = TaskForDay2.initControl();
		if child == nil then
			return;
		end
        
        local pDragNode = SCFunction:getUiNodeByIdlist("6007-1")
        if not pDragNode then
            return 
        end
        local contentSize = pDragNode:getContentSize();                 
        child:setTag(1);
        child:setAnchorPoint(CCPointMake(0.5, 0.5));
        child:setPosition(CCPointMake(contentSize.width/2, contentSize.height/2));
        pDragNode:addChild(child);
        
        local pLabel2 = tolua.cast(child:getChildByTag(2), "SCLabel");
        local pLabel3 = tolua.cast(child:getChildByTag(3), "SCLabel");
        if pLabel2 and pLabel3 then
            pLabel2:setColor(color_lightYellow);
            pLabel3:setColor(color_lightYellow);
        end
	end
	
	local pButton10 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-10"), "SCButton")
	local pButton11 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-11"), "SCButton")
	local pButton12 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-12"), "SCButton")
	local pButton13 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-13"), "SCButton")
	if pButton10 == nil or pButton11 == nil or pButton12 == nil or pButton13 == nil then
		return
	end
	local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-2-4-6"), "SCButton")
	if pButton6 then
	    pButton6:luaSetSelectorOnClicked(showEverydayGiftTip);
	end
	local pButton6 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-2-35-35"), "SCButton")
	if pButton6 then
	    pButton6:luaSetSelectorOnClicked(showEverydayGiftTipForKey);
	end
	pButton10:luaSetSelectorOnClicked(onGiveUpBtnClick);
	pButton11:luaSetSelectorOnClicked(onAutoFindRoadBtnClick);
	pButton13:luaSetSelectorOnClicked(onClickOneKeyAchieve);
	if m_stEveryDayQuestList.ucQuestStatus == 4 then
		pButton10:setVisible(false);
		pButton11:setVisible(false);		
		pButton12:setVisible(true);
		pButton13:setVisible(false);
		pButton12:luaSetSelectorOnClicked(onAcceptBtnClick);
	    --local imgPath = getRealUIResourcePath("img/new00055.png")
		--if imgPath then
		    --pButton12:setTitle(imgPath:getData());
		--end
		pButton12:setTitle(L("str0278"), DEFAULT_FONT_NAME, F(15))
	elseif m_stEveryDayQuestList.ucQuestStatus == QUEST_STATUS_DOING then
		pButton10:setVisible(true);
		pButton11:setVisible(true);		
		pButton12:setVisible(false);
		pButton13:setVisible(true);
	elseif m_stEveryDayQuestList.ucQuestStatus == 5 then
		pButton10:setVisible(false);
		pButton11:setVisible(false);		
		pButton12:setVisible(true);
		pButton13:setVisible(false);
		--local imgPath = getRealUIResourcePath("img/new00022.png")
		--if imgPath then
			--pButton12:setTitle(imgPath:getData());
		pButton12:luaSetSelectorOnClicked(onReceiveRewardsBtnClick);
		--end
		pButton12:setTitle(L("str6193"), DEFAULT_FONT_NAME, F(15))
	end
	
	local pLabel4 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-4"), "SCLabel");
	if pLabel4 and m_stEveryDayQuestList.szQuestName then
		pLabel4:setText(m_stEveryDayQuestList.szQuestName);
		pLabel4:setColor(color_green);		
	end
	
	local pLabel6 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-6"), "SCLabel");
	if pLabel6 and m_stEveryDayQuestList.dwAwardExp then
		pLabel6:setText(m_stEveryDayQuestList.dwAwardExp);
	end
	
	local pDragNode9 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-9"), "SCDragNode");
	if pDragNode9 and m_stEveryDayQuestList.szQuestDescribe then
		pDragNode9:removeAllChildrenWithCleanup(true);
		local pParsedNode = getItemTextNode(m_stEveryDayQuestList.szQuestDescribe, 0, 15);
		if  pParsedNode then
			pDragNode9:addChild(pParsedNode);
		end		
	end
	
	local pLabel5 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-2-5"), "SCLabel")
	if pLabel5 and m_stEveryDayQuestList.nEveryDay then
		pLabel5:setText(m_stEveryDayQuestList.nEveryDay.."/10");
		pLabel5:setColor(color_green);
	end
end

local function showEverydayTaskWnd()
	local wndCtrl = getCurentSceneWindowController(6007);
	if wndCtrl then
		return;
	end
	
	local wnd = TaskForDay.initControl();
	if wnd then
		wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl = getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl);
        end
	end		
end

function refresEverydayNullTaskWnd()
    local pDragNode = SCFunction:getUiNodeByIdlist("6007-1")
    if not pDragNode then return end 
    
    pDragNode:removeAllChildrenWithCleanup(true);	
    
    local pLabel5 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-2-5"), "SCLabel")
	if pLabel5 then
		pLabel5:setText("0/10");
		pLabel5:setColor(color_green);
	end
	
	local child = pDragNode:getChildByTag(1);
	if child == nil then
		child = TaskForDay1.initControl(m_isCanRefresh);
		if child == nil then
			return;
		end

        local contentSize = pDragNode:getContentSize();
        child:setTag(1);
        child:setAnchorPoint(CCPointMake(0.5, 0.5));
        child:setPosition(CCPointMake(contentSize.width/2, contentSize.height/2));
        pDragNode:addChild(child);
        
        local pLabel1 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-1"), "SCLabel")
        local pLabel3 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-3"), "SCLabel")
        local pLabel7 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-5"), "SCLabel")
        local pLabel8 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-6"), "SCLabel")
        if pLabel1 and pLabel3 and  pLabel7  and pLabel8 then
            pLabel1:setColor(color_lightYellow);
            pLabel3:setColor(color_red);
            pLabel7:setColor(color_green);
            pLabel8:setColor(color_lightYellow);
            if CLIENT_TYPE == 2 then
				if m_nRefreshTimes and m_nRefreshTimes > 0 then
					pLabel3:setText(L("str9312"))
				end
            end
        end
		
		local pButton4 = tolua.cast(SCFunction:getUiNodeByIdlist("6007-1-1-4"), "SCButton")
		if pButton4 then
		    if Hero:getSingleton():getEmoney() < 100 or m_isCanRefresh == 0 then
		        pButton4:setButtonType(EnumBtnTypeAsh)
		    else
		        pButton4:setButtonType(EnumBtnType9Atlas)
		    end
		    
			pButton4:luaSetSelectorOnClicked(onRefreshBtnClick);
			
			if CLIENT_TYPE == 2 then
				if m_nRefreshTimes and m_nRefreshTimes > 0 then
					pButton4:setButtonType(EnumBtnType9Atlas)
				end
			end
		end
	end
end

local function removeUnUseWnd()
    local navCtrl = getCurentSceneNavigationController()
    if navCtrl  == nil then
        return;
    end
    
    navCtrl:removeWindowControllerByTag(8001);
    navCtrl:removeWindowControllerByTag(7022);
    navCtrl:removeWindowControllerByTag(2011);
end

----------------消息处理区----------------
function TaskForDay_recvEverydayTaskInfo(dt)
	if dt == nil then
		return;
	end
	
	m_stEveryDayQuestList.ucQuestStatus = dt:readByte();
	m_stEveryDayQuestList.nQuestType = dt:readInt();
	m_stEveryDayQuestList.nQuestParm = dt:readInt();
	m_stEveryDayQuestList.dwAwardExp = dt:readInt();
	
	local szQuestName = dt:readString();
	m_stEveryDayQuestList.szQuestName = "";
	if szQuestName then
		m_stEveryDayQuestList.szQuestName = szQuestName:getData(); 
	end
	
	local szQuestDescribe = dt:readString();
	m_stEveryDayQuestList.szQuestDescribe = "";
	if szQuestDescribe then
		m_stEveryDayQuestList.szQuestDescribe = szQuestDescribe:getData(); 
	end
	
	m_stEveryDayQuestList.nEveryDay = dt:readInt();
	m_stEveryDayQuestList.idCopy = dt:readInt();
	m_stEveryDayQuestList.idMap = dt:readInt();
	m_stEveryDayQuestList.ucType = dt:readByte();
	m_stEveryDayQuestList.usPosX = dt:readShort();
	m_stEveryDayQuestList.usPosY = dt:readShort();
	removeUnUseWnd();
	showEverydayTaskWnd();
	refresEverydayTaskWnd();
end

function TaskForDay_recvEverydayTaskFinish(dt)
	if dt == nil then
		return;
	end
	
	m_isCanRefresh = dt:readByte();
	m_szRefreshMsg = "";
	local szMsg = dt:readString();
	if szMsg then
		m_szRefreshMsg = szMsg:getData();
	end
	if CLIENT_TYPE == 2 then
		m_nRefreshTimes = dt:readInt();
	end
	
	local wndCtrl = getCurentSceneWindowController(6007);
	if wndCtrl == nil then
		showEverydayTaskWnd();
	end
	
	refresEverydayNullTaskWnd();
end

----------------消息注册区----------------

----------------全局函数区----------------
function TaskForDay_sendEverydayTask()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_ACTQUEST);
	if dataStream then
		dataStream:writeShort(ACTQUEST_SEND_EVERYDAY_QUEST_INFO)
		SCDataTransThread:getSingleton():transData(dataStream)
		SCActivityIndicator:getSingleton():show();
	end 
end

function TaskForDay.wndCloss()
	m_stEveryDayQuestList = {};
	m_isCanRefresh = nil;
	m_szRefreshMsg= nil;
	m_bSendRefreshMsg = nil;
	TaskForDay2.releaseControl();
	TaskForDay1.releaseControl();
end

--函数调用