--定义一个与文件名相同的table
TreasureHunt = {}
------------------消息--------------------

--------------------变量定义--------------
local m_roleInfo = {}					--寻宝武将信息

----------------结构定义区----------------
---武将信息
local stPartnerInfo = {
	initWithStream = function (dt)
		if dt == nil then
			return {}
		end
		
		local tmp = {
            __mode = "kv",
        }
		
		tmp.idPartnerType = dt:readInt();
		local tmpStr = dt:readString();
		if tmpStr == nil then
			tmp.szName = "";
		else	
			tmp.szName = tmpStr:getData();
		end
		
		tmpStr = dt:readString();
		if tmpStr == nil then
			tmp.szClanName = "";
		else	
			tmp.szClanName = tmpStr:getData();
		end		
		
		
		tmp.ucLevel = dt:readByte();
		tmp.ucStatusType = dt:readByte();
		
		tmpStr = dt:readString();
		if tmpStr == nil then
			tmp.szTip = "";
		else	
			tmp.szTip = tmpStr:getData();
		end	
		
		tmpStr = dt:readString();
		if tmpStr == nil then
			tmp.szTip2 = "";
		else	
			tmp.szTip2 = tmpStr:getData();
		end	
		
		tmp.nFacePhoto = dt:readInt();
		tmp.ucRecommend = dt:readByte();
		tmp.ucClan = dt:readByte();
				
		tmp.nAtk = dt:readInt()
		--tmp.nDef = 0--dt:readInt()
		tmp.nSkillAtk = dt:readInt()
		--tmp.nSkillDef = 0--dt:readInt()
		tmp.dwHpGrowUp = dt:readInt()
		tmp.nHp = dt:readInt()
		tmp.szSkillName = dt:readString()
		if tmp.szSkillName then
		    tmp.szSkillName = tmp.szSkillName:getData()
		else
		    tmp.szSkillName = ""
		end
		return tmp
	end
}

----------------常量定义区----------------
local EVENTAWARD_TREASURE_INFO = 17		--寻宝信息 
local EVENTAWARD_TREASURE_HUNT = 18  	--开始寻宝 

----------------函数回调------------------
---页面回调---
function TreasureHunt.onClickedMultiPage(tag, index)
    local pMultiPage = SCTypeCast:castNodeToMultiPage(SCFunction:getUiNodeByIdlist("11002-1"))
    if not pMultiPage then return end
    
    local pageNode = pMultiPage:getPageWithIndex(index)
    if not pageNode then return end
    
    local pChildNode = pageNode:getChildByTag(1)
    if pChildNode then 
		if index == 1 then		--兑换界面
			TreasureHunt2.refreshShopInfo()			--刷新商店兑换状态
		end
		return
	end
    
    --寻宝界面
    if 0 == index then	
		pChildNode = TreasureHunt1.initControl()
        if pChildNode then
			pageNode:addChild(pChildNode)
            TreasureHunt1.init(pChildNode)
            pChildNode:setPosition(CCPointMake(SX(0), SY(0)))
        end
	elseif 1 == index then
		pChildNode = TreasureHunt2.initControl()
        if pChildNode then
			pageNode:addChild(pChildNode)
            TreasureHunt2.init(pChildNode)
            pChildNode:setPosition(CCPointMake(SX(0), SY(0)))
        end
        
        --显示商店信息
		TreasureHunt2.seExchangeShopInfo()		--设置商店信息
		TreasureHunt2.seExchangeShopRoleInfo()
		TreasureHunt2.setBulbNum()				--设置七星灯数量
    end
end

----------------UI控制器区----------------
function TreasureHunt.initControl()
	local pWindow11002 = SCWindow:window()
	if pWindow11002 then
		pWindow11002:setTag(11002)
		pWindow11002:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow11002:setPosition(AUTO_POS(0.00, 0.00))
		local pImgPath = getRealUIResourcePath("1.6/treasure/new00887.png")
		if pImgPath then
			pWindow11002:setTitleWithImage(pImgPath:getData())
		end
		pWindow11002:setContentSize(AUTO_SIZE(480, 320))
		pWindow11002:luaSetSelectorOnClose(TreasureHunt.releaseControl)
	end

	local pMultiPage1 = SCMultiPage:pageWithType(EnumMultiPageTypeLarge)
	if pMultiPage1 then
		pMultiPage1:setTag(1)
		pMultiPage1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pMultiPage1:setPosition(AUTO_POS(0.00, 0.00))
		pMultiPage1:setContentSize(AUTO_SIZE(480, 320))
		local pageImg = {"1.6/treasure/new00889.png", "1.6/treasure/new00885.png"}
		for i = 1, 2 do
			local pNode = SCNode:node()
			if pNode then
				pNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)				   
				pNode:setPosition(ANCHOR_LEFT_BOTTOM)
				pMultiPage1:addPage(pNode)
				local imgPath = getRealUIResourcePath(pageImg[i])				   
				if imgPath then
					pMultiPage1:setTitleAtPage(imgPath:getData(), i - 1)
				end
			end
		end
	end

	if pMultiPage1 and pWindow11002 then
		pWindow11002:addChild(tolua.cast(pMultiPage1, "SCNode"))
	end
	
	return pWindow11002
end

---功能初始化---
function TreasureHunt.init()
	local pWnd = getCurentSceneWindow(11002)
	if not pWnd then return end
	
    local pMultiPage = SCTypeCast:castNodeToMultiPage(pWnd:getChildByTag(1))
    if pMultiPage then
        pMultiPage:luaSetSelectorOnPageSelected(TreasureHunt.onClickedMultiPage)
        local pNode = pMultiPage:getPageWithIndex(0)
        if pNode then
            local pChildNode = TreasureHunt1.initControl()
            if pChildNode then
                pChildNode:setPosition(CCPointMake(SX(0), SY(0)))
                pNode:addChild(pChildNode)
                TreasureHunt1.init(pChildNode)
            end
        end
    end
end

---窗口释放---
function TreasureHunt.releaseControl()
	m_roleInfo = {}
	
	TreasureHunt1.releaseControl()
	TreasureHunt2.releaseControl()
	TreasureHunt3.releaseControl()
	WingsShop.releaseControl()		--兑换信息在羽翼商店接收，需清除
	local num = TreasureHunt3.getBagItemNum();
	if num > 0 then
		showMessage(L("str9290"))
	end
end

----------------消息处理区----------------
----------------消息注册区----------------

----------------全局函数区----------------
function TreasureHunt.showTreasureHuntWnd()
    local wnd =  TreasureHunt.initControl()
    if wnd then
        local wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
            TreasureHunt.init()
            return
        end
    end
end

---寻宝界面请求---
function TreasureHunt.sendHuntWndReq()
	--删除活动框
	local node = SCFunction:getUiNodeByIdlist("5918-5932-10111-5999")
    if node then
        node:removeFromParentAndCleanup(true)
    end
    
    --删除光效
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_PUSH_UNLOCK)
    dataStream:writeShort(UNLOCK_TYPE_CHIBI_TREASURE)
    SCDataTransThread:getSingleton():transData(dataStream)
    
    
	local dt = SCDataTransStream:streamWithCommand(_MSG_COPYAWARD)
    dt:writeShort(EVENTAWARD_TREASURE_INFO)
    SCDataTransThread:getSingleton():transData(dt)
    SCActivityIndicator:getSingleton():show()
    
    --商店信息请求
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_EXCHANGESHOP)
	dataStream:writeByte(2)
	dataStream:writeInt(9)
	SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show()
end

---显示属性界面---
function TreasureHunt.showRoleInfoWnd(bIsNeedBtn)
	local pRunningScene = getRunningScene()
    if not pRunningScene then return end
    
	if pRunningScene:getUINode():getChildByTag(6002) then return end
	if not m_roleInfo[1] then return end
	
	BlowRecruit6.nExtraHeight = 10
    local wnd = BlowRecruit6.initControl()
    if wnd == nil then
        BlowRecruit6.nExtraHeight = 0
		return
    end    
    
	pRunningScene:getUINode():addChild(wnd)
	
	wnd:setBackButtonVisibled(false);
    wnd:setCloseButtonVisibled(false);
    wnd:setFrameVisibled(false);
    wnd:setAutoCloseOnTouchSpace(true)	
	
	local pButton2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("6002-1-2"))
	if pButton2 then
		if bIsNeedBtn then
			pButton2:luaSetSelectorOnClicked(TreasureHunt2.onClickExchangeRole)
			pButton2:setVisible(true)
			pButton2:setTitle(L("str30148"), DEFAULT_FONT_NAME, F(14))
		else
			pButton2:setVisible(false)
		end
	end
	
	if BlowRecruit6.m_pButton6 then--不存在的变量
		BlowRecruit6.m_pButton6:luaSetSelectorOnClicked(onClosePartnerInfoBtnClick)
	end

	local pTextBox3 = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlist("6002-1-3"))
	if m_roleInfo[1] and pTextBox3 then
		local strInfo = "*6"..m_roleInfo[1].szName
		strInfo = strInfo.."_"..L("str5056").." "..m_roleInfo[1].szClanName
		strInfo = strInfo.."_"..L("str0013").." "..m_roleInfo[1].ucLevel;
		
		strInfo = strInfo.."_"..L("str8127").." "..m_roleInfo[1].nAtk;
		--strInfo = strInfo.."_"..L("str9145").." "..parterData.nDef;
		strInfo = strInfo.."_"..L("str8128").." "..m_roleInfo[1].nSkillAtk;
		--strInfo = strInfo.."_"..L("str9146").." "..parterData.nSkillDef;
		strInfo = strInfo.."_"..L("str9147").." "..m_roleInfo[1].dwHpGrowUp;
		strInfo = strInfo.."_"..L("str5069").." "..m_roleInfo[1].nHp;
		strInfo = strInfo.."_".."*3"..L("str0295").." "..m_roleInfo[1].szSkillName;
		
		TextParser:getSingleton():setText(pTextBox3, strInfo); 
	end
end

---接收武将信息---
function TreasureHunt.recvRoleInfo(dt)
	SCActivityIndicator:getSingleton():close()
	m_roleInfo = {}
	
	local ucAmountPerPage = dt:readByte();
	local ucType = dt:readByte();
	local ucClan = dt:readByte();
	local usAllPage = dt:readShort();
	local ucAmount = dt:readByte();
	for i = 1, ucAmount do
		table.insert(m_roleInfo, stPartnerInfo.initWithStream(dt))
	end
	
	--设置武将动作
	TreasureHunt1.showRoleAct()
	TreasureHunt2.showRoleAct()
end

---返回武将信息---
function TreasureHunt.getRoleInfo()
	return m_roleInfo
end
