local _MSG_TRIBE                =1613        --//家族系统
local MSG_SOCIATY_BOSS_TIME_LIST            = 41    --//每周BOSS时间列表
local MSG_SOCIATY_SET_BOSS_TIME            = 42    --//设置每周BOSS时间
    

local data = nil

local stSocialBossTime = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.dwTime = dt:readInt() -- 
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTime = ""
        else
            tmp.szTime = scStr:getData()
        end
        tmp.ucChooseFlag = dt:readByte()
    
        return tmp
    end
}

local stSocialBossTimeList = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv"
        }
        tmp.ucCanSet = dt:readByte()
        tmp.ucAmount = dt:readByte()
        tmp.SocialBossTime = {}
        
        for i = 1, tmp.ucAmount do
          table.insert(tmp.SocialBossTime, stSocialBossTime.initWithStream(dt))
        end
            
        return tmp
    end
}

local function onCheckBox(tag)

        local count = 0
        for i = 1, 7 do
            local pBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2035-"..i));
            if pBox~=nil then
                     if pBox:isSelect() == true then
                        count = count + 1
                    end 
            end
        end 
        
        if count > 2 then 
            for i = 1, 7 do
            local pBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2035-"..i));
                if pBox~=nil then
                         if pBox:isSelect()== true and tag ~= i  then
                            pBox:setSelect(false)
                        local pLabel2 = SCTypeCast:castNodeToLabel(pBox:getChildByTag(i*10 + 2));
                        if pLabel2 then
                             pLabel2:setVisible(false);
                        end
                        break
                end     
            end
            end
        end

        
        local pBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2035-"..tag));
                if pBox~=nil then
                         if pBox:isSelect()== true   then
                            local pLabel2 = SCTypeCast:castNodeToLabel(pBox:getChildByTag(tag*10 + 2));
                            if pLabel2 then
                                 pLabel2:setVisible(true);
                                 pLabel2:setColor(colorGreen());
                            end
                        else 
                             local pLabel2 = SCTypeCast:castNodeToLabel(pBox:getChildByTag(tag*10 + 2));
                            if pLabel2 then
                                 pLabel2:setVisible(false);    
                              end
                        end   
                end     
     
    
end


local function onSaveClick(tag)

          
    
       local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
       dataStream:writeShort(MSG_SOCIATY_SET_BOSS_TIME);
       dataStream:writeByte(0);
        local count = 0
        for i = 1, 7 do
            local pBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2035-"..i));
            if pBox~=nil then
                     if pBox:isSelect() == true then
                            local time = data.SocialBossTime[i].dwTime
                             dataStream:writeInt(data.SocialBossTime[i].dwTime);
                    end 
            end
        end 
    
   SCDataTransThread:getSingleton():transData(dataStream);


end

local function createSetNode()


     local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiNodeByIdlist("2035"));
    if wnd ~= nil  then
        return wnd
    end


     local wnd = SCTypeCast:castNodeToWindow(SCFunction:getUiById(2035));
    if wnd == nil then
        return nil 
    end
    local imgPath = getRealUIResourcePath("img/titile12.png")
    if imgPath then
        wnd:setTitleWithImage(imgPath:getData());
    end
    
    -- create a test window controller
    local wndCtrl = SCWindowController:controllerWithWindow(wnd);
    wnd:setBackgroundColor(colorWindowRedBG());
    
    local naviCtrl =  getCurentSceneNavigationController();
    if  naviCtrl and wndCtrl then
    naviCtrl:pushWindowController(wndCtrl);
    end
    
    for i = 1, 7 do 
        
    local pBox = SCTypeCast:castNodeToCheckBox(wnd:getChildByTag(i));
    if pBox then
        --pBox:setDescribe(_("str2030"),getDefaultFontName(),gFontSizeMake(15),colorOrange());
        local strFile = getRealUIResourcePath("img/new00003.png");
        if strFile then 
            pBox:setBackgroundImage(strFile:getData())
        end
        
        local strFile = getRealUIResourcePath("img/img1015.png"); 
        if strFile then 
            pBox:setSelectedImage(strFile:getData())
        end

        pBox:luaSetSelectorOnButtonClicked(onCheckBox);
    end
        
    end
    
    return wnd;
end

local function recSetList()
    local dataStream = LuaData:getSingleton():getDataTransStream();
     if dataStream == nil then
         return ;
     end
       local tmp = stSocialBossTimeList.initWithStream(dataStream)
    local wnd = createSetNode();
    if wnd == nil then 
        return 
    end 
    
    data = tmp
    
    local pBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(10));
    if pBtn ~= nil then
        pBtn:luaSetSelectorOnClicked(onSaveClick);
        if Hero:getSingleton() then
            if Hero:getSingleton():isSocietyLeader() == false then
                pBtn:setVisible(false);
            end
        end
    end
    
    for i = 1, tmp.ucAmount do
        
            local pBox = SCTypeCast:castNodeToCheckBox(wnd:getChildByTag(i));
            if pBox~=nil then
                if tmp.ucCanSet== 0 then
                    pBox:setTouchEnabled(false)
                end
                
                
                
                local pLabel1 = SCTypeCast:castNodeToLabel(pBox:getChildByTag(i*10 + 1));
                if pLabel1 then
                    pLabel1:setText(""..tmp.SocialBossTime[i].szTime);
                end
                            
                local pLabel2 = SCTypeCast:castNodeToLabel(pBox:getChildByTag(i*10 + 2));
                if pLabel2 then
                    if tmp.SocialBossTime[i].ucChooseFlag == 1 then 
                            pLabel2:setVisible(true);
                            pLabel2:setColor(colorGreen());
                            pBox:setSelect(true);
                    else
                        pLabel2:setVisible(false);
                    end
                end
        
            end
    end 
    
end



LuaData:getSingleton():luaSetSelectorOnRecvData(recSetList, LuaData_SOCIATY_BOSS_TIME_LIST);