--定义一个与文件名相同的table
ViewPlayInfo = {}
----------------常量定义区----------------
local OTHERPLAYDATA_CHECK = 11  --点击查看

local GOD_HUNTER_DRAGON = 1811010010 --青龙魂
local GOD_HUNTER_TIGER = 1812010010  --白虎魂
local GOD_HUNTER_BRID = 1813010010   --朱雀魂
local GOD_HUNTER_TURTLE = 1814010010 --玄武魂
local GOD_HUNTER_BEGIN = 1811010000
local GOD_HUNTER_END = 1861010010
----------------变量定义区----------------
local Wnd = nil
local flag = nil  --当前显示界面的标志位
local BaseOrSkill = nil  --0表示在基础界面1表示在技能界面
local ViewOtherAll = {}
local m_Value = 0;
----------------结构定义区----------------
local stEquip_Info = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		self.ucPos = dt:readByte()			 		--装备的位置
		self.IdEquip = dt:readInt()			    	--装备id
		self.ItemTypeId = dt:readInt()                --TypeId
		self.IdEquipPhoto = dt:readInt()    		--装备图片id
	return self
	end	
}

local stSoul_Info = {
    initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
	    self.ucPos = dt:readByte()          --武魂的位置
		self.IdHunt = dt:readInt()          --武魂id
        self.idType = dt:readInt()          --武魂类型id
        self.IdHuntPhoto = dt:readInt()     --武魂图片id
        self.ucLevel = dt:readByte()        --武魂等级 
        self.szName = dt:readString()       --武魂名字
        if self.szName then
		    self.szName = self.szName:getData()
		else
		    self.szName = " "
		end
		self.idMagicType1 = dt:readInt()  --武魂属性1
		self.idMagicType2 = dt:readInt()  --武魂属性2
		--[[
        self.szHuntAttr = dt:readString()   --武魂属性
        if self.szHuntAttr then
		    self.szHuntAttr = self.szHuntAttr:getData()
		else
		    self.szHuntAttr = " "
		end
		self.szHuntAttr1 = dt:readString()   --武魂属性
        if self.szHuntAttr1 then
		    self.szHuntAttr1 = self.szHuntAttr1:getData()
		else
		    self.szHuntAttr1 = " "
		end
		]]
	return self
	end	
}

local stViewOtherAll = {
	initWithStream = function(dt)
		if dt == nil then
			return {}
		end
		
		local self = {
            __mode = "kv",
        }
		
		self.idObj = dt:readInt()			 		--玩家id
		self.ucObjType = dt:readByte()			    --人物1武将2
		self.szName = dt:readString()               --名字(szName)
		if self.szName then
		    self.szName = self.szName:getData()
		else
		    self.szName = " "
		end
		self.usLev = dt:readShort()					--等级
		self.ucProfession = dt:readByte()			--职业
		self.dwLowLookFace = dt:readInt()			--图片索引
		self.dwReputation = dt:readInt()			--声望
		self.currExp = dt:readInt()					--当前经验
		self.upExp = dt:readInt()					--升级经验
		self.dwLife = dt:readInt()					--生命
		self.dwPhyAtk = dt:readInt()				--物攻
		self.dwPhyDef = dt:readInt()				--物防
		self.dwSkillAtk = dt:readInt()				--技攻
		self.dwSkillDef = dt:readInt()				--技防
		self.dwStrength = dt:readInt()				--武力
		self.dwIntellect = dt:readInt()				--智力
		self.dwAtkDamage = dt:readInt()				--破甲伤害
		self.dwDefDamage = dt:readInt()				--减免伤害
		self.dwCritRate = dt:readInt()				--暴击
		self.dwResilienceRate = dt:readInt()		--暴击抵抗
		self.dwCritDmgRate = dt:readInt()	 		--暴击伤害
		self.ucAccount = dt:readByte()				--装备的个数
		self.stEquInfo = {}							--装备信息
		self.idMagicTypeSet = {}					--技能信息
		for i = 1, self.ucAccount do
			table.insert(self.stEquInfo, stEquip_Info.initWithStream(dt))
		end
		for i = 1, 5 do
			self.idMagicTypeSet[i] = dt:readInt()
		end
        self.ucSoulAccount = dt:readByte()          --武魂数量
		self.stSoulInfo = {}						--武魂信息
		for i = 1, self.ucSoulAccount do
			table.insert(self.stSoulInfo, stSoul_Info.initWithStream(dt))
		end
		if CLIENT_VERSION >= 328 then
		    self.nFightCapacityRank = dt:readInt();
		end
		self.idWingPhoto = dt:readInt(); --//翅膀图片id

		
		return self
	end
}
----------------本地函数----------------------
local function ChangeView(tag)  --切换界面
    local pButton1 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4421-10"))   --基础按钮
    local pButton2 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4421-11"))   --技能按钮
    local pButton3 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4421-12"))   --武魂按钮
    local pButton4 = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("4421-13"))   --神器按钮
    local imgPath = getRealUIResourcePath("kernal/multi-page-large-other.pn")    --未选中底板图标
    local imgPath1 = getRealUIResourcePath("kernal/multi-page-large-current.pn")   --选中底板图标
    if pButton1==nil or pButton2==nil or pButton3==nil or pButton4==nil or imgPath==nil or imgPath1==nil then
        return;
    end
    if tag == 10 then

        BaseOrSkill = 0;
        for i = 1, 4 do
            local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i-1)))
            if pDragNode then
                pDragNode:setVisible(false)
            end
            local pDragNode2 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+19)))
            if pDragNode2 then
                pDragNode2:setVisible(false)
            end
            local pDragNode3 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+29)))
            if pDragNode3 then
                pDragNode3:setVisible(false)
            end
        end
        local pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..flag))
        if pDragNode1 then
            pDragNode1:setVisible(true)
        end
        pButton1:setBackgroundImage(imgPath1:getData())
        pButton2:setBackgroundImage(imgPath:getData())
        pButton3:setBackgroundImage(imgPath:getData())
        pButton4:setBackgroundImage(imgPath:getData())
        --end
    elseif tag == 11 then
        BaseOrSkill = 1;
        for i = 1, 4 do
            local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i-1)))
            if pDragNode then
                pDragNode:setVisible(false)
            end
            local pDragNode2 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+19)))
            if pDragNode2 then
                pDragNode2:setVisible(false)
            end
            local pDragNode3 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+29)))
            if pDragNode3 then
                pDragNode3:setVisible(false)
            end
        end
        local pDragNode1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(flag+20)))
        if pDragNode1 then
            pDragNode1:setVisible(true)
        end
        pButton1:setBackgroundImage(imgPath:getData())
        pButton2:setBackgroundImage(imgPath1:getData())
        pButton3:setBackgroundImage(imgPath:getData())
        pButton4:setBackgroundImage(imgPath:getData())
    elseif tag == 12 then
        BaseOrSkill = 2;
        for i = 1, 4 do
            local pDragNode = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i-1)))
            if pDragNode then
                pDragNode:setVisible(false)
            end
            local pDragNode2 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+19)))
            if pDragNode2 then
                pDragNode2:setVisible(false)
            end
            local pDragNode3 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+29)))
            if pDragNode3 then
                pDragNode3:setVisible(false)
            end
        end
        local pDragNode3 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(flag+30)))
        if pDragNode3 then
            pDragNode3:setVisible(true)
        end
        pButton1:setBackgroundImage(imgPath:getData())
        pButton2:setBackgroundImage(imgPath:getData())
        pButton3:setBackgroundImage(imgPath1:getData())
        pButton4:setBackgroundImage(imgPath:getData())
    elseif tag == 13 then
        showMessage(L("str6194"))
        pButton1:setBackgroundImage(imgPath:getData())
        pButton2:setBackgroundImage(imgPath:getData())
        pButton3:setBackgroundImage(imgPath:getData())
        pButton4:setBackgroundImage(imgPath1:getData())
    end
end 

local function Addfriend()
    gAddFriend(ViewOtherAll.idUser, ViewOtherAll.stOtherBase[1].szName)     --加为好友
end

local function ViewResName(tag)    --查看装备名字
    ItemProcessor:getSingleton():sendLookOtherItem(tag)
end

local function addBoss()    --加载宠物
    local PageBox = tolua.cast(SCFunction:getUiNodeByIdlist("4421-10000"), "SCPageScrollBox");
	if PageBox == nil then
	    return;
	end
    
    for j = 2, ViewOtherAll.ucAmount do
        local pImageFile = getRealUIResourcePath("kernal/Tip3.pn");	--设置第一个Dragnode边框
        local pTxtFile = getRealUIResourcePath("kernal/Tip3.ini");
        local pDragNode10002 = SCDragNode:node()
        if pDragNode10002 then
            pDragNode10002:setTag(j)
            pDragNode10002:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10002:setPosition(AUTO_POS(0.00 + 202 * (j - 1), 0.00))
            pDragNode10002:setContentSize(AUTO_SIZE(202, 260))
            pDragNode10002:setFrameVisibled(true)
             if pTxtFile and pImageFile then
                pDragNode10002:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
            end
            pDragNode10002:setDragEnabled(false)
            PageBox:addChild(tolua.cast(pDragNode10002, "SCNode"))
        end
        
        local imgPath = getRealUIResourcePath("img/new00012.png")  --蓝色圆图标
        local pImage10006 = SCImage:imageWithFile(imgPath:getData())
        if pImage10006 and imgPath then
            pImage10006:setTag(10006)
            pImage10006:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage10006:setPosition(AUTO_POS(35.50, 101.50))
            pImage10006:setContentSize(AUTO_SIZE(128, 128))
            pDragNode10002:addChild(tolua.cast(pImage10006, "SCNode"))
        end
        
        local ani = nil
        local lookfcae = nil
        if j == 1 then
            lookfcae = ViewOtherAll.stOtherBase[j].dwLowLookFace / 10;
        else
            lookfcae = ViewOtherAll.stOtherBase[j].dwLowLookFace;
        end
        ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(lookfcae, lookfcae, EnumFrameAnchorFoot); 
        if ani then
            local aniNode = SCAnimationNode:nodeWithAnimation(ani);
            if aniNode then
                aniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                aniNode:setPosition(CCPointMake(pDragNode10002:getContentSize().width/2, SY(155)));
                pDragNode10002:addChild(aniNode);
                aniNode:setTag(9999);
                local ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(ViewOtherAll.stOtherBase[j].idWingPhoto, ViewOtherAll.stOtherBase[j].idWingPhoto, EnumFrameAnchorFoot); 
				if ani then
					setHeroBackAnimation(ani, aniNode)
					resetHeroBackAnimationPosition(aniNode, CCPointMake(ani:getPosition().x, ani:getPosition().y - SX(10)))
				end
            end
        end
        
        local pName = SCLabel:labelWithStringFont(ViewOtherAll.stOtherBase[j].szName, DEFAULT_FONT_NAME, F(11))
        if pName then
            pName:setAnchorPoint(CCPointMake(0.5, 0.5))
            pName:setPosition(CCPointMake(pDragNode10002:getContentSize().width/2, SY(235)))
            pName:setColor(Hero:getSingleton():getNameColor(ViewOtherAll.stOtherBase[j].usLev))
            pDragNode10002:addChild(tolua.cast(pName, "SCNode"))
        end
        
        local pExp = SCLabel:labelWithStringFont("LV."..ViewOtherAll.stOtherBase[j].usLev, DEFAULT_FONT_NAME, F(11))
        if pExp then
            pExp:setAnchorPoint(CCPointMake(0.5, 0.5))
            pExp:setPosition(CCPointMake(pDragNode10002:getContentSize().width/2, SY(222)))
            pExp:setColor(Hero:getSingleton():getNameColor(ViewOtherAll.stOtherBase[j].usLev))
            pDragNode10002:addChild(tolua.cast(pExp, "SCNode"))
        end

        local pDragNode10007 = SCDragNode:node()        --第一个存放3个底背景图标容器
        if pDragNode10007 then
            pDragNode10007:setTag(10007)
            pDragNode10007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10007:setPosition(AUTO_POS(4.00, 99.00))
            pDragNode10007:setContentSize(AUTO_SIZE(57, 154))
            pDragNode10007:setFrameVisibled(false)
            pDragNode10007:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10007, "SCNode"))
        end

        local imgPath = getRealUIResourcePath("img/new00002.png")
        local pButton10008 = SCButton:button()
        if pButton10008 then
            --pButton10008:setTag(1)
            pButton10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10008:setPosition(AUTO_POS(5.50, 104.50))
            pButton10008:setContentSize(AUTO_SIZE(46, 46))
            --pButton10008:setTitle()
            pButton10008:setBackgroundImage(imgPath:getData())
            pButton10008:setSelectedImage(imgPath:getData())
            pDragNode10007:addChild(tolua.cast(pButton10008, "SCNode"))
        end
        
        local pButton10009 = SCButton:button()
        if pButton10009 then
            --pButton10009:setTag(2)
            pButton10009:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10009:setPosition(AUTO_POS(5.00, 53.00))
            pButton10009:setContentSize(AUTO_SIZE(46, 46))
            --pButton10009:setTitle()
            pButton10009:setBackgroundImage(imgPath:getData())
            pButton10009:setSelectedImage(imgPath:getData())
            pDragNode10007:addChild(tolua.cast(pButton10009, "SCNode"))
        end
        
        local pButton10010 = SCButton:button()
        if pButton10010 then
            --pButton10010:setTag(3)
            pButton10010:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10010:setPosition(AUTO_POS(5.00, 0.00))
            pButton10010:setContentSize(AUTO_SIZE(46, 46))
            --pButton10010:setTitle()
            pButton10010:setBackgroundImage(imgPath:getData())
            pButton10010:setSelectedImage(imgPath:getData())
            pDragNode10007:addChild(tolua.cast(pButton10010, "SCNode"))
        end
        
        local pDragNode10008 = SCDragNode:node()        --第二个存放3个底背景图标容器
        if pDragNode10008 then
            pDragNode10008:setTag(10008)
            pDragNode10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10008:setPosition(AUTO_POS(141.00, 99.00))
            pDragNode10008:setContentSize(AUTO_SIZE(57, 154))
            pDragNode10008:setFrameVisibled(false)
            pDragNode10008:setDragEnabled(false)
            --pDragNode10008:setFrameType(EnumFrameTypeRound)
            pDragNode10002:addChild(tolua.cast(pDragNode10008, "SCNode"))
        end

        local imgPath = getRealUIResourcePath("img/new00002.png")
        local pButton10011 = SCButton:button()
        if pButton10011 then
            --pButton10011:setTag(4)
            pButton10011:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10011:setPosition(AUTO_POS(5.50, 104.50))
            pButton10011:setContentSize(AUTO_SIZE(46, 46))
            --pButton10011:setTitle()
            pButton10011:setBackgroundImage(imgPath:getData())
            pButton10011:setSelectedImage(imgPath:getData())
            pDragNode10008:addChild(tolua.cast(pButton10011, "SCNode"))
        end
        
        local pButton10012 = SCButton:button()
        if pButton10012 then
            --pButton10012:setTag(5)
            pButton10012:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10012:setPosition(AUTO_POS(5.00, 53.00))
            pButton10012:setContentSize(AUTO_SIZE(46, 46))
            --pButton10012:setTitle()
            pButton10012:setBackgroundImage(imgPath:getData())
            pButton10012:setSelectedImage(imgPath:getData())
            pDragNode10008:addChild(tolua.cast(pButton10012, "SCNode"))
        end
        
        local pButton10013 = SCButton:button()
        if pButton10013 then
            --pButton10013:setTag(6)
            pButton10013:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10013:setPosition(AUTO_POS(5.00, 0.00))
            pButton10013:setContentSize(AUTO_SIZE(46, 46))
            --pButton10013:setTitle()
            pButton10013:setBackgroundImage(imgPath:getData())
            pButton10013:setSelectedImage(imgPath:getData())
            pDragNode10008:addChild(tolua.cast(pButton10013, "SCNode"))
        end
        
        --装备具体放的位置
        for z = 1, ViewOtherAll.stOtherBase[j].ucAccount do
            if ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 1 and pButton10008 then
                pButton10008:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10008:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10008:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10008:getContentSize().width / 2, pButton10008:getContentSize().height / 2));
                        pButton10008:addChild(pAmiNode);
                    end
                end
                pButton10008:luaSetSelectorOnClicked(ViewResName);
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 2 and pButton10009 then
                pButton10009:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10009:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10009:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10009:getContentSize().width / 2, pButton10009:getContentSize().height / 2));
                        pButton10009:addChild(pAmiNode);
                    end
                end
                pButton10009:luaSetSelectorOnClicked(ViewResName);
                
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 3 and pButton10010 then
                pButton10010:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10010:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10010:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10010:getContentSize().width / 2, pButton10010:getContentSize().height / 2));
                        pButton10010:addChild(pAmiNode);
                    end
                end
                pButton10010:luaSetSelectorOnClicked(ViewResName);
                
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 4 and pButton10011 then
                pButton10011:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10011:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10011:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10011:getContentSize().width / 2, pButton10011:getContentSize().height / 2));
                        pButton10011:addChild(pAmiNode);
                    end
                end
                pButton10011:luaSetSelectorOnClicked(ViewResName);
                
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 5 and pButton10012 then
                pButton10012:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10012:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10012:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10012:getContentSize().width / 2, pButton10012:getContentSize().height / 2));
                        pButton10012:addChild(pAmiNode);
                    end
                end
                pButton10012:luaSetSelectorOnClicked(ViewResName);
                
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 6 and pButton10013 then
                pButton10013:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10013:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10013:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10013:getContentSize().width / 2, pButton10013:getContentSize().height / 2));
                        pButton10013:addChild(pAmiNode);
                    end
                end
                pButton10013:luaSetSelectorOnClicked(ViewResName);
            end
        end

        local pDragNode10017 = SCDragNode:node()    --经验进度条容器
        if pDragNode10017 and pDragNode10002 then
            pDragNode10017:setTag(10017)
            pDragNode10017:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10017:setPosition(AUTO_POS(12.00, 72.50))
            pDragNode10017:setContentSize(AUTO_SIZE(179, 20))
            pDragNode10017:setFrameVisibled(true)
            pDragNode10017:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10017, "SCNode"))
        end

        local imgPath = getRealUIResourcePath("kernal/black-left.pn")  --进度条背景左
        local pImage10018 = SCImage:imageWithFile(imgPath:getData())
        if pImage10018 and imgPath and pDragNode10017 then
            pImage10018:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage10018:setPosition(AUTO_POS(3.00, 3.00))
            pImage10018:setContentSize(AUTO_SIZE(6, 14))
            pDragNode10017:addChild(tolua.cast(pImage10018, "SCNode"))
        end
        
        local imgPath = getRealUIResourcePath("kernal/black-mid.pn") --进度条背景中
        local pImageMid = SCImage:imageWithFile(imgPath:getData(), CCRectMake(0, 0, SX(160), SY(14)))
        if pImageMid and imgPath and pDragNode10017 then
            pImageMid:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImageMid:setPosition(AUTO_POS(9.00, 3.00))
            pDragNode10017:addChild(tolua.cast(pImageMid, "SCNode"))
        end

        local imgPath = getRealUIResourcePath("kernal/black-right.pn")  --进度条背景右
        local pImage10019 = SCImage:imageWithFile(imgPath:getData())
        if pImage10019 and imgPath then
            pImage10019:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage10019:setPosition(AUTO_POS(168.50, 3.00))
            pImage10019:setContentSize(AUTO_SIZE(6, 14))
            pDragNode10017:addChild(tolua.cast(pImage10019, "SCNode"))
        end
        
        --显示经验进度条
        local num = ViewOtherAll.stOtherBase[j].currExp/ViewOtherAll.stOtherBase[j].upExp
        if num > 1 then
            num = 1
        end
        local LeftimgPath = getRealUIResourcePath("kernal/blue-left.pn")  --进度条背景左
        local MiddimgPath = getRealUIResourcePath("kernal/blue-mid.pn")  --进度条背景中
        local RightimgPath = getRealUIResourcePath("kernal/blue-right.pn")  --进度条背景右
        if num <= 0.05 then
            local pImage10018 = SCImage:imageWithFile(LeftimgPath:getData(), CCRectMake(0, 0, SX(6*num*20), SY(14)))
            if pImage10018 and imgPath and pDragNode10017 then
                pImage10018:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage10018:setPosition(AUTO_POS(3.00, 3.00))
                pImage10018:setContentSize(AUTO_SIZE(6, 14))
                pDragNode10017:addChild(tolua.cast(pImage10018, "SCNode"))
            end
        elseif num <= 0.95 then
            local pImage10018 = SCImage:imageWithFile(LeftimgPath:getData(), CCRectMake(0, 0, SX(6), SY(14)))
            if pImage10018 and imgPath and pDragNode10017 then
                pImage10018:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage10018:setPosition(AUTO_POS(3.00, 3.00))
                pImage10018:setContentSize(AUTO_SIZE(6, 14))
                pDragNode10017:addChild(tolua.cast(pImage10018, "SCNode"))
            end
            local pImageMid = SCImage:imageWithFile(MiddimgPath:getData(), CCRectMake(0, 0, SX(160*(num-0.05)*1.1), SY(14)))
            if pImageMid and imgPath and pDragNode10017 then
                pImageMid:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImageMid:setPosition(AUTO_POS(9.00, 3.00))
                pDragNode10017:addChild(tolua.cast(pImageMid, "SCNode"))
            end
        else
            local pImage10018 = SCImage:imageWithFile(LeftimgPath:getData(), CCRectMake(0, 0, SX(6), SY(14)))
            if pImage10018 and imgPath and pDragNode10017 then
                pImage10018:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage10018:setPosition(AUTO_POS(3.00, 3.00))
                pImage10018:setContentSize(AUTO_SIZE(6, 14))
                pDragNode10017:addChild(tolua.cast(pImage10018, "SCNode"))
            end
            local pImageMid = SCImage:imageWithFile(MiddimgPath:getData(), CCRectMake(0, 0, SX(160), SY(14)))
            if pImageMid and imgPath and pDragNode10017 then
                pImageMid:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImageMid:setPosition(AUTO_POS(9.00, 3.00))
                pDragNode10017:addChild(tolua.cast(pImageMid, "SCNode"))
            end
            local pImage10019 = SCImage:imageWithFile(RightimgPath:getData(), CCRectMake(0, 0, SX(6*(num-0.95)*20), SY(14)))
            if pImage10019 and imgPath and pDragNode10017 then
                pImage10019:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage10019:setPosition(AUTO_POS(168.50, 3.00))
                pImage10019:setContentSize(AUTO_SIZE(6, 14))
                pDragNode10017:addChild(tolua.cast(pImage10019, "SCNode"))
            end
        end
            
        local ExpLabel = SCLabel:labelWithStringFont(ViewOtherAll.stOtherBase[j].currExp.."/"..ViewOtherAll.stOtherBase[j].upExp, DEFAULT_FONT_NAME, F(13))  --显示当前经验数  --ViewOtherAll.stOtherBase[j].currExp/ViewOtherAll.stOtherBase[j].upExp
        if ExpLabel and pDragNode10017 then
            ExpLabel:setAnchorPoint(ANCHOR_CENTER)
            ExpLabel:setPosition(AUTO_POS(90.00, 10.00))
            pDragNode10017:addChild(tolua.cast(ExpLabel, "SCNode"))
        end
        
        local pDragNode10012 = SCDragNode:node()   --第一个文字容器
        if pDragNode10012 then
            pDragNode10012:setTag(10012)
            pDragNode10012:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10012:setPosition(AUTO_POS(20.00, 50.00))
            pDragNode10012:setContentSize(AUTO_SIZE(175, 25))
            pDragNode10012:setFrameVisibled(false)
            pDragNode10012:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10012, "SCNode"))
        end
        
        local pText10013 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10013 and pDragNode10012 then
            pText10013:setTag(1)
            pText10013:setAnchorPoint(ANCHOR_CENTER)
            pText10013:setPosition(AUTO_POS(45.50, 4.00))
            pText10013:setScrollVertical(false)
            --pText:setContentSize(AUTO_SIZE(102, 60))
            if ViewOtherAll.stOtherBase[j].ucProfession == 1 then
                TextParser:getSingleton():setText(pText10013, L("str0383"))
            elseif ViewOtherAll.stOtherBase[j].ucProfession == 2 then
                TextParser:getSingleton():setText(pText10013, L("str0386"))
            elseif ViewOtherAll.stOtherBase[j].ucProfession == 3 then
                TextParser:getSingleton():setText(pText10013, L("str0384"))
            elseif ViewOtherAll.stOtherBase[j].ucProfession == 4 then
                TextParser:getSingleton():setText(pText10013, L("str0385"))
            end
            if j > 1 then
                TextParser:getSingleton():setText(pText10013, L("str3031"))
            end
            pDragNode10012:addChild(tolua.cast(pText10013, "SCNode"))
        end

        local pText10014 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10014 and pDragNode10012 then
            pText10014:setTag(2)
            pText10014:setAnchorPoint(ANCHOR_CENTER)
            pText10014:setPosition(AUTO_POS(132.00, 4.00))
            pText10014:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10014, L("str0387").."*6"..ViewOtherAll.stOtherBase[j].dwLife.."*0")
            pDragNode10012:addChild(tolua.cast(pText10014, "SCNode"))
        end
        
        local pDragNode10013 = SCDragNode:node()   --第二个文字容器
        if pDragNode10013 and pDragNode10012 then
            pDragNode10013:setTag(10013)
            pDragNode10013:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10013:setPosition(AUTO_POS(20.00, 30.00))
            pDragNode10013:setContentSize(AUTO_SIZE(175, 25))
            pDragNode10013:setFrameVisibled(false)
            pDragNode10013:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10013, "SCNode"))
        end
        
        local pText10013 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10013 then
            pText10013:setTag(1)
            pText10013:setAnchorPoint(ANCHOR_CENTER)
            pText10013:setPosition(AUTO_POS(45.50, 4.00))
            pText10013:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10013, L("str0388").."*6"..ViewOtherAll.stOtherBase[j].dwPhyAtk.."*0")
            pDragNode10013:addChild(tolua.cast(pText10013, "SCNode"))
        end

        local pText10014 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10014 and pDragNode10013 then
            pText10014:setTag(2)
            pText10014:setAnchorPoint(ANCHOR_CENTER)
            pText10014:setPosition(AUTO_POS(132.00, 4.00))
            pText10014:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10014, L("str0389").."*6"..ViewOtherAll.stOtherBase[j].dwPhyDef.."*0")
            pDragNode10013:addChild(tolua.cast(pText10014, "SCNode"))
        end
        
        local pDragNode10014 = SCDragNode:node()   --第三个文字容器
        if pDragNode10014 and pDragNode10002 then
            pDragNode10014:setTag(10014)
            pDragNode10014:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10014:setPosition(AUTO_POS(20.00, 10.00))
            pDragNode10014:setContentSize(AUTO_SIZE(175, 25))
            pDragNode10014:setFrameVisibled(false)
            pDragNode10014:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10014, "SCNode"))
        end
        
        local pText10013 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10013 and pDragNode10014 then
            pText10013:setTag(1)
            pText10013:setAnchorPoint(ANCHOR_CENTER)
            pText10013:setPosition(AUTO_POS(45.50, 4.00))
            pText10013:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10013, L("str0390").."*6"..ViewOtherAll.stOtherBase[j].dwSkillAtk.."*0")
            pDragNode10014:addChild(tolua.cast(pText10013, "SCNode"))
        end

        local pText10014 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10014 and pDragNode10014 then
            pText10014:setTag(2)
            pText10014:setAnchorPoint(ANCHOR_CENTER)
            pText10014:setPosition(AUTO_POS(132.00, 4.00))
            pText10014:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10014, L("str0391").."*6"..ViewOtherAll.stOtherBase[j].dwSkillDef.."*0")
            pDragNode10014:addChild(tolua.cast(pText10014, "SCNode"))
        end
	end
end

local function ListBoxCheck(tag, itemTag, itemIndex)
    if m_Value == 0 then
        addBoss();
        m_Value = m_Value + 1;
    end
    flag = itemTag;
    for i = 0, 3 do
        local pImage = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4421-9998-"..i.."-1"))
        local pNodeDrag = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..i))
        local pNodeDrag1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+20)))
        local pNodeDrag2 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+30)))
        if pImage then
            pImage:setImage(RES("img/new00015.png"))
        end
        if pNodeDrag then
            pNodeDrag:setVisible(false)
        end
        if pNodeDrag1 then
            pNodeDrag1:setVisible(false)
        end
        if pNodeDrag2 then
            pNodeDrag2:setVisible(false)
        end
    end

    local PageBoxLeft = SCFunction:getUiNodeByIdlist("4421-10000");
    if PageBoxLeft then
        PageBoxLeft:setOffset(AUTO_POS(202 * itemTag, 0))
    end
    
    if BaseOrSkill == 0 then
        local pNode = SCFunction:getUiNodeByIdlist("4421-"..itemTag);
        if pNode then
            pNode:setVisible(true)
        end
    elseif BaseOrSkill == 1 then
        local pNode = SCFunction:getUiNodeByIdlist("4421-"..(itemTag+20));
        if pNode then
            pNode:setVisible(true)
        end
    elseif BaseOrSkill == 2 then
        local pNode = SCFunction:getUiNodeByIdlist("4421-"..(itemTag+30));
        if pNode then
            pNode:setVisible(true)
        end
    end
    
    local pImage1 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4421-9998-"..itemTag.."-1"))
    if pImage1 then
        pImage1:setImage(RES("img/new00016.png"))
    end
end

local function PageBoxLeftCheck(tag, itemTag, itemIndex)
    if m_Value == 0 then
        addBoss();
        m_Value = m_Value + 1;
    end
    for i = 0, 3 do
        local pImage = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4421-9998-"..i.."-1"))
        local pNodeDrag = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..i))
        local pNodeDrag1 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+20)))
        local pNodeDrag2 = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlist("4421-"..(i+30)))
        if pImage then
            pImage:setImage(RES("img/new00015.png"))
        end
        if pNodeDrag then
            pNodeDrag:setVisible(false)
        end
        if pNodeDrag1 then
            pNodeDrag1:setVisible(false)
        end
        if pNodeDrag2 then
            pNodeDrag2:setVisible(false)
        end
    end
    local PageBoxLeft = SCFunction:getUiNodeByIdlist("4421-10000");
    if PageBoxLeft then
        Value = PageBoxLeft:getPageIndex()
        flag = PageBoxLeft:getPageIndex()
    end
    
    if BaseOrSkill == 0 then
        local pNode = SCFunction:getUiNodeByIdlist("4421-"..flag);
        if pNode then
            pNode:setVisible(true)
        end
    elseif BaseOrSkill == 1 then
        local pNode = SCFunction:getUiNodeByIdlist("4421-"..(flag+20));
        if pNode then
            pNode:setVisible(true)
        end
    elseif BaseOrSkill == 2 then
        local pNode = SCFunction:getUiNodeByIdlist("4421-"..(flag+30));
        if pNode then
            pNode:setVisible(true)
        end
    end

    local pImage1 = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlist("4421-9998-"..Value.."-1"))
    if pImage1 then
        pImage1:setImage(RES("img/new00016.png"))
    end
end

local function BoxView()            --最左边listbox按钮框
    local pListbox = SCListBox:boxWithWidthHeight(AUTO_W(69), AUTO_H(195))  --存放全部切换按钮容器
    if pListbox and Wnd then
        pListbox:setTag(9998)
        pListbox:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pListbox:setPosition(AUTO_POS(4.00, 66.00))
        pListbox:setScrollVertical(false)
        pListbox:luaSetSelectorOnItemSelected(ListBoxCheck)
        Wnd:addChild(tolua.cast(pListbox, "SCNode"))
    end
        
    for i = 1, ViewOtherAll.ucAmount do
        local pNodeRole1 = SCDragNode:node()        --存放单个按钮容器
        if pNodeRole1 and pListbox then
            pNodeRole1:setTag(i-1)
            pNodeRole1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pNodeRole1:setPosition(AUTO_POS(0.00, 157.00 - (i - 1) * 42))
            pNodeRole1:setContentSize(AUTO_SIZE(58, 38))
            pNodeRole1:setDragEnabled(false)
            pListbox:addItem(tolua.cast(pNodeRole1, "SCNode"))
        end
        
        local imgPath = nil
        if i > 1 then
            imgPath = getRealUIResourcePath("img/new00015.png")  --灰色底板
        else
            imgPath = getRealUIResourcePath("img/new00016.png")  --黄色底板
        end
        local pImageRole1 = SCImage:imageWithFile(imgPath:getData())
        if pImageRole1 and imgPath then
            pImageRole1:setTag(1)
            pImageRole1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImageRole1:setPosition(AUTO_POS(0.00, 0.00))
            pNodeRole1:addChild(tolua.cast(pImageRole1, "SCNode"))
        end
        
        local pLableName = SCLabel:labelWithStringFont(ViewOtherAll.stOtherBase[i].szName, DEFAULT_FONT_NAME, F(12))  --玩家姓名
        if pLableName and pNodeRole1 then
            pLableName:setTag(2)
            pLableName:setAnchorPoint(ANCHOR_CENTER)
            pLableName:setPosition(CCPointMake(pImageRole1:getContentSize().width/2, SY(25)))
            pLableName:setColor(Hero:getSingleton():getNameColor(ViewOtherAll.stOtherBase[i].usLev))
            pNodeRole1:addChild(tolua.cast(pLableName, "SCNode"))
        end
        
        local pLableExp = SCLabel:labelWithStringFont("LV."..ViewOtherAll.stOtherBase[i].usLev, DEFAULT_FONT_NAME, F(12)) --玩家等级
        if pLableExp and pNodeRole1 then
            pLableExp:setTag(3)
            pLableExp:setAnchorPoint(ANCHOR_CENTER)
            pLableExp:setPosition(CCPointMake(pImageRole1:getContentSize().width/2, SY(9)))
            pLableExp:setColor(Hero:getSingleton():getNameColor(ViewOtherAll.stOtherBase[i].usLev))
            pNodeRole1:addChild(tolua.cast(pLableExp, "SCNode"))
        end
	end
end

local function LeftView()   --左边显示人物装备
    local PageBox = SCPageScrollBox:boxWithWidthHeight(AUTO_W(202), AUTO_H(260));
	if PageBox and Wnd then
	    PageBox:setTag(10000)
		PageBox:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		PageBox:setPosition(AUTO_POS(69.50, 7.00))
		PageBox:setContentSize(AUTO_SIZE(202 * ViewOtherAll.ucAmount, 260))
		PageBox:setScrollVertical(false)
		PageBox:setScrollHorizontal(true)
		PageBox:setPageSize(AUTO_SIZE(202, 260));
		PageBox:luaSetSelectorOnScrollToPrevious(PageBoxLeftCheck)
		PageBox:luaSetSelectorOnScrollToNext(PageBoxLeftCheck)
		Wnd:addChild(tolua.cast(PageBox, "SCNode"))
	end
    
    for j = 1, 1 do
        local pImageFile = getRealUIResourcePath("kernal/Tip3.pn");	--设置第一个Dragnode边框
        local pTxtFile = getRealUIResourcePath("kernal/Tip3.ini");
        local pDragNode10002 = SCDragNode:node()
        if pDragNode10002 and PageBox then
            pDragNode10002:setTag(j)
            pDragNode10002:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10002:setPosition(AUTO_POS(0.00 + 202 * (j - 1), 0.00))
            pDragNode10002:setContentSize(AUTO_SIZE(202, 260))
            pDragNode10002:setFrameVisibled(true)
             if pTxtFile and pImageFile then
                pDragNode10002:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
            end
            pDragNode10002:setDragEnabled(false)
            PageBox:addChild(tolua.cast(pDragNode10002, "SCNode"))
        end
        
        local imgPath = getRealUIResourcePath("img/new00012.png")  --蓝色圆图标
        local pImage10006 = SCImage:imageWithFile(imgPath:getData())
        if pImage10006 and imgPath then
            pImage10006:setTag(10006)
            pImage10006:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage10006:setPosition(AUTO_POS(35.50, 101.50))
            pImage10006:setContentSize(AUTO_SIZE(128, 128))
            pDragNode10002:addChild(tolua.cast(pImage10006, "SCNode"))
        end
        
        local ani = nil
        local lookfcae = nil
        if j == 1 then
            lookfcae = ViewOtherAll.stOtherBase[j].dwLowLookFace / 10;
        else
            lookfcae = ViewOtherAll.stOtherBase[j].dwLowLookFace;
        end
        ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(lookfcae, lookfcae, EnumFrameAnchorFoot); 
        if ani then
            local aniNode = SCAnimationNode:nodeWithAnimation(ani);
            if aniNode then
                aniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                aniNode:setPosition(CCPointMake(pDragNode10002:getContentSize().width/2, SY(155)));
                pDragNode10002:addChild(aniNode);
                aniNode:setTag(9999);
                
                if CLIENT_VERSION >= 328 then
                    if ViewOtherAll.stOtherBase[j].nFightCapacityRank and ViewOtherAll.stOtherBase[j].ucObjType == 1 then
                        setHeroFootAnimation(ViewOtherAll.stOtherBase[j].nFightCapacityRank, aniNode);
                    end
                end
				local ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(ViewOtherAll.stOtherBase[j].idWingPhoto, ViewOtherAll.stOtherBase[j].idWingPhoto, EnumFrameAnchorFoot); 
				if ani then
					setHeroBackAnimation(ani, aniNode)
				end
            end
        end
        
        local pName = SCLabel:labelWithStringFont(ViewOtherAll.stOtherBase[j].szName, DEFAULT_FONT_NAME, F(11))
        if pName then
            pName:setAnchorPoint(CCPointMake(0.5, 0.5))
            pName:setPosition(CCPointMake(pDragNode10002:getContentSize().width/2, SY(235)))
            pName:setColor(Hero:getSingleton():getNameColor(ViewOtherAll.stOtherBase[j].usLev))
            pDragNode10002:addChild(tolua.cast(pName, "SCNode"))
        end
        
        local pExp = SCLabel:labelWithStringFont("LV."..ViewOtherAll.stOtherBase[j].usLev, DEFAULT_FONT_NAME, F(11))
        if pExp then
            pExp:setAnchorPoint(CCPointMake(0.5, 0.5))
            pExp:setPosition(CCPointMake(pDragNode10002:getContentSize().width/2, SY(222)))
            pExp:setColor(Hero:getSingleton():getNameColor(ViewOtherAll.stOtherBase[j].usLev))
            pDragNode10002:addChild(tolua.cast(pExp, "SCNode"))
        end

        local pDragNode10007 = SCDragNode:node()        --第一个存放3个底背景图标容器
        if pDragNode10007 and pDragNode10002 then
            pDragNode10007:setTag(10007)
            pDragNode10007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10007:setPosition(AUTO_POS(4.00, 99.00))
            pDragNode10007:setContentSize(AUTO_SIZE(57, 154))
            pDragNode10007:setFrameVisibled(false)
            pDragNode10007:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10007, "SCNode"))
        end

        local imgPath = getRealUIResourcePath("img/new00002.png")
        local pButton10008 = SCButton:button()
        if pButton10008 and pDragNode10007 then
            --pButton10008:setTag(1)
            pButton10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10008:setPosition(AUTO_POS(5.50, 104.50))
            pButton10008:setContentSize(AUTO_SIZE(46, 46))
            --pButton10008:setTitle()
            pButton10008:setBackgroundImage(imgPath:getData())
            pButton10008:setSelectedImage(imgPath:getData())
            pDragNode10007:addChild(tolua.cast(pButton10008, "SCNode"))
        end
        
        local pButton10009 = SCButton:button()
        if pButton10009 and pDragNode10007 then
            --pButton10009:setTag(2)
            pButton10009:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10009:setPosition(AUTO_POS(5.00, 53.00))
            pButton10009:setContentSize(AUTO_SIZE(46, 46))
            --pButton10009:setTitle()
            pButton10009:setBackgroundImage(imgPath:getData())
            pButton10009:setSelectedImage(imgPath:getData())
            pDragNode10007:addChild(tolua.cast(pButton10009, "SCNode"))
        end
        
        local pButton10010 = SCButton:button()
        if pButton10010 and pDragNode10007 then
            --pButton10010:setTag(3)
            pButton10010:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10010:setPosition(AUTO_POS(5.00, 0.00))
            pButton10010:setContentSize(AUTO_SIZE(46, 46))
            --pButton10010:setTitle()
            pButton10010:setBackgroundImage(imgPath:getData())
            pButton10010:setSelectedImage(imgPath:getData())
            pDragNode10007:addChild(tolua.cast(pButton10010, "SCNode"))
        end
        
        local pDragNode10008 = SCDragNode:node()        --第二个存放3个底背景图标容器
        if pDragNode10008 and pDragNode10002 then
            pDragNode10008:setTag(10008)
            pDragNode10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10008:setPosition(AUTO_POS(141.00, 99.00))
            pDragNode10008:setContentSize(AUTO_SIZE(57, 154))
            pDragNode10008:setFrameVisibled(false)
            pDragNode10008:setDragEnabled(false)
            --pDragNode10008:setFrameType(EnumFrameTypeRound)
            pDragNode10002:addChild(tolua.cast(pDragNode10008, "SCNode"))
        end

        local imgPath = getRealUIResourcePath("img/new00002.png")
        local pButton10011 = SCButton:button()
        if pButton10011 and pDragNode10008 then
            --pButton10011:setTag(4)
            pButton10011:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10011:setPosition(AUTO_POS(5.50, 104.50))
            pButton10011:setContentSize(AUTO_SIZE(46, 46))
            --pButton10011:setTitle()
            pButton10011:setBackgroundImage(imgPath:getData())
            pButton10011:setSelectedImage(imgPath:getData())
            pDragNode10008:addChild(tolua.cast(pButton10011, "SCNode"))
        end
        
        local pButton10012 = SCButton:button()
        if pButton10012 and pDragNode10008 then
            --pButton10012:setTag(5)
            pButton10012:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10012:setPosition(AUTO_POS(5.00, 53.00))
            pButton10012:setContentSize(AUTO_SIZE(46, 46))
            --pButton10012:setTitle()
            pButton10012:setBackgroundImage(imgPath:getData())
            pButton10012:setSelectedImage(imgPath:getData())
            pDragNode10008:addChild(tolua.cast(pButton10012, "SCNode"))
        end
        
        local pButton10013 = SCButton:button()
        if pButton10013 and pDragNode10008 then
            --pButton10013:setTag(6)
            pButton10013:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pButton10013:setPosition(AUTO_POS(5.00, 0.00))
            pButton10013:setContentSize(AUTO_SIZE(46, 46))
            --pButton10013:setTitle()
            pButton10013:setBackgroundImage(imgPath:getData())
            pButton10013:setSelectedImage(imgPath:getData())
            pDragNode10008:addChild(tolua.cast(pButton10013, "SCNode"))
        end
        
        --装备具体放的位置
        for z = 1, ViewOtherAll.stOtherBase[j].ucAccount do
            if ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 1 and pDragNode10008 then
                pButton10008:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10008:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10008:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10008:getContentSize().width / 2, pButton10008:getContentSize().height / 2));
                        pButton10008:addChild(pAmiNode);
                    end
                end
                pButton10008:luaSetSelectorOnClicked(ViewResName);
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 2 and pButton10009 then
                pButton10009:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10009:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10009:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10009:getContentSize().width / 2, pButton10009:getContentSize().height / 2));
                        pButton10009:addChild(pAmiNode);
                    end
                end
                pButton10009:luaSetSelectorOnClicked(ViewResName);
                
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 3 and pButton10010 then
                pButton10010:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10010:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10010:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10010:getContentSize().width / 2, pButton10010:getContentSize().height / 2));
                        pButton10010:addChild(pAmiNode);
                    end
                end
                pButton10010:luaSetSelectorOnClicked(ViewResName);
                
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 4 and pButton10011 then
                pButton10011:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10011:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10011:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10011:getContentSize().width / 2, pButton10011:getContentSize().height / 2));
                        pButton10011:addChild(pAmiNode);
                    end
                end
                pButton10011:luaSetSelectorOnClicked(ViewResName);
                
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 5 and pButton10012 then
                pButton10012:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10012:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10012:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10012:getContentSize().width / 2, pButton10012:getContentSize().height / 2));
                        pButton10012:addChild(pAmiNode);
                    end
                end
                pButton10012:luaSetSelectorOnClicked(ViewResName);
                
            elseif ViewOtherAll.stOtherBase[j].stEquInfo[z].ucPos == 6 and pButton10013 then
                pButton10013:setTag(ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquip);
                pButton10013:setTitle(RES("item/"..ViewOtherAll.stOtherBase[j].stEquInfo[z].IdEquipPhoto..".jp"))
                if ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId then
                    local mark = ViewOtherAll.stOtherBase[j].stEquInfo[z].ItemTypeId % 100 - 3 - 2
                    local pAmiNode = getQualityNode(mark)
                    if pAmiNode then
                        pButton10013:removeAllChildrenWithCleanup(true);
                        pAmiNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        pAmiNode:setPosition(CCPointMake(pButton10013:getContentSize().width / 2, pButton10013:getContentSize().height / 2));
                        pButton10013:addChild(pAmiNode);
                    end
                end
                pButton10013:luaSetSelectorOnClicked(ViewResName);
            end
        end

        local pDragNode10017 = SCDragNode:node()    --经验进度条容器
        if pDragNode10017 and pDragNode10002 then
            pDragNode10017:setTag(10017)
            pDragNode10017:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10017:setPosition(AUTO_POS(12.00, 72.50))
            pDragNode10017:setContentSize(AUTO_SIZE(179, 20))
            pDragNode10017:setFrameVisibled(true)
            pDragNode10017:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10017, "SCNode"))
        end

        local imgPath = getRealUIResourcePath("kernal/black-left.pn")  --进度条背景左
        local pImage10018 = SCImage:imageWithFile(imgPath:getData())
        if pImage10018 and imgPath and pDragNode10017 then
            pImage10018:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage10018:setPosition(AUTO_POS(3.00, 3.00))
            pImage10018:setContentSize(AUTO_SIZE(6, 14))
            pDragNode10017:addChild(tolua.cast(pImage10018, "SCNode"))
        end
        
        local imgPath = getRealUIResourcePath("kernal/black-mid.pn") --进度条背景中
        local pImageMid = SCImage:imageWithFile(imgPath:getData(), CCRectMake(0, 0, SX(160), SY(14)))
        if pImageMid and imgPath and pDragNode10017 then
            pImageMid:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImageMid:setPosition(AUTO_POS(9.00, 3.00))
            pDragNode10017:addChild(tolua.cast(pImageMid, "SCNode"))
        end

        local imgPath = getRealUIResourcePath("kernal/black-right.pn")  --进度条背景右
        local pImage10019 = SCImage:imageWithFile(imgPath:getData())
        if pImage10019 and imgPath and pDragNode10017 then
            pImage10019:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pImage10019:setPosition(AUTO_POS(168.50, 3.00))
            pImage10019:setContentSize(AUTO_SIZE(6, 14))
            pDragNode10017:addChild(tolua.cast(pImage10019, "SCNode"))
        end
        
        --显示经验进度条
        local num = ViewOtherAll.stOtherBase[j].currExp/ViewOtherAll.stOtherBase[j].upExp
        if num > 1 then
            num = 1
        end
        local LeftimgPath = getRealUIResourcePath("kernal/blue-left.pn")  --进度条背景左
        local MiddimgPath = getRealUIResourcePath("kernal/blue-mid.pn")  --进度条背景中
        local RightimgPath = getRealUIResourcePath("kernal/blue-right.pn")  --进度条背景右
        if num <= 0.05 then
            local pImage10018 = SCImage:imageWithFile(LeftimgPath:getData(), CCRectMake(0, 0, SX(6*num*20), SY(14)))
            if pImage10018 and imgPath and pDragNode10017 then
                pImage10018:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage10018:setPosition(AUTO_POS(3.00, 3.00))
                pImage10018:setContentSize(AUTO_SIZE(6, 14))
                pDragNode10017:addChild(tolua.cast(pImage10018, "SCNode"))
            end
        elseif num <= 0.95 then
            local pImage10018 = SCImage:imageWithFile(LeftimgPath:getData(), CCRectMake(0, 0, SX(6), SY(14)))
            if pImage10018 and imgPath and pDragNode10017 then
                pImage10018:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage10018:setPosition(AUTO_POS(3.00, 3.00))
                pImage10018:setContentSize(AUTO_SIZE(6, 14))
                pDragNode10017:addChild(tolua.cast(pImage10018, "SCNode"))
            end
            local pImageMid = SCImage:imageWithFile(MiddimgPath:getData(), CCRectMake(0, 0, SX(160*(num-0.05)*1.1), SY(14)))
            if pImageMid and imgPath and pDragNode10017 then
                pImageMid:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImageMid:setPosition(AUTO_POS(9.00, 3.00))
                pDragNode10017:addChild(tolua.cast(pImageMid, "SCNode"))
            end
        else
            local pImage10018 = SCImage:imageWithFile(LeftimgPath:getData(), CCRectMake(0, 0, SX(6), SY(14)))
            if pImage10018 and imgPath and pDragNode10017 then
                pImage10018:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage10018:setPosition(AUTO_POS(3.00, 3.00))
                pImage10018:setContentSize(AUTO_SIZE(6, 14))
                pDragNode10017:addChild(tolua.cast(pImage10018, "SCNode"))
            end
            local pImageMid = SCImage:imageWithFile(MiddimgPath:getData(), CCRectMake(0, 0, SX(160), SY(14)))
            if pImageMid and imgPath and pDragNode10017 then
                pImageMid:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImageMid:setPosition(AUTO_POS(9.00, 3.00))
                pDragNode10017:addChild(tolua.cast(pImageMid, "SCNode"))
            end
            local pImage10019 = SCImage:imageWithFile(RightimgPath:getData(), CCRectMake(0, 0, SX(6*(num-0.95)*20), SY(14)))
            if pImage10019 and imgPath and pDragNode10017 then
                pImage10019:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                pImage10019:setPosition(AUTO_POS(168.50, 3.00))
                pImage10019:setContentSize(AUTO_SIZE(6, 14))
                pDragNode10017:addChild(tolua.cast(pImage10019, "SCNode"))
            end
        end
            
        local ExpLabel = SCLabel:labelWithStringFont(ViewOtherAll.stOtherBase[j].currExp.."/"..ViewOtherAll.stOtherBase[j].upExp, DEFAULT_FONT_NAME, F(13))  --显示当前经验数  --ViewOtherAll.stOtherBase[j].currExp/ViewOtherAll.stOtherBase[j].upExp
        if ExpLabel and pDragNode10017 then
            ExpLabel:setAnchorPoint(ANCHOR_CENTER)
            ExpLabel:setPosition(AUTO_POS(90.00, 10.00))
            pDragNode10017:addChild(tolua.cast(ExpLabel, "SCNode"))
        end
        
        local pDragNode10012 = SCDragNode:node()   --第一个文字容器
        if pDragNode10012 and pDragNode10002 then
            pDragNode10012:setTag(10012)
            pDragNode10012:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10012:setPosition(AUTO_POS(20.00, 50.00))
            pDragNode10012:setContentSize(AUTO_SIZE(175, 25))
            pDragNode10012:setFrameVisibled(false)
            pDragNode10012:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10012, "SCNode"))
        end
        
        local pText10013 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10013 then
            pText10013:setTag(1)
            pText10013:setAnchorPoint(ANCHOR_CENTER)
            pText10013:setPosition(AUTO_POS(45.50, 4.00))
            pText10013:setScrollVertical(false)
            --pText:setContentSize(AUTO_SIZE(102, 60))
            if ViewOtherAll.stOtherBase[j].ucProfession == 1 then
                TextParser:getSingleton():setText(pText10013, L("str0383"))
            elseif ViewOtherAll.stOtherBase[j].ucProfession == 2 then
                TextParser:getSingleton():setText(pText10013, L("str0386"))
            elseif ViewOtherAll.stOtherBase[j].ucProfession == 3 then
                TextParser:getSingleton():setText(pText10013, L("str0384"))
            elseif ViewOtherAll.stOtherBase[j].ucProfession == 4 then
                TextParser:getSingleton():setText(pText10013, L("str0385"))
            end
            if j > 1 then
                TextParser:getSingleton():setText(pText10013, L("str3031"))
            end
            pDragNode10012:addChild(tolua.cast(pText10013, "SCNode"))
        end

        local pText10014 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10014 and pDragNode10012 then
            pText10014:setTag(2)
            pText10014:setAnchorPoint(ANCHOR_CENTER)
            pText10014:setPosition(AUTO_POS(132.00, 4.00))
            pText10014:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10014, L("str0387").."*6"..ViewOtherAll.stOtherBase[j].dwLife.."*0")
            pDragNode10012:addChild(tolua.cast(pText10014, "SCNode"))
        end
        
        local pDragNode10013 = SCDragNode:node()   --第二个文字容器
        if pDragNode10013 and pDragNode10002 then
            pDragNode10013:setTag(10013)
            pDragNode10013:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10013:setPosition(AUTO_POS(20.00, 30.00))
            pDragNode10013:setContentSize(AUTO_SIZE(175, 25))
            pDragNode10013:setFrameVisibled(false)
            pDragNode10013:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10013, "SCNode"))
        end
        
        local pText10013 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10013 then
            pText10013:setTag(1)
            pText10013:setAnchorPoint(ANCHOR_CENTER)
            pText10013:setPosition(AUTO_POS(45.50, 4.00))
            pText10013:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10013, L("str0388").."*6"..ViewOtherAll.stOtherBase[j].dwPhyAtk.."*0")
            pDragNode10013:addChild(tolua.cast(pText10013, "SCNode"))
        end

        local pText10014 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10014 and pDragNode10013 then
            pText10014:setTag(2)
            pText10014:setAnchorPoint(ANCHOR_CENTER)
            pText10014:setPosition(AUTO_POS(132.00, 4.00))
            pText10014:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10014, L("str0389").."*6"..ViewOtherAll.stOtherBase[j].dwPhyDef.."*0")
            pDragNode10013:addChild(tolua.cast(pText10014, "SCNode"))
        end
        
        local pDragNode10014 = SCDragNode:node()   --第三个文字容器
        if pDragNode10014 and pDragNode10002 then
            pDragNode10014:setTag(10014)
            pDragNode10014:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10014:setPosition(AUTO_POS(20.00, 10.00))
            pDragNode10014:setContentSize(AUTO_SIZE(175, 25))
            pDragNode10014:setFrameVisibled(false)
            pDragNode10014:setDragEnabled(false)
            pDragNode10002:addChild(tolua.cast(pDragNode10014, "SCNode"))
        end
        
        local pText10013 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10013 and pDragNode10014 then
            pText10013:setTag(1)
            pText10013:setAnchorPoint(ANCHOR_CENTER)
            pText10013:setPosition(AUTO_POS(45.50, 4.00))
            pText10013:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10013, L("str0390").."*6"..ViewOtherAll.stOtherBase[j].dwSkillAtk.."*0")
            pDragNode10014:addChild(tolua.cast(pText10013, "SCNode"))
        end

        local pText10014 = SCTextBox:boxWithWidthHeightFont(AUTO_W(89), AUTO_H(16), DEFAULT_FONT_NAME, F(11));
        if pText10014 then
            pText10014:setTag(2)
            pText10014:setAnchorPoint(ANCHOR_CENTER)
            pText10014:setPosition(AUTO_POS(132.00, 4.00))
            pText10014:setScrollVertical(false)
            TextParser:getSingleton():setText(pText10014, L("str0391").."*6"..ViewOtherAll.stOtherBase[j].dwSkillDef.."*0")
            pDragNode10014:addChild(tolua.cast(pText10014, "SCNode"))
        end
	end
end

local function RightView()   --右边显示人物具体信息
    
    for j = 1, ViewOtherAll.ucAmount do
    
    local pImageFile = getRealUIResourcePath("kernal/Tip3.pn");
    local pTxtFile = getRealUIResourcePath("kernal/Tip3.ini");
    local pDragNode10003 = SCDragNode:node()        --设置第二个Dragnode边框
	if pDragNode10003 then
		pDragNode10003:setTag(j-1)
		pDragNode10003:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10003:setPosition(AUTO_POS(269.50, 7.00))
		pDragNode10003:setContentSize(AUTO_SIZE(202, 260))
		pDragNode10003:setFrameVisibled(true)
		 if pTxtFile and pImageFile then
            pDragNode10003:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
        end
        if j == 1 then
            pDragNode10003:setVisible(true)
        else
            pDragNode10003:setVisible(false)
        end
		pDragNode10003:setDragEnabled(false)
		--PageBox:addChild(tolua.cast(pDragNode10003, "SCNode"), 2, 2)
		Wnd:addChild(tolua.cast(pDragNode10003, "SCNode"))
	end

	local pDragNode10020 = SCDragNode:node()   --头像容器
	if pDragNode10020 then
		pDragNode10020:setTag(10020)
		pDragNode10020:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10020:setPosition(AUTO_POS(10.50, 179.50))
		pDragNode10020:setContentSize(AUTO_SIZE(175, 66))
		pDragNode10020:setFrameVisibled(false)
		pDragNode10020:setDragEnabled(false)
		pDragNode10003:addChild(tolua.cast(pDragNode10020, "SCNode"))
		--pDragNode10020:setFrameType(EnumFrameTypeRound)
	end

    local imgPath = nil
    local pLable10024 = nil
    --local num = ViewOtherAll.stOtherBase[j].dwLowLookFace
	if ViewOtherAll.stOtherBase[j].ucProfession == 1 then
	    if ViewOtherAll.stOtherBase[j].ucObjType == 1 then
            imgPath = getRealUIResourcePath("faceicon/311004.jp")  --角色图像
        else
            imgPath = getRealUIResourcePath("faceicon/"..ViewOtherAll.stOtherBase[j].dwLowLookFace..".jp")
        end
        if j == 1 then
            pLable10024 = SCLabel:labelWithStringFont(L("str0392"), DEFAULT_FONT_NAME, F(12))  --英雄职业
        else
            pLable10024 = SCLabel:labelWithStringFont(L("str3032"), DEFAULT_FONT_NAME, F(12))
        end
    elseif ViewOtherAll.stOtherBase[j].ucProfession == 2 then
        if ViewOtherAll.stOtherBase[j].ucObjType == 1 then
            imgPath = getRealUIResourcePath("faceicon/311003.jp")  --角色图像
        else
            imgPath = getRealUIResourcePath("faceicon/"..ViewOtherAll.stOtherBase[j].dwLowLookFace..".jp")
        end
        --pLable10024 = SCLabel:labelWithStringFont(L("str0393"), DEFAULT_FONT_NAME, F(12))  --英雄职业
         if j == 1 then
            pLable10024 = SCLabel:labelWithStringFont(L("str0395"), DEFAULT_FONT_NAME, F(12))  --英雄职业
        else
            pLable10024 = SCLabel:labelWithStringFont(L("str3032"), DEFAULT_FONT_NAME, F(12))
        end
    elseif ViewOtherAll.stOtherBase[j].ucProfession == 3 then
        if ViewOtherAll.stOtherBase[j].ucObjType == 1 then
            imgPath = getRealUIResourcePath("faceicon/311001.jp")  --角色图像
        else
            imgPath = getRealUIResourcePath("faceicon/"..ViewOtherAll.stOtherBase[j].dwLowLookFace..".jp")
        end
        --pLable10024 = SCLabel:labelWithStringFont(L("str0394"), DEFAULT_FONT_NAME, F(12))  --英雄职业
        if j == 1 then
            pLable10024 = SCLabel:labelWithStringFont(L("str0393"), DEFAULT_FONT_NAME, F(12))  --英雄职业
        else
            pLable10024 = SCLabel:labelWithStringFont(L("str3032"), DEFAULT_FONT_NAME, F(12))
        end
    elseif ViewOtherAll.stOtherBase[j].ucProfession == 4 then
        if ViewOtherAll.stOtherBase[j].ucObjType == 1 then
            imgPath = getRealUIResourcePath("faceicon/311002.jp")  --角色图像
        else
            imgPath = getRealUIResourcePath("faceicon/"..ViewOtherAll.stOtherBase[j].dwLowLookFace..".jp")
        end
        --pLable10024 = SCLabel:labelWithStringFont(L("str0395"), DEFAULT_FONT_NAME, F(12))  --英雄职业
         if j == 1 then
            pLable10024 = SCLabel:labelWithStringFont(L("str0394"), DEFAULT_FONT_NAME, F(12))  --英雄职业
        else
            pLable10024 = SCLabel:labelWithStringFont(L("str3032"), DEFAULT_FONT_NAME, F(12))
        end
    end
    local pImage10021 = nil
    if imgPath then
	    pImage10021 = SCImage:imageWithFile(imgPath:getData())
	end
	if pImage10021 and imgPath and pDragNode10020 then
		pImage10021:setTag(10021)
		pImage10021:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10021:setPosition(AUTO_POS(5.00, 3.00))
		pImage10021:setContentSize(AUTO_SIZE(60, 60))
		pDragNode10020:addChild(tolua.cast(pImage10021, "SCNode"))
	end

	local pDragNode10022 = SCDragNode:node()    --英雄个人信息容器
	if pDragNode10022 and pDragNode10020 then
		pDragNode10022:setTag(10022)
		pDragNode10022:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10022:setPosition(AUTO_POS(69.00, 0.00))
		pDragNode10022:setContentSize(AUTO_SIZE(110, 68))
		pDragNode10022:setFrameVisibled(true)
		pDragNode10022:setDragEnabled(false)
		pDragNode10022:setFrameType(EnumFrameTypeRound)
		pDragNode10020:addChild(tolua.cast(pDragNode10022, "SCNode"))
	end

	local pLable10023 = SCLabel:labelWithStringFont(ViewOtherAll.stOtherBase[j].szName, DEFAULT_FONT_NAME, F(12))  --英雄名字
	if pLable10023 and pDragNode10022 then
		pLable10023:setTag(1)
		pLable10023:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable10023:setColor(Hero:getSingleton():getNameColor(ViewOtherAll.stOtherBase[j].usLev))
		pDragNode10022:addChild(tolua.cast(pLable10023, "SCNode"))
	end
    
    local pText10024 = SCTextBox:boxWithWidthHeightFont(AUTO_W(93), AUTO_H(13), DEFAULT_FONT_NAME, F(12));
    if pText10024 and pDragNode10022 then
        pText10024:setTag(2)
        pText10024:setAnchorPoint(ANCHOR_CENTER)
        pText10024:setScrollVertical(false)
        --pText10024:setPosition(AUTO_POS(59.00, 25.00))
        if ViewOtherAll.stOtherBase[j].ucProfession == 1 then
            TextParser:getSingleton():setText(pText10024, L("str0392"))
        elseif ViewOtherAll.stOtherBase[j].ucProfession == 2 then
            TextParser:getSingleton():setText(pText10024, L("str0395"))
        elseif ViewOtherAll.stOtherBase[j].ucProfession == 3 then
            TextParser:getSingleton():setText(pText10024, L("str0393"))
        elseif ViewOtherAll.stOtherBase[j].ucProfession == 4 then
            TextParser:getSingleton():setText(pText10024, L("str0394"))
        end
        if j > 1 then
            TextParser:getSingleton():setText(pText10024, L("str3032"))
        end
        pDragNode10022:addChild(tolua.cast(pText10024, "SCNode"))
    end
	
    if j < 2 then   
        if pLable10023 then
           pLable10023:setPosition(AUTO_POS(9.00, 44.50))
        end 
        if pText10024 then
            pText10024:setPosition(AUTO_POS(55.50, 32.00))
        end
        local pText10025 = SCTextBox:boxWithWidthHeightFont(AUTO_W(93), AUTO_H(13), DEFAULT_FONT_NAME, F(12));
        if pText10025 and pDragNode10022 then
            pText10025:setTag(3)
            pText10025:setAnchorPoint(ANCHOR_CENTER)
            pText10025:setPosition(AUTO_POS(55.50, 16.00))  
            pText10025:setScrollVertical(false)     
            TextParser:getSingleton():setText(pText10025, L("str0397").."*5"..ViewOtherAll.stOtherBase[j].dwReputation.."*0")
            pDragNode10022:addChild(tolua.cast(pText10025, "SCNode"))
        end
    else
        if  pLable10023 and pText10024 then
            pLable10023:setPosition(AUTO_POS(9.00, 38.50))
            pText10024:setPosition(AUTO_POS(55.50, 22.00))
        end
    end
    
	local pDragNode10026 = SCDragNode:node()      --第一个文字属性容器
	if pDragNode10026 and pDragNode10003 then
		pDragNode10026:setTag(10026)
		pDragNode10026:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10026:setPosition(AUTO_POS(10.00, 149.50))
		pDragNode10026:setContentSize(AUTO_SIZE(176, 33))
		pDragNode10026:setFrameVisibled(false)
		pDragNode10026:setDragEnabled(false)
		--pDragNode10026:setFrameType(EnumFrameTypeRound)
		pDragNode10003:addChild(tolua.cast(pDragNode10026, "SCNode"))
	end

	local pDragNode10027 = SCDragNode:node()
	if pDragNode10027 and pDragNode10026 then
		pDragNode10027:setTag(1)
		pDragNode10027:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10027:setPosition(AUTO_POS(-3.50, 3.50))
		pDragNode10027:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10027:setFrameVisibled(true)
		pDragNode10027:setDragEnabled(false)
		pDragNode10027:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10027, "SCNode"))
	end
	
	local pText10028 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10028 and pDragNode10027 then
        pText10028:setTag(1)
        pText10028:setAnchorPoint(ANCHOR_CENTER)
        pText10028:setPosition(AUTO_POS(51.50, 7.00))
        pText10028:setScrollVertical(false)  
        TextParser:getSingleton():setText(pText10028, L("str0398").."*9"..ViewOtherAll.stOtherBase[j].usLev.."*0")
        pDragNode10027:addChild(tolua.cast(pText10028, "SCNode"))
    end

	local pDragNode10029 = SCDragNode:node()
	if pDragNode10029 and pDragNode10026 then
		pDragNode10029:setTag(2)
		pDragNode10029:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10029:setPosition(AUTO_POS(90.50, 4.00))
		pDragNode10029:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10029:setFrameVisibled(true)
		pDragNode10029:setDragEnabled(false)
		pDragNode10029:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10029, "SCNode"))
	end

    local pText10030 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10030 and pDragNode10029 then
        pText10030:setTag(1)
        pText10030:setAnchorPoint(ANCHOR_CENTER)
        pText10030:setPosition(AUTO_POS(51.50, 7.00))
        pText10030:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10030, L("str0399").."*9"..ViewOtherAll.stOtherBase[j].dwLife.."*0")
        pDragNode10029:addChild(tolua.cast(pText10030, "SCNode"))
    end
	
	local pDragNode10026 = SCDragNode:node()      --第二个文字属性容器
	if pDragNode10026 and pDragNode10003 then
		pDragNode10026:setTag(10027)
		pDragNode10026:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10026:setPosition(AUTO_POS(10.00, 126.50))
		pDragNode10026:setContentSize(AUTO_SIZE(176, 33))
		pDragNode10026:setFrameVisibled(false)
		pDragNode10026:setDragEnabled(false)
		--pDragNode10026:setFrameType(EnumFrameTypeRound)
		pDragNode10003:addChild(tolua.cast(pDragNode10026, "SCNode"))
	end

	local pDragNode10027 = SCDragNode:node()
	if pDragNode10027 and pDragNode10026 then
		pDragNode10027:setTag(1)
		pDragNode10027:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10027:setPosition(AUTO_POS(-3.50, 3.50))
		pDragNode10027:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10027:setFrameVisibled(true)
		pDragNode10027:setDragEnabled(false)
		pDragNode10027:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10027, "SCNode"))
	end

    local pText10028 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10028 and pDragNode10027 then
        pText10028:setTag(1)
        pText10028:setAnchorPoint(ANCHOR_CENTER)
        pText10028:setPosition(AUTO_POS(51.50, 7.00))
        pText10028:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10028, L("str0388").."*9"..ViewOtherAll.stOtherBase[j].dwPhyAtk.."*0")
        pDragNode10027:addChild(tolua.cast(pText10028, "SCNode"))
    end

	local pDragNode10029 = SCDragNode:node()
	if pDragNode10029 and pDragNode10026 then
		pDragNode10029:setTag(2)
		pDragNode10029:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10029:setPosition(AUTO_POS(90.50, 4.00))
		pDragNode10029:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10029:setFrameVisibled(true)
		pDragNode10029:setDragEnabled(false)
		pDragNode10029:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10029, "SCNode"))
	end

    local pText10030 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10030 and pDragNode10029 then
        pText10030:setTag(1)
        pText10030:setAnchorPoint(ANCHOR_CENTER)
        pText10030:setPosition(AUTO_POS(51.50, 7.00))
        pText10030:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10030, L("str0389").."*9"..ViewOtherAll.stOtherBase[j].dwPhyDef.."*0")
        pDragNode10029:addChild(tolua.cast(pText10030, "SCNode"))
    end
	
	local pDragNode10026 = SCDragNode:node()      --第三个文字属性容器
	if pDragNode10026 and pDragNode10003 then
		pDragNode10026:setTag(10028)
		pDragNode10026:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10026:setPosition(AUTO_POS(10.00, 103.50))
		pDragNode10026:setContentSize(AUTO_SIZE(176, 33))
		pDragNode10026:setFrameVisibled(false)
		pDragNode10026:setDragEnabled(false)
		--pDragNode10026:setFrameType(EnumFrameTypeRound)
		pDragNode10003:addChild(tolua.cast(pDragNode10026, "SCNode"))
	end

	local pDragNode10027 = SCDragNode:node()
	if pDragNode10027 and pDragNode10026 then
		pDragNode10027:setTag(1)
		pDragNode10027:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10027:setPosition(AUTO_POS(-3.50, 3.50))
		pDragNode10027:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10027:setFrameVisibled(true)
		pDragNode10027:setDragEnabled(false)
		pDragNode10027:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10027, "SCNode"))
	end

    local pText10028 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10028 and pDragNode10027 then
        pText10028:setTag(1)
        pText10028:setAnchorPoint(ANCHOR_CENTER)
        pText10028:setPosition(AUTO_POS(51.50, 7.00))
        pText10028:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10028, L("str0390").."*9"..ViewOtherAll.stOtherBase[j].dwSkillAtk.."*0")
        pDragNode10027:addChild(tolua.cast(pText10028, "SCNode"))
    end

	local pDragNode10029 = SCDragNode:node()
	if pDragNode10029 and pDragNode10026 then
		pDragNode10029:setTag(2)
		pDragNode10029:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10029:setPosition(AUTO_POS(90.50, 4.00))
		pDragNode10029:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10029:setFrameVisibled(true)
		pDragNode10029:setDragEnabled(false)
		pDragNode10029:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10029, "SCNode"))
	end

    local pText10030 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10030 and pDragNode10029 then
        pText10030:setTag(1)
        pText10030:setAnchorPoint(ANCHOR_CENTER)
        pText10030:setPosition(AUTO_POS(51.50, 7.00))
        pText10030:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10030, L("str0391").."*9"..ViewOtherAll.stOtherBase[j].dwSkillDef.."*0")
        pDragNode10029:addChild(tolua.cast(pText10030, "SCNode"))
    end
	
	local pDragNode10026 = SCDragNode:node()      --第四个文字属性容器
	if pDragNode10026 and pDragNode10003 then
		pDragNode10026:setTag(10029)
		pDragNode10026:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10026:setPosition(AUTO_POS(10.00, 80.50))
		pDragNode10026:setContentSize(AUTO_SIZE(176, 33))
		pDragNode10026:setFrameVisibled(false)
		pDragNode10026:setDragEnabled(false)
		--pDragNode10026:setFrameType(EnumFrameTypeRound)
		pDragNode10003:addChild(tolua.cast(pDragNode10026, "SCNode"))
	end

	local pDragNode10027 = SCDragNode:node()
	if pDragNode10027 and pDragNode10026 then
		pDragNode10027:setTag(1)
		pDragNode10027:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10027:setPosition(AUTO_POS(-3.50, 3.50))
		pDragNode10027:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10027:setFrameVisibled(true)
		pDragNode10027:setDragEnabled(false)
		pDragNode10027:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10027, "SCNode"))
	end

    local pText10028 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10028 and pDragNode10027 then
        pText10028:setTag(1)
        pText10028:setAnchorPoint(ANCHOR_CENTER)
        pText10028:setPosition(AUTO_POS(51.50, 7.00))
        pText10028:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10028, L("str0400").."*9"..ViewOtherAll.stOtherBase[j].dwStrength.."*0")
        pDragNode10027:addChild(tolua.cast(pText10028, "SCNode"))
    end

	local pDragNode10029 = SCDragNode:node()
	if pDragNode10029 and pDragNode10026 then
		pDragNode10029:setTag(2)
		pDragNode10029:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10029:setPosition(AUTO_POS(90.50, 4.00))
		pDragNode10029:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10029:setFrameVisibled(true)
		pDragNode10029:setDragEnabled(false)
		pDragNode10029:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10029, "SCNode"))
	end
    
    local pText10030 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10030 and pDragNode10029 then
        pText10030:setTag(1)
        pText10030:setAnchorPoint(ANCHOR_CENTER)
        pText10030:setPosition(AUTO_POS(51.50, 7.00))
        pText10030:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10030, L("str0401").."*9"..ViewOtherAll.stOtherBase[j].dwIntellect.."*0")
        pDragNode10029:addChild(tolua.cast(pText10030, "SCNode"))
    end
	
	local pDragNode10026 = SCDragNode:node()      --第五个文字属性容器
	if pDragNode10026 and pDragNode10003 then
		pDragNode10026:setTag(10030)
		pDragNode10026:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10026:setPosition(AUTO_POS(10.00, 57.50))
		pDragNode10026:setContentSize(AUTO_SIZE(176, 33))
		pDragNode10026:setFrameVisibled(false)
		pDragNode10026:setDragEnabled(false)
		--pDragNode10026:setFrameType(EnumFrameTypeRound)
		pDragNode10003:addChild(tolua.cast(pDragNode10026, "SCNode"))
	end

	local pDragNode10027 = SCDragNode:node()
	if pDragNode10027 and pDragNode10026 then
		pDragNode10027:setTag(1)
		pDragNode10027:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10027:setPosition(AUTO_POS(-3.50, 3.50))
		pDragNode10027:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10027:setFrameVisibled(true)
		pDragNode10027:setDragEnabled(false)
		pDragNode10027:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10027, "SCNode"))
	end

    local pText10028 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10028 and pDragNode10027 then
        pText10028:setTag(1)
        pText10028:setAnchorPoint(ANCHOR_CENTER)
        pText10028:setPosition(AUTO_POS(51.50, 7.00))
        pText10028:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10028, L("str0402").."*9"..ViewOtherAll.stOtherBase[j].dwAtkDamage.."*0")
        pDragNode10027:addChild(tolua.cast(pText10028, "SCNode"))
    end

	local pDragNode10029 = SCDragNode:node()
	if pDragNode10029 and pDragNode10026 then
		pDragNode10029:setTag(2)
		pDragNode10029:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10029:setPosition(AUTO_POS(90.50, 4.00))
		pDragNode10029:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10029:setFrameVisibled(true)
		pDragNode10029:setDragEnabled(false)
		pDragNode10029:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10029, "SCNode"))
	end

    local pText10030 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10030 and pDragNode10029 then
        pText10030:setTag(1)
        pText10030:setAnchorPoint(ANCHOR_CENTER)
        pText10030:setPosition(AUTO_POS(51.50, 7.00))
        pText10030:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10030, L("str0403").."*9"..ViewOtherAll.stOtherBase[j].dwDefDamage.."*0")
        pDragNode10029:addChild(tolua.cast(pText10030, "SCNode"))
    end
	
	local pDragNode10026 = SCDragNode:node()      --第六个文字属性容器
	if pDragNode10026 and pDragNode10003 then
		pDragNode10026:setTag(10031)
		pDragNode10026:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10026:setPosition(AUTO_POS(10.00, 34.50))
		pDragNode10026:setContentSize(AUTO_SIZE(176, 33))
		pDragNode10026:setFrameVisibled(false)
		pDragNode10026:setDragEnabled(false)
		--pDragNode10026:setFrameType(EnumFrameTypeRound)
		pDragNode10003:addChild(tolua.cast(pDragNode10026, "SCNode"))
	end

	local pDragNode10027 = SCDragNode:node()
	if pDragNode10027 and pDragNode10026 then
		pDragNode10027:setTag(1)
		pDragNode10027:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10027:setPosition(AUTO_POS(-3.50, 3.50))
		pDragNode10027:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10027:setFrameVisibled(true)
		pDragNode10027:setDragEnabled(false)
		pDragNode10027:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10027, "SCNode"))
	end

    local pText10028 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10028 and pDragNode10027 then
        pText10028:setTag(1)
        pText10028:setAnchorPoint(ANCHOR_CENTER)
        pText10028:setPosition(AUTO_POS(51.50, 7.00))
        pText10028:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10028, L("str0404").."*9"..ViewOtherAll.stOtherBase[j].dwCritRate.."*0")
        pDragNode10027:addChild(tolua.cast(pText10028, "SCNode"))
    end

	local pDragNode10029 = SCDragNode:node()
	if pDragNode10029 and pDragNode10026  then
		pDragNode10029:setTag(2)
		pDragNode10029:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10029:setPosition(AUTO_POS(90.50, 4.00))
		pDragNode10029:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10029:setFrameVisibled(true)
		pDragNode10029:setDragEnabled(false)
		pDragNode10029:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10029, "SCNode"))
	end
	
    local pText10030 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10030 and pDragNode10029 then
        pText10030:setTag(1)
        pText10030:setAnchorPoint(ANCHOR_CENTER)
        pText10030:setPosition(AUTO_POS(51.50, 7.00))
        pText10030:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10030, L("str0405").."*9"..ViewOtherAll.stOtherBase[j].dwResilienceRate.."*0")
        pDragNode10029:addChild(tolua.cast(pText10030, "SCNode"))
    end
	
	local pDragNode10026 = SCDragNode:node()      --第七个文字属性容器
	if pDragNode10026 and pDragNode10003 then
		pDragNode10026:setTag(10032)
		pDragNode10026:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10026:setPosition(AUTO_POS(10.00, 11.50))
		pDragNode10026:setContentSize(AUTO_SIZE(176, 33))
		pDragNode10026:setFrameVisibled(false)
		pDragNode10026:setDragEnabled(false)
		--pDragNode10026:setFrameType(EnumFrameTypeRound)
		pDragNode10003:addChild(tolua.cast(pDragNode10026, "SCNode"))
	end

	local pDragNode10027 = SCDragNode:node()
	if pDragNode10027 and pDragNode10026  then
		pDragNode10027:setTag(1)
		pDragNode10027:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10027:setPosition(AUTO_POS(-3.50, 3.50))
		pDragNode10027:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10027:setFrameVisibled(true)
		pDragNode10027:setDragEnabled(false)
		pDragNode10027:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10027, "SCNode"))
	end

    local pText10028 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10028 and pDragNode10027 then
        pText10028:setTag(1)
        pText10028:setAnchorPoint(ANCHOR_CENTER)
        pText10028:setPosition(AUTO_POS(51.50, 7.00))
        pText10028:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10028, L("str0406").."*9"..math.floor(ViewOtherAll.stOtherBase[j].dwCritDmgRate/10).."*0")
        pDragNode10027:addChild(tolua.cast(pText10028, "SCNode"))
    end

	local pDragNode10029 = SCDragNode:node()
	if pDragNode10029 and pDragNode10026  then
		pDragNode10029:setTag(2)
		pDragNode10029:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10029:setPosition(AUTO_POS(90.50, 4.00))
		pDragNode10029:setContentSize(AUTO_SIZE(94, 18))
		pDragNode10029:setFrameVisibled(true)
		pDragNode10029:setDragEnabled(false)
		pDragNode10029:setFrameType(EnumFrameTypeListNormal)
		pDragNode10026:addChild(tolua.cast(pDragNode10029, "SCNode"))
	end

    local pText10030 = SCTextBox:boxWithWidthHeightFont(AUTO_W(90), AUTO_H(15), DEFAULT_FONT_NAME, F(11));
    if pText10030 and pDragNode10029 then
        pText10030:setTag(1)
        pText10030:setAnchorPoint(ANCHOR_CENTER)
        pText10030:setPosition(AUTO_POS(51.50, 7.00))
        pText10030:setScrollVertical(false) 
        TextParser:getSingleton():setText(pText10030, L(""))
        pDragNode10029:addChild(tolua.cast(pText10030, "SCNode"))
    end
	
	end
end

local function SkillView()

    for j = 1, ViewOtherAll.ucAmount do
        local pImageFile = getRealUIResourcePath("kernal/Tip3.pn");	--设置第三个Dragnode边框
        local pTxtFile = getRealUIResourcePath("kernal/Tip3.ini");
        local pDragNode10004 = SCDragNode:node()
        if pDragNode10004 then
            pDragNode10004:setTag(19+j)
            pDragNode10004:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            pDragNode10004:setPosition(AUTO_POS(269.50, 7.00))
            pDragNode10004:setContentSize(AUTO_SIZE(202, 260))
            pDragNode10004:setFrameVisibled(true)
            pDragNode10004:setVisible(false)
            if pTxtFile and pImageFile then
                pDragNode10004:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
            end
            pDragNode10004:setDragEnabled(false)
            Wnd:addChild(tolua.cast(pDragNode10004, "SCNode"))
        end
        
        for i = 0, 4 do
            if ViewOtherAll.stOtherBase[j].idMagicTypeSet[i+1] == 0 then

            else
                local pDragNode1 = SCDragNode:node()
                if pDragNode1 and pDragNode10004 then
                    pDragNode1:setTag(i)
                    pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pDragNode1:setPosition(AUTO_POS(4.00, 198.00 - (i*49)))
                    pDragNode1:setContentSize(AUTO_SIZE(194, 60))
                    pDragNode1:setFrameVisibled(true)
                    pDragNode1:setDragEnabled(false)
                    pDragNode1:setFrameType(EnumFrameTypeRound)
                    pDragNode10004:addChild(tolua.cast(pDragNode1, "SCNode"))
                end
                local item = TableParser:getSingleton():getMagicTypeByKey(ViewOtherAll.stOtherBase[j].idMagicTypeSet[i+1])
                if item then
                    local imgPath = getRealUIResourcePath("img/new00002.png")
                    local imgPath1 = getRealUIResourcePath("Skill/"..item.faction_photo..".png")
                    local SkillButton = SCButton:button()      --技能
                    if SkillButton and imgPath and imgPath1 and pDragNode1 then
                        SkillButton:setTag(10009)
                        SkillButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                        SkillButton:setPosition(AUTO_POS(6.00, 7.00))
                        SkillButton:setContentSize(AUTO_SIZE(46, 46))
                        SkillButton:setTitle(imgPath1:getData())
                        SkillButton:setBackgroundImage(imgPath:getData())
                        SkillButton:setSelectedImage(imgPath:getData())
                        pDragNode1:addChild(tolua.cast(SkillButton, "SCNode"))
                    end
                    
                    local pDragNode = SCFunction:getUiNodeByIdlistAndParent(i.."", pDragNode10004)
                    local pLable10007 = SCLabel:labelWithStringFont(item.name:getData(), DEFAULT_FONT_NAME, F(15))
                    if pLable10007 and pDragNode then
                        pLable10007:setTag(10007)
                        pLable10007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                        pLable10007:setPosition(AUTO_POS(61.00, 33.00))
                        --pLable10007:setColor(Hero:getSingleton():getNameColor(item.level))
                        pDragNode:addChild(tolua.cast(pLable10007, "SCNode"))
                    end
                    
                    local lev = item.level/20
                    local lev1 = item.level%20  --级
                    if lev1 == 0 then
                        lev1 = 20;
                    end
                    local lev2 = nil    --阶
                    if lev <= 1 then
                        lev2 = 1
                    elseif lev <= 2 then
                        lev2 = 2
                    elseif lev <= 3 then
                        lev2 = 3
                    elseif lev <= 4 then
                        lev2 = 4
                    elseif lev <= 5 then
                        lev2 = 5
                    elseif lev <= 6 then
                        lev2 = 6
                    end
                    
                    local ani = nil;
                    local color = color_white;
                    if item.level > 100 then
                        color = colorLightYellow();
                        ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1030, 1030);
                    elseif item.level > 80 then
                        color = colorYellow();
                        ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1015, 1015);
                    elseif item.level > 60 then
                        color = colorPurple();
                        ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1014, 1014);
                    elseif item.level > 40 then
                        color = colorSkyBlue();
                        ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1013, 1013);
                    elseif item.level > 20 then
                        color = colorGreen();
                        ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1012, 1012);
                    end
                    pLable10007:setColor(color)
                    
                    if ani then
                        ani:setFPS(10.0);
                        local aniNode = SCAnimationNode:nodeWithAnimation(ani);
                        if aniNode then
                            aniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                            aniNode:setPosition(CCPointMake(SkillButton:getContentSize().width/2, SkillButton:getContentSize().height/2));
                            SkillButton:addChild(aniNode);
                        end
                    end
                                    
                    local pLable10008 = SCLabel:labelWithStringFont(lev2..L("str0430")..lev1..L("str0407"), DEFAULT_FONT_NAME, F(11))
                    if pLable10008 and pDragNode then
                        pLable10008:setTag(10008)
                        pLable10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                        pLable10008:setColor(color)
                        pLable10008:setPosition(AUTO_POS(61.00, 13.00))
                        pDragNode:addChild(tolua.cast(pLable10008, "SCNode"))
                    end
                end
            end
        end
    end
end

local function Soul()
	for j=1, #ViewOtherAll.stOtherBase do
		local pImageFile = getRealUIResourcePath("kernal/Tip3.pn");	--设置第四个Dragnode边框
		local pTxtFile = getRealUIResourcePath("kernal/Tip3.ini");
		local pDragNode10005 = SCDragNode:node()
		if pDragNode10005 and Wnd then
			pDragNode10005:setTag(29+j)
			pDragNode10005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pDragNode10005:setPosition(AUTO_POS(269.50, 7.00))
			pDragNode10005:setContentSize(AUTO_SIZE(202, 260))
			pDragNode10005:setFrameVisibled(true)
			pDragNode10005:setVisible(false)
			if pTxtFile and pImageFile then
				pDragNode10005:setFrameWithFile(pImageFile:getData(), pTxtFile:getData())
			end
			pDragNode10005:setDragEnabled(false)
			Wnd:addChild(tolua.cast(pDragNode10005, "SCNode"))
		end
		
		local pListBox10016 = SCListBox:boxWithWidthHeight(AUTO_W(194), AUTO_H(243))
		if pListBox10016 and pDragNode10005 then
			tolua.cast(pListBox10016, "SCNode"):setTag(10016)
			tolua.cast(pListBox10016, "SCNode"):setAnchorPoint(ANCHOR_CENTER)
			local size = pDragNode10005:getContentSize()
			tolua.cast(pListBox10016, "SCNode"):setPosition(CCPointMake(size.width / 2, size.height / 2))
			pDragNode10005:addChild(tolua.cast(pListBox10016, "SCNode"))
		end
		
		for i=1, #ViewOtherAll.stOtherBase[j].stSoulInfo do
			if ViewOtherAll.stOtherBase[j].ucSoulAccount == 0 then
				break;
			end
			
			local pDragNode1 = SCDragNode:node()
			if pDragNode1 then
				pDragNode1:setTag(i)
				pDragNode1:setContentSize(AUTO_SIZE(194, 49))
				pDragNode1:setFrameVisibled(false)
				pDragNode1:setDragEnabled(false)
				
				local pDragNode2 = SCDragNode:node()
				if pDragNode2 then
					pDragNode2:setFrameType(EnumFrameTypeRound)
					pDragNode2:setFrameVisibled(true)
					pDragNode2:setDragEnabled(false)
					pDragNode2:setContentSize(AUTO_SIZE(194, 60));
					pDragNode2:setAnchorPoint(CCPointMake(0.5, 0.5));
					local size = pDragNode1:getContentSize();
					pDragNode2:setPosition(CCPointMake(size.width / 2, size.height / 2));
					pDragNode1:addChild(pDragNode2);
				end
				pDragNode1:setFrameType(EnumFrameTypeRound)
				pListBox10016:addItem(tolua.cast(pDragNode1, "SCNode"))
			end

			local imgPath = getRealUIResourcePath("img/new00002.png")
			local imgPath1 = getRealUIResourcePath("item/"..ViewOtherAll.stOtherBase[j].stSoulInfo[i].IdHuntPhoto..".jp")
			local SkillButton = SCButton:button()      --技能
			if SkillButton and imgPath and imgPath1 then
				SkillButton:setTag(10109)
				SkillButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
				SkillButton:setPosition(AUTO_POS(6.00, 1.00))
				SkillButton:setContentSize(AUTO_SIZE(46, 46))
				SkillButton:setTitle(imgPath1:getData())
				SkillButton:setBackgroundImage(imgPath:getData())
				SkillButton:setSelectedImage(imgPath:getData())
				pDragNode1:addChild(tolua.cast(SkillButton, "SCNode"))
			end
			
			local pLable10007 = SCLabel:labelWithStringFont(ViewOtherAll.stOtherBase[j].stSoulInfo[i].szName, DEFAULT_FONT_NAME, F(11))
			if pLable10007 then
				pLable10007:setTag(10007)
				pLable10007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
				pLable10007:setPosition(AUTO_POS(55.00, 29.00))
				pDragNode1:addChild(tolua.cast(pLable10007, "SCNode"))
			end
			
			local pLable10009 = SCLabel:labelWithStringFont("LV."..ViewOtherAll.stOtherBase[j].stSoulInfo[i].ucLevel, DEFAULT_FONT_NAME, F(11))
			if pLable10009 then
				pLable10009:setTag(10009)
				pLable10009:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
				pLable10009:setPosition(AUTO_POS(55.00, 9.00))
				pDragNode1:addChild(tolua.cast(pLable10009, "SCNode"))
			end
			
			local TypeID = ViewOtherAll.stOtherBase[j].stSoulInfo[i].idType%10;
			local color = nil
			if TypeID == 9 then
				color = color_orange   --橙色
			elseif TypeID == 8 then
				color = color_yellow   --黄色
			elseif TypeID == 7 then
				color = color_purple   --紫色
			elseif TypeID == 6 then
				color = color_skyBlue  --蓝色
			elseif TypeID == 5 then
				color = color_green    --绿色
			elseif TypeID == 0 then
				color = color_orange   --橙色
			else 
				color = color_white    --白色
			end

			if pLable10007 and pLable10009 then
				pLable10007:setColor(color)
				pLable10009:setColor(color)
			end 
			if ani then
				ani:setFPS(10.0);
				local aniNode = SCAnimationNode:nodeWithAnimation(ani);
				if aniNode and SkillButton then
					aniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
					aniNode:setPosition(CCPointMake(SkillButton:getContentSize().width/2, SkillButton:getContentSize().height/2));
					SkillButton:addChild(aniNode);
				end
			end
			local pTypeId = ViewOtherAll.stOtherBase[j].stSoulInfo[i].idType
			local strAttr1 = ""
			local strAttr2 = ""
			local color1 = nil
			local color2 = nil
			if pTypeId >= GOD_HUNTER_BEGIN and pTypeId <= GOD_HUNTER_END then
				local itemInfo = TableParser:getSingleton():getItemInfoByKey(pTypeId);
				if itemInfo.effect_type_1 == ViewOtherAll.stOtherBase[j].stSoulInfo[i].idMagicType1 then
					local pLevel = ViewOtherAll.stOtherBase[j].stSoulInfo[i].ucLevel
					local attrNum = itemInfo.effect_param_1 + (pLevel-1)*itemInfo.effect_param_1/2
					strAttr1 = GlobalFunction_getAttributeNameByTypeIdOfHunter(itemInfo.effect_type_1).."+"..attrNum
					if 4971 == itemInfo.effect_type_1 then
						strAttr1 = strAttr1.."%";
					end
					color1 = color_orange
				else
					strAttr1 = L("str3319")
					color1 = color_gray
				end
				if itemInfo.effect_type_2 == ViewOtherAll.stOtherBase[j].stSoulInfo[i].idMagicType2 then
					local pLevel = ViewOtherAll.stOtherBase[j].stSoulInfo[i].ucLevel
					local attrNum = itemInfo.effect_param_2 + (pLevel-1)*itemInfo.effect_param_2/2
					strAttr2 = GlobalFunction_getAttributeNameByTypeIdOfHunter(itemInfo.effect_type_2).."+"..attrNum
					if 4971 == itemInfo.effect_type_2 then
						strAttr2 = strAttr2.."%";
					end
					color2 = color_orange
				else
					strAttr2 = L("str3319")
					color2 = color_gray
				end
			else
				local itemInfo = TableParser:getSingleton():getItemInfoByKey(pTypeId);
				color1 = color_orange
				color2 = color_orange
				if itemInfo.effect_type_1 == ViewOtherAll.stOtherBase[j].stSoulInfo[i].idMagicType1 then
					local pLevel = ViewOtherAll.stOtherBase[j].stSoulInfo[i].ucLevel
					strAttr1 = GlobalFunction_getAttributeNameByTypeIdOfHunter(itemInfo.effect_type_1).."+"..pLevel*itemInfo.effect_param_1
					if 4971 == itemInfo.effect_type_1 then
						strAttr1 = strAttr1.."%";
					end
				end
				strAttr2 = ""
			end
			local pLable10008 = SCLabel:labelWithStringFont(strAttr1, DEFAULT_FONT_NAME, F(11))
			if pLable10008 and pDragNode1 then
				pLable10008:setTag(10008)
				pLable10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
				pLable10008:setColor(color1)
				pLable10008:setPosition(AUTO_POS(105.00, 29.00))
				pDragNode1:addChild(tolua.cast(pLable10008, "SCNode"))
			end
			local pLable10021 = SCLabel:labelWithStringFont(strAttr2, DEFAULT_FONT_NAME, F(11))
			if pLable10021 and pDragNode1 then
				pLable10021:setTag(10021)
				pLable10021:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
				pLable10021:setColor(color2)
				pLable10021:setPosition(AUTO_POS(105.00, 9.00))
				pDragNode1:addChild(tolua.cast(pLable10021, "SCNode"))
			end
        end
    end
end

----------------UI控制器区----------------
function ViewPlayInfo.initControl()
	Wnd = SCWindow:window()
	if Wnd then
		Wnd:setTag(4421)
		Wnd:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Wnd:setPosition(AUTO_POS(0.00, 0.00))
		Wnd:setContentSize(AUTO_SIZE(480, 320))
		Wnd:luaSetSelectorOnClose(ViewPlayInfo.releaseControl)
	end

	local imgPath = getRealUIResourcePath("img/new00574.png")  --查看标题
	local pImage10001 = SCImage:imageWithFile(imgPath:getData())
	if pImage10001 and imgPath and Wnd then
		Wnd:setTitleWithImage(imgPath:getData())
	end
	
    local imgPath = getRealUIResourcePath("kernal/multi-page-large-other.pn")    --未选中底板图标
    local imgPath1 = getRealUIResourcePath("img/new00010.png")   --基础文字
    local imgPath2 = getRealUIResourcePath("img/new00324.png")   --技能文字
    local imgPath3 = getRealUIResourcePath("img/new00325.png")   --神器文字
    local imgPath4 = getRealUIResourcePath("img/new00506.png")   --好友文字
    local imgPath6 = getRealUIResourcePath("img/new00681.png")   --武魂文字
    local imgPath5 = getRealUIResourcePath("kernal/multi-page-large-current.pn")   --选中底板图标
    local imgPath7 = getRealUIResourcePath("kernal/ButtonNormal.pn")   --好友底板图标
    if imgPath == nil or imgPath1 == nil or imgPath2 == nil or imgPath3 == nil or imgPath4 == nil or imgPath6 == nil or imgPath5 == nil then
        return nil
    end
    
    local pButton1 = SCButton:button()      --基础
    if pButton1 and Wnd then
        pButton1:setTag(10)
        pButton1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pButton1:setPosition(AUTO_POS(123.50, 285.50))
        pButton1:setContentSize(AUTO_SIZE(46, 46))
        pButton1:setTitle(imgPath1:getData())
        pButton1:setBackgroundImage(imgPath5:getData())
        pButton1:luaSetSelectorOnClicked(ChangeView)
        Wnd:addChild(tolua.cast(pButton1, "SCNode"))
    end
    
    local pButton2 = SCButton:button()      --技能
    if pButton2 and Wnd then
        pButton2:setTag(11)
        pButton2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pButton2:setPosition(AUTO_POS(199.50, 285.50))
        pButton2:setContentSize(AUTO_SIZE(46, 46))
        pButton2:setTitle(imgPath2:getData())
        pButton2:setBackgroundImage(imgPath:getData())
        pButton2:luaSetSelectorOnClicked(ChangeView)
        Wnd:addChild(tolua.cast(pButton2, "SCNode"))
    end
    
    local pButton3 = SCButton:button()      --武魂
    if pButton3 and Wnd then
        pButton3:setTag(12)
        pButton3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pButton3:setPosition(AUTO_POS(275.50, 285.50))
        pButton3:setContentSize(AUTO_SIZE(46, 46))
        pButton3:setTitle(imgPath6:getData())
        pButton3:setBackgroundImage(imgPath:getData())
        pButton3:luaSetSelectorOnClicked(ChangeView)
        Wnd:addChild(tolua.cast(pButton3, "SCNode"))
    end
    --[[
    local pButton4 = SCButton:button()      --神器
    if pButton4 and Wnd then
        pButton4:setTag(13)
        pButton4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        pButton4:setPosition(AUTO_POS(351.50, 285.50))
        pButton4:setContentSize(AUTO_SIZE(46, 46))
        pButton4:setTitle(imgPath3:getData())
        pButton4:setBackgroundImage(imgPath:getData())
        pButton4:luaSetSelectorOnClicked(ChangeView)
        Wnd:addChild(tolua.cast(pButton4, "SCNode"))
    end
    --]]
    local FriendButton = SCButton:button()      --加为好友
    if FriendButton and Wnd then
        FriendButton:setTag(13)
        --setNodeContentSize(FriendButton, CCSizeMake(SX(61), SY(28)))
        FriendButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
        FriendButton:setButtonType(EnumBtnType9Atlas)
        FriendButton:setPosition(AUTO_POS(8.50, 10.50))
        FriendButton:setContentSize(AUTO_SIZE(61, 28))
        FriendButton:setTitle(imgPath4:getData())
        --FriendButton:setTitle("好友", DEFAULT_FONT_NAME, F(13), ccc4(255, 255, 255, 255)); 
        --FriendButton:setBackgroundImage(imgPath7:getData())
        FriendButton:luaSetSelectorOnClicked(Addfriend)
        Wnd:addChild(tolua.cast(FriendButton, "SCNode"))
    end
    
    BoxView();    --最左边listbox按钮框
    LeftView();   --左边显示人物装备
    RightView();  --右边显示人物具体信息
    SkillView();  --技能信息
    Soul();
   
	return Wnd
end
function ViewPlayInfo.releaseControl()
	if ViewPlayInfo.wndCloss then
		ViewPlayInfo.wndCloss()
	end
end
--函数调用
----------------逻辑功能区----------------
function ViewPlayInfo_recvData(dt, isLast)
	ViewOtherAll.idUser = dt:readInt()
	ViewOtherAll.idEudemon = dt:readInt()
	local ucAmount = dt:readByte()
	if not ViewOtherAll.ucAmount then
	    ViewOtherAll.ucAmount = 0
	end
	ViewOtherAll.ucAmount = ViewOtherAll.ucAmount + ucAmount;
	for i = 1, ucAmount do
	    if not ViewOtherAll.stOtherBase then
	        ViewOtherAll.stOtherBase = {}
	    end
		table.insert(ViewOtherAll.stOtherBase, stViewOtherAll.initWithStream(dt))
	end
	
    if isLast == true then
        ViewPlayInfo.Window()
        SCActivityIndicator:getSingleton():close();   ----关闭等待转圈图标
    end
end

----------------消息处理区----------------
function ViewPlayInfo_sendData(idUser, idEudemon, idName)   --发送物品id
    local lev = Hero:getSingleton():getLeval();
    if lev < 30 then
        showMessage(L("str0510"))
        return
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_PLAYERINFO);
	if dataStream then                   ----消息发送提示
		dataStream:writeShort(OTHERPLAYDATA_CHECK)
		dataStream:writeInt(idUser)  --idUser
		dataStream:writeInt(idEudemon)
		dataStream:writeString(idName)
		SCDataTransThread:getSingleton():transData(dataStream)
		showGuideStep(GUIDE_TYPE_MONEY_SYMBOL, -1)
		SCActivityIndicator:getSingleton():show();
	end
	
	ViewOtherAll.stOtherBase = {}
	ViewOtherAll.ucAmount = 0;
end

----------------全局函数区----------------
function ViewPlayInfo.Window()
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(4421);
	flag = 0;
	BaseOrSkill = 0;
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
	else
		wnd = ViewPlayInfo.initControl()
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd)
			local naviCtrl = getCurentSceneNavigationController()
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl)
			end
		 end
	end
end

function ViewPlayInfo.wndCloss()
    Wnd = nil
    flag = nil
    BaseOrSkill = nil
    m_Value = 0
    ViewOtherAll = {}
end

--函数调用