local   _MSG_CALENDARACTION    = 2402    -- 活动日程表
local   MSG_BOSS_DAMAGE_RANK = 3
local    MSG_BOSS_BASE_INFO = 4        --//BOSS基本信息
local    MSG_BOSS_MAP_LOCK_TIME = 5    --//即将开始不可跨跃区域
local    MSG_BOSS_TIME_LEAVE    = 6        --//即将开始的剩余时间
local    MSG_BOSS_CLEAR_TIME_LEAVE = 7--//立即清除剩余时间
local   MSG_BOSS_MY_RANK_INFO = 8 --
local   MSG_BOSS_UPDATE_USER_NUM    = 9    --//更新参与人数
local   MSG_SET_AUTO_BOSS_FIGHT = 25
local    MSG_BOSS_MAP_INSPIRE        = 20    --//世界boss鼓舞
local    MSG_BOSS_MAP_REBORN            = 21    --//世界boss地图欲火重生与立即复活
local    MSG_LEAVE_BOSS_MAP            = 22--//离开世界boss地图
local    MSG_ENTER_BOSS_MAP            = 23    --//进入世界boss地图

local MSG_TRIBE_WAR_TIME_LEAVE = 30    --//公会战准备时间(地图内)
local MSG_TRIBE_WAR_FIGHT_INFO = 31    --//公会战基本信息(地图内)
local MSG_TRIBE_WAR_UPDATE_USERNUM = 32    --//公会战更新剩余人数(地图内)

local MSG_LEAVE_MINI_BOSS_MAP		= 35	--//离开副本隐藏boss地图
local MSG_MINI_BOSS_EXIST_INVITE	= 36	--//显示邀请好友按钮
local MSG_MINI_BOSS_INVITE_FRIEND = 37	--//邀请好友参加副本隐藏boss地图
local MSG_MINI_BOSS_FRIEND_ACCEPT = 38	--//立即参加
local MSG_MINI_BOSS_SYSTEM_INVITE = 39	--//系统隐藏BOSS邀请(战斗中,上线)
local MSG_TOP_UP_INTEGRAL         =  44 --//积分奖励
local MSG_BATTLE_FIGHT_TIME		= 40	--//战斗限时时间
local   BossType = 1
local	m_bosInviteMsg = nil

----公会

local   _MSG_TRIBE                =1613        --//家族系统
local    MSG_SOCIATY_BOSS_TIME_LIST            = 41    --//每周BOSS时间列表
local    MSG_SOCIATY_SET_BOSS_TIME            = 42    --//设置每周BOSS时间
local    MSG_SOCIATY_BOSS_MAP_INSPIRE        = 43    --//鼓舞
local    MSG_SOCIATY_BOSS_MAP_REBORN            = 44    --//欲火重生与立即复活
local    MSG_SOCIATY_LEAVE_BOSS_MAP            = 45    --//离开公会boss地图
local    MSG_SOCIATY_ENTER_BOSS_MAP            = 46    --//进入公会boss地图


---定时器 回调
local TimeID  = nil

---消息
local stDamageListMag = {
        initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            --[[     
           ucAmount,          
           szRankDamage = {}, 
           ]]
        }
            
        tmp.ucAmount = dt:readByte()
        tmp.szRankDamage = {}
        for i = 1, tmp.ucAmount do
                local scStr = dt:readString()
            if scStr == nil then
               -- tmp.szMyDamage = ""
            else
                 table.insert(tmp.szRankDamage, scStr:getData())
            end
            
        end
        
        return tmp
    end
}

local stBossMag = {
        initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
           ucCategoryType,         
           szName,        
           usLevel,          
           nCurLife, 
           nMaxLife,
           nPhoto,
        }
        
        tmp.ucCategoryType = dt:readByte()
        BossType = tmp.ucCategoryType;
        
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.usLevel = dt:readShort()
        tmp.nCurLife = dt:readInt()
        tmp.nMaxLife = dt:readInt()
        tmp.nPhoto = dt:readInt()
        return tmp
    end
}


local stmeDamageMag = {
        initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
           usCurNum,         --//当前人数
           usInspireNum,      --  //鼓舞值
           usMyRank,         -- //排名
           nDamagePercent,   --//10000=100.00%
           nMyDamage,   --//自己的伤害
        }
        

        
        
        tmp.usCurNum = dt:readShort()
        tmp.usInspireNum = dt:readShort()
        tmp.usMyRank = dt:readShort()
        tmp.nDamagePercent = dt:readInt()
        tmp.nMyDamage = dt:readInt()
    
        return tmp
    end
}

local stFriend = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
        }
        tmp.idUser = dt:readInt()
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        tmp.usLev = dt:readShort()
        tmp.byRemainTimes = dt:readByte() --//剩余次数
		tmp.dwRank = dt:readInt()
        return tmp
    end
}

local stInviteInfo = {
	initWithStream = function(dt)
		tmp = {}
		if not dt then
			return tmp
		end
		tmp.ucFlag = dt:readByte()
		tmp.idTarget = dt:readInt()
		tmp.szWord = dt:readString()
		if tmp.szWord then
			tmp.szWord = tmp.szWord:getData()
		end
		
		return tmp
	end
}

----关闭自动打

function closeAutoFighter()
    local box = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2034-2"));
        if box == nil then
            return
        end
        
        box:setSelect(false)
         local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
              dataStream:writeShort(MSG_SET_AUTO_BOSS_FIGHT)
              dataStream:writeByte(0)
              SCDataTransThread:getSingleton():transData(dataStream); 
                  if  TimeID then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(TimeID);
                TimeID = nil;
                end 
        
end

    ------------------
 local function onTimer(time)
        local box = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2034-2"));
        if box == nil then
            return 
        end
        if box:isSelect() == true then
              local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
              dataStream:writeShort(MSG_SET_AUTO_BOSS_FIGHT)
              dataStream:writeByte(1)
              SCDataTransThread:getSingleton():transData(dataStream);  
         end
 end
    
    
---自动打
local function onAutoBoss(tag)
       local box = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2034-2"));
        if box == nil then
            return 
        end
        if box:isSelect() == true then
              local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
              dataStream:writeShort(MSG_SET_AUTO_BOSS_FIGHT)
              dataStream:writeByte(1)
              SCDataTransThread:getSingleton():transData(dataStream);  
              
              TimeID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(onTimer, 8.0, false);
        else
              local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
              dataStream:writeShort(MSG_SET_AUTO_BOSS_FIGHT)
              dataStream:writeByte(0)
              SCDataTransThread:getSingleton():transData(dataStream); 
              
              
               if  TimeID then
                CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(TimeID);
                TimeID = nil;
                end 
        end    
end
---伤害列表
local function onDemageList(tag)
    local btn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlist("2034-" .. tag));
    if btn then       
        local strFile = getRealUIResourcePath("img/img5010.png");   
        if tag == 12 then           
             btn:setTag(11);
        else
             strFile = getRealUIResourcePath("img/img5011.png");
             btn:setTag(12);
        end
        if strFile then 
            btn:setTitle(strFile:getData())
        end
    end
    local Bn = SCFunction:getUiNodeByIdlist("2034-9");
    if Bn then
        local b = Bn:isVisible();
        if b == true then
            Bn:setVisible(false);
        else 
            Bn:setVisible(true);
        end
    end
end
---离开副本
local function onLeaveMap(tag)
    --setIsHideRightButton(false);
	if BossType == 1 or BossType == 2 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
		dataStream:writeShort(MSG_LEAVE_BOSS_MAP)
		SCDataTransThread:getSingleton():transData(dataStream);
	elseif BossType == 3 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
		dataStream:writeShort(MSG_SOCIATY_LEAVE_BOSS_MAP)
		SCDataTransThread:getSingleton():transData(dataStream);
	elseif BossType == 4 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
		dataStream:writeShort(MSG_LEAVE_MINI_BOSS_MAP)
		SCDataTransThread:getSingleton():transData(dataStream);
    end 
    
end



---欲火重生
local function onFireReBorn(tag)
    if BossType == 1 or BossType == 2 or BossType == 4 then
              local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
              dataStream:writeShort(MSG_BOSS_MAP_REBORN);
              dataStream:writeByte(0);
              dataStream:writeInt(0);
              dataStream:writeByte(0);
              SCDataTransThread:getSingleton():transData(dataStream);
    elseif BossType == 3   then
      local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
              dataStream:writeShort(MSG_SOCIATY_BOSS_MAP_REBORN);
              dataStream:writeByte(0);
              dataStream:writeInt(0);
              dataStream:writeByte(0);
             SCDataTransThread:getSingleton():transData(dataStream);
    end 

end

---立即重生
local function onReBornRightNow(tag)
 if BossType == 1 or BossType == 2 or BossType == 4 then
   local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
  dataStream:writeShort(MSG_BOSS_MAP_REBORN);
  dataStream:writeByte(0);
  dataStream:writeInt(1);
  dataStream:writeByte(0);
  SCDataTransThread:getSingleton():transData(dataStream);
   elseif BossType == 3   then
      local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
              dataStream:writeShort(MSG_SOCIATY_BOSS_MAP_REBORN);
              dataStream:writeByte(0);
              dataStream:writeInt(1);
              dataStream:writeByte(0);
             SCDataTransThread:getSingleton():transData(dataStream);
    end 
end

---阅历鼓舞
local function onEAdd(tag)
	if BossType == 1 or BossType == 2 or BossType == 4 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
		dataStream:writeShort(MSG_BOSS_MAP_INSPIRE);
		dataStream:writeByte(0);
		dataStream:writeInt(1);
		dataStream:writeByte(1);
		SCDataTransThread:getSingleton():transData(dataStream);
	elseif BossType == 3   then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
		dataStream:writeShort(MSG_SOCIATY_BOSS_MAP_INSPIRE);
		dataStream:writeByte(0);
		dataStream:writeInt(1);
		dataStream:writeByte(0);
		SCDataTransThread:getSingleton():transData(dataStream);
	end 
end


---元宝鼓舞
local function onYAdd(tag)
	if BossType == 1 or BossType == 2 or BossType == 4 then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION);
		dataStream:writeShort(MSG_BOSS_MAP_INSPIRE);
		dataStream:writeByte(0);
		dataStream:writeInt(0);
		dataStream:writeByte(1);
		SCDataTransThread:getSingleton():transData(dataStream);
    elseif BossType == 3   then
		local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
        dataStream:writeShort(MSG_SOCIATY_BOSS_MAP_INSPIRE);
        dataStream:writeByte(0);
        dataStream:writeInt(0);
        dataStream:writeByte(0);
        SCDataTransThread:getSingleton():transData(dataStream);
    end 
end
---关闭窗体
function closeBossNode()
    local scene = getRunningScene();
    if scene~= nil then
        scene:getUINode():removeChildByTag(2034, true);
        
        if  TimeID then
            CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(TimeID);
            TimeID = nil;
        end 
    end
end
local function OnClickCheckBox(tag)
    local pBox = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2034-2"));
    if pBox then
        if pBox:isSelect() then
            pBox:setSelect(false);
        else
            pBox:setSelect(true);
        end
        onAutoBoss(0);
    end
end
---创建窗体
local function createBossNode()
    --setIsHideRightButton(true);
    local node = SCFunction:getUiNodeByIdlist("2034");
    if node ~= nil  then
    
        node:setAnchorPoint(CCPointMake(0.5, 1));
        node:setPosition(CCPointMake(getScreenWidth() / 2, getScreenHeight()));
        return node
    end
    
    
      --get the UI file
    local node = SCTypeCast:castNodeToDragNode(SCFunction:getUiById(2034));
    if node == nil then
        return nil 
    end
    
        node:setAnchorPoint(CCPointMake(0.5, 1));
        node:setPosition(CCPointMake(getScreenWidth() / 2, getScreenHeight()));
    
     local scene = getRunningScene();
    if scene~= nil then
        scene:getUINode():addChild(node);
    end
    
    --node:setBackgroundColor(colorOrange());
    node:setFrameVisibled(true);
    node:setFrameType(EnumFrameTypeLine);
     local Bn = SCTypeCast:castNodeToDragNode(SCFunction:getUiNodeByIdlistAndParent("9", node));
    if Bn then 
        Bn:setVisible(false);
        --Bn:setBackgroundColor(colorOrange());
        Bn:setFrameVisibled(true);
        Bn:setFrameType(EnumFrameTypeLine);
        Bn:setAnchorPoint(CCPointMake(0.5, 0));
        Bn:setPosition(CCPointMake(node:getContentSize().width / 2, Bn:getPosition().y));
    end
    
    local list = SCFunction:getUiNodeByIdlistAndParent("9-10840", node)
    if list then 
       -- list:setVisible(false);
    end
    
    local pBox = SCTypeCast:castNodeToCheckBox(node:getChildByTag(2));
    if pBox then
        pBox:setDescribe(_LTParser("str2030"),getDefaultFontName(),getFontSize(15),colorOrange());
        
        local strFile = getRealUIResourcePath("img/channelSetClose.png");
        if strFile then 
            pBox:setBackgroundImage(strFile:getData())
        end
        
        local strFile = getRealUIResourcePath("img/channelSetOpen.png");
        if strFile then 
            pBox:setSelectedImage(strFile:getData())
        end
        node:reorderChild(pBox, 100);
        pBox:luaSetSelectorOnButtonClicked(onAutoBoss);
    end
    
    local pBtnCheckBox = SCButton:button();
    if pBtnCheckBox then
        pBtnCheckBox:setPosition(pBox:getPosition());
        pBtnCheckBox:setContentSize(CCSizeMake(75 * gUIScale().x, 15 * gUIScale().y));
        pBtnCheckBox:luaSetSelectorOnClicked(OnClickCheckBox);
        node:addChild(pBtnCheckBox);
    end

    local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(6));
    if pBtn then
        pBtn:setAnchorPoint(CCPointMake(1, 0));
        pBtn:setPosition(CCPointMake(node:getContentSize().width / 2 + getScreenWidth() / 2 - pBtn:getContentSize().width, pBtn:getPosition().y));
        pBtn:luaSetSelectorOnClicked(onLeaveMap);
    end
    

    local btn = SCTypeCast:castNodeToButton(node:getChildByTag(8));
    if btn then
        --pBox:setDescribe(_("str2030"),getDefaultFontName(),gFontSizeMake(15),colorOrange());
        local strFile = getRealUIResourcePath("img/img5010.png");
        if strFile then 
            btn:setTitle(strFile:getData())
        end
        btn:setTag(11);

        btn:setAnchorPoint(CCPointMake(1, 0));
        btn:setPosition(CCPointMake(node:getContentSize().width / 2 + getScreenWidth() / 2 - pBtn:getContentSize().width, btn:getPosition().y));
        btn:luaSetSelectorOnClicked(onDemageList);
    end
    
    local pBtn = SCTypeCast:castNodeToButton(node:getChildByTag(6));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onLeaveMap);
    end
    
    local nodeP = SCTypeCast:castNodeToDragNode(node:getChildByTag(7));
    if nodeP then
          nodeP:setFrameVisibled(true);
          nodeP:setFrameType(EnumFrameTypeLine);
          
        nodeP:setAnchorPoint(CCPointMake(1, 0));
        nodeP:setPosition(CCPointMake(node:getContentSize().width / 2 + getScreenWidth() / 2 - pBtn:getContentSize().width, nodeP:getPosition().y));
    end
    
    
    local nodeP = node:getChildByTag(4);
    if nodeP then
              local pro = ProgressBarEx:newProgressBarEx(EnumProgressBarTypeRed, 260);
            if pro then
                 pro:setTag(100);

                 pro:setPosition(nodeP:getPosition())
                 node:addChild(pro);
            end
    end
    

      
    if BossType~=4 then
		if luaIsUnlock(81) then
		  ---欲火重生
			local strFile = getRealUIResourcePath("img/img7007.png");
			if strFile then
				 local btn1 = SCButton:button();
				 btn1:setTitle(strFile:getData())
				 btn1:setPosition(CCPoint(200 * gUIScale().x, -btn1:getContentSize().height));
				 btn1:luaSetSelectorOnClicked(onFireReBorn);
				 node:addChild(btn1);
			end
			---立即重生
			 local strFile = getRealUIResourcePath("img/img7008.png");
			if strFile then
				 local btn2 = SCButton:button();
				 btn2:setTitle(strFile:getData())
				 btn2:setPosition(CCPoint(150 * gUIScale().x, -btn2:getContentSize().height));
				 
				 btn2:luaSetSelectorOnClicked(onReBornRightNow);
				 node:addChild(btn2);
			end
			---阅历鼓舞
			local strFile = getRealUIResourcePath("img/img7009.png");
			if strFile then
				 local btn3 = SCButton:button();
				  btn3:setTitle(strFile:getData())
				 btn3:setPosition(CCPoint(50 * gUIScale().x, -btn3:getContentSize().height));
				
				 btn3:luaSetSelectorOnClicked(onEAdd);
				 node:addChild(btn3);
			end
			
		---元宝鼓舞
			local strFile = getRealUIResourcePath("img/img7010.png");
			if strFile then
				 local btn4 = SCButton:button();
				  btn4:setTitle(strFile:getData())
				 btn4:setPosition(CCPoint(100 * gUIScale().x, -btn4:getContentSize().height));
				
				 btn4:luaSetSelectorOnClicked(onYAdd);
				 node:addChild(btn4);
			end
		else 
			   ---立即重生
			 local strFile = getRealUIResourcePath("img/img7008.png");
			if strFile then
				 local btn = SCButton:button();
				  btn:setTitle(strFile:getData())
				 btn:setPosition(CCPoint(150 * gUIScale().x, -btn:getContentSize().height));
				
				 btn:luaSetSelectorOnClicked(onReBornRightNow);
				 node:addChild(btn);
			end
			---阅历鼓舞
			local strFile = getRealUIResourcePath("img/img7009.png");
			if strFile then
				 local btn = SCButton:button();
				  btn:setTitle(strFile:getData())
				 btn:setPosition(CCPoint(100 * gUIScale().x, -btn:getContentSize().height));
				
				 btn:luaSetSelectorOnClicked(onEAdd);
				 node:addChild(btn);
			end
		end
	else
		---立即重生
		local strFile = getRealUIResourcePath("img/img7008.png");
		if strFile then
			local btn = SCButton:button();
			btn:setTitle(strFile:getData())
			btn:setPosition(CCPoint(150 * gUIScale().x, -btn:getContentSize().height));
					
			btn:luaSetSelectorOnClicked(onReBornRightNow);
			node:addChild(btn);
		end
		local label = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("7-73", node))
		if label then
			label:setVisible(false)
		end
    end
    
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-9-91"));
    if pLabel then
        pLabel:setText(_LTParser("str2031").."0".._LTParser("str2032"));        
        pLabel:setAnchorPoint(CCPointMake(0.5, 0));
        pLabel:setPosition(CCPointMake(Bn:getContentSize().width / 2, pLabel:getPosition().y));
    end
    
    pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-9-92"));
    if pLabel then 
        pLabel:setAnchorPoint(CCPointMake(0.5, 0));
        pLabel:setPosition(CCPointMake(Bn:getContentSize().width / 2, pLabel:getPosition().y));
    end
   
    return node;

end


---boss信息
local function createBossInfo(tmp)


    local node = createBossNode();
    if node == nil then
        return 
    end
	
	local faceBack = SCTypeCast:castNodeToImage(node:getChildByTag(5));
	if faceBack then
		if not faceBack:getChildByTag(5000) then
			local photoTxt = "img/new00060.png"
			if tmp.ucCategoryType == 2 then
				photoTxt = "img/new00062.png"
			elseif tmp.ucCategoryType == 3 then
				photoTxt = "kernal/close-normal.png"
			elseif tmp.ucCategoryType == 4 then
				photoTxt = "kernal/close-normal.png"
			end
			local filePath = getRealUIResourcePath(photoTxt)
			if filePath then
				local face = SCImage:imageWithFile(filePath:getData())
				face:setTag(5000)
				face:setAnchorPoint(CCPointMake(0.5, 0.5))
				face:setPosition(CCPointMake(faceBack:getContentSize().width/2, faceBack:getContentSize().height/2))
				faceBack:addChild(face)
			end
		end
	end        

    local pLabel = SCTypeCast:castNodeToLabel(node:getChildByTag(1));

    if pLabel then
        pLabel:setText(""..tmp.szName.." "..tmp.usLevel.._LTParser("level"));
    end

    local pro = SCTypeCast:castNodeToProgressBarEx(SCFunction:getUiNodeByIdlist("2034-100"));
    if pro then 
         pro:setWidth(243);
         pro:setMaxValue(tmp.nMaxLife);
         pro:setValue(tmp.nCurLife);
    end

    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-10"));
    if pLabel then 
        SCFunction:getUiNodeByIdlist("2034"):reorderChild(pLabel, 1);
        pLabel:setText(""..tmp.nCurLife.."/"..tmp.nMaxLife);
    end
    
   
    local CTime = node:getChildByTag(222);
     if CTime then
        return ;
    end
    


end
---伤害列表
local function createDamageList(tmp)
    local list = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("2034-9-10840"));
    if list== nil then
        return;
    end
    list:removeAllItems();
    for i = 1, tmp.ucAmount do
		if i == 1 then
			tmp.szRankDamage[i] = "*2"..tmp.szRankDamage[i]
		elseif i == 2 then
			tmp.szRankDamage[i] = "*6"..tmp.szRankDamage[i]
		elseif i == 3 then
			tmp.szRankDamage[i] = "*4"..tmp.szRankDamage[i]
		end
        local parserNode = getItemTextNode(tmp.szRankDamage[i])
        if parserNode then 
            parserNode:setTag(1)
            list:addItem(tolua.cast(parserNode, "SCNode"));   
        end
    end 

end 
----我的伤害信息
local function createMyInfo(tmp)
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-9-91"));
    if pLabel then
        pLabel:setText(_LTParser("str2031")..tmp.usCurNum.._LTParser("str2032"));
    end
    
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-9-92"));
    if pLabel then
        pLabel:setText(_LTParser("str2033")..tmp.nMyDamage.."("..(tmp.nDamagePercent/100).."%)".._LTParser("str2034"));
    end
    
     local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-7-71"));
    if pLabel then
        if tmp.usMyRank == 0 then
            pLabel:setText(_LTParser("str6056"));
        else
            pLabel:setText(_LTParser("str2035")..tmp.usMyRank .. _LTParser("str5034"));
        end
    end
    
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-7-72"));
    if pLabel then
        pLabel:setText(_LTParser("str2034").._LTParser("colon")..(tmp.nDamagePercent/100).."%");
    end
    
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-7-73"));
    if pLabel then
        pLabel:setText(_LTParser("str2053").._LTParser("colon")..(tmp.usInspireNum).."%");
    end

    
end
---CD结束回调
local function onTimeOut()
    Hero:getSingleton():setCanNotPassPX(1024);
end

----CD时间
local function createTime(time, type)
    local node = SCFunction:getUiNodeByIdlist("2034")
    if node == nil then 
        return 
    end
        node:setAnchorPoint(CCPointMake(0.5, 1));
        node:setPosition(CCPointMake(getScreenWidth() / 2, getScreenHeight()));
    local label = nil;
    if type == 0 then        
        label = SCLabel:labelWithStringFont(_LTParser("str6048"), getDefaultFontName(), getFontSize(12));
    else
        label = SCLabel:labelWithStringFont(_LTParser("str6040"), getDefaultFontName(), getFontSize(12));
    end
    if label then
        label:setPosition(CCPointMake(238 * gUIScale().x, 32 * gUIScale().y));
        label:setTag(223);
        label:setColor(color_red);
        node:addChild(label);
    end
    local CTime = CountDownNode:newCountDownNode(DisplayTimeType_Minute_Second);
    if CTime then 
        node:removeChildByTag(222,true) ; 
        CTime:setTag(222);
        CTime:setPosition(CCPointMake(298 * gUIScale().x, 32 * gUIScale().y));
        CTime:setTime(time);
        CTime:setColor(color_red);
        CTime:luasetSelectorOnClose(onTimeOut)
        node:addChild(CTime);
    end
end 
----刚进去副本时间
local function createStartLeaveTime(dt)
        local    idMap = dt:readInt();                --//地图id
        local    usPosX = dt:readShort();            --    //坐标x
        local    usPosY = dt:readShort();            --    //坐标y
        local    nLeaveTime = dt:readInt();        --    //剩余时间
        local    ucVisible = dt:readByte();			--//1:阻挡物可见
        local    ucRightFlag = dt:readByte();		--//0:向左, 1:向右
        --createTime(nLeaveTime, 1)
        Hero:getSingleton():setCanNotPassPX(usPosX, ucRightFlag);
end
--踢回原位标记
local mark = 0;
--踢回原位
function KickBackInSitu()
    if 1 == mark then
        ChatProcessor:getSingleton():addSystemMessage(_LTParser("str6055"));
    else
        ChatProcessor:getSingleton():addSystemMessage(_LTParser("str6059"));
    end
end
--邀请好友
local function onClickInviteFriend()
--[[
	local USERINFO_MINIBOSS_FRIENDLIST= 91
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_MINIBOSS_FRIENDLIST)
    SCDataTransThread:getSingleton():transData(dataStream)
]]
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION)
    dataStream:writeShort(MSG_MINI_BOSS_INVITE_FRIEND)
    dataStream:writeInt(0)
    SCDataTransThread:getSingleton():transData(dataStream)
	local node = SCFunction:getUiNodeByIdlist("2034-5001");
    if not node then
		return
    end
	node:removeAllChildrenWithCleanup(true)
end
--显示邀请好友按钮
local function showInviteFriendsButton()
	local node = SCFunction:getUiNodeByIdlist("2034");
    if not node then
		return
    end
	---邀请好友
	local strFile = getRealUIResourcePath("img/new00094.png");
	if strFile then
		local btn = SCButton:button();
		btn:setTag(5001)
		btn:setTitle(strFile:getData())
		btn:setPosition(CCPoint(200 * gUIScale().x, -btn:getContentSize().height));
		local pAni = LookfaceParser:getSingleton():getAnimationByIndex(1101, 1139);
		if pAni then
			local pAniNode = SCAnimationNode:nodeWithAnimation(pAni);
			pAniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
			pAniNode:setPosition(CCPointMake(btn:getContentSize().width/2, btn:getContentSize().height/2))
			btn:addChild(pAniNode);
		end
		btn:luaSetSelectorOnClicked(onClickInviteFriend);
		node:addChild(btn);
	end
end

local MAPTYPE_SYN_CAMPAIGN_WAR = 67108864   --军团战地图ID
local function recWorldMsg()
    local dt = SCMessageCenter:getSingleton():getDataTransStream();
    local action = dt:readShort();
	if action == MSG_BATTLE_FIGHT_TIME then
        DuelTemple_isFight()
        if  true == GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_SYN_CAMPAIGN_WAR) then
			removeAllWindwoController();
        end
        return
    end
    if action == MSG_TOP_UP_INTEGRAL then
        IntegralReward_WndMsg(dt)
        return
    end
    if action == MSG_BOSS_DAMAGE_RANK then
		createDamageList(stDamageListMag.initWithStream(dt));
		return
	end
    if action == MSG_BOSS_BASE_INFO then
		createBossInfo(stBossMag.initWithStream(dt));
		return
	end
    if action == MSG_BOSS_MY_RANK_INFO then 
		createMyInfo(stmeDamageMag.initWithStream(dt));
		return
	end
    if action == MSG_BOSS_TIME_LEAVE then
        local time = dt:readInt();
        local RebornFlag = dt:readByte();
        mark = RebornFlag;
        createTime(time, RebornFlag)
		return
	end
    if action == MSG_BOSS_MAP_LOCK_TIME then 
        createStartLeaveTime(dt)
		return
	end
    if action == MSG_BOSS_UPDATE_USER_NUM then
        local usernum = dt:readInt();
        local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlist("2034-9-91"));
        if pLabel then
            pLabel:setText(_LTParser("str2031")..usernum.._LTParser("str2032"));
        end
		return
	end
    if action == MSG_SET_AUTO_BOSS_FIGHT then
        local type = dt:readByte();
        local box = SCTypeCast:castNodeToCheckBox(SCFunction:getUiNodeByIdlist("2034-2"));
        if box == nil then
            return 
        end
        if type == 1 then
            box:setSelect(true) 
        else
            box:setSelect(false) 
        end
		return
	end
    if action == MSG_BOSS_CLEAR_TIME_LEAVE then
        if GameCommonMsgRecive:getSingleton():isKindOfMap(67108864) == true then
            Hero:getSingleton():setCanNotPassPX(1024);
            local pNode = SCFunction:getUiNodeByIdlist("7014");
            if pNode then
                pNode:removeChildByTag(70141, true);
            end
            return;
        end
        Hero:getSingleton():setCanNotPassPX(1024);
        
        local node = SCFunction:getUiNodeByIdlist("2034")
        if node == nil then 
            return 
        end
        node:setAnchorPoint(CCPointMake(0.5, 1));
        node:setPosition(CCPointMake(getScreenWidth() / 2, getScreenHeight()));
           
        local pNode = node:getChildByTag(222);
        if pNode then
            node:removeChildByTag(222,true) ; 
        end
        pNode = node:getChildByTag(223);
        if pNode then
            node:removeChildByTag(223,true) ; 
        end
		return
	end
    if action == MSG_TRIBE_WAR_TIME_LEAVE then
        setSocietyBattleInfo(action, dt);
		return
	end
    if action == MSG_TRIBE_WAR_FIGHT_INFO then
        setSocietyBattleInfo(action, dt);
		return
	end
    if action == MSG_TRIBE_WAR_UPDATE_USERNUM then
        setSocietyBattleInfo(action, dt);
		return
	end
	if action == MSG_MINI_BOSS_EXIST_INVITE then
		showInviteFriendsButton()
		return
	end
	if action == MSG_MINI_BOSS_SYSTEM_INVITE then
		m_bosInviteMsg = stInviteInfo.initWithStream(dt)
		if not BattleProcessor:getSingleton():getIsInBattle() and getMainInterface() then
			WorldBoss_ShowInviteWindow()
		end
		return
    end
end
--选择好友
local function onSelectItem(tag, itemTag, index)
	local scene = getRunningScene()
    if not scene then
		return
    end
    local uiNode = scene:getUINode()
    if not uiNode then
		return
    end
    local frendNode = uiNode:getChildByTag(6002)
    if frendNode then
		frendNode:removeFromParentAndCleanup(true)
    end
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION)
    dataStream:writeShort(MSG_MINI_BOSS_INVITE_FRIEND)
    dataStream:writeInt(itemTag)
    SCDataTransThread:getSingleton():transData(dataStream)
end
--显示好友列表窗口
local function showFriendListWnd(dt)
    local scene = getRunningScene()
    if not scene then
		return
    end
    local uiNode = scene:getUINode()
    if not uiNode then
		return
    end
    if uiNode:getChildByTag(6002) then
        uiNode:removeChildByTag(6002, true)
        return
    end
    local frendNode = FrameWindow:frameWnd()
    frendNode:setTag(6002)
    frendNode:setOutSpaceClickClose(true)
    frendNode:setAnchorPoint(CCPointMake(0.5, 0.5))
    frendNode:setPosition(CCPointMake(WIN_SIZE.width/2, WIN_SIZE.height/2))
    frendNode:setContentSize(CCSizeMake(SX(150), SY(250)))
    local dragNode = SCDragNode:node()
    dragNode:setDragEnabled(false)
    local parserNode = getItemTextNode(_LTParser("str5050"))
    parserNode:setAnchorPoint(CCPointMake(0.5, 0.5))
    parserNode:setPosition(CCPointMake(frendNode:getContentSize().width/2, frendNode:getContentSize().height-SY(20)))
    dragNode:setContentSize(CCSizeMake(frendNode:getContentSize().width, parserNode:getContentSize().height+SY(10)))
    dragNode:addChild(parserNode)
    frendNode:addChild(dragNode)
    local listBox = SCListBox:boxWithWidthHeight(SX(130), SY(200))
    listBox:setTag(1)
    --listBox:setBackgroundColor(colorBlack())
    --listBox:setAnchorPoint(CCPointMake(0.5, 0.5))
    listBox:setPosition(CCPointMake(SX(10), SY(10)))
    listBox:luaSetSelectorOnItemSelected(onSelectItem)
    frendNode:addChild(listBox)
    uiNode:addChild(frendNode)

    local pListBox = tolua.cast(frendNode:getChildByTag(1), "SCListBox")
    if pListBox then
        pListBox:removeAllItems()
        local usAmount = dt:readShort()
        for i=1, usAmount do
			local tmp = stFriend.initWithStream(dt)
            local dragNode = SCDragNode:node()
            dragNode:setDragEnabled(false)
            dragNode:setFrameType(EnumFrameTypeListNormal)
            dragNode:setFrameVisibled(true)
            local text = string.format(_LTParser("str5046"), tmp.szName, tmp.byRemainTimes)
            local parserNode = getItemTextNode(text)
            parserNode:setPosition(0, SY(5))
            dragNode:setContentSize(CCSizeMake(pListBox:getContentSize().width, parserNode:getContentSize().height+SY(10)))
            dragNode:addChild(parserNode)
            pListBox:addItem(dragNode)
            dragNode:setTag(tmp.idUser)
        end
    end
end

--好友列表信息
local function recvWorldFriendList()
	local dt = LuaData:getSingleton():getDataTransStream()
	showFriendListWnd(dt)
end

local function onClickInviteWindow(tag)
	if not m_bosInviteMsg or not m_bosInviteMsg.szWord then
		return
	end
	local flag = getIntPart(m_bosInviteMsg.ucFlag/10)*10
	if tag == 1 then
		flag = m_bosInviteMsg.ucFlag%10
	end
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_CALENDARACTION)
	dataStream:writeShort(MSG_MINI_BOSS_SYSTEM_INVITE)
	dataStream:writeByte(flag)
	dataStream:writeInt(m_bosInviteMsg.idTarget)
	SCDataTransThread:getSingleton():transData(dataStream)
	m_bosInviteMsg = nil
	BattleProcessor:getSingleton():removeBattle();
end

--全局函数
function WorldBoss_ShowInviteWindow()
	if not m_bosInviteMsg or not m_bosInviteMsg.szWord then
		return false
	end
	luashowConfirmationWindow(m_bosInviteMsg.szWord, WIN_YES_NO, onClickInviteWindow)
	return true
end

--SCMessageCenter:getSingleton():luaRegistCommand(recWorldMsg, _MSG_CALENDARACTION, 0, nil)
LuaData:getSingleton():luaSetSelectorOnRecvData(recvWorldFriendList, LuaData_USERINFO_MINIBOSS_FRIENDLIST);