--定义一个与文件名相同的table
armyGroupFightl = {}
------------------消息--------------------

----------------结构定义区----------------
local stSignGameInfo = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {
            __mode = "kv",
            usSignNum, --//报名公会个数
            ucFlag,    --//0:可报名;  1:已报名 2:不能报名 3：可进入战场
            idTribeLeader,
            ucClan,    --//1龙将2剑舞3箭神4军师
            szName,
            szTribe,
        }
        tmp.usSignNum = dt:readShort()
        tmp.ucFlag = dt:readByte();
        tmp.idTribeLeader = dt:readInt();
        tmp.ucClan = dt:readByte();
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szName = ""
        else
            tmp.szName = scStr:getData()
        end
        local scStr = dt:readString()
        if scStr == nil then
            tmp.szTribe = ""
        else
            tmp.szTribe = scStr:getData()
        end
        return tmp
    end
}
----------------常量定义区----------------
local ACTION_TRIBEWAR_SIGN_AFFIRM           = 16;    --//公会战报名
local ACTION_TRIBEWAR_PAIR_INFO             = 15;    --//公会配对界面
----------------变量定义区----------------
--变量的定义
local m_tmpTagOfBtn = nil
----------------UI控制器区----------------
function armyGroupFightl.initControl()
	local pWindow4230 = SCWindow:window()
	if pWindow4230 then
		pWindow4230:setTag(4230)
		pWindow4230:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow4230:setPosition(AUTO_POS(0.00, 0.00))pWindow4230:setContentSize(AUTO_SIZE(480, 320))
		pWindow4230:luaSetSelectorOnClose(armyGroupFightl.releaseControl)
	end

	local pDragNode1 = SCDragNode:node()
	if pDragNode1 then
		pDragNode1:setTag(1)
		pDragNode1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode1:setPosition(AUTO_POS(6.00, 40.00))
		pDragNode1:setContentSize(AUTO_SIZE(210, 220))
		pDragNode1:setFrameVisibled(true)
		pDragNode1:setDragEnabled(false)
		pDragNode1:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode2 = SCDragNode:node()
	if pDragNode2 then
		pDragNode2:setTag(2)
		pDragNode2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode2:setPosition(AUTO_POS(220.00, 180.00))
		pDragNode2:setContentSize(AUTO_SIZE(250, 80))
		pDragNode2:setFrameVisibled(true)
		pDragNode2:setDragEnabled(false)
		pDragNode2:setFrameType(EnumFrameTypeRound)
	end

	local pDragNode3 = SCDragNode:node()
	if pDragNode3 then
		pDragNode3:setTag(3)
		pDragNode3:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode3:setPosition(AUTO_POS(220.00, 40.00))
		pDragNode3:setContentSize(AUTO_SIZE(250, 140))
		pDragNode3:setFrameVisibled(true)
		pDragNode3:setDragEnabled(false)
		pDragNode3:setFrameType(EnumFrameTypeRound)
	end

	local pButton4 = SCButton:button(EnumBtnType9Atlas)
	if pButton4 then
		pButton4:setTag(4)
		pButton4:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton4:setPosition(AUTO_POS(17.00, 8.00))
		pButton4:setContentSize(AUTO_SIZE(107, 28))
		pButton4:setTitle(L("str3174"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton5 = SCButton:button(EnumBtnType9Atlas)
	if pButton5 then
		pButton5:setTag(5)
		pButton5:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton5:setPosition(AUTO_POS(127.00, 8.00))
		pButton5:setContentSize(AUTO_SIZE(107, 28))
		pButton5:setTitle(L("str3226"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton6 = SCButton:button(EnumBtnType9Atlas)
	if pButton6 then
		pButton6:setTag(6)
		pButton6:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton6:setPosition(AUTO_POS(244.00, 8.00))
		pButton6:setContentSize(AUTO_SIZE(107, 28))
		pButton6:setTitle(L("str3176"), DEFAULT_FONT_NAME, F(15))
	end

	local pButton7 = SCButton:button(EnumBtnType9Atlas)
	if pButton7 then
		pButton7:setTag(7)
		pButton7:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton7:setPosition(AUTO_POS(357.00, 8.00))
		pButton7:setContentSize(AUTO_SIZE(107, 28))
		pButton7:setTitle(L("str3175"), DEFAULT_FONT_NAME, F(15))
	end

	local pLable11 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(13))
	if pLable11 then
		pLable11:setTag(11)
		pLable11:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable11:setPosition(AUTO_POS(75.00, 9.00))
		pLable11:setColor(ccc4(255,255,255,255))
	end

	local pTextBox10 = SCTextBox:boxWithWidthHeightFont(AUTO_W(230), AUTO_H(105), DEFAULT_FONT_NAME, F(13))
	if pTextBox10 then
		tolua.cast(pTextBox10, "SCNode"):setTag(10)
		tolua.cast(pTextBox10, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pTextBox10, "SCNode"):setPosition(AUTO_POS(10.00, 25.00))
		pTextBox10:setText(L("  "))
	end

	local imgPath = getRealUIResourcePath("img/new00218.png")
	local pImage12 = nil
	if imgPath then
		pImage12 = SCImage:imageWithFile(imgPath:getData())
		if pImage12 then
			pImage12:setTag(12)
			pImage12:setAnchorPoint(CCPointMake(0.5, 0))
			pImage12:setPosition(AUTO_POS(105.00, 55.00))
		end
	end

	local pTextBox13 = SCTextBox:boxWithWidthHeightFont(AUTO_W(120), AUTO_H(40), DEFAULT_FONT_NAME, F(15))
	if pTextBox13 then
		tolua.cast(pTextBox13, "SCNode"):setTag(13)
		tolua.cast(pTextBox13, "SCNode"):setAnchorPoint(CCPointMake(0, 0))
		tolua.cast(pTextBox13, "SCNode"):setPosition(AUTO_POS(40.00, 10.00))
		pTextBox13:setText(L(" "))
	end

	local pTextBox9 = SCTextBox:boxWithWidthHeightFont(AUTO_W(230), AUTO_H(59), DEFAULT_FONT_NAME, F(13))
	if pTextBox9 then
		tolua.cast(pTextBox9, "SCNode"):setTag(9)
		tolua.cast(pTextBox9, "SCNode"):setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		tolua.cast(pTextBox9, "SCNode"):setPosition(AUTO_POS(10.00, 10.00))
		pTextBox9:setText(L(" "))
	end

	local pButton8 = SCButton:button(EnumBtnTypeNormalImg)
	if pButton8 then
		pButton8:setTag(8)
		pButton8:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton8:setPosition(AUTO_POS(175.00, 77.00))
		pButton8:setContentSize(AUTO_SIZE(70, 24))
		local imgPath = getRealUIResourcePath("pk/new00721.png")
		if imgPath then
			pButton8:setTitle(imgPath:getData())
		end
	end

	local pLable14 = SCLabel:labelWithStringFont(L("str3245"), DEFAULT_FONT_NAME, F(13))
	if pLable14 then
		pLable14:setTag(14)
		pLable14:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pLable14:setPosition(AUTO_POS(10.00, 9.00))
		pLable14:setColor(ccc4(60,255,0,255))
	end
	
	local pLable15 = SCLabel:labelWithStringFont(L(" "), DEFAULT_FONT_NAME, F(15))
	if pLable15 then
		pLable15:setTag(15)
		pLable15:setAnchorPoint(CCPointMake(0.5,0))
		pLable15:setPosition(AUTO_POS(105.00, 30.00))
		pLable15:setColor(ccc4(255,252,0,255))
	end
	
	if pDragNode1 and pWindow4230 then
		pWindow4230:addChild(tolua.cast(pDragNode1, "SCNode"))
	end
	if pDragNode2 and pWindow4230 then
		pWindow4230:addChild(tolua.cast(pDragNode2, "SCNode"))
	end
	if pDragNode3 and pWindow4230 then
		pWindow4230:addChild(tolua.cast(pDragNode3, "SCNode"))
	end
	if pButton4 and pWindow4230 then
		pWindow4230:addChild(tolua.cast(pButton4, "SCNode"))
	end
	if pButton5 and pWindow4230 then
		pWindow4230:addChild(tolua.cast(pButton5, "SCNode"))
	end
	if pButton6 and pWindow4230 then
		pWindow4230:addChild(tolua.cast(pButton6, "SCNode"))
	end
	if pButton7 and pWindow4230 then
		pWindow4230:addChild(tolua.cast(pButton7, "SCNode"))
	end
	if pLable11 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pLable11, "SCNode"))
	end
	if pTextBox10 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pTextBox10, "SCNode"))
	end
	if pImage12 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pImage12, "SCNode"))
	end
	if pTextBox13 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pTextBox13, "SCNode"))
	end
	if pTextBox9 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pTextBox9, "SCNode"))
	end
	if pButton8 and pDragNode2 then
		pDragNode2:addChild(tolua.cast(pButton8, "SCNode"))
	end
	if pLable14 and pDragNode3 then
		pDragNode3:addChild(tolua.cast(pLable14, "SCNode"))
	end
	if pLable15 and pDragNode1 then
		pDragNode1:addChild(tolua.cast(pLable15, "SCNode"))
	end
	return pWindow4230
end
function armyGroupFightl.releaseControl()
	if armyGroupFightl.wndClose then
		armyGroupFightl.wndClose()
	end
end
--函数定义
----------------逻辑功能区----------------
--查看已报名军团
local function onLookBtnClick(tag)
	armyGroupFight2_showArmyGroupFight2Wnd()
	--armyGroupFight1_showArmyGroupFight1Wnd()
end

--查看对战表
local function onLookFightTableBtnClick()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    if dataStream then
        dataStream:writeShort(ACTION_TRIBEWAR_PAIR_INFO)
        SCDataTransThread:getSingleton():transData(dataStream); 
	    SCActivityIndicator:getSingleton():show();
    end
    armyGroupFight3_showArmyGroupFight3Wnd()
end

--军团战报名
local function onApplyBtnClick()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    if dataStream then
        dataStream:writeShort(ACTION_TRIBEWAR_SIGN_AFFIRM)
        SCDataTransThread:getSingleton():transData(dataStream); 
	    SCActivityIndicator:getSingleton():show();
    end
end

--打开军团战
local function sendArmyGroupFight()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_TRIBE);
    if dataStream then
        dataStream:writeShort(MSG_SOCIATY_SIGN_GAME_INFO)
        SCDataTransThread:getSingleton():transData(dataStream); 
	    SCActivityIndicator:getSingleton():show();
    end
end

---------新人气调用军团报名-----------
function clickto_onApplyBtnClick()
	sendArmyGroupFight()
end 
--奖励说明
local function onStateBtnClick()
    armyGroupFight5_showArmyGroupFight5Wnd(0)
end
--规则说明
local function onRuleBtnClick()
    armyGroupFight5_showArmyGroupFight5Wnd(1)
end
local function onNotLevBtnClick()   
    showMessage(L("str3228"))
end
--初始化界面
local function sentDataToTheWnd(wnd)
    if not wnd then
        return
    end
    local pBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(4));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onLookBtnClick);
    end
    local pBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(5));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onStateBtnClick);
    end
    local pBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(6));
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onLookFightTableBtnClick);
    end
    local pBtn = SCTypeCast:castNodeToButton(SCFunction:getUiNodeByIdlistAndParent("2-8", wnd))
    if pBtn then
        pBtn:luaSetSelectorOnClicked(onRuleBtnClick);
    end
    local pImg = SCTypeCast:castNodeToImage(SCFunction:getUiNodeByIdlistAndParent("1-12", wnd))
    if pImg then
        pImg:setScaleX(0.7);
    end
    local pTestBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("2-9", wnd))
    if pTestBox then
        pTestBox:setParserDelegate(TextParser:getSingleton());
        pTestBox:setText(L("str3229"))
    end
    local pTestBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("3-10", wnd))
    if pTestBox then
        pTestBox:setParserDelegate(TextParser:getSingleton());
        pTestBox:setText(L("str3230"))
    end
end

local function refreshWndData(dt,wnd)
    if not wnd or not dt then
        return
    end
    local pBtn = SCTypeCast:castNodeToButton(wnd:getChildByTag(7));
    if pBtn then
        local isAdmiralFlg = Hero:getSingleton():getRank()
        if 3 < isAdmiralFlg then
            if 1 == dt.ucFlag or 3 == dt.ucFlag then
                pBtn:setButtonType(EnumBtnTypeAsh)
                pBtn:setTitle(L("str3227"), DEFAULT_FONT_NAME, F(15))
                pBtn:setTouchForce(true)
            else
                pBtn:setButtonType(EnumBtnTypeAsh)
                pBtn:setTouchForce(true)
            end
        else
            if 1 == dt.ucFlag or 3 == dt.ucFlag then
                pBtn:setButtonType(EnumBtnTypeAsh)
                pBtn:setTitle(L("str3227"), DEFAULT_FONT_NAME, F(15))
                pBtn:setTouchForce(true)
            elseif 0 == dt.ucFlag then
                pBtn:luaSetSelectorOnClicked(onApplyBtnClick);
            elseif 2 == dt.ucFlag then
                pBtn:setButtonType(EnumBtnTypeAsh)
                pBtn:luaSetSelectorOnClicked(onNotLevBtnClick);
            end
        end
    end
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("3-11", wnd))
    if pLabel then
        if 0 == dt.ucFlag or 2 == dt.ucFlag then
            pLabel:setText(string.format(L("str3178"),dt.usSignNum))
            pLabel:setColor(getColorOrange())
        else
            pLabel:setText(string.format(L("str3179"),dt.usSignNum))
            pLabel:setColor(getColorOrange())
        end
    end
    local pTextBox = SCTypeCast:castNodeToTextBox(SCFunction:getUiNodeByIdlistAndParent("1-13", wnd))
    local pLabel = SCTypeCast:castNodeToLabel(SCFunction:getUiNodeByIdlistAndParent("1-15", wnd))
    if pTextBox and pLabel then
        if 0 < dt.ucClan then
            if dt.szName and dt.szTribe then
                local str = L("str3233")..dt.szTribe..L("str3234")..dt.szName
                pTextBox:setParserDelegate(TextParser:getSingleton());
                pTextBox:setText(str)
                pTextBox:setVisible(true)
                pLabel:setVisible(false)
            end
        else
            pTextBox:setVisible(false)
            pLabel:setText(L("str3243"))
            pLabel:setVisible(true)
        end
    end
    local pDragNode = SCTypeCast:castNodeToDragNode(wnd:getChildByTag(1));
    if pDragNode then
        local nWidth = pDragNode:getContentSize().width
        local nHeight = pDragNode:getContentSize().height
        local ani = nil
        local idIcon = nil
        if not dt.ucClan or 2 > dt.ucClan then
            idIcon = 111010
        elseif 2 == dt.ucClan then
            idIcon = 141010
        elseif 3 == dt.ucClan then
            idIcon = 121010
        elseif 4 == dt.ucClan then
            idIcon = 131010
        end
        if idIcon then
            ani = SCLookfaceParser :getSingleton():getAnimationByLookfaceAndIndex(idIcon)
        end
        local pLookNode = pDragNode:getChildByTag(899)
        if pLookNode then
            pDragNode:removeChildByTag(899,true)
        end
        if ani then
            pLookNode = SCAnimationNode:nodeWithAnimation(ani);
            if pLookNode then
                pLookNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                pLookNode:setPosition(CCPointMake(nWidth / 2 + SX(15), nHeight / 2 ))
                pLookNode:setTag(899)
                local wingIcon = 50601
                local aniWing = SCLookfaceParser :getSingleton():getAnimationByIndex(wingIcon, wingIcon)
                if aniWing then
                    setHeroBackAnimation(aniWing, pLookNode)
                end
                pDragNode:addChild(pLookNode); 
            end
        end         
    end
end
----------------消息处理区----------------
local function recSocietyBattleApply()
    SCActivityIndicator:getSingleton():close();
    local dt = LuaData:getSingleton():getDataTransStream();
    if dt then
        armyGroupFightl_showArmyGroupFightlWnd(stSignGameInfo.initWithStream(dt));
    end
end
----------------消息注册区----------------
LuaData:getSingleton():luaSetSelectorOnRecvData(recSocietyBattleApply, LuaData_MSG_SOCIATY_SIGN_GAME_INFO);
----------------全局函数区----------------
function armyGroupFightl_showArmyGroupFightlWnd(dt)
    local wndCtrl = getCurentSceneWindowController(4230)
    if wndCtrl then
        local wnd = wndCtrl:getWindow()
        refreshWndData(dt,wnd)
        return
    end
    local idIcon = Hero:getSingleton():getLookFace()
    local wnd = armyGroupFightl.initControl()
    if wnd then
        wndCtrl = SCWindowController:controllerWithWindow(wnd)
        local naviCtrl =  getCurentSceneNavigationController()
        if wndCtrl and naviCtrl then
            naviCtrl:pushWindowController(wndCtrl)
        end
        local titlefile = getRealUIResourcePath("tribe/new00824.png")
        if titlefile then
            wnd:setTitleWithImage(titlefile:getData())
        end
        sentDataToTheWnd(wnd)
        refreshWndData(dt,wnd)
    end
end
function armyGroupFightl.wndClose()
    m_tmpTagOfBtn = nil
end

--函数调用