-------------------------version info------------------------------------
CLIENT_VERSION      =   loadAni-175; --325及之前的客户端 loadAni = 500；
CLIENT_TYPE      	=   2;  --0简体  1繁体  2泰国
-------------------------screen params------------------------------------
SCREEN_SIZE  		=	getScreenSizeEx()
SCREEN_CENTER		=	CCPointMake(SCREEN_SIZE.width / 2, SCREEN_SIZE.height / 2)
-------------------------app info------------------------------------
APP_NAME            =   "IOS_SELF"
-------------------------node anchort point ------------------------------------
ANCHOR_LEFT_TOP		=	CCPointMake(0, 1)
ANCHOR_LEFT_BOTTOM	=	CCPointMake(0, 0)
ANCHOR_CENTER		=	CCPointMake(0.5, 0.5)
ANCHOR_RIGHT_TOP	=	CCPointMake(1, 1)
ANCHOR_RIGHT_BOTTOM	=	CCPointMake(1, 0)
-------------------------ui scale------------------------------------
UI_SCALE            =   gUIScale()
function AUTO_X(x)
    return x * UI_SCALE.x
end
function AUTO_Y(y)
    return y * UI_SCALE.y
end
function AUTO_W(w)
    return w * UI_SCALE.x
end
function AUTO_H(h)
    return h * UI_SCALE.y
end
function AUTO_POS(x, y)
    return CCPointMake(UI_SCALE.x * x, UI_SCALE.y * y)
end
function AUTO_SIZE(w, h)
    return CCSizeMake(UI_SCALE.x * w, UI_SCALE.y * h)
end
------------------------window size-------------------------------------
local function getWindowSize()
    if UI_SCALE.x == 1.0 then 
        return CCSizeMake(480, 320)
    elseif UI_SCALE.x == 1.5 then 
        return CCSizeMake(720, 480)
    else --UI_SCALE.x == 2.0
        return CCSizeMake(960 , 640)
    end
end
WIN_SIZE            =   getWindowSize()  
WIN_CENTER          =   CCPointMake(WIN_SIZE.width / 2, WIN_SIZE.height / 2)     
------------------------font about-------------------------------------
function F(size)
	return getFontSize(size)
end
DEFAULT_FONT_NAME	=	getDefaultFontName()
DEFAULT_FONT_SIZE	=	F(13)
------------------------language-------------------------------------
function L(str)
	return _LTParser(str)
end
------------------------resources-------------------------------------
function RES(file)
    local str = getRealUIResourcePath(file)
    if str ~= nil then 
        return str:getData()
    end
    return nil
end
------------------------tcp transpot---------------------------------
function TRANS(data)
    SCDataTransThread:getSingleton():transData(data)
end
function RECV()
    return SCMessageCenter:getSingleton():getDataTransStream()
end
-----------------------tip &&銆€msg-----------------------------------
function SHOW_MESSAGE(msg, title)
    CCMessageBox(msg, title)
end
function SHOW_TIP(msg)
    CCMessageBox(msg, "")
end

------------------------controller mgr-------------------------------
function PUSH_CTRL(ctrl)
    local scene = SCBaseScene:getRunningScene()
    if scene ~= nil then 
        scene:getNavigationController():pushWindowController(ctrl)
    end
end

function POP_TOP_CTRL()
    local scene = SCBaseScene:getRunningScene()
    if scene ~= nil then 
        scene:getNavigationController():popWindowController()
    end
end

function ADD_CTRL(ctrl)
    local scene = SCBaseScene:getRunningScene()
    if scene ~= nil then 
        scene:getNavigationController():addWindowController(ctrl)
    end
end

function REMOVE_TOP_CTRL()
    local scene = SCBaseScene:getRunningScene()
    if scene ~= nil then 
        scene:getNavigationController():removeTopWindowController()
    end
end

function REMOVE_CTRL(ctrl)
    local scene = SCBaseScene:getRunningScene()
    if scene ~= nil then 
        scene:getNavigationController():removeWindowController(ctrl)
    end
end

function REMOVE_CTRL_BY_TAG(tag)
    local scene = SCBaseScene:getRunningScene()
    if scene ~= nil then 
        scene:getNavigationController():removeWindowControllerByTag(tag)
    end
end

-----------------------------------WAITING UI-----------------------------
local isActivityIndicatorInited = false
function SHOW_WAIT()
    if (isActivityIndicatorInited == false) then 
        isActivityIndicatorInited = SCActivityIndicator:getSingleton():init()
    end
    SCActivityIndicator:getSingleton():show()
end
function SHOW_TEXT_WAIT(text)
    if (isActivityIndicatorInited == false) then 
        isActivityIndicatorInited = SCActivityIndicator:getSingleton():init()
    end
    SCActivityIndicator:getSingleton():showWithText(text)
end
function CLOSE_WAIT()
    if (isActivityIndicatorInited == false) then 
        isActivityIndicatorInited = SCActivityIndicator:getSingleton():init()
    end
    SCActivityIndicator:getSingleton():close()
end

--------------------------------animation about----------------------------
function ANIMATION(groupId, aniId)
    return SCAnimationFactory:getSingleton():generateAnimationFormPlist(groupId,  aniId)
end
--------------------------------get then platform---------------------------
CC_PLATFORM_UNKNOWN		= 0
CC_PLATFORM_IOS			= 1
CC_PLATFORM_ANDROID		= 2
CC_PLATFORM_WOPHONE		= 3
CC_PLATFORM_WIN32		= 4
CC_PLATFORM_MARMALADE	= 5
CC_PLATFORM_LINUX		= 6
CC_PLATFORM_BADA		= 7
CC_PLATFORM_QNX			= 8

CC_TARGET_PLATFORM	=	getTargetPlatform()