_DEBUG = false

function SetDebugFlag()
	_DEBUG = true
end
-------------------------------------------------------------------------------------
local m_SyngameTime = nil
local m_EntryID = nil
local m_ArmyGroupFlg = nil
local function syngameTimer(fTime)
    m_SyngameTime.nTime = m_SyngameTime.nTime - 1
    MainInterface_showSyngameTime(m_SyngameTime, true)
end
local function checkArmyClick()
    armyGroupFight3_sendLookReport()
end
function MainInterface_showSyngameTime(syngameTime, bShow)
	--if nil == syngameTime then
	--	return
	--end
	local interface = getMainInterface();
	if nil == interface then
		return
	end
	for i=1005, 1008 do
		local node = SCFunction:getUiNodeByIdlistAndParent("5932-"..i, interface)
		if node and m_ArmyGroupFlg then
			node:setVisible(not bShow)
		end
	end
	if false == bShow then
	    local pNode = interface:getChildByTag(12001)
	    if pNode then
	        interface:removeChildByTag(12001,true)
	    end
	    m_SyngameTime = nil
	    if m_EntryID then
	        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_EntryID);
            m_EntryID = nil;
	    end
	    return
	end
	
	local cutWillNode = SCFunction:getUiNodeByIdlistAndParent("5942-2014", interface)
	if cutWillNode then
		cutWillNode:setVisible(false)
	end
	
	local baseNode = interface:getChildByTag(12001)
	if nil == baseNode then
		baseNode = SCNode:node()
		baseNode:setTag(12001)
		baseNode:setContentSize(CCSizeMake(SX(160), SY(50)))
		baseNode:setAnchorPoint(CCPointMake(0, 1))
		if currentDeviceType()==SC_DEVICE_TYPE_1280x800 or currentDeviceType()==SC_DEVICE_TYPE_1280x720 then
		    baseNode:setPosition(CCPointMake(SX(50), SY(300)))
		else
		    baseNode:setPosition(CCPointMake(SX(50), SY(260)))
		end
		baseNode:setBackgroundColor(ccc4(0,0,0,180))
		interface:addChild(baseNode)
	end
	if nil == baseNode then
		return
	end
	local nWidth = baseNode:getContentSize().width
    local nHeight = baseNode:getContentSize().height
	local pBtn = SCButton:button();
    if pBtn then
        pBtn:setAnchorPoint(CCPointMake(0.5, 0.5));
        pBtn:setPosition(CCPointMake(nWidth / 2, nHeight / 2));
        pBtn:setContentSize(CCSizeMake(nWidth, nHeight))
        pBtn:luaSetSelectorOnClicked(checkArmyClick);
        baseNode:addChild(pBtn);
    end
	local imgNode = tolua.cast(baseNode:getChildByTag(1), "SCImage")
	if nil == imgNode then
		local filePath = getRealUIResourcePath("tribe/new00825.png")
		if filePath then
			imgNode = SCImage:imageWithFile(filePath:getData())
			imgNode:setTag(1)
			imgNode:setAnchorPoint(CCPointMake(0, 0.5))
			imgNode:setPosition(CCPointMake(SX(5), baseNode:getContentSize().height/2))
			baseNode:addChild(imgNode)
		end
	end
	local labelDes = tolua.cast(baseNode:getChildByTag(3), "SCLabel")
	if nil == labelDes then
		labelDes = SCLabel:labelWithStringFont(L("str3225"), DEFAULT_FONT_NAME, F(12))
		labelDes:setTag(3)
		labelDes:setColor(color_green)
		labelDes:setAnchorPoint(CCPointMake(0, 0))
		labelDes:setPosition(CCPointMake(imgNode:getContentSize().width+SX(2), SY(6)))
		baseNode:addChild(labelDes)
	end
	if not syngameTime or syngameTime.nTime <= 0 then
	    if m_EntryID then
	        CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(m_EntryID);
            m_EntryID = nil;
	    end
	    return
	else
	    if m_EntryID == nil then
	        m_EntryID = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(syngameTimer, 1.0, false)
	    end
	end
	
	if nil == imgNode then
		return
	end
	local labelName = tolua.cast(baseNode:getChildByTag(2), "SCLabel")
	if nil == labelName then
		labelName = SCLabel:labelWithStringFont(syngameTime.szName..":"..makeTime(syngameTime.nTime, Min_Sec), DEFAULT_FONT_NAME, F(12))
		labelName:setTag(2)
		labelName:setColor(color_orange)
		labelName:setAnchorPoint(CCPointMake(0, 1))
		labelName:setPosition(CCPointMake(imgNode:getContentSize().width+SX(12), baseNode:getContentSize().height-SY(5)))
		baseNode:addChild(labelName)
	else
	    labelName:setText(syngameTime.szName..":"..makeTime(syngameTime.nTime, Min_Sec))
	end
	if nil == labelName then
		return
	end
	
end

function recvSyngameTime(dt)
	local dt = LuaData:getSingleton():getDataTransStream()
	if nil == dt then
		return
	end
	if nil == m_SyngameTime then
		m_SyngameTime = {}
	end
	m_SyngameTime.nTime = dt:readInt();
	m_SyngameTime.szName = dt:readString()
	if m_SyngameTime.szName then
		m_SyngameTime.szName = m_SyngameTime.szName:getData()
	else
		m_SyngameTime.szName = ""
	end
	MainInterface_showSyngameTime(m_SyngameTime, true)
end
LuaData:getSingleton():luaSetSelectorOnRecvData(recvSyngameTime, LuaData_MSG_SYNGAME_TIME);
----------------------------------------------------------------------------------------------------
local function initialization()
	--Flowers 送花
	--SendFlowersProcessor:getSingleton();
end

local function main()
	initialization();
end

function BossMap()
	setMainCurrencyInfoNodeIsVisible(false);
	setMainTopNodeIsVisible(false);
	setIsHideRightButton(false)
	removeAllWindwoController()
	pauseAllGuide()
end

function UnBossMap()
	setMainCurrencyInfoNodeIsVisible(true);
	setMainTopNodeIsVisible(true);
	setIsHideRightButton(true)
	closeBossNode();
	closeSocietyBattleNode();
	restartAllBeginnerGuide()
end

local MAPTYPE_SYN_CAMPAIGN_WAR = 67108864
local MAPTYPE_BATTLE_DISABLE = 16

--加载地图开始
function loadMapBegin()
    open_LoadingScreen();
end

--加载地图结束
function loadMapEnd()
    coloseWnd_LoadingScreen();
	if  true == GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_SYN_CAMPAIGN_WAR) then
	    local wndCtrl = getCurentSceneWindowController(4223);
        if wndCtrl then
            removeWindowCtrl(wndCtrl);
        end
        local wndCtrl = getCurentSceneWindowController(4230);
        if wndCtrl then
            removeWindowCtrl(wndCtrl);
        end
        local wndCtrl = getCurentSceneWindowController(4421);
        if wndCtrl then
            removeWindowCtrl(wndCtrl);
        end
        m_ArmyGroupFlg = true
	    if false == GameCommonMsgRecive:getSingleton():isKindOfMap(MAPTYPE_BATTLE_DISABLE) then
		    MainInterface_showSyngameTime(m_SyngameTime, true)
		else
		    MainInterface_showSyngameTime(m_SyngameTime, true)
		end
	else
		MainInterface_showSyngameTime(m_SyngameTime, false)
		m_ArmyGroupFlg = false
	end
end

---人物移动
function heroPosChange()
    closeOnlineLevWnd();--关闭存在的在线练功界面
end

math.randomseed(os.time())
main()