--定义一个与文件名相同的table
recharge = {}
------------------消息--------------------

----------------结构定义区----------------
local stRechargeItem = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = {__mode = "kv", }
        tmp.usAwardType = dt:readShort();
        tmp.idItemType = dt:readInt();
        tmp.nNum = dt:readInt();
		return tmp;
	end
};

local stRechargeGift = {
    initWithStream = function (dt)
        if dt == nil then
            return {}
        end
        local tmp = { __mode = "kv", }
        tmp.ucLevel = dt:readByte();
        tmp.idGiftType = dt:readInt();
        tmp.nRecharge = dt:readInt();
        tmp.szDescription = dt:readString();
        tmp.ucAmount = dt:readByte();
        tmp.stfill = { __mode = "kv" }
        for i = 1, tmp.ucAmount do
            table.insert(tmp.stfill, stRechargeItem.initWithStream(dt))
        end
        return tmp;
	end
};
----------------常量定义区----------------
local GIFTINFO_RECHARE_GIFT_FLAG  = 3  --	//充值奖励状态
local GIFTINFO_RECHARE_DETAIL = 4    --	//充值奖励信息(只需请求一次)
local GIFTINFO_GET_RECHARGE_AWARD = 5 ---	//领取奖励
local GIFTINFO_RECHARE_DETAIL_END = 6		--//充值奖励信息(只需请求一次)(下发的最后一个包)

----------------变量定义区----------------
local stRecharge = {}
local offset = nil
local Wnd = nil
----------------本地函数------------------
local function CloseWnd()
    POP_TOP_CTRL();
end
function recharge_getstRecharge()
	return stRecharge;
end

local function onClickShowItem(tag)     --查看物品
    local type = stRecharge[offset+1].stfill[tag].usAwardType;
    if type == 0 then
        showTip(stRecharge[offset+1].stfill[tag].idItemType)
    else
        --[[local pframeWnd = FrameWindow:frameWnd();
        if pframeWnd then
            pframeWnd:setContentSize(CCSizeMake(SX(133), SY(80)));
            pframeWnd:setAnchorPoint(CCPointMake(0.5, 0.5));
            pframeWnd:setPosition(AUTO_POS(247.50, 118.00))
        end--]]
        if type == 1 then
            luaShowTipCpp(1, stRecharge[offset+1].stfill[tag].nNum)  --金钱 
        elseif type == 2 then
            luaShowTipCpp(2, stRecharge[offset+1].stfill[tag].nNum)  --储备金 
        elseif type == 3 then
            luaShowTipCpp(3, stRecharge[offset+1].stfill[tag].nNum)  --阅历 
        elseif type == 4 then
            luaShowTipCpp(4, stRecharge[offset+1].stfill[tag].nNum)    --经验 
        elseif type == 5 then
            luaShowTipCpp(5, stRecharge[offset+1].stfill[tag].nNum)    --声望 
        elseif type == 6 then
            --luaShowTipCpp(1, stRecharge[offset+1].stfill[tag].nNum)     --魂力 
        elseif type == 7 then
            luaShowTipCpp(7, stRecharge[offset+1].stfill[tag].nNum)        --仙晶 
        elseif type == 8 then
            --luaShowTipCpp(8, stRecharge[offset+1].stfill[tag].nNum)    --生命水晶 
        elseif type == 9 then
            luaShowTipCpp(9, stRecharge[offset+1].stfill[tag].nNum)    --体力 
        elseif type == 101 then
            luaShowTipCpp(101, stRecharge[offset+1].stfill[tag].nNum)    --战功 
        elseif type == 102 then
            luaShowTipCpp(102, stRecharge[offset+1].stfill[tag].nNum)    --通宝 
        elseif type == 103 then
            --pParsedNode = getItemTextNode(L("str0369")..stRecharge[offset+1].stfill[tag].nNum)    --灵石
        end
        --[[if pParsedNode then
            pParsedNode:setAnchorPoint(CCPointMake(0.5, 0.5));
            pParsedNode:setPosition(CCPointMake(pframeWnd:getContentSize().width / 2, pframeWnd:getContentSize().height / 2));
            pframeWnd:addChild(pParsedNode);
            --pframeWnd:luaSetReturnSelector(RemoveChild);
        end
        Wnd:addChild(pframeWnd);--]]
    end
end

local function getBright(index)    --按位判断是否能领取奖励 位1代表可领取 
    local mark = getLeftMoveBit(index);
    if getAndBit(recharge.nData, mark) > 0 then
        return true;
    else
        return false;
    end
end

local function getBrightisRecv(index)    --按位判断是否能领取过奖励 位1代表已领取
    local mark = getLeftMoveBit(index);
    if getAndBit(recharge.nData2, mark) > 0 then
        return true;
    else
        return false;
    end
end

local function Surerechange()
    --屏蔽充值
    --[[if 1 then
        showMessage(_LTParser("str6192"))
        return
    end]]
    POP_TOP_CTRL()
    showVIPrechargeableWnd()
end

local function ChangeView(tag, num)   --滑动画面后改变的值
    local PageBox = SCTypeCast:castNodeToPageScrollBox(SCFunction:getUiNodeByIdlist("4422-10002-10013"));
    if PageBox then
        offset = PageBox:getPageIndex()
        if offset > 11 then
            offset = 11;
        end
    end
    
    local pDragNode10009 = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10009"), "SCNode");    --改变需要累计充值余额
    pDragNode10009:removeChildByTag(10016, true); 
    local pNode = getImageNumber(stRecharge[offset+1].nRecharge, "img/img7099.png", SX(15.9), SY(20));  --显示需要累计充值余额
	if pNode then
	    pNode:setTag(10016)
	    --pNode:setScale(1.5);
		pNode:setAnchorPoint(ANCHOR_CENTER)
		pNode:setPosition(AUTO_POS(176, 41.00))
		pDragNode10009:addChild(tolua.cast(pNode, "SCNode"))
	end
	
	local imgPath = getRealUIResourcePath("img/new00457.png")	--可领取图标
	local imgPath1 = getRealUIResourcePath("img/new00458.png")	--可领取选中图标
	local imgPath2 = getRealUIResourcePath("img/new00529.png") --不可领取灰色图标		
	local imgPath3 = getRealUIResourcePath("img/new00577.png") --已领取灰色图标	
	local pButton10014 = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10014"), "SCNode");   --领取奖励按钮 --改变需要按钮状态
	if pButton10014 then
		if getBrightisRecv(offset) == true then	--1代表已领取
			pButton10014:setTitle(imgPath3:getData())  --可领取图标
			pButton10014:setSelectedImage(imgPath3:getData())	--可领取选中图标
		else
			if getBright(offset) == true then  --1代表可领取
				pButton10014:setTitle(imgPath:getData())  --可领取图标
				pButton10014:setSelectedImage(imgPath1:getData())	--可领取选中图标
				--pButton10014:luaSetSelectorOnClicked(GoodDeedsendData)
			else
				pButton10014:setTitle(imgPath2:getData())  --不可领取灰色图标
				pButton10014:setSelectedImage(imgPath2:getData())
			end
		end
	end
	
	local imgPath = getRealUIResourcePath("img/new00"..(463+offset)..".jp")
	local pImage10007 = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10007"), "SCNode");
	if pImage10007 then
	    pImage10007:setImage(imgPath:getData())
	end
	
	local pText = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10022"), "SCNode");
	if pText then
	    TextParser:getSingleton():setText(pText, L("str0"..(370+offset)))
	end
	
	local pImage = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10009-10010"), "SCNode");
	if offset < 3 then
        pImage:setPosition(AUTO_POS(58.00, 26.00))
    elseif offset > 2 and offset < 8 then
        pImage:setPosition(AUTO_POS(40.00, 26.00))
    elseif offset > 7 then
        pImage:setPosition(AUTO_POS(20.00, 26.00))
    end
end

local function ViewRes(tag)
    local PageBox = SCFunction:getUiNodeByIdlist("4422-10002-10013");
    if tag == 10019 then        --左按钮
        if offset > 0 then
            offset = offset - 1;
        end
        PageBox:setOffset(AUTO_POS(200 * offset, 0))
    elseif tag == 10020 then    --右按钮
        if offset < #stRecharge - 1 then
            offset = offset + 1;
        end
        PageBox:setOffset(AUTO_POS(200 * offset, 0))
    end
    
    local pDragNode10009 = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10009"), "SCNode");    --改变需要累计充值余额
    pDragNode10009:removeChildByTag(10016, true); 
    local pNode = getImageNumber(stRecharge[offset+1].nRecharge, "img/img7099.png", SX(15.9), SY(20));  --显示需要累计充值余额 
	if pNode then
	    pNode:setTag(10016)
	    --pNode:setScale(1.5);
		pNode:setAnchorPoint(ANCHOR_CENTER)
		pNode:setPosition(AUTO_POS(176, 41.00))
		pDragNode10009:addChild(tolua.cast(pNode, "SCNode"))
	end
	
	local imgPath = getRealUIResourcePath("img/new00457.png")	--可领取图标
	local imgPath1 = getRealUIResourcePath("img/new00458.png")	--可领取选中图标
	local imgPath2 = getRealUIResourcePath("img/new00529.png") --不可领取灰色图标		
	local pButton10014 = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10014"), "SCNode");   --领取奖励按钮 --改变需要按钮状态
	if pButton10014 then
		if getBrightisRecv(offset) == true then	--1代表已领取
			pButton10014:setTitle(imgPath2:getData())  --可领取图标
			pButton10014:setSelectedImage(imgPath2:getData())	--可领取选中图标
		else
			if getBright(offset) == true then  --1代表可领取
				pButton10014:setTitle(imgPath:getData())  --可领取图标
				pButton10014:setSelectedImage(imgPath1:getData())	--可领取选中图标
				--pButton10014:luaSetSelectorOnClicked(GoodDeedsendData)
			else
				pButton10014:setTitle(imgPath2:getData())  --不可领取灰色图标
				pButton10014:setSelectedImage(imgPath2:getData())
			end
		end
	end
	
	local imgPath = getRealUIResourcePath("img/new00"..(463+offset)..".jp")
	local pImage10007 = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10007"), "SCNode");
	if pImage10007 then
	    pImage10007:setImage(imgPath:getData())
	end
	
	local pText = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10022"), "SCNode");
	if pText then
	    TextParser:getSingleton():setText(pText, L("str0"..(370+offset)))
	end
	
	local pImage = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10009-10010"), "SCNode");
	if offset < 3 then
        pImage:setPosition(AUTO_POS(58.00, 26.00))
    elseif offset > 2 and offset < 8 then
        pImage:setPosition(AUTO_POS(40.00, 26.00))
    elseif offset > 7 then
        pImage:setPosition(AUTO_POS(20.00, 26.00))
    end
end

local function ShowRes()
	local pDragNode10002 = SCFunction:getUiNodeByIdlistAndParent("10002", Wnd)
	local imgPath = getRealUIResourcePath("img/new00"..(463+offset)..".jp")   --活动任务图片
	local pImage10007 = SCImage:imageWithFile(imgPath:getData())
	if pImage10007 and imgPath then
		pImage10007:setTag(10007)
		pImage10007:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10007:setPosition(AUTO_POS(16.50, 118.00))
		pImage10007:setContentSize(AUTO_SIZE(100, 100))
		pDragNode10002:addChild(tolua.cast(pImage10007, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00452.png")   --当前累计充值图标
	local pImage10008 = SCImage:imageWithFile(imgPath:getData())
	if pImage10008 and imgPath then
		pImage10008:setTag(10008)
		pImage10008:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10008:setPosition(AUTO_POS(16.50, 97.50))
		pImage10008:setContentSize(AUTO_SIZE(80, 14))
		pDragNode10002:addChild(tolua.cast(pImage10008, "SCNode"))
	end
	
	local pMoneyNode = getImageNumber(recharge.nRecharge, "img/new00530.png", SX(12.2), SY(18));  --显示累计充值余额
	if pMoneyNode then
	    pMoneyNode:setTag(10017)
		pMoneyNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pMoneyNode:setPosition(AUTO_POS(96.50, 96.50))
		pMoneyNode:setScaleX(0.6)
		pDragNode10002:addChild(tolua.cast(pMoneyNode, "SCNode"))
	end

	local pDragNode10009 = SCDragNode:node()    --需要充值余额的容器
	if pDragNode10009 then
		pDragNode10009:setTag(10009)
		pDragNode10009:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10009:setPosition(AUTO_POS(151.50, 160.50))
		pDragNode10009:setContentSize(AUTO_SIZE(291, 57))
		pDragNode10009:setFrameVisibled(true)
		pDragNode10009:setDragEnabled(false)
		pDragNode10009:setFrameType(EnumFrameTypeNone)
		pDragNode10002:addChild(tolua.cast(pDragNode10009, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00456.png")
	local pImage10010 = SCImage:imageWithFile(imgPath:getData())
	if pImage10010 and imgPath then
		pImage10010:setTag(10010)
		pImage10010:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		if offset < 3 then
            pImage10010:setPosition(AUTO_POS(55.00, 26.00))
        elseif offset > 2 and offset < 8 then
            pImage10010:setPosition(AUTO_POS(37.00, 26.00))
        elseif offset > 7 then
            pImage10010:setPosition(AUTO_POS(16.00, 26.00))
        end
		pImage10010:setContentSize(AUTO_SIZE(62, 24))
		pDragNode10009:addChild(tolua.cast(pImage10010, "SCNode"))
	end
	
	local pNode = getImageNumber(stRecharge[1+offset].nRecharge, "img/img7099.png", SX(15.9), SY(20));  --显示需要累计充值余额
	if pNode then
	    pNode:setTag(10016)
	    --pNode:setScale(1.5);
		pNode:setAnchorPoint(ANCHOR_CENTER)
		pNode:setPosition(AUTO_POS(176, 41.00))
		pDragNode10009:addChild(tolua.cast(pNode, "SCNode"))
	end
	
	local pText = SCTextBox:boxWithWidthHeightFont(AUTO_W(135), AUTO_H(60), DEFAULT_FONT_NAME, F(11));
	if pText then
	    pText:setTag(10022)
		pText:setAnchorPoint(ANCHOR_CENTER)
		pText:setPosition(AUTO_POS(83.00, 68.00))
		--pText:setContentSize(AUTO_SIZE(102, 60))
		TextParser:getSingleton():setText(pText, L("str0"..(370+offset)))
		pDragNode10002:addChild(tolua.cast(pText, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00462.png")  --元字图标
	local pImage10011 = SCImage:imageWithFile(imgPath:getData())
	if pImage10011 and imgPath then
		pImage10011:setTag(10011)
		pImage10011:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10011:setPosition(AUTO_POS(182, 26.00))
		pImage10011:setContentSize(AUTO_SIZE(26, 24))
		pDragNode10009:addChild(tolua.cast(pImage10011, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00461.png")   --送字的图标
	local pImage10012 = SCImage:imageWithFile(imgPath:getData())
	if pImage10012 and imgPath then
		pImage10012:setTag(10012)
		pImage10012:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10012:setPosition(AUTO_POS(-37.00, 2.50))
		pImage10012:setContentSize(AUTO_SIZE(50, 50))
		pDragNode10009:addChild(tolua.cast(pImage10012, "SCNode"))
	end

	local pPageScrollBox= SCPageScrollBox:boxWithWidthHeight(AUTO_W(200), AUTO_H(145))  --横向滑动窗口
	if pPageScrollBox then
		pPageScrollBox:setTag(10013)
		pPageScrollBox:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pPageScrollBox:setPosition(AUTO_POS(173.00, 36.50))
		pPageScrollBox:setScrollVertical(false)
		pPageScrollBox:setContentSize(AUTO_SIZE(200 * (#stRecharge), 145))
		pPageScrollBox:setPageSize(AUTO_SIZE(200, 145));
		pPageScrollBox:luaSetSelectorOnScrollToPrevious(ChangeView)
		pPageScrollBox:luaSetSelectorOnScrollToNext(ChangeView)
		pPageScrollBox:setOffset(AUTO_POS(200 * offset, 0))
		pDragNode10002:addChild(tolua.cast(pPageScrollBox, "SCNode"))
	end
	
	for z = 1, #stRecharge do
        local PResNode = SCDragNode:node()    --获取物品列表
        if PResNode then
            PResNode:setTag(10018)
            PResNode:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
            PResNode:setContentSize(AUTO_SIZE(200, 145))
            PResNode:setPosition(AUTO_POS(0.00 + (z - 1) * 200, 0.00))
            PResNode:setFrameVisibled(true)
            PResNode:setDragEnabled(false)
            PResNode:setFrameType(EnumFrameTypeNone)
            pPageScrollBox:addChild(tolua.cast(PResNode, "SCNode"))
        end
        
        for i = 1, 3 do
            for j = 1, 4 do
                local imgPath = getRealUIResourcePath("img/new00002.png")
                local pButton = SCButton:button()   --奖励物品按钮
                if pButton then
                    pButton:setTag((i-1)*4+j)
                    --pButton:setTitle(imgPath:getData())
                    pButton:setBackgroundImage(imgPath:getData())
					pButton:setSelectedImage(imgPath:getData())
                    pButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
                    pButton:setPosition(AUTO_POS(0.00 + (j - 1)*51.50, 100.0 - (i - 1) * 50))
                    --pButton:luaSetSelectorOnClicked(GoodDeedsendData)
                    pButton:setContentSize(AUTO_SIZE(46, 46))
                    PResNode:addChild(tolua.cast(pButton, "SCNode"))
                end
            end
        end
		
		for k = 1, stRecharge[z].ucAmount do	
		    if stRecharge[z].stfill[k].usAwardType == 0 then
		        local itemInfo = TableParser:getSingleton():getItemInfoByKey(stRecharge[z].stfill[k].idItemType);  --获取id值
                local imgPath = getRealUIResourcePath("item/" .. itemInfo.icon .. ".jp");
                if imgPath then
                    local Button = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(k.."", PResNode), "SCButton")
                    Button:setTitle(imgPath:getData())
                    Button:luaSetSelectorOnClicked(onClickShowItem)
                    
                    local Label = SCLabel:labelWithStringFont(stRecharge[z].stfill[k].nNum, DEFAULT_FONT_NAME, F(10))
                    if Label then
                        Label:setAnchorPoint(ANCHOR_RIGHT_BOTTOM)
                        Label:setPosition(AUTO_POS(43.50, 0.00))
                        Button:addChild(tolua.cast(Label, "SCNode"))
                        local ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1022, 1022);
                        if ani then
                            ani:setFPS(10.0);
                            local aniNode = SCAnimationNode:nodeWithAnimation(ani);
                            if aniNode then
                                aniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                                aniNode:setPosition(CCPointMake(Button:getContentSize().width/2, Button:getContentSize().height/2));
                                Button:addChild(aniNode);
                                aniNode:setTag(9999);
                            end
                        end
                    end
                end
		    else
		        local Button = tolua.cast(SCFunction:getUiNodeByIdlistAndParent(k.."", PResNode), "SCButton")
		        local imgPath = nil
		        if stRecharge[z].stfill[k].usAwardType == 1 then
		            imgPath = getRealUIResourcePath("item/2001001.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 2 then
		            imgPath = getRealUIResourcePath("item/2001001.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 3 then
		            imgPath = getRealUIResourcePath("item/2001001.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 4 then
		            imgPath = getRealUIResourcePath("item/2001002.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 5 then
		            imgPath = getRealUIResourcePath("item/2001003.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 6 then
		            imgPath = getRealUIResourcePath("item/2001001.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 7 then
		            imgPath = getRealUIResourcePath("item/2001001.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 8 then
		            imgPath = getRealUIResourcePath("item/2001001.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 9 then
		            imgPath = getRealUIResourcePath("item/2001005.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 101 then
		            imgPath = getRealUIResourcePath("item/2001006.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 102 then
		            imgPath = getRealUIResourcePath("item/2001008.jp")
		        elseif stRecharge[z].stfill[k].usAwardType == 103 then
		            imgPath = getRealUIResourcePath("item/2001001.jp")
		        end
                Button:setTitle(imgPath:getData())
                Button:luaSetSelectorOnClicked(onClickShowItem)
                local Label = SCLabel:labelWithStringFont(recharge_itoa(stRecharge[z].stfill[k].nNum), DEFAULT_FONT_NAME, F(10))
                if Label then
                    Label:setAnchorPoint(ANCHOR_RIGHT_BOTTOM)
                    Label:setPosition(AUTO_POS(40.00, 4.00))
                    Button:addChild(tolua.cast(Label, "SCNode"))
                end
                local ani = SCAnimationFactory:getSingleton():generateAnimationFormPlist(1022, 1022)
                if ani then
                    ani:setFPS(10.0);
                    local aniNode = SCAnimationNode:nodeWithAnimation(ani);
                    if aniNode then
                        aniNode:setAnchorPoint(CCPointMake(0.5, 0.5));
                        aniNode:setPosition(CCPointMake(Button:getContentSize().width/2, Button:getContentSize().height/2));
                        Button:addChild(aniNode);
                        aniNode:setTag(9999);
                    end
                end
		    end
		end
	end
	
	local imgPath = getRealUIResourcePath("img/new00048.png")   --左边滑动按钮    
    local LeftButton = SCButton:button() --SCImage:imageWithFile(imgPath:getData())
	if LeftButton and imgPath then
		LeftButton:setTag(10019)
		LeftButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		LeftButton:setPosition(AUTO_POS(151.00, 93.00))
		LeftButton:setContentSize(AUTO_SIZE(40, 60))
		LeftButton:setTitle(imgPath:getData())
		LeftButton:luaSetSelectorOnClicked(ViewRes)
		pDragNode10002:addChild(tolua.cast(LeftButton, "SCNode"))
	end
	
	local imgPath = getRealUIResourcePath("img/new00047.png")   --右边滑动按钮
    local RightButton = SCButton:button() --SCImage:imageWithFile(imgPath:getData())
	if RightButton and imgPath then
		RightButton:setTag(10020)
		RightButton:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		RightButton:setPosition(AUTO_POS(374.00, 93.00))
		RightButton:setContentSize(AUTO_SIZE(40, 60))
		RightButton:setTitle(imgPath:getData())
		RightButton:luaSetSelectorOnClicked(ViewRes)
		pDragNode10002:addChild(tolua.cast(RightButton, "SCNode"))
	end
	
	
	local imgPath = getRealUIResourcePath("img/new00457.png")	--可领取图标
	local imgPath1 = getRealUIResourcePath("img/new00458.png")	--可领取选中图标
	local imgPath2 = getRealUIResourcePath("img/new00529.png") --不可领取灰色图标
	local imgPath3 = getRealUIResourcePath("img/new00577.png") --已领取图标
		
	local pButton10014 = SCButton:button()   --领取奖励按钮
	if pButton10014 then
		pButton10014:setTag(10014)
		if getBrightisRecv(offset) == true then	--1代表已领取
			pButton10014:setTitle(imgPath3:getData())	--可领取选中图标
		    pButton10014:setSelectedImage(imgPath3:getData())
		else
			if getBright(offset) == true then  --1代表可领取
				pButton10014:setTitle(imgPath:getData())  --可领取图标
				pButton10014:setSelectedImage(imgPath1:getData())	--可领取选中图标
			else
				pButton10014:setTitle(imgPath2:getData())  --不可领取灰色图标
				pButton10014:setSelectedImage(imgPath2:getData())
			end
		end
		pButton10014:luaSetSelectorOnClicked(recharge_sendRecvRes)
		pButton10014:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10014:setPosition(AUTO_POS(237.00, 9.00))
		pButton10014:setContentSize(AUTO_SIZE(74, 28))
		pDragNode10002:addChild(tolua.cast(pButton10014, "SCNode"))
	end

    local imgPath = getRealUIResourcePath("img/new00119.png")   --充值前景图
    local imgPath1 = getRealUIResourcePath("img/new00118.png")  --充值背景图
    if imgPath == nil or imgPath1 == nil then
        return;
    end
    local pButton10015 = SCButton:button()   --充值按钮
	if pButton10015 then
		pButton10015:setTag(10015)
		pButton10015:setTitle(imgPath:getData())
		pButton10015:setBackgroundImage(imgPath1:getData())
		pButton10015:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10015:setPosition(AUTO_POS(41.00, 5.0))
		pButton10015:luaSetSelectorOnClicked(Surerechange)
		pButton10015:setContentSize(AUTO_SIZE(61, 30))
		pDragNode10002:addChild(tolua.cast(pButton10015, "SCNode"))
	end
end
----------------UI控制器区----------------
function recharge.initControl()
	Wnd = SCWindow:window()
	if Wnd then
		Wnd:setTag(4422)
		Wnd:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		Wnd:setPosition(AUTO_POS(-0.00, 30.00))
		Wnd:setContentSize(AUTO_SIZE(480, 260))
		Wnd:luaSetSelectorOnClose(recharge.releaseControl)
	end

	local pDragNode10002 = SCDragNode:node()
	if pDragNode10002 then
		pDragNode10002:setTag(10002)
		pDragNode10002:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pDragNode10002:setPosition(AUTO_POS(38.00, 7.00))
		pDragNode10002:setContentSize(AUTO_SIZE(472, 246))
		pDragNode10002:setFrameVisibled(true)
		pDragNode10002:setDragEnabled(false)
		pDragNode10002:setFrameType(EnumFrameTypeNone)
		Wnd:addChild(tolua.cast(pDragNode10002, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00124.png")   --窗口背景图
	local pImage10004 = SCImage:imageWithFile(imgPath:getData())
	if pImage10004 and imgPath then
		pImage10004:setTag(10004)
		pImage10004:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10004:setPosition(AUTO_POS(2.00, 4.50))
		pImage10004:setContentSize(AUTO_SIZE(472, 240))
		pImage10004:setScaleX(0.85)
		pDragNode10002:addChild(tolua.cast(pImage10004, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00450.png")   --充值礼包图标
	local pImage10005 = SCImage:imageWithFile(imgPath:getData())
	if pImage10005 and imgPath then
		pImage10005:setTag(10005)
		pImage10005:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pImage10005:setPosition(AUTO_POS(179.00, 226.50))
		pImage10005:setContentSize(AUTO_SIZE(58, 16))
		pDragNode10002:addChild(tolua.cast(pImage10005, "SCNode"))
	end

	local imgPath = getRealUIResourcePath("img/new00123.png")   --小X图标
	local pButton10021 = SCButton:button()   --关闭窗口按钮
	if pButton10021 then
        pButton10021:setMusicPath("closeWindow.mp3");
		pButton10021:setTag(10021)
		pButton10021:setTitle(imgPath:getData())
		pButton10021:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pButton10021:setPosition(AUTO_POS(383.00, 223.50))
		pButton10021:setTouchRectScale(3.0,3.0)  
		pButton10021:luaSetSelectorOnClicked(CloseWnd)
		pButton10021:setContentSize(AUTO_SIZE(38, 38))
		pDragNode10002:addChild(tolua.cast(pButton10021, "SCNode"))
	end
	ShowRes();
	--[[
	local label = SCLabel:labelWithStringFont(L("str6285"), getDefaultFontName(), getFontSize(10))
	if label then
	    label:setColor(color_red)
	    label:setPosition(CCPointMake(SX(150), SY(20)))
	    Wnd:addChild(label)
	end
	--]]
	return Wnd
end
function recharge.releaseControl()
	if recharge.wndCloss then
		recharge.wndCloss()
	end
end
--函数定义
----------------逻辑功能区----------------

----------------消息处理区----------------
function recharge_sendData()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO)  
    dataStream:writeShort(GIFTINFO_RECHARE_GIFT_FLAG)  --充值奖励状态
    SCDataTransThread:getSingleton():transData(dataStream)
	
	dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO)
	dataStream:writeShort(GIFTINFO_RECHARE_DETAIL)  --充值奖励信息(只需请求一次)
	SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show()
end

function recharge_sendRecvRes()  --发送领取物品
    if getBright(offset) == true then
        local dataStream = SCDataTransStream:streamWithCommand(_MSG_GIFTINFO)  
        dataStream:writeShort(GIFTINFO_GET_RECHARGE_AWARD)
        dataStream:writeInt(stRecharge[offset+1].idGiftType)
        dataStream:writeInt(UNLOCK_TYPE_RECHARGE_GIFT)
        SCDataTransThread:getSingleton():transData(dataStream)
    end
end

function recharge_recvDataState(dt)
	recharge.nData = dt:readInt()
	recharge.nRecharge = dt:readInt()
	recharge.nData2 = dt:readInt()
	--显示已领取按钮
	local imgPath2 = getRealUIResourcePath("img/new00577.png") --显示已领取图标
	local pButton10014 = tolua.cast(SCFunction:getUiNodeByIdlist("4422-10002-10014"), "SCNode");   --领取奖励按钮 --改变需要按钮状态
	if pButton10014 then
        pButton10014:setTitle(imgPath2:getData())  --不可领取灰色图标
        pButton10014:setSelectedImage(imgPath2:getData())
	end            
end

function recharge_recvDataInfo(dt)
	recharge.ucAmount = dt:readByte()
	for i = 1, recharge.ucAmount do
		table.insert(stRecharge, stRechargeGift.initWithStream(dt))
	end
end

function recharge_recvDataInfoEnd(dt)
	recharge.ucAmount = dt:readByte()
	for i = 1, recharge.ucAmount do
		table.insert(stRecharge, stRechargeGift.initWithStream(dt))
	end
	recharge.Window()
end

----------------消息注册区----------------

----------------全局函数区----------------
function recharge.Window()
	local wnd = nil;
	offset = 0;
    for i = 0, 11 do
        if getBrightisRecv(i) == false then
            offset = i
            break;
        end
        if i == 11 then
            offset = 11
        end
    end
	local wndCtrl = getCurentSceneWindowController(4422);
	if wndCtrl then
		wnd = wndCtrl:getWindow();   
	else
		wnd = recharge.initControl()
		if wnd then
			local wndCtrl = SCWindowController:controllerWithWindow(wnd)
			local naviCtrl = getCurentSceneNavigationController()
			if wndCtrl and naviCtrl then
				naviCtrl:pushWindowController(wndCtrl)
				wnd:setCloseButtonVisibled(false)
				wnd:setFrameVisibled(false);
			end
		end
	end
end

function recharge_itoa(num)
    local number = nil
    if num >= 10000 then
	    number = (num / 10000)..L("str0285");
	else
        number = num
	end
	return number;
end

function recharge.wndCloss()
    stRecharge = {}
    offset = nil
    Wnd = nil
end

--函数调用