--定义一个与文件名相同的table
yanwu2 = {}
------------------消息--------------------CCLuaLog
----------------结构定义区----------------
local stWorldEvent = {
	initWithStream = function(dt)
		local tmp = {}
		if not dt then
			return tmp
		end
		
		tmp.usIndex = dt:readShort();
		tmp.szName = dt:readString();
		if tmp.szName then
			tmp.szName = tmp.szName:getData();
		else
			tmp.szName = "";
		end
		
		tmp.szState = dt:readString();
		if tmp.szState then
			tmp.szState = tmp.szState:getData();
		else
			tmp.szState = "";
		end
		
		tmp.byType = dt:readByte();
		tmp.usNeedLevel = dt:readShort();
		tmp.dwPhoto = dt:readInt();	
		
		return tmp;
	end
}
----------------常量定义区----------------
local WORLDEVENT_TYPE_WORLD_BOSS1 = 1	--//世界boss1
local WORLDEVENT_TYPE_WORLD_TREE = 2	--//世界摇钱树
local WORLDEVENT_TYPE_WORLD_BOSS2 = 3	--//世界boss2s
local WORLDEVENT_TYPE_WORLD_QUIZ = 4	--//世界答题竞猜
local WORLDEVENT_TYPE_ESCORT = 5 --押送军粮
local USERINFO_OPEN_WORLD_EVENT = 75 -- //打开世界活动
local USERINFO_JION_WORLD_EVENT = 76 -- //参与世界活动或改按钮
local ACTION_TRIBEWAR_ENTER_MAP		= 11	--//进入军团战地图
local WORLDEVENT_TYPE_YANWUFIELD = 20    -----//演武场 
----------------变量定义区----------------
local stAllWorldEvent = {}
local news_time = 0;   -----几个消息包
--变量的定义
----------------UI控制器区----------------
function yanwu2.initControl()
	local pWindow1 = SCWindow:window()
	if pWindow1 then
		pWindow1:setTag(50052)
		pWindow1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pWindow1:setPosition(AUTO_POS(0.50, -1.00))pWindow1:setContentSize(AUTO_SIZE(480, 320))
		pWindow1:luaSetSelectorOnClose(yanwu2.releaseControl)
	end

	local imgPath = getRealUIResourcePath("active/new00866.pn")
	local pImage2 = nil
	if imgPath then
		pImage2 = SCImage:imageWithFile(imgPath:getData())
		if pImage2 then
			pImage2:setTag(2)
			pImage2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
			pImage2:setPosition(AUTO_POS(24.00, 285.50))
		end
	end

	if pImage2 and pWindow1 then
		pWindow1:addChild(tolua.cast(pImage2, "SCNode"))
	end
	return pWindow1
end
function yanwu2.releaseControl()
--	if yanwu2.wndClose then
--		yanwu2.wndClose()
		news_time = 0;
		stAllWorldEvent = {};
		m_curIndex = nil;
--	end
end
--函数定义
----------------逻辑功能区----------------
--发送参与消息
local function sendJoinWorldEvent(index)
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_JION_WORLD_EVENT)
	dataStream:writeShort(index)
	dataStream:writeByte(1)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show();	
end

--点击关闭
local function onCloseBtnClick(tag)
	stAllWorldEvent = {}
	news_time = 0;
	local wndCtrl = getCurentSceneWindowController(50052);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end	
end
--点击参加
local function onEnterSureBtnClick(tag)
    if m_curIndex ~= nil then
        if m_curIndex <= #stAllWorldEvent then
		--    sendJoinWorldEvent(stAllWorldEvent[m_curIndex].usIndex);
		    sendJoinWorldEvent(m_curIndex);
		    onCloseBtnClick(nil);
	    end
	end
end
---------参加军团战-------------
local function choose_join()
    local dataStream = SCDataTransStream:streamWithCommand(_MSG_SYNWAR);
    if dataStream then
        dataStream:writeShort(ACTION_TRIBEWAR_ENTER_MAP)
        SCDataTransThread:getSingleton():transData(dataStream); 
	    SCActivityIndicator:getSingleton():show();
    end
end 
local function yanwu_uplev()
	showMessage(L"str9236")
	return
end 
--点击参加按钮
local function onEnterBtnClick(tag)
	local index = 1;
	if tag == 1 then
		index = 1;
	elseif tag == 2 then
		index = 2;
	elseif tag == 3 then
		index = 3;
	elseif tag == 4 then
		AnswerGuess.showAnswerGuessWnd();
		local wndCtrl = getCurentSceneWindowController(50052);
		if wndCtrl then
			removeWindowCtrl(wndCtrl);
		end
		return;
	elseif tag == 5 or tag == 6 then
	    if CLIENT_VERSION >= 328 then
            REMOVE_TOP_CTRL()
            VanFood_OpenVanFoodWnd()
            return		
	    end
	elseif tag == 17  then
		clickto_onClickActivityBtnTwo()
		return;
	elseif  tag == 10  then
		clickto_onApplyBtnClick()
		local wndCtrl = getCurentSceneWindowController(50052);
		if wndCtrl then
			removeWindowCtrl(wndCtrl);
		end	
		return;
	end
	m_curIndex = index;
	luashowConfirmationWindow(_LTParser("str9220"), WIN_YES, onEnterSureBtnClick);
end
-----进入演武场------
local function gotoyanwu()
	local wndCtrl = getCurentSceneWindowController(50052);
	if wndCtrl then
		removeWindowCtrl(wndCtrl);
	end
	yanwu_init()
end 
function  yanwu2_init(byNum)
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(50052);
	if wndCtrl then
	    wnd = wndCtrl:getWindow();   -----不是很清楚
	else
        wnd = yanwu2.initControl();   -----不是很清楚
        if wnd then
            local wndCtrl = SCWindowController:controllerWithWindow(wnd)
            local naviCtrl = getCurentSceneNavigationController()
            if wndCtrl and naviCtrl then
                naviCtrl:pushWindowController(wndCtrl)
            end
        end
	end
	yanwu2_addNode(byNum)
end
local function levelNoToEnter()
    showMessage(L("str3132"))
end

local function levelTribeNoToEnter()
    showMessage(L("str3315"))
end
----------添加listbox---------
function yanwu2_addNode(byNum)
	local wnd = nil;
	local wndCtrl = getCurentSceneWindowController(50052);
	if wndCtrl then
	    wnd = wndCtrl:getWindow();
	else
		return;
	end 
	news_time = byNum + news_time
	if news_time > 20 then
		news_time = 20
	end
	wnd:removeChildByTag(525,true)
	local pPlistBox = SCTypeCast:castNodeToListBox(SCFunction:getUiNodeByIdlist("50052-525"))
    if pPlistBox == nil then
        pPlistBox = SCListBox:boxWithWidthHeight(AUTO_W(463),AUTO_H(261));
        pPlistBox:setTag(525)
		pPlistBox:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
		pPlistBox:setPosition(AUTO_POS(6, 8))
		wnd:addChild(pPlistBox)
    end 
    local node_count = 0;
	local btnimgPath1 = getRealUIResourcePath("img/new00154.png");
	local btnimgPath2 = getRealUIResourcePath("img/new00349.png");
	local btnimgPath3 = getRealUIResourcePath("img/new00358.png");
	local btnimgPath4 = getRealUIResourcePath("img/new00516.png");
    if  pPlistBox  then
		for i=1, news_time do
			if stAllWorldEvent[i].byType == 1 and stAllWorldEvent[i].usIndex ~= WORLDEVENT_TYPE_YANWUFIELD  then
				node_count = node_count+1
				local pNode = SCNode:node();
				if pNode then
					pNode:setContentSize(AUTO_SIZE(450, 80))
					pNode:setTag(node_count)
					pPlistBox:addItem(pNode)
					local imgPath = getRealUIResourcePath("active/new00868.png")
					local pImage2 = nil
					if imgPath then
						pImage2 = SCImage:imageWithFile(imgPath:getData())
						if pImage2 then
							pImage2:setTag(2)
							pImage2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
							pImage2:setPosition(AUTO_POS(4, 5))
							pNode:addChild(pImage2)
						end
					end
					if stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_BOSS1 then
						local imgPath1 = RES("active/new00870.png");
						local imgPath2 = RES("img/new00350.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21039"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1  then 
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001003.png");
						if imgPath1  then 
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str30121"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_TREE then
						local imgPath1 = RES("active/new00874.png");
						local imgPath2 = RES("img/new00786.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21040"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1  then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 28))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 28))
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_BOSS2 then
						local imgPath1 = RES("active/new00872.png");
						local imgPath2 = RES("img/new00355.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21039"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1  then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001003.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str30121"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_QUIZ then
						local imgPath1 = RES("active/new00867.png");
						local imgPath2 = RES("img/new00285.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21041"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 28))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 28))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_ESCORT then
						local imgPath1 = RES("active/new00873.png");
						local imgPath2 = RES("escort/new00842.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21043"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/new00175.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 28))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str21044"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 28))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == 6 then   ----------第二次押送
						local imgPath1 = RES("active/new00873.png");
						local imgPath2 = RES("escort/new00842.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21043"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/new00175.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 28))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str21044"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 28))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_YANWUFIELD then  ----演武场
						local imgPath1 = RES("yanwu/new00906.png");
						local imgPath2 = RES("yanwu/new00905.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						---------奖励图片---------------
						local imgPath1 = RES("img/2001002.png");
						if  imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str0192"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/new00175.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str21044"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == 17 then    -----军团BOSS
						local imgPath1 = RES("active/new00869.png");
						local imgPath2 = RES("img/new00434.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001003.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str30121"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == 10 then    -----军团争霸
						local imgPath1 = RES("active/new00869.png");
						local imgPath2 = RES("img/new00398.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						---------奖励图片---------------
						local imgPath1 = RES("img/2001008.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0138"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("jade/new00791.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str21090"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							
							pImage2:addChild(Label1)
						end
					end
					if stAllWorldEvent[i].usIndex ~= 17 and stAllWorldEvent[i].usIndex ~= 10 and stAllWorldEvent[i].usIndex ~= WORLDEVENT_TYPE_YANWUFIELD then
						local Label1 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setText(stAllWorldEvent[i].szState);
							Label1:setPosition(AUTO_POS(200,45))
							pImage2:addChild(Label1)
						end
					else
						local Label1 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setText(stAllWorldEvent[i].szState);
							Label1:setPosition(AUTO_POS(120,16))
							
							pImage2:addChild(Label1)
						end
					end 
					local Label2 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
					if Label2 then
						local str = L("str9159");
						str = str..stAllWorldEvent[i].usNeedLevel;
						Label2:setText(str);
						Label2:setPosition(AUTO_POS(150,20))
						
						if stAllWorldEvent[i].byType == 0 then
							Label2:setColor(color_red);
						else
							Label2:setColor(color_lightgreen);
						end
					end
					local Button = SCButton:button(EnumBtnType9Atlas)
					if Button and btnimgPath1 and btnimgPath2 and btnimgPath3 and btnimgPath4 then
						Button:setButtonType(3)
						Button:setContentSize(AUTO_SIZE(90, 45))
						local imgPath = getRealUIResourcePath("img/new00356.png")
						if imgPath then
							Button:setTitle(imgPath:getData())
						end
						--[[
						local pBackimg = getRealUIResourcePath("img/new00155.png")
						if pBackimg then
							Button:setBackgroundImage(pBackimg:getData())
						end
						]]
						Button:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
						Button:setPosition(AUTO_POS(355,15))
						Button:setTag(stAllWorldEvent[i].usIndex)
						Button:luaSetSelectorOnClicked(onEnterBtnClick);
						if stAllWorldEvent[i].usIndex ~= 17 and stAllWorldEvent[i].usIndex ~= 10 and stAllWorldEvent[i].usIndex ~= WORLDEVENT_TYPE_YANWUFIELD then
							if stAllWorldEvent[i].byType == 0 then
								Button:setTitle(btnimgPath4:getData());
								Button:luaSetSelectorOnClicked(levelNoToEnter);
							elseif stAllWorldEvent[i].byType == 1 then
								--Button:setBackgroundImage(btnimgPath1:getData());
								Button:setButtonType(1)
								Button:setTitle(btnimgPath2:getData());
							elseif stAllWorldEvent[i].byType == 2 then
								Button:setTouchEnabled(false);
							elseif stAllWorldEvent[i].byType == 3 then
								Button:setTouchEnabled(false);
								Button:setTitle(btnimgPath3:getData());
							else
								Button:setVisible(false);
							end
						elseif  stAllWorldEvent[i].usIndex == 17  then
							if stAllWorldEvent[i].byType == 0 then
								Button:setTitle(L("str21021"), DEFAULT_FONT_NAME, F(12));
								Button:luaSetSelectorOnClicked(levelTribeNoToEnter);
							elseif stAllWorldEvent[i].byType == 1 then
								Button:setTitle(L("str21022"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
							elseif stAllWorldEvent[i].byType == 2 then
								Button:setButtonType(1)
								Button:setTitle(L("str21023"), DEFAULT_FONT_NAME, F(12));
							elseif stAllWorldEvent[i].byType == 3 then
								Button:setTitle(L("str21024"), DEFAULT_FONT_NAME, F(12));
								Button:setTouchEnabled(false);
							elseif stAllWorldEvent[i].byType == 4 then
								Button:setTitle(L("str21028"), DEFAULT_FONT_NAME, F(12));
								Button:setTouchEnabled(false);
							else
								Button:setTitle(L("str21020"), DEFAULT_FONT_NAME, F(12));
							end
						elseif  stAllWorldEvent[i].usIndex == 10  then
							if stAllWorldEvent[i].byType == 0 then
								Button:setTitle(L("str21021"), DEFAULT_FONT_NAME, F(12));
								Button:luaSetSelectorOnClicked(levelTribeNoToEnter);
							elseif stAllWorldEvent[i].byType == 1 then
								--Button:luaSetSelectorOnClicked(choose_join)
								Button:setTitle(L("str21022"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
							elseif stAllWorldEvent[i].byType == 2 then
								Button:setTitle(L("str3305"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
								--Button:setTouchEnabled(false);
							elseif stAllWorldEvent[i].byType == 3 then
								Button:setTitle(L("str3305"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
								--Button:setTouchEnabled(false);
							elseif stAllWorldEvent[i].byType == 4 then
								Button:setButtonType(1)
								Button:setTitle(L("str3305"), DEFAULT_FONT_NAME, F(12));
							else
								Button:setTitle(L("str3305"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
							end
						elseif  stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_YANWUFIELD  then
							if  Hero:getSingleton():getLeval() < 48 then
								Button:setTitle(L("str21087"), DEFAULT_FONT_NAME, F(12));
								Button:setTouchEnabled(false);
							else
								Button:setTitle(L("str20158"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
								if CLIENT_VERSION >= 335 then
									Button:luaSetSelectorOnClicked(gotoyanwu)
								else
									Button:luaSetSelectorOnClicked(yanwu_uplev)
								end 
							end 
						end 
						pImage2:addChild(Button)
					end
					
				end 
			end 
		end 
		----------提前显示-----------
		for i=1, news_time do
			--i = (news_time - 1)*5 + i;  -----控制显示第二个包
			if stAllWorldEvent[i].byType ~= 1 and stAllWorldEvent[i].usIndex ~= WORLDEVENT_TYPE_YANWUFIELD then
				node_count = node_count+1
				local pNode = SCNode:node();
				if pNode then
					pNode:setContentSize(AUTO_SIZE(450, 80))
					--pNode:setPosition(AUTO_POS(4,6))
					pNode:setTag(node_count)
					pPlistBox:addItem(pNode)
					local imgPath = getRealUIResourcePath("active/new00868.png")
					local pImage2 = nil
					if imgPath then
						pImage2 = SCImage:imageWithFile(imgPath:getData())
						if pImage2 then
							pImage2:setTag(2)
							pImage2:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
							pImage2:setPosition(AUTO_POS(4, 5))
							pNode:addChild(pImage2)
						end
					end
					if stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_BOSS1 then
						local imgPath1 = RES("active/new00870.png");
						local imgPath2 = RES("img/new00350.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21039"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1  then 
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001003.png");
						if imgPath1  then 
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str30121"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_TREE then
						local imgPath1 = RES("active/new00874.png");
						local imgPath2 = RES("img/new00786.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21040"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1  then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 28))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 28))
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_BOSS2 then
						local imgPath1 = RES("active/new00872.png");
						local imgPath2 = RES("img/new00355.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21039"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1  then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001003.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str30121"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_WORLD_QUIZ then
						local imgPath1 = RES("active/new00867.png");
						local imgPath2 = RES("img/new00285.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21041"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 28))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 28))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_ESCORT then
						local imgPath1 = RES("active/new00873.png");
						local imgPath2 = RES("escort/new00842.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21043"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/new00175.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 28))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str21044"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 28))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == 6 then   ----------第二次押送
						local imgPath1 = RES("active/new00873.png");
						local imgPath2 = RES("escort/new00842.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str21043"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/new00175.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 28))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str21044"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 28))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_YANWUFIELD then  ----演武场
						local imgPath1 = RES("yanwu/new00906.png");
						local imgPath2 = RES("yanwu/new00905.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						---------奖励图片---------------
						local imgPath1 = RES("img/2001002.png");
						if  imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-----------文字描述-------
						local Label1 = SCLabel:labelWithStringFont(L("str0192"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/new00175.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str21044"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == 17 then    -----军团BOSS
						local imgPath1 = RES("active/new00869.png");
						local imgPath2 = RES("img/new00434.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						---------奖励图片---------------
						local imgPath1 = RES("img/2001001.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0139"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("img/2001003.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str30121"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							
							pImage2:addChild(Label1)
						end
					elseif stAllWorldEvent[i].usIndex == 10 then    -----军团争霸
						local imgPath1 = RES("active/new00869.png");
						local imgPath2 = RES("img/new00398.png");
						if imgPath1 and imgPath2 then
							local img1 = SCImage:imageWithFile(imgPath1)
							local img2 = SCImage:imageWithFile(imgPath2)
							if img1 and img2 then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(7, 15))
								img2:setPosition(AUTO_POS(120, 40))
								pImage2:addChild(img1)
								pImage2:addChild(img2)
							end
						end 
						---------奖励图片---------------
						local imgPath1 = RES("img/2001008.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 42))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str0138"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 42))
							
							pImage2:addChild(Label1)
						end
						---------奖励图片---------------
						local imgPath1 = RES("jade/new00791.png");
						if imgPath1 then
							local img1 = SCImage:imageWithFile(imgPath1)
							if img1  then
								img1:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
								img1:setPosition(AUTO_POS(310, 13))
								img1:setScale(0.6)
								pImage2:addChild(img1)
							end 
						end 
						-------------图标说明-----------
						local Label1 = SCLabel:labelWithStringFont(L("str21090"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setPosition(AUTO_POS(310, 13))
							
							pImage2:addChild(Label1)
						end
					end
					if stAllWorldEvent[i].usIndex ~= 17 and stAllWorldEvent[i].usIndex ~= 10 and stAllWorldEvent[i].usIndex ~= WORLDEVENT_TYPE_YANWUFIELD then
						local Label1 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setText(stAllWorldEvent[i].szState);
							Label1:setPosition(AUTO_POS(200,45))
							
							pImage2:addChild(Label1)
						end
					else
						local Label1 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
						if Label1 then
							Label1:setText(stAllWorldEvent[i].szState);
							Label1:setPosition(AUTO_POS(120,16))
							pImage2:addChild(Label1)
						end
					end 
					local Label2 = SCLabel:labelWithStringFont(L("label_text"), DEFAULT_FONT_NAME, F(12))
					if Label2 then
						local str = L("str9159");
						str = str..stAllWorldEvent[i].usNeedLevel;
						Label2:setText(str);
						Label2:setPosition(AUTO_POS(150,20))
						
						if stAllWorldEvent[i].byType == 0 then
							Label2:setColor(color_red);
						else
							Label2:setColor(color_lightgreen);
						end
					end
					local Button = SCButton:button()
					if Button and btnimgPath1 and btnimgPath2 and btnimgPath3 and btnimgPath4 then
						Button:setButtonType(3)
						Button:setContentSize(AUTO_SIZE(90, 45))
						local imgPath = getRealUIResourcePath("img/new00356.png")
						if imgPath then
							Button:setTitle(imgPath:getData())
						end
						--[[
						local pBackimg = getRealUIResourcePath("img/new00155.png")
						if pBackimg then
							Button:setBackgroundImage(pBackimg:getData())
						end
						]]
						Button:setAnchorPoint(ANCHOR_LEFT_BOTTOM)
						Button:setPosition(AUTO_POS(355,15))
						Button:setTag(stAllWorldEvent[i].usIndex)
						Button:luaSetSelectorOnClicked(onEnterBtnClick);
						if  stAllWorldEvent[i].usIndex ~= 17 and stAllWorldEvent[i].usIndex ~= 10 and stAllWorldEvent[i].usIndex ~= WORLDEVENT_TYPE_YANWUFIELD then
							if stAllWorldEvent[i].byType == 0 then
								Button:setTitle(btnimgPath4:getData());
								Button:luaSetSelectorOnClicked(levelNoToEnter);
							elseif stAllWorldEvent[i].byType == 1 then
								--Button:setBackgroundImage(btnimgPath1:getData());
								Button:setButtonType(1)
								Button:setTitle(btnimgPath2:getData());
							elseif stAllWorldEvent[i].byType == 2 then
								Button:setTouchEnabled(false);
							elseif stAllWorldEvent[i].byType == 3 then
								Button:setTouchEnabled(false);
								Button:setTitle(btnimgPath3:getData());
							else
								Button:setVisible(false);
							end
						elseif  stAllWorldEvent[i].usIndex == 17  then
							if stAllWorldEvent[i].byType == 0 then
								Button:setTitle(L("str21021"), DEFAULT_FONT_NAME, F(12));
								Button:luaSetSelectorOnClicked(levelTribeNoToEnter);
							elseif stAllWorldEvent[i].byType == 1 then
								Button:setTitle(L("str21022"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
							elseif stAllWorldEvent[i].byType == 2 then
								Button:setButtonType(1)
								Button:setTitle(L("str21023"), DEFAULT_FONT_NAME, F(12));
							elseif stAllWorldEvent[i].byType == 3 then
								Button:setTitle(L("str21024"), DEFAULT_FONT_NAME, F(12));
								Button:setTouchEnabled(false);
							elseif stAllWorldEvent[i].byType == 4 then
								Button:setTitle(L("str21028"), DEFAULT_FONT_NAME, F(12));
								Button:setTouchEnabled(false);
							else
								Button:setTitle(L("str21020"), DEFAULT_FONT_NAME, F(12));
							end
						elseif  stAllWorldEvent[i].usIndex == 10  then
							if stAllWorldEvent[i].byType == 0 then
								Button:setTitle(L("str21021"), DEFAULT_FONT_NAME, F(12));
								Button:luaSetSelectorOnClicked(levelTribeNoToEnter);
							elseif stAllWorldEvent[i].byType == 1 then
								--Button:luaSetSelectorOnClicked(choose_join)
								Button:setTitle(L("str21022"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
							elseif stAllWorldEvent[i].byType == 2 then
								Button:setTitle(L("str3305"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
								--Button:setTouchEnabled(false);
							elseif stAllWorldEvent[i].byType == 3 then
								Button:setTitle(L("str3305"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
								--Button:setTouchEnabled(false);
							elseif stAllWorldEvent[i].byType == 4 then
								Button:setButtonType(1)
								Button:setTitle(L("str3305"), DEFAULT_FONT_NAME, F(12));
							else
								Button:setTitle(L("str3305"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
							end
						elseif  stAllWorldEvent[i].usIndex == WORLDEVENT_TYPE_YANWUFIELD  then
							if  Hero:getSingleton():getLeval() < 48 then
								Button:setTitle(L("str21087"), DEFAULT_FONT_NAME, F(12));
								Button:setTouchEnabled(false);
							else
								Button:setTitle(L("str20158"), DEFAULT_FONT_NAME, F(12));
								Button:setButtonType(1)
								if CLIENT_VERSION >= 335 then
									Button:luaSetSelectorOnClicked(gotoyanwu)
								else
									Button:luaSetSelectorOnClicked(yanwu_uplev)
								end 
							end 
						end 
					
						pImage2:addChild(Button)
					end
					
				end 
			end 
		end
    end 
    
end 
------------打开界面-----------
function yanwu2_open()
	local dataStream = SCDataTransStream:streamWithCommand(_MSG_USERINFO)
    dataStream:writeShort(USERINFO_OPEN_WORLD_EVENT)
    SCDataTransThread:getSingleton():transData(dataStream)
	SCActivityIndicator:getSingleton():show();	

end 
----------------消息处理区----------------
function yanwu2_recvWorldEvent(dt)
	if not dt then
		return
	end
	local byNum = dt:readByte();
	if byNum > 100 then
		byNum = 100
	end
	for i=1, byNum do
		table.insert(stAllWorldEvent, stWorldEvent.initWithStream(dt));
	end
	yanwu2_init(byNum)
	
end
----------------消息注册区----------------

----------------全局函数区----------------



--函数调用